"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/core/lineRange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(j){for(var t=[],k=0,D=j.length;k<D;k++)t[k]=K[j[k]];return t};const Oe=this,Ve=typeof global=="object"?global:{};var he;(function(j){j.global=Oe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof j.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}j.Environment=t})(he||(he={}));var he;(function(j){class t{constructor(a,L,d){this.type=a,this.detail=L,this.timestamp=d}}j.LoaderEvent=t;class k{constructor(a){this._events=[new t(1,"",a)]}record(a,L){this._events.push(new t(a,L,j.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}j.LoaderEventRecorder=k;class D{record(a,L){}getEvents(){return[]}}D.INSTANCE=new D,j.NullLoaderEventRecorder=D})(he||(he={}));var he;(function(j){class t{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let a;for(a in D)D.hasOwnProperty(a)&&i(a,D[a])}}static isEmpty(D){let i=!0;return t.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return t.forEachProperty(D,(a,L)=>{L&&typeof L=="object"?i[a]=t.recursiveClone(L):i[a]=L}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=j.global.performance&&typeof j.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?j.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,j.Utilities=t})(he||(he={}));var he;(function(j){function t(i){if(i instanceof Error)return i;const a=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(a.stack=i.stack),a}j.ensureError=t;class k{static validateConfigurationOptions(a){function L(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError>"u"&&(a.catchError=!1),typeof a.recordStats>"u"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=L),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(j.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags>"u"&&(a.preferScriptTags=!1),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",a.onError(d),a.nodeCachedData=void 0}return a}static mergeConfigurationOptions(a=null,L=null){let d=j.Utilities.recursiveClone(L||{});return j.Utilities.forEachProperty(a,(u,s)=>{u==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):u==="paths"&&typeof d.paths<"u"?j.Utilities.forEachProperty(s,(c,E)=>d.paths[c]=E):u==="config"&&typeof d.config<"u"?j.Utilities.forEachProperty(s,(c,E)=>d.config[c]=E):d[u]=j.Utilities.recursiveClone(s)}),k.validateConfigurationOptions(d)}}j.ConfigurationOptionsUtil=k;class D{constructor(a,L){if(this._env=a,this.options=k.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,u=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],j.Utilities.forEachProperty(this.options.paths,(a,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:a,to:L}):this.sortedPathsRules.push({from:a,to:[L]})}),this.sortedPathsRules.sort((a,L)=>L.from.length-a.from.length)}cloneAndMerge(a){return new D(this._env,k.mergeConfigurationOptions(a,this.options))}getOptionsLiteral(){return this.options}_applyPaths(a){let L;for(let d=0,u=this.sortedPathsRules.length;d<u;d++)if(L=this.sortedPathsRules[d],j.Utilities.startsWith(a,L.from)){let s=[];for(let c=0,E=L.to.length;c<E;c++)s.push(L.to[c]+a.substr(L.from.length));return s}return[a]}_addUrlArgsToUrl(a){return j.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a}_addUrlArgsIfNecessaryToUrls(a){if(this.options.urlArgs)for(let L=0,d=a.length;L<d;L++)a[L]=this._addUrlArgsToUrl(a[L]);return a}moduleIdToPaths(a){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a))return this.isBuild()?["empty:"]:["node|"+a];let L=a,d;if(!j.Utilities.endsWith(L,".js")&&!j.Utilities.isAbsolutePath(L)){d=this._applyPaths(L);for(let u=0,s=d.length;u<s;u++)this.isBuild()&&d[u]==="empty:"||(j.Utilities.isAbsolutePath(d[u])||(d[u]=this.options.baseUrl+d[u]),!j.Utilities.endsWith(d[u],".js")&&!j.Utilities.containsQueryString(d[u])&&(d[u]=d[u]+".js"))}else!j.Utilities.endsWith(L,".js")&&!j.Utilities.containsQueryString(L)&&(L=L+".js"),d=[L];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(a){let L=a;return j.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],j.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(a){return!!(!this.options.isBuild||j.Utilities.isAnonymousModule(a)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[a])}isDuplicateMessageIgnoredFor(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)}getConfigForModule(a){if(this.options.config)return this.options.config[a]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(a){this.options.onError(a)}}j.Configuration=D})(he||(he={}));var he;(function(j){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,c,E,o){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new k;let h={callback:E,errorback:o};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(h);return}this._callbackMap[c]=[h],this._scriptLoader.load(s,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(s){let c=this._callbackMap[s];delete this._callbackMap[s];for(let E=0;E<c.length;E++)c[E].callback()}triggerErrorback(s,c){let E=this._callbackMap[s];delete this._callbackMap[s];for(let o=0;o<E.length;o++)E[o].errorback(c)}}class k{attachListeners(s,c,E){let o=()=>{s.removeEventListener("load",h),s.removeEventListener("error",e)},h=A=>{o(),c()},e=A=>{o(),E(A)};s.addEventListener("load",h),s.addEventListener("error",e)}load(s,c,E,o){if(/^node\|/.test(c)){let h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||j.global.nodeRequire),A=c.split("|"),y=null;try{y=e(A[1])}catch(_){o(_);return}s.enqueueDefineAnonymousModule([],()=>y),E()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,E,o);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),h.setAttribute("src",c);const{cspNonce:A}=s.getConfig().getOptionsLiteral();A&&h.setAttribute("nonce",A),document.getElementsByTagName("head")[0].appendChild(h)}}}function D(u){const{trustedTypesPolicy:s}=u.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,c,E,o){if(/^node\|/.test(c)){const h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||j.global.nodeRequire),A=c.split("|");let y=null;try{y=e(A[1])}catch(_){o(_);return}s.enqueueDefineAnonymousModule([],function(){return y}),E()}else{const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(c).then(A=>{if(A.status!==200)throw new Error(A.statusText);return A.text()}).then(A=>{A=`${A}
//# sourceURL=${c}`,(h?self.eval(h.createScript("",A)):new Function(A)).call(self),E()}).then(void 0,o);return}try{h&&(c=h.createScriptURL(c)),importScripts(c),E()}catch(A){o(A)}}}}class a{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,c){const{nodeCachedData:E}=c.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const o=this,h=s("module");function e(A){const y=A.constructor;let _=function(M){try{return A.require(M)}finally{}};return _.resolve=function(M,g){return y._resolveFilename(M,A,!1,g)},_.resolve.paths=function(M){return y._resolveLookupPaths(M,A)},_.main=process.mainModule,_.extensions=y._extensions,_.cache=y._cache,_}h.prototype._compile=function(A,y){const _=h.wrap(A.replace(/^#!.*/,"")),$=c.getRecorder(),M=o._getCachedDataPath(E,y),g={filename:y};let m;try{const b=o._fs.readFileSync(M);m=b.slice(0,16),g.cachedData=b.slice(16),$.record(60,M)}catch{$.record(61,M)}const r=new o._vm.Script(_,g),l=r.runInThisContext(g),R=o._path.dirname(y),f=e(this),w=[this.exports,f,this,y,R,process,Ve,Buffer],N=l.apply(this.exports,w);return o._handleCachedData(r,_,M,!g.cachedData,c),o._verifyCachedData(r,_,M,m,c),N}}load(s,c,E,o){const h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||j.global.nodeRequire),A=h.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,s);let y=s.getRecorder();if(/^node\|/.test(c)){let _=c.split("|"),$=null;try{$=e(_[1])}catch(M){o(M);return}s.enqueueDefineAnonymousModule([],()=>$),E()}else{c=j.Utilities.fileUriToFilePath(this._env.isWindows,c);const _=this._path.normalize(c),$=this._getElectronRendererScriptPathOrUri(_),M=!!h.nodeCachedData,g=M?this._getCachedDataPath(h.nodeCachedData,c):void 0;this._readSourceAndCachedData(_,g,y,(m,r,l,R)=>{if(m){o(m);return}let f;r.charCodeAt(0)===a._BOM?f=a._PREFIX+r.substring(1)+a._SUFFIX:f=a._PREFIX+r+a._SUFFIX,f=A(f,_);const w={filename:$,cachedData:l},N=this._createAndEvalScript(s,f,w,E,o);this._handleCachedData(N,f,g,M&&!l,s),this._verifyCachedData(N,f,g,R,s)})}}_createAndEvalScript(s,c,E,o,h){const e=s.getRecorder();e.record(31,E.filename);const A=new this._vm.Script(c,E),y=A.runInThisContext(E),_=s.getGlobalAMDDefineFunc();let $=!1;const M=function(){return $=!0,_.apply(null,arguments)};return M.amd=_.amd,y.call(j.global,s.getGlobalAMDRequireFunc(),M,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),$?o():h(new Error(`Didn't receive define call in ${E.filename}!`)),A}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let c=s.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,c){const E=this._crypto.createHash("md5").update(c,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),o=this._path.basename(c).replace(/\.js$/,"");return this._path.join(s.path,`${o}-${E}.code`)}_handleCachedData(s,c,E,o,h){s.cachedDataRejected?this._fs.unlink(E,e=>{h.getRecorder().record(62,E),this._createAndWriteCachedData(s,c,E,h),e&&h.getConfig().onError(e)}):o&&this._createAndWriteCachedData(s,c,E,h)}_createAndWriteCachedData(s,c,E,o){let h=Math.ceil(o.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,A=0,y;const _=()=>{setTimeout(()=>{y||(y=this._crypto.createHash("md5").update(c,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||A>=5)){if($.length<e){_();return}e=$.length,this._fs.writeFile(E,Buffer.concat([y,$]),M=>{M&&o.getConfig().onError(M),o.getRecorder().record(63,E),_()})}},h*Math.pow(4,A++))};_()}_readSourceAndCachedData(s,c,E,o){if(!c)this._fs.readFile(s,{encoding:"utf8"},o);else{let h,e,A,y=2;const _=$=>{$?o($):--y===0&&o(void 0,h,e,A)};this._fs.readFile(s,{encoding:"utf8"},($,M)=>{h=M,_($)}),this._fs.readFile(c,($,M)=>{!$&&M&&M.length>0?(A=M.slice(0,16),e=M.slice(16),E.record(60,c)):E.record(61,c),_()})}}_verifyCachedData(s,c,E,o,h){o&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();o.equals(e)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,A=>{A&&h.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random()))))}}a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`;function L(u,s){if(s.__$__isRecorded)return s;const c=function(o){u.record(33,o);try{return s(o)}finally{u.record(34,o)}};return c.__$__isRecorded=!0,c}j.ensureRecordedNodeRequire=L;function d(u){return new t(u)}j.createScriptLoader=d})(he||(he={}));var he;(function(j){class t{constructor(u){let s=u.lastIndexOf("/");s!==-1?this.fromModulePath=u.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(u){let s=u,c;for(c=/\/\.\//;c.test(s);)s=s.replace(c,"/");for(s=s.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(s);)s=s.replace(c,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(u){let s=u;return j.Utilities.isAbsolutePath(s)||(j.Utilities.startsWith(s,"./")||j.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),j.ModuleIdResolver=t;class k{constructor(u,s,c,E,o,h){this.id=u,this.strId=s,this.dependencies=c,this._callback=E,this._errorback=o,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,s){try{return{returnedValue:u.apply(j.global,s),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(u,s,c,E){return u.shouldInvokeFactory(s)?u.shouldCatchError()?this._safeInvokeFunction(c,E):{returnedValue:c.apply(j.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(u,s,c,E){this._isComplete=!0;let o=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let h=k._invokeFactory(s,this.strId,this._callback,c);o=h.producedError,u.record(22,this.strId),!o&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||j.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(o){let h=j.ensureError(o);h.phase="factory",h.moduleId=this.strId,h.neededBy=E(this.id),this.error=h,s.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}j.Module=k;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let s=this._strModuleIdToIntModuleId.get(u);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(u,s),this._intModuleIdToStrModuleId[s]=u),s}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class i{constructor(u){this.id=u}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),j.RegularDependency=i;class a{constructor(u,s,c){this.id=u,this.pluginId=s,this.pluginParam=c}}j.PluginDependency=a;class L{constructor(u,s,c,E,o=0){this._env=u,this._scriptLoader=s,this._loaderAvailableTimestamp=o,this._defineFunc=c,this._requireFunc=E,this._moduleIdProvider=new D,this._config=new j.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,s){let c=h=>h.replace(/\\/g,"/"),E=c(u),o=s.split(/\n/);for(let h=0;h<o.length;h++){let e=o[h].match(/(.*):(\d+):(\d+)\)?$/);if(e){let A=e[1],y=e[2],_=e[3],$=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr($),A=c(A),A===E){let M={line:parseInt(y,10),col:parseInt(_,10)};return M.line===1&&(M.col-=53),M}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],s=0;for(let c=0,E=this._modules2.length;c<E;c++){let o=this._modules2[c];if(!o)continue;let h=this._buildInfoPath[o.id]||null,e=this._buildInfoDefineStack[o.id]||null,A=this._buildInfoDependencies[o.id];u[s++]={id:o.strId,path:h,defineLocation:h&&e?L._findRelevantLocationInStack(h,e):null,dependencies:A,shim:null,exports:o.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new j.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=j.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:u,callback:s}}defineModule(u,s,c,E,o,h=new t(u)){let e=this._moduleIdProvider.getModuleId(u);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let A=new k(e,u,this._normalizeDependencies(s,h),c,E,h);this._modules2[e]=A,this._config.isBuild()&&(this._buildInfoDefineStack[e]=o,this._buildInfoDependencies[e]=(A.dependencies||[]).map(y=>this._moduleIdProvider.getStrModuleId(y.id))),this._resolve(A)}_normalizeDependency(u,s){if(u==="exports")return i.EXPORTS;if(u==="module")return i.MODULE;if(u==="require")return i.REQUIRE;let c=u.indexOf("!");if(c>=0){let E=s.resolveModule(u.substr(0,c)),o=s.resolveModule(u.substr(c+1)),h=this._moduleIdProvider.getModuleId(E+"!"+o),e=this._moduleIdProvider.getModuleId(E);return new a(h,e,o)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(u)))}_normalizeDependencies(u,s){let c=[],E=0;for(let o=0,h=u.length;o<h;o++)c[E++]=this._normalizeDependency(u[o],s);return c}_relativeRequire(u,s,c,E){if(typeof s=="string")return this.synchronousRequire(s,u);this.defineModule(j.Utilities.generateAnonymousModule(),s,c,E,null,u)}synchronousRequire(u,s=new t(u)){let c=this._normalizeDependency(u,s),E=this._modules2[c.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(u,s){let c=this._config.shouldRecordStats();s?this._config=new j.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),s.dependencies,s.callback,null,s.stack)}}_createLoadError(u,s){let c=this._moduleIdProvider.getStrModuleId(u),E=(this._inverseDependencies2[u]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const o=j.ensureError(s);return o.phase="loading",o.moduleId=c,o.neededBy=E,o}_onLoadError(u,s){const c=this._createLoadError(u,s);this._modules2[u]||(this._modules2[u]=new k(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let E=[];for(let e=0,A=this._moduleIdProvider.getMaxModuleId();e<A;e++)E[e]=!1;let o=!1,h=[];for(h.push(u),E[u]=!0;h.length>0;){let e=h.shift(),A=this._modules2[e];A&&(o=A.onDependencyError(c)||o);let y=this._inverseDependencies2[e];if(y)for(let _=0,$=y.length;_<$;_++){let M=y[_];E[M]||(h.push(M),E[M]=!0)}}o||this._config.onError(c)}_hasDependencyPath(u,s){let c=this._modules2[u];if(!c)return!1;let E=[];for(let h=0,e=this._moduleIdProvider.getMaxModuleId();h<e;h++)E[h]=!1;let o=[];for(o.push(c),E[u]=!0;o.length>0;){let e=o.shift().dependencies;if(e)for(let A=0,y=e.length;A<y;A++){let _=e[A];if(_.id===s)return!0;let $=this._modules2[_.id];$&&!E[_.id]&&(E[_.id]=!0,o.push($))}}return!1}_findCyclePath(u,s,c){if(u===s||c===50)return[u];let E=this._modules2[u];if(!E)return null;let o=E.dependencies;if(o)for(let h=0,e=o.length;h<e;h++){let A=this._findCyclePath(o[h].id,s,c+1);if(A!==null)return A.push(u),A}return null}_createRequire(u){let s=(c,E,o)=>this._relativeRequire(u,c,E,o);return s.toUrl=c=>this._config.requireToUrl(u.resolveModule(c)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(c,E=!1)=>{this.configure(c,E)},s.__$__nodeRequire=j.global.nodeRequire,s}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let s=this._moduleIdProvider.getStrModuleId(u),c=this._config.moduleIdToPaths(s),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||E.test(s))&&c.push("node|"+s);let o=-1,h=e=>{if(o++,o>=c.length)this._onLoadError(u,e);else{let A=c[o],y=this.getRecorder();if(this._config.isBuild()&&A==="empty:"){this._buildInfoPath[u]=A,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}y.record(10,A),this._scriptLoader.load(this,A,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=A),y.record(11,A),this._onLoad(u)},_=>{y.record(12,A),h(_)})}};h(null)}_loadPluginDependency(u,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let c=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],E,null,null)};c.error=E=>{this._config.onError(this._createLoadError(s.id,E))},u.load(s.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(u){let s=u.dependencies;if(s)for(let c=0,E=s.length;c<E;c++){let o=s[c];if(o===i.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(o===i.MODULE){u.unresolvedDependenciesCount--;continue}if(o===i.REQUIRE){u.unresolvedDependenciesCount--;continue}let h=this._modules2[o.id];if(h&&h.isComplete()){if(h.error){u.onDependencyError(h.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(o.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(o.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let e=this._findCyclePath(o.id,u.id,0)||[];e.reverse(),e.push(o.id),console.warn(e.map(A=>this._moduleIdProvider.getStrModuleId(A)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[o.id]=this._inverseDependencies2[o.id]||[],this._inverseDependencies2[o.id].push(u.id),o instanceof a){let e=this._modules2[o.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,o);continue}let A=this._inversePluginDependencies2.get(o.pluginId);A||(A=[],this._inversePluginDependencies2.set(o.pluginId,A)),A.push(o),this._loadModule(o.pluginId);continue}this._loadModule(o.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let s=this.getRecorder();if(u.isComplete())return;let c=u.dependencies,E=[];if(c)for(let A=0,y=c.length;A<y;A++){let _=c[A];if(_===i.EXPORTS){E[A]=u.exports;continue}if(_===i.MODULE){E[A]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(_===i.REQUIRE){E[A]=this._createRequire(u.moduleIdResolver);continue}let $=this._modules2[_.id];if($){E[A]=$.exports;continue}E[A]=null}const o=A=>(this._inverseDependencies2[A]||[]).map(y=>this._moduleIdProvider.getStrModuleId(y));u.complete(s,this._config,E,o);let h=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,h)for(let A=0,y=h.length;A<y;A++){let _=h[A],$=this._modules2[_];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(u.id);if(e){this._inversePluginDependencies2.delete(u.id);for(let A=0,y=e.length;A<y;A++)this._loadPluginDependency(u.exports,e[A])}}}j.ModuleManager=L})(he||(he={}));var Z,he;(function(j){const t=new j.Environment;let k=null;const D=function(d,u,s){typeof d!="string"&&(s=u,u=d,d=null),(typeof u!="object"||!Array.isArray(u))&&(s=u,u=null),u||(u=["require","exports","module"]),d?k.defineModule(d,u,s,null,null):k.enqueueDefineAnonymousModule(u,s)};D.amd={jQuery:!0};const i=function(d,u=!1){k.configure(d,u)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(j.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=i,a.getConfig=function(){return k.getConfig().getOptionsLiteral()},a.reset=function(){k=k.reset()},a.getBuildInfo=function(){return k.getBuildInfo()},a.getStats=function(){return k.getLoaderEvents()},a.define=D;function L(){if(typeof j.global.require<"u"||typeof require<"u"){const d=j.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const u=j.ensureRecordedNodeRequire(k.getRecorder(),d);j.global.nodeRequire=u,a.nodeRequire=u,a.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=a:(t.isElectronRenderer||(j.global.define=D),j.global.require=a)}j.init=L,(typeof j.global.define!="function"||!j.global.define.amd)&&(k=new j.ModuleManager(t,j.createScriptLoader(t),D,a,j.Utilities.getHighPerformanceTimestamp()),typeof j.global.require<"u"&&typeof j.global.require!="function"&&a.config(j.global.require),Z=function(){return D.apply(null,arguments)},Z.amd=D.amd,typeof doNotInitLoader>"u"&&L())})(he||(he={})),Z(K[57],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(d,u,s,c){if(c=c||{},(c["vs/css"]||{}).disabled){s({});return}const o=u.toUrl(d+".css");D(d,o,()=>{s({})},h=>{typeof s.error=="function"&&s.error("Could not find "+o+".")})}t.load=k;function D(d,u,s,c){if(i(d,u)){s();return}a(d,u,s,c)}function i(d,u){const s=document.getElementsByTagName("link");for(let c=0,E=s.length;c<E;c++){const o=s[c].getAttribute("data-name"),h=s[c].getAttribute("href");if(o===d||h===u)return!0}return!1}function a(d,u,s,c){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",d),L(d,E,s,c),E.setAttribute("href",u),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function L(d,u,s,c){const E=()=>{u.removeEventListener("load",o),u.removeEventListener("error",h)},o=e=>{E(),s()},h=e=>{E(),c(e)};u.addEventListener("load",o),u.addEventListener("error",h)}}),Z("vs/nls",["require","exports"],function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(e,A){let y;return A.length===0?y=e:y=e.replace(/\{(\d+)\}/g,(_,$)=>{const M=$[0],g=A[M];let m=_;return typeof g=="string"?m=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(m=String(g)),m}),k&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function a(e,A){let y=e[A];return y||(y=e["*"],y)?y:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,A,y){const _=L(e)+L(A)+"vscode/"+L(y),$=await fetch(_);if($.ok)return await $.json();throw new Error(`${$.status} - ${$.statusText}`)}function u(e){return function(A,y){const _=Array.prototype.slice.call(arguments,2);return i(e[A],_)}}function s(e,A,...y){return i(A,y)}t.localize=s;function c(e){}t.getConfiguredDefaultLocale=c;function E(e){k=e}t.setPseudoTranslation=E;function o(e,A){return{localize:u(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(y=>{})}}t.create=o;function h(e,A,y,_){const $=_["vs/nls"]??{};if(!e||e.length===0)return y({localize:s,getConfiguredDefaultLocale:()=>$.availableLanguages?.["*"]});const M=$.availableLanguages?a($.availableLanguages,e):null,g=M===null||M===D;let m=".nls";g||(m=m+"."+M);const r=l=>{Array.isArray(l)?l.localize=u(l):l.localize=u(l[e]),l.getConfiguredDefaultLocale=()=>$.availableLanguages?.["*"],y(l)};typeof $.loadBundle=="function"?$.loadBundle(e,M,(l,R)=>{l?A([e+".nls"],r):r(R)}):$.translationServiceUrl&&!g?(async()=>{try{const l=await d($.translationServiceUrl,M,e);return r(l)}catch(l){if(!M.includes("-"))return console.error(l),A([e+".nls"],r);try{const R=M.split("-")[0],f=await d($.translationServiceUrl,R,e);return $.availableLanguages??={},$.availableLanguages["*"]=R,r(f)}catch(R){return console.error(R),A([e+".nls"],r)}}})():A([e+m],r,l=>{if(m===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${M}. Falling back to the default language:`,l),A([e+".nls"],r)})}t.load=h}),function(){const j=globalThis.MonacoEnvironment,t=j&&j.baseUrl?j.baseUrl:"../../../";function k(c,E){if(j?.createTrustedTypesPolicy)try{return j.createTrustedTypesPolicy(c,E)}catch(o){console.warn(o);return}try{return self.trustedTypes?.createPolicy(c,E)}catch(o){console.warn(o);return}}const D=k("amdLoader",{createScriptURL:c=>c,createScript:(c,...E)=>{const o=E.slice(0,-1).join(","),h=E.pop().toString();return`(function anonymous(${o}) { ${h}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function a(){return new Promise((c,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const o=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(o).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${o}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,E);return}D?importScripts(D.createScriptURL(o)):importScripts(o),c()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function d(c){a().then(()=>{L(),require([c],function(E){setTimeout(function(){const o=E.create((h,e)=>{globalThis.postMessage(h,e)},null);for(globalThis.onmessage=h=>o.onmessage(h.data,h.ports);s.length>0;){const h=s.shift();o.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let u=!0;const s=[];globalThis.onmessage=c=>{if(!u){s.push(c);return}u=!1,d(c.data)}}(),Z(K[27],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7r=t.$6r=t.$5r=t.$4r=void 0;function k(d,u){const s=Math.pow(10,u);return Math.round(d*s)/s}class D{constructor(u,s,c,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=k(Math.max(Math.min(1,E),0),3)}static equals(u,s){return u.r===s.r&&u.g===s.g&&u.b===s.b&&u.a===s.a}}t.$4r=D;class i{constructor(u,s,c,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.l=k(Math.max(Math.min(1,c),0),3),this.a=k(Math.max(Math.min(1,E),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.l===s.l&&u.a===s.a}static fromRGBA(u){const s=u.r/255,c=u.g/255,E=u.b/255,o=u.a,h=Math.max(s,c,E),e=Math.min(s,c,E);let A=0,y=0;const _=(e+h)/2,$=h-e;if($>0){switch(y=Math.min(_<=.5?$/(2*_):$/(2-2*_),1),h){case s:A=(c-E)/$+(c<E?6:0);break;case c:A=(E-s)/$+2;break;case E:A=(s-c)/$+4;break}A*=60,A=Math.round(A)}return new i(A,y,_,o)}static i(u,s,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?u+(s-u)*6*c:c<1/2?s:c<2/3?u+(s-u)*(2/3-c)*6:u}static toRGBA(u){const s=u.h/360,{s:c,l:E,a:o}=u;let h,e,A;if(c===0)h=e=A=E;else{const y=E<.5?E*(1+c):E+c-E*c,_=2*E-y;h=i.i(_,y,s+1/3),e=i.i(_,y,s),A=i.i(_,y,s-1/3)}return new D(Math.round(h*255),Math.round(e*255),Math.round(A*255),o)}}t.$5r=i;class a{constructor(u,s,c,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.v=k(Math.max(Math.min(1,c),0),3),this.a=k(Math.max(Math.min(1,E),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.v===s.v&&u.a===s.a}static fromRGBA(u){const s=u.r/255,c=u.g/255,E=u.b/255,o=Math.max(s,c,E),h=Math.min(s,c,E),e=o-h,A=o===0?0:e/o;let y;return e===0?y=0:o===s?y=((c-E)/e%6+6)%6:o===c?y=(E-s)/e+2:y=(s-c)/e+4,new a(Math.round(y*60),A,o,u.a)}static toRGBA(u){const{h:s,s:c,v:E,a:o}=u,h=E*c,e=h*(1-Math.abs(s/60%2-1)),A=E-h;let[y,_,$]=[0,0,0];return s<60?(y=h,_=e):s<120?(y=e,_=h):s<180?(_=h,$=e):s<240?(_=e,$=h):s<300?(y=e,$=h):s<=360&&(y=h,$=e),y=Math.round((y+A)*255),_=Math.round((_+A)*255),$=Math.round(($+A)*255),new D(y,_,$,o)}}t.$6r=a;class L{static fromHex(u){return L.Format.CSS.parseHex(u)||L.red}static equals(u,s){return!u&&!s?!0:!u||!s?!1:u.equals(s)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:a.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof D)this.rgba=u;else if(u instanceof i)this.i=u,this.rgba=i.toRGBA(u);else if(u instanceof a)this.j=u,this.rgba=a.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&D.equals(this.rgba,u.rgba)&&i.equals(this.hsla,u.hsla)&&a.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=L.k(this.rgba.r),s=L.k(this.rgba.g),c=L.k(this.rgba.b),E=.2126*u+.7152*s+.0722*c;return k(E,4)}static k(u){const s=u/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(u){const s=this.getRelativeLuminance(),c=u.getRelativeLuminance();return s>c?(s+.05)/(c+.05):(c+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const s=this.getRelativeLuminance(),c=u.getRelativeLuminance();return s>c}isDarkerThan(u){const s=this.getRelativeLuminance(),c=u.getRelativeLuminance();return s<c}lighten(u){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:s,g:c,b:E,a:o}=this.rgba;return new L(new D(s,c,E,o*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const s=u.rgba,c=this.rgba.a,E=s.a,o=c+E*(1-c);if(o<1e-6)return L.transparent;const h=this.rgba.r*c/o+s.r*E*(1-c)/o,e=this.rgba.g*c/o+s.g*E*(1-c)/o,A=this.rgba.b*c/o+s.b*E*(1-c)/o;return new L(new D(h,e,A,o))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:s,g:c,b:E,a:o}=this.rgba;return new L(new D(u.rgba.r-o*(u.rgba.r-s),u.rgba.g-o*(u.rgba.g-c),u.rgba.b-o*(u.rgba.b-E),1))}flatten(...u){const s=u.reduceRight((c,E)=>L.o(E,c));return L.o(this,s)}static o(u,s){const c=1-u.rgba.a;return new L(new D(c*s.rgba.r+u.rgba.a*u.rgba.r,c*s.rgba.g+u.rgba.a*u.rgba.g,c*s.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=L.Format.CSS.format(this)),this.u}static getLighterColor(u,s,c){if(u.isLighterThan(s))return u;c=c||.5;const E=u.getRelativeLuminance(),o=s.getRelativeLuminance();return c=c*(o-E)/o,u.lighten(c)}static getDarkerColor(u,s,c){if(u.isDarkerThan(s))return u;c=c||.5;const E=u.getRelativeLuminance(),o=s.getRelativeLuminance();return c=c*(E-o)/E,u.darken(c)}}t.$7r=L,L.white=new L(new D(255,255,255,1)),L.black=new L(new D(0,0,0,1)),L.red=new L(new D(255,0,0,1)),L.blue=new L(new D(0,0,255,1)),L.green=new L(new D(0,255,0,1)),L.cyan=new L(new D(0,255,255,1)),L.lightgrey=new L(new D(211,211,211,1)),L.transparent=new L(new D(0,0,0,0)),function(d){let u;(function(s){let c;(function(E){function o(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:d.Format.CSS.formatRGBA(r)}E.formatRGB=o;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}E.formatRGBA=h;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(r)}E.formatHSL=e;function A(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}E.formatHSLA=A;function y(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function _(r){return`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}`}E.formatHex=_;function $(r,l=!1){return l&&r.rgba.a===1?d.Format.CSS.formatHex(r):`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}${y(Math.round(r.rgba.a*255))}`}E.formatHexA=$;function M(r){return r.isOpaque()?d.Format.CSS.formatHex(r):d.Format.CSS.formatRGBA(r)}E.format=M;function g(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const R=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),f=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),w=16*m(r.charCodeAt(5))+m(r.charCodeAt(6));return new d(new D(R,f,w,1))}if(l===9){const R=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),f=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),w=16*m(r.charCodeAt(5))+m(r.charCodeAt(6)),N=16*m(r.charCodeAt(7))+m(r.charCodeAt(8));return new d(new D(R,f,w,N/255))}if(l===4){const R=m(r.charCodeAt(1)),f=m(r.charCodeAt(2)),w=m(r.charCodeAt(3));return new d(new D(16*R+R,16*f+f,16*w+w))}if(l===5){const R=m(r.charCodeAt(1)),f=m(r.charCodeAt(2)),w=m(r.charCodeAt(3)),N=m(r.charCodeAt(4));return new d(new D(16*R+R,16*f+f,16*w+w,(16*N+N)/255))}return null}E.parseHex=g;function m(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=s.CSS||(s.CSS={}))})(u=d.Format||(d.Format={}))}(L||(t.$7r=L={}))}),Z(K[28],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fu=void 0;class k{constructor(i,a,L,d){this.originalStart=i,this.originalLength=a,this.modifiedStart=L,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$fu=k}),Z(K[3],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.$W=t.setUnexpectedErrorHandler=t.$U=t.$T=void 0;class k{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?g.isErrorNoTelemetry(l)?new g(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(R=>{R(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$T=k,t.$U=new k;function D(r){t.$U.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=D;function i(r){if(!r||typeof r!="object")return!1;const l=r;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.$W=i;function a(r){s(r)||t.$U.onUnexpectedError(r)}t.$X=a;function L(r){s(r)||t.$U.onUnexpectedExternalError(r)}t.$Y=L;function d(r){if(r instanceof Error){const{name:l,message:R}=r,f=r.stacktrace||r.stack;return{$isError:!0,name:l,message:R,stack:f,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.$Z=d;const u="Canceled";function s(r){return r instanceof c?!0:r instanceof Error&&r.name===u&&r.message===u}t.$1=s;class c extends Error{constructor(){super(u),this.name=this.message}}t.$2=c;function E(){const r=new Error(u);return r.name=r.message,r}t.$3=E;function o(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.$4=o;function h(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.$5=h;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.$6=e;function A(r){const l=new Error(`${r} has been disposed`);return l.name="DISPOSED",l}t.$7=A;function y(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.$8=y;class _ extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$9=_;class $ extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$0=$;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=M;class g extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof g)return l;const R=new g;return R.message=l.message,R.stack=l.stack,R}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$_=g;class m extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.$ab=m}),Z(K[29],te([0,1,3]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.CompareResult=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.top=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=void 0;function D(U,B=0){return U[U.length-(1+B)]}t.$9e=D;function i(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$0e=i;function a(U,B,q=(O,C)=>O===C){if(U===B)return!0;if(!U||!B||U.length!==B.length)return!1;for(let O=0,C=U.length;O<C;O++)if(!q(U[O],B[O]))return!1;return!0}t.$$e=a;function L(U,B){const q=U.length-1;B<q&&(U[B]=U[q]),U.pop()}t.$_e=L;function d(U,B,q){return u(U.length,O=>q(U[O],B))}t.$af=d;function u(U,B){let q=0,O=U-1;for(;q<=O;){const C=(q+O)/2|0,Q=B(C);if(Q<0)q=C+1;else if(Q>0)O=C-1;else return C}return-(q+1)}t.$bf=u;function s(U,B){let q=0,O=U.length;if(O===0)return 0;for(;q<O;){const C=Math.floor((q+O)/2);B(U[C])?O=C:q=C+1}return q}t.$cf=s;function c(U,B,q){if(U=U|0,U>=B.length)throw new TypeError("invalid index");const O=B[Math.floor(B.length*Math.random())],C=[],Q=[],ee=[];for(const re of B){const ae=q(re,O);ae<0?C.push(re):ae>0?Q.push(re):ee.push(re)}return U<C.length?c(U,C,q):U<C.length+ee.length?ee[0]:c(U-(C.length+ee.length),Q,q)}t.$df=c;function E(U,B){const q=[];let O;for(const C of U.slice(0).sort(B))!O||B(O[0],C)!==0?(O=[C],q.push(O)):O.push(C);return q}t.$ef=E;function o(U,B,q){const O=[];function C(re,ae,fe){if(ae===0&&fe.length===0)return;const we=O[O.length-1];we&&we.start+we.deleteCount===re?(we.deleteCount+=ae,we.toInsert.push(...fe)):O.push({start:re,deleteCount:ae,toInsert:fe})}let Q=0,ee=0;for(;;){if(Q===U.length){C(Q,0,B.slice(ee));break}if(ee===B.length){C(Q,U.length-Q,[]);break}const re=U[Q],ae=B[ee],fe=q(re,ae);fe===0?(Q+=1,ee+=1):fe<0?(C(Q,1,[]),Q+=1):fe>0&&(C(Q,0,[ae]),ee+=1)}return O}t.$ff=o;function h(U,B,q){const O=o(U,B,q),C=[],Q=[];for(const ee of O)C.push(...U.slice(ee.start,ee.start+ee.deleteCount)),Q.push(...ee.toInsert);return{removed:C,added:Q}}t.$gf=h;function e(U,B,q){if(q===0)return[];const O=U.slice(0,q).sort(B);return y(U,B,O,q,U.length),O}t.top=e;function A(U,B,q,O,C){return q===0?Promise.resolve([]):new Promise((Q,ee)=>{(async()=>{const re=U.length,ae=U.slice(0,q).sort(B);for(let fe=q,we=Math.min(q+O,re);fe<re;fe=we,we=Math.min(we+O,re)){if(fe>q&&await new Promise(Fe=>setTimeout(Fe)),C&&C.isCancellationRequested)throw new k.$2;y(U,B,ae,fe,we)}return ae})().then(Q,ee)})}t.$if=A;function y(U,B,q,O,C){for(const Q=q.length;O<C;O++){const ee=U[O];if(B(ee,q[Q-1])<0){q.pop();const re=s(q,ae=>B(ee,ae)<0);q.splice(re,0,ee)}}}function _(U){return U.filter(B=>!!B)}t.$jf=_;function $(U){let B=0;for(let q=0;q<U.length;q++)U[q]&&(U[B]=U[q],B+=1);U.length=B}t.$kf=$;function M(U,B,q){U.splice(q,0,U.splice(B,1)[0])}t.$lf=M;function g(U){return!Array.isArray(U)||U.length===0}t.$mf=g;function m(U){return Array.isArray(U)&&U.length>0}t.$nf=m;function r(U,B=q=>q){const q=new Set;return U.filter(O=>{const C=B(O);return q.has(C)?!1:(q.add(C),!0)})}t.$of=r;function l(U){const B=new Set;return q=>{const O=U(q);return B.has(O)?!1:(B.add(O),!0)}}t.$pf=l;function R(U,B){const q=f(U,B);if(q!==-1)return U[q]}t.$qf=R;function f(U,B){for(let q=U.length-1;q>=0;q--){const O=U[q];if(B(O))return q}return-1}t.$rf=f;function w(U,B){return U.length>0?U[0]:B}t.$sf=w;function N(U,B){return U.length>0?U[U.length-1]:B}t.$tf=N;function b(U,B,q=(O,C)=>O===C){let O=0;for(let C=0,Q=Math.min(U.length,B.length);C<Q&&q(U[C],B[C]);C++)O++;return O}t.$uf=b;function p(U){return[].concat(...U)}t.$vf=p;function F(U,B){let q=typeof B=="number"?U:0;typeof B=="number"?q=U:(q=0,B=U);const O=[];if(q<=B)for(let C=q;C<B;C++)O.push(C);else for(let C=q;C>B;C--)O.push(C);return O}t.$wf=F;function P(U,B,q){return U.reduce((O,C)=>(O[B(C)]=q?q(C):C,O),Object.create(null))}t.$xf=P;function v(U,B){return U.push(B),()=>I(U,B)}t.$yf=v;function I(U,B){const q=U.indexOf(B);if(q>-1)return U.splice(q,1),B}t.$zf=I;function S(U,B,q){const O=U.slice(0,B),C=U.slice(B);return O.concat(q,C)}t.$Af=S;function W(U,B){let q;if(typeof B=="number"){let O=B;q=()=>{const C=Math.sin(O++)*179426549;return C-Math.floor(C)}}else q=Math.random;for(let O=U.length-1;O>0;O-=1){const C=Math.floor(q()*(O+1)),Q=U[O];U[O]=U[C],U[C]=Q}}t.$Bf=W;function z(U,B){const q=U.indexOf(B);q>-1&&(U.splice(q,1),U.unshift(B))}t.$Cf=z;function x(U,B){const q=U.indexOf(B);q>-1&&(U.splice(q,1),U.push(B))}t.$Df=x;function J(U,B){for(const q of B)U.push(q)}t.$Ef=J;function G(U,B){return Array.isArray(U)?U.map(B):B(U)}t.$Ff=G;function ne(U){return Array.isArray(U)?U:[U]}t.$Gf=ne;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$Hf=n;function de(U,B){for(const q of U){const O=B(q);if(O!==void 0)return O}}t.$If=de;function $e(U,B,q){const O=oe(U,B),C=U.length,Q=q.length;U.length=C+Q;for(let ee=C-1;ee>=O;ee--)U[ee+Q]=U[ee];for(let ee=0;ee<Q;ee++)U[ee+O]=q[ee]}t.$Jf=$e;function me(U,B,q,O){const C=oe(U,B),Q=U.splice(C,q);return $e(U,C,O),Q}t.$Kf=me;function oe(U,B){return B<0?Math.max(B+U.length,0):Math.min(B,U.length)}var ve;(function(U){function B(C){return C<0}U.isLessThan=B;function q(C){return C>0}U.isGreaterThan=q;function O(C){return C===0}U.isNeitherLessOrGreaterThan=O,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Le(U,B){return(q,O)=>B(U(q),U(O))}t.$Lf=Le;function Ae(...U){return(B,q)=>{for(const O of U){const C=O(B,q);if(!ve.isNeitherLessOrGreaterThan(C))return C}return ve.neitherLessOrGreaterThan}}t.$Mf=Ae;const Me=(U,B)=>U-B;t.$Nf=Me;function Re(U,B){if(U.length===0)return;let q=U[0];for(let O=1;O<U.length;O++){const C=U[O];B(C,q)>0&&(q=C)}return q}t.$Of=Re;function ue(U,B){if(U.length===0)return;let q=U[0];for(let O=1;O<U.length;O++){const C=U[O];B(C,q)>=0&&(q=C)}return q}t.$Pf=ue;function le(U,B){return Re(U,(q,O)=>-B(q,O))}t.$Qf=le;class se{constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let q=this.c;for(;q<this.f.length&&B(this.f[q]);)q++;const O=q===this.c?null:this.f.slice(this.c,q);return this.c=q,O}takeFromEndWhile(B){let q=this.d;for(;q>=0&&B(this.f[q]);)q--;const O=q===this.d?null:this.f.slice(q+1,this.d+1);return this.d=q,O}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const q=this.f.slice(this.c,this.c+B);return this.c+=B,q}}t.$Rf=se;class ge{constructor(B){this.iterate=B}forEach(B){this.iterate(q=>(B(q),!0))}toArray(){const B=[];return this.iterate(q=>(B.push(q),!0)),B}filter(B){return new ge(q=>this.iterate(O=>B(O)?q(O):!0))}map(B){return new ge(q=>this.iterate(O=>q(B(O))))}some(B){let q=!1;return this.iterate(O=>(q=B(O),!q)),q}findFirst(B){let q;return this.iterate(O=>B(O)?(q=O,!1):!0),q}findLast(B){let q;return this.iterate(O=>(B(O)&&(q=O),!0)),q}findLastMaxBy(B){let q,O=!0;return this.iterate(C=>((O||ve.isGreaterThan(B(C,q)))&&(O=!1,q=C),!0)),q}}t.$Sf=ge,ge.empty=new ge(U=>{})}),Z(K[10],te([0,1,3]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oc=t.$nc=t.$mc=t.$lc=t.ok=void 0;function D(u,s){if(!u)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=D;function i(u,s="Unreachable"){throw new Error(s)}t.$lc=i;function a(u){if(!u)throw new k.$ab("Assertion Failed")}t.$mc=a;function L(u){if(!u()){debugger;u(),(0,k.$X)(new k.$ab("Assertion Failed"))}}t.$nc=L;function d(u,s){let c=0;for(;c<u.length-1;){const E=u[c],o=u[c+1];if(!s(E,o))return!1;c++}return!0}t.$oc=d}),Z(K[15],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function k(D){const i=this;let a=!1,L;return function(){return a||(a=!0,L=D.apply(i,arguments)),L}}t.$bb=k}),Z(K[16],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(D){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}D.is=i;const a=Object.freeze([]);function L(){return a}D.empty=L;function*d(g){yield g}D.single=d;function u(g){return i(g)?g:d(g)}D.wrap=u;function s(g){return g||a}D.from=s;function c(g){return!g||g[Symbol.iterator]().next().done===!0}D.isEmpty=c;function E(g){return g[Symbol.iterator]().next().value}D.first=E;function o(g,m){for(const r of g)if(m(r))return!0;return!1}D.some=o;function h(g,m){for(const r of g)if(m(r))return r}D.find=h;function*e(g,m){for(const r of g)m(r)&&(yield r)}D.filter=e;function*A(g,m){let r=0;for(const l of g)yield m(l,r++)}D.map=A;function*y(...g){for(const m of g)for(const r of m)yield r}D.concat=y;function _(g,m,r){let l=r;for(const R of g)l=m(l,R);return l}D.reduce=_;function*$(g,m,r=g.length){for(m<0&&(m+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);m<r;m++)yield g[m]}D.slice=$;function M(g,m=Number.POSITIVE_INFINITY){const r=[];if(m===0)return[r,g];const l=g[Symbol.iterator]();for(let R=0;R<m;R++){const f=l.next();if(f.done)return[r,D.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return l}}]}D.consume=M})(k||(t.Iterable=k={}))}),Z(K[30],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hq=t.KeyMod=t.KeyCodeUtils=t.$gq=t.$fq=t.$eq=t.$dq=t.$cq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,y){this._keyCodeToStr[A]=y,this._strToKeyCode[y.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const a=new i,L=new i,d=new i;t.$cq=new Array(230),t.$dq={};const u=[],s=Object.create(null),c=Object.create(null);t.$eq={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>s[e]||0,toString:e=>u[e]||"None"},t.$fq=[],t.$gq=[];for(let e=0;e<=193;e++)t.$fq[e]=-1;for(let e=0;e<=132;e++)t.$gq[e]=-1;(function(){const e="",A=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],y=[],_=[];for(const $ of A){const[M,g,m,r,l,R,f,w,N]=$;if(_[g]||(_[g]=!0,u[g]=m,s[m]=g,c[m.toLowerCase()]=g,M&&(t.$fq[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$gq[r]=g))),!y[r]){if(y[r]=!0,!l)throw new Error(`String representation missing for key code ${r} around scan code ${m}`);a.define(r,l),L.define(r,w||l),d.define(r,N||w||l)}R&&(t.$cq[R]=r),f&&(t.$dq[f]=r)}t.$gq[3]=46})();var E;(function(e){function A(m){return a.keyCodeToStr(m)}e.toString=A;function y(m){return a.strToKeyCode(m)}e.fromString=y;function _(m){return L.keyCodeToStr(m)}e.toUserSettingsUS=_;function $(m){return d.keyCodeToStr(m)}e.toUserSettingsGeneral=$;function M(m){return L.strToKeyCode(m)||d.strToKeyCode(m)}e.fromUserSettings=M;function g(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(m)}e.toElectronAccelerator=g})(E||(t.KeyCodeUtils=E={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o||(t.KeyMod=o={}));function h(e,A){const y=(A&65535)<<16>>>0;return(e|y)>>>0}t.$hq=h}),Z(K[31],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=void 0;class k{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$S=k}),Z(K[7],te([0,1,15,16]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=t.$cb=void 0;const i=!1;let a=null;function L(N){a=N}if(t.$cb=L,i){const N="__is_disposable_tracked__";L(new class{trackDisposable(b){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[N]||console.log(p)},3e3)}setParent(b,p){if(b&&b!==$.None)try{b[N]=!0}catch{}}markAsDisposed(b){if(b&&b!==$.None)try{b[N]=!0}catch{}}markAsSingleton(b){}})}function d(N){return a?.trackDisposable(N),N}function u(N){a?.markAsDisposed(N)}function s(N,b){a?.setParent(N,b)}function c(N,b){if(a)for(const p of N)a.setParent(p,b)}function E(N){return a?.markAsSingleton(N),N}t.$db=E;function o(N){return typeof N.dispose=="function"&&N.dispose.length===0}t.$eb=o;function h(N){if(D.Iterable.is(N)){const b=[];for(const p of N)if(p)try{p.dispose()}catch(F){b.push(F)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(N)?[]:N}else if(N)return N.dispose(),N}t.$fb=h;function e(N){for(const b of N)o(b)&&b.dispose();return[]}t.$gb=e;function A(...N){const b=y(()=>h(N));return c(N,b),b}t.$hb=A;function y(N){const b=d({dispose:(0,k.$bb)(()=>{u(b),N()})});return b}t.$ib=y;class _{constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return s(b,this),this.g?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}}t.$jb=_,_.DISABLE_DISPOSED_WARNING=!1;class ${constructor(){this.q=new _,d(this),s(this.q,this)}dispose(){u(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}t.$kb=$,$.None=Object.freeze({dispose(){}});class M{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&s(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&s(b,null),b}}t.$lb=M;class g{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$mb=g;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(b){let p=b;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,u(this))},this}}t.$nb=m;class r{constructor(){this.a=new Map}acquire(b,...p){let F=this.a.get(b);F||(F={counter:0,object:this.b(b,...p)},this.a.set(b,F));const{object:P}=F,v=(0,k.$bb)(()=>{--F.counter===0&&(this.c(b,F.object),this.a.delete(b))});return F.counter++,{object:P,dispose:v}}}t.$ob=r;class l{constructor(b){this.a=b}async acquire(b,...p){const F=this.a.acquire(b,...p);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(P){throw F.dispose(),P}}}t.$pb=l;class R{constructor(b){this.object=b}dispose(){}}t.$qb=R;function f(N){const b=new _;try{N(b)}finally{b.dispose()}}t.$rb=f;class w{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get(b){return this.a.get(b)}set(b,p,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(b)?.dispose(),this.a.set(b,p)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$sb=w}),Z(K[17],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jc=void 0;class k{constructor(a){this.element=a,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class D{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let a=this.a;for(;a!==k.Undefined;){const L=a.next;a.prev=k.Undefined,a.next=k.Undefined,a=L}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(a){return this.d(a,!1)}push(a){return this.d(a,!0)}d(a,L){const d=new k(a);if(this.a===k.Undefined)this.a=d,this.b=d;else if(L){const s=this.b;this.b=d,d.prev=s,s.next=d}else{const s=this.a;this.a=d,d.next=s,s.prev=d}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(d))}}shift(){if(this.a!==k.Undefined){const a=this.a.element;return this.e(this.a),a}}pop(){if(this.b!==k.Undefined){const a=this.b.element;return this.e(this.b),a}}e(a){if(a.prev!==k.Undefined&&a.next!==k.Undefined){const L=a.prev;L.next=a.next,a.next.prev=L}else a.prev===k.Undefined&&a.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):a.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):a.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let a=this.a;for(;a!==k.Undefined;)yield a.element,a=a.next}}t.$jc=D}),Z(K[11],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.Platform=t.$b=t.$a=void 0,t.$a="en";let k=!1,D=!1,i=!1,a=!1,L=!1,d=!1,u=!1,s=!1,c=!1,E=!1,o,h=t.$a,e=t.$a,A,y;t.$b=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.$b.vscode<"u"&&typeof t.$b.vscode.process<"u"?_=t.$b.vscode.process:typeof process<"u"&&(_=process);const $=typeof _?.versions?.electron=="string",M=$&&_?.type==="renderer";if(typeof navigator=="object"&&!M){y=navigator.userAgent,k=y.indexOf("Windows")>=0,D=y.indexOf("Macintosh")>=0,s=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=y.indexOf("Linux")>=0,E=y?.indexOf("Mobi")>=0,d=!0,o=t.$a,h=o,e=navigator.language;const b=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),p=b&&b.getAttribute("data-settings");if(p)try{const F=JSON.parse(p),P=F.availableLanguages["*"];o=F.locale,e=F.osLocale,h=P||t.$a,A=F._translationsConfigFile}catch{}}else if(typeof _=="object"){k=_.platform==="win32",D=_.platform==="darwin",i=_.platform==="linux",a=i&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,u=$,c=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=t.$a,h=t.$a;const b=_.env.VSCODE_NLS_CONFIG;if(b)try{const p=JSON.parse(b),F=p.availableLanguages["*"];o=p.locale,e=p.osLocale,h=F||t.$a,A=p._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var g;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(g||(t.Platform=g={}));function m(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$c=m;let r=0;D?r=1:k?r=3:i&&(r=2),t.$d=k,t.$e=D,t.$f=i,t.$g=a,t.$h=L,t.$i=u,t.$j=d,t.$k=d&&typeof t.$b.importScripts=="function",t.$l=s,t.$m=E,t.$n=c,t.$o=r,t.$p=y,t.$q=h;var l;(function(b){function p(){return t.$q}b.value=p;function F(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}b.isDefaultVariant=F;function P(){return t.$q==="en"}b.isDefault=P})(l||(t.Language=l={})),t.$r=o,t.$s=e,t.$t=A,t.$u=typeof t.$b.postMessage=="function"&&!t.$b.importScripts,t.$v=(()=>{if(t.$u){const b=[];t.$b.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let P=0,v=b.length;P<v;P++){const I=b[P];if(I.id===F.data.vscodeScheduleAsyncWork){b.splice(P,1),I.callback();return}}});let p=0;return F=>{const P=++p;b.push({id:P,callback:F}),t.$b.postMessage({vscodeScheduleAsyncWork:P},"*")}}return b=>setTimeout(b)})();var R;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(R||(t.OperatingSystem=R={})),t.OS=D||s?2:k?1:3;let f=!0,w=!1;function N(){if(!w){w=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,f=new Uint16Array(b.buffer)[0]===(2<<8)+1}return f}t.$x=N,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0)}),Z(K[32],te([0,1,11]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6b=t.$5b=t.env=t.cwd=void 0;let D;if(typeof k.$b.vscode<"u"&&typeof k.$b.vscode.process<"u"){const i=k.$b.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return k.$d?"win32":k.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$5b=D.platform,t.$6b=D.arch}),Z(K[33],te([0,1,32]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ic=t.sep=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=void 0;const D=65,i=97,a=90,L=122,d=46,u=47,s=92,c=58,E=63;class o extends Error{constructor(l,R,f){let w;typeof R=="string"&&R.indexOf("not ")===0?(w="must not be",R=R.replace(/^not /,"")):w="must be";const N=l.indexOf(".")!==-1?"property":"argument";let b=`The "${l}" ${N} ${w} of type ${R}`;b+=`. Received type ${typeof f}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,l){if(r===null||typeof r!="object")throw new o(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new o(l,"string",r)}const A=k.$5b==="win32";function y(r){return r===u||r===s}function _(r){return r===u}function $(r){return r>=D&&r<=a||r>=i&&r<=L}function M(r,l,R,f){let w="",N=0,b=-1,p=0,F=0;for(let P=0;P<=r.length;++P){if(P<r.length)F=r.charCodeAt(P);else{if(f(F))break;F=u}if(f(F)){if(!(b===P-1||p===1))if(p===2){if(w.length<2||N!==2||w.charCodeAt(w.length-1)!==d||w.charCodeAt(w.length-2)!==d){if(w.length>2){const v=w.lastIndexOf(R);v===-1?(w="",N=0):(w=w.slice(0,v),N=w.length-1-w.lastIndexOf(R)),b=P,p=0;continue}else if(w.length!==0){w="",N=0,b=P,p=0;continue}}l&&(w+=w.length>0?`${R}..`:"..",N=2)}else w.length>0?w+=`${R}${r.slice(b+1,P)}`:w=r.slice(b+1,P),N=P-b-1;b=P,p=0}else F===d&&p!==-1?++p:p=-1}return w}function g(r,l){h(l,"pathObject");const R=l.dir||l.root,f=l.base||`${l.name||""}${l.ext||""}`;return R?R===l.root?`${R}${f}`:`${R}${r}${f}`:f}t.$7b={resolve(...r){let l="",R="",f=!1;for(let w=r.length-1;w>=-1;w--){let N;if(w>=0){if(N=r[w],e(N,"path"),N.length===0)continue}else l.length===0?N=k.cwd():(N=k.env[`=${l}`]||k.cwd(),(N===void 0||N.slice(0,2).toLowerCase()!==l.toLowerCase()&&N.charCodeAt(2)===s)&&(N=`${l}\\`));const b=N.length;let p=0,F="",P=!1;const v=N.charCodeAt(0);if(b===1)y(v)&&(p=1,P=!0);else if(y(v))if(P=!0,y(N.charCodeAt(1))){let I=2,S=I;for(;I<b&&!y(N.charCodeAt(I));)I++;if(I<b&&I!==S){const W=N.slice(S,I);for(S=I;I<b&&y(N.charCodeAt(I));)I++;if(I<b&&I!==S){for(S=I;I<b&&!y(N.charCodeAt(I));)I++;(I===b||I!==S)&&(F=`\\\\${W}\\${N.slice(S,I)}`,p=I)}}}else p=1;else $(v)&&N.charCodeAt(1)===c&&(F=N.slice(0,2),p=2,b>2&&y(N.charCodeAt(2))&&(P=!0,p=3));if(F.length>0)if(l.length>0){if(F.toLowerCase()!==l.toLowerCase())continue}else l=F;if(f){if(l.length>0)break}else if(R=`${N.slice(p)}\\${R}`,f=P,P&&l.length>0)break}return R=M(R,!f,"\\",y),f?`${l}\\${R}`:`${l}${R}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let R=0,f,w=!1;const N=r.charCodeAt(0);if(l===1)return _(N)?"\\":r;if(y(N))if(w=!0,y(r.charCodeAt(1))){let p=2,F=p;for(;p<l&&!y(r.charCodeAt(p));)p++;if(p<l&&p!==F){const P=r.slice(F,p);for(F=p;p<l&&y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&!y(r.charCodeAt(p));)p++;if(p===l)return`\\\\${P}\\${r.slice(F)}\\`;p!==F&&(f=`\\\\${P}\\${r.slice(F,p)}`,R=p)}}}else R=1;else $(N)&&r.charCodeAt(1)===c&&(f=r.slice(0,2),R=2,l>2&&y(r.charCodeAt(2))&&(w=!0,R=3));let b=R<l?M(r.slice(R),!w,"\\",y):"";return b.length===0&&!w&&(b="."),b.length>0&&y(r.charCodeAt(l-1))&&(b+="\\"),f===void 0?w?`\\${b}`:b:w?`${f}\\${b}`:`${f}${b}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const R=r.charCodeAt(0);return y(R)||l>2&&$(R)&&r.charCodeAt(1)===c&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,R;for(let N=0;N<r.length;++N){const b=r[N];e(b,"path"),b.length>0&&(l===void 0?l=R=b:l+=`\\${b}`)}if(l===void 0)return".";let f=!0,w=0;if(typeof R=="string"&&y(R.charCodeAt(0))){++w;const N=R.length;N>1&&y(R.charCodeAt(1))&&(++w,N>2&&(y(R.charCodeAt(2))?++w:f=!1))}if(f){for(;w<l.length&&y(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$7b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const R=t.$7b.resolve(r),f=t.$7b.resolve(l);if(R===f||(r=R.toLowerCase(),l=f.toLowerCase(),r===l))return"";let w=0;for(;w<r.length&&r.charCodeAt(w)===s;)w++;let N=r.length;for(;N-1>w&&r.charCodeAt(N-1)===s;)N--;const b=N-w;let p=0;for(;p<l.length&&l.charCodeAt(p)===s;)p++;let F=l.length;for(;F-1>p&&l.charCodeAt(F-1)===s;)F--;const P=F-p,v=b<P?b:P;let I=-1,S=0;for(;S<v;S++){const z=r.charCodeAt(w+S);if(z!==l.charCodeAt(p+S))break;z===s&&(I=S)}if(S!==v){if(I===-1)return f}else{if(P>v){if(l.charCodeAt(p+S)===s)return f.slice(p+S+1);if(S===2)return f.slice(p+S)}b>v&&(r.charCodeAt(w+S)===s?I=S:S===2&&(I=3)),I===-1&&(I=0)}let W="";for(S=w+I+1;S<=N;++S)(S===N||r.charCodeAt(S)===s)&&(W+=W.length===0?"..":"\\..");return p+=I,W.length>0?`${W}${f.slice(p,F)}`:(f.charCodeAt(p)===s&&++p,f.slice(p,F))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=t.$7b.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const R=l.charCodeAt(2);if(R!==E&&R!==d)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===c&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let R=-1,f=0;const w=r.charCodeAt(0);if(l===1)return y(w)?r:".";if(y(w)){if(R=f=1,y(r.charCodeAt(1))){let p=2,F=p;for(;p<l&&!y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&!y(r.charCodeAt(p));)p++;if(p===l)return r;p!==F&&(R=f=p+1)}}}}else $(w)&&r.charCodeAt(1)===c&&(R=l>2&&y(r.charCodeAt(2))?3:2,f=R);let N=-1,b=!0;for(let p=l-1;p>=f;--p)if(y(r.charCodeAt(p))){if(!b){N=p;break}}else b=!1;if(N===-1){if(R===-1)return".";N=R}return r.slice(0,N)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let R=0,f=-1,w=!0,N;if(r.length>=2&&$(r.charCodeAt(0))&&r.charCodeAt(1)===c&&(R=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let b=l.length-1,p=-1;for(N=r.length-1;N>=R;--N){const F=r.charCodeAt(N);if(y(F)){if(!w){R=N+1;break}}else p===-1&&(w=!1,p=N+1),b>=0&&(F===l.charCodeAt(b)?--b===-1&&(f=N):(b=-1,f=p))}return R===f?f=p:f===-1&&(f=r.length),r.slice(R,f)}for(N=r.length-1;N>=R;--N)if(y(r.charCodeAt(N))){if(!w){R=N+1;break}}else f===-1&&(w=!1,f=N+1);return f===-1?"":r.slice(R,f)},extname(r){e(r,"path");let l=0,R=-1,f=0,w=-1,N=!0,b=0;r.length>=2&&r.charCodeAt(1)===c&&$(r.charCodeAt(0))&&(l=f=2);for(let p=r.length-1;p>=l;--p){const F=r.charCodeAt(p);if(y(F)){if(!N){f=p+1;break}continue}w===-1&&(N=!1,w=p+1),F===d?R===-1?R=p:b!==1&&(b=1):R!==-1&&(b=-1)}return R===-1||w===-1||b===0||b===1&&R===w-1&&R===f+1?"":r.slice(R,w)},format:g.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const R=r.length;let f=0,w=r.charCodeAt(0);if(R===1)return y(w)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(y(w)){if(f=1,y(r.charCodeAt(1))){let I=2,S=I;for(;I<R&&!y(r.charCodeAt(I));)I++;if(I<R&&I!==S){for(S=I;I<R&&y(r.charCodeAt(I));)I++;if(I<R&&I!==S){for(S=I;I<R&&!y(r.charCodeAt(I));)I++;I===R?f=I:I!==S&&(f=I+1)}}}}else if($(w)&&r.charCodeAt(1)===c){if(R<=2)return l.root=l.dir=r,l;if(f=2,y(r.charCodeAt(2))){if(R===3)return l.root=l.dir=r,l;f=3}}f>0&&(l.root=r.slice(0,f));let N=-1,b=f,p=-1,F=!0,P=r.length-1,v=0;for(;P>=f;--P){if(w=r.charCodeAt(P),y(w)){if(!F){b=P+1;break}continue}p===-1&&(F=!1,p=P+1),w===d?N===-1?N=P:v!==1&&(v=1):N!==-1&&(v=-1)}return p!==-1&&(N===-1||v===0||v===1&&N===p-1&&N===b+1?l.base=l.name=r.slice(b,p):(l.name=r.slice(b,N),l.base=r.slice(b,p),l.ext=r.slice(N,p))),b>0&&b!==f?l.dir=r.slice(0,b-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(A){const r=/\\/g;return()=>{const l=k.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>k.cwd()})();t.$8b={resolve(...r){let l="",R=!1;for(let f=r.length-1;f>=-1&&!R;f--){const w=f>=0?r[f]:m();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,R=w.charCodeAt(0)===u)}return l=M(l,!R,"/",_),R?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===u,R=r.charCodeAt(r.length-1)===u;return r=M(r,!l,"/",_),r.length===0?l?"/":R?"./":".":(R&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let l;for(let R=0;R<r.length;++R){const f=r[R];e(f,"path"),f.length>0&&(l===void 0?l=f:l+=`/${f}`)}return l===void 0?".":t.$8b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=t.$8b.resolve(r),l=t.$8b.resolve(l),r===l))return"";const R=1,f=r.length,w=f-R,N=1,b=l.length-N,p=w<b?w:b;let F=-1,P=0;for(;P<p;P++){const I=r.charCodeAt(R+P);if(I!==l.charCodeAt(N+P))break;I===u&&(F=P)}if(P===p)if(b>p){if(l.charCodeAt(N+P)===u)return l.slice(N+P+1);if(P===0)return l.slice(N+P)}else w>p&&(r.charCodeAt(R+P)===u?F=P:P===0&&(F=0));let v="";for(P=R+F+1;P<=f;++P)(P===f||r.charCodeAt(P)===u)&&(v+=v.length===0?"..":"/..");return`${v}${l.slice(N+F)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===u;let R=-1,f=!0;for(let w=r.length-1;w>=1;--w)if(r.charCodeAt(w)===u){if(!f){R=w;break}}else f=!1;return R===-1?l?"/":".":l&&R===1?"//":r.slice(0,R)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let R=0,f=-1,w=!0,N;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let b=l.length-1,p=-1;for(N=r.length-1;N>=0;--N){const F=r.charCodeAt(N);if(F===u){if(!w){R=N+1;break}}else p===-1&&(w=!1,p=N+1),b>=0&&(F===l.charCodeAt(b)?--b===-1&&(f=N):(b=-1,f=p))}return R===f?f=p:f===-1&&(f=r.length),r.slice(R,f)}for(N=r.length-1;N>=0;--N)if(r.charCodeAt(N)===u){if(!w){R=N+1;break}}else f===-1&&(w=!1,f=N+1);return f===-1?"":r.slice(R,f)},extname(r){e(r,"path");let l=-1,R=0,f=-1,w=!0,N=0;for(let b=r.length-1;b>=0;--b){const p=r.charCodeAt(b);if(p===u){if(!w){R=b+1;break}continue}f===-1&&(w=!1,f=b+1),p===d?l===-1?l=b:N!==1&&(N=1):l!==-1&&(N=-1)}return l===-1||f===-1||N===0||N===1&&l===f-1&&l===R+1?"":r.slice(l,f)},format:g.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const R=r.charCodeAt(0)===u;let f;R?(l.root="/",f=1):f=0;let w=-1,N=0,b=-1,p=!0,F=r.length-1,P=0;for(;F>=f;--F){const v=r.charCodeAt(F);if(v===u){if(!p){N=F+1;break}continue}b===-1&&(p=!1,b=F+1),v===d?w===-1?w=F:P!==1&&(P=1):w!==-1&&(P=-1)}if(b!==-1){const v=N===0&&R?1:N;w===-1||P===0||P===1&&w===b-1&&w===N+1?l.base=l.name=r.slice(v,b):(l.name=r.slice(v,w),l.base=r.slice(v,b),l.ext=r.slice(w,b))}return N>0?l.dir=r.slice(0,N-1):R&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$8b.win32=t.$7b.win32=t.$7b,t.$8b.posix=t.$7b.posix=t.$8b,t.$9b=A?t.$7b.normalize:t.$8b.normalize,t.$0b=A?t.$7b.isAbsolute:t.$8b.isAbsolute,t.$$b=A?t.$7b.join:t.$8b.join,t.$_b=A?t.$7b.resolve:t.$8b.resolve,t.$ac=A?t.$7b.relative:t.$8b.relative,t.$bc=A?t.$7b.dirname:t.$8b.dirname,t.$cc=A?t.$7b.basename:t.$8b.basename,t.$dc=A?t.$7b.extname:t.$8b.extname,t.$ec=A?t.$7b.format:t.$8b.format,t.$fc=A?t.$7b.parse:t.$8b.parse,t.$gc=A?t.$7b.toNamespacedPath:t.$8b.toNamespacedPath,t.sep=A?t.$7b.sep:t.$8b.sep,t.$ic=A?t.$7b.delimiter:t.$8b.delimiter}),Z(K[18],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(a){return new D(a)}constructor(a){this.c=k&&a===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$1c=D}),Z(K[8],te([0,1,3,15,7,17,18]),function(j,t,k,D,i,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.$5c=t.$4c=t.$3c=t.Event=void 0;const d=!1,u=!1;var s;(function(p){p.None=()=>i.$kb.None;function F(U){if(u){const{onDidAddListener:B}=U,q=e.create();let O=0;U.onDidAddListener=()=>{++O===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),B?.()}}}function P(U,B){return ne(U,()=>{},0,void 0,!0,void 0,B)}p.defer=P;function v(U){return(B,q=null,O)=>{let C=!1,Q;return Q=U(ee=>{if(!C)return Q?Q.dispose():C=!0,B.call(q,ee)},null,O),C&&Q.dispose(),Q}}p.once=v;function I(U,B,q){return G((O,C=null,Q)=>U(ee=>O.call(C,B(ee)),null,Q),q)}p.map=I;function S(U,B,q){return G((O,C=null,Q)=>U(ee=>{B(ee),O.call(C,ee)},null,Q),q)}p.forEach=S;function W(U,B,q){return G((O,C=null,Q)=>U(ee=>B(ee)&&O.call(C,ee),null,Q),q)}p.filter=W;function z(U){return U}p.signal=z;function x(...U){return(B,q=null,O)=>(0,i.$hb)(...U.map(C=>C(Q=>B.call(q,Q),null,O)))}p.any=x;function J(U,B,q,O){let C=q;return I(U,Q=>(C=B(C,Q),C),O)}p.reduce=J;function G(U,B){let q;const O={onWillAddFirstListener(){q=U(C.fire,C)},onDidRemoveLastListener(){q?.dispose()}};B||F(O);const C=new M(O);return B?.add(C),C.event}function ne(U,B,q=100,O=!1,C=!1,Q,ee){let re,ae,fe,we=0,Fe;const Te={leakWarningThreshold:Q,onWillAddFirstListener(){re=U(Ue=>{we++,ae=B(ae,Ue),O&&!fe&&(ke.fire(ae),ae=void 0),Fe=()=>{const Ie=ae;ae=void 0,fe=void 0,(!O||we>1)&&ke.fire(Ie),we=0},typeof q=="number"?(clearTimeout(fe),fe=setTimeout(Fe,q)):fe===void 0&&(fe=0,queueMicrotask(Fe))})},onWillRemoveListener(){C&&we>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,re.dispose()}};ee||F(Te);const ke=new M(Te);return ee?.add(ke),ke.event}p.debounce=ne;function n(U,B=0,q){return p.debounce(U,(O,C)=>O?(O.push(C),O):[C],B,void 0,!0,void 0,q)}p.accumulate=n;function de(U,B=(O,C)=>O===C,q){let O=!0,C;return W(U,Q=>{const ee=O||!B(Q,C);return O=!1,C=Q,ee},q)}p.latch=de;function $e(U,B,q){return[p.filter(U,B,q),p.filter(U,O=>!B(O),q)]}p.split=$e;function me(U,B=!1,q=[]){let O=q.slice(),C=U(re=>{O?O.push(re):ee.fire(re)});const Q=()=>{O?.forEach(re=>ee.fire(re)),O=null},ee=new M({onWillAddFirstListener(){C||(C=U(re=>ee.fire(re)))},onDidAddFirstListener(){O&&(B?setTimeout(Q):Q())},onDidRemoveLastListener(){C&&C.dispose(),C=null}});return ee.event}p.buffer=me;class oe{constructor(B){this.event=B,this.d=new i.$jb}map(B){return new oe(I(this.event,B,this.d))}forEach(B){return new oe(S(this.event,B,this.d))}filter(B){return new oe(W(this.event,B,this.d))}reduce(B,q){return new oe(J(this.event,B,q,this.d))}latch(){return new oe(de(this.event,void 0,this.d))}debounce(B,q=100,O=!1,C=!1,Q){return new oe(ne(this.event,B,q,O,C,Q,this.d))}on(B,q,O){return this.event(B,q,O)}once(B,q,O){return v(this.event)(B,q,O)}dispose(){this.d.dispose()}}function ve(U){return new oe(U)}p.chain=ve;function Le(U,B,q=O=>O){const O=(...re)=>ee.fire(q(...re)),C=()=>U.on(B,O),Q=()=>U.removeListener(B,O),ee=new M({onWillAddFirstListener:C,onDidRemoveLastListener:Q});return ee.event}p.fromNodeEventEmitter=Le;function Ae(U,B,q=O=>O){const O=(...re)=>ee.fire(q(...re)),C=()=>U.addEventListener(B,O),Q=()=>U.removeEventListener(B,O),ee=new M({onWillAddFirstListener:C,onDidRemoveLastListener:Q});return ee.event}p.fromDOMEventEmitter=Ae;function Me(U){return new Promise(B=>v(U)(B))}p.toPromise=Me;function Re(U,B){return B(void 0),U(q=>B(q))}p.runAndSubscribe=Re;function ue(U,B){let q=null;function O(Q){q?.dispose(),q=new i.$jb,B(Q,q)}O(void 0);const C=U(Q=>O(Q));return(0,i.$ib)(()=>{C.dispose(),q?.dispose()})}p.runAndSubscribeWithStore=ue;class le{constructor(B,q){this._observable=B,this.d=0,this.f=!1;const O={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};q||F(O),this.emitter=new M(O),q&&q.add(this.emitter)}beginUpdate(B){this.d++}handlePossibleChange(B){}handleChange(B,q){this.f=!0}endUpdate(B){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function se(U,B){return new le(U,B).emitter.event}p.fromObservable=se;function ge(U){return B=>{let q=0,O=!1;const C={beginUpdate(){q++},endUpdate(){q--,q===0&&(U.reportChanges(),O&&(O=!1,B()))},handlePossibleChange(){},handleChange(){O=!0}};return U.addObserver(C),{dispose(){U.removeObserver(C)}}}}p.fromObservableLight=ge})(s||(t.Event=s={}));class c{constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${c.d++}`,c.all.add(this)}start(F){this.f=new L.$1c,this.listenerCount=F}stop(){if(this.f){const F=this.f.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.f=void 0}}}t.$3c=c,c.all=new Set,c.d=0;let E=-1;function o(p){const F=E;return E=p,{dispose(){E=F}}}t.$4c=o;class h{constructor(F,P=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=P,this.f=0}dispose(){this.d?.clear()}check(F,P){const v=this.threshold;if(v<=0||P<v)return;this.d||(this.d=new Map);const I=this.d.get(F.value)||0;if(this.d.set(F.value,I+1),this.f-=1,this.f<=0){this.f=v*.5;let S,W=0;for(const[z,x]of this.d)(!S||W<x)&&(S=z,W=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${W}):`),console.warn(S)}return()=>{const S=this.d.get(F.value)||0;this.d.set(F.value,S-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let A=0;class y{constructor(F){this.value=F,this.id=A++}}const _=2,$=(p,F)=>{if(p instanceof y)F(p);else for(let P=0;P<p.length;P++){const v=p[P];v&&F(v)}};class M{constructor(F){this.u=0,this.d=F,this.f=E>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new c(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(d){const F=this.q;queueMicrotask(()=>{$(F,P=>P.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(F,P,v)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$kb.None;if(this.j)return i.$kb.None;P&&(F=F.bind(P));const I=new y(F);let S,W;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(I.stack=e.create(),S=this.f.check(I.stack,this.u+1)),d&&(I.stack=W??e.create()),this.q?this.q instanceof y?(this.t??=new m,this.q=[this.q,I]):this.q.push(I):(this.d?.onWillAddFirstListener?.(this),this.q=I,this.d?.onDidAddFirstListener?.(this)),this.u++;const z=(0,i.$ib)(()=>{S?.(),this.v(I)});return v instanceof i.$jb?v.add(z):Array.isArray(v)&&v.push(z),z},this.m}v(F){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const P=this.q,v=P.indexOf(F);if(v===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,P[v]=void 0;const I=this.t.current===this;if(this.u*_<=P.length){let S=0;for(let W=0;W<P.length;W++)P[W]?P[S++]=P[W]:I&&(this.t.end--,S<this.t.i&&this.t.i--);P.length=S}}w(F,P){if(!F)return;const v=this.d?.onListenerError||k.$X;if(!v){F.value(P);return}try{F.value(P)}catch(I){v(I)}}x(F){const P=F.current.q;for(;F.i<F.end;)this.w(P[F.i++],F.value);F.reset()}fire(F){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof y)this.w(this.q,F);else{const P=this.t;P.enqueue(this,F,this.q.length),this.x(P)}this.g?.stop()}hasListeners(){return this.u>0}}t.$5c=M;const g=()=>new m;t.$6c=g;class m{constructor(){this.i=-1,this.end=0}enqueue(F,P,v){this.i=0,this.end=v,this.current=F,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends M{async fireAsync(F,P,v){if(this.q)for(this.h||(this.h=new a.$jc),$(this.q,I=>this.h.push([I.value,F]));this.h.size>0&&!P.isCancellationRequested;){const[I,S]=this.h.shift(),W=[],z={...S,token:P,waitUntil:x=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");v&&(x=v(x,I)),W.push(x)}};try{I(z)}catch(x){(0,k.$X)(x);continue}Object.freeze(W),await Promise.allSettled(W).then(x=>{for(const J of x)J.status==="rejected"&&(0,k.$X)(J.reason)})}}}t.$7c=r;class l extends M{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new a.$jc,this.y=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.y(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.u&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$8c=l;class R extends l{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$9c=R;class f extends M{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$0c=f;class w{constructor(){this.f=!1,this.g=[],this.d=new M({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(F){const P={event:F,listener:null};this.g.push(P),this.f&&this.k(P);const v=()=>{this.f&&this.m(P);const I=this.g.indexOf(P);this.g.splice(I,1)};return(0,i.$ib)((0,D.$bb)(v))}h(){this.f=!0,this.g.forEach(F=>this.k(F))}j(){this.f=!1,this.g.forEach(F=>this.m(F))}k(F){F.listener=F.event(P=>this.d.fire(P))}m(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.d.dispose()}}t.$$c=w;class N{constructor(){this.d=[]}wrapEvent(F){return(P,v,I)=>F(S=>{const W=this.d[this.d.length-1];W?W.push(()=>P.call(v,S)):P.call(v,S)},void 0,I)}bufferEvents(F){const P=[];this.d.push(P);const v=F();return this.d.pop(),P.forEach(I=>I()),v}}t.$_c=N;class b{constructor(){this.d=!1,this.f=s.None,this.g=i.$kb.None,this.h=new M({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(F){this.f=F,this.d&&(this.g.dispose(),this.g=F(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$ad=b}),Z(K[19],te([0,1,8]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=t.CancellationToken=void 0;const D=Object.freeze(function(d,u){const s=setTimeout(d.bind(u),0);return{dispose(){clearTimeout(s)}}});var i;(function(d){function u(s){return s===d.None||s===d.Cancelled||s instanceof a?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=u,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(t.CancellationToken=i={}));class a{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new k.$5c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(u){this.a=void 0,this.b=void 0,this.b=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new a),this.a}cancel(){this.a?this.a instanceof a&&this.a.cancel():this.a=i.Cancelled}dispose(u=!1){u&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof a&&this.a.dispose():this.a=i.None}}t.$bd=L}),Z(K[34],te([0,1,19]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ed=t.$dd=t.$cd=void 0;class D{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new k.$bd,u=this.b(d.token);return this.a={promise:u,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$cd=D;class i{constructor(d){this.c=d,this.a=void 0,this.b=void 0}get(d){const u=JSON.stringify(d);return this.b!==u&&(this.b=u,this.a=this.c(d)),this.a}}t.$dd=i;class a{get cachedValues(){return this.a}constructor(d){this.b=d,this.a=new Map}get(d){if(this.a.has(d))return this.a.get(d);const u=this.b(d);return this.a.set(d,u),u}}t.$ed=a}),Z(K[5],te([0,1,34,31]),function(j,t,k,D){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=t.$ee=t.$de=t.$ce=t.GraphemeBreakType=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=t.$kd=t.$jd=t.$id=t.$hd=void 0;function a(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$hd=a;const L=/{(\d+)}/g;function d(T,...V){return V.length===0?T:T.replace(L,function(H,X){const Y=parseInt(X,10);return isNaN(Y)||Y<0||Y>=V.length?H:V[Y]})}t.$id=d;const u=/{([^}]+)}/g;function s(T,V){return T.replace(u,(H,X)=>V[X]??H)}t.$jd=s;function c(T){return T.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}t.$kd=c;function E(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$ld=E;function o(T,V){let H=0;const X=V.charCodeAt(0);for(let Y=T.length-1;Y>=0;Y--)T.charCodeAt(Y)===X&&H++;return H}t.$md=o;function h(T,V,H="\u2026"){return T.length<=V?T:`${T.substr(0,V)}${H}`}t.$nd=h;function e(T,V=" "){const H=A(T,V);return y(H,V)}t.$od=e;function A(T,V){if(!T||!V)return T;const H=V.length;if(H===0||T.length===0)return T;let X=0;for(;T.indexOf(V,X)===X;)X=X+H;return T.substring(X)}t.$pd=A;function y(T,V){if(!T||!V)return T;const H=V.length,X=T.length;if(H===0||X===0)return T;let Y=X,ie=-1;for(;ie=T.lastIndexOf(V,Y-1),!(ie===-1||ie+H!==Y);){if(ie===0)return"";Y=ie}return T.substring(0,Y)}t.$qd=y;function _(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$rd=_;function $(T){return T.replace(/\*/g,"")}t.$sd=$;function M(T,V,H={}){if(!T)throw new Error("Cannot create regex from empty string");V||(T=E(T)),H.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let X="";return H.global&&(X+="g"),H.matchCase||(X+="i"),H.multiline&&(X+="m"),H.unicode&&(X+="u"),new RegExp(T,X)}t.$td=M;function g(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$ud=g;function m(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.$vd=m;function r(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.$wd=r;function l(T){return T.split(/\r\n|\r|\n/)}t.$xd=l;function R(T){for(let V=0,H=T.length;V<H;V++){const X=T.charCodeAt(V);if(X!==32&&X!==9)return V}return-1}t.$yd=R;function f(T,V=0,H=T.length){for(let X=V;X<H;X++){const Y=T.charCodeAt(X);if(Y!==32&&Y!==9)return T.substring(V,X)}return T.substring(V,H)}t.$zd=f;function w(T,V=T.length-1){for(let H=V;H>=0;H--){const X=T.charCodeAt(H);if(X!==32&&X!==9)return H}return-1}t.$Ad=w;function N(T,V,H){const X=[];let Y=0;for(const ie of T.matchAll(V)){if(X.push(T.slice(Y,ie.index)),ie.index===void 0)throw new Error("match.index should be defined");Y=ie.index+ie[0].length,X.push(H(ie[0],...ie.slice(1),ie.index,T,ie.groups))}return X.push(T.slice(Y)),Promise.all(X).then(ie=>ie.join(""))}t.$Bd=N;function b(T,V){return T<V?-1:T>V?1:0}t.$Cd=b;function p(T,V,H=0,X=T.length,Y=0,ie=V.length){for(;H<X&&Y<ie;H++,Y++){const ye=T.charCodeAt(H),ce=V.charCodeAt(Y);if(ye<ce)return-1;if(ye>ce)return 1}const be=X-H,Pe=ie-Y;return be<Pe?-1:be>Pe?1:0}t.$Dd=p;function F(T,V){return P(T,V,0,T.length,0,V.length)}t.$Ed=F;function P(T,V,H=0,X=T.length,Y=0,ie=V.length){for(;H<X&&Y<ie;H++,Y++){let ye=T.charCodeAt(H),ce=V.charCodeAt(Y);if(ye===ce)continue;if(ye>=128||ce>=128)return p(T.toLowerCase(),V.toLowerCase(),H,X,Y,ie);I(ye)&&(ye-=32),I(ce)&&(ce-=32);const Ne=ye-ce;if(Ne!==0)return Ne}const be=X-H,Pe=ie-Y;return be<Pe?-1:be>Pe?1:0}t.$Fd=P;function v(T){return T>=48&&T<=57}t.$Gd=v;function I(T){return T>=97&&T<=122}t.$Hd=I;function S(T){return T>=65&&T<=90}t.$Id=S;function W(T,V){return T.length===V.length&&P(T,V)===0}t.$Jd=W;function z(T,V){const H=V.length;return V.length>T.length?!1:P(T,V,0,H)===0}t.$Kd=z;function x(T,V){const H=Math.min(T.length,V.length);let X;for(X=0;X<H;X++)if(T.charCodeAt(X)!==V.charCodeAt(X))return X;return H}t.$Ld=x;function J(T,V){const H=Math.min(T.length,V.length);let X;const Y=T.length-1,ie=V.length-1;for(X=0;X<H;X++)if(T.charCodeAt(Y-X)!==V.charCodeAt(ie-X))return X;return H}t.$Md=J;function G(T){return 55296<=T&&T<=56319}t.$Nd=G;function ne(T){return 56320<=T&&T<=57343}t.$Od=ne;function n(T,V){return(T-55296<<10)+(V-56320)+65536}t.$Pd=n;function de(T,V,H){const X=T.charCodeAt(H);if(G(X)&&H+1<V){const Y=T.charCodeAt(H+1);if(ne(Y))return n(X,Y)}return X}t.$Qd=de;function $e(T,V){const H=T.charCodeAt(V-1);if(ne(H)&&V>1){const X=T.charCodeAt(V-2);if(G(X))return n(X,H)}return H}class me{get offset(){return this.e}constructor(V,H=0){this.c=V,this.d=V.length,this.e=H}setOffset(V){this.e=V}prevCodePoint(){const V=$e(this.c,this.e);return this.e-=V>=65536?2:1,V}nextCodePoint(){const V=de(this.c,this.d,this.e);return this.e+=V>=65536?2:1,V}eol(){return this.e>=this.d}}t.$Rd=me;class oe{get offset(){return this.c.offset}constructor(V,H=0){this.c=new me(V,H)}nextGraphemeLength(){const V=pe.getInstance(),H=this.c,X=H.offset;let Y=V.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ie=H.offset,be=V.getGraphemeBreakType(H.nextCodePoint());if(Ie(Y,be)){H.setOffset(ie);break}Y=be}return H.offset-X}prevGraphemeLength(){const V=pe.getInstance(),H=this.c,X=H.offset;let Y=V.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ie=H.offset,be=V.getGraphemeBreakType(H.prevCodePoint());if(Ie(be,Y)){H.setOffset(ie);break}Y=be}return X-H.offset}eol(){return this.c.eol()}}t.$Sd=oe;function ve(T,V){return new oe(T,V).nextGraphemeLength()}t.$Td=ve;function Le(T,V){return new oe(T,V).prevGraphemeLength()}t.$Ud=Le;function Ae(T,V){V>0&&ne(T.charCodeAt(V))&&V--;const H=V+ve(T,V);return[H-Le(T,H),H]}t.$Vd=Ae;function Me(T){const V=new oe(T);let H=0;for(;!V.eol();)H++,V.nextGraphemeLength();return H}t.$Wd=Me;let Re;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(T){return Re||(Re=ue()),Re.test(T)}t.$Xd=le;const se=/^[\t\n\r\x20-\x7E]*$/;function ge(T){return se.test(T)}t.$Yd=ge,t.$Zd=/[\u2028\u2029]/;function U(T){return t.$Zd.test(T)}t.$1d=U;function B(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$2d=B;function q(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$3d=q;function O(T,V){if(T.length<V)return T;const H=/\b/g;let X=0;for(;H.test(T)&&!(T.length-H.lastIndex<V);)X=H.lastIndex,H.lastIndex+=1;return T.substring(X).replace(/^\s/,"")}t.$4d=O;const C=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Q=/\x1b\].*?\x07/g;function ee(T){return T&&(T=T.replace(C,"").replace(Q,"")),T}t.$5d=ee,t.$6d=String.fromCharCode(65279);function re(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$7d=re;function ae(T){return re(T)?T.substr(1):T}t.$8d=ae;function fe(T,V){if(!T||!V||T.length<V.length)return!1;const H=V.length,X=T.toLowerCase();let Y=0,ie=-1;for(;Y<H;){const be=X.indexOf(V[Y],ie+1);if(be<0)return!1;ie=be,Y++}return!0}t.$9d=fe;function we(T,V=!1){return T?(V&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$0d=we;function Fe(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$$d=Fe;function Te(T,V=1){if(V===0)return"";let H=-1;do H=T.indexOf(`
`,H+1),V--;while(V>0&&H>=0);return H===-1?T:(T[H-1]==="\r"&&H--,T.substr(0,H))}t.$_d=Te;function ke(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$ae=ke;function Ue(T){return pe.getInstance().getGraphemeBreakType(T)}t.$be=Ue;function Ie(T,V){return T===0?V!==5&&V!==7:T===2&&V===3?!1:T===4||T===2||T===3||V===4||V===2||V===3?!0:!(T===8&&(V===8||V===9||V===11||V===12)||(T===11||T===9)&&(V===9||V===10)||(T===12||T===10)&&V===10||V===5||V===13||V===7||T===1||T===13&&V===14||T===6&&V===6)}var qe;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(qe||(t.GraphemeBreakType=qe={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=je()}getGraphemeBreakType(V){if(V<32)return V===10?3:V===13?2:4;if(V<127)return 0;const H=this.d,X=H.length/3;let Y=1;for(;Y<=X;)if(V<H[3*Y])Y=2*Y;else if(V>H[3*Y+1])Y=2*Y+1;else return H[3*Y+2];return 0}}pe.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(T,V){if(T===0)return 0;const H=He(T,V);if(H!==void 0)return H;const X=new me(V,T);return X.prevCodePoint(),X.offset}t.$ce=Ce;function He(T,V){const H=new me(V,T);let X=H.prevCodePoint();for(;ze(X)||X===65039||X===8419;){if(H.offset===0)return;X=H.prevCodePoint()}if(!q(X))return;let Y=H.offset;return Y>0&&H.prevCodePoint()===8205&&(Y=H.offset),Y}function ze(T){return 127995<=T&&T<=127999}var We;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$de="\xA0";class Ee{static getInstance(V){return Ee.d.get(Array.from(V))}static getLocales(){return Ee.e.value}constructor(V){this.f=V}isAmbiguous(V){return this.f.has(V)}getPrimaryConfusable(V){return this.f.get(V)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ee=Ee,i=Ee,Ee.c=new D.$S(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.d=new k.$dd(T=>{function V(ce){const Ne=new Map;for(let _e=0;_e<ce.length;_e+=2)Ne.set(ce[_e],ce[_e+1]);return Ne}function H(ce,Ne){const _e=new Map(ce);for(const[Se,Be]of Ne)_e.set(Se,Be);return _e}function X(ce,Ne){if(!ce)return Ne;const _e=new Map;for(const[Se,Be]of ce)Ne.has(Se)&&_e.set(Se,Be);return _e}const Y=i.c.value;let ie=T.filter(ce=>!ce.startsWith("_")&&ce in Y);ie.length===0&&(ie=["_default"]);let be;for(const ce of ie){const Ne=V(Y[ce]);be=X(be,Ne)}const Pe=V(Y._common),ye=H(Pe,be);return new Ee(ye)}),Ee.e=new D.$S(()=>Object.keys(Ee.c.value).filter(T=>!T.startsWith("_")));class De{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(De.c())),this.d}static isInvisibleCharacter(V){return De.e().has(V)}static get codePoints(){return De.e()}}t.$fe=De,De.d=void 0}),Z(K[35],te([0,1,5]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fi=t.$ei=t.$di=t.$ci=t.$bi=t.$ai=t.$_h=void 0;function D(_){return i(_,0)}t.$_h=D;function i(_,$){switch(typeof _){case"object":return _===null?a(349,$):Array.isArray(_)?u(_,$):s(_,$);case"string":return d(_,$);case"boolean":return L(_,$);case"number":return a(_,$);case"undefined":return a(937,$);default:return a(617,$)}}t.$ai=i;function a(_,$){return($<<5)-$+_|0}t.$bi=a;function L(_,$){return a(_?433:863,$)}function d(_,$){$=a(149417,$);for(let M=0,g=_.length;M<g;M++)$=a(_.charCodeAt(M),$);return $}t.$ci=d;function u(_,$){return $=a(104579,$),_.reduce((M,g)=>i(g,M),$)}function s(_,$){return $=a(181387,$),Object.keys(_).sort().reduce((M,g)=>(M=d(g,M),i(_[g],M)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=i($,this.g),this.g}}t.$di=c;var E;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function o(_,$,M=32){const g=M-$,m=~((1<<g)-1);return(_<<$|(m&_)>>>g)>>>0}function h(_,$=0,M=_.byteLength,g=0){for(let m=0;m<M;m++)_[$+m]=g}function e(_,$,M="0"){for(;_.length<$;)_=M+_;return _}function A(_,$=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(M=>M.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),$/4)}t.$ei=A;class y{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const M=$.length;if(M===0)return;const g=this.p;let m=this.r,r=this.u,l,R;for(r!==0?(l=r,R=-1,r=0):(l=$.charCodeAt(0),R=0);;){let f=l;if(k.$Nd(l))if(R+1<M){const w=$.charCodeAt(R+1);k.$Od(w)?(R++,f=k.$Pd(l,w)):f=65533}else{r=l;break}else k.$Od(l)&&(f=65533);if(m=this.w(g,m,f),R++,R<M)l=$.charCodeAt(R);else break}this.r=m,this.u=r}w($,M,g){return g<128?$[M++]=g:g<2048?($[M++]=192|(g&1984)>>>6,$[M++]=128|(g&63)>>>0):g<65536?($[M++]=224|(g&61440)>>>12,$[M++]=128|(g&4032)>>>6,$[M++]=128|(g&63)>>>0):($[M++]=240|(g&1835008)>>>18,$[M++]=128|(g&258048)>>>12,$[M++]=128|(g&4032)>>>6,$[M++]=128|(g&63)>>>0),M>=64&&(this.y(),M-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),M}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=y.g,M=this.q;for(let b=0;b<64;b+=4)$.setUint32(b,M.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)$.setUint32(b,o($.getUint32(b-12,!1)^$.getUint32(b-32,!1)^$.getUint32(b-56,!1)^$.getUint32(b-64,!1),1),!1);let g=this.h,m=this.l,r=this.m,l=this.n,R=this.o,f,w,N;for(let b=0;b<80;b++)b<20?(f=m&r|~m&l,w=1518500249):b<40?(f=m^r^l,w=1859775393):b<60?(f=m&r|m&l|r&l,w=2400959708):(f=m^r^l,w=3395469782),N=o(g,5)+f+R+w+$.getUint32(b*4,!1)&4294967295,R=l,l=r,r=o(m,30),m=g,g=N;this.h=this.h+g&4294967295,this.l=this.l+m&4294967295,this.m=this.m+r&4294967295,this.n=this.n+l&4294967295,this.o=this.o+R&4294967295}}t.$fi=y,y.g=new DataView(new ArrayBuffer(320))}),Z(K[20],te([0,1,28,35]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iu=t.$hu=t.$gu=void 0;class i{constructor(o){this.a=o}getElements(){const o=this.a,h=new Int32Array(o.length);for(let e=0,A=o.length;e<A;e++)h[e]=o.charCodeAt(e);return h}}t.$gu=i;function a(E,o,h){return new c(new i(E),new i(o)).ComputeDiff(h).changes}t.$hu=a;class L{static Assert(o,h){if(!o)throw new Error(h)}}class d{static Copy(o,h,e,A,y){for(let _=0;_<y;_++)e[A+_]=o[h+_]}static Copy2(o,h,e,A,y){for(let _=0;_<y;_++)e[A+_]=o[h+_]}}var u;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$fu(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,h){this.b=Math.min(this.b,o),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(o,h){this.b=Math.min(this.b,o),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(o,h,e=null){this.a=e,this.b=o,this.c=h;const[A,y,_]=c.o(o),[$,M,g]=c.o(h);this.d=_&&g,this.e=A,this.f=y,this.g=$,this.h=M,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const h=o.getElements();if(c.n(h)){const e=new Int32Array(h.length);for(let A=0,y=h.length;A<y;A++)e[A]=(0,D.$ci)(h[A],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(o,h){return this.f[o]!==this.h[h]?!1:this.d?this.e[o]===this.g[h]:!0}q(o,h){if(!this.p(o,h))return!1;const e=c.r(this.b,o),A=c.r(this.c,h);return e===A}static r(o,h){return typeof o.getStrictElement=="function"?o.getStrictElement(h):null}s(o,h){return this.f[o]!==this.f[h]?!1:this.d?this.e[o]===this.e[h]:!0}u(o,h){return this.h[o]!==this.h[h]?!1:this.d?this.g[o]===this.g[h]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,h,e,A,y){const _=[!1];let $=this.w(o,h,e,A,_);return y&&($=this.z($)),{quitEarly:_[0],changes:$}}w(o,h,e,A,y){for(y[0]=!1;o<=h&&e<=A&&this.p(o,e);)o++,e++;for(;h>=o&&A>=e&&this.p(h,A);)h--,A--;if(o>h||e>A){let r;return e<=A?(L.Assert(o===h+1,"originalStart should only be one more than originalEnd"),r=[new k.$fu(o,0,e,A-e+1)]):o<=h?(L.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new k.$fu(o,h-o+1,e,0)]):(L.Assert(o===h+1,"originalStart should only be one more than originalEnd"),L.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const _=[0],$=[0],M=this.y(o,h,e,A,_,$,y),g=_[0],m=$[0];if(M!==null)return M;if(!y[0]){const r=this.w(o,g,e,m,y);let l=[];return y[0]?l=[new k.$fu(g+1,h-(g+1)+1,m+1,A-(m+1)+1)]:l=this.w(g+1,h,m+1,A,y),this.H(r,l)}return[new k.$fu(o,h-o+1,e,A-e+1)]}x(o,h,e,A,y,_,$,M,g,m,r,l,R,f,w,N,b,p){let F=null,P=null,v=new s,I=h,S=e,W=R[0]-N[0]-A,z=-1073741824,x=this.k.length-1;do{const J=W+o;J===I||J<S&&g[J-1]<g[J+1]?(r=g[J+1],f=r-W-A,r<z&&v.MarkNextChange(),z=r,v.AddModifiedElement(r+1,f),W=J+1-o):(r=g[J-1]+1,f=r-W-A,r<z&&v.MarkNextChange(),z=r-1,v.AddOriginalElement(r,f+1),W=J-1-o),x>=0&&(g=this.k[x],o=g[0],I=1,S=g.length-1)}while(--x>=-1);if(F=v.getReverseChanges(),p[0]){let J=R[0]+1,G=N[0]+1;if(F!==null&&F.length>0){const ne=F[F.length-1];J=Math.max(J,ne.getOriginalEnd()),G=Math.max(G,ne.getModifiedEnd())}P=[new k.$fu(J,l-J+1,G,w-G+1)]}else{v=new s,I=_,S=$,W=R[0]-N[0]-M,z=1073741824,x=b?this.m.length-1:this.m.length-2;do{const J=W+y;J===I||J<S&&m[J-1]>=m[J+1]?(r=m[J+1]-1,f=r-W-M,r>z&&v.MarkNextChange(),z=r+1,v.AddOriginalElement(r+1,f+1),W=J+1-y):(r=m[J-1],f=r-W-M,r>z&&v.MarkNextChange(),z=r,v.AddModifiedElement(r+1,f+1),W=J-1-y),x>=0&&(m=this.m[x],y=m[0],I=1,S=m.length-1)}while(--x>=-1);P=v.getChanges()}return this.H(F,P)}y(o,h,e,A,y,_,$){let M=0,g=0,m=0,r=0,l=0,R=0;o--,e--,y[0]=0,_[0]=0,this.k=[],this.m=[];const f=h-o+(A-e),w=f+1,N=new Int32Array(w),b=new Int32Array(w),p=A-e,F=h-o,P=o-e,v=h-A,S=(F-p)%2===0;N[p]=o,b[F]=h,$[0]=!1;for(let W=1;W<=f/2+1;W++){let z=0,x=0;m=this.J(p-W,W,p,w),r=this.J(p+W,W,p,w);for(let G=m;G<=r;G+=2){G===m||G<r&&N[G-1]<N[G+1]?M=N[G+1]:M=N[G-1]+1,g=M-(G-p)-P;const ne=M;for(;M<h&&g<A&&this.p(M+1,g+1);)M++,g++;if(N[G]=M,M+g>z+x&&(z=M,x=g),!S&&Math.abs(G-F)<=W-1&&M>=b[G])return y[0]=M,_[0]=g,ne<=b[G]&&1447>0&&W<=1447+1?this.x(p,m,r,P,F,l,R,v,N,b,M,h,y,g,A,_,S,$):null}const J=(z-o+(x-e)-W)/2;if(this.a!==null&&!this.a(z,J))return $[0]=!0,y[0]=z,_[0]=x,J>0&&1447>0&&W<=1447+1?this.x(p,m,r,P,F,l,R,v,N,b,M,h,y,g,A,_,S,$):(o++,e++,[new k.$fu(o,h-o+1,e,A-e+1)]);l=this.J(F-W,W,F,w),R=this.J(F+W,W,F,w);for(let G=l;G<=R;G+=2){G===l||G<R&&b[G-1]>=b[G+1]?M=b[G+1]-1:M=b[G-1],g=M-(G-F)-v;const ne=M;for(;M>o&&g>e&&this.p(M,g);)M--,g--;if(b[G]=M,S&&Math.abs(G-p)<=W&&M<=N[G])return y[0]=M,_[0]=g,ne>=N[G]&&1447>0&&W<=1447+1?this.x(p,m,r,P,F,l,R,v,N,b,M,h,y,g,A,_,S,$):null}if(W<=1447){let G=new Int32Array(r-m+2);G[0]=p-m+1,d.Copy2(N,m,G,1,r-m+1),this.k.push(G),G=new Int32Array(R-l+2),G[0]=F-l+1,d.Copy2(b,l,G,1,R-l+1),this.m.push(G)}}return this.x(p,m,r,P,F,l,R,v,N,b,M,h,y,g,A,_,S,$)}z(o){for(let h=0;h<o.length;h++){const e=o[h],A=h<o.length-1?o[h+1].originalStart:this.f.length,y=h<o.length-1?o[h+1].modifiedStart:this.h.length,_=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<y&&(!_||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const M=[null];if(h<o.length-1&&this.I(o[h],o[h+1],M)){o[h]=M[0],o.splice(h+1,1),h--;continue}}for(let h=o.length-1;h>=0;h--){const e=o[h];let A=0,y=0;if(h>0){const r=o[h-1];A=r.originalStart+r.originalLength,y=r.modifiedStart+r.modifiedLength}const _=e.originalLength>0,$=e.modifiedLength>0;let M=0,g=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const l=e.originalStart-r,R=e.modifiedStart-r;if(l<A||R<y||_&&!this.s(l,l+e.originalLength)||$&&!this.u(R,R+e.modifiedLength))break;const w=(l===A&&R===y?5:0)+this.G(l,e.originalLength,R,e.modifiedLength);w>g&&(g=w,M=r)}e.originalStart-=M,e.modifiedStart-=M;const m=[null];if(h>0&&this.I(o[h-1],o[h],m)){o[h-1]=m[0],o.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=o.length;h<e;h++){const A=o[h-1],y=o[h],_=y.originalStart-A.originalStart-A.originalLength,$=A.originalStart,M=y.originalStart+y.originalLength,g=M-$,m=A.modifiedStart,r=y.modifiedStart+y.modifiedLength,l=r-m;if(_<5&&g<20&&l<20){const R=this.A($,g,m,l,_);if(R){const[f,w]=R;(f!==A.originalStart+A.originalLength||w!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=f-A.originalStart,A.modifiedLength=w-A.modifiedStart,y.originalStart=f+_,y.modifiedStart=w+_,y.originalLength=M-y.originalStart,y.modifiedLength=r-y.modifiedStart)}}}return o}A(o,h,e,A,y){if(h<y||A<y)return null;const _=o+h-y+1,$=e+A-y+1;let M=0,g=0,m=0;for(let r=o;r<_;r++)for(let l=e;l<$;l++){const R=this.B(r,l,y);R>0&&R>M&&(M=R,g=r,m=l)}return M>0?[g,m]:null}B(o,h,e){let A=0;for(let y=0;y<e;y++){if(!this.p(o+y,h+y))return 0;A+=this.e[o+y].length}return A}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,h){if(this.C(o)||this.C(o-1))return!0;if(h>0){const e=o+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,h){if(this.E(o)||this.E(o-1))return!0;if(h>0){const e=o+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,h,e,A){const y=this.D(o,h)?1:0,_=this.F(e,A)?1:0;return y+_}H(o,h){const e=[];if(o.length===0||h.length===0)return h.length>0?h:o;if(this.I(o[o.length-1],h[0],e)){const A=new Array(o.length+h.length-1);return d.Copy(o,0,A,0,o.length-1),A[o.length-1]=e[0],d.Copy(h,1,A,o.length,h.length-1),A}else{const A=new Array(o.length+h.length);return d.Copy(o,0,A,0,o.length),d.Copy(h,0,A,o.length,h.length),A}}I(o,h,e){if(L.Assert(o.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),L.Assert(o.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=h.originalStart||o.modifiedStart+o.modifiedLength>=h.modifiedStart){const A=o.originalStart;let y=o.originalLength;const _=o.modifiedStart;let $=o.modifiedLength;return o.originalStart+o.originalLength>=h.originalStart&&(y=h.originalStart+h.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=h.modifiedStart&&($=h.modifiedStart+h.modifiedLength-o.modifiedStart),e[0]=new k.$fu(A,y,_,$),!0}else return e[0]=null,!1}J(o,h,e,A){if(o>=0&&o<A)return o;const y=e,_=A-e-1,$=h%2===0;if(o<0){const M=y%2===0;return $===M?0:1}else{const M=_%2===0;return $===M?A-1:A-2}}}t.$iu=c}),Z(K[21],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=void 0;function k(l){return typeof l=="string"}t.$ge=k;function D(l){return Array.isArray(l)&&l.every(R=>k(R))}t.$he=D;function i(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}t.$ie=i;function a(l){const R=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof R}t.$je=a;function L(l){return typeof l=="number"&&!isNaN(l)}t.$ke=L;function d(l){return!!l&&typeof l[Symbol.iterator]=="function"}t.$le=d;function u(l){return l===!0||l===!1}t.$me=u;function s(l){return typeof l>"u"}t.$ne=s;function c(l){return!E(l)}t.$oe=c;function E(l){return s(l)||l===null}t.$pe=E;function o(l,R){if(!l)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}t.$qe=o;function h(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}t.$re=h;function e(...l){const R=[];for(let f=0;f<l.length;f++){const w=l[f];if(E(w))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);R.push(w)}return R}t.$se=e;const A=Object.prototype.hasOwnProperty;function y(l){if(!i(l))return!1;for(const R in l)if(A.call(l,R))return!1;return!0}t.$te=y;function _(l){return typeof l=="function"}t.$ue=_;function $(...l){return l.length>0&&l.every(_)}t.$ve=$;function M(l,R){const f=Math.min(l.length,R.length);for(let w=0;w<f;w++)g(l[w],R[w])}t.$we=M;function g(l,R){if(k(R)){if(typeof l!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(_(R)){try{if(l instanceof R)return}catch{}if(!E(l)&&l.constructor===R||R.length===1&&R.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$xe=g;function m(l){return l===null?void 0:l}t.$ye=m;function r(l){return typeof l>"u"?null:l}t.$ze=r}),Z(K[36],te([0,1,21]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yj=t.$xj=t.$wj=void 0;const D=Object.create(null);function i(d,u){if((0,k.$ge)(u)){const s=D[u];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${u}`);u=s}return D[d]=u,{id:d}}function a(){return D}t.$wj=a;function L(){return Object.values(t.$yj)}t.$xj=L,t.$yj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Z(K[12],te([0,1,21]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=t.$Im=t.$Hm=t.$Gm=t.$Fm=t.$Em=void 0;function D(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const $=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([M,g])=>{$[M]=g&&typeof g=="object"?D(g):g}),$}t.$Em=D;function i(_){if(!_||typeof _!="object")return _;const $=[_];for(;$.length>0;){const M=$.shift();Object.freeze(M);for(const g in M)if(a.call(M,g)){const m=M[g];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.$je)(m)&&$.push(m)}}return _}t.$Fm=i;const a=Object.prototype.hasOwnProperty;function L(_,$){return d(_,$,new Set)}t.$Gm=L;function d(_,$,M){if((0,k.$pe)(_))return _;const g=$(_);if(typeof g<"u")return g;if(Array.isArray(_)){const m=[];for(const r of _)m.push(d(r,$,M));return m}if((0,k.$ie)(_)){if(M.has(_))throw new Error("Cannot clone recursive data-structure");M.add(_);const m={};for(const r in _)a.call(_,r)&&(m[r]=d(_[r],$,M));return M.delete(_),m}return _}function u(_,$,M=!0){return(0,k.$ie)(_)?((0,k.$ie)($)&&Object.keys($).forEach(g=>{g in _?M&&((0,k.$ie)(_[g])&&(0,k.$ie)($[g])?u(_[g],$[g],M):_[g]=$[g]):_[g]=$[g]}),_):$}t.$Hm=u;function s(_,$){if(_===$)return!0;if(_==null||$===null||$===void 0||typeof _!=typeof $||typeof _!="object"||Array.isArray(_)!==Array.isArray($))return!1;let M,g;if(Array.isArray(_)){if(_.length!==$.length)return!1;for(M=0;M<_.length;M++)if(!s(_[M],$[M]))return!1}else{const m=[];for(g in _)m.push(g);m.sort();const r=[];for(g in $)r.push(g);if(r.sort(),!s(m,r))return!1;for(M=0;M<m.length;M++)if(!s(_[m[M]],$[m[M]]))return!1}return!0}t.$Im=s;function c(_){const $=new Set;return JSON.stringify(_,(M,g)=>{if((0,k.$ie)(g)||Array.isArray(g)){if($.has(g))return"[Circular]";$.add(g)}return g})}t.$Jm=c;function E(_,$){const M=Object.create(null);return!_||!$||Object.keys($).forEach(m=>{const r=_[m],l=$[m];s(r,l)||(M[m]=l)}),M}t.$Km=E;function o(_,$){const M=$.toLowerCase(),g=Object.keys(_).find(m=>m.toLowerCase()===M);return g?_[g]:_[$]}t.$Lm=o;function h(_,$){const M=Object.create(null);for(const[g,m]of Object.entries(_))$(g,m)&&(M[g]=m);return M}t.$Mm=h;function e(_){let $=[],M=Object.getPrototypeOf(_);for(;Object.prototype!==M;)$=$.concat(Object.getOwnPropertyNames(M)),M=Object.getPrototypeOf(M);return $}t.$Nm=e;function A(_){const $=[];for(const M of e(_))typeof _[M]=="function"&&$.push(M);return $}t.$Om=A;function y(_,$){const M=m=>function(){const r=Array.prototype.slice.call(arguments,0);return $(m,r)},g={};for(const m of _)g[m]=M(m);return g}t.$Pm=y}),Z(K[22],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gd=t.$fd=t.Constants=void 0;var k;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function D(a){return a<0?0:a>255?255:a|0}t.$fd=D;function i(a){return a<0?0:a>4294967295?4294967295:a|0}t.$gd=i}),Z(K[13],te([0,1,33,11]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,a=/^\//,L=/^\/\//;function d(f,w){if(!f.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!i.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!a.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(f,w){return!f&&!w?"file":f}function s(f,w){switch(f){case"https":case"http":case"file":w?w[0]!==E&&(w=E+w):w=E;break}return w}const c="",E="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(w){return w instanceof h?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,N,b,p,F,P=!1){typeof w=="object"?(this.scheme=w.scheme||c,this.authority=w.authority||c,this.path=w.path||c,this.query=w.query||c,this.fragment=w.fragment||c):(this.scheme=u(w,P),this.authority=N||c,this.path=s(this.scheme,b||c),this.query=p||c,this.fragment=F||c,d(this,P))}get fsPath(){return g(this,!1)}with(w){if(!w)return this;let{scheme:N,authority:b,path:p,query:F,fragment:P}=w;return N===void 0?N=this.scheme:N===null&&(N=c),b===void 0?b=this.authority:b===null&&(b=c),p===void 0?p=this.path:p===null&&(p=c),F===void 0?F=this.query:F===null&&(F=c),P===void 0?P=this.fragment:P===null&&(P=c),N===this.scheme&&b===this.authority&&p===this.path&&F===this.query&&P===this.fragment?this:new y(N,b,p,F,P)}static parse(w,N=!1){const b=o.exec(w);return b?new y(b[2]||c,R(b[4]||c),R(b[5]||c),R(b[7]||c),R(b[9]||c),N):new y(c,c,c,c,c)}static file(w){let N=c;if(D.$d&&(w=w.replace(/\\/g,E)),w[0]===E&&w[1]===E){const b=w.indexOf(E,2);b===-1?(N=w.substring(2),w=E):(N=w.substring(2,b),w=w.substring(b)||E)}return new y("file",N,w,c,c)}static from(w,N){return new y(w.scheme,w.authority,w.path,w.query,w.fragment,N)}static joinPath(w,...N){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.$d&&w.scheme==="file"?b=h.file(k.$7b.join(g(w,!0),...N)).path:b=k.$8b.join(w.path,...N),w.with({path:b})}toString(w=!1){return m(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof h)return w;{const N=new y(w);return N._formatted=w.external??null,N._fsPath=w._sep===A?w.fsPath??null:null,N}}else return w}}t.URI=h;function e(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}t.$Re=e;const A=D.$d?1:void 0;class y extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(w=!1){return w?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=A),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function $(f,w,N){let b,p=-1;for(let F=0;F<f.length;F++){const P=f.charCodeAt(F);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||w&&P===47||N&&P===91||N&&P===93||N&&P===58)p!==-1&&(b+=encodeURIComponent(f.substring(p,F)),p=-1),b!==void 0&&(b+=f.charAt(F));else{b===void 0&&(b=f.substr(0,F));const v=_[P];v!==void 0?(p!==-1&&(b+=encodeURIComponent(f.substring(p,F)),p=-1),b+=v):p===-1&&(p=F)}}return p!==-1&&(b+=encodeURIComponent(f.substring(p))),b!==void 0?b:f}function M(f){let w;for(let N=0;N<f.length;N++){const b=f.charCodeAt(N);b===35||b===63?(w===void 0&&(w=f.substr(0,N)),w+=_[b]):w!==void 0&&(w+=f[N])}return w!==void 0?w:f}function g(f,w){let N;return f.authority&&f.path.length>1&&f.scheme==="file"?N=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?w?N=f.path.substr(1):N=f.path[1].toLowerCase()+f.path.substr(2):N=f.path,D.$d&&(N=N.replace(/\//g,"\\")),N}t.$Se=g;function m(f,w){const N=w?M:$;let b="",{scheme:p,authority:F,path:P,query:v,fragment:I}=f;if(p&&(b+=p,b+=":"),(F||p==="file")&&(b+=E,b+=E),F){let S=F.indexOf("@");if(S!==-1){const W=F.substr(0,S);F=F.substr(S+1),S=W.lastIndexOf(":"),S===-1?b+=N(W,!1,!1):(b+=N(W.substr(0,S),!1,!1),b+=":",b+=N(W.substr(S+1),!1,!0)),b+="@"}F=F.toLowerCase(),S=F.lastIndexOf(":"),S===-1?b+=N(F,!1,!0):(b+=N(F.substr(0,S),!1,!0),b+=F.substr(S))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const S=P.charCodeAt(1);S>=65&&S<=90&&(P=`/${String.fromCharCode(S+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const S=P.charCodeAt(0);S>=65&&S<=90&&(P=`${String.fromCharCode(S+32)}:${P.substr(2)}`)}b+=N(P,!0,!1)}return v&&(b+="?",b+=N(v,!1,!1)),I&&(b+="#",b+=w?I:$(I,!1,!1)),b}function r(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+r(f.substr(3)):f}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(f){return f.match(l)?f.replace(l,w=>r(w)):f}}),Z(K[58],te([0,1,3,8,7,12,11,5]),function(j,t,k,D,i,a,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let s=!1;function c(R){L.$j&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(R.message))}t.logOnceWebWorkerWarning=c;var E;(function(R){R[R.Request=0]="Request",R[R.Reply=1]="Reply",R[R.SubscribeEvent=2]="SubscribeEvent",R[R.Event=3]="Event",R[R.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class o{constructor(f,w,N,b){this.vsWorker=f,this.req=w,this.method=N,this.args=b,this.type=0}}class h{constructor(f,w,N,b){this.vsWorker=f,this.seq=w,this.res=N,this.err=b,this.type=1}}class e{constructor(f,w,N,b){this.vsWorker=f,this.req=w,this.eventName=N,this.arg=b,this.type=2}}class A{constructor(f,w,N){this.vsWorker=f,this.req=w,this.event=N,this.type=3}}class y{constructor(f,w){this.vsWorker=f,this.req=w,this.type=4}}class _{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,w){const N=String(++this.b);return new Promise((b,p)=>{this.c[N]={resolve:b,reject:p},this.o(new o(this.a,N,f,w))})}listen(f,w){let N=null;const b=new D.$5c({onWillAddFirstListener:()=>{N=String(++this.b),this.d.set(N,b),this.o(new e(this.a,N,f,w))},onDidRemoveLastListener:()=>{this.d.delete(N),this.o(new y(this.a,N)),N=null}});return b.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case 1:return this.j(f);case 0:return this.k(f);case 2:return this.l(f);case 3:return this.m(f);case 4:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[f.seq];if(delete this.c[f.seq],f.err){let N=f.err;f.err.$isError&&(N=new Error,N.name=f.err.name,N.message=f.err.message,N.stack=f.err.stack),w.reject(N);return}w.resolve(f.res)}k(f){const w=f.req;this.g.handleMessage(f.method,f.args).then(b=>{this.o(new h(this.a,w,b,void 0))},b=>{b.detail instanceof Error&&(b.detail=(0,k.$Z)(b.detail)),this.o(new h(this.a,w,void 0,(0,k.$Z)(b)))})}l(f){const w=f.req,N=this.g.handleEvent(f.eventName,f.arg)(b=>{this.o(new A(this.a,w,b))});this.f.set(w,N)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const w=[];if(f.type===0)for(let N=0;N<f.args.length;N++)f.args[N]instanceof ArrayBuffer&&w.push(f.args[N]);else f.type===1&&f.res instanceof ArrayBuffer&&w.push(f.res);this.g.sendMessage(f,w)}}class $ extends i.$kb{constructor(f,w,N){super();let b=null;this.a=this.B(f.create("vs/base/common/worker/simpleWorker",S=>{this.c.handleMessage(S)},S=>{b?.(S)})),this.c=new _({sendMessage:(S,W)=>{this.a.postMessage(S,W)},handleMessage:(S,W)=>{if(typeof N[S]!="function")return Promise.reject(new Error("Missing method "+S+" on main thread host."));try{return Promise.resolve(N[S].apply(N,W))}catch(z){return Promise.reject(z)}},handleEvent:(S,W)=>{if(g(S)){const z=N[S].call(N,W);if(typeof z!="function")throw new Error(`Missing dynamic event ${S} on main thread host.`);return z}if(M(S)){const z=N[S];if(typeof z!="function")throw new Error(`Missing event ${S} on main thread host.`);return z}throw new Error(`Malformed event name ${S}`)}}),this.c.setWorkerId(this.a.getId());let p=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?p=F.getConfig():typeof globalThis.requirejs<"u"&&(p=globalThis.requirejs.s.contexts._.config);const P=(0,a.$Om)(N);this.b=this.c.sendMessage(u,[this.a.getId(),JSON.parse(JSON.stringify(p)),w,P]);const v=(S,W)=>this.g(S,W),I=(S,W)=>this.c.listen(S,W);this.f=new Promise((S,W)=>{b=W,this.b.then(z=>{S(m(z,v,I))},z=>{W(z),this.h("Worker failed to load "+w,z)})})}getProxyObject(){return this.f}g(f,w){return new Promise((N,b)=>{this.b.then(()=>{this.c.sendMessage(f,w).then(N,b)},b)})}h(f,w){console.error(f),console.info(w)}}t.SimpleWorkerClient=$;function M(R){return R[0]==="o"&&R[1]==="n"&&d.$Id(R.charCodeAt(2))}function g(R){return/^onDynamic/.test(R)&&d.$Id(R.charCodeAt(9))}function m(R,f,w){const N=F=>function(){const P=Array.prototype.slice.call(arguments,0);return f(F,P)},b=F=>function(P){return w(F,P)},p={};for(const F of R){if(g(F)){p[F]=b(F);continue}if(M(F)){p[F]=w(F,void 0);continue}p[F]=N(F)}return p}class r{constructor(f,w){this.a=w,this.b=null,this.c=new _({sendMessage:(N,b)=>{f(N,b)},handleMessage:(N,b)=>this.d(N,b),handleEvent:(N,b)=>this.f(N,b)})}onmessage(f){this.c.handleMessage(f)}d(f,w){if(f===u)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,w))}catch(N){return Promise.reject(N)}}f(f,w){if(!this.b)throw new Error("Missing requestHandler");if(g(f)){const N=this.b[f].call(this.b,w);if(typeof N!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return N}if(M(f)){const N=this.b[f];if(typeof N!="function")throw new Error(`Missing event ${f} on request handler.`);return N}throw new Error(`Malformed event name ${f}`)}g(f,w,N,b){this.c.setWorkerId(f);const P=m(b,(v,I)=>this.c.sendMessage(v,I),(v,I)=>this.c.listen(v,I));return this.a?(this.b=this.a(P),Promise.resolve((0,a.$Om)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((v,I)=>{(globalThis.require||j)([N],W=>{if(this.b=W.create(P),!this.b){I(new Error("No RequestHandler!"));return}v((0,a.$Om)(this.b))},I)}))}}t.SimpleWorkerServer=r;function l(R){return new r(R,null)}t.create=l}),Z(K[23],te([0,1,22]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=void 0;class D{constructor(d){const u=(0,k.$fd)(d);this.c=u,this.a=D.d(u),this.b=new Map}static d(d){const u=new Uint8Array(256);return u.fill(d),u}set(d,u){const s=(0,k.$fd)(u);d>=0&&d<256?this.a[d]=s:this.b.set(d,s)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Zr=D;var i;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(i||(i={}));class a{constructor(){this.a=new D(0)}add(d){this.a.set(d,1)}has(d){return this.a.get(d)===1}clear(){return this.a.clear()}}t.$1r=a}),Z(K[6],te([0,1,3]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SB=void 0;class D{static addRange(a,L){let d=0;for(;d<L.length&&L[d].endExclusive<a.start;)d++;let u=d;for(;u<L.length&&L[u].start<=a.endExclusive;)u++;if(d===u)L.splice(d,0,a);else{const s=Math.min(a.start,L[d].start),c=Math.max(a.endExclusive,L[u-1].endExclusive);L.splice(d,u-d,new D(s,c))}}static tryCreate(a,L){if(!(a>L))return new D(a,L)}constructor(a,L){if(this.start=a,this.endExclusive=L,a>L)throw new k.$ab(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(a){return new D(this.start+a,this.endExclusive+a)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(a){return this.start===a.start&&this.endExclusive===a.endExclusive}containsRange(a){return this.start<=a.start&&a.endExclusive<=this.endExclusive}contains(a){return this.start<=a&&a<this.endExclusive}join(a){return new D(Math.min(this.start,a.start),Math.max(this.endExclusive,a.endExclusive))}intersect(a){const L=Math.max(this.start,a.start),d=Math.min(this.endExclusive,a.endExclusive);if(L<=d)return new D(L,d)}}t.$SB=D}),Z(K[4],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kr=void 0;class k{constructor(i,a){this.lineNumber=i,this.column=a}with(i=this.lineNumber,a=this.column){return i===this.lineNumber&&a===this.column?this:new k(i,a)}delta(i=0,a=0){return this.with(this.lineNumber+i,this.column+a)}equals(i){return k.equals(this,i)}static equals(i,a){return!i&&!a?!0:!!i&&!!a&&i.lineNumber===a.lineNumber&&i.column===a.column}isBefore(i){return k.isBefore(this,i)}static isBefore(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<a.column}isBeforeOrEqual(i){return k.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<=a.column}static compare(i,a){const L=i.lineNumber|0,d=a.lineNumber|0;if(L===d){const u=i.column|0,s=a.column|0;return u-s}return L-d}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new k(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.$Kr=k}),Z(K[2],te([0,1,4]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lr=void 0;class D{constructor(a,L,d,u){a>d||a===d&&L>u?(this.startLineNumber=d,this.startColumn=u,this.endLineNumber=a,this.endColumn=L):(this.startLineNumber=a,this.startColumn=L,this.endLineNumber=d,this.endColumn=u)}isEmpty(){return D.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return D.containsPosition(this,a)}static containsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<a.startColumn||L.lineNumber===a.endLineNumber&&L.column>a.endColumn)}static strictContainsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<=a.startColumn||L.lineNumber===a.endLineNumber&&L.column>=a.endColumn)}containsRange(a){return D.containsRange(this,a)}static containsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>a.endColumn)}strictContainsRange(a){return D.strictContainsRange(this,a)}static strictContainsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<=a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>=a.endColumn)}plusRange(a){return D.plusRange(this,a)}static plusRange(a,L){let d,u,s,c;return L.startLineNumber<a.startLineNumber?(d=L.startLineNumber,u=L.startColumn):L.startLineNumber===a.startLineNumber?(d=L.startLineNumber,u=Math.min(L.startColumn,a.startColumn)):(d=a.startLineNumber,u=a.startColumn),L.endLineNumber>a.endLineNumber?(s=L.endLineNumber,c=L.endColumn):L.endLineNumber===a.endLineNumber?(s=L.endLineNumber,c=Math.max(L.endColumn,a.endColumn)):(s=a.endLineNumber,c=a.endColumn),new D(d,u,s,c)}intersectRanges(a){return D.intersectRanges(this,a)}static intersectRanges(a,L){let d=a.startLineNumber,u=a.startColumn,s=a.endLineNumber,c=a.endColumn;const E=L.startLineNumber,o=L.startColumn,h=L.endLineNumber,e=L.endColumn;return d<E?(d=E,u=o):d===E&&(u=Math.max(u,o)),s>h?(s=h,c=e):s===h&&(c=Math.min(c,e)),d>s||d===s&&u>c?null:new D(d,u,s,c)}equalsRange(a){return D.equalsRange(this,a)}static equalsRange(a,L){return!a&&!L?!0:!!a&&!!L&&a.startLineNumber===L.startLineNumber&&a.startColumn===L.startColumn&&a.endLineNumber===L.endLineNumber&&a.endColumn===L.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(a){return new k.$Kr(a.endLineNumber,a.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(a){return new k.$Kr(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,L){return new D(this.startLineNumber,this.startColumn,a,L)}setStartPosition(a,L){return new D(a,L,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(a){return new D(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(a){return new D(a.endLineNumber,a.endColumn,a.endLineNumber,a.endColumn)}delta(a){return new D(this.startLineNumber+a,this.startColumn,this.endLineNumber+a,this.endColumn)}static fromPositions(a,L=a){return new D(a.lineNumber,a.column,L.lineNumber,L.column)}static lift(a){return a?new D(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<a.startColumn)}static areIntersecting(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<=L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,L){if(a&&L){const s=a.startLineNumber|0,c=L.startLineNumber|0;if(s===c){const E=a.startColumn|0,o=L.startColumn|0;if(E===o){const h=a.endLineNumber|0,e=L.endLineNumber|0;if(h===e){const A=a.endColumn|0,y=L.endColumn|0;return A-y}return h-e}return E-o}return s-c}return(a?1:0)-(L?1:0)}static compareRangesUsingEnds(a,L){return a.endLineNumber===L.endLineNumber?a.endColumn===L.endColumn?a.startLineNumber===L.startLineNumber?a.startColumn-L.startColumn:a.startLineNumber-L.startLineNumber:a.endColumn-L.endColumn:a.endLineNumber-L.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}t.$Lr=D}),Z(K[14],te([0,1,3,2]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mr=void 0;class i{static fromRange(L){return new i(L.startLineNumber,L.endLineNumber)}static subtract(L,d){return d?L.startLineNumber<d.startLineNumber&&d.endLineNumberExclusive<L.endLineNumberExclusive?[new i(L.startLineNumber,d.startLineNumber),new i(d.endLineNumberExclusive,L.endLineNumberExclusive)]:d.startLineNumber<=L.startLineNumber&&L.endLineNumberExclusive<=d.endLineNumberExclusive?[]:d.endLineNumberExclusive<L.endLineNumberExclusive?[new i(Math.max(d.endLineNumberExclusive,L.startLineNumber),L.endLineNumberExclusive)]:[new i(L.startLineNumber,Math.min(d.startLineNumber,L.endLineNumberExclusive))]:[L]}static joinMany(L){if(L.length===0)return[];let d=L[0];for(let u=1;u<L.length;u++)d=this.join(d,L[u]);return d}static join(L,d){if(L.length===0)return d;if(d.length===0)return L;const u=[];let s=0,c=0,E=null;for(;s<L.length||c<d.length;){let o=null;if(s<L.length&&c<d.length){const h=L[s],e=d[c];h.startLineNumber<e.startLineNumber?(o=h,s++):(o=e,c++)}else s<L.length?(o=L[s],s++):(o=d[c],c++);E===null?E=o:E.endLineNumberExclusive>=o.startLineNumber?E=new i(E.startLineNumber,Math.max(E.endLineNumberExclusive,o.endLineNumberExclusive)):(u.push(E),E=o)}return E!==null&&u.push(E),u}static ofLength(L,d){return new i(L,L+d)}static deserialize(L){return new i(L[0],L[1])}constructor(L,d){if(L>d)throw new k.$ab(`startLineNumber ${L} cannot be after endLineNumberExclusive ${d}`);this.startLineNumber=L,this.endLineNumberExclusive=d}contains(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(L){return new i(this.startLineNumber+L,this.endLineNumberExclusive+L)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(L){return new i(Math.min(this.startLineNumber,L.startLineNumber),Math.max(this.endLineNumberExclusive,L.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(L){const d=Math.max(this.startLineNumber,L.startLineNumber),u=Math.min(this.endLineNumberExclusive,L.endLineNumberExclusive);if(d<=u)return new i(d,u)}intersectsStrict(L){return this.startLineNumber<L.endLineNumberExclusive&&L.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(L){return this.startLineNumber<=L.endLineNumberExclusive&&L.startLineNumber<=this.endLineNumberExclusive}equals(L){return this.startLineNumber===L.startLineNumber&&this.endLineNumberExclusive===L.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.$Lr(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.$Lr(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(L){const d=[];for(let u=this.startLineNumber;u<this.endLineNumberExclusive;u++)d.push(L(u));return d}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}}t.$Mr=i}),Z(K[37],te([0,1,4,2]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tr=t.SelectionDirection=void 0;var i;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class a extends D.$Lr{constructor(d,u,s,c){super(d,u,s,c),this.selectionStartLineNumber=d,this.selectionStartColumn=u,this.positionLineNumber=s,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return a.selectionsEqual(this,d)}static selectionsEqual(d,u){return d.selectionStartLineNumber===u.selectionStartLineNumber&&d.selectionStartColumn===u.selectionStartColumn&&d.positionLineNumber===u.positionLineNumber&&d.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,u){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,d,u):new a(d,u,this.startLineNumber,this.startColumn)}getPosition(){return new k.$Kr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$Kr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,u){return this.getDirection()===0?new a(d,u,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,d,u)}static fromPositions(d,u=d){return new a(d.lineNumber,d.column,u.lineNumber,u.column)}static fromRange(d,u){return u===0?new a(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new a(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new a(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,u){if(d&&!u||!d&&u)return!1;if(!d&&!u)return!0;if(d.length!==u.length)return!1;for(let s=0,c=d.length;s<c;s++)if(!this.selectionsEqual(d[s],u[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,u,s,c,E){return E===0?new a(d,u,s,c):new a(s,c,d,u)}}t.$Tr=a}),Z(K[38],te([0,1,23]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3r=t.$2r=t.WordCharacterClass=void 0;var D;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class i extends k.$Zr{constructor(d){super(0);for(let u=0,s=d.length;u<s;u++)this.set(d.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.$2r=i;function a(L){const d={};return u=>(d.hasOwnProperty(u)||(d[u]=L(u)),d[u])}t.$3r=a(L=>new i(L))}),Z(K[24],te([0,1,16,7,17]),function(j,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jr=t.$Ir=t.$Hr=t.$Gr=t.$Fr=void 0,t.$Fr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function a(E=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const h of t.$Fr)E.indexOf(h)>=0||(o+="\\"+h);return o+="\\s]+)",new RegExp(o,"g")}t.$Gr=a();function L(E){let o=t.$Gr;if(E&&E instanceof RegExp)if(E.global)o=E;else{let h="g";E.ignoreCase&&(h+="i"),E.multiline&&(h+="m"),E.unicode&&(h+="u"),o=new RegExp(E.source,h)}return o.lastIndex=0,o}t.$Hr=L;const d=new i.$jc;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function u(E){const o=d.unshift(E);return(0,D.$ib)(o)}t.$Ir=u;function s(E,o,h,e,A){if(A||(A=k.Iterable.first(d)),h.length>A.maxLen){let g=E-A.maxLen/2;return g<0?g=0:e+=g,h=h.substring(g,E+A.maxLen/2),s(E,o,h,e,A)}const y=Date.now(),_=E-1-e;let $=-1,M=null;for(let g=1;!(Date.now()-y>=A.timeBudget);g++){const m=_-A.windowSize*g;o.lastIndex=Math.max(0,m);const r=c(o,h,_,$);if(!r&&M||(M=r,m<=0))break;$=m}if(M){const g={word:M[0],startColumn:e+1+M.index,endColumn:e+1+M.index+M[0].length};return o.lastIndex=0,g}return null}t.$Jr=s;function c(E,o,h,e){let A;for(;A=E.exec(o);){const y=A.index||0;if(y<=h&&E.lastIndex>=h)return A;if(e>0&&y>e)return null}return null}}),Z(K[9],te([0,1,3,6]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MW=t.$LW=t.$KW=t.$JW=void 0;class i{static trivial(s,c){return new i([new a(new D.$SB(0,s.length),new D.$SB(0,c.length))],!1)}static trivialTimedOut(s,c){return new i([new a(new D.$SB(0,s.length),new D.$SB(0,c.length))],!0)}constructor(s,c){this.diffs=s,this.hitTimeout=c}}t.$JW=i;class a{constructor(s,c){this.seq1Range=s,this.seq2Range=c}reverse(){return new a(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new a(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new a(this.seq1Range.delta(s),this.seq2Range.delta(s))}}t.$KW=a;class L{isValid(){return!0}}t.$LW=L,L.instance=new L;class d{constructor(s){if(this.c=s,this.a=Date.now(),this.b=!0,s<=0)throw new k.$ab("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.$MW=d}),Z(K[39],te([0,1,6,9]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SW=t.$RW=t.$QW=t.$PW=void 0;function i(s,c,E){let o=E;return o=L(s,c,o),o=d(s,c,o),o}t.$PW=i;function a(s,c,E){const o=[];for(const h of E){const e=o[o.length-1];if(!e){o.push(h);continue}h.seq1Range.start-e.seq1Range.endExclusive<=2||h.seq2Range.start-e.seq2Range.endExclusive<=2?o[o.length-1]=new D.$KW(e.seq1Range.join(h.seq1Range),e.seq2Range.join(h.seq2Range)):o.push(h)}return o}t.$QW=a;function L(s,c,E){const o=[];E.length>0&&o.push(E[0]);for(let e=1;e<E.length;e++){const A=o[o.length-1];let y=E[e];if(y.seq1Range.isEmpty||y.seq2Range.isEmpty){const _=y.seq1Range.start-A.seq1Range.endExclusive;let $;for($=1;$<=_&&!(s.getElement(y.seq1Range.start-$)!==s.getElement(y.seq1Range.endExclusive-$)||c.getElement(y.seq2Range.start-$)!==c.getElement(y.seq2Range.endExclusive-$));$++);if($--,$===_){o[o.length-1]=new D.$KW(new k.$SB(A.seq1Range.start,y.seq1Range.endExclusive-_),new k.$SB(A.seq2Range.start,y.seq2Range.endExclusive-_));continue}y=y.delta(-$)}o.push(y)}const h=[];for(let e=0;e<o.length-1;e++){const A=o[e+1];let y=o[e];if(y.seq1Range.isEmpty||y.seq2Range.isEmpty){const _=A.seq1Range.start-y.seq1Range.endExclusive;let $;for($=0;$<_&&!(s.getElement(y.seq1Range.start+$)!==s.getElement(y.seq1Range.endExclusive+$)||c.getElement(y.seq2Range.start+$)!==c.getElement(y.seq2Range.endExclusive+$));$++);if($===_){o[e+1]=new D.$KW(new k.$SB(y.seq1Range.start+_,A.seq1Range.endExclusive),new k.$SB(y.seq2Range.start+_,A.seq2Range.endExclusive));continue}$>0&&(y=y.delta($))}h.push(y)}return o.length>0&&h.push(o[o.length-1]),h}t.$RW=L;function d(s,c,E){if(!s.getBoundaryScore||!c.getBoundaryScore)return E;for(let o=0;o<E.length;o++){const h=o>0?E[o-1]:void 0,e=E[o],A=o+1<E.length?E[o+1]:void 0,y=new k.$SB(h?h.seq1Range.start+1:0,A?A.seq1Range.endExclusive-1:s.length),_=new k.$SB(h?h.seq2Range.start+1:0,A?A.seq2Range.endExclusive-1:c.length);e.seq1Range.isEmpty?E[o]=u(e,s,c,y,_):e.seq2Range.isEmpty&&(E[o]=u(e.reverse(),c,s,_,y).reverse())}return E}t.$SW=d;function u(s,c,E,o,h){let A=1;for(;s.seq1Range.start-A>=o.start&&s.seq2Range.start-A>=h.start&&E.getElement(s.seq2Range.start-A)===E.getElement(s.seq2Range.endExclusive-A)&&A<100;)A++;A--;let y=0;for(;s.seq1Range.start+y<o.endExclusive&&s.seq2Range.endExclusive+y<h.endExclusive&&E.getElement(s.seq2Range.start+y)===E.getElement(s.seq2Range.endExclusive+y)&&y<100;)y++;if(A===0&&y===0)return s;let _=0,$=-1;for(let M=-A;M<=y;M++){const g=s.seq2Range.start+M,m=s.seq2Range.endExclusive+M,r=s.seq1Range.start+M,l=c.getBoundaryScore(r)+E.getBoundaryScore(g)+E.getBoundaryScore(m);l>$&&($=l,_=M)}return s.delta(_)}}),Z(K[40],te([0,1,6,9]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TW=void 0;class i{compute(s,c,E=D.$LW.instance){if(s.length===0||c.length===0)return D.$JW.trivial(s,c);function o(m,r){for(;m<s.length&&r<c.length&&s.getElement(m)===c.getElement(r);)m++,r++;return m}let h=0;const e=new L;e.set(0,o(0,0));const A=new d;A.set(0,e.get(0)===0?null:new a(null,0,0,e.get(0)));let y=0;e:for(;;){if(h++,!E.isValid())return D.$JW.trivialTimedOut(s,c);const m=-Math.min(h,c.length+h%2),r=Math.min(h,s.length+h%2);for(y=m;y<=r;y+=2){const l=y===r?-1:e.get(y+1),R=y===m?-1:e.get(y-1)+1,f=Math.min(Math.max(l,R),s.length),w=f-y;if(f>s.length||w>c.length)continue;const N=o(f,w);e.set(y,N);const b=f===l?A.get(y+1):A.get(y-1);if(A.set(y,N!==f?new a(b,f,w,N-f):b),e.get(y)===s.length&&e.get(y)-y===c.length)break e}}let _=A.get(y);const $=[];let M=s.length,g=c.length;for(;;){const m=_?_.x+_.length:0,r=_?_.y+_.length:0;if((m!==M||r!==g)&&$.push(new D.$KW(new k.$SB(m,M),new k.$SB(r,g))),!_)break;M=_.x,g=_.y,_=_.prev}return $.reverse(),new D.$JW($,!1)}}t.$TW=i;class a{constructor(s,c,E,o){this.prev=s,this.x=c,this.y=E,this.length=o}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){if(s<0){if(s=-s-1,s>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[s]=c}else{if(s>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[s]=c}}}class d{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){s<0?(s=-s-1,this.b[s]=c):this.a[s]=c}}}),Z(K[41],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NW=void 0;class k{constructor(i,a){this.width=i,this.height=a,this.a=[],this.a=new Array(i*a)}get(i,a){return this.a[i+a*this.width]}set(i,a,L){this.a[i+a*this.width]=L}}t.$NW=k}),Z(K[42],te([0,1,6,9,41]),function(j,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OW=void 0;class a{compute(d,u,s=D.$LW.instance,c){if(d.length===0||u.length===0)return D.$JW.trivial(d,u);const E=new i.$NW(d.length,u.length),o=new i.$NW(d.length,u.length),h=new i.$NW(d.length,u.length);for(let g=0;g<d.length;g++)for(let m=0;m<u.length;m++){if(!s.isValid())return D.$JW.trivialTimedOut(d,u);const r=g===0?0:E.get(g-1,m),l=m===0?0:E.get(g,m-1);let R;d.getElement(g)===u.getElement(m)?(g===0||m===0?R=0:R=E.get(g-1,m-1),g>0&&m>0&&o.get(g-1,m-1)===3&&(R+=h.get(g-1,m-1)),R+=c?c(g,m):1):R=-1;const f=Math.max(r,l,R);if(f===R){const w=g>0&&m>0?h.get(g-1,m-1):0;h.set(g,m,w+1),o.set(g,m,3)}else f===r?(h.set(g,m,0),o.set(g,m,1)):f===l&&(h.set(g,m,0),o.set(g,m,2));E.set(g,m,f)}const e=[];let A=d.length,y=u.length;function _(g,m){(g+1!==A||m+1!==y)&&e.push(new D.$KW(new k.$SB(g+1,A),new k.$SB(m+1,y))),A=g,y=m}let $=d.length-1,M=u.length-1;for(;$>=0&&M>=0;)o.get($,M)===3?(_($,M),$--,M--):o.get($,M)===1?$--:M--;return _(-1,-1),e.reverse(),new D.$JW(e,!1)}}t.$OW=a}),Z(K[25],te([0,1,14]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rr=t.$Qr=t.$Pr=t.$Or=t.$Nr=void 0;class D{constructor(s,c,E){this.changes=s,this.moves=c,this.hitTimeout=E}}t.$Nr=D;class i{static inverse(s,c,E){const o=[];let h=1,e=1;for(const y of s){const _=new i(new k.$Mr(h,y.originalRange.startLineNumber),new k.$Mr(e,y.modifiedRange.startLineNumber),void 0);_.modifiedRange.isEmpty||o.push(_),h=y.originalRange.endLineNumberExclusive,e=y.modifiedRange.endLineNumberExclusive}const A=new i(new k.$Mr(h,c+1),new k.$Mr(e,E+1),void 0);return A.modifiedRange.isEmpty||o.push(A),o}constructor(s,c,E){this.originalRange=s,this.modifiedRange=c,this.innerChanges=E}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(s=>s.flip()))}}t.$Or=i;class a{constructor(s,c){this.originalRange=s,this.modifiedRange=c}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}}t.$Pr=a;class L{constructor(s,c){this.originalRange=s,this.modifiedRange=c}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new L(this.modifiedRange,this.originalRange)}}t.$Qr=L;class d{constructor(s,c){this.lineRangeMapping=s,this.changes=c}flip(){return new d(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}t.$Rr=d}),Z(K[26],te([0,1,20,25,5,2,10,14]),function(j,t,k,D,i,a,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ku=t.$ju=void 0;const u=3;class s{computeDiff(m,r,l){const f=new y(m,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),w=[];let N=null;for(const b of f.changes){let p;b.originalEndLineNumber===0?p=new d.$Mr(b.originalStartLineNumber+1,b.originalStartLineNumber+1):p=new d.$Mr(b.originalStartLineNumber,b.originalEndLineNumber+1);let F;b.modifiedEndLineNumber===0?F=new d.$Mr(b.modifiedStartLineNumber+1,b.modifiedStartLineNumber+1):F=new d.$Mr(b.modifiedStartLineNumber,b.modifiedEndLineNumber+1);let P=new D.$Or(p,F,b.charChanges?.map(v=>new D.$Pr(new a.$Lr(v.originalStartLineNumber,v.originalStartColumn,v.originalEndLineNumber,v.originalEndColumn),new a.$Lr(v.modifiedStartLineNumber,v.modifiedStartColumn,v.modifiedEndLineNumber,v.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new D.$Or(N.originalRange.join(P.originalRange),N.modifiedRange.join(P.modifiedRange),N.innerChanges&&P.innerChanges?N.innerChanges.concat(P.innerChanges):void 0),w.pop()),w.push(P),N=P}return(0,L.$nc)(()=>(0,L.$oc)(w,(b,p)=>p.originalRange.startLineNumber-b.originalRange.endLineNumberExclusive===p.modifiedRange.startLineNumber-b.modifiedRange.endLineNumberExclusive&&b.originalRange.endLineNumberExclusive<p.originalRange.startLineNumber&&b.modifiedRange.endLineNumberExclusive<p.modifiedRange.startLineNumber)),new D.$Nr(w,[],f.quitEarly)}}t.$ju=s;function c(g,m,r,l){return new k.$iu(g,m,r).ComputeDiff(l)}class E{constructor(m){const r=[],l=[];for(let R=0,f=m.length;R<f;R++)r[R]=_(m[R],1),l[R]=$(m[R],1);this.lines=m,this.a=r,this.b=l}getElements(){const m=[];for(let r=0,l=this.lines.length;r<l;r++)m[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,r,l){const R=[],f=[],w=[];let N=0;for(let b=r;b<=l;b++){const p=this.lines[b],F=m?this.a[b]:1,P=m?this.b[b]:p.length+1;for(let v=F;v<P;v++)R[N]=p.charCodeAt(v-1),f[N]=b+1,w[N]=v,N++;!m&&b<l&&(R[N]=10,f[N]=b+1,w[N]=p.length+1,N++)}return new o(R,f,w)}}class o{constructor(m,r,l){this.a=m,this.b=r,this.d=l}toString(){return"["+this.a.map((m,r)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(m,r){if(m<0||m>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(m){return m>0&&m===this.b.length?this.getEndLineNumber(m-1):(this.e(m,this.b),this.b[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this.e(m,this.b),this.a[m]===10?this.b[m]+1:this.b[m])}getStartColumn(m){return m>0&&m===this.d.length?this.getEndColumn(m-1):(this.e(m,this.d),this.d[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this.e(m,this.d),this.a[m]===10?1:this.d[m]+1)}}class h{constructor(m,r,l,R,f,w,N,b){this.originalStartLineNumber=m,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=R,this.modifiedStartLineNumber=f,this.modifiedStartColumn=w,this.modifiedEndLineNumber=N,this.modifiedEndColumn=b}static createFromDiffChange(m,r,l){const R=r.getStartLineNumber(m.originalStart),f=r.getStartColumn(m.originalStart),w=r.getEndLineNumber(m.originalStart+m.originalLength-1),N=r.getEndColumn(m.originalStart+m.originalLength-1),b=l.getStartLineNumber(m.modifiedStart),p=l.getStartColumn(m.modifiedStart),F=l.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),P=l.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new h(R,f,w,N,b,p,F,P)}}function e(g){if(g.length<=1)return g;const m=[g[0]];let r=m[0];for(let l=1,R=g.length;l<R;l++){const f=g[l],w=f.originalStart-(r.originalStart+r.originalLength),N=f.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(w,N)<u?(r.originalLength=f.originalStart+f.originalLength-r.originalStart,r.modifiedLength=f.modifiedStart+f.modifiedLength-r.modifiedStart):(m.push(f),r=f)}return m}class A{constructor(m,r,l,R,f){this.originalStartLineNumber=m,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=R,this.charChanges=f}static createFromDiffResult(m,r,l,R,f,w,N){let b,p,F,P,v;if(r.originalLength===0?(b=l.getStartLineNumber(r.originalStart)-1,p=0):(b=l.getStartLineNumber(r.originalStart),p=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(F=R.getStartLineNumber(r.modifiedStart)-1,P=0):(F=R.getStartLineNumber(r.modifiedStart),P=R.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),w&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&f()){const I=l.createCharSequence(m,r.originalStart,r.originalStart+r.originalLength-1),S=R.createCharSequence(m,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&S.getElements().length>0){let W=c(I,S,f,!0).changes;N&&(W=e(W)),v=[];for(let z=0,x=W.length;z<x;z++)v.push(h.createFromDiffChange(W[z],I,S))}}return new A(b,p,F,P,v)}}class y{constructor(m,r,l){this.a=l.shouldComputeCharChanges,this.b=l.shouldPostProcessCharChanges,this.d=l.shouldIgnoreTrimWhitespace,this.e=l.shouldMakePrettyDiff,this.f=m,this.g=r,this.h=new E(m),this.j=new E(r),this.k=M(l.maxComputationTime),this.l=M(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=c(this.h,this.j,this.k,this.e),r=m.changes,l=m.quitEarly;if(this.d){const N=[];for(let b=0,p=r.length;b<p;b++)N.push(A.createFromDiffResult(this.d,r[b],this.h,this.j,this.l,this.a,this.b));return{quitEarly:l,changes:N}}const R=[];let f=0,w=0;for(let N=-1,b=r.length;N<b;N++){const p=N+1<b?r[N+1]:null,F=p?p.originalStart:this.f.length,P=p?p.modifiedStart:this.g.length;for(;f<F&&w<P;){const v=this.f[f],I=this.g[w];if(v!==I){{let S=_(v,1),W=_(I,1);for(;S>1&&W>1;){const z=v.charCodeAt(S-2),x=I.charCodeAt(W-2);if(z!==x)break;S--,W--}(S>1||W>1)&&this.m(R,f+1,1,S,w+1,1,W)}{let S=$(v,1),W=$(I,1);const z=v.length+1,x=I.length+1;for(;S<z&&W<x;){const J=v.charCodeAt(S-1),G=v.charCodeAt(W-1);if(J!==G)break;S++,W++}(S<z||W<x)&&this.m(R,f+1,S,z,w+1,W,x)}}f++,w++}p&&(R.push(A.createFromDiffResult(this.d,p,this.h,this.j,this.l,this.a,this.b)),f+=p.originalLength,w+=p.modifiedLength)}return{quitEarly:l,changes:R}}m(m,r,l,R,f,w,N){if(this.n(m,r,l,R,f,w,N))return;let b;this.a&&(b=[new h(r,l,r,R,f,w,f,N)]),m.push(new A(r,r,f,f,b))}n(m,r,l,R,f,w,N){const b=m.length;if(b===0)return!1;const p=m[b-1];return p.originalEndLineNumber===0||p.modifiedEndLineNumber===0?!1:p.originalEndLineNumber===r&&p.modifiedEndLineNumber===f?(this.a&&p.charChanges&&p.charChanges.push(new h(r,l,r,R,f,w,f,N)),!0):p.originalEndLineNumber+1===r&&p.modifiedEndLineNumber+1===f?(p.originalEndLineNumber=r,p.modifiedEndLineNumber=f,this.a&&p.charChanges&&p.charChanges.push(new h(r,l,r,R,f,w,f,N)),!0):!1}}t.$ku=y;function _(g,m){const r=i.$yd(g);return r===-1?m:r+1}function $(g,m){const r=i.$Ad(g);return r===-1?m:r+2}function M(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),Z(K[43],te([0,1,10,14,6,4,2,9,42,39,40,25]),function(j,t,k,D,i,a,L,d,u,s,c,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XW=t.$WW=t.$VW=t.$UW=void 0;class o{constructor(){this.b=new u.$OW,this.f=new c.$TW}computeDiff(P,v,I){const S=I.maxComputationTimeMs===0?d.$LW.instance:new d.$MW(I.maxComputationTimeMs),W=!I.ignoreTrimWhitespace,z=new Map;function x(ue){let le=z.get(ue);return le===void 0&&(le=z.size,z.set(ue,le)),le}const J=P.map(ue=>x(ue.trim())),G=v.map(ue=>x(ue.trim())),ne=new $(J,P),n=new $(G,v),de=(()=>ne.length+n.length<1500?this.b.compute(ne,n,S,(ue,le)=>P[ue]===v[le]?v[le].length===0?.1:1+Math.log(1+v[le].length):.99):this.f.compute(ne,n))();let $e=de.diffs,me=de.hitTimeout;$e=(0,s.$PW)(ne,n,$e);const oe=[],ve=ue=>{if(W)for(let le=0;le<ue;le++){const se=Le+le,ge=Ae+le;if(P[se]!==v[ge]){const U=this.h(P,v,new d.$KW(new i.$SB(se,se+1),new i.$SB(ge,ge+1)),S,W);for(const B of U.mappings)oe.push(B);U.hitTimeout&&(me=!0)}}};let Le=0,Ae=0;for(const ue of $e){(0,k.$nc)(()=>ue.seq1Range.start-Le===ue.seq2Range.start-Ae);const le=ue.seq1Range.start-Le;ve(le),Le=ue.seq1Range.endExclusive,Ae=ue.seq2Range.endExclusive;const se=this.h(P,v,ue,S,W);se.hitTimeout&&(me=!0);for(const ge of se.mappings)oe.push(ge)}ve(P.length-Le);const Me=A(oe,P,v),Re=[];if(I.computeMoves){const ue=Me.filter(se=>se.modifiedRange.isEmpty&&se.originalRange.length>=3).map(se=>new p(se.originalRange,P)),le=new Set(Me.filter(se=>se.originalRange.isEmpty&&se.modifiedRange.length>=3).map(se=>new p(se.modifiedRange,v)));for(const se of ue){let ge=-1,U;for(const B of le){const q=se.computeSimilarity(B);q>ge&&(ge=q,U=B)}if(ge>.9&&U){const B=this.h(P,v,new d.$KW(new i.$SB(se.range.startLineNumber-1,se.range.endLineNumberExclusive-1),new i.$SB(U.range.startLineNumber-1,U.range.endLineNumberExclusive-1)),S,W),q=A(B.mappings,P,v,!0);le.delete(U),Re.push(new E.$Rr(new E.$Qr(se.range,U.range),q))}}}return new E.$Nr(Me,Re,me)}h(P,v,I,S,W){const z=new g(P,I.seq1Range,W),x=new g(v,I.seq2Range,W),J=z.length+x.length<500?this.b.compute(z,x,S):this.f.compute(z,x,S);let G=J.diffs;return G=(0,s.$PW)(z,x,G),G=h(z,x,G),G=(0,s.$QW)(z,x,G),{mappings:G.map(n=>new E.$Pr(z.translateRange(n.seq1Range),x.translateRange(n.seq2Range))),hitTimeout:J.hitTimeout}}}t.$UW=o;function h(F,P,v){const I=[];let S;function W(){if(!S)return;const x=S.s1Range.length-S.deleted,J=S.s2Range.length-S.added;Math.max(S.deleted,S.added)+(S.count-1)>x&&I.push(new d.$KW(S.s1Range,S.s2Range)),S=void 0}for(const x of v){let J=function($e,me){if(!S||!S.s1Range.containsRange($e)||!S.s2Range.containsRange(me))if(S&&!(S.s1Range.endExclusive<$e.start&&S.s2Range.endExclusive<me.start)){const Le=i.$SB.tryCreate(S.s1Range.endExclusive,$e.start),Ae=i.$SB.tryCreate(S.s2Range.endExclusive,me.start);S.deleted+=Le?.length??0,S.added+=Ae?.length??0,S.s1Range=S.s1Range.join($e),S.s2Range=S.s2Range.join(me)}else W(),S={added:0,deleted:0,count:0,s1Range:$e,s2Range:me};const oe=$e.intersect(x.seq1Range),ve=me.intersect(x.seq2Range);S.count++,S.deleted+=oe?.length??0,S.added+=ve?.length??0};const G=F.findWordContaining(x.seq1Range.start-1),ne=P.findWordContaining(x.seq2Range.start-1),n=F.findWordContaining(x.seq1Range.endExclusive),de=P.findWordContaining(x.seq2Range.endExclusive);G&&n&&ne&&de&&G.equals(n)&&ne.equals(de)?J(G,ne):(G&&ne&&J(G,ne),n&&de&&J(n,de))}return W(),e(v,I)}function e(F,P){const v=[];for(;F.length>0||P.length>0;){const I=F[0],S=P[0];let W;I&&(!S||I.seq1Range.start<S.seq1Range.start)?W=F.shift():W=P.shift(),v.length>0&&v[v.length-1].seq1Range.endExclusive>=W.seq1Range.start?v[v.length-1]=v[v.length-1].join(W):v.push(W)}return v}function A(F,P,v,I=!1){const S=[];for(const W of _(F.map(z=>y(z,P,v)),(z,x)=>z.originalRange.overlapOrTouch(x.originalRange)||z.modifiedRange.overlapOrTouch(x.modifiedRange))){const z=W[0],x=W[W.length-1];S.push(new E.$Or(z.originalRange.join(x.originalRange),z.modifiedRange.join(x.modifiedRange),W.map(J=>J.innerChanges[0])))}return(0,k.$nc)(()=>!I&&S.length>0&&S[0].originalRange.startLineNumber!==S[0].modifiedRange.startLineNumber?!1:(0,k.$oc)(S,(W,z)=>z.originalRange.startLineNumber-W.originalRange.endLineNumberExclusive===z.modifiedRange.startLineNumber-W.modifiedRange.endLineNumberExclusive&&W.originalRange.endLineNumberExclusive<z.originalRange.startLineNumber&&W.modifiedRange.endLineNumberExclusive<z.modifiedRange.startLineNumber)),S}t.$VW=A;function y(F,P,v){let I=0,S=0;F.modifiedRange.endColumn===1&&F.originalRange.endColumn===1&&F.originalRange.startLineNumber+I<=F.originalRange.endLineNumber&&F.modifiedRange.startLineNumber+I<=F.modifiedRange.endLineNumber&&(S=-1),F.modifiedRange.startColumn-1>=v[F.modifiedRange.startLineNumber-1].length&&F.originalRange.startColumn-1>=P[F.originalRange.startLineNumber-1].length&&F.originalRange.startLineNumber<=F.originalRange.endLineNumber+S&&F.modifiedRange.startLineNumber<=F.modifiedRange.endLineNumber+S&&(I=1);const W=new D.$Mr(F.originalRange.startLineNumber+I,F.originalRange.endLineNumber+1+S),z=new D.$Mr(F.modifiedRange.startLineNumber+I,F.modifiedRange.endLineNumber+1+S);return new E.$Or(W,z,[F])}t.$WW=y;function*_(F,P){let v,I;for(const S of F)I!==void 0&&P(I,S)?v.push(S):(v&&(yield v),v=[S]),I=S;v&&(yield v)}class ${constructor(P,v){this.b=P,this.f=v}getElement(P){return this.b[P]}get length(){return this.b.length}getBoundaryScore(P){const v=P===0?0:M(this.f[P-1]),I=P===this.f.length?0:M(this.f[P]);return 1e3-(v+I)}}t.$XW=$;function M(F){let P=0;for(;P<F.length&&(F.charCodeAt(P)===32||F.charCodeAt(P)===9);)P++;return P}class g{constructor(P,v,I){this.lines=P,this.considerWhitespaceChanges=I,this.b=[],this.f=[],this.h=[];let S=!1;v.start>0&&v.endExclusive>=P.length&&(v=new i.$SB(v.start-1,v.endExclusive),S=!0),this.lineRange=v;for(let W=this.lineRange.start;W<this.lineRange.endExclusive;W++){let z=P[W],x=0;if(S)x=z.length,z="",S=!1;else if(!I){const J=z.trimStart();x=z.length-J.length,z=J.trimEnd()}this.h.push(x);for(let J=0;J<z.length;J++)this.b.push(z.charCodeAt(J));W<P.length-1&&(this.b.push(`
`.charCodeAt(0)),this.f[W-this.lineRange.start]=this.b.length)}this.h.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.b].map(P=>String.fromCharCode(P)).join("")}getElement(P){return this.b[P]}get length(){return this.b.length}getBoundaryScore(P){const v=f(P>0?this.b[P-1]:-1),I=f(P<this.b.length?this.b[P]:-1);if(v===6&&I===7)return 0;let S=0;return v!==I&&(S+=10,I===1&&(S+=1)),S+=R(v),S+=R(I),S}translateOffset(P){if(this.lineRange.isEmpty)return new a.$Kr(this.lineRange.start+1,1);let v=0,I=this.f.length;for(;v<I;){const W=Math.floor((v+I)/2);this.f[W]>P?I=W:v=W+1}const S=v===0?0:this.f[v-1];return new a.$Kr(this.lineRange.start+v+1,P-S+1+this.h[v])}translateRange(P){return L.$Lr.fromPositions(this.translateOffset(P.start),this.translateOffset(P.endExclusive))}findWordContaining(P){if(P<0||P>=this.b.length||!m(this.b[P]))return;let v=P;for(;v>0&&m(this.b[v-1]);)v--;let I=P;for(;I<this.b.length&&m(this.b[I]);)I++;return new i.$SB(v,I)}}function m(F){return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57}var r;(function(F){F[F.WordLower=0]="WordLower",F[F.WordUpper=1]="WordUpper",F[F.WordNumber=2]="WordNumber",F[F.End=3]="End",F[F.Other=4]="Other",F[F.Space=5]="Space",F[F.LineBreakCR=6]="LineBreakCR",F[F.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const l={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function R(F){return l[F]}function f(F){return F===10?7:F===13?6:w(F)?5:F>=97&&F<=122?0:F>=65&&F<=90?1:F>=48&&F<=57?2:F===-1?3:4}function w(F){return F===32||F===9}const N=new Map;function b(F){let P=N.get(F);return P===void 0&&(P=N.size,N.set(F,P)),P}class p{constructor(P,v){this.range=P,this.lines=v,this.f=[];let I=0;for(let S=P.startLineNumber-1;S<P.endLineNumberExclusive-1;S++){const W=v[S];for(let x=0;x<W.length;x++){I++;const J=W[x],G=b(J);this.f[G]=(this.f[G]||0)+1}I++;const z=b(`
`);this.f[z]=(this.f[z]||0)+1}this.b=I}computeSimilarity(P){let v=0;const I=Math.max(this.f.length,P.f.length);for(let S=0;S<I;S++)v+=Math.abs((this.f[S]??0)-(P.f[S]??0));return 1-v/(this.b+P.b)}}}),Z(K[44],te([0,1,26,43]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YW=void 0,t.$YW={getLegacy:()=>new k.$ju,getAdvanced:()=>new D.$UW}}),Z(K[45],te([0,1,27]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZW=void 0;function D(o){const h=[];for(const e of o){const A=Number(e);(A||A===0&&e.replace(/\s/g,"")!=="")&&h.push(A)}return h}function i(o,h,e,A){return{red:o/255,blue:e/255,green:h/255,alpha:A}}function a(o,h){const e=h.index,A=h[0].length;if(!e)return;const y=o.positionAt(e);return{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:y.lineNumber,endColumn:y.column+A}}function L(o,h){if(!o)return;const e=k.$7r.Format.CSS.parseHex(h);if(e)return{range:o,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(o,h,e){if(!o||h.length!==1)return;const y=h[0].values(),_=D(y);return{range:o,color:i(_[0],_[1],_[2],e?_[3]:1)}}function u(o,h,e){if(!o||h.length!==1)return;const y=h[0].values(),_=D(y),$=new k.$7r(new k.$5r(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:o,color:i($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(o,h){return typeof o=="string"?[...o.matchAll(h)]:o.findMatches(h)}function c(o){const h=[],A=s(o,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(A.length>0)for(const y of A){const _=y.filter(m=>m!==void 0),$=_[1],M=_[2];if(!M)continue;let g;if($==="rgb"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=d(a(o,y),s(M,m),!1)}else if($==="rgba"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=d(a(o,y),s(M,m),!0)}else if($==="hsl"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=u(a(o,y),s(M,m),!1)}else if($==="hsla"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=u(a(o,y),s(M,m),!0)}else $==="#"&&(g=L(a(o,y),$+M));g&&h.push(g)}return h}function E(o){return!o||typeof o.getValue!="function"||typeof o.positionAt!="function"?[]:c(o)}t.$ZW=E}),Z(K[46],te([0,1,23]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FW=t.$EW=t.$DW=t.State=void 0;var D;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class i{constructor(e,A,y){const _=new Uint8Array(e*A);for(let $=0,M=e*A;$<M;$++)_[$]=y;this.a=_,this.rows=e,this.cols=A}get(e,A){return this.a[e*this.cols+A]}set(e,A,y){this.a[e*this.cols+A]=y}}class a{constructor(e){let A=0,y=0;for(let $=0,M=e.length;$<M;$++){const[g,m,r]=e[$];m>A&&(A=m),g>y&&(y=g),r>y&&(y=r)}A++,y++;const _=new i(y,A,0);for(let $=0,M=e.length;$<M;$++){const[g,m,r]=e[$];_.set(g,m,r)}this.a=_,this.b=A}nextState(e,A){return A<0||A>=this.b?0:this.a.get(e,A)}}t.$DW=a;let L=null;function d(){return L===null&&(L=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var u;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let s=null;function c(){if(s===null){s=new k.$Zr(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<h.length;A++)s.set(h.charCodeAt(A),1);const e=".,;:";for(let A=0;A<e.length;A++)s.set(e.charCodeAt(A),2)}return s}class E{static a(e,A,y,_,$){let M=$-1;do{const g=A.charCodeAt(M);if(e.get(g)!==2)break;M--}while(M>_);if(_>0){const g=A.charCodeAt(_-1),m=A.charCodeAt(M);(g===40&&m===41||g===91&&m===93||g===123&&m===125)&&M--}return{range:{startLineNumber:y,startColumn:_+1,endLineNumber:y,endColumn:M+2},url:A.substring(_,M+1)}}static computeLinks(e,A=d()){const y=c(),_=[];for(let $=1,M=e.getLineCount();$<=M;$++){const g=e.getLineContent($),m=g.length;let r=0,l=0,R=0,f=1,w=!1,N=!1,b=!1,p=!1;for(;r<m;){let F=!1;const P=g.charCodeAt(r);if(f===13){let v;switch(P){case 40:w=!0,v=0;break;case 41:v=w?0:1;break;case 91:b=!0,N=!0,v=0;break;case 93:b=!1,v=N?0:1;break;case 123:p=!0,v=0;break;case 125:v=p?0:1;break;case 39:case 34:case 96:R===P?v=1:R===39||R===34||R===96?v=0:v=1;break;case 42:v=R===42?1:0;break;case 124:v=R===124?1:0;break;case 32:v=b?0:1;break;default:v=y.get(P)}v===1&&(_.push(E.a(y,g,$,l,r)),F=!0)}else if(f===12){let v;P===91?(N=!0,v=0):v=y.get(P),v===1?F=!0:f=13}else f=A.nextState(f,P),f===0&&(F=!0);F&&(f=1,w=!1,N=!1,p=!1,l=r+1,R=P),r++}f===13&&_.push(E.a(y,g,$,l,m))}return _}}t.$EW=E;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:E.computeLinks(h)}t.$FW=o}),Z(K[47],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GW=void 0;class k{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,a,L,d,u){if(i&&a){const s=this.a(a,u);if(s)return{range:i,value:s}}if(L&&d){const s=this.a(d,u);if(s)return{range:L,value:s}}return null}a(i,a){const L=this.b(i,a);return L!==null?L:this.d(i,a)}b(i,a){const L=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let d=Number(i);const u=parseFloat(i);return!isNaN(d)&&!isNaN(u)&&d===u?d===0&&!a?null:(d=Math.floor(d*L),d+=a?L:-L,String(d/L)):null}d(i,a){return this.e(this.c,i,a)}e(i,a,L){let d=null;for(let u=0,s=i.length;d===null&&u<s;u++)d=this.f(i[u],a,L);return d}f(i,a,L){let d=i.indexOf(a);return d>=0?(d+=L?1:-1,d<0?d=i.length-1:d%=i.length,i[d]):null}}t.$GW=k,k.INSTANCE=new k}),Z(K[48],te([0,1,12]),function(j,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vt=t.$Ut=t.$Tt=t.$St=t.ModelConstants=t.PositionAffinity=t.$Rt=t.TrackedRangeStickiness=t.$Qt=t.$Pt=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var a;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(a||(t.MinimapPosition=a={}));var L;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var d;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var u;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var s;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class c{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,k.$Im)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.$Pt=c;class E{constructor(m,r){this._findMatchBrand=void 0,this.range=m,this.matches=r}}t.$Qt=E;var o;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(o||(t.TrackedRangeStickiness=o={}));function h(g){return g&&typeof g.read=="function"}t.$Rt=h;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var A;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A||(t.ModelConstants=A={}));class y{constructor(m,r,l,R,f,w){this.identifier=m,this.range=r,this.text=l,this.forceMoveMarkers=R,this.isAutoWhitespaceEdit=f,this._isTracked=w}}t.$St=y;class _{constructor(m,r,l){this.regex=m,this.wordSeparators=r,this.simpleSearch=l}}t.$Tt=_;class ${constructor(m,r,l){this.reverseEdits=m,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}t.$Ut=$;function M(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.$Vt=M}),Z(K[49],te([0,1,29,22]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pu=t.$ou=t.$nu=void 0;class i{constructor(u){this.a=u,this.b=new Uint32Array(u.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(u,s){u=(0,D.$gd)(u);const c=this.a,E=this.b,o=s.length;return o===0?!1:(this.a=new Uint32Array(c.length+o),this.a.set(c.subarray(0,u),0),this.a.set(c.subarray(u),u+o),this.a.set(s,u),u-1<this.c[0]&&(this.c[0]=u-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(u,s){return u=(0,D.$gd)(u),s=(0,D.$gd)(s),this.a[u]===s?!1:(this.a[u]=s,u-1<this.c[0]&&(this.c[0]=u-1),!0)}removeValues(u,s){u=(0,D.$gd)(u),s=(0,D.$gd)(s);const c=this.a,E=this.b;if(u>=c.length)return!1;const o=c.length-u;return s>=o&&(s=o),s===0?!1:(this.a=new Uint32Array(c.length-s),this.a.set(c.subarray(0,u),0),this.a.set(c.subarray(u+s),u),this.b=new Uint32Array(this.a.length),u-1<this.c[0]&&(this.c[0]=u-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(u){return u<0?0:(u=(0,D.$gd)(u),this.d(u))}d(u){if(u<=this.c[0])return this.b[u];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),u>=this.a.length&&(u=this.a.length-1);for(let c=s;c<=u;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],u),this.b[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let s=0,c=this.a.length-1,E=0,o=0,h=0;for(;s<=c;)if(E=s+(c-s)/2|0,o=this.b[E],h=o-this.a[E],u<h)c=E-1;else if(u>=o)s=E+1;else break;return new L(E,u-h)}}t.$nu=i;class a{constructor(u){this.a=u,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(u){return this.g(),u===0?0:this.d[u-1]}getIndexOf(u){this.g();const s=this.e[u],c=s>0?this.d[s-1]:0;return new L(s,u-c)}removeValues(u,s){this.a.splice(u,s),this.f(u)}insertValues(u,s){this.a=(0,k.$Af)(this.a,u,s),this.f(u)}f(u){this.b=!1,this.c=Math.min(this.c,u-1)}g(){if(!this.b){for(let u=this.c+1,s=this.a.length;u<s;u++){const c=this.a[u],E=u>0?this.d[u-1]:0;this.d[u]=E+c;for(let o=0;o<c;o++)this.e[E+o]=u}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(u,s){this.a[u]!==s&&(this.a[u]=s,this.f(u))}}t.$ou=a;class L{constructor(u,s){this.index=u,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=s}}t.$pu=L}),Z(K[50],te([0,1,5,4,49]),function(j,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qu=void 0;class a{constructor(d,u,s,c){this.d=d,this.f=u,this.g=s,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const u=d.changes;for(const s of u)this.o(s.range),this.p(new D.$Kr(s.range.startLineNumber,s.range.startColumn),s.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,u=this.f.length,s=new Uint32Array(u);for(let c=0;c<u;c++)s[c]=this.f[c].length+d;this.j=new i.$nu(s)}}n(d,u){this.f[d]=u,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,u){if(u.length===0)return;const s=(0,k.$xd)(u);if(s.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]+this.f[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]);const c=new Uint32Array(s.length-1);for(let E=1;E<s.length;E++)this.f.splice(d.lineNumber+E-1,0,s[E]),c[E-1]=s[E].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,c)}}t.$qu=a}),Z(K[51],te([0,1,5,38,4,2,48]),function(j,t,k,D,i,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KB=t.$JB=t.$IB=t.$HB=t.$GB=t.$FB=void 0;const d=999;class u{constructor($,M,g,m){this.searchString=$,this.isRegex=M,this.matchCase=g,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let M=null;try{M=k.$td(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!M)return null;let g=!this.isRegex&&!$;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L.$Tt(M,this.wordSeparators?(0,D.$3r)(this.wordSeparators):null,g?this.searchString:null)}}t.$FB=u;function s(_){if(!_||_.length===0)return!1;for(let $=0,M=_.length;$<M;$++){const g=_.charCodeAt($);if(g===10)return!0;if(g===92){if($++,$>=M)break;const m=_.charCodeAt($);if(m===110||m===114||m===87)return!0}}return!1}t.$GB=s;function c(_,$,M){if(!M)return new L.$Qt(_,null);const g=[];for(let m=0,r=$.length;m<r;m++)g[m]=$[m];return new L.$Qt(_,g)}t.$HB=c;class E{constructor($){const M=[];let g=0;for(let m=0,r=$.length;m<r;m++)$.charCodeAt(m)===10&&(M[g++]=m);this.a=M}findLineFeedCountBeforeOffset($){const M=this.a;let g=0,m=M.length-1;if(m===-1||$<=M[0])return 0;for(;g<m;){const r=g+((m-g)/2>>0);M[r]>=$?m=r-1:M[r+1]>=$?(g=r,m=r):g=r+1}return g+1}}class o{static findMatches($,M,g,m,r){const l=M.parseSearchRequest();return l?l.regex.multiline?this.b($,g,new y(l.wordSeparators,l.regex),m,r):this.c($,g,l,m,r):[]}static a($,M,g,m,r,l){let R,f=0;m?(f=m.findLineFeedCountBeforeOffset(r),R=M+r+f):R=M+r;let w;if(m){const F=m.findLineFeedCountBeforeOffset(r+l.length)-f;w=R+l.length+F}else w=R+l.length;const N=$.getPositionAt(R),b=$.getPositionAt(w);return new a.$Lr(N.lineNumber,N.column,b.lineNumber,b.column)}static b($,M,g,m,r){const l=$.getOffsetAt(M.getStartPosition()),R=$.getValueInRange(M,1),f=$.getEOL()===`\r
`?new E(R):null,w=[];let N=0,b;for(g.reset(0);b=g.next(R);)if(w[N++]=c(this.a($,l,R,f,b.index,b[0]),b,m),N>=r)return w;return w}static c($,M,g,m,r){const l=[];let R=0;if(M.startLineNumber===M.endLineNumber){const w=$.getLineContent(M.startLineNumber).substring(M.startColumn-1,M.endColumn-1);return R=this.d(g,w,M.startLineNumber,M.startColumn-1,R,l,m,r),l}const f=$.getLineContent(M.startLineNumber).substring(M.startColumn-1);R=this.d(g,f,M.startLineNumber,M.startColumn-1,R,l,m,r);for(let w=M.startLineNumber+1;w<M.endLineNumber&&R<r;w++)R=this.d(g,$.getLineContent(w),w,0,R,l,m,r);if(R<r){const w=$.getLineContent(M.endLineNumber).substring(0,M.endColumn-1);R=this.d(g,w,M.endLineNumber,0,R,l,m,r)}return l}static d($,M,g,m,r,l,R,f){const w=$.wordSeparators;if(!R&&$.simpleSearch){const p=$.simpleSearch,F=p.length,P=M.length;let v=-F;for(;(v=M.indexOf(p,v+F))!==-1;)if((!w||A(w,M,P,v,F))&&(l[r++]=new L.$Qt(new a.$Lr(g,v+1+m,g,v+1+F+m),null),r>=f))return r;return r}const N=new y($.wordSeparators,$.regex);let b;N.reset(0);do if(b=N.next(M),b&&(l[r++]=c(new a.$Lr(g,b.index+1+m,g,b.index+1+b[0].length+m),b,R),r>=f))return r;while(b);return r}static findNextMatch($,M,g,m){const r=M.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.e($,g,l,m):this.f($,g,l,m)}static e($,M,g,m){const r=new i.$Kr(M.lineNumber,1),l=$.getOffsetAt(r),R=$.getLineCount(),f=$.getValueInRange(new a.$Lr(r.lineNumber,r.column,R,$.getLineMaxColumn(R)),1),w=$.getEOL()===`\r
`?new E(f):null;g.reset(M.column-1);const N=g.next(f);return N?c(this.a($,l,f,w,N.index,N[0]),N,m):M.lineNumber!==1||M.column!==1?this.e($,new i.$Kr(1,1),g,m):null}static f($,M,g,m){const r=$.getLineCount(),l=M.lineNumber,R=$.getLineContent(l),f=this.g(g,R,l,M.column,m);if(f)return f;for(let w=1;w<=r;w++){const N=(l+w-1)%r,b=$.getLineContent(N+1),p=this.g(g,b,N+1,1,m);if(p)return p}return null}static g($,M,g,m,r){$.reset(m-1);const l=$.next(M);return l?c(new a.$Lr(g,l.index+1,g,l.index+1+l[0].length),l,r):null}static findPreviousMatch($,M,g,m){const r=M.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.h($,g,l,m):this.j($,g,l,m)}static h($,M,g,m){const r=this.b($,new a.$Lr(1,1,M.lineNumber,M.column),g,m,10*d);if(r.length>0)return r[r.length-1];const l=$.getLineCount();return M.lineNumber!==l||M.column!==$.getLineMaxColumn(l)?this.h($,new i.$Kr(l,$.getLineMaxColumn(l)),g,m):null}static j($,M,g,m){const r=$.getLineCount(),l=M.lineNumber,R=$.getLineContent(l).substring(0,M.column-1),f=this.k(g,R,l,m);if(f)return f;for(let w=1;w<=r;w++){const N=(r+l-w-1)%r,b=$.getLineContent(N+1),p=this.k(g,b,N+1,m);if(p)return p}return null}static k($,M,g,m){let r=null,l;for($.reset(0);l=$.next(M);)r=c(new a.$Lr(g,l.index+1,g,l.index+1+l[0].length),l,m);return r}}t.$IB=o;function h(_,$,M,g,m){if(g===0)return!0;const r=$.charCodeAt(g-1);if(_.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=$.charCodeAt(g);if(_.get(l)!==0)return!0}return!1}function e(_,$,M,g,m){if(g+m===M)return!0;const r=$.charCodeAt(g+m);if(_.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=$.charCodeAt(g+m-1);if(_.get(l)!==0)return!0}return!1}function A(_,$,M,g,m){return h(_,$,M,g,m)&&e(_,$,M,g,m)}t.$JB=A;class y{constructor($,M){this._wordSeparators=$,this.a=M,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const M=$.length;let g;do{if(this.b+this.c===M||(g=this.a.exec($),!g))return null;const m=g.index,r=g[0].length;if(m===this.b&&r===this.c){if(r===0){k.$Qd($,M,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=m,this.c=r,!this._wordSeparators||A(this._wordSeparators,$,M,m,r))return g}while(g);return null}}t.$KB=y}),Z(K[52],te([0,1,2,51,5,10,24]),function(j,t,k,D,i,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$CW=void 0;class d{static computeUnicodeHighlights(e,A,y){const _=y?y.startLineNumber:1,$=y?y.endLineNumber:e.getLineCount(),M=new c(A),g=M.getCandidateCodePoints();let m;g==="allNonBasicAscii"?m=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):m=new RegExp(`${u(Array.from(g))}`,"g");const r=new D.$KB(null,m),l=[];let R=!1,f,w=0,N=0,b=0;e:for(let p=_,F=$;p<=F;p++){const P=e.getLineContent(p),v=P.length;r.reset(0);do if(f=r.next(P),f){let I=f.index,S=f.index+f[0].length;if(I>0){const J=P.charCodeAt(I-1);i.$Nd(J)&&I--}if(S+1<v){const J=P.charCodeAt(S-1);i.$Nd(J)&&S++}const W=P.substring(I,S);let z=(0,L.$Jr)(I+1,L.$Gr,P,0);z&&z.endColumn<=I+1&&(z=null);const x=M.shouldHighlightNonBasicASCII(W,z?z.word:null);if(x!==0){x===3?w++:x===2?N++:x===1?b++:(0,a.$lc)(x);const J=1e3;if(l.length>=J){R=!0;break e}l.push(new k.$Lr(p,I+1,p,S+1))}}while(f)}return{ranges:l,hasMore:R,ambiguousCharacterCount:w,invisibleCharacterCount:N,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(e,A){const y=new c(A);switch(y.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),M=y.ambiguousCharacters.getPrimaryConfusable($),g=i.$ee.getLocales().filter(m=>!i.$ee.getInstance(new Set([...A.allowedLocales,m])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(M),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.$CW=d;function u(h,e){return`[${i.$ld(h.map(y=>String.fromCodePoint(y)).join(""))}]`}var s;(function(h){h[h.Ambiguous=0]="Ambiguous",h[h.Invisible=1]="Invisible",h[h.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.$ee.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const A of i.$fe.codePoints)E(String.fromCodePoint(A))||e.add(A);if(this.b.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.a)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const y=e.codePointAt(0);if(this.a.has(y))return 0;if(this.b.nonBasicASCII)return 1;let _=!1,$=!1;if(A)for(const M of A){const g=M.codePointAt(0),m=i.$Yd(M);_=_||m,!m&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.$fe.isInvisibleCharacter(g)&&($=!0)}return!_&&$?0:this.b.invisibleCharacters&&!E(e)&&i.$fe.isInvisibleCharacter(y)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(y)?3:0}}function E(h){return h===" "||h===`
`||h==="	"}var o;(function(h){h[h.None=0]="None",h[h.NonBasicASCII=1]="NonBasicASCII",h[h.Invisible=2]="Invisible",h[h.Ambiguous=3]="Ambiguous"})(o||(o={}))}),Z(K[53],te([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a||(t.CompletionItemKind=a={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var u;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(u||(t.ContentWidgetPositionPreference=u={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var c;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var o;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(o||(t.EditorAutoIndentStrategy=o={}));var h;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.pasteAs=82]="pasteAs",n[n.parameterHints=83]="parameterHints",n[n.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",n[n.quickSuggestions=86]="quickSuggestions",n[n.quickSuggestionsDelay=87]="quickSuggestionsDelay",n[n.readOnly=88]="readOnly",n[n.readOnlyMessage=89]="readOnlyMessage",n[n.renameOnType=90]="renameOnType",n[n.renderControlCharacters=91]="renderControlCharacters",n[n.renderFinalNewline=92]="renderFinalNewline",n[n.renderLineHighlight=93]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=95]="renderValidationDecorations",n[n.renderWhitespace=96]="renderWhitespace",n[n.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",n[n.roundedSelection=98]="roundedSelection",n[n.rulers=99]="rulers",n[n.scrollbar=100]="scrollbar",n[n.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=102]="scrollBeyondLastLine",n[n.scrollPredominantAxis=103]="scrollPredominantAxis",n[n.selectionClipboard=104]="selectionClipboard",n[n.selectionHighlight=105]="selectionHighlight",n[n.selectOnLineNumbers=106]="selectOnLineNumbers",n[n.showFoldingControls=107]="showFoldingControls",n[n.showUnused=108]="showUnused",n[n.snippetSuggestions=109]="snippetSuggestions",n[n.smartSelect=110]="smartSelect",n[n.smoothScrolling=111]="smoothScrolling",n[n.stickyScroll=112]="stickyScroll",n[n.stickyTabStops=113]="stickyTabStops",n[n.stopRenderingLineAfter=114]="stopRenderingLineAfter",n[n.suggest=115]="suggest",n[n.suggestFontSize=116]="suggestFontSize",n[n.suggestLineHeight=117]="suggestLineHeight",n[n.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",n[n.suggestSelection=119]="suggestSelection",n[n.tabCompletion=120]="tabCompletion",n[n.tabIndex=121]="tabIndex",n[n.unicodeHighlighting=122]="unicodeHighlighting",n[n.unusualLineTerminators=123]="unusualLineTerminators",n[n.useShadowDOM=124]="useShadowDOM",n[n.useTabStops=125]="useTabStops",n[n.wordBreak=126]="wordBreak",n[n.wordSeparators=127]="wordSeparators",n[n.wordWrap=128]="wordWrap",n[n.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=131]="wordWrapColumn",n[n.wordWrapOverride1=132]="wordWrapOverride1",n[n.wordWrapOverride2=133]="wordWrapOverride2",n[n.wrappingIndent=134]="wrappingIndent",n[n.wrappingStrategy=135]="wrappingStrategy",n[n.showDeprecated=136]="showDeprecated",n[n.inlayHints=137]="inlayHints",n[n.editorClassName=138]="editorClassName",n[n.pixelRatio=139]="pixelRatio",n[n.tabFocusMode=140]="tabFocusMode",n[n.layoutInfo=141]="layoutInfo",n[n.wrappingInfo=142]="wrappingInfo",n[n.defaultColorDecorators=143]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(h||(t.EditorOption=h={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var A;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(A||(t.EndOfLineSequence=A={}));var y;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(y||(t.GlyphMarginLane=y={}));var _;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(_||(t.IndentAction=_={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var M;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(M||(t.InlayHintKind=M={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(m||(t.KeyCode=m={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var R;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(R||(t.MinimapPosition=R={}));var f;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(t.MouseTargetType=f={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var N;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(N||(t.OverviewRulerLane=N={}));var b;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(b||(t.PositionAffinity=b={}));var p;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(p||(t.RenderLineNumbersType=p={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var v;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(v||(t.ScrollbarVisibility=v={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var S;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(S||(t.SignatureHelpTriggerKind=S={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W||(t.SymbolKind=W={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z||(t.SymbolTag=z={}));var x;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(x||(t.TextEditorCursorBlinkingStyle=x={}));var J;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(J||(t.TextEditorCursorStyle=J={}));var G;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G||(t.TrackedRangeStickiness=G={}));var ne;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ne||(t.WrappingIndent=ne={}))}),Z(K[54],te([0,1,8,7]),function(j,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bs=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$5c,this.onDidChange=this.c.event,this.d=null}handleChange(d){this.c.fire({changedLanguages:d,changedColorMap:!1})}register(d,u){return this.a.set(d,u),this.handleChange([d]),(0,D.$ib)(()=>{this.a.get(d)===u&&(this.a.delete(d),this.handleChange([d]))})}get(d){return this.a.get(d)||null}registerFactory(d,u){this.b.get(d)?.dispose();const s=new a(this,d,u);return this.b.set(d,s),(0,D.$ib)(()=>{const c=this.b.get(d);!c||c!==s||(this.b.delete(d),c.dispose())})}async getOrCreate(d){const u=this.get(d);if(u)return u;const s=this.b.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this.b.get(d);return!!(!s||s.isResolved)}setColorMap(d){this.d=d,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$bs=i;class a extends D.$kb{get isResolved(){return this.c}constructor(d,u,s){super(),this.f=d,this.g=u,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const d=await this.h.tokenizationSupport;this.c=!0,d&&!this.a&&this.B(this.f.register(this.g,d))}}}),Z(K[55],te([0,1,36,13,2,54]),function(j,t,k,D,i,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$qs=t.$ps=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$os=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.$ns=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$ms=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$ls=t.$ks=t.$js=void 0;class L{constructor(I,S,W){this.offset=I,this.type=S,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$js=L;class d{constructor(I,S){this.tokens=I,this.endState=S,this._tokenizationResultBrand=void 0}}t.$ks=d;class u{constructor(I,S){this.tokens=I,this.endState=S,this._encodedTokenizationResultBrand=void 0}}t.$ls=u;var s;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(s||(t.CompletionItemKind=s={}));var c;(function(v){const I=new Map;I.set(0,k.$yj.symbolMethod),I.set(1,k.$yj.symbolFunction),I.set(2,k.$yj.symbolConstructor),I.set(3,k.$yj.symbolField),I.set(4,k.$yj.symbolVariable),I.set(5,k.$yj.symbolClass),I.set(6,k.$yj.symbolStruct),I.set(7,k.$yj.symbolInterface),I.set(8,k.$yj.symbolModule),I.set(9,k.$yj.symbolProperty),I.set(10,k.$yj.symbolEvent),I.set(11,k.$yj.symbolOperator),I.set(12,k.$yj.symbolUnit),I.set(13,k.$yj.symbolValue),I.set(15,k.$yj.symbolEnum),I.set(14,k.$yj.symbolConstant),I.set(15,k.$yj.symbolEnum),I.set(16,k.$yj.symbolEnumMember),I.set(17,k.$yj.symbolKeyword),I.set(27,k.$yj.symbolSnippet),I.set(18,k.$yj.symbolText),I.set(19,k.$yj.symbolColor),I.set(20,k.$yj.symbolFile),I.set(21,k.$yj.symbolReference),I.set(22,k.$yj.symbolCustomColor),I.set(23,k.$yj.symbolFolder),I.set(24,k.$yj.symbolTypeParameter),I.set(25,k.$yj.account),I.set(26,k.$yj.issues);function S(x){let J=I.get(x);return J||(console.info("No codicon found for CompletionItemKind "+x),J=k.$yj.symbolProperty),J}v.toIcon=S;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function z(x,J){let G=W.get(x);return typeof G>"u"&&!J&&(G=9),G}v.fromString=z})(c||(t.CompletionItemKinds=c={}));var E;(function(v){v[v.Deprecated=1]="Deprecated"})(E||(t.CompletionItemTag=E={}));var o;(function(v){v[v.None=0]="None",v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(o||(t.CompletionItemInsertTextRule=o={}));var h;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var e;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class A{constructor(I,S,W,z){this.range=I,this.text=S,this.completionKind=W,this.isSnippetText=z}equals(I){return i.$Lr.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}t.$ms=A;var y;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var _;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var $;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})($||(t.DocumentHighlightKind=$={}));function M(v){return v&&D.URI.isUri(v.uri)&&i.$Lr.isIRange(v.range)&&(i.$Lr.isIRange(v.originSelectionRange)||i.$Lr.isIRange(v.targetSelectionRange))}t.$ns=M;var g;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(g||(t.SymbolKind=g={}));var m;(function(v){v[v.Deprecated=1]="Deprecated"})(m||(t.SymbolTag=m={}));var r;(function(v){const I=new Map;I.set(0,k.$yj.symbolFile),I.set(1,k.$yj.symbolModule),I.set(2,k.$yj.symbolNamespace),I.set(3,k.$yj.symbolPackage),I.set(4,k.$yj.symbolClass),I.set(5,k.$yj.symbolMethod),I.set(6,k.$yj.symbolProperty),I.set(7,k.$yj.symbolField),I.set(8,k.$yj.symbolConstructor),I.set(9,k.$yj.symbolEnum),I.set(10,k.$yj.symbolInterface),I.set(11,k.$yj.symbolFunction),I.set(12,k.$yj.symbolVariable),I.set(13,k.$yj.symbolConstant),I.set(14,k.$yj.symbolString),I.set(15,k.$yj.symbolNumber),I.set(16,k.$yj.symbolBoolean),I.set(17,k.$yj.symbolArray),I.set(18,k.$yj.symbolObject),I.set(19,k.$yj.symbolKey),I.set(20,k.$yj.symbolNull),I.set(21,k.$yj.symbolEnumMember),I.set(22,k.$yj.symbolStruct),I.set(23,k.$yj.symbolEvent),I.set(24,k.$yj.symbolOperator),I.set(25,k.$yj.symbolTypeParameter);function S(W){let z=I.get(W);return z||(console.info("No codicon found for SymbolKind "+W),z=k.$yj.symbolProperty),z}v.toIcon=S})(r||(t.SymbolKinds=r={}));class l{static fromValue(I){switch(I){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(I)}constructor(I){this.value=I}}t.$os=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var R;(function(v){function I(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}v.is=I})(R||(t.Command=R={}));var f;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(f||(t.CommentThreadCollapsibleState=f={}));var w;(function(v){v[v.Unresolved=0]="Unresolved",v[v.Resolved=1]="Resolved"})(w||(t.CommentThreadState=w={}));var N;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(N||(t.CommentMode=N={}));var b;(function(v){v[v.Published=0]="Published",v[v.Draft=1]="Draft"})(b||(t.CommentState=b={}));var p;(function(v){v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));class F{constructor(I){this.b=I,this.a=null}dispose(){this.a&&this.a.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$ps=F,t.$qs=new a.$bs;var P;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(P||(t.ExternalUriOpenerPriority=P={}))}),Z(K[56],te([0,1,19,8,30,13,4,2,37,55,53]),function(j,t,k,D,i,a,L,d,u,s,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IW=t.$HW=void 0;class E{static chord(e,A){return(0,i.$hq)(e,A)}}t.$HW=E,E.CtrlCmd=2048,E.Shift=1024,E.Alt=512,E.WinCtrl=256;function o(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.$bd,Emitter:D.$5c,KeyCode:c.KeyCode,KeyMod:E,Position:L.$Kr,Range:d.$Lr,Selection:u.$Tr,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:a.URI,Token:s.$js}}t.$IW=o}),Z(K[59],te([0,1,20,13,4,2,50,24,46,47,56,18,52,26,44,12,3,45]),function(j,t,k,D,i,a,L,d,u,s,c,E,o,h,e,A,y,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends L.$qu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const l=[];for(let R=0;R<this.f.length;R++){const f=this.f[R],w=this.offsetAt(new i.$Kr(R+1,1)),N=f.matchAll(r);for(const b of N)(b.index||b.index===0)&&(b.index=b.index+w),l.push(b)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,l){const R=(0,d.$Jr)(r.column,(0,d.$Hr)(l),this.f[r.lineNumber-1],0);return R?new a.$Lr(r.lineNumber,R.startColumn,r.lineNumber,R.endColumn):null}getWordUntilPosition(r,l){const R=this.getWordAtPosition(r,l);return R?{word:this.f[r.lineNumber-1].substring(R.startColumn-1,r.column-1),startColumn:R.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this.f,R=this.q.bind(this);let f=0,w="",N=0,b=[];return{*[Symbol.iterator](){for(;;)if(N<b.length){const p=w.substring(b[N].start,b[N].end);N+=1,yield p}else if(f<l.length)w=l[f],b=R(w,r),N=0,f+=1;else break}}}getLineWords(r,l){const R=this.f[r-1],f=this.q(R,l),w=[];for(const N of f)w.push({word:R.substring(N.start,N.end),startColumn:N.start+1,endColumn:N.end+1});return w}q(r,l){const R=[];let f;for(l.lastIndex=0;(f=l.exec(r))&&f[0].length!==0;)R.push({start:f.index,end:f.index+f[0].length});return R}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this.g,R=r.startLineNumber-1,f=r.endLineNumber-1,w=[];w.push(this.f[R].substring(r.startColumn-1));for(let N=R+1;N<f;N++)w.push(this.f[N]);return w.push(this.f[f].substring(0,r.endColumn-1)),w.join(l)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const l=this.j.getIndexOf(r),R=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,R)}}r(r){const l=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),R=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||R.lineNumber!==r.endLineNumber||R.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:R.lineNumber,endColumn:R.column}:r}s(r){if(!i.$Kr.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:R}=r,f=!1;if(l<1)l=1,R=1,f=!0;else if(l>this.f.length)l=this.f.length,R=this.f[l-1].length+1,f=!0;else{const w=this.f[l-1].length+1;R<1?(R=1,f=!0):R>w&&(R=w,f=!0)}return f?{lineNumber:l,column:R}:r}}class M{constructor(r,l){this.d=r,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(l=>r.push(this.f[l])),r}acceptNewModel(r){this.f[r.url]=new $(D.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this.f[r])return;this.f[r].onEvents(l)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,l,R){const f=this.j(r);return f?o.$CW.computeUnicodeHighlights(f,l,R):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,l,R,f){const w=this.j(r),N=this.j(l);return!w||!N?null:M.l(w,N,R,f)}static l(r,l,R,f){const w=f==="advanced"?e.$YW.getAdvanced():e.$YW.getLegacy(),N=r.getLinesContent(),b=l.getLinesContent(),p=w.computeDiff(N,b,R),F=p.changes.length>0?!1:this.n(r,l);function P(v){return v.map(I=>[I.originalRange.startLineNumber,I.originalRange.endLineNumberExclusive,I.modifiedRange.startLineNumber,I.modifiedRange.endLineNumberExclusive,I.innerChanges?.map(S=>[S.originalRange.startLineNumber,S.originalRange.startColumn,S.originalRange.endLineNumber,S.originalRange.endColumn,S.modifiedRange.startLineNumber,S.modifiedRange.startColumn,S.modifiedRange.endLineNumber,S.modifiedRange.endColumn])])}return{identical:F,quitEarly:p.hitTimeout,changes:P(p.changes),moves:p.moves.map(v=>[v.lineRangeMapping.originalRange.startLineNumber,v.lineRangeMapping.originalRange.endLineNumberExclusive,v.lineRangeMapping.modifiedRange.startLineNumber,v.lineRangeMapping.modifiedRange.endLineNumberExclusive,P(v.changes)])}}static n(r,l){const R=r.getLineCount(),f=l.getLineCount();if(R!==f)return!1;for(let w=1;w<=R;w++){const N=r.getLineContent(w),b=l.getLineContent(w);if(N!==b)return!1}return!0}async computeDirtyDiff(r,l,R){const f=this.j(r),w=this.j(l);if(!f||!w)return null;const N=f.getLinesContent(),b=w.getLinesContent();return new h.$ku(N,b,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:R,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,l,R){const f=this.j(r);if(!f)return l;const w=[];let N;l=l.slice(0).sort((b,p)=>{if(b.range&&p.range)return a.$Lr.compareRangesUsingStarts(b.range,p.range);const F=b.range?0:1,P=p.range?0:1;return F-P});for(let{range:b,text:p,eol:F}of l){if(typeof F=="number"&&(N=F),a.$Lr.isEmpty(b)&&!p)continue;const P=f.getValueInRange(b);if(p=p.replace(/\r\n|\n|\r/g,f.eol),P===p)continue;if(Math.max(p.length,P.length)>M.o){w.push({range:b,text:p});continue}const v=(0,k.$hu)(P,p,R),I=f.offsetAt(a.$Lr.lift(b).getStartPosition());for(const S of v){const W=f.positionAt(I+S.originalStart),z=f.positionAt(I+S.originalStart+S.originalLength),x={text:p.substr(S.modifiedStart,S.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:z.lineNumber,endColumn:z.column}};f.getValueInRange(x.range)!==x.text&&w.push(x)}}return typeof N=="number"&&w.push({eol:N,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeHumanReadableDiff(r,l,R){const f=this.j(r);if(!f)return l;const w=[];let N;l=l.slice(0).sort((b,p)=>{if(b.range&&p.range)return a.$Lr.compareRangesUsingStarts(b.range,p.range);const F=b.range?0:1,P=p.range?0:1;return F-P});for(let{range:b,text:p,eol:F}of l){let z=function(J,G){return new i.$Kr(J.lineNumber+G.lineNumber-1,G.lineNumber===1?J.column+G.column-1:G.column)},x=function(J,G){const ne=[];for(let n=G.startLineNumber;n<=G.endLineNumber;n++){const de=J[n-1];n===G.startLineNumber&&n===G.endLineNumber?ne.push(de.substring(G.startColumn-1,G.endColumn-1)):n===G.startLineNumber?ne.push(de.substring(G.startColumn-1)):n===G.endLineNumber?ne.push(de.substring(0,G.endColumn-1)):ne.push(de)}return ne};if(typeof F=="number"&&(N=F),a.$Lr.isEmpty(b)&&!p)continue;const P=f.getValueInRange(b);if(p=p.replace(/\r\n|\n|\r/g,f.eol),P===p)continue;if(Math.max(p.length,P.length)>M.o){w.push({range:b,text:p});continue}const v=P.split(/\r\n|\n|\r/),I=p.split(/\r\n|\n|\r/),S=e.$YW.getAdvanced().computeDiff(v,I,R),W=a.$Lr.lift(b).getStartPosition();for(const J of S.changes)if(J.innerChanges)for(const G of J.innerChanges)w.push({range:a.$Lr.fromPositions(z(W,G.originalRange.getStartPosition()),z(W,G.originalRange.getEndPosition())),text:x(I,G.modifiedRange).join(f.eol)});else throw new y.$ab("The experimental diff algorithm always produces inner changes")}return typeof N=="number"&&w.push({eol:N,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(r){const l=this.j(r);return l?(0,u.$FW)(l):null}async computeDefaultDocumentColors(r){const l=this.j(r);return l?(0,_.$ZW)(l):null}async textualSuggest(r,l,R,f){const w=new E.$1c,N=new RegExp(R,f),b=new Set;e:for(const p of r){const F=this.j(p);if(F){for(const P of F.words(N))if(!(P===l||!isNaN(Number(P)))&&(b.add(P),b.size>M.p))break e}}return{words:Array.from(b),duration:w.elapsed()}}async computeWordRanges(r,l,R,f){const w=this.j(r);if(!w)return Object.create(null);const N=new RegExp(R,f),b=Object.create(null);for(let p=l.startLineNumber;p<l.endLineNumber;p++){const F=w.getLineWords(p,N);for(const P of F){if(!isNaN(Number(P.word)))continue;let v=b[P.word];v||(v=[],b[P.word]=v),v.push({startLineNumber:p,startColumn:P.startColumn,endLineNumber:p,endColumn:P.endColumn})}}return b}async navigateValueSet(r,l,R,f,w){const N=this.j(r);if(!N)return null;const b=new RegExp(f,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const p=N.getValueInRange(l),F=N.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},b);if(!F)return null;const P=N.getValueInRange(F);return s.$GW.INSTANCE.navigateValueSet(l,p,F,P,R)}loadForeignModule(r,l,R){const f=(b,p)=>this.d.fhr(b,p),N={host:(0,A.$Pm)(R,f),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(N,l),Promise.resolve((0,A.$Om)(this.h))):new Promise((b,p)=>{j([r],F=>{this.h=F.create(N,l),b((0,A.$Om)(this.h))},p)})}fmr(r,l){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,l))}catch(R){return Promise.reject(R)}}}t.EditorSimpleWorker=M,M.o=1e5,M.p=1e4;function g(m){return new M(m,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,c.$IW)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
