"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/objects","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/server/node/serverEnvironmentService","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","vs/base/common/hash","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],we=function(ae){for(var e=[],y=0,O=ae.length;y<O;y++)e[y]=be[ae[y]];return e};define(be[140],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R=void 0;class y{static get(){const a=new Map,I=new Map,L=new Map,R=new Map;function b(h,m){h.has(m.detail)||h.set(m.detail,-m.timestamp)}function d(h,m){const $=h.get(m.detail);$&&($>=0||h.set(m.detail,$+m.timestamp))}let P=[];typeof ae.getStats=="function"&&(P=ae.getStats().slice(0).sort((h,m)=>h.timestamp-m.timestamp));for(const h of P)switch(h.type){case 10:b(a,h);break;case 11:case 12:d(a,h);break;case 21:b(I,h);break;case 22:d(I,h);break;case 33:b(L,h);break;case 34:d(L,h);break;case 31:b(R,h);break;case 32:d(R,h);break}let p=0;L.forEach(h=>p+=h);function w(h){const m=[];return h.forEach(($,o)=>m.push([o,$])),m}return{amdLoad:w(a),amdInvoke:w(I),nodeRequire:w(L),nodeEval:w(R),nodeRequireTotal:p}}static toMarkdownTable(a,I){let L="";const R=[];return a.forEach((b,d)=>{R[d]=b.length}),I.forEach(b=>{b.forEach((d,P)=>{typeof d>"u"&&(d=b[P]="-");const p=d.toString().length;R[P]=Math.max(p,R[P])})}),a.forEach((b,d)=>{L+=`| ${b+" ".repeat(R[d]-b.toString().length)} `}),L+=`|
`,a.forEach((b,d)=>{L+=`| ${"-".repeat(R[d])} `}),L+=`|
`,I.forEach(b=>{b.forEach((d,P)=>{typeof d<"u"&&(L+=`| ${d+" ".repeat(R[P]-d.toString().length)} `)}),L+=`|
`}),L}}e.$R=y}),define(be[93],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function y(L){return(R,b,d)=>{let P=null,p=null;if(typeof d.value=="function"?(P="value",p=d.value):typeof d.get=="function"&&(P="get",p=d.get),!p)throw new Error("not supported");d[P]=L(p,b)}}function O(L,R,b){let d=null,P=null;if(typeof b.value=="function"?(d="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(d="get",P=b.get),!P)throw new Error("not supported");const p=`$memoize$${R}`;b[d]=function(...w){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,w)}),this[p]}}e.$Pg=O;function a(L,R,b){return y((d,P)=>{const p=`$debounce$${P}`,w=`$debounce$result$${P}`;return function(...h){this[w]||(this[w]=b?b():void 0),clearTimeout(this[p]),R&&(this[w]=R(this[w],...h),h=[this[w]]),this[p]=setTimeout(()=>{d.apply(this,h),this[w]=b?b():void 0},L)}})}e.$Qg=a;function I(L,R,b){return y((d,P)=>{const p=`$throttle$timer$${P}`,w=`$throttle$result$${P}`,h=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...$){if(this[w]||(this[w]=b?b():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...$)),this[m])return;const o=this[h]+L;o<=Date.now()?(this[h]=Date.now(),d.apply(this,[this[w]]),this[w]=b?b():void 0):(this[m]=!0,this[p]=setTimeout(()=>{this[m]=!1,this[h]=Date.now(),d.apply(this,[this[w]]),this[w]=b?b():void 0},o-Date.now()))}})}e.$Rg=I}),define(be[11],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.$W=e.setUnexpectedErrorHandler=e.$U=e.$T=void 0;class y{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?D.isErrorNoTelemetry(i)?new D(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$T=y,e.$U=new y;function O(t){e.$U.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function a(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$W=a;function I(t){d(t)||e.$U.onUnexpectedError(t)}e.$X=I;function L(t){d(t)||e.$U.onUnexpectedExternalError(t)}e.$Y=L;function R(t){if(t instanceof Error){const{name:i,message:r}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.$Z=R;const b="Canceled";function d(t){return t instanceof P?!0:t instanceof Error&&t.name===b&&t.message===b}e.$1=d;class P extends Error{constructor(){super(b),this.name=this.message}}e.$2=P;function p(){const t=new Error(b);return t.name=t.message,t}e.$3=p;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$4=w;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$5=h;function m(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$6=m;function $(t){const i=new Error(`${t} has been disposed`);return i.name="DISPOSED",i}e.$7=$;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$8=o;class u extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$9=u;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$0=l;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=g;class D extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof D)return i;const r=new D;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$_=D;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(be[18],we([1,0,11]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function O(z,q=0){return z[z.length-(1+q)]}e.$9e=O;function a(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$0e=a;function I(z,q,W=(U,X)=>U===X){if(z===q)return!0;if(!z||!q||z.length!==q.length)return!1;for(let U=0,X=z.length;U<X;U++)if(!W(z[U],q[U]))return!1;return!0}e.$$e=I;function L(z,q){const W=z.length-1;q<W&&(z[q]=z[W]),z.pop()}e.$_e=L;function R(z,q,W){return b(z.length,U=>W(z[U],q))}e.$af=R;function b(z,q){let W=0,U=z-1;for(;W<=U;){const X=(W+U)/2|0,G=q(X);if(G<0)W=X+1;else if(G>0)U=X-1;else return X}return-(W+1)}e.$bf=b;function d(z,q){let W=0,U=z.length;if(U===0)return 0;for(;W<U;){const X=Math.floor((W+U)/2);q(z[X])?U=X:W=X+1}return W}e.$cf=d;function P(z,q,W){if(z=z|0,z>=q.length)throw new TypeError("invalid index");const U=q[Math.floor(q.length*Math.random())],X=[],G=[],Y=[];for(const ue of q){const pe=W(ue,U);pe<0?X.push(ue):pe>0?G.push(ue):Y.push(ue)}return z<X.length?P(z,X,W):z<X.length+Y.length?Y[0]:P(z-(X.length+Y.length),G,W)}e.$df=P;function p(z,q){const W=[];let U;for(const X of z.slice(0).sort(q))!U||q(U[0],X)!==0?(U=[X],W.push(U)):U.push(X);return W}e.$ef=p;function w(z,q,W){const U=[];function X(ue,pe,Se){if(pe===0&&Se.length===0)return;const Ce=U[U.length-1];Ce&&Ce.start+Ce.deleteCount===ue?(Ce.deleteCount+=pe,Ce.toInsert.push(...Se)):U.push({start:ue,deleteCount:pe,toInsert:Se})}let G=0,Y=0;for(;;){if(G===z.length){X(G,0,q.slice(Y));break}if(Y===q.length){X(G,z.length-G,[]);break}const ue=z[G],pe=q[Y],Se=W(ue,pe);Se===0?(G+=1,Y+=1):Se<0?(X(G,1,[]),G+=1):Se>0&&(X(G,0,[pe]),Y+=1)}return U}e.$ff=w;function h(z,q,W){const U=w(z,q,W),X=[],G=[];for(const Y of U)X.push(...z.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:X,added:G}}e.$gf=h;function m(z,q,W){if(W===0)return[];const U=z.slice(0,W).sort(q);return o(z,q,U,W,z.length),U}e.top=m;function $(z,q,W,U,X){return W===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const ue=z.length,pe=z.slice(0,W).sort(q);for(let Se=W,Ce=Math.min(W+U,ue);Se<ue;Se=Ce,Ce=Math.min(Ce+U,ue)){if(Se>W&&await new Promise(Fe=>setTimeout(Fe)),X&&X.isCancellationRequested)throw new y.$2;o(z,q,pe,Se,Ce)}return pe})().then(G,Y)})}e.$if=$;function o(z,q,W,U,X){for(const G=W.length;U<X;U++){const Y=z[U];if(q(Y,W[G-1])<0){W.pop();const ue=d(W,pe=>q(Y,pe)<0);W.splice(ue,0,Y)}}}function u(z){return z.filter(q=>!!q)}e.$jf=u;function l(z){let q=0;for(let W=0;W<z.length;W++)z[W]&&(z[q]=z[W],q+=1);z.length=q}e.$kf=l;function g(z,q,W){z.splice(W,0,z.splice(q,1)[0])}e.$lf=g;function D(z){return!Array.isArray(z)||z.length===0}e.$mf=D;function E(z){return Array.isArray(z)&&z.length>0}e.$nf=E;function t(z,q=W=>W){const W=new Set;return z.filter(U=>{const X=q(U);return W.has(X)?!1:(W.add(X),!0)})}e.$of=t;function i(z){const q=new Set;return W=>{const U=z(W);return q.has(U)?!1:(q.add(U),!0)}}e.$pf=i;function r(z,q){const W=n(z,q);if(W!==-1)return z[W]}e.$qf=r;function n(z,q){for(let W=z.length-1;W>=0;W--){const U=z[W];if(q(U))return W}return-1}e.$rf=n;function s(z,q){return z.length>0?z[0]:q}e.$sf=s;function c(z,q){return z.length>0?z[z.length-1]:q}e.$tf=c;function f(z,q,W=(U,X)=>U===X){let U=0;for(let X=0,G=Math.min(z.length,q.length);X<G&&W(z[X],q[X]);X++)U++;return U}e.$uf=f;function k(z){return[].concat(...z)}e.$vf=k;function v(z,q){let W=typeof q=="number"?z:0;typeof q=="number"?W=z:(W=0,q=z);const U=[];if(W<=q)for(let X=W;X<q;X++)U.push(X);else for(let X=W;X>q;X--)U.push(X);return U}e.$wf=v;function C(z,q,W){return z.reduce((U,X)=>(U[q(X)]=W?W(X):X,U),Object.create(null))}e.$xf=C;function A(z,q){return z.push(q),()=>M(z,q)}e.$yf=A;function M(z,q){const W=z.indexOf(q);if(W>-1)return z.splice(W,1),q}e.$zf=M;function K(z,q,W){const U=z.slice(0,q),X=z.slice(q);return U.concat(W,X)}e.$Af=K;function te(z,q){let W;if(typeof q=="number"){let U=q;W=()=>{const X=Math.sin(U++)*179426549;return X-Math.floor(X)}}else W=Math.random;for(let U=z.length-1;U>0;U-=1){const X=Math.floor(W()*(U+1)),G=z[U];z[U]=z[X],z[X]=G}}e.$Bf=te;function he(z,q){const W=z.indexOf(q);W>-1&&(z.splice(W,1),z.unshift(q))}e.$Cf=he;function ce(z,q){const W=z.indexOf(q);W>-1&&(z.splice(W,1),z.push(q))}e.$Df=ce;function le(z,q){for(const W of q)z.push(W)}e.$Ef=le;function ge(z,q){return Array.isArray(z)?z.map(q):q(z)}e.$Ff=ge;function se(z){return Array.isArray(z)?z:[z]}e.$Gf=se;function V(z){return z[Math.floor(Math.random()*z.length)]}e.$Hf=V;function ie(z,q){for(const W of z){const U=q(W);if(U!==void 0)return U}}e.$If=ie;function J(z,q,W){const U=H(z,q),X=z.length,G=W.length;z.length=X+G;for(let Y=X-1;Y>=U;Y--)z[Y+G]=z[Y];for(let Y=0;Y<G;Y++)z[Y+U]=W[Y]}e.$Jf=J;function Z(z,q,W,U){const X=H(z,q),G=z.splice(X,W);return J(z,X,U),G}e.$Kf=Z;function H(z,q){return q<0?Math.max(q+z.length,0):Math.min(q,z.length)}var B;(function(z){function q(X){return X<0}z.isLessThan=q;function W(X){return X>0}z.isGreaterThan=W;function U(X){return X===0}z.isNeitherLessOrGreaterThan=U,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function ne(z,q){return(W,U)=>q(z(W),z(U))}e.$Lf=ne;function Q(...z){return(q,W)=>{for(const U of z){const X=U(q,W);if(!B.isNeitherLessOrGreaterThan(X))return X}return B.neitherLessOrGreaterThan}}e.$Mf=Q;const _=(z,q)=>z-q;e.$Nf=_;function T(z,q){if(z.length===0)return;let W=z[0];for(let U=1;U<z.length;U++){const X=z[U];q(X,W)>0&&(W=X)}return W}e.$Of=T;function S(z,q){if(z.length===0)return;let W=z[0];for(let U=1;U<z.length;U++){const X=z[U];q(X,W)>=0&&(W=X)}return W}e.$Pf=S;function F(z,q){return T(z,(W,U)=>-q(W,U))}e.$Qf=F;class ee{constructor(q){this.f=q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(q){let W=this.c;for(;W<this.f.length&&q(this.f[W]);)W++;const U=W===this.c?null:this.f.slice(this.c,W);return this.c=W,U}takeFromEndWhile(q){let W=this.d;for(;W>=0&&q(this.f[W]);)W--;const U=W===this.d?null:this.f.slice(W+1,this.d+1);return this.d=W,U}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const q=this.f[this.c];return this.c++,q}removeLast(){const q=this.f[this.d];return this.d--,q}takeCount(q){const W=this.f.slice(this.c,this.c+q);return this.c+=q,W}}e.$Rf=ee;class oe{constructor(q){this.iterate=q}forEach(q){this.iterate(W=>(q(W),!0))}toArray(){const q=[];return this.iterate(W=>(q.push(W),!0)),q}filter(q){return new oe(W=>this.iterate(U=>q(U)?W(U):!0))}map(q){return new oe(W=>this.iterate(U=>W(q(U))))}some(q){let W=!1;return this.iterate(U=>(W=q(U),!W)),W}findFirst(q){let W;return this.iterate(U=>q(U)?(W=U,!1):!0),W}findLast(q){let W;return this.iterate(U=>(q(U)&&(W=U),!0)),W}findLastMaxBy(q){let W,U=!0;return this.iterate(X=>((U||B.isGreaterThan(q(X,W)))&&(U=!1,W=X),!0)),W}}e.$Sf=oe,oe.empty=new oe(z=>{})}),define(be[94],we([1,0,11]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.$nc=e.$mc=e.$lc=e.ok=void 0;function O(b,d){if(!b)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=O;function a(b,d="Unreachable"){throw new Error(d)}e.$lc=a;function I(b){if(!b)throw new y.$ab("Assertion Failed")}e.$mc=I;function L(b){if(!b()){debugger;b(),(0,y.$X)(new y.$ab("Assertion Failed"))}}e.$nc=L;function R(b,d){let P=0;for(;P<b.length-1;){const p=b[P],w=b[P+1];if(!d(p,w))return!1;P++}return!0}e.$oc=R}),define(be[71],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function y(O){const a=this;let I=!1,L;return function(){return I||(I=!0,L=O.apply(a,arguments)),L}}e.$bb=y}),define(be[46],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(O){function a(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}O.is=a;const I=Object.freeze([]);function L(){return I}O.empty=L;function*R(D){yield D}O.single=R;function b(D){return a(D)?D:R(D)}O.wrap=b;function d(D){return D||I}O.from=d;function P(D){return!D||D[Symbol.iterator]().next().done===!0}O.isEmpty=P;function p(D){return D[Symbol.iterator]().next().value}O.first=p;function w(D,E){for(const t of D)if(E(t))return!0;return!1}O.some=w;function h(D,E){for(const t of D)if(E(t))return t}O.find=h;function*m(D,E){for(const t of D)E(t)&&(yield t)}O.filter=m;function*$(D,E){let t=0;for(const i of D)yield E(i,t++)}O.map=$;function*o(...D){for(const E of D)for(const t of E)yield t}O.concat=o;function u(D,E,t){let i=t;for(const r of D)i=E(i,r);return i}O.reduce=u;function*l(D,E,t=D.length){for(E<0&&(E+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);E<t;E++)yield D[E]}O.slice=l;function g(D,E=Number.POSITIVE_INFINITY){const t=[];if(E===0)return[t,D];const i=D[Symbol.iterator]();for(let r=0;r<E;r++){const n=i.next();if(n.done)return[t,O.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return i}}]}O.consume=g})(y||(e.Iterable=y={}))}),define(be[72],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var a;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(a||(e.ParseErrorCode=a={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function L(t,i=!1){let r=0;const n=t.length;let s="",c=0,f=16,k=0;function v(ce){let le=0,ge=0;for(;le<ce;){const se=t.charCodeAt(r);if(se>=48&&se<=57)ge=ge*16+se-48;else if(se>=65&&se<=70)ge=ge*16+se-65+10;else if(se>=97&&se<=102)ge=ge*16+se-97+10;else break;r++,le++}return le<ce&&(ge=-1),ge}function C(ce){r=ce,s="",c=0,f=16,k=0}function A(){const ce=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&d(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&d(t.charCodeAt(r)))for(r++;r<t.length&&d(t.charCodeAt(r));)r++;else return k=3,t.substring(ce,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&d(t.charCodeAt(r))){for(r++;r<t.length&&d(t.charCodeAt(r));)r++;le=r}else k=3;return t.substring(ce,le)}function M(){let ce="",le=r;for(;;){if(r>=n){ce+=t.substring(le,r),k=2;break}const ge=t.charCodeAt(r);if(ge===34){ce+=t.substring(le,r),r++;break}if(ge===92){if(ce+=t.substring(le,r),r++,r>=n){k=2;break}switch(t.charCodeAt(r++)){case 34:ce+='"';break;case 92:ce+="\\";break;case 47:ce+="/";break;case 98:ce+="\b";break;case 102:ce+="\f";break;case 110:ce+=`
`;break;case 114:ce+="\r";break;case 116:ce+="	";break;case 117:{const V=v(4);V>=0?ce+=String.fromCharCode(V):k=4;break}default:k=5}le=r;continue}if(ge>=0&&ge<=31)if(b(ge)){ce+=t.substring(le,r),k=2;break}else k=6;r++}return ce}function K(){if(s="",k=0,c=r,r>=n)return c=n,f=17;let ce=t.charCodeAt(r);if(R(ce)){do r++,s+=String.fromCharCode(ce),ce=t.charCodeAt(r);while(R(ce));return f=15}if(b(ce))return r++,s+=String.fromCharCode(ce),ce===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),f=14;switch(ce){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,s=M(),f=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!b(t.charCodeAt(r));)r++;return s=t.substring(le,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const ge=n-1;let se=!1;for(;r<ge;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,se=!0;break}r++}return se||(r++,k=1),s=t.substring(le,r),f=13}return s+=String.fromCharCode(ce),r++,f=16}case 45:if(s+=String.fromCharCode(ce),r++,r===n||!d(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),f=11;default:for(;r<n&&te(ce);)r++,ce=t.charCodeAt(r);if(c!==r){switch(s=t.substring(c,r),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(ce),r++,f=16}}function te(ce){if(R(ce)||b(ce))return!1;switch(ce){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let ce;do ce=K();while(ce>=12&&ce<=15);return ce}return{setPosition:C,getPosition:()=>r,scan:i?he:K,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>k}}e.$sm=L;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function p(t,i){const r=[],n=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function k(v,C,A,M){c.value=v,c.offset=C,c.length=A,c.type=M,c.colonOffset=void 0,s=c}try{g(t,{onObjectBegin:(v,C)=>{if(i<=v)throw n;s=void 0,f=i>v,r.push("")},onObjectProperty:(v,C,A)=>{if(i<C||(k(v,C,A,"property"),r[r.length-1]=v,i<=C+A))throw n},onObjectEnd:(v,C)=>{if(i<=v)throw n;s=void 0,r.pop()},onArrayBegin:(v,C)=>{if(i<=v)throw n;s=void 0,r.push(0)},onArrayEnd:(v,C)=>{if(i<=v)throw n;s=void 0,r.pop()},onLiteralValue:(v,C,A)=>{if(i<C||(k(v,C,A,E(v)),i<=C+A))throw n},onSeparator:(v,C,A)=>{if(i<=C)throw n;if(v===":"&&s&&s.type==="property")s.colonOffset=C,f=!1,s=void 0;else if(v===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(f=!0,r[r.length-1]=""),s=void 0}}})}catch(v){if(v!==n)throw v}return{path:r,previousNode:s,isAtPropertyKey:f,matches:v=>{let C=0;for(let A=0;C<v.length&&A<r.length;A++)if(v[C]===r[A]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}e.$tm=p;function w(t,i=[],r=I.DEFAULT){let n=null,s=[];const c=[];function f(v){Array.isArray(s)?s.push(v):n!==null&&(s[n]=v)}return g(t,{onObjectBegin:()=>{const v={};f(v),c.push(s),s=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const v=[];f(v),c.push(s),s=v,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:f,onError:(v,C,A)=>{i.push({error:v,offset:C,length:A})}},r),s[0]}e.$um=w;function h(t,i=[],r=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function c(v){return n.children.push(v),v}g(t,{onObjectBegin:v=>{n=c({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,C,A)=>{n=c({type:"property",offset:C,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:C,length:A,parent:n})},onObjectEnd:(v,C)=>{n.length=v+C-n.offset,n=n.parent,s(v+C)},onArrayBegin:(v,C)=>{n=c({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,C)=>{n.length=v+C-n.offset,n=n.parent,s(v+C)},onLiteralValue:(v,C,A)=>{c({type:E(v),offset:C,length:A,parent:n,value:v}),s(C+A)},onSeparator:(v,C,A)=>{n.type==="property"&&(v===":"?n.colonOffset=C:v===","&&s(C))},onError:(v,C,A)=>{i.push({error:v,offset:C,length:A})}},r);const k=n.children[0];return k&&delete k.parent,k}e.$vm=h;function m(t,i){if(!t)return;let r=t;for(const n of i)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===n){r=c.children[1],s=!0;break}if(!s)return}else{const s=n;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.$wm=m;function $(t){if(!t.parent||!t.parent.children)return[];const i=$(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;i.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&i.push(r)}return i}e.$xm=$;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const i=Object.create(null);for(const r of t.children){const n=r.children[1];n&&(i[r.children[0].value]=o(n))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$ym=o;function u(t,i,r=!1){return i>=t.offset&&i<t.offset+t.length||r&&i===t.offset+t.length}e.$zm=u;function l(t,i,r=!1){if(u(t,i,r)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=i;s++){const c=l(n[s],i,r);if(c)return c}return t}}e.$Am=l;function g(t,i,r=I.DEFAULT){const n=L(t,!1);function s(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(ne){return ne?Q=>ne(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=s(i.onObjectBegin),k=c(i.onObjectProperty),v=s(i.onObjectEnd),C=s(i.onArrayBegin),A=s(i.onArrayEnd),M=c(i.onLiteralValue),K=c(i.onSeparator),te=s(i.onComment),he=c(i.onError),ce=r&&r.disallowComments,le=r&&r.allowTrailingComma;function ge(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ce||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(ne){case 12:case 13:ce?se(10):te();break;case 16:se(1);break;case 15:case 14:break;default:return ne}}}function se(ne,Q=[],_=[]){if(he(ne),Q.length+_.length>0){let T=n.getToken();for(;T!==17;){if(Q.indexOf(T)!==-1){ge();break}else if(_.indexOf(T)!==-1)break;T=ge()}}}function V(ne){const Q=n.getTokenValue();return ne?M(Q):k(Q),ge(),!0}function ie(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(se(2),ne=0)}catch{se(2)}M(ne);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ge(),!0}function J(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(K(":"),ge(),B()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function Z(){f(),ge();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||se(4,[],[]),K(","),ge(),n.getToken()===2&&le)break}else ne&&se(6,[],[]);J()||se(4,[],[2,5]),ne=!0}return v(),n.getToken()!==2?se(7,[2],[]):ge(),!0}function H(){C(),ge();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||se(4,[],[]),K(","),ge(),n.getToken()===4&&le)break}else ne&&se(6,[],[]);B()||se(4,[],[4,5]),ne=!0}return A(),n.getToken()!==4?se(8,[4],[]):ge(),!0}function B(){switch(n.getToken()){case 3:return H();case 1:return Z();case 10:return V(!0);default:return ie()}}return ge(),n.getToken()===17?r.allowEmptyContent?!0:(se(4,[],[]),!1):B()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.$Bm=g;function D(t,i){const r=L(t),n=[];let s,c=0,f;do switch(f=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:c!==f&&n.push(t.substring(c,f)),i!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,i)),c=r.getPosition();break}while(s!==17);return n.join("")}e.$Cm=D;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Dm=E}),define(be[95],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=void 0;class y{constructor(a){this.d=a,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(a){this.c=a}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$S=y}),define(be[2],we([1,0,71,46]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const a=!1;let I=null;function L(c){I=c}if(e.$cb=L,a){const c="__is_disposable_tracked__";L(new class{trackDisposable(f){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[c]||console.log(k)},3e3)}setParent(f,k){if(f&&f!==l.None)try{f[c]=!0}catch{}}markAsDisposed(f){if(f&&f!==l.None)try{f[c]=!0}catch{}}markAsSingleton(f){}})}function R(c){return I?.trackDisposable(c),c}function b(c){I?.markAsDisposed(c)}function d(c,f){I?.setParent(c,f)}function P(c,f){if(I)for(const k of c)I.setParent(k,f)}function p(c){return I?.markAsSingleton(c),c}e.$db=p;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.$eb=w;function h(c){if(O.Iterable.is(c)){const f=[];for(const k of c)if(k)try{k.dispose()}catch(v){f.push(v)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.$fb=h;function m(c){for(const f of c)w(f)&&f.dispose();return[]}e.$gb=m;function $(...c){const f=o(()=>h(c));return P(c,f),f}e.$hb=$;function o(c){const f=R({dispose:(0,y.$bb)(()=>{b(f),c()})});return f}e.$ib=o;class u{constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return d(f,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}}e.$jb=u,u.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this.q=new u,R(this),d(this.q,this)}dispose(){b(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$kb=l,l.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&d(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&d(f,null),f}}e.$lb=g;class D{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mb=D;class E{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(f){let k=f;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,b(this))},this}}e.$nb=E;class t{constructor(){this.a=new Map}acquire(f,...k){let v=this.a.get(f);v||(v={counter:0,object:this.b(f,...k)},this.a.set(f,v));const{object:C}=v,A=(0,y.$bb)(()=>{--v.counter===0&&(this.c(f,v.object),this.a.delete(f))});return v.counter++,{object:C,dispose:A}}}e.$ob=t;class i{constructor(f){this.a=f}async acquire(f,...k){const v=this.a.acquire(f,...k);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(C){throw v.dispose(),C}}}e.$pb=i;class r{constructor(f){this.object=f}dispose(){}}e.$qb=r;function n(c){const f=new u;try{c(f)}finally{f.dispose()}}e.$rb=n;class s{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,k,v=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||this.a.get(f)?.dispose(),this.a.set(f,k)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sb=s}),define(be[96],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=void 0;class y{constructor(I){this.element=I,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class O{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let I=this.a;for(;I!==y.Undefined;){const L=I.next;I.prev=y.Undefined,I.next=y.Undefined,I=L}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,L){const R=new y(I);if(this.a===y.Undefined)this.a=R,this.b=R;else if(L){const d=this.b;this.b=R,R.prev=d,d.next=R}else{const d=this.a;this.a=R,R.next=d,d.prev=R}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(R))}}shift(){if(this.a!==y.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==y.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==y.Undefined&&I.next!==y.Undefined){const L=I.prev;L.next=I.next,I.next.prev=L}else I.prev===y.Undefined&&I.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):I.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):I.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==y.Undefined;)yield I.element,I=I.next}}e.$jc=O}),define(be[28],we([1,0]),function(ae,e){"use strict";var y,O,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.Touch=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;function I($,o,u){let l=$.get(o);return l===void 0&&(l=u,$.set(o,l)),l}e.$gi=I;function L($){const o=[];return $.forEach((u,l)=>{o.push(`${l} => ${u}`)}),`Map(${$.size}) {${o.join(", ")}}`}e.$hi=L;function R($){const o=[];return $.forEach(u=>{o.push(u)}),`Set(${$.size}) {${o.join(", ")}}`}e.$ii=R;class b{constructor(o,u){this.uri=o,this.value=u}}class d{constructor(o,u){this[y]="ResourceMap",o instanceof d?(this.b=new Map(o.b),this.c=u??d.a):(this.b=new Map,this.c=o??d.a)}set(o,u){return this.b.set(this.c(o),new b(o,u)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,u){typeof u<"u"&&(o=o.bind(u));for(const[l,g]of this.b)o(g.value,g.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$ji=d,d.a=$=>$.toString();class P{constructor(o,u){this[O]="ResourceSet",!o||typeof o=="function"?this.a=new d(o):(this.a=new d(u),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,u){this.a.forEach((l,g)=>o.call(u,g,g,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$ki=P;var p;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class w{constructor(){this[a]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,u=0){const l=this.a.get(o);if(l)return u!==0&&this.j(l,u),l.value}set(o,u,l=0){let g=this.a.get(o);if(g)g.value=u,l!==0&&this.j(g,l);else{switch(g={key:o,value:u,next:void 0,previous:void 0},l){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(o,g),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const u=this.a.get(o);if(u)return this.a.delete(o),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,u){const l=this.e;let g=this.b;for(;g;){if(u?o.bind(u)(g.value,g.key,this):o(g.value,g.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const o=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(o.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.key,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return g}values(){const o=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(o.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.value,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return g}entries(){const o=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(o.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:[l.key,l.value],done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return g}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let u=this.b,l=this.size;for(;u&&l>o;)this.a.delete(u.key),u=u.next,l--;this.b=u,this.d=l,u&&(u.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const u=o.next,l=o.previous;if(!u||!l)throw new Error("Invalid list");u.previous=l,l.next=u}o.next=void 0,o.previous=void 0,this.e++}j(o,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(o===this.b)return;const l=o.next,g=o.previous;o===this.c?(g.next=void 0,this.c=g):(l.previous=g,g.next=l),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(u===2){if(o===this.c)return;const l=o.next,g=o.previous;o===this.b?(l.previous=void 0,this.b=l):(l.previous=g,g.next=l),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((u,l)=>{o.push([l,u])}),o}fromJSON(o){this.clear();for(const[u,l]of o)this.set(u,l)}}e.$li=w;class h extends w{constructor(o,u=1){super(),this.k=o,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,u=2){return super.get(o,u)}peek(o){return super.get(o,0)}set(o,u){return super.set(o,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$mi=h;class m{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let u=this.a.get(o)||0;return u===0?!1:(u--,u===0?this.a.delete(o):this.a.set(o,u),!0)}has(o){return this.a.has(o)}}e.$ni=m}),function(ae,e){typeof define=="function"&&define.amd?define(be[141],we([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(z,q){for(var W=0;W<q.length;W++){var U=q[W];U.enumerable=U.enumerable||!1,U.configurable=!0,"value"in U&&(U.writable=!0),Object.defineProperty(z,U.key,U)}}function y(z,q,W){return q&&e(z.prototype,q),W&&e(z,W),Object.defineProperty(z,"prototype",{writable:!1}),z}function O(z,q){if(z){if(typeof z=="string")return a(z,q);var W=Object.prototype.toString.call(z).slice(8,-1);if(W==="Object"&&z.constructor&&(W=z.constructor.name),W==="Map"||W==="Set")return Array.from(z);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return a(z,q)}}function a(z,q){(q==null||q>z.length)&&(q=z.length);for(var W=0,U=new Array(q);W<q;W++)U[W]=z[W];return U}function I(z,q){var W=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(W)return(W=W.call(z)).next.bind(W);if(Array.isArray(z)||(W=O(z))||q&&z&&typeof z.length=="number"){W&&(z=W);var U=0;return function(){return U>=z.length?{done:!0}:{done:!1,value:z[U++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=L();function R(z){ae.defaults=z}var b=/[&<>"']/,d=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,p=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(q){return w[q]};function m(z,q){if(q){if(b.test(z))return z.replace(d,h)}else if(P.test(z))return z.replace(p,h);return z}var $=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(z){return z.replace($,function(q,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var u=/(^|[^\[])\^/g;function l(z,q){z=typeof z=="string"?z:z.source,q=q||"";var W={replace:function(X,G){return G=G.source||G,G=G.replace(u,"$1"),z=z.replace(X,G),W},getRegex:function(){return new RegExp(z,q)}};return W}var g=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(z,q,W){if(z){var U;try{U=decodeURIComponent(o(W)).replace(g,"").toLowerCase()}catch{return null}if(U.indexOf("javascript:")===0||U.indexOf("vbscript:")===0||U.indexOf("data:")===0)return null}q&&!D.test(W)&&(W=s(q,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var t={},i=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(z,q){t[" "+z]||(i.test(z)?t[" "+z]=z+"/":t[" "+z]=v(z,"/",!0)),z=t[" "+z];var W=z.indexOf(":")===-1;return q.substring(0,2)==="//"?W?q:z.replace(r,"$1")+q:q.charAt(0)==="/"?W?q:z.replace(n,"$1")+q:z+q}var c={exec:function(){}};function f(z){for(var q=1,W,U;q<arguments.length;q++){W=arguments[q];for(U in W)Object.prototype.hasOwnProperty.call(W,U)&&(z[U]=W[U])}return z}function k(z,q){var W=z.replace(/\|/g,function(G,Y,ue){for(var pe=!1,Se=Y;--Se>=0&&ue[Se]==="\\";)pe=!pe;return pe?"|":" |"}),U=W.split(/ \|/),X=0;if(U[0].trim()||U.shift(),U.length>0&&!U[U.length-1].trim()&&U.pop(),U.length>q)U.splice(q);else for(;U.length<q;)U.push("");for(;X<U.length;X++)U[X]=U[X].trim().replace(/\\\|/g,"|");return U}function v(z,q,W){var U=z.length;if(U===0)return"";for(var X=0;X<U;){var G=z.charAt(U-X-1);if(G===q&&!W)X++;else if(G!==q&&W)X++;else break}return z.slice(0,U-X)}function C(z,q){if(z.indexOf(q[1])===-1)return-1;for(var W=z.length,U=0,X=0;X<W;X++)if(z[X]==="\\")X++;else if(z[X]===q[0])U++;else if(z[X]===q[1]&&(U--,U<0))return X;return-1}function A(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(z,q){if(q<1)return"";for(var W="";q>1;)q&1&&(W+=z),q>>=1,z+=z;return W+z}function K(z,q,W,U){var X=q.href,G=q.title?m(q.title):null,Y=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){U.state.inLink=!0;var ue={type:"link",raw:W,href:X,title:G,text:Y,tokens:U.inlineTokens(Y)};return U.state.inLink=!1,ue}return{type:"image",raw:W,href:X,title:G,text:m(Y)}}function te(z,q){var W=z.match(/^(\s+)(?:```)/);if(W===null)return q;var U=W[1];return q.split(`
`).map(function(X){var G=X.match(/^\s+/);if(G===null)return X;var Y=G[0];return Y.length>=U.length?X.slice(U.length):X}).join(`
`)}var he=function(){function z(W){this.options=W||ae.defaults}var q=z.prototype;return q.space=function(U){var X=this.rules.block.newline.exec(U);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},q.code=function(U){var X=this.rules.block.code.exec(U);if(X){var G=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?G:v(G,`
`)}}},q.fences=function(U){var X=this.rules.block.fences.exec(U);if(X){var G=X[0],Y=te(G,X[3]||"");return{type:"code",raw:G,lang:X[2]?X[2].trim():X[2],text:Y}}},q.heading=function(U){var X=this.rules.block.heading.exec(U);if(X){var G=X[2].trim();if(/#$/.test(G)){var Y=v(G,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(G=Y.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:G,tokens:this.lexer.inline(G)}}},q.hr=function(U){var X=this.rules.block.hr.exec(U);if(X)return{type:"hr",raw:X[0]}},q.blockquote=function(U){var X=this.rules.block.blockquote.exec(U);if(X){var G=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},q.list=function(U){var X=this.rules.block.list.exec(U);if(X){var G,Y,ue,pe,Se,Ce,Fe,ze,me,Ee,ye,je,Te=X[1].trim(),xe=Te.length>1,Be={type:"list",raw:"",ordered:xe,start:xe?+Te.slice(0,-1):"",loose:!1,items:[]};Te=xe?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=xe?Te:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");U&&(je=!1,!(!(X=Ze.exec(U))||this.rules.block.hr.test(U)));){if(G=X[0],U=U.substring(G.length),ze=X[2].split(`
`,1)[0],me=U.split(`
`,1)[0],this.options.pedantic?(pe=2,ye=ze.trimLeft()):(pe=X[2].search(/[^ ]/),pe=pe>4?1:pe,ye=ze.slice(pe),pe+=X[1].length),Ce=!1,!ze&&/^ *$/.test(me)&&(G+=me+`
`,U=U.substring(me.length+1),je=!0),!je)for(var Ye=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),Ge=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");U&&(Ee=U.split(`
`,1)[0],ze=Ee,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(ze)||Ge.test(ze)||Ye.test(ze)||it.test(U)));){if(ze.search(/[^ ]/)>=pe||!ze.trim())ye+=`
`+ze.slice(pe);else if(!Ce)ye+=`
`+ze;else break;!Ce&&!ze.trim()&&(Ce=!0),G+=Ee+`
`,U=U.substring(Ee.length+1)}Be.loose||(Fe?Be.loose=!0:/\n *\n *$/.test(G)&&(Fe=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(ye),Y&&(ue=Y[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:G,task:!!Y,checked:ue,loose:!1,text:ye}),Be.raw+=G}Be.items[Be.items.length-1].raw=G.trimRight(),Be.items[Be.items.length-1].text=ye.trimRight(),Be.raw=Be.raw.trimRight();var fe=Be.items.length;for(Se=0;Se<fe;Se++){this.lexer.state.top=!1,Be.items[Se].tokens=this.lexer.blockTokens(Be.items[Se].text,[]);var De=Be.items[Se].tokens.filter(function(Ie){return Ie.type==="space"}),Le=De.every(function(Ie){for(var Oe=Ie.raw.split(""),qe=0,He=I(Oe),Ke;!(Ke=He()).done;){var et=Ke.value;if(et===`
`&&(qe+=1),qe>1)return!0}return!1});!Be.loose&&De.length&&Le&&(Be.loose=!0,Be.items[Se].loose=!0)}return Be}},q.html=function(U){var X=this.rules.block.html.exec(U);if(X){var G={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var Y=this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]);G.type="paragraph",G.text=Y,G.tokens=this.lexer.inline(Y)}return G}},q.def=function(U){var X=this.rules.block.def.exec(U);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var G=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:X[0],href:X[2],title:X[3]}}},q.table=function(U){var X=this.rules.block.table.exec(U);if(X){var G={type:"table",header:k(X[1]).map(function(Fe){return{text:Fe}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=X[0];var Y=G.align.length,ue,pe,Se,Ce;for(ue=0;ue<Y;ue++)/^ *-+: *$/.test(G.align[ue])?G.align[ue]="right":/^ *:-+: *$/.test(G.align[ue])?G.align[ue]="center":/^ *:-+ *$/.test(G.align[ue])?G.align[ue]="left":G.align[ue]=null;for(Y=G.rows.length,ue=0;ue<Y;ue++)G.rows[ue]=k(G.rows[ue],G.header.length).map(function(Fe){return{text:Fe}});for(Y=G.header.length,pe=0;pe<Y;pe++)G.header[pe].tokens=this.lexer.inline(G.header[pe].text);for(Y=G.rows.length,pe=0;pe<Y;pe++)for(Ce=G.rows[pe],Se=0;Se<Ce.length;Se++)Ce[Se].tokens=this.lexer.inline(Ce[Se].text);return G}}},q.lheading=function(U){var X=this.rules.block.lheading.exec(U);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},q.paragraph=function(U){var X=this.rules.block.paragraph.exec(U);if(X){var G=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:G,tokens:this.lexer.inline(G)}}},q.text=function(U){var X=this.rules.block.text.exec(U);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},q.escape=function(U){var X=this.rules.inline.escape.exec(U);if(X)return{type:"escape",raw:X[0],text:m(X[1])}},q.tag=function(U){var X=this.rules.inline.tag.exec(U);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]):X[0]}},q.link=function(U){var X=this.rules.inline.link.exec(U);if(X){var G=X[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Y=v(G.slice(0,-1),"\\");if((G.length-Y.length)%2===0)return}else{var ue=C(X[2],"()");if(ue>-1){var pe=X[0].indexOf("!")===0?5:4,Se=pe+X[1].length+ue;X[2]=X[2].substring(0,ue),X[0]=X[0].substring(0,Se).trim(),X[3]=""}}var Ce=X[2],Fe="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);ze&&(Ce=ze[1],Fe=ze[3])}else Fe=X[3]?X[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(G)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),K(X,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},q.reflink=function(U,X){var G;if((G=this.rules.inline.reflink.exec(U))||(G=this.rules.inline.nolink.exec(U))){var Y=(G[2]||G[1]).replace(/\s+/g," ");if(Y=X[Y.toLowerCase()],!Y||!Y.href){var ue=G[0].charAt(0);return{type:"text",raw:ue,text:ue}}return K(G,Y,G[0],this.lexer)}},q.emStrong=function(U,X,G){G===void 0&&(G="");var Y=this.rules.inline.emStrong.lDelim.exec(U);if(Y&&!(Y[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Y[1]||Y[2]||"";if(!ue||ue&&(G===""||this.rules.inline.punctuation.exec(G))){var pe=Y[0].length-1,Se,Ce,Fe=pe,ze=0,me=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,X=X.slice(-1*U.length+pe);(Y=me.exec(X))!=null;)if(Se=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!Se){if(Ce=Se.length,Y[3]||Y[4]){Fe+=Ce;continue}else if((Y[5]||Y[6])&&pe%3&&!((pe+Ce)%3)){ze+=Ce;continue}if(Fe-=Ce,!(Fe>0)){if(Ce=Math.min(Ce,Ce+Fe+ze),Math.min(pe,Ce)%2){var Ee=U.slice(1,pe+Y.index+Ce);return{type:"em",raw:U.slice(0,pe+Y.index+Ce+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ye=U.slice(2,pe+Y.index+Ce-1);return{type:"strong",raw:U.slice(0,pe+Y.index+Ce+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},q.codespan=function(U){var X=this.rules.inline.code.exec(U);if(X){var G=X[2].replace(/\n/g," "),Y=/[^ ]/.test(G),ue=/^ /.test(G)&&/ $/.test(G);return Y&&ue&&(G=G.substring(1,G.length-1)),G=m(G,!0),{type:"codespan",raw:X[0],text:G}}},q.br=function(U){var X=this.rules.inline.br.exec(U);if(X)return{type:"br",raw:X[0]}},q.del=function(U){var X=this.rules.inline.del.exec(U);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},q.autolink=function(U,X){var G=this.rules.inline.autolink.exec(U);if(G){var Y,ue;return G[2]==="@"?(Y=m(this.options.mangle?X(G[1]):G[1]),ue="mailto:"+Y):(Y=m(G[1]),ue=Y),{type:"link",raw:G[0],text:Y,href:ue,tokens:[{type:"text",raw:Y,text:Y}]}}},q.url=function(U,X){var G;if(G=this.rules.inline.url.exec(U)){var Y,ue;if(G[2]==="@")Y=m(this.options.mangle?X(G[0]):G[0]),ue="mailto:"+Y;else{var pe;do pe=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(pe!==G[0]);Y=m(G[0]),G[1]==="www."?ue="http://"+Y:ue=Y}return{type:"link",raw:G[0],text:Y,href:ue,tokens:[{type:"text",raw:Y,text:Y}]}}},q.inlineText=function(U,X){var G=this.rules.inline.text.exec(U);if(G){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):m(G[0]):G[0]:Y=m(this.options.smartypants?X(G[0]):G[0]),{type:"text",raw:G[0],text:Y}}},z}(),ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=l(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=l(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=l(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=l(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=l(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=l(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=f({},ce),ce.gfm=f({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=l(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.gfm.paragraph=l(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ce.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=f({},ce.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:l(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var le={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};le._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",le.punctuation=l(le.punctuation).replace(/punctuation/g,le._punctuation).getRegex(),le.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,le.escapedEmSt=/\\\*|\\_/g,le._comment=l(ce._comment).replace("(?:-->|$)","-->").getRegex(),le.emStrong.lDelim=l(le.emStrong.lDelim).replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimAst=l(le.emStrong.rDelimAst,"g").replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimUnd=l(le.emStrong.rDelimUnd,"g").replace(/punct/g,le._punctuation).getRegex(),le._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,le._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,le._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,le.autolink=l(le.autolink).replace("scheme",le._scheme).replace("email",le._email).getRegex(),le._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,le.tag=l(le.tag).replace("comment",le._comment).replace("attribute",le._attribute).getRegex(),le._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,le._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,le._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,le.link=l(le.link).replace("label",le._label).replace("href",le._href).replace("title",le._title).getRegex(),le.reflink=l(le.reflink).replace("label",le._label).replace("ref",ce._label).getRegex(),le.nolink=l(le.nolink).replace("ref",ce._label).getRegex(),le.reflinkSearch=l(le.reflinkSearch,"g").replace("reflink",le.reflink).replace("nolink",le.nolink).getRegex(),le.normal=f({},le),le.pedantic=f({},le.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",le._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",le._label).getRegex()}),le.gfm=f({},le.normal,{escape:l(le.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),le.gfm.url=l(le.gfm.url,"i").replace("email",le.gfm._extended_email).getRegex(),le.breaks=f({},le.gfm,{br:l(le.br).replace("{2,}","*").getRegex(),text:l(le.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function se(z){var q="",W,U,X=z.length;for(W=0;W<X;W++)U=z.charCodeAt(W),Math.random()>.5&&(U="x"+U.toString(16)),q+="&#"+U+";";return q}var V=function(){function z(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||ae.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var U={block:ce.normal,inline:le.normal};this.options.pedantic?(U.block=ce.pedantic,U.inline=le.pedantic):this.options.gfm&&(U.block=ce.gfm,this.options.breaks?U.inline=le.breaks:U.inline=le.gfm),this.tokenizer.rules=U}z.lex=function(U,X){var G=new z(X);return G.lex(U)},z.lexInline=function(U,X){var G=new z(X);return G.inlineTokens(U)};var q=z.prototype;return q.lex=function(U){U=U.replace(/\r\n|\r/g,`
`),this.blockTokens(U,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},q.blockTokens=function(U,X){var G=this;X===void 0&&(X=[]),this.options.pedantic?U=U.replace(/\t/g,"    ").replace(/^ +$/gm,""):U=U.replace(/^( *)(\t+)/gm,function(Fe,ze,me){return ze+"    ".repeat(me.length)});for(var Y,ue,pe,Se;U;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(Y=Fe.call({lexer:G},U,X))?(U=U.substring(Y.raw.length),X.push(Y),!0):!1}))){if(Y=this.tokenizer.space(U)){U=U.substring(Y.raw.length),Y.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(Y);continue}if(Y=this.tokenizer.code(U)){U=U.substring(Y.raw.length),ue=X[X.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):X.push(Y);continue}if(Y=this.tokenizer.fences(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.heading(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.hr(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.blockquote(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.list(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.html(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.def(U)){U=U.substring(Y.raw.length),ue=X[X.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.lheading(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(pe=U,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,ze=U.slice(1),me=void 0;G.options.extensions.startBlock.forEach(function(Ee){me=Ee.call({lexer:this},ze),typeof me=="number"&&me>=0&&(Fe=Math.min(Fe,me))}),Fe<1/0&&Fe>=0&&(pe=U.substring(0,Fe+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(pe))){ue=X[X.length-1],Se&&ue.type==="paragraph"?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):X.push(Y),Se=pe.length!==U.length,U=U.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(U)){U=U.substring(Y.raw.length),ue=X[X.length-1],ue&&ue.type==="text"?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):X.push(Y);continue}if(U){var Ce="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,X},q.inline=function(U,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:U,tokens:X}),X},q.inlineTokens=function(U,X){var G=this;X===void 0&&(X=[]);var Y,ue,pe,Se=U,Ce,Fe,ze;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)me.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ce.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;U;)if(Fe||(ze=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Y=ye.call({lexer:G},U,X))?(U=U.substring(Y.raw.length),X.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.tag(U)){U=U.substring(Y.raw.length),ue=X[X.length-1],ue&&Y.type==="text"&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):X.push(Y);continue}if(Y=this.tokenizer.link(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.reflink(U,this.tokens.links)){U=U.substring(Y.raw.length),ue=X[X.length-1],ue&&Y.type==="text"&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):X.push(Y);continue}if(Y=this.tokenizer.emStrong(U,Se,ze)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.codespan(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.br(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.del(U)){U=U.substring(Y.raw.length),X.push(Y);continue}if(Y=this.tokenizer.autolink(U,se)){U=U.substring(Y.raw.length),X.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(U,se))){U=U.substring(Y.raw.length),X.push(Y);continue}if(pe=U,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=U.slice(1),Te=void 0;G.options.extensions.startInline.forEach(function(xe){Te=xe.call({lexer:this},je),typeof Te=="number"&&Te>=0&&(ye=Math.min(ye,Te))}),ye<1/0&&ye>=0&&(pe=U.substring(0,ye+1))}(),Y=this.tokenizer.inlineText(pe,ge)){U=U.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(ze=Y.raw.slice(-1)),Fe=!0,ue=X[X.length-1],ue&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):X.push(Y);continue}if(U){var Ee="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return X},y(z,null,[{key:"rules",get:function(){return{block:ce,inline:le}}}]),z}(),ie=function(){function z(W){this.options=W||ae.defaults}var q=z.prototype;return q.code=function(U,X,G){var Y=(X||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(U,Y);ue!=null&&ue!==U&&(G=!0,U=ue)}return U=U.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+m(Y,!0)+'">'+(G?U:m(U,!0))+`</code></pre>
`:"<pre><code>"+(G?U:m(U,!0))+`</code></pre>
`},q.blockquote=function(U){return`<blockquote>
`+U+`</blockquote>
`},q.html=function(U){return U},q.heading=function(U,X,G,Y){if(this.options.headerIds){var ue=this.options.headerPrefix+Y.slug(G);return"<h"+X+' id="'+ue+'">'+U+"</h"+X+`>
`}return"<h"+X+">"+U+"</h"+X+`>
`},q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},q.list=function(U,X,G){var Y=X?"ol":"ul",ue=X&&G!==1?' start="'+G+'"':"";return"<"+Y+ue+`>
`+U+"</"+Y+`>
`},q.listitem=function(U){return"<li>"+U+`</li>
`},q.checkbox=function(U){return"<input "+(U?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},q.paragraph=function(U){return"<p>"+U+`</p>
`},q.table=function(U,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+U+`</thead>
`+X+`</table>
`},q.tablerow=function(U){return`<tr>
`+U+`</tr>
`},q.tablecell=function(U,X){var G=X.header?"th":"td",Y=X.align?"<"+G+' align="'+X.align+'">':"<"+G+">";return Y+U+("</"+G+`>
`)},q.strong=function(U){return"<strong>"+U+"</strong>"},q.em=function(U){return"<em>"+U+"</em>"},q.codespan=function(U){return"<code>"+U+"</code>"},q.br=function(){return this.options.xhtml?"<br/>":"<br>"},q.del=function(U){return"<del>"+U+"</del>"},q.link=function(U,X,G){if(U=E(this.options.sanitize,this.options.baseUrl,U),U===null)return G;var Y='<a href="'+m(U)+'"';return X&&(Y+=' title="'+X+'"'),Y+=">"+G+"</a>",Y},q.image=function(U,X,G){if(U=E(this.options.sanitize,this.options.baseUrl,U),U===null)return G;var Y='<img src="'+U+'" alt="'+G+'"';return X&&(Y+=' title="'+X+'"'),Y+=this.options.xhtml?"/>":">",Y},q.text=function(U){return U},z}(),J=function(){function z(){}var q=z.prototype;return q.strong=function(U){return U},q.em=function(U){return U},q.codespan=function(U){return U},q.del=function(U){return U},q.html=function(U){return U},q.text=function(U){return U},q.link=function(U,X,G){return""+G},q.image=function(U,X,G){return""+G},q.br=function(){return""},z}(),Z=function(){function z(){this.seen={}}var q=z.prototype;return q.serialize=function(U){return U.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},q.getNextSafeSlug=function(U,X){var G=U,Y=0;if(this.seen.hasOwnProperty(G)){Y=this.seen[U];do Y++,G=U+"-"+Y;while(this.seen.hasOwnProperty(G))}return X||(this.seen[U]=Y,this.seen[G]=0),G},q.slug=function(U,X){X===void 0&&(X={});var G=this.serialize(U);return this.getNextSafeSlug(G,X.dryrun)},z}(),H=function(){function z(W){this.options=W||ae.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new Z}z.parse=function(U,X){var G=new z(X);return G.parse(U)},z.parseInline=function(U,X){var G=new z(X);return G.parseInline(U)};var q=z.prototype;return q.parse=function(U,X){X===void 0&&(X=!0);var G="",Y,ue,pe,Se,Ce,Fe,ze,me,Ee,ye,je,Te,xe,Be,Ze,Ye,it,Xe,Ge,fe=U.length;for(Y=0;Y<fe;Y++){if(ye=U[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ge=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ge!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){G+=Ge||"";continue}switch(ye.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,o(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(me="",ze="",Se=ye.header.length,ue=0;ue<Se;ue++)ze+=this.renderer.tablecell(this.parseInline(ye.header[ue].tokens),{header:!0,align:ye.align[ue]});for(me+=this.renderer.tablerow(ze),Ee="",Se=ye.rows.length,ue=0;ue<Se;ue++){for(Fe=ye.rows[ue],ze="",Ce=Fe.length,pe=0;pe<Ce;pe++)ze+=this.renderer.tablecell(this.parseInline(Fe[pe].tokens),{header:!1,align:ye.align[pe]});Ee+=this.renderer.tablerow(ze)}G+=this.renderer.table(me,Ee);continue}case"blockquote":{Ee=this.parse(ye.tokens),G+=this.renderer.blockquote(Ee);continue}case"list":{for(je=ye.ordered,Te=ye.start,xe=ye.loose,Se=ye.items.length,Ee="",ue=0;ue<Se;ue++)Ze=ye.items[ue],Ye=Ze.checked,it=Ze.task,Be="",Ze.task&&(Xe=this.renderer.checkbox(Ye),xe?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=Xe+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=Xe+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:Xe}):Be+=Xe),Be+=this.parse(Ze.tokens,xe),Ee+=this.renderer.listitem(Be,it,Ye);G+=this.renderer.list(Ee,je,Te);continue}case"html":{G+=this.renderer.html(ye.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ee=ye.tokens?this.parseInline(ye.tokens):ye.text;Y+1<fe&&U[Y+1].type==="text";)ye=U[++Y],Ee+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);G+=X?this.renderer.paragraph(Ee):Ee;continue}default:{var De='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return G},q.parseInline=function(U,X){X=X||this.renderer;var G="",Y,ue,pe,Se=U.length;for(Y=0;Y<Se;Y++){if(ue=U[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(pe=this.options.extensions.renderers[ue.type].call({parser:this},ue),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ue.type))){G+=pe||"";continue}switch(ue.type){case"escape":{G+=X.text(ue.text);break}case"html":{G+=X.html(ue.text);break}case"link":{G+=X.link(ue.href,ue.title,this.parseInline(ue.tokens,X));break}case"image":{G+=X.image(ue.href,ue.title,ue.text);break}case"strong":{G+=X.strong(this.parseInline(ue.tokens,X));break}case"em":{G+=X.em(this.parseInline(ue.tokens,X));break}case"codespan":{G+=X.codespan(ue.text);break}case"br":{G+=X.br();break}case"del":{G+=X.del(this.parseInline(ue.tokens,X));break}case"text":{G+=X.text(ue.text);break}default:{var Ce='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return G},z}();function B(z,q,W){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof q=="function"&&(W=q,q=null),q=f({},B.defaults,q||{}),A(q),W){var U=q.highlight,X;try{X=V.lex(z,q)}catch(Se){return W(Se)}var G=function(Ce){var Fe;if(!Ce)try{q.walkTokens&&B.walkTokens(X,q.walkTokens),Fe=H.parse(X,q)}catch(ze){Ce=ze}return q.highlight=U,Ce?W(Ce):W(null,Fe)};if(!U||U.length<3||(delete q.highlight,!X.length))return G();var Y=0;B.walkTokens(X,function(Se){Se.type==="code"&&(Y++,setTimeout(function(){U(Se.text,Se.lang,function(Ce,Fe){if(Ce)return G(Ce);Fe!=null&&Fe!==Se.text&&(Se.text=Fe,Se.escaped=!0),Y--,Y===0&&G()})},0))}),Y===0&&G();return}function ue(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+m(Se.message+"",!0)+"</pre>";throw Se}try{var pe=V.lex(z,q);if(q.walkTokens){if(q.async)return Promise.all(B.walkTokens(pe,q.walkTokens)).then(function(){return H.parse(pe,q)}).catch(ue);B.walkTokens(pe,q.walkTokens)}return H.parse(pe,q)}catch(Se){ue(Se)}}B.options=B.setOptions=function(z){return f(B.defaults,z),R(B.defaults),B},B.getDefaults=L,B.defaults=ae.defaults,B.use=function(){for(var z=arguments.length,q=new Array(z),W=0;W<z;W++)q[W]=arguments[W];var U=f.apply(void 0,[{}].concat(q)),X=B.defaults.extensions||{renderers:{},childTokens:{}},G;q.forEach(function(Y){if(Y.extensions&&(G=!0,Y.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Se=X.renderers?X.renderers[pe.name]:null;Se?X.renderers[pe.name]=function(){for(var Ce=arguments.length,Fe=new Array(Ce),ze=0;ze<Ce;ze++)Fe[ze]=arguments[ze];var me=pe.renderer.apply(this,Fe);return me===!1&&(me=Se.apply(this,Fe)),me}:X.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[pe.level]?X[pe.level].unshift(pe.tokenizer):X[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?X.startBlock?X.startBlock.push(pe.start):X.startBlock=[pe.start]:pe.level==="inline"&&(X.startInline?X.startInline.push(pe.start):X.startInline=[pe.start]))}pe.childTokens&&(X.childTokens[pe.name]=pe.childTokens)})),Y.renderer&&function(){var pe=B.defaults.renderer||new ie,Se=function(ze){var me=pe[ze];pe[ze]=function(){for(var Ee=arguments.length,ye=new Array(Ee),je=0;je<Ee;je++)ye[je]=arguments[je];var Te=Y.renderer[ze].apply(pe,ye);return Te===!1&&(Te=me.apply(pe,ye)),Te}};for(var Ce in Y.renderer)Se(Ce);U.renderer=pe}(),Y.tokenizer&&function(){var pe=B.defaults.tokenizer||new he,Se=function(ze){var me=pe[ze];pe[ze]=function(){for(var Ee=arguments.length,ye=new Array(Ee),je=0;je<Ee;je++)ye[je]=arguments[je];var Te=Y.tokenizer[ze].apply(pe,ye);return Te===!1&&(Te=me.apply(pe,ye)),Te}};for(var Ce in Y.tokenizer)Se(Ce);U.tokenizer=pe}(),Y.walkTokens){var ue=B.defaults.walkTokens;U.walkTokens=function(pe){var Se=[];return Se.push(Y.walkTokens.call(this,pe)),ue&&(Se=Se.concat(ue.call(this,pe))),Se}}G&&(U.extensions=X),B.setOptions(U)})},B.walkTokens=function(z,q){for(var W=[],U=function(){var ue=G.value;switch(W=W.concat(q.call(B,ue)),ue.type){case"table":{for(var pe=I(ue.header),Se;!(Se=pe()).done;){var Ce=Se.value;W=W.concat(B.walkTokens(Ce.tokens,q))}for(var Fe=I(ue.rows),ze;!(ze=Fe()).done;)for(var me=ze.value,Ee=I(me),ye;!(ye=Ee()).done;){var je=ye.value;W=W.concat(B.walkTokens(je.tokens,q))}break}case"list":{W=W.concat(B.walkTokens(ue.items,q));break}default:B.defaults.extensions&&B.defaults.extensions.childTokens&&B.defaults.extensions.childTokens[ue.type]?B.defaults.extensions.childTokens[ue.type].forEach(function(Te){W=W.concat(B.walkTokens(ue[Te],q))}):ue.tokens&&(W=W.concat(B.walkTokens(ue.tokens,q)))}},X=I(z),G;!(G=X()).done;)U();return W},B.parseInline=function(z,q){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");q=f({},B.defaults,q||{}),A(q);try{var W=V.lexInline(z,q);return q.walkTokens&&B.walkTokens(W,q.walkTokens),H.parseInline(W,q)}catch(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+m(U.message+"",!0)+"</pre>";throw U}},B.Parser=H,B.parser=H.parse,B.Renderer=ie,B.TextRenderer=J,B.Lexer=V,B.lexer=V.lex,B.Tokenizer=he,B.Slugger=Z,B.parse=B;var ne=B.options,Q=B.setOptions,_=B.use,T=B.walkTokens,S=B.parseInline,F=B,ee=H.parse,oe=V.lex;ae.Lexer=V,ae.Parser=H,ae.Renderer=ie,ae.Slugger=Z,ae.TextRenderer=J,ae.Tokenizer=he,ae.getDefaults=L,ae.lexer=oe,ae.marked=B,ae.options=ne,ae.parse=F,ae.parseInline=S,ae.parser=ee,ae.setOptions=Q,ae.use=_,ae.walkTokens=T,Object.defineProperty(ae,"__esModule",{value:!0})}),define(be[97],we([1,0,28]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=void 0;const O=new y.$mi(1e4);function a(d){return b(d,"NFC",O)}e.$4k=a;const I=new y.$mi(1e4);function L(d){return b(d,"NFD",I)}e.$5k=L;const R=/[^\u0000-\u0080]/;function b(d,P,p){if(!d)return d;const w=p.get(d);if(w)return w;let h;return R.test(d)?h=d.normalize(P):h=d,p.set(d,h),h}e.$6k=function(){const d=/[\u0300-\u036f]/g;return function(P){return L(P).replace(d,"")}}()}),define(be[142],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=e.rot=e.$ql=void 0;function y(R,b,d){return Math.min(Math.max(R,b),d)}e.$ql=y;function O(R,b){return(b+R%b)%b}e.rot=O;class a{constructor(){this.a=0}getNext(){return this.a++}}e.$sl=a;class I{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$tl=I;class L{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const d=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$ul=L}),function(){function ae(a){const I=[];typeof a=="number"&&I.push("code/timeOrigin",a);function L(b){I.push(b,Date.now())}function R(){const b=[];for(let d=0;d<I.length;d+=2)b.push({name:I[d],startTime:I[d+1]});return b}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(a){performance.mark(a)},getMarks(){let a=performance.timeOrigin;typeof a!="number"&&(a=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(a)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(a+L.startTime)});return I}};if(typeof process=="object"){const a=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(a)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function y(a){return a.MonacoPerformanceMarks||(a.MonacoPerformanceMarks=e()),a.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=y(O))}(),define(be[3],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let y=!1,O=!1,a=!1,I=!1,L=!1,R=!1,b=!1,d=!1,P=!1,p=!1,w,h=e.$a,m=e.$a,$,o;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?u=e.$b.vscode.process:typeof process<"u"&&(u=process);const l=typeof u?.versions?.electron=="string",g=l&&u?.type==="renderer";if(typeof navigator=="object"&&!g){o=navigator.userAgent,y=o.indexOf("Windows")>=0,O=o.indexOf("Macintosh")>=0,d=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,R=!0,w=e.$a,h=w,m=navigator.language;const f=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),k=f&&f.getAttribute("data-settings");if(k)try{const v=JSON.parse(k),C=v.availableLanguages["*"];w=v.locale,m=v.osLocale,h=C||e.$a,$=v._translationsConfigFile}catch{}}else if(typeof u=="object"){y=u.platform==="win32",O=u.platform==="darwin",a=u.platform==="linux",I=a&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,b=l,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,h=e.$a;const f=u.env.VSCODE_NLS_CONFIG;if(f)try{const k=JSON.parse(f),v=k.availableLanguages["*"];w=k.locale,m=k.osLocale,h=v||e.$a,$=k._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var D;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(D||(e.Platform=D={}));function E(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=E;let t=0;O?t=1:y?t=3:a&&(t=2),e.$d=y,e.$e=O,e.$f=a,e.$g=I,e.$h=L,e.$i=b,e.$j=R,e.$k=R&&typeof e.$b.importScripts=="function",e.$l=d,e.$m=p,e.$n=P,e.$o=t,e.$p=o,e.$q=h;var i;(function(f){function k(){return e.$q}f.value=k;function v(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}f.isDefaultVariant=v;function C(){return e.$q==="en"}f.isDefault=C})(i||(e.Language=i={})),e.$r=w,e.$s=m,e.$t=$,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const f=[];e.$b.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,A=f.length;C<A;C++){const M=f[C];if(M.id===v.data.vscodeScheduleAsyncWork){f.splice(C,1),M.callback();return}}});let k=0;return v=>{const C=++k;f.push({id:C,callback:v}),e.$b.postMessage({vscodeScheduleAsyncWork:C},"*")}}return f=>setTimeout(f)})();var r;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=O||d?2:y?1:3;let n=!0,s=!1;function c(){if(!s){s=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,n=new Uint16Array(f.buffer)[0]===(2<<8)+1}return n}e.$x=c,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(be[29],we([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6b=e.$5b=e.env=e.cwd=void 0;let O;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const a=y.$b.vscode.process;O={get platform(){return a.platform},get arch(){return a.arch},get env(){return a.env},cwd(){return a.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$5b=O.platform,e.$6b=O.arch}),define(be[7],we([1,0,29]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ic=e.sep=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=void 0;const O=65,a=97,I=90,L=122,R=46,b=47,d=92,P=58,p=63;class w extends Error{constructor(i,r,n){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const c=i.indexOf(".")!==-1?"property":"argument";let f=`The "${i}" ${c} ${s} of type ${r}`;f+=`. Received type ${typeof n}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,i){if(t===null||typeof t!="object")throw new w(i,"Object",t)}function m(t,i){if(typeof t!="string")throw new w(i,"string",t)}const $=y.$5b==="win32";function o(t){return t===b||t===d}function u(t){return t===b}function l(t){return t>=O&&t<=I||t>=a&&t<=L}function g(t,i,r,n){let s="",c=0,f=-1,k=0,v=0;for(let C=0;C<=t.length;++C){if(C<t.length)v=t.charCodeAt(C);else{if(n(v))break;v=b}if(n(v)){if(!(f===C-1||k===1))if(k===2){if(s.length<2||c!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const A=s.lastIndexOf(r);A===-1?(s="",c=0):(s=s.slice(0,A),c=s.length-1-s.lastIndexOf(r)),f=C,k=0;continue}else if(s.length!==0){s="",c=0,f=C,k=0;continue}}i&&(s+=s.length>0?`${r}..`:"..",c=2)}else s.length>0?s+=`${r}${t.slice(f+1,C)}`:s=t.slice(f+1,C),c=C-f-1;f=C,k=0}else v===R&&k!==-1?++k:k=-1}return s}function D(t,i){h(i,"pathObject");const r=i.dir||i.root,n=i.base||`${i.name||""}${i.ext||""}`;return r?r===i.root?`${r}${n}`:`${r}${t}${n}`:n}e.$7b={resolve(...t){let i="",r="",n=!1;for(let s=t.length-1;s>=-1;s--){let c;if(s>=0){if(c=t[s],m(c,"path"),c.length===0)continue}else i.length===0?c=y.cwd():(c=y.env[`=${i}`]||y.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==i.toLowerCase()&&c.charCodeAt(2)===d)&&(c=`${i}\\`));const f=c.length;let k=0,v="",C=!1;const A=c.charCodeAt(0);if(f===1)o(A)&&(k=1,C=!0);else if(o(A))if(C=!0,o(c.charCodeAt(1))){let M=2,K=M;for(;M<f&&!o(c.charCodeAt(M));)M++;if(M<f&&M!==K){const te=c.slice(K,M);for(K=M;M<f&&o(c.charCodeAt(M));)M++;if(M<f&&M!==K){for(K=M;M<f&&!o(c.charCodeAt(M));)M++;(M===f||M!==K)&&(v=`\\\\${te}\\${c.slice(K,M)}`,k=M)}}}else k=1;else l(A)&&c.charCodeAt(1)===P&&(v=c.slice(0,2),k=2,f>2&&o(c.charCodeAt(2))&&(C=!0,k=3));if(v.length>0)if(i.length>0){if(v.toLowerCase()!==i.toLowerCase())continue}else i=v;if(n){if(i.length>0)break}else if(r=`${c.slice(k)}\\${r}`,n=C,C&&i.length>0)break}return r=g(r,!n,"\\",o),n?`${i}\\${r}`:`${i}${r}`||"."},normalize(t){m(t,"path");const i=t.length;if(i===0)return".";let r=0,n,s=!1;const c=t.charCodeAt(0);if(i===1)return u(c)?"\\":t;if(o(c))if(s=!0,o(t.charCodeAt(1))){let k=2,v=k;for(;k<i&&!o(t.charCodeAt(k));)k++;if(k<i&&k!==v){const C=t.slice(v,k);for(v=k;k<i&&o(t.charCodeAt(k));)k++;if(k<i&&k!==v){for(v=k;k<i&&!o(t.charCodeAt(k));)k++;if(k===i)return`\\\\${C}\\${t.slice(v)}\\`;k!==v&&(n=`\\\\${C}\\${t.slice(v,k)}`,r=k)}}}else r=1;else l(c)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),r=2,i>2&&o(t.charCodeAt(2))&&(s=!0,r=3));let f=r<i?g(t.slice(r),!s,"\\",o):"";return f.length===0&&!s&&(f="."),f.length>0&&o(t.charCodeAt(i-1))&&(f+="\\"),n===void 0?s?`\\${f}`:f:s?`${n}\\${f}`:`${n}${f}`},isAbsolute(t){m(t,"path");const i=t.length;if(i===0)return!1;const r=t.charCodeAt(0);return o(r)||i>2&&l(r)&&t.charCodeAt(1)===P&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,r;for(let c=0;c<t.length;++c){const f=t[c];m(f,"path"),f.length>0&&(i===void 0?i=r=f:i+=`\\${f}`)}if(i===void 0)return".";let n=!0,s=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++s;const c=r.length;c>1&&o(r.charCodeAt(1))&&(++s,c>2&&(o(r.charCodeAt(2))?++s:n=!1))}if(n){for(;s<i.length&&o(i.charCodeAt(s));)s++;s>=2&&(i=`\\${i.slice(s)}`)}return e.$7b.normalize(i)},relative(t,i){if(m(t,"from"),m(i,"to"),t===i)return"";const r=e.$7b.resolve(t),n=e.$7b.resolve(i);if(r===n||(t=r.toLowerCase(),i=n.toLowerCase(),t===i))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===d;)s++;let c=t.length;for(;c-1>s&&t.charCodeAt(c-1)===d;)c--;const f=c-s;let k=0;for(;k<i.length&&i.charCodeAt(k)===d;)k++;let v=i.length;for(;v-1>k&&i.charCodeAt(v-1)===d;)v--;const C=v-k,A=f<C?f:C;let M=-1,K=0;for(;K<A;K++){const he=t.charCodeAt(s+K);if(he!==i.charCodeAt(k+K))break;he===d&&(M=K)}if(K!==A){if(M===-1)return n}else{if(C>A){if(i.charCodeAt(k+K)===d)return n.slice(k+K+1);if(K===2)return n.slice(k+K)}f>A&&(t.charCodeAt(s+K)===d?M=K:K===2&&(M=3)),M===-1&&(M=0)}let te="";for(K=s+M+1;K<=c;++K)(K===c||t.charCodeAt(K)===d)&&(te+=te.length===0?"..":"\\..");return k+=M,te.length>0?`${te}${n.slice(k,v)}`:(n.charCodeAt(k)===d&&++k,n.slice(k,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.$7b.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===d){if(i.charCodeAt(1)===d){const r=i.charCodeAt(2);if(r!==p&&r!==R)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(l(i.charCodeAt(0))&&i.charCodeAt(1)===P&&i.charCodeAt(2)===d)return`\\\\?\\${i}`;return t},dirname(t){m(t,"path");const i=t.length;if(i===0)return".";let r=-1,n=0;const s=t.charCodeAt(0);if(i===1)return o(s)?t:".";if(o(s)){if(r=n=1,o(t.charCodeAt(1))){let k=2,v=k;for(;k<i&&!o(t.charCodeAt(k));)k++;if(k<i&&k!==v){for(v=k;k<i&&o(t.charCodeAt(k));)k++;if(k<i&&k!==v){for(v=k;k<i&&!o(t.charCodeAt(k));)k++;if(k===i)return t;k!==v&&(r=n=k+1)}}}}else l(s)&&t.charCodeAt(1)===P&&(r=i>2&&o(t.charCodeAt(2))?3:2,n=r);let c=-1,f=!0;for(let k=i-1;k>=n;--k)if(o(t.charCodeAt(k))){if(!f){c=k;break}}else f=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,i){i!==void 0&&m(i,"ext"),m(t,"path");let r=0,n=-1,s=!0,c;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(r=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let f=i.length-1,k=-1;for(c=t.length-1;c>=r;--c){const v=t.charCodeAt(c);if(o(v)){if(!s){r=c+1;break}}else k===-1&&(s=!1,k=c+1),f>=0&&(v===i.charCodeAt(f)?--f===-1&&(n=c):(f=-1,n=k))}return r===n?n=k:n===-1&&(n=t.length),t.slice(r,n)}for(c=t.length-1;c>=r;--c)if(o(t.charCodeAt(c))){if(!s){r=c+1;break}}else n===-1&&(s=!1,n=c+1);return n===-1?"":t.slice(r,n)},extname(t){m(t,"path");let i=0,r=-1,n=0,s=-1,c=!0,f=0;t.length>=2&&t.charCodeAt(1)===P&&l(t.charCodeAt(0))&&(i=n=2);for(let k=t.length-1;k>=i;--k){const v=t.charCodeAt(k);if(o(v)){if(!c){n=k+1;break}continue}s===-1&&(c=!1,s=k+1),v===R?r===-1?r=k:f!==1&&(f=1):r!==-1&&(f=-1)}return r===-1||s===-1||f===0||f===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:D.bind(null,"\\"),parse(t){m(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const r=t.length;let n=0,s=t.charCodeAt(0);if(r===1)return o(s)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(o(s)){if(n=1,o(t.charCodeAt(1))){let M=2,K=M;for(;M<r&&!o(t.charCodeAt(M));)M++;if(M<r&&M!==K){for(K=M;M<r&&o(t.charCodeAt(M));)M++;if(M<r&&M!==K){for(K=M;M<r&&!o(t.charCodeAt(M));)M++;M===r?n=M:M!==K&&(n=M+1)}}}}else if(l(s)&&t.charCodeAt(1)===P){if(r<=2)return i.root=i.dir=t,i;if(n=2,o(t.charCodeAt(2))){if(r===3)return i.root=i.dir=t,i;n=3}}n>0&&(i.root=t.slice(0,n));let c=-1,f=n,k=-1,v=!0,C=t.length-1,A=0;for(;C>=n;--C){if(s=t.charCodeAt(C),o(s)){if(!v){f=C+1;break}continue}k===-1&&(v=!1,k=C+1),s===R?c===-1?c=C:A!==1&&(A=1):c!==-1&&(A=-1)}return k!==-1&&(c===-1||A===0||A===1&&c===k-1&&c===f+1?i.base=i.name=t.slice(f,k):(i.name=t.slice(f,c),i.base=t.slice(f,k),i.ext=t.slice(c,k))),f>0&&f!==n?i.dir=t.slice(0,f-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if($){const t=/\\/g;return()=>{const i=y.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>y.cwd()})();e.$8b={resolve(...t){let i="",r=!1;for(let n=t.length-1;n>=-1&&!r;n--){const s=n>=0?t[n]:E();m(s,"path"),s.length!==0&&(i=`${s}/${i}`,r=s.charCodeAt(0)===b)}return i=g(i,!r,"/",u),r?`/${i}`:i.length>0?i:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===b,r=t.charCodeAt(t.length-1)===b;return t=g(t,!i,"/",u),t.length===0?i?"/":r?"./":".":(r&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let i;for(let r=0;r<t.length;++r){const n=t[r];m(n,"path"),n.length>0&&(i===void 0?i=n:i+=`/${n}`)}return i===void 0?".":e.$8b.normalize(i)},relative(t,i){if(m(t,"from"),m(i,"to"),t===i||(t=e.$8b.resolve(t),i=e.$8b.resolve(i),t===i))return"";const r=1,n=t.length,s=n-r,c=1,f=i.length-c,k=s<f?s:f;let v=-1,C=0;for(;C<k;C++){const M=t.charCodeAt(r+C);if(M!==i.charCodeAt(c+C))break;M===b&&(v=C)}if(C===k)if(f>k){if(i.charCodeAt(c+C)===b)return i.slice(c+C+1);if(C===0)return i.slice(c+C)}else s>k&&(t.charCodeAt(r+C)===b?v=C:C===0&&(v=0));let A="";for(C=r+v+1;C<=n;++C)(C===n||t.charCodeAt(C)===b)&&(A+=A.length===0?"..":"/..");return`${A}${i.slice(c+v)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===b;let r=-1,n=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===b){if(!n){r=s;break}}else n=!1;return r===-1?i?"/":".":i&&r===1?"//":t.slice(0,r)},basename(t,i){i!==void 0&&m(i,"ext"),m(t,"path");let r=0,n=-1,s=!0,c;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let f=i.length-1,k=-1;for(c=t.length-1;c>=0;--c){const v=t.charCodeAt(c);if(v===b){if(!s){r=c+1;break}}else k===-1&&(s=!1,k=c+1),f>=0&&(v===i.charCodeAt(f)?--f===-1&&(n=c):(f=-1,n=k))}return r===n?n=k:n===-1&&(n=t.length),t.slice(r,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===b){if(!s){r=c+1;break}}else n===-1&&(s=!1,n=c+1);return n===-1?"":t.slice(r,n)},extname(t){m(t,"path");let i=-1,r=0,n=-1,s=!0,c=0;for(let f=t.length-1;f>=0;--f){const k=t.charCodeAt(f);if(k===b){if(!s){r=f+1;break}continue}n===-1&&(s=!1,n=f+1),k===R?i===-1?i=f:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||n===-1||c===0||c===1&&i===n-1&&i===r+1?"":t.slice(i,n)},format:D.bind(null,"/"),parse(t){m(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const r=t.charCodeAt(0)===b;let n;r?(i.root="/",n=1):n=0;let s=-1,c=0,f=-1,k=!0,v=t.length-1,C=0;for(;v>=n;--v){const A=t.charCodeAt(v);if(A===b){if(!k){c=v+1;break}continue}f===-1&&(k=!1,f=v+1),A===R?s===-1?s=v:C!==1&&(C=1):s!==-1&&(C=-1)}if(f!==-1){const A=c===0&&r?1:c;s===-1||C===0||C===1&&s===f-1&&s===c+1?i.base=i.name=t.slice(A,f):(i.name=t.slice(A,s),i.base=t.slice(A,f),i.ext=t.slice(s,f))}return c>0?i.dir=t.slice(0,c-1):r&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$8b.win32=e.$7b.win32=e.$7b,e.$8b.posix=e.$7b.posix=e.$8b,e.$9b=$?e.$7b.normalize:e.$8b.normalize,e.$0b=$?e.$7b.isAbsolute:e.$8b.isAbsolute,e.$$b=$?e.$7b.join:e.$8b.join,e.$_b=$?e.$7b.resolve:e.$8b.resolve,e.$ac=$?e.$7b.relative:e.$8b.relative,e.$bc=$?e.$7b.dirname:e.$8b.dirname,e.$cc=$?e.$7b.basename:e.$8b.basename,e.$dc=$?e.$7b.extname:e.$8b.extname,e.$ec=$?e.$7b.format:e.$8b.format,e.$fc=$?e.$7b.parse:e.$8b.parse,e.$gc=$?e.$7b.toNamespacedPath:e.$8b.toNamespacedPath,e.sep=$?e.$7b.sep:e.$8b.sep,e.$ic=$?e.$7b.delimiter:e.$8b.delimiter}),define(be[58],we([1,0,7]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=void 0,e.$rr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(P){const p=(0,y.$dc)(P),w=O[p.toLowerCase()];return w!==void 0?w:L(P)}e.$sr=I;function L(P){const p=(0,y.$dc)(P);return a[p.toLowerCase()]}e.$tr=L;function R(P){for(const p in a)if(a[p]===P)return p}e.$ur=R;const b=/^(.+)\/(.+?)(;.+)?$/;function d(P,p){const w=b.exec(P);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:p?void 0:P}e.$vr=d}),define(be[59],we([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O||(e.Source=O={}));var a;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(a||(e.TerminateResponseCode=a={}));function I(R,...b){const d=b.reduce((w,h)=>(w[h]=!0,w),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(R).filter(w=>!d[w]).forEach(w=>{for(let h=0;h<P.length;h++)if(w.search(P[h])!==-1){delete R[w];break}})}e.$cl=I;function L(R){R&&(delete R.DEBUG,y.$e&&delete R.DYLD_LIBRARY_PATH,y.$f&&delete R.LD_PRELOAD)}e.$dl=L}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var O in y)(typeof exports=="object"?exports:ae)[O]=y[O]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function y(O){if(e[O])return e[O].exports;var a=e[O]={i:O,l:!1,exports:{}};return ae[O].call(a.exports,a,a.exports,y),a.l=!0,a.exports}return y.m=ae,y.c=e,y.d=function(O,a,I){y.o(O,a)||Object.defineProperty(O,a,{enumerable:!0,get:I})},y.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},y.t=function(O,a){if(1&a&&(O=y(O)),8&a||4&a&&typeof O=="object"&&O&&O.__esModule)return O;var I=Object.create(null);if(y.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:O}),2&a&&typeof O!="string")for(var L in O)y.d(I,L,function(R){return O[R]}.bind(null,L));return I},y.n=function(O){var a=O&&O.__esModule?function(){return O.default}:function(){return O};return y.d(a,"a",a),a},y.o=function(O,a){return Object.prototype.hasOwnProperty.call(O,a)},y.p="",y(y.s=0)}([function(ae,e,y){(function(O){var a;e=ae.exports=_,a=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],d=0,P=d++;b[P]="0|[1-9]\\d*";var p=d++;b[p]="[0-9]+";var w=d++;b[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=d++;b[h]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var m=d++;b[m]="("+b[p]+")\\.("+b[p]+")\\.("+b[p]+")";var $=d++;b[$]="(?:"+b[P]+"|"+b[w]+")";var o=d++;b[o]="(?:"+b[p]+"|"+b[w]+")";var u=d++;b[u]="(?:-("+b[$]+"(?:\\."+b[$]+")*))";var l=d++;b[l]="(?:-?("+b[o]+"(?:\\."+b[o]+")*))";var g=d++;b[g]="[0-9A-Za-z-]+";var D=d++;b[D]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var E=d++,t="v?"+b[h]+b[u]+"?"+b[D]+"?";b[E]="^"+t+"$";var i="[v=\\s]*"+b[m]+b[l]+"?"+b[D]+"?",r=d++;b[r]="^"+i+"$";var n=d++;b[n]="((?:<|>)?=?)";var s=d++;b[s]=b[p]+"|x|X|\\*";var c=d++;b[c]=b[P]+"|x|X|\\*";var f=d++;b[f]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[u]+")?"+b[D]+"?)?)?";var k=d++;b[k]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[l]+")?"+b[D]+"?)?)?";var v=d++;b[v]="^"+b[n]+"\\s*"+b[f]+"$";var C=d++;b[C]="^"+b[n]+"\\s*"+b[k]+"$";var A=d++;b[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=d++;b[M]="(?:~>?)";var K=d++;b[K]="(\\s*)"+b[M]+"\\s+",R[K]=new RegExp(b[K],"g");var te=d++;b[te]="^"+b[M]+b[f]+"$";var he=d++;b[he]="^"+b[M]+b[k]+"$";var ce=d++;b[ce]="(?:\\^)";var le=d++;b[le]="(\\s*)"+b[ce]+"\\s+",R[le]=new RegExp(b[le],"g");var ge=d++;b[ge]="^"+b[ce]+b[f]+"$";var se=d++;b[se]="^"+b[ce]+b[k]+"$";var V=d++;b[V]="^"+b[n]+"\\s*("+i+")$|^$";var ie=d++;b[ie]="^"+b[n]+"\\s*("+t+")$|^$";var J=d++;b[J]="(\\s*)"+b[n]+"\\s*("+i+"|"+b[f]+")",R[J]=new RegExp(b[J],"g");var Z=d++;b[Z]="^\\s*("+b[f]+")\\s+-\\s+("+b[f]+")\\s*$";var H=d++;b[H]="^\\s*("+b[k]+")\\s+-\\s+("+b[k]+")\\s*$";var B=d++;b[B]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)a(ne,b[ne]),R[ne]||(R[ne]=new RegExp(b[ne]));function Q(me,Ee){if(me instanceof _)return me;if(typeof me!="string"||me.length>I||!(Ee?R[r]:R[E]).test(me))return null;try{return new _(me,Ee)}catch{return null}}function _(me,Ee){if(me instanceof _){if(me.loose===Ee)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof _))return new _(me,Ee);a("SemVer",me,Ee),this.loose=Ee;var ye=me.trim().match(Ee?R[r]:R[E]);if(!ye)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Te=+je;if(Te>=0&&Te<L)return Te}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Q,e.valid=function(me,Ee){var ye=Q(me,Ee);return ye?ye.version:null},e.clean=function(me,Ee){var ye=Q(me.trim().replace(/^[=v]+/,""),Ee);return ye?ye.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(me){return a("SemVer.compare",this.version,this.loose,me),me instanceof _||(me=new _(me,this.loose)),this.compareMain(me)||this.comparePre(me)},_.prototype.compareMain=function(me){return me instanceof _||(me=new _(me,this.loose)),S(this.major,me.major)||S(this.minor,me.minor)||S(this.patch,me.patch)},_.prototype.comparePre=function(me){if(me instanceof _||(me=new _(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Ee=0;do{var ye=this.prerelease[Ee],je=me.prerelease[Ee];if(a("prerelease compare",Ee,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return S(ye,je)}while(++Ee)},_.prototype.inc=function(me,Ee){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Ee,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new _(me,ye).inc(Ee,je).version}catch{return null}},e.diff=function(me,Ee){if(z(me,Ee))return null;var ye=Q(me),je=Q(Ee);if(ye.prerelease.length||je.prerelease.length){for(var Te in ye)if((Te==="major"||Te==="minor"||Te==="patch")&&ye[Te]!==je[Te])return"pre"+Te;return"prerelease"}for(var Te in ye)if((Te==="major"||Te==="minor"||Te==="patch")&&ye[Te]!==je[Te])return Te},e.compareIdentifiers=S;var T=/^[0-9]+$/;function S(me,Ee){var ye=T.test(me),je=T.test(Ee);return ye&&je&&(me=+me,Ee=+Ee),ye&&!je?-1:je&&!ye?1:me<Ee?-1:me>Ee?1:0}function F(me,Ee,ye){return new _(me,ye).compare(new _(Ee,ye))}function ee(me,Ee,ye){return F(me,Ee,ye)>0}function oe(me,Ee,ye){return F(me,Ee,ye)<0}function z(me,Ee,ye){return F(me,Ee,ye)===0}function q(me,Ee,ye){return F(me,Ee,ye)!==0}function W(me,Ee,ye){return F(me,Ee,ye)>=0}function U(me,Ee,ye){return F(me,Ee,ye)<=0}function X(me,Ee,ye,je){var Te;switch(Ee){case"===":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Te=me===ye;break;case"!==":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Te=me!==ye;break;case"":case"=":case"==":Te=z(me,ye,je);break;case"!=":Te=q(me,ye,je);break;case">":Te=ee(me,ye,je);break;case">=":Te=W(me,ye,je);break;case"<":Te=oe(me,ye,je);break;case"<=":Te=U(me,ye,je);break;default:throw new TypeError("Invalid operator: "+Ee)}return Te}function G(me,Ee){if(me instanceof G){if(me.loose===Ee)return me;me=me.value}if(!(this instanceof G))return new G(me,Ee);a("comparator",me,Ee),this.loose=Ee,this.parse(me),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,a("comp",this)}e.rcompareIdentifiers=function(me,Ee){return S(Ee,me)},e.major=function(me,Ee){return new _(me,Ee).major},e.minor=function(me,Ee){return new _(me,Ee).minor},e.patch=function(me,Ee){return new _(me,Ee).patch},e.compare=F,e.compareLoose=function(me,Ee){return F(me,Ee,!0)},e.rcompare=function(me,Ee,ye){return F(Ee,me,ye)},e.sort=function(me,Ee){return me.sort(function(ye,je){return e.compare(ye,je,Ee)})},e.rsort=function(me,Ee){return me.sort(function(ye,je){return e.rcompare(ye,je,Ee)})},e.gt=ee,e.lt=oe,e.eq=z,e.neq=q,e.gte=W,e.lte=U,e.cmp=X,e.Comparator=G;var Y={};function ue(me,Ee){if(me instanceof ue)return me.loose===Ee?me:new ue(me.raw,Ee);if(me instanceof G)return new ue(me.value,Ee);if(!(this instanceof ue))return new ue(me,Ee);if(this.loose=Ee,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function Se(me,Ee,ye,je,Te,xe,Be,Ze,Ye,it,Xe,Ge,fe){return((Ee=pe(ye)?"":pe(je)?">="+ye+".0.0":pe(Te)?">="+ye+"."+je+".0":">="+Ee)+" "+(Ze=pe(Ye)?"":pe(it)?"<"+(+Ye+1)+".0.0":pe(Xe)?"<"+Ye+"."+(+it+1)+".0":Ge?"<="+Ye+"."+it+"."+Xe+"-"+Ge:"<="+Ze)).trim()}function Ce(me,Ee){for(var ye=0;ye<me.length;ye++)if(!me[ye].test(Ee))return!1;if(Ee.prerelease.length){for(ye=0;ye<me.length;ye++)if(a(me[ye].semver),me[ye].semver!==Y&&me[ye].semver.prerelease.length>0){var je=me[ye].semver;if(je.major===Ee.major&&je.minor===Ee.minor&&je.patch===Ee.patch)return!0}return!1}return!0}function Fe(me,Ee,ye){try{Ee=new ue(Ee,ye)}catch{return!1}return Ee.test(me)}function ze(me,Ee,ye,je){var Te,xe,Be,Ze,Ye;switch(me=new _(me,je),Ee=new ue(Ee,je),ye){case">":Te=ee,xe=U,Be=oe,Ze=">",Ye=">=";break;case"<":Te=oe,xe=W,Be=ee,Ze="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(me,Ee,je))return!1;for(var it=0;it<Ee.set.length;++it){var Xe=Ee.set[it],Ge=null,fe=null;if(Xe.forEach(function(De){De.semver===Y&&(De=new G(">=0.0.0")),Ge=Ge||De,fe=fe||De,Te(De.semver,Ge.semver,je)?Ge=De:Be(De.semver,fe.semver,je)&&(fe=De)}),Ge.operator===Ze||Ge.operator===Ye||(!fe.operator||fe.operator===Ze)&&xe(me,fe.semver)||fe.operator===Ye&&Be(me,fe.semver))return!1}return!0}G.prototype.parse=function(me){var Ee=this.loose?R[V]:R[ie],ye=me.match(Ee);if(!ye)throw new TypeError("Invalid comparator: "+me);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new _(ye[2],this.loose):this.semver=Y},G.prototype.toString=function(){return this.value},G.prototype.test=function(me){return a("Comparator.test",me,this.loose),this.semver===Y||(typeof me=="string"&&(me=new _(me,this.loose)),X(me,this.operator,this.semver,this.loose))},G.prototype.intersects=function(me,Ee){if(!(me instanceof G))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ue(me.value,Ee),Fe(this.value,ye,Ee);if(me.operator==="")return ye=new ue(this.value,Ee),Fe(me.semver,ye,Ee);var je=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),xe=this.semver.version===me.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ze=X(this.semver,"<",me.semver,Ee)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ye=X(this.semver,">",me.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return je||Te||xe&&Be||Ze||Ye},e.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(me){var Ee=this.loose;me=me.trim(),a("range",me,Ee);var ye=Ee?R[H]:R[Z];me=me.replace(ye,Se),a("hyphen replace",me),me=me.replace(R[J],"$1$2$3"),a("comparator trim",me,R[J]),me=(me=(me=me.replace(R[K],"$1~")).replace(R[le],"$1^")).split(/\s+/).join(" ");var je=Ee?R[V]:R[ie],Te=me.split(" ").map(function(xe){return function(Be,Ze){return a("comp",Be),Be=function(Ye,it){return Ye.trim().split(/\s+/).map(function(Xe){return function(Ge,fe){a("caret",Ge,fe);var De=fe?R[se]:R[ge];return Ge.replace(De,function(Le,Ie,Oe,qe,He){var Ke;return a("caret",Ge,Le,Ie,Oe,qe,He),pe(Ie)?Ke="":pe(Oe)?Ke=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(qe)?Ke=Ie==="0"?">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0":">="+Ie+"."+Oe+".0 <"+(+Ie+1)+".0.0":He?(a("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ke=Ie==="0"?Oe==="0"?">="+Ie+"."+Oe+"."+qe+He+" <"+Ie+"."+Oe+"."+(+qe+1):">="+Ie+"."+Oe+"."+qe+He+" <"+Ie+"."+(+Oe+1)+".0":">="+Ie+"."+Oe+"."+qe+He+" <"+(+Ie+1)+".0.0"):(a("no pr"),Ke=Ie==="0"?Oe==="0"?">="+Ie+"."+Oe+"."+qe+" <"+Ie+"."+Oe+"."+(+qe+1):">="+Ie+"."+Oe+"."+qe+" <"+Ie+"."+(+Oe+1)+".0":">="+Ie+"."+Oe+"."+qe+" <"+(+Ie+1)+".0.0"),a("caret return",Ke),Ke})}(Xe,it)}).join(" ")}(Be,Ze),a("caret",Be),Be=function(Ye,it){return Ye.trim().split(/\s+/).map(function(Xe){return function(Ge,fe){var De=fe?R[he]:R[te];return Ge.replace(De,function(Le,Ie,Oe,qe,He){var Ke;return a("tilde",Ge,Le,Ie,Oe,qe,He),pe(Ie)?Ke="":pe(Oe)?Ke=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(qe)?Ke=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0":He?(a("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ke=">="+Ie+"."+Oe+"."+qe+He+" <"+Ie+"."+(+Oe+1)+".0"):Ke=">="+Ie+"."+Oe+"."+qe+" <"+Ie+"."+(+Oe+1)+".0",a("tilde return",Ke),Ke})}(Xe,it)}).join(" ")}(Be,Ze),a("tildes",Be),Be=function(Ye,it){return a("replaceXRanges",Ye,it),Ye.split(/\s+/).map(function(Xe){return function(Ge,fe){Ge=Ge.trim();var De=fe?R[C]:R[v];return Ge.replace(De,function(Le,Ie,Oe,qe,He,Ke){a("xRange",Ge,Le,Ie,Oe,qe,He,Ke);var et=pe(Oe),Je=et||pe(qe),st=Je||pe(He);return Ie==="="&&st&&(Ie=""),et?Le=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&st?(Je&&(qe=0),st&&(He=0),Ie===">"?(Ie=">=",Je?(Oe=+Oe+1,qe=0,He=0):st&&(qe=+qe+1,He=0)):Ie==="<="&&(Ie="<",Je?Oe=+Oe+1:qe=+qe+1),Le=Ie+Oe+"."+qe+"."+He):Je?Le=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":st&&(Le=">="+Oe+"."+qe+".0 <"+Oe+"."+(+qe+1)+".0"),a("xRange return",Le),Le})}(Xe,it)}).join(" ")}(Be,Ze),a("xrange",Be),Be=function(Ye,it){return a("replaceStars",Ye,it),Ye.trim().replace(R[B],"")}(Be,Ze),a("stars",Be),Be}(xe,Ee)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(xe){return!!xe.match(je)})),Te=Te.map(function(xe){return new G(xe,Ee)})},ue.prototype.intersects=function(me,Ee){if(!(me instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return me.set.some(function(Te){return Te.every(function(xe){return je.intersects(xe,Ee)})})})})},e.toComparators=function(me,Ee){return new ue(me,Ee).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new _(me,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(Ce(this.set[Ee],me))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(me,Ee,ye){var je=null,Te=null;try{var xe=new ue(Ee,ye)}catch{return null}return me.forEach(function(Be){xe.test(Be)&&(je&&Te.compare(Be)!==-1||(Te=new _(je=Be,ye)))}),je},e.minSatisfying=function(me,Ee,ye){var je=null,Te=null;try{var xe=new ue(Ee,ye)}catch{return null}return me.forEach(function(Be){xe.test(Be)&&(je&&Te.compare(Be)!==1||(Te=new _(je=Be,ye)))}),je},e.validRange=function(me,Ee){try{return new ue(me,Ee).range||"*"}catch{return null}},e.ltr=function(me,Ee,ye){return ze(me,Ee,"<",ye)},e.gtr=function(me,Ee,ye){return ze(me,Ee,">",ye)},e.outside=ze,e.prerelease=function(me,Ee){var ye=Q(me,Ee);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(me,Ee,ye){return me=new ue(me,ye),Ee=new ue(Ee,ye),me.intersects(Ee)},e.coerce=function(me){if(me instanceof _)return me;if(typeof me!="string")return null;var Ee=me.match(R[A]);return Ee==null?null:Q((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,y(1))},function(ae,e){var y,O,a=ae.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(o){if(y===setTimeout)return setTimeout(o,0);if((y===I||!y)&&setTimeout)return y=setTimeout,setTimeout(o,0);try{return y(o,0)}catch{try{return y.call(null,o,0)}catch{return y.call(this,o,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:I}catch{y=I}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var b,d=[],P=!1,p=-1;function w(){P&&b&&(P=!1,b.length?d=b.concat(d):p=-1,d.length&&h())}function h(){if(!P){var o=R(w);P=!0;for(var u=d.length;u;){for(b=d,d=[];++p<u;)b&&b[p].run();p=-1,u=d.length}b=null,P=!1,function(l){if(O===clearTimeout)return clearTimeout(l);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(l);try{O(l)}catch{try{return O.call(null,l)}catch{return O.call(this,l)}}}(o)}}function m(o,u){this.fun=o,this.array=u}function $(){}a.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)u[l-1]=arguments[l];d.push(new m(o,u)),d.length!==1||P||R(h)},m.prototype.run=function(){this.fun.apply(null,this.array)},a.title="browser",a.browser=!0,a.env={},a.argv=[],a.version="",a.versions={},a.on=$,a.addListener=$,a.once=$,a.off=$,a.removeListener=$,a.removeAllListeners=$,a.emit=$,a.prependListener=$,a.prependOnceListener=$,a.listeners=function(o){return[]},a.binding=function(o){throw new Error("process.binding is not supported")},a.cwd=function(){return"/"},a.chdir=function(o){throw new Error("process.chdir is not supported")},a.umask=function(){return 0}}])}),define(be[143],we([1,0]),function(ae,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class O{constructor(R,b,d){this.level=R,this.key=b,this.value=d,this.forward=[]}}const a=void 0;class I{constructor(R,b=2**16){this.comparator=R,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new O(this.c,a,a)}get size(){return this.f}clear(){this.e=new O(this.c,a,a)}has(R){return!!I.g(this,R,this.comparator)}get(R){return I.g(this,R,this.comparator)?.value}set(R,b){return I.h(this,R,b,this.comparator)&&(this.f+=1),this}delete(R){const b=I.k(this,R,this.comparator);return b&&(this.f-=1),b}forEach(R,b){let d=this.e.forward[0];for(;d;)R.call(b,d.value,d.key,this),d=d.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this.e.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static g(R,b,d){let P=R.e;for(let p=R.d-1;p>=0;p--)for(;P.forward[p]&&d(P.forward[p].key,b)<0;)P=P.forward[p];if(P=P.forward[0],P&&d(P.key,b)===0)return P}static h(R,b,d,P){const p=[];let w=R.e;for(let h=R.d-1;h>=0;h--){for(;w.forward[h]&&P(w.forward[h].key,b)<0;)w=w.forward[h];p[h]=w}if(w=w.forward[0],w&&P(w.key,b)===0)return w.value=d,!1;{const h=I.j(R);if(h>R.d){for(let m=R.d;m<h;m++)p[m]=R.e;R.d=h}w=new O(h,b,d);for(let m=0;m<h;m++)w.forward[m]=p[m].forward[m],p[m].forward[m]=w;return!0}}static j(R,b=.5){let d=1;for(;Math.random()<b&&d<R.c;)d+=1;return d}static k(R,b,d){const P=[];let p=R.e;for(let w=R.d-1;w>=0;w--){for(;p.forward[w]&&d(p.forward[w].key,b)<0;)p=p.forward[w];P[w]=p}if(p=p.forward[0],!p||d(p.key,b)!==0)return!1;for(let w=0;w<R.d&&P[w].forward[w]===p;w++)P[w].forward[w]=p.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===a;)R.d-=1;return!0}}e.$$q=I}),define(be[98],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(I){return new O(I)}constructor(I){this.c=y&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1c=O}),define(be[5],we([1,0,11,71,2,96,98]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.Event=void 0;const R=!1,b=!1;var d;(function(k){k.None=()=>a.$kb.None;function v(z){if(b){const{onDidAddListener:q}=z,W=m.create();let U=0;z.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),W.print()),q?.()}}}function C(z,q){return se(z,()=>{},0,void 0,!0,void 0,q)}k.defer=C;function A(z){return(q,W=null,U)=>{let X=!1,G;return G=z(Y=>{if(!X)return G?G.dispose():X=!0,q.call(W,Y)},null,U),X&&G.dispose(),G}}k.once=A;function M(z,q,W){return ge((U,X=null,G)=>z(Y=>U.call(X,q(Y)),null,G),W)}k.map=M;function K(z,q,W){return ge((U,X=null,G)=>z(Y=>{q(Y),U.call(X,Y)},null,G),W)}k.forEach=K;function te(z,q,W){return ge((U,X=null,G)=>z(Y=>q(Y)&&U.call(X,Y),null,G),W)}k.filter=te;function he(z){return z}k.signal=he;function ce(...z){return(q,W=null,U)=>(0,a.$hb)(...z.map(X=>X(G=>q.call(W,G),null,U)))}k.any=ce;function le(z,q,W,U){let X=W;return M(z,G=>(X=q(X,G),X),U)}k.reduce=le;function ge(z,q){let W;const U={onWillAddFirstListener(){W=z(X.fire,X)},onDidRemoveLastListener(){W?.dispose()}};q||v(U);const X=new g(U);return q?.add(X),X.event}function se(z,q,W=100,U=!1,X=!1,G,Y){let ue,pe,Se,Ce=0,Fe;const ze={leakWarningThreshold:G,onWillAddFirstListener(){ue=z(Ee=>{Ce++,pe=q(pe,Ee),U&&!Se&&(me.fire(pe),pe=void 0),Fe=()=>{const ye=pe;pe=void 0,Se=void 0,(!U||Ce>1)&&me.fire(ye),Ce=0},typeof W=="number"?(clearTimeout(Se),Se=setTimeout(Fe,W)):Se===void 0&&(Se=0,queueMicrotask(Fe))})},onWillRemoveListener(){X&&Ce>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,ue.dispose()}};Y||v(ze);const me=new g(ze);return Y?.add(me),me.event}k.debounce=se;function V(z,q=0,W){return k.debounce(z,(U,X)=>U?(U.push(X),U):[X],q,void 0,!0,void 0,W)}k.accumulate=V;function ie(z,q=(U,X)=>U===X,W){let U=!0,X;return te(z,G=>{const Y=U||!q(G,X);return U=!1,X=G,Y},W)}k.latch=ie;function J(z,q,W){return[k.filter(z,q,W),k.filter(z,U=>!q(U),W)]}k.split=J;function Z(z,q=!1,W=[]){let U=W.slice(),X=z(ue=>{U?U.push(ue):Y.fire(ue)});const G=()=>{U?.forEach(ue=>Y.fire(ue)),U=null},Y=new g({onWillAddFirstListener(){X||(X=z(ue=>Y.fire(ue)))},onDidAddFirstListener(){U&&(q?setTimeout(G):G())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return Y.event}k.buffer=Z;class H{constructor(q){this.event=q,this.d=new a.$jb}map(q){return new H(M(this.event,q,this.d))}forEach(q){return new H(K(this.event,q,this.d))}filter(q){return new H(te(this.event,q,this.d))}reduce(q,W){return new H(le(this.event,q,W,this.d))}latch(){return new H(ie(this.event,void 0,this.d))}debounce(q,W=100,U=!1,X=!1,G){return new H(se(this.event,q,W,U,X,G,this.d))}on(q,W,U){return this.event(q,W,U)}once(q,W,U){return A(this.event)(q,W,U)}dispose(){this.d.dispose()}}function B(z){return new H(z)}k.chain=B;function ne(z,q,W=U=>U){const U=(...ue)=>Y.fire(W(...ue)),X=()=>z.on(q,U),G=()=>z.removeListener(q,U),Y=new g({onWillAddFirstListener:X,onDidRemoveLastListener:G});return Y.event}k.fromNodeEventEmitter=ne;function Q(z,q,W=U=>U){const U=(...ue)=>Y.fire(W(...ue)),X=()=>z.addEventListener(q,U),G=()=>z.removeEventListener(q,U),Y=new g({onWillAddFirstListener:X,onDidRemoveLastListener:G});return Y.event}k.fromDOMEventEmitter=Q;function _(z){return new Promise(q=>A(z)(q))}k.toPromise=_;function T(z,q){return q(void 0),z(W=>q(W))}k.runAndSubscribe=T;function S(z,q){let W=null;function U(G){W?.dispose(),W=new a.$jb,q(G,W)}U(void 0);const X=z(G=>U(G));return(0,a.$ib)(()=>{X.dispose(),W?.dispose()})}k.runAndSubscribeWithStore=S;class F{constructor(q,W){this._observable=q,this.d=0,this.f=!1;const U={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};W||v(U),this.emitter=new g(U),W&&W.add(this.emitter)}beginUpdate(q){this.d++}handlePossibleChange(q){}handleChange(q,W){this.f=!0}endUpdate(q){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function ee(z,q){return new F(z,q).emitter.event}k.fromObservable=ee;function oe(z){return q=>{let W=0,U=!1;const X={beginUpdate(){W++},endUpdate(){W--,W===0&&(z.reportChanges(),U&&(U=!1,q()))},handlePossibleChange(){},handleChange(){U=!0}};return z.addObserver(X),{dispose(){z.removeObserver(X)}}}}k.fromObservableLight=oe})(d||(e.Event=d={}));class P{constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${P.d++}`,P.all.add(this)}start(v){this.f=new L.$1c,this.listenerCount=v}stop(){if(this.f){const v=this.f.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.f=void 0}}}e.$3c=P,P.all=new Set,P.d=0;let p=-1;function w(k){const v=p;return p=k,{dispose(){p=v}}}e.$4c=w;class h{constructor(v,C=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=C,this.f=0}dispose(){this.d?.clear()}check(v,C){const A=this.threshold;if(A<=0||C<A)return;this.d||(this.d=new Map);const M=this.d.get(v.value)||0;if(this.d.set(v.value,M+1),this.f-=1,this.f<=0){this.f=A*.5;let K,te=0;for(const[he,ce]of this.d)(!K||te<ce)&&(K=he,te=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${te}):`),console.warn(K)}return()=>{const K=this.d.get(v.value)||0;this.d.set(v.value,K-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let $=0;class o{constructor(v){this.value=v,this.id=$++}}const u=2,l=(k,v)=>{if(k instanceof o)v(k);else for(let C=0;C<k.length;C++){const A=k[C];A&&v(A)}};class g{constructor(v){this.u=0,this.d=v,this.f=p>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??p):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(R){const v=this.q;queueMicrotask(()=>{l(v,C=>C.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(v,C,A)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),a.$kb.None;if(this.j)return a.$kb.None;C&&(v=v.bind(C));const M=new o(v);let K,te;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(M.stack=m.create(),K=this.f.check(M.stack,this.u+1)),R&&(M.stack=te??m.create()),this.q?this.q instanceof o?(this.t??=new E,this.q=[this.q,M]):this.q.push(M):(this.d?.onWillAddFirstListener?.(this),this.q=M,this.d?.onDidAddFirstListener?.(this)),this.u++;const he=(0,a.$ib)(()=>{K?.(),this.v(M)});return A instanceof a.$jb?A.add(he):Array.isArray(A)&&A.push(he),he},this.m}v(v){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const C=this.q,A=C.indexOf(v);if(A===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,C[A]=void 0;const M=this.t.current===this;if(this.u*u<=C.length){let K=0;for(let te=0;te<C.length;te++)C[te]?C[K++]=C[te]:M&&(this.t.end--,K<this.t.i&&this.t.i--);C.length=K}}w(v,C){if(!v)return;const A=this.d?.onListenerError||y.$X;if(!A){v.value(C);return}try{v.value(C)}catch(M){A(M)}}x(v){const C=v.current.q;for(;v.i<v.end;)this.w(C[v.i++],v.value);v.reset()}fire(v){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof o)this.w(this.q,v);else{const C=this.t;C.enqueue(this,v,this.q.length),this.x(C)}this.g?.stop()}hasListeners(){return this.u>0}}e.$5c=g;const D=()=>new E;e.$6c=D;class E{constructor(){this.i=-1,this.end=0}enqueue(v,C,A){this.i=0,this.end=A,this.current=v,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends g{async fireAsync(v,C,A){if(this.q)for(this.h||(this.h=new I.$jc),l(this.q,M=>this.h.push([M.value,v]));this.h.size>0&&!C.isCancellationRequested;){const[M,K]=this.h.shift(),te=[],he={...K,token:C,waitUntil:ce=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");A&&(ce=A(ce,M)),te.push(ce)}};try{M(he)}catch(ce){(0,y.$X)(ce);continue}Object.freeze(te),await Promise.allSettled(te).then(ce=>{for(const le of ce)le.status==="rejected"&&(0,y.$X)(le.reason)})}}}e.$7c=t;class i extends g{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new I.$jc,this.y=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.y(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.u&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$8c=i;class r extends i{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$9c=r;class n extends g{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$0c=n;class s{constructor(){this.f=!1,this.g=[],this.d=new g({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(v){const C={event:v,listener:null};this.g.push(C),this.f&&this.k(C);const A=()=>{this.f&&this.m(C);const M=this.g.indexOf(C);this.g.splice(M,1)};return(0,a.$ib)((0,O.$bb)(A))}h(){this.f=!0,this.g.forEach(v=>this.k(v))}j(){this.f=!1,this.g.forEach(v=>this.m(v))}k(v){v.listener=v.event(C=>this.d.fire(C))}m(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.d.dispose()}}e.$$c=s;class c{constructor(){this.d=[]}wrapEvent(v){return(C,A,M)=>v(K=>{const te=this.d[this.d.length-1];te?te.push(()=>C.call(A,K)):C.call(A,K)},void 0,M)}bufferEvents(v){const C=[];this.d.push(C);const A=v();return this.d.pop(),C.forEach(M=>M()),A}}e.$_c=c;class f{constructor(){this.d=!1,this.f=d.None,this.g=a.$kb.None,this.h=new g({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(v){this.f=v,this.d&&(this.g.dispose(),this.g=v(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$ad=f}),define(be[20],we([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.CancellationToken=void 0;const O=Object.freeze(function(R,b){const d=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(d)}}});var a;(function(R){function b(d){return d===R.None||d===R.Cancelled||d instanceof I?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(a||(e.CancellationToken=a={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new y.$5c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(b){this.a=void 0,this.b=void 0,this.b=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new I),this.a}cancel(){this.a?this.a instanceof I&&this.a.cancel():this.a=a.Cancelled}dispose(b=!1){b&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof I&&this.a.dispose():this.a=a.None}}e.$bd=L}),define(be[144],we([1,0,20]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=void 0;class O{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new y.$bd,b=this.b(R.token);return this.a={promise:b,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$cd=O;class a{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const b=JSON.stringify(R);return this.b!==b&&(this.b=b,this.a=this.c(R)),this.a}}e.$dd=a;class I{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const b=this.b(R);return this.a.set(R,b),b}}e.$ed=I}),define(be[47],we([1,0,11,2]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function a(D){const E=D;return E?typeof E.read=="function":!1}e.$tb=a;function I(D){const E=D;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.$ub=I;function L(D){const E=D;return E?I(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$vb=L;function R(D,E){return new b(D,E)}e.$wb=R;class b{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,y.$X)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let i;switch(E){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const r=i.indexOf(t);r>=0&&i.splice(r,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(D,E){const t=[];let i;for(;(i=D.read())!==null;)t.push(i);return E(t)}e.$xb=d;function P(D,E,t){const i=[];let r;for(;(r=D.read())!==null&&i.length<t;)i.push(r);return r===null&&i.length>0?E(i):{read:()=>{if(i.length>0)return i.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return D.read()}}}e.$yb=P;function p(D,E){return new Promise((t,i)=>{const r=[];w(D,{onData:n=>{E&&r.push(n)},onError:n=>{E?i(n):t(void 0)},onEnd:()=>{t(E?E(r):void 0)}})})}e.$zb=p;function w(D,E){let t=!1;return D.on("error",i=>{t||E.onError(i)}),D.on("end",()=>{t||E.onEnd()}),D.on("data",i=>{t||E.onData(i)}),(0,O.$ib)(()=>t=!0)}e.$Ab=w;function h(D,E){return new Promise((t,i)=>{const r=new O.$jb,n=[],s=k=>{if(n.push(k),n.length>E)return r.dispose(),D.pause(),t({stream:D,buffer:n,ended:!1})},c=k=>i(k),f=()=>t({stream:D,buffer:n,ended:!0});r.add((0,O.$ib)(()=>D.removeListener("error",c))),D.on("error",c),r.add((0,O.$ib)(()=>D.removeListener("end",f))),D.on("end",f),r.add((0,O.$ib)(()=>D.removeListener("data",s))),D.on("data",s)})}e.$Bb=h;function m(D,E){const t=R(E);return t.end(D),t}e.$Cb=m;function $(){const D=R(()=>{throw new Error("not supported")});return D.end(),D}e.$Db=$;function o(D){let E=!1;return{read:()=>E?null:(E=!0,D)}}e.$Eb=o;function u(D,E,t){const i=R(t);return w(D,{onData:r=>i.write(E.data(r)),onError:r=>i.error(E.error?E.error(r):r),onEnd:()=>i.end()}),i}e.$Fb=u;function l(D,E,t){let i=!1;return{read:()=>{const r=E.read();return i?r:(i=!0,r!==null?t([D,r]):D)}}}e.$Gb=l;function g(D,E,t){let i=!1;const r=R(t);return w(E,{onData:n=>i?r.write(n):(i=!0,r.write(t([D,n]))),onError:n=>r.error(n),onEnd:()=>{i||(i=!0,r.write(D)),r.end()}}),r}e.$Hb=g}),define(be[15],we([1,0,95,47]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const a=typeof Buffer<"u",I=new y.$S(()=>new Uint8Array(256));let L,R;class b{static alloc(C){return a?new b(Buffer.allocUnsafe(C)):new b(new Uint8Array(C))}static wrap(C){return a&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new b(C)}static fromString(C,A){return!(A?.dontUseNodeBuffer||!1)&&a?new b(Buffer.from(C)):(L||(L=new TextEncoder),new b(L.encode(C)))}static fromByteArray(C){const A=b.alloc(C.length);for(let M=0,K=C.length;M<K;M++)A.buffer[M]=C[M];return A}static concat(C,A){if(typeof A>"u"){A=0;for(let te=0,he=C.length;te<he;te++)A+=C[te].byteLength}const M=b.alloc(A);let K=0;for(let te=0,he=C.length;te<he;te++){const ce=C[te];M.set(ce,K),K+=ce.byteLength}return M}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=b.alloc(this.byteLength);return C.set(this),C}toString(){return a?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(C,A){return new b(this.buffer.subarray(C,A))}set(C,A){if(C instanceof b)this.buffer.set(C.buffer,A);else if(C instanceof Uint8Array)this.buffer.set(C,A);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),A);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,A){w(this.buffer,C,A)}readUInt32LE(C){return h(this.buffer,C)}writeUInt32LE(C,A){m(this.buffer,C,A)}readUInt8(C){return $(this.buffer,C)}writeUInt8(C,A){o(this.buffer,C,A)}indexOf(C){const A=C instanceof b?C.buffer:C,M=A.byteLength,K=this.buffer,te=K.byteLength;if(M===0)return 0;if(M===1)return K.indexOf(A[0]);if(M>te)return-1;const he=I.value;he.fill(A.length);for(let se=0;se<A.length;se++)he[A[se]]=A.length-se-1;let ce=A.length-1,le=ce,ge=-1;for(;ce<te;)if(K[ce]===A[le]){if(le===0){ge=ce;break}ce--,le--}else ce+=Math.max(A.length-le,he[K[ce]]),le=A.length-1;return ge}}e.$Ib=b;function d(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0}e.$Jb=d;function P(v,C,A){v[A+0]=C&255,C=C>>>8,v[A+1]=C&255}e.$Kb=P;function p(v,C){return v[C]*2**24+v[C+1]*2**16+v[C+2]*2**8+v[C+3]}e.$Lb=p;function w(v,C,A){v[A+3]=C,C=C>>>8,v[A+2]=C,C=C>>>8,v[A+1]=C,C=C>>>8,v[A]=C}e.$Mb=w;function h(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0|v[C+2]<<16>>>0|v[C+3]<<24>>>0}e.$Nb=h;function m(v,C,A){v[A+0]=C&255,C=C>>>8,v[A+1]=C&255,C=C>>>8,v[A+2]=C&255,C=C>>>8,v[A+3]=C&255}e.$Ob=m;function $(v,C){return v[C]}e.$Pb=$;function o(v,C,A){v[A]=C}e.$Qb=o;function u(v){return O.$xb(v,C=>b.concat(C))}e.$Rb=u;function l(v){return O.$Eb(v)}e.$Sb=l;function g(v){return O.$zb(v,C=>b.concat(C))}e.$Tb=g;async function D(v){return v.ended?b.concat(v.buffer):b.concat([...v.buffer,await g(v.stream)])}e.$Ub=D;function E(v){return O.$Cb(v,C=>b.concat(C))}e.$Vb=E;function t(v){return O.$Fb(v,{data:C=>typeof C=="string"?b.fromString(C):b.wrap(C)},C=>b.concat(C))}e.$Wb=t;function i(v){return O.$wb(C=>b.concat(C),v)}e.$Xb=i;function r(v,C){return O.$Gb(v,C,A=>b.concat(A))}e.$Yb=r;function n(v,C){return O.$Hb(v,C,A=>b.concat(A))}e.$Zb=n;function s(v){let C=0,A=0,M=0;const K=new Uint8Array(Math.floor(v.length/4*3)),te=ce=>{switch(A){case 3:K[M++]=C|ce,A=0;break;case 2:K[M++]=C|ce>>>2,C=ce<<6,A=3;break;case 1:K[M++]=C|ce>>>4,C=ce<<4,A=2;break;default:C=ce<<2,A=1}};for(let ce=0;ce<v.length;ce++){const le=v.charCodeAt(ce);if(le>=65&&le<=90)te(le-65);else if(le>=97&&le<=122)te(le-97+26);else if(le>=48&&le<=57)te(le-48+52);else if(le===43||le===45)te(62);else if(le===47||le===95)te(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ce]}`)}}const he=M;for(;A>0;)te(0);return b.wrap(K).slice(0,he)}e.$1b=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:v},C=!0,A=!1){const M=A?f:c;let K="";const te=v.byteLength%3;let he=0;for(;he<v.byteLength-te;he+=3){const ce=v[he+0],le=v[he+1],ge=v[he+2];K+=M[ce>>>2],K+=M[(ce<<4|le>>>4)&63],K+=M[(le<<2|ge>>>6)&63],K+=M[ge&63]}if(te===1){const ce=v[he+0];K+=M[ce>>>2],K+=M[ce<<4&63],C&&(K+="==")}else if(te===2){const ce=v[he+0],le=v[he+1];K+=M[ce>>>2],K+=M[(ce<<4|le>>>4)&63],K+=M[le<<2&63],C&&(K+="=")}return K}e.$2b=k}),define(be[17],we([1,0,144,95]),function(ae,e,y,O){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.GraphemeBreakType=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=void 0;function I(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.$hd=I;const L=/{(\d+)}/g;function R(fe,...De){return De.length===0?fe:fe.replace(L,function(Le,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=De.length?Le:De[Oe]})}e.$id=R;const b=/{([^}]+)}/g;function d(fe,De){return fe.replace(b,(Le,Ie)=>De[Ie]??Le)}e.$jd=d;function P(fe){return fe.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.$kd=P;function p(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$ld=p;function w(fe,De){let Le=0;const Ie=De.charCodeAt(0);for(let Oe=fe.length-1;Oe>=0;Oe--)fe.charCodeAt(Oe)===Ie&&Le++;return Le}e.$md=w;function h(fe,De,Le="\u2026"){return fe.length<=De?fe:`${fe.substr(0,De)}${Le}`}e.$nd=h;function m(fe,De=" "){const Le=$(fe,De);return o(Le,De)}e.$od=m;function $(fe,De){if(!fe||!De)return fe;const Le=De.length;if(Le===0||fe.length===0)return fe;let Ie=0;for(;fe.indexOf(De,Ie)===Ie;)Ie=Ie+Le;return fe.substring(Ie)}e.$pd=$;function o(fe,De){if(!fe||!De)return fe;const Le=De.length,Ie=fe.length;if(Le===0||Ie===0)return fe;let Oe=Ie,qe=-1;for(;qe=fe.lastIndexOf(De,Oe-1),!(qe===-1||qe+Le!==Oe);){if(qe===0)return"";Oe=qe}return fe.substring(0,Oe)}e.$qd=o;function u(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$rd=u;function l(fe){return fe.replace(/\*/g,"")}e.$sd=l;function g(fe,De,Le={}){if(!fe)throw new Error("Cannot create regex from empty string");De||(fe=p(fe)),Le.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Ie="";return Le.global&&(Ie+="g"),Le.matchCase||(Ie+="i"),Le.multiline&&(Ie+="m"),Le.unicode&&(Ie+="u"),new RegExp(fe,Ie)}e.$td=g;function D(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.$ud=D;function E(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$vd=E;function t(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.$wd=t;function i(fe){return fe.split(/\r\n|\r|\n/)}e.$xd=i;function r(fe){for(let De=0,Le=fe.length;De<Le;De++){const Ie=fe.charCodeAt(De);if(Ie!==32&&Ie!==9)return De}return-1}e.$yd=r;function n(fe,De=0,Le=fe.length){for(let Ie=De;Ie<Le;Ie++){const Oe=fe.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return fe.substring(De,Ie)}return fe.substring(De,Le)}e.$zd=n;function s(fe,De=fe.length-1){for(let Le=De;Le>=0;Le--){const Ie=fe.charCodeAt(Le);if(Ie!==32&&Ie!==9)return Le}return-1}e.$Ad=s;function c(fe,De,Le){const Ie=[];let Oe=0;for(const qe of fe.matchAll(De)){if(Ie.push(fe.slice(Oe,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Oe=qe.index+qe[0].length,Ie.push(Le(qe[0],...qe.slice(1),qe.index,fe,qe.groups))}return Ie.push(fe.slice(Oe)),Promise.all(Ie).then(qe=>qe.join(""))}e.$Bd=c;function f(fe,De){return fe<De?-1:fe>De?1:0}e.$Cd=f;function k(fe,De,Le=0,Ie=fe.length,Oe=0,qe=De.length){for(;Le<Ie&&Oe<qe;Le++,Oe++){const et=fe.charCodeAt(Le),Je=De.charCodeAt(Oe);if(et<Je)return-1;if(et>Je)return 1}const He=Ie-Le,Ke=qe-Oe;return He<Ke?-1:He>Ke?1:0}e.$Dd=k;function v(fe,De){return C(fe,De,0,fe.length,0,De.length)}e.$Ed=v;function C(fe,De,Le=0,Ie=fe.length,Oe=0,qe=De.length){for(;Le<Ie&&Oe<qe;Le++,Oe++){let et=fe.charCodeAt(Le),Je=De.charCodeAt(Oe);if(et===Je)continue;if(et>=128||Je>=128)return k(fe.toLowerCase(),De.toLowerCase(),Le,Ie,Oe,qe);M(et)&&(et-=32),M(Je)&&(Je-=32);const st=et-Je;if(st!==0)return st}const He=Ie-Le,Ke=qe-Oe;return He<Ke?-1:He>Ke?1:0}e.$Fd=C;function A(fe){return fe>=48&&fe<=57}e.$Gd=A;function M(fe){return fe>=97&&fe<=122}e.$Hd=M;function K(fe){return fe>=65&&fe<=90}e.$Id=K;function te(fe,De){return fe.length===De.length&&C(fe,De)===0}e.$Jd=te;function he(fe,De){const Le=De.length;return De.length>fe.length?!1:C(fe,De,0,Le)===0}e.$Kd=he;function ce(fe,De){const Le=Math.min(fe.length,De.length);let Ie;for(Ie=0;Ie<Le;Ie++)if(fe.charCodeAt(Ie)!==De.charCodeAt(Ie))return Ie;return Le}e.$Ld=ce;function le(fe,De){const Le=Math.min(fe.length,De.length);let Ie;const Oe=fe.length-1,qe=De.length-1;for(Ie=0;Ie<Le;Ie++)if(fe.charCodeAt(Oe-Ie)!==De.charCodeAt(qe-Ie))return Ie;return Le}e.$Md=le;function ge(fe){return 55296<=fe&&fe<=56319}e.$Nd=ge;function se(fe){return 56320<=fe&&fe<=57343}e.$Od=se;function V(fe,De){return(fe-55296<<10)+(De-56320)+65536}e.$Pd=V;function ie(fe,De,Le){const Ie=fe.charCodeAt(Le);if(ge(Ie)&&Le+1<De){const Oe=fe.charCodeAt(Le+1);if(se(Oe))return V(Ie,Oe)}return Ie}e.$Qd=ie;function J(fe,De){const Le=fe.charCodeAt(De-1);if(se(Le)&&De>1){const Ie=fe.charCodeAt(De-2);if(ge(Ie))return V(Ie,Le)}return Le}class Z{get offset(){return this.e}constructor(De,Le=0){this.c=De,this.d=De.length,this.e=Le}setOffset(De){this.e=De}prevCodePoint(){const De=J(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=ie(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.$Rd=Z;class H{get offset(){return this.c.offset}constructor(De,Le=0){this.c=new Z(De,Le)}nextGraphemeLength(){const De=Te.getInstance(),Le=this.c,Ie=Le.offset;let Oe=De.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const qe=Le.offset,He=De.getGraphemeBreakType(Le.nextCodePoint());if(ye(Oe,He)){Le.setOffset(qe);break}Oe=He}return Le.offset-Ie}prevGraphemeLength(){const De=Te.getInstance(),Le=this.c,Ie=Le.offset;let Oe=De.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const qe=Le.offset,He=De.getGraphemeBreakType(Le.prevCodePoint());if(ye(He,Oe)){Le.setOffset(qe);break}Oe=He}return Ie-Le.offset}eol(){return this.c.eol()}}e.$Sd=H;function B(fe,De){return new H(fe,De).nextGraphemeLength()}e.$Td=B;function ne(fe,De){return new H(fe,De).prevGraphemeLength()}e.$Ud=ne;function Q(fe,De){De>0&&se(fe.charCodeAt(De))&&De--;const Le=De+B(fe,De);return[Le-ne(fe,Le),Le]}e.$Vd=Q;function _(fe){const De=new H(fe);let Le=0;for(;!De.eol();)Le++,De.nextGraphemeLength();return Le}e.$Wd=_;let T;function S(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(fe){return T||(T=S()),T.test(fe)}e.$Xd=F;const ee=/^[\t\n\r\x20-\x7E]*$/;function oe(fe){return ee.test(fe)}e.$Yd=oe,e.$Zd=/[\u2028\u2029]/;function z(fe){return e.$Zd.test(fe)}e.$1d=z;function q(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.$2d=q;function W(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.$3d=W;function U(fe,De){if(fe.length<De)return fe;const Le=/\b/g;let Ie=0;for(;Le.test(fe)&&!(fe.length-Le.lastIndex<De);)Ie=Le.lastIndex,Le.lastIndex+=1;return fe.substring(Ie).replace(/^\s/,"")}e.$4d=U;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Y(fe){return fe&&(fe=fe.replace(X,"").replace(G,"")),fe}e.$5d=Y,e.$6d=String.fromCharCode(65279);function ue(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.$7d=ue;function pe(fe){return ue(fe)?fe.substr(1):fe}e.$8d=pe;function Se(fe,De){if(!fe||!De||fe.length<De.length)return!1;const Le=De.length,Ie=fe.toLowerCase();let Oe=0,qe=-1;for(;Oe<Le;){const He=Ie.indexOf(De[Oe],qe+1);if(He<0)return!1;qe=He,Oe++}return!0}e.$9d=Se;function Ce(fe,De=!1){return fe?(De&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.$0d=Ce;function Fe(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.$$d=Fe;function ze(fe,De=1){if(De===0)return"";let Le=-1;do Le=fe.indexOf(`
`,Le+1),De--;while(De>0&&Le>=0);return Le===-1?fe:(fe[Le-1]==="\r"&&Le--,fe.substr(0,Le))}e.$_d=ze;function me(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.$ae=me;function Ee(fe){return Te.getInstance().getGraphemeBreakType(fe)}e.$be=Ee;function ye(fe,De){return fe===0?De!==5&&De!==7:fe===2&&De===3?!1:fe===4||fe===2||fe===3||De===4||De===2||De===3?!0:!(fe===8&&(De===8||De===9||De===11||De===12)||(fe===11||fe===9)&&(De===9||De===10)||(fe===12||fe===10)&&De===10||De===5||De===13||De===7||fe===1||fe===13&&De===14||fe===6&&De===6)}var je;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=xe()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Le=this.d,Ie=Le.length/3;let Oe=1;for(;Oe<=Ie;)if(De<Le[3*Oe])Oe=2*Oe;else if(De>Le[3*Oe+1])Oe=2*Oe+1;else return Le[3*Oe+2];return 0}}Te.c=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(fe,De){if(fe===0)return 0;const Le=Ze(fe,De);if(Le!==void 0)return Le;const Ie=new Z(De,fe);return Ie.prevCodePoint(),Ie.offset}e.$ce=Be;function Ze(fe,De){const Le=new Z(De,fe);let Ie=Le.prevCodePoint();for(;Ye(Ie)||Ie===65039||Ie===8419;){if(Le.offset===0)return;Ie=Le.prevCodePoint()}if(!W(Ie))return;let Oe=Le.offset;return Oe>0&&Le.prevCodePoint()===8205&&(Oe=Le.offset),Oe}function Ye(fe){return 127995<=fe&&fe<=127999}var it;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$de="\xA0";class Xe{static getInstance(De){return Xe.d.get(Array.from(De))}static getLocales(){return Xe.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ee=Xe,a=Xe,Xe.c=new O.$S(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Xe.d=new y.$dd(fe=>{function De(Je){const st=new Map;for(let ct=0;ct<Je.length;ct+=2)st.set(Je[ct],Je[ct+1]);return st}function Le(Je,st){const ct=new Map(Je);for(const[ot,pt]of st)ct.set(ot,pt);return ct}function Ie(Je,st){if(!Je)return st;const ct=new Map;for(const[ot,pt]of Je)st.has(ot)&&ct.set(ot,pt);return ct}const Oe=a.c.value;let qe=fe.filter(Je=>!Je.startsWith("_")&&Je in Oe);qe.length===0&&(qe=["_default"]);let He;for(const Je of qe){const st=De(Oe[Je]);He=Ie(He,st)}const Ke=De(Oe._common),et=Le(Ke,He);return new Xe(et)}),Xe.e=new O.$S(()=>Object.keys(Xe.c.value).filter(fe=>!fe.startsWith("_")));class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(De){return Ge.e().has(De)}static get codePoints(){return Ge.e()}}e.$fe=Ge,Ge.d=void 0}),define(be[145],we([1,0,28,17]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.FuzzyScore=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.or=void 0;function a(...G){return function(Y,ue){for(let pe=0,Se=G.length;pe<Se;pe++){const Ce=G[pe](Y,ue);if(Ce)return Ce}return null}}e.or=a,e.$gj=I.bind(void 0,!1),e.$hj=I.bind(void 0,!0);function I(G,Y,ue){if(!ue||ue.length<Y.length)return null;let pe;return G?pe=O.$Kd(ue,Y):pe=ue.indexOf(Y)===0,pe?Y.length>0?[{start:0,end:Y.length}]:[]:null}function L(G,Y){const ue=Y.toLowerCase().indexOf(G.toLowerCase());return ue===-1?null:[{start:ue,end:ue+G.length}]}e.$ij=L;function R(G,Y){return b(G.toLowerCase(),Y.toLowerCase(),0,0)}e.$jj=R;function b(G,Y,ue,pe){if(ue===G.length)return[];if(pe===Y.length)return null;if(G[ue]===Y[pe]){let Se=null;return(Se=b(G,Y,ue+1,pe+1))?u({start:pe,end:pe+1},Se):null}return b(G,Y,ue,pe+1)}function d(G){return 97<=G&&G<=122}function P(G){return 65<=G&&G<=90}e.$kj=P;function p(G){return 48<=G&&G<=57}function w(G){return G===32||G===9||G===10||G===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>h.add(G.charCodeAt(0)));function m(G){return w(G)||h.has(G)}function $(G,Y){return G===Y||m(G)&&m(Y)}function o(G){return d(G)||P(G)||p(G)}function u(G,Y){return Y.length===0?Y=[G]:G.end===Y[0].start?Y[0].start=G.start:Y.unshift(G),Y}function l(G,Y){for(let ue=Y;ue<G.length;ue++){const pe=G.charCodeAt(ue);if(P(pe)||p(pe)||ue>0&&!o(G.charCodeAt(ue-1)))return ue}return G.length}function g(G,Y,ue,pe){if(ue===G.length)return[];if(pe===Y.length)return null;if(G[ue]!==Y[pe].toLowerCase())return null;{let Se=null,Ce=pe+1;for(Se=g(G,Y,ue+1,pe+1);!Se&&(Ce=l(Y,Ce))<Y.length;)Se=g(G,Y,ue+1,Ce),Ce++;return Se===null?null:u({start:pe,end:pe+1},Se)}}function D(G){let Y=0,ue=0,pe=0,Se=0,Ce=0;for(let ye=0;ye<G.length;ye++)Ce=G.charCodeAt(ye),P(Ce)&&Y++,d(Ce)&&ue++,o(Ce)&&pe++,p(Ce)&&Se++;const Fe=Y/G.length,ze=ue/G.length,me=pe/G.length,Ee=Se/G.length;return{upperPercent:Fe,lowerPercent:ze,alphaPercent:me,numericPercent:Ee}}function E(G){const{upperPercent:Y,lowerPercent:ue}=G;return ue===0&&Y>.6}function t(G){const{upperPercent:Y,lowerPercent:ue,alphaPercent:pe,numericPercent:Se}=G;return ue>.2&&Y<.8&&pe>.6&&Se<.2}function i(G){let Y=0,ue=0,pe=0,Se=0;for(let Ce=0;Ce<G.length;Ce++)pe=G.charCodeAt(Ce),P(pe)&&Y++,d(pe)&&ue++,w(pe)&&Se++;return(Y===0||ue===0)&&Se===0?G.length<=30:Y<=5}function r(G,Y){if(!Y||(Y=Y.trim(),Y.length===0)||!i(G)||Y.length>60)return null;const ue=D(Y);if(!t(ue)){if(!E(ue))return null;Y=Y.toLowerCase()}let pe=null,Se=0;for(G=G.toLowerCase();Se<Y.length&&(pe=g(G,Y,0,Se))===null;)Se=l(Y,Se+1);return pe}e.$lj=r;function n(G,Y,ue=!1){if(!Y||Y.length===0)return null;let pe=null,Se=0;for(G=G.toLowerCase(),Y=Y.toLowerCase();Se<Y.length&&(pe=s(G,Y,0,Se,ue))===null;)Se=c(Y,Se+1);return pe}e.$mj=n;function s(G,Y,ue,pe,Se){if(ue===G.length)return[];if(pe===Y.length)return null;if($(G.charCodeAt(ue),Y.charCodeAt(pe))){let Ce=null,Fe=pe+1;if(Ce=s(G,Y,ue+1,pe+1,Se),!Se)for(;!Ce&&(Fe=c(Y,Fe))<Y.length;)Ce=s(G,Y,ue+1,Fe,Se),Fe++;return Ce?G.charCodeAt(ue)!==Y.charCodeAt(pe)?Ce:u({start:pe,end:pe+1},Ce):null}else return null}function c(G,Y){for(let ue=Y;ue<G.length;ue++)if(m(G.charCodeAt(ue))||ue>0&&m(G.charCodeAt(ue-1)))return ue;return G.length}const f=a(e.$hj,r,L),k=a(e.$hj,r,R),v=new y.$mi(1e4);function C(G,Y,ue=!1){if(typeof G!="string"||typeof Y!="string")return null;let pe=v.get(G);pe||(pe=new RegExp(O.$rd(G),"i"),v.set(G,pe));const Se=pe.exec(Y);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:ue?k(G,Y):f(G,Y)}e.$nj=C;function A(G,Y){const ue=ee(G,G.toLowerCase(),0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ue?K(ue):null}e.$oj=A;function M(G,Y,ue,pe,Se,Ce){const Fe=Math.min(13,G.length);for(;ue<Fe;ue++){const ze=ee(G,Y,ue,pe,Se,Ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ze)return ze}return[0,Ce]}e.$pj=M;function K(G){if(typeof G>"u")return[];const Y=[],ue=G[1];for(let pe=G.length-1;pe>1;pe--){const Se=G[pe]+ue,Ce=Y[Y.length-1];Ce&&Ce.end===Se?Ce.end=Se+1:Y.push({start:Se,end:Se+1})}return Y}e.$qj=K;const te=128;function he(){const G=[],Y=[];for(let ue=0;ue<=te;ue++)Y[ue]=0;for(let ue=0;ue<=te;ue++)G.push(Y.slice(0));return G}function ce(G){const Y=[];for(let ue=0;ue<=G;ue++)Y[ue]=0;return Y}const le=ce(2*te),ge=ce(2*te),se=he(),V=he(),ie=he(),J=!1;function Z(G,Y,ue,pe,Se){function Ce(ze,me,Ee=" "){for(;ze.length<me;)ze=Ee+ze;return ze}let Fe=` |   |${pe.split("").map(ze=>Ce(ze,3)).join("|")}
`;for(let ze=0;ze<=ue;ze++)ze===0?Fe+=" |":Fe+=`${Y[ze-1]}|`,Fe+=G[ze].slice(0,Se+1).map(me=>Ce(me.toString(),3)).join("|")+`
`;return Fe}function H(G,Y,ue,pe){G=G.substr(Y),ue=ue.substr(pe),console.log(Z(V,G,G.length,ue,ue.length)),console.log(Z(ie,G,G.length,ue,ue.length)),console.log(Z(se,G,G.length,ue,ue.length))}function B(G,Y){if(Y<0||Y>=G.length)return!1;const ue=G.codePointAt(Y);switch(ue){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$3d(ue)}}function ne(G,Y){if(Y<0||Y>=G.length)return!1;switch(G.charCodeAt(Y)){case 32:case 9:return!0;default:return!1}}function Q(G,Y,ue){return Y[G]!==ue[G]}function _(G,Y,ue,pe,Se,Ce,Fe=!1){for(;Y<ue&&Se<Ce;)G[Y]===pe[Se]&&(Fe&&(le[Y]=Se),Y+=1),Se+=1;return Y===ue}e.$rj=_;var T;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(T||(T={}));var S;(function(G){G.Default=[-100,0];function Y(ue){return!ue||ue.length===2&&ue[0]===-100&&ue[1]===0}G.isDefault=Y})(S||(e.FuzzyScore=S={}));class F{constructor(Y,ue){this.firstMatchCanBeWeak=Y,this.boostFullMatch=ue}}e.$sj=F,F.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ee(G,Y,ue,pe,Se,Ce,Fe=F.default){const ze=G.length>te?te:G.length,me=pe.length>te?te:pe.length;if(ue>=ze||Ce>=me||ze-ue>me-Ce||!_(Y,ue,ze,Se,Ce,me,!0))return;oe(ze,me,ue,Ce,Y,Se);let Ee=1,ye=1,je=ue,Te=Ce;const xe=[!1];for(Ee=1,je=ue;je<ze;Ee++,je++){const Xe=le[je],Ge=ge[je],fe=je+1<ze?ge[je+1]:me;for(ye=Xe-Ce+1,Te=Xe;Te<fe;ye++,Te++){let De=Number.MIN_SAFE_INTEGER,Le=!1;Te<=Ge&&(De=z(G,Y,je,ue,pe,Se,Te,me,Ce,se[Ee-1][ye-1]===0,xe));let Ie=0;De!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ie=De+V[Ee-1][ye-1]);const Oe=Te>Xe,qe=Oe?V[Ee][ye-1]+(se[Ee][ye-1]>0?-5:0):0,He=Te>Xe+1&&se[Ee][ye-1]>0,Ke=He?V[Ee][ye-2]+(se[Ee][ye-2]>0?-5:0):0;if(He&&(!Oe||Ke>=qe)&&(!Le||Ke>=Ie))V[Ee][ye]=Ke,ie[Ee][ye]=3,se[Ee][ye]=0;else if(Oe&&(!Le||qe>=Ie))V[Ee][ye]=qe,ie[Ee][ye]=2,se[Ee][ye]=0;else if(Le)V[Ee][ye]=Ie,ie[Ee][ye]=1,se[Ee][ye]=se[Ee-1][ye-1]+1;else throw new Error("not possible")}}if(J&&H(G,ue,pe,Ce),!xe[0]&&!Fe.firstMatchCanBeWeak)return;Ee--,ye--;const Be=[V[Ee][ye],Ce];let Ze=0,Ye=0;for(;Ee>=1;){let Xe=ye;do{const Ge=ie[Ee][Xe];if(Ge===3)Xe=Xe-2;else if(Ge===2)Xe=Xe-1;else break}while(Xe>=1);Ze>1&&Y[ue+Ee-1]===Se[Ce+ye-1]&&!Q(Xe+Ce-1,pe,Se)&&Ze+1>se[Ee][Xe]&&(Xe=ye),Xe===ye?Ze++:Ze=1,Ye||(Ye=Xe),Ee--,ye=Xe-1,Be.push(ye)}me===ze&&Fe.boostFullMatch&&(Be[0]+=2);const it=Ye-ze;return Be[0]-=it,Be}e.$tj=ee;function oe(G,Y,ue,pe,Se,Ce){let Fe=G-1,ze=Y-1;for(;Fe>=ue&&ze>=pe;)Se[Fe]===Ce[ze]&&(ge[Fe]=ze,Fe--),ze--}function z(G,Y,ue,pe,Se,Ce,Fe,ze,me,Ee,ye){if(Y[ue]!==Ce[Fe])return Number.MIN_SAFE_INTEGER;let je=1,Te=!1;return Fe===ue-pe?je=G[ue]===Se[Fe]?7:5:Q(Fe,Se,Ce)&&(Fe===0||!Q(Fe-1,Se,Ce))?(je=G[ue]===Se[Fe]?7:5,Te=!0):B(Ce,Fe)&&(Fe===0||!B(Ce,Fe-1))?je=5:(B(Ce,Fe-1)||ne(Ce,Fe-1))&&(je=5,Te=!0),je>1&&ue===pe&&(ye[0]=!0),Te||(Te=Q(Fe,Se,Ce)||B(Ce,Fe-1)||ne(Ce,Fe-1)),ue===pe?Fe>me&&(je-=Te?3:5):Ee?je+=Te?2:0:je+=Te?0:1,Fe+1===ze&&(je-=Te?3:5),je}function q(G,Y,ue,pe,Se,Ce,Fe){return U(G,Y,ue,pe,Se,Ce,!0,Fe)}e.$uj=q;function W(G,Y,ue,pe,Se,Ce,Fe){return U(G,Y,ue,pe,Se,Ce,!1,Fe)}e.$vj=W;function U(G,Y,ue,pe,Se,Ce,Fe,ze){let me=ee(G,Y,ue,pe,Se,Ce,ze);if(me&&!Fe)return me;if(G.length>=3){const Ee=Math.min(7,G.length-1);for(let ye=ue+1;ye<Ee;ye++){const je=X(G,ye);if(je){const Te=ee(je,je.toLowerCase(),ue,pe,Se,Ce,ze);Te&&(Te[0]-=3,(!me||Te[0]>me[0])&&(me=Te))}}}return me}function X(G,Y){if(Y+1>=G.length)return;const ue=G[Y],pe=G[Y+1];if(ue!==pe)return G.slice(0,Y)+pe+ue+G.slice(Y+2)}}),define(be[73],we([1,0,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0;function O(u){return a(u,0)}e.$_h=O;function a(u,l){switch(typeof u){case"object":return u===null?I(349,l):Array.isArray(u)?b(u,l):d(u,l);case"string":return R(u,l);case"boolean":return L(u,l);case"number":return I(u,l);case"undefined":return I(937,l);default:return I(617,l)}}e.$ai=a;function I(u,l){return(l<<5)-l+u|0}e.$bi=I;function L(u,l){return I(u?433:863,l)}function R(u,l){l=I(149417,l);for(let g=0,D=u.length;g<D;g++)l=I(u.charCodeAt(g),l);return l}e.$ci=R;function b(u,l){return l=I(104579,l),u.reduce((g,D)=>a(D,g),l)}function d(u,l){return l=I(181387,l),Object.keys(u).sort().reduce((g,D)=>(g=R(D,g),a(u[D],g)),l)}class P{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=a(l,this.g),this.g}}e.$di=P;var p;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function w(u,l,g=32){const D=g-l,E=~((1<<D)-1);return(u<<l|(E&u)>>>D)>>>0}function h(u,l=0,g=u.byteLength,D=0){for(let E=0;E<g;E++)u[l+E]=D}function m(u,l,g="0"){for(;u.length<l;)u=g+u;return u}function $(u,l=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),l/4)}e.$ei=$;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const g=l.length;if(g===0)return;const D=this.p;let E=this.r,t=this.u,i,r;for(t!==0?(i=t,r=-1,t=0):(i=l.charCodeAt(0),r=0);;){let n=i;if(y.$Nd(i))if(r+1<g){const s=l.charCodeAt(r+1);y.$Od(s)?(r++,n=y.$Pd(i,s)):n=65533}else{t=i;break}else y.$Od(i)&&(n=65533);if(E=this.w(D,E,n),r++,r<g)i=l.charCodeAt(r);else break}this.r=E,this.u=t}w(l,g,D){return D<128?l[g++]=D:D<2048?(l[g++]=192|(D&1984)>>>6,l[g++]=128|(D&63)>>>0):D<65536?(l[g++]=224|(D&61440)>>>12,l[g++]=128|(D&4032)>>>6,l[g++]=128|(D&63)>>>0):(l[g++]=240|(D&1835008)>>>18,l[g++]=128|(D&258048)>>>12,l[g++]=128|(D&4032)>>>6,l[g++]=128|(D&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),$(this.h)+$(this.l)+$(this.m)+$(this.n)+$(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=o.g,g=this.q;for(let f=0;f<64;f+=4)l.setUint32(f,g.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)l.setUint32(f,w(l.getUint32(f-12,!1)^l.getUint32(f-32,!1)^l.getUint32(f-56,!1)^l.getUint32(f-64,!1),1),!1);let D=this.h,E=this.l,t=this.m,i=this.n,r=this.o,n,s,c;for(let f=0;f<80;f++)f<20?(n=E&t|~E&i,s=1518500249):f<40?(n=E^t^i,s=1859775393):f<60?(n=E&t|E&i|t&i,s=2400959708):(n=E^t^i,s=3395469782),c=w(D,5)+n+r+s+l.getUint32(f*4,!1)&4294967295,r=i,i=t,t=w(E,30),E=D,D=c;this.h=this.h+D&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+i&4294967295,this.o=this.o+r&4294967295}}e.$fi=o,o.g=new DataView(new ArrayBuffer(320))}),define(be[60],we([1,0,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(a){a[a.Ignore=0]="Ignore",a[a.Info=1]="Info",a[a.Warning=2]="Warning",a[a.Error=3]="Error"})(O||(O={})),function(a){const I="error",L="warning",R="warn",b="info",d="ignore";function P(w){return w?y.$Jd(I,w)?a.Error:y.$Jd(L,w)||y.$Jd(R,w)?a.Warning:y.$Jd(b,w)?a.Info:a.Ignore:a.Ignore}a.fromValue=P;function p(w){switch(w){case a.Error:return I;case a.Warning:return L;case a.Info:return b;default:return d}}a.toString=p}(O||(O={})),e.default=O}),define(be[146],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(be[61],we([1,0,18,17]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;class a{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const m=h.charCodeAt(0),$=this.b.charCodeAt(this.c);return m-$}value(){return this.b[this.c]}}e.$nh=a;class I{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,O.$Dd)(h,this.b,0,h.length,this.c,this.d):(0,O.$Fd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$oh=I;class L{constructor(h=!0,m=!0){this.f=h,this.g=m}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let m=h.length-1;m>=0;m--,this.c--){const $=this.b.charCodeAt(m);if(!($===47||this.f&&$===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,O.$Dd)(h,this.b,0,h.length,this.d,this.e):(0,O.$Fd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ph=L;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class b{constructor(h,m){this.f=h,this.g=m,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,O.$Ed)(h,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Ed)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,O.$Cd)(h,this.c.query);if(this.d[this.e]===5)return(0,O.$Cd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$qh=b;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(P||(P={}));class p{static forUris(h=()=>!1,m=()=>!1){return new p(new b(h,m))}static forPaths(h=!1){return new p(new L(void 0,!h))}static forStrings(){return new p(new a)}static forConfigKeys(){return new p(new I)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,m){if(m){const $=m.slice(0);(0,y.$Bf)($);for(const o of $)this.set(o,h)}else{const $=h.slice(0);(0,y.$Bf)($);for(const o of $)this.set(o[0],o[1])}}set(h,m){const $=this.b.reset(h);let o;this.c||(this.c=new d,this.c.segment=$.value());const u=[];for(o=this.c;;){const g=$.cmp(o.segment);if(g>0)o.left||(o.left=new d,o.left.segment=$.value()),u.push([-1,o]),o=o.left;else if(g<0)o.right||(o.right=new d,o.right.segment=$.value()),u.push([1,o]),o=o.right;else if($.hasNext())$.next(),o.mid||(o.mid=new d,o.mid.segment=$.value()),u.push([0,o]),o=o.mid;else break}const l=o.value;o.value=m,o.key=h;for(let g=u.length-1;g>=0;g--){const D=u[g][1];D.updateHeight();const E=D.balanceFactor();if(E<-1||E>1){const t=u[g][0],i=u[g+1][0];if(t===1&&i===1)u[g][1]=D.rotateLeft();else if(t===-1&&i===-1)u[g][1]=D.rotateRight();else if(t===1&&i===-1)D.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=D.rotateLeft();else if(t===-1&&i===1)D.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=D.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return l}get(h){return this.d(h)?.value}d(h){const m=this.b.reset(h);let $=this.c;for(;$;){const o=m.cmp($.segment);if(o>0)$=$.left;else if(o<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else break}return $}has(h){const m=this.d(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,m){const $=this.b.reset(h),o=[];let u=this.c;for(;u;){const l=$.cmp(u.segment);if(l>0)o.push([-1,u]),u=u.left;else if(l<0)o.push([1,u]),u=u.right;else if($.hasNext())$.next(),o.push([0,u]),u=u.mid;else break}if(u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const l=this.f(u.right);if(l.key){const{key:g,value:D,segment:E}=l;this.e(l.key,!1),u.key=g,u.value=D,u.segment=E}}else{const l=u.left??u.right;if(o.length>0){const[g,D]=o[o.length-1];switch(g){case-1:D.left=l;break;case 0:D.mid=l;break;case 1:D.right=l;break}}else this.c=l}for(let l=o.length-1;l>=0;l--){const g=o[l][1];g.updateHeight();const D=g.balanceFactor();if(D>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),o[l][1]=g.rotateLeft()):D<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),o[l][1]=g.rotateRight()),l>0)switch(o[l-1][0]){case-1:o[l-1][1].left=o[l][1];break;case 1:o[l-1][1].right=o[l][1];break;case 0:o[l-1][1].mid=o[l][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this.b.reset(h);let $=this.c,o;for(;$;){const u=m.cmp($.segment);if(u>0)$=$.left;else if(u<0)$=$.right;else if(m.hasNext())m.next(),o=$.value||o,$=$.mid;else break}return $&&$.value||o}findSuperstr(h){return this.g(h,!1)}g(h,m){const $=this.b.reset(h);let o=this.c;for(;o;){const u=$.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if($.hasNext())$.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[m,$]of this)h($,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const m=[];return this.j(h,m),m[Symbol.iterator]()}j(h,m){h&&(h.left&&this.j(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this.j(h.mid,m),h.right&&this.j(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const $=m.balanceFactor();return $<-1||$>1?!1:h(m.left)&&h(m.right)};return h(this.c)}}e.$rh=p}),define(be[8],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;function y(i){return typeof i=="string"}e.$ge=y;function O(i){return Array.isArray(i)&&i.every(r=>y(r))}e.$he=O;function a(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.$ie=a;function I(i){const r=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof r}e.$je=I;function L(i){return typeof i=="number"&&!isNaN(i)}e.$ke=L;function R(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.$le=R;function b(i){return i===!0||i===!1}e.$me=b;function d(i){return typeof i>"u"}e.$ne=d;function P(i){return!p(i)}e.$oe=P;function p(i){return d(i)||i===null}e.$pe=p;function w(i,r){if(!i)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.$qe=w;function h(i){if(p(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.$re=h;function m(...i){const r=[];for(let n=0;n<i.length;n++){const s=i[n];if(p(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(s)}return r}e.$se=m;const $=Object.prototype.hasOwnProperty;function o(i){if(!a(i))return!1;for(const r in i)if($.call(i,r))return!1;return!0}e.$te=o;function u(i){return typeof i=="function"}e.$ue=u;function l(...i){return i.length>0&&i.every(u)}e.$ve=l;function g(i,r){const n=Math.min(i.length,r.length);for(let s=0;s<n;s++)D(i[s],r[s])}e.$we=g;function D(i,r){if(y(r)){if(typeof i!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(u(r)){try{if(i instanceof r)return}catch{}if(!p(i)&&i.constructor===r||r.length===1&&r.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$xe=D;function E(i){return i===null?void 0:i}e.$ye=E;function t(i){return typeof i>"u"?null:i}e.$ze=t}),define(be[48],we([1,0,8]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=void 0;const O=Object.create(null);function a(R,b){if((0,y.$ge)(b)){const d=O[b];if(d===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=d}return O[R]=b,{id:R}}function I(){return O}e.$wj=I;function L(){return Object.values(e.$yj)}e.$xj=L,e.$yj={add:a("add",6e4),plus:a("plus",6e4),gistNew:a("gist-new",6e4),repoCreate:a("repo-create",6e4),lightbulb:a("lightbulb",60001),lightBulb:a("light-bulb",60001),repo:a("repo",60002),repoDelete:a("repo-delete",60002),gistFork:a("gist-fork",60003),repoForked:a("repo-forked",60003),gitPullRequest:a("git-pull-request",60004),gitPullRequestAbandoned:a("git-pull-request-abandoned",60004),recordKeys:a("record-keys",60005),keyboard:a("keyboard",60005),tag:a("tag",60006),tagAdd:a("tag-add",60006),tagRemove:a("tag-remove",60006),person:a("person",60007),personFollow:a("person-follow",60007),personOutline:a("person-outline",60007),personFilled:a("person-filled",60007),gitBranch:a("git-branch",60008),gitBranchCreate:a("git-branch-create",60008),gitBranchDelete:a("git-branch-delete",60008),sourceControl:a("source-control",60008),mirror:a("mirror",60009),mirrorPublic:a("mirror-public",60009),star:a("star",60010),starAdd:a("star-add",60010),starDelete:a("star-delete",60010),starEmpty:a("star-empty",60010),comment:a("comment",60011),commentAdd:a("comment-add",60011),alert:a("alert",60012),warning:a("warning",60012),search:a("search",60013),searchSave:a("search-save",60013),logOut:a("log-out",60014),signOut:a("sign-out",60014),logIn:a("log-in",60015),signIn:a("sign-in",60015),eye:a("eye",60016),eyeUnwatch:a("eye-unwatch",60016),eyeWatch:a("eye-watch",60016),circleFilled:a("circle-filled",60017),primitiveDot:a("primitive-dot",60017),closeDirty:a("close-dirty",60017),debugBreakpoint:a("debug-breakpoint",60017),debugBreakpointDisabled:a("debug-breakpoint-disabled",60017),debugHint:a("debug-hint",60017),primitiveSquare:a("primitive-square",60018),edit:a("edit",60019),pencil:a("pencil",60019),info:a("info",60020),issueOpened:a("issue-opened",60020),gistPrivate:a("gist-private",60021),gitForkPrivate:a("git-fork-private",60021),lock:a("lock",60021),mirrorPrivate:a("mirror-private",60021),close:a("close",60022),removeClose:a("remove-close",60022),x:a("x",60022),repoSync:a("repo-sync",60023),sync:a("sync",60023),clone:a("clone",60024),desktopDownload:a("desktop-download",60024),beaker:a("beaker",60025),microscope:a("microscope",60025),vm:a("vm",60026),deviceDesktop:a("device-desktop",60026),file:a("file",60027),fileText:a("file-text",60027),more:a("more",60028),ellipsis:a("ellipsis",60028),kebabHorizontal:a("kebab-horizontal",60028),mailReply:a("mail-reply",60029),reply:a("reply",60029),organization:a("organization",60030),organizationFilled:a("organization-filled",60030),organizationOutline:a("organization-outline",60030),newFile:a("new-file",60031),fileAdd:a("file-add",60031),newFolder:a("new-folder",60032),fileDirectoryCreate:a("file-directory-create",60032),trash:a("trash",60033),trashcan:a("trashcan",60033),history:a("history",60034),clock:a("clock",60034),folder:a("folder",60035),fileDirectory:a("file-directory",60035),symbolFolder:a("symbol-folder",60035),logoGithub:a("logo-github",60036),markGithub:a("mark-github",60036),github:a("github",60036),terminal:a("terminal",60037),console:a("console",60037),repl:a("repl",60037),zap:a("zap",60038),symbolEvent:a("symbol-event",60038),error:a("error",60039),stop:a("stop",60039),variable:a("variable",60040),symbolVariable:a("symbol-variable",60040),array:a("array",60042),symbolArray:a("symbol-array",60042),symbolModule:a("symbol-module",60043),symbolPackage:a("symbol-package",60043),symbolNamespace:a("symbol-namespace",60043),symbolObject:a("symbol-object",60043),symbolMethod:a("symbol-method",60044),symbolFunction:a("symbol-function",60044),symbolConstructor:a("symbol-constructor",60044),symbolBoolean:a("symbol-boolean",60047),symbolNull:a("symbol-null",60047),symbolNumeric:a("symbol-numeric",60048),symbolNumber:a("symbol-number",60048),symbolStructure:a("symbol-structure",60049),symbolStruct:a("symbol-struct",60049),symbolParameter:a("symbol-parameter",60050),symbolTypeParameter:a("symbol-type-parameter",60050),symbolKey:a("symbol-key",60051),symbolText:a("symbol-text",60051),symbolReference:a("symbol-reference",60052),goToFile:a("go-to-file",60052),symbolEnum:a("symbol-enum",60053),symbolValue:a("symbol-value",60053),symbolRuler:a("symbol-ruler",60054),symbolUnit:a("symbol-unit",60054),activateBreakpoints:a("activate-breakpoints",60055),archive:a("archive",60056),arrowBoth:a("arrow-both",60057),arrowDown:a("arrow-down",60058),arrowLeft:a("arrow-left",60059),arrowRight:a("arrow-right",60060),arrowSmallDown:a("arrow-small-down",60061),arrowSmallLeft:a("arrow-small-left",60062),arrowSmallRight:a("arrow-small-right",60063),arrowSmallUp:a("arrow-small-up",60064),arrowUp:a("arrow-up",60065),bell:a("bell",60066),bold:a("bold",60067),book:a("book",60068),bookmark:a("bookmark",60069),debugBreakpointConditionalUnverified:a("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:a("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:a("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:a("debug-breakpoint-data-unverified",60072),debugBreakpointData:a("debug-breakpoint-data",60073),debugBreakpointDataDisabled:a("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:a("debug-breakpoint-log-unverified",60074),debugBreakpointLog:a("debug-breakpoint-log",60075),debugBreakpointLogDisabled:a("debug-breakpoint-log-disabled",60075),briefcase:a("briefcase",60076),broadcast:a("broadcast",60077),browser:a("browser",60078),bug:a("bug",60079),calendar:a("calendar",60080),caseSensitive:a("case-sensitive",60081),check:a("check",60082),checklist:a("checklist",60083),chevronDown:a("chevron-down",60084),dropDownButton:a("drop-down-button",60084),chevronLeft:a("chevron-left",60085),chevronRight:a("chevron-right",60086),chevronUp:a("chevron-up",60087),chromeClose:a("chrome-close",60088),chromeMaximize:a("chrome-maximize",60089),chromeMinimize:a("chrome-minimize",60090),chromeRestore:a("chrome-restore",60091),circle:a("circle",60092),circleOutline:a("circle-outline",60092),debugBreakpointUnverified:a("debug-breakpoint-unverified",60092),circleSlash:a("circle-slash",60093),circuitBoard:a("circuit-board",60094),clearAll:a("clear-all",60095),clippy:a("clippy",60096),closeAll:a("close-all",60097),cloudDownload:a("cloud-download",60098),cloudUpload:a("cloud-upload",60099),code:a("code",60100),collapseAll:a("collapse-all",60101),colorMode:a("color-mode",60102),commentDiscussion:a("comment-discussion",60103),compareChanges:a("compare-changes",60157),creditCard:a("credit-card",60105),dash:a("dash",60108),dashboard:a("dashboard",60109),database:a("database",60110),debugContinue:a("debug-continue",60111),debugDisconnect:a("debug-disconnect",60112),debugPause:a("debug-pause",60113),debugRestart:a("debug-restart",60114),debugStart:a("debug-start",60115),debugStepInto:a("debug-step-into",60116),debugStepOut:a("debug-step-out",60117),debugStepOver:a("debug-step-over",60118),debugStop:a("debug-stop",60119),debug:a("debug",60120),deviceCameraVideo:a("device-camera-video",60121),deviceCamera:a("device-camera",60122),deviceMobile:a("device-mobile",60123),diffAdded:a("diff-added",60124),diffIgnored:a("diff-ignored",60125),diffModified:a("diff-modified",60126),diffRemoved:a("diff-removed",60127),diffRenamed:a("diff-renamed",60128),diff:a("diff",60129),discard:a("discard",60130),editorLayout:a("editor-layout",60131),emptyWindow:a("empty-window",60132),exclude:a("exclude",60133),extensions:a("extensions",60134),eyeClosed:a("eye-closed",60135),fileBinary:a("file-binary",60136),fileCode:a("file-code",60137),fileMedia:a("file-media",60138),filePdf:a("file-pdf",60139),fileSubmodule:a("file-submodule",60140),fileSymlinkDirectory:a("file-symlink-directory",60141),fileSymlinkFile:a("file-symlink-file",60142),fileZip:a("file-zip",60143),files:a("files",60144),filter:a("filter",60145),flame:a("flame",60146),foldDown:a("fold-down",60147),foldUp:a("fold-up",60148),fold:a("fold",60149),folderActive:a("folder-active",60150),folderOpened:a("folder-opened",60151),gear:a("gear",60152),gift:a("gift",60153),gistSecret:a("gist-secret",60154),gist:a("gist",60155),gitCommit:a("git-commit",60156),gitCompare:a("git-compare",60157),gitMerge:a("git-merge",60158),githubAction:a("github-action",60159),githubAlt:a("github-alt",60160),globe:a("globe",60161),grabber:a("grabber",60162),graph:a("graph",60163),gripper:a("gripper",60164),heart:a("heart",60165),home:a("home",60166),horizontalRule:a("horizontal-rule",60167),hubot:a("hubot",60168),inbox:a("inbox",60169),issueClosed:a("issue-closed",60324),issueReopened:a("issue-reopened",60171),issues:a("issues",60172),italic:a("italic",60173),jersey:a("jersey",60174),json:a("json",60175),bracket:a("bracket",60175),kebabVertical:a("kebab-vertical",60176),key:a("key",60177),law:a("law",60178),lightbulbAutofix:a("lightbulb-autofix",60179),linkExternal:a("link-external",60180),link:a("link",60181),listOrdered:a("list-ordered",60182),listUnordered:a("list-unordered",60183),liveShare:a("live-share",60184),loading:a("loading",60185),location:a("location",60186),mailRead:a("mail-read",60187),mail:a("mail",60188),markdown:a("markdown",60189),megaphone:a("megaphone",60190),mention:a("mention",60191),milestone:a("milestone",60192),mortarBoard:a("mortar-board",60193),move:a("move",60194),multipleWindows:a("multiple-windows",60195),mute:a("mute",60196),noNewline:a("no-newline",60197),note:a("note",60198),octoface:a("octoface",60199),openPreview:a("open-preview",60200),package_:a("package",60201),paintcan:a("paintcan",60202),pin:a("pin",60203),play:a("play",60204),run:a("run",60204),plug:a("plug",60205),preserveCase:a("preserve-case",60206),preview:a("preview",60207),project:a("project",60208),pulse:a("pulse",60209),question:a("question",60210),quote:a("quote",60211),radioTower:a("radio-tower",60212),reactions:a("reactions",60213),references:a("references",60214),refresh:a("refresh",60215),regex:a("regex",60216),remoteExplorer:a("remote-explorer",60217),remote:a("remote",60218),remove:a("remove",60219),replaceAll:a("replace-all",60220),replace:a("replace",60221),repoClone:a("repo-clone",60222),repoForcePush:a("repo-force-push",60223),repoPull:a("repo-pull",60224),repoPush:a("repo-push",60225),report:a("report",60226),requestChanges:a("request-changes",60227),rocket:a("rocket",60228),rootFolderOpened:a("root-folder-opened",60229),rootFolder:a("root-folder",60230),rss:a("rss",60231),ruby:a("ruby",60232),saveAll:a("save-all",60233),saveAs:a("save-as",60234),save:a("save",60235),screenFull:a("screen-full",60236),screenNormal:a("screen-normal",60237),searchStop:a("search-stop",60238),server:a("server",60240),settingsGear:a("settings-gear",60241),settings:a("settings",60242),shield:a("shield",60243),smiley:a("smiley",60244),sortPrecedence:a("sort-precedence",60245),splitHorizontal:a("split-horizontal",60246),splitVertical:a("split-vertical",60247),squirrel:a("squirrel",60248),starFull:a("star-full",60249),starHalf:a("star-half",60250),symbolClass:a("symbol-class",60251),symbolColor:a("symbol-color",60252),symbolCustomColor:a("symbol-customcolor",60252),symbolConstant:a("symbol-constant",60253),symbolEnumMember:a("symbol-enum-member",60254),symbolField:a("symbol-field",60255),symbolFile:a("symbol-file",60256),symbolInterface:a("symbol-interface",60257),symbolKeyword:a("symbol-keyword",60258),symbolMisc:a("symbol-misc",60259),symbolOperator:a("symbol-operator",60260),symbolProperty:a("symbol-property",60261),wrench:a("wrench",60261),wrenchSubaction:a("wrench-subaction",60261),symbolSnippet:a("symbol-snippet",60262),tasklist:a("tasklist",60263),telescope:a("telescope",60264),textSize:a("text-size",60265),threeBars:a("three-bars",60266),thumbsdown:a("thumbsdown",60267),thumbsup:a("thumbsup",60268),tools:a("tools",60269),triangleDown:a("triangle-down",60270),triangleLeft:a("triangle-left",60271),triangleRight:a("triangle-right",60272),triangleUp:a("triangle-up",60273),twitter:a("twitter",60274),unfold:a("unfold",60275),unlock:a("unlock",60276),unmute:a("unmute",60277),unverified:a("unverified",60278),verified:a("verified",60279),versions:a("versions",60280),vmActive:a("vm-active",60281),vmOutline:a("vm-outline",60282),vmRunning:a("vm-running",60283),watch:a("watch",60284),whitespace:a("whitespace",60285),wholeWord:a("whole-word",60286),window:a("window",60287),wordWrap:a("word-wrap",60288),zoomIn:a("zoom-in",60289),zoomOut:a("zoom-out",60290),listFilter:a("list-filter",60291),listFlat:a("list-flat",60292),listSelection:a("list-selection",60293),selection:a("selection",60293),listTree:a("list-tree",60294),debugBreakpointFunctionUnverified:a("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:a("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:a("debug-breakpoint-function-disabled",60296),debugStackframeActive:a("debug-stackframe-active",60297),circleSmallFilled:a("circle-small-filled",60298),debugStackframeDot:a("debug-stackframe-dot",60298),debugStackframe:a("debug-stackframe",60299),debugStackframeFocused:a("debug-stackframe-focused",60299),debugBreakpointUnsupported:a("debug-breakpoint-unsupported",60300),symbolString:a("symbol-string",60301),debugReverseContinue:a("debug-reverse-continue",60302),debugStepBack:a("debug-step-back",60303),debugRestartFrame:a("debug-restart-frame",60304),callIncoming:a("call-incoming",60306),callOutgoing:a("call-outgoing",60307),menu:a("menu",60308),expandAll:a("expand-all",60309),feedback:a("feedback",60310),groupByRefType:a("group-by-ref-type",60311),ungroupByRefType:a("ungroup-by-ref-type",60312),account:a("account",60313),bellDot:a("bell-dot",60314),debugConsole:a("debug-console",60315),library:a("library",60316),output:a("output",60317),runAll:a("run-all",60318),syncIgnored:a("sync-ignored",60319),pinned:a("pinned",60320),githubInverted:a("github-inverted",60321),debugAlt:a("debug-alt",60305),serverProcess:a("server-process",60322),serverEnvironment:a("server-environment",60323),pass:a("pass",60324),stopCircle:a("stop-circle",60325),playCircle:a("play-circle",60326),record:a("record",60327),debugAltSmall:a("debug-alt-small",60328),vmConnect:a("vm-connect",60329),cloud:a("cloud",60330),merge:a("merge",60331),exportIcon:a("export",60332),graphLeft:a("graph-left",60333),magnet:a("magnet",60334),notebook:a("notebook",60335),redo:a("redo",60336),checkAll:a("check-all",60337),pinnedDirty:a("pinned-dirty",60338),passFilled:a("pass-filled",60339),circleLargeFilled:a("circle-large-filled",60340),circleLarge:a("circle-large",60341),circleLargeOutline:a("circle-large-outline",60341),combine:a("combine",60342),gather:a("gather",60342),table:a("table",60343),variableGroup:a("variable-group",60344),typeHierarchy:a("type-hierarchy",60345),typeHierarchySub:a("type-hierarchy-sub",60346),typeHierarchySuper:a("type-hierarchy-super",60347),gitPullRequestCreate:a("git-pull-request-create",60348),runAbove:a("run-above",60349),runBelow:a("run-below",60350),notebookTemplate:a("notebook-template",60351),debugRerun:a("debug-rerun",60352),workspaceTrusted:a("workspace-trusted",60353),workspaceUntrusted:a("workspace-untrusted",60354),workspaceUnspecified:a("workspace-unspecified",60355),terminalCmd:a("terminal-cmd",60356),terminalDebian:a("terminal-debian",60357),terminalLinux:a("terminal-linux",60358),terminalPowershell:a("terminal-powershell",60359),terminalTmux:a("terminal-tmux",60360),terminalUbuntu:a("terminal-ubuntu",60361),terminalBash:a("terminal-bash",60362),arrowSwap:a("arrow-swap",60363),copy:a("copy",60364),personAdd:a("person-add",60365),filterFilled:a("filter-filled",60366),wand:a("wand",60367),debugLineByLine:a("debug-line-by-line",60368),inspect:a("inspect",60369),layers:a("layers",60370),layersDot:a("layers-dot",60371),layersActive:a("layers-active",60372),compass:a("compass",60373),compassDot:a("compass-dot",60374),compassActive:a("compass-active",60375),azure:a("azure",60376),issueDraft:a("issue-draft",60377),gitPullRequestClosed:a("git-pull-request-closed",60378),gitPullRequestDraft:a("git-pull-request-draft",60379),debugAll:a("debug-all",60380),debugCoverage:a("debug-coverage",60381),runErrors:a("run-errors",60382),folderLibrary:a("folder-library",60383),debugContinueSmall:a("debug-continue-small",60384),beakerStop:a("beaker-stop",60385),graphLine:a("graph-line",60386),graphScatter:a("graph-scatter",60387),pieChart:a("pie-chart",60388),bracketDot:a("bracket-dot",60389),bracketError:a("bracket-error",60390),lockSmall:a("lock-small",60391),azureDevops:a("azure-devops",60392),verifiedFilled:a("verified-filled",60393),newLine:a("newline",60394),layout:a("layout",60395),layoutActivitybarLeft:a("layout-activitybar-left",60396),layoutActivitybarRight:a("layout-activitybar-right",60397),layoutPanelLeft:a("layout-panel-left",60398),layoutPanelCenter:a("layout-panel-center",60399),layoutPanelJustify:a("layout-panel-justify",60400),layoutPanelRight:a("layout-panel-right",60401),layoutPanel:a("layout-panel",60402),layoutSidebarLeft:a("layout-sidebar-left",60403),layoutSidebarRight:a("layout-sidebar-right",60404),layoutStatusbar:a("layout-statusbar",60405),layoutMenubar:a("layout-menubar",60406),layoutCentered:a("layout-centered",60407),layoutSidebarRightOff:a("layout-sidebar-right-off",60416),layoutPanelOff:a("layout-panel-off",60417),layoutSidebarLeftOff:a("layout-sidebar-left-off",60418),target:a("target",60408),indent:a("indent",60409),recordSmall:a("record-small",60410),errorSmall:a("error-small",60411),arrowCircleDown:a("arrow-circle-down",60412),arrowCircleLeft:a("arrow-circle-left",60413),arrowCircleRight:a("arrow-circle-right",60414),arrowCircleUp:a("arrow-circle-up",60415),heartFilled:a("heart-filled",60420),map:a("map",60421),mapFilled:a("map-filled",60422),circleSmall:a("circle-small",60423),bellSlash:a("bell-slash",60424),bellSlashDot:a("bell-slash-dot",60425),commentUnresolved:a("comment-unresolved",60426),gitPullRequestGoToChanges:a("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:a("git-pull-request-new-changes",60428),searchFuzzy:a("search-fuzzy",60429),commentDraft:a("comment-draft",60430),send:a("send",60431),sparkle:a("sparkle",60432),insert:a("insert",60433),dialogError:a("dialog-error","error"),dialogWarning:a("dialog-warning","warning"),dialogInfo:a("dialog-info","info"),dialogClose:a("dialog-close","close"),treeItemExpanded:a("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:a("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:a("tree-filter-on-type-off","list-selection"),treeFilterClear:a("tree-filter-clear","close"),treeItemLoading:a("tree-item-loading","loading"),menuSelection:a("menu-selection","check"),menuSubmenu:a("menu-submenu","chevron-right"),menuBarMore:a("menubar-more","more"),scrollbarButtonLeft:a("scrollbar-button-left","triangle-left"),scrollbarButtonRight:a("scrollbar-button-right","triangle-right"),scrollbarButtonUp:a("scrollbar-button-up","triangle-up"),scrollbarButtonDown:a("scrollbar-button-down","triangle-down"),toolBarMore:a("toolbar-more","more"),quickInputBack:a("quick-input-back","arrow-left")}}),define(be[38],we([1,0,7,3,17,8]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function L(c){return c===47||c===92}e.$Ae=L;function R(c){return c.replace(/[\\/]/g,y.$8b.sep)}e.$Be=R;function b(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Ce=b;function d(c,f=y.$8b.sep){if(!c)return"";const k=c.length,v=c.charCodeAt(0);if(L(v)){if(L(c.charCodeAt(1))&&!L(c.charCodeAt(2))){let A=3;const M=A;for(;A<k&&!L(c.charCodeAt(A));A++);if(M!==A&&!L(c.charCodeAt(A+1))){for(A+=1;A<k;A++)if(L(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,f)}}return f}else if(u(v)&&c.charCodeAt(1)===58)return L(c.charCodeAt(2))?c.slice(0,2)+f:c.slice(0,2);let C=c.indexOf("://");if(C!==-1){for(C+=3;C<k;C++)if(L(c.charCodeAt(C)))return c.slice(0,C+1)}return""}e.$De=d;function P(c){if(!O.$d||!c||c.length<5)return!1;let f=c.charCodeAt(0);if(f!==92||(f=c.charCodeAt(1),f!==92))return!1;let k=2;const v=k;for(;k<c.length&&(f=c.charCodeAt(k),f!==92);k++);return!(v===k||(f=c.charCodeAt(k+1),isNaN(f)||f===92))}e.$Ee=P;const p=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,f=O.$d){const k=f?p:w;return!(!c||c.length===0||/^\s+$/.test(c)||(k.lastIndex=0,k.test(c))||f&&h.test(c)||c==="."||c===".."||f&&c[c.length-1]==="."||f&&c.length!==c.trim().length||c.length>255)}e.$Fe=m;function $(c,f,k){const v=c===f;return!k||v?v:!c||!f?!1:(0,a.$Jd)(c,f)}e.$Ge=$;function o(c,f,k,v=y.sep){if(c===f)return!0;if(!c||!f||f.length>c.length)return!1;if(k){if(!(0,a.$Kd)(c,f))return!1;if(f.length===c.length)return!0;let A=f.length;return f.charAt(f.length-1)===v&&A--,c.charAt(A)===v}return f.charAt(f.length-1)!==v&&(f+=v),c.indexOf(f)===0}e.$He=o;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.$Ie=u;function l(c,f){return O.$d&&c.endsWith(":")&&(c+=y.sep),(0,y.$0b)(c)||(c=(0,y.$$b)(f,c)),c=(0,y.$9b)(c),O.$d?(c=(0,a.$qd)(c,y.sep),c.endsWith(":")&&(c+=y.sep)):(c=(0,a.$qd)(c,y.sep),c||(c=y.sep)),c}e.$Je=l;function g(c){const f=(0,y.$9b)(c);return O.$d?c.length>3?!1:D(f)&&(c.length===2||f.charCodeAt(2)===92):f===y.$8b.sep}e.$Ke=g;function D(c,f=O.$d){return f?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$Le=D;function E(c,f=O.$d){return D(c,f)?c[0]:void 0}e.$Me=E;function t(c,f,k){return f.length>c.length?-1:c===f?0:(k&&(c=c.toLowerCase(),f=f.toLowerCase()),c.indexOf(f))}e.$Ne=t;function i(c){const f=c.split(":");let k,v,C;for(const A of f){const M=Number(A);(0,I.$ke)(M)?v===void 0?v=M:C===void 0&&(C=M):k=k?[k,A].join(":"):A}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:v!==void 0?v:void 0,column:C!==void 0?C:v!==void 0?1:void 0}}e.$Oe=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(c,f,k=8){let v="";for(let A=0;A<k;A++){let M;A===0&&O.$d&&!f&&(k===3||k===4)?M=n:M=r,v+=M.charAt(Math.floor(Math.random()*M.length))}let C;return f?C=`${f}-${v}`:C=v,c?(0,y.$$b)(c,C):C}e.$Pe=s}),define(be[22],we([1,0,8]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const l=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,D])=>{l[g]=D&&typeof D=="object"?O(D):D}),l}e.$Em=O;function a(u){if(!u||typeof u!="object")return u;const l=[u];for(;l.length>0;){const g=l.shift();Object.freeze(g);for(const D in g)if(I.call(g,D)){const E=g[D];typeof E=="object"&&!Object.isFrozen(E)&&!(0,y.$je)(E)&&l.push(E)}}return u}e.$Fm=a;const I=Object.prototype.hasOwnProperty;function L(u,l){return R(u,l,new Set)}e.$Gm=L;function R(u,l,g){if((0,y.$pe)(u))return u;const D=l(u);if(typeof D<"u")return D;if(Array.isArray(u)){const E=[];for(const t of u)E.push(R(t,l,g));return E}if((0,y.$ie)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const E={};for(const t in u)I.call(u,t)&&(E[t]=R(u[t],l,g));return g.delete(u),E}return u}function b(u,l,g=!0){return(0,y.$ie)(u)?((0,y.$ie)(l)&&Object.keys(l).forEach(D=>{D in u?g&&((0,y.$ie)(u[D])&&(0,y.$ie)(l[D])?b(u[D],l[D],g):u[D]=l[D]):u[D]=l[D]}),u):l}e.$Hm=b;function d(u,l){if(u===l)return!0;if(u==null||l===null||l===void 0||typeof u!=typeof l||typeof u!="object"||Array.isArray(u)!==Array.isArray(l))return!1;let g,D;if(Array.isArray(u)){if(u.length!==l.length)return!1;for(g=0;g<u.length;g++)if(!d(u[g],l[g]))return!1}else{const E=[];for(D in u)E.push(D);E.sort();const t=[];for(D in l)t.push(D);if(t.sort(),!d(E,t))return!1;for(g=0;g<E.length;g++)if(!d(u[E[g]],l[E[g]]))return!1}return!0}e.$Im=d;function P(u){const l=new Set;return JSON.stringify(u,(g,D)=>{if((0,y.$ie)(D)||Array.isArray(D)){if(l.has(D))return"[Circular]";l.add(D)}return D})}e.$Jm=P;function p(u,l){const g=Object.create(null);return!u||!l||Object.keys(l).forEach(E=>{const t=u[E],i=l[E];d(t,i)||(g[E]=i)}),g}e.$Km=p;function w(u,l){const g=l.toLowerCase(),D=Object.keys(u).find(E=>E.toLowerCase()===g);return D?u[D]:u[l]}e.$Lm=w;function h(u,l){const g=Object.create(null);for(const[D,E]of Object.entries(u))l(D,E)&&(g[D]=E);return g}e.$Mm=h;function m(u){let l=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)l=l.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return l}e.$Nm=m;function $(u){const l=[];for(const g of m(u))typeof u[g]=="function"&&l.push(g);return l}e.$Om=$;function o(u,l){const g=E=>function(){const t=Array.prototype.slice.call(arguments,0);return l(E,t)},D={};for(const E of u)D[E]=g(E);return D}e.$Pm=o}),define(be[99],we([1,0,48]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$zj=e.ThemeColor=void 0;var O;(function(L){function R(b){return b&&typeof b=="object"&&typeof b.id=="string"}L.isThemeColor=R})(O||(e.ThemeColor=O={}));function a(L){return{id:L}}e.$zj=a;var I;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function b(l){const g=R.exec(l.id);if(!g)return b(y.$yj.error);const[,D,E]=g,t=["codicon","codicon-"+D];return E&&t.push("codicon-modifier-"+E.substring(1)),t}L.asClassNameArray=b;function d(l){return b(l).join(" ")}L.asClassName=d;function P(l){return"."+b(l).join(".")}L.asCSSSelector=P;function p(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||O.isThemeColor(l.color))}L.isThemeIcon=p;const w=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function h(l){const g=w.exec(l);if(!g)return;const[,D]=g;return{id:D}}L.fromString=h;function m(l){return{id:l}}L.fromId=m;function $(l,g){let D=l.id;const E=D.lastIndexOf("~");return E!==-1&&(D=D.substring(0,E)),g&&(D=`${D}~${g}`),{id:D}}L.modify=$;function o(l){const g=l.id.lastIndexOf("~");if(g!==-1)return l.id.substring(g+1)}L.getModifier=o;function u(l,g){return l.id===g.id&&l.color?.id===g.color?.id}L.isEqual=u})(I||(e.ThemeIcon=I={}))}),define(be[147],we([1,0,145,17,99]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=void 0;const I="$(",L=new RegExp(`\\$\\(${a.ThemeIcon.iconNameExpression}(?:${a.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function b(u){return u.replace(R,(l,g)=>g?l:`\\${l}`)}e.$Aj=b;const d=new RegExp(`\\\\${L.source}`,"g");function P(u){return u.replace(d,l=>`\\${l}`)}e.$Bj=P;const p=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function w(u){return u.indexOf(I)===-1?u:u.replace(p,(l,g,D,E)=>D?l:g||E||"")}e.$Cj=w;function h(u){return u?u.replace(/\$\((.*?)\)/g,(l,g)=>` ${g} `).trim():""}e.$Dj=h;const m=new RegExp(`\\$\\(${a.ThemeIcon.iconNameCharacter}+\\)`,"g");function $(u){m.lastIndex=0;let l="";const g=[];let D=0;for(;;){const E=m.lastIndex,t=m.exec(u),i=u.substring(E,t?.index);if(i.length>0){l+=i;for(let r=0;r<i.length;r++)g.push(D)}if(!t)break;D+=t[0].length}return{text:l,iconOffsets:g}}e.$Ej=$;function o(u,l,g=!1){const{text:D,iconOffsets:E}=l;if(!E||E.length===0)return(0,y.$nj)(u,D,g);const t=(0,O.$pd)(D," "),i=D.length-t.length,r=(0,y.$nj)(u,t,g);if(r)for(const n of r){const s=E[n.start+i]+i;n.start+=s,n.end+=s}return r}e.$Fj=o}),define(be[4],we([1,0,7,3]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const a=/^\w[\w\d+.-]*$/,I=/^\//,L=/^\/\//;function R(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!a.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!I.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(n,s){return!n&&!s?"file":n}function d(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==p&&(s=p+s):s=p;break}return s}const P="",p="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(s){return s instanceof h?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,c,f,k,v,C=!1){typeof s=="object"?(this.scheme=s.scheme||P,this.authority=s.authority||P,this.path=s.path||P,this.query=s.query||P,this.fragment=s.fragment||P):(this.scheme=b(s,C),this.authority=c||P,this.path=d(this.scheme,f||P),this.query=k||P,this.fragment=v||P,R(this,C))}get fsPath(){return D(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:f,path:k,query:v,fragment:C}=s;return c===void 0?c=this.scheme:c===null&&(c=P),f===void 0?f=this.authority:f===null&&(f=P),k===void 0?k=this.path:k===null&&(k=P),v===void 0?v=this.query:v===null&&(v=P),C===void 0?C=this.fragment:C===null&&(C=P),c===this.scheme&&f===this.authority&&k===this.path&&v===this.query&&C===this.fragment?this:new o(c,f,k,v,C)}static parse(s,c=!1){const f=w.exec(s);return f?new o(f[2]||P,r(f[4]||P),r(f[5]||P),r(f[7]||P),r(f[9]||P),c):new o(P,P,P,P,P)}static file(s){let c=P;if(O.$d&&(s=s.replace(/\\/g,p)),s[0]===p&&s[1]===p){const f=s.indexOf(p,2);f===-1?(c=s.substring(2),s=p):(c=s.substring(2,f),s=s.substring(f)||p)}return new o("file",c,s,P,P)}static from(s,c){return new o(s.scheme,s.authority,s.path,s.query,s.fragment,c)}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return O.$d&&s.scheme==="file"?f=h.file(y.$7b.join(D(s,!0),...c)).path:f=y.$8b.join(s.path,...c),s.with({path:f})}toString(s=!1){return E(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof h)return s;{const c=new o(s);return c._formatted=s.external??null,c._fsPath=s._sep===$?s.fsPath??null:null,c}}else return s}}e.URI=h;function m(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Re=m;const $=O.$d?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(s=!1){return s?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=$),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,s,c){let f,k=-1;for(let v=0;v<n.length;v++){const C=n.charCodeAt(v);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||s&&C===47||c&&C===91||c&&C===93||c&&C===58)k!==-1&&(f+=encodeURIComponent(n.substring(k,v)),k=-1),f!==void 0&&(f+=n.charAt(v));else{f===void 0&&(f=n.substr(0,v));const A=u[C];A!==void 0?(k!==-1&&(f+=encodeURIComponent(n.substring(k,v)),k=-1),f+=A):k===-1&&(k=v)}}return k!==-1&&(f+=encodeURIComponent(n.substring(k))),f!==void 0?f:n}function g(n){let s;for(let c=0;c<n.length;c++){const f=n.charCodeAt(c);f===35||f===63?(s===void 0&&(s=n.substr(0,c)),s+=u[f]):s!==void 0&&(s+=n[c])}return s!==void 0?s:n}function D(n,s){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,O.$d&&(c=c.replace(/\//g,"\\")),c}e.$Se=D;function E(n,s){const c=s?g:l;let f="",{scheme:k,authority:v,path:C,query:A,fragment:M}=n;if(k&&(f+=k,f+=":"),(v||k==="file")&&(f+=p,f+=p),v){let K=v.indexOf("@");if(K!==-1){const te=v.substr(0,K);v=v.substr(K+1),K=te.lastIndexOf(":"),K===-1?f+=c(te,!1,!1):(f+=c(te.substr(0,K),!1,!1),f+=":",f+=c(te.substr(K+1),!1,!0)),f+="@"}v=v.toLowerCase(),K=v.lastIndexOf(":"),K===-1?f+=c(v,!1,!0):(f+=c(v.substr(0,K),!1,!0),f+=v.substr(K))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const K=C.charCodeAt(1);K>=65&&K<=90&&(C=`/${String.fromCharCode(K+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const K=C.charCodeAt(0);K>=65&&K<=90&&(C=`${String.fromCharCode(K+32)}:${C.substr(2)}`)}f+=c(C,!0,!1)}return A&&(f+="?",f+=c(A,!1,!1)),M&&(f+="#",f+=s?M:l(M,!1,!1)),f}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,s=>t(s)):n}}),define(be[148],we([1,0,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Bp=e.$Ap=e.$zp=void 0;function O(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$zp=O;function a(d){const P=[];let p;try{const w=JSON.parse(d.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),p=h.__$stack),P.push(...w)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:p}}e.$Ap=a;function I(d){if(typeof d!="string")return I(a(d).stack);const P=d;if(P){const p=L(P),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(w&&w.length===4)return{uri:y.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Bp=I;function L(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function R(d,P){const{args:p,stack:w}=a(d),h=typeof p[0]=="string"&&p.length===1;let m=L(w);m&&(m=`(${m.trim()})`);let $=[];if(typeof p[0]=="string"?m&&h?$=[`%c[${P}] %c${p[0]} %c${m}`,b("blue"),b(""),b("grey")]:$=[`%c[${P}] %c${p[0]}`,b("blue"),b(""),...p.slice(1)]:$=[`%c[${P}]%`,b("blue"),...p],m&&!h&&$.push(m),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,$)}e.log=R;function b(d){return`color: ${d}`}}),define(be[49],we([1,0,15,17,4]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function I(d){return JSON.stringify(d,R)}e.$Sg=I;function L(d){let P=JSON.parse(d);return P=b(P),P}e.$Tg=L;function R(d,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,O.$wd)(P)}:P}function b(d,P=0){if(!d||P>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return a.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof y.$Ib||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let p=0;p<d.length;++p)d[p]=b(d[p],P+1);else for(const p in d)Object.hasOwnProperty.call(d,p)&&(d[p]=b(d[p],P+1))}return d}e.$Ug=b}),define(be[13],we([1,0,11,3,4]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var I;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={})),e.$Te="vscode-tkn",e.$Ue="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${I.vscodeRemoteResource}`}set(P,p,w){this.a[P]=p,this.b[P]=w}setConnectionToken(P,p){this.c[P]=p}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(o){return y.$X(o),P}const p=P.authority;let w=this.a[p];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const h=this.b[p],m=this.c[p];let $=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&($+=`&${e.$Ue}=${encodeURIComponent(m)}`),a.URI.from({scheme:O.$j?this.d:I.vscodeRemoteResource,authority:`${w}:${h}`,path:O.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:$})}}e.$Ve=new L,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const p=this.b(P,ae);return this.uriToBrowserUri(p)}uriToBrowserUri(P){return P.scheme===I.vscodeRemote?e.$Ve.rewrite(P):P.scheme===I.file&&(O.$h||O.$k&&O.$b.origin===`${I.vscodeFileResource}://${R.a}`)?P.with({scheme:I.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const p=this.b(P,ae);return this.uriToFileUri(p)}uriToFileUri(P){return P.scheme===I.vscodeFileResource?P.with({scheme:I.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,p){return a.URI.isUri(P)?P:a.URI.parse(p.toUrl(P))}}R.a="vscode-app",e.$1e=new R;var b;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const p="vscode-coi";function w(m){let $;typeof m=="string"?$=new URL(m).searchParams:m instanceof URL?$=m.searchParams:a.URI.isUri(m)&&($=new URL(m.toString(!0)).searchParams);const o=$?.get(p);if(o)return P.get(o)}d.getHeadersFromQuery=w;function h(m,$,o){if(!globalThis.crossOriginIsolated)return;const u=$&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(p,u):m[p]=u}d.addSearchParam=h})(b||(e.COI=b={}))}),define(be[19],we([1,0,38,13,7,3,17,4]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function b(h){return(0,R.$Se)(h,!0)}e.$Tf=b;class d{constructor(m){this.a=m}compare(m,$,o=!1){return m===$?0:(0,L.$Cd)(this.getComparisonKey(m,o),this.getComparisonKey($,o))}isEqual(m,$,o=!1){return m===$?!0:!m||!$?!1:this.getComparisonKey(m,o)===this.getComparisonKey($,o)}getComparisonKey(m,$=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,$,o=!1){if(m.scheme===$.scheme){if(m.scheme===O.Schemas.file)return y.$He(b(m),b($),this.a(m))&&m.query===$.query&&(o||m.fragment===$.fragment);if((0,e.$$f)(m.authority,$.authority))return y.$He(m.path,$.path,this.a(m),"/")&&m.query===$.query&&(o||m.fragment===$.fragment)}return!1}joinPath(m,...$){return R.URI.joinPath(m,...$)}basenameOrAuthority(m){return(0,e.$3f)(m)||m.authority}basename(m){return a.$8b.basename(m.path)}extname(m){return a.$8b.extname(m.path)}dirname(m){if(m.path.length===0)return m;let $;return m.scheme===O.Schemas.file?$=R.URI.file(a.$bc(b(m))).path:($=a.$8b.dirname(m.path),m.authority&&$.length&&$.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),$="/")),m.with({path:$})}normalizePath(m){if(!m.path.length)return m;let $;return m.scheme===O.Schemas.file?$=R.URI.file(a.$9b(b(m))).path:$=a.$8b.normalize(m.path),m.with({path:$})}relativePath(m,$){if(m.scheme!==$.scheme||!(0,e.$$f)(m.authority,$.authority))return;if(m.scheme===O.Schemas.file){const l=a.$ac(b(m),b($));return I.$d?y.$Be(l):l}let o=m.path||"/";const u=$.path||"/";if(this.a(m)){let l=0;for(const g=Math.min(o.length,u.length);l<g&&!(o.charCodeAt(l)!==u.charCodeAt(l)&&o.charAt(l).toLowerCase()!==u.charAt(l).toLowerCase());l++);o=u.substr(0,l)+o.substr(l)}return a.$8b.relative(o,u)}resolvePath(m,$){if(m.scheme===O.Schemas.file){const o=R.URI.file(a.$_b(b(m),$));return m.with({authority:o.authority,path:o.path})}return $=y.$Ce($),m.with({path:a.$8b.resolve(m.path,$)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,$){return m===$||m!==void 0&&$!==void 0&&(0,L.$Jd)(m,$)}hasTrailingPathSeparator(m,$=a.sep){if(m.scheme===O.Schemas.file){const o=b(m);return o.length>y.$De(o).length&&o[o.length-1]===$}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,$=a.sep){return(0,e.$_f)(m,$)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,$=a.sep){let o=!1;if(m.scheme===O.Schemas.file){const u=b(m);o=u!==void 0&&u.length===y.$De(u).length&&u[u.length-1]===$}else{$="/";const u=m.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.$_f)(m,$)?m.with({path:m.path+"/"}):m}}e.$Uf=d,e.$Vf=new d(()=>!1),e.$Wf=new d(h=>h.scheme===O.Schemas.file?!I.$f:!0),e.$Xf=new d(h=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function P(h,m){const $=[];for(let o=0;o<h.length;o++){const u=m(h[o]);h.some((l,g)=>g===o?!1:(0,e.$Zf)(u,m(l)))||$.push(h[o])}return $}e.$cg=P;var p;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m($){const o=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(g=>{const[D,E]=g.split(":");D&&E&&o.set(D,E)});const l=$.path.substring(0,$.path.indexOf(";"));return l&&o.set(h.META_DATA_MIME,l),o}h.parseMetaData=m})(p||(e.DataUri=p={}));function w(h,m,$){if(m){let o=h.path;return o&&o[0]!==a.$8b.sep&&(o=a.$8b.sep+o),h.with({scheme:$,authority:m,path:o})}return h.with({scheme:$})}e.$dg=w}),define(be[14],we([1,0,20,11,5,2,19,3,146]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function d(T){return!!T&&typeof T.then=="function"}e.$eg=d;function P(T){const S=new y.$bd,F=T(S.token),ee=new Promise((oe,z)=>{const q=S.token.onCancellationRequested(()=>{q.dispose(),S.dispose(),z(new O.$2)});Promise.resolve(F).then(W=>{q.dispose(),S.dispose(),oe(W)},W=>{q.dispose(),S.dispose(),z(W)})});return new class{cancel(){S.cancel()}then(oe,z){return ee.then(oe,z)}catch(oe){return this.then(void 0,oe)}finally(oe){return ee.finally(oe)}}}e.$fg=P;function p(T,S,F){return new Promise((ee,oe)=>{const z=S.onCancellationRequested(()=>{z.dispose(),ee(F)});T.then(ee,oe).finally(()=>z.dispose())})}e.$gg=p;function w(T,S){return new Promise((F,ee)=>{const oe=S.onCancellationRequested(()=>{oe.dispose(),ee(new O.$2)});T.then(F,ee).finally(()=>oe.dispose())})}e.$hg=w;async function h(T){let S=-1;const F=T.map((ee,oe)=>ee.then(z=>(S=oe,z)));try{return await Promise.race(F)}finally{T.forEach((ee,oe)=>{oe!==S&&ee.cancel()})}}e.$ig=h;function m(T,S,F){let ee;const oe=setTimeout(()=>{ee?.(void 0),F?.()},S);return Promise.race([T.finally(()=>clearTimeout(oe)),new Promise(z=>ee=z)])}e.$jg=m;function $(T){return new Promise((S,F)=>{const ee=T();d(ee)?ee.then(S,F):S(ee)})}e.$kg=$;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(S){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=S,!this.b){const F=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(F,F).then(ee)})}return new Promise((F,ee)=>{this.b.then(F,ee)})}return this.a=S(),new Promise((F,ee)=>{this.a.then(oe=>{this.a=null,F(oe)},oe=>{this.a=null,ee(oe)})})}dispose(){this.f=!0}}e.$lg=o;class u{constructor(){this.a=Promise.resolve(null)}queue(S){return this.a=this.a.then(()=>S(),()=>S())}}e.$mg=u;class l{constructor(){this.a=new Map}queue(S,F){const oe=(this.a.get(S)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(S)===oe&&this.a.delete(S)});return this.a.set(S,oe),oe}}e.$ng=l;const g=(T,S)=>{let F=!0;const ee=setTimeout(()=>{F=!1,S()},T);return{isTriggered:()=>F,dispose:()=>{clearTimeout(ee),F=!1}}},D=T=>{let S=!0;return queueMicrotask(()=>{S&&(S=!1,T())}),{isTriggered:()=>S,dispose:()=>{S=!1}}};class E{constructor(S){this.defaultDelay=S,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(S,F=this.defaultDelay){this.g=S,this.h(),this.b||(this.b=new Promise((oe,z)=>{this.d=oe,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const oe=this.g;return this.g=null,oe()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=F===b.$2c?D(ee):g(F,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=E;class t{constructor(S){this.a=new E(S),this.b=new o}trigger(S,F){return this.a.trigger(()=>this.b.queue(S),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=t;class i{constructor(){this.a=!1,this.b=new Promise((S,F)=>{this.d=S})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=i;class r extends i{constructor(S){super(),this.f=setTimeout(()=>this.open(),S)}open(){clearTimeout(this.f),super.open()}}e.$rg=r;function n(T,S){return S?new Promise((F,ee)=>{const oe=setTimeout(()=>{z.dispose(),F()},T),z=S.onCancellationRequested(()=>{clearTimeout(oe),z.dispose(),ee(new O.$2)})}):P(F=>n(T,F))}e.$sg=n;function s(T,S=0){const F=setTimeout(T,S);return(0,I.$ib)(()=>clearTimeout(F))}e.$tg=s;function c(T){const S=[];let F=0;const ee=T.length;function oe(){return F<ee?T[F++]():null}function z(q){q!=null&&S.push(q);const W=oe();return W?W.then(z):Promise.resolve(S)}return Promise.resolve(null).then(z)}e.$ug=c;function f(T,S=ee=>!!ee,F=null){let ee=0;const oe=T.length,z=()=>{if(ee>=oe)return Promise.resolve(F);const q=T[ee++];return Promise.resolve(q()).then(U=>S(U)?Promise.resolve(U):z())};return z()}e.$vg=f;function k(T,S=ee=>!!ee,F=null){if(T.length===0)return Promise.resolve(F);let ee=T.length;const oe=()=>{ee=-1;for(const z of T)z.cancel?.()};return new Promise((z,q)=>{for(const W of T)W.then(U=>{--ee>=0&&S(U)?(oe(),z(U)):ee===0&&z(F)}).catch(U=>{--ee>=0&&(oe(),q(U))})})}e.$wg=k;class v{constructor(S){this.a=0,this.d=S,this.f=[],this.b=0,this.g=new a.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(S){return this.a++,new Promise((F,ee)=>{this.f.push({factory:S,c:F,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const S=this.f.shift();this.b++;const F=S.factory();F.then(S.c,S.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=v;class C extends v{constructor(){super(1)}}e.$yg=C;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const S=new Z;return this.b.add(S),S.p}d(){for(const[,S]of this.a)if(S.size>0)return!1;return!0}queueFor(S,F=L.$Vf){const ee=F.getComparisonKey(S);let oe=this.a.get(ee);return oe||(oe=new C,a.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(ee),this.f()}),this.a.set(ee,oe)),oe}f(){this.d()&&this.g()}g(){for(const S of this.b)S.complete();this.b.clear()}dispose(){for(const[,S]of this.a)S.dispose();this.a.clear(),this.g()}}e.$zg=A;class M{constructor(S,F){this.a=-1,typeof S=="function"&&typeof F=="number"&&this.setIfNotSet(S,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(S,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,S()},F)}setIfNotSet(S,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,S()},F))}}e.$Ag=M;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(S,F){this.cancel(),this.a=setInterval(()=>{S()},F)}}e.$Bg=K;class te{constructor(S,F){this.b=-1,this.a=S,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(S=this.d){this.cancel(),this.b=setTimeout(this.f,S)}get delay(){return this.d}set delay(S){this.d=S}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=te;class he{constructor(S,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=S,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(S=this.b){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(S/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=he;class ce extends te{constructor(S,F){super(S,F),this.j=[]}work(S){this.j.push(S),this.isScheduled()||this.schedule()}h(){const S=this.j;this.j=[],this.a?.(S)}dispose(){this.j=[],super.dispose()}}e.$Eg=ce;class le extends I.$kb{constructor(S,F){super(),this.g=S,this.h=F,this.a=[],this.b=this.B(new I.$lb),this.f=!1}get pending(){return this.a.length}work(S){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+S.length>this.g.maxBufferedWork)return!1}else if(this.pending+S.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of S)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=le,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=T=>{(0,R.$v)(()=>{if(S)return;const F=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let S=!1;return{dispose(){S||(S=!0)}}}:e.$Gg=(T,S)=>{const F=requestIdleCallback(T,typeof S=="number"?{timeout:S}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(F))}}}}();class ge{constructor(S){this.d=!1,this.a=()=>{try{this.f=S()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=ge;async function se(T,S,F){let ee;for(let oe=0;oe<F;oe++)try{return await T()}catch(z){ee=z,await n(S)}throw ee}e.$Ig=se;class V{hasPending(S){return this.a?typeof S=="number"?this.a.taskId===S:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(S,F,ee){return this.a={taskId:S,cancel:()=>ee?.(),promise:F},F.then(()=>this.d(S),()=>this.d(S)),F}d(S){this.a&&S===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const S=this.b;this.b=void 0,S.run().then(S.promiseResolve,S.promiseReject)}}setNext(S){if(this.b)this.b.run=S;else{let F,ee;const oe=new Promise((z,q)=>{F=z,ee=q});this.b={run:S,promise:oe,promiseResolve:F,promiseReject:ee}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=V;class ie{constructor(S,F=()=>Date.now()){this.d=S,this.f=F,this.a=0,this.b=0}increment(){const S=this.f();return S-this.a>this.d&&(this.a=S,this.b=0),this.b++,this.b}}e.$Kg=ie;var J;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(J||(J={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((S,F)=>{this.a=S,this.b=F})}complete(S){return new Promise(F=>{this.a(S),this.d={outcome:0,value:S},F()})}error(S){return new Promise(F=>{this.b(S),this.d={outcome:1,value:S},F()})}cancel(){return this.error(new O.$2)}}e.$Lg=Z;var H;(function(T){async function S(ee){let oe;const z=await Promise.all(ee.map(q=>q.then(W=>W,W=>{oe||(oe=W)})));if(typeof oe<"u")throw oe;return z}T.settled=S;function F(ee){return new Promise(async(oe,z)=>{try{await ee(oe,z)}catch(q){z(q)}})}T.withAsyncBody=F})(H||(e.Promises=H={}));var B;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(B||(B={}));class ne{static fromArray(S){return new ne(F=>{F.emitMany(S)})}static fromPromise(S){return new ne(async F=>{F.emitMany(await S)})}static fromPromises(S){return new ne(async F=>{await Promise.all(S.map(async ee=>F.emitOne(await ee)))})}static merge(S){return new ne(async F=>{await Promise.all(S.map(async ee=>{for await(const oe of ee)F.emitOne(oe)}))})}constructor(S){this.a=0,this.b=[],this.d=null,this.f=new a.$5c,queueMicrotask(async()=>{const F={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(S(F)),this.j()}catch(ee){this.k(ee)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let S=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(S<this.b.length)return{done:!1,value:this.b[S++]};if(this.a===1)return{done:!0,value:void 0};await a.Event.toPromise(this.f.event)}while(!0)}}}static map(S,F){return new ne(async ee=>{for await(const oe of S)ee.emitOne(F(oe))})}map(S){return ne.map(this,S)}static filter(S,F){return new ne(async ee=>{for await(const oe of S)F(oe)&&ee.emitOne(oe)})}filter(S){return ne.filter(this,S)}static coalesce(S){return ne.filter(S,F=>!!F)}coalesce(){return ne.coalesce(this)}static async toPromise(S){const F=[];for await(const ee of S)F.push(ee);return F}toPromise(){return ne.toPromise(this)}g(S){this.a===0&&(this.b.push(S),this.f.fire())}h(S){this.a===0&&(this.b=this.b.concat(S),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(S){this.a===0&&(this.a=2,this.d=S,this.f.fire())}}e.$Mg=ne,ne.EMPTY=ne.fromArray([]);class Q extends ne{constructor(S,F){super(F),this.l=S}cancel(){this.l.cancel()}}e.$Ng=Q;function _(T){const S=new y.$bd,F=T(S.token);return new Q(S,async ee=>{const oe=S.token.onCancellationRequested(()=>{oe.dispose(),S.dispose(),ee.reject(new O.$2)});try{for await(const z of F){if(S.token.isCancellationRequested)return;ee.emitOne(z)}oe.dispose(),S.dispose()}catch(z){oe.dispose(),S.dispose(),ee.reject(z)}})}e.$Og=_}),define(be[74],we([1,0,18,14,38,28,7,3,17]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0;function d(){return Object.create(null)}e.$8i=d,e.$9i="**",e.$0i="/";const P="[/\\\\]",p="[^/\\\\]",w=/\//g;function h(ie,J){switch(ie){case 0:return"";case 1:return`${p}*?`;default:return`(?:${P}|${p}+${P}${J?`|${P}${p}+`:""})*?`}}function m(ie,J){if(!ie)return[];const Z=[];let H=!1,B=!1,ne="";for(const Q of ie){switch(Q){case J:if(!H&&!B){Z.push(ne),ne="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":B=!0;break;case"]":B=!1;break}ne+=Q}return ne&&Z.push(ne),Z}e.$$i=m;function $(ie){if(!ie)return"";let J="";const Z=m(ie,e.$0i);if(Z.every(H=>H===e.$9i))J=".*";else{let H=!1;Z.forEach((B,ne)=>{if(B===e.$9i){if(H)return;J+=h(2,ne===Z.length-1)}else{let Q=!1,_="",T=!1,S="";for(const F of B){if(F!=="}"&&Q){_+=F;continue}if(T&&(F!=="]"||!S)){let ee;F==="-"?ee=F:(F==="^"||F==="!")&&!S?ee="^":F===e.$0i?ee="":ee=(0,b.$ld)(F),S+=ee;continue}switch(F){case"{":Q=!0;continue;case"[":T=!0;continue;case"}":{const oe=`(?:${m(_,",").map(z=>$(z)).join("|")})`;J+=oe,Q=!1,_="";break}case"]":{J+="["+S+"]",T=!1,S="";break}case"?":J+=p;continue;case"*":J+=h(1);continue;default:J+=(0,b.$ld)(F)}}ne<Z.length-1&&(Z[ne+1]!==e.$9i||ne+2<Z.length)&&(J+=P)}H=B===e.$9i})}return J}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$mi(1e4),i=function(){return!1},r=function(){return null};function n(ie,J){if(!ie)return r;let Z;typeof ie!="string"?Z=ie.pattern:Z=ie,Z=Z.trim();const H=`${Z}_${!!J.trimForExclusions}`;let B=t.get(H);if(B)return s(B,ie);let ne;return o.test(Z)?B=f(Z.substr(4),Z):(ne=u.exec(c(Z,J)))?B=k(ne[1],Z):(J.trimForExclusions?g:l).test(Z)?B=v(Z,J):(ne=D.exec(c(Z,J)))?B=C(ne[1].substr(1),Z,!0):(ne=E.exec(c(Z,J)))?B=C(ne[1],Z,!1):B=A(Z),t.set(H,B),s(B,ie)}function s(ie,J){if(typeof J=="string")return ie;const Z=function(H,B){return(0,a.$He)(H,J.base,!R.$f)?ie((0,b.$pd)(H.substr(J.base.length),L.sep),B):null};return Z.allBasenames=ie.allBasenames,Z.allPaths=ie.allPaths,Z.basenames=ie.basenames,Z.patterns=ie.patterns,Z}function c(ie,J){return J.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function f(ie,J){return function(Z,H){return typeof Z=="string"&&Z.endsWith(ie)?J:null}}function k(ie,J){const Z=`/${ie}`,H=`\\${ie}`,B=function(Q,_){return typeof Q!="string"?null:_?_===ie?J:null:Q===ie||Q.endsWith(Z)||Q.endsWith(H)?J:null},ne=[ie];return B.basenames=ne,B.patterns=[J],B.allBasenames=ne,B}function v(ie,J){const Z=se(ie.slice(1,-1).split(",").map(_=>n(_,J)).filter(_=>_!==r),ie),H=Z.length;if(!H)return r;if(H===1)return Z[0];const B=function(_,T){for(let S=0,F=Z.length;S<F;S++)if(Z[S](_,T))return ie;return null},ne=Z.find(_=>!!_.allBasenames);ne&&(B.allBasenames=ne.allBasenames);const Q=Z.reduce((_,T)=>T.allPaths?_.concat(T.allPaths):_,[]);return Q.length&&(B.allPaths=Q),B}function C(ie,J,Z){const H=L.sep===L.$8b.sep,B=H?ie:ie.replace(w,L.sep),ne=L.sep+B,Q=L.$8b.sep+ie;let _;return Z?_=function(T,S){return typeof T=="string"&&(T===B||T.endsWith(ne)||!H&&(T===ie||T.endsWith(Q)))?J:null}:_=function(T,S){return typeof T=="string"&&(T===B||!H&&T===ie)?J:null},_.allPaths=[(Z?"*/":"./")+ie],_}function A(ie){try{const J=new RegExp(`^${$(ie)}$`);return function(Z){return J.lastIndex=0,typeof Z=="string"&&J.test(Z)?ie:null}}catch{return r}}function M(ie,J,Z){return!ie||typeof J!="string"?!1:K(ie)(J,void 0,Z)}e.$_i=M;function K(ie,J={}){if(!ie)return i;if(typeof ie=="string"||te(ie)){const Z=n(ie,J);if(Z===r)return i;const H=function(B,ne){return!!Z(B,ne)};return Z.allBasenames&&(H.allBasenames=Z.allBasenames),Z.allPaths&&(H.allPaths=Z.allPaths),H}return le(ie,J)}e.$aj=K;function te(ie){const J=ie;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$bj=te;function he(ie){return ie.allBasenames||[]}e.$cj=he;function ce(ie){return ie.allPaths||[]}e.$dj=ce;function le(ie,J){const Z=se(Object.getOwnPropertyNames(ie).map(_=>ge(_,ie[_],J)).filter(_=>_!==r)),H=Z.length;if(!H)return r;if(!Z.some(_=>!!_.requiresSiblings)){if(H===1)return Z[0];const _=function(F,ee){let oe;for(let z=0,q=Z.length;z<q;z++){const W=Z[z](F,ee);if(typeof W=="string")return W;(0,O.$eg)(W)&&(oe||(oe=[]),oe.push(W))}return oe?(async()=>{for(const z of oe){const q=await z;if(typeof q=="string")return q}return null})():null},T=Z.find(F=>!!F.allBasenames);T&&(_.allBasenames=T.allBasenames);const S=Z.reduce((F,ee)=>ee.allPaths?F.concat(ee.allPaths):F,[]);return S.length&&(_.allPaths=S),_}const B=function(_,T,S){let F,ee;for(let oe=0,z=Z.length;oe<z;oe++){const q=Z[oe];q.requiresSiblings&&S&&(T||(T=(0,L.$cc)(_)),F||(F=T.substr(0,T.length-(0,L.$dc)(_).length)));const W=q(_,T,F,S);if(typeof W=="string")return W;(0,O.$eg)(W)&&(ee||(ee=[]),ee.push(W))}return ee?(async()=>{for(const oe of ee){const z=await oe;if(typeof z=="string")return z}return null})():null},ne=Z.find(_=>!!_.allBasenames);ne&&(B.allBasenames=ne.allBasenames);const Q=Z.reduce((_,T)=>T.allPaths?_.concat(T.allPaths):_,[]);return Q.length&&(B.allPaths=Q),B}function ge(ie,J,Z){if(J===!1)return r;const H=n(ie,Z);if(H===r)return r;if(typeof J=="boolean")return H;if(J){const B=J.when;if(typeof B=="string"){const ne=(Q,_,T,S)=>{if(!S||!H(Q,_))return null;const F=B.replace("$(basename)",()=>T),ee=S(F);return(0,O.$eg)(ee)?ee.then(oe=>oe?ie:null):ee?ie:null};return ne.requiresSiblings=!0,ne}}return H}function se(ie,J){const Z=ie.filter(_=>!!_.basenames);if(Z.length<2)return ie;const H=Z.reduce((_,T)=>{const S=T.basenames;return S?_.concat(S):_},[]);let B;if(J){B=[];for(let _=0,T=H.length;_<T;_++)B.push(J)}else B=Z.reduce((_,T)=>{const S=T.patterns;return S?_.concat(S):_},[]);const ne=function(_,T){if(typeof _!="string")return null;if(!T){let F;for(F=_.length;F>0;F--){const ee=_.charCodeAt(F-1);if(ee===47||ee===92)break}T=_.substr(F)}const S=H.indexOf(T);return S!==-1?B[S]:null};ne.basenames=H,ne.patterns=B,ne.allBasenames=H;const Q=ie.filter(_=>!_.basenames);return Q.push(ne),Q}function V(ie,J){return(0,y.$$e)(ie,J,(Z,H)=>typeof Z=="string"&&typeof H=="string"?Z===H:typeof Z!="string"&&typeof H!="string"?Z.base===H.base&&Z.pattern===H.pattern:!1)}e.$ej=V}),define(be[100],we([1,0,11,147,19,17,4]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class b{constructor(u="",l=!1){if(this.value=u,typeof this.value!="string")throw(0,y.$4)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(u,l=0){return this.value+=w(this.supportThemeIcons?(0,O.$Aj)(u):u).replace(/([ \t]+)/g,(g,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,l){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(u,l,g){return this.value+="[",this.value+=this.c(l,"]"),this.value+="](",this.value+=this.c(String(u),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(u,l){const g=new RegExp((0,I.$ld)(l),"g");return u.replace(g,(D,E)=>u.charAt(E-1)!=="\\"?`\\${D}`:D)}}e.$Gj=b;function d(o){return P(o)?!o.value:Array.isArray(o)?o.every(d):!0}e.$Hj=d;function P(o){return o instanceof b?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$Ij=P;function p(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,a.$Yf)(L.URI.from(o.baseUri),L.URI.from(u.baseUri)))}e.$Jj=p;function w(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Kj=w;function h(o){return o.replace(/"/g,"&quot;")}e.$Lj=h;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Mj=m;function $(o){const u=[],l=o.split("|").map(D=>D.trim());o=l[0];const g=l[1];if(g){const D=/height=(\d+)/.exec(g),E=/width=(\d+)/.exec(g),t=D?D[1]:"",i=E?E[1]:"",r=isFinite(parseInt(i)),n=isFinite(parseInt(t));r&&u.push(`width="${i}"`),n&&u.push(`height="${t}"`)}return{href:o,dimensions:u}}e.$Nj=$}),define(be[149],we([1,0,18,38,7,3,19,17]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xz=e.$Wz=e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=void 0;function b(n,s){const{os:c,tildify:f,relative:k}=s;if(k){const A=d(n,k,c);if(typeof A=="string")return A}let v=n.fsPath;if(c===1&&!I.$d?v=v.replace(/\//g,"\\"):c!==1&&I.$d&&(v=v.replace(/\\/g,"/")),c!==1&&f?.userHome){const A=f.userHome.fsPath;let M;n.scheme!==f.userHome.scheme&&n.path.startsWith(a.$8b.sep)?M=f.userHome.with({path:n.path}).fsPath:M=n.fsPath,v=w(M,A,c)}return(c===1?a.$7b:a.$8b).normalize(P(v,c===1))}e.$Oz=b;function d(n,s,c){const f=c===1?a.$7b:a.$8b,k=c===3?L.$Vf:L.$Xf,v=s.getWorkspace(),C=(0,y.$sf)(v.folders);if(!C)return;n.scheme!==C.uri.scheme&&n.path.startsWith(a.$8b.sep)&&(n=C.uri.with({path:n.path}));const A=s.getWorkspaceFolder(n);if(!A)return;let M;if(k.isEqual(A.uri,n)?M="":M=k.relativePath(A.uri,n)??"",M&&(M=f.normalize(M)),v.folders.length>1&&!s.noPrefix){const K=A.name?A.name:k.basenameOrAuthority(A.uri);M=M?`${K} \u2022 ${M}`:K}return M}function P(n,s=I.$d){return(0,O.$Le)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$Pz=P;let p=Object.create(null);function w(n,s,c=I.OS){if(c===1||!n||!s)return n;let f=p.original===s?p.normalized:void 0;f||(f=s,I.$d&&(f=(0,O.$Be)(f)),f=`${(0,R.$qd)(f,a.$8b.sep)}${a.$8b.sep}`,p={original:s,normalized:f});let k=n;return I.$d&&(k=(0,O.$Be)(k)),(c===3?k.startsWith(f):(0,R.$Kd)(k,f))?`~/${k.substr(f.length)}`:n}e.$Qz=w;function h(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}e.$Rz=h;const m="\u2026",$="\\\\",o="~";function u(n,s=a.sep){const c=new Array(n.length);let f=!1;for(let k=0;k<n.length;k++){const v=n[k];if(v===""){c[k]=`.${s}`;continue}if(!v){c[k]=v;continue}f=!0;let C="",A=v;A.indexOf($)===0?(C=A.substr(0,A.indexOf($)+$.length),A=A.substr(A.indexOf($)+$.length)):A.indexOf(s)===0?(C=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length)):A.indexOf(o)===0&&(C=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const M=A.split(s);for(let K=1;f&&K<=M.length;K++)for(let te=M.length-K;f&&te>=0;te--){f=!1;let he=M.slice(te,te+K).join(s);for(let ce=0;!f&&ce<n.length;ce++)if(ce!==k&&n[ce]&&n[ce].indexOf(he)>-1){const le=te+K===M.length,ge=te>0&&n[ce].indexOf(s)>-1?s+he:he,se=n[ce].endsWith(ge);f=!le||se}if(!f){let ce="";(M[0].endsWith(":")||C!=="")&&(te===1&&(te=0,K++,he=M[0]+s+he),te>0&&(ce=M[0]+s),ce=C+ce),te>0&&(ce=ce+m+s),ce=ce+he,te+K<M.length&&(ce=ce+s+m),c[k]=ce}}f&&(c[k]=v)}return c}e.$Sz=u;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function g(n,s=Object.create(null)){const c=[];let f=!1,k="";for(const v of n)if(v==="$"||f&&v==="{")k&&c.push({value:k,type:l.TEXT}),k="",f=!0;else if(v==="}"&&f){const C=s[k];if(typeof C=="string")C.length&&c.push({value:C,type:l.VARIABLE});else if(C){const A=c[c.length-1];(!A||A.type!==l.SEPARATOR)&&c.push({value:C.label,type:l.SEPARATOR})}k="",f=!1}else k+=v;return k&&!f&&c.push({value:k,type:l.TEXT}),c.filter((v,C)=>{if(v.type===l.SEPARATOR){const A=c[C-1],M=c[C+1];return[A,M].every(K=>K&&(K.type===l.VARIABLE||K.type===l.TEXT)&&K.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Tz=g;function D(n,s){return I.$e||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$e?"&":"&&"):n.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Uz=D;function E(n,s){return I.$e||s?n.replace(/\(&&\w\)|&&/g,""):I.$d?n.replace(/&&|&/g,c=>c==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$Vz=E;function t(n){return n.replace(/&/g,"&&")}e.$Wz=t;function i(n){if(n.endsWith("]")){const s=n.lastIndexOf(" [",n.length-2);if(s!==-1){const c=r(n.substring(0,s));return{name:c.name,parentPath:c.parentPath+n.substring(s)}}}return r(n)}e.$Xz=i;function r(n){const s=n.indexOf("/")!==-1?a.$8b:a.$7b,c=s.basename(n),f=s.dirname(n);return c.length?{name:c,parentPath:f}:{name:f,parentPath:""}}}),define(be[50],we([1,0,15,4]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=void 0;function a(p){return p.toJSON()}class I{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:a(O.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:a(O.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:O.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$km=I,e.$lm=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function L(p,w,h){if(!p||h>200)return null;if(typeof p=="object"){if(p instanceof O.URI)return w.transformOutgoing(p);for(const m in p)if(Object.hasOwnProperty.call(p,m)){const $=L(p[m],w,h+1);$!==null&&(p[m]=$)}}return null}function R(p,w){const h=L(p,w,0);return h===null?p:h}e.$mm=R;function b(p,w,h,m){if(!p||m>200)return null;if(typeof p=="object"){if(p.$mid===1)return h?O.URI.revive(w.transformIncoming(p)):w.transformIncoming(p);if(p instanceof y.$Ib)return null;for(const $ in p)if(Object.hasOwnProperty.call(p,$)){const o=b(p[$],w,h,m+1);o!==null&&(p[$]=o)}}return null}function d(p,w){const h=b(p,w,!1,0);return h===null?p:h}e.$nm=d;function P(p,w){const h=b(p,w,!0,0);return h===null?p:h}e.$om=P}),define(be[21],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(a){return y.test(a)}e.$2e=O,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let a;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?a=crypto.getRandomValues.bind(crypto):a=function(R){for(let b=0;b<R.length;b++)R[b]=Math.floor(Math.random()*256);return R};const I=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){a(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let b=0,d="";return d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d+="-",d+=L[I[b++]],d+=L[I[b++]],d+="-",d+=L[I[b++]],d+=L[I[b++]],d+="-",d+=L[I[b++]],d+=L[I[b++]],d+="-",d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d+=L[I[b++]],d}}()}),define(be[150],we([1,0,18,46,21]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.$0r=e.$9r=e.$8r=void 0;function I(p){return{asString:async()=>p,asFile:()=>{},value:typeof p=="string"?p:void 0}}e.$8r=I;function L(p,w,h){const m={id:(0,a.$3e)(),name:p,uri:w,data:h};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$9r=L;class R{constructor(){this.a=new Map}get size(){let w=0;for(const h of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const h=[...this.a.keys()];return O.Iterable.some(this,([m,$])=>$.asFile())&&h.push("files"),P(b(w),h)}get(w){return this.a.get(this.b(w))?.[0]}append(w,h){const m=this.a.get(w);m?m.push(h):this.a.set(this.b(w),[h])}replace(w,h){this.a.set(this.b(w),[h])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,h]of this.a)for(const m of h)yield[w,m]}b(w){return b(w)}}e.$0r=R;function b(p){return p.toLowerCase()}function d(p,w){return P(b(p),w.map(b))}e.$$r=d;function P(p,w){if(p==="*/*")return w.length>0;if(w.includes(p))return!0;const h=p.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!h)return!1;const[m,$,o]=h;return o==="*"?w.some(u=>u.startsWith($+"/")):!1}e.$_r=Object.freeze({create:p=>(0,y.$of)(p.map(w=>w.toString())).join(`\r
`),split:p=>p.split(`\r
`),parse:p=>e.$_r.split(p).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function ae(e,y,O){function a(h){return new Promise(m=>y.exists(h,m))}function I(h){return new Promise((m,$)=>{const o=new Date;y.utimes(h,o,o,u=>u?$(u):m())})}function L(h){return new Promise((m,$)=>y.mkdir(h,{recursive:!0},o=>o&&o.code!=="EEXIST"?$(o):m(h)))}function R(h){return new Promise((m,$)=>y.rm(h,{recursive:!0,force:!0,maxRetries:3},o=>o?$(o):m()))}function b(h){return new Promise((m,$)=>y.readFile(h,"utf8",(o,u)=>o?$(o):m(u)))}function d(h,m){return new Promise(($,o)=>y.writeFile(h,m,"utf8",u=>u?o(u):$()))}async function P(h){const m=e.join(h,"languagepacks.json");try{return JSON.parse(await b(m))}catch{}}function p(h,m){try{for(;m;){if(h[m])return m;{const $=m.lastIndexOf("-");if($>0)m=m.substring(0,$);else return}}}catch($){console.error("Resolving language pack configuration failed.",$)}}function w(h,m,$,o,u){const l=function(D){return O.mark("code/didGenerateNls"),Promise.resolve({locale:D,osLocale:u,availableLanguages:{}})};if(O.mark("code/willGenerateNls"),o==="pseudo")return Promise.resolve({locale:o,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:o,osLocale:u,availableLanguages:{}});if(o&&(o==="en"||o==="en-us"))return Promise.resolve({locale:o,osLocale:u,availableLanguages:{}});const g=o;try{return h?P(m).then(D=>{if(!D)return l(g);const E=p(D,o);if(!E)return l(g);o=E;const t=D[o];let i;return!t||typeof t.hash!="string"||!t.translations||typeof(i=t.translations.vscode)!="string"?l(g):a(i).then(r=>{if(!r)return l(g);const n=t.hash+"."+o,s=e.join(m,"clp",n),c=e.join(s,h),f=e.join(s,"tcf.json"),k=e.join(s,"corrupted.info"),v={locale:g,osLocale:u,availableLanguages:{"*":o},_languagePackId:n,_translationsConfigFile:f,_cacheRoot:s,_resolvedLanguagePackCoreLocation:c,_corruptedFile:k};return a(k).then(C=>{let A;return C?A=R(s):A=Promise.resolve(void 0),A.then(()=>a(c).then(M=>M?(I(c).catch(()=>{}),O.mark("code/didGenerateNls"),v):L(c).then(()=>Promise.all([b($),b(i)])).then(K=>{const te=JSON.parse(K[0]),he=JSON.parse(K[1]).contents,ce=Object.keys(te.bundles),le=[];for(const ge of ce){const se=te.bundles[ge],V=Object.create(null);for(const ie of se){const J=te.keys[ie],Z=te.messages[ie],H=he[ie];let B;if(H){B=[];for(let ne=0;ne<J.length;ne++){const Q=J[ne],_=typeof Q=="string"?Q:Q.key;let T=H[_];T===void 0&&(T=Z[ne]),B.push(T)}}else B=Z;V[ie]=B}le.push(d(e.join(c,ge.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return le.push(d(f,JSON.stringify(t.translations))),Promise.all(le)}).then(()=>(O.mark("code/didGenerateNls"),v)).catch(K=>(console.error("Generating translation files failed.",K),l(o)))))})})}):l(g)}catch(D){return console.error("Generating translation files failed.",D),l(o)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(be[151],we([75,30,42]),function(e,y,O){return ae(e,y,O)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),O=require("../common/performance");module.exports=ae(e,y,O)}else throw new Error("Unknown context")}(),define(be[152],we([1,0,26]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function a(L){const R=L.replace(/\-/g,":").toLowerCase();return!O.has(R)}function I(){const L=(0,y.networkInterfaces)();for(const R in L){const b=L[R];if(b){for(const{mac:d}of b)if(a(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$pm=I}),define(be[101],we([1,0,26,61,21,152]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0,e.$qm=new class{c(d){return this.a||(this.a=O.$rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,P=0;const p=(0,y.networkInterfaces)();for(const w in p){const h=p[w];if(h)for(const{mac:m,internal:$}of h)$||(P+=1,this.c(m.toUpperCase())&&(d+=1))}this.b=P>0?d/P:0}return this.b}};let L;async function R(d){return L||(L=(async()=>await b(d)||a.$3e())()),L}e.$rm=R;async function b(d){try{const P=await new Promise((w,h)=>{ae(["crypto"],w,h)}),p=(0,I.$pm)();return P.createHash("sha256").update(p,"utf8").digest("hex")}catch(P){d(P);return}}}),define(be[153],we([1,0,30,292,293,3]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=void 0;async function L(R){if(I.$e||I.$d)return;let b;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,O.open)(d,y.constants.R_OK);break}catch{}if(!b){R("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),P={id:"unknown"};for await(const p of(0,a.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!p.includes("="))continue;const w=p.split("=")[0].toUpperCase().trim();if(d.has(w)){const h=p.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?P.id=h:w==="ID_LIKE"?P.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(P.version_id=h)}}return P}catch(d){R(d)}}e.$4e=L}),define(be[23],we([1,0,30,26,294,14,38,97,7,3,19,4]),function(ae,e,y,O,a,I,L,R,b,d,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(le){le[le.UNLINK=0]="UNLINK",le[le.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(le,ge=w.UNLINK,se){if((0,L.$Ke)(le))throw new Error("rimraf - will refuse to recursively delete root");return ge===w.UNLINK?$(le):m(le,se)}async function m(le,ge=(0,L.$Pe)((0,O.tmpdir)())){try{try{await y.promises.rename(le,ge)}catch(se){return se.code==="ENOENT"?void 0:$(le)}$(ge).catch(se=>{})}catch(se){if(se.code!=="ENOENT")throw se}}async function $(le){return(0,a.promisify)(y.rm)(le,{recursive:!0,force:!0,maxRetries:3})}function o(le){if((0,L.$Ke)(le))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(le,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function u(le,ge){return D(await(ge?l(le):(0,a.promisify)(y.readdir)(le)))}async function l(le){try{return await(0,a.promisify)(y.readdir)(le,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const ge=[],se=await u(le);for(const V of se){let ie=!1,J=!1,Z=!1;try{const H=await e.Promises.lstat((0,b.$$b)(le,V));ie=H.isFile(),J=H.isDirectory(),Z=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ge.push({name:V,isFile:()=>ie,isDirectory:()=>J,isSymbolicLink:()=>Z})}return ge}function g(le){return D(y.readdirSync(le))}e.readdirSync=g;function D(le){return le.map(ge=>typeof ge=="string"?d.$e?(0,R.$4k)(ge):ge:(ge.name=d.$e?(0,R.$4k)(ge.name):ge.name,ge))}async function E(le){const ge=await u(le),se=[];for(const V of ge)await i.existsDirectory((0,b.$$b)(le,V))&&se.push(V);return se}function t(le,ge=1e3){return new Promise(se=>{let V=!1;const ie=setInterval(()=>{V||(V=!0,y.access(le,J=>{V=!1,J&&(clearInterval(ie),se(void 0))}))},ge)})}e.whenDeleted=t;var i;(function(le){async function ge(ie){let J;try{if(J=await e.Promises.lstat(ie),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(ie),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(d.$d&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ie)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw H}throw Z}}le.stat=ge;async function se(ie){try{const{stat:J,symbolicLink:Z}=await le.stat(ie);return J.isFile()&&Z?.dangling!==!0}catch{}return!1}le.existsFile=se;async function V(ie){try{const{stat:J,symbolicLink:Z}=await le.stat(ie);return J.isDirectory()&&Z?.dangling!==!0}catch{}return!1}le.existsDirectory=V})(i||(e.SymlinkSupport=i={}));const r=new I.$zg;function n(le,ge,se){return r.queueFor(p.URI.file(le),P.$Wf).queue(()=>{const V=v(se);return new Promise((ie,J)=>f(le,ge,V,Z=>Z?J(Z):ie()))})}let s=!0;function c(le){s=le}e.configureFlushOnWrite=c;function f(le,ge,se,V){if(!s)return y.writeFile(le,ge,{mode:se.mode,flag:se.flag},V);y.open(le,se.flag,se.mode,(ie,J)=>{if(ie)return V(ie);y.writeFile(J,ge,Z=>{if(Z)return y.close(J,()=>V(Z));y.fdatasync(J,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),y.close(J,B=>V(B))))})})}function k(le,ge,se){const V=v(se);if(!s)return y.writeFileSync(le,ge,{mode:V.mode,flag:V.flag});const ie=y.openSync(le,V.flag,V.mode);try{y.writeFileSync(ie,ge);try{y.fdatasyncSync(ie)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),c(!1)}}finally{y.closeSync(ie)}}e.writeFileSync=k;function v(le){return le?{mode:typeof le.mode=="number"?le.mode:438,flag:typeof le.flag=="string"?le.flag:"w"}:{mode:438,flag:"w"}}async function C(le,ge){if(le!==ge)try{await e.Promises.rename(le,ge)}catch(se){if(le.toLowerCase()!==ge.toLowerCase()&&se.code==="EXDEV"||le.endsWith("."))await A(le,ge,{preserveSymlinks:!1}),await h(le,w.MOVE);else throw se}}async function A(le,ge,se){return K(le,ge,{root:{source:le,target:ge},options:se,handledSourcePaths:new Set})}const M=511;async function K(le,ge,se){if(se.handledSourcePaths.has(le))return;se.handledSourcePaths.add(le);const{stat:V,symbolicLink:ie}=await i.stat(le);if(ie){if(se.options.preserveSymlinks)try{return await ce(le,ge,se)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(ie.dangling)return}return V.isDirectory()?te(le,ge,V.mode&M,se):he(le,ge,V.mode&M)}async function te(le,ge,se,V){await e.Promises.mkdir(ge,{recursive:!0,mode:se});const ie=await u(le);for(const J of ie)await K((0,b.$$b)(le,J),(0,b.$$b)(ge,J),V)}async function he(le,ge,se){await e.Promises.copyFile(le,ge),await e.Promises.chmod(ge,se)}async function ce(le,ge,se){let V=await e.Promises.readlink(le);(0,L.$He)(V,se.root.source,!d.$f)&&(V=(0,b.$$b)(se.root.target,V.substr(se.root.source.length+1))),await e.Promises.symlink(V,ge)}e.Promises=new class{get access(){return(0,a.promisify)(y.access)}get stat(){return(0,a.promisify)(y.stat)}get lstat(){return(0,a.promisify)(y.lstat)}get utimes(){return(0,a.promisify)(y.utimes)}get read(){return(le,ge,se,V,ie)=>new Promise((J,Z)=>{y.read(le,ge,se,V,ie,(H,B,ne)=>H?Z(H):J({bytesRead:B,buffer:ne}))})}get readFile(){return(0,a.promisify)(y.readFile)}get write(){return(le,ge,se,V,ie)=>new Promise((J,Z)=>{y.write(le,ge,se,V,ie,(H,B,ne)=>H?Z(H):J({bytesWritten:B,buffer:ne}))})}get appendFile(){return(0,a.promisify)(y.appendFile)}get fdatasync(){return(0,a.promisify)(y.fdatasync)}get truncate(){return(0,a.promisify)(y.truncate)}get rename(){return(0,a.promisify)(y.rename)}get copyFile(){return(0,a.promisify)(y.copyFile)}get open(){return(0,a.promisify)(y.open)}get close(){return(0,a.promisify)(y.close)}get symlink(){return(0,a.promisify)(y.symlink)}get readlink(){return(0,a.promisify)(y.readlink)}get chmod(){return(0,a.promisify)(y.chmod)}get mkdir(){return(0,a.promisify)(y.mkdir)}get unlink(){return(0,a.promisify)(y.unlink)}get rmdir(){return(0,a.promisify)(y.rmdir)}get realpath(){return(0,a.promisify)(y.realpath)}async exists(le){try{return await e.Promises.access(le),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return E}get writeFile(){return n}get rm(){return h}get move(){return C}get copy(){return A}}}),define(be[154],we([1,0,30,7,3,17,23]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function R(w){if(a.$f)return w;const h=(0,O.$bc)(w);if(w===h)return w;const m=((0,O.$cc)(w)||w).toLowerCase();try{const o=(0,L.readdirSync)(h).filter(u=>u.toLowerCase()===m);if(o.length===1){const u=R(h);if(u)return(0,O.$$b)(u,o[0])}else if(o.length>1){const u=o.indexOf(m);if(u>=0){const l=R(h);if(l)return(0,O.$$b)(l,o[u])}}}catch{}return null}e.$Gp=R;async function b(w){if(a.$f)return w;const h=(0,O.$bc)(w);if(w===h)return w;const m=((0,O.$cc)(w)||w).toLowerCase();try{const o=(await L.Promises.readdir(h)).filter(u=>u.toLowerCase()===m);if(o.length===1){const u=await b(h);if(u)return(0,O.$$b)(u,o[0])}else if(o.length>1){const u=o.indexOf(m);if(u>=0){const l=await b(h);if(l)return(0,O.$$b)(l,o[u])}}}catch{}return null}e.$Hp=b;async function d(w){try{return await L.Promises.realpath(w)}catch{const m=p(w);return await L.Promises.access(m,y.constants.R_OK),m}}e.$Ip=d;function P(w){try{return y.realpathSync(w)}catch{const m=p(w);return y.accessSync(m,y.constants.R_OK),m}}e.$Jp=P;function p(w){return(0,I.$qd)((0,O.$9b)(w),O.sep)}}),define(be[155],we([1,0,76]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function O(R,b,d,P=1){let p=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!p)return p=!0,w(0)},d);a(R,b,P,m=>{if(!p)return p=!0,clearTimeout(h),w(m)})})}e.$5e=O;function a(R,b,d,P){if(b===0)return P(0);const p=new y.Socket;p.once("connect",()=>(L(p),a(R+d,b-1,d,P))),p.once("data",()=>{}),p.once("error",w=>(L(p),w.code!=="ECONNREFUSED"?a(R+d,b-1,d,P):P(R))),p.connect(R,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(R,b,d,P="127.0.0.1"){let p=!1,w,h=1;const m=y.createServer({pauseOnConnect:!0});function $(o,u){p||(p=!0,m.removeAllListeners(),m.close(),w&&clearTimeout(w),u(o))}return new Promise(o=>{w=setTimeout(()=>{$(0,o)},d),m.on("listening",()=>{$(R,o)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<b?(R++,h++,m.listen(R,P)):$(0,o)}),m.on("close",()=>{$(0,o)}),m.listen(R,P)})}e.$7e=I;function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(be[102],we([1,0,26,7,23]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=void 0;const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(D){D[D.x64=0]="x64",D[D.x86=1]="x86",D[D.ARM=2]="ARM"})(b||(b={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class p{constructor(E,t,i){this.exePath=E,this.displayName=t,this.a=i}async exists(){return this.a===void 0&&(this.a=await a.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:D=!1}={}){return D?d===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:D=!1,findPreview:E=!1}={}){const t=w({useAlternateBitness:D});if(!t)return null;const i=O.$$b(t,"PowerShell");if(!await a.SymlinkSupport.existsDirectory(i))return null;let r=-1,n=null;for(const f of await a.Promises.readdir(i)){let k=-1;if(E){const C=f.indexOf("-");if(C<0)continue;const A=f.substring(0,C);if(!I.test(A)||f.substring(C+1)!=="preview")continue;k=parseInt(A,10)}else{if(!I.test(f))continue;k=parseInt(f,10)}if(k<=r)continue;const v=O.$$b(i,f,"pwsh.exe");await a.SymlinkSupport.existsFile(v)&&(n=v,r=k)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",c=E?" Preview":"";return new p(n,`PowerShell${c}${s}`,!0)}async function m({findPreview:D}={}){if(!process.env.LOCALAPPDATA)return null;const E=O.$$b(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await a.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=D?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await a.Promises.readdir(E))if(t.test(r)){const n=O.$$b(E,r,"pwsh.exe");return new p(n,i)}return null}function $(){const D=O.$$b(y.homedir(),".dotnet","tools","pwsh.exe");return new p(D,".NET Core PowerShell Global Tool")}function o(){const D=O.$$b(process.env.windir,d===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(D,"Windows PowerShell",!0)}async function*u(){let D=await h();D&&(yield D),D=await h({useAlternateBitness:!0}),D&&(yield D),D=await m(),D&&(yield D),D=$(),D&&(yield D),D=await h({findPreview:!0}),D&&(yield D),D=await m({findPreview:!0}),D&&(yield D),D=await h({useAlternateBitness:!0,findPreview:!0}),D&&(yield D),D=o(),D&&(yield D)}async function*l(){for await(const D of u())await D.exists()&&(yield D)}e.$al=l;async function g(){for await(const D of l())return D;return null}e.$bl=g}),define(be[103],we([1,0,7,3,29,59,8,23]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$fl=e.$el=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function b(p=a.env){return p.comspec||"cmd.exe"}e.$el=b;function d(p){let w=[],h=!1;const m=function($){if(h){w.push($);return}(!p.send($,u=>{if(u&&console.error(u),h=!1,w.length>0){const l=w.slice(0);w=[],l.forEach(g=>m(g))}})||O.$d)&&(h=!0)};return{send:m}}e.$fl=d;var P;(function(p){async function w(h,m,$){if(y.$0b(h))return h;if(m===void 0&&(m=a.cwd()),y.$bc(h)!=="."||($===void 0&&L.$ge(a.env.PATH)&&($=a.env.PATH.split(y.$ic)),$===void 0||$.length===0))return y.$$b(m,h);async function u(l){if(await R.Promises.exists(l)){let g;try{g=await R.Promises.stat(l)}catch(D){D.message.startsWith("EACCES")&&(g=await R.Promises.lstat(l))}return g?!g.isDirectory():!1}return!1}for(const l of $){let g;if(y.$0b(l)?g=y.$$b(l,h):g=y.$$b(m,l,h),await u(g))return g;let D=g+".com";if(await u(D)||(D=g+".exe",await u(D)))return D}return y.$$b(m,h)}p.findExecutable=w})(P||(e.win32=P={}))}),define(be[104],we([1,0,51,13]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;function a(L){return new Promise((R,b)=>{let d;const P=new Map;function p(h,m,$,o,u){const l=P.get(m);if(h===L||l){const g={name:w($),cmd:$,pid:h,ppid:m,load:o,mem:u};P.set(h,g),h===L&&(d=g),l&&(l.children||(l.children=[]),l.children.push(g),l.children.length>1&&(l.children=l.children.sort((D,E)=>D.pid-E.pid)))}}function w(h){const m=/--utility-sub-type=network/i,$=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(o.exec(h))return"electron-crash-reporter";if(u.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let D=g.exec(h);if(D&&D.length===2)return D[1]==="renderer"?"window":D[1]==="utility"?m.exec(h)?"utility-network-service":"utility-process":D[1]==="extensionHost"?"extension-host":D[1];const E=/[a-zA-Z-]+\.js/g;let t="";do D=E.exec(h),D&&(t+=D+" ");while(D);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:$.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,$)=>{ae(["@vscode/windows-process-tree"],m,$)}).then(m=>{m.getProcessList(L,$=>{if(!$){b(new Error(`Root process ${L} not found`));return}m.getProcessCpuUsage($,o=>{const u=new Map;o.forEach(l=>{const g=h(l.commandLine||"");u.set(l.pid,{name:w(g),cmd:g,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),d=u.get(L),d?(u.forEach(l=>{const g=u.get(l.ppid);g&&(g.children||(g.children=[]),g.children.push(l))}),u.forEach(l=>{l.children&&(l.children=l.children.sort((g,D)=>g.pid-D.pid))}),R(d)):b(new Error(`Root process ${L} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let h=function(){let m=[d];const $=[];for(;m.length;){const u=m.shift();u&&($.push(u.pid),u.children&&(m=m.concat(u.children)))}let o=JSON.stringify(O.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+$.join(" "),(0,y.exec)(o,{},(u,l,g)=>{if(u||g)b(u||new Error(g.toString()));else{const D=l.toString().split(`
`);for(let E=0;E<$.length;E++){const t=P.get($[E]);t.load=parseFloat(D[E])}if(!d){b(new Error(`Root process ${L} not found`));return}R(d)}})};(0,y.exec)("which ps",{},(m,$,o)=>{if(m||o)if(process.platform!=="linux")b(m||new Error(o.toString()));else{const u=JSON.stringify(O.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(u,{},(l,g,D)=>{l||D?b(l||new Error(D.toString())):(I(g,p),h())})}else{const u=$.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${u} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,D,E)=>{g||E&&!E.includes("screen size is bogus")?b(g||new Error(E.toString())):(I(D,p),process.platform==="linux"?h():d?R(d):b(new Error(`Root process ${L} not found`)))})}})}})}e.$cr=a;function I(L,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=L.toString().split(`
`);for(const P of d){const p=b.exec(P.trim());p&&p.length===6&&R(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(be[156],we([1,0,26,3,102,103]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=void 0;async function L(p,w){return p===1?O.$d?P():I.$el(w):b(p,w)}e.$gl=L;let R=null;function b(p,w){if(O.$f&&p===2||O.$e&&p===3)return"/bin/bash";if(!R){let h;if(O.$d)h="/bin/bash";else{if(h=w.SHELL,!h)try{h=(0,y.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}R=h}return R}let d=null;async function P(){return d||(d=(await(0,a.$bl)()).exePath),d}}),function(){function ae(){function e(){return process.uncHostAllowlist}function y(b){const d=new Set;if(Array.isArray(b))for(const P of b)typeof P=="string"&&d.add(P);return Array.from(d)}function O(){const b=e();return b?Array.from(b):[]}function a(b){if(process.platform!=="win32")return;const d=e();if(d)if(typeof b=="string")d.add(b.toLowerCase());else for(const P of y(b))a(P)}function I(b){if(typeof b!="string")return;const d=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let P;for(const p of d){if(b.indexOf(p)!==0)continue;const h=b.indexOf("\\",p.length);if(h===-1)continue;const m=b.substring(p.length,h);if(m){P=m;break}}return P}function L(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:a,getUNCHost:I,disableUNCAccessRestrictions:L,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ae()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ae():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Re=this&&this.__decorate||function(ae,e,y,O){var a=arguments.length,I=a<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,y):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ae,e,y,O);else for(var R=ae.length-1;R>=0;R--)(L=ae[R])&&(I=(a<3?L(I):a>3?L(e,y,I):L(e,y))||I);return a>3&&I&&Object.defineProperty(e,y,I),I};define(be[43],we([1,0,18,14,15,20,93,11,5,2,49,17,8]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.ProxyChannel=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.RequestInitiator=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0;var h;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(h||(h={}));function m(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var $;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})($||($={}));function o(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(u||(u={}));function l(J){let Z=0;for(let H=0;;H+=7){const B=J.read(1);if(Z|=(B.buffer[0]&127)<<H,!(B.buffer[0]&128))return Z}}const g=r(0);function D(J,Z){if(Z===0){J.write(g);return}let H=0;for(let ne=Z;ne!==0;ne=ne>>>7)H++;const B=a.$Ib.alloc(H);for(let ne=0;Z!==0;ne++)B.buffer[ne]=Z&127,Z=Z>>>7,Z>0&&(B.buffer[ne]|=128);J.write(B)}class E{constructor(Z){this.b=Z,this.a=0}read(Z){const H=this.b.slice(this.a,this.a+Z);return this.a+=H.byteLength,H}}e.$Vg=E;class t{constructor(){this.a=[]}get buffer(){return a.$Ib.concat(this.a)}write(Z){this.a.push(Z)}}e.$Wg=t;var i;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(i||(i={}));function r(J){const Z=a.$Ib.alloc(1);return Z.writeUInt8(J,0),Z}const n={Undefined:r(i.Undefined),String:r(i.String),Buffer:r(i.Buffer),VSBuffer:r(i.VSBuffer),Array:r(i.Array),Object:r(i.Object),Uint:r(i.Int)},s=typeof Buffer<"u";function c(J,Z){if(typeof Z>"u")J.write(n.Undefined);else if(typeof Z=="string"){const H=a.$Ib.fromString(Z);J.write(n.String),D(J,H.byteLength),J.write(H)}else if(s&&Buffer.isBuffer(Z)){const H=a.$Ib.wrap(Z);J.write(n.Buffer),D(J,H.byteLength),J.write(H)}else if(Z instanceof a.$Ib)J.write(n.VSBuffer),D(J,Z.byteLength),J.write(Z);else if(Array.isArray(Z)){J.write(n.Array),D(J,Z.length);for(const H of Z)c(J,H)}else if(typeof Z=="number"&&(Z|0)===Z)J.write(n.Uint),D(J,Z);else{const H=a.$Ib.fromString(JSON.stringify(Z));J.write(n.Object),D(J,H.byteLength),J.write(H)}}e.$Xg=c;function f(J){switch(J.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return J.read(l(J)).toString();case i.Buffer:return J.read(l(J)).buffer;case i.VSBuffer:return J.read(l(J));case i.Array:{const H=l(J),B=[];for(let ne=0;ne<H;ne++)B.push(f(J));return B}case i.Object:return JSON.parse(J.read(l(J)).toString());case i.Int:return l(J)}}e.$Yg=f;class k{constructor(Z,H,B=null,ne=1e3){this.h=Z,this.j=H,this.k=B,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(Z,H){this.b.set(Z,H),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const H=this.o([Z.type]);this.k?.logOutgoing(H,0,1,o(Z.type));return}case 201:case 202:case 204:case 203:{const H=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(H,Z.id,1,o(Z.type),Z.data);return}}}o(Z,H=void 0){const B=new t;return c(B,Z),c(B,H),this.p(B.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const H=new E(Z),B=f(H),ne=f(H),Q=B[0];switch(Q){case 100:return this.k?.logIncoming(Z.byteLength,B[1],1,`${m(Q)}: ${B[2]}.${B[3]}`,ne),this.s({type:Q,id:B[1],channelName:B[2],name:B[3],arg:ne});case 102:return this.k?.logIncoming(Z.byteLength,B[1],1,`${m(Q)}: ${B[2]}.${B[3]}`,ne),this.t({type:Q,id:B[1],channelName:B[2],name:B[3],arg:ne});case 101:return this.k?.logIncoming(Z.byteLength,B[1],1,`${m(Q)}`),this.u({type:Q,id:B[1]});case 103:return this.k?.logIncoming(Z.byteLength,B[1],1,`${m(Q)}`),this.u({type:Q,id:B[1]})}}s(Z){const H=this.b.get(Z.channelName);if(!H){this.v(Z);return}const B=new I.$bd;let ne;try{ne=H.call(this.j,Z.name,Z.arg,B.token)}catch(T){ne=Promise.reject(T)}const Q=Z.id;ne.then(T=>{this.m({id:Q,data:T,type:201}),this.d.delete(Z.id)},T=>{T instanceof Error?this.m({id:Q,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:Q,data:T,type:203}),this.d.delete(Z.id)});const _=(0,d.$ib)(()=>B.cancel());this.d.set(Z.id,_)}t(Z){const H=this.b.get(Z.channelName);if(!H){this.v(Z);return}const B=Z.id,Q=H.listen(this.j,Z.name,Z.arg)(_=>this.m({id:B,data:_,type:204}));this.d.set(Z.id,Q)}u(Z){const H=this.d.get(Z.id);H&&(H.dispose(),this.d.delete(Z.id))}v(Z){let H=this.g.get(Z.channelName);H||(H=[],this.g.set(Z.channelName,H));const B=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:Z,timeoutTimer:B})}w(Z){const H=this.g.get(Z);if(H){for(const B of H)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.s(B.request);break;case 102:this.t(B.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$fb)(this.d.values()),this.d.clear()}}e.$Zg=k;var v;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class C{constructor(Z,H=null){this.l=Z,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$5c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(B=>this.s(B)),this.j=H}getChannel(Z){const H=this;return{call(B,ne,Q){return H.a?Promise.reject(new R.$2):H.m(Z,B,ne,Q)},listen(B,ne){return H.a?b.Event.None:H.o(Z,B,ne)}}}m(Z,H,B,ne=I.CancellationToken.None){const Q=this.g++,T={id:Q,type:100,channelName:Z,name:H,arg:B};if(ne.isCancellationRequested)return Promise.reject(new R.$2);let S;return new Promise((ee,oe)=>{if(ne.isCancellationRequested)return oe(new R.$2);const z=()=>{const X=G=>{switch(G.type){case 201:this.f.delete(Q),ee(G.data);break;case 202:{this.f.delete(Q);const Y=new Error(G.data.message);Y.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Y.name=G.data.name,oe(Y);break}case 203:this.f.delete(Q),oe(G.data);break}};this.f.set(Q,X),this.p(T)};let q=null;this.b===u.Idle?z():(q=(0,O.$fg)(X=>this.u()),q.then(()=>{q=null,z()}));const W=()=>{q?(q.cancel(),q=null):this.p({id:Q,type:101}),oe(new R.$2)},U=ne.onCancellationRequested(W);S=(0,d.$hb)((0,d.$ib)(W),U),this.d.add(S)}).finally(()=>{this.d.delete(S)})}o(Z,H,B){const ne=this.g++,_={id:ne,type:102,channelName:Z,name:H,arg:B};let T=null;const S=new b.$5c({onWillAddFirstListener:()=>{T=(0,O.$fg)(ee=>this.u()),T.then(()=>{T=null,this.d.add(S),this.p(_)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(S),this.p({id:ne,type:103}))}}),F=ee=>S.fire(ee.data);return this.f.set(ne,F),S.event}p(Z){switch(Z.type){case 100:case 102:{const H=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(H,Z.id,0,`${m(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const H=this.q([Z.type,Z.id]);this.j?.logOutgoing(H,Z.id,0,m(Z.type));return}}}q(Z,H=void 0){const B=new t;return c(B,Z),c(B,H),this.r(B.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const H=new E(Z),B=f(H),ne=f(H),Q=B[0];switch(Q){case 200:return this.j?.logIncoming(Z.byteLength,0,0,o(Q)),this.t({type:B[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,B[1],0,o(Q),ne),this.t({type:B[0],id:B[1],data:ne})}}t(Z){if(Z.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$fb)(this.d.values()),this.d.clear()}}e.$1g=C,Re([L.$Pg],C.prototype,"onDidInitializePromise",null);class A{get connections(){const Z=[];return this.f.forEach(H=>Z.push(H)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new b.$5c,this.onDidAddConnection=this.g.event,this.h=new b.$5c,this.onDidRemoveConnection=this.h.event,Z(({protocol:H,onDidClientDisconnect:B})=>{b.Event.once(H.onMessage)(Q=>{const _=new E(Q),T=f(_),S=new k(H,T),F=new C(H);this.a.forEach((oe,z)=>S.registerChannel(z,oe));const ee={channelServer:S,channelClient:F,ctx:T};this.f.add(ee),this.g.fire(ee),B(()=>{S.dispose(),F.dispose(),this.f.delete(ee),this.h.fire(ee)})})})}getChannel(Z,H){const B=this;return{call(ne,Q,_){let T;if((0,w.$ue)(H)){const F=(0,y.$Hf)(B.connections.filter(H));T=F?Promise.resolve(F):b.Event.toPromise(b.Event.filter(B.onDidAddConnection,H))}else T=H.routeCall(B,ne,Q);const S=T.then(F=>F.channelClient.getChannel(Z));return K(S).call(ne,Q,_)},listen(ne,Q){if((0,w.$ue)(H))return B.j(Z,H,ne,Q);const _=H.routeEvent(B,ne,Q).then(T=>T.channelClient.getChannel(Z));return K(_).listen(ne,Q)}}}j(Z,H,B,ne){const Q=this;let _=new d.$jb;const T=new b.$5c({onWillAddFirstListener:()=>{_=new d.$jb;const S=new b.$$c,F=new Map,ee=z=>{const W=z.channelClient.getChannel(Z).listen(B,ne),U=S.add(W);F.set(z,U)},oe=z=>{const q=F.get(z);q&&(q.dispose(),F.delete(z))};Q.connections.filter(H).forEach(ee),b.Event.filter(Q.onDidAddConnection,H)(ee,void 0,_),Q.onDidRemoveConnection(oe,void 0,_),S.event(T.fire,T,_),_.add(S)},onDidRemoveLastListener:()=>{_.dispose()}});return T.event}registerChannel(Z,H){this.a.set(Z,H),this.f.forEach(B=>{B.channelServer.registerChannel(Z,H)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$2g=A;class M{constructor(Z,H,B=null){const ne=new t;c(ne,H),Z.send(ne.buffer),this.a=new C(Z,B),this.d=new k(Z,H,B)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,H){this.d.registerChannel(Z,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$3g=M;function K(J){return{call(Z,H,B){return J.then(ne=>ne.call(Z,H,B))},listen(Z,H){const B=new b.$ad;return J.then(ne=>B.input=ne.listen(Z,H)),B.event}}}e.$4g=K;function te(J){let Z=!1;return{call(H,B,ne){return Z?J.call(H,B,ne):(0,O.$sg)(0).then(()=>Z=!0).then(()=>J.call(H,B,ne))},listen(H,B){if(Z)return J.listen(H,B);const ne=new b.$ad;return(0,O.$sg)(0).then(()=>Z=!0).then(()=>ne.input=J.listen(H,B)),ne.event}}}e.$5g=te;class he{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const H of Z.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await b.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$6g=he;var ce;(function(J){function Z(Q,_){const T=Q,S=_&&_.disableMarshalling,F=new Map;for(const ee in T)B(ee)&&F.set(ee,b.Event.buffer(T[ee],!0));return new class{listen(ee,oe,z){const q=F.get(oe);if(q)return q;if(ne(oe)){const W=T[oe];if(typeof W=="function")return W.call(T,z)}throw new Error(`Event not found: ${oe}`)}call(ee,oe,z){const q=T[oe];if(typeof q=="function"){if(!S&&Array.isArray(z))for(let W=0;W<z.length;W++)z[W]=(0,P.$Ug)(z[W]);return q.apply(T,z)}throw new Error(`Method not found: ${oe}`)}}}J.fromService=Z;function H(Q,_){const T=_&&_.disableMarshalling;return new Proxy({},{get(S,F){if(typeof F=="string")return _?.properties?.has(F)?_.properties.get(F):ne(F)?function(ee){return Q.listen(F,ee)}:B(F)?Q.listen(F):async function(...ee){let oe;_&&!(0,w.$pe)(_.context)?oe=[_.context,...ee]:oe=ee;const z=await Q.call(F,oe);return T?z:(0,P.$Ug)(z)};throw new Error(`Property not found: ${String(F)}`)}})}J.toService=H;function B(Q){return Q[0]==="o"&&Q[1]==="n"&&p.$Id(Q.charCodeAt(2))}function ne(Q){return/^onDynamic/.test(Q)&&p.$Id(Q.charCodeAt(9))}})(ce||(e.ProxyChannel=ce={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const Z=J.toString();if(Z!=="[object Object]")return Z}return J}function se(J){return Array.isArray(J)?J.map(ge):ge(J)}function V(J,Z,H,B,ne,Q,_){_=se(_);const T=le[ne],S=T[B%T.length];let F=[`%c[${J}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${S}`];/\($/.test(Q)?(F=F.concat(_),F.push(")")):F.push(_),console.log.apply(console,F)}class ie{constructor(Z,H){this.d=Z,this.f=H,this.a=0,this.b=0}logOutgoing(Z,H,B,ne,Q){this.b+=Z,V(this.d,this.b,Z,H,B,ne,Q)}logIncoming(Z,H,B,ne,Q){this.a+=Z,V(this.f,this.a,Z,H,B,ne,Q)}}e.$7g=ie}),define(be[105],we([1,0,15,5,2,43]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_g=e.$$g=e.$0g=e.$9g=e.ProtocolConstants=e.$8g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let c=0;function f(v,C){if(!s.has(v)){const A=String(++c);s.set(v,A)}return s.get(v)}function k(v,C,A,M){if(!n.enableDiagnostics)return;const K=f(v,C);if(M instanceof y.$Ib||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const te=y.$Ib.alloc(M.byteLength);te.set(M),n.records.push({timestamp:Date.now(),id:K,label:C,type:A,buff:te})}else n.records.push({timestamp:Date.now(),id:K,label:C,type:A,data:M})}n.traceSocketEvent=k})(R||(e.SocketDiagnostics=R={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let d=null;function P(){return d||(d=y.$Ib.alloc(0)),d}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,c){if(s===0)return P();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const C=this.a[0];return c&&(this.a.shift(),this.b-=s),C}if(this.a[0].byteLength>s){const C=this.a[0].slice(0,s);return c&&(this.a[0]=this.a[0].slice(s),this.b-=s),C}const f=y.$Ib.alloc(s);let k=0,v=0;for(;s>0;){const C=this.a[v];if(C.byteLength>s){const A=C.slice(0,s);f.set(A,k),k+=s,c&&(this.a[v]=C.slice(s),this.b-=s),s-=s}else f.set(C,k),k+=C.byteLength,c?(this.a.shift(),this.b-=C.byteLength):v++,s-=C.byteLength}return f}}e.$8g=p;var w;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class ${constructor(s,c,f,k){this.type=s,this.id=c,this.ack=f,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends a.$kb{constructor(s){super(),this.f=this.B(new O.$5c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new p,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,k=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new $(f,k,v,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=y.$Ib.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(c,s.data)}g(s,c){const f=this.f===0;return this.d.push(s,c),this.f+=s.byteLength+c.byteLength,f}h(){const s=y.$Ib.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,c){this.g(s,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class l extends a.$kb{constructor(s){super(),this.f=new O.$5c,this.onMessage=this.f.event,this.g=new O.$5c,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new $(1,0,0,s))}}e.$9g=l;class g extends I.$3g{static fromSocket(s,c){return new g(new l(s),c)}get onDidDispose(){return this.b.onDidDispose}constructor(s,c,f=null){super(s,c,f),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$0g=g;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$5c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$$g=D;class E{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,c=this.a;for(;c;)c=c.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let c=0,f=this.a;for(;f;)s[c++]=f.data,f=f.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const c=new E(s);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let c=0;c<i.a;c++)this.c[c]=s-1e3*c;setInterval(()=>{for(let c=i.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),c=(1+i.a)*1e3;let f=0;for(let k=0;k<i.a;k++)s-this.c[k]<=c&&f++;return 1-f/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new D,this.onControlMessage=this.u.event,this.v=new D,this.onMessage=this.v.event,this.w=new D,this.onDidDispose=this.w.event,this.x=new D,this.onSocketClose=this.x.event,this.y=new D,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??i.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new a.$jb,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new $(5,0,0,P());this.p.write(s),this.p.flush()}sendPause(){const s=new $(7,0,0,P());this.p.write(s)}sendResume(){const s=new $(8,0,0,P());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,c){this.a=!0,this.r.dispose(),this.r=new a.$jb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new $(3,0,this.h,P());this.p.write(s);const c=this.b.toArray();for(let f=0,k=c.length;f<k;f++)this.p.write(c[f]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const c=this.b.peek();if(c&&c.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new $(6,0,0,P())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let f=0,k=c.length;f<k;f++)this.p.write(c[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const c=++this.c;this.h=this.g;const f=new $(1,c,this.h,s);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(s){const c=new $(2,0,0,s);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),c=Date.now()-s.writtenTime,f=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(c>=2e4&&f>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:f});return}const v=Math.max(2e4-c,2e4-f,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new $(3,0,this.h,P());this.p.write(s)}D(){this.h=this.g;const s=new $(9,0,this.h,P());this.p.write(s)}}e.$_g=r}),define(be[106],we([1,0,51,14,15,20,148,11,5,2,22,103,59,43]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=void 0;class m extends h.$Zg{constructor(u){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",l=>a.$Ib.wrap(Buffer.from(l,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Dp=m;class ${constructor(u,l){this.i=u,this.j=l,this.c=new Set,this.g=new Map,this.h=new b.$5c,this.onDidProcessExit=this.h.event;const g=l&&l.timeout?l.timeout:6e4;this.b=new O.$og(g),this.d=null,this.f=null}getChannel(u){const l=this;return{call(g,D,E){return l.k(u,g,D,E)},listen(g,D){return l.l(u,g,D)}}}k(u,l,g,D=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(D.isCancellationRequested)return Promise.reject(R.$3());this.b.cancel();const E=this.n(u),t=(0,O.$fg)(n=>E.call(l,g,n)),i=D.onCancellationRequested(()=>t.cancel()),r=(0,d.$ib)(()=>t.cancel());return this.c.add(r),t.finally(()=>{i.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,l,g){if(!this.b)return b.Event.None;this.b.cancel();let D;const E=new b.$5c({onWillAddFirstListener:()=>{D=this.n(u).listen(l,g)(E.fire,E),this.c.add(D)},onDidRemoveLastListener:()=>{this.c.delete(D),D.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,P.$Em)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,w.$dl)(l.env),this.d=(0,y.fork)(this.i,u,l);const g=new b.$5c;b.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,L.$zp)(s)){(0,L.log)(s,`IPC Library: ${this.j.serverName}`);return}g.fire(a.$Ib.wrap(Buffer.from(s,"base64")))});const E=this.j.useQueue?(0,p.$fl)(this.d):this.d,t=s=>this.d&&this.d.connected&&E.send(s.buffer.toString("base64")),i=g.event,r={send:t,onMessage:i};this.f=new h.$1g(r);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,c)=>{process.removeListener("exit",n),this.c.forEach(f=>(0,d.$fb)(f)),this.c.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:c})})}return this.f}n(u){let l=this.g.get(u);return l||(l=this.m.getChannel(u),this.g.set(u,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Ep=$}),define(be[157],we([1,0,14,5,2,49,8]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.StorageState=e.$Co=e.StorageHint=void 0;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function b(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Co=b;var d;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends a.$kb{constructor(h,m=Object.create(null)){super(),this.m=h,this.n=m,this.b=this.B(new O.$8c),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new y.$pg(P.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((m,$)=>this.s($,m)),h.deleted?.forEach(m=>this.s(m,void 0))}finally{this.b.resume()}}s(h,m){if(this.c===d.Closed)return;let $=!1;(0,L.$pe)(m)?$=this.f.delete(h):this.f.get(h)!==m&&(this.f.set(h,m),$=!0),$&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,m){const $=this.f.get(h);return(0,L.$pe)($)?m:$}getBoolean(h,m){const $=this.get(h);return(0,L.$pe)($)?m:$==="true"}getNumber(h,m){const $=this.get(h);return(0,L.$pe)($)?m:parseInt($,10)}getObject(h,m){const $=this.get(h);return(0,L.$pe)($)?m:(0,I.$Tg)($)}async set(h,m,$=!1){if(this.c===d.Closed)return;if((0,L.$pe)(m))return this.delete(h,$);const o=(0,L.$ie)(m)||Array.isArray(m)?(0,I.$Sg)(m):String(m);if(this.f.get(h)!==o)return this.f.set(h,o),this.j.set(h,o),this.h.delete(h),this.b.fire({key:h,external:$}),this.w()}async delete(h,m=!1){if(!(this.c===d.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:m}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Do=P,P.a=100;class p{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((m,$)=>this.a.set($,m)),h.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.$Eo=p}),define(be[107],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;class y{constructor(a,I){this.lineNumber=a,this.column=I}with(a=this.lineNumber,I=this.column){return a===this.lineNumber&&I===this.column?this:new y(a,I)}delta(a=0,I=0){return this.with(this.lineNumber+a,this.column+I)}equals(a){return y.equals(this,a)}static equals(a,I){return!a&&!I?!0:!!a&&!!I&&a.lineNumber===I.lineNumber&&a.column===I.column}isBefore(a){return y.isBefore(this,a)}static isBefore(a,I){return a.lineNumber<I.lineNumber?!0:I.lineNumber<a.lineNumber?!1:a.column<I.column}isBeforeOrEqual(a){return y.isBeforeOrEqual(this,a)}static isBeforeOrEqual(a,I){return a.lineNumber<I.lineNumber?!0:I.lineNumber<a.lineNumber?!1:a.column<=I.column}static compare(a,I){const L=a.lineNumber|0,R=I.lineNumber|0;if(L===R){const b=a.column|0,d=I.column|0;return b-d}return L-R}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(a){return new y(a.lineNumber,a.column)}static isIPosition(a){return a&&typeof a.lineNumber=="number"&&typeof a.column=="number"}}e.$Kr=y}),define(be[52],we([1,0,107]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class O{constructor(I,L,R,b){I>R||I===R&&L>b?(this.startLineNumber=R,this.startColumn=b,this.endLineNumber=I,this.endColumn=L):(this.startLineNumber=I,this.startColumn=L,this.endLineNumber=R,this.endColumn=b)}isEmpty(){return O.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return O.containsPosition(this,I)}static containsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<I.startColumn||L.lineNumber===I.endLineNumber&&L.column>I.endColumn)}static strictContainsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<=I.startColumn||L.lineNumber===I.endLineNumber&&L.column>=I.endColumn)}containsRange(I){return O.containsRange(this,I)}static containsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>I.endColumn)}strictContainsRange(I){return O.strictContainsRange(this,I)}static strictContainsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<=I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>=I.endColumn)}plusRange(I){return O.plusRange(this,I)}static plusRange(I,L){let R,b,d,P;return L.startLineNumber<I.startLineNumber?(R=L.startLineNumber,b=L.startColumn):L.startLineNumber===I.startLineNumber?(R=L.startLineNumber,b=Math.min(L.startColumn,I.startColumn)):(R=I.startLineNumber,b=I.startColumn),L.endLineNumber>I.endLineNumber?(d=L.endLineNumber,P=L.endColumn):L.endLineNumber===I.endLineNumber?(d=L.endLineNumber,P=Math.max(L.endColumn,I.endColumn)):(d=I.endLineNumber,P=I.endColumn),new O(R,b,d,P)}intersectRanges(I){return O.intersectRanges(this,I)}static intersectRanges(I,L){let R=I.startLineNumber,b=I.startColumn,d=I.endLineNumber,P=I.endColumn;const p=L.startLineNumber,w=L.startColumn,h=L.endLineNumber,m=L.endColumn;return R<p?(R=p,b=w):R===p&&(b=Math.max(b,w)),d>h?(d=h,P=m):d===h&&(P=Math.min(P,m)),R>d||R===d&&b>P?null:new O(R,b,d,P)}equalsRange(I){return O.equalsRange(this,I)}static equalsRange(I,L){return!I&&!L?!0:!!I&&!!L&&I.startLineNumber===L.startLineNumber&&I.startColumn===L.startColumn&&I.endLineNumber===L.endLineNumber&&I.endColumn===L.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(I){return new y.$Kr(I.endLineNumber,I.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(I){return new y.$Kr(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,L){return new O(this.startLineNumber,this.startColumn,I,L)}setStartPosition(I,L){return new O(I,L,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(I){return new O(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(I){return new O(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new O(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,L=I){return new O(I.lineNumber,I.column,L.lineNumber,L.column)}static lift(I){return I?new O(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<I.startColumn)}static areIntersecting(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<=L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,L){if(I&&L){const d=I.startLineNumber|0,P=L.startLineNumber|0;if(d===P){const p=I.startColumn|0,w=L.startColumn|0;if(p===w){const h=I.endLineNumber|0,m=L.endLineNumber|0;if(h===m){const $=I.endColumn|0,o=L.endColumn|0;return $-o}return h-m}return p-w}return d-P}return(I?1:0)-(L?1:0)}static compareRangesUsingEnds(I,L){return I.endLineNumber===L.endLineNumber?I.endColumn===L.endColumn?I.startLineNumber===L.startLineNumber?I.startColumn-L.startColumn:I.startLineNumber-L.startLineNumber:I.endColumn-L.endColumn:I.endLineNumber-L.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Lr=O}),define(be[158],we([1,0,5,2]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;class a{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$5c,this.onDidChange=this.c.event,this.d=null}handleChange(R){this.c.fire({changedLanguages:R,changedColorMap:!1})}register(R,b){return this.a.set(R,b),this.handleChange([R]),(0,O.$ib)(()=>{this.a.get(R)===b&&(this.a.delete(R),this.handleChange([R]))})}get(R){return this.a.get(R)||null}registerFactory(R,b){this.b.get(R)?.dispose();const d=new I(this,R,b);return this.b.set(R,d),(0,O.$ib)(()=>{const P=this.b.get(R);!P||P!==d||(this.b.delete(R),P.dispose())})}async getOrCreate(R){const b=this.get(R);if(b)return b;const d=this.b.get(R);return!d||d.isResolved?null:(await d.resolve(),this.get(R))}isResolved(R){if(this.get(R))return!0;const d=this.b.get(R);return!!(!d||d.isResolved)}setColorMap(R){this.d=R,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$bs=a;class I extends O.$kb{get isResolved(){return this.c}constructor(R,b,d){super(),this.f=R,this.g=b,this.h=d,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const R=await this.h.tokenizationSupport;this.c=!0,R&&!this.a&&this.B(this.f.register(this.g,R))}}}),define(be[159],we([1,0,48,4,52,158]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qs=e.$ps=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$os=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.$ns=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ms=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ls=e.$ks=e.$js=void 0;class L{constructor(M,K,te){this.offset=M,this.type=K,this.language=te,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$js=L;class R{constructor(M,K){this.tokens=M,this.endState=K,this._tokenizationResultBrand=void 0}}e.$ks=R;class b{constructor(M,K){this.tokens=M,this.endState=K,this._encodedTokenizationResultBrand=void 0}}e.$ls=b;var d;(function(A){A[A.Method=0]="Method",A[A.Function=1]="Function",A[A.Constructor=2]="Constructor",A[A.Field=3]="Field",A[A.Variable=4]="Variable",A[A.Class=5]="Class",A[A.Struct=6]="Struct",A[A.Interface=7]="Interface",A[A.Module=8]="Module",A[A.Property=9]="Property",A[A.Event=10]="Event",A[A.Operator=11]="Operator",A[A.Unit=12]="Unit",A[A.Value=13]="Value",A[A.Constant=14]="Constant",A[A.Enum=15]="Enum",A[A.EnumMember=16]="EnumMember",A[A.Keyword=17]="Keyword",A[A.Text=18]="Text",A[A.Color=19]="Color",A[A.File=20]="File",A[A.Reference=21]="Reference",A[A.Customcolor=22]="Customcolor",A[A.Folder=23]="Folder",A[A.TypeParameter=24]="TypeParameter",A[A.User=25]="User",A[A.Issue=26]="Issue",A[A.Snippet=27]="Snippet"})(d||(e.CompletionItemKind=d={}));var P;(function(A){const M=new Map;M.set(0,y.$yj.symbolMethod),M.set(1,y.$yj.symbolFunction),M.set(2,y.$yj.symbolConstructor),M.set(3,y.$yj.symbolField),M.set(4,y.$yj.symbolVariable),M.set(5,y.$yj.symbolClass),M.set(6,y.$yj.symbolStruct),M.set(7,y.$yj.symbolInterface),M.set(8,y.$yj.symbolModule),M.set(9,y.$yj.symbolProperty),M.set(10,y.$yj.symbolEvent),M.set(11,y.$yj.symbolOperator),M.set(12,y.$yj.symbolUnit),M.set(13,y.$yj.symbolValue),M.set(15,y.$yj.symbolEnum),M.set(14,y.$yj.symbolConstant),M.set(15,y.$yj.symbolEnum),M.set(16,y.$yj.symbolEnumMember),M.set(17,y.$yj.symbolKeyword),M.set(27,y.$yj.symbolSnippet),M.set(18,y.$yj.symbolText),M.set(19,y.$yj.symbolColor),M.set(20,y.$yj.symbolFile),M.set(21,y.$yj.symbolReference),M.set(22,y.$yj.symbolCustomColor),M.set(23,y.$yj.symbolFolder),M.set(24,y.$yj.symbolTypeParameter),M.set(25,y.$yj.account),M.set(26,y.$yj.issues);function K(ce){let le=M.get(ce);return le||(console.info("No codicon found for CompletionItemKind "+ce),le=y.$yj.symbolProperty),le}A.toIcon=K;const te=new Map;te.set("method",0),te.set("function",1),te.set("constructor",2),te.set("field",3),te.set("variable",4),te.set("class",5),te.set("struct",6),te.set("interface",7),te.set("module",8),te.set("property",9),te.set("event",10),te.set("operator",11),te.set("unit",12),te.set("value",13),te.set("constant",14),te.set("enum",15),te.set("enum-member",16),te.set("enumMember",16),te.set("keyword",17),te.set("snippet",27),te.set("text",18),te.set("color",19),te.set("file",20),te.set("reference",21),te.set("customcolor",22),te.set("folder",23),te.set("type-parameter",24),te.set("typeParameter",24),te.set("account",25),te.set("issue",26);function he(ce,le){let ge=te.get(ce);return typeof ge>"u"&&!le&&(ge=9),ge}A.fromString=he})(P||(e.CompletionItemKinds=P={}));var p;(function(A){A[A.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var w;(function(A){A[A.None=0]="None",A[A.KeepWhitespace=1]="KeepWhitespace",A[A.InsertAsSnippet=4]="InsertAsSnippet"})(w||(e.CompletionItemInsertTextRule=w={}));var h;(function(A){A[A.Invoke=0]="Invoke",A[A.TriggerCharacter=1]="TriggerCharacter",A[A.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var m;(function(A){A[A.Automatic=0]="Automatic",A[A.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class ${constructor(M,K,te,he){this.range=M,this.text=K,this.completionKind=te,this.isSnippetText=he}equals(M){return a.$Lr.lift(this.range).equalsRange(M.range)&&this.text===M.text&&this.completionKind===M.completionKind&&this.isSnippetText===M.isSnippetText}}e.$ms=$;var o;(function(A){A[A.Invoke=1]="Invoke",A[A.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var u;(function(A){A[A.Invoke=1]="Invoke",A[A.TriggerCharacter=2]="TriggerCharacter",A[A.ContentChange=3]="ContentChange"})(u||(e.SignatureHelpTriggerKind=u={}));var l;(function(A){A[A.Text=0]="Text",A[A.Read=1]="Read",A[A.Write=2]="Write"})(l||(e.DocumentHighlightKind=l={}));function g(A){return A&&O.URI.isUri(A.uri)&&a.$Lr.isIRange(A.range)&&(a.$Lr.isIRange(A.originSelectionRange)||a.$Lr.isIRange(A.targetSelectionRange))}e.$ns=g;var D;(function(A){A[A.File=0]="File",A[A.Module=1]="Module",A[A.Namespace=2]="Namespace",A[A.Package=3]="Package",A[A.Class=4]="Class",A[A.Method=5]="Method",A[A.Property=6]="Property",A[A.Field=7]="Field",A[A.Constructor=8]="Constructor",A[A.Enum=9]="Enum",A[A.Interface=10]="Interface",A[A.Function=11]="Function",A[A.Variable=12]="Variable",A[A.Constant=13]="Constant",A[A.String=14]="String",A[A.Number=15]="Number",A[A.Boolean=16]="Boolean",A[A.Array=17]="Array",A[A.Object=18]="Object",A[A.Key=19]="Key",A[A.Null=20]="Null",A[A.EnumMember=21]="EnumMember",A[A.Struct=22]="Struct",A[A.Event=23]="Event",A[A.Operator=24]="Operator",A[A.TypeParameter=25]="TypeParameter"})(D||(e.SymbolKind=D={}));var E;(function(A){A[A.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var t;(function(A){const M=new Map;M.set(0,y.$yj.symbolFile),M.set(1,y.$yj.symbolModule),M.set(2,y.$yj.symbolNamespace),M.set(3,y.$yj.symbolPackage),M.set(4,y.$yj.symbolClass),M.set(5,y.$yj.symbolMethod),M.set(6,y.$yj.symbolProperty),M.set(7,y.$yj.symbolField),M.set(8,y.$yj.symbolConstructor),M.set(9,y.$yj.symbolEnum),M.set(10,y.$yj.symbolInterface),M.set(11,y.$yj.symbolFunction),M.set(12,y.$yj.symbolVariable),M.set(13,y.$yj.symbolConstant),M.set(14,y.$yj.symbolString),M.set(15,y.$yj.symbolNumber),M.set(16,y.$yj.symbolBoolean),M.set(17,y.$yj.symbolArray),M.set(18,y.$yj.symbolObject),M.set(19,y.$yj.symbolKey),M.set(20,y.$yj.symbolNull),M.set(21,y.$yj.symbolEnumMember),M.set(22,y.$yj.symbolStruct),M.set(23,y.$yj.symbolEvent),M.set(24,y.$yj.symbolOperator),M.set(25,y.$yj.symbolTypeParameter);function K(te){let he=M.get(te);return he||(console.info("No codicon found for SymbolKind "+te),he=y.$yj.symbolProperty),he}A.toIcon=K})(t||(e.SymbolKinds=t={}));class i{static fromValue(M){switch(M){case"comment":return i.Comment;case"imports":return i.Imports;case"region":return i.Region}return new i(M)}constructor(M){this.value=M}}e.$os=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var r;(function(A){function M(K){return!K||typeof K!="object"?!1:typeof K.id=="string"&&typeof K.title=="string"}A.is=M})(r||(e.Command=r={}));var n;(function(A){A[A.Collapsed=0]="Collapsed",A[A.Expanded=1]="Expanded"})(n||(e.CommentThreadCollapsibleState=n={}));var s;(function(A){A[A.Unresolved=0]="Unresolved",A[A.Resolved=1]="Resolved"})(s||(e.CommentThreadState=s={}));var c;(function(A){A[A.Editing=0]="Editing",A[A.Preview=1]="Preview"})(c||(e.CommentMode=c={}));var f;(function(A){A[A.Published=0]="Published",A[A.Draft=1]="Draft"})(f||(e.CommentState=f={}));var k;(function(A){A[A.Type=1]="Type",A[A.Parameter=2]="Parameter"})(k||(e.InlayHintKind=k={}));class v{constructor(M){this.b=M,this.a=null}dispose(){this.a&&this.a.then(M=>{M&&M.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ps=v,e.$qs=new I.$bs;var C;(function(A){A[A.None=0]="None",A[A.Option=1]="Option",A[A.Default=2]="Default",A[A.Preferred=3]="Preferred"})(C||(e.ExternalUriOpenerPriority=C={}))}),define(be[160],we([9,10]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(be[161],we([1,0,5,2,160]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class I extends O.$kb{constructor(w,h="",m="",$=!0,o){super(),this.h=this.B(new y.$5c),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=h,this.u=m,this.w=$,this.C=o}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,h){this.C&&await this.C(w)}}e.$3h=I;class L extends O.$kb{constructor(){super(...arguments),this.f=this.B(new y.$5c),this.onWillRun=this.f.event,this.h=this.B(new y.$5c),this.onDidRun=this.h.event}async run(w,h){if(!w.enabled)return;this.f.fire({action:w});let m;try{await this.k(w,h)}catch($){m=$}this.h.fire({action:w,error:m})}async k(w,h){await w.run(h)}}e.$4h=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let h=[];for(const m of w)m.length&&(h.length?h=[...h,new R,...m]:h=m);return h}async run(){}}e.$5h=R,R.ID="vs.actions.separator";class b{get actions(){return this.a}constructor(w,h,m,$){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=h,this.class=$,this.a=m}async run(){}}e.$6h=b;class d extends I{constructor(){super(d.ID,a.localize(0,null),void 0,!1)}}e.$7h=d,d.ID="vs.actions.empty";function P(p){return{id:p.id,label:p.label,class:void 0,enabled:p.enabled??!0,checked:p.checked??!1,run:async()=>p.run(),tooltip:p.label}}e.$8h=P}),define(be[162],we([9,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(be[163],we([1,0,162]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0;const O=60,a=O*60,I=a*24,L=I*7,R=I*30,b=I*365;function d(p,w,h,m){typeof p!="number"&&(p=p.getTime());const $=Math.round((new Date().getTime()-p)/1e3);if($<-30)return(0,y.localize)(0,null,d(new Date().getTime()+$*1e3,!1));if(!m&&$<30)return(0,y.localize)(1,null);let o;return $<O?(o=$,w?o===1?h?(0,y.localize)(2,null,o):(0,y.localize)(3,null,o):h?(0,y.localize)(4,null,o):(0,y.localize)(5,null,o):o===1?h?(0,y.localize)(6,null,o):(0,y.localize)(7,null,o):h?(0,y.localize)(8,null,o):(0,y.localize)(9,null,o)):$<a?(o=Math.floor($/O),w?o===1?h?(0,y.localize)(10,null,o):(0,y.localize)(11,null,o):h?(0,y.localize)(12,null,o):(0,y.localize)(13,null,o):o===1?h?(0,y.localize)(14,null,o):(0,y.localize)(15,null,o):h?(0,y.localize)(16,null,o):(0,y.localize)(17,null,o)):$<I?(o=Math.floor($/a),w?o===1?h?(0,y.localize)(18,null,o):(0,y.localize)(19,null,o):h?(0,y.localize)(20,null,o):(0,y.localize)(21,null,o):o===1?h?(0,y.localize)(22,null,o):(0,y.localize)(23,null,o):h?(0,y.localize)(24,null,o):(0,y.localize)(25,null,o)):$<L?(o=Math.floor($/I),w?o===1?(0,y.localize)(26,null,o):(0,y.localize)(27,null,o):o===1?(0,y.localize)(28,null,o):(0,y.localize)(29,null,o)):$<R?(o=Math.floor($/L),w?o===1?h?(0,y.localize)(30,null,o):(0,y.localize)(31,null,o):h?(0,y.localize)(32,null,o):(0,y.localize)(33,null,o):o===1?h?(0,y.localize)(34,null,o):(0,y.localize)(35,null,o):h?(0,y.localize)(36,null,o):(0,y.localize)(37,null,o)):$<b?(o=Math.floor($/R),w?o===1?h?(0,y.localize)(38,null,o):(0,y.localize)(39,null,o):h?(0,y.localize)(40,null,o):(0,y.localize)(41,null,o):o===1?h?(0,y.localize)(42,null,o):(0,y.localize)(43,null,o):h?(0,y.localize)(44,null,o):(0,y.localize)(45,null,o)):(o=Math.floor($/b),w?o===1?h?(0,y.localize)(46,null,o):(0,y.localize)(47,null,o):h?(0,y.localize)(48,null,o):(0,y.localize)(49,null,o):o===1?h?(0,y.localize)(50,null,o):(0,y.localize)(51,null,o):h?(0,y.localize)(52,null,o):(0,y.localize)(53,null,o))}e.$Ol=d;function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Pl=P}),define(be[164],we([9,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(be[39],we([1,0,18,8,164]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function I(p,w){return w&&(p.stack||p.stacktrace)?a.localize(0,null,R(p),L(p.stack)||L(p.stacktrace)):R(p)}function L(p){return Array.isArray(p)?p.join(`
`):p}function R(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?a.localize(1,null,p.message):p.message||a.localize(2,null)}function b(p=null,w=!1){if(!p)return a.localize(3,null);if(Array.isArray(p)){const h=y.$jf(p),m=b(h[0],w);return h.length>1?a.localize(4,null,m,h.length):m}if(O.$ge(p))return p;if(p.detail){const h=p.detail;if(h.error)return I(h.error,w);if(h.exception)return I(h.exception,w)}return p.stack?I(p,w):p.message?p.message:a.localize(5,null)}e.$9h=b;function d(p){const w=p;return w instanceof Error&&Array.isArray(w.actions)}e.$0h=d;function P(p,w){let h;return typeof p=="string"?h=new Error(p):h=p,h.actions=w,h}e.$$h=P}),define(be[165],we([9,10]),function(ae,e){return ae.create("vs/base/common/jsonErrorMessages",e)}),define(be[166],we([1,0,165]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;function O(a){switch(a){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$$o=O}),define(be[167],we([9,10]),function(ae,e){return ae.create("vs/base/node/zip",e)}),define(be[168],we([9,10]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[169],we([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(be[170],we([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(be[171],we([9,10]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(be[172],we([9,10]),function(ae,e){return ae.create("vs/platform/environment/node/argvHelper",e)}),define(be[173],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[174],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[175],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[176],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[177],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[178],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[179],we([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[180],we([9,10]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[181],we([9,10]),function(ae,e){return ae.create("vs/platform/files/common/fileService",e)}),define(be[182],we([9,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(be[183],we([9,10]),function(ae,e){return ae.create("vs/platform/files/common/io",e)}),define(be[184],we([9,10]),function(ae,e){return ae.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[185],we([9,10]),function(ae,e){return ae.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[186],we([9,10]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(be[187],we([9,10]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(be[188],we([9,10]),function(ae,e){return ae.create("vs/platform/shell/node/shellEnv",e)}),define(be[189],we([9,10]),function(ae,e){return ae.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[190],we([9,10]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[191],we([9,10]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[192],we([9,10]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[193],we([9,10]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(be[194],we([9,10]),function(ae,e){return ae.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(be[195],we([9,10]),function(ae,e){return ae.create("vs/server/node/serverEnvironmentService",e)}),define(be[196],we([9,10]),function(ae,e){return ae.create("vs/server/node/serverServices",e)}),define(be[197],we([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[198],we([9,10]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(be[199],we([9,10]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[200],we([9,10]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[201],we([1,0,11,170]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var a;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(a||(e.TokenType=a={}));function I(...d){switch(d.length){case 1:return(0,O.localize)(0,null,d[0]);case 2:return(0,O.localize)(1,null,d[0],d[1]);case 3:return(0,O.localize)(2,null,d[0],d[1],d[2]);default:return}}const L=(0,O.localize)(3,null),R=(0,O.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$5)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const p=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:p,lexeme:w,additionalInfo:P}),this.f.push(h)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const p=this.c.substring(this.d,this.e),w=b.b.get(p);w?this.k(w):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,p=!1,w=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const m=this.c.charCodeAt(P);if(p)p=!1;else if(m===47&&!w){P++;break}else m===91?w=!0:m===92?p=!0:m===93&&(w=!1);P++}for(;P<this.c.length&&b.a.has(this.c.charCodeAt(P));)P++;this.e=P;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=b,b.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0))),b.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(be[202],we([1,0,5,2]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0;class a{constructor(){this.a=new y.$5c,this.b=new y.$5c,this.c=new y.$5c,this.d=new y.$5c}call(R,b,d){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(R,b,d){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$pn=a,a.ChannelName="extensionhostdebugservice";class I extends O.$kb{constructor(R){super(),this.b=R}reload(R){this.b.call("reload",[R])}get onReload(){return this.b.listen("reload")}close(R){this.b.call("close",[R])}get onClose(){return this.b.listen("close")}attachSession(R,b,d){this.b.call("attach",[R,b,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(R,b){this.b.call("terminate",[R,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(R,b){return this.b.call("openExtensionDevelopmentHostWindow",[R,b])}}e.$qn=I}),define(be[203],we([1,0,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0;class O{constructor(L){this.a=L}listen(L,R,b){throw new Error("Invalid listen")}call(L,R,b){switch(R){case"download":return this.a.download(y.URI.revive(b[0]),y.URI.revive(b[1]))}throw new Error("Invalid call")}}e.$sn=O;class a{constructor(L,R){this.a=L,this.b=R}async download(L,R){const b=this.b();b&&(L=b.transformOutgoingURI(L),R=b.transformOutgoingURI(R)),await this.a.call("download",[L,R])}}e.$tn=a}),define(be[204],we([1,0,163,93,13,7,29,19,4]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0,e.$Ql=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,I.$bc)(a.$1e.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,I.$$b)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,R.$6f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.$6f)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,y.$Pl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$$b)(this.userDataPath,"logs",h)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$6f)(b.URI.file((0,I.$$b)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$6f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$6f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$6f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=L.env.VSCODE_PORTABLE;return h?b.URI.file((0,I.$$b)(h,"argv.json")):(0,R.$6f)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,I.$$b)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,I.$_b)(h):(0,I.$9b)((0,I.$$b)(a.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?b.URI.file((0,I.$_b)(h)):b.URI.file((0,I.$$b)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,I.$_b)(h);const m=L.env.VSCODE_EXTENSIONS;if(m)return m;const $=L.env.VSCODE_PORTABLE;return $?(0,I.$$b)($,"extensions"):(0,R.$6f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?b.URI.parse(m):b.URI.file((0,I.$9b)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,I.$9b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Ql.test(h))}get extensionLogLevel(){const h=[];for(const m of this.args.log||[]){const $=e.$Ql.exec(m);$&&$[1]&&$[2]&&h.push([$[1],$[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$6f)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=L.env.VSCODE_PORTABLE;return h?b.URI.file((0,I.$$b)(h,"policy.json")):(0,R.$6f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,m,$){this.a=h,this.b=m,this.c=$,this.editSessionId=this.args.editSessionId}}e.$Rl=d,Re([O.$Pg],d.prototype,"appRoot",null),Re([O.$Pg],d.prototype,"userHome",null),Re([O.$Pg],d.prototype,"userDataPath",null),Re([O.$Pg],d.prototype,"appSettingsHome",null),Re([O.$Pg],d.prototype,"tmpDir",null),Re([O.$Pg],d.prototype,"cacheHome",null),Re([O.$Pg],d.prototype,"stateResource",null),Re([O.$Pg],d.prototype,"userRoamingDataHome",null),Re([O.$Pg],d.prototype,"userDataSyncHome",null),Re([O.$Pg],d.prototype,"sync",null),Re([O.$Pg],d.prototype,"machineSettingsResource",null),Re([O.$Pg],d.prototype,"workspaceStorageHome",null),Re([O.$Pg],d.prototype,"localHistoryHome",null),Re([O.$Pg],d.prototype,"keyboardLayoutResource",null),Re([O.$Pg],d.prototype,"argvResource",null),Re([O.$Pg],d.prototype,"isExtensionDevelopment",null),Re([O.$Pg],d.prototype,"untitledWorkspacesHome",null),Re([O.$Pg],d.prototype,"builtinExtensionsPath",null),Re([O.$Pg],d.prototype,"extensionsPath",null),Re([O.$Pg],d.prototype,"extensionDevelopmentLocationURI",null),Re([O.$Pg],d.prototype,"extensionDevelopmentKind",null),Re([O.$Pg],d.prototype,"extensionTestsLocationURI",null),Re([O.$Pg],d.prototype,"debugExtensionHost",null),Re([O.$Pg],d.prototype,"logLevel",null),Re([O.$Pg],d.prototype,"extensionLogLevel",null),Re([O.$Pg],d.prototype,"serviceMachineIdResource",null),Re([O.$Pg],d.prototype,"disableTelemetry",null),Re([O.$Pg],d.prototype,"disableWorkspaceTrust",null),Re([O.$Pg],d.prototype,"policyFile",null);function P(w,h){return p(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}e.$Sl=P;function p(w,h,m,$,o,u){const g=Number(h||w)||($?null:m),D=g?!!h:!1;let E;if(u)try{E=JSON.parse(u)}catch{}return{port:g,break:D,debugId:o,env:E}}e.$Tl=p}),define(be[62],we([1,0,295,3,171]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=e.$il=e.$hl=void 0;const I={o:(0,a.localize)(0,null),e:(0,a.localize)(1,null),t:(0,a.localize)(2,null)};e.$hl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,a.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,a.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,a.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,a.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,a.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,a.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,a.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,a.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,a.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,a.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,a.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,a.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,a.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,a.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,a.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,a.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,a.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,a.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,a.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,a.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,a.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,a.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,a.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,a.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,a.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,a.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,a.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,a.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,a.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,a.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,a.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,a.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,a.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R($,o,u=L){const l=$.find(c=>c.length>0&&c[0]!=="-"),g={},D=["_"],E=[],t={};let i;for(const c in o){const f=o[c];f.type==="subcommand"?c===l&&(i=f):(f.alias&&(g[c]=f.alias),f.type==="string"||f.type==="string[]"?(D.push(c),f.deprecates&&D.push(...f.deprecates)):f.type==="boolean"&&(E.push(c),f.deprecates&&E.push(...f.deprecates)),f.global&&(t[c]=f))}if(i&&l){const c=t;for(const C in i.options)c[C]=i.options[C];const f=$.filter(C=>C!==l),k=u.getSubcommandReporter?u.getSubcommandReporter(l):void 0,v=R(f,c,k);return{[l]:v,_:[]}}const r=y($,{string:D,boolean:E,alias:g}),n={},s=r;n._=r._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in o){const f=o[c];if(f.type==="subcommand")continue;f.alias&&delete s[f.alias];let k=s[c];if(f.deprecates)for(const v of f.deprecates)s.hasOwnProperty(v)&&(k||(k=s[v],k&&u.onDeprecatedOption(v,f.deprecationMessage||(0,a.localize)(36,null,c))),delete s[v]);if(typeof k<"u"){if(f.type==="string[]"){if(Array.isArray(k)||(k=[k]),!f.allowEmptyValue){const v=k.filter(C=>C.length>0);v.length!==k.length&&(u.onEmptyValue(c),k=v.length>0?v:void 0)}}else f.type==="string"&&(Array.isArray(k)?(k=k.pop(),u.onMultipleValues(c,k)):!k&&!f.allowEmptyValue&&(u.onEmptyValue(c),k=void 0));n[c]=k,f.deprecationMessage&&u.onDeprecatedOption(c,f.deprecationMessage)}delete s[c]}for(const c in s)u.onUnknownOption(c);return n}e.$il=R;function b($,o){let u="";return o.args&&(Array.isArray(o.args)?u=` <${o.args.join("> <")}>`:u=` <${o.args}>`),o.alias?`-${o.alias} --${$}${u}`:`--${$}${u}`}function d($,o){const u=[];for(const l in $){const g=$[l],D=b(l,g);u.push([D,g.description])}return P(u,o)}e.$jl=d;function P($,o){const l=$.reduce((E,t)=>Math.max(E,t[0].length),12)+2+1;if(o-l<25)return $.reduce((E,t)=>E.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=o-l-1,D=[];for(const E of $){const t=E[0],i=w(E[1],g),r=p(l-t.length-2);D.push("  "+t+r+i[0]);for(let n=1;n<i.length;n++)D.push(p(l)+i[n])}return D}function p($){return" ".repeat($)}function w($,o){const u=[];for(;$.length;){const l=$.length<o?$.length:$.lastIndexOf(" ",o),g=$.slice(0,l).trim();$=$.slice(l),u.push(g)}return u}function h($,o,u,l,g){const D=process.stdout.isTTY&&process.stdout.columns||80,E=g?.noInputFiles!==!0?`[${(0,a.localize)(37,null)}...]`:"",t=[`${$} ${u}`];t.push(""),t.push(`${(0,a.localize)(38,null)}: ${o} [${(0,a.localize)(39,null)}]${E}`),t.push(""),g?.noPipe!==!0&&(O.$d?t.push((0,a.localize)(40,null,o)):t.push((0,a.localize)(41,null,o)),t.push(""));const i={},r=[];for(const n in l){const s=l[n];if(s.type==="subcommand")s.description&&r.push({command:n,description:s.description});else if(s.description&&s.cat){let c=i[s.cat];c||(i[s.cat]=c={}),c[n]=s}}for(const n in i){const s=n,c=i[s];c&&(t.push(I[s]),t.push(...d(c,D)),t.push(""))}return r.length&&(t.push((0,a.localize)(42,null)),t.push(...P(r.map(n=>[n.command,n.description]),D)),t.push("")),t.join(`
`)}e.$kl=h;function m($,o){return`${$||(0,a.localize)(43,null)}
${o||(0,a.localize)(44,null)}
${process.arch}`}e.$ll=m}),define(be[205],we([1,0,296,172,62]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=void 0;function I(p,w){const h=(g,D)=>{console.warn((0,O.localize)(0,null,g,D))},m=g=>{console.warn((0,O.localize)(1,null,g))},$=(g,D)=>{console.warn((0,O.localize)(2,null,g,D))},o=g=>({onUnknownOption:D=>{g!=="tunnel"&&console.warn((0,O.localize)(3,null,D,g))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:$,getSubcommandReporter:g!=="tunnel"?o:void 0}),u={onUnknownOption:g=>{console.warn((0,O.localize)(4,null,g))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:$,getSubcommandReporter:o},l=(0,a.$il)(p,a.$hl,w?u:void 0);return l.goto&&l._.forEach(g=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,O.localize)(5,null))),l}function L(p){const w=p.findIndex(h=>!/^-/.test(h));if(w>-1)return[...p.slice(0,w),...p.slice(w+1)]}function R(p){let[,...w]=p;process.env.VSCODE_DEV&&(w=L(w)||[]);const h=!P(process.env);return I(w,h)}e.$ml=R;function b(p){let[,,...w]=p;return process.env.VSCODE_DEV&&(w=L(w)||[]),I(w,!0)}e.$nl=b;function d(p,...w){const h=p.indexOf("--");return h===-1?p.push(...w):p.splice(h,0,...w),p}e.$ol=d;function P(p){return p.VSCODE_CLI==="1"}e.$pl=P}),function(){"use strict";function ae(e,y,O){function a(L,R){const b=I(L,R),d=[b];return e.isAbsolute(b)||d.unshift(O),e.resolve(...d)}function I(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(p,"AppData","Roaming")}break;case"darwin":d=e.join(y.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:a}}if(typeof define=="function")define(be[206],we([75,26,29]),function(e,y,O){return ae(e,y,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=ae(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[108],we([1,0,26,204,206]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=void 0;class I extends O.$Rl{constructor(d,P){super(d,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,a.getUserDataPath)(d,P.nameShort)},P)}}e.$Ul=I;function L(b,d){return(0,O.$Tl)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,d,b.extensionEnvironment)}e.$Vl=L;function R(b,d){return(0,O.$Tl)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,d,b.extensionEnvironment)}e.$Wl=R}),define(be[207],we([1,0,8,176]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;function a(L,R,b){try{I(L,R,b)}catch(d){console.error(d?.message??d)}return L}e.$_o=a;function I(L,R,b){const d=(P,p,w)=>{const h=P[p];if((0,y.$ge)(h)){const m=h,$=m.length;if($>1&&m[0]==="%"&&m[$-1]==="%"){const o=m.substr(1,$-2);let u=R[o];u===void 0&&b&&(u=b[o]);const l=typeof u=="string"?u:u?.message,g=b?.[o],D=typeof g=="string"?g:g?.message;if(!l){D||console.warn(`[${L.name}]: ${(0,O.localize)(0,null,o)}`);return}if(w&&(p==="title"||p==="category")&&D&&D!==l){const E={value:l,original:D};P[p]=E}else P[p]=l}}else if((0,y.$ie)(h))for(const m in h)h.hasOwnProperty(m)&&(m==="commands"?d(h,m,!0):d(h,m,w));else if(Array.isArray(h))for(let m=0;m<h.length;m++)d(h,m,w)};for(const P in L)L.hasOwnProperty(P)&&d(L,P)}}),define(be[77],we([1,0,19,60,180,53]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(u){return u=u.trim(),u==="*"||L.test(u)}e.$oo=b;function d(u){if(!b(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=u.match(L);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$po=d;function P(u){if(!u)return null;const l=u.majorBase,g=u.majorMustEqual,D=u.minorBase;let E=u.minorMustEqual;const t=u.patchBase;let i=u.patchMustEqual;u.hasCaret&&(l===0||(E=!1),i=!1);let r=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,s,c,f]=n;r=Date.UTC(Number(s),Number(c)-1,Number(f))}}return{majorBase:l,majorMustEqual:g,minorBase:D,minorMustEqual:E,patchBase:t,patchMustEqual:i,isMinimum:u.hasGreaterEquals,notBefore:r}}e.$qo=P;function p(u,l,g){let D;typeof u=="string"?D=P(d(u)):D=u;let E;l instanceof Date?E=l.getTime():typeof l=="string"&&(E=new Date(l).getTime());let t;if(typeof g=="string"?t=P(d(g)):t=g,!D||!t)return!1;const i=D.majorBase,r=D.minorBase,n=D.patchBase;let s=t.majorBase,c=t.minorBase,f=t.patchBase;const k=t.notBefore;let v=t.majorMustEqual,C=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?i>s?!0:i<s?!1:r>c?!0:r<c||E&&E<k?!1:n>=f:(i===1&&s===0&&(!v||!C||!A)&&(s=1,c=0,f=0,v=!0,C=!1,A=!1),i<s?!1:i>s?!v:r<c?!1:r>c?!C:n<f?!1:n>f?!A:!(E&&E<k))}e.$ro=p;function w(u,l,g,D,E){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([O.default.Error,a.localize(0,null)]),t;if(typeof D.name!="string")return t.push([O.default.Error,a.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([O.default.Error,a.localize(2,null,"version")]),t;if(!D.engines)return t.push([O.default.Error,a.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([O.default.Error,a.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!o(D.extensionDependencies))return t.push([O.default.Error,a.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!o(D.activationEvents))return t.push([O.default.Error,a.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([O.default.Error,a.localize(7,null,"activationEvents","main","browser")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([O.default.Warning,a.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([O.default.Error,a.localize(9,null,"main")]),t;{const n=(0,y.$6f)(g,D.main);(0,y.$Zf)(n,g)||t.push([O.default.Warning,a.localize(10,null,n.path,g.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([O.default.Error,a.localize(11,null,"browser")]),t;{const n=(0,y.$6f)(g,D.browser);(0,y.$Zf)(n,g)||t.push([O.default.Warning,a.localize(12,null,n.path,g.path)])}}if(!I.valid(D.version))return t.push([O.default.Error,a.localize(13,null)]),t;const i=[];if(!h(u,l,D,E,i))for(const n of i)t.push([O.default.Error,n]);return t}e.$so=w;function h(u,l,g,D,E){return D||typeof g.main>"u"&&typeof g.browser>"u"?!0:$(u,l,g.engines.vscode,E)}e.$to=h;function m(u,l,g){return u==="*"||$(l,g,u)}e.$uo=m;function $(u,l,g,D=[]){const E=P(d(g));if(!E)return D.push(a.localize(14,null,g)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return D.push(a.localize(15,null,g)),!1}else if(!E.majorMustEqual)return D.push(a.localize(16,null,g)),!1;return p(u,l,E)?!0:(D.push(a.localize(17,null,u,g)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let l=0,g=u.length;l<g;l++)if(typeof u[l]!="string")return!1;return!0}}),define(be[208],we([1,0,15,21]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;async function a(I,L,R){let b=R&&R.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const P=(await L.readFile(I.serviceMachineIdResource)).value.toString();b=(0,O.$2e)(P)?P:null}catch{b=null}if(!b){b=(0,O.$3e)();try{await L.writeFile(I.serviceMachineIdResource,y.$Ib.fromString(b))}catch{}}return R?.store("storage.serviceMachineId",b,-1,1),b}e.$No=a}),define(be[63],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class y{constructor(a,I=[],L=!1){this.ctor=a,this.staticArguments=I,this.supportsDelayedInstantiation=L}}e.$ih=y}),define(be[209],we([1,0,63]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.InstantiationType=void 0;const O=[];var a;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(a||(e.InstantiationType=a={}));function I(R,b,d){b instanceof y.$ih||(b=new y.$ih(b,[],!!d)),O.push([R,b])}e.$9q=I;function L(){return O}e.$0q=L}),define(be[210],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class y{constructor(I,L){this.key=I,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Pp=y;class O{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const L of this.a.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const R=this.lookupOrInsertNode(I),b=this.lookupOrInsertNode(L);R.outgoing.set(b.key,b),b.incoming.set(R.key,R)}removeNode(I){const L=this.b(I);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(I){const L=this.b(I);let R=this.a.get(L);return R||(R=new y(L,I),this.a.set(L,R)),R}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[L,R]of this.a)I.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,L]of this.a){const R=new Set([I]),b=this.c(L,R);if(b)return b}}c(I,L){for(const[R,b]of I.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const d=this.c(b,L);if(d)return d;L.delete(R)}}}e.$Qp=O}),define(be[6],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e._util=void 0;var y;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(y||(e._util=y={})),e.$kh=a("instantiationService");function O(L,R,b){R[y.DI_TARGET]===R?R[y.DI_DEPENDENCIES].push({id:L,index:b}):(R[y.DI_DEPENDENCIES]=[{id:L,index:b}],R[y.DI_TARGET]=R)}function a(L){if(y.serviceIds.has(L))return y.serviceIds.get(L);const R=function(b,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,b,P)};return R.toString=()=>L,y.serviceIds.set(L,R),R}e.$lh=a;function I(L){return L}e.$mh=I}),define(be[24],we([1,0,8,4,6]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,a.$lh)("configurationService");function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof O.URI)}e.$Sh=I;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof O.URI)}e.$Th=L;var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function b(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=b;function d(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Vh=d;function P(u,l){const g=Object.create(null);for(const D in u)p(g,D,u[D],l);return g}e.$Wh=P;function p(u,l,g,D){const E=l.split("."),t=E.pop();let i=u;for(let r=0;r<E.length;r++){const n=E[r];let s=i[n];switch(typeof s){case"undefined":s=i[n]=Object.create(null);break;case"object":break;default:D(`Ignoring ${l} as ${E.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[t]=g}catch{D(`Ignoring ${l} as ${E.join(".")} is ${JSON.stringify(i)}`)}else D(`Ignoring ${l} as ${E.join(".")} is ${JSON.stringify(i)}`)}e.$Xh=p;function w(u,l){const g=l.split(".");h(u,g)}e.$Yh=w;function h(u,l){const g=l.shift();if(l.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const D=u[g];typeof D=="object"&&!Array.isArray(D)&&(h(D,l),Object.keys(D).length===0&&delete u[g])}}function m(u,l,g){function D(i,r){let n=i;for(const s of r){if(typeof n!="object"||n===null)return;n=n[s]}return n}const E=l.split("."),t=D(u,E);return typeof t>"u"?g:t}e.$Zh=m;function $(u,l,g){Object.keys(l).forEach(D=>{D!=="__proto__"&&(D in u?y.$ie(u[D])&&y.$ie(l[D])?$(u[D],l[D],g):g&&(u[D]=l[D]):u[D]=l[D])})}e.$1h=$;function o(u){return u.replace(/[\[\]]/g,"")}e.$2h=o}),define(be[64],we([1,0,3,17,201,6,169,11]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",y.$e),b.set("isLinux",y.$f),b.set("isWindows",y.$d),b.set("isWeb",y.$j),b.set("isMacNative",y.$e&&!y.$j),b.set("isEdge",y.$B),b.set("isFirefox",y.$z),b.set("isChrome",y.$y),b.set("isSafari",y.$A);function d(T,S){if(b.get(T)!==void 0)throw(0,R.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(T,S)}e.$pi=d;const P=Object.prototype.hasOwnProperty;var p;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const w={regexParsingWithErrorRecovery:!0},h=(0,L.localize)(0,null),m=(0,L.localize)(1,null),$=(0,L.localize)(2,null),o=(0,L.localize)(3,null),u=(0,L.localize)(4,null),l=(0,L.localize)(5,null),g=(0,L.localize)(6,null),D=(0,L.localize)(7,null);class E{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(S=w){this.k=S,this.d=new a.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(S){if(S===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(S).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const ee=this.D(),oe=ee.type===17?l:void 0;throw this.h.push({message:u,offset:ee.offset,lexeme:a.$oi.getLexeme(ee),additionalInfo:oe}),E.c}return F}catch(F){if(F!==E.c)throw F;return}}l(){return this.m()}m(){const S=[this.o()];for(;this.y(16);){const F=this.o();S.push(F)}return S.length===1?S[0]:t.or(...S)}o(){const S=[this.s()];for(;this.y(15);){const F=this.s();S.push(F)}return S.length===1?S[0]:t.and(...S)}s(){if(this.y(2)){const S=this.D();switch(S.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,o),F?.negate()}case 17:return this.z(),M.create(S.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",S)}}return this.t()}t(){const S=this.D();switch(S.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,o),F}case 17:{const F=S.lexeme;if(this.z(),this.y(9)){const oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),oe.type!==10)throw this.B("REGEX",oe);const z=oe.lexeme,q=z.lastIndexOf("/"),W=q===z.length-1?void 0:this.w(z.substring(q+1));let U;try{U=new RegExp(z.substring(1,q),W)}catch{throw this.B("REGEX",oe)}return ge.create(F,U)}switch(oe.type){case 10:case 19:{const z=[oe.lexeme];this.z();let q=this.D(),W=0;for(let ue=0;ue<oe.lexeme.length;ue++)oe.lexeme.charCodeAt(ue)===40?W++:oe.lexeme.charCodeAt(ue)===41&&W--;for(;!this.E()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:W++;break;case 1:W--;break;case 10:case 18:for(let ue=0;ue<q.lexeme.length;ue++)q.lexeme.charCodeAt(ue)===40?W++:oe.lexeme.charCodeAt(ue)===41&&W--}if(W<0)break;z.push(a.$oi.getLexeme(q)),this.z(),q=this.D()}const U=z.join(""),X=U.lastIndexOf("/"),G=X===U.length-1?void 0:this.w(U.substring(X+1));let Y;try{Y=new RegExp(U.substring(1,X),G)}catch{throw this.B("REGEX",oe)}return t.regex(F,Y)}case 18:{const z=oe.lexeme;this.z();let q=null;if(!(0,O.$hd)(z)){const W=z.indexOf("/"),U=z.lastIndexOf("/");if(W!==U&&W>=0){const X=z.slice(W+1,U),G=z[U+1]==="i"?"i":"";try{q=new RegExp(X,G)}catch{throw this.B("REGEX",oe)}}}if(q===null)throw this.B("REGEX",oe);return ge.create(F,q)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,$);const oe=this.u();return t.notIn(F,oe)}switch(this.D().type){case 3:{this.z();const oe=this.u();if(this.x().type===18)return t.equals(F,oe);switch(oe){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,oe)}}case 4:{this.z();const oe=this.u();if(this.x().type===18)return t.notEquals(F,oe);switch(oe){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,oe)}}case 5:return this.z(),ce.create(F,this.u());case 6:return this.z(),le.create(F,this.u());case 7:return this.z(),te.create(F,this.u());case 8:return this.z(),he.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:g,offset:S.offset,lexeme:"",additionalInfo:D}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const S=this.D();switch(S.type){case 17:case 18:return this.z(),S.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(S){return S.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(S){return this.C(S)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(S,F){if(this.C(S))return this.z();throw this.B(F,this.D())}B(S,F,ee){const oe=(0,L.localize)(8,null,S,a.$oi.getLexeme(F)),z=F.offset,q=a.$oi.getLexeme(F);return this.h.push({message:oe,offset:z,lexeme:q,additionalInfo:ee}),E.c}C(S){return this.D().type===S}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=E,E.c=new Error;class t{static false(){return s.INSTANCE}static true(){return c.INSTANCE}static has(S){return f.create(S)}static equals(S,F){return k.create(S,F)}static notEquals(S,F){return A.create(S,F)}static regex(S,F){return ge.create(S,F)}static in(S,F){return v.create(S,F)}static notIn(S,F){return C.create(S,F)}static not(S){return M.create(S)}static and(...S){return ie.create(S,null,!0)}static or(...S){return J.create(S,null,!0)}static greater(S,F){return te.create(S,F)}static greaterEquals(S,F){return he.create(S,F)}static smaller(S,F){return ce.create(S,F)}static smallerEquals(S,F){return le.create(S,F)}static deserialize(S){return S==null?void 0:this.c.parse(S)}}e.$ri=t,t.c=new E({regexParsingWithErrorRecovery:!1});function i(T){const S=new E({regexParsingWithErrorRecovery:!1});return T.map(F=>(S.parse(F),S.lexingErrors.length>0?S.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,L.localize)(9,null,ee.additionalInfo):(0,L.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):S.parsingErrors.length>0?S.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$si=i;function r(T,S){const F=T?T.substituteConstants():void 0,ee=S?S.substituteConstants():void 0;return!F&&!ee?!0:!F||!ee?!1:F.equals(ee)}e.$ti=r;function n(T,S){return T.cmp(S)}class s{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return c.INSTANCE}}e.$ui=s,s.INSTANCE=new s;class c{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return s.INSTANCE}}e.$vi=c,c.INSTANCE=new c;class f{static create(S,F=null){const ee=b.get(S);return typeof ee=="boolean"?ee?c.INSTANCE:s.INSTANCE:new f(S,F)}constructor(S,F){this.key=S,this.c=F,this.type=2}cmp(S){return S.type!==this.type?this.type-S.type:H(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=b.get(this.key);return typeof S=="boolean"?S?c.INSTANCE:s.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$wi=f;class k{static create(S,F,ee=null){if(typeof F=="boolean")return F?f.create(S,ee):M.create(S,ee);const oe=b.get(S);return typeof oe=="boolean"?F===(oe?"true":"false")?c.INSTANCE:s.INSTANCE:new k(S,F,ee)}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=4}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=b.get(this.c);if(typeof S=="boolean"){const F=S?"true":"false";return this.d===F?c.INSTANCE:s.INSTANCE}return this}evaluate(S){return S.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(S){return S.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$xi=k;class v{static create(S,F){return new v(S,F)}constructor(S,F){this.d=S,this.f=F,this.type=10,this.c=null}cmp(S){return S.type!==this.type?this.type-S.type:B(this.d,this.f,S.d,S.f)}equals(S){return S.type===this.type?this.d===S.d&&this.f===S.f:!1}substituteConstants(){return this}evaluate(S){const F=S.getValue(this.f),ee=S.getValue(this.d);return Array.isArray(F)?F.includes(ee):typeof ee=="string"&&typeof F=="object"&&F!==null?P.call(F,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(S){return S.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$yi=v;class C{static create(S,F){return new C(S,F)}constructor(S,F){this.d=S,this.f=F,this.type=11,this.c=v.create(S,F)}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(S){return S.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=C;class A{static create(S,F,ee=null){if(typeof F=="boolean")return F?M.create(S,ee):f.create(S,ee);const oe=b.get(S);return typeof oe=="boolean"?F===(oe?"true":"false")?s.INSTANCE:c.INSTANCE:new A(S,F,ee)}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=5}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=b.get(this.c);if(typeof S=="boolean"){const F=S?"true":"false";return this.d===F?s.INSTANCE:c.INSTANCE}return this}evaluate(S){return S.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(S){return S.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ai=A;class M{static create(S,F=null){const ee=b.get(S);return typeof ee=="boolean"?ee?s.INSTANCE:c.INSTANCE:new M(S,F)}constructor(S,F){this.c=S,this.d=F,this.type=3}cmp(S){return S.type!==this.type?this.type-S.type:H(this.c,S.c)}equals(S){return S.type===this.type?this.c===S.c:!1}substituteConstants(){const S=b.get(this.c);return typeof S=="boolean"?S?s.INSTANCE:c.INSTANCE:this}evaluate(S){return!S.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(S){return S.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Bi=M;function K(T,S){if(typeof T=="string"){const F=parseFloat(T);isNaN(F)||(T=F)}return typeof T=="string"||typeof T=="number"?S(T):s.INSTANCE}class te{static create(S,F,ee=null){return K(F,oe=>new te(S,oe,ee))}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=12}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Ci=te;class he{static create(S,F,ee=null){return K(F,oe=>new he(S,oe,ee))}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=13}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Di=he;class ce{static create(S,F,ee=null){return K(F,oe=>new ce(S,oe,ee))}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=14}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Ei=ce;class le{static create(S,F,ee=null){return K(F,oe=>new le(S,oe,ee))}constructor(S,F,ee){this.c=S,this.d=F,this.f=ee,this.type=15}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Fi=le;class ge{static create(S,F){return new ge(S,F)}constructor(S,F){this.d=S,this.f=F,this.type=7,this.c=null}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.d<S.d)return-1;if(this.d>S.d)return 1;const F=this.f?this.f.source:"",ee=S.f?S.f.source:"";return F<ee?-1:F>ee?1:0}equals(S){if(S.type===this.type){const F=this.f?this.f.source:"",ee=S.f?S.f.source:"";return this.d===S.d&&F===ee}return!1}substituteConstants(){return this}evaluate(S){const F=S.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const S=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${S}`}keys(){return[this.d]}map(S){return S.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.$Gi=ge;class se{static create(S){return new se(S)}constructor(S){this.c=S,this.type=8}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(S){return new se(this.c.map(S))}negate(){return this.c}}e.$Hi=se;function V(T){let S=null;for(let F=0,ee=T.length;F<ee;F++){const oe=T[F].substituteConstants();if(T[F]!==oe&&S===null){S=[];for(let z=0;z<F;z++)S[z]=T[z]}S!==null&&(S[F]=oe)}return S===null?T:S}class ie{static create(S,F,ee){return ie.d(S,F,ee)}constructor(S,F){this.expr=S,this.c=F,this.type=6}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let F=0,ee=this.expr.length;F<ee;F++){const oe=n(this.expr[F],S.expr[F]);if(oe!==0)return oe}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let F=0,ee=this.expr.length;F<ee;F++)if(!this.expr[F].equals(S.expr[F]))return!1;return!0}return!1}substituteConstants(){const S=V(this.expr);return S===this.expr?this:ie.create(S,this.c,!1)}evaluate(S){for(let F=0,ee=this.expr.length;F<ee;F++)if(!this.expr[F].evaluate(S))return!1;return!0}static d(S,F,ee){const oe=[];let z=!1;for(const q of S)if(q){if(q.type===1){z=!0;continue}if(q.type===0)return s.INSTANCE;if(q.type===6){oe.push(...q.expr);continue}oe.push(q)}if(oe.length===0&&z)return c.INSTANCE;if(oe.length!==0){if(oe.length===1)return oe[0];oe.sort(n);for(let q=1;q<oe.length;q++)oe[q-1].equals(oe[q])&&(oe.splice(q,1),q--);if(oe.length===1)return oe[0];for(;oe.length>1;){const q=oe[oe.length-1];if(q.type!==9)break;oe.pop();const W=oe.pop(),U=oe.length===0,X=J.create(q.expr.map(G=>ie.create([G,W],null,ee)),null,U);X&&(oe.push(X),oe.sort(n))}if(oe.length===1)return oe[0];if(ee){for(let q=0;q<oe.length;q++)for(let W=q+1;W<oe.length;W++)if(oe[q].negate().equals(oe[W]))return s.INSTANCE;if(oe.length===1)return oe[0]}return new ie(oe,F)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const F of this.expr)S.push(...F.keys());return S}map(S){return new ie(this.expr.map(F=>F.map(S)),null)}negate(){if(!this.c){const S=[];for(const F of this.expr)S.push(F.negate());this.c=J.create(S,this,!0)}return this.c}}e.$Ii=ie;class J{static create(S,F,ee){return J.d(S,F,ee)}constructor(S,F){this.expr=S,this.c=F,this.type=9}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let F=0,ee=this.expr.length;F<ee;F++){const oe=n(this.expr[F],S.expr[F]);if(oe!==0)return oe}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let F=0,ee=this.expr.length;F<ee;F++)if(!this.expr[F].equals(S.expr[F]))return!1;return!0}return!1}substituteConstants(){const S=V(this.expr);return S===this.expr?this:J.create(S,this.c,!1)}evaluate(S){for(let F=0,ee=this.expr.length;F<ee;F++)if(this.expr[F].evaluate(S))return!0;return!1}static d(S,F,ee){let oe=[],z=!1;if(S){for(let q=0,W=S.length;q<W;q++){const U=S[q];if(U){if(U.type===0){z=!0;continue}if(U.type===1)return c.INSTANCE;if(U.type===9){oe=oe.concat(U.expr);continue}oe.push(U)}}if(oe.length===0&&z)return s.INSTANCE;oe.sort(n)}if(oe.length!==0){if(oe.length===1)return oe[0];for(let q=1;q<oe.length;q++)oe[q-1].equals(oe[q])&&(oe.splice(q,1),q--);if(oe.length===1)return oe[0];if(ee){for(let q=0;q<oe.length;q++)for(let W=q+1;W<oe.length;W++)if(oe[q].negate().equals(oe[W]))return c.INSTANCE;if(oe.length===1)return oe[0]}return new J(oe,F)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const F of this.expr)S.push(...F.keys());return S}map(S){return new J(this.expr.map(F=>F.map(S)),null)}negate(){if(!this.c){const S=[];for(const F of this.expr)S.push(F.negate());for(;S.length>1;){const F=S.shift(),ee=S.shift(),oe=[];for(const z of _(F))for(const q of _(ee))oe.push(ie.create([z,q],null,!1));S.unshift(J.create(oe,null,!1))}this.c=J.create(S,this,!0)}return this.c}}e.$Ji=J;class Z extends f{static all(){return Z.d.values()}constructor(S,F,ee){super(S,null),this.f=F,typeof ee=="object"?Z.d.push({...ee,key:S}):ee!==!0&&Z.d.push({key:S,description:ee,type:F!=null?typeof F:void 0})}bindTo(S){return S.createKey(this.key,this.f)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return k.create(this.key,S)}notEqualsTo(S){return A.create(this.key,S)}}e.$Ki=Z,Z.d=[],e.$Li=(0,I.$lh)("contextKeyService");function H(T,S){return T<S?-1:T>S?1:0}function B(T,S,F,ee){return T<F?-1:T>F?1:S<ee?-1:S>ee?1:0}function ne(T,S){if(T.type===0||S.type===1)return!0;if(T.type===9)return S.type===9?Q(T.expr,S.expr):!1;if(S.type===9){for(const F of S.expr)if(ne(T,F))return!0;return!1}if(T.type===6){if(S.type===6)return Q(S.expr,T.expr);for(const F of T.expr)if(ne(F,S))return!0;return!1}return T.equals(S)}e.$Mi=ne;function Q(T,S){let F=0,ee=0;for(;F<T.length&&ee<S.length;){const oe=T[F].cmp(S[ee]);if(oe<0)return!1;oe===0&&F++,ee++}return F===T.length}function _(T){return T.type===9?T.expr:[T]}}),define(be[78],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=(0,y.$lh)("credentialsService"),e.$kn=(0,y.$lh)("credentialsMainService");class O{constructor(){this.a={}}async getPassword(I,L){return this.a[I]?.[L]??null}async setPassword(I,L,R){this.a[I]=this.a[I]??{},this.a[I][L]=R}async deletePassword(I,L){return this.a[I]?.[L]?(delete this.a[I][L],Object.keys(this.a[I]).length===0&&delete this.a[I],!0):!1}async findPassword(I){return JSON.stringify(this.a[I])??null}async findCredentials(I){const L=[];for(const R of Object.keys(this.a[I]||{}))L.push({account:R,password:this.a[I][R]});return L}async clear(){this.a={}}}e.$ln=O}),define(be[211],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.ID=void 0,e.ID="diagnosticsService",e.$2l=(0,y.$lh)(e.ID);function O(I){return!!I.hostName&&!!I.errorMessage}e.$3l=O;class a{async getPerformanceInfo(L,R){return{}}async getSystemInfo(L,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,R){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.$4l=a}),define(be[79],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn=(0,y.$lh)("downloadService")}),define(be[25],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,y.$lh)("environmentService"),e.$th=(0,y.$mh)(e.$sh)}),define(be[31],we([1,0,174,6]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Mn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=void 0,e.$An="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Bn=new RegExp(e.$An),e.$Cn="__web_extension",e.$Dn="skipWalkthrough",e.$En="extensionsSync";function a(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Fn=a;function I(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Gn=I;function L(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Hn=L;function R(l,g){return g==="web"&&!l.includes("web")}e.$In=R;function b(l,g,D){return R(g,D)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===D?!0:d(D).includes(l)}e.$Jn=b;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Kn=d;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$Ln=P;var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var h;(function(l){l.Install="install",l.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Mn=(0,O.$lh)("extensionGalleryService");var $;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var o;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class u extends Error{constructor(g,D){super(g),this.code=D,this.name=D}}e.$Nn=u,e.$On=(0,O.$lh)("extensionManagementService"),e.$Pn="extensionsIdentifiers/disabled",e.$Qn="extensionsIdentifiers/enabled",e.$Rn=(0,O.$lh)("IGlobalExtensionEnablementService"),e.$Sn=(0,O.$lh)("IExtensionTipsService"),e.$Tn=(0,y.localize)(0,null),e.$Un={value:e.$Tn,original:"Extensions"},e.$Vn={value:(0,y.localize)(1,null),original:"Preferences"}}),define(be[212],we([1,0,5,2,22,4,50,31]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=void 0;function b(o,u){return o?I.URI.revive(u?u.transformIncoming(o):o):void 0}function d(o,u){return u?u.transformOutgoingURI(o):o}function P(o,u){u=u||L.$lm;const l=o.manifest;return{...(0,L.$om)({...o,manifest:void 0},u),manifest:l}}function p(o,u){return o?.profileLocation?(0,L.$om)(o,u??L.$lm):o}function w(o,u){return u?(0,a.$Gm)(o,l=>l instanceof I.URI?u.transformOutgoingURI(l):void 0):o}class h{constructor(u,l){this.a=u,this.b=l,this.onInstallExtension=y.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,l){const g=this.b(u);switch(l){case"onInstallExtension":return y.Event.map(this.onInstallExtension,D=>({...D,profileLocation:D.profileLocation?d(D.profileLocation,g):D.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,D=>D.map(E=>({...E,local:E.local?w(E.local,g):E.local,profileLocation:E.profileLocation?d(E.profileLocation,g):E.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,D=>({...D,profileLocation:D.profileLocation?d(D.profileLocation,g):D.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,D=>({...D,profileLocation:D.profileLocation?d(D.profileLocation,g):D.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,D=>w(D,g))}throw new Error("Invalid listen")}async call(u,l,g){const D=this.b(u);switch(l){case"zip":{const E=P(g[0],D),t=await this.a.zip(E);return d(t,D)}case"unzip":return this.a.unzip(b(g[0],D));case"install":return this.a.install(b(g[0],D),p(g[1],D));case"installFromLocation":return this.a.installFromLocation(b(g[0],D),b(g[1],D));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],b(g[1],D),b(g[2],D));case"getManifest":return this.a.getManifest(b(g[0],D));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],p(g[1],D));case"installGalleryExtensions":{const E=g[0];return this.a.installGalleryExtensions(E.map(({extension:t,options:i})=>({extension:t,options:p(i,D)??{}})))}case"uninstall":return this.a.uninstall(P(g[0],D),p(g[1],D));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(g[0],D));case"getInstalled":return(await this.a.getInstalled(g[0],b(g[1],D))).map(t=>w(t,D));case"copyExtensions":return this.a.copyExtensions(b(g[0],D),b(g[1],D));case"updateMetadata":{const E=await this.a.updateMetadata(P(g[0],D),g[1],b(g[2],D));return w(E,D)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1],g[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Vo=h;class m extends O.$kb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new y.$5c),this.f=this.B(new y.$5c),this.g=this.B(new y.$5c),this.h=this.B(new y.$5c),this.j=this.B(new y.$5c),this.B(this.k.listen("onInstallExtension")(l=>this.l(this.c,{...l,source:this.m(l.source)?I.URI.revive(l.source):l.source,profileLocation:I.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(l=>this.l(this.f,l.map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.m(g.source)?I.URI.revive(g.source):g.source,profileLocation:I.URI.revive(g.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(l=>this.l(this.g,{...l,profileLocation:I.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(l=>this.l(this.h,{...l,profileLocation:I.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(l=>this.j.fire(P(l,null))))}l(u,l){u.fire(l)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const l=await this.getTargetPlatform();return u.allTargetPlatforms.some(g=>(0,R.$Jn)(g,u.allTargetPlatforms,l))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(l=>I.URI.revive(l)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,l){return Promise.resolve(this.k.call("install",[u,l])).then(g=>P(g,null))}installFromLocation(u,l){return Promise.resolve(this.k.call("installFromLocation",[u,l])).then(g=>P(g,null))}async installExtensionsFromProfile(u,l,g){return(await this.k.call("installExtensionsFromProfile",[u,l,g])).map(E=>P(E,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,l){return Promise.resolve(this.k.call("installFromGallery",[u,l])).then(g=>P(g,null))}async installGalleryExtensions(u){return(await this.k.call("installGalleryExtensions",[u])).map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.m(g.source)?I.URI.revive(g.source):g.source,profileLocation:I.URI.revive(g.profileLocation)}))}uninstall(u,l){return Promise.resolve(this.k.call("uninstall",[u,l]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(l=>P(l,null))}getInstalled(u=null,l){return Promise.resolve(this.k.call("getInstalled",[u,l])).then(g=>g.map(D=>P(D,null)))}updateMetadata(u,l,g){return Promise.resolve(this.k.call("updateMetadata",[u,l,g])).then(D=>P(D,null))}copyExtensions(u,l){return this.k.call("copyExtensions",[u,l])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,l,g){const D=await this.k.call("download",[u,l,g]);return I.URI.revive(D)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Wo=m;class ${constructor(u){this.a=u}listen(u,l){throw new Error("Invalid listen")}call(u,l,g){switch(l){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Xo=$}),define(be[80],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=void 0,e.$So=(0,y.$lh)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((I,L)=>ae(["node-vsce-sign"],async R=>I(R),L))),this.a}async verify(I,L,R){let b;try{b=await this.b()}catch{return!1}return b.verify(I,L,R)}}e.$To=O}),define(be[16],we([1,0,61,7,17,8,4,182,6,3,13]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileKind=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileOperationResult=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileChangeType=e.$6j=e.FileOperation=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.FileSystemProviderErrorCode=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Pj=e.$Oj=void 0,e.$Oj=(0,b.$lh)("fileService");function p(H){return H.create===!0}e.$Pj=p;var w;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var h;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var m;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function $(H){return!!(H.capabilities&2)}e.$Qj=$;function o(H){return!!(H.capabilities&8)}e.$Rj=o;function u(H){return!!(H.capabilities&131072)}e.$Sj=u;function l(H){return!!(H.capabilities&4)}e.$Tj=l;function g(H){return!!(H.capabilities&16)}e.$Uj=g;function D(H){return $(H)?!!(H.capabilities&16384):!1}e.$Vj=D;function E(H){return $(H)?!!(H.capabilities&32768):!1}e.$Wj=E;function t(H){return!!(H.capabilities&65536)}e.$Xj=t;function i(H){return!!(H.capabilities&2048)}e.$Yj=i;var r;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class n extends Error{static create(B,ne){const Q=new n(B.toString(),ne);return f(Q,ne),Q}constructor(B,ne){super(B),this.code=ne}}e.$Zj=n;function s(H,B){return n.create(H,B)}e.$1j=s;function c(H){return H||s((0,R.localize)(0,null),r.Unknown)}e.$2j=c;function f(H,B){return H.name=B?`${B} (FileSystemError)`:"FileSystemError",H}e.$3j=f;function k(H){if(!H)return r.Unknown;if(H instanceof n)return H.code;const B=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!B)return r.Unknown;switch(B[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$4j=k;function v(H){if(H instanceof he)return H.fileOperationResult;switch(k(H)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$5j=v;var C;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class A{constructor(B,ne,Q){this.resource=B,this.operation=ne,this.target=Q}isOperation(B){return this.operation===B}}e.$6j=A;var M;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class K{constructor(B,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Q=new Map;for(const _ of B){const T=Q.get(_.type);switch(T?T.push([_.resource,_]):Q.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,T]of Q)switch(_){case 1:this.a=y.$rh.forUris(()=>ne),this.a.fill(T);break;case 0:this.b=y.$rh.forUris(()=>ne),this.b.fill(T);break;case 2:this.c=y.$rh.forUris(()=>ne),this.c.fill(T);break}}contains(B,...ne){return this.d(B,{includeChildren:!1},...ne)}affects(B,...ne){return this.d(B,{includeChildren:!0},...ne)}d(B,ne,...Q){if(!B)return!1;const _=Q.length>0;return!!((!_||Q.includes(1))&&(this.a?.get(B)||ne.includeChildren&&this.a?.findSuperstr(B))||(!_||Q.includes(0))&&(this.b?.get(B)||ne.includeChildren&&this.b?.findSuperstr(B))||(!_||Q.includes(2))&&(this.c?.findSubstr(B)||ne.includeChildren&&this.c?.findSuperstr(B)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$7j=K;function te(H,B,ne){return!H||!B||H===B||B.length>H.length?!1:(B.charAt(B.length-1)!==O.sep&&(B+=O.sep),ne?(0,a.$Kd)(H,B):H.indexOf(B)===0)}e.$8j=te;class he extends Error{constructor(B,ne,Q){super(B),this.fileOperationResult=ne,this.options=Q}}e.$9j=he;class ce extends he{constructor(B,ne,Q,_){super(B,ne,_),this.fileOperationResult=ne,this.size=Q}}e.$0j=ce;class le extends he{constructor(B,ne,Q){super(B,2,Q),this.stat=ne}}e.$$j=le;var ge;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$_j={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bk="files.associations",e.$ck="files.exclude",e.$dk="files.readonlyInclude",e.$ek="files.readonlyExclude",e.$fk="files.readonlyFromPermissions";var se;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(se||(e.FileKind=se={})),e.$gk="";function V(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$hk=V;async function ie(H,B){if(!B.hasProvider(L.URI.from({scheme:H.scheme})))return new Promise(ne=>{const Q=B.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===H.scheme&&_.added&&(Q.dispose(),ne())})})}e.$ik=ie;class J{static formatSize(B){return(0,I.$ke)(B)||(B=0),B<J.KB?(0,R.localize)(1,null,B.toFixed(0)):B<J.MB?(0,R.localize)(2,null,(B/J.KB).toFixed(2)):B<J.GB?(0,R.localize)(3,null,(B/J.MB).toFixed(2)):B<J.TB?(0,R.localize)(4,null,(B/J.GB).toFixed(2)):(0,R.localize)(5,null,(B/J.TB).toFixed(2))}}e.$jk=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;function Z(H){const B=typeof H=="string"||H?.scheme===P.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===P.Schemas.file?1024*J.MB:B?10*J.MB:d.$j?50*J.MB:1024*J.MB}e.$kk=Z}),define(be[213],we([1,0,15,39,11,5,2,47,4,21,16]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=void 0,e.$fM="localFilesystem";class p extends L.$kb{constructor(h,m){super(),this.a=h,this.b=m,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.$5c),this.onDidChangeFile=this.f.event,this.g=this.B(new I.$5c),this.onDidWatchError=this.g.event,this.h=(0,d.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,m){const{buffer:$}=await this.a.call("readFile",[h,m]);return $}readFileStream(h,m,$){const o=(0,R.$wb)(l=>y.$Ib.concat(l.map(g=>y.$Ib.wrap(g))).buffer),u=this.a.listen("readFileStream",[h,m])(l=>{if(l instanceof y.$Ib)o.write(l.buffer);else{if(l==="end")o.end();else{let g;if(l instanceof Error)g=l;else{const D=l;g=(0,P.$1j)(D.message??(0,O.$9h)(D),D.code??P.FileSystemProviderErrorCode.Unknown)}o.error(g),o.end()}u.dispose()}});return $.onCancellationRequested(()=>{o.error((0,a.$3)()),o.end(),u.dispose()}),o}writeFile(h,m,$){return this.a.call("writeFile",[h,y.$Ib.wrap(m),$])}open(h,m){return this.a.call("open",[h,m])}close(h){return this.a.call("close",[h])}async read(h,m,$,o,u){const[l,g]=await this.a.call("read",[h,m,u]);return $.set(l.buffer.slice(0,g),o),g}write(h,m,$,o,u){return this.a.call("write",[h,m,y.$Ib.wrap($),o,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,m){return this.a.call("delete",[h,m])}rename(h,m,$){return this.a.call("rename",[h,m,$])}copy(h,m,$){return this.a.call("copy",[h,m,$])}cloneFile(h,m){return this.a.call("cloneFile",[h,m])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const m=h;this.f.fire(m.map($=>({resource:b.URI.revive($.resource),type:$.type})))}else{const m=h;this.g.fire(m)}}))}watch(h,m){const $=(0,d.$3e)();return this.a.call("watch",[this.h,$,h,m]),(0,L.$ib)(()=>this.a.call("unwatch",[this.h,$]))}}e.$gM=p}),define(be[109],we([1,0,15,11,183,16]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;async function L(P,p,w,h,m,$){let o;try{await R(P,p,w,h,m,$)}catch(u){o=u}finally{o&&m.errorTransformer&&(o=m.errorTransformer(o)),typeof o<"u"&&w.error(o),w.end()}}e.$op=L;async function R(P,p,w,h,m,$){b($);const o=await P.open(p,{create:!1});try{b($);let u=0,l=0,g=m&&typeof m.length=="number"?m.length:void 0,D=y.$Ib.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),E=m&&typeof m.position=="number"?m.position:0,t=0;do l=await P.read(o,E,D.buffer,t,D.byteLength-t),E+=l,t+=l,u+=l,typeof g=="number"&&(g-=l),t===D.byteLength&&(await w.write(h(D)),D=y.$Ib.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),t=0);while(l>0&&(typeof g!="number"||g>0)&&b($)&&d(u,m));if(t>0){let i=t;typeof g=="number"&&(i=Math.min(t,g)),w.write(h(D.slice(0,i)))}}catch(u){throw(0,I.$2j)(u)}finally{await P.close(o)}}function b(P){if(P.isCancellationRequested)throw(0,O.$3)();return!0}function d(P,p){if(typeof p?.limits?.size=="number"&&P>p.limits.size)throw(0,I.$1j)((0,a.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(be[65],we([1,0,74,2,7,3,4,16]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0;function b(u){return u.recursive===!0}e.$qp=b;class d extends O.$kb{constructor(l,g,D,E){super(),this.h=l,this.i=g,this.j=D,this.k=E,this.c=this.B(new O.$lb),this.f=void 0,this.g=0}m(){const l=new O.$jb;this.c.value=l,this.b=this.l(l),this.b.setVerboseLogging(this.j),l.add(this.b.onDidChangeFile(g=>this.h(g))),l.add(this.b.onDidLogMessage(g=>this.i(g))),l.add(this.b.onDidError(g=>this.n(g)))}n(l){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${l}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${l}`):this.r(l)}p(l){this.g++,this.m(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.j=l,await this.b?.setVerboseLogging(l)}r(l){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${l}`})}s(l){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$rp=d,d.a=5;class P extends d{constructor(l,g,D){super(l,g,D,{type:"node.js",restartOnError:!1})}}e.$sp=P;class p extends d{constructor(l,g,D){super(l,g,D,{type:"universal",restartOnError:!0})}}e.$tp=p;function w(u){return u.map(l=>({type:l.type,resource:L.URI.file(l.path)}))}e.$up=w;function h(u){const l=new o;for(const g of u)l.processEvent(g);return l.coalesce()}e.$vp=h;function m(u,l){return typeof l=="string"&&!l.startsWith(y.$9i)&&!(0,a.$0b)(l)?{base:u,pattern:l}:l}e.$wp=m;function $(u,l){const g=[];for(const D of l)g.push((0,y.$aj)(m(u,D)));return g}e.$xp=$;class o{constructor(){this.a=new Set,this.b=new Map}c(l){return I.$f?l.path:l.path.toLowerCase()}processEvent(l){const g=this.b.get(this.c(l));let D=!1;if(g){const E=g.type,t=l.type;g.path!==l.path&&(l.type===2||l.type===1)?D=!0:E===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(g)):E===2&&t===1?g.type=0:E===1&&t===0||(g.type=t)}else D=!0;D&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],g=[];return Array.from(this.a).filter(D=>D.type!==2?(l.push(D),!1):!0).sort((D,E)=>D.path.length-E.path.length).filter(D=>g.some(E=>(0,R.$8j)(D.path,E,!I.$f))?!1:(g.push(D.path),!0)).concat(l)}}}),define(be[214],we([1,0,30,14,20,38,2,97,7,3,154,23,65]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=void 0;class h extends L.$kb{constructor(o,u,l,g){super(),this.j=o,this.k=u,this.l=l,this.m=g,this.c=this.B(new O.$Fg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},D=>this.k(D))),this.f=this.B(new O.$Eg(D=>this.u(D),h.b)),this.g=(0,w.$xp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,w.$xp)(this.j.path,this.j.includes):void 0,this.i=new a.$bd,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await p.Promises.stat(o);this.B(await this.s(o,u.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let u=o.path;try{u=await p.Promises.realpath(o.path),o.path===u&&(u=await(0,P.$Hp)(o.path)??o.path),o.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${u})`)}catch{}return u}async s(o,u){if(d.$e&&(0,I.$He)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$kb.None;const l=new a.$bd(this.i.token),g=new L.$jb;try{const D=(0,b.$cc)(o),E=(0,y.watch)(o);g.add((0,L.$ib)(()=>{E.removeAllListeners(),E.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(u)try{for(const r of await p.Promises.readdir(o))t.add(r)}catch(r){this.w(r)}const i=new Map;g.add((0,L.$ib)(()=>{for(const[,r]of i)r.dispose();i.clear()})),E.on("error",(r,n)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${r}, ${n})`),this.dispose()}),E.on("change",(r,n)=>{if(l.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${n}`);let s="";if(n&&(s=n.toString(),d.$e&&(s=(0,R.$4k)(s))),!(!s||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){i.get(s)?.dispose();const c=setTimeout(async()=>{if(i.delete(s),s===D&&!await p.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.v((0,b.$$b)(o,s));if(l.token.isCancellationRequested)return;let k;f?t.has(s)?k=0:(k=1,t.add(s)):(t.delete(s),k=2),this.t({path:(0,b.$$b)(this.j.path,s),type:k})},h.a);i.set(s,(0,L.$ib)(()=>clearTimeout(c)))}else{let c;t.has(s)?c=0:(c=1,t.add(s)),this.t({path:(0,b.$$b)(this.j.path,s),type:c})}else if(r==="rename"||s!==D){const c=setTimeout(async()=>{const f=await p.Promises.exists(o);l.token.isCancellationRequested||(f?(this.t({path:this.j.path,type:0},!0),g.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);g.clear(),g.add((0,L.$ib)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(D){await p.Promises.exists(o)&&!l.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${D.toString()})`)}return(0,L.$ib)(()=>{l.dispose(!0),g.dispose()})}t(o,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!u&&this.g.some(l=>l(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(l=>l(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const u=(0,w.$vp)(o);if(u.length>0){if(this.m)for(const g of u)this.z(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(d.$f)return p.Promises.exists(o);try{const u=(0,b.$cc)(o);return(await p.Promises.readdir((0,b.$bc)(o))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Kp=h,h.a=100,h.b=75;async function m($,o,u,l,g=512){const D=await p.Promises.open($,"r"),E=Buffer.allocUnsafe(g),t=new a.$bd(l);let i,r=!1;const n={path:$,excludes:[],recursive:!1},s=new h(n,c=>{(async()=>{for(const{type:f}of c)if(f===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:k}=await p.Promises.read(D,E,0,g,null);if(!k||t.token.isCancellationRequested)break;o(E.slice(0,k))}}catch(k){i=new Error(k),t.dispose(!0)}finally{r=!1}}})()});return await s.ready,u(),new Promise((c,f)=>{t.token.onCancellationRequested(async()=>{s.dispose();try{await p.Promises.close(D)}catch(k){i=new Error(k)}i?f(i):c()})})}e.$Lp=m}),define(be[215],we([1,0,5,74,2,3,214]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class R extends a.$kb{constructor(){super(...arguments),this.a=this.B(new y.$5c),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$5c),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.i(d),p=P.filter(h=>{const m=this.c.get(h.path);return m?!(0,O.$ej)(m.request.excludes,h.excludes)||!(0,O.$ej)(m.request.includes,h.includes):!0}),w=Array.from(this.c.values()).filter(({request:h})=>!P.find(m=>m.path===h.path&&(0,O.$ej)(m.excludes,h.excludes)&&(0,O.$ej)(m.includes,h.includes))).map(({request:h})=>h.path);p.length&&this.j(`Request to start watching: ${p.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const h of w)this.h(h);for(const h of p)this.g(h)}g(d){const P=new L.$Kp(d,w=>this.a.fire(w),w=>this.b.fire(w),this.f),p={request:d,instance:P};this.c.set(d.path,p)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}i(d){const P=new Map;for(const p of d){const w=I.$f?p.path:p.path.toLowerCase();P.set(w,p)}return Array.from(P.values())}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$Mp=R}),define(be[216],we([1,0,65,215]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class a extends y.$sp{constructor(L,R,b){super(L,R,b),this.m()}l(){return new O.$Mp}}e.$Np=a}),define(be[217],we([1,0,13,43,106,65]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;class L extends I.$tp{constructor(b,d,P){super(b,d,P),this.m()}l(b){const d=b.add(new a.$Ep(y.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(d.onDidProcessExit(({code:P,signal:p})=>this.n(`terminated by itself with code ${P}, signal: ${p}`))),O.ProxyChannel.toService((0,O.$5g)(d.getChannel("watcher")))}}e.$Fp=L}),define(be[81],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class y{constructor(...a){this.a=new Map;for(const[I,L]of a)this.set(I,L)}set(a,I){const L=this.a.get(a);return this.a.set(a,I),L}has(a){return this.a.has(a)}get(a){return this.a.get(a)}}e.$jh=y}),define(be[110],we([1,0,14,11,2,63,210,6,81,96]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;const P=!1;class p extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class w{constructor(o=new b.$jh,u=!1,l,g=P){this.f=o,this.g=u,this.h=l,this.i=g,this.o=new Set,this.f.set(R.$kh,this),this._globalGraph=g?l?._globalGraph??new L.$Qp(D=>D):void 0}createChild(o){return new w(o,this.g,this,this.i)}invokeFunction(o,...u){const l=m.traceInvocation(this.i,o);let g=!1;try{return o({get:E=>{if(g)throw(0,O.$5)("service accessor is only valid during the invocation of its target method");const t=this.m(E,l);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...u)}finally{g=!0,l.stop()}}createInstance(o,...u){let l,g;return o instanceof I.$ih?(l=m.traceCreation(this.i,o.ctor),g=this.j(o.ctor,o.staticArguments.concat(u),l)):(l=m.traceCreation(this.i,o),g=this.j(o,u,l)),l.stop(),g}j(o,u=[],l){const g=R._util.getServiceDependencies(o).sort((t,i)=>t.index-i.index),D=[];for(const t of g){const i=this.m(t.id,l);i||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(i)}const E=g.length>0?g[0].index:u.length;if(u.length!==E){console.trace(`[createInstance] First service dependency of ${o.name} at position ${E+1} conflicts with ${u.length} static arguments`);const t=E-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,E)}return Reflect.construct(o,u.concat(D))}k(o,u){if(this.f.get(o)instanceof I.$ih)this.f.set(o,u);else if(this.h)this.h.k(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const u=this.f.get(o);return!u&&this.h?this.h.l(o):u}m(o,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const l=this.l(o);return l instanceof I.$ih?this.q(o,l,u.branch(o,!0)):(u.branch(o,!1),l)}q(o,u,l){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,u,l)}finally{this.o.delete(o)}}r(o,u,l){const g=new L.$Qp(t=>t.id.toString());let D=0;const E=[{id:o,desc:u,_trace:l}];for(;E.length;){const t=E.pop();if(g.lookupOrInsertNode(t),D++>1e3)throw new p(g);for(const i of R._util.getServiceDependencies(t.desc.ctor)){const r=this.l(i.id);if(r||this.u(`[createInstance] ${o} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),r instanceof I.$ih){const n={id:i.id,desc:r,_trace:t._trace.branch(i.id,!0)};g.insertEdge(t,n),E.push(n)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new p(g);break}for(const{data:i}of t){if(this.l(i.id)instanceof I.$ih){const n=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,n)}g.removeNode(i)}}return this.l(o)}s(o,u,l=[],g,D){if(this.f.get(o)instanceof I.$ih)return this.t(o,u,l,g,D);if(this.h)return this.h.s(o,u,l,g,D);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(o,u,l=[],g,D){if(g){const E=new w(void 0,this.g,this,this.i);E.c=String(o);const t=new Map,i=new y.$Hg(()=>{const r=E.j(u,l,D);for(const[n,s]of t){const c=r[n];if(typeof c=="function")for(const f of s)c.apply(r,f)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,n){if(!i.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let f=t.get(n);return f||(f=new d.$jc,t.set(n,f)),(v,C,A)=>{const M=f.push([v,C,A]);return(0,a.$ib)(M)}}if(n in r)return r[n];const s=i.value;let c=s[n];return typeof c!="function"||(c=c.bind(s),r[n]=c),c},set(r,n,s){return i.value[n]=s,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,l,D)}u(o,u){if(u&&console.warn(o),this.g)throw new Error(o)}}e.$Rp=w;var h;(function($){$[$.None=0]="None",$[$.Creation=1]="Creation",$[$.Invocation=2]="Invocation",$[$.Branch=3]="Branch"})(h||(h={}));class m{static traceInvocation(o,u){return o?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,u){return o?new m(1,u.name):m.c}constructor(o,u){this.type=o,this.name=u,this.g=Date.now(),this.h=[]}branch(o,u){const l=new m(3,o.toString());return this.h.push([o,u,l]),l}stop(){const o=Date.now()-this.g;m.f+=o;let u=!1;function l(D,E){const t=[],i=new Array(D+1).join("	");for(const[r,n,s]of E.h)if(n&&s){u=!0,t.push(`${i}CREATES -> ${r}`);const c=l(D+1,s);c&&t.push(c)}else t.push(`${i}uses -> ${r}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||u)&&m.all.add(g.join(`
`))}}e.$Sp=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(be[218],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$lz=void 0,e.$lz=(0,y.$lh)("labelService");var O;(function(a){a[a.SHORT=0]="SHORT",a[a.MEDIUM=1]="MEDIUM",a[a.LONG=2]="LONG"})(O||(e.Verbosity=O={}))});var Ae=this&&this.__param||function(ae,e){return function(y,O){e(y,O,ae)}};define(be[82],we([1,0,20,2,3,185,31,6]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=void 0;function b(P){return P.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$tq=b,e.$uq=(0,R.$lh)("languagePackService");let d=e.$vq=class extends O.$kb{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new y.$bd;setTimeout(()=>p.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const m=w.firstPage.filter($=>$.properties.localizedLanguages?.length&&$.tags.some(o=>o.startsWith("lp-"))).map($=>{const o=$.properties.localizedLanguages?.[0],u=b($);return{...this.f(u,o,$),extensionId:$.identifier.id,galleryExtension:$}});return m.push(this.f("en","English")),m}f(p,w,h){const m=w??p;let $;if(m!==p&&($=`(${p})`),p.toLowerCase()===a.$q.toLowerCase()&&($??="",$+=(0,I.localize)(0,null)),h?.installCount){$??="";const o=h.installCount;let u;o>1e6?u=`${Math.floor(o/1e5)/10}M`:o>1e3?u=`${Math.floor(o/1e3)}K`:u=String(o),$+=` $(cloud-download) ${u}`}return{id:p,label:m,description:$}}};e.$vq=d=Re([Ae(0,L.$Mn)],d)}),define(be[12],we([1,0,39,5,73,2,28,3,19,8,4,64,6]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,w.$lh)("logService"),e.$Oi=(0,w.$lh)("loggerService");function h(){return new Date().toISOString()}function m(v){return(0,d.$ke)(v)}e.$Pi=m;var $;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})($||(e.LogLevel=$={})),e.$Qi=$.Info;function o(v,C,A){switch(C){case $.Trace:v.trace(A);break;case $.Debug:v.debug(A);break;case $.Info:v.info(A);break;case $.Warning:v.warn(A);break;case $.Error:v.error(A);break;case $.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=o;function u(v,C=!1){let A="";for(let M=0;M<v.length;M++){let K=v[M];if(K instanceof Error&&(K=(0,y.$9h)(K,C)),typeof K=="object")try{K=JSON.stringify(K)}catch{}A+=(M>0?" ":"")+K}return A}class l extends I.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new O.$5c),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==$.Off&&this.b<=C}}e.$Si=l;class g extends l{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...A){this.f($.Trace)&&this.g($.Trace,u([C,...A],!0))}debug(C,...A){this.f($.Debug)&&this.g($.Debug,u([C,...A]))}info(C,...A){this.f($.Info)&&this.g($.Info,u([C,...A]))}warn(C,...A){this.f($.Warning)&&this.g($.Warning,u([C,...A]))}error(C,...A){if(this.f($.Error))if(C instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=C.stack,this.g($.Error,u(M))}else this.g($.Error,u([C,...A]))}flush(){}}e.$Ti=g;class D extends l{constructor(C=e.$Qi){super(),this.setLevel(C),this.g=!R.$d}trace(C,...A){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...A):console.log(`[main ${h()}]`,C,...A))}debug(C,...A){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...A):console.log(`[main ${h()}]`,C,...A))}info(C,...A){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...A):console.log(`[main ${h()}]`,C,...A))}warn(C,...A){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,C,...A):console.warn(`[main ${h()}]`,C,...A))}error(C,...A){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,C,...A):console.error(`[main ${h()}]`,C,...A))}dispose(){}flush(){}}e.$Ui=D;class E extends l{constructor(C=e.$Qi,A=!0){super(),this.g=A,this.setLevel(C)}trace(C,...A){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...A):console.log(C,...A))}debug(C,...A){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...A):console.log(C,...A))}info(C,...A){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...A):console.log(C,...A))}warn(C,...A){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...A):console.log(C,...A))}error(C,...A){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...A):console.error(C,...A))}dispose(){}flush(){}}e.$Vi=E;class t extends l{constructor(C,A=e.$Qi){super(),this.g=C,this.setLevel(A)}trace(C,...A){this.f($.Trace)&&this.g.log($.Trace,[this.h(C),...A])}debug(C,...A){this.f($.Debug)&&this.g.log($.Debug,[this.h(C),...A])}info(C,...A){this.f($.Info)&&this.g.log($.Info,[this.h(C),...A])}warn(C,...A){this.f($.Warning)&&this.g.log($.Warning,[this.h(C),...A])}error(C,...A){this.f($.Error)&&this.g.log($.Error,[this.h(C),...A])}h(C){return typeof C=="string"?C:(0,y.$9h)(C,this.f($.Trace))}dispose(){}flush(){}}e.$Wi=t;class i extends l{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const A of this.g)A.setLevel(C);super.setLevel(C)}trace(C,...A){for(const M of this.g)M.trace(C,...A)}debug(C,...A){for(const M of this.g)M.debug(C,...A)}info(C,...A){for(const M of this.g)M.info(C,...A)}warn(C,...A){for(const M of this.g)M.warn(C,...A)}error(C,...A){for(const M of this.g)M.error(C,...A)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose()}}e.$Xi=i;class r extends I.$kb{constructor(C,A,M){if(super(),this.h=C,this.j=A,this.b=new L.$ji,this.c=this.B(new O.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$5c),this.onDidChangeVisibility=this.g.event,M)for(const K of M)this.b.set(K.resource,{logger:void 0,info:K})}k(C){return(0,d.$ge)(C)?[...this.b.values()].find(A=>A.info.id===C):this.b.get(C)}getLogger(C){return this.k(C)?.logger}createLogger(C,A){const M=this.l(C),K=(0,d.$ge)(C)?C:A?.id??(0,a.$_h)(M.toString()).toString(16);let te=this.b.get(M)?.logger;const he=A?.logLevel==="always"?$.Trace:A?.logLevel;te||(te=this.m(M,he??this.getLogLevel(M)??this.h,{...A,id:K}));const ce={logger:te,info:{resource:M,id:K,logLevel:he,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(ce.info),this.b.set(M,ce),te}l(C){return(0,d.$ge)(C)?(0,b.$6f)(this.j,`${C}.log`):C}setLogLevel(C,A){if(P.URI.isUri(C)){const M=C,K=A,te=this.b.get(M);te&&K!==te.info.logLevel&&(te.info.logLevel=K===this.h?void 0:K,te.logger?.setLevel(K),this.b.set(te.info.resource,te),this.f.fire([M,K]))}else{this.h=C;for(const[M,K]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,A){const M=this.k(C);M&&A!==!M.info.hidden&&(M.info.hidden=!A,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,A]))}getLogLevel(C){let A;return C&&(A=this.b.get(C)?.info.logLevel),A??this.h}registerLogger(C){const A=this.b.get(C.resource);A?A.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const A=this.b.get(C);A&&(A.logger&&A.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=r;class n{constructor(){this.onDidChangeLogLevel=new O.$5c().event}setLevel(C){}getLevel(){return $.Info}trace(C,...A){}debug(C,...A){}info(C,...A){}warn(C,...A){}error(C,...A){}critical(C,...A){}dispose(){}flush(){}}e.$Zi=n;class s extends n{}e.$1i=s;function c(v){if(v.verbose)return $.Trace;if(typeof v.logLevel=="string"){const C=k(v.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Qi}e.$2i=c;function f(v){switch(v){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}e.$3i=f;function k(v){switch(v){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$4i=k,e.$5i=new p.$Ki("logLevel",f($.Info))}),define(be[219],we([1,0,78,5,2,12,3,14]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;let b=e.$mn=class Kt extends a.$kb{constructor(P){super(),this.h=P,this.c=this.B(new O.$5c),this.onDidChangePassword=this.c.event,this.g=new R.$ng}async getPassword(P,p){this.h.trace("Going to get password from keytar:",P,p);let w;try{w=await this.i()}catch{return null}return await this.g.queue(P+p,()=>this.k(w,P,p))}async k(P,p,w){this.h.trace("Doing get password from keytar:",p,w);const h=await(0,R.$Ig)(()=>P.getPassword(p,w),50,3);if(!h)return this.h.trace("Did not get a password from keytar for account:",w),h;let m,$;try{const o=JSON.parse(h);m=o.content,$=o.hasNextChunk}catch{}if(!m||!$)return this.h.trace("Got password from keytar for account:",w),h;try{let o=1;for(;$;){const u=await(0,R.$Ig)(()=>P.getPassword(p,`${w}-${o}`),50,3),l=JSON.parse(u);m+=l.content,$=l.hasNextChunk,o++}return this.h.trace(`Got ${o}-chunked password from keytar for account:`,w),m}catch(o){return this.h.error(o),h}}async setPassword(P,p,w){this.h.trace("Going to set password using keytar:",P,p);let h;try{h=await this.i()}catch(m){throw this.j?.(m),m}await this.g.queue(P+p,()=>this.l(h,P,p,w)),this.c.fire({service:P,account:p})}async l(P,p,w,h){if(this.h.trace("Doing set password from keytar:",p,w),!L.$d){await(0,R.$Ig)(()=>P.setPassword(p,w,h),50,3),this.h.trace("Set password from keytar for account:",w);return}if(await this.m(P,p,w),h.length<=Kt.b){await(0,R.$Ig)(()=>P.setPassword(p,w,h),50,3),this.h.trace("Set password from keytar for account:",w);return}let m=0,$=0,o=!0;for(;o;){const u=h.substring(m,m+Kt.b);m+=Kt.b,o=h.length-m>0;const l={content:u,hasNextChunk:o};await(0,R.$Ig)(()=>P.setPassword(p,$?`${w}-${$}`:w,JSON.stringify(l)),50,3),$++}this.h.trace(`Set${$?` ${$}-chunked`:""} password from keytar for account:`,w)}async deletePassword(P,p){this.h.trace("Going to delete password using keytar:",P,p);let w;try{w=await this.i()}catch(m){throw this.j?.(m),m}const h=await this.g.queue(P+p,()=>this.m(w,P,p));return h&&this.c.fire({service:P,account:p}),h}async m(P,p,w){this.h.trace("Doing delete password from keytar:",p,w);const h=await P.getPassword(p,w);if(!h)return this.h.trace("Did not get a password to delete from keytar for account:",w),!1;let m,$;try{const u=JSON.parse(h);m=u.content,$=u.hasNextChunk}catch{}let o=0;if(m&&$)try{for(o++;$;){const u=`${w}-${o}`,l=await P.getPassword(p,u);await P.deletePassword(p,u),$=JSON.parse(l).hasNextChunk,o++}}catch(u){this.h.error(u)}return await P.deletePassword(p,w)?(this.h.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,w),!0):(this.h.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,w),!1)}async findPassword(P){let p;try{p=await this.i()}catch{return null}return await p.findPassword(P)}async findCredentials(P){let p;try{p=await this.i()}catch{return[]}return await p.findCredentials(P)}clear(){return this.f instanceof y.$ln?this.f.clear():Promise.resolve()}};b.a=2500,b.b=b.a-100,e.$mn=b=Re([Ae(0,I.$Ni)],b)}),define(be[220],we([1,0,18,14,11,5,2,7,65,12]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class P extends L.$kb{constructor(w,h){super(),this.a=w,this.b=h,this.c=this.B(new I.$5c),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$5c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.$pg(0)),this.s=[],this.t=this.B(new O.$pg(0))}watch(w,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(w,h):this.u(w,h)}l(w,h){const m={path:this.C(w),excludes:h.excludes,includes:h.includes,recursive:h.recursive},$=(0,y.$yf)(this.j,m);return this.m(),(0,L.$ib)(()=>{$(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,a.$X)(w))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,b.$up)(h)),h=>this.z(h),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const h of this.j)(0,b.$qp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const h of this.j)(0,b.$qp)(h)&&w.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,h){const m={path:this.C(w),excludes:h.excludes,includes:h.includes,recursive:!1},$=(0,y.$yf)(this.s,m);return this.v(),(0,L.$ib)(()=>{$(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,a.$X)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,b.$up)(w)),w=>this.z(w),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,R.$9b)(w.fsPath)}}e.$yp=P}),define(be[111],we([1,0,18,14,15,20,5,73,46,2,61,13,42,19,47,181,16,109,12,11]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;let D=e.$pp=class extends d.$kb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$5c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$5c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$5c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.$5c),this.onDidRunOperation=this.m.event,this.R=this.B(new L.$5c),this.onDidFilesChange=this.R.event,this.S=this.B(new L.$5c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.$zg)}registerProvider(t,i){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${t}`);const r=new d.$jb;return this.h.set(t,i),this.c.fire({added:!0,scheme:t,provider:i}),r.add(i.onDidChangeFile(n=>this.R.fire(new o.$7j(n,!this.O(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this.S.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:t}))),(0,d.$ib)(()=>{this.c.fire({added:!1,scheme:t,provider:i}),this.h.delete(t),(0,d.$fb)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const i=[];this.f.fire({scheme:t,join(r){i.push(r)}}),!this.h.has(t)&&await O.Promises.settled(i)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,i){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return b.Iterable.map(this.h,([t,i])=>({scheme:t,capabilities:i.capabilities}))}async j(t){if(!(0,h.$0f)(t))throw new o.$9j((0,$.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const i=this.h.get(t.scheme);if(!i){const r=new g.$_;throw r.message=(0,$.localize)(1,null,t.toString()),r}return i}async k(t){const i=await this.j(t);if((0,o.$Tj)(i)||(0,o.$Qj)(i)||(0,o.$Uj)(i))return i;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const i=await this.j(t);if((0,o.$Tj)(i)||(0,o.$Qj)(i))return i;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,i){try{return await this.n(t,i)}catch(r){throw(0,o.$4j)(r)===o.FileSystemProviderErrorCode.FileNotFound?new o.$9j((0,$.localize)(2,null,this.nb(t)),1):(0,o.$2j)(r)}}async n(t,i){const r=await this.j(t),n=this.O(r),s=i?.resolveTo,c=i?.resolveSingleChildDescendants,f=i?.resolveMetadata,k=await r.stat(t);let v;return this.p(r,t,k,void 0,!!f,(C,A)=>(v||(v=P.$rh.forUris(()=>!n),v.set(t,!0),s&&v.fill(!0,s)),v.get(C.resource)||v.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&c?A===1:!1))}async p(t,i,r,n,s,c){const{providerExtUri:f}=this.N(t),k={resource:i,name:f.basename(i),isFile:(r.type&o.FileType.File)!==0,isDirectory:(r.type&o.FileType.Directory)!==0,isSymbolicLink:(r.type&o.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&o.FilePermission.Locked),etag:(0,o.$hk)({mtime:r.mtime,size:r.size}),children:void 0};if(k.isDirectory&&c(k,n)){try{const v=await t.readdir(i),C=await O.Promises.settled(v.map(async([A,M])=>{try{const K=f.joinPath(i,A),te=s?await t.stat(K):{type:M};return await this.p(t,K,te,v.length,s,c)}catch(K){return this.b.trace(K),null}}));k.children=(0,y.$jf)(C)}catch(v){this.b.trace(v),k.children=[]}return k}return k}async resolveAll(t){return O.Promises.settled(t.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const i=await this.j(t),r=await i.stat(t);return this.p(i,t,r,void 0,!0,()=>!1)}async exists(t){const i=await this.j(t);try{return!!await i.stat(t)}catch{return!1}}async canCreateFile(t,i){try{await this.r(t,i)}catch(r){return r}return!0}async r(t,i){if(!i?.overwrite&&await this.exists(t))throw new o.$9j((0,$.localize)(3,null,this.nb(t)),3,i)}async createFile(t,i=a.$Ib.fromString(""),r){await this.r(t,r);const n=await this.writeFile(t,i);return this.m.fire(new o.$6j(t,0,n)),n}async writeFile(t,i,r){const n=this.lb(await this.l(t),t),{providerExtUri:s}=this.N(n);try{await this.s(n,t,r)||await this.P(n,s.dirname(t));let f;if((0,o.$Qj)(n)&&!(i instanceof a.$Ib))if((0,m.$ub)(i)){const k=await(0,m.$Bb)(i,3);k.ended?f=a.$Ib.concat(k.buffer):f=k}else f=(0,m.$yb)(i,k=>a.$Ib.concat(k),3);else f=i;if(!(0,o.$Tj)(n)||(0,o.$Qj)(n)&&f instanceof a.$Ib)await this.cb(n,t,r,f);else{const k=f instanceof a.$Ib?(0,a.$Sb)(f):f;r?.atomic!==!1&&r?.atomic?.postfix?await this.Y(n,t,(0,h.$6f)((0,h.$5f)(t),`${(0,h.$3f)(t)}${r.atomic.postfix}`),r,k):await this.Z(n,t,r,k)}this.m.fire(new o.$6j(t,4))}catch(c){throw new o.$9j((0,$.localize)(4,null,this.nb(t),(0,o.$2j)(c).toString()),(0,o.$5j)(c),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,i,r){const n=!!r?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,$.localize)(5,null,this.nb(i)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,$.localize)(6,null,this.nb(i)));if(n)throw new Error((0,$.localize)(7,null,this.nb(i)))}let c;try{c=await t.stat(i)}catch{return}if(c.type&o.FileType.Directory)throw new o.$9j((0,$.localize)(8,null,this.nb(i)),0,r);if(this.mb(i,c),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==o.$gk&&typeof c.mtime=="number"&&typeof c.size=="number"&&r.mtime<c.mtime&&r.etag!==(0,o.$hk)({mtime:r.mtime,size:c.size}))throw new o.$9j((0,$.localize)(9,null),3,r);return c}async readFile(t,i,r){const n=await this.k(t);return i?.atomic?this.t(n,t,i,r):this.u(n,t,i,r)}async t(t,i,r,n){return new Promise((s,c)=>{this.X.queueFor(i,this.N(t).providerExtUri).queue(async()=>{try{const f=await this.u(t,i,r,n);s(f)}catch(f){c(f)}})})}async u(t,i,r,n){const s=await this.v(t,i,{...r,preferUnbuffered:!0},n);return{...s,value:await(0,a.$Tb)(s.value)}}async readFileStream(t,i,r){const n=await this.k(t);return this.v(n,t,i,r)}async v(t,i,r,n){const s=new I.$bd(n),c=this.F(i,r).then(k=>k,k=>{throw s.cancel(),k});let f;try{return typeof r?.etag=="string"&&r.etag!==o.$gk&&await c,r?.atomic&&(0,o.$Vj)(t)||!((0,o.$Tj)(t)||(0,o.$Uj)(t))||(0,o.$Qj)(t)&&r?.preferUnbuffered?f=this.D(t,i,r):(0,o.$Uj)(t)?f=this.z(t,i,s.token,r):f=this.C(t,i,s.token,r),{...await c,value:f}}catch(k){throw f&&await(0,m.$zb)(f),this.w(k,i,r)}}w(t,i,r){const n=(0,$.localize)(10,null,this.nb(i),(0,o.$2j)(t).toString());return t instanceof o.$$j?new o.$$j(n,t.stat,r):t instanceof o.$0j?new o.$0j(n,t.fileOperationResult,t.size,t.options):new o.$9j(n,(0,o.$5j)(t),r)}z(t,i,r,n=Object.create(null)){const s=t.readFileStream(i,n,r);return(0,m.$Fb)(s,{data:c=>c instanceof a.$Ib?c:a.$Ib.wrap(c),error:c=>this.w(c,i,n)},c=>a.$Ib.concat(c))}C(t,i,r,n=Object.create(null)){const s=(0,a.$Xb)();return(0,u.$op)(t,i,s,c=>c,{...n,bufferSize:this.a,errorTransformer:c=>this.w(c,i,n)},r),s}D(t,i,r){const n=(0,m.$wb)(s=>a.$Ib.concat(s));return(async()=>{try{let s;r?.atomic&&(0,o.$Vj)(t)?s=await t.readFile(i,{atomic:!0}):s=await t.readFile(i),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.G(i,s.byteLength,r),n.end(a.$Ib.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(t,i){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new o.$9j((0,$.localize)(11,null,this.nb(t)),0,i);if(typeof i?.etag=="string"&&i.etag!==o.$gk&&i.etag===r.etag)throw new o.$$j((0,$.localize)(12,null),r,i);return this.G(t,r.size,i),r}G(t,i,r){if(typeof r?.limits?.size=="number"&&i>r.limits.size)throw new o.$0j((0,$.localize)(13,null,this.nb(t)),7,i,r)}async canMove(t,i,r){return this.H(t,i,"move",r)}async canCopy(t,i,r){return this.H(t,i,"copy",r)}async H(t,i,r,n){if(t.toString()!==i.toString())try{const s=r==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(i),i);await this.M(s,t,c,i,r,n)}catch(s){return s}return!0}async move(t,i,r){const n=this.lb(await this.l(t),t),s=this.lb(await this.l(i),i),c=await this.I(n,t,s,i,"move",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,c==="move"?2:3,f)),f}async copy(t,i,r){const n=await this.k(t),s=this.lb(await this.l(i),i),c=await this.I(n,t,s,i,"copy",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,c==="copy"?3:2,f)),f}async I(t,i,r,n,s,c){if(i.toString()===n.toString())return s;const{exists:f,isSameResourceWithDifferentPathCase:k}=await this.M(t,i,r,n,s,c);if(f&&!k&&c&&await this.del(n,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(n)),s==="copy"){if(t===r&&(0,o.$Rj)(t))await t.copy(i,n,{overwrite:c});else{const v=await this.resolve(i);v.isDirectory?await this.L(t,v,r,n):await this.J(t,i,r,n)}return s}else return t===r?(await t.rename(i,n,{overwrite:c}),s):(await this.I(t,i,r,n,"copy",c),await this.del(i,{recursive:!0}),"copy")}async J(t,i,r,n){if((0,o.$Tj)(t)&&(0,o.$Tj)(r))return this.eb(t,i,r,n);if((0,o.$Tj)(t)&&(0,o.$Qj)(r))return this.kb(t,i,r,n);if((0,o.$Qj)(t)&&(0,o.$Tj)(r))return this.ib(t,i,r,n);if((0,o.$Qj)(t)&&(0,o.$Qj)(r))return this.gb(t,i,r,n)}async L(t,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await O.Promises.settled(i.children.map(async s=>{const c=this.N(r).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(t,await this.resolve(s.resource),r,c):this.J(t,s.resource,r,c)}))}async M(t,i,r,n,s,c){let f=!1;if(t===r){const{providerExtUri:v,isPathCaseSensitive:C}=this.N(t);if(C||(f=v.isEqual(i,n)),f&&s==="copy")throw new Error((0,$.localize)(14,null,this.nb(i),this.nb(n)));if(!f&&v.isEqualOrParent(n,i))throw new Error((0,$.localize)(15,null,this.nb(i),this.nb(n)))}const k=await this.exists(n);if(k&&!f){if(!c)throw new o.$9j((0,$.localize)(16,null,this.nb(i),this.nb(n)),4);if(t===r){const{providerExtUri:v}=this.N(t);if(v.isEqualOrParent(i,n))throw new Error((0,$.localize)(17,null,this.nb(i),this.nb(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:f}}N(t){const i=this.O(t);return{providerExtUri:i?h.$Vf:h.$Xf,isPathCaseSensitive:i}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const i=this.lb(await this.j(t),t);await this.P(i,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,0,r)),r}async P(t,i){const r=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(i,n.dirname(i));)try{if(!((await t.stat(i)).type&o.FileType.Directory))throw new Error((0,$.localize)(18,null,this.nb(i)));break}catch(s){if((0,o.$4j)(s)!==o.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(n.basename(i)),i=n.dirname(i)}for(let s=r.length-1;s>=0;s--){i=n.joinPath(i,r[s]);try{await t.mkdir(i)}catch(c){if((0,o.$4j)(c)!==o.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,i){try{await this.Q(t,i)}catch(r){return r}return!0}async Q(t,i){const r=this.lb(await this.j(t),t),n=!!i?.useTrash;if(n&&!(r.capabilities&4096))throw new Error((0,$.localize)(19,null,this.nb(t)));const s=i?.atomic;if(s&&!(r.capabilities&65536))throw new Error((0,$.localize)(20,null,this.nb(t)));if(n&&s)throw new Error((0,$.localize)(21,null,this.nb(t)));let c;try{c=await r.stat(t)}catch{}if(c)this.mb(t,c);else throw new o.$9j((0,$.localize)(22,null,this.nb(t)),1);if(!!!i?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,$.localize)(23,null,this.nb(t)))}return r}async del(t,i){const r=await this.Q(t,i),n=!!i?.useTrash,s=!!i?.recursive,c=i?.atomic??!1;await r.delete(t,{recursive:s,useTrash:n,atomic:c}),this.m.fire(new o.$6j(t,1))}async cloneFile(t,i){const r=await this.j(t),n=this.lb(await this.l(i),i);if(r===n&&this.N(r).providerExtUri.isEqual(t,i))return;if(r===n&&(0,o.$Sj)(r))return r.cloneFile(t,i);await this.P(n,this.N(n).providerExtUri.dirname(i));const s=this.X.queueFor(t,this.N(r).providerExtUri);return r===n&&(0,o.$Rj)(r)?s.queue(()=>r.copy(t,i,{overwrite:!0})):s.queue(()=>this.J(r,t,n,i))}watch(t,i={recursive:!1,excludes:[]}){const r=new d.$jb;let n=!1,s=()=>{n=!0};return r.add((0,d.$ib)(()=>s())),(async()=>{try{const c=await this.W(t,i);n?(0,d.$fb)(c):s=()=>(0,d.$fb)(c)}catch(c){this.b.error(c)}})(),r}async W(t,i){const r=await this.j(t),n=(0,R.$_h)([this.N(r).providerExtUri.getComparisonKey(t),i]);let s=this.U.get(n);return s||(s={count:0,disposable:r.watch(t,i)},this.U.set(n,s)),s.count+=1,(0,d.$ib)(()=>{s&&(s.count--,s.count===0&&((0,d.$fb)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.$fb)(t.disposable);this.U.clear()}async Y(t,i,r,n,s){await this.Z(t,r,n,s);try{await t.rename(r,i,{overwrite:!0})}catch(c){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async Z(t,i,r,n){return this.X.queueFor(i,this.N(t).providerExtUri).queue(async()=>{const s=await t.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,m.$ub)(n)||(0,m.$vb)(n)?await this.$(t,s,n):await this.ab(t,s,n)}catch(c){throw(0,o.$2j)(c)}finally{await t.close(s)}})}async $(t,i,r){let n=0,s;if((0,m.$vb)(r)){if(r.buffer.length>0){const c=a.$Ib.concat(r.buffer);await this.bb(t,i,c,c.byteLength,n,0),n+=c.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((c,f)=>{(0,m.$Ab)(s,{onData:async k=>{s.pause();try{await this.bb(t,i,k,k.byteLength,n,0)}catch(v){return f(v)}n+=k.byteLength,setTimeout(()=>s.resume())},onError:k=>f(k),onEnd:()=>c()})})}async ab(t,i,r){let n=0,s;for(;(s=r.read())!==null;)await this.bb(t,i,s,s.byteLength,n,0),n+=s.byteLength}async bb(t,i,r,n,s,c){let f=0;for(;f<n;){const k=await t.write(i,s+f,r.buffer,c+f,n-f);f+=k}}async cb(t,i,r,n){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.db(t,i,r,n))}async db(t,i,r,n){let s;n instanceof a.$Ib?s=n:(0,m.$ub)(n)?s=await(0,a.$Tb)(n):(0,m.$vb)(n)?s=await(0,a.$Ub)(n):s=(0,a.$Rb)(n),await t.writeFile(i,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async eb(t,i,r,n){return this.X.queueFor(n,this.N(r).providerExtUri).queue(()=>this.fb(t,i,r,n))}async fb(t,i,r,n){let s,c;try{s=await t.open(i,{create:!1}),c=await r.open(n,{create:!0,unlock:!1});const f=a.$Ib.alloc(this.a);let k=0,v=0,C=0;do C=await t.read(s,k,f.buffer,v,f.byteLength-v),await this.bb(r,c,f,C,k,v),k+=C,v+=C,v===f.byteLength&&(v=0);while(C>0)}catch(f){throw(0,o.$2j)(f)}finally{await O.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async gb(t,i,r,n){return this.X.queueFor(n,this.N(r).providerExtUri).queue(()=>this.hb(t,i,r,n))}async hb(t,i,r,n){return r.writeFile(n,await t.readFile(i),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,i,r,n){return this.X.queueFor(n,this.N(r).providerExtUri).queue(()=>this.jb(t,i,r,n))}async jb(t,i,r,n){const s=await r.open(n,{create:!0,unlock:!1});try{const c=await t.readFile(i);await this.bb(r,s,a.$Ib.wrap(c),c.byteLength,0,0)}catch(c){throw(0,o.$2j)(c)}finally{await r.close(s)}}async kb(t,i,r,n){const s=await(0,a.$Tb)(this.C(t,i,I.CancellationToken.None));await this.cb(r,n,void 0,s)}lb(t,i){if(t.capabilities&2048)throw new o.$9j((0,$.localize)(24,null,this.nb(i)),6);return t}mb(t,i){if((i.permissions??0)&o.FilePermission.Readonly)throw new o.$9j((0,$.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};e.$pp=D=Re([Ae(0,l.$Ni)],D)}),define(be[66],we([1,0,30,297,14,28,15,5,38,2,7,3,19,47,23,184,16,109,220,39,217,216]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0,(()=>{try{(0,O.gracefulify)(y)}catch(i){console.error(`Error enabling graceful-fs: ${(0,g.$9h)(i)}`)}})();class t extends l.$yp{constructor(r,n){super(r,n),this.onDidChangeCapabilities=R.Event.None,this.I=new I.$ji(s=>w.$Wf.getComparisonKey(s)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,p.$f&&(this.F|=1024)),this.F}async stat(r){try{const{stat:n,symbolicLink:s}=await m.SymlinkSupport.stat(this.C(r));return{type:this.H(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:o.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const n=await m.Promises.readdir(this.C(r),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async c=>{try{let f;c.isSymbolicLink()?f=(await this.stat((0,w.$6f)(r,c.name))).type:f=this.H(c),s.push([c.name,f])}catch(f){this.a.trace(f)}})),s}catch(n){throw this.ab(n)}}H(r,n){let s;return n?.dangling?s=o.FileType.Unknown:r.isFile()?s=o.FileType.File:r.isDirectory()?s=o.FileType.Directory:s=o.FileType.Unknown,n&&(s|=o.FileType.SymbolicLink),s}async J(r){const n=this.C(r);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.I.get(r);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const c=new a.$qg;return this.I.set(r,c),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.$ib)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(r)===c&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(r)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(r,n){let s;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),s=await this.J(r));const c=this.C(r);return await m.Promises.readFile(c)}catch(c){throw this.ab(c)}finally{s?.dispose()}}L(r){t.D&&this.a.trace(r)}readFileStream(r,n,s){const c=(0,h.$wb)(f=>L.$Ib.concat(f.map(k=>L.$Ib.wrap(k))).buffer);return(0,u.$op)(this,r,c,f=>f.buffer,{...n,bufferSize:256*1024},s),c}async writeFile(r,n,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.M(r,(0,w.$6f)((0,w.$5f)(r),`${(0,w.$3f)(r)}${s.atomic.postfix}`),n,s):this.N(r,n,s)}async M(r,n,s,c){await this.N(n,s,c);try{await this.rename(n,r,{overwrite:!0})}catch(f){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw f}}async N(r,n,s){let c;try{const f=this.C(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(f)){if(!s.overwrite)throw(0,o.$1j)((0,$.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,o.$1j)((0,$.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(f){throw await this.bb(r,f)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){t.R=r}async open(r,n){const s=this.C(r);let c;(0,o.$Pj)(n)&&(c=await this.J(r));let f;try{if((0,o.$Pj)(n)&&n.unlock)try{const{stat:v}=await m.SymlinkSupport.stat(s);v.mode&128||await m.Promises.chmod(s,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let k;if((0,o.$Pj)(n)){if(p.$d)try{await m.Promises.truncate(s,0),k="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}k||(k="w")}else k="r";f=await m.Promises.open(s,k)}catch(k){throw c?.dispose(),(0,o.$Pj)(n)?await this.bb(r,k):this.ab(k)}if(this.O.set(f,0),(0,o.$Pj)(n)&&this.Q.set(f,r),c){const k=this.P.get(f);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${f} (${s})`),this.P.set(f,c),k&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${f} (${s})`),k.dispose())}return f}async close(r){const n=this.P.get(r);try{if(this.O.delete(r),this.Q.delete(r)&&t.R)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.ab(s)}finally{n&&(this.P.get(r)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.P.delete(r)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,s,c,f){const k=this.S(r,n);let v=null;try{v=(await m.Promises.read(r,s,c,f,k)).bytesRead}catch(C){throw this.ab(C)}finally{this.U(r,k,v)}return v}S(r,n){return n===this.O.get(r)?null:n}U(r,n,s){const c=this.O.get(r);typeof c=="number"&&(typeof n=="number"||(typeof s=="number"?this.O.set(r,c+s):this.O.delete(r)))}async write(r,n,s,c,f){return(0,a.$Ig)(()=>this.W(r,n,s,c,f),100,3)}async W(r,n,s,c,f){const k=this.S(r,n);let v=null;try{v=(await m.Promises.write(r,s,c,f,k)).bytesWritten}catch(C){throw await this.bb(this.Q.get(r),C)}finally{this.U(r,k,v)}return v}async mkdir(r){try{await m.Promises.mkdir(this.C(r))}catch(n){throw this.ab(n)}}async delete(r,n){try{const s=this.C(r);if(n.recursive){let c;n?.atomic!==!1&&n.atomic.postfix&&(c=(0,P.$$b)((0,P.$bc)(s),`${(0,P.$cc)(s)}${n.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,c)}else try{await m.Promises.unlink(s)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let f=!1;try{const{stat:k,symbolicLink:v}=await m.SymlinkSupport.stat(s);f=k.isDirectory()&&!v}catch{}if(f)await m.Promises.rmdir(s);else throw c}else throw c}}catch(s){throw this.ab(s)}}async rename(r,n,s){const c=this.C(r),f=this.C(n);if(c!==f)try{await this.X(r,n,"move",s.overwrite),await m.Promises.move(c,f)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,$.localize)(2,null,(0,P.$cc)(c),(0,P.$cc)((0,P.$bc)(f)),k.toString()))),this.ab(k)}}async copy(r,n,s){const c=this.C(r),f=this.C(n);if(c!==f)try{await this.X(r,n,"copy",s.overwrite),await m.Promises.copy(c,f,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,$.localize)(3,null,(0,P.$cc)(c),(0,P.$cc)((0,P.$bc)(f)),k.toString()))),this.ab(k)}}async X(r,n,s,c){const f=this.C(r),k=this.C(n);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.$Ge)(f,k,!0)),v){if(s==="copy")throw(0,o.$1j)((0,$.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const A=await this.G(r);if(!A)throw(0,o.$1j)((0,$.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const M=await this.G(n);if(M){if(!c)throw(0,o.$1j)((0,$.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);A.type&o.FileType.File&&M.type&o.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,n){return this.Y(r,n,!1)}async Y(r,n,s){const c=this.C(r),f=this.C(n),k=!!(this.capabilities&1024);if((0,b.$Ge)(c,f,!k))return;const v=new d.$jb;try{const[C,A]=await Promise.all([this.J(r),this.J(n)]);v.add(C),v.add(A),s&&await m.Promises.mkdir((0,P.$bc)(f),{recursive:!0}),await m.Promises.copyFile(c,f)}catch(C){if(C.code==="ENOENT"&&!s)return this.Y(r,n,!0);throw this.ab(C)}finally{v.dispose()}}p(r,n,s){return new D.$Fp(c=>r(c),c=>n(c),s)}y(r,n,s){return new E.$Np(c=>r(c),c=>n(c),s)}ab(r){if(r instanceof o.$Zj)return r;let n=r,s;switch(r.code){case"ENOENT":s=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=o.FileSystemProviderErrorCode.Unknown;break;default:s=o.FileSystemProviderErrorCode.Unknown}return(0,o.$1j)(n,s)}async bb(r,n){let s=this.ab(n);if(r&&s.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.C(r));c.mode&128||(s=(0,o.$1j)(n,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return s}}e.$Op=t,t.D=!1,t.R=!0}),define(be[221],we([1,0,5,66,2,15,47,20]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class b extends a.$kb{constructor(p,w){super(),this.a=p,this.b=w,this.w=new Map,this.y=new Map}call(p,w,h){const m=this.c(p);switch(w){case"stat":return this.g(m,h[0]);case"readdir":return this.h(m,h[0]);case"open":return this.l(m,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(m,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(m,h[0],h[1],h[2]);case"rename":return this.t(m,h[0],h[1],h[2]);case"copy":return this.u(m,h[0],h[1],h[2]);case"cloneFile":return this.v(m,h[0],h[1]);case"mkdir":return this.r(m,h[0]);case"delete":return this.s(m,h[0],h[1]);case"watch":return this.C(m,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${w} not found`)}listen(p,w,h){const m=this.c(p);switch(w){case"fileChange":return this.z(m,h[0]);case"readFileStream":return this.j(m,h[0],h[1])}throw new Error(`Unknown event ${w}`)}g(p,w){const h=this.f(p,w,!0);return this.a.stat(h)}h(p,w){const h=this.f(p,w);return this.a.readdir(h)}async i(p,w,h){const m=this.f(p,w,!0),$=await this.a.readFile(m,h);return I.$Ib.wrap($)}j(p,w,h){const m=this.f(p,w,!0),$=new R.$bd,o=new y.$5c({onDidRemoveLastListener:()=>{$.cancel()}}),u=this.a.readFileStream(m,h,$.token);return(0,L.$Ab)(u,{onData:l=>o.fire(I.$Ib.wrap(l)),onError:l=>o.fire(l),onEnd:()=>{o.fire("end"),o.dispose(),$.dispose()}}),o.event}k(p,w,h,m){const $=this.f(p,w);return this.a.writeFile($,h.buffer,m)}l(p,w,h){const m=this.f(p,w,!0);return this.a.open(m,h)}m(p){return this.a.close(p)}async n(p,w,h){const m=I.$Ib.alloc(h),$=0,o=await this.a.read(p,w,m.buffer,$,h);return[m,o]}p(p,w,h,m,$){return this.a.write(p,w,h.buffer,m,$)}r(p,w){const h=this.f(p,w);return this.a.mkdir(h)}s(p,w,h){const m=this.f(p,w);return this.a.delete(m,h)}t(p,w,h,m){const $=this.f(p,w),o=this.f(p,h);return this.a.rename($,o,m)}u(p,w,h,m){const $=this.f(p,w),o=this.f(p,h);return this.a.copy($,o,m)}v(p,w,h){const m=this.f(p,w),$=this.f(p,h);return this.a.cloneFile(m,$)}z(p,w){const h=new y.$5c({onWillAddFirstListener:()=>{this.w.set(w,this.F(p,h))},onDidRemoveLastListener:()=>{(0,a.$fb)(this.w.get(w)),this.w.delete(w)}});return h.event}async C(p,w,h,m,$){const o=this.w.get(w);if(o){const u=this.f(p,m),l=o.watch(h,u,$);this.y.set(w+h,l)}}async D(p,w){const h=p+w,m=this.y.get(h);m&&((0,a.$fb)(m),this.y.delete(h))}dispose(){super.dispose();for(const[,p]of this.y)p.dispose();this.y.clear();for(const[,p]of this.w)p.dispose();this.w.clear()}}e.$ir=b;class d extends a.$kb{constructor(p,w,h,m){super(),this.c=p,this.f=h,this.g=m,this.a=new Map,this.b=this.B(new O.$Op(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(w)}h(p){const w=this.B(new y.$5c);this.B(w.event(h=>{p.fire(h.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(h=>w.fire(h))),this.B(this.b.onDidWatchError(h=>p.fire(h)))}i(p){}j(p){}watch(p,w,h){const m=this.j(this.g);return Array.isArray(m)&&(h.excludes=[...h.excludes,...m]),this.a.set(p,this.b.watch(w,h)),(0,a.$ib)(()=>{(0,a.$fb)(this.a.get(p)),this.a.delete(p)})}dispose(){super.dispose();for(const[,p]of this.a)p.dispose();this.a.clear()}}e.$jr=d}),define(be[112],we([1,0,4,5,12,2]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0;class L extends a.$Yi{constructor(p,w,h,m,$){super(w,h,m),this.n=p,this.p=$,this.B($.listen("onDidChangeLogLevel",p)(o=>{(0,a.$Pi)(o)?super.setLogLevel(o):super.setLogLevel(y.URI.revive(o[0]),o[1])})),this.B($.listen("onDidChangeVisibility",p)(([o,u])=>super.setVisibility(y.URI.revive(o),u))),this.B($.listen("onDidChangeLoggers",p)(({added:o,removed:u})=>{for(const l of o)super.registerLogger({...l,resource:y.URI.revive(l.resource)});for(const l of u)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new a.$Wi({log:(p,w)=>{this.p.call("consoleLog",[p,w])}})}registerLogger(p){super.registerLogger(p),this.p.call("registerLogger",[p,this.n])}deregisterLogger(p){super.deregisterLogger(p),this.p.call("deregisterLogger",[p,this.n])}setLogLevel(p,w){super.setLogLevel(p,w),this.p.call("setLogLevel",[p,w])}setVisibility(p,w){super.setVisibility(p,w),this.p.call("setVisibility",[this.l(p),w])}m(p,w,h){return new R(this.p,p,w,h,this.n)}static setLogLevel(p,w,h){return p.call("setLogLevel",[w,h])}}e.$Kq=L;class R extends a.$Ti{constructor(p,w,h,m,$){super(m?.logLevel==="always"),this.m=p,this.n=w,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[w,m,$]).then(()=>{this.r(this.l),this.k=!0})}g(p,w){const h=[[p,w]];this.k?this.r(h):this.l.push(...h)}r(p){this.m.call("log",[this.n,p])}}class b{constructor(p,w){this.a=p,this.b=w}listen(p,w){const h=this.b(p);switch(w){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map($=>this.c($,h)),removed:[...m.removed].map($=>this.c($,h))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,m=>[h.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,m=>(0,a.$Pi)(m)?m:[h.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${w}`)}async call(p,w,h){const m=this.b(p);switch(w){case"setLogLevel":return(0,a.$Pi)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(y.URI.revive(m.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map($=>this.c($,m)))}throw new Error(`Call not found: ${w}`)}c(p,w){return{...p,resource:w.transformOutgoingURI(p.resource)}}}e.$Lq=b;class d extends I.$kb{constructor(p,w){super(),w.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const m of h)p.registerLogger({...m,resource:y.URI.revive(m.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,m])=>p.setVisibility(y.URI.revive(h),m))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:m})=>{for(const $ of h)p.registerLogger({...$,resource:y.URI.revive($.resource)});for(const $ of m)p.deregisterLogger($.resource)}))}}e.$Mq=d}),define(be[113],we([1,0,2,12]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=void 0;class a extends y.$kb{constructor(L,R=[]){super(),this.a=new O.$Xi([L,...R]),this.B(L.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$yM=a}),define(be[222],we([1,0,16,12]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0;var a;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(a||(a={}));async function I(d,P,p,w,h){try{const m=await new Promise((o,u)=>{ae(["@vscode/spdlog"],o,u)});m.setFlushOn(a.Trace);const $=await m.createAsyncRotatingLogger(d,P,p,w);return h?$.clearFormatters():$.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),$}catch(m){console.error(m)}return null}function L(d,P,p){switch(P){case O.LogLevel.Trace:d.trace(p);break;case O.LogLevel.Debug:d.debug(p);break;case O.LogLevel.Info:d.info(p);break;case O.LogLevel.Warning:d.warn(p);break;case O.LogLevel.Error:d.error(p);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function R(d,P){switch(P){case O.LogLevel.Trace:d.setLevel(a.Trace);break;case O.LogLevel.Debug:d.setLevel(a.Debug);break;case O.LogLevel.Info:d.setLevel(a.Info);break;case O.LogLevel.Warning:d.setLevel(a.Warning);break;case O.LogLevel.Error:d.setLevel(a.Error);break;case O.LogLevel.Off:d.setLevel(a.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class b extends O.$Ti{constructor(P,p,w,h,m){super(),this.k=[],this.setLevel(m),this.l=this.n(P,p,w,h),this.B(this.onDidChangeLogLevel($=>{this.m&&R(this.m,$)}))}async n(P,p,w,h){const m=w?6:1,$=30/m*y.$jk.MB,o=await I(P,p,$,m,h);if(o){this.m=o,R(this.m,this.getLevel());for(const{level:u,message:l}of this.k)L(this.m,u,l);this.k=[]}}g(P,p){this.m?L(this.m,P,p):this.getLevel()<=P&&this.k.push({level:P,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$nM=b}),define(be[114],we([1,0,21,12,222]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=void 0;class I extends O.$Yi{m(R,b,d){return new a.$nM((0,y.$3e)(),R.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,b)}}e.$oM=I}),define(be[223],we([1,0,60,186,6]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var L;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(b){function d(m,$){return $-m}b.compare=d;const P=Object.create(null);P[b.Error]=(0,O.localize)(0,null),P[b.Warning]=(0,O.localize)(1,null),P[b.Info]=(0,O.localize)(2,null);function p(m){return P[m]||""}b.toString=p;function w(m){switch(m){case y.default.Error:return b.Error;case y.default.Warning:return b.Warning;case y.default.Info:return b.Info;case y.default.Ignore:return b.Hint}}b.fromSeverity=w;function h(m){switch(m){case b.Error:return y.default.Error;case b.Warning:return y.default.Warning;case b.Info:return y.default.Info;case b.Hint:return y.default.Ignore}}b.toSeverity=h}(L||(e.MarkerSeverity=L={}));var R;(function(b){const d="";function P(w){return p(w,!0)}b.makeKey=P;function p(w,h){const m=[d];return w.source?m.push(w.source.replace("\xA6","\\\xA6")):m.push(d),w.code?typeof w.code=="string"?m.push(w.code.replace("\xA6","\\\xA6")):m.push(w.code.value.replace("\xA6","\\\xA6")):m.push(d),w.severity!==void 0&&w.severity!==null?m.push(L.toString(w.severity)):m.push(d),w.message&&h?m.push(w.message.replace("\xA6","\\\xA6")):m.push(d),w.startLineNumber!==void 0&&w.startLineNumber!==null?m.push(w.startLineNumber.toString()):m.push(d),w.startColumn!==void 0&&w.startColumn!==null?m.push(w.startColumn.toString()):m.push(d),w.endLineNumber!==void 0&&w.endLineNumber!==null?m.push(w.endLineNumber.toString()):m.push(d),w.endColumn!==void 0&&w.endColumn!==null?m.push(w.endColumn.toString()):m.push(d),m.push(d),m.join("\xA6")}b.makeKeyOptionalMessage=p})(R||(e.IMarkerData=R={})),e.$is=(0,a.$lh)("markerService")}),define(be[67],we([1,0,5,46,2,6]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=(0,I.$lh)("policy");class L extends a.$kb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$5c),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.i(d),O.Iterable.reduce(this.g.entries(),(p,[w,h])=>({...p,[w]:h}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(d,[P,p])=>({...d,[P]:{definition:p,value:this.g.get(P)}}),{})}}e.$Tm=L;class R{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Um=R}),define(be[54],we([1,0,3,29]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.context<"u"){const I=y.$b.vscode.context.configuration();if(I)a=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:I.version})}Object.assign(a,{extensionsGallery:O.env.EXTENSIONS_GALLERY?JSON.parse(O.env.EXTENSIONS_GALLERY):a.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else a={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.1",sha256:"095dc6d5d45490966dfa74d24add92036b42bf02a37d88c4b0f510dc91deeee6",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.80.0",sha256:"ac75e4ecf79efafa2bb0e6c8c548a6c8359555623f677a386cbcea80630aee4f",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.80.1",commit:"74f6148eb9ea00507ec113ec51c489d6ffb4b771",date:"2023-07-19T22:05:25.246Z"},Object.keys(a).length===0&&Object.assign(a,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(be[27],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,y.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"}),define(be[35],we([1,0,94,8]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;class a{constructor(){this.a=new Map}add(L,R){y.ok(O.$ge(L)),y.ok(O.$ie(R)),y.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Qm=new a}),define(be[224],we([1,0,5,35]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0,e.$Rm={JSONContribution:"base.contributions.json"};function a(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class I{constructor(){this.b=new y.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,d){this.a[a(b)]=d,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const L=new I;O.$Qm.add(e.$Rm.JSONContribution,L)}),define(be[55],we([1,0,18,5,8,168,24,224,35]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.ConfigurationScope=e.$Vm=e.EditPresentationTypes=void 0;var d;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$Vm={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m="vscode://schemas/settings/resourceLanguage",e.$4m="vscode://schemas/settings/configurationDefaults";const p=b.$Qm.as(R.$Rm.JSONContribution);class w{constructor(){this.h=new Set,this.i=new O.$5c,this.onDidSchemaChange=this.i.event,this.j=new O.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$3m,this.g),this.v()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const r=new Set;this.n(t,i,r),p.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const i=new Set;this.o(t,i),p.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:t,remove:i}){const r=new Set;this.o(i,r),this.n(t,!1,r),p.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const i=new Set;this.k(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(t,i){const r=[];for(const{overrides:n,source:s}of t)for(const c in n)if(i.add(c),e.$6m.test(c)){const f=this.a.get(c),k=f?.valuesSources??new Map;if(s)for(const M of Object.keys(n[c]))k.set(M,s);const v={...f?.value||{},...n[c]};this.a.set(c,{source:s,value:v,valuesSources:k});const C=(0,L.$2h)(c),A={type:"object",default:v,description:I.localize(1,null,C),$ref:e.$3m,defaultDefaultValue:v,source:a.$ge(s)?void 0:s,defaultValueSource:s};r.push(...$(c)),this.d[c]=A,this.b.properties[c]=A}else{this.a.set(c,{value:n[c],source:s});const f=this.d[c];f&&(this.w(c,f),this.r(c,f))}this.m(r)}deregisterDefaultConfigurations(t){const i=new Set;this.l(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(t,i){for(const{overrides:r,source:n}of t)for(const s in r){const c=this.a.get(s),f=a.$ge(n)?n:n?.id,k=a.$ge(c?.source)?c?.source:c?.source?.id;if(f===k)if(i.add(s),this.a.delete(s),e.$6m.test(s))delete this.d[s],delete this.b.properties[s];else{const v=this.d[s];v&&(this.w(s,v),this.r(s,v))}}this.u()}deltaConfiguration(t){let i=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),i=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),i=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const i of t)this.h.add(i);this.u()}n(t,i,r){t.forEach(n=>{this.p(n,i,n.extensionInfo,n.restrictedProperties,void 0,r),this.c.push(n),this.q(n)})}o(t,i){const r=n=>{if(n.properties)for(const s in n.properties){i.add(s);const c=this.d[s];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>r(s))};for(const n of t){r(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,i=!0,r,n,s=3,c){s=a.$pe(t.scope)?s:t.scope;const f=t.properties;if(f)for(const v in f){const C=f[v];if(i&&g(v,C)){delete f[v];continue}if(C.source=r,C.defaultDefaultValue=f[v].default,this.w(v,C),e.$6m.test(v)?C.scope=void 0:(C.scope=a.$pe(C.scope)?s:C.scope,C.restricted=a.$pe(C.restricted)?!!n?.includes(v):C.restricted),f[v].hasOwnProperty("included")&&!f[v].included){this.f[v]=f[v],delete f[v];continue}else this.d[v]=f[v],f[v].policy?.name&&this.e.set(f[v].policy.name,v);!f[v].deprecationMessage&&f[v].markdownDeprecationMessage&&(f[v].deprecationMessage=f[v].markdownDeprecationMessage),c.add(v)}const k=t.allOf;if(k)for(const v of k)this.p(v,i,r,n,s,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const i=r=>{const n=r.properties;if(n)for(const c in n)this.r(c,n[c]);r.allOf?.forEach(i)};i(t)}r(t,i){switch(e.$Wm.properties[t]=i,i.scope){case 1:e.$Xm.properties[t]=i;break;case 2:e.$Ym.properties[t]=i;break;case 6:e.$Zm.properties[t]=i;break;case 3:e.$1m.properties[t]=i;break;case 4:e.$2m.properties[t]=i;break;case 5:e.$2m.properties[t]=i,this.g.properties[t]=i;break}}s(t,i){switch(delete e.$Wm.properties[t],i.scope){case 1:delete e.$Xm.properties[t];break;case 2:delete e.$Ym.properties[t];break;case 6:delete e.$Zm.properties[t];break;case 3:delete e.$1m.properties[t];break;case 4:case 5:delete e.$2m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const i=`[${t}]`,r={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$3m};this.w(i,r),e.$Wm.properties[i]=r,e.$Xm.properties[i]=r,e.$Ym.properties[i]=r,e.$Zm.properties[i]=r,e.$1m.properties[i]=r,e.$2m.properties[i]=r}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$3m};e.$Wm.patternProperties[e.$5m]=t,e.$Xm.patternProperties[e.$5m]=t,e.$Ym.patternProperties[e.$5m]=t,e.$Zm.patternProperties[e.$5m]=t,e.$1m.patternProperties[e.$5m]=t,e.$2m.patternProperties[e.$5m]=t,this.i.fire()}w(t,i){const r=this.a.get(t);let n=r?.value,s=r?.source;a.$ne(n)&&(n=i.defaultDefaultValue,s=void 0),a.$ne(n)&&(n=u(i.type)),i.default=n,i.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",m=new RegExp(h,"g");e.$5m=`^(${h})+$`,e.$6m=new RegExp(e.$5m);function $(E){const t=[];if(e.$6m.test(E)){let i=m.exec(E);for(;i?.length;){const r=i[1].trim();r&&t.push(r),i=m.exec(E)}}return(0,y.$of)(t)}e.$7m=$;function o(E){return E.reduce((t,i)=>`${t}[${i}]`,"")}e.$8m=o;function u(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$9m=u;const l=new w;b.$Qm.add(e.$Vm.Configuration,l);function g(E,t){return E.trim()?e.$6m.test(E)?I.localize(7,null,E):l.getConfigurationProperties()[E]!==void 0?I.localize(8,null,E):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,E,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$0m=g;function D(){const E=[],t=l.getConfigurationProperties();for(const i of Object.keys(t))E.push([i,t[i].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$$m=D}),define(be[115],we([1,0,18,5,72,2,28,22,8,4,24,55,35]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=void 0;function h(i){return Object.isFrozen(i)?i:R.$Fm(i)}class m{constructor(r={},n=[],s=[],c){this.b=r,this.c=n,this.d=s,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof m)return n;const s=new $("");return s.parseRaw(n),s.configurationModel});this.f=r.reduce((n,s)=>s===n?s:n.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,P.$Zh)(this.contents,r):this.contents}inspect(r,n){const s=this.rawConfiguration.getValue(r),c=n?this.rawConfiguration.getOverrideValue(r,n):void 0,f=n?this.rawConfiguration.override(n).getValue(r):s;return{value:s,override:c,merged:f}}getOverrideValue(r,n){const s=this.i(n);return s?r?(0,P.$Zh)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const s of this.overrides)s.identifiers.includes(r)&&n.push(...s.keys);return y.$of(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return y.$of(r)}override(r){let n=this.a.get(r);return n||(n=this.g(r),this.a.set(r,n)),n}merge(...r){const n=R.$Em(this.contents),s=R.$Em(this.overrides),c=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const k of r)if(f.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(n,k.contents);for(const v of k.overrides){const[C]=s.filter(A=>y.$$e(A.identifiers,v.identifiers));C?(this.h(C.contents,v.contents),C.keys.push(...v.keys),C.keys=y.$of(C.keys)):s.push(R.$Em(v))}for(const v of k.keys)c.indexOf(v)===-1&&c.push(v)}return new m(n,c,s,f.every(k=>k instanceof m)?void 0:f)}g(r){const n=this.i(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const c of y.$of([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[c];const k=n[c];k&&(typeof f=="object"&&typeof k=="object"?(f=R.$Em(f),this.h(f,k)):f=k),s[c]=f}return new m(s,this.keys,this.overrides)}h(r,n){for(const s of Object.keys(n)){if(s in r&&b.$ie(r[s])&&b.$ie(n[s])){this.h(r[s],n[s]);continue}r[s]=R.$Em(n[s])}}i(r){let n=null,s=null;const c=f=>{f&&(s?this.h(s,f):s=R.$Em(f))};for(const f of this.overrides)y.$$e(f.identifiers,[r])?n=f.contents:f.identifiers.includes(r)&&c(f.contents);return c(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,n){this.j(r,n,!0)}setValue(r,n){this.j(r,n,!1)}removeValue(r){const n=this.keys.indexOf(r);n!==-1&&(this.keys.splice(n,1),(0,P.$Yh)(this.contents,r),p.$6m.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>y.$$e(s.identifiers,(0,p.$7m)(r))),1))}j(r,n,s){(0,P.$Xh)(this.contents,r,n,c=>console.error(c)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),p.$6m.test(r)&&this.overrides.push({identifiers:(0,p.$7m)(r),keys:Object.keys(this.contents[r]),contents:(0,P.$Wh)(this.contents[r],c=>console.error(c))})}}e.$_m=m;class ${constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!b.$pe(r)){const s=this.g(r);this.parseRaw(s,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:s,keys:c,overrides:f,restricted:k,hasExcludedProperties:v}=this.h(r,n);this.b=new m(s,c,f,v?[r]:void 0),this.c=k||[]}g(r){let n={},s=null,c=[];const f=[],k=[];function v(A){Array.isArray(c)?c.push(A):s!==null&&(c[s]=A)}const C={onObjectBegin:()=>{const A={};v(A),f.push(c),c=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{const A=[];v(A),f.push(c),c=A,s=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:v,onError:(A,M,K)=>{k.push({error:A,offset:M,length:K})}};if(r)try{a.$Bm(r,C),n=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return n}h(r,n){const s=w.$Qm.as(p.$Vm.Configuration).getConfigurationProperties(),c=this.i(r,s,!0,n);r=c.raw;const f=(0,P.$Wh)(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),k=Object.keys(r),v=this.j(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:f,keys:k,overrides:v,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,n,s,c){let f=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:f};const k={},v=[];for(const C in r)if(p.$6m.test(C)&&s){const A=this.i(r[C],n,!1,c);k[C]=A.raw,f=f||A.hasExcludedProperties,v.push(...A.restricted)}else{const A=n[C],M=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&v.push(C),(M===void 0||c.scopes===void 0||c.scopes.includes(M))&&!(c.skipRestricted&&A?.restricted)?k[C]=r[C]:f=!0}return{raw:k,restricted:v,hasExcludedProperties:f}}j(r,n){const s=[];for(const c of Object.keys(r))if(p.$6m.test(c)){const f={};for(const k in r[c])f[k]=r[c][k];s.push({identifiers:(0,p.$7m)(c),keys:Object.keys(f),contents:(0,P.$Wh)(f,n)})}return s}}e.$an=$;class o extends I.$kb{constructor(r,n,s,c){super(),this.f=r,this.g=n,this.h=c,this.c=this.B(new O.$5c),this.onDidChange=this.c.event,this.a=new $(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,f=>f.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&s.isEqual(f.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$bn=o;class u{constructor(r,n,s,c,f,k,v,C,A,M,K,te,he){this.a=r,this.b=n,this.c=s,this.overrideIdentifiers=c,this.d=f,this.f=k,this.g=v,this.h=C,this.i=A,this.j=M,this.k=K,this.l=te,this.m=he}get value(){return h(this.c)}n(r,n,s){const c=r.inspect(n,s);return{get value(){return h(c.value)},get override(){return h(c.override)},get merged(){return h(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(r,n,s,c,f=new m,k=new m,v=new L.$ji,C=new m,A=new L.$ji){this.c=r,this.d=n,this.f=s,this.g=c,this.h=f,this.i=k,this.j=v,this.l=C,this.m=A,this.a=null,this.b=new L.$ji,this.n=null}getValue(r,n,s){return this.q(r,n,s).getValue(r)}updateValue(r,n,s={}){let c;s.resource?(c=this.m.get(s.resource),c||(c=new m,this.m.set(s.resource,c))):c=this.l,n===void 0?c.removeValue(r):c.setValue(r,n),s.resource||(this.a=null)}inspect(r,n,s){const c=this.q(r,n,s),f=this.u(n.resource,s),k=n.resource?this.m.get(n.resource)||this.l:this.l,v=new Set;for(const C of c.overrides)for(const A of C.identifiers)c.getOverrideValue(r,A)!==void 0&&v.add(A);return new u(r,n,c.getValue(r),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,f||void 0,k)}keys(r){const n=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,n){this.j.set(r,n),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const s=[];if(!n){const{added:c,updated:f,removed:k}=E(this.c,r);n=[...c,...f,...k]}for(const c of n)for(const f of(0,p.$7m)(c)){const k=this.c.getKeysForOverrideIdentifier(f),v=r.getKeysForOverrideIdentifier(f),C=[...v.filter(A=>k.indexOf(A)===-1),...k.filter(A=>v.indexOf(A)===-1),...k.filter(A=>!R.$Im(this.c.override(f).getValue(A),r.override(f).getValue(A)))];s.push([f,C])}return this.updateDefaultConfiguration(r),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:s,removed:c}=E(this.d,r),f=[...n,...s,...c];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:s,removed:c,overrides:f}=E(this.applicationConfiguration,r),k=[...n,...s,...c];return k.length&&this.updateApplicationConfiguration(r),{keys:k,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:s,removed:c,overrides:f}=E(this.localUserConfiguration,r),k=[...n,...s,...c];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:s,removed:c,overrides:f}=E(this.remoteUserConfiguration,r),k=[...n,...s,...c];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:s,removed:c,overrides:f}=E(this.workspaceConfiguration,r),k=[...n,...s,...c];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:f}}compareAndUpdateFolderConfiguration(r,n){const s=this.p.get(r),{added:c,updated:f,removed:k,overrides:v}=E(s,n),C=[...c,...f,...k];return(C.length||!s)&&this.updateFolderConfiguration(r,n),{keys:C,overrides:v}}compareAndDeleteFolderConfiguration(r){const n=this.p.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:c,removed:f,overrides:k}=E(n,void 0);return{keys:[...s,...c,...f],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,n,s){let c=this.r(n,s);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}r({resource:r},n){let s=this.s();if(n&&r){const c=n.getFolder(r);c&&(s=this.t(c.uri)||s);const f=this.m.get(r);f&&(s=s.merge(f))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let n=this.b.get(r);if(!n){const s=this.s(),c=this.j.get(r);c?(n=s.merge(c),this.b.set(r,n)):n=s}return n}u(r,n){if(n&&r){const s=n.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,n)=>{const{contents:s,overrides:c,keys:f}=this.j.get(n);return r.push([n,{contents:s,overrides:c,keys:f}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(n=>r.add(n)),this.userConfiguration.keys.forEach(n=>r.add(n)),this.i.keys.forEach(n=>r.add(n)),this.j.forEach(n=>n.keys.forEach(s=>r.add(s))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}w(r){const n=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(c=>n.add(c))),[...n.values()]}static parse(r){const n=this.x(r.defaults),s=this.x(r.policy),c=this.x(r.application),f=this.x(r.user),k=this.x(r.workspace),v=r.folders.reduce((C,A)=>(C.set(d.URI.revive(A[0]),this.x(A[1])),C),new L.$ji);return new l(n,s,c,f,new m,k,v,new m,new L.$ji)}static x(r){return new m(r.contents,r.keys,r.overrides)}}e.$cn=l;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const c of i)c.keys.forEach(f=>r.add(f)),c.overrides.forEach(([f,k])=>{const v=(0,L.$gi)(n,f,new Set);k.forEach(C=>v.add(C))});const s=[];return n.forEach((c,f)=>s.push([f,[...c.values()]])),{keys:[...r.values()],overrides:s}}e.$dn=g;class D{constructor(r,n,s,c){this.change=r,this.f=n,this.g=s,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const f of r.keys)this.affectedKeys.add(f);for(const[,f]of r.overrides)for(const k of f)this.affectedKeys.add(k);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(r,n){const s=this.a+r,c=this.d.indexOf(s);if(c<0)return!1;const f=c+s.length;if(f>=this.d.length)return!1;const k=this.d.charCodeAt(f);if(k!==this.b&&k!==this.c)return!1;if(n){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.f?.workspace):void 0,C=this.g.getValue(r,n,this.h);return!R.$Im(v,C)}return!0}}e.$en=D;function E(i,r){const{added:n,removed:s,updated:c}=t(r?.rawConfiguration,i?.rawConfiguration),f=[],k=i?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const C=v.filter(A=>!k.includes(A));for(const A of C)f.push([A,r.getKeysForOverrideIdentifier(A)])}if(i){const C=k.filter(A=>!v.includes(A));for(const A of C)f.push([A,i.getKeysForOverrideIdentifier(A)])}if(r&&i){for(const C of k)if(v.includes(C)){const A=t({contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)},{contents:r.getOverrideValue(void 0,C)||{},keys:r.getKeysForOverrideIdentifier(C)});f.push([C,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:s,updated:c,overrides:f}}function t(i,r){const n=i?r?i.keys.filter(f=>r.keys.indexOf(f)===-1):[...i.keys]:[],s=r?i?r.keys.filter(f=>i.keys.indexOf(f)===-1):[...r.keys]:[],c=[];if(i&&r){for(const f of r.keys)if(i.keys.indexOf(f)!==-1){const k=(0,P.$Zh)(r.contents,f),v=(0,P.$Zh)(i.contents,f);R.$Im(k,v)||c.push(f)}}return{added:n,removed:s,updated:c}}}),define(be[225],we([1,0,18,5,2,22,8,115,55,12,67,35]),function(ae,e,y,O,a,I,L,R,b,d,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=void 0;class w extends a.$kb{constructor(){super(...arguments),this.a=this.B(new O.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new R.$_m}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.$Qm.as(b.$Vm.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:u})=>this.c(Array.from(o),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,u){this.h(o,p.$Qm.as(b.$Vm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new R.$_m;const o=p.$Qm.as(b.$Vm.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,u){const l=this.f();for(const g of o){const D=l[g],E=u[g];D!==void 0?this.b.addValue(g,D):E?this.b.addValue(g,E.default):this.b.removeValue(g)}}}e.$fn=w;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.$_m}async initialize(){return this.configurationModel}}e.$gn=h;let m=e.$hn=class extends a.$kb{get configurationModel(){return this.b}constructor(o,u,l){super(),this.c=o,this.f=u,this.g=l,this.a=this.B(new O.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new R.$_m}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const u={},l=[],g=p.$Qm.as(b.$Vm.Configuration).getConfigurationProperties();for(const D of o){const E=g[D];if(!E){l.push(D);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}l.push(D),u[E.policy.name]={type:E.type}}}return(0,L.$te)(u)||await this.f.updatePolicyDefinitions(u),l}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const u=p.$Qm.as(b.$Vm.Configuration).getPolicyConfigurations(),l=(0,y.$jf)(o.map(g=>u.get(g)));this.j(l,!0)}j(o,u){this.g.trace("PolicyConfiguration#update",o);const l=p.$Qm.as(b.$Vm.Configuration).getConfigurationProperties(),g=[],D=this.b.isEmpty();for(const E of o){const t=l[E]?.policy?.name;if(t){const i=this.f.getPolicyValue(t);(D?i!==void 0:!(0,I.$Im)(this.b.getValue(E),i))&&g.push([E,i])}else this.b.getValue(E)!==void 0&&g.push([E,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const E=this.b;this.b=new R.$_m;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,i]of g)i===void 0?this.b.removeValue(t):this.b.setValue(t,i);u&&this.a.fire(this.b)}}};e.$hn=m=Re([Ae(1,P.$Sm),Ae(2,d.$Ni)],m)}),define(be[116],we([1,0,14,5,2,19,24,115,225,67]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0;class P extends a.$kb{constructor(w,h,m,$){super(),this.i=w,this.h=this.B(new O.$5c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$fn),this.c=m instanceof d.$Um?new b.$gn:this.B(new b.$hn(this.b,m,$)),this.f=this.B(new R.$bn(this.i,void 0,I.$Wf,h)),this.a=new R.$cn(this.b.configurationModel,this.c.configurationModel,new R.$_m,new R.$_m),this.g=this.B(new y.$Cg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:u})=>this.k(o,u))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,h,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$cn(w,h,new R.$_m,m)}getConfigurationData(){return this.a.toData()}getValue(w,h){const m=typeof w=="string"?w:void 0,$=(0,L.$Sh)(w)?w:(0,L.$Sh)(h)?h:{};return this.a.getValue(m,$,void 0)}updateValue(w,h,m,$){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const h=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(m,h,2)}k(w,h){const m=this.a.toData(),$=this.a.compareAndUpdateDefaultConfiguration(w,h);this.m($,m,7)}l(w){const h=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(w);this.m(m,h,7)}m(w,h,m){const $=new R.$en(w,{data:h},this.a);$.source=m,$.sourceConfig=this.n(m),this.h.fire($)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$in=P}),define(be[117],we([1,0,11,6]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.RemoteAuthorityResolverErrorCode=e.$uk=e.$tk=e.RemoteConnectionType=e.$sk=void 0,e.$sk=(0,O.$lh)("remoteAuthorityResolverService");var a;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(a||(e.RemoteConnectionType=a={}));class I{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$tk=I;class L{constructor(p,w){this.host=p,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$uk=L;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class b extends y.$_{static isNotAvailable(p){return p instanceof b&&p._code===R.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof b&&p._code===R.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof b&&p._code===R.NoResolverFound}static isHandled(p){return p instanceof b&&p.isHandled}constructor(p,w=R.Unknown,h){super(p),this._message=p,this._code=w,this._detail=h,this.isHandled=w===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,b.prototype)}}e.$vk=b;function d(P){const p=P.indexOf("+");return p===-1?P:P.substring(0,p)}e.$wk=d}),define(be[226],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,y.$lh)("IRemoteExtensionsScannerService"),e.$BM="remoteExtensionsScanner"}),define(be[56],we([1,0,13]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function O(d){return d.scheme===y.Schemas.vscodeRemote?d.authority:void 0}e.$xk=O;function a(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$yk=a;function I(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$zk=I;function L(d){const{host:P,port:p}=b(d);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:p}}e.$Ak=L;function R(d,P){let{host:p,port:w}=b(d);return typeof w>"u"&&(w=P),{host:p,port:w}}e.$Bk=R;function b(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const p=d.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const w=d.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:d,port:void 0}}}),define(be[40],we([1,0,17,6,56]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.TargetPlatform=e.ExtensionType=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=void 0,e.$yl="extensions.user.cache",e.$zl="extensions.builtin.cache",e.$Al="undefined_publisher",e.$Bl=["ui","workspace","web"];function I($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$Cl=I,e.$Dl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function($){$[$.System=0]="System",$[$.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function($){$.WIN32_X64="win32-x64",$.WIN32_IA32="win32-ia32",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class b{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,u){if(typeof o>"u"||o===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof o=="string"||typeof u=="string"){const l=typeof o=="string"?o:o.value,g=typeof u=="string"?u:u.value;return y.$Jd(l,g)}return o._lower===u._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$El=b;class d{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const u of o)this.add(u)}add(o){this.c.add(b.toKey(o))}delete(o){return this.c.delete(b.toKey(o))}has(o){return this.c.has(b.toKey(o))}}e.$Fl=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(b.toKey(o))}get(o){return this.c.get(b.toKey(o))}has(o){return this.c.has(b.toKey(o))}set(o,u){this.c.set(b.toKey(o),u)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gl=P;function p($){return w($)}e.$Hl=p;function w($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}e.$Il=w;function h($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}e.$Jl=h;function m($,o){if(o){const u=`onResolveRemoteAuthority:${(0,a.$yk)(o)}`;return!!$.activationEvents?.includes(u)}return!1}e.$Kl=m,e.$Ll=(0,O.$lh)("IBuiltinExtensionsScannerService")}),define(be[227],we([1,0,2,40,16]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;class I extends y.$kb{constructor(R,b,d,P,p){super(),this.a=R,this.b=b,this.c=d,this.f=p,this.B(P.onDidInstallExtensions(w=>this.g(w))),this.B(P.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const b of R)b.local&&this.invalidate(b.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,R)&&await this.i(b);else await this.i(this.a.defaultProfile)}async i(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,O.$yl))}catch(b){(0,a.$5j)(b)!==1&&this.f.error(b)}}}e.$ip=I}),define(be[44],we([1,0,15,11,2,187,55,6,12,35]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0,e.$vo=(0,R.$lh)("requestService");class P{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?E[t]="*****":E[t]=this.b[t];this.a=E}return this.a}}class p extends a.$kb{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,I.localize)(0,null),when:b.$5i.isEqualTo((0,b.$3i)(b.LogLevel.Trace)).serialize()})}async c(E,t,i){const r=`${E} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new P(t.headers??{}));try{const n=await i();return this.a.trace(`${r} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${r} - error`,t.type,(0,O.$8)(n)),n}}}e.$wo=p;function w(D){return D.res.statusCode&&D.res.statusCode>=200&&D.res.statusCode<300||D.res.statusCode===1223}e.$xo=w;function h(D){return D.res.statusCode===204}async function m(D){return h(D)?null:(await(0,y.$Tb)(D.stream)).toString()}e.$yo=m;async function $(D){if(!w(D))throw new Error("Server returned "+D.res.statusCode);return m(D)}e.$zo=$;async function o(D){if(!w(D))throw new Error("Server returned "+D.res.statusCode);if(h(D))return null;const t=(await(0,y.$Tb)(D.stream)).toString();try{return JSON.parse(t)}catch(i){throw i.message+=`:
`+t,i}}e.$Ao=o;function u(D){g(D)}e.$Bo=u;let l;function g(D){const E=d.$Qm.as(L.$Vm.Configuration),t=l;l={id:"http",order:15,title:(0,I.localize)(1,null),type:"object",scope:D,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null),(0,I.localize)(8,null)],default:"override",description:(0,I.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(10,null),restricted:!0}}},E.updateConfigurations({add:[l],remove:t?[t]:[]})}g(1)}),define(be[228],we([1,0,20,13,16,44]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0;let L=e.$RM=class{constructor(b,d){this.a=b,this.b=d}async download(b,d,P=y.CancellationToken.None){if(b.scheme===O.Schemas.file||b.scheme===O.Schemas.vscodeRemote){await this.b.copy(b,d);return}const p={type:"GET",url:b.toString(!0)},w=await this.a.request(p,P);if(w.res.statusCode===200)await this.b.writeFile(d,w.stream);else{const h=await(0,I.$zo)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$RM=L=Re([Ae(0,I.$vo),Ae(1,a.$Oj)],L)}),define(be[229],we([1,0,15,20]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class a{constructor(R){this.a=R}listen(R,b){throw new Error("Invalid listen")}call(R,b,d,P=O.CancellationToken.None){switch(b){case"request":return this.a.request(d[0],P).then(async({res:p,stream:w})=>{const h=await(0,y.$Tb)(w);return[{statusCode:p.statusCode,headers:p.headers},h]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$xq=a;class I{constructor(R){this.a=R}async request(R,b){const[d,P]=await this.a.call("request",[R],b);return{res:d,stream:(0,y.$Vb)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$yq=I}),define(be[230],we([1,0,83,8]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;function a(L,R){return L.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:L.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function I(L,R,b={}){const d=(0,y.parse)(L),P=b.proxyUrl||a(d,R);if(!P)return null;const p=(0,y.parse)(P);if(!/^https?:$/.test(p.protocol||""))return null;const w={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,O.$me)(b.strictSSL)?b.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((h,m)=>{ae(["http-proxy-agent"],h,m)}))(w):new(await new Promise((h,m)=>{ae(["https-proxy-agent"],h,m)}))(w)}e.$zq=I}),define(be[84],we([1,0,51,7,188,20,39,11,3,21,156,205,14,142]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0;let m;async function $(u,l,g,D){return g["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$d?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$pl)(D)&&!g["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$pl)(D)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=w.Promises.withAsyncBody(async(E,t)=>{const i=new I.$bd;let r=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(r=(0,h.$ql)(n,1,120)*1e3);const s=setTimeout(()=>{i.dispose(!0),t(new Error((0,a.localize)(0,null)))},r);try{E(await o(l,i.token))}catch(c){!(0,R.$1)(c)&&!i.token.isCancellationRequested?t(new Error((0,a.localize)(1,null,(0,L.$9h)(c)))):E({})}finally{clearTimeout(s),i.dispose()}})),m)}e.$vl=$;async function o(u,l){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const D=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",D);const E=(0,d.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",i);const r=await(0,P.$gl)(b.OS,i);return u.trace("getUnixShellEnvironment#shell",r),new Promise((n,s)=>{if(l.isCancellationRequested)return s(new R.$2);const c=(0,O.$cc)(r);let f,k;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(f=`& '${process.execPath}' ${v} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,k=["-Login","-Command"]):c==="nu"?(f=`^'${process.execPath}' ${v} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,k=["-i","-l","-c"]):(f=`'${process.execPath}' ${v} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,c==="tcsh"||c==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),f);const C=(0,y.spawn)(r,[...k,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});l.onCancellationRequested(()=>(C.kill(),s(new R.$2))),C.on("error",K=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.$9h)(K)),s(K)});const A=[];C.stdout.on("data",K=>A.push(K));const M=[];C.stderr.on("data",K=>M.push(K)),C.on("close",(K,te)=>{const he=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",he);const ce=Buffer.concat(M).toString("utf8");if(ce.trim()&&u.trace("getUnixShellEnvironment#stderr",ce),K||te)return s(new Error((0,a.localize)(2,null,K,te)));const le=t.exec(he),ge=le?le[1]:"{}";try{const se=JSON.parse(ge);g?se.ELECTRON_RUN_AS_NODE=g:delete se.ELECTRON_RUN_AS_NODE,D?se.ELECTRON_NO_ATTACH_CONSOLE=D:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){u.error("getUnixShellEnvironment#errorCaught",(0,L.$9h)(se)),s(se)}})})}}),define(be[231],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=void 0,e.$pM=(0,y.$lh)("stateReadService"),e.$qM=(0,y.$lh)("stateService")}),define(be[232],we([1,0,14,15,8,25,16,12]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.$rM=e.SaveStrategy=void 0;var b;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(b||(e.SaveStrategy=b={}));class d{constructor(h,m,$,o){this.f=h,this.g=$,this.h=o,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=m===0?void 0:new y.$pg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,m){const $=this.a[h];return(0,a.$pe)($)?m:$}setItem(h,m){this.setItems([{key:h,data:m}])}setItems(h){let m=!1;for(const{key:$,data:o}of h)this.a[$]!==o&&((0,a.$pe)(o)?(0,a.$ne)(this.a[$])||(this.a[$]=void 0,m=!0):(this.a[$]=o,m=!0));m&&this.j()}removeItem(h){(0,a.$ne)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,O.$Ib.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$rM=d;let P=e.$sM=class{constructor(h,m,$,o){this.a=new d(m.stateResource,h,$,o)}async init(){await this.a.init()}getItem(h,m){return this.a.getItem(h,m)}};e.$sM=P=Re([Ae(1,I.$sh),Ae(2,R.$Ni),Ae(3,L.$Oj)],P);class p extends P{setItem(h,m){this.a.setItem(h,m)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$tM=p}),define(be[118],we([1,0,3,29,21]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=void 0;function I(b){if(y.$o===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function L(b,d,P,p,w,h,m,$){const o=Object.create(null);o["common.machineId"]=h,o.sessionID=(0,a.$3e)()+Date.now(),o.commitHash=p,o.version=w,o["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,y.$c)(y.$o),o["common.nodePlatform"]=O.$5b,o["common.nodeArch"]=P,o["common.product"]=$||"desktop",m&&(o["common.msftInternal"]=m);let u=0;const l=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),y.$g&&(o["common.snap"]="true");const g=I(d);return g&&(o["common.platformDetail"]=g),o}e.$Wn=L;function R(b){const d=O.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return b.some(p=>P===p)}e.$Xn=R}),define(be[233],we([1,0,18,11,2,22,16]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var R;(function(d){function P(p,w){return p.callstack<w.callstack?-1:p.callstack>w.callstack?1:0}d.compare=P})(R||(e.ErrorEvent=R={}));class b{constructor(P,p=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new a.$jb,this.c=P,this.d=p;const w=O.$U.addListener(h=>this.j(h));this.h.add((0,a.$ib)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(P){if(!P||(P.detail&&P.detail.stack&&(P=P.detail),O.$_.isErrorNoTelemetry(P)||P instanceof L.$9j||typeof P?.message=="string"&&P.message.includes("Unable to read file")))return;const p=Array.isArray(P.stack)?P.stack.join(`
`):P.stack,w=P.message?P.message:(0,I.$Jm)(P);p&&this.k({msg:w,callstack:p})}k(P){const p=(0,y.$af)(this.g,P,R.compare);p<0?(P.count=1,this.g.splice(~p,0,P)):(this.g[p].count||(this.g[p].count=0),this.g[p].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const P of this.g)this.c.publicLogError2("UnhandledError",P);this.g.length=0}}b.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=b}),define(be[234],we([1,0,2]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class O extends y.$kb{constructor(I,L){super(),this.a=I,this.b=L}async call(I,L,R){switch(L){case"updateTelemetryLevel":{const{telemetryLevel:b}=R;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:d}=R;return this.b?this.b.log(b,d):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${L} not found`)}listen(I,L,R){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$or=O}),define(be[32],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,y.$lh)("telemetryService"),e.$Sk=(0,y.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var O;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var a;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(a||(e.TelemetryConfiguration=a={}))}),define(be[235],we([1,0,26,14,72,13,7,3,4,101,23,104,211,16,27,32]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=void 0;const o=new Map;async function u(t,i){const r=`${t}::${i.join(":")}`,n=o.get(r);if(n)return n;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,f=new Map,k=2e4;function v(A,M,K,te){const he=M.substring(A.length+1);return O.Promises.withAsyncBody(async ce=>{let le;try{le=await P.Promises.readdir(M,{withFileTypes:!0})}catch{ce();return}if(te.count>=k){te.count+=le.length,te.maxReached=!0,ce();return}let ge=le.length;if(ge===0){ce();return}let se=le;te.count+le.length>k&&(te.maxReached=!0,ge=k-te.count,se=le.slice(0,ge)),te.count+=le.length;for(const V of se)if(V.isDirectory()){if(K.includes(V.name)||await v(A,(0,L.$$b)(M,V.name),K,te),--ge===0){ce();return}}else{const ie=V.name.lastIndexOf(".");if(ie>=0){const J=V.name.substring(ie+1);J&&c.set(J,(c.get(J)??0)+1)}for(const J of s)J.relativePathPattern?.test(he)!==!1&&J.filePattern.test(V.name)&&f.set(J.tag,(f.get(J.tag)??0)+1);if(--ge===0){ce();return}}})}const C=O.Promises.withAsyncBody(async A=>{const M={count:0,maxReached:!1};await v(t,t,i,M);const K=await D(t);A({configFiles:l(f),fileTypes:l(c),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:K})});return o.set(r,C),C}e.$dr=u;function l(t){return Array.from(t.entries(),([i,r])=>({name:i,count:r})).sort((i,r)=>r.count-i.count)}function g(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/h.$jk.GB).toFixed(2)}GB (${(y.freemem()/h.$jk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$qm.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.$er=g;async function D(t){try{const i=new Map,r=(0,L.$$b)(t,".vscode","launch.json"),n=await P.Promises.readFile(r),s=[],c=(0,a.$um)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,a.$Dm)(c)==="object"&&c.configurations)for(const f of c.configurations){const k=f.type;k&&(i.has(k)?i.set(k,i.get(k)+1):i.set(k,1))}return l(i)}catch{return[]}}e.$fr=D;let E=e.$gr=class{constructor(i,r){this.c=i,this.d=r}f(i){const r=[];return r.push(`OS Version:       ${i.os}`),r.push(`CPUs:             ${i.cpus}`),r.push(`Memory (System):  ${i.memory}`),r.push(`VM:               ${i.vmHint}`),r.join(`
`)}g(i){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const n=y.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(y.totalmem()/h.$jk.GB).toFixed(2)}GB (${(y.freemem()/h.$jk.GB).toFixed(2)}GB free)`),R.$d||r.push(`Load (avg):       ${y.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(d.$qm.value()*100)}%`),r.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${i.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(i,r){return Promise.all([(0,p.$cr)(i.mainPID),this.k(i)]).then(async n=>{let[s,c]=n,f=this.m(i,s);return r.forEach(k=>{if((0,w.$3l)(k))f+=`
${k.errorMessage}`,c+=`
${k.errorMessage}`;else if(f+=`

Remote: ${k.hostName}`,k.processes&&(f+=`
${this.m(i,k.processes)}`),k.workspaceMetadata){c+=`
|  Remote: ${k.hostName}`;for(const v of Object.keys(k.workspaceMetadata)){const C=k.workspaceMetadata[v];let A=`${C.fileCount} files`;C.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${v}): ${A}`,c+=this.h(C)}}}),{processInfo:f,workspaceInfo:c}})}async getSystemInfo(i,r){const{memory:n,vmHint:s,os:c,cpus:f}=g(),k={os:c,memory:n,cpus:f,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:r};return R.$d||(k.load=`${y.loadavg().map(v=>Math.round(v)).join(", ")}`),R.$f&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(i,r){const n=[];return(0,p.$cr)(i.mainPID).then(async s=>(n.push(""),n.push(this.g(i)),n.push(""),n.push(this.m(i,s)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(i))),r.forEach(c=>{if((0,w.$3l)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.f(c.machineInfo)),c.processes&&n.push(this.m(i,c.processes)),c.workspaceMetadata)for(const f of Object.keys(c.workspaceMetadata)){const k=c.workspaceMetadata[f];let v=`${k.fileCount} files`;k.maxFilesReached&&(v=`more than ${v}`),n.push(`Folder (${f}): ${v}`),n.push(this.h(k))}}),n.push(""),n.push(""),n.join(`
`)))}h(i){const r=[];let s=0;const c=(C,A)=>{const M=` ${C}(${A})`;s+M.length>60?(r.push(f),f="|                 ",s=f.length):s+=M.length,f+=M};let f="|      File types:";const k=10,v=i.fileTypes.length>k?k:i.fileTypes.length;for(let C=0;C<v;C++){const A=i.fileTypes[C];c(A.name,A.count)}if(r.push(f),i.configFiles.length>=0&&(f="|      Conf files:",s=0,i.configFiles.forEach(C=>{c(C.name,C.count)}),r.push(f)),i.launchConfigFiles.length>0){let C="|      Launch Configs:";i.launchConfigFiles.forEach(A=>{const M=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;C+=M}),r.push(C)}return r.join(`
`)}j(i){const r=Math.max(...Object.keys(i).map(n=>n.length));return Object.keys(i).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${i[n]}`).join(`
                  `)}k(i){const r=[],n=[];return i.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const f=b.URI.revive(c);if(f.scheme===I.Schemas.file){const k=f.fsPath;n.push(u(k,["node_modules",".git"]).then(v=>{let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),r.push(`|    Folder (${(0,L.$cc)(k)}): ${C}`),r.push(this.h(v))}).catch(v=>{r.push(`|      Error: Unable to collect workspace stats for folder ${k} (${v.toString()})`)}))}else r.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(i,r){const n=new Map;i.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),i.pidToNames.forEach(({pid:c,name:f})=>n.set(c,f));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(i.mainPID,n,s,r,0),s.join(`
`)}n(i,r,n,s,c){const f=c===0;let k;f?k=s.pid===i?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?k=r.get(s.pid):k=`${"  ".repeat(c)} ${s.name}`;const v=process.platform==="win32"?s.mem:y.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/h.$jk.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(s.children)&&s.children.forEach(C=>this.n(i,r,n,C,c+1))}async getWorkspaceFileExtensions(i){const r=new Set;for(const{uri:n}of i.folders){const s=b.URI.revive(n);if(s.scheme!==I.Schemas.file)continue;const c=s.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(k=>r.add(k.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(i){for(const{uri:r}of i.folders){const n=b.URI.revive(r);if(n.scheme!==I.Schemas.file)continue;const s=n.fsPath;try{const c=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};e.$gr=E=Re([Ae(0,$.$Rk),Ae(1,m.$6i)],E)}),define(be[36],we([1,0,22,8,5,24,56,118,32]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=void 0;class d{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$Yn=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Zn=P,e.$1n=new P;class p{async publicLog(s,c,f){}async publicLogError(s,c,f){}}e.$2n=p,e.$3n="telemetry",e.$4n="extensionTelemetryLog",e.$5n={log:()=>null,flush:()=>Promise.resolve(null)};function w(n,s){return a.Event.debounce(s.onDidChangeConfiguration,(f,k)=>{const v=f?new Set([...f.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:v}},1e3,!0)(f=>{f.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,I.$Uh)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.$6n=w;function h(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry||s.extensionTestsLocationURI)}e.$7n=h;function m(n,s){return!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$8n=m;function $(n){const s=n.getValue(b.$Yk),c=n.getValue(b.$Zk);if(n.getValue(b.$1k)===!1||c===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9n=$;function o(n){const s={},c={},f={};g(n,f);for(let k in f){k=k.length>150?k.substr(k.length-149):k;const v=f[k];typeof v=="number"?c[k]=v:typeof v=="boolean"?c[k]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${v.length}`),s[k]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(s[k]=v)}return{properties:s,measurements:c}}e.$0n=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const s=(0,L.$yk)(n);return u.has(s)?s:"other"}e.$$n=l;function g(n,s,c=0,f){if(n)for(const k of Object.getOwnPropertyNames(n)){const v=n[k],C=f?f+k:k;Array.isArray(v)?s[C]=(0,y.$Jm)(v):v instanceof Date?s[C]=v.toISOString():(0,O.$ie)(v)?c<2?g(v,s,c+1,C+"."):s[C]=(0,y.$Jm)(v):s[C]=v}}function D(n,s){const c=n.msftInternalDomains||[],f=s.getValue("telemetry.internalTesting");return(0,R.$Xn)(c)||f}e.$_n=D;function E(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$ao=E;function t(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let c=n;const f=[];for(const A of s)for(;;){const M=A.exec(n);if(!M)break;f.push([M.index,A.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(c="";;){const A=v.exec(n);if(!A)break;const M=f.some(([K,te])=>A.index<te&&K<v.lastIndex);!k.test(A[0])&&!M&&(c+=n.substring(C,A.index)+"<REDACTED: user-file-path>",C=v.lastIndex)}return C<n.length&&(c+=n.substr(C)),c}function i(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of s)if(c.regex.test(n))return`<REDACTED: ${c.label}>`;return n}function r(n,s){return(0,y.$Gm)(n,c=>{if(c instanceof d||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let f=c.replaceAll("%20"," ");f=t(f,s);for(const k of s)f=f.replace(k,"");return f=i(f),f}})}e.$bo=r}),define(be[37],we([1,0,17,31,40,3,4,11,29,36]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function P(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,y.$Ed)(r.id,n.id)===0}e.$co=P;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(n){const s=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,s,c)}static parse(n){const s=p.exec(n);return s&&s[1]&&s[2]?new w({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,c="undefined"){this.version=s,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$do=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const n=h.exec(r);return n&&n[1]?[o(n[1]),n[2]]:[o(r),void 0]}e.$eo=m;function $(r,n){return`${r}.${n}`}e.$fo=$;function o(r){return r.toLowerCase()}e.$go=o;function u(r,n){return o($(r??a.$Al,n))}e.$ho=u;function l(r,n){const s=[],c=f=>{for(const k of s)if(k.some(v=>P(n(v),n(f))))return k;return null};for(const f of r){const k=c(f);k?k.push(f):s.push([f])}return s}e.$io=l;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$jo=g;function D(r){return{id:new d.$Yn(r.identifier.id),name:new d.$Yn(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$ko=D,e.$lo=new a.$El("pprice.better-merge");function E(r,n){const s=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const f=c.shift();if(f&&s.every(k=>!P(k.identifier,{id:f}))){const k=r.filter(v=>P(v.identifier,{id:f}));k.length===1&&(s.push(k[0]),c.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$mo=E;async function t(r,n){if(!I.$f)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,R.$8)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(r,n){const s=await t(r,n),c=(0,O.$Hn)(s?"alpine":I.$o,b.$6b);return n.debug("ComputeTargetPlatform:",c),c}e.$no=i}),define(be[119],we([1,0,20,11,13,19,53,4,175,31,37,40]),function(ae,e,y,O,a,I,L,R,b,d,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;const w=o=>(0,b.localize)(0,null,o),h=(0,b.localize)(1,null,"ms-dotnettools.csharp");function m(o,u){return u?`${o.publisher}.${o.name}@${o.version}`:`${o.publisher}.${o.name}`}let $=e.$Uo=class{constructor(u,l,g){this.a=u,this.b=l,this.d=g}get f(){}async listExtensions(u,l,g){let D=await this.b.getInstalled(1,g);const E=p.$Dl.map(i=>i.toLowerCase());if(l&&l!==""){if(E.indexOf(l.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}D=D.filter(i=>i.manifest.categories?i.manifest.categories.map(n=>n.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.a.info("Possible Categories: "),E.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),D=D.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let t;for(const i of D)t!==i.identifier.id&&(t=i.identifier.id,this.a.info(m(i.manifest,u)))}async installExtensions(u,l,g,D){const E=[];try{const t=[];u.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const i=[];let r=[];const n=(c,f,k)=>{r.push({id:c,version:f!=="prerelease"?f:void 0,installOptions:{...g,isBuiltin:k,installPreReleaseVersion:f==="prerelease"||g.installPreReleaseVersion}})};for(const c of u)if(c instanceof R.URI)i.push({vsix:c,installOptions:g});else{const[f,k]=(0,P.$eo)(c);n(f,k,!1)}for(const c of l)if(c instanceof R.URI)i.push({vsix:c,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,k]=(0,P.$eo)(c);n(f,k,!0)}const s=await this.b.getInstalled(1,g.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:c,installOptions:f})=>{try{const k=await this.g(c,f,D,s);k&&t.push(k)}catch(k){this.a.error(k),E.push(c.toString())}})),r.length&&(r=r.filter(({id:c,version:f})=>{const k=s.find(v=>(0,P.$co)(v.identifier,{id:c}));if(k){if(!D&&(!f||f==="prerelease"&&k.preRelease))return this.a.info((0,b.localize)(5,null,c,k.manifest.version,c)),!1;if(f&&k.manifest.version===f)return this.a.info((0,b.localize)(6,null,`${c}@${f}`)),!1}return!0}),r.length)){const c=await this.h(r);await Promise.all(r.map(async f=>{const k=c.get(f.id.toLowerCase());if(k)try{const v=await this.j(f,k,s);v&&t.push(v)}catch(v){this.a.error(v.message||v.stack||v),E.push(f.id)}else this.a.error(`${w(f.version?`${f.id}@${f.version}`:f.id)}
${h}`),E.push(f.id)}))}}catch(t){throw this.a.error((0,b.localize)(7,null,(0,O.$8)(t))),t}if(E.length)throw new Error((0,b.localize)(8,null,E.join(", ")))}async g(u,l,g,D){const E=await this.b.getManifest(u);if(!E)throw new Error("Invalid vsix");if(await this.l(E,g,l.profileLocation,D))try{return await this.b.install(u,l),this.a.info((0,b.localize)(9,null,(0,I.$3f)(u))),E}catch(i){if((0,O.$1)(i))return this.a.info((0,b.localize)(10,null,(0,I.$3f)(u))),null;throw i}return null}async h(u){const l=new Map,g=u.some(t=>t.installOptions.installPreReleaseVersion),D=await this.b.getTargetPlatform(),E=[];for(const t of u)d.$Bn.test(t.id)&&E.push({...t,preRelease:g});if(E.length){const t=await this.d.getExtensions(E,{targetPlatform:D},y.CancellationToken.None);for(const i of t)l.set(i.identifier.id.toLowerCase(),i)}return l}async j({id:u,version:l,installOptions:g},D,E){const t=await this.d.getManifest(D,y.CancellationToken.None);if(t&&!this.k(t))return null;const i=E.find(r=>(0,P.$co)(r.identifier,D.identifier));if(i){if(D.version===i.manifest.version)return this.a.info((0,b.localize)(11,null,l?`${u}@${l}`:u)),null;this.a.info((0,b.localize)(12,null,u,D.version))}try{g.isBuiltin?this.a.info(l?(0,b.localize)(13,null,u,l):(0,b.localize)(14,null,u)):this.a.info(l?(0,b.localize)(15,null,u,l):(0,b.localize)(16,null,u));const r=await this.b.installFromGallery(D,{...g,installGivenVersion:!!l});return this.a.info((0,b.localize)(17,null,u,r.manifest.version)),t}catch(r){if((0,O.$1)(r))return this.a.info((0,b.localize)(18,null,u)),null;throw r}}k(u){return!0}async l(u,l,g,D){if(!l){const E={id:(0,P.$ho)(u.publisher,u.name)},t=D.find(i=>(0,P.$co)(E,i.identifier)&&(0,L.gt)(i.manifest.version,u.version));if(t)return this.a.info((0,b.localize)(19,null,t.identifier.id,t.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,l,g){const D=async t=>{if(t instanceof R.URI){const i=await this.b.getManifest(t);return m(i)}return t},E=[];for(const t of u){const i=await D(t),n=(await this.b.getInstalled(void 0,g)).filter(s=>(0,P.$co)(s.identifier,{id:i}));if(!n.length)throw new Error(`${this.m(i)}
${h}`);if(n.some(s=>s.type===0)){this.a.info((0,b.localize)(20,null,i));return}if(!l&&n.some(s=>s.isBuiltin)){this.a.info((0,b.localize)(21,null,i));return}this.a.info((0,b.localize)(22,null,i));for(const s of n)await this.b.uninstall(s,{profileLocation:g}),E.push(s);this.f?this.a.info((0,b.localize)(23,null,i,this.f)):this.a.info((0,b.localize)(24,null,i))}}async locateExtension(u){const l=await this.b.getInstalled();u.forEach(g=>{l.forEach(D=>{if(D.identifier.id===g&&D.location.scheme===a.Schemas.file){this.a.info(D.location.fsPath);return}})})}m(u){return this.f?(0,b.localize)(25,null,u,this.f):(0,b.localize)(26,null,u)}};e.$Uo=$=Re([Ae(1,d.$On),Ae(2,d.$Mn)],$)}),define(be[236],we([1,0,5,2,28,37,40]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;class R extends O.$kb{constructor(d,P,p,w,h,m,$){super(),this.f=d,this.g=P,this.h=p,this.i=w,this.j=h,this.k=m,this.l=$,this.a=this.B(new y.$5c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$sb),this.m().then(null,o=>$.error(o))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(d=>this.p(d.added))),this.B(this.i.onAddExtensions(d=>this.r(d))),this.B(this.i.onDidAddExtensions(d=>this.s(d))),this.B(this.i.onRemoveExtensions(d=>this.t(d))),this.B(this.i.onDidRemoveExtensions(d=>this.u(d))),this.B(this.k.onDidFilesChange(d=>this.v(d)))}async p(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,O.$hb)(this.k.watch(this.j.extUri.dirname(P.extensionsResource)),this.k.watch(P.extensionsResource))),this.y(P.extensionsResource))))}catch(P){throw this.l.error(P),P}}async r(d){for(const P of d.extensions)this.C(this.F(P.identifier,P.version),d.profileLocation)}async s(d){for(const P of d.extensions){const p=this.F(P.identifier,P.version);d.error?this.D(p,d.profileLocation):this.C(p,d.profileLocation)}}async t(d){for(const P of d.extensions)this.D(this.F(P.identifier,P.version),d.profileLocation)}async u(d){const P=[],p=[];for(const w of d.extensions){const h=this.F(w.identifier,w.version);d.error?this.C(h,d.profileLocation):(this.D(h,d.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",w.identifier.id,w.version),p.push(this.f.scanInstalledExtensionAtLocation(w.location).then(m=>{m?P.push(m):this.l.info("Extension not found at the location",w.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(p),P.length&&await this.z(P)}catch(w){this.l.error(w)}}v(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(d){const P=[],p=[],w=await this.i.scanProfileExtensions(d),h=new Set,m=new Set;for(const[$,o]of this.b)o.has(d)&&m.add($);for(const $ of w){const o=this.F($.identifier,$.version);h.add(o),m.has(o)||(P.push($.identifier),this.C(o,d))}for(const $ of m)if(!h.has($)){const o=this.G($);o&&(p.push(o.identifier),this.D($,d))}(P.length||p.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:p.length?{extensions:p,profileLocation:d}:void 0})}async y(d){const P=await this.i.scanProfileExtensions(d);for(const p of P)this.C(this.F(p.identifier,p.version),d)}async z(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.F(p.identifier,p.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}C(d,P){let p=this.b.get(d);p||this.b.set(d,p=new a.$ki(w=>this.j.extUri.getComparisonKey(w))),p.add(P)}D(d,P){const p=this.b.get(d);p&&p.delete(P),p?.size||this.b.delete(d)}F(d,P){return`${L.$El.toKey(d.id)}@${P}`}G(d){const[P,p]=(0,I.$eo)(d);return p?{identifier:{id:P},version:p}:void 0}}e.$jp=R}),define(be[237],we([1,0,208,36]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=void 0;async function a(I,L,R,b,d,P,p){const w={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${L.nameShort})`};if((0,O.$7n)(L,R)&&(0,O.$9n)(b)===3){const h=await(0,y.$No)(R,d,P);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=p.machineId||h}return w}e.$Oo=a}),define(be[120],we([1,0,85,18,14,2,13,7,23,25,31,37,12,82,4]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;let $=e.$wq=class extends h.$vq{constructor(g,D,E,t){super(E),this.h=g,this.i=t,this.g=this.B(new o(D,t)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(g,D){const t=(await this.g.getLanguagePacks())[D];if(!t){this.i.warn(`No language pack found for ${D}`);return}const i=t.translations[g];return i?m.URI.file(i):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),D=Object.keys(g).map(E=>{const t=g[E];return{...this.f(E,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return D.push(this.f("en","English")),D.sort((E,t)=>E.label.localeCompare(t.label)),D}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const D=await this.g.getLanguagePacks();Object.keys(D).some(E=>D[E]&&D[E].extensions.some(t=>(0,p.$co)(t.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,D]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(D);return!(0,O.$$e)(Object.keys(g),Object.keys(E))}};e.$wq=$=Re([Ae(0,P.$On),Ae(1,d.$th),Ae(2,P.$Mn),Ae(3,w.$Ni)],$);let o=class extends I.$kb{constructor(g,D){super(),this.i=D,this.c={},this.f=(0,R.$$b)(g.userDataPath,"languagepacks.json"),this.g=new a.$yg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(D=>{Object.keys(D).forEach(E=>delete D[E]),this.j(D,...g)}).then(()=>this.c)}j(g,...D){for(const E of D)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.k(g,E);Object.keys(g).forEach(E=>this.l(g[E]))}k(g,D){const E=D.identifier,t=D.manifest.contributes&&D.manifest.contributes.localizations?D.manifest.contributes.localizations:[];for(const i of t)if(D.location.scheme===L.Schemas.file&&u(i)){let r=g[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=r);const n=r.extensions.filter(s=>(0,p.$co)(s.extensionIdentifier,E))[0];n?n.version=D.manifest.version:r.extensions.push({extensionIdentifier:E,version:D.manifest.version});for(const s of i.translations)r.translations[s.id]=(0,R.$$b)(D.location.fsPath,s.path)}}l(g){if(g){const D=(0,y.createHash)("md5");for(const E of g.extensions)D.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);g.hash=D.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let D=null;return b.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(D=g(E),E)).then(E=>{for(const i of Object.keys(E))E[i]||delete E[i];this.c=E,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>D,E=>this.i.error(E))})}};o=Re([Ae(0,d.$th),Ae(1,w.$Ni)],o);function u(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const g of l.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(be[238],we([1,0,11,22,36]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",L="https://mobile.events.data.microsoft.com/ping";async function R(d,P,p){const w=await new Promise((u,l)=>{ae(["@microsoft/1ds-core-js"],u,l)}),h=await new Promise((u,l)=>{ae(["@microsoft/1ds-post-js"],u,l)}),m=new w.AppInsightsCore,$=new h.PostChannel,o={instrumentationKey:d,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(p){o.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:p};o.extensionConfig[$.identifier]=u}return m.initialize(o,[]),m.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class b{constructor(P,p,w,h,m){this.e=P,this.f=p,this.g=w,this.h=m,this.c=I,this.d=L,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(P){if(this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(p=>{P(p)},p=>{(0,y.$X)(p),console.error(p)})}}log(P,p){if(!this.a)return;p=(0,O.$Hm)(p,this.g),p=(0,a.$0n)(p);const w=this.f+"/"+P;try{this.i(h=>{h.pluginVersionString=p?.properties.version??"Unknown",h.track({name:w,baseData:{name:w,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.$lM=b}),define(be[239],we([1,0,2,22,3,17,189,24,55,54,27,35,32,36]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let m=e.$Cq=class{constructor(u,l,g){this.k=l,this.l=g,this.d={},this.i=new y.$jb,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const D of this.f)this.j.push(new RegExp((0,I.$ld)(D),"gi")),D.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$ld)(D.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(D=>{(D.affectsConfiguration(w.$Yk)||D.affectsConfiguration(w.$1k)||D.affectsConfiguration(w.$Zk))&&this.m()}))}setExperimentProperty(u,l){this.d[u]=l}m(){let u=(0,h.$9n)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const g=l.usage?3:l.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,l,g){this.g<l||(g=(0,O.$Hm)(g,this.d),g=(0,h.$bo)(g,this.j),g=(0,O.$Hm)(g,this.c),this.b.forEach(D=>D.log(u,g)))}publicLog(u,l){this.n(u,3,l)}publicLog2(u,l){this.publicLog(u,l)}publicLogError(u,l){this.h&&this.n(u,2,l)}publicLogError2(u,l){this.publicLogError(u,l)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Cq=m=Re([Ae(1,R.$Rh),Ae(2,P.$6i)],m);function $(){const o=(0,L.localize)(0,null,d.default.nameLong),u=d.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=a.$j?"":(0,L.localize)(3,null),g=(0,L.localize)(4,null),D=(0,L.localize)(5,null),E=(0,L.localize)(6,null),t=(0,L.localize)(7,null),i=`
|       | ${g} | ${D} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${o} ${u} ${l}

&nbsp;

${t}
${i}

&nbsp;

${r}
`}p.$Qm.as(b.$Vm.Configuration).registerConfiguration({id:w.$Xk,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[w.$Yk]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:$(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$Qm.as(b.$Vm.Configuration).registerConfiguration({id:w.$Xk,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[w.$1k]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,L.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,L.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${w.$Yk}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[240],we([1,0,24,6,27,32,239,36]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=void 0;let b=e.$lr=class extends L.$Cq{constructor(P,p,w,h){super(P,w,h),this.o=p}publicLog(P,p){if(!(this.o<3))return super.publicLog(P,p)}publicLog2(P,p){return this.publicLog(P,p)}publicLogError(P,p){return this.o<2?Promise.resolve(void 0):super.publicLogError(P,p)}publicLogError2(P,p){return this.publicLogError(P,p)}async updateInjectedTelemetryLevel(P){if(P===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,P):P,this.o===0&&this.dispose()}};e.$lr=b=Re([Ae(2,y.$Rh),Ae(3,a.$6i)],b),e.$mr=new class extends R.$Zn{async updateInjectedTelemetryLevel(){}},e.$nr=(0,O.$mh)(I.$Rk)}),define(be[241],we([1,0,242,238]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=void 0;class a extends O.$lM{constructor(L,R,b,d){const P={sendPOST:(p,w)=>{const h={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const m=y.request(p.urlString,h,$=>{$.on("data",function(o){w($.statusCode??200,$.headers,o.toString())}),$.on("error",function(o){w(0,{})})});m.write(p.data),m.end()}catch{w(0,{})}}};super(L,R,b,d,P)}}e.$mM=a}),define(be[243],we([1,0,11,233]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class a extends O.default{i(){(0,y.setUnexpectedErrorHandler)(R=>console.error(R));const L=[];process.on("unhandledRejection",(R,b)=>{L.push(b),setTimeout(()=>{const d=L.indexOf(b);d>=0&&b.catch(P=>{L.splice(d,1),(0,y.$1)(P)||(console.warn(`rejected promise not handled within 1 second: ${P}`),P.stack&&console.warn(`stack trace: ${P.stack}`),R&&(0,y.$X)(R))})},1e3)}),process.on("rejectionHandled",R=>{const b=L.indexOf(R);b>=0&&L.splice(b,1)}),process.on("uncaughtException",R=>{(0,y.$W)(R)||(0,y.$X)(R)})}}e.default=a}),define(be[121],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(be[122],we([1,0,3,121]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;const a=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(P){this.collections=P,this.a=new Map,this.b=new Map,P.forEach((p,w)=>{this.d(p,w);const h=p.map.entries();let m=h.next();for(;!m.done;){const $=m.value[1],o=m.value[0];let u=this.a.get(o);if(u||(u=[],this.a.set(o,u)),u.length>0&&u[0].type===O.EnvironmentVariableMutatorType.Replace){m=h.next();continue}const l={extensionIdentifier:w,value:$.value,type:$.type,scope:$.scope,variable:$.variable,options:$.options};l.scope||delete l.scope,u.unshift(l),m=h.next()}})}async applyToProcessEnvironment(P,p,w){let h;y.$d&&(h={},Object.keys(P).forEach(m=>h[m.toLowerCase()]=m));for(const[m,$]of this.getVariableMap(p)){const o=y.$d&&h[m.toLowerCase()]||m;for(const u of $){const l=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case O.EnvironmentVariableMutatorType.Append:P[o]=(P[o]||"")+l;break;case O.EnvironmentVariableMutatorType.Prepend:P[o]=l+(P[o]||"");break;case O.EnvironmentVariableMutatorType.Replace:P[o]=l;break}if(u.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${a.get(u.type)}`;P[g]=(P[g]?P[g]+":":"")+m+"="+this.c(l)}}}}c(P){return P.replaceAll(":","\\x3a")}diff(P,p){const w=new Map,h=new Map,m=new Map;if(P.getVariableMap(p).forEach(($,o)=>{const u=this.getVariableMap(p).get(o),l=R($,u);l&&w.set(o,l)}),this.getVariableMap(p).forEach(($,o)=>{const u=P.getVariableMap(p).get(o),l=R($,u);l&&m.set(o,l)}),this.getVariableMap(p).forEach(($,o)=>{const u=P.getVariableMap(p).get(o),l=b($,u);l&&h.set(o,l)}),!(w.size===0&&h.size===0&&m.size===0))return{added:w,changed:h,removed:m}}getVariableMap(P){const p=new Map;for(const w of this.a.values()){const h=w.filter(m=>L(m,P));h.length>0&&p.set(h[0].variable,h)}return p}getDescriptionMap(P){const p=new Map;for(const w of this.b.values()){const h=w.filter(m=>L(m,P,!0));for(const m of h)p.set(m.extensionIdentifier,m.description)}return p}d(P,p){if(!P.descriptionMap)return;const w=P.descriptionMap.entries();let h=w.next();for(;!h.done;){const m=h.value[1],$=h.value[0];let o=this.b.get($);o||(o=[],this.b.set($,o));const u={extensionIdentifier:p,scope:m.scope,description:m.description};u.scope||delete u.scope,o.push(u),h=w.next()}}}e.$3q=I;function L(d,P,p=!1){return d.scope?!!(d.scope.workspaceFolder&&P?.workspaceFolder&&d.scope.workspaceFolder.index===P.workspaceFolder.index):p?P===d.scope:!0}function R(d,P){if(!P)return d;const p=new Set;P.forEach(h=>p.add(h.extensionIdentifier));const w=[];return d.forEach(h=>{p.has(h.extensionIdentifier)||w.push(h)}),w.length===0?void 0:w}function b(d,P){if(!P)return;const p=new Map;P.forEach(h=>p.set(h.extensionIdentifier,h));const w=[];return d.forEach(h=>{const m=p.get(h.extensionIdentifier);m&&(h.type!==m.type||h.value!==m.value||h.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&w.push(m)}),w.length===0?void 0:w}}),define(be[86],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;function y(b){return[...b.entries()]}e.$Wq=y;function O(b){return b?[...b.entries()]:[]}e.$Xq=O;function a(b){return new Map(b)}e.$Yq=a;function I(b){return new Map(b??[])}e.$Zq=I;function L(b){return Array.from(b.entries()).map(d=>[d[0],y(d[1].map),O(d[1].descriptionMap)])}e.$1q=L;function R(b){return new Map(b.map(d=>[d[0],{map:a(d[1]),descriptionMap:I(d[2])}]))}e.$2q=R}),define(be[244],we([1,0,14,20,5,2,12]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let R=e.$Nq=class extends I.$kb{constructor(d,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new a.$5c),this.onCreateRequest=this.g.event,this.b=d===void 0?15e3:d}createRequest(d){return new Promise((P,p)=>{const w=++this.a;this.c.set(w,P),this.g.fire({requestId:w,...d});const h=new O.$bd;(0,y.$sg)(this.b,h.token).then(()=>p(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,I.$ib)(()=>h.cancel())])})}acceptReply(d,P){const p=this.c.get(d);p?(this.c.delete(d),(0,I.$fb)(this.f.get(d)||[]),this.f.delete(d),p(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${d}`)}};e.$Nq=R=Re([Ae(1,L.$Ni)],R)}),define(be[87],we([1,0,6,64,35]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.$Gq=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Fq=void 0,e.$Fq=new O.$Ki("terminalTabFocusMode",!1,!0);var I;(function(E){E.DefaultProfile="terminal.integrated.defaultProfile.",E.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var L;(function(E){E.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",E.AutomationProfileLinux="terminal.integrated.automationProfile.linux",E.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",E.AutomationProfileWindows="terminal.integrated.automationProfile.windows",E.ProfilesWindows="terminal.integrated.profiles.windows",E.ProfilesMacOs="terminal.integrated.profiles.osx",E.ProfilesLinux="terminal.integrated.profiles.linux",E.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",E.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",E.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",E.UseWslProfiles="terminal.integrated.useWslProfiles",E.TabsDefaultColor="terminal.integrated.tabs.defaultColor",E.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",E.TabsEnabled="terminal.integrated.tabs.enabled",E.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",E.TabsHideCondition="terminal.integrated.tabs.hideCondition",E.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",E.TabsShowActions="terminal.integrated.tabs.showActions",E.TabsLocation="terminal.integrated.tabs.location",E.TabsFocusMode="terminal.integrated.tabs.focusMode",E.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",E.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",E.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",E.CopyOnSelection="terminal.integrated.copyOnSelection",E.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",E.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",E.FontFamily="terminal.integrated.fontFamily",E.FontSize="terminal.integrated.fontSize",E.LetterSpacing="terminal.integrated.letterSpacing",E.LineHeight="terminal.integrated.lineHeight",E.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",E.TabStopWidth="terminal.integrated.tabStopWidth",E.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",E.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",E.BellDuration="terminal.integrated.bellDuration",E.FontWeight="terminal.integrated.fontWeight",E.FontWeightBold="terminal.integrated.fontWeightBold",E.CursorBlinking="terminal.integrated.cursorBlinking",E.CursorStyle="terminal.integrated.cursorStyle",E.CursorWidth="terminal.integrated.cursorWidth",E.Scrollback="terminal.integrated.scrollback",E.DetectLocale="terminal.integrated.detectLocale",E.DefaultLocation="terminal.integrated.defaultLocation",E.GpuAcceleration="terminal.integrated.gpuAcceleration",E.TerminalTitleSeparator="terminal.integrated.tabs.separator",E.TerminalTitle="terminal.integrated.tabs.title",E.TerminalDescription="terminal.integrated.tabs.description",E.RightClickBehavior="terminal.integrated.rightClickBehavior",E.Cwd="terminal.integrated.cwd",E.ConfirmOnExit="terminal.integrated.confirmOnExit",E.ConfirmOnKill="terminal.integrated.confirmOnKill",E.EnableBell="terminal.integrated.enableBell",E.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",E.AllowChords="terminal.integrated.allowChords",E.AllowMnemonics="terminal.integrated.allowMnemonics",E.TabFocusMode="terminal.integrated.tabFocusMode",E.EnvMacOs="terminal.integrated.env.osx",E.EnvLinux="terminal.integrated.env.linux",E.EnvWindows="terminal.integrated.env.windows",E.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",E.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",E.ShowExitAlert="terminal.integrated.showExitAlert",E.SplitCwd="terminal.integrated.splitCwd",E.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",E.WordSeparators="terminal.integrated.wordSeparators",E.EnableFileLinks="terminal.integrated.enableFileLinks",E.UnicodeVersion="terminal.integrated.unicodeVersion",E.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",E.LocalEchoEnabled="terminal.integrated.localEchoEnabled",E.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",E.LocalEchoStyle="terminal.integrated.localEchoStyle",E.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",E.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",E.CustomGlyphs="terminal.integrated.customGlyphs",E.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",E.InheritEnv="terminal.integrated.inheritEnv",E.ShowLinkHover="terminal.integrated.showLinkHover",E.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",E.AutoReplies="terminal.integrated.autoReplies",E.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",E.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",E.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",E.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",E.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",E.EnableImages="terminal.integrated.enableImages",E.SmoothScrolling="terminal.integrated.smoothScrolling",E.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",E.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(L||(e.TerminalSettingId=L={}));var R;(function(E){E.PowerShell="pwsh",E.Bash="bash",E.Fish="fish",E.Sh="sh",E.Csh="csh",E.Ksh="ksh",E.Zsh="zsh"})(R||(e.PosixShellType=R={}));var b;(function(E){E.CommandPrompt="cmd",E.PowerShell="pwsh",E.Wsl="wsl",E.GitBash="gitbash"})(b||(e.WindowsShellType=b={}));var d;(function(E){E[E.Api=0]="Api",E[E.Process=1]="Process",E[E.Sequence=2]="Sequence",E[E.Config=3]="Config"})(d||(e.TitleEventSource=d={}));var P;(function(E){E.LocalPty="localPty",E.PtyHost="ptyHost",E.PtyHostWindow="ptyHostWindow",E.Logger="logger",E.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={})),e.$Gq=(0,y.$lh)("ptyService");var p;(function(E){E.Cwd="cwd",E.InitialCwd="initialCwd",E.FixedDimensions="fixedDimensions",E.Title="title",E.ShellType="shellType",E.HasChildProcesses="hasChildProcesses",E.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",E.OverrideDimensions="overrideDimensions",E.FailedShellIntegrationActivation="failedShellIntegrationActivation",E.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={}));var w;(function(E){E[E.BeatInterval=5e3]="BeatInterval",E[E.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",E[E.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",E[E.SecondWaitMultiplier=1]="SecondWaitMultiplier",E[E.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var h;(function(E){E[E.Panel=1]="Panel",E[E.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var m;(function(E){E.TerminalView="view",E.Editor="editor"})(m||(e.TerminalLocationString=m={}));var $;(function(E){E[E.GraceTime=6e4]="GraceTime",E[E.ShortGraceTime=6e3]="ShortGraceTime"})($||(e.LocalReconnectConstants=$={}));var o;(function(E){E[E.HighWatermarkChars=1e5]="HighWatermarkChars",E[E.LowWatermarkChars=5e3]="LowWatermarkChars",E[E.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var u;(function(E){E.GitBash="Git Bash",E.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var l;(function(E){E[E.Off=0]="Off",E[E.FinalTerm=1]="FinalTerm",E[E.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var g;(function(E){E[E.Unknown=0]="Unknown",E[E.Shutdown=1]="Shutdown",E[E.Process=2]="Process",E[E.User=3]="User",E[E.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$Hq={Backend:"workbench.contributions.terminal.processBackend"};class D{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const i=this.b(t.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}a.$Qm.add(e.$Hq.Backend,new D),e.$Iq=(0,y.$lh)("localPtyService"),e.$Jq=(0,y.$lh)("terminalLogService")}),define(be[245],we([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0;function O(L){let R=L;R.includes("\\")&&(R=R.replace(/\\/g,"\\\\"));const b=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return R=R.replace(b,""),`'${R}'`}e.$3L=O;function a(L,R,b){if(!L)return"";if(!R)return L;R.match(/[\/\\]$/)&&(R=R.slice(0,R.length-1));const d=L.replace(/\\/g,"/").toLowerCase(),P=R.replace(/\\/g,"/").toLowerCase();return d.includes(P)?`~${b}${L.slice(R.length+1)}`:L}e.$4L=a;function I(L){return L.match(/^['"].*['"]$/)&&(L=L.substring(1,L.length-1)),y.OS===1&&L&&L[1]===":"?L[0].toUpperCase()+L.substring(1):L}e.$5L=I}),define(be[246],we([1,0,48,4,191,99]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=e.$Oq=void 0;function L(w,h){const m=[{name:null,description:(0,a.localize)(0,null)}];return m.push(...w.map($=>({name:$.profileName,description:R($)}))),h&&m.push(...h.map($=>({name:$.title,description:b($)}))),{values:m.map($=>$.name),markdownDescriptions:m.map($=>$.description)}}e.$Oq=L;function R(w){let h=`$(${I.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$yj.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?h+=`
- args: "${w.args}"`:h+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(h+=`
- overrideName: ${w.overrideName}`),w.color&&(h+=`
- color: ${w.color}`),w.env&&(h+=`
- env: ${JSON.stringify(w.env)}`),h}function b(w){return`$(${I.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$yj.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function d(w,h){if(!w&&!h)return!0;if(typeof w=="string"&&typeof h=="string")return w===h;if(Array.isArray(w)&&Array.isArray(h)){if(w.length!==h.length)return!1;for(let m=0;m<w.length;m++)if(w[m]!==h[m])return!1;return!0}return!1}e.$Pq=d;function P(w,h){if(!w&&!h)return!0;if(!w||!h)return!1;if(I.ThemeIcon.isThemeIcon(w)&&I.ThemeIcon.isThemeIcon(h))return w.id===h.id&&w.color===h.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof h=="object"&&"light"in h&&"dark"in h){const m=w,$=h;if((O.URI.isUri(m.light)||p(m.light))&&(O.URI.isUri(m.dark)||p(m.dark))&&(O.URI.isUri($.light)||p($.light))&&(O.URI.isUri($.dark)||p($.dark)))return m.light.path===$.light.path&&m.dark.path===$.dark.path}if(O.URI.isUri(w)&&O.URI.isUri(h)||p(w)||p(h)){const m=w,$=h;return m.path===$.path&&m.scheme===$.scheme}return!1}e.$Qq=P;function p(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.$Rq=p}),define(be[247],we([1,0,48,3,190,55,35,246]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=e.$Sq=void 0,e.$Sq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Tq={type:"string",enum:Array.from((0,y.$xj)(),o=>o.id),markdownEnumDescriptions:Array.from((0,y.$xj)(),o=>`$(${o.id})`)};const b={args:{description:(0,a.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,a.localize)(1,null),type:"boolean"},icon:{description:(0,a.localize)(2,null),...e.$Tq},color:{description:(0,a.localize)(3,null),...e.$Sq},env:{markdownDescription:(0,a.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},d={type:"object",required:["path"],properties:{path:{description:(0,a.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},P={type:"object",required:["path"],properties:{path:{description:(0,a.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function p(o){const u=o===2?"linux":o===1?"osx":"windows";return(0,a.localize)(7,null,(0,O.$c)(o),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,a.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,a.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,a.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,a.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,a.localize)(12,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,a.localize)(13,null),type:"string"},id:{description:(0,a.localize)(14,null),type:"string"},title:{description:(0,a.localize)(15,null),type:"string"},...b}},{type:"null"},d]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,a.localize)(16,null),type:"string"},id:{description:(0,a.localize)(17,null),type:"string"},title:{description:(0,a.localize)(18,null),type:"string"},...b}},{type:"null"},d]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,a.localize)(19,null),type:"string"},id:{description:(0,a.localize)(20,null),type:"string"},title:{description:(0,a.localize)(21,null),type:"string"},...b}},{type:"null"},d]}},["terminal.integrated.useWslProfiles"]:{description:(0,a.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,a.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,a.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,a.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,a.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){L.$Qm.as(I.$Vm.Configuration).registerConfiguration(w),$()}e.$Uq=h;let m;function $(o,u){const l=L.$Qm.as(I.$Vm.Configuration);let g;o&&(g=(0,R.$Oq)(o?.profiles,u));const D=m;m={id:"terminal",order:100,title:(0,a.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,a.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?g?.values:void 0,markdownEnumDescriptions:o?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,a.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?g?.values:void 0,markdownEnumDescriptions:o?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,a.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?g?.values:void 0,markdownEnumDescriptions:o?.os===1?g?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:D?[D]:[]})}e.$Vq=$}),define(be[248],we([1,0,2,13,106,25,108]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=void 0;let R=e.$GM=class{constructor(d,P){this.a=d,this.b=P}start(d){const P={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},p=(0,L.$Vl)(this.b.args,this.b.isBuilt);p&&(p.break&&p.port?P.debugBrk=p.port:!p.break&&p.port&&(P.debug=p.port));const w=new a.$Ep(O.$1e.asFileUri("bootstrap-fork").fsPath,P),h=new y.$jb;return h.add(w),{client:w,store:h,onDidProcessExit:w.onDidProcessExit}}};e.$GM=R=Re([Ae(1,I.$sh)],R)}),define(be[249],we([1,0,26,13,22,7,3,29,17,8,23,121,86,122]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0;function m(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let s=0;return n&&n.length===4&&(s=parseInt(n[3])),s}e.$4q=m;async function $(n,s,c,f=R.env,k=P.Promises.exists){if(I.$0b(n))return await k(n)?n:void 0;if(s===void 0&&(s=R.cwd()),I.$bc(n)!=="."){const M=I.$$b(s,n);return await k(M)?M:void 0}const C=(0,a.$Lm)(f,"PATH");if(c===void 0&&(0,d.$ge)(C)&&(c=C.split(I.$ic)),c===void 0||c.length===0){const M=I.$$b(s,n);return await k(M)?M:void 0}for(const M of c){let K;if(I.$0b(M)?K=I.$$b(M,n):K=I.$$b(s,M,n),await k(K))return K;if(L.$d){let te=K+".com";if(await k(te)||(te=K+".exe",await k(te)))return te}}const A=I.$$b(s,n);return await k(A)?A:void 0}e.$5q=$;function o(n,s,c,f,k){const v=L.$d&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||v)return;const C=n.args,A=R.$5b==="win32"?I.$cc(n.executable).toLowerCase():I.$cc(n.executable),M=I.$bc(O.$1e.asFileUri("").fsPath);let K;const te={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(te.VSCODE_NONCE=s.shellIntegration.nonce),L.$d){if(A==="pwsh.exe"||A==="powershell.exe")return!C||i(C)?K=g.get(l.WindowsPwsh):t(C)&&(K=g.get(l.WindowsPwshLogin)),K?(K=[...K],K[K.length-1]=(0,b.$id)(K[K.length-1],M,""),{newArgs:K,envMixin:te}):void 0;f.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(A){case"bash":return!C||C.length===0?K=g.get(l.Bash):r(C)&&(te.VSCODE_SHELL_LOGIN="1",u(s,te),K=g.get(l.Bash)),K?(K=[...K],K[K.length-1]=(0,b.$id)(K[K.length-1],M),{newArgs:K,envMixin:te}):void 0;case"fish":{const he=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ce=I.$$b(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return te.XDG_DATA_DIRS=`${he}:${ce}`,u(s,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!C||i(C)?K=g.get(l.Pwsh):t(C)&&(K=g.get(l.PwshLogin)),K?(K=[...K],K[K.length-1]=(0,b.$id)(K[K.length-1],M,""),{newArgs:K,envMixin:te}):void 0;case"zsh":{if(!C||C.length===0?K=g.get(l.Zsh):r(C)?(K=g.get(l.ZshLogin),u(s,te)):(C===g.get(l.Zsh)||C===g.get(l.ZshLogin))&&(K=C),!K)return;K=[...K],K[K.length-1]=(0,b.$id)(K[K.length-1],M);let he;try{he=y.userInfo().username}catch{he="unknown"}const ce=I.$$b(y.tmpdir(),`${he}-${k.applicationName}-zsh`);te.ZDOTDIR=ce;const le=c?.ZDOTDIR??y.homedir()??"~";te.USER_ZDOTDIR=le;const ge=[];return ge.push({source:I.$$b(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.$$b(ce,".zshrc")}),ge.push({source:I.$$b(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.$$b(ce,".zprofile")}),ge.push({source:I.$$b(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.$$b(ce,".zshenv")}),ge.push({source:I.$$b(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.$$b(ce,".zlogin")}),{newArgs:K,envMixin:te,filesToCopy:ge}}}f.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.$6q=o;function u(n,s){if(L.$e&&n.environmentVariableCollections){const c=(0,w.$2q)(n.environmentVariableCollections),k=new h.$3q(c).getVariableMap({workspaceFolder:n.workspaceFolder}).get("PATH"),v=[];if(k)for(const C of k)C.type===p.EnvironmentVariableMutatorType.Prepend&&v.push(C.value);v.length>0&&(s.VSCODE_PATH_PREFIX=v.join(""))}}var l;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(l||(l={}));const g=new Map;g.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(l.Zsh,["-i"]),g.set(l.ZshLogin,["-il"]),g.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const D=["-login","-l"],E=["-nol","-nologo"];function t(n){return typeof n=="string"?D.includes(n.toLowerCase()):n.length===1&&D.includes(n[0].toLowerCase())||n.length===2&&(D.includes(n[0].toLowerCase())||D.includes(n[1].toLowerCase()))&&(E.includes(n[0].toLowerCase())||E.includes(n[1].toLowerCase()))}function i(n){return typeof n=="string"?E.includes(n.toLowerCase()):n.length===0||n?.length===1&&E.includes(n[0].toLowerCase())}function r(n){return n==="string"&&D.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&D.includes(n[0].toLowerCase())}}),define(be[250],we([1,0,51,48,7,3,8,23,102,249,75]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;let p,w=!0;function h(s,c,f,k,v=process.env,C,A,M,K){return C=C||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},I.$d?m(f,C,v,A,k.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:k.getValue("terminal.integrated.profiles.windows"),typeof c=="string"?c:k.getValue("terminal.integrated.defaultProfile.windows"),K,M):i(C,A,f,s&&typeof s=="object"?{...s}:k.getValue(I.$f?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof c=="string"?c:k.getValue(I.$f?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),K,M,v)}e.$7q=h;async function m(s,c,f,k,v,C,A,M,K){const te=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),he=`${process.env.windir}\\${te?"Sysnative":"System32"}`;let ce=!1;(0,d.$4q)()>=16299&&(ce=!0),await l(M);const le=new Map;if(s){le.set("PowerShell",{source:"PowerShell",icon:O.$yj.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${he}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$yj.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),le.set("Command Prompt",{path:`${he}\\cmd.exe`,icon:O.$yj.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$yj.terminalBash,isAutoDetected:!0});const se=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${he}\\cmd.exe`,args:["/K",se],requiresPath:process.env.CMDER_ROOT?se:{path:se,isUnsafe:!0},isAutoDetected:!0})}r(C,le);const ge=await $(le.entries(),A,c,f,k,K);if(s||v)try{const se=await E(`${he}\\${ce?"wsl":"bash"}.exe`,A);for(const V of se)(!C||!(V.profileName in C))&&ge.push(V)}catch{w&&(k?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return ge}async function $(s,c,f,k=process.env,v,C){const A=[];for(const[M,K]of s)A.push(o(M,K,c,f,k,v,C));return(await Promise.all(A)).filter(M=>!!M)}async function o(s,c,f,k,v=process.env,C,A){if(c===null)return;let M,K,te;if("source"in c&&!("path"in c)){const ge=p?.get(c.source);if(!ge)return;M=ge.paths,K=c.args||ge.args,c.icon?te=u(c.icon):ge.icon&&(te=ge.icon)}else M=Array.isArray(c.path)?c.path:[c.path],K=I.$d||Array.isArray(c.args)?c.args:void 0,te=u(c.icon);let he;if(A){const ge=M.map(V=>typeof V=="string"?V:V.path),se=await A(ge);he=new Array(M.length);for(let V=0;V<M.length;V++)typeof M[V]=="string"?he[V]=se[V]:he[V]={path:se[V],isUnsafe:!0}}else he=M.slice();let ce;if(c.requiresPath){let ge;if((0,L.$ge)(c.requiresPath)?ge=c.requiresPath:(ge=c.requiresPath.path,c.requiresPath.isUnsafe&&(ce=ge)),!await k.existsFile(ge))return}const le=await n(s,f,he,k,v,K,c.env,c.overrideName,c.isAutoDetected,ce);if(!le){C?.debug("Terminal profile not validated",s,M);return}return le.isAutoDetected=c.isAutoDetected,le.icon=te,le.color=c.color,le}function u(s){return typeof s=="string"?{id:s}:s}async function l(s){if(p&&!s)return;const[c,f]=await Promise.all([g(),s||D()]);p=new Map,p.set("Git Bash",{profileName:"Git Bash",paths:c,args:["--login","-i"]}),p.set("PowerShell",{profileName:"PowerShell",paths:f,icon:O.$yj.terminalPowershell})}async function g(){const s=new Set,c=await(0,d.$5q)("git.exe");if(c){const v=(0,P.dirname)(c);s.add((0,P.resolve)(v,"../.."))}function f(v,C){C&&v.add(C)}f(s,process.env.ProgramW6432),f(s,process.env.ProgramFiles),f(s,process.env["ProgramFiles(X86)"]),f(s,`${process.env.LocalAppData}\\Program`);const k=[];for(const v of s)k.push(`${v}\\Git\\bin\\bash.exe`,`${v}\\Git\\usr\\bin\\bash.exe`,`${v}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function D(){const s=[];for await(const c of(0,b.$al)())s.push(c.exePath);return s}async function E(s,c){const f=[],k=await new Promise((A,M)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(K,te)=>{if(K)return M("Problem occurred when getting wsl distros");A(te)})});if(!k)return[];const v=new RegExp(/[\r?\n]/),C=k.split(v).filter(A=>A.trim().length>0&&A!=="");for(const A of C){if(A===""||A.startsWith("docker-desktop"))continue;const M=`${A} (WSL)`,K={profileName:M,path:s,args:["-d",`${A}`],isDefault:M===c,icon:t(A),isAutoDetected:!1};f.push(K)}return f}function t(s){return s.includes("Ubuntu")?O.$yj.terminalUbuntu:s.includes("Debian")?O.$yj.terminalDebian:O.$yj.terminalLinux}async function i(s,c,f,k,v,C,A,M){const K=new Map;if(f){const te=(await s.readFile("/etc/shells")).toString(),he=(C||te.split(`
`)).map(le=>{const ge=le.indexOf("#");return ge===-1?le:le.substring(0,ge)}).filter(le=>le.trim().length>0),ce=new Map;for(const le of he){let ge=(0,a.$cc)(le),se=ce.get(ge)||0;se++,se>1&&(ge=`${ge} (${se})`),ce.set(ge,se),K.set(ge,{path:le,isAutoDetected:!0})}}return r(k,K),await $(K.entries(),v,s,M,c,A)}function r(s,c){if(s)for(const[f,k]of Object.entries(s))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?c.delete(f):(k.icon=k.icon||c.get(f)?.icon,c.set(f,k))}async function n(s,c,f,k,v,C,A,M,K,te){if(f.length===0)return Promise.resolve(void 0);const he=f.shift();if(he==="")return n(s,c,f,k,v,C,A,M,K);const ce=typeof he!="string"&&he.isUnsafe,le=typeof he=="string"?he:he.path,ge={profileName:s,path:le,args:C,env:A,overrideName:M,isAutoDetected:K,isDefault:s===c,isUnsafePath:ce,requiresUnsafePath:te};if((0,a.$cc)(le)===le){const V=v.PATH?v.PATH.split(a.$ic):void 0,ie=await(0,d.$5q)(le,void 0,V,void 0,k.existsFile);return ie?(ge.path=ie,ge.isFromPath=!0,ge):n(s,c,f,k,v,C)}return await k.existsFile((0,a.$9b)(le))?ge:n(s,c,f,k,v,C,A,M,K)}}),define(be[251],we([1,0,5,2,3,43,24,12,112,84,244,87,247,250]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let $=0,o=e.$8q=class extends O.$kb{get c(){return this.g(),this.a}get f(){return this.g(),this.b}g(){this.a||([this.a,this.b]=this.O())}constructor(l,g,D,E){super(),this.G=l,this.H=g,this.I=D,this.J=E,this.i=!1,this.j=0,this.k=!0,this.l=!1,this.p=this.B(new y.$5c),this.onPtyHostExit=this.p.event,this.r=this.B(new y.$5c),this.onPtyHostStart=this.r.event,this.s=this.B(new y.$5c),this.onPtyHostUnresponsive=this.s.event,this.t=this.B(new y.$5c),this.onPtyHostResponsive=this.t.event,this.u=this.B(new y.$5c),this.onPtyHostRequestResolveVariables=this.u.event,this.v=this.B(new y.$5c),this.onProcessData=this.v.event,this.w=this.B(new y.$5c),this.onProcessReady=this.w.event,this.y=this.B(new y.$5c),this.onProcessReplay=this.y.event,this.z=this.B(new y.$5c),this.onProcessOrphanQuestion=this.z.event,this.C=this.B(new y.$5c),this.onDidRequestDetach=this.C.event,this.D=this.B(new y.$5c),this.onDidChangeProperty=this.D.event,this.F=this.B(new y.$5c),this.onProcessExit=this.F.event,(0,w.$Uq)(),this.B((0,O.$ib)(()=>this.P())),this.h=this.B(new P.$Nq(void 0,this.I)),this.h.onCreateRequest(this.u.fire,this.u),this.G.onBeforeWindowConnection?y.Event.once(this.G.onBeforeWindowConnection)(()=>this.g()):this.g(),this.G.onWillShutdown?.(()=>this.i=!0)}get L(){return this.H.getValue("terminal.integrated.ignoreProcessNames")}async M(){return this.f.refreshIgnoreProcessNames?.(this.L)}async N(){if(a.$d)return process.env;try{return await(0,d.$vl)(this.H,this.I,{_:[]},process.env)}catch(l){return this.I.error("ptyHost was unable to resolve shell environment",l),{}}}O(){const l=this.G.start($),g=l.client;this.r.fire(),I.ProxyChannel.toService(g.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.Q()),this.Q(!0),this.B(l.onDidProcessExit(t=>{this.p.fire(t.code),!this.i&&!this.l&&(this.j<=m.MaxRestarts?(this.I.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.j++,this.restartPtyHost()):this.I.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const E=I.ProxyChannel.toService(g.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(E.onProcessData(t=>this.v.fire(t))),this.B(E.onProcessReady(t=>this.w.fire(t))),this.B(E.onProcessExit(t=>this.F.fire(t))),this.B(E.onDidChangeProperty(t=>this.D.fire(t))),this.B(E.onProcessReplay(t=>this.y.fire(t))),this.B(E.onProcessOrphanQuestion(t=>this.z.fire(t))),this.B(E.onDidRequestDetach(t=>this.C.fire(t))),this.B(new b.$Mq(this.J,g.getChannel(p.TerminalIpcChannels.Logger))),this.a=l,this.b=E,this.B(this.H.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.M()})),this.M(),[l,E]}dispose(){this.l=!0,super.dispose()}async createProcess(l,g,D,E,t,i,r,n,s,c,f){const k=setTimeout(()=>this.U(),p.HeartbeatConstants.CreateProcessTimeout),v=await this.f.createProcess(l,g,D,E,t,i,r,n,s,c,f);return clearTimeout(k),$=Math.max($,v),v}updateTitle(l,g,D){return this.f.updateTitle(l,g,D)}updateIcon(l,g,D,E){return this.f.updateIcon(l,g,D,E)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,g){return this.f.detachFromProcess(l,g)}listProcesses(){return this.f.listProcesses()}getPerformanceMarks(){return this.f.getPerformanceMarks()}reduceConnectionGraceTime(){return this.f.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,g){return this.f.shutdown(l,g)}input(l,g){return this.f.input(l,g)}processBinary(l,g){return this.f.processBinary(l,g)}resize(l,g,D){return this.f.resize(l,g,D)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,g){return this.f.acknowledgeDataEvent(l,g)}setUnicodeVersion(l,g){return this.f.setUnicodeVersion(l,g)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}getLatency(l){return this.f.getLatency(l)}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,g){return this.f.installAutoReply(l,g)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.f.getDefaultSystemShell(l)}async getProfiles(l,g,D,E=!1){const t=await this.N();return(0,h.$7q)(g,D,E,this.H,t,void 0,this.I,this.X.bind(this,l))}getEnvironment(){return this.f.getEnvironment()}getWslPath(l,g){return this.f.getWslPath(l,g)}getRevivedPtyNewId(l){return this.f.getRevivedPtyNewId(l)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return await this.f.getTerminalLayoutInfo(l)}async requestDetachInstance(l,g){return this.f.requestDetachInstance(l,g)}async acceptDetachInstanceReply(l,g){return this.f.acceptDetachInstanceReply(l,g)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,g){return this.f.reviveTerminalProcesses(l,g)}async refreshProperty(l,g){return this.f.refreshProperty(l,g)}async updateProperty(l,g,D){return this.f.updateProperty(l,g,D)}async restartPtyHost(){this.P(),this.k=!0,this.O()}P(){this.f.shutdownAll?.(),this.c.store.dispose()}Q(l){this.W(),this.m=setTimeout(()=>this.R(),l?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.k||(this.k=!0,this.t.fire())}R(){this.I.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.m=void 0,this.n=setTimeout(()=>this.S(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}S(){this.I.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.n=void 0,this.k&&(this.k=!1,this.s.fire())}U(){this.W(),this.I.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.k&&(this.k=!1,this.s.fire())}W(){this.m&&(clearTimeout(this.m),this.m=void 0),this.n&&(clearTimeout(this.n),this.n=void 0)}X(l,g){return this.h.createRequest({workspaceId:l,originalText:g})}async acceptPtyHostResolvedVariables(l,g){this.h.acceptReply(l,g)}};e.$8q=o=Re([Ae(1,L.$Rh),Ae(2,R.$Ni),Ae(3,R.$Oi)],o)}),define(be[34],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk=(0,y.$lh)("IUriIdentityService")}),define(be[123],we([1,0,34,209,16,19,143,5,2]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class d{constructor(w){this.uri=w,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let P=e.$_q=class{constructor(w){this.g=w,this.c=new b.$jb,this.f=2**16;const h=new Map,m=$=>{let o=h.get($.scheme);return o===void 0&&(o=w.hasProvider($)&&!this.g.hasCapability($,1024),h.set($.scheme,o)),o};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)($=>{h.delete($.scheme)})),this.extUri=new I.$Uf(m),this.d=new L.$$q(($,o)=>this.extUri.compare($,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,I.$7f)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new d(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((m,$)=>m[1].time<$[1].time?1:m[1].time>$[1].time?-1:0);d._clock=0,this.d.clear();const h=this.f*.5;for(let m=0;m<h;m++)this.d.set(w[m][0],w[m][1].touch())}};e.$_q=P=Re([Ae(0,a.$Oj)],P),(0,O.$9q)(y.$lk,P,1)}),define(be[88],we([1,0,193,7,61,19,4,6,13]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,R.$lh)("contextService");function d(n){const s=n;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}e.$vh=d;function P(n){return typeof n?.id=="string"&&!d(n)&&!w(n)}e.$wh=P,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function p(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.$cc)(n)}:s?e.$xh:e.$yh;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$zh=p;function w(n){const s=n;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}e.$Ah=w;function h(n){const s=n;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:L.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}e.$Bh=h;var m;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function $(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$Ch=$;function o(n){const s=n;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$Dh=o;class u{constructor(s,c,f,k,v){this.h=s,this.j=f,this.k=k,this.l=v,this.c=a.$rh.forUris(this.l,()=>!0),this.folders=c}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=a.$rh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=u;class l{constructor(s,c){this.raw=c,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,I.$6f)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=l;function g(n){return new l({uri:n,index:0,name:(0,I.$2f)(n)},{uri:n.toString()})}e.$Gh=g,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,y.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function D(n,s){return I.$Wf.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$Lh=D;function E(n){let s;return L.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===b.Schemas.tmp}e.$Mh=E,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Nh}e.$Oh=t;function i(n,s){return!D(n,s)&&!E(n)}e.$Ph=i;function r(n){return(typeof n=="string"?(0,O.$dc)(n):(0,I.$4f)(n))===e.$Ih}e.$Qh=r}),define(be[33],we([1,0,73,5,2,19,4,192,25,16,6,12,88,28,34,14,21,17,8]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;function g(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}e.$mk=g,e.$nk=(0,P.$lh)("IUserDataProfilesService");function D(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:L.URI.revive(r.location).with({scheme:n}),globalStorageHome:L.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(r.extensionsResource).with({scheme:n}),cacheHome:L.URI.revive(r.cacheHome).with({scheme:n}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.$ok=D;function E(r,n,s,c,f){return{id:r,name:n,location:s,isDefault:!1,shortName:f?.shortName,globalStorageHome:(0,I.$6f)(s,"globalStorage"),settingsResource:(0,I.$6f)(s,"settings.json"),keybindingsResource:(0,I.$6f)(s,"keybindings.json"),tasksResource:(0,I.$6f)(s,"tasks.json"),snippetsHome:(0,I.$6f)(s,"snippets"),extensionsResource:(0,I.$6f)(s,"extensions.json"),cacheHome:(0,I.$6f)(c,r),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}e.$pk=E;let t=e.$qk=class extends a.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,s,c,f){super(),this.n=n,this.r=s,this.s=c,this.t=f,this.f=!0,this.h=this.B(new O.$5c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new O.$5c),this.onWillCreateProfile=this.i.event,this.j=this.B(new O.$5c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new O.$5c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$ji,emptyWindows:new Map},this.profilesHome=(0,I.$6f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,I.$6f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=[];if(this.f)try{for(const k of this.J()){if(!k.name||!(0,l.$ge)(k.name)||!k.location){this.t.warn("Skipping the invalid stored profile",k.location||k.name);continue}n.push(E((0,I.$3f)(k.location),k.name,k.location,this.g,{shortName:k.shortName,useDefaultFlags:k.useDefaultFlags}))}}catch(k){this.t.error(k)}const s=new h.$ji,c=new Map,f=this.w();if(n.unshift({...f,extensionsResource:this.O()??f.extensionsResource,isDefault:!0}),n.length)try{const k=this.M();if(k.workspaces)for(const[v,C]of Object.entries(k.workspaces)){const A=L.URI.parse(v),M=n.find(K=>K.id===C);M&&s.set(A,M)}if(k.emptyWindows)for(const[v,C]of Object.entries(k.emptyWindows)){const A=n.find(M=>M.id===C);A&&c.set(v,A)}}catch(k){this.t.error(k)}this.u={profiles:n,workspaces:s,emptyWindows:c}}return this.u}w(){return E("__default__profile__",(0,R.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(n){const s="Temp",c=new RegExp(`${(0,u.$ld)(s)}\\s(\\d+)`);let f=0;for(const v of this.profiles){const C=c.exec(v.name),A=C?parseInt(C[1]):0;f=A>f?A:f}const k=`${s} ${f+1}`;return this.createProfile((0,y.$_h)((0,o.$3e)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,s,c){return this.createProfile((0,y.$_h)((0,o.$3e)()).toString(16),n,s,c)}async createProfile(n,s,c,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.y(n,s,c);return f&&await this.setProfileForWorkspace(f,k),k}async y(n,s,c){if(!(0,l.$ge)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let f=this.l.get(s);return f||(f=(async()=>{try{const k=this.profiles.find(A=>A.name===s||A.id===n);if(k)return k;const v=E(n,s,(0,I.$6f)(this.profilesHome,n),this.g,c);await this.r.createFolder(v.location);const C=[];return this.i.fire({profile:v,join(A){C.push(A)}}),await $.Promises.settled(C),this.D([v],[],[]),v}finally{this.l.delete(s)}})(),this.l.set(s,f)),f}async updateProfile(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(f=>f.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=E(c.id,s.name??c.name,c.location,this.g,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.D([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(f=>f.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.j.fire({profile:s,join(f){c.push(f)}});try{await Promise.allSettled(c)}catch(f){this.t.error(f)}for(const f of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(f)?.id&&this.v.emptyWindows.delete(f);for(const f of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(f)?.id&&this.v.workspaces.delete(f);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(f){(0,d.$5j)(f)!==1&&this.t.error(f)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(f=>f.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.G(n,c)}unsetWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.z(n);return L.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(n){return(0,w.$vh)(n)?n.uri:(0,w.$Ah)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,n.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,n.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,n.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,n.location)))}D(n,s,c){const f=[...this.profiles,...n],k=[];this.m.profiles=[];for(let v of f)v.isDefault||s.some(C=>v.id===C.id)||(v=c.find(C=>v.id===C.id)??v,v.isTransient?this.m.profiles.push(v):k.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.L(k),this.u=void 0,this.F(n,s,c)}F(n,s,c){this.h.fire({added:n,removed:s,updated:c,all:this.profiles})}G(n,s,c){c=s?.isTransient?!0:c,c||this.G(n,void 0,!0);const f=this.z(n),k=c?this.m:this.v;L.URI.isUri(f)?(k.workspaces.delete(f),s&&k.workspaces.set(f,s)):(k.emptyWindows.delete(f),s&&k.emptyWindows.set(f,s)),c||this.H()}H(){const n={};for(const[c,f]of this.v.workspaces.entries())n[c.toString()]=f.id;const s={};for(const[c,f]of this.v.emptyWindows.entries())s[c.toString()]=f.id;this.N({workspaces:n,emptyWindows:s}),this.u=void 0}I(n){const s={},c=this.w();if(n.workspaces)for(const[k,v]of Object.entries(n.workspaces)){const C=L.URI.parse(v);s[k]=this.s.extUri.isEqual(C,c.location)?c.id:this.s.extUri.basename(C)}const f={};if(n.emptyWindows)for(const[k,v]of Object.entries(n.emptyWindows)){const C=L.URI.parse(v);f[k]=this.s.extUri.isEqual(C,c.location)?c.id:this.s.extUri.basename(C)}return{workspaces:s,emptyWindows:f}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.$qk=t=Re([Ae(0,b.$sh),Ae(1,d.$Oj),Ae(2,m.$lk),Ae(3,p.$Ni)],t);class i extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$rk=i}),define(be[252],we([1,0,18,14,20,11,5,2,3,8,4,173,31,37,40,12,27,32,33]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=void 0;let g=e.$4o=class extends R.$kb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,c,f,k){super(),this.t=n,this.u=s,this.v=c,this.w=f,this.y=k,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.$5c),this.m=this.B(new L.$5c),this.n=this.B(new L.$5c),this.p=this.B(new L.$5c),this.s=[],this.B((0,R.$ib)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.k.forEach(v=>v.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,w.$Jn)(c,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{const f=(await this.installGalleryExtensions([{extension:n,options:s}])).find(({identifier:k})=>(0,h.$co)(k,n.identifier));if(f?.local)return f?.local;throw f?.error?f.error:E(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw E(c)}}async installGalleryExtensions(n){if(!this.t.isEnabled())throw new w.$Nn(p.localize(0,null),w.ExtensionManagementErrorCode.Internal);const s=[],c=[];await Promise.allSettled(n.map(async({extension:f,options:k})=>{try{const v=await this.H(f,!!k?.installGivenVersion,!!k?.installPreReleaseVersion);c.push({...v,options:k})}catch(v){s.push({identifier:f.identifier,operation:2,source:f,error:v})}})),c.length&&s.push(...await this.z(c));for(const f of s)f.error&&(this.v.error("Failed to install extension.",f.identifier.id),this.v.error(f.error),f.source&&!P.URI.isUri(f.source)&&t(this.u,"extensionGallery:install",{extensionData:(0,h.$ko)(f.source),error:f.error}));return s}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.J(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.P(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n){const s=[];return await Promise.allSettled(n.map(async c=>{try{const f=await this.C(c);s.push(...f)}catch(f){s.push({identifier:{id:(0,h.$ho)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:f})}})),this.m.fire(s),s}async C({manifest:n,extension:s,options:c}){const f=c.isApplicationScoped||c.isBuiltin||(0,m.$Hl)(n),k={...c,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:f,profileLocation:f?this.y.defaultProfile.extensionsResource:c.profileLocation??this.Q()},v=he=>`${h.$do.create(he).toString()}${k.profileLocation?`-${k.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const he=this.j.get(v(s));if(he)return this.v.info("Extensions is already requested to install",s.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const C=[],A=[],M=[],K=this.R(n,s,k);P.URI.isUri(s)||this.j.set(v(s),{task:K,waitingTasks:[]}),this.l.fire({identifier:K.identifier,source:s,profileLocation:k.profileLocation}),this.v.info("Installing extension:",K.identifier.id),C.push({task:K,manifest:n});let te=!1;try{if(k.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const ce=await this.G(K.identifier,n,!!k.installOnlyNewlyAddedFromExtensionPack,!!k.installPreReleaseVersion,k.profileLocation),le=await this.getInstalled(void 0,k.profileLocation);for(const{gallery:ge,manifest:se}of(0,y.$of)(ce,({gallery:V})=>V.identifier.id)){te=te||!!se.extensionDependencies?.some(J=>(0,h.$co)({id:J},K.identifier));const V=v(ge),ie=this.j.get(V);if(ie){if(this.D(K,ie.task)){const J=ie.task.identifier;this.v.info("Waiting for already requested installing extension",J.id,K.identifier.id),ie.waitingTasks.push(K),A.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,Z=>Z.some(H=>(0,h.$co)(H.identifier,J)))).then(Z=>{if(this.v.info("Finished waiting for already requested installing extension",J.id,K.identifier.id),!Z.find(B=>(0,h.$co)(B.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!le.some(({identifier:J})=>(0,h.$co)(J,ge.identifier))){const J=this.R(se,ge,{...k,donotIncludePackAndDependencies:!0});this.j.set(V,{task:J,waitingTasks:[K]}),this.l.fire({identifier:J.identifier,source:ge,profileLocation:k.profileLocation}),this.v.info("Installing extension:",J.identifier.id,K.identifier.id),C.push({task:J,manifest:se})}}}catch(ce){if(P.URI.isUri(K.source))(0,y.$nf)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",K.identifier.id,ce.message),(0,y.$nf)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",K.identifier.id,ce.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),ce}const he=C.reduce((ce,{task:le,manifest:ge})=>(ce.set(le.identifier.id.toLowerCase(),{task:le,manifest:ge}),ce),new Map);for(;he.size;){let ce;const le=[...he.values()].filter(({manifest:ge})=>!ge.extensionDependencies?.some(se=>he.has(se.toLowerCase())));le.length?ce=he.size===1?le:le.filter(({task:ge})=>!(ge===K&&!te)):(this.v.info("Found extensions with circular dependencies",le.map(({task:ge})=>ge.identifier.id)),ce=[...he.values()]),await this.F(ce.map(async({task:ge})=>{const se=new Date().getTime();try{const V=await ge.run();if(await this.F(this.s.map(ie=>ie.postInstall(V,ge.source,k,a.CancellationToken.None))),!P.URI.isUri(ge.source)){const ie=ge.operation===3,J=ie?void 0:(new Date().getTime()-ge.source.lastUpdated)/1e3;if(t(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$ko)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-se,durationSinceUpdate:J}),b.$j&&ge.operation!==3)try{await this.t.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}M.push({local:V,identifier:ge.identifier,operation:ge.operation,source:ge.source,context:k.context,profileLocation:ge.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw P.URI.isUri(ge.source)||t(this.u,ge.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$ko)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-se,error:V}),this.v.error("Error while installing the extension:",ge.identifier.id),V}finally{he.delete(ge.identifier.id.toLowerCase())}}))}return A.length&&await this.F(A),M.forEach(({identifier:ce})=>this.v.info("Extension installed successfully:",ce.id)),M}catch(he){if(C.forEach(({task:ce})=>ce.cancel()),M.length)try{const ce=await Promise.allSettled(M.map(({local:le})=>this.S(le,{versionOnly:!0,profileLocation:k.profileLocation}).run()));for(let le=0;le<ce.length;le++){const ge=ce[le],{identifier:se}=M[le];ge.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",se.id):this.v.warn("Rollback: Error while uninstalling extension",se.id,(0,I.$8)(ge.reason))}}catch(ce){this.v.warn("Error while rolling back extensions",(0,I.$8)(ce),M.map(({identifier:le})=>le.id))}return C.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:k.context,profileLocation:k.profileLocation,error:he}))}finally{for(const{task:he}of C)he.source&&!P.URI.isUri(he.source)&&this.j.delete(v(he.source))}}D(n,s){for(const[,{task:c,waitingTasks:f}]of this.j.entries())if(c===n&&(f.includes(s)||f.some(k=>this.D(k,s)))||c===s&&f[0]&&!this.D(n,f[0]))return!1;return!0}async F(n){const s=[],c=[],f=await Promise.allSettled(n);for(const k of f)k.status==="fulfilled"?s.push(k.value):c.push(k.reason);if(c.length)throw D(c);return s}async G(n,s,c,f,k){if(!this.t.isEnabled())return[];const v=await this.getInstalled(void 0,k),C=[],A=[],M=async(K,te)=>{C.push(K);const he=te.extensionDependencies||[],ce=[...he];if(te.extensionPack){const le=c?v.find(ge=>(0,h.$co)(ge.identifier,K)):void 0;for(const ge of te.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(se=>(0,h.$co)({id:se},{id:ge}))||ce.every(se=>!(0,h.$co)({id:se},{id:ge}))&&ce.push(ge)}if(ce.length){const le=ce.filter(ge=>C.every(se=>!(0,h.$co)(se,{id:ge})));if(le.length){const ge=await this.t.getExtensions(le.map(se=>({id:se,preRelease:f})),a.CancellationToken.None);for(const se of ge){if(C.find(J=>(0,h.$co)(J,se.identifier)))continue;const V=he.some(J=>(0,h.$co)({id:J},se.identifier));let ie;try{ie=await this.H(se,!1,f)}catch(J){if(V)throw J;this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id,(0,I.$8)(J));continue}A.push({gallery:ie.extension,manifest:ie.manifest}),await M(ie.extension.identifier,ie.manifest)}}}};return await M(n,s),A}async H(n,s,c){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,h.$co)(n.identifier,C)))throw new w.$Nn(p.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const C=await this.getTargetPlatform();throw new w.$Nn(p.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.$Fn)(C)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const k=await this.I(n,s,c);if(k){if(c&&!s&&n.hasPreReleaseVersion&&!k.properties.isPreReleaseVersion)throw new w.$Nn(p.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],a.CancellationToken.None))[0]?new w.$Nn(p.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Nn(p.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",k.identifier.id);const v=await this.t.getManifest(k,a.CancellationToken.None);if(v===null)throw new w.$Nn(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(v.version!==k.version)throw new w.$Nn(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:v}}async I(n,s,c){const f=await this.getTargetPlatform();let k=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(k=(await this.t.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:f,compatible:!0},a.CancellationToken.None))[0]||null),!k&&await this.t.isExtensionCompatible(n,c,f)&&(k=n),k||(s?k=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:f,compatible:!0},a.CancellationToken.None))[0]||null:k=await this.t.getCompatibleExtension(n,c,f)),k}async J(n,s){const c={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.Q()},f=K=>`${K.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,k=this.k.get(f(n.identifier));if(k)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),k.waitUntilTaskIsFinished();const v=K=>{const te=this.S(K,c);return this.k.set(f(te.extension.identifier),te),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.n.fire({identifier:K.identifier,profileLocation:c.profileLocation,applicationScoped:K.isApplicationScoped}),te},C=(K,te)=>{te?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,c.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,te.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,h.$jo)(K),error:te}),this.p.fire({identifier:K.identifier,error:te?.code,profileLocation:c.profileLocation,applicationScoped:K.isApplicationScoped})},A=[],M=[];try{A.push(v(n));const K=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.N(n,K);for(const he of te)this.k.has(f(he.identifier))?this.v.info("Extensions is already requested to uninstall",he.identifier.id):A.push(v(he))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.L(A.map(te=>te.extension),K,n),await this.F(A.map(async te=>{try{if(await te.run(),await this.F(this.s.map(he=>he.postUninstall(te.extension,c,a.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}C(te.extension)}catch(he){const ce=he instanceof w.$Nn?he:new w.$Nn((0,I.$8)(he),w.ExtensionManagementErrorCode.Internal);throw C(te.extension,ce),ce}finally{M.push(te)}}))}catch(K){const te=K instanceof w.$Nn?K:new w.$Nn((0,I.$8)(K),w.ExtensionManagementErrorCode.Internal);for(const he of A){try{he.cancel()}catch{}M.includes(he)||C(he.extension,te)}throw te}finally{for(const K of A)this.k.delete(f(K.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}L(n,s,c){for(const f of n){const k=this.O(f,s);if(k.length){const v=k.filter(C=>!n.some(A=>(0,h.$co)(A.identifier,C.identifier)));if(v.length)throw new Error(this.M(f,v,c))}}}M(n,s,c){return c===n?s.length===1?p.localize(6,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(7,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(8,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?p.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}N(n,s,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const k=s.filter(C=>!C.isBuiltin&&f.some(A=>(0,h.$co)({id:A},C.identifier))),v=[];for(const C of k)v.push(...this.N(C,s,c));return[...k,...v]}return[]}O(n,s){return s.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(f=>(0,h.$co)({id:f},n.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$4o=g=Re([Ae(0,w.$Mn),Ae(1,u.$Rk),Ae(2,$.$Ni),Ae(3,o.$6i),Ae(4,l.$nk)],g);function D(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$5o=D;function E(r){if(r instanceof w.$Nn)return r;const n=new w.$Nn(r.message,w.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}e.$6o=E;function t(r,n,{extensionData:s,verificationStatus:c,duration:f,error:k,durationSinceUpdate:v}){let C,A;(0,d.$oe)(c)&&(c===!0?c="Verified":(c===!1||(C=w.ExtensionManagementErrorCode.Signature,A=c),c="Unverified")),k&&(k instanceof w.$Nn?(C=k.code,k.code===w.ExtensionManagementErrorCode.Signature&&(A=k.message)):C=w.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...s,verificationStatus:c,success:!k,duration:f,errorcode:C,errorcodeDetail:A,durationSinceUpdate:v})}class i{constructor(){this.d=new O.$qg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.$fg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$fg)(n=>new Promise((s,c)=>{const f=n.onCancellationRequested(()=>{f.dispose(),c(new I.$2)})})),this.d.open()),this.g.cancel()}}e.$7o=i}),define(be[45],we([1,0,14,15,2,5,28,4,31,37,16,6,12,33,34,8,11,32]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class g extends Error{constructor(r,n){super(r),this.code=n}}e.$8o=g,e.$9o=(0,p.$lh)("IExtensionsProfileScannerService");let D=e.$0o=class extends a.$kb{constructor(r,n,s,c,f,k){super(),this.i=r,this.j=n,this.k=s,this.l=c,this.m=f,this.n=k,this.b=this.B(new I.$5c),this.onAddExtensions=this.b.event,this.c=this.B(new I.$5c),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$5c),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$5c),this.onDidRemoveExtensions=this.g.event,this.h=new L.$ji}scanProfileExtensions(r,n){return this.p(r,void 0,n)}async addExtensionsToProfile(r,n){const s=[],c=[];try{return await this.p(n,f=>{const k=[];for(const v of f)r.some(([C])=>(0,d.$co)(C.identifier,v.identifier)&&C.manifest.version!==v.version)?s.push(v):k.push(v);for(const[v,C]of r)if(!k.some(A=>(0,d.$co)(A.identifier,v.identifier)&&A.version===v.manifest.version)){const A={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:C};c.push(A),k.push(A)}return c.length&&this.b.fire({extensions:c,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),k}),c.length&&this.c.fire({extensions:c,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),c}catch(f){throw c.length&&this.c.fire({extensions:c,error:f,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:f,profileLocation:n}),f}}async updateMetadata(r,n){const s=[];return await this.p(n,c=>{const f=[];for(const k of c){const v=r.find(([C])=>(0,d.$co)(C.identifier,k.identifier)&&C.manifest.version===k.version);v&&(k.metadata={...k.metadata,...v[1]},s.push(k)),f.push(k)}return f}),s}async removeExtensionFromProfile(r,n){const s=[];this.f.fire({extensions:s,profileLocation:n});try{await this.p(n,c=>{const f=[];for(const k of c)(0,d.$co)(k.identifier,r.identifier)?s.push(k):f.push(k);return s.length&&this.f.fire({extensions:s,profileLocation:n}),f}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(c){throw s.length&&this.g.fire({extensions:s,error:c,profileLocation:n}),c}}async p(r,n,s){return this.w(r).queue(async()=>{let c=[],f;try{const k=await this.j.readFile(r);f=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,P.$5j)(k)!==1)throw k;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(f=await this.v()),!f&&s?.bailOutWhenFileNotFound)throw new g((0,o.$8)(k),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.r(r);let k=!1;for(const v of f){E(v)||this.r(r);let C;if((0,$.$ge)(v.relativeLocation)&&v.relativeLocation)C=this.t(v.relativeLocation);else if((0,$.$ge)(v.location))C=this.t(v.location),k=!0,v.relativeLocation=v.location,v.location=C.toJSON();else{C=R.URI.revive(v.location);const A=this.s(C);A&&(k=!0,v.relativeLocation=A)}c.push({identifier:v.identifier,location:C,version:v.version,metadata:v.metadata})}k&&await this.j.writeFile(r,O.$Ib.fromString(JSON.stringify(f)))}if(n){c=n(c);const k=c.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.s(v.location),metadata:v.metadata}));await this.j.writeFile(r,O.$Ib.fromString(JSON.stringify(k)))}return c})}r(r){const n=new g(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(r)).value.toString()}catch(f){if((0,P.$5j)(f)===1)return;throw f}this.n.info("Migrating extensions from old default profile location",r.toString());let c;try{const f=JSON.parse(s);Array.isArray(f)&&f.every(k=>E(k))?c=f:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.n.error(f)}if(c)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.$Ib.fromString(JSON.stringify(c)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(f){if((0,P.$5j)(f)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw f}try{await this.j.del(r)}catch(f){(0,P.$5j)(f)!==1&&this.n.error(f)}try{await this.j.del(n)}catch(f){(0,P.$5j)(f)!==1&&this.n.error(f)}return c})()),this.u}w(r){let n=this.h.get(r);return n||(n=new y.$yg,this.h.set(r,n)),n}};e.$0o=D=Re([Ae(1,P.$Oj),Ae(2,h.$nk),Ae(3,m.$lk),Ae(4,u.$Rk),Ae(5,w.$Ni)],D);function E(i){return(0,$.$ie)(i)&&(0,b.$Ln)(i.identifier)&&(t(i.location)||(0,$.$ge)(i.location)&&i.location)&&((0,$.$ne)(i.relativeLocation)||(0,$.$ge)(i.relativeLocation))&&i.version&&(0,$.$ge)(i.version)}function t(i){return i?(0,$.$ge)(i.path)&&(0,$.$ge)(i.scheme):!1}}),define(be[57],we([1,0,18,14,22,15,11,72,166,2,13,7,3,19,53,60,8,4,177,25,37,40,77,16,6,12,27,5,49,45,33,34,207]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.Translations=void 0;var M;(function(se){function V(ie,J){if(ie===J)return!0;const Z=Object.keys(ie),H=new Set;for(const B of Object.keys(J))H.add(B);if(Z.length!==H.size)return!1;for(const B of Z){if(ie[B]!==J[B])return!1;H.delete(B)}return H.size===0}se.equals=V})(M||(e.Translations=M={})),e.$ap=(0,r.$lh)("IExtensionsScannerService");let K=e.$bp=class extends d.$kb{constructor(V,ie,J,Z,H,B,ne,Q,_,T,S,F){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=ie,this.l=J,this.m=Z,this.n=H,this.r=B,this.s=ne,this.t=Q,this.u=_,this.v=T,this.w=S,this.y=F,this.g=this.B(new c.$5c),this.onDidChangeCache=this.g.event,this.h=(0,h.$6f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ce,this.m,this.h)),this.j=this.B(this.y.createInstance(ce,this.m,this.h)),this.k=this.B(this.y.createInstance(he,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,D.$no)(this.s,this.t)),this.z}async scanAllExtensions(V,ie,J){const[Z,H]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(ie)]),B=J?await this.scanExtensionsUnderDevelopment(V,[...Z,...H]):[];return this.G(Z,H,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const ie=[];ie.push(this.H(!!V.useCache,V.language)),ie.push(this.I(V.language,!!V.checkControlFile));const[J,Z]=await Promise.all(ie);return this.F([...J,...Z],0,V,!1)}async scanUserExtensions(V){const ie=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",ie);const J=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,Z=await this.L(ie,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,J),H=V.useCache&&!Z.devMode&&Z.excludeObsolete?this.j:this.k;let B;try{B=await H.scanExtensions(Z)}catch(ne){if(ne instanceof k.$8o&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),B=await H.scanExtensions(Z);else throw ne}return B=await this.F(B,1,V,!0),this.t.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment(V,ie){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const J=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(Z=>Z.scheme===P.Schemas.file).map(async Z=>{const H=await this.L(Z,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(H)).map(ne=>(ne.type=ie.find(Q=>(0,D.$co)(Q.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,H)))}))).flat();return this.F(J,"development",V,!0)}return[]}async scanExistingExtension(V,ie,J){const Z=await this.L(V,!1,ie,!0,J.language,!0,void 0),H=await this.k.scanExtension(Z);return!H||!J.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(V,ie,J){const Z=await this.L(V,!1,ie,!0,J.language,!0,void 0),H=await this.k.scanOneOrMultipleExtensions(Z);return this.F(H,ie,J,!0)}async scanMetadata(V){const ie=(0,h.$6f)(V,"package.json"),J=(await this.s.readFile(ie)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(V,ie){const J=(0,h.$6f)(V,"package.json"),Z=(await this.s.readFile(J)).value.toString(),H=JSON.parse(Z);ie.isMachineScoped=ie.isMachineScoped||void 0,ie.isBuiltin=ie.isBuiltin||void 0,H.__metadata={...H.__metadata,...ie},await this.s.writeFile((0,h.$6f)(V,"package.json"),I.$Ib.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof k.$8o&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(ie=>[ie,ie.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,I.$Ib.fromString(JSON.stringify([])))}catch(ie){(0,i.$5j)(ie)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$8)(ie))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,ie,J,Z){return J.includeAllVersions||(V=this.G(ie===0?V:void 0,ie===1?V:void 0,ie==="development"?V:void 0,await this.getTargetPlatform(),Z)),J.includeInvalid||(V=V.filter(H=>H.isValid)),V.sort((H,B)=>{const ne=p.$cc(H.location.fsPath),Q=p.$cc(B.location.fsPath);return ne<Q?-1:ne>Q?1:0})}G(V,ie,J,Z,H){const B=(Q,_,T)=>{if(Q.isValid&&!_.isValid)return!1;if(Q.isValid===_.isValid){if(H&&m.gt(Q.manifest.version,_.manifest.version))return this.t.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(m.eq(Q.manifest.version,_.manifest.version)){if(Q.type===0)return this.t.debug(`Skipping extension ${_.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===Z)return this.t.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return T?this.t.warn(`Overwriting user extension ${Q.location.path} with ${_.location.path}.`):this.t.debug(`Overwriting user extension ${Q.location.path} with ${_.location.path}.`),!0},ne=new E.$Gl;return V?.forEach(Q=>{const _=ne.get(Q.identifier.id);(!_||B(_,Q,!1))&&ne.set(Q.identifier.id,Q)}),ie?.forEach(Q=>{const _=ne.get(Q.identifier.id);if(!_&&V&&Q.type===0){this.t.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!_||B(_,Q,!1))&&ne.set(Q.identifier.id,Q)}),J?.forEach(Q=>{const _=ne.get(Q.identifier.id);(!_||B(_,Q,!0))&&ne.set(Q.identifier.id,Q),ne.set(Q.identifier.id,Q)}),[...ne.values()]}async H(V,ie){this.t.trace("Started scanning system extensions");const J=await this.L(this.systemExtensionsLocation,!1,0,!0,ie,!0,void 0),H=await(V&&!J.devMode?this.i:this.k).scanExtensions(J);return this.t.trace("Scanned system extensions:",H.length),H}async I(V,ie){const J=this.u.isBuilt?[]:this.v.builtInExtensions;if(!J?.length)return[];this.t.trace("Started scanning dev system extensions");const Z=ie?await this.J():{},H=[],B=u.URI.file(p.$9b(p.$$b(P.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of J){const _=Z[Q.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":H.push((0,h.$6f)(B,Q.name));break;default:H.push(u.URI.file(_));break}}const ne=await Promise.all(H.map(async Q=>this.k.scanExtension(await this.L(Q,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",ne.length),(0,y.$jf)(ne)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,ie,J,Z,H,B,ne){const Q=await this.f(H??w.$q),_=await this.M(V),T=ie&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,S=T?await this.M(T):void 0;return new te(V,_,T,S,ie,ne,J,Z,B,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,H,Q)}async M(V){try{const ie=await this.s.stat(V);if(typeof ie.mtime=="number")return ie.mtime}catch{}}};e.$bp=K=Re([Ae(4,v.$nk),Ae(5,k.$9o),Ae(6,i.$Oj),Ae(7,n.$Ni),Ae(8,g.$sh),Ae(9,s.$6i),Ae(10,C.$lk),Ae(11,r.$kh)],K);class te{constructor(V,ie,J,Z,H,B,ne,Q,_,T,S,F,ee,oe,z){this.location=V,this.mtime=ie,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=Z,this.profile=H,this.profileScanOptions=B,this.type=ne,this.excludeObsolete=Q,this.validate=_,this.productVersion=T,this.productDate=S,this.productCommit=F,this.devMode=ee,this.language=oe,this.translations=z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,ie){return(0,h.$Yf)(V.location,ie.location)&&V.mtime===ie.mtime&&(0,h.$Yf)(V.applicationExtensionslocation,ie.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&V.profile===ie.profile&&a.$Im(V.profileScanOptions,ie.profileScanOptions)&&V.type===ie.type&&V.excludeObsolete===ie.excludeObsolete&&V.validate===ie.validate&&V.productVersion===ie.productVersion&&V.productDate===ie.productDate&&V.productCommit===ie.productCommit&&V.devMode===ie.devMode&&V.language===ie.language&&M.equals(V.translations,ie.translations)}}e.$cp=te;let he=class extends d.$kb{constructor(V,ie,J,Z,H){super(),this.f=V,this.g=ie,this.h=J,this.i=Z,this.j=H}async scanExtensions(V){const ie=V.profile?await this.l(V):await this.k(V);let J={};if(V.excludeObsolete&&V.type===1)try{const Z=(await this.i.readFile(this.f)).value.toString();J=JSON.parse(Z)}catch{}return(0,o.$te)(J)?ie:ie.filter(Z=>!J[D.$do.create(Z).toString()])}async k(V){const ie=await this.i.resolve(V.location);if(!ie.children?.length)return[];const J=await Promise.all(ie.children.map(async Z=>{if(!Z.isDirectory||V.type===1&&(0,h.$3f)(Z.resource).indexOf(".")===0)return null;const H=new te(Z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H)}));return(0,y.$jf)(J).sort((Z,H)=>Z.location.path<H.location.path?-1:1)}async l(V){let ie=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){ie=ie.filter(Z=>!Z.metadata?.isApplicationScoped);const J=await this.m(V.applicationExtensionslocation,Z=>!!Z.metadata?.isBuiltin||!!Z.metadata?.isApplicationScoped,V);ie.push(...J)}return ie}async m(V,ie,J){const Z=await this.g.scanProfileExtensions(V,J.profileScanOptions);if(!Z.length)return[];const H=await Promise.all(Z.map(async B=>{if(ie(B)){const ne=new te(B.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(ne,B.metadata)}return null}));return(0,y.$jf)(H)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,h.$6f)(V.location,"package.json"))){const ie=await this.scanExtension(V);return ie?[ie]:[]}else return await this.scanExtensions(V)}catch(ie){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,L.$8)(ie)),[]}}async scanExtension(V,ie){try{let J=await this.scanExtensionManifest(V.location);if(J){J.publisher||(J.publisher=E.$Al),ie=ie??J.__metadata,delete J.__metadata;const Z=(0,D.$ho)(J.publisher,J.name),H=ie?.id?{id:Z,uuid:ie.id}:{id:Z},B=ie?.isSystem?0:V.type,ne=B===0||!!ie?.isBuiltin;J=await this.n(V.location,J,te.createNlsConfiguration(V));const Q={type:B,identifier:H,manifest:J,location:V.location,isBuiltin:ne,targetPlatform:ie?.targetPlatform??"undefined",metadata:ie,isValid:!0,validations:[]};return V.validate?this.validate(Q,V):Q}}catch(J){V.type!==0&&this.j.error(J)}return null}validate(V,ie){let J=!0;const Z=(0,t.$so)(ie.productVersion,ie.productDate,ie.location,V.manifest,V.isBuiltin);for(const[H,B]of Z)H===$.default.Error&&(J=!1,this.j.error(this.u(ie.location,B)));return V.isValid=J,V.validations=Z,V}async scanExtensionManifest(V){const ie=(0,h.$6f)(V,"package.json");let J;try{J=(await this.i.readFile(ie)).value.toString()}catch(H){return(0,i.$5j)(H)!==1&&this.j.error(this.u(V,(0,l.localize)(0,null,ie.path,H.message))),null}let Z;try{Z=JSON.parse(J)}catch{const B=[];(0,R.$um)(J,B);for(const ne of B)this.j.error(this.u(V,(0,l.localize)(1,null,ie.path,ne.offset,ne.length,(0,b.$$o)(ne.error))));return null}return(0,R.$Dm)(Z)!=="object"?(this.j.error(this.u(V,(0,l.localize)(2,null,ie.path))),null):Z}async n(V,ie,J){const Z=await this.r(V,ie,J);if(Z)try{const H=[],B=await this.s(Z.default,H);if(H.length>0)return H.forEach(Q=>{this.j.error(this.u(V,(0,l.localize)(3,null,Z.default?.path,(0,b.$$o)(Q.error))))}),ie;if((0,R.$Dm)(Z)!=="object")return this.j.error(this.u(V,(0,l.localize)(4,null,Z.default?.path))),ie;const ne=Z.values||Object.create(null);return(0,A.$_o)(ie,ne,B)}catch{}return ie}async r(V,ie,J){const Z=(0,h.$6f)(V,"package.nls.json"),H=(_,T)=>{T.forEach(S=>{this.j.error(this.u(V,(0,l.localize)(5,null,_?.path,(0,b.$$o)(S.error))))})},B=_=>{this.j.error(this.u(V,(0,l.localize)(6,null,_?.path)))},ne=`${ie.publisher}.${ie.name}`,Q=J.translations[ne];if(Q)try{const _=u.URI.file(Q),T=(await this.i.readFile(_)).value.toString(),S=[],F=(0,R.$um)(T,S);return S.length>0?(H(_,S),{values:void 0,default:Z}):(0,R.$Dm)(F)!=="object"?(B(_),{values:void 0,default:Z}):{values:F.contents?F.contents.package:void 0,default:Z}}catch{return{values:void 0,default:Z}}else{if(!await this.i.exists(Z))return;let T;try{T=await this.t(V,J)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const S=(await this.i.readFile(T.localized)).value.toString(),F=[],ee=(0,R.$um)(S,F);return F.length>0?(H(T.localized,F),{values:void 0,default:T.original}):(0,R.$Dm)(ee)!=="object"?(B(T.localized),{values:void 0,default:T.original}):{values:ee,default:T.original}}catch{return{values:void 0,default:T.original}}}}async s(V,ie){if(V)try{const J=(await this.i.readFile(V)).value.toString();return(0,R.$um)(J,ie)}catch{}}t(V,ie){return new Promise((J,Z)=>{const H=B=>{const ne=(0,h.$6f)(V,`package.nls.${B}.json`);this.i.exists(ne).then(Q=>{Q&&J({localized:ne,original:(0,h.$6f)(V,"package.nls.json")});const _=B.lastIndexOf("-");_===-1?J({localized:(0,h.$6f)(V,"package.nls.json"),original:null}):(B=B.substring(0,_),H(B))})};if(ie.devMode||ie.pseudo||!ie.language)return J({localized:(0,h.$6f)(V,"package.nls.json"),original:null});H(ie.language)})}u(V,ie){return`[${V.path}]: ${ie}`}};he=Re([Ae(1,k.$9o),Ae(2,C.$lk),Ae(3,i.$Oj),Ae(4,n.$Ni)],he);let ce=class extends he{constructor(V,ie,J,Z,H,B,ne){super(ie,Z,H,B,ne),this.z=V,this.C=J,this.w=this.B(new O.$pg(3e3)),this.y=this.B(new c.$5c),this.onDidChangeCache=this.y.event}async scanExtensions(V){const ie=this.H(V),J=await this.D(ie);if(this.v=V,J&&J.input&&te.equals(J.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),J.result.map(H=>(H.location=u.URI.revive(H.location),H));const Z=await super.scanExtensions(V);return await this.F(ie,{input:V,result:Z}),Z}async D(V){try{const ie=await this.i.readFile(V),J=JSON.parse(ie.value.toString());return{result:J.result,input:(0,f.$Ug)(J.input)}}catch(ie){this.j.debug("Error while reading the extension cache file:",V.path,(0,L.$8)(ie))}return null}async F(V,ie){try{await this.i.writeFile(V,I.$Ib.fromString(JSON.stringify(ie)))}catch(J){this.j.debug("Error while writing the extension cache file:",V.path,(0,L.$8)(J))}}async G(){if(!this.v)return;const V=this.H(this.v),ie=await this.D(V);if(!ie)return;const J=ie.result,Z=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!a.$Im(Z,J))try{this.j.info("Invalidating Cache",J,Z),await this.i.del(V),this.y.fire()}catch(H){this.j.error(H)}}H(V){const ie=this.I(V);return this.h.extUri.joinPath(ie.cacheHome,V.type===0?E.$zl:E.$yl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(ie=>this.h.extUri.isEqual(V.location,ie.extensionsResource))??this.z:this.C.defaultProfile}};ce=Re([Ae(2,v.$nk),Ae(3,k.$9o),Ae(4,C.$lk),Ae(5,i.$Oj),Ae(6,n.$Ni)],ce);function le(se,V){const ie=(0,D.$fo)(se.manifest.publisher,se.manifest.name);return{id:ie,identifier:new E.$El(ie),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:V,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.$dp=le;class ge extends K{constructor(V,ie,J,Z,H,B,ne,Q,_,T,S,F){super(V,ie,(0,h.$6f)(J,".vscode-oss-dev","extensions","control.json"),Z,H,B,ne,Q,_,T,S,F),this.N=(async()=>{if(w.$t)try{const ee=await this.s.readFile(u.URI.file(w.$t));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$ep=ge}),define(be[253],we([1,0,51,14,39,5,2,13,7,23,12,33]),function(ae,e,y,O,a,I,L,R,b,d,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;let w=e.$gp=class extends L.$kb{constructor(m,$){super(),this.b=m,this.f=$,this.a=new O.$xg(5)}async postUninstall(m){const $=this.g(m,"uninstall");$&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h($.script,"uninstall",$.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(o){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(o)}}));try{await d.Promises.rm(this.j(m))}catch(o){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(o)}}g(m,$){const o=`vscode:${$}`;if(m.location.scheme===R.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[o]=="string"){const u=m.manifest.scripts[o].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${o} should be a node script`),null):{script:(0,b.$$b)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(m,$,o,u,l){return new Promise((g,D)=>{const E=this.i(m,$,o,l);let t;const i=r=>{t&&(clearTimeout(t),t=null),r?D(r):g(void 0)};E.on("error",r=>{i((0,a.$9h)(r)||"Unknown")}),E.on("exit",(r,n)=>{i(r?`post-${$} process exited with code ${r}`:void 0)}),u&&(t=setTimeout(()=>{t=null,E.kill(),D("timed out")},5e3))})}i(m,$,o,u){const l={silent:!0,execArgv:void 0},g=(0,y.fork)(m,[`--type=extension-post-${$}`,...o],l);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const D=I.Event.fromNodeEventEmitter(g.stdout,"data"),E=I.Event.fromNodeEventEmitter(g.stderr,"data");D(r=>this.f.info(u.identifier.id,u.manifest.version,`post-${$}`,r)),E(r=>this.f.error(u.identifier.id,u.manifest.version,`post-${$}`,r));const t=I.Event.any(I.Event.map(D,r=>({data:`%c${r}`,format:[""]})),I.Event.map(E,r=>({data:`%c${r}`,format:["color: red"]})));return I.Event.debounce(t,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(u.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),g}j(m){return(0,b.$$b)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.$gp=w=Re([Ae(0,p.$nk),Ae(1,P.$Ni)],w)}),define(be[124],we([1,0,12,33,34,32,45,16,25,4]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0;let P=e.$xM=class extends L.$0o{constructor(w,h,m,$,o,u){super(d.URI.file(w.extensionsPath),h,m,$,o,u)}};e.$xM=P=Re([Ae(0,b.$th),Ae(1,R.$Oj),Ae(2,O.$nk),Ae(3,a.$lk),Ae(4,I.$Rk),Ae(5,y.$Ni)],P)}),define(be[254],we([1,0,14,5,2,42,8,157,6,33]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ho=e.$Go=e.$Fo=void 0,e.$Fo="__$__isNewStorageMarker",e.$Go="__$__targetStorageMarker",e.$Ho=(0,b.$lh)("storageService");var P;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var p;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var w;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(l){const g=l.get(e.$Go);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.$Io=h;class m extends a.$kb{constructor(g={flushInterval:m.a}){super(),this.j=g,this.b=this.B(new O.$8c),this.onDidChangeValue=this.b.event,this.c=this.B(new O.$8c),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$5c),this.onWillSaveState=this.f.event,this.h=this.B(new y.$Cg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new a.$lb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,y.$Gg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,a.$fb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.J()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,D){const{key:E,external:t}=D;if(E===e.$Go){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:E,target:this.F(g)[E],external:t})}r(g){this.f.fire({reason:g})}get(g,D,E){return this.L(D)?.get(g,E)}getBoolean(g,D,E){return this.L(D)?.getBoolean(g,E)}getNumber(g,D,E){return this.L(D)?.getNumber(g,E)}getObject(g,D,E){return this.L(D)?.getObject(g,E)}storeAll(g,D){this.t(()=>{for(const E of g)this.store(E.key,E.value,E.scope,E.target,D)})}store(g,D,E,t,i=!1){if((0,L.$pe)(D)){this.remove(g,E,i);return}this.t(()=>{this.u(g,E,t),this.L(E)?.set(g,D,i)})}remove(g,D,E=!1){this.t(()=>{this.u(g,D,void 0),this.L(D)?.delete(g,E)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,D){const E=[],t=this.F(g);for(const i of Object.keys(t))t[i]===D&&E.push(i);return E}u(g,D,E,t=!1){const i=this.F(D);typeof E=="number"?i[g]!==E&&(i[g]=E,this.L(D)?.set(e.$Go,JSON.stringify(i),t)):typeof i[g]=="number"&&(delete i[g],this.L(D)?.set(e.$Go,JSON.stringify(i),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const D=this.L(g);return D?h(D):Object.create(null)}isNew(g){return this.getBoolean(e.$Fo,g)===!0}async flush(g=P.NONE){this.f.fire({reason:g});const D=this.L(-1),E=this.L(0),t=this.L(1);switch(g){case P.NONE:await y.Promises.settled([D?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await y.Promises.settled([D?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,D=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return u(g,D,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,D){return this.r(P.NONE),(0,d.$mk)(g)?this.N(g,D):this.O(g,D)}H(g,D){return!(g.id===D.id||$(D)&&$(g))}I(g,D,E){this.t(()=>{const t=new Set;for(const[i,r]of g)t.add(i),D.get(i)!==r&&this.n(E,{key:i,external:!0});for(const[i]of D.items)t.has(i)||this.n(E,{key:i,external:!0})})}}e.$Jo=m,m.a=60*1e3;function $(l){return l.isDefault||!!l.useDefaultFlags?.uiState}e.$Ko=$;class o extends m{constructor(){super(),this.p=this.B(new R.$Do(new R.$Eo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.$Do(new R.$Eo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.$Do(new R.$Eo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.$Lo=o;async function u(l,g,D,E,t,i){const r=M=>{try{return JSON.parse(M)}catch{return M}},n=new Map,s=new Map;l.forEach((M,K)=>{n.set(K,M),s.set(K,r(M))});const c=new Map,f=new Map;g.forEach((M,K)=>{c.set(K,M),f.set(K,r(M))});const k=new Map,v=new Map;D.forEach((M,K)=>{k.set(K,M),v.set(K,r(M))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const C=[];if(n.forEach((M,K)=>{C.push({key:K,value:M})}),console.table(C),console.groupEnd(),console.log(s),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];c.forEach((K,te)=>{M.push({key:te,value:K})}),console.table(M),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${i})`);const A=[];k.forEach((M,K)=>{A.push({key:K,value:M})}),console.table(A),console.groupEnd(),console.log(v)}e.$Mo=u}),define(be[125],we([1,0,18,20,11,3,29,8,4,24,25,31,37,77,16,12,27,44,237,254,32]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=void 0;const E=I.$j?"web":(0,p.$Hn)(I.$o,L.$6b),t="X-Market-Search-Activity-Id";var i;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(...T){return String(T.reduce((S,F)=>S|F,0))}var n;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class v{constructor(S=k){this.d=S}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(S,F=this.d.pageSize){return new v({...this.d,pageNumber:S,pageSize:F})}withFilter(S,...F){const ee=[...this.d.criteria,...F.length?F.map(oe=>({filterType:S,value:oe})):[{filterType:S}]];return new v({...this.d,criteria:ee})}withSortBy(S){return new v({...this.d,sortBy:S})}withSortOrder(S){return new v({...this.d,sortOrder:S})}withFlags(...S){return new v({...this.d,flags:S.reduce((F,ee)=>F|ee,0)})}withAssetTypes(...S){return new v({...this.d,assetTypes:S})}withSource(S){return new v({...this.d,source:S})}get raw(){const{criteria:S,pageNumber:F,pageSize:ee,sortBy:oe,sortOrder:z,flags:q,assetTypes:W}=this.d;return{filters:[{criteria:S,pageNumber:F,pageSize:ee,sortBy:oe,sortOrder:z}],assetTypes:W,flags:q}}get searchText(){const S=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return S&&S.value?S.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(S=>String(S.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(T,S){const F=(T||[]).filter(ee=>ee.statisticName===S)[0];return F?F.value:0}function A(T){const S="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(ee=>ee.assetType.indexOf(S)===0).reduce((ee,oe)=>{const z=te(T,oe.assetType);return z&&ee.push([oe.assetType.substring(S.length),z]),ee},[])}function M(T){if(T.properties){const S=T.properties.filter(oe=>oe.key===s.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=S.filter(oe=>F.test(oe.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return te(T,s.Repository)}function K(T){return{uri:`${T.fallbackAssetUri}/${s.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${s.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function te(T,S){return T.files.filter(ee=>ee.assetType===S)[0]?{uri:`${T.assetUri}/${S}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${S}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function he(T,S){const F=T.properties?T.properties.filter(oe=>oe.key===S):[],ee=F.length>0&&F[0].value;return ee?ee.split(",").map(oe=>(0,w.$go)(oe)):[]}function ce(T){const S=T.properties?T.properties.filter(F=>F.key===c.Engine):[];return S.length>0&&S[0].value||""}function le(T){const S=T.properties?T.properties.filter(F=>F.key===c.PreRelease):[];return S.length>0&&S[0].value==="true"}function ge(T){const S=T.properties?T.properties.filter(ee=>ee.key===c.LocalizedLanguages):[],F=S.length>0&&S[0].value||"";return F?F.split(","):[]}function se(T){return T.properties?.find(S=>S.key===c.SponsorLink)?.value}function V(T){return T.indexOf("preview")!==-1}function ie(T){return T.targetPlatform?(0,p.$Gn)(T.targetPlatform):"undefined"}function J(T){const S=(0,y.$of)(T.versions.map(ie)),F=!!T.tags?.includes(p.$Cn),ee=S.indexOf("web");return F?ee===-1&&S.push("web"):ee!==-1&&S.splice(ee,1),S}function Z(T,S){const F=(0,p.$Kn)(S);for(let ee=0;ee<T.length;ee++){const oe=T[ee];if(oe.version===T[ee-1]?.version){let z=ee;const q=ie(oe);if(q===S)for(;z>0&&T[z-1].version===oe.version;)z--;else if(F.includes(q))for(;z>0&&T[z-1].version===oe.version&&ie(T[z-1])!==S;)z--;z!==ee&&(T.splice(ee,1),T.splice(z,0,oe))}}return T}e.$Po=Z;function H(T,S,F){T.telemetryData={index:S,querySource:F,queryActivityId:T.queryContext?.[t]}}function B(T,S,F,ee){const oe=T.versions[0],z={manifest:te(S,s.Manifest),readme:te(S,s.Details),changelog:te(S,s.Changelog),license:te(S,s.License),repository:M(S),download:K(S),icon:te(S,s.Icon),signature:te(S,s.Signature),coreTranslations:A(S)};return{identifier:{id:(0,w.$ho)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:S.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(oe),description:T.shortDescription||"",installCount:C(T.statistics,"install"),rating:C(T.statistics,"averagerating"),ratingCount:C(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:F,assets:z,properties:{dependencies:he(S,c.Dependency),extensionPack:he(S,c.ExtensionPack),engine:ce(S),localizedLanguages:ge(S),targetPlatform:ie(S),isPreReleaseVersion:le(S)},hasPreReleaseVersion:le(oe),hasReleaseVersion:!0,preview:V(T.flags),isSigned:!!z.signature,queryContext:ee}}let ne=class{constructor(S,F,ee,oe,z,q,W,U){this.k=F,this.l=ee,this.n=oe,this.o=z,this.q=q,this.u=W,this.w=U;const X=W.extensionsGallery,G=X?.servicePPEUrl&&U.getValue("_extensionsGallery.enablePPE");this.d=G?X.servicePPEUrl:X?.serviceUrl,this.g=G?void 0:X?.searchUrl,this.h=X?.controlUrl,this.j=(0,l.$Oo)(W.version,W,this.n,this.w,this.q,S,this.o)}x(S=""){return`${this.d}${S}`}isEnabled(){return!!this.d}async getExtensions(S,F,ee){const oe=O.CancellationToken.isCancellationToken(F)?{}:F,z=O.CancellationToken.isCancellationToken(F)?F:ee,q=[],W=[],U=[],X=[];let G=!0;for(const pe of S){pe.uuid?W.push(pe.uuid):q.push(pe.id);const Se=!!(pe.version||pe.preRelease);U.push({id:pe.id,uuid:pe.uuid,includePreRelease:Se}),pe.version&&X.push({id:pe.id,uuid:pe.uuid,version:pe.version}),G=G&&!!pe.hasPreRelease&&!Se}if(!W.length&&!q.length)return[];let Y=new v().withPage(1,S.length);W.length&&(Y=Y.withFilter(n.ExtensionId,...W)),q.length&&(Y=Y.withFilter(n.ExtensionName,...q)),(oe.queryAllVersions||G)&&(Y=Y.withFlags(Y.flags,i.IncludeVersions)),oe.source&&(Y=Y.withSource(oe.source));const{extensions:ue}=await this.z(Y,{targetPlatform:oe.targetPlatform??E,includePreRelease:U,versions:X,compatible:!!oe.compatible},z);return oe.source&&ue.forEach((pe,Se)=>H(pe,Se,oe.source)),ue}async getCompatibleExtension(S,F,ee){if((0,p.$In)(S.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(S,F,ee))return S;const oe=new v().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,S.identifier.uuid),{extensions:z}=await this.z(oe,{targetPlatform:ee,compatible:!0,includePreRelease:F},O.CancellationToken.None);return z[0]||null}async isExtensionCompatible(S,F,ee){if(!(0,p.$Jn)(S.properties.targetPlatform,S.allTargetPlatforms,ee)||!F&&S.properties.isPreReleaseVersion)return!1;let oe=S.properties.engine;if(!oe){const z=await this.getManifest(S,O.CancellationToken.None);if(!z)throw new Error("Manifest was not found");oe=z.engines.vscode}return(0,h.$uo)(oe,this.u.version,this.u.date)}async y(S,F,ee,oe,z){if(!(0,p.$Jn)(ie(S),oe,z)||F!=="any"&&le(S)!==(F==="prerelease"))return!1;if(ee)try{const q=await this.E(S);if(!(0,h.$uo)(q,this.u.version,this.u.date))return!1}catch(q){return this.l.error(`Error while getting the engine for the version ${S.version}.`,(0,a.$8)(q)),!1}return!0}async query(S,F){let ee=S.text||"";const oe=S.pageSize??50;let z=new v().withPage(1,oe);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Y,ue)=>(z=z.withFilter(n.Category,ue||Y),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Y,ue)=>(z=z.withFilter(n.Tag,ue||Y),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(n.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),z=z.withFilter(n.SearchText,ee)),z=z.withSortBy(0)):S.ids?z=z.withFilter(n.ExtensionId,...S.ids):S.names?z=z.withFilter(n.ExtensionName,...S.names):z=z.withSortBy(4),typeof S.sortBy=="number"&&(z=z.withSortBy(S.sortBy)),typeof S.sortOrder=="number"&&(z=z.withSortOrder(S.sortOrder)),S.source&&(z=z.withSource(S.source));const q=async(G,Y)=>{const{extensions:ue,total:pe}=await this.z(G,{targetPlatform:E,compatible:!1,includePreRelease:!!S.includePreRelease},Y);return ue.forEach((Se,Ce)=>H(Se,(G.pageNumber-1)*G.pageSize+Ce,S.source)),{extensions:ue,total:pe}},{extensions:W,total:U}=await q(z,F),X=async(G,Y)=>{if(Y.isCancellationRequested)throw new a.$2;const{extensions:ue}=await q(z.withPage(G+1),Y);return ue};return{firstPage:W,total:U,pageSize:z.pageSize,getPage:X}}async z(S,F,ee){const oe=S.flags;S.flags&i.IncludeLatestVersionOnly&&S.flags&i.IncludeVersions&&(S=S.withFlags(S.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(S.flags&i.IncludeLatestVersionOnly)&&!(S.flags&i.IncludeVersions)&&(S=S.withFlags(S.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(S=S.withFlags(S.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),S=S.withFlags(S.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:z,total:q,context:W}=await this.B(S,ee);if(!(S.flags&i.IncludeLatestVersionOnly)){const Y=[];for(const ue of z){const pe=await this.A(ue,F,W);pe&&Y.push(pe)}return{extensions:Y,total:q}}const X=[],G=new Map;for(let Y=0;Y<z.length;Y++){const ue=z[Y],pe={id:(0,w.$ho)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},Se=(0,R.$me)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,w.$co)(Fe,pe))?.includePreRelease;if(F.compatible&&(0,p.$In)(J(ue),F.targetPlatform))continue;const Ce=await this.A(ue,F,W);!Ce||Ce.properties.isPreReleaseVersion&&(!Se||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==F.targetPlatform&&Ce.hasPreReleaseVersion?G.set(ue.extensionId,Y):X.push([Y,Ce])}if(G.size){const Y=new Date().getTime(),ue=new v().withFlags(oe&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,G.size).withFilter(n.ExtensionId,...G.keys()),{extensions:pe}=await this.z(ue,F,ee);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Y,count:G.size});for(const Se of pe){const Ce=G.get(Se.identifier.uuid);X.push([Ce,Se])}}return{extensions:X.sort((Y,ue)=>Y[0]-ue[0]).map(([,Y])=>Y),total:q}}async A(S,F,ee){const oe={id:(0,w.$ho)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},z=F.versions?.find(X=>(0,w.$co)(X,oe))?.version,q=(0,R.$me)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(X=>(0,w.$co)(X,oe))?.includePreRelease,W=J(S),U=Z(S.versions,F.targetPlatform);if(F.compatible&&(0,p.$In)(W,F.targetPlatform))return null;for(let X=0;X<U.length;X++){const G=U[X];if(!(z&&G.version!==z)){if(await this.y(G,q?"any":"release",F.compatible,W,F.targetPlatform))return B(S,G,W,ee);if(z&&G.version===z)return null}}return z||F.compatible?null:B(S,S.versions[0],W)}async B(S,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");S=S.withFlags(S.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(i.Unpublished));const ee=await this.j,oe=JSON.stringify(S.raw),z={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(oe.length)},q=new Date().getTime();let W,U,X=0;try{if(W=await this.k.request({type:"POST",url:this.g&&S.criteria.some(Y=>Y.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:oe,headers:z},F),W.res.statusCode&&W.res.statusCode>=400&&W.res.statusCode<500)return{galleryExtensions:[],total:X};const G=await(0,u.$Ao)(W);if(G){const Y=G.results[0],ue=Y.extensions,pe=Y.resultMetadata&&Y.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return X=pe&&pe.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:X,context:{[t]:W.res.headers.activityid}}}return{galleryExtensions:[],total:X}}catch(G){throw U=G,G}finally{this.o.publicLog2("galleryService:query",{...S.telemetryData,requestBodySize:String(oe.length),duration:new Date().getTime()-q,success:!!W&&(0,u.$xo)(W),responseBodySize:W?.res.headers["Content-Length"],statusCode:W?String(W.res.statusCode):void 0,errorCode:U?(0,a.$1)(U)?"canceled":(0,a.$8)(U).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(S,F,ee,oe){if(!this.isEnabled())return;const z=I.$j?this.x(`/itemName/${S}.${F}/version/${ee}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${S}/extensions/${F}/${ee}/stats?statType=${oe}`),q=I.$j?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",U={...await this.j,Accept:q};try{await this.k.request({type:"POST",url:z,headers:U},O.CancellationToken.None)}catch{}}async download(S,F,ee){this.l.trace("ExtensionGalleryService#download",S.identifier.id);const oe=(0,w.$ko)(S),z=new Date().getTime(),q=Y=>this.o.publicLog("galleryService:downloadVSIX",{...oe,duration:Y}),W=ee===2?"install":ee===3?"update":"",U=W?{uri:`${S.assets.download.uri}${b.URI.parse(S.assets.download.uri).query?"&":"?"}${W}=true`,fallbackUri:`${S.assets.download.fallbackUri}${b.URI.parse(S.assets.download.fallbackUri).query?"&":"?"}${W}=true`}:S.assets.download,X=S.queryContext?.[t]?{[t]:S.queryContext[t]}:void 0,G=await this.D(U,X?{headers:X}:void 0);await this.q.writeFile(F,G.stream),q(new Date().getTime()-z)}async downloadSignatureArchive(S,F){if(!S.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",S.identifier.id);const ee=await this.D(S.assets.signature);await this.q.writeFile(F,ee.stream)}async getReadme(S,F){if(S.assets.readme){const ee=await this.D(S.assets.readme,{},F);return await(0,u.$zo)(ee)||""}return""}async getManifest(S,F){if(S.assets.manifest){const ee=await this.D(S.assets.manifest,{},F),oe=await(0,u.$zo)(ee);return oe?JSON.parse(oe):null}return null}async C(S,F){const ee=te(S,s.Manifest);if(!ee)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},z=await this.D(ee,{headers:oe});return await(0,u.$Ao)(z)}async getCoreTranslation(S,F){const ee=S.assets.coreTranslations.filter(oe=>oe[0]===F.toUpperCase())[0];if(ee){const oe=await this.D(ee[1]),z=await(0,u.$zo)(oe);return z?JSON.parse(z):null}return null}async getChangelog(S,F){if(S.assets.changelog){const ee=await this.D(S.assets.changelog,{},F);return await(0,u.$zo)(ee)||""}return""}async getAllCompatibleVersions(S,F,ee){let oe=new v().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);S.identifier.uuid?oe=oe.withFilter(n.ExtensionId,S.identifier.uuid):oe=oe.withFilter(n.ExtensionName,S.identifier.id);const{galleryExtensions:z}=await this.B(oe,O.CancellationToken.None);if(!z.length)return[];const q=J(z[0]);if((0,p.$In)(q,ee))return[];const W=[];await Promise.all(z[0].versions.map(async G=>{try{await this.y(G,F?"any":"release",!0,q,ee)&&W.push(G)}catch{}}));const U=[],X=new Set;for(const G of Z(W,ee))X.has(G.version)||(X.add(G.version),U.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:le(G)}));return U}async D(S,F={},ee=O.CancellationToken.None){const oe=await this.j,z={type:"GET"},q={...oe,...F.headers||{}};F={...F,...z,headers:q};const W=S.uri,U=S.fallbackUri,X={...F,url:W};try{const G=await this.k.request(X,ee);if(G.res.statusCode===200)return G;const Y=await(0,u.$zo)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${Y}`)}catch(G){if((0,a.$1)(G))throw G;const Y=(0,a.$8)(G);this.o.publicLog2("galleryService:cdnFallback",{url:W,message:Y});const ue={...F,url:U};return this.k.request(ue,ee)}}async E(S){let F=ce(S);if(!F){const ee=await this.C(S,O.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");F=ee.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const S=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,u.$Ao)(S),ee=[],oe={},z=[];if(F){for(const q of F.malicious)ee.push({id:q});if(F.migrateToPreRelease)for(const[q,W]of Object.entries(F.migrateToPreRelease))(!W.engine||(0,h.$uo)(W.engine,this.u.version,this.u.date))&&(oe[q.toLowerCase()]={disallowInstall:!0,extension:{id:W.id,displayName:W.displayName,autoMigrate:{storage:!!W.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[q,W]of Object.entries(F.deprecated))W&&(oe[q.toLowerCase()]=(0,R.$me)(W)?{}:W);if(F.search)for(const q of F.search)z.push(q)}return{malicious:ee,deprecated:oe,search:z}}};ne=Re([Ae(1,u.$vo),Ae(2,$.$Ni),Ae(3,P.$sh),Ae(4,D.$Rk),Ae(5,m.$Oj),Ae(6,o.$6i),Ae(7,d.$Rh)],ne);let Q=e.$Qo=class extends ne{constructor(S,F,ee,oe,z,q,W,U){super(S,F,ee,oe,z,q,W,U)}};e.$Qo=Q=Re([Ae(0,g.$Ho),Ae(1,u.$vo),Ae(2,$.$Ni),Ae(3,P.$sh),Ae(4,D.$Rk),Ae(5,m.$Oj),Ae(6,o.$6i),Ae(7,d.$Rh)],Q);let _=e.$Ro=class extends ne{constructor(S,F,ee,oe,z,q,W){super(void 0,S,F,ee,oe,z,q,W)}};e.$Ro=_=Re([Ae(0,u.$vo),Ae(1,$.$Ni),Ae(2,P.$sh),Ae(3,D.$Rk),Ae(4,m.$Oj),Ae(5,o.$6i),Ae(6,d.$Rh)],_)}),define(be[255],we([1,0,5,2,33,50]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class L{constructor(d,P){this.a=d,this.b=P}listen(d,P){const p=this.b(d);switch(P){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,I.$mm)({...h},p)),added:w.added.map(h=>(0,I.$mm)({...h},p)),removed:w.removed.map(h=>(0,I.$mm)({...h},p)),updated:w.updated.map(h=>(0,I.$mm)({...h},p))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,p){const w=this.b(d);switch(P){case"createProfile":{const h=await this.a.createProfile(p[0],p[1],p[2]);return(0,I.$mm)({...h},w)}case"updateProfile":{let h=(0,a.$ok)((0,I.$nm)(p[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,p[1]),(0,I.$mm)({...h},w)}case"removeProfile":{const h=(0,a.$ok)((0,I.$nm)(p[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${P}`)}}e.$EM=L;class R extends O.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,p){super(),this.profilesHome=P,this.f=p,this.a=[],this.b=this.B(new y.$5c),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(w=>(0,a.$ok)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(o=>(0,a.$ok)(o,this.profilesHome.scheme)),m=w.removed.map(o=>(0,a.$ok)(o,this.profilesHome.scheme)),$=w.updated.map(o=>(0,a.$ok)(o,this.profilesHome.scheme));this.a=w.all.map(o=>(0,a.$ok)(o,this.profilesHome.scheme)),this.b.fire({added:h,removed:m,updated:$,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,p){const w=await this.f.call("createNamedProfile",[d,P,p]);return(0,a.$ok)(w,this.profilesHome.scheme)}async createProfile(d,P,p,w){const h=await this.f.call("createProfile",[d,P,p,w]);return(0,a.$ok)(h,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,a.$ok)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const p=await this.f.call("updateProfile",[d,P]);return(0,a.$ok)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$FM=R}),define(be[126],we([1,0,4,25,16,12,231,34,33,8,232]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=void 0;let p=e.$uM=class Xt extends b.$qk{constructor($,o,u,l,g){super(u,l,o,g),this.P=$,this.Q=u}J(){return this.P.getItem(Xt.b,[]).map(o=>({...o,location:(0,d.$ge)(o.location)?this.s.extUri.joinPath(this.profilesHome,o.location):y.URI.revive(o.location)}))}M(){const $=this.P.getItem(Xt.c,{});return this.P.getItem(Xt.a,!1)?$:this.I($)}O(){return this.s.extUri.joinPath(y.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p.a="profileAssociationsMigration",e.$uM=p=Re([Ae(0,L.$pM),Ae(1,R.$lk),Ae(2,O.$th),Ae(3,a.$Oj),Ae(4,I.$Ni)],p);let w=e.$vM=class Ft extends p{constructor($,o,u,l,g){super($,o,u,l,g),this.W=$}L($){$.length?this.W.setItem(Ft.b,$.map(o=>({...o,location:this.s.extUri.basename(o.location)}))):this.W.removeItem(Ft.b)}J(){const $=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L($),this.W.setItem("userDataProfilesMigration",!0)),$}N($){$.emptyWindows||$.workspaces?this.W.setItem(Ft.c,$):this.W.removeItem(Ft.c)}M(){const $="workspaceAndProfileInfo",o=this.W.getItem($,void 0);if(o){this.W.removeItem($);const l=o.reduce((g,{workspace:D,profile:E})=>(g[y.URI.revive(D).toString()]=y.URI.revive(E).toString(),g),{});this.W.setItem(Ft.c,{workspaces:l})}const u=super.M();return this.W.getItem(Ft.a,!1)||(this.N(u),this.W.setItem(Ft.a,!0)),u}};e.$vM=w=Re([Ae(0,L.$qM),Ae(1,R.$lk),Ae(2,O.$th),Ae(3,a.$Oj),Ae(4,I.$Ni)],w);let h=e.$wM=class extends w{constructor($,o,u,l){super(new P.$tM(0,o,l,u),$,o,u,l)}async init(){return await this.W.init(),super.init()}};e.$wM=h=Re([Ae(0,R.$lk),Ae(1,O.$th),Ae(2,a.$Oj),Ae(3,I.$Ni)],h)}),define(be[127],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=void 0,e.$7l=(0,y.$lh)("extensionHostStatusService");class O{constructor(){this.a=new Map}setExitInfo(I,L){this.a.set(I,L)}getExitInfo(I){return this.a.get(I)||null}}e.$8l=O}),define(be[256],we([1,0,5,14]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0;function a(L){let R=0,b=0,d=0;L>=1e3&&(d=Math.floor(L/1e3),L-=d*1e3),d>=60&&(b=Math.floor(d/60),d-=b*60),b>=60&&(R=Math.floor(b/60),b-=R*60);const P=R?`${R}h`:"",p=b?`${b}m`:"",w=d?`${d}s`:"",h=L?`${L}ms`:"";return`${P}${p}${w}${h}`}class I{constructor(R,b,d,P){this.i=R,this.j=b,this.a=new y.$5c,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=d,this.protocol=P,this.e=!1,this.f=new O.$Dg(()=>{this.k(`The reconnection grace time of ${a(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new O.$Dg(()=>{this.k(`The reconnection short grace time of ${a(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${a(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(R){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${R}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${a(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const R=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),R.end(),this.a.fire(void 0)}acceptReconnection(R,b,d){this.d=R,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,d),this.protocol.endAcceptReconnection()}}e.$dm=I}),define(be[89],we([1,0,30,13,7,151,54]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.InternalNLSConfiguration=e.$2k=void 0;const R=a.$$b(O.$1e.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function d(m){return new Promise($=>y.exists(m,$))}function P(m,$){return d(R).then(o=>{if(!o||!L.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const u=`${m}||${$}`;let l=b.get(u);return l||(l=I.getNLSConfiguration(L.default.commit,$,R,m,m).then(g=>(p.is(g)&&(g._languagePackSupport=!0),g.locale!=="en"&&g.locale!=="en-us"&&Object.keys(g.availableLanguages).length===0&&b.delete(u),g)),b.set(u,l)),l})}e.$2k=P;var p;(function(m){function $(o){const u=o;return u&&typeof u._languagePackId=="string"}m.is=$})(p||(e.InternalNLSConfiguration=p={}));const w=async m=>{try{const $=h(await y.promises.readFile(m,"utf8"));return JSON.parse($).locale}catch($){return $.code!=="ENOENT"&&console.warn($),"en"}};e.$3k=w;const h=m=>{const $=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return m.replace($,(o,u,l,g,D)=>{if(g)return"";if(D){const E=D.length;return E>2&&D[E-1]===`
`?D[E-2]==="\r"?`\r
`:`
`:""}else return o})}}),define(be[128],we([1,0,19,4,25,45,57,16,6,12,27,34,33,89]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0;let m=e.$jM=class extends L.$bp{constructor(o,u,l,g,D,E,t,i){super(O.URI.file(D.builtinExtensionsPath),O.URI.file(D.extensionsPath),(0,y.$6f)(D.userHome,".vscode-oss-dev","extensions","control.json"),o.defaultProfile,o,u,l,g,D,E,t,i),this.N=D}async f(o){const u=await(0,h.$2k)(o,this.N.userDataPath);if(h.InternalNLSConfiguration.is(u))try{const l=await this.s.readFile(O.URI.file(u._translationsConfigFile));return JSON.parse(l.value.toString())}catch{}return Object.create(null)}};e.$jM=m=Re([Ae(0,w.$nk),Ae(1,I.$9o),Ae(2,R.$Oj),Ae(3,d.$Ni),Ae(4,a.$th),Ae(5,P.$6i),Ae(6,p.$lk),Ae(7,b.$kh)],m)}),define(be[257],we([1,0,258,30,7,21,13,23]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.ServerConnectionTokenType=void 0;const b=/^[0-9A-Za-z_-]+$/;var d;(function(o){o[o.None=0]="None",o[o.Optional=1]="Optional",o[o.Mandatory=2]="Mandatory"})(d||(e.ServerConnectionTokenType=d={}));class P{constructor(){this.type=0}validate(u){return!0}}e.$em=P;class p{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$fm=p;class w{constructor(u){this.message=u}}e.$gm=w;async function h(o,u){const l=o["without-connection-token"],g=o["connection-token"],D=o["connection-token-file"];if(l)return typeof g<"u"||typeof D<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new P;if(typeof D<"u"){if(typeof g<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let E;try{E=O.readFileSync(D).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${D}'.`)}return b.test(E)?new p(E):new w(`The connection token defined in '${D} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof g<"u"?b.test(g)?new p(g):new w(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):new p(await u())}e.$hm=h;async function m(o){return h(o,async()=>{if(!o["user-data-dir"])return(0,I.$3e)();const l=a.$$b(o["user-data-dir"],"token");try{const E=(await R.Promises.readFile(l)).toString().replace(/\r?\n$/,"");if(b.test(E))return E}catch{}const g=(0,I.$3e)();try{await R.Promises.writeFile(l,g,{mode:384})}catch{}return g})}e.$im=m;function $(o,u,l){if(o.validate(l.query[L.$Ue]))return!0;const g=y.parse(u.headers.cookie||"");return o.validate(g[L.$Te])}e.$jm=$}),define(be[41],we([1,0,195,108,62,6,25]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=void 0,e.$Xl={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":a.$hl["user-data-dir"],"enable-smoke-test-driver":a.$hl["enable-smoke-test-driver"],"disable-telemetry":a.$hl["disable-telemetry"],"disable-workspace-trust":a.$hl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:a.$hl.log,logsPath:a.$hl.logsPath,"force-disable-user-env":a.$hl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":a.$hl["extensions-dir"],"extensions-download-dir":a.$hl["extensions-download-dir"],"builtin-extensions-dir":a.$hl["builtin-extensions-dir"],"install-extension":a.$hl["install-extension"],"install-builtin-extension":a.$hl["install-builtin-extension"],"uninstall-extension":a.$hl["uninstall-extension"],"list-extensions":a.$hl["list-extensions"],"locate-extension":a.$hl["locate-extension"],"show-versions":a.$hl["show-versions"],category:a.$hl.category,force:a.$hl.force,"do-not-sync":a.$hl["do-not-sync"],"pre-release":a.$hl["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:a.$hl.help,version:a.$hl.version,"locate-shell-integration-path":a.$hl["locate-shell-integration-path"],compatibility:{type:"string"},_:a.$hl._},e.$Yl=(0,I.$mh)(L.$sh);class R extends O.$Ul{get args(){return super.args}}e.$Zl=R}),define(be[259],we([1,0,78,12,41,27,219,21,18]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0;let d=e.$nn=class extends L.$mn{constructor(p,w,h){super(p),this.p=w,this.r=h,this.p.args["github-auth"]&&this.t(this.p.args["github-auth"]).catch(m=>{this.h.error("Failed to store provided GitHub token",m)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new y.$ln,this.f;try{this.f=await new Promise((p,w)=>{ae(["keytar"],p,w)}),await this.f.findCredentials("test-keytar-loads")}catch(p){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${p.message??p}`),this.f=new y.$ln}return this.f}async t(p){const w="vscode.github-authentication",h=`${await this.getSecretStoragePrefix()}${w}`,m="github.auth",o=[["read:user","user:email","repo"]].map(g=>({id:(0,R.$3e)(),scopes:g.sort(),accessToken:p})),u=await this.getPassword(h,m);let l;if(u)try{const g=JSON.parse(u);g.content=JSON.parse(g.content),l=g}catch(g){this.h.error("Failed to parse existing GitHub credentials",g)}return l?.content&&(l.content=l.content.filter(g=>{const D=g.scopes.sort();return!o.find(E=>(0,b.$$e)(D,E.scopes)&&E.account?.label===g.account?.label)})),this.setPassword(h,m,JSON.stringify({extensionId:w,...l||{},content:JSON.stringify([...o,...l?.content||[]])}))}};e.$nn=d=Re([Ae(0,O.$Ni),Ae(1,a.$Yl),Ae(2,I.$6i)],d)}),define(be[260],we([1,0,298,242,261,26]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=void 0;class L extends y.AppInsightsCore{constructor(b){super(),this.a=b}track(b){const d=b.baseData||{};d.properties||(d.properties={}),d.measurements||(d.measurements={});try{const P=I.cpus();d.measurements.cores=P.length,d.properties["common.cpuModel"]=P[0].model}catch{}try{d.measurements.memoryFree=I.freemem(),d.measurements.memoryTotal=I.totalmem()}catch{}try{d.properties["common.shell"]=I.userInfo().shell,d.properties["common.release"]=I.release(),d.properties["common.arch"]=I.arch()}catch{}try{const P=(/^http:/.test(this.a)?a:O).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});P.on("error",()=>{}),P.write(JSON.stringify(d)),P.end()}catch{}}}e.$kM=L}),define(be[262],we([1,0,30,75,83,258,85,38,58,3,12,41,7,13,21,27,44,20,4,15,8,89,56]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CacheControl=e.$JM=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(M,K,te,he){K.writeHead(te,{"Content-Type":"text/plain"}),K.end(he)}e.$JM=r;var n;(function(M){M[M.NO_CACHING=0]="NO_CACHING",M[M.ETAG=1]="ETAG",M[M.NO_EXPIRY=2]="NO_EXPIRY"})(n||(e.CacheControl=n={}));async function s(M,K,te,he,ce,le){try{const ge=await y.promises.stat(M);if(K===1){const se=`W/"${[ge.ino,ge.size,ge.mtime.getTime()].join("-")}"`;if(he.headers["if-none-match"]===se)return ce.writeHead(304),void ce.end();le.Etag=se}else K===2?le["Cache-Control"]="public, max-age=31536000":K===0&&(le["Cache-Control"]="no-store");le["Content-Type"]=i[(0,w.$dc)(M)]||(0,b.$tr)(M)||"text/plain",ce.writeHead(200,le),(0,y.createReadStream)(M).pipe(ce)}catch(ge){return ge.code!=="ENOENT"?(te.error(ge),console.error(ge.toString())):console.error(`File not found: ${M}`),ce.writeHead(404,{"Content-Type":"text/plain"}),void ce.end("Not found")}}e.$KM=s;const c=(0,w.$bc)(h.$1e.asFileUri("").fsPath);let f=e.$LM=class{constructor(K,te,he,ce,le){this.f=K,this.g=te,this.h=he,this.i=ce,this.j=le,this.a=this.j.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ge=(0,t.$zk)(le);this.b=`${ge}/static`,this.c=`${ge}/callback`,this.d="/web-extension-resource"}async handle(K,te,he){try{const ce=he.pathname;return ce.startsWith(this.b)&&ce.charCodeAt(this.b.length)===47?this.k(K,te,he):ce==="/"?this.n(K,te,he):ce===this.c?this.p(te):ce.startsWith(this.d)&&ce.charCodeAt(this.d.length)===47?this.m(K,te,he):r(K,te,404,"Not found.")}catch(ce){return this.h.error(ce),console.error(ce.toString()),r(K,te,500,"Internal Server Error.")}}async k(K,te,he){const ce=Object.create(null),ge=decodeURIComponent(he.pathname).substring(this.b.length+1),se=(0,w.$$b)(c,ge);return(0,R.$He)(se,c,!d.$f)?s(se,this.g.isBuilt?2:1,this.h,K,te,ce):r(K,te,400,"Bad request.")}l(K){const te=K.authority.indexOf(".");return te!==-1?K.authority.substring(te+1):void 0}async m(K,te,he){if(!this.a)return r(K,te,500,"No extension gallery service configured.");const ce=decodeURIComponent(he.pathname),le=(0,w.$9b)(ce.substring(this.d.length+1)),ge=l.URI.parse(le).with({scheme:this.a.scheme,authority:le.substring(0,le.indexOf("/")),path:le.substring(le.indexOf("/")+1)});if(this.l(this.a)!==this.l(ge))return r(K,te,403,"Request Forbidden");const se={},V=ne=>{const Q=K.headers[ne];Q&&((0,D.$ge)(Q)||Q[0])?se[ne]=(0,D.$ge)(Q)?Q:Q[0]:ne!==ne.toLowerCase()&&V(ne.toLowerCase())};V("X-Client-Name"),V("X-Client-Version"),V("X-Machine-Id"),V("X-Client-Commit");const ie=await this.i.request({type:"GET",url:ge.toString(!0),headers:se},u.CancellationToken.None),J=ie.res.statusCode||500;if(J!==200){let ne=null;try{ne=await(0,o.$zo)(ie)}catch{}return r(K,te,J,ne||`Request failed with status ${J}`)}const Z=Object.create(null),H=ne=>{const Q=ie.res.headers[ne];Q?Z[ne]=Q:ne!==ne.toLowerCase()&&H(ne.toLowerCase())};H("Cache-Control"),H("Content-Type"),te.writeHead(200,Z);const B=await(0,g.$Tb)(ie.stream);return void te.end(B.buffer)}async n(K,te,he){const ce=he.query[h.$Ue];if(typeof ce=="string"){const q=Object.create(null);q["Set-Cookie"]=I.serialize(h.$Te,ce,{sameSite:"lax",maxAge:60*60*24*7});const W=Object.create(null);for(const X in he.query)X!==h.$Ue&&(W[X]=he.query[X]);const U=a.format({pathname:"/",query:W});return q.Location=U,te.writeHead(302,q),void te.end()}const le=!this.g.isBuilt&&this.g.args["use-test-resolver"],ge=le?"test+test":"remote";if(!ge)return r(K,te,400,"Bad request.");function se(q){return JSON.stringify(q).replace(/"/g,"&quot;")}let V;this.g.args["enable-smoke-test-driver"]&&(V=!1);const ie=q=>q&&l.URI.file(O.resolve(q)).with({scheme:h.Schemas.vscodeRemote,authority:ge}),J=h.$1e.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,Z=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$3e)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,H=(0,e.$NM)((0,e.$PM)(K)),B=(0,e.$OM)((0,e.$PM)(K)),ne={codeServerVersion:this.j.codeServerVersion,rootEndpoint:H,updateEndpoint:this.g.args["disable-update-check"]?void 0:H+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?H+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??H+"/proxy/{{port}}/",serviceWorker:{scope:B+"/",path:H+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const q=JSON.parse((await y.promises.readFile((0,w.$$b)(c,"product.overrides.json"))).toString());Object.assign(ne,q)}catch{}const Q={remoteAuthority:ge,webviewEndpoint:B+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:V,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:ie(this.g.args["default-folder"]),workspaceUri:ie(this.g.args["default-workspace"]),productConfiguration:ne,callbackRoute:this.c},_=this.g.args.locale||await(0,E.$3k)(this.g.argvResource.fsPath),T=await(0,E.$2k)(_,this.g.userDataPath),S=this.j.extensionsGallery?.nlsBaseUrl,F={WORKBENCH_WEB_CONFIGURATION:se(Q),WORKBENCH_AUTH_SESSION:Z?se(Z):"",WORKBENCH_WEB_BASE_URL:B+this.b,WORKBENCH_NLS_BASE_URL:B+(S?`${S}${S.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:H,VS_BASE:B,NLS_CONFIGURATION:se(T)};if(le){const q=[];for(const W of["vscode-test-resolver","github-authentication"]){const U=JSON.parse((await y.promises.readFile(h.$1e.asFileUri(`${h.$We}/${W}/package.json`).fsPath)).toString());q.push({extensionPath:W,packageJSON:U})}F.WORKBENCH_BUILTIN_EXTENSIONS=se(q)}let ee;try{ee=(await y.promises.readFile(J)).toString().replace(/\{\{([^}]+)\}\}/g,(W,U)=>F[U]??"undefined")}catch{return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}const z={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(ee).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(z["Set-Cookie"]=I.serialize(h.$Te,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),te.writeHead(200,z),void te.end(ee)}o(K){const te=/<script>([\s\S]+?)<\/script>/img,he=[];let ce;for(;ce=te.exec(K);){const le=L.createHash("sha256"),ge=ce[1].replace(/\r\n/g,`
`),se=le.update(Buffer.from(ge)).digest().toString("base64");he.push(`'sha256-${se}'`)}return he}async p(K){const te=h.$1e.asFileUri("vs/code/browser/workbench/callback.html").fsPath,he=(await y.promises.readFile(te)).toString(),ce=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(he).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return K.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ce}),void K.end(he)}};e.$LM=f=Re([Ae(1,p.$Yl),Ae(2,P.$Ni),Ae(3,o.$vo),Ae(4,$.$6i)],f);const k=(M,K=!1)=>M.replace(/\/\/+/g,"/").replace(/\/+$/,K?"/":"");e.$MM=k;const v=M=>{const K=(M.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$MM)("./"+(K>1?"../".repeat(K-1):""))};e.$NM=v;const C=M=>{const K=M.split("?",1)[0].split("/");return(0,e.$MM)("./"+K[K.length-1])};e.$OM=C;const A=M=>M.originalUrl||M.url;e.$PM=A}),define(be[263],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=void 0,e.$rL=(0,y.$lh)("IExtHostInitDataService")}),define(be[264],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.$bL=void 0,e.$bL=(0,y.$lh)("IExtHostRpcService");class O{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$cL=O}),define(be[68],we([1,0,50]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;function O(I){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:I,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function a(I){return new y.$km(O(I))}e.$ar=a}),define(be[265],we([1,0,3,42,4,68,50,104,235,7,19]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class p{constructor(h,m,$,o){this.b=h,this.c=m,this.d=$,this.e=o}async call(h,m,$){switch(m){case"getEnvironmentData":{const o=$,u=(0,I.$ar)(o.remoteAuthority);let l=await this.f(o.profile);return l=(0,L.$mm)(l,u),l}case"getExtensionHostExitInfo":{const o=$;return this.e.getExitInfo(o.reconnectionToken)}case"getDiagnosticInfo":{const o=$,u={machineInfo:(0,b.$er)()},l=o.includeProcesses?(0,R.$cr)(process.pid):Promise.resolve();let g=[];const D={};if(o.folders){const E=(0,I.$ar)("");g=o.folders.map(i=>a.URI.revive(E.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,b.$dr)(i.fsPath,["node_modules",".git"]).then(r=>{D[(0,d.$cc)(i.fsPath)]=r}))}return Promise.all([l,...g]).then(([E,t])=>(u.processes=E||void 0,u.workspaceMetadata=o.folders?D:void 0,u))}}throw new Error(`IPC Command ${m} not found`)}listen(h,m,$){throw new Error("Not supported")}async f(h){return h&&!this.d.profiles.some(m=>m.id===h)&&await this.d.createProfile(h,h),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:a.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,P.$6f)(this.c.logsHome,`exthost${p.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:O.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(m=>({...m}))}}}}e.$hr=p,p.a=1}),define(be[266],we([1,0,4,68,66,7,221]),function(ae,e,y,O,a,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class R extends L.$ir{constructor(P,p){super(new a.$Op(P),P),this.H=p,this.G=new Map,this.B(this.a)}c(P){let p=this.G.get(P.remoteAuthority);return p||(p=(0,O.$ar)(P.remoteAuthority),this.G.set(P.remoteAuthority,p)),p}f(P,p,w=!1){if(w&&p.path==="/vscode-resource"&&p.query){const h=JSON.parse(p.query).requestResourcePath;return y.URI.from({scheme:"file",path:h})}return y.URI.revive(P.transformIncoming(p))}F(P,p){return new b(P,p,this.b,this.H)}}e.$kr=R;class b extends L.$jr{constructor(P,p,w,h){super(P,p,w,h)}i(P){const p=P.args["file-watcher-polling"];if(p){const w=p.split(I.$ic),h=Number(w[0]);if(h>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:h}}}j(P){if(P.extensionsPath)return[I.$8b.join(P.extensionsPath,"**")]}}}),define(be[90],we([1,0,198,8,4,2,6,35,16,13,39,161,60]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.EditorsOrder=e.$nE=e.CloseDirection=e.$mE=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorInputCapabilities=e.$dE=e.SaveReason=e.Verbosity=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=void 0,e.$4D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5D={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$6D="workbench.editor.sidebysideEditor",e.$7D="workbench.editors.textDiffEditor",e.$8D="workbench.editors.binaryResourceDiffEditor";var h;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(h||(e.EditorPaneSelectionChangeReason=h={}));var m;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function $(B){const ne=B;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.$9D=$;function o(B,ne,Q){for(const _ of Q.visibleEditorPanes)if(_.group.id===ne&&B.matches(_.input))return _.getViewState()}e.$0D=o;function u(B){if(c(B))return!1;const ne=B;return a.URI.isUri(ne?.resource)}e.$$D=u;function l(B){if(c(B))return!1;const ne=B;return ne?.original!==void 0&&ne.modified!==void 0}e.$_D=l;function g(B){if(c(B)||l(B))return!1;const ne=B;return ne?.primary!==void 0&&ne.secondary!==void 0}e.$aE=g;function D(B){if(c(B))return!1;const ne=B;return ne?ne.resource===void 0||ne.resource.scheme===d.Schemas.untitled||ne.forceUntitled===!0:!1}e.$bE=D;function E(B){if(c(B))return!1;const ne=B;return a.URI.isUri(ne?.base?.resource)&&a.URI.isUri(ne?.input1?.resource)&&a.URI.isUri(ne?.input2?.resource)&&a.URI.isUri(ne?.result?.resource)}e.$cE=E;var t;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class r{constructor(){this.a=new Map}registerSource(ne,Q){let _=this.a.get(ne);return _||(_={source:ne,label:Q},this.a.set(ne,_)),_.source}getSourceLabel(ne){return this.a.get(ne)?.label??ne}}e.$dE=new r;var n;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor",B[B.MultipleEditors=256]="MultipleEditors",B[B.Scratchpad=512]="Scratchpad"})(n||(e.EditorInputCapabilities=n={}));class s extends I.$kb{}e.$eE=s;function c(B){return B instanceof s}e.$fE=c;function f(B){const ne=B;return a.URI.isUri(ne?.preferredResource)}function k(B){const ne=B;return c(ne?.primary)&&c(ne?.secondary)}e.$gE=k;function v(B){const ne=B;return c(ne?.modified)&&c(ne?.original)}e.$hE=v;function C(B,ne,Q,_,T){return H(_,[(0,p.$8h)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const S={...Q,limits:{size:Number.MAX_VALUE}};B.openEditor(ne,S)}}),(0,p.$8h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>T.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$iE=C;function A(B){return c(B?.editor)}e.$jE=A;function M(B){const ne=B;return A(B)&&ne?.group!==void 0}e.$kE=M;function K(B){const ne=B;return typeof ne?.groupId=="number"&&c(ne.editor)}e.$lE=K;var te;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(te||(e.EditorCloseContext=te={}));var he;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LOCKED=2]="GROUP_LOCKED",B[B.EDITOR_OPEN=3]="EDITOR_OPEN",B[B.EDITOR_CLOSE=4]="EDITOR_CLOSE",B[B.EDITOR_MOVE=5]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=7]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=9]="EDITOR_PIN",B[B.EDITOR_STICKY=10]="EDITOR_STICKY",B[B.EDITOR_DIRTY=11]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(he||(e.GroupModelChangeKind=he={}));var ce;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(ce||(e.SideBySideEditor=ce={}));class le{getOriginalUri(ne,Q){if(!ne)return;if(E(ne))return e.$mE.getOriginalUri(ne.result,Q);if(Q?.supportSideBySide){const{primary:T,secondary:S}=this.a(ne);if(T&&S){if(Q?.supportSideBySide===ce.BOTH)return{primary:this.getOriginalUri(T,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(S,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===ce.ANY)return this.getOriginalUri(T,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(S,{filterByScheme:Q.filterByScheme});ne=Q.supportSideBySide===ce.PRIMARY?T:S}}if(l(ne)||g(ne)||E(ne))return;const _=f(ne)?ne.preferredResource:ne.resource;return!_||!Q||!Q.filterByScheme?_:this.b(_,Q.filterByScheme)}a(ne){return k(ne)||g(ne)?{primary:ne.primary,secondary:ne.secondary}:v(ne)||l(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,Q){if(!ne)return;if(E(ne))return e.$mE.getCanonicalUri(ne.result,Q);if(Q?.supportSideBySide){const{primary:T,secondary:S}=this.a(ne);if(T&&S){if(Q?.supportSideBySide===ce.BOTH)return{primary:this.getCanonicalUri(T,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(S,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===ce.ANY)return this.getCanonicalUri(T,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(S,{filterByScheme:Q.filterByScheme});ne=Q.supportSideBySide===ce.PRIMARY?T:S}}if(l(ne)||g(ne)||E(ne))return;const _=ne.resource;return!_||!Q||!Q.filterByScheme?_:this.b(_,Q.filterByScheme)}b(ne,Q){if(Array.isArray(Q)){if(Q.some(_=>ne.scheme===_))return ne}else if(Q===ne.scheme)return ne}}e.$mE=new le;var ge;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(ne){const Q=this.a=ne.get(L.$kh);for(const[_,T]of this.c)this.e(_,T,Q);this.c.clear()}e(ne,Q,_){const T=_.createInstance(Q);this.d.set(ne,T)}registerFileEditorFactory(ne){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ne}getFileEditorFactory(){return(0,O.$re)(this.b)}registerEditorSerializer(ne,Q){if(this.c.has(ne)||this.d.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.a?this.e(ne,Q,this.a):this.c.set(ne,Q),(0,I.$ib)(()=>{this.c.delete(ne),this.d.delete(ne)})}getEditorSerializer(ne){return this.d.get(typeof ne=="string"?ne:ne.typeId)}}R.$Qm.add(e.$4D.EditorFactory,new se);async function V(B,ne,Q){return!B||!B.length?[]:await Promise.all(B.map(async _=>{const T=a.URI.revive(_.fileUri);if(!T){Q.info("Cannot resolve the path because it is not valid.",_);return}if(!await ne.canHandleResource(T)){Q.info("Cannot resolve the path because it cannot be handled",_);return}let F=_.exists,ee=_.type;if(typeof F!="boolean"||typeof ee!="number")try{ee=(await ne.stat(T)).isDirectory?b.FileType.Directory:b.FileType.Unknown,F=!0}catch(z){Q.error(z),F=!1}if(!F&&_.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",_);return}if(ee===b.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",_);return}const oe={..._.options,pinned:!0};return F?{resource:T,options:oe}:{resource:T,options:oe,forceUntitled:!0}}))}e.$nE=V;var ie;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function J(B){const ne=B;if(!ne)return!1;const Q=ne;if(Q.modified)return J(Q.modified);const _=ne;return!!(_.contributionsState&&_.viewState&&Array.isArray(_.cursorState))}e.$oE=J;function Z(B){return(0,P.$0h)(B)}e.$pE=Z;function H(B,ne,Q){const _=(0,P.$$h)(B,ne);return _.forceMessage=Q?.forceMessage,_.forceSeverity=Q?.forceSeverity,_.allowDialog=Q?.allowDialog,_}e.$qE=H}),define(be[129],we([1,0,15,74,46,58,13,7,3,64]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.$gH=e.CellStatusbarAlignment=e.$fH=e.$eH=e.$dH=e.NotebookEditorPriority=e.$cH=e.$bH=e.$aH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_G=e.$$G=e.$0G=e.$9G=e.CellKind=e.$8G=e.$7G=e.$6G=void 0,e.$6G="workbench.editor.notebook",e.$7G="workbench.editor.notebookTextDiffEditor",e.$8G="workbench.editor.interactive";var P;(function(se){se[se.Markup=1]="Markup",se[se.Code=2]="Code"})(P||(e.CellKind=P={})),e.$9G=["application/json","application/javascript","text/html","image/svg+xml",I.$rr.latex,I.$rr.markdown,"image/png","image/jpeg",I.$rr.text],e.$0G=[I.$rr.latex,I.$rr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$rr.text],e.$$G=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_G="_notAvailable";var p;(function(se){se[se.Running=1]="Running",se[se.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var w;(function(se){se[se.Unconfirmed=1]="Unconfirmed",se[se.Pending=2]="Pending",se[se.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var h;(function(se){se[se.Unconfirmed=1]="Unconfirmed",se[se.Pending=2]="Pending",se[se.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var m;(function(se){se[se.WithHardKernelDependency=0]="WithHardKernelDependency",se[se.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",se[se.Pure=2]="Pure",se[se.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var $;(function(se){se.Always="always",se.Never="never",se.Optional="optional"})($||(e.RendererMessagingSpec=$={}));var o;(function(se){se[se.ModelChange=1]="ModelChange",se[se.Move=2]="Move",se[se.ChangeCellLanguage=5]="ChangeCellLanguage",se[se.Initialize=6]="Initialize",se[se.ChangeCellMetadata=7]="ChangeCellMetadata",se[se.Output=8]="Output",se[se.OutputItem=9]="OutputItem",se[se.ChangeCellContent=10]="ChangeCellContent",se[se.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",se[se.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",se[se.ChangeCellMime=13]="ChangeCellMime",se[se.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var u;(function(se){se[se.Handle=0]="Handle",se[se.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var l;(function(se){se[se.Replace=1]="Replace",se[se.Output=2]="Output",se[se.Metadata=3]="Metadata",se[se.CellLanguage=4]="CellLanguage",se[se.DocumentMetadata=5]="DocumentMetadata",se[se.Move=6]="Move",se[se.OutputItems=7]="OutputItems",se[se.PartialMetadata=8]="PartialMetadata",se[se.PartialInternalMetadata=9]="PartialInternalMetadata"})(l||(e.CellEditType=l={}));var g;(function(se){se.scheme=L.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],ie=new RegExp(`^[${V.join("")}]+`),J=7;function Z(T,S){const F=S.toString(J),oe=`${F.length<V.length?V[F.length-1]:"z"}${F}s${(0,y.$2b)(y.$Ib.fromString(T.scheme),!0,!0)}`;return T.with({scheme:se.scheme,fragment:oe})}se.generate=Z;function H(T){if(T.scheme!==se.scheme)return;const S=T.fragment.indexOf("s");if(S<0)return;const F=parseInt(T.fragment.substring(0,S).replace(ie,""),J),ee=(0,y.$1b)(T.fragment.substring(S+1)).toString();if(!isNaN(F))return{handle:F,notebook:T.with({scheme:ee,fragment:null})}}se.parse=H;function B(T,S){return T.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${S??""},${T.scheme!==L.Schemas.file?T.scheme:""}`})}se.generateCellOutputUri=B;function ne(T){if(T.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const S=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(T.fragment);if(!S)return;const F=S[1]&&S[1]!==""?S[1]:void 0,ee=S[2];return{outputId:F,notebook:T.with({scheme:ee||L.Schemas.file,fragment:null})}}se.parseCellOutputUri=ne;function Q(T,S,F){return se.generate(T,S).with({scheme:F})}se.generateCellPropertyUri=Q;function _(T,S){if(T.scheme===S)return se.parse(T.with({scheme:se.scheme}))}se.parseCellPropertyUri=_})(g||(e.CellUri=g={}));const D=se=>b.$d?se.replace(/\//g,"\\"):se;class E{constructor(V=[],ie=e.$9G){this.e=ie,this.d=[...new Set(V)].map(J=>({pattern:J,matches:O.$aj(D(J))}))}sort(V){const ie=new Map(a.Iterable.map(V,Z=>[Z,D(Z)]));let J=[];for(const{matches:Z}of this.d)for(const[H,B]of ie)if(Z(B)){J.push(H),ie.delete(H);break}return ie.size&&(J=J.concat([...ie.keys()].sort((Z,H)=>this.e.indexOf(Z)-this.e.indexOf(H)))),J}prioritize(V,ie){const J=this.f(V);if(J===-1){this.d.unshift({pattern:V,matches:O.$aj(D(V))});return}const Z=new Set(ie.map(B=>this.f(B,J)));Z.delete(-1);const H=Array.from(Z).sort();this.d.splice(J+1,0,...H.map(B=>this.d[B]));for(let B=H.length-1;B>=0;B--)this.d.splice(H[B],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,ie=this.d.length){const J=D(V);for(let Z=0;Z<ie;Z++)if(this.d[Z].matches(J))return Z;return-1}}e.$aH=E;function t(se,V,ie,J=(Z,H)=>Z===H){const Z=[];function H(Q,_,T){if(_===0&&T.length===0)return;const S=Z[Z.length-1];S&&S.start+S.deleteCount===Q?(S.deleteCount+=_,S.toInsert.push(...T)):Z.push({start:Q,deleteCount:_,toInsert:T})}let B=0,ne=0;for(;;){if(B===se.length){H(B,0,V.slice(ne));break}if(ne===V.length){H(B,se.length-B,[]);break}const Q=se[B],_=V[ne];if(J(Q,_)){B+=1,ne+=1;continue}ie(_)?(H(B,1,[]),B+=1):(H(B,0,[_]),ne+=1)}return Z}e.$bH=t,e.$cH=new d.$Ki("notebookEditorCursorAtBoundary","none");var i;(function(se){se.default="default",se.option="option"})(i||(e.NotebookEditorPriority=i={}));function r(se){const V=se;return!!((typeof V.include=="string"||O.$bj(V.include))&&(typeof V.exclude=="string"||O.$bj(V.exclude)))}e.$dH=r;function n(se,V,ie){if(Array.isArray(se.viewType)&&se.viewType.indexOf(V)>=0||se.viewType===V)return!0;if(se.filenamePattern){const J=r(se.filenamePattern)?se.filenamePattern.include:se.filenamePattern,Z=r(se.filenamePattern)?se.filenamePattern.exclude:void 0;if(O.$_i(J,(0,R.$cc)(ie.fsPath).toLowerCase()))return!(Z&&O.$_i(Z,(0,R.$cc)(ie.fsPath).toLowerCase()))}return!1}e.$eH=n,e.$fH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var s;(function(se){se[se.Left=1]="Left",se[se.Right=2]="Right"})(s||(e.CellStatusbarAlignment=s={}));class c{static create(V){return`${c.d}${V}`}static parse(V){if(V.startsWith(c.d))return V.substring(c.d.length)}}e.$gH=c,c.d="notebook/";function f(se){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(se)}e.$hH=f;const k=new TextDecoder;function v(se){const V=[];let ie=!1;for(const J of se)(V.length===0||ie)&&(V.push(J),ie=!0);return K(V),ge(y.$Ib.concat(V.map(J=>y.$Ib.wrap(J))))}e.$iH=v;const C=`${String.fromCharCode(27)}[A`,A=C.split("").map(se=>se.charCodeAt(0)),M=10;function K(se){se.forEach((V,ie)=>{if(ie===0||V.length<C.length)return;const J=se[ie-1],Z=V.subarray(0,C.length);if(Z[0]===A[0]&&Z[1]===A[1]&&Z[2]===A[2]){const H=J.lastIndexOf(M);if(H===-1)return;se[ie-1]=J.subarray(0,H),se[ie]=V.subarray(C.length)}})}function te(se){let V=se;do se=V,V=se.replace(/[^\n]\x08/gm,"");while(V.length<se.length);return se}function he(se){for(se=se.replace(/\r+\n/gm,`
`);se.search(/\r[^$]/g)>-1;){const V=se.match(/^(.*)\r+/m)[1];let ie=se.match(/\r+(.*)$/m)[1];ie=ie+V.slice(ie.length,V.length),se=se.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return se}const ce="\b".charCodeAt(0),le="\r".charCodeAt(0);function ge(se){return!se.buffer.includes(ce)&&!se.buffer.includes(le)?se:y.$Ib.fromString(he(te(k.decode(se.buffer))))}});var Ct=this&&this.__classPrivateFieldSet||function(ae,e,y,O,a){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?a.call(ae,y):a?a.value=y:e.set(ae,y),y},nt=this&&this.__classPrivateFieldGet||function(ae,e,y,O){if(y==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!O:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?O:y==="a"?O.call(ae):O?O.value:e.get(ae)};define(be[130],we([1,0,18,11,100,28,58,17,8,4,21,40,16,117,129]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m){"use strict";var $,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A,M,K,te,he,ce,le,ge,se;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.TestRunProfileKind=e.TestResultState=e.$JK=e.$IK=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HK=e.$GK=e.$FK=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EK=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.ColorThemeKind=e.$yK=e.$xK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wK=e.DebugConsoleMode=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$qK=e.$pK=e.FileChangeType=e.$oK=e.$nK=e.$mK=e.$lK=e.InlineCompletionTriggerKind=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.ConfigurationTarget=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1J=e.ViewBadge=e.ProgressLocation=e.$ZJ=e.$YJ=e.TaskScope=e.ShellQuoting=e.$XJ=e.$WJ=e.$VJ=e.TaskPanelKind=e.TaskRevealKind=e.$UJ=e.TerminalLocation=e.$TJ=e.$SJ=e.$RJ=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$MJ=e.StatusBarAlignment=e.ViewColumn=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HJ=e.$GJ=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.LanguageStatusSeverity=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.CodeActionTriggerKind=e.$tJ=e.$sJ=e.SymbolTag=e.SymbolKind=e.$rJ=e.DocumentHighlightKind=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$mJ=e.$lJ=e.FileEditType=e.$kJ=e.$jJ=e.$iJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V(j){return Object.assign(j,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(j,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[re,...$e]=arguments;return Reflect.construct(j,$e,re.constructor)}}})}var ie;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(ie||(e.TerminalOutputAnchor=ie={}));var J;(function(j){j[j.Command=0]="Command",j[j.Opener=1]="Opener"})(J||(e.TerminalQuickFixType=J={}));let Z=e.$bJ=i=class{static from(...N){let re=N;return new i(function(){if(re){for(const $e of re)$e&&typeof $e.dispose=="function"&&$e.dispose();re=void 0}})}constructor(N){$.set(this,void 0),Ct(this,$,N,"f")}dispose(){typeof nt(this,$,"f")=="function"&&(nt(this,$,"f").call(this),Ct(this,$,void 0,"f"))}};$=new WeakMap,e.$bJ=Z=i=Re([V],Z);let H=e.$cJ=r=class{static Min(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let $e=1;$e<N.length;$e++){const Me=N[$e];Me.isBefore(re)&&(re=Me)}return re}static Max(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let $e=1;$e<N.length;$e++){const Me=N[$e];Me.isAfter(re)&&(re=Me)}return re}static isPosition(N){if(!N)return!1;if(N instanceof r)return!0;const{line:re,character:$e}=N;return typeof re=="number"&&typeof $e=="number"}static of(N){if(N instanceof r)return N;if(this.isPosition(N))return new r(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,re){if(N<0)throw(0,O.$4)("line must be non-negative");if(re<0)throw(0,O.$4)("character must be non-negative");this.c=N,this.e=re}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,re=0){if(N===null||re===null)throw(0,O.$4)();let $e;return typeof N>"u"?$e=0:typeof N=="number"?$e=N:($e=typeof N.lineDelta=="number"?N.lineDelta:0,re=typeof N.characterDelta=="number"?N.characterDelta:0),$e===0&&re===0?this:new r(this.line+$e,this.character+re)}with(N,re=this.character){if(N===null||re===null)throw(0,O.$4)();let $e;return typeof N>"u"?$e=this.line:typeof N=="number"?$e=N:($e=typeof N.line=="number"?N.line:this.line,re=typeof N.character=="number"?N.character:this.character),$e===this.line&&re===this.character?this:new r($e,re)}toJSON(){return{line:this.line,character:this.character}}};e.$cJ=H=r=Re([V],H);let B=e.$dJ=n=class{static isRange(N){return N instanceof n?!0:N?H.isPosition(N.start)&&H.isPosition(N.end):!1}static of(N){if(N instanceof n)return N;if(this.isRange(N))return new n(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,re,$e,Me){let Ve,_e;if(typeof N=="number"&&typeof re=="number"&&typeof $e=="number"&&typeof Me=="number"?(Ve=new H(N,re),_e=new H($e,Me)):H.isPosition(N)&&H.isPosition(re)&&(Ve=H.of(N),_e=H.of(re)),!Ve||!_e)throw new Error("Invalid arguments");Ve.isBefore(_e)?(this.c=Ve,this.e=_e):(this.c=_e,this.e=Ve)}contains(N){return n.isRange(N)?this.contains(N.start)&&this.contains(N.end):H.isPosition(N)?!(H.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const re=H.Max(N.start,this.c),$e=H.Min(N.end,this.e);if(!re.isAfter($e))return new n(re,$e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const re=H.Min(N.start,this.c),$e=H.Max(N.end,this.end);return new n(re,$e)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,re=this.end){if(N===null||re===null)throw(0,O.$4)();let $e;return N?H.isPosition(N)?$e=N:($e=N.start||this.start,re=N.end||this.end):$e=this.start,$e.isEqual(this.c)&&re.isEqual(this.end)?this:new n($e,re)}toJSON(){return[this.start,this.end]}};e.$dJ=B=n=Re([V],B);let ne=e.$eJ=s=class extends B{static isSelection(N){return N instanceof s?!0:N?B.isRange(N)&&H.isPosition(N.anchor)&&H.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,re,$e,Me){let Ve,_e;if(typeof N=="number"&&typeof re=="number"&&typeof $e=="number"&&typeof Me=="number"?(Ve=new H(N,re),_e=new H($e,Me)):H.isPosition(N)&&H.isPosition(re)&&(Ve=H.of(N),_e=H.of(re)),!Ve||!_e)throw new Error("Invalid arguments");super(Ve,_e),this.f=Ve,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$eJ=ne=s=Re([V],ne);const Q=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$4)("connectionToken")};class _{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re,$e){if(typeof N!="string"||N.length===0)throw(0,O.$4)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,O.$4)("port");typeof $e<"u"&&Q($e),this.host=N,this.port=Math.round(re),this.connectionToken=$e}}e.$fJ=_;class T{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re){this.makeConnection=N,this.connectionToken=re,typeof re<"u"&&Q(re)}}e.$gJ=T;class S extends Error{static NotAvailable(N,re){return new S(N,h.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(N){return new S(N,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,re=h.RemoteAuthorityResolverErrorCode.Unknown,$e){super(N),this._message=N,this._code=re,this._detail=$e,Object.setPrototypeOf(this,S.prototype)}}e.$hJ=S;var F;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(F||(e.EndOfLine=F={}));var ee;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ee||(e.EnvironmentVariableMutatorType=ee={}));let oe=e.$iJ=c=class{static isTextEdit(N){return N instanceof c?!0:N?B.isRange(N)&&typeof N.newText=="string":!1}static replace(N,re){return new c(N,re)}static insert(N,re){return c.replace(new B(N,N),re)}static delete(N){return c.replace(N,"")}static setEndOfLine(N){const re=new c(new B(new H(0,0),new H(0,0)),"");return re.newEol=N,re}get range(){return this.c}set range(N){if(N&&!B.isRange(N))throw(0,O.$4)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,O.$4)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,O.$4)("newEol");this.f=N}constructor(N,re){this.c=N,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$iJ=oe=c=Re([V],oe);let z=e.$jJ=f=class{static isNotebookCellEdit(N){return N instanceof f?!0:N?Nt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,re){return new f(N,re)}static insertCells(N,re){return new f(new Nt(N,N),re)}static deleteCells(N){return new f(N,[])}static updateCellMetadata(N,re){const $e=new f(new Nt(N,N),[]);return $e.newCellMetadata=re,$e}static updateNotebookMetadata(N){const re=new f(new Nt(0,0),[]);return re.newNotebookMetadata=N,re}constructor(N,re){this.range=N,this.newCells=re}};e.$jJ=z=f=Re([V],z);class q{static isSnippetTextEdit(N){return N instanceof q?!0:N?B.isRange(N.range)&&X.isSnippetString(N.snippet):!1}static replace(N,re){return new q(N,re)}static insert(N,re){return q.replace(new B(N,N),re)}constructor(N,re){this.range=N,this.snippet=re}}e.$kJ=q;var W;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(W||(e.FileEditType=W={}));let U=e.$lJ=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,re,$e,Me){this.c.push({_type:1,from:N,to:re,options:$e,metadata:Me})}createFile(N,re,$e){this.c.push({_type:1,from:void 0,to:N,options:re,metadata:$e})}deleteFile(N,re,$e){this.c.push({_type:1,from:N,to:void 0,options:re,metadata:$e})}e(N,re,$e){this.c.push({_type:3,metadata:$e,uri:N,edit:{editType:5,metadata:re},notebookMetadata:re})}f(N,re,$e,Me){const Ve=re.start,_e=re.end;(Ve!==_e||$e.length>0)&&this.c.push({_type:5,uri:N,index:Ve,count:_e-Ve,cells:$e,metadata:Me})}g(N,re,$e,Me){this.c.push({_type:3,metadata:Me,uri:N,edit:{editType:3,index:re,metadata:$e}})}replace(N,re,$e,Me){this.c.push({_type:2,uri:N,edit:new oe(re,$e),metadata:Me})}insert(N,re,$e,Me){this.replace(N,new B(re,re),$e,Me)}delete(N,re,$e){this.replace(N,re,"",$e)}has(N){return this.c.some(re=>re._type===2&&re.uri.toString()===N.toString())}set(N,re){if(re)for(const $e of re){if(!$e)continue;let Me,Ve;Array.isArray($e)?(Me=$e[0],Ve=$e[1]):Me=$e,z.isNotebookCellEdit(Me)?Me.newCellMetadata?this.g(N,Me.range.start,Me.newCellMetadata,Ve):Me.newNotebookMetadata?this.e(N,Me.newNotebookMetadata,Ve):this.f(N,Me.range,Me.newCells,Ve):q.isSnippetTextEdit(Me)?this.c.push({_type:6,uri:N,range:Me.range,edit:Me.snippet,metadata:Ve}):this.c.push({_type:2,uri:N,edit:Me,metadata:Ve})}else{for(let $e=0;$e<this.c.length;$e++){const Me=this.c[$e];switch(Me._type){case 2:case 6:case 3:case 5:Me.uri.toString()===N.toString()&&(this.c[$e]=void 0);break}}(0,y.$kf)(this.c)}}get(N){const re=[];for(const $e of this.c)$e._type===2&&$e.uri.toString()===N.toString()&&re.push($e.edit);return re}entries(){const N=new I.$ji;for(const re of this.c)if(re._type===2){let $e=N.get(re.uri);$e||($e=[re.uri,[]],N.set(re.uri,$e)),$e[1].push(re.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$lJ=U=Re([V],U);let X=e.$mJ=k=class{static isSnippetString(N){return N instanceof k?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=k.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,re=this.e++){if(typeof N=="function"){const $e=new k;$e.e=this.e,N($e),this.e=$e.e,N=$e.value}else N=k.c(N);return this.value+="${",this.value+=re,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,re=this.e++){const $e=N.map(Me=>Me.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=$e,this.value+="|}",this}appendVariable(N,re){if(typeof re=="function"){const $e=new k;$e.e=this.e,re($e),this.e=$e.e,re=$e.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$mJ=X=k=Re([V],X);var G;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(G||(e.DiagnosticTag=G={}));var Y;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Y||(e.DiagnosticSeverity=Y={}));let ue=e.$nJ=v=class{static isLocation(N){return N instanceof v?!0:N?B.isRange(N.range)&&d.URI.isUri(N.uri):!1}constructor(N,re){if(this.uri=N,re)if(B.isRange(re))this.range=B.of(re);else if(H.isPosition(re))this.range=new B(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$nJ=ue=v=Re([V],ue);let pe=e.$oJ=class{static is(N){return N?typeof N.message=="string"&&N.location&&B.isRange(N.location.range)&&d.URI.isUri(N.location.uri):!1}constructor(N,re){this.location=N,this.message=re}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.location.range.isEqual(re.location.range)&&N.location.uri.toString()===re.location.uri.toString()}};e.$oJ=pe=Re([V],pe);let Se=e.$pJ=class{constructor(N,re,$e=Y.Error){if(!B.isRange(N))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=N,this.message=re,this.severity=$e}toJSON(){return{severity:Y[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.severity===re.severity&&N.code===re.code&&N.severity===re.severity&&N.source===re.source&&N.range.isEqual(re.range)&&(0,y.$$e)(N.tags,re.tags)&&(0,y.$$e)(N.relatedInformation,re.relatedInformation,pe.isEqual)}};e.$pJ=Se=Re([V],Se);let Ce=e.$qJ=class{constructor(N,re){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=re}};e.$qJ=Ce=Re([V],Ce);var Fe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Fe||(e.DocumentHighlightKind=Fe={}));let ze=e.$rJ=class{constructor(N,re=Fe.Text){this.range=N,this.kind=re}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};e.$rJ=ze=Re([V],ze);var me;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var Ee;(function(j){j[j.Deprecated=1]="Deprecated"})(Ee||(e.SymbolTag=Ee={}));let ye=e.$sJ=C=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,re,$e,Me,Ve){this.name=N,this.kind=re,this.containerName=Ve,typeof $e=="string"&&(this.containerName=$e),Me instanceof ue?this.location=Me:$e instanceof B&&(this.location=new ue(Me,$e)),C.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$sJ=ye=C=Re([V],ye);let je=e.$tJ=A=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(A.validate)}constructor(N,re,$e,Me,Ve){this.name=N,this.detail=re,this.kind=$e,this.range=Me,this.selectionRange=Ve,this.children=[],A.validate(this)}};e.$tJ=je=A=Re([V],je);var Te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let xe=e.$uJ=class{constructor(N,re){this.title=N,this.kind=re}};e.$uJ=xe=Re([V],xe);let Be=e.$vJ=M=class{constructor(N){this.value=N}append(N){return new M(this.value?this.value+M.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+M.c)}};Be.c=".",e.$vJ=Be=M=Re([V],Be);class Ze extends Be{constructor(N){super(N),this.value=N}}e.$wJ=Ze,Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll"),Be.Notebook=Be.Empty.append("notebook");let Ye=e.$xJ=class{constructor(N,re){if(this.range=N,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xJ=Ye=Re([V],Ye);class it{constructor(N,re,$e,Me,Ve,_e){this.kind=N,this.name=re,this.detail=$e,this.uri=Me,this.range=Ve,this.selectionRange=_e}}e.$yJ=it;class Xe{constructor(N,re){this.fromRanges=re,this.from=N}}e.$zJ=Xe;class Ge{constructor(N,re){this.fromRanges=re,this.to=N}}e.$AJ=Ge;var fe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(fe||(e.LanguageStatusSeverity=fe={}));let De=e.$BJ=class{constructor(N,re){this.range=N,this.command=re}get isResolved(){return!!this.command}};e.$BJ=De=Re([V],De);let Le=e.$CJ=K=class{static isMarkdownString(N){return N instanceof K?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,re=!1){o.set(this,void 0),Ct(this,o,new a.$Gj(N,{supportThemeIcons:re}),"f")}get value(){return nt(this,o,"f").value}set value(N){nt(this,o,"f").value=N}get isTrusted(){return nt(this,o,"f").isTrusted}set isTrusted(N){nt(this,o,"f").isTrusted=N}get supportThemeIcons(){return nt(this,o,"f").supportThemeIcons}set supportThemeIcons(N){nt(this,o,"f").supportThemeIcons=N}get supportHtml(){return nt(this,o,"f").supportHtml}set supportHtml(N){nt(this,o,"f").supportHtml=N}get baseUri(){return nt(this,o,"f").baseUri}set baseUri(N){nt(this,o,"f").baseUri=N}appendText(N){return nt(this,o,"f").appendText(N),this}appendMarkdown(N){return nt(this,o,"f").appendMarkdown(N),this}appendCodeblock(N,re){return nt(this,o,"f").appendCodeblock(re??"",N),this}};o=new WeakMap,e.$CJ=Le=K=Re([V],Le);let Ie=e.$DJ=class{constructor(N,re){this.label=N,this.documentation=re}};e.$DJ=Ie=Re([V],Ie);let Oe=e.$EJ=class{constructor(N,re){this.label=N,this.documentation=re,this.parameters=[]}};e.$EJ=Oe=Re([V],Oe);let qe=e.$FJ=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FJ=qe=Re([V],qe);var He;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(He||(e.SignatureHelpTriggerKind=He={}));var Ke;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ke||(e.InlayHintKind=Ke={}));let et=e.$GJ=class{constructor(N){this.value=N}};e.$GJ=et=Re([V],et);let Je=e.$HJ=class{constructor(N,re,$e){this.position=N,this.label=re,this.kind=$e}};e.$HJ=Je=Re([V],Je);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var ot;(function(j){j[j.Deprecated=1]="Deprecated"})(ot||(e.CompletionItemTag=ot={}));let pt=e.$IJ=class{constructor(N,re){this.label=N,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IJ=pt=Re([V],pt);let yt=e.$JJ=class{constructor(N=[],re=!1){this.items=N,this.isIncomplete=re}};e.$JJ=yt=Re([V],yt);let It=e.$KJ=class{constructor(N,re,$e){this.insertText=N,this.range=re,this.command=$e}};e.$KJ=It=Re([V],It);let gt=e.$LJ=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$LJ=gt=Re([V],gt);var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var At;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(At||(e.StatusBarAlignment=At={}));function Mt(j,N){return`${p.$El.toKey(j)}.${N}`}e.$MJ=Mt;var vt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(vt||(e.TextEditorLineNumbersStyle=vt={}));var Lt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var jt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var dt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(dt||(e.TextEditorSelectionChangeKind=dt={}));var St;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var Rt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Rt||(e.DecorationRangeBehavior=Rt={})),function(j){function N(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=N}(dt||(e.TextEditorSelectionChangeKind=dt={}));let rt=e.$NJ=class{constructor(N,re){if(re&&!d.URI.isUri(re))throw(0,O.$4)("target");if(!B.isRange(N)||N.isEmpty)throw(0,O.$4)("range");this.range=N,this.target=re}};e.$NJ=rt=Re([V],rt);let $t=e.$OJ=class{constructor(N,re,$e,Me){this.red=N,this.green=re,this.blue=$e,this.alpha=Me}};e.$OJ=$t=Re([V],$t);let ve=e.$PJ=class{constructor(N,re){if(re&&!(re instanceof $t))throw(0,O.$4)("color");if(!B.isRange(N)||N.isEmpty)throw(0,O.$4)("range");this.range=N,this.color=re}};e.$PJ=ve=Re([V],ve);let ke=e.$QJ=class{constructor(N){if(!N||typeof N!="string")throw(0,O.$4)("label");this.label=N}};e.$QJ=ke=Re([V],ke);var de;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(de||(e.ColorFormat=de={}));var x;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(x||(e.SourceControlInputBoxValidationType=x={}));var Pe;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Pe||(e.TerminalExitReason=Pe={}));class Ne{constructor(N,re,$e){if(this.startIndex=N,this.length=re,this.tooltip=$e,typeof N!="number"||N<0)throw(0,O.$4)("startIndex");if(typeof re!="number"||re<1)throw(0,O.$4)("length");if($e!==void 0&&typeof $e!="string")throw(0,O.$4)("tooltip")}}e.$RJ=Ne;class We{constructor(N){this.uri=N}}e.$SJ=We;class Ue{constructor(N){this.terminalCommand=N}}e.$TJ=Ue;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class lt{constructor(N){if(this.options=N,typeof N!="object")throw(0,O.$4)("options")}}e.$UJ=lt;var ht;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ht||(e.TaskRevealKind=ht={}));var bt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(bt||(e.TaskPanelKind=bt={}));let at=e.$VJ=te=class{static from(N){switch(N){case"clean":return te.Clean;case"build":return te.Build;case"rebuild":return te.Rebuild;case"test":return te.Test;default:return}}constructor(N,re){if(this.label=re,typeof N!="string"||typeof re!="string")throw(0,O.$4)("name");this.c=N}get id(){return this.c}};at.Clean=new te("clean","Clean"),at.Build=new te("build","Build"),at.Rebuild=new te("rebuild","Rebuild"),at.Test=new te("test","Test"),e.$VJ=at=te=Re([V],at);function mt(j){let N="";for(let re=0;re<j.length;re++)N+=j[re].replace(/,/g,",,")+",";return N}let Zt=e.$WJ=class{constructor(N,re,$e){if(typeof N!="string")throw(0,O.$4)("process");this.e=[],this.c=N,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=$e):this.f=re)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,O.$4)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const re of this.e)N.push(re);return mt(N)}};e.$WJ=Zt=Re([V],Zt);let Qt=e.$XJ=class{constructor(N,re,$e){if(this.f=[],Array.isArray(re)){if(!N)throw(0,O.$4)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,O.$4)("command");this.e=N,this.f=re,this.g=$e}else{if(typeof N!="string")throw(0,O.$4)("commandLine");this.c=N,this.g=re}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,O.$4)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,O.$4)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)N.push(typeof re=="string"?re:re.value);return mt(N)}};e.$XJ=Qt=Re([V],Qt);var sn;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(sn||(e.ShellQuoting=sn={}));var Wt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class rn{constructor(N){this.c=N}computeId(){return"customExecution"+(0,P.$3e)()}set callback(N){this.c=N}get callback(){return this.c}}e.$YJ=rn;let Tt=e.$ZJ=he=class{constructor(N,re,$e,Me,Ve,_e){this.j=!1,this.k=this.definition=N;let tt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=$e,this.execution=Me,tt=Ve,this.j=!0):re===Wt.Global||re===Wt.Workspace?(this.target=re,this.m=this.name=$e,this.t=this.source=Me,this.execution=Ve,tt=_e):(this.target=re,this.m=this.name=$e,this.t=this.source=Me,this.execution=Ve,tt=_e),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Zt?this.k={type:he.e,id:this.n.computeId()}:this.n instanceof Qt?this.k={type:he.f,id:this.n.computeId()}:this.n instanceof rn?this.k={type:he.c,id:this.n.computeId()}:this.k={type:he.g,id:(0,P.$3e)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,O.$4)("Kind can't be undefined or null");this.y(),this.k=N}get scope(){return this.l}set target(N){this.y(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,O.$4)("name");this.y(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.y(),this.n=N;const re=this.k.type;(he.g===re||he.e===re||he.f===re||he.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.y(),this.o=N,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.y(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,O.$4)("source must be a string of length > 0");this.y(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.y(),this.u=N}get detail(){return this.x}set detail(N){N===null&&(N=void 0),this.x=N}get presentationOptions(){return this.v}set presentationOptions(N){N==null&&(N=Object.create(null)),this.y(),this.v=N}get runOptions(){return this.w}set runOptions(N){N==null&&(N=Object.create(null)),this.y(),this.w=N}};Tt.c="customExecution",Tt.e="process",Tt.f="shell",Tt.g="$empty",e.$ZJ=Tt=he=Re([V],Tt);var on;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(on||(e.ProgressLocation=on={}));var an;(function(j){function N(re){const $e=re;return(0,b.$ke)($e.value)?$e.tooltip&&!(0,b.$ge)($e.tooltip)?(console.log("INVALID view badge, invalid tooltip",$e.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",$e.value),!1)}j.isViewBadge=N})(an||(e.ViewBadge=an={}));let cn=e.$1J=ce=class{static isTreeItem(N,re){const $e=N;if($e.checkboxState!==void 0){const Me=(0,b.$ke)($e.checkboxState)?$e.checkboxState:(0,b.$ie)($e.checkboxState)&&(0,b.$ke)($e.checkboxState.state)?$e.checkboxState.state:void 0,Ve=!(0,b.$ke)($e.checkboxState)&&(0,b.$ie)($e.checkboxState)?$e.checkboxState.tooltip:void 0;if(Me===void 0||Me!==Vt.Checked&&Me!==Vt.Unchecked||Ve!==void 0&&!(0,b.$ge)(Ve))return console.log("INVALID tree item, invalid checkboxState",$e.checkboxState),!1}if(N instanceof ce)return!0;if($e.label!==void 0&&!(0,b.$ge)($e.label)&&!$e.label?.label)return console.log("INVALID tree item, invalid label",$e.label),!1;if($e.id!==void 0&&!(0,b.$ge)($e.id))return console.log("INVALID tree item, invalid id",$e.id),!1;if($e.iconPath!==void 0&&!(0,b.$ge)($e.iconPath)&&!d.URI.isUri($e.iconPath)&&(!$e.iconPath||!(0,b.$ge)($e.iconPath.id))){const Me=$e.iconPath;if(!Me||!(0,b.$ge)(Me.light)&&!d.URI.isUri(Me.light)&&!(0,b.$ge)(Me.dark)&&!d.URI.isUri(Me.dark))return console.log("INVALID tree item, invalid iconPath",$e.iconPath),!1}return $e.description!==void 0&&!(0,b.$ge)($e.description)&&typeof $e.description!="boolean"?(console.log("INVALID tree item, invalid description",$e.description),!1):$e.resourceUri!==void 0&&!d.URI.isUri($e.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",$e.resourceUri),!1):$e.tooltip!==void 0&&!(0,b.$ge)($e.tooltip)&&!($e.tooltip instanceof Le)?(console.log("INVALID tree item, invalid tooltip",$e.tooltip),!1):$e.command!==void 0&&!$e.command.command?(console.log("INVALID tree item, invalid command",$e.command),!1):$e.collapsibleState!==void 0&&$e.collapsibleState<Ut.None&&$e.collapsibleState>Ut.Expanded?(console.log("INVALID tree item, invalid collapsibleState",$e.collapsibleState),!1):$e.contextValue!==void 0&&!(0,b.$ge)($e.contextValue)?(console.log("INVALID tree item, invalid contextValue",$e.contextValue),!1):$e.accessibilityInformation!==void 0&&!$e.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",$e.accessibilityInformation),!1):!0}constructor(N,re=Ut.None){this.collapsibleState=re,d.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$1J=cn=ce=Re([V],cn);var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut||(e.TreeItemCollapsibleState=Ut={}));var Vt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Vt||(e.TreeItemCheckboxState=Vt={}));let Yt=e.$2J=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$2J=Yt=Re([V],Yt);class ln extends Yt{}e.$3J=ln;class wi extends ln{constructor(N){super(""),u.set(this,void 0),Ct(this,u,N,"f")}asFile(){return nt(this,u,"f")}}e.$4J=wi,u=new WeakMap;class pi{constructor(N,re,$e,Me){this.name=N,this.uri=re,this._itemId=$e,this.c=Me}data(){return this.c()}}e.$5J=pi;let un=e.$6J=class{constructor(N){l.add(this),g.set(this,new Map);for(const[re,$e]of N??[]){const Me=nt(this,g,"f").get(nt(this,l,"m",D).call(this,re));Me?Me.push($e):nt(this,g,"f").set(nt(this,l,"m",D).call(this,re),[$e])}}get(N){return nt(this,g,"f").get(nt(this,l,"m",D).call(this,N))?.[0]}set(N,re){nt(this,g,"f").set(nt(this,l,"m",D).call(this,N),[re])}forEach(N,re){for(const[$e,Me]of nt(this,g,"f"))for(const Ve of Me)N.call(re,Ve,$e,this)}*[(g=new WeakMap,l=new WeakSet,Symbol.iterator)](){for(const[N,re]of nt(this,g,"f"))for(const $e of re)yield[N,$e]}};D=function(N){return N.toLowerCase()},e.$6J=un=Re([V],un);let hn=e.$7J=class{constructor(N){this.insertText=N}};e.$7J=hn=Re([V],hn);let fn=e.$8J=class{constructor(N,re,$e){this.id=re,this.label=$e,this.insertText=N}};e.$8J=fn=Re([V],fn);let Ot=e.$9J=class{constructor(N,re){this.id=N,this.color=re}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$9J=Ot=Re([V],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let dn=e.$0J=class{constructor(N){this.id=N}};e.$0J=dn=Re([V],dn);var mn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(mn||(e.ConfigurationTarget=mn={}));let gn=e.$$J=class{get base(){return this.c}set base(N){this.c=N,this.e=d.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,re){if(typeof N!="string"&&(!N||!d.URI.isUri(N)&&!d.URI.isUri(N.uri)))throw(0,O.$4)("base");if(typeof re!="string")throw(0,O.$4)("pattern");typeof N=="string"?this.baseUri=d.URI.file(N):d.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$J=gn=Re([V],gn);const $n=new WeakMap;function yi(j,N){$n.set(j,N)}e.$_J=yi;let zt=e.$aK=class{constructor(N,re,$e,Me){this.enabled=typeof N=="boolean"?N:!0,typeof re=="string"&&(this.condition=re),typeof $e=="string"&&(this.hitCondition=$e),typeof Me=="string"&&(this.logMessage=Me)}get id(){return this.c||(this.c=$n.get(this)??(0,P.$3e)()),this.c}};e.$aK=zt=Re([V],zt);let bn=e.$bK=class extends zt{constructor(N,re,$e,Me,Ve){if(super(re,$e,Me,Ve),N===null)throw(0,O.$4)("location");this.location=N}};e.$bK=bn=Re([V],bn);let wn=e.$cK=class extends zt{constructor(N,re,$e,Me,Ve){super(re,$e,Me,Ve),this.functionName=N}};e.$cK=wn=Re([V],wn);let pn=e.$dK=class extends zt{constructor(N,re,$e,Me,Ve,_e,tt){if(super(Me,Ve,_e,tt),!re)throw(0,O.$4)("dataId");this.label=N,this.dataId=re,this.canPersist=$e}};e.$dK=pn=Re([V],pn);let yn=e.$eK=class{constructor(N,re,$e){this.command=N,this.args=re||[],this.options=$e}};e.$eK=yn=Re([V],yn);let vn=e.$fK=class{constructor(N,re){this.port=N,this.host=re}};e.$fK=vn=Re([V],vn);let En=e.$gK=class{constructor(N){this.path=N}};e.$gK=En=Re([V],En);let kn=e.$hK=class{constructor(N){this.implementation=N}};e.$hK=kn=Re([V],kn);let Dn=e.$iK=class{constructor(N,re,$e){this.session=N,this.threadId=re,this.frameId=$e}};e.$iK=Dn=Re([V],Dn);let Sn=e.$jK=class{constructor(N,re){this.session=N,this.threadId=re}};e.$jK=Sn=Re([V],Sn);let Pn=e.$kK=class{constructor(N,re){this.range=N,this.expression=re}};e.$kK=Pn=Re([V],Pn);var Cn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Cn||(e.InlineCompletionTriggerKind=Cn={}));let In=e.$lK=class{constructor(N,re){this.range=N,this.text=re}};e.$lK=In=Re([V],In);let An=e.$mK=class{constructor(N,re,$e=!0){this.range=N,this.variableName=re,this.caseSensitiveLookup=$e}};e.$mK=An=Re([V],An);let Ln=e.$nK=class{constructor(N,re){this.range=N,this.expression=re}};e.$nK=Ln=Re([V],Ln);let Rn=e.$oK=class{constructor(N,re){this.frameId=N,this.stoppedLocation=re}};e.$oK=Rn=Re([V],Rn);var On;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(On||(e.FileChangeType=On={}));let Nn=e.$pK=le=class extends Error{static FileExists(N){return new le(N,w.FileSystemProviderErrorCode.FileExists,le.FileExists)}static FileNotFound(N){return new le(N,w.FileSystemProviderErrorCode.FileNotFound,le.FileNotFound)}static FileNotADirectory(N){return new le(N,w.FileSystemProviderErrorCode.FileNotADirectory,le.FileNotADirectory)}static FileIsADirectory(N){return new le(N,w.FileSystemProviderErrorCode.FileIsADirectory,le.FileIsADirectory)}static NoPermissions(N){return new le(N,w.FileSystemProviderErrorCode.NoPermissions,le.NoPermissions)}static Unavailable(N){return new le(N,w.FileSystemProviderErrorCode.Unavailable,le.Unavailable)}constructor(N,re=w.FileSystemProviderErrorCode.Unknown,$e){super(d.URI.isUri(N)?N.toString(!0):N),this.code=$e?.name??"Unknown",(0,w.$3j)(this,re),Object.setPrototypeOf(this,le.prototype),typeof Error.captureStackTrace=="function"&&typeof $e=="function"&&Error.captureStackTrace(this,$e)}};e.$pK=Nn=le=Re([V],Nn);let Fn=e.$qK=class{constructor(N,re,$e){this.start=N,this.end=re,this.kind=$e}};e.$qK=Fn=Re([V],Fn);var Mn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mn||(e.FoldingRangeKind=Mn={}));var jn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(jn||(e.CommentThreadCollapsibleState=jn={}));var Tn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Tn||(e.CommentMode=Tn={}));var Un;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Un||(e.CommentState=Un={}));var zn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(zn||(e.CommentThreadState=zn={}));class vi{constructor(N,re=[]){this.tokenTypes=N,this.tokenModifiers=re}}e.$rK=vi;function Ei(j){return typeof j>"u"||(0,b.$he)(j)}class xt{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let re=0,$e=N.tokenTypes.length;re<$e;re++)this.j.set(N.tokenTypes[re],re);for(let re=0,$e=N.tokenModifiers.length;re<$e;re++)this.k.set(N.tokenModifiers[re],re)}}push(N,re,$e,Me,Ve){if(typeof N=="number"&&typeof re=="number"&&typeof $e=="number"&&typeof Me=="number"&&(typeof Ve=="number"||typeof Ve>"u"))return typeof Ve>"u"&&(Ve=0),this.n(N,re,$e,Me,Ve);if(B.isRange(N)&&typeof re=="string"&&Ei($e))return this.m(N,re,$e);throw(0,O.$4)()}m(N,re,$e){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Me=N.start.line,Ve=N.start.character,_e=N.end.character-N.start.character,tt=this.j.get(re);let ft=0;if($e)for(const wt of $e){if(!this.k.has(wt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this.k.get(wt);ft|=1<<kt>>>0}this.n(Me,Ve,_e,tt,ft)}n(N,re,$e,Me,Ve){if(this.f&&(N<this.c||N===this.c&&re<this.e)){this.f=!1;const ft=this.g.length/5|0;let wt=0,kt=0;for(let Dt=0;Dt<ft;Dt++){let Pt=this.g[5*Dt],qt=this.g[5*Dt+1];Pt===0?(Pt=wt,qt+=kt):Pt+=wt,this.g[5*Dt]=Pt,this.g[5*Dt+1]=qt,wt=Pt,kt=qt}}let _e=N,tt=re;this.f&&this.h>0&&(_e-=this.c,_e===0&&(tt-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=tt,this.g[this.h++]=$e,this.g[this.h++]=Me,this.g[this.h++]=Ve,this.c=N,this.e=re}static o(N){const re=[],$e=N.length/5|0;for(let tt=0;tt<$e;tt++)re[tt]=tt;re.sort((tt,ft)=>{const wt=N[5*tt],kt=N[5*ft];if(wt===kt){const Dt=N[5*tt+1],Pt=N[5*ft+1];return Dt-Pt}return wt-kt});const Me=new Uint32Array(N.length);let Ve=0,_e=0;for(let tt=0;tt<$e;tt++){const ft=5*re[tt],wt=N[ft+0],kt=N[ft+1],Dt=N[ft+2],Pt=N[ft+3],qt=N[ft+4],bi=wt-Ve,Hi=bi===0?kt-_e:kt,Ht=5*tt;Me[Ht+0]=bi,Me[Ht+1]=Hi,Me[Ht+2]=Dt,Me[Ht+3]=Pt,Me[Ht+4]=qt,Ve=wt,_e=kt}return Me}build(N){return this.f?new _t(new Uint32Array(this.g),N):new _t(xt.o(this.g),N)}}e.$sK=xt;class _t{constructor(N,re){this.resultId=re,this.data=N}}e.$tK=_t;class ki{constructor(N,re,$e){this.start=N,this.deleteCount=re,this.data=$e}}e.$uK=ki;class Di{constructor(N,re){this.resultId=re,this.edits=N}}e.$vK=Di;var Bn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Bn||(e.DebugConsoleMode=Bn={}));let en=e.$wK=class{constructor(){}};en.Back={iconPath:new Ot("arrow-left")},e.$wK=en=Re([V],en);var qn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(qn||(e.QuickPickItemKind=qn={}));var Hn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Hn||(e.InputBoxValidationSeverity=Hn={}));var Wn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Wn||(e.ExtensionKind=Wn={}));class Si{static validate(N){if(typeof N.badge=="string"){let re=(0,R.$Td)(N.badge,0);if(re<N.badge.length&&(re+=(0,R.$Td)(N.badge,re)),N.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Ot.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,re,$e){this.badge=N,this.tooltip=re,this.color=$e}}e.$xK=Si;let Vn=e.$yK=class{constructor(N){this.kind=N}};e.$yK=Vn=Re([V],Vn);var Jn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Jn||(e.ColorThemeKind=Jn={}));class Nt{static isNotebookRange(N){return N instanceof Nt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,re){if(N<0)throw(0,O.$4)("start must be positive");if(re<0)throw(0,O.$4)("end must be positive");N<=re?(this.c=N,this.e=re):(this.c=re,this.e=N)}with(N){let re=this.c,$e=this.e;return N.start!==void 0&&(re=N.start),N.end!==void 0&&($e=N.end),re===this.c&&$e===this.e?this:new Nt(re,$e)}}e.$zK=Nt;class Jt{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(re=>Jt.isNotebookCellData(re))}static isNotebookCellData(N){return!0}constructor(N,re,$e,Me,Ve,_e,tt){this.kind=N,this.value=re,this.languageId=$e,this.mime=Me,this.outputs=Ve??[],this.metadata=_e,this.executionSummary=tt,Jt.validate(this)}}e.$AK=Jt;class Pi{constructor(N){this.cells=N}}e.$BK=Pi;class Et{static isNotebookCellOutputItem(N){return N instanceof Et?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const re={name:N.name,message:N.message,stack:N.stack};return Et.json(re,"application/vnd.code.notebook.error")}static stdout(N){return Et.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Et.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,re="application/octet-stream"){return new Et(N,re)}static text(N,re=L.$rr.text){const $e=nt(Et,E,"f",t).encode(String(N));return new Et($e,re)}static json(N,re="text/x-json"){const $e=JSON.stringify(N,void 0,"	");return Et.text($e,re)}constructor(N,re){this.data=N,this.mime=re;const $e=(0,L.$vr)(re,!0);if(!$e)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=$e}}e.$CK=Et,E=Et,t={value:new TextEncoder};class Gt{static isNotebookCellOutput(N){return N instanceof Gt?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,re=!1){const $e=new Set,Me=new Set;for(let Ve=0;Ve<N.length;Ve++){const _e=N[Ve],tt=(0,L.$vr)(_e.mime);if(!$e.has(tt)||(0,m.$hH)(tt)){$e.add(tt);continue}Me.add(Ve),re&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Me.size===0?N:N.filter((Ve,_e)=>!Me.has(_e))}constructor(N,re,$e){this.items=Gt.ensureUniqueMimeTypes(N,!0),typeof re=="string"?(this.id=re,this.metadata=$e):(this.id=(0,P.$3e)(),this.metadata=re??$e)}}e.$DK=Gt;var Gn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Gn||(e.NotebookCellKind=Gn={}));var Kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Kn||(e.NotebookCellExecutionState=Kn={}));var Xn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Xn||(e.NotebookCellStatusBarAlignment=Xn={}));var Zn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Zn||(e.NotebookEditorRevealType=Zn={}));class Ci{constructor(N,re){this.text=N,this.alignment=re}}e.$EK=Ci;var Qn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Qn||(e.NotebookControllerAffinity=Qn={}));var Yn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Yn||(e.NotebookControllerAffinity2=Yn={}));class Ii{constructor(N,re=[]){this.uri=N,this.provides=(0,y.$Gf)(re)}}e.$FK=Ii;class Ai{constructor(N){this.label=N}}e.$GK=Ai;let xn=e.$HK=class{constructor(N,re){this.label=N,this.timestamp=re}};e.$HK=xn=Re([V],xn);var _n;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(_n||(e.ExtensionMode=_n={}));var ei;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ei||(e.ExtensionRuntime=ei={}));var ti;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ti||(e.StandardTokenType=ti={}));class Li{constructor(N,re){this.ranges=N,this.wordPattern=re}}e.$IK=Li;class Ri{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$JK=Ri;var ni;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ni||(e.TestResultState=ni={}));var ii;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ii||(e.TestRunProfileKind=ii={}));let tn=e.$KK=class{constructor(N=void 0,re=void 0,$e=void 0,Me=!1){this.include=N,this.exclude=re,this.profile=$e,this.continuous=Me}};e.$KK=tn=Re([V],tn);let si=e.$LK=class extends tn{};e.$LK=si=Re([V],si);let ri=e.$MK=ge=class{static diff(N,re,$e){const Me=new ge(N);return Me.expectedOutput=re,Me.actualOutput=$e,Me}constructor(N){this.message=N}};e.$MK=ri=ge=Re([V],ri);let oi=e.$NK=class{constructor(N){this.id=N}};e.$NK=oi=Re([V],oi);let Bt=e.$OK=class{constructor(N,re){this.covered=N,this.total=re}};e.$OK=Bt=Re([V],Bt);let ai=e.$PK=se=class{static fromDetails(N,re){const $e=new Bt(0,0),Me=new Bt(0,0),Ve=new Bt(0,0);for(const tt of re)if("branches"in tt){$e.total+=1,$e.covered+=tt.executionCount>0?1:0;for(const ft of tt.branches)Me.total+=1,Me.covered+=ft.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=tt.executionCount>0?1:0;const _e=new se(N,$e,Me.total>0?Me:void 0,Ve.total>0?Ve:void 0);return _e.detailedCoverage=re,_e}constructor(N,re,$e,Me){this.uri=N,this.statementCoverage=re,this.branchCoverage=$e,this.functionCoverage=Me}};e.$PK=ai=se=Re([V],ai);let ci=e.$QK=class{constructor(N,re,$e=[]){this.executionCount=N,this.location=re,this.branches=$e}};e.$QK=ci=Re([V],ci);let li=e.$RK=class{constructor(N,re){this.executionCount=N,this.location=re}};e.$RK=li=Re([V],li);let ui=e.$SK=class{constructor(N,re){this.executionCount=N,this.location=re}};e.$SK=ui=Re([V],ui);var hi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(hi||(e.ExternalUriOpenerPriority=hi={}));var fi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(fi||(e.WorkspaceTrustState=fi={}));var di;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(di||(e.PortAutoForwardAction=di={}));class Oi{constructor(N,re,$e,Me,Ve,_e){this.kind=N,this.name=re,this.detail=$e,this.uri=Me,this.range=Ve,this.selectionRange=_e}}e.$TK=Oi;class Ni{constructor(N){this.uri=N}}e.$UK=Ni;class Fi{constructor(N,re){this.original=N,this.modified=re}}e.$VK=Fi;class Mi{constructor(N,re,$e,Me){this.base=N,this.input1=re,this.input2=$e,this.result=Me}}e.$WK=Mi;class ji{constructor(N,re){this.uri=N,this.viewType=re}}e.$XK=ji;class Ti{constructor(N){this.viewType=N}}e.$YK=Ti;class Ui{constructor(N,re){this.uri=N,this.notebookType=re}}e.$ZK=Ui;class zi{constructor(N,re,$e){this.original=N,this.modified=re,this.notebookType=$e}}e.$1K=zi;class Bi{constructor(){}}e.$2K=Bi;class qi{constructor(N,re){this.uri=N,this.inputBoxUri=re}}e.$3K=qi;var mi;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(mi||(e.InteractiveSessionVoteDirection=mi={}));var gi;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(gi||(e.InteractiveSessionCopyKind=gi={}));var $i;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone"})($i||(e.InteractiveEditorResponseFeedbackKind=$i={}))}),define(be[267],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=void 0,e.$ZL=(0,y.$lh)("environmentVariableService")}),define(be[268],we([1,0,7,4,59,3,245,8]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0;function b(E,t){if(t)if(I.$d)for(const i in t){let r=i;for(const s in E)if(i.toLowerCase()===s.toLowerCase()){r=s;break}const n=t[i];n!==void 0&&d(E,r,n)}else Object.keys(t).forEach(i=>{const r=t[i];r!==void 0&&d(E,i,r)})}e.$7L=b;function d(E,t,i){typeof i=="string"?E[t]=i:delete E[t]}function P(E,t,i,r){E.TERM_PROGRAM="vscode",t&&(E.TERM_PROGRAM_VERSION=t),h(E,r)&&(E.LANG=m(i)),E.COLORTERM="truecolor"}e.$8L=P;function p(E,t){if(t)for(const i of Object.keys(t)){const r=t[i];r!=null&&(E[i]=r)}}async function w(E,t){return await Promise.all(Object.entries(t).map(async([i,r])=>{if(typeof r=="string")try{t[i]=await E(r)}catch{t[i]=r}})),t}function h(E,t){if(t==="on")return!0;if(t==="auto"){const i=E.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$9L=h;function m(E){const t=E?E.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$0L=m;async function $(E,t,i,r,n,s){if(E.cwd){const f=typeof E.cwd=="object"?E.cwd.fsPath:E.cwd,k=await o(f,i);return(0,L.$5L)(k||f)}let c;return!E.ignoreConfigurationCwd&&n&&(i&&(n=await o(n,i,s)),n&&(y.$0b(n)?c=n:r&&(c=y.$$b(r.fsPath,n)))),c||(c=r?r.fsPath:t||""),(0,L.$5L)(c)}e.$$L=$;async function o(E,t,i){if(t)try{return await t(E)}catch(r){i?.error("Could not resolve terminal cwd",r);return}return E}function u(E,t,i){if(i)return r=>i.resolveWithEnvironment(t,E,r)}e.$_L=u;async function l(E,t,i,r,n,s){const c={};if(E.strictEnv)p(c,E.env);else{p(c,s);const f={...t};i&&(f&&await w(i,f),E.env&&await w(i,E.env)),(0,a.$cl)(c,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),b(c,f),b(c,E.env),P(c,r,I.$q,n)}return c}e.$aM=l;async function g(E,t,i,r,n,s,c=I.$d){let f;if((0,R.$ge)(E)?f=E:(f=E.fsPath,c&&s!==1?f=f.replace(/\\/g,"/"):!c&&s===1&&(f=f.replace(/\//g,"\\"))),!t)return f;const k=f.includes(" "),v=f.includes("(")||f.includes(")"),C=y.$cc(t,".exe"),A=C==="pwsh"||i==="pwsh"||C==="powershell"||i==="powershell";if(A&&(k||f.includes("'")))return`& '${f.replace(/'/g,"''")}'`;if(v&&A)return`& '${f}'`;if(s===1){if(r!==void 0)return r==="gitbash"?(0,L.$3L)(f.replace(/\\/g,"/")):r==="wsl"?n?.getWslPath(f,"win-to-unix")||f:k?`"${f}"`:f;const M=t.toLowerCase();return M.includes("wsl")||M.includes("bash.exe")&&!M.toLowerCase().includes("git")?n?.getWslPath(f,"win-to-unix")||f:k?`"${f}"`:f}return(0,L.$3L)(f)}e.$bM=g;function D(E,t,i){const r=typeof E=="string"?O.URI.parse(E):E;let n=r?(0,R.$ye)(t.getWorkspaceFolder(r)):void 0;if(!n){const s=i.getLastActiveWorkspaceRoot();n=s?(0,R.$ye)(t.getWorkspaceFolder(s)):void 0}return n}e.$cM=D}),define(be[69],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(I){I.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var O;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class a{static fromExtHostTestItem(L,R,b=L.parent){if(L._isRoot)return new a([R]);const d=[L.id];for(let P=b;P&&P.id!==R;P=P.parent)d.push(P.id);return d.push(R),new a(d.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const R=L.indexOf("\0");return R===-1?L:L.slice(0,R)}static fromString(L){return new a(L.split("\0"))}static join(L,R){return new a([...L.path,R])}static joinToString(L,R){return L.toString()+"\0"+R}static parentId(L){const R=L.lastIndexOf("\0");return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf("\0");return R===-1?L:L.slice(R+1)}static isChild(L,R){return R.startsWith(L)&&R[L.length]==="\0"}static compare(L,R){return L===R?0:a.isChild(L,R)?2:a.isChild(R,L)?3:1}constructor(L,R=L.length){if(this.path=L,this.d=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new a(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new a(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new a(this.path,L)}compare(L){if(typeof L=="string")return a.compare(this.toString(),L);for(let R=0;R<L.d&&R<this.d;R++)if(L.path[R]!==this.path[R])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$XH=a}),define(be[91],we([1,0,4,52,69]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$4H=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3H=e.$2H=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1H=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZH=e.$YH=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var I;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(I||(e.TestResultState=I={}));var L;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var R;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(R||(e.TestRunProfileBitset=R={})),e.$YH=[2,4,8,16,32,64];const b=k=>"runId"in k;e.$ZH=b;var d;(function(k){k.serialize=v=>({range:v.range.toJSON(),uri:v.uri.toJSON()}),k.deserialize=v=>({range:O.$Lr.lift(v.range),uri:y.URI.revive(v.uri)})})(d||(e.IRichLocation=d={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var p;(function(k){k.serialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&d.serialize(v.location)}),k.deserialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&d.deserialize(v.location)})})(p||(e.ITestErrorMessage=p={}));const w=(k,v)=>`${v?"s":"e"}${k}`;e.$1H=w;var h;(function(k){k.serialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&d.serialize(v.location)}),k.deserialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&d.deserialize(v.location)})})(h||(e.ITestOutputMessage=h={}));var m;(function(k){k.serialize=v=>v.type===0?p.serialize(v):h.serialize(v),k.deserialize=v=>v.type===0?p.deserialize(v):h.deserialize(v)})(m||(e.ITestMessage=m={}));var $;(function(k){k.serializeWithoutMessages=v=>({state:v.state,duration:v.duration,messages:[]}),k.serialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(m.serialize)}),k.deserialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(m.deserialize)})})($||(e.ITestTaskState=$={}));const o="\0",u=(k,v)=>k+o+v;e.$2H=u;const l=k=>{const v=k.indexOf(o);return{ctrlId:k.slice(0,v),tagId:k.slice(v+1)}};e.$3H=l;var g;(function(k){k.serialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?.toJSON(),range:v.range?.toJSON()||null,description:v.description,error:v.error,sortText:v.sortText}),k.deserialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?y.URI.revive(v.uri):void 0,range:v.range?O.$Lr.lift(v.range):null,description:v.description,error:v.error,sortText:v.sortText})})(g||(e.ITestItem=g={}));var D;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var E;(function(k){k.serialize=v=>({expand:v.expand,item:g.serialize(v.item)}),k.deserialize=v=>({controllerId:a.$XH.root(v.item.extId),expand:v.expand,item:g.deserialize(v.item)})})(E||(e.InternalTestItem=E={}));var t;(function(k){k.serialize=v=>{let C;return v.item&&(C={},v.item.label!==void 0&&(C.label=v.item.label),v.item.tags!==void 0&&(C.tags=v.item.tags),v.item.busy!==void 0&&(C.busy=v.item.busy),v.item.uri!==void 0&&(C.uri=v.item.uri?.toJSON()),v.item.range!==void 0&&(C.range=v.item.range?.toJSON()),v.item.description!==void 0&&(C.description=v.item.description),v.item.error!==void 0&&(C.error=v.item.error),v.item.sortText!==void 0&&(C.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:C}},k.deserialize=v=>{let C;return v.item&&(C={},v.item.label!==void 0&&(C.label=v.item.label),v.item.tags!==void 0&&(C.tags=v.item.tags),v.item.busy!==void 0&&(C.busy=v.item.busy),v.item.range!==void 0&&(C.range=v.item.range?O.$Lr.lift(v.item.range):null),v.item.description!==void 0&&(C.description=v.item.description),v.item.error!==void 0&&(C.error=v.item.error),v.item.sortText!==void 0&&(C.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:C}}})(t||(e.ITestItemUpdate=t={}));const i=(k,v)=>{v.expand!==void 0&&(k.expand=v.expand),v.item!==void 0&&(k.item=k.item?Object.assign(k.item,v.item):v.item)};e.$4H=i;var r;(function(k){k.serializeWithoutMessages=v=>({...E.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map($.serializeWithoutMessages)}),k.serialize=v=>({...E.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map($.serialize)}),k.deserialize=v=>({...E.deserialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map($.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var n;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(n||(e.DetailType=n={}));var s;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(s||(e.TestDiffOpType=s={}));var c;(function(k){k.deserialize=v=>v.op===0?{op:v.op,item:E.deserialize(v.item)}:v.op===1?{op:v.op,item:t.deserialize(v.item)}:v.op===2?{op:v.op,uri:y.URI.revive(v.uri),docv:v.docv}:v,k.serialize=v=>v.op===0?{op:v.op,item:E.serialize(v.item)}:v.op===1?{op:v.op,item:t.serialize(v.item)}:v})(c||(e.TestsDiffOp=c={}));class f{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(v){const C=this.o();for(const A of v)switch(A.op){case 0:this.j(E.deserialize(A.item),C);break;case 1:this.k(t.deserialize(A.item),C);break;case 3:this.l(A.itemId,C);break;case 5:this.m(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}C.complete?.()}j(v,C){const A=a.$XH.parentId(v.item.extId)?.toString();let M;if(!A)M=this.p(v),this.f.add(M),this.d.set(v.item.extId,M);else if(this.d.has(A)){const K=this.d.get(A);K.children.add(v.item.extId),M=this.p(v,K),this.d.set(v.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(v)}`);return}return C.add?.(M),v.expand===2&&this.g++,M}k(v,C){const A=this.d.get(v.extId);if(A)return v.expand!==void 0&&(A.expand===2&&this.g--,v.expand===2&&this.g++),(0,e.$4H)(A,v),C.update?.(A),A}l(v,C){const A=this.d.get(v);if(!A)return;const M=a.$XH.parentId(A.item.extId)?.toString();M?this.d.get(M).children.delete(A.item.extId):this.f.delete(A);const K=[[v]];for(;K.length;)for(const te of K.pop()){const he=this.d.get(te);he&&(K.push(he.children),this.d.delete(te),C.remove?.(he,he!==A),he.expand===2&&this.g--)}}m(v){}updatePendingRoots(v){this.h+=v}o(){return{}}}e.$5H=f}),define(be[131],we([1,0,14,5,2,94,91,69]),function(ae,e,y,O,a,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TestItemEventOp=void 0;var b;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const d=(l,g)=>l===g,p=Object.entries({range:(l,g)=>l===g?!0:!l||!g?!1:l.equalsRange(g),busy:d,label:d,description:d,error:d,sortText:d,tags:(l,g)=>!(l.length!==g.length||l.some(D=>!g.includes(D)))}),w=(l,g)=>{let D;for(const[E,t]of p)t(l[E],g[E])||(D?D[E]=g[E]:D={[E]:g[E]});return D};class h extends a.$kb{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new y.$Cg(()=>this.flushDiff(),200)),this.g=this.B(new O.$5c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===g.uri){D.docv=g.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===g.item.extId){(0,L.$4H)(D.item,g.item);return}if(D.op===0&&D.item.item.extId===g.item.extId){(0,L.$4H)(D.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,D){const E=this.tree.get(g);if(E){if((E.expandLevels===void 0||D>E.expandLevels)&&(E.expandLevels=D),E.expand===1){const t=this.I(E);return t.isOpen()?this.H(E,D-1):t.wait().then(()=>this.H(E,D-1))}else if(E.expand===3)return E.resolveBarrier?.isOpen()===!1?E.resolveBarrier.wait().then(()=>this.H(E,D-1)):this.H(E,D-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,D){switch(D.op){case 3:this.L(R.$XH.joinToString(g.fullId,D.id));break;case 0:this.u(D.item,g);break;case 5:for(const E of D.ops)this.p(g,E);break;case 1:this.w(D.new,D.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:D.update}});break;case 6:this.s(g.actual.uri);break;default:(0,I.$lc)(D)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,D){const E=R.$XH.fromExtHostTestItem(g,this.root.id,D?.actual),t=this.m.getApiFor(g);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(g.id);let i=this.tree.get(E.toString());if(!i){i={fullId:E,actual:g,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(i.fullId.toString(),i),this.C(g,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:i.expand,item:this.m.toITestItem(g)}}),this.F(g,i,D);return}if(i.actual===g){this.D(g,i,D);return}if(i.actual.uri?.toString()!==g.uri?.toString())return this.L(E.toString()),this.u(g,D);const r=this.m.getChildren(i.actual),n=i.actual,s=w(this.m.toITestItem(n),this.m.toITestItem(g));this.m.getApiFor(n).listener=void 0,i.actual=g,i.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(g.tags,n.tags,E.toString()),delete s.tags),this.p(i,{op:4,update:s})),this.F(g,i,D);for(const[c,f]of r)this.m.getChildren(g).get(f.id)||this.L(R.$XH.joinToString(E,f.id));this.s(i.actual.uri)}w(g,D,E){const t=new Set(D.map(i=>i.id));for(const i of g)t.delete(i.id)||this.y(i);this.pushDiff({op:1,item:{extId:E,item:{tags:g.map(i=>(0,L.$2H)(this.m.controllerId,i.id))}}}),t.forEach(this.z,this)}y(g){const D=this.j.get(g.id);D?D.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$2H)(this.m.controllerId,g.id)}}))}z(g){const D=this.j.get(g);D&&!--D.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,L.$2H)(this.m.controllerId,g)}))}C(g,D){this.m.getApiFor(g).parent=D&&D.actual!==this.root?D.actual:void 0}D(g,D,E){this.C(g,E);const t=this.m.getApiFor(g);t.parent=E?.actual,t.listener=i=>this.p(D,i),this.G(D)}F(g,D,E){this.D(g,D,E);for(const[t,i]of this.m.getChildren(g))this.u(i,D)}G(g){let D;this.h?g.resolveBarrier?D=g.resolveBarrier.isOpen()?3:2:D=g.actual.canResolveChildren?1:0:D=0,D!==g.expand&&(g.expand=D,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:D}}),D===1&&g.expandLevels!==void 0&&this.I(g))}H(g,D){if(D<0)return;const E=[];for(const[t,i]of this.m.getChildren(g.actual)){const r=this.expand(R.$XH.joinToString(g.fullId,i.id),D);(0,y.$eg)(r)&&E.push(r)}if(E.length)return Promise.all(E).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const i=new y.$qg;return i.open(),i}g.expand=2,this.J(g);const D=g.resolveBarrier=new y.$qg,E=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,i)};let t;try{t=this.h(g.actual===this.root?void 0:g.actual)}catch(i){E(i)}return(0,y.$eg)(t)?t.catch(E).then(()=>{D.open(),this.G(g)}):(D.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const D=this.tree.get(g);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const E=[D];for(;E.length;){const t=E.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.z(i.id);this.tree.delete(t.fullId.toString());for(const[i,r]of this.m.getChildren(t.actual))E.push(this.tree.get(R.$XH.joinToString(t.fullId,r.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$4K=h;class m extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$5K=m;class $ extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6K=$;class o extends Error{constructor(g,D,E){super(`TestItem with ID "${g}" is from controller "${D}" and cannot be added as a child of an item from controller "${E}".`)}}e.$7K=o;const u=(l,g,D)=>{let E=new Map;return{get size(){return E.size},forEach(t,i){for(const r of E.values())t.call(i,r,this)},[Symbol.iterator](){return E.entries()},replace(t){const i=new Map,r=new Set(E.keys()),n={op:5,ops:[]};for(const s of t){if(!(s instanceof D))throw new $(s.id);const c=g(s).controllerId;if(c!==l.controllerId)throw new o(s.id,c,l.controllerId);if(i.has(s.id))throw new m(s.id);i.set(s.id,s),r.delete(s.id),n.ops.push({op:0,item:s})}for(const s of r.keys())n.ops.push({op:3,id:s});l.listener?.(n),E=i},add(t){if(!(t instanceof D))throw new $(t.id);E.set(t.id,t),l.listener?.({op:0,item:t})},delete(t){E.delete(t)&&l.listener?.({op:3,id:t})},get(t){return E.get(t)},toJSON(){return Array.from(E.values())}}};e.$8K=u}),define(be[132],we([1,0,131]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.$9K=void 0;const O=new WeakMap,a=(L,R)=>{const b={controllerId:R};return O.set(L,b),b};e.$9K=a;const I=L=>{const R=O.get(L);if(!R)throw new y.$6K(L?.id||"<unknown>");return R};e.$0K=I}),define(be[269],we([1,0,24,6]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=void 0,e.$oD=".vscode",e.$pD="settings",e.$qD=`${e.$oD}/${e.$pD}.json`,e.$rD="vscode://schemas/settings/default",e.$sD="vscode://schemas/settings/user",e.$tD="vscode://schemas/settings/profile",e.$uD="vscode://schemas/settings/machine",e.$vD="vscode://schemas/settings/workspace",e.$wD="vscode://schemas/settings/folder",e.$xD="vscode://schemas/launch",e.$yD="vscode://schemas/tasks",e.$zD=[1],e.$AD=[2,3,4,5,6],e.$BD=[3,4,5],e.$CD=[1,...e.$BD],e.$DD=[2,3,4,5,6],e.$ED=[3,4,5,6],e.$FD=[4,5,6],e.$GD="tasks",e.$HD="launch",e.$ID=Object.create(null),e.$ID[e.$GD]=`${e.$oD}/${e.$GD}.json`,e.$ID[e.$HD]=`${e.$oD}/${e.$HD}.json`,e.$JD=Object.create(null),e.$JD[e.$GD]=`${e.$GD}.json`,e.$KD=(0,O.$mh)(y.$Rh),e.$LD=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(be[133],we([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.VariableKind=e.$EL=void 0,e.$EL=(0,y.$lh)("configurationResolverService");var O;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class a extends Error{constructor(L,R){super(R),this.variable=L}}e.$FL=a}),define(be[270],we([1,0,7,29,8,22,3,149,199,133,17]),function(ae,e,y,O,a,I,L,R,b,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0;class p{constructor(h,m,$,o){this.h=new Map,this.a=h,this.b=m,this.g=$,o&&(this.c=o.then(u=>this.i(u)))}i(h){if(L.$d){const m=Object.create(null);return Object.keys(h).forEach($=>{m[$.toLowerCase()]=h[$]}),m}return h}resolveWithEnvironment(h,m,$){return this.l({env:this.i(h),userHome:void 0},m?m.uri:void 0,$)}async resolveAsync(h,m){const $={env:await this.c,userHome:await this.g};return this.l($,h?h.uri:void 0,m)}async j(h,m,$,o){const u=I.$Em(m);L.$d&&u.windows?Object.keys(u.windows).forEach(g=>u[g]=u.windows[g]):L.$e&&u.osx?Object.keys(u.osx).forEach(g=>u[g]=u.osx[g]):L.$f&&u.linux&&Object.keys(u.linux).forEach(g=>u[g]=u.linux[g]),delete u.windows,delete u.osx,delete u.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,h?h.uri:void 0,u,$,o)}async resolveAnyAsync(h,m,$){return this.j(h,m,$)}async resolveAnyMap(h,m,$){const o=new Map;return{newConfig:await this.j(h,m,$,o),resolvedVariables:o}}resolveWithInteractionReplace(h,m,$,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(h,m,$,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(h,m){if(this.h.has(h))throw new Error("Variable "+h+" is contributed twice.");this.h.set(h,m)}async l(h,m,$,o,u){if(a.$ge($))return this.m(h,m,$,o,u);if(Array.isArray($))return Promise.all($.map(l=>this.l(h,m,l,o,u)));if(a.$ie($)){const l=Object.create(null),g=await Promise.all(Object.keys($).map(async D=>[await this.m(h,m,D,o,u),await this.l(h,m,$[D],o,u)]));for(const[D,E]of g)l[D]=E;return l}return $}m(h,m,$,o,u){return(0,P.$Bd)($,p.VARIABLE_REGEXP,async(l,g)=>{if(g.includes(p.VARIABLE_LHS))return l;let D=await this.o(h,l,g,m,o);return u?.set(g,D),D!==l&&a.$ge(D)&&D.match(p.VARIABLE_REGEXP)&&(D=await this.m(h,m,D,o,u)),D})}n(h){return this.b?this.b.getUriLabel(h,{noPrefix:!0}):h.fsPath}async o(h,m,$,o,u){let l;const g=$.split(":");g.length>1&&($=g[0],l=g[1]);const D=i=>{const r=this.a.getFilePath();if(r)return(0,R.$Pz)(r);throw new d.$FL(i,(0,b.localize)(0,null,m))},E=i=>{const r=D(i);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,R.$Pz)(n)}throw new d.$FL(i,(0,b.localize)(1,null,m,y.$cc(r)))},t=i=>{if(l){const r=this.a.getFolderUri(l);if(r)return r;throw new d.$FL(i,(0,b.localize)(2,null,m,l))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new d.$FL(i,(0,b.localize)(3,null,m)):new d.$FL(i,(0,b.localize)(4,null,m))};switch($){case"env":if(l){if(h.env){const i=h.env[L.$d?l.toLowerCase():l];if(a.$ge(i))return i}return""}throw new d.$FL(d.VariableKind.Env,(0,b.localize)(5,null,m));case"config":if(l){const i=this.a.getConfigurationValue(o,l);if(a.$pe(i))throw new d.$FL(d.VariableKind.Config,(0,b.localize)(6,null,m,l));if(a.$ie(i))throw new d.$FL(d.VariableKind.Config,(0,b.localize)(7,null,m,l));return i}throw new d.$FL(d.VariableKind.Config,(0,b.localize)(8,null,m));case"command":return this.p(d.VariableKind.Command,m,l,u,"command");case"input":return this.p(d.VariableKind.Input,m,l,u,"input");case"extensionInstallFolder":if(l){const i=await this.a.getExtension(l);if(!i)throw new d.$FL(d.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,m,l));return this.n(i.extensionLocation)}throw new d.$FL(d.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,m));default:switch($){case"workspaceRoot":case"workspaceFolder":return(0,R.$Pz)(this.n(t(d.VariableKind.WorkspaceFolder)));case"cwd":return o||l?(0,R.$Pz)(this.n(t(d.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Pz)(y.$cc(this.n(t(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(h.userHome)return h.userHome;throw new d.$FL(d.VariableKind.UserHome,(0,b.localize)(11,null,m))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new d.$FL(d.VariableKind.LineNumber,(0,b.localize)(12,null,m))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new d.$FL(d.VariableKind.SelectedText,(0,b.localize)(13,null,m))}case"file":return D(d.VariableKind.File);case"fileWorkspaceFolder":return E(d.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||l?y.$ac(this.n(t(d.VariableKind.RelativeFile)),D(d.VariableKind.RelativeFile)):D(d.VariableKind.RelativeFile);case"relativeFileDirname":{const i=y.$bc(D(d.VariableKind.RelativeFileDirname));if(o||l){const r=y.$ac(this.n(t(d.VariableKind.RelativeFileDirname)),i);return r.length===0?".":r}return i}case"fileDirname":return y.$bc(D(d.VariableKind.FileDirname));case"fileExtname":return y.$dc(D(d.VariableKind.FileExtname));case"fileBasename":return y.$cc(D(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=y.$cc(D(d.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-y.$dc(i).length)}case"fileDirnameBasename":return y.$cc(y.$bc(D(d.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||m}case"execInstallFolder":{const i=this.a.getAppRoot();return i||m}case"pathSeparator":return y.sep;default:try{const i=l?`${$}:${l}`:$;return this.p(d.VariableKind.Unknown,m,i,u,void 0)}catch{return m}}}}p(h,m,$,o,u){if($&&o){const l=u===void 0?o[$]:o[u+":"+$];if(typeof l=="string")return l;throw new d.$FL(h,(0,b.localize)(14,null,m))}return m}}e.$dM=p,p.VARIABLE_LHS="${",p.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[271],we([1,0,6,90]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,y.$lh)("editorGroupsService");var a;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(a||(e.GroupDirection=a={}));var I;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var L;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R||(e.GroupsArrangement=R={}));var b;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function d(m){const $=m;return(0,O.$fE)($?.editor)&&(0,O.$fE)($?.replacement)}e.$sC=d;var P;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var p;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(p||(e.OpenEditorContext=p={}));function w(m){const $=m;return!!$&&typeof $.id=="number"&&Array.isArray($.editors)}e.$tC=w;function h(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=h}),define(be[134],we([1,0,6,271]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,y.$lh)("editorService"),e.$wC=-1,e.$xC=-2;function a(I){const L=I;return typeof I=="number"||(0,O.$tC)(L)}e.$yC=a}),define(be[135],we([1,0,18,15,150,71,100,28,141,49,58,22,8,4,52,159,223,132,90,129,69,91,134,130]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aL=e.$_K=e.MarkdownString=e.$$K=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(ve){function ke(x){const{selectionStartLineNumber:Pe,selectionStartColumn:Ne,positionLineNumber:We,positionColumn:Ue}=x,Qe=new i.$cJ(Pe-1,Ne-1),lt=new i.$cJ(We-1,Ue-1);return new i.$eJ(Qe,lt)}ve.to=ke;function de(x){const{anchor:Pe,active:Ne}=x;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ve.from=de})(r||(e.Selection=r={}));var n;(function(ve){function ke(x){if(!x)return;const{start:Pe,end:Ne}=x;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ve.from=ke;function de(x){if(!x)return;const{startLineNumber:Pe,startColumn:Ne,endLineNumber:We,endColumn:Ue}=x;return new i.$dJ(Pe-1,Ne-1,We-1,Ue-1)}ve.to=de})(n||(e.Range=n={}));var s;(function(ve){function ke(de){switch(de){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}ve.to=ke})(s||(e.TokenType=s={}));var c;(function(ve){function ke(x){return new i.$cJ(x.lineNumber-1,x.column-1)}ve.to=ke;function de(x){return{lineNumber:x.line+1,column:x.character+1}}ve.from=de})(c||(e.Position=c={}));var f;(function(ve){function ke(Pe,Ne,We){return(0,y.$jf)((0,y.$Gf)(Pe).map(Ue=>de(Ue,Ne,We)))}ve.from=ke;function de(Pe,Ne,We){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:We?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:x(Pe.scheme,Ne),pattern:De.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:We?.isBuiltin}}function x(Pe,Ne){return Ne&&typeof Pe=="string"?Ne.transformOutgoingScheme(Pe):Pe}})(f||(e.DocumentSelector=f={}));var k;(function(ve){function ke(x){switch(x){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}ve.from=ke;function de(x){switch(x){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}ve.to=de})(k||(e.DiagnosticTag=k={}));var v;(function(ve){function ke(x){let Pe;return x.code&&((0,w.$ge)(x.code)||(0,w.$ke)(x.code)?Pe=String(x.code):Pe={value:String(x.code.value),target:x.code.target}),{...n.from(x.range),message:x.message,source:x.source,code:Pe,severity:A.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(C.from),tags:Array.isArray(x.tags)?(0,y.$jf)(x.tags.map(k.from)):void 0}}ve.from=ke;function de(x){const Pe=new i.$pJ(n.to(x),x.message,A.to(x.severity));return Pe.source=x.source,Pe.code=(0,w.$ge)(x.code)?x.code:x.code?.value,Pe.relatedInformation=x.relatedInformation&&x.relatedInformation.map(C.to),Pe.tags=x.tags&&(0,y.$jf)(x.tags.map(k.to)),Pe}ve.to=de})(v||(e.Diagnostic=v={}));var C;(function(ve){function ke(x){return{...n.from(x.location.range),message:x.message,resource:x.location.uri}}ve.from=ke;function de(x){return new i.$oJ(new i.$nJ(x.resource,n.to(x)),x.message)}ve.to=de})(C||(e.DiagnosticRelatedInformation=C={}));var A;(function(ve){function ke(x){switch(x){case i.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ve.from=ke;function de(x){switch(x){case o.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}ve.to=de})(A||(e.DiagnosticSeverity=A={}));var M;(function(ve){function ke(x){return typeof x=="number"&&x>=i.ViewColumn.One?x-1:x===i.ViewColumn.Beside?t.$xC:t.$wC}ve.from=ke;function de(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=de})(M||(e.ViewColumn=M={}));function K(ve){return typeof ve.range<"u"}function te(ve){return ve.length===0?!0:!!K(ve[0])}e.$$K=te;var he;(function(ve){function ke(Ue){return Ue.map(ve.from)}ve.fromMany=ke;function de(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function x(Ue){let Qe;if(de(Ue)){const{language:at,value:mt}=Ue;Qe={value:"```"+at+`
`+mt+"\n```\n"}}else i.$CJ.isMarkdownString(Ue)?Qe={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?Qe={value:Ue}:Qe={value:""};const lt=Object.create(null);Qe.uris=lt;const ht=at=>{try{let mt=h.URI.parse(at,!0);mt=mt.with({query:Pe(mt.query,lt)}),lt[at]=mt}catch{}return""},bt=new b.marked.Renderer;return bt.link=ht,bt.image=at=>typeof at=="string"?ht(L.$Nj(at).href):"",(0,b.marked)(Qe.value,{renderer:bt}),Qe}ve.from=x;function Pe(Ue,Qe){if(!Ue)return Ue;let lt;try{lt=(0,d.$Tg)(Ue)}catch{}if(!lt)return Ue;let ht=!1;return lt=(0,p.$Gm)(lt,bt=>{if(h.URI.isUri(bt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[at]=bt,ht=!0,at}else return}),ht?JSON.stringify(lt):Ue}function Ne(Ue){const Qe=new i.$CJ(Ue.value,Ue.supportThemeIcons);return Qe.isTrusted=Ue.isTrusted,Qe.supportHtml=Ue.supportHtml,Qe.baseUri=Ue.baseUri?h.URI.from(Ue.baseUri):void 0,Qe}ve.to=Ne;function We(Ue){if(Ue)return typeof Ue=="string"?Ue:ve.from(Ue)}ve.fromStrict=We})(he||(e.MarkdownString=he={}));function ce(ve){return te(ve)?ve.map(ke=>({range:n.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?he.fromMany(ke.hoverMessage):ke.hoverMessage?he.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):ve.map(ke=>({range:n.from(ke)}))}e.$_K=ce;function le(ve){return typeof ve>"u"?ve:typeof ve=="string"?h.URI.file(ve):ve}e.$aL=le;var ge;(function(ve){function ke(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?le(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}ve.from=ke})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var se;(function(ve){function ke(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?le(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ge.from(de.before):void 0,after:de.after?ge.from(de.after):void 0}}ve.from=ke})(se||(e.ThemableDecorationRenderOptions=se={}));var V;(function(ve){function ke(de){if(typeof de>"u")return de;switch(de){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ke})(V||(e.DecorationRangeBehavior=V={}));var ie;(function(ve){function ke(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?V.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?se.from(de.light):void 0,dark:de.dark?se.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?le(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ge.from(de.before):void 0,after:de.after?ge.from(de.after):void 0}}ve.from=ke})(ie||(e.DecorationRenderOptions=ie={}));var J;(function(ve){function ke(x){return{text:x.newText,eol:x.newEol&&Ye.from(x.newEol),range:n.from(x.range)}}ve.from=ke;function de(x){const Pe=new i.$iJ(n.to(x.range),x.text);return Pe.newEol=typeof x.eol>"u"?void 0:Ye.to(x.eol),Pe}ve.to=de})(J||(e.TextEdit=J={}));var Z;(function(ve){function ke(x,Pe){const Ne={edits:[]};if(x instanceof i.$lJ){const We=new R.$ki;for(const Ue of x._allEntries())Ue._type===1&&h.URI.isUri(Ue.to)&&Ue.from===void 0&&We.add(Ue.to);for(const Ue of x._allEntries())if(Ue._type===1){let Qe;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?Qe={type:"base64",value:(0,O.$2b)(O.$Ib.wrap(Ue.options.contents))}:Qe={type:"dataTransferItem",id:Ue.options.contents._itemId}),Ne.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:Qe},metadata:Ue.metadata})}else Ue._type===2?Ne.edits.push({resource:Ue.uri,textEdit:J.from(Ue.edit),versionId:We.has(Ue.uri)?void 0:Pe?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===6?Ne.edits.push({resource:Ue.uri,textEdit:{range:n.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:We.has(Ue.uri)?void 0:Pe?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===3?Ne.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===5&&Ne.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(et.from)}})}return Ne}ve.from=ke;function de(x){const Pe=new i.$lJ,Ne=new R.$ji;for(const We of x.edits)if(We.textEdit){const Ue=We,Qe=h.URI.revive(Ue.resource),lt=n.to(Ue.textEdit.range),ht=Ue.textEdit.text,bt=Ue.textEdit.insertAsSnippet;let at;bt?at=i.$kJ.replace(lt,new i.$mJ(ht)):at=i.$iJ.replace(lt,ht);const mt=Ne.get(Qe);mt?mt.push(at):Ne.set(Qe,[at])}else Pe.renameFile(h.URI.revive(We.oldResource),h.URI.revive(We.newResource),We.options);for(const[We,Ue]of Ne)Pe.set(We,Ue);return Pe}ve.to=de})(Z||(e.WorkspaceEdit=Z={}));var H;(function(ve){const ke=Object.create(null);ke[i.SymbolKind.File]=0,ke[i.SymbolKind.Module]=1,ke[i.SymbolKind.Namespace]=2,ke[i.SymbolKind.Package]=3,ke[i.SymbolKind.Class]=4,ke[i.SymbolKind.Method]=5,ke[i.SymbolKind.Property]=6,ke[i.SymbolKind.Field]=7,ke[i.SymbolKind.Constructor]=8,ke[i.SymbolKind.Enum]=9,ke[i.SymbolKind.Interface]=10,ke[i.SymbolKind.Function]=11,ke[i.SymbolKind.Variable]=12,ke[i.SymbolKind.Constant]=13,ke[i.SymbolKind.String]=14,ke[i.SymbolKind.Number]=15,ke[i.SymbolKind.Boolean]=16,ke[i.SymbolKind.Array]=17,ke[i.SymbolKind.Object]=18,ke[i.SymbolKind.Key]=19,ke[i.SymbolKind.Null]=20,ke[i.SymbolKind.EnumMember]=21,ke[i.SymbolKind.Struct]=22,ke[i.SymbolKind.Event]=23,ke[i.SymbolKind.Operator]=24,ke[i.SymbolKind.TypeParameter]=25;function de(Pe){return typeof ke[Pe]=="number"?ke[Pe]:6}ve.from=de;function x(Pe){for(const Ne in ke)if(ke[Ne]===Pe)return Number(Ne);return i.SymbolKind.Property}ve.to=x})(H||(e.SymbolKind=H={}));var B;(function(ve){function ke(x){switch(x){case i.SymbolTag.Deprecated:return 1}}ve.from=ke;function de(x){switch(x){case 1:return i.SymbolTag.Deprecated}}ve.to=de})(B||(e.SymbolTag=B={}));var ne;(function(ve){function ke(x){return{name:x.name,kind:H.from(x.kind),tags:x.tags&&x.tags.map(B.from),containerName:x.containerName,location:F.from(x.location)}}ve.from=ke;function de(x){const Pe=new i.$sJ(x.name,H.to(x.kind),x.containerName,F.to(x.location));return Pe.tags=x.tags&&x.tags.map(B.to),Pe}ve.to=de})(ne||(e.WorkspaceSymbol=ne={}));var Q;(function(ve){function ke(x){const Pe={name:x.name||"!!MISSING: name!!",detail:x.detail,range:n.from(x.range),selectionRange:n.from(x.selectionRange),kind:H.from(x.kind),tags:x.tags?.map(B.from)??[]};return x.children&&(Pe.children=x.children.map(ke)),Pe}ve.from=ke;function de(x){const Pe=new i.$tJ(x.name,x.detail,H.to(x.kind),n.to(x.range),n.to(x.selectionRange));return(0,y.$nf)(x.tags)&&(Pe.tags=x.tags.map(B.to)),x.children&&(Pe.children=x.children.map(de)),Pe}ve.to=de})(Q||(e.DocumentSymbol=Q={}));var _;(function(ve){function ke(x){const Pe=new i.$yJ(H.to(x.kind),x.name,x.detail||"",h.URI.revive(x.uri),n.to(x.range),n.to(x.selectionRange));return Pe._sessionId=x._sessionId,Pe._itemId=x._itemId,Pe}ve.to=ke;function de(x,Pe,Ne){if(Pe=Pe??x._sessionId,Ne=Ne??x._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,name:x.name,detail:x.detail,kind:H.from(x.kind),uri:x.uri,range:n.from(x.range),selectionRange:n.from(x.selectionRange),tags:x.tags?.map(B.from)}}ve.from=de})(_||(e.CallHierarchyItem=_={}));var T;(function(ve){function ke(de){return new i.$zJ(_.to(de.from),de.fromRanges.map(x=>n.to(x)))}ve.to=ke})(T||(e.CallHierarchyIncomingCall=T={}));var S;(function(ve){function ke(de){return new i.$AJ(_.to(de.to),de.fromRanges.map(x=>n.to(x)))}ve.to=ke})(S||(e.CallHierarchyOutgoingCall=S={}));var F;(function(ve){function ke(x){return{range:x.range&&n.from(x.range),uri:x.uri}}ve.from=ke;function de(x){return new i.$nJ(h.URI.revive(x.uri),n.to(x.range))}ve.to=de})(F||(e.location=F={}));var ee;(function(ve){function ke(x){const Pe=x,Ne=x;return{originSelectionRange:Pe.originSelectionRange?n.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ne.uri,range:n.from(Pe.targetRange?Pe.targetRange:Ne.range),targetSelectionRange:Pe.targetSelectionRange?n.from(Pe.targetSelectionRange):void 0}}ve.from=ke;function de(x){return{targetUri:h.URI.revive(x.uri),targetRange:n.to(x.range),targetSelectionRange:x.targetSelectionRange?n.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?n.to(x.originSelectionRange):void 0}}ve.to=de})(ee||(e.DefinitionLink=ee={}));var oe;(function(ve){function ke(x){return{range:n.from(x.range),contents:he.fromMany(x.contents)}}ve.from=ke;function de(x){return new i.$qJ(x.contents.map(he.to),n.to(x.range))}ve.to=de})(oe||(e.Hover=oe={}));var z;(function(ve){function ke(x){return{range:n.from(x.range),expression:x.expression}}ve.from=ke;function de(x){return new i.$kK(n.to(x.range),x.expression)}ve.to=de})(z||(e.EvaluatableExpression=z={}));var q;(function(ve){function ke(x){if(x instanceof i.$lK)return{type:"text",range:n.from(x.range),text:x.text};if(x instanceof i.$mK)return{type:"variable",range:n.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof i.$nK)return{type:"expression",range:n.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ke;function de(x){switch(x.type){case"text":return{range:n.to(x.range),text:x.text};case"variable":return{range:n.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:n.to(x.range),expression:x.expression}}}ve.to=de})(q||(e.InlineValue=q={}));var W;(function(ve){function ke(x){return{frameId:x.frameId,stoppedLocation:n.from(x.stoppedLocation)}}ve.from=ke;function de(x){return new i.$oK(x.frameId,n.to(x.stoppedLocation))}ve.to=de})(W||(e.InlineValueContext=W={}));var U;(function(ve){function ke(x){return{range:n.from(x.range),kind:x.kind}}ve.from=ke;function de(x){return new i.$rJ(n.to(x.range),x.kind)}ve.to=de})(U||(e.DocumentHighlight=U={}));var X;(function(ve){function ke(de){switch(de){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}ve.to=ke})(X||(e.CompletionTriggerKind=X={}));var G;(function(ve){function ke(de){return{triggerKind:X.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}ve.to=ke})(G||(e.CompletionContext=G={}));var Y;(function(ve){function ke(x){switch(x){case i.CompletionItemTag.Deprecated:return 1}}ve.from=ke;function de(x){switch(x){case 1:return i.CompletionItemTag.Deprecated}}ve.to=de})(Y||(e.CompletionItemTag=Y={}));var ue;(function(ve){const ke=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function de(Ne){return ke.get(Ne)??9}ve.from=de;const x=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Pe(Ne){return x.get(Ne)??i.CompletionItemKind.Property}ve.to=Pe})(ue||(e.CompletionItemKind=ue={}));var pe;(function(ve){function ke(de,x){const Pe=new i.$IJ(de.label);return Pe.insertText=de.insertText,Pe.kind=ue.to(de.kind),Pe.tags=de.tags?.map(Y.to),Pe.detail=de.detail,Pe.documentation=L.$Ij(de.documentation)?he.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,m.$Lr.isIRange(de.range)?Pe.range=n.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:n.to(de.range.insert),replacing:n.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new i.$mJ(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof i.$dJ?new i.$iJ(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Ne=>J.to(Ne))),Pe.command=x&&de.command?x.fromInternal(de.command):void 0,Pe}ve.to=ke})(pe||(e.CompletionItem=pe={}));var Se;(function(ve){function ke(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:he.fromStrict(x.documentation)}}ve.from=ke;function de(x){return{label:x.label,documentation:L.$Ij(x.documentation)?he.to(x.documentation):x.documentation}}ve.to=de})(Se||(e.ParameterInformation=Se={}));var Ce;(function(ve){function ke(x){return{label:x.label,documentation:he.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(Se.from):[],activeParameter:x.activeParameter}}ve.from=ke;function de(x){return{label:x.label,documentation:L.$Ij(x.documentation)?he.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(Se.to):[],activeParameter:x.activeParameter}}ve.to=de})(Ce||(e.SignatureInformation=Ce={}));var Fe;(function(ve){function ke(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Ce.from):[]}}ve.from=ke;function de(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Ce.to):[]}}ve.to=de})(Fe||(e.SignatureHelp=Fe={}));var ze;(function(ve){function ke(de,x){const Pe=new i.$HJ(c.to(x.position),typeof x.label=="string"?x.label:x.label.map(me.to.bind(void 0,de)),x.kind&&Ee.to(x.kind));return Pe.textEdits=x.textEdits&&x.textEdits.map(J.to),Pe.tooltip=L.$Ij(x.tooltip)?he.to(x.tooltip):x.tooltip,Pe.paddingLeft=x.paddingLeft,Pe.paddingRight=x.paddingRight,Pe}ve.to=ke})(ze||(e.InlayHint=ze={}));var me;(function(ve){function ke(de,x){const Pe=new i.$GJ(x.label);return Pe.tooltip=L.$Ij(x.tooltip)?he.to(x.tooltip):x.tooltip,$.Command.is(x.command)&&(Pe.command=de.fromInternal(x.command)),x.location&&(Pe.location=F.to(x.location)),Pe}ve.to=ke})(me||(e.InlayHintLabelPart=me={}));var Ee;(function(ve){function ke(x){return x}ve.from=ke;function de(x){return x}ve.to=de})(Ee||(e.InlayHintKind=Ee={}));var ye;(function(ve){function ke(x){return{range:n.from(x.range),url:x.target,tooltip:x.tooltip}}ve.from=ke;function de(x){let Pe;if(x.url)try{Pe=typeof x.url=="string"?h.URI.parse(x.url,!0):h.URI.revive(x.url)}catch{}return new i.$NJ(n.to(x.range),Pe)}ve.to=de})(ye||(e.DocumentLink=ye={}));var je;(function(ve){function ke(x){const Pe=new i.$QJ(x.label);return x.textEdit&&(Pe.textEdit=J.to(x.textEdit)),x.additionalTextEdits&&(Pe.additionalTextEdits=x.additionalTextEdits.map(Ne=>J.to(Ne))),Pe}ve.to=ke;function de(x){return{label:x.label,textEdit:x.textEdit?J.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Pe=>J.from(Pe)):void 0}}ve.from=de})(je||(e.ColorPresentation=je={}));var Te;(function(ve){function ke(x){return new i.$OJ(x[0],x[1],x[2],x[3])}ve.to=ke;function de(x){return[x.red,x.green,x.blue,x.alpha]}ve.from=de})(Te||(e.Color=Te={}));var xe;(function(ve){function ke(x){return{range:n.from(x.range)}}ve.from=ke;function de(x){return new i.$xJ(n.to(x.range))}ve.to=de})(xe||(e.SelectionRange=xe={}));var Be;(function(ve){function ke(de){switch(de){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}ve.to=ke})(Be||(e.TextDocumentSaveReason=Be={}));var Ze;(function(ve){function ke(x){switch(x){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ke;function de(x){switch(x){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}ve.to=de})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var Ye;(function(ve){function ke(x){if(x===i.EndOfLine.CRLF)return 1;if(x===i.EndOfLine.LF)return 0}ve.from=ke;function de(x){if(x===1)return i.EndOfLine.CRLF;if(x===0)return i.EndOfLine.LF}ve.to=de})(Ye||(e.EndOfLine=Ye={}));var it;(function(ve){function ke(de){if(typeof de=="object")return de.viewId;switch(de){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ke})(it||(e.ProgressLocation=it={}));var Xe;(function(ve){function ke(x){const Pe={start:x.start+1,end:x.end+1};return x.kind&&(Pe.kind=Ge.from(x.kind)),Pe}ve.from=ke;function de(x){const Pe={start:x.start-1,end:x.end-1};return x.kind&&(Pe.kind=Ge.to(x.kind)),Pe}ve.to=de})(Xe||(e.FoldingRange=Xe={}));var Ge;(function(ve){function ke(x){if(x)switch(x){case i.FoldingRangeKind.Comment:return $.$os.Comment;case i.FoldingRangeKind.Imports:return $.$os.Imports;case i.FoldingRangeKind.Region:return $.$os.Region}}ve.from=ke;function de(x){if(x)switch(x.value){case $.$os.Comment.value:return i.FoldingRangeKind.Comment;case $.$os.Imports.value:return i.FoldingRangeKind.Imports;case $.$os.Region.value:return i.FoldingRangeKind.Region}}ve.to=de})(Ge||(e.FoldingRangeKind=Ge={}));var fe;(function(ve){function ke(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?n.from(de.selection):void 0,override:typeof de.override=="boolean"?l.$5D.id:void 0}}ve.from=ke})(fe||(e.TextEditorOpenOptions=fe={}));var De;(function(ve){function ke(Ne){return Ne instanceof i.$$J?Ne.toJSON():typeof Ne=="string"?Ne:de(Ne)||x(Ne)?new i.$$J(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}ve.from=ke;function de(Ne){const We=Ne;return We?h.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function x(Ne){const We=Ne;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Pe(Ne){return typeof Ne=="string"?Ne:new i.$$J(h.URI.revive(Ne.baseUri),Ne.pattern)}ve.to=Pe})(De||(e.GlobPattern=De={}));var Le;(function(ve){function ke(de){if(de){if(Array.isArray(de))return de.map(ke);if(typeof de=="string")return de;{const x=de;return{language:x.language,scheme:x.scheme,pattern:De.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ve.from=ke})(Le||(e.LanguageSelector=Le={}));var Ie;(function(ve){function ke(x){return{start:x.start,end:x.end}}ve.from=ke;function de(x){return new i.$zK(x.start,x.end)}ve.to=de})(Ie||(e.NotebookRange=Ie={}));var Oe;(function(ve){function ke(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ve.to=ke;function de(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ve.from=de})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var qe;(function(ve){function ke(de){if(de===g.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(de===g.NotebookCellExecutionState.Pending)return;if(de===g.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}ve.to=ke})(qe||(e.NotebookCellExecutionState=qe={}));var He;(function(ve){function ke(x){switch(x){case i.NotebookCellKind.Markup:return g.CellKind.Markup;case i.NotebookCellKind.Code:default:return g.CellKind.Code}}ve.from=ke;function de(x){switch(x){case g.CellKind.Markup:return i.NotebookCellKind.Markup;case g.CellKind.Code:default:return i.NotebookCellKind.Code}}ve.to=de})(He||(e.NotebookCellKind=He={}));var Ke;(function(ve){function ke(x){const Pe={metadata:x.metadata??Object.create(null),cells:[]};for(const Ne of x.cells)i.$AK.validate(Ne),Pe.cells.push(et.from(Ne));return Pe}ve.from=ke;function de(x){const Pe=new i.$BK(x.cells.map(et.to));return(0,w.$te)(x.metadata)||(Pe.metadata=x.metadata),Pe}ve.to=de})(Ke||(e.NotebookData=Ke={}));var et;(function(ve){function ke(x){return{cellKind:He.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Oe.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(st.from):[]}}ve.from=ke;function de(x){return new i.$AK(He.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(st.to):void 0,x.metadata,x.internalMetadata?Oe.to(x.internalMetadata):void 0)}ve.to=de})(et||(e.NotebookCellData=et={}));var Je;(function(ve){function ke(x){return{mime:x.mime,valueBytes:O.$Ib.wrap(x.data)}}ve.from=ke;function de(x){return new i.$CK(x.valueBytes.buffer,x.mime)}ve.to=de})(Je||(e.NotebookCellOutputItem=Je={}));var st;(function(ve){function ke(x){return{outputId:x.id,items:x.items.map(Je.from),metadata:x.metadata}}ve.from=ke;function de(x){const Pe=x.items.map(Je.to);return new i.$DK(Pe,x.outputId,x.metadata)}ve.to=de})(st||(e.NotebookCellOutput=st={}));var ct;(function(ve){function ke(Pe){return x(Pe)?{include:(0,w.$ye)(De.from(Pe.include)),exclude:(0,w.$ye)(De.from(Pe.exclude))}:(0,w.$ye)(De.from(Pe))}ve.from=ke;function de(Pe){return x(Pe)?{include:De.to(Pe.include),exclude:De.to(Pe.exclude)}:De.to(Pe)}ve.to=de;function x(Pe){const Ne=Pe;return Ne?!(0,w.$pe)(Ne.include)&&!(0,w.$pe)(Ne.exclude):!1}})(ct||(e.NotebookExclusiveDocumentPattern=ct={}));var ot;(function(ve){function ke(de,x,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Ne,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}ve.from=ke})(ot||(e.NotebookStatusBarItem=ot={}));var pt;(function(ve){function ke(de,x,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:x.toInternal(Ne,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}ve.from=ke})(pt||(e.NotebookKernelSourceAction=pt={}));var yt;(function(ve){function ke(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}ve.from=ke})(yt||(e.NotebookDocumentContentOptions=yt={}));var It;(function(ve){function ke(x){return{uri:x.uri,provides:x.provides}}ve.from=ke;function de(x){return new i.$FK(h.URI.revive(x.uri),x.provides)}ve.to=de})(It||(e.NotebookRendererScript=It={}));var gt;(function(ve){function ke(x){return{message:he.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:n.from(x.location.range),uri:x.location.uri}}}ve.from=ke;function de(x){const Pe=new i.$MK(typeof x.message=="string"?x.message:he.to(x.message));return Pe.actualOutput=x.actual,Pe.expectedOutput=x.expected,Pe.location=x.location?F.to(x.location):void 0,Pe}ve.to=de})(gt||(e.TestMessage=gt={}));var ut;(function(ve){ve.namespace=E.$2H,ve.denamespace=E.$3H})(ut||(e.TestTag=ut={}));var At;(function(ve){function ke(x){const Pe=(0,u.$0K)(x).controllerId;return{extId:D.$XH.fromExtHostTestItem(x,Pe).toString(),label:x.label,uri:h.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Ne=>ut.namespace(Pe,Ne.id)),range:m.$Lr.lift(n.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&he.fromStrict(x.error)||null}}ve.from=ke;function de(x){return{parent:void 0,error:void 0,id:D.$XH.fromString(x.extId).localId,label:x.label,uri:h.URI.revive(x.uri),tags:(x.tags||[]).map(Pe=>{const{tagId:Ne}=ut.denamespace(Pe);return new i.$NK(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:n.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ve.toPlain=de})(At||(e.TestItem=At={})),function(ve){function ke(x){return{id:x.id}}ve.from=ke;function de(x){return new i.$NK(x.id)}ve.to=de}(ut||(e.TestTag=ut={}));var Mt;(function(ve){const ke=(x,Pe)=>{const Ne=[];for(const[Ue,Qe]of Pe)D.$XH.compare(Qe.item.extId,Ue)===2&&(Pe.delete(Ue),Ne.push(Qe));const We={...At.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(Qe=>Qe.type===0).map(gt.to)})),children:Ne.map(Ue=>ke(Ue,Pe))};for(const Ue of We.children)Ue.parent=We;return We};function de(x){const Pe=[],Ne=new Map;for(const We of x.items){Ne.set(We.item.extId,We);const Ue=D.$XH.root(We.item.extId);x.request.targets.some(Qe=>Qe.controllerId===Ue&&Qe.testIds.includes(We.item.extId))&&Pe.push(We)}return{completedAt:x.completedAt,results:Pe.map(We=>ke(We,Ne))}}ve.to=de})(Mt||(e.TestResults=Mt={}));var vt;(function(ve){function ke(Ne){return{covered:Ne.covered,total:Ne.covered}}function de(Ne){return"line"in Ne?c.from(Ne):n.from(Ne)}function x(Ne){return"branches"in Ne?{count:Ne.executionCount,location:de(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(We=>({count:We.executionCount,location:We.location&&de(We.location)})):void 0}:{type:0,count:Ne.executionCount,location:de(Ne.location)}}ve.fromDetailed=x;function Pe(Ne){return{uri:Ne.uri,statement:ke(Ne.statementCoverage),branch:Ne.branchCoverage&&ke(Ne.branchCoverage),function:Ne.functionCoverage&&ke(Ne.functionCoverage),details:Ne.detailedCoverage?.map(x)}}ve.fromFile=Pe})(vt||(e.TestCoverage=vt={}));var Lt;(function(ve){function ke(de){switch(de){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}ve.to=ke})(Lt||(e.CodeActionTriggerKind=Lt={}));var jt;(function(ve){function ke(x){const Pe=new i.$TK(H.to(x.kind),x.name,x.detail||"",h.URI.revive(x.uri),n.to(x.range),n.to(x.selectionRange));return Pe._sessionId=x._sessionId,Pe._itemId=x._itemId,Pe}ve.to=ke;function de(x,Pe,Ne){if(Pe=Pe??x._sessionId,Ne=Ne??x._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,kind:H.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:n.from(x.range),selectionRange:n.from(x.selectionRange),tags:x.tags?.map(B.from)}}ve.from=de})(jt||(e.TypeHierarchyItem=jt={}));var dt;(function(ve){function ke(de){if(de)return{value:de.value,tooltip:de.tooltip}}ve.from=ke})(dt||(e.ViewBadge=dt={}));var St;(function(ve){function ke(Ne,We,Ue){const Qe=We.fileData;return Qe?new i.$4J(new i.$5J(Qe.name,h.URI.revive(Qe.uri),Qe.id,(0,I.$bb)(()=>Ue(Qe.id)))):Ne===P.$rr.uriList&&We.uriListData?new i.$3J(Pe(We.uriListData)):new i.$3J(We.asString)}ve.to=ke;async function de(Ne,We){const Ue=await We.asString();if(Ne===P.$rr.uriList)return{asString:Ue,fileData:void 0,uriListData:x(Ue)};const Qe=We.asFile();return{asString:Ue,fileData:Qe?{name:Qe.name,uri:Qe.uri,id:Qe._itemId??Qe.id}:void 0}}ve.from=de;function x(Ne){return a.$_r.split(Ne).map(We=>{if(We.startsWith("#"))return We;try{return h.URI.parse(We)}catch{}return We})}function Pe(Ne){return a.$_r.create(Ne.map(We=>typeof We=="string"?We:h.URI.revive(We)))}})(St||(e.DataTransferItem=St={}));var Rt;(function(ve){function ke(x,Pe){const Ne=x.items.map(([We,Ue])=>[We,St.to(We,Ue,Pe)]);return new i.$6J(Ne)}ve.toDataTransfer=ke;async function de(x){const Pe={items:[]},Ne=[];for(const[We,Ue]of x)Ne.push((async()=>{Pe.items.push([We,await St.from(We,Ue)])})());return await Promise.all(Ne),Pe}ve.from=de})(Rt||(e.DataTransfer=Rt={}));var rt;(function(ve){function ke(x){return{message:x.message,metadata:x.metadata,title:x.title,tooltip:x.tooltip}}ve.to=ke;function de(x){return{kind:"reply",message:x.message,metadata:x.metadata,title:x.title,tooltip:x.tooltip}}ve.from=de})(rt||(e.ChatReplyFollowup=rt={}));var $t;(function(ve){function ke(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",args:de.args}:rt.from(de)}ve.from=ke})($t||(e.ChatFollowup=$t={}))}),define(be[272],we([1,0,52,132,69,131,91,135,4]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=e.$nL=void 0;const d=(g,D,E,t)=>{let i=D;return{enumerable:!0,configurable:!1,get(){return i},set(r){if(!E(i,r)){const n=i;i=r,g.listener?.(t(r,n))}}}},P=(g,D)=>g===D,p={range:(g,D)=>g===D?!0:!g||!D?!1:g.isEqual(D),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(g,D)=>!(g.length!==D.length||g.some(E=>!D.find(t=>E.id===t.id)))},w=g=>D=>({op:4,update:g(D)}),h=(g,D)=>({range:(()=>{let E;const t=w(i=>({range:y.$Lr.lift(R.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return E},set(i){g.listener?.({op:6}),p.range(E,i)||(E=i,g.listener?.(t(i)))}}})(),label:d(g,D,p.label,w(E=>({label:E}))),description:d(g,void 0,p.description,w(E=>({description:E}))),sortText:d(g,void 0,p.sortText,w(E=>({sortText:E}))),canResolveChildren:d(g,!1,p.canResolveChildren,E=>({op:2,state:E})),busy:d(g,!1,p.busy,w(E=>({busy:E}))),error:d(g,void 0,p.error,w(E=>({error:R.MarkdownString.fromStrict(E)||null}))),tags:d(g,[],p.tags,(E,t)=>({op:1,new:E.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),m=g=>{const D=a.$XH.fromString(g.extId),E=new o(D.controllerId,D.localId,g.label,b.URI.revive(g.uri)||void 0);return E.range=R.Range.to(g.range||void 0),E.description=g.description||void 0,E.sortText=g.sortText||void 0,E.tags=g.tags.map(t=>R.TestTag.to({id:(0,L.$3H)(t).tagId})),E},$=g=>{let D;for(const E of g.tests){const t=m(E.item);(0,O.$0K)(t).parent=D,D=t}return D};e.$nL=$;class o{constructor(D,E,t,i){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const r=(0,O.$9K)(this,D);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,I.$8K)(r,O.$0K,o),enumerable:!0,writable:!1},...h(r,t)})}}e.$oL=o;class u extends o{constructor(D,E){super(D,D,E,void 0),this._isRoot=!0}}e.$pL=u;class l extends I.$4K{constructor(D,E,t){super({controllerId:D,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:O.$0K,getChildren:i=>i.children,root:new u(D,E),toITestItem:R.TestItem.from})}}e.$qL=l}),define(be[273],we([1,0,8,269,117,88,86,133,90,134,13,218,267,87]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=void 0,e.$1L="remoteterminal";let m=e.$2L=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(o,u,l,g,D,E,t,i,r,n){this.a=o,this.b=u,this.c=l,this.d=g,this.e=D,this.f=E,this.g=t,this.h=i,this.i=r,this.j=n}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(o,u,l,g,D,E,t,i){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),n=l?(0,y.$ye)(this.d.getWorkspaceFolder(l)):void 0;let s;try{s=(await this.e.resolveAnyMap(n,{shellLaunchConfig:o,configuration:u})).resolvedVariables}catch(te){this.h.error(te)}if(s)for(const[te,he]of s.entries())(/^config:/.test(te)||te==="selectedText"||te==="lineNumber")&&(r[te]=he);const c=[];for(const[te,he]of this.f.collections.entries())c.push([te,(0,L.$Wq)(he.map),(0,L.$Xq)(he.descriptionMap)]);const f=await this.g.resolveAuthority(this.a),k=f.options&&f.options.extensionHostEnv,v=this.d.getWorkspace(),C=v.folders,A=l?this.d.getWorkspaceFolder(l):null,M=b.$mE.getOriginalUri(this.i.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[P.Schemas.file,P.Schemas.vscodeUserData,P.Schemas.vscodeRemote]}),K={configuration:u,resolvedVariables:r,envVariableCollections:c,shellLaunchConfig:o,workspaceId:v.id,workspaceName:this.j.getWorkspaceLabel(v),workspaceFolders:C,activeWorkspaceFolder:A,activeFileResource:M,shouldPersistTerminal:D,options:g,cols:E,rows:t,unicodeVersion:i,resolverEnv:k};return await this.b.call("$createProcess",K)}requestDetachInstance(o,u){return this.b.call("$requestDetachInstance",[o,u])}acceptDetachInstanceReply(o,u){return this.b.call("$acceptDetachInstanceReply",[o,u])}attachToProcess(o){return this.b.call("$attachToProcess",[o])}detachFromProcess(o,u){return this.b.call("$detachFromProcess",[o,u])}listProcesses(){return this.b.call("$listProcesses")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(o,u){return this.b.call("$processBinary",[o,u])}start(o){return this.b.call("$start",[o])}input(o,u){return this.b.call("$input",[o,u])}acknowledgeDataEvent(o,u){return this.b.call("$acknowledgeDataEvent",[o,u])}setUnicodeVersion(o,u){return this.b.call("$setUnicodeVersion",[o,u])}shutdown(o,u){return this.b.call("$shutdown",[o,u])}resize(o,u,l){return this.b.call("$resize",[o,u,l])}clearBuffer(o){return this.b.call("$clearBuffer",[o])}getInitialCwd(o){return this.b.call("$getInitialCwd",[o])}getCwd(o){return this.b.call("$getCwd",[o])}orphanQuestionReply(o){return this.b.call("$orphanQuestionReply",[o])}sendCommandResult(o,u,l){return this.b.call("$sendCommandResult",[o,u,l])}freePortKillProcess(o){return this.b.call("$freePortKillProcess",[o])}installAutoReply(o,u){return this.b.call("$installAutoReply",[o,u])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(o){return this.b.call("$getDefaultSystemShell",[o])}getProfiles(o,u,l){return this.b.call("$getProfiles",[this.d.getWorkspace().id,o,u,l])}acceptPtyHostResolvedVariables(o,u){return this.b.call("$acceptPtyHostResolvedVariables",[o,u])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(o,u){return this.b.call("$getWslPath",[o,u])}setTerminalLayoutInfo(o){const l={workspaceId:this.d.getWorkspace().id,tabs:o?o.tabs:[]};return this.b.call("$setTerminalLayoutInfo",l)}updateTitle(o,u,l){return this.b.call("$updateTitle",[o,u,l])}updateIcon(o,u,l,g){return this.b.call("$updateIcon",[o,u,l,g])}refreshProperty(o,u){return this.b.call("$refreshProperty",[o,u])}updateProperty(o,u,l){return this.b.call("$updateProperty",[o,u,l])}getTerminalLayoutInfo(){const u={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",u)}reviveTerminalProcesses(o,u){return this.b.call("$reviveTerminalProcesses",[o,u])}getRevivedPtyNewId(o){return this.b.call("$getRevivedPtyNewId",[o])}serializeTerminalState(o){return this.b.call("$serializeTerminalState",[o])}};e.$2L=m=Re([Ae(2,O.$KD),Ae(3,I.$uh),Ae(4,R.$EL),Ae(5,w.$ZL),Ae(6,a.$sk),Ae(7,h.$Jq),Ae(8,d.$vC),Ae(9,p.$lz)],m)}),define(be[274],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.ExtHostConnectionType=void 0;var y;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class O{constructor(p){this.pipeName=p,this.type=1}serialize(p){p[O.ENV_KEY]=this.pipeName}}e.$9l=O,O.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class a{constructor(){this.type=2}serialize(p){p[a.ENV_KEY]="1"}}e.$0l=a,a.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class I{constructor(){this.type=3}serialize(p){p[I.ENV_KEY]="1"}}e.$$l=I,I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(P){delete P[O.ENV_KEY],delete P[a.ENV_KEY],delete P[I.ENV_KEY]}function R(P,p){L(p),P.serialize(p)}e.$_l=R;function b(P){if(P[O.ENV_KEY])return d(P,new O(P[O.ENV_KEY]));if(P[a.ENV_KEY])return d(P,new a);if(P[I.ENV_KEY])return d(P,new I);throw new Error("No connection information defined in environment!")}e.$am=b;function d(P,p){return L(P),p}}),define(be[275],we([1,0,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Nl=e.$Ml=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(O||(e.UIKind=O={}));var a;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(a||(e.ExtensionHostExitCode=a={}));var I;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function L(d){const P=y.$Ib.alloc(1);switch(d){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$Ml=L;function R(d,P){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$Nl=R;var b;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(be[276],we([1,0,6,5,12,263,275,56,36,22,4,2,197]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$uL=e.$tL=e.$sL=void 0;let h=e.$sL=class extends p.$kb{constructor(u,l){super(),this.n=u,this.p=l,this.a=this.B(new O.$5c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$5c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=l.createLogger(this.j,{id:b.$4n,name:(0,w.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(l.onDidChangeLogLevel(g=>{(0,a.$Pi)(g)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===a.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,l,g){const D=this.getTelemetryDetails(),E=new m(l,g,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),t=this.m.get(u.identifier.value)??[];return this.m.set(u.identifier.value,[...t,E]),E.apiTelemetryLogger}$initializeTelemetryLevel(u,l,g){this.f=u,this.g=l,this.c=g??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(u){const l=Object.create(null);switch(l["common.extname"]=`${u.publisher}.${u.name}`,l["common.extversion"]=u.version,l["common.vscodemachineid"]=this.n.telemetryInfo.machineId,l["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,l["common.vscodeversion"]=this.n.version,l["common.isnewappinstall"]=$(this.n.telemetryInfo.firstSessionDate),l["common.product"]=this.n.environment.appHost,this.n.uiKind){case L.UIKind.Web:l["common.uikind"]="web";break;case L.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,R.$yk)((0,b.$$n)(this.n.remote.authority)),l}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const l=this.getTelemetryDetails();this.m.forEach((g,D)=>{const E=g.filter(t=>!t.isDisposed);E.length===0?this.m.delete(D):this.m.set(D,E)}),this.m.forEach(g=>{for(const D of g)D.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(u,l){const D=this.m.get(u.value)?.filter(t=>!t.isDisposed);if(!D)return this.m.delete(u.value),!1;let E=!1;for(const t of D)t.ignoreUnhandledExtHostErrors||(t.logError(l),E=!0);return E}};e.$sL=h=Re([Ae(0,I.$rL),Ae(1,a.$Oi)],h);class m{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,l,g,D,E,t,i){this.g=g,this.h=D,this.i=E,this.j=t,this.a=new O.$5c,this.ignoreUnhandledExtHostErrors=l?.ignoreUnhandledErrors??!1,this.b=l?.ignoreBuiltInCommonProperties??!1,this.c=l?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(u,l){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:l},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let l="properties"in u?u.properties??{}:u;return l=(0,b.$bo)(l,[]),this.c&&(l=(0,d.$Hm)(l,this.c)),this.b||(l=(0,d.$Hm)(l,this.j)),"properties"in u?u.properties=l:u=l,u}k(u,l){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f?.sendEventData(u,l),this.h.trace(u,l))}logUsage(u,l){this.d.isUsageEnabled&&this.k(u,l)}logError(u,l){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,l):this.f.sendErrorData(u,l))}get apiTelemetryLogger(){if(!this.e){const u=this,l={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(l)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$tL=m;function $(o){const u=Date.now()-new Date(o).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$uL=$,e.$vL=(0,y.$lh)("IExtHostTelemetry")}),define(be[277],we([1,0,40,200,53]),function(ae,e,y,O,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=void 0;function I(L,R,b,d){const P=new y.$Gl;return L.forEach(p=>{const w=P.get(p.identifier);w&&d.warn((0,O.localize)(0,null,w.extensionLocation.fsPath,p.extensionLocation.fsPath)),P.set(p.identifier,p)}),R.forEach(p=>{const w=P.get(p.identifier);if(w)if(w.isBuiltin){if(a.gte(w.version,p.version)){d.warn(`Skipping extension ${p.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}p.isBuiltin=!0}else d.warn((0,O.localize)(1,null,w.extensionLocation.fsPath,p.extensionLocation.fsPath));else if(p.isBuiltin){d.warn(`Skipping obsolete builtin extension ${p.extensionLocation.path}`);return}P.set(p.identifier,p)}),b.forEach(p=>{d.info((0,O.localize)(2,null,p.extensionLocation.fsPath));const w=P.get(p.identifier);w&&w.isBuiltin&&(p.isBuiltin=!0),P.set(p.identifier,p)}),Array.from(P.values())}e.$zM=I}),define(be[278],we([1,0,7,3,29,4,42,50,64,57,277,13]),function(ae,e,y,O,a,I,L,R,b,d,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;class w{constructor($,o,u,l,g,D,E){this.b=$,this.c=u,this.d=l,this.f=g,this.g=D,this.h=E;const t=o.args["install-builtin-extension"];if(t){g.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!o.args["do-not-sync"],installPreReleaseVersion:!!o.args["pre-release"]};L.mark("code/server/willInstallBuiltinExtensions"),this.a=$.installExtensions([],this.i(t),r,!!o.args.force).then(()=>{L.mark("code/server/didInstallBuiltinExtensions"),g.trace("Finished installing builtin extensions")},n=>{g.error(n)})}else this.a=Promise.resolve();const i=o.args["install-extension"];i&&(g.trace("Installing extensions passed via args..."),this.a.then(()=>$.installExtensions(this.i(i),[],{isMachineScoped:!!o.args["do-not-sync"],installPreReleaseVersion:!!o.args["pre-release"],isApplicationScoped:!0},!!o.args.force)).then(()=>{g.trace("Finished installing extensions")},r=>{g.error(r)}))}i($){return $.map(o=>/\.vsix$/i.test(o)?I.URI.file((0,y.$0b)(o)?o:(0,y.$$b)((0,a.cwd)(),o)):o)}whenExtensionsReady(){return this.a}async scanExtensions($,o,u,l){L.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${$}`),await this.whenExtensionsReady();const g=u?u.filter(E=>E.scheme===p.Schemas.file).map(E=>E.fsPath):void 0;o=o??this.c.defaultProfile.extensionsResource;const D=await this.j(o,$??O.$q,g,l);return this.f.trace("Scanned Extensions",D),this.q(D),L.mark("code/server/didScanExtensions"),D}async scanSingleExtension($,o,u){await this.whenExtensionsReady();const l=$.scheme===p.Schemas.file?$.fsPath:null;if(!l)return null;const g=await this.n(l,o,u??O.$q);return g?(this.q([g]),g):null}async j($,o,u,l){await this.o(o,l);const[g,D,E]=await Promise.all([this.l(o),this.m($,o),this.k(o,u)]);return(0,P.$zM)(g,D,E,this.f)}async k($,o){return o?(await Promise.all(o.map(u=>this.d.scanOneOrMultipleExtensions(I.URI.file((0,y.$_b)(u)),1,{language:$})))).flat().map(u=>(0,d.$dp)(u,!0)):[]}async l($){return(await this.d.scanSystemExtensions({language:$,useCache:!0})).map(u=>(0,d.$dp)(u,!1))}async m($,o){return(await this.d.scanUserExtensions({profileLocation:$,language:o,useCache:!0})).map(l=>(0,d.$dp)(l,!1))}async n($,o,u){const l=I.URI.file((0,y.$_b)($)),g=o?0:1,D=await this.d.scanExistingExtension(l,g,{language:u});return D?(0,d.$dp)(D,!1):null}async o($,o){if(!($===O.$a||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(l=>l.id===$)){this.f.trace(`Language Pack ${$} is already installed. Skipping language pack installation.`);return}}catch(u){this.f.error(u)}if(!o){this.f.trace(`No language pack id provided for language ${$}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${o} for language ${$} is not installed. It will be installed now.`);try{await this.b.installExtensions([o],[],{isMachineScoped:!0},!0)}catch(u){this.f.error(u)}}}q($){const o=(t,i)=>t.replace(/file/g,"vscode-remote"),u=t=>{let i="";return i+=t.global?"g":"",i+=t.ignoreCase?"i":"",i+=t.multiline?"m":"",new RegExp(o(t.source,!0),i)},l=new class{mapDefined(t){return b.$wi.create(t)}mapNot(t){return b.$Bi.create(t)}mapEquals(t,i){return t==="resourceScheme"&&typeof i=="string"?b.$xi.create(t,o(i,!1)):b.$xi.create(t,i)}mapNotEquals(t,i){return t==="resourceScheme"&&typeof i=="string"?b.$Ai.create(t,o(i,!1)):b.$Ai.create(t,i)}mapGreater(t,i){return b.$Ci.create(t,i)}mapGreaterEquals(t,i){return b.$Di.create(t,i)}mapSmaller(t,i){return b.$Ei.create(t,i)}mapSmallerEquals(t,i){return b.$Fi.create(t,i)}mapRegex(t,i){return t==="resourceScheme"&&i?b.$Gi.create(t,u(i)):b.$Gi.create(t,i)}mapIn(t,i){return b.$yi.create(t,i)}mapNotIn(t,i){return b.$zi.create(t,i)}},g=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const i=b.$ri.deserialize(t.when);if(!i)return;const r=i.map(l);t.when=r.serialize()},D=t=>{if(Array.isArray(t))for(const i of t)g(i);else g(t)},E=t=>{for(const i in t)D(t[i])};$.forEach(t=>{t.contributes&&(t.contributes.menus&&E(t.contributes.menus),t.contributes.keybindings&&D(t.contributes.keybindings),t.contributes.views&&E(t.contributes.views))})}}e.$CM=w;class h{constructor($,o){this.a=$,this.b=o}listen($,o){throw new Error("Invalid listen")}async call($,o,u){const l=this.b($);switch(o){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const g=u[0],D=u[1]?I.URI.revive(l.transformIncoming(u[1])):void 0,E=Array.isArray(u[2])?u[2].map(r=>I.URI.revive(l.transformIncoming(r))):void 0,t=u[3];return(await this.a.scanExtensions(g,D,E,t)).map(r=>(0,R.$mm)(r,l))}case"scanSingleExtension":{const g=await this.a.scanSingleExtension(I.URI.revive(l.transformIncoming(u[0])),u[1],u[2]);return g?(0,R.$mm)(g,l):null}}throw new Error("Invalid call")}}e.$DM=h}),define(be[136],we([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=void 0;class y{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++y.count}}e.$Kz=y,y.count=0;const O=[];function a(R){const b=new y(R);return O[b.nid]=b,b}e.$Lz=a;function I(R){return O[R].sid}e.$Mz=I;class L{constructor(b){this.value=b}}e.$Nz=L}),define(be[279],we([1,0,136]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$I=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var a;(function($){$[$.UnknownInput=0]="UnknownInput",$[$.TextInput=1]="TextInput",$[$.TextDiffInput=2]="TextDiffInput",$[$.TextMergeInput=3]="TextMergeInput",$[$.NotebookInput=4]="NotebookInput",$[$.NotebookDiffInput=5]="NotebookDiffInput",$[$.CustomEditorInput=6]="CustomEditorInput",$[$.WebviewEditorInput=7]="WebviewEditorInput",$[$.TerminalEditorInput=8]="TerminalEditorInput",$[$.InteractiveEditorInput=9]="InteractiveEditorInput"})(a||(e.TabInputKind=a={}));var I;(function($){$[$.TAB_OPEN=0]="TAB_OPEN",$[$.TAB_CLOSE=1]="TAB_CLOSE",$[$.TAB_UPDATE=2]="TAB_UPDATE",$[$.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var L;(function($){$[$.Editable=0]="Editable",$[$.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function($){$[$.Int8Array=1]="Int8Array",$[$.Uint8Array=2]="Uint8Array",$[$.Uint8ClampedArray=3]="Uint8ClampedArray",$[$.Int16Array=4]="Int16Array",$[$.Uint16Array=5]="Uint16Array",$[$.Int32Array=6]="Int32Array",$[$.Uint32Array=7]="Uint32Array",$[$.Float32Array=8]="Float32Array",$[$.Float64Array=9]="Float64Array",$[$.BigInt64Array=10]="BigInt64Array",$[$.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var b;(function($){$[$.Text=1]="Text",$[$.Error=2]="Error",$[$.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var d;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var P;(function($){$[$.None=0]="None",$[$.Process=1]="Process",$[$.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class p{static mixin(o){return o._id=p.a++,o}}e.$$I=p,p.a=0;var w;(function($){$.label="a",$.kind="b",$.detail="c",$.documentation="d",$.sortText="e",$.filterText="f",$.preselect="g",$.insertText="h",$.insertTextRules="i",$.range="j",$.commitCharacters="k",$.additionalTextEdits="l",$.kindModifier="m",$.commandIdent="n",$.commandId="o",$.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var h;(function($){$.defaultRanges="a",$.completions="b",$.isIncomplete="c",$.duration="d"})(h||(e.ISuggestResultDtoField=h={}));var m;(function($){$[$.Workspace=0]="Workspace",$[$.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$_I={MainThreadAuthentication:(0,y.$Lz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Lz)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.$Lz)("MainThreadClipboard"),MainThreadCommands:(0,y.$Lz)("MainThreadCommands"),MainThreadComments:(0,y.$Lz)("MainThreadComments"),MainThreadConfiguration:(0,y.$Lz)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Lz)("MainThreadConsole"),MainThreadDebugService:(0,y.$Lz)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Lz)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Lz)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Lz)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Lz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Lz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Lz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Lz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Lz)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Lz)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Lz)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Lz)("MainThreadDownloadService"),MainThreadKeytar:(0,y.$Lz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.$Lz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Lz)("MainThreadLanguages"),MainThreadLogger:(0,y.$Lz)("MainThreadLogger"),MainThreadMessageService:(0,y.$Lz)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Lz)("MainThreadOutputService"),MainThreadProgress:(0,y.$Lz)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Lz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Lz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Lz)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Lz)("MainThreadSecretState"),MainThreadStorage:(0,y.$Lz)("MainThreadStorage"),MainThreadTelemetry:(0,y.$Lz)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Lz)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Lz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Lz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Lz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Lz)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Lz)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Lz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Lz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Lz)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Lz)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$Lz)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Lz)("MainThreadSCM"),MainThreadSearch:(0,y.$Lz)("MainThreadSearch"),MainThreadShare:(0,y.$Lz)("MainThreadShare"),MainThreadTask:(0,y.$Lz)("MainThreadTask"),MainThreadWindow:(0,y.$Lz)("MainThreadWindow"),MainThreadLabelService:(0,y.$Lz)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Lz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Lz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Lz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Lz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Lz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Lz)("MainThreadInteractive"),MainThreadChat:(0,y.$Lz)("MainThreadChat"),MainThreadInlineChat:(0,y.$Lz)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Lz)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Lz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Lz)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Lz)("MainThreadTimeline"),MainThreadTesting:(0,y.$Lz)("MainThreadTesting"),MainThreadLocalization:(0,y.$Lz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,y.$Lz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,y.$Lz)("MainThreadIssueReporter")},e.$aJ={ExtHostCommands:(0,y.$Lz)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Lz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Lz)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Lz)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Lz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Lz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Lz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Lz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Lz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Lz)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Lz)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Lz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Lz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Lz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Lz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Lz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Lz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Lz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Lz)("ExtHostStatusBar"),ExtHostShare:(0,y.$Lz)("ExtHostShare"),ExtHostExtensionService:(0,y.$Lz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Lz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Lz)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Lz)("ExtHostSCM"),ExtHostSearch:(0,y.$Lz)("ExtHostSearch"),ExtHostTask:(0,y.$Lz)("ExtHostTask"),ExtHostWorkspace:(0,y.$Lz)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Lz)("ExtHostWindow"),ExtHostWebviews:(0,y.$Lz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Lz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Lz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Lz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Lz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Lz)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Lz)("ExtHostProgress"),ExtHostComments:(0,y.$Lz)("ExtHostComments"),ExtHostSecretState:(0,y.$Lz)("ExtHostSecretState"),ExtHostStorage:(0,y.$Lz)("ExtHostStorage"),ExtHostUrls:(0,y.$Lz)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Lz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Lz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Lz)("ExtHostOutputService"),ExtHosLabelService:(0,y.$Lz)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Lz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Lz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Lz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Lz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Lz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Lz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Lz)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Lz)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Lz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,y.$Lz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,y.$Lz)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Lz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Lz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Lz)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Lz)("ExtHostTimeline"),ExtHostTesting:(0,y.$Lz)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Lz)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Lz)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Lz)("ExtHostIssueReporter")}});var Ct=this&&this.__classPrivateFieldSet||function(ae,e,y,O,a){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?a.call(ae,y):a?a.value=y:e.set(ae,y),y},nt=this&&this.__classPrivateFieldGet||function(ae,e,y,O){if(y==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!O:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?O:y==="a"?O.call(ae):O?O.value:e.get(ae)};define(be[280],we([1,0,8,130,135,22,279,18,12,49,52,107,4,2,6,264,272,15,136,39,98,36,276]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t){"use strict";var i,r,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=void 0;let s=e.$wL=class{constructor(A,M,K){i.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),n.set(this,void 0),Ct(this,i,A.getProxy(L.$_I.MainThreadCommands),"f"),this.d=M,Ct(this,n,K,"f"),Ct(this,r,A.getProxy(L.$_I.MainThreadTelemetry),"f"),this.converter=new c(this,te=>{const he=this.c.get(te);return he?.result===k.Void?he:void 0},M),this.f=[{processArgument(te){return(0,d.$Ug)(te)}},{processArgument(te){return(0,I.$Gm)(te,function(he){if(P.$Lr.isIRange(he))return a.Range.to(he);if(p.$Kr.isIPosition(he))return a.Position.to(he);if(P.$Lr.isIRange(he.range)&&w.URI.isUri(he.uri))return a.location.to(he);if(he instanceof u.$Ib)return he.buffer.buffer;if(!Array.isArray(he))return he})}}]}registerArgumentProcessor(A){this.f.push(A)}registerApiCommand(A){const M=this.registerCommand(!1,A.id,async(...K)=>{const te=A.args.map((ce,le)=>{if(!ce.validate(K[le]))throw new Error(`Invalid argument '${ce.name}' when running '${A.id}', received: ${K[le]}`);return ce.convert(K[le])}),he=await this.executeCommand(A.internalId,...te);return A.result.convert(he,K,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this.c.set(A.id,A),new O.$bJ(()=>{M.dispose(),this.c.delete(A.id)})}registerCommand(A,M,K,te,he,ce){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:K,thisArg:te,description:he,extension:ce}),A&&nt(this,i,"f").$registerCommand(M),new O.$bJ(()=>{this.b.delete(M)&&A&&nt(this,i,"f").$unregisterCommand(M)})}executeCommand(A,...M){return this.d.trace("ExtHostCommands#executeCommand",A),this.g(A,M,!0)}async g(A,M,K){if(this.b.has(A))return nt(this,i,"f").$fireCommandActivationEvent(A),this.h(A,M,!1);{let te=!1;const he=(0,I.$Gm)(M,function(ce){if(ce instanceof O.$cJ)return a.Position.from(ce);if(ce instanceof O.$dJ)return a.Range.from(ce);if(ce instanceof O.$nJ)return a.location.from(ce);if(O.$zK.isNotebookRange(ce))return a.NotebookRange.from(ce);if(ce instanceof ArrayBuffer)return te=!0,u.$Ib.wrap(new Uint8Array(ce));if(ce instanceof Uint8Array)return te=!0,u.$Ib.wrap(ce);if(ce instanceof u.$Ib)return te=!0,ce;if(!Array.isArray(ce))return ce});try{const ce=await nt(this,i,"f").$executeCommand(A,te?new l.$Nz(he):he,K);return(0,d.$Ug)(ce)}catch(ce){if(ce instanceof Error&&ce.message==="$executeCommand:retry")return this.g(A,M,!1);throw ce}}}async h(A,M,K){const te=this.b.get(A);if(!te)throw new Error("Unknown command");const{callback:he,thisArg:ce,description:le}=te;if(le)for(let se=0;se<le.args.length;se++)try{(0,y.$xe)(M[se],le.args[se].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed. Illegal argument '${le.args[se].name}' - ${le.args[se].description}`)}const ge=D.$1c.create();try{return await he.apply(ce,M)}catch(se){if(A===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...M);V&&(A=V.command)}if(this.d.error(se,A,te.extension?.identifier),!K)throw se;if(te.extension?.identifier){const V=nt(this,n,"f").onExtensionError(te.extension.identifier,se);this.d.trace("forwarded error to extension?",V,te.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$9h)(se)),this.id=A,this.source=te.extension?.displayName??te.extension?.name}}}finally{this.j(te,A,ge.elapsed())}}j(A,M,K){A.extension&&nt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new E.$Yn(M),duration:K})}$executeContributedCommand(A,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",A);const K=this.b.get(A);return K?(M=M.map(te=>this.f.reduce((he,ce)=>ce.processArgument(he,K.extension?.identifier),te)),this.h(A,M,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this.d.trace("ExtHostCommands#getCommands",A),nt(this,i,"f").$getCommands().then(M=>(A&&(M=M.filter(K=>K[0]!=="_")),M))}$getContributedCommandHandlerDescriptions(){const A=Object.create(null);for(const[M,K]of this.b){const{description:te}=K;te&&(A[M]=te)}return Promise.resolve(A)}};i=new WeakMap,r=new WeakMap,n=new WeakMap,e.$wL=s=Re([Ae(0,$.$bL),Ae(1,b.$Ni),Ae(2,t.$vL)],s),e.$xL=(0,m.$lh)("IExtHostCommands");class c{constructor(A,M,K){this.d=A,this.f=M,this.g=K,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(A,M){if(!A)return;const K={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return K;const te=this.f(A.command);if(te)K.id=te.internalId,K.arguments=te.args.map((he,ce)=>he.convert(A.arguments&&A.arguments[ce]));else if((0,R.$nf)(A.arguments)){const he=`${A.command}/${++this.c}`;this.b.set(he,A),M.add((0,h.$ib)(()=>{this.b.delete(he),this.g.trace("CommandsConverter#DISPOSE",he)})),K.$ident=he,K.id=this.delegatingCommandId,K.arguments=[he],this.g.trace("CommandsConverter#CREATE",A.command,he)}return K}fromInternal(A){return typeof A.$ident=="string"?this.b.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this.b.get(A[0])}h(...A){const M=this.getActualCommand(...A);return this.g.trace("CommandsConverter#EXECUTE",A[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.$yL=c;class f{constructor(A,M,K,te){this.name=A,this.description=M,this.validate=K,this.convert=te}optional(){return new f(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,M){return new f(A??this.name,M??this.description,this.validate,this.convert)}}e.$zL=f,f.Uri=new f("uri","Uri of a text document",C=>w.URI.isUri(C),C=>C),f.Position=new f("position","A position in a text document",C=>O.$cJ.isPosition(C),a.Position.from),f.Range=new f("range","A range in a text document",C=>O.$dJ.isRange(C),a.Range.from),f.Selection=new f("selection","A selection in a text document",C=>O.$eJ.isSelection(C),a.Selection.from),f.Number=new f("number","",C=>typeof C=="number",C=>C),f.String=new f("string","",C=>typeof C=="string",C=>C),f.CallHierarchyItem=new f("item","A call hierarchy item",C=>C instanceof O.$yJ,a.CallHierarchyItem.from),f.TypeHierarchyItem=new f("item","A type hierarchy item",C=>C instanceof O.$TK,a.TypeHierarchyItem.from),f.TestItem=new f("testItem","A VS Code TestItem",C=>C instanceof o.$oL,a.TestItem.from);class k{constructor(A,M){this.description=A,this.convert=M}}e.$AL=k,k.Void=new k("no result",C=>C);class v{constructor(A,M,K,te,he){this.id=A,this.internalId=M,this.description=K,this.args=te,this.result=he}}e.$BL=v}),define(be[281],we([1,0,11,2,13,213]),function(ae,e,y,O,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0,e.$hM="remoteFilesystem";class L extends I.$gM{static register(b,d,P){const p=b.getConnection();if(!p)return O.$kb.None;const w=new O.$jb,h=(async()=>{try{const m=await b.getRawEnvironment();m?d.registerProvider(a.Schemas.vscodeRemote,w.add(new L(m,p))):P.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(m){P.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$8)(m))}})();return w.add(d.onWillActivateFileSystemProvider(m=>{m.scheme===a.Schemas.vscodeRemote&&m.join(h)})),w}constructor(b,d){super(d.getChannel(e.$hM),{pathCaseSensitive:b.os===3})}}e.$iM=L}),define(be[92],we([1,0,30,14,7,8,23,167,299,300]),function(ae,e,y,O,a,I,L,R,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.zip=e.$Zo=e.$Yo=void 0,e.$Yo="end of central directory record signature not found";const P=new RegExp(e.$Yo);class p extends Error{constructor(i,r){let n=r.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=r}}e.$Zo=p;function w(t){const i=t.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,n)=>r+n,i&61440)}function h(t){if(t instanceof p)return t;let i;return P.test(t.message)&&(i="CorruptZip"),new p(i,t)}function m(t,i,r,n,s,c){const f=a.$bc(i),k=a.$$b(n,f);if(!k.startsWith(n))return Promise.reject(new Error(R.localize(0,null,i)));const v=a.$$b(n,i);let C;return c.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(L.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((A,M)=>{if(!c.isCancellationRequested)try{C=(0,y.createWriteStream)(v,{mode:r}),C.once("close",()=>A()),C.once("error",M),t.once("error",M),t.pipe(C)}catch(K){M(K)}}))}function $(t,i,r,n){let s=(0,O.$fg)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{s.cancel(),t.close()}),new Promise((f,k)=>{const v=new O.$mg,C=A=>{A.isCancellationRequested||(c++,t.readEntry())};t.once("error",k),t.once("close",()=>s.then(()=>{n.isCancellationRequested||t.entryCount===c?f():k(new p("Incomplete",new Error(R.localize(1,null,c,t.entryCount))))},k)),t.readEntry(),t.on("entry",A=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){C(n);return}const M=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const he=a.$$b(i,M);s=(0,O.$fg)(ce=>L.Promises.mkdir(he,{recursive:!0}).then(()=>C(ce)).then(void 0,k));return}const K=u(t,A),te=w(A);s=(0,O.$fg)(he=>v.queue(()=>K.then(ce=>m(ce,M,te,i,r,he).then(()=>C(he)))).then(null,k))})})}function o(t,i=!1){return new Promise((r,n)=>{(0,b.open)(t,i?{lazyEntries:!0}:void 0,(s,c)=>{s?n(h(s)):r((0,I.$re)(c))})})}function u(t,i){return new Promise((r,n)=>{t.openReadStream(i,(s,c)=>{s?n(h(s)):r((0,I.$re)(c))})})}function l(t,i){return new Promise((r,n)=>{const s=new d.ZipFile;i.forEach(f=>{f.contents?s.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&s.addFile(f.localPath,f.path)}),s.end();const c=(0,y.createWriteStream)(t);s.outputStream.pipe(c),s.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>r(t))})}e.zip=l;function g(t,i,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=o(t,!0);return r.overwrite&&(c=c.then(f=>L.Promises.rm(i).then(()=>f))),c.then(f=>$(f,i,{sourcePathRegex:s},n))}e.$2o=g;function D(t,i){return o(t).then(r=>new Promise((n,s)=>{r.on("entry",c=>{c.fileName===i&&u(r,c).then(f=>n(f),f=>s(f))}),r.once("close",()=>s(new Error(R.localize(2,null,i))))}))}function E(t,i){return D(t,i).then(r=>new Promise((n,s)=>{const c=[];r.once("error",s),r.on("data",f=>c.push(f)),r.on("end",()=>n(Buffer.concat(c)))}))}e.$3o=E}),define(be[282],we([1,0,14,11,2,13,3,19,53,8,21,23,92,24,25,31,37,80,16,12]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;let D=e.$fp=class nn extends a.$kb{constructor(t,i,r,n,s,c){super(),this.h=i,this.i=r,this.j=n,this.k=s,this.l=c,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,i,r){await this.g;const n=(0,R.$6f)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,n,c=>this.i.download(t,c,i))}catch(c){throw new $.$Nn(c.message,$.ExtensionManagementErrorCode.Download)}let s=!1;if(r&&this.m(t)){const c=await this.n(t);try{s=await this.k.verify(n.fsPath,c.fsPath,this.l.getLevel()===g.LogLevel.Trace)}catch(f){const k=f;if(s=k.code,k.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${k.output}`),s===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$Nn(w.$Yo,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(c)}catch(f){this.l.error(f)}}}return s===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:n,verificationStatus:s}}m(t){if(!t.isSigned)return!1;const i=this.j.getValue("extensions.verifySignature");return(0,d.$me)(i)?i:!0}async n(t){await this.g;const i=(0,R.$6f)(this.extensionsDownloadDir,`${this.v(t)}${nn.c}`);return await this.r(t,i,r=>this.i.downloadSignatureArchive(t,r)),i}async r(t,i,r){if(await this.h.exists(i))return;if(i.scheme!==I.Schemas.file){await r(i);return}const n=(0,R.$6f)(this.extensionsDownloadDir,`.${(0,P.$3e)()}`);await this.h.exists(n)||await r(n);try{await this.t(n,i,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,i.path);else throw this.l.info(`Rename failed because of ${(0,O.$8)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.h.del(t)}async t(t,i,r){try{await p.Promises.rename(t.fsPath,i.fsPath)}catch(n){if(L.$d&&n&&n.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${t} to ${i} with 'EPERM' error. Trying again...`),this.t(t,i,r);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const i=[],r=[],n=[];for(const f of t.children)if(f.name.endsWith(nn.c))n.push(f.resource);else{const k=o.$do.parse(f.name);k&&r.push([k,f])}const s=(0,o.$io)(r,([f])=>f),c=[];for(const f of s)f.sort((k,v)=>b.rcompare(k[0].version,v[0].version)),i.push(...f.slice(1).map(k=>k[1].resource)),c.push(f[0][1]);c.sort((f,k)=>f.mtime-k.mtime),i.push(...c.slice(0,Math.max(0,c.length-this.f)).map(f=>f.resource)),i.push(...n),await y.Promises.settled(i.map(f=>(this.l.trace("Deleting from cache",f.path),this.h.del(f))))}}catch(t){this.l.error(t)}}v(t){return this.f?o.$do.create(t).toString().toLowerCase():(0,P.$3e)()}};D.c=".sigzip",e.$fp=D=Re([Ae(0,m.$th),Ae(1,l.$Oj),Ae(2,$.$Mn),Ae(3,h.$Rh),Ae(4,u.$So),Ae(5,g.$Ni)],D)}),define(be[283],we([1,0,92,179]),function(ae,e,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;function a(I){return(0,y.$3o)(I,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.$hp=a}),define(be[137],we([1,0,14,15,20,39,11,5,2,28,13,7,3,19,53,8,4,21,23,92,178,79,25,252,31,37,45,57,282,253,283,227,236,77,16,6,12,27,32,34,33]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A,M,K,te,he,ce,le,ge,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=void 0,e.$kp=(0,te.$mh)(r.$On);let V=e.$lp=class extends i.$4o{constructor(Q,_,T,S,F,ee,oe,z,q,W,U,X){super(Q,_,T,W,X),this.$=F,this.ab=ee,this.bb=oe,this.cb=q,this.db=U,this.Y=this.B(new R.$5c),this.onDidUpdateExtensionMetadata=this.Y.event,this.Z=new Map,this.lb=new d.$ki;const G=this.B(z.createInstance(k.$gp));this.U=this.B(z.createInstance(ie,ue=>G.postUninstall(ue))),this.W=this.B(new C.$ip(X,q,U,this,this.v)),this.X=this.B(z.createInstance(f.$fp));const Y=this.B(new A.$jp(this,this.$,X,ee,U,q,T));this.B(Y.onDidChangeExtensionsByAnotherSource(ue=>this.kb(ue))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.$no)(this.cb,this.v)),this.eb}async zip(Q){this.v.trace("ExtensionManagementService#zip",Q.identifier.id);const _=await this.jb(Q),T=await(0,g.zip)((0,h.$6f)(this.X.extensionsDownloadDir,(0,u.$3e)()).fsPath,_);return o.URI.file(T)}async unzip(Q){return this.v.trace("ExtensionManagementService#unzip",Q.toString()),(await this.install(Q)).identifier}async getManifest(Q){const{location:_,cleanup:T}=await this.fb(Q),S=p.$_b(_.fsPath);try{return await(0,v.$hp)(S)}finally{await T()}}getInstalled(Q,_=this.y.defaultProfile.extensionsResource){return this.U.scanExtensions(Q??null,_)}scanAllUserInstalledExtensions(){return this.U.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.U.scanUserExtensionAtLocation(Q)}async install(Q,_={}){this.v.trace("ExtensionManagementService#install",Q.toString());const{location:T,cleanup:S}=await this.fb(Q);try{const F=await(0,v.$hp)(p.$_b(T.fsPath)),ee=(0,n.$ho)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,M.$uo)(F.engines.vscode,this.w.version,this.w.date))throw new Error(D.localize(0,null,ee,this.w.version));const oe=await this.z([{manifest:F,extension:T,options:_}]);if(oe[0]?.local)return oe[0]?.local;throw oe[0]?.error?oe[0].error:(0,i.$6o)(new Error(`Unknown error while installing extension ${ee}`))}finally{await S()}}async installFromLocation(Q,_){this.v.trace("ExtensionManagementService#installFromLocation",Q.toString());const T=await this.U.scanUserExtensionAtLocation(Q);if(!T)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.ob([[T,void 0]],_),this.v.info("Successfully installed extension",T.identifier.id,_.toString()),T}async installExtensionsFromProfile(Q,_,T){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",Q,_.toString(),T.toString());const S=(await this.U.scanExtensions(1,_)).filter(F=>Q.some(ee=>(0,n.$co)(ee,F.identifier)));if(S.length){const F=await Promise.all(S.map(ee=>this.U.scanMetadata(ee,_)));await this.ob(S.map((ee,oe)=>[ee,F[oe]]),T),this.v.info("Successfully installed extensions",S.map(ee=>ee.identifier.id),T.toString())}return S}async updateMetadata(Q,_,T=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),_.isPreReleaseVersion&&(_.preRelease=!0),_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.pinned=_.pinned||void 0,Q=await this.U.updateMetadata(Q,_,T),this.W.invalidate(T),this.Y.fire(Q),Q}async reinstallFromGallery(Q){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.t.isEnabled())throw new Error(D.localize(1,null));const _=await this.getTargetPlatform(),[T]=await this.t.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:_,compatible:!0},a.CancellationToken.None);if(!T)throw new Error(D.localize(2,null));await this.U.setUninstalled(Q);try{await this.U.removeUninstalledExtension(Q)}catch(S){throw new Error(D.localize(3,null,(0,I.$9h)(S)))}return this.installFromGallery(T)}copyExtensions(Q,_){return this.U.copyExtensions(Q,_)}markAsUninstalled(...Q){return this.U.setUninstalled(...Q)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.U.cleanUp()}catch(Q){this.v.error(Q)}}async download(Q,_,T){const{location:S}=await this.X.download(Q,_,!T);return S}async fb(Q){if(Q.scheme===P.Schemas.file)return{location:Q,async cleanup(){}};this.v.trace("Downloading extension from",Q.toString());const _=(0,h.$6f)(this.X.extensionsDownloadDir,(0,u.$3e)());return await this.bb.download(Q,_),this.v.info("Downloaded extension to",_.toString()),{location:_,cleanup:async()=>{try{await this.cb.del(_)}catch(S){this.v.error(S)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(Q,_,T){if(o.URI.isUri(_))return new H(Q,_,T,this.t,this.U,this.db,this.y,this.$,this.ab,this.v);const S=n.$do.create(_).toString();let F=this.Z.get(S);return F||(this.Z.set(S,F=new Z(Q,_,T,this.X,this.U,this.db,this.y,this.$,this.ab,this.v)),F.waitUntilTaskIsFinished().finally(()=>this.Z.delete(S))),F}S(Q,_){return new B(Q,_.profileLocation,this.ab)}async jb(Q){const _=async S=>{let F=await l.Promises.readdir(S);F=F.map(z=>p.$$b(S,z));const ee=await Promise.all(F.map(z=>l.Promises.stat(z)));let oe=Promise.resolve([]);return ee.forEach((z,q)=>{const W=F[q];z.isFile()&&(oe=oe.then(U=>[...U,W])),z.isDirectory()&&(oe=oe.then(U=>_(W).then(X=>[...U,...X])))}),oe};return(await _(Q.location.fsPath)).map(S=>({path:`extension/${p.$ac(Q.location.fsPath,S)}`,localPath:S}))}async kb({added:Q,removed:_}){if(_)for(const T of _.extensions)this.v.info("Extensions removed from another source",T.id,_.profileLocation.toString()),this.p.fire({identifier:T,profileLocation:_.profileLocation});if(Q){const S=(await this.U.scanExtensions(1,Q.profileLocation)).filter(F=>Q.extensions.some(ee=>(0,n.$co)(ee,F.identifier)));this.m.fire(S.map(F=>(this.v.info("Extensions added from another source",F.identifier.id,Q.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:Q.profileLocation,operation:1})))}}async mb(){this.B(this.U.onExtract(_=>this.lb.add(_)));const Q=await this.cb.resolve(this.$.userExtensionsLocation);for(const _ of Q.children??[])_.isDirectory&&this.lb.add(_.resource);this.B(this.cb.watch(this.$.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(_=>this.nb(_)))}async nb(Q){if(!Q.affects(this.$.userExtensionsLocation,1))return;const _=[];for(const T of Q.rawAdded){if(this.lb.has(T)||!this.db.extUri.isEqual(this.db.extUri.dirname(T),this.$.userExtensionsLocation)||this.db.extUri.isEqual(T,this.db.extUri.joinPath(this.$.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(T).startsWith(".")||!(await this.cb.stat(T)).isDirectory)continue;const S=await this.U.scanUserExtensionAtLocation(T);S&&S.installedTimestamp===void 0&&(this.lb.add(T),_.push(S))}_.length&&(await this.ob(_.map(T=>[T,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",_.map(T=>T.identifier.id)))}async ob(Q,_){const T=Q.map(S=>S[0]);await this.pb(T),await this.ab.addExtensionsToProfile(Q,_),this.m.fire(T.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:_})))}async pb(Q){const _=await this.U.getUninstalledExtensions();for(const T of Q){const S=n.$do.create(T);_[S.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",S.id),await this.U.setInstalled(S),this.v.info("Removed the extension from uninstalled list:",S.id))}}};e.$lp=V=Re([Ae(0,r.$Mn),Ae(1,le.$Rk),Ae(2,he.$Ni),Ae(3,t.$th),Ae(4,c.$ap),Ae(5,s.$9o),Ae(6,E.$rn),Ae(7,te.$kh),Ae(8,K.$Oj),Ae(9,ce.$6i),Ae(10,ge.$lk),Ae(11,se.$nk)],V);let ie=e.$mp=class extends b.$kb{constructor(Q,_,T,S,F,ee){super(),this.k=Q,this.l=_,this.m=T,this.n=S,this.p=F,this.s=ee,this.h=this.B(new R.$5c),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,h.$6f)(this.m.userExtensionsLocation,".obsolete"),this.g=new y.$yg}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(Q,_){const T={includeInvalid:!0,profileLocation:_};let S=[];return Q===null||Q===0?S.push(...await this.m.scanAllExtensions({includeInvalid:!0},T,!1)):Q===1&&S.push(...await this.m.scanUserExtensions(T)),S=Q!==null?S.filter(F=>F.type===Q):S,Promise.all(S.map(F=>this.y(F)))}async scanAllUserExtensions(Q){const _=await this.m.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return Promise.all(_.map(T=>this.y(T)))}async scanUserExtensionAtLocation(Q){try{const _=await this.m.scanExistingExtension(Q,1,{includeInvalid:!0});if(_)return await this.y(_)}catch(_){this.s.error(_)}return null}async extractUserExtension(Q,_,T,S,F){await this.j.catch(()=>{});const ee=Q.toString(),oe=p.$$b(this.m.userExtensionsLocation.fsPath,`.${(0,u.$3e)()}`),z=p.$$b(this.m.userExtensionsLocation.fsPath,ee);let q=await this.l.exists(o.URI.file(z));if(q&&S){try{await l.Promises.rm(z)}catch{throw new r.$Nn(D.localize(4,null,z,Q.id),r.ExtensionManagementErrorCode.Delete)}q=!1}if(!q){await this.u(Q,_,oe,F),await this.m.updateMetadata(o.URI.file(oe),T);try{this.h.fire(o.URI.file(z)),await this.v(Q,oe,z,Date.now()+2*60*1e3),this.s.info("Renamed to",z)}catch(W){try{await l.Promises.rm(oe)}catch{}if(W.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);else throw this.s.info(`Rename failed because of ${(0,L.$8)(W)}. Deleted from extracted location`,oe),W}}return this.w(o.URI.file(z),1)}async scanMetadata(Q,_){return _?(await this.n.scanProfileExtensions(_)).find(S=>(0,n.$co)(S.identifier,Q.identifier))?.metadata:this.m.scanMetadata(Q.location)}async updateMetadata(Q,_,T){return T?await this.n.updateMetadata([[Q,_]],T):await this.m.updateMetadata(Q.location,_),this.w(Q.location,Q.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...Q){const _=Q.map(T=>n.$do.create(T));await this.t(T=>_.forEach(S=>{T[S.toString()]=!0,this.s.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(Q){await this.t(_=>delete _[Q.toString()])}async removeExtension(Q,_){this.s.trace(`Deleting ${_} extension from disk`,Q.identifier.id,Q.location.fsPath);const T=this.p.extUri.joinPath(this.p.extUri.dirname(Q.location),`._${(0,u.$3e)()}`);await this.v(Q.identifier,Q.location.fsPath,T.fsPath,Date.now()+2*60*1e3),await this.l.del(T,{recursive:!0}),this.s.info("Deleted from disk",Q.identifier.id,Q.location.fsPath)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.t(_=>delete _[n.$do.create(Q).toString()])}async copyExtensions(Q,_){const T=await this.scanExtensions(1,Q),S=await Promise.all(T.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,Q)]));await this.n.addExtensionsToProfile(S,_)}async t(Q){return this.g.queue(async()=>{let _;try{_=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,K.$5j)(S)!==1)throw S}let T={};if(_)try{T=JSON.parse(_)}catch{}return Q&&(Q(T),Object.keys(T).length?await this.l.writeFile(this.c,O.$Ib.fromString(JSON.stringify(T))):await this.l.del(this.c)),T})}async u(Q,_,T,S){this.s.trace(`Started extracting the extension from ${_} to ${T}`);try{await l.Promises.rm(T)}catch(F){throw new r.$Nn(this.D(F).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,g.$2o)(_,T,{sourcePath:"extension",overwrite:!0},S),this.s.info(`Extracted extension to ${T}:`,Q.id)}catch(F){try{await l.Promises.rm(T)}catch{}let ee=r.ExtensionManagementErrorCode.Extract;throw F instanceof g.$Zo&&(F.type==="CorruptZip"?ee=r.ExtensionManagementErrorCode.CorruptZip:F.type==="Incomplete"&&(ee=r.ExtensionManagementErrorCode.IncompleteZip)),new r.$Nn(F.message,ee)}}async v(Q,_,T,S){try{await l.Promises.rename(_,T)}catch(F){if(w.$d&&F&&F.code==="EPERM"&&Date.now()<S)return this.s.info(`Failed renaming ${_} to ${T} with 'EPERM' error. Trying again...`,Q.id),this.v(Q,_,T,S);throw new r.$Nn(F.message||D.localize(5,null,_,T),F.code||r.ExtensionManagementErrorCode.Rename)}}async w(Q,_){const T=await this.m.scanExistingExtension(Q,_,{includeInvalid:!0});if(T)return this.y(T);throw new Error(D.localize(6,null,Q.path))}async y(Q){const _=await this.l.resolve(Q.location);let T,S;return _.children&&(T=_.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,S=_.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:T,changelogUrl:S,publisherDisplayName:Q.metadata?.publisherDisplayName||null,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned}}async z(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(Q));const _=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const F of _)Q[n.$do.create(F).toString()]||T.add(F.identifier.id.toLowerCase());try{const F=(0,n.$io)(_,ee=>ee.identifier);await y.Promises.settled(F.map(async ee=>{const oe=ee.sort((z,q)=>m.rcompare(z.manifest.version,q.manifest.version))[0];T.has(oe.identifier.id.toLowerCase())||await this.k(await this.y(oe))}))}catch(F){this.s.error(F)}const S=_.filter(F=>F.metadata&&Q[n.$do.create(F).toString()]);await Promise.allSettled(S.map(F=>this.removeUninstalledExtension(F)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const Q=[];let _;try{_=await this.l.resolve(this.m.userExtensionsLocation)}catch(T){(0,K.$5j)(T)!==1&&this.s.error(T)}for(const T of _?.children??[])T.isDirectory&&T.name.startsWith("._")&&(0,u.$2e)(T.name.substring(2))&&Q.push((async()=>{this.s.trace("Deleting the generated extension folder",T.resource.toString());try{await this.l.del(T.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",T.resource.toString())}catch(S){this.s.error(S)}})());await Promise.allSettled(Q)}D(Q){const _=Array.isArray(Q)?Q:[Q];return _.length===1?_[0]instanceof Error?_[0]:new Error(_[0]):_.reduce((T,S)=>new Error(`${T.message}${T.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}};e.$mp=ie=Re([Ae(1,K.$Oj),Ae(2,c.$ap),Ae(3,s.$9o),Ae(4,ge.$lk),Ae(5,he.$Ni)],ie);class J extends i.$7o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,$.$ne)(this.m.operation)?this.l:this.m.operation}constructor(Q,_,T,S,F,ee,oe,z,q){super(),this.identifier=Q,this.source=_,this.m=T,this.n=S,this.o=F,this.p=ee,this.q=oe,this.s=z,this.t=q,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(Q){const[_,T]=await this.y(Q);return this.j=_.isBuiltin||_.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[_,T]],this.j),_}async v({zipPath:Q,key:_,metadata:T},S,F){let ee=await this.w(_);return ee||(this.t.trace("Extracting extension...",_.id),ee=await this.n.extractUserExtension(_,Q,T,S,F),this.t.info("Extracting extension completed.",_.id)),ee}async w(Q){return await this.x(Q)?(this.t.trace("Removing the extension from uninstalled list:",Q.id),await this.n.setInstalled(Q),this.t.info("Removed the extension from uninstalled list:",Q.id),(await this.n.scanAllUserExtensions(!0)).find(S=>n.$do.create(S).equals(Q))):void 0}async x(Q){return!!(await this.n.getUninstalledExtensions())[Q.toString()]}}class Z extends J{constructor(Q,_,T,S,F,ee,oe,z,q,W){super(_.identifier,_,T,F,ee,oe,z,q,W),this.z=_,this.A=S}async y(Q){const T=(await this.n.scanExtensions(null,this.m.profileLocation)).find(oe=>(0,n.$co)(oe.identifier,this.z.identifier));T&&(this.l=3);const S={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||T?.isMachineScoped,isBuiltin:this.m.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,$.$me)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.z.version)return[await this.n.updateMetadata(T,S),S];const{location:F,verificationStatus:ee}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=ee,this.C(F.fsPath),[await this.v({zipPath:F.fsPath,key:n.$do.create(this.z),metadata:S},!1,Q),S]}catch(oe){try{await this.A.delete(F)}catch(z){this.t.warn("Error while deleting the downloaded file",F.toString(),(0,L.$8)(z))}throw oe}}async C(Q){try{await(0,v.$hp)(Q)}catch(_){throw new r.$Nn((0,i.$5o)(_).message,r.ExtensionManagementErrorCode.Invalid)}}}e.$np=Z;class H extends J{constructor(Q,_,T,S,F,ee,oe,z,q,W){super({id:(0,n.$ho)(Q.publisher,Q.name)},_,T,F,ee,oe,z,q,W),this.z=Q,this.A=_,this.B=S}async h(Q){const _=await super.h(Q);return this.E(_,Q),_}async y(Q){const _=new n.$do(this.identifier,this.z.version),S=(await this.n.scanExtensions(1,this.m.profileLocation)).find(oe=>(0,n.$co)(this.identifier,oe.identifier)),F={isApplicationScoped:this.m.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||S?.isMachineScoped,isBuiltin:this.m.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(S)if(this.l=3,_.equals(new n.$do(S.identifier,S.manifest.version)))try{await this.n.removeExtension(S,"existing")}catch{throw new Error(D.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&m.gt(S.manifest.version,this.z.version)&&await this.n.setUninstalled(S);else{const oe=await this.w(_);if(oe)try{await this.n.removeExtension(oe,"existing")}catch{throw new Error(D.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:p.$_b(this.A.fsPath),key:_,metadata:F},!0,Q),F]}async E(Q,_){try{let[T]=await this.B.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],_);if(T||([T]=await this.B.getExtensions([{id:Q.identifier.id}],_)),T){const S={id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(Q,S,this.m.profileLocation)}}catch{}}}class B extends i.$7o{constructor(Q,_,T){super(),this.extension=Q,this.j=_,this.k=T}async h(Q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[70],we([1,0,85,76,26,284,15,11,5,2,7,3,21,43,105]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0;class ${traceSocketEvent(C,A){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,A)}constructor(C,A=""){this.f=!0,this.debugLabel=A,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,R.$X)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const A=M=>{this.traceSocketEvent("read",M),C(L.$Ib.wrap(M))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(C){const A=M=>{C({type:0,hadError:M,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(C){const A=()=>{C()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,R.$X)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,R.$X)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ah=$;var o;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var u;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(u||(u={}));class l extends d.$kb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,A){this.socket.traceSocketEvent(C,A)}constructor(C,A,M,K){super(),this.f=this.B(new b.$5c),this.g=this.B(new b.$5c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:M?.byteLength||0,recordInflateBytes:K}),this.a=this.B(new g(this,A,M,K,this.f,(te,he)=>this.k(te,he))),this.B(this.a.onError(te=>{console.error(te),(0,R.$X)(te),this.g.fire({type:0,hadError:!0,error:te})})),this.b=new m.$8g,this.B(this.socket.onData(te=>this.l(te))),this.B(this.socket.onClose(async te=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(te)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let A=0;for(;A<C.byteLength;)this.a.writeMessage(C.slice(A,Math.min(A+262144,C.byteLength))),A+=262144}k(C,A){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let M=2;C.byteLength<126?M+=0:C.byteLength<2**16?M+=2:M+=8;const K=L.$Ib.alloc(M);if(A?K.writeUInt8(194,0):K.writeUInt8(130,0),C.byteLength<126)K.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){K.writeUInt8(126,1);let te=1;K.writeUInt8(C.byteLength>>>8&255,++te),K.writeUInt8(C.byteLength>>>0&255,++te)}else{K.writeUInt8(127,1);let te=1;K.writeUInt8(0,++te),K.writeUInt8(0,++te),K.writeUInt8(0,++te),K.writeUInt8(0,++te),K.writeUInt8(C.byteLength>>>24&255,++te),K.writeUInt8(C.byteLength>>>16&255,++te),K.writeUInt8(C.byteLength>>>8&255,++te),K.writeUInt8(C.byteLength>>>0&255,++te)}this.socket.write(L.$Ib.concat([K,C]))}end(){this.h=!0,this.socket.end()}l(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),M=A.readUInt8(0),K=(M&128)>>>7,te=(M&64)>>>6,he=A.readUInt8(1),ce=(he&128)>>>7,le=he&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=K,this.j.firstFrameOfMessage&&(this.j.compressed=!!te),this.j.firstFrameOfMessage=!!K,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),M=A.readUInt8(1),K=(M&128)>>>7;let te=M&127,he=1;te===126?te=A.readUInt8(++he)*2**8+A.readUInt8(++he):te===127&&(te=A.readUInt8(++he)*0+A.readUInt8(++he)*0+A.readUInt8(++he)*0+A.readUInt8(++he)*0+A.readUInt8(++he)*2**24+A.readUInt8(++he)*2**16+A.readUInt8(++he)*2**8+A.readUInt8(++he));let ce=0;K&&(ce=A.readUInt8(++he)*2**24+A.readUInt8(++he)*2**16+A.readUInt8(++he)*2**8+A.readUInt8(++he)),this.j.state=3,this.j.readLen=te,this.j.mask=ce,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(A,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$bh=l;class g extends d.$kb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Ib.alloc(0)}constructor(C,A,M,K,te,he){super(),this.l=C,this.m=te,this.n=he,this.a=this.B(new b.$5c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$5c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new b.$5c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,A?(this.b=this.B(new D(this.l,K,M,{windowBits:15})),this.f=this.B(new E(this.l,{windowBits:15})),this.B(this.b.onError(ce=>this.a.fire(ce))),this.B(this.f.onError(ce=>this.a.fire(ce)))):(this.b=null,this.f=null)}writeMessage(C){this.g.push(C),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const C=this.g.shift();if(this.f){const A=await this.s(this.f,C);this.n(A,!0)}else this.n(C,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(C,A){return new Promise((M,K)=>{C.write(A),C.flush(te=>M(te))})}acceptFrame(C,A,M){this.h.push({data:C,isCompressed:A,isLastFrameOfMessage:M}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const A=await this.w(this.b,C.data,C.isLastFrameOfMessage);this.m.fire(A)}else this.m.fire(C.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(C,A,M){return new Promise((K,te)=>{C.write(A),M&&C.write(L.$Ib.fromByteArray([0,0,255,255])),C.flush(he=>K(he))})}}class D extends d.$kb{get recordedInflateBytes(){return this.j?L.$Ib.concat(this.f):L.$Ib.alloc(0)}constructor(C,A,M,K){super(),this.h=C,this.j=A,this.a=this.B(new b.$5c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(K),this.b.on("error",te=>{this.h.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this.a.fire(te)}),this.b.on("data",te=>{this.h.traceSocketEvent("zlibInflateData",te),this.g.push(L.$Ib.wrap(te))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=L.$Ib.concat(this.g);this.g.length=0,C(A)})}}class E extends d.$kb{constructor(C,A){super(),this.g=C,this.a=this.B(new b.$5c),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(L.$Ib.wrap(M))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=L.$Ib.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),C(A)})}}function t(v,C){if(C===0)return;const A=v.byteLength>>>2;for(let le=0;le<A;le++){const ge=v.readUInt32BE(le*4);v.writeUInt32BE(ge^C,le*4)}const M=A*4,K=v.byteLength-M,te=C>>>24&255,he=C>>>16&255,ce=C>>>8&255;K>=1&&v.writeUInt8(v.readUInt8(M)^te,M),K>=2&&v.writeUInt8(v.readUInt8(M+1)^he,M+1),K>=3&&v.writeUInt8(v.readUInt8(M+2)^ce,M+2)}e.$ch=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function r(){const v=(0,w.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const C=process.platform!=="darwin"&&e.$ch?e.$ch:(0,a.tmpdir)(),A=(0,P.$$b)(C,`vscode-ipc-${v}.sock`);return s(A),A}e.$dh=r;function n(v,C,A){const M=(0,y.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${A}-${C}-sock`;const K=A.substr(0,4),te=C.substr(0,6),he=M.substr(0,8);let ce;return process.platform!=="darwin"&&e.$ch&&!process.env.VSCODE_PORTABLE?ce=(0,P.$$b)(e.$ch,`vscode-${he}-${K}-${te}.sock`):ce=(0,P.$$b)(v,`${K}-${te}.sock`),s(ce),ce}e.$eh=n;function s(v){const C=i[p.$o];typeof C=="number"&&v.length>=C&&console.warn(`WARNING: IPC handle "${v}" is longer than ${C} chars, try a shorter --user-data-dir`)}class c extends h.$2g{static b(C){const A=b.Event.fromNodeEventEmitter(C,"connection");return b.Event.map(A,M=>({protocol:new m.$9g(new $(M,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(M,"close"))}))}constructor(C){super(c.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$fh=c;function f(v){return new Promise((C,A)=>{const M=(0,O.createServer)();M.on("error",A),M.listen(v,()=>{M.removeListener("error",A),C(new c(M))})})}e.$gh=f;function k(v,C){return new Promise((A,M)=>{const K=(0,O.createConnection)(v,()=>{K.removeListener("error",M),A(m.$0g.fromSocket(new $(K,`ipc-client${C}`),C))});K.once("error",M)})}e.$hh=k}),define(be[138],we([1,0,83,14,15,11,8,24,25,84,12,44,230,284]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0;let m=e.$Aq=class extends p.$wo{constructor(l,g,D,E){super(E),this.j=l,this.k=g,this.l=D,this.m(),this.B(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const l=this.j.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,g){const{f:D,g:E}=this;let t;try{t=await(0,d.$vl)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,I.$8)(n)))}const i={...process.env,...t},r=l.agent?l.agent:await(0,w.$zq)(l.url||"",i,{proxyUrl:D,strictSSL:E});return l.agent=r,l.strictSSL=E,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.c(l.isChromiumNetwork?"electron":"node",l,()=>o(l,g))}async resolveProxy(l){}};e.$Aq=m=Re([Ae(0,R.$Rh),Ae(1,b.$th),Ae(2,P.$Ni),Ae(3,P.$Oi)],m);async function $(u){return((0,y.parse)(u.url).protocol==="https:"?await new Promise((D,E)=>{ae(["https"],D,E)}):await new Promise((D,E)=>{ae(["http"],D,E)})).request}async function o(u,l){return O.Promises.withAsyncBody(async(g,D)=>{const E=(0,y.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await $(u),i={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,L.$me)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(i.auth=u.user+":"+u.password);const r=t(i,n=>{const s=(0,L.$ke)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)o({...u,url:n.headers.location,followRedirects:s-1},l).then(g,D);else{let c=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,h.createGunzip)())),g({res:n,stream:(0,a.$Wb)(c)})}});r.on("error",D),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),l.onCancellationRequested(()=>{r.abort(),D(new I.$2)})})}e.$Bq=o}),define(be[139],we([1,0,51,76,89,13,7,15,5,70,84,12,41,3,59,127,2,274,24]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0;async function g(n={},s,c,f,k,v){const C=await(0,a.$2k)(c,f.userDataPath);let A={};if(s)try{A=await(0,P.$vl)(v,k,f.args,process.env)}catch(le){k.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",le)}const K={...process.env,...A,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(C,void 0,0),...n},te=f.isBuilt?(0,L.$$b)(f.appRoot,"bin"):(0,L.$$b)(f.appRoot,"resources","server","bin-dev"),he=(0,L.$$b)(te,"remote-cli");let ce=t(K,"PATH");return ce?ce=he+L.$ic+ce:ce=he,i(K,"PATH",ce),f.args["without-browser-env-var"]||(K.BROWSER=(0,L.$$b)(te,"helpers",h.$d?"browser.cmd":"browser.sh")),r(K),K}e.$bm=g;class D{constructor(s,c){this.socket=s,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let s,c,f;return this.socket instanceof d.$ah?(s=!0,c=!1,f=R.$Ib.alloc(0)):(s=!1,c=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:s,permessageDeflate:c,inflateBytes:f.buffer.toString("base64")}}}let E=e.$cm=class{constructor(s,c,f,k,v,C,A,M){this.i=s,this.j=v,this.l=C,this.m=A,this.n=M,this.b=new b.$5c,this.onClose=this.b.event,this.c=!h.$d||!this.j.args["socket-path"],this.d=!1,this.f=c,this.g=null,this.h=new D(f,k),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(s){this.l.info(`${this.o}${s}`)}q(s){this.l.error(`${this.o}${s}`)}async r(s,c){const f=new o.$jb;f.add(c.socket),f.add((0,o.$ib)(()=>{s.destroy()}));const k=()=>{f.dispose()};f.add(c.socket.onEnd(k)),f.add(c.socket.onClose(k)),f.add(b.Event.fromNodeEventEmitter(s,"end")(k)),f.add(b.Event.fromNodeEventEmitter(s,"close")(k)),f.add(b.Event.fromNodeEventEmitter(s,"error")(k)),f.add(c.socket.onData(v=>s.write(v.buffer))),f.add(b.Event.fromNodeEventEmitter(s,"data")(v=>{c.socket.write(R.$Ib.wrap(v))})),c.initialDataChunk.byteLength>0&&s.write(c.initialDataChunk.buffer)}async s(s,c){await c.socketDrain();const f=c.toIExtHostSocketMessage();let k;c.socket instanceof d.$ah?k=c.socket.socket:k=c.socket.socket.socket,s.send(f,k)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const s={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(s)}acceptReconnection(s,c,f){this.f=s,this.p("The client has reconnected.");const k=new D(c,f);if(!this.g){this.h=k;return}this.s(this.g,k)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(s){try{let c=process.execArgv?process.execArgv.filter(he=>!/^--inspect(-brk)?=/.test(he)):[];s.port&&!process.pkg&&(c=[`--inspect${s.break?"-brk":""}=${s.port}`]);const f=await g(s.env,!0,s.language,this.j,this.l,this.n);(0,m.$dl)(f);let k;if(this.c)(0,u.$_l)(new u.$0l,f),k=null;else{const{namedPipeServer:he,pipeName:ce}=await this.u();(0,u.$_l)(new u.$9l(ce),f),k=he}const v={env:f,execArgv:c,silent:!0},C=["--type=extensionHost","--transformURIs"],A=this.j.args["use-host-proxy"];C.push(`--useHostProxy=${A?"true":"false"}`),this.g=y.fork(I.$1e.asFileUri("bootstrap-fork").fsPath,C,v);const M=this.g.pid;this.p(`<${M}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const K=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),te=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if(K(he=>this.p(`<${M}> ${he}`)),te(he=>this.p(`<${M}><stderr> ${he}`)),this.g.on("error",he=>{this.q(`<${M}> Extension Host Process had an error`),this.l.error(he),this.t()}),this.g.on("exit",(he,ce)=>{this.m.setExitInfo(this.i,{code:he,signal:ce}),this.p(`<${M}> Extension Host Process exited with code: ${he}, signal: ${ce}.`),this.t()}),k)k.on("connection",he=>{k.close(),this.r(he,this.h)});else{const he=ce=>{ce.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",he),this.s(this.g,this.h),this.h=null)};this.g.on("message",he)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}u(){return new Promise((s,c)=>{const f=(0,d.$dh)(),k=O.createServer();k.on("error",c),k.listen(f,()=>{k?.removeListener("error",c),s({pipeName:f,namedPipeServer:k})})})}};e.$cm=E=Re([Ae(4,w.$Yl),Ae(5,p.$Ni),Ae(6,$.$7l),Ae(7,l.$Rh)],E);function t(n,s){const c=Object.keys(n).filter(k=>k.toLowerCase()===s.toLowerCase()),f=c.length>0?c[0]:s;return n[f]}function i(n,s,c){const f=Object.keys(n).filter(v=>v.toLowerCase()===s.toLowerCase()),k=f.length>0?f[0]:s;n[k]=c}function r(n){for(const s of Object.keys(n))n[s]===null&&delete n[s]}}),define(be[285],we([1,0,81,12,63,116,24,44,138,36,32,31,125,137,80,110,54,2,111,66,13,16,27,41,119,82,120,11,4,7,29,228,79,34,123,62,3,57,128,33,45,67,126,124,113,114,194,286]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A,M,K,te,he,ce,le,ge,se,V,ie,J,Z,H,B,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class Q extends u.$kb{constructor(F,ee){super(),this.a=F,this.b=ee,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const F=await this.f();await F.invokeFunction(async ee=>{const oe=ee.get(L.$Rh),z=ee.get(O.$Ni);he.$d&&(oe.getValue("security.restrictUNCAccess")===!1?(0,ne.disableUNCAccessRestrictions)():(0,ne.addUNCHostToAllowlist)(oe.getValue("security.allowedUNCHosts")));try{await this.g(F.createInstance(r.$Uo,new O.$Vi(z.getLevel(),!1)))}catch(q){throw z.error(q),console.error((0,c.$8)(q)),q}})}async f(){const F=new y.$jh,ee={_serviceBrand:void 0,...o.default};F.set(t.$6i,ee);const oe=new i.$Zl(this.a,ee);F.set(i.$Yl,oe);const z=new H.$oM((0,O.$2i)(oe),oe.logsHome);F.set(O.$Oi,z);const q=new Z.$yM(this.B(z.createLogger("remoteCLI",{name:(0,B.localize)(0,null)})));F.set(O.$Ni,q),q.trace(`Remote configuration data at ${this.b}`),q.trace("process arguments:",this.a);const W=this.B(new l.$pp(q));F.set(E.$Oj,W),W.registerProvider(D.Schemas.file,this.B(new g.$Op(q)));const U=new K.$_q(W);F.set(M.$lk,U);const X=this.B(new ie.$wM(U,oe,W,q));F.set(ge.$nk,X);const G=this.B(new I.$in(X.defaultProfile.settingsResource,W,new V.$Um,q));return F.set(L.$Rh,G),await Promise.all([G.initialize(),X.init()]),F.set(R.$vo,new a.$ih(b.$Aq)),F.set(A.$rn,new a.$ih(C.$RM)),F.set(P.$Rk,d.$1n),F.set(p.$Mn,new a.$ih(w.$Ro)),F.set(se.$9o,new a.$ih(J.$xM)),F.set(ce.$ap,new a.$ih(le.$jM)),F.set(m.$So,new a.$ih(m.$To)),F.set(h.$kp,new a.$ih(h.$lp)),F.set(n.$uq,new a.$ih(s.$wq)),new $.$Rp(F)}async g(F){if(this.a["list-extensions"])return F.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const ee={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return F.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),ee,!!this.a.force)}else{if(this.a["uninstall-extension"])return F.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return F.locateExtension(this.a["locate-extension"])}}h(F){return F.map(ee=>/\.vsix$/i.test(ee)?f.URI.file((0,k.$0b)(ee)?ee:(0,k.$$b)((0,v.cwd)(),ee)):ee)}}function _(S){setTimeout(()=>process.exit(S),0)}async function T(S,F,ee){if(S.help){const z=o.default.serverApplicationName+(he.$d?".cmd":"");console.log((0,te.$kl)(o.default.nameLong,z,o.default.version,ee,{noInputFiles:!0,noPipe:!0}));return}if(S.version){console.log((0,te.$ll)(o.default.version,o.default.commit));return}const oe=new Q(S,F);try{await oe.run(),_(0)}catch{_(1)}finally{oe.dispose()}}e.run=T}),define(be[287],we([1,0,70,261,30,280,4,12,88]),function(ae,e,y,O,a,I,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=void 0;class d{constructor(w,h,m){this.b=w,this.c=h,this.f=m,this.a=O.createServer(($,o)=>this.h($,o)),this.g().catch($=>(h.error($),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,h){const m=(o,u)=>{h.writeHead(o,{"content-type":"application/json"}),h.end(JSON.stringify(u||null),l=>l&&this.c.error(l))},$=[];w.setEncoding("utf8"),w.on("data",o=>$.push(o)),w.on("end",async()=>{try{const o=JSON.parse($.join(""));let u;switch(o.type){case"open":u=await this.i(o);break;case"openExternal":u=await this.j(o);break;case"status":u=await this.l(o);break;case"extensionManagement":u=await this.k(o);break;default:m(404,`Unknown message type: ${o.type}`);break}m(200,u)}catch(o){const u=o instanceof Error?o.message:JSON.stringify(o);m(500,u),this.c.error("Error while processing pipe request",o)}})}async i(w){const{fileURIs:h,folderURIs:m,forceNewWindow:$,diffMode:o,mergeMode:u,addMode:l,forceReuseWindow:g,gotoLineMode:D,waitMarkerFilePath:E,remoteAuthority:t}=w,i=[];if(Array.isArray(m))for(const c of m)try{i.push({folderUri:L.URI.parse(c)})}catch{}if(Array.isArray(h))for(const c of h)try{(0,b.$Qh)(c)?i.push({workspaceUri:L.URI.parse(c)}):i.push({fileUri:L.URI.parse(c)})}catch{}const r=E?L.URI.file(E):void 0,s={forceNewWindow:$,diffMode:o,mergeMode:u,addMode:l,gotoLineMode:D,forceReuseWindow:g,preferNewWindow:!g&&!r&&!l,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",i,s)}async j(w){for(const h of w.uris){const m=L.URI.parse(h),$=m.scheme==="file"?m:h;await this.b.executeCommand("_remoteCLI.openExternal",$)}}async k(w){const h=$=>$?.map(o=>/\.vsix$/i.test(o)?L.URI.parse(o):o),m={list:w.list,install:h(w.install),uninstall:h(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",m)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&a.existsSync(this.f)&&a.unlinkSync(this.f)}}e.$CL=d;let P=e.$DL=class extends d{constructor(w,h){super(w,h,(0,y.$dh)())}};e.$DL=P=Re([Ae(0,I.$xL),Ae(1,R.$Ni)],P)}),define(be[288],we([1,0,26,5,22,2,7,3,4,70,68,287,122,86,268,270,139,8]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=void 0;class l extends $.$dM{constructor(E,t,i,r,n){super({getFolderUri:s=>{const c=t.filter(f=>f.name===s);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(s,c)=>r[`config:${c}`],getExecPath:()=>E.VSCODE_EXEC_PATH,getAppRoot:()=>E.VSCODE_CWD,getFilePath:()=>{if(i)return L.$9b(i.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async s=>{const f=(await n.getInstalled()).find(k=>k.identifier.id===s);return f&&{extensionLocation:f.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(E))}}class g extends I.$kb{constructor(E,t,i,r,n,s){super(),this.g=E,this.h=t,this.i=i,this.j=r,this.l=n,this.m=s,this.a=0,this.b=new Map,this.c=this.B(new O.$5c),this.onExecuteCommand=this.c.event}async call(E,t,i){switch(t){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,i);case"$createProcess":{const r=(0,P.$ar)(E.remoteAuthority);return this.n(r,i)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,i);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,i);case"$listProcesses":return this.i.listProcesses.apply(this.i,i);case"$getPerformanceMarks":return this.i.getPerformanceMarks.apply(this.i,i);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,i);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,i);case"$start":return this.i.start.apply(this.i,i);case"$input":return this.i.input.apply(this.i,i);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,i);case"$shutdown":return this.i.shutdown.apply(this.i,i);case"$resize":return this.i.resize.apply(this.i,i);case"$clearBuffer":return this.i.clearBuffer.apply(this.i,i);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,i);case"$getCwd":return this.i.getCwd.apply(this.i,i);case"$processBinary":return this.i.processBinary.apply(this.i,i);case"$sendCommandResult":return this.r(i[0],i[1],i[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,i);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,i);case"$getDefaultSystemShell":return this.s.apply(this,i);case"$getProfiles":return this.t.apply(this,i);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(i[0],i[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,i);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,i);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,i);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,i);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,i);case"$updateTitle":return this.i.updateTitle.apply(this.i,i);case"$updateProperty":return this.i.updateProperty.apply(this.i,i);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,i);case"$requestDetachInstance":return this.i.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(i[0],i[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,i)}throw new Error(`IPC Command ${t} not found`)}listen(E,t,i){switch(t){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||O.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||O.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||O.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||O.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||O.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||O.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(E,t){const i={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:b.URI.revive(E.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},r=await(0,o.$bm)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,R.$q,this.g,this.h,this.m);this.h.trace("baseEnv",r);const n=ge=>({uri:b.URI.revive(E.transformIncoming(ge.uri)),name:ge.name,index:ge.index,toResource:()=>{throw new Error("Not implemented")}}),s=t.workspaceFolders.map(n),c=t.activeWorkspaceFolder?n(t.activeWorkspaceFolder):void 0,f=t.activeFileResource?b.URI.revive(E.transformIncoming(t.activeFileResource)):void 0,k=new l(r,s,f,t.resolvedVariables,this.l),v=m.$_L(c,process.env,k),C=await m.$$L(i,y.homedir(),v,c?.uri,t.configuration["terminal.integrated.cwd"],this.h);i.cwd=C;const A=R.$d?"terminal.integrated.env.windows":R.$e?"terminal.integrated.env.osx":"terminal.integrated.env.linux",M=t.configuration[A],K=await m.$aM(i,M,v,this.j.version,t.configuration["terminal.integrated.detectLocale"],r);if(!i.strictEnv){const ge=[];for(const[J,Z,H]of t.envVariableCollections)ge.push([J,{map:(0,h.$Yq)(Z),descriptionMap:(0,h.$Zq)(H)}]);const se=new Map(ge),V=new w.$3q(se),ie=c?(0,u.$ye)(c):void 0;await V.applyToProcessEnvironment(K,{workspaceFolder:ie},v)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:C,cols:t.cols,rows:t.rows,env:K});const te=(0,d.$dh)();K.VSCODE_IPC_HOOK_CLI=te;const he=await this.i.createProcess(i,C,t.cols,t.rows,t.unicodeVersion,K,r,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),ce={executeCommand:(ge,...se)=>this.p(he,ge,se,E)},le=new p.$CL(ce,this.h,te);return this.i.onProcessExit(ge=>ge.id===he&&le.dispose()),{persistentTerminalId:he,resolvedShellLaunchConfig:i}}p(E,t,i,r){let n,s;const c=new Promise((v,C)=>{n=v,s=C}),f=++this.a;this.b.set(f,{resolve:n,reject:s,uriTransformer:r});const k=(0,a.$Gm)(i,v=>{if(v&&v.$mid===1)return r.transformOutgoing(v);if(v&&v instanceof b.URI)return r.transformOutgoingURI(v)});return this.c.fire({reqId:f,persistentProcessId:E,commandId:t,commandArgs:k}),c}r(E,t,i){const r=this.b.get(E);if(!r)return;this.b.delete(E);const n=(0,a.$Gm)(i,s=>{if(s&&s.$mid===1)return r.uriTransformer.transformIncoming(s)});t?r.reject(n):r.resolve(n)}s(E){return this.i.getDefaultSystemShell(E)}async t(E,t,i,r){return this.i.getProfiles?.(E,t,i,r)||[]}u(){return{...process.env}}w(E,t){return this.i.getWslPath(E,t)}y(){return this.i.reduceConnectionGraceTime()}}e.$eM=g}),define(be[289],we([1,0,26,5,2,13,7,101,23,43,24,116,78,259,202,79,203,25,125,31,80,119,212,137,16,111,66,63,110,81,82,120,12,54,27,44,229,138,118,32,36,243,87,251,34,123,265,266,234,240,288,68,41,273,281,127,57,128,45,33,260,67,241,114,126,124,113,112,196,278,226,255,248]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A,M,K,te,he,ce,le,ge,se,V,ie,J,Z,H,B,ne,Q,_,T,S,F,ee,oe,z,q,W,U,X,G,Y,ue,pe,Se,Ce,Fe,ze,me,Ee,ye,je,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=void 0;const xe="monacoworkbench";async function Be(Le,Ie,Oe,qe){const He=new k.$jh,Ke=new it,et={_serviceBrand:void 0,...M.default};He.set(K.$6i,et);const Je=new F.$Zl(Ie,et);He.set(u.$sh,Je),He.set(u.$th,Je);const st=new pe.$oM((0,A.$2i)(Je),Je.logsHome);He.set(A.$Oi,st),Ke.registerChannel("logger",new ze.$Lq(st,rt=>Ye(rt.remoteAuthority)));const ct=st.createLogger("remoteagent",{name:(0,me.localize)(0,null)}),ot=new Fe.$yM(ct,[new Xe((0,A.$2i)(Je))]);He.set(A.$Ni,ot),setTimeout(()=>De(Je.logsHome.fsPath).then(null,rt=>ot.error(rt)),1e4),ot.onDidChangeLogLevel(rt=>(0,A.log)(ot,rt,`Log level changed to ${(0,A.$3i)(ot.getLevel())}`)),ot.trace(`Remote configuration data at ${Oe}`),ot.trace("process arguments:",Je.args),Array.isArray(et.serverGreeting)&&ot.info(`

${et.serverGreeting.join(`
`)}

`),Ke.registerChannel(m.$pn.ChannelName,new m.$pn);const pt=new d.$6g(rt=>rt.clientId==="renderer"),yt=qe.add(new n.$pp(ot));He.set(r.$Oj,yt),yt.registerProvider(I.Schemas.file,qe.add(new s.$Op(ot)));const It=new H.$_q(yt);He.set(Z.$lk,It);const gt=new p.$in(Je.machineSettingsResource,yt,new Y.$Um,ot);He.set(P.$Rh,gt);const ut=new Se.$wM(It,Je,yt,ot);He.set(X.$nk,ut),Ke.registerChannel("userDataProfiles",new je.$EM(ut,rt=>Ye(rt.remoteAuthority)));const[,,At]=await Promise.all([gt.initialize(),ut.init(),(0,R.$rm)(ot.error.bind(ot))]),Mt=new z.$8l;He.set(z.$7l,Mt),He.set(te.$vo,new c.$ih(ce.$Aq));let vt=se.$5n;const Lt=(0,se.$_n)(et,gt);if((0,se.$7n)(et,Je)){const rt=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";rt?vt=new ue.$mM(!1,xe,null,()=>new G.$kM(rt)):et.aiConfig&&et.aiConfig.ariaKey&&(vt=new ue.$mM(Lt,xe,null,et.aiConfig.ariaKey)),qe.add((0,a.$ib)(()=>vt?.flush()));const $t={appenders:[vt],commonProperties:(0,le.$Wn)((0,y.release)(),(0,y.hostname)(),process.arch,et.commit,et.version+"-remote",At,Lt,"remoteAgent"),piiPaths:(0,se.$ao)(Je)},ve=Je.args["telemetry-level"];let ke=3;ve==="all"?ke=3:ve==="error"?ke=2:ve==="crash"?ke=1:ve!==void 0&&(ke=0),He.set(_.$nr,new c.$ih(_.$lr,[$t,ke]))}else He.set(_.$nr,_.$mr);He.set(g.$Mn,new c.$ih(l.$Ro));const jt=Ke.getChannel("download",pt);He.set($.$rn,new o.$tn(jt,()=>Ye("renderer"))),He.set(U.$9o,new c.$ih(Ce.$xM)),He.set(q.$ap,new c.$ih(W.$jM)),He.set(D.$So,new c.$ih(D.$To)),He.set(i.$kp,new c.$ih(i.$lp));const dt=new f.$Rp(He);He.set(v.$uq,dt.createInstance(C.$wq));const St=dt.createInstance(Te.$GM,{graceTime:108e5,shortGraceTime:3e5,scrollback:gt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Rt=dt.createInstance(J.$8q,St);return He.set(ie.$Gq,Rt),He.set(w.$kn,new c.$ih(h.$nn)),dt.invokeFunction(rt=>{const $t=rt.get(i.$kp),ve=rt.get(q.$ap),ke=rt.get(g.$Mn),de=rt.get(v.$uq),x=new B.$hr(Le,Je,ut,Mt);Ke.registerChannel("remoteextensionsenvironment",x);const Pe=new Q.$or(rt.get(_.$nr),vt);Ke.registerChannel("telemetry",Pe),Ke.registerChannel(ee.$1L,new T.$eM(Je,ot,Rt,et,$t,gt));const Ne=new Ee.$CM(dt.createInstance(E.$Uo,ot),Je,ut,ve,ot,ke,de);Ke.registerChannel(ye.$BM,new Ee.$DM(Ne,ht=>Ye(ht.remoteAuthority)));const We=new ne.$kr(ot,Je);Ke.registerChannel(oe.$hM,We),Ke.registerChannel("request",new he.$xq(rt.get(te.$vo)));const Ue=new t.$Vo($t,ht=>Ye(ht.remoteAuthority));Ke.registerChannel("extensions",Ue);const Qe=d.ProxyChannel.fromService(rt.get(v.$uq));Ke.registerChannel("languagePacks",Qe);const lt=d.ProxyChannel.fromService(rt.get(w.$kn));return Ke.registerChannel("credentials",lt),Ne.whenExtensionsReady().then(()=>$t.cleanUp()),qe.add(new V.default(rt.get(ge.$Rk))),{telemetryService:rt.get(ge.$Rk)}}),{socketServer:Ke,instantiationService:dt}}e.$HM=Be;const Ze=Object.create(null);function Ye(Le){return Ze[Le]||(Ze[Le]=(0,S.$ar)(Le)),Ze[Le]}class it extends d.$2g{constructor(){const Ie=new O.$5c;super(Ie.event),this.b=Ie}acceptConnection(Ie,Oe){this.b.fire({protocol:Ie,onDidClientDisconnect:Oe})}}e.$IM=it;class Xe extends A.$Si{constructor(Ie=A.$Qi){super(),this.setLevel(Ie),this.g=!!process.stdout.isTTY}trace(Ie,...Oe){this.f(A.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ie,...Oe):console.log(`[${Ge()}]`,Ie,...Oe))}debug(Ie,...Oe){this.f(A.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ie,...Oe):console.log(`[${Ge()}]`,Ie,...Oe))}info(Ie,...Oe){this.f(A.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,Ie,...Oe):console.log(`[${Ge()}]`,Ie,...Oe))}warn(Ie,...Oe){this.f(A.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ge()}]\x1B[0m`,Ie,...Oe):console.warn(`[${Ge()}]`,Ie,...Oe))}error(Ie,...Oe){this.f(A.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ge()}]\x1B[0m`,Ie,...Oe):console.error(`[${Ge()}]`,Ie,...Oe))}dispose(){}flush(){}}function Ge(){const Le=new Date;return`${fe(Le.getHours())}:${fe(Le.getMinutes())}:${fe(Le.getSeconds())}`}function fe(Le){return Le<10?`0${Le}`:String(Le)}async function De(Le){const Ie=L.$cc(Le),Oe=L.$bc(Le),Ke=(await b.Promises.readdir(Oe)).filter(Je=>/^\d{8}T\d{6}$/.test(Je)).sort().filter(Je=>Je!==Ie),et=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(et.map(Je=>b.Promises.rm(L.$$b(Oe,Je))))}}),define(be[290],we([1,0,85,30,76,291,83,140,15,11,38,2,13,7,42,3,17,4,21,153,155,286,105,70,24,6,12,27,56,32,139,256,257,41,289,262]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w,h,m,$,o,u,l,g,D,E,t,i,r,n,s,c,f,k,v,C,A,M,K,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0;const he=5*60*1e3;let ce=class extends p.$kb{constructor(V,ie,J,Z,H,B,ne,Q){super(),this.k=V,this.l=ie,this.m=J,this.n=H,this.p=B,this.r=ne,this.s=Q,this.h=ge.create(this.p),this.i=(0,f.$zk)(B),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=Z?this.s.createInstance(te.$LM,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(V,ie){if(V.method!=="GET")return(0,te.$JM)(V,ie,405,`Unsupported method ${V.method}`);if(!V.url)return(0,te.$JM)(V,ie,400,"Bad request.");const J=L.parse(V.url,!0);let Z=J.pathname;if(!Z)return(0,te.$JM)(V,ie,400,"Bad request.");if(Z.startsWith(this.i)&&Z.charCodeAt(this.i.length)===47&&(Z=Z.substring(this.i.length)),Z==="/version")return ie.writeHead(200,{"Content-Type":"text/plain"}),void ie.end(this.p.commit||"");if(Z==="/delay-shutdown")return this.H(),ie.writeHead(200),void ie.end("OK");if(!(0,A.$jm)(this.l,V,J))return(0,te.$JM)(V,ie,403,"Forbidden.");if(Z==="/vscode-remote-resource"){const H=J.query.path;if(typeof H!="string")return(0,te.$JM)(V,ie,400,"Bad request.");let B;try{B=u.URI.from({scheme:w.Schemas.file,path:H}).fsPath}catch{return(0,te.$JM)(V,ie,400,"Bad request.")}const ne=Object.create(null);this.n.isBuilt&&((0,P.$He)(B,this.n.builtinExtensionsPath,!$.$f)||(0,P.$He)(B,this.n.extensionsPath,!$.$f))&&(ne["Cache-Control"]="public, max-age=31536000"),ne.Vary="Origin";const Q=V.headers.origin;return Q&&this.h.matches(Q)&&(ne["Access-Control-Allow-Origin"]=Q),(0,te.$KM)(B,1,this.r,V,ie,ne)}if(this.g){this.g.handle(V,ie,J);return}return ie.writeHead(404,{"Content-Type":"text/plain"}),void ie.end("Not found")}handleUpgrade(V,ie){let J=(0,l.$3e)(),Z=!1,H=!1;if(V.url){const S=L.parse(V.url,!0).query;typeof S.reconnectionToken=="string"&&(J=S.reconnectionToken),S.reconnection==="true"&&(Z=!0),S.skipWebSocketFrames==="true"&&(H=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){ie.end("HTTP/1.1 400 Bad Request");return}const B=V.headers["sec-websocket-key"],ne=y.createHash("sha1");ne.update(B+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const _=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ne.digest("base64")}`];let T=!1;if(!H&&!this.n.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const S=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const F of S)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(F)){if(/\b(permessage-deflate)\b/.test(F)){T=!0,_.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(F)){T=!0,_.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ie.write(_.join(`\r
`)+`\r
\r
`),ie.setTimeout(0),ie.setNoDelay(!0),H?this.v(new i.$ah(ie,`server-connection-${J}`),Z,J):this.v(new i.$bh(new i.$ah(ie,`server-connection-${J}`),T,null,!0),Z,J)}handleServerError(V){this.r.error("Error occurred in server"),this.r.error(V)}t(V){let ie;return V instanceof i.$ah?ie=V.socket:ie=V.socket.socket,ie.remoteAddress||"<unknown>"}async u(V,ie,J){const Z=ie.getSocket();this.r.error(`${V} ${J}.`);const H={type:"error",reason:J};ie.sendControl(b.$Ib.fromString(JSON.stringify(H))),ie.dispose(),await Z.drain(),Z.dispose()}v(V,ie,J){const Z=this.t(V),H=`[${Z}][${J.substr(0,8)}]`,B=new t.$_g({socket:V}),ne=this.m?new this.m.validator:null,Q=this.m?new this.m.signer:null;let _;(function(ee){ee[ee.WaitingForAuth=0]="WaitingForAuth",ee[ee.WaitingForConnectionType=1]="WaitingForConnectionType",ee[ee.Done=2]="Done",ee[ee.Error=3]="Error"})(_||(_={}));let T=0;const S=ee=>{T=3,F.dispose(),this.u(H,B,ee)},F=B.onControlMessage(ee=>{if(T===0){let oe;try{oe=JSON.parse(ee.toString())}catch{return S("Malformed first message")}if(oe.type!=="auth")return S("Invalid first message");if(this.l.type===2&&!this.l.validate(oe.auth))return S("Unauthorized client refused: auth mismatch");let z=(0,l.$3e)();if(Q)try{z=Q.sign(oe.data)}catch{}let q=(0,l.$3e)();if(ne)try{q=ne.createNewMessage(q)}catch{}const W={type:"sign",data:q,signedData:z};B.sendControl(b.$Ib.fromString(JSON.stringify(W))),T=1}else if(T===1){let oe;try{oe=JSON.parse(ee.toString())}catch{return S("Malformed second message")}if(oe.type!=="connectionType")return S("Invalid second message");if(typeof oe.signedData!="string")return S("Invalid second message field type");const z=oe.commit,q=this.p.commit;if(z&&q&&z!==q)return S("Client refused: version mismatch");let W=!1;if(!ne)W=!0;else if(this.l.validate(oe.signedData))W=!0;else try{W=ne.validate(oe.signedData)==="ok"}catch{}if(!W){if(this.n.isBuilt)return S("Unauthorized client refused");this.r.error(`${H} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const U in this.b)this.b[U].shortenReconnectionGraceTimeIfNecessary();for(const U in this.a)this.a[U].shortenReconnectionGraceTimeIfNecessary();T=2,F.dispose(),this.w(Z,H,B,V,ie,J,oe)}})}async w(V,ie,J,Z,H,B,ne){const Q=ne.desiredConnectionType===1?`${ie}[ManagementConnection]`:ne.desiredConnectionType===2?`${ie}[ExtensionHostConnection]`:ie;if(ne.desiredConnectionType===1)if(H){if(!this.b[B])return this.f.has(B)?this.u(Q,J,"Unknown reconnection token (seen before)"):this.u(Q,J,"Unknown reconnection token (never seen)");J.sendControl(b.$Ib.fromString(JSON.stringify({type:"ok"})));const _=J.readEntireBuffer();J.dispose(),this.b[B].acceptReconnection(V,Z,_)}else{if(this.b[B])return this.u(Q,J,"Duplicate reconnection token");J.sendControl(b.$Ib.fromString(JSON.stringify({type:"ok"})));const _=new C.$dm(this.r,B,V,J);this.k.acceptConnection(_.protocol,_.onClose),this.b[B]=_,this.f.add(B),_.onClose(()=>{delete this.b[B]})}else if(ne.desiredConnectionType===2){const _=ne.args||{language:"en"},T=await this.C(_);if(T.port&&this.r.trace(`${Q} - startParams debug port ${T.port}`),this.r.trace(`${Q} - startParams language: ${T.language}`),this.r.trace(`${Q} - startParams env: ${JSON.stringify(T.env)}`),H){if(!this.a[B])return this.f.has(B)?this.u(Q,J,"Unknown reconnection token (seen before)"):this.u(Q,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(b.$Ib.fromString(JSON.stringify(T.port?{debugPort:T.port}:{})));const S=J.readEntireBuffer();J.dispose(),this.a[B].acceptReconnection(V,Z,S)}else{if(this.a[B])return this.u(Q,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(b.$Ib.fromString(JSON.stringify(T.port?{debugPort:T.port}:{})));const S=J.readEntireBuffer();J.dispose();const F=this.s.createInstance(v.$cm,B,V,Z,S);this.a[B]=F,this.f.add(B),F.onClose(()=>{delete this.a[B],this.D()}),F.start(T)}}else if(ne.desiredConnectionType===3){const _=ne.args;this.y(J,_)}else return this.u(Q,J,"Unknown initial data received")}async y(V,ie){const J=V.getSocket().socket,Z=V.readEntireBuffer();V.dispose(),J.pause();const H=await this.z(ie.host,ie.port);Z.byteLength>0&&H.write(Z.buffer),H.on("end",()=>J.end()),H.on("close",()=>J.end()),H.on("error",()=>J.destroy()),J.on("end",()=>H.end()),J.on("close",()=>H.end()),J.on("error",()=>H.destroy()),H.pipe(J),J.pipe(H)}z(V,ie){return new Promise((J,Z)=>{const H=a.createConnection({host:V,port:ie},()=>{H.removeListener("error",Z),H.pause(),J(H)});H.once("error",Z)})}C(V){return typeof V.port=="number"?(0,D.$5e)(V.port,10,5e3).then(ie=>(V.port=ie,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(V=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!V?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},he))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ce=Re([Ae(4,M.$Yl),Ae(5,c.$6i),Ae(6,s.$Ni),Ae(7,n.$kh)],ce);async function le(se,V,ie){const J=await(0,A.$im)(V);J instanceof A.$gm&&(console.warn(J.message),process.exit(1));function Z(W){(0,d.setUnexpectedErrorHandler)(U=>{(0,d.$W)(U)&&U.stack&&/unexpectedErrorHandler/.test(U.stack)||W(U)})}const H=[];Z(W=>{H.push(W),console.error(W)});let B=!1;process.on("SIGPIPE",()=>{B||(B=!0,(0,d.$X)(new Error("Unexpected SIGPIPE")))});const ne=new p.$jb,{socketServer:Q,instantiationService:_}=await(0,K.$HM)(J,V,ie,ne);_.invokeFunction(W=>{const U=W.get(s.$Ni);H.forEach(X=>U.error(X)),H.length=0,Z(X=>U.error(X))}),_.invokeFunction(W=>{const U=W.get(r.$Rh);$.$d&&(U.getValue("security.restrictUNCAccess")===!1?(0,E.disableUNCAccessRestrictions)():(0,E.addUNCHostToAllowlist)(U.getValue("security.allowedUNCHosts")))}),_.invokeFunction(W=>{const U=W.get(s.$Ni);if($.$d&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const X=(0,h.$$b)(process.env.HOMEDRIVE,"node_modules"),G=(0,h.$bc)((0,h.$$b)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Y=(0,h.$$b)(G,"node_modules");if(O.existsSync(X)||O.existsSync(Y)){const ue=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${X}
* ${Y}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;U.warn(ue),console.warn(ue),process.exit(0)}}});const T=_.invokeFunction(W=>{const U=W.get(s.$Ni);if(O.existsSync((0,h.$$b)(w.$1e.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(G){U.error(G)}return null}),S=O.existsSync(w.$1e.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(S&&se&&typeof se!="string"){const W=J.type!==0?`?${w.$Ue}=${J.value}`:"";console.log(`Web UI available at http://localhost${se.port===80?"":`:${se.port}`}/${W}`)}const F=_.createInstance(ce,Q,J,T,S);m.mark("code/server/ready");const ee=I.performance.now(),oe=global.vscodeServerStartTime,z=global.vscodeServerListenTime,q=global.vscodeServerCodeLoadedTime;if(_.invokeFunction(async W=>{const U=W.get(k.$Rk);if(U.publicLog2("serverStart",{startTime:oe,startedTime:z,codeLoadedTime:q,readyTime:ee}),$.$f){const X=W.get(s.$Ni),G=await(0,g.$4e)(X.error.bind(X));G&&U.publicLog2("serverPlatformInfo",{platformId:G.id,platformVersionId:G.version_id,platformIdLike:G.id_like})}}),V["print-startup-performance"]){const W=R.$R.get();let U="";U+=`

### Load AMD-module
`,U+=R.$R.toMarkdownTable(["Module","Duration"],W.amdLoad),U+=`

### Load commonjs-module
`,U+=R.$R.toMarkdownTable(["Module","Duration"],W.nodeRequire),U+=`

### Invoke AMD-module factory
`,U+=R.$R.toMarkdownTable(["Module","Duration"],W.amdInvoke),U+=`

### Invoke commonjs-module
`,U+=R.$R.toMarkdownTable(["Module","Duration"],W.nodeEval),U+=`Start-up time: ${z-oe}
`,U+=`Code loading time: ${q-oe}
`,U+=`Initialized time: ${ee-oe}
`,U+=`
`,console.log(U)}return F}e.$QM=le;class ge{static create(V){const ie=V.webEndpointUrlTemplate,J=V.commit,Z=V.quality;if(!ie||!J||!Z)return new ge(null);const H=(0,l.$3e)(),ne=new URL(ie.replace("{{uuid}}",H).replace("{{commit}}",J).replace("{{quality}}",Z)).origin,Q=(0,o.$ld)(ne).replace(H,"[a-zA-Z0-9\\-]+");try{const _=(0,o.$td)(`^${Q}$`,!0,{matchCase:!1});return new ge(_)}catch{return new ge(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(be[301],we([1,0,26,30,13,285,290,62,7,291,41,54,42]),function(ae,e,y,O,a,I,L,R,b,d,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=d.performance.now();const h={onMultipleValues:(l,g)=>{console.error(`Option '${l}' can only be defined once. Using value ${g}.`)},onEmptyValue:l=>{console.error(`Ignoring option '${l}': Value must not be empty.`)},onUnknownOption:l=>{console.error(`Ignoring option '${l}': not supported for server.`)},onDeprecatedOption:(l,g)=>{console.warn(`Option '${l}' is deprecated: ${g}`)}};function m(){return(0,R.$il)(process.argv.slice(2),P.$Xl,h)}function $(l){const g=l["server-data-dir"]||l["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.$$b)(y.homedir(),p.default.serverDataFolderName||".vscode-remote"),D=l["user-data-dir"]||(0,b.$$b)(g,"data"),E=(0,b.$$b)(D,"User"),t=(0,b.$$b)(E,"globalStorage"),i=(0,b.$$b)(E,"History"),r=(0,b.$$b)(D,"Machine");l["user-data-dir"]=D;const n=(0,b.$bc)(a.$1e.asFileUri("").fsPath),s=l["builtin-extensions-dir"]||(0,b.$$b)(n,"extensions");return l["builtin-extensions-dir"]=s,l["extensions-dir"]=l["extensions-dir"]||(0,b.$$b)(g,"extensions"),[g,l["extensions-dir"],D,E,r,t,i].forEach(c=>{try{O.existsSync(c)||O.mkdirSync(c,{mode:448})}catch(f){console.error(f)}}),g}function o(l=m()){return(0,I.run)(l,$(l),P.$Xl)}e.spawnCli=o;function u(l,g=m()){return(0,L.$QM)(l,g,$(g))}e.createServer=u})}).call(this);

//# sourceMappingURL=server.main.js.map
