"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","child_process","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/htmlContent","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","http","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/dataTransfer","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],b=0,A=re.length;b<A;b++)e[b]=De[re[b]];return e};define(De[65],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G=e.$F=e.$E=e.$D=void 0;function b(R,m){const k=Object.create(null);for(const g of R){const L=m(g);let I=k[L];I||(I=k[L]=[]),I.push(g)}return k}e.$D=b;function A(R,m){const k=[],g=[];for(const L of R)m.has(L)||k.push(L);for(const L of m)R.has(L)||g.push(L);return{removed:k,added:g}}e.$E=A;function h(R,m){const k=[],g=[];for(const[L,I]of R)m.has(L)||k.push(I);for(const[L,I]of m)R.has(L)||g.push(I);return{removed:k,added:g}}e.$F=h;class F{constructor(){this.a=new Map}add(m,k){let g=this.a.get(m);g||(g=new Set,this.a.set(m,g)),g.add(k)}delete(m,k){const g=this.a.get(m);g&&(g.delete(k),g.size===0&&this.a.delete(m))}forEach(m,k){const g=this.a.get(m);g&&g.forEach(k)}}e.$G=F}),define(De[66],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function b(R){return(m,k,g)=>{let L=null,I=null;if(typeof g.value=="function"?(L="value",I=g.value):typeof g.get=="function"&&(L="get",I=g.get),!I)throw new Error("not supported");g[L]=R(I,k)}}function A(R,m,k){let g=null,L=null;if(typeof k.value=="function"?(g="value",L=k.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",L=k.get),!L)throw new Error("not supported");const I=`$memoize$${m}`;k[g]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,w)}),this[I]}}e.$Pg=A;function h(R,m,k){return b((g,L)=>{const I=`$debounce$${L}`,w=`$debounce$result$${L}`;return function(...D){this[w]||(this[w]=k?k():void 0),clearTimeout(this[I]),m&&(this[w]=m(this[w],...D),D=[this[w]]),this[I]=setTimeout(()=>{g.apply(this,D),this[w]=k?k():void 0},R)}})}e.$Qg=h;function F(R,m,k){return b((g,L)=>{const I=`$throttle$timer$${L}`,w=`$throttle$result$${L}`,D=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...p){if(this[w]||(this[w]=k?k():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),m&&(this[w]=m(this[w],...p)),this[C])return;const i=this[D]+R;i<=Date.now()?(this[D]=Date.now(),g.apply(this,[this[w]]),this[w]=k?k():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[D]=Date.now(),g.apply(this,[this[w]]),this[w]=k?k():void 0},i-Date.now()))}})}e.$Rg=F}),define(De[8],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.$W=e.setUnexpectedErrorHandler=e.$U=e.$T=void 0;class b{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?f.isErrorNoTelemetry(o)?new f(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$T=b,e.$U=new b;function A(n){e.$U.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=A;function h(n){if(!n||typeof n!="object")return!1;const o=n;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$W=h;function F(n){g(n)||e.$U.onUnexpectedError(n)}e.$X=F;function R(n){g(n)||e.$U.onUnexpectedExternalError(n)}e.$Y=R;function m(n){if(n instanceof Error){const{name:o,message:s}=n,t=n.stacktrace||n.stack;return{$isError:!0,name:o,message:s,stack:t,noTelemetry:f.isErrorNoTelemetry(n)}}return n}e.$Z=m;const k="Canceled";function g(n){return n instanceof L?!0:n instanceof Error&&n.name===k&&n.message===k}e.$1=g;class L extends Error{constructor(){super(k),this.name=this.message}}e.$2=L;function I(){const n=new Error(k);return n.name=n.message,n}e.$3=I;function w(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.$4=w;function D(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.$5=D;function C(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.$6=C;function p(n){const o=new Error(`${n} has been disposed`);return o.name="DISPOSED",o}e.$7=p;function i(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.$8=i;class c extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$9=c;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$0=u;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=v;class f extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof f)return o;const s=new f;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$_=f;class E extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(De[19],Ce([1,0,8]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function A(ee,te=0){return ee[ee.length-(1+te)]}e.$9e=A;function h(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.$0e=h;function F(ee,te,le=(X,ue)=>X===ue){if(ee===te)return!0;if(!ee||!te||ee.length!==te.length)return!1;for(let X=0,ue=ee.length;X<ue;X++)if(!le(ee[X],te[X]))return!1;return!0}e.$$e=F;function R(ee,te){const le=ee.length-1;te<le&&(ee[te]=ee[le]),ee.pop()}e.$_e=R;function m(ee,te,le){return k(ee.length,X=>le(ee[X],te))}e.$af=m;function k(ee,te){let le=0,X=ee-1;for(;le<=X;){const ue=(le+X)/2|0,se=te(ue);if(se<0)le=ue+1;else if(se>0)X=ue-1;else return ue}return-(le+1)}e.$bf=k;function g(ee,te){let le=0,X=ee.length;if(X===0)return 0;for(;le<X;){const ue=Math.floor((le+X)/2);te(ee[ue])?X=ue:le=ue+1}return le}e.$cf=g;function L(ee,te,le){if(ee=ee|0,ee>=te.length)throw new TypeError("invalid index");const X=te[Math.floor(te.length*Math.random())],ue=[],se=[],oe=[];for(const T of te){const J=le(T,X);J<0?ue.push(T):J>0?se.push(T):oe.push(T)}return ee<ue.length?L(ee,ue,le):ee<ue.length+oe.length?oe[0]:L(ee-(ue.length+oe.length),se,le)}e.$df=L;function I(ee,te){const le=[];let X;for(const ue of ee.slice(0).sort(te))!X||te(X[0],ue)!==0?(X=[ue],le.push(X)):X.push(ue);return le}e.$ef=I;function w(ee,te,le){const X=[];function ue(T,J,Z){if(J===0&&Z.length===0)return;const x=X[X.length-1];x&&x.start+x.deleteCount===T?(x.deleteCount+=J,x.toInsert.push(...Z)):X.push({start:T,deleteCount:J,toInsert:Z})}let se=0,oe=0;for(;;){if(se===ee.length){ue(se,0,te.slice(oe));break}if(oe===te.length){ue(se,ee.length-se,[]);break}const T=ee[se],J=te[oe],Z=le(T,J);Z===0?(se+=1,oe+=1):Z<0?(ue(se,1,[]),se+=1):Z>0&&(ue(se,0,[J]),oe+=1)}return X}e.$ff=w;function D(ee,te,le){const X=w(ee,te,le),ue=[],se=[];for(const oe of X)ue.push(...ee.slice(oe.start,oe.start+oe.deleteCount)),se.push(...oe.toInsert);return{removed:ue,added:se}}e.$gf=D;function C(ee,te,le){if(le===0)return[];const X=ee.slice(0,le).sort(te);return i(ee,te,X,le,ee.length),X}e.top=C;function p(ee,te,le,X,ue){return le===0?Promise.resolve([]):new Promise((se,oe)=>{(async()=>{const T=ee.length,J=ee.slice(0,le).sort(te);for(let Z=le,x=Math.min(le+X,T);Z<T;Z=x,x=Math.min(x+X,T)){if(Z>le&&await new Promise(me=>setTimeout(me)),ue&&ue.isCancellationRequested)throw new b.$2;i(ee,te,J,Z,x)}return J})().then(se,oe)})}e.$if=p;function i(ee,te,le,X,ue){for(const se=le.length;X<ue;X++){const oe=ee[X];if(te(oe,le[se-1])<0){le.pop();const T=g(le,J=>te(oe,J)<0);le.splice(T,0,oe)}}}function c(ee){return ee.filter(te=>!!te)}e.$jf=c;function u(ee){let te=0;for(let le=0;le<ee.length;le++)ee[le]&&(ee[te]=ee[le],te+=1);ee.length=te}e.$kf=u;function v(ee,te,le){ee.splice(le,0,ee.splice(te,1)[0])}e.$lf=v;function f(ee){return!Array.isArray(ee)||ee.length===0}e.$mf=f;function E(ee){return Array.isArray(ee)&&ee.length>0}e.$nf=E;function n(ee,te=le=>le){const le=new Set;return ee.filter(X=>{const ue=te(X);return le.has(ue)?!1:(le.add(ue),!0)})}e.$of=n;function o(ee){const te=new Set;return le=>{const X=ee(le);return te.has(X)?!1:(te.add(X),!0)}}e.$pf=o;function s(ee,te){const le=t(ee,te);if(le!==-1)return ee[le]}e.$qf=s;function t(ee,te){for(let le=ee.length-1;le>=0;le--){const X=ee[le];if(te(X))return le}return-1}e.$rf=t;function d(ee,te){return ee.length>0?ee[0]:te}e.$sf=d;function $(ee,te){return ee.length>0?ee[ee.length-1]:te}e.$tf=$;function l(ee,te,le=(X,ue)=>X===ue){let X=0;for(let ue=0,se=Math.min(ee.length,te.length);ue<se&&le(ee[ue],te[ue]);ue++)X++;return X}e.$uf=l;function S(ee){return[].concat(...ee)}e.$vf=S;function y(ee,te){let le=typeof te=="number"?ee:0;typeof te=="number"?le=ee:(le=0,te=ee);const X=[];if(le<=te)for(let ue=le;ue<te;ue++)X.push(ue);else for(let ue=le;ue>te;ue--)X.push(ue);return X}e.$wf=y;function a(ee,te,le){return ee.reduce((X,ue)=>(X[te(ue)]=le?le(ue):ue,X),Object.create(null))}e.$xf=a;function r(ee,te){return ee.push(te),()=>P(ee,te)}e.$yf=r;function P(ee,te){const le=ee.indexOf(te);if(le>-1)return ee.splice(le,1),te}e.$zf=P;function N(ee,te,le){const X=ee.slice(0,te),ue=ee.slice(te);return X.concat(le,ue)}e.$Af=N;function U(ee,te){let le;if(typeof te=="number"){let X=te;le=()=>{const ue=Math.sin(X++)*179426549;return ue-Math.floor(ue)}}else le=Math.random;for(let X=ee.length-1;X>0;X-=1){const ue=Math.floor(le()*(X+1)),se=ee[X];ee[X]=ee[ue],ee[ue]=se}}e.$Bf=U;function q(ee,te){const le=ee.indexOf(te);le>-1&&(ee.splice(le,1),ee.unshift(te))}e.$Cf=q;function B(ee,te){const le=ee.indexOf(te);le>-1&&(ee.splice(le,1),ee.push(te))}e.$Df=B;function O(ee,te){for(const le of te)ee.push(le)}e.$Ef=O;function K(ee,te){return Array.isArray(ee)?ee.map(te):te(ee)}e.$Ff=K;function z(ee){return Array.isArray(ee)?ee:[ee]}e.$Gf=z;function j(ee){return ee[Math.floor(Math.random()*ee.length)]}e.$Hf=j;function he(ee,te){for(const le of ee){const X=te(le);if(X!==void 0)return X}}e.$If=he;function ie(ee,te,le){const X=V(ee,te),ue=ee.length,se=le.length;ee.length=ue+se;for(let oe=ue-1;oe>=X;oe--)ee[oe+se]=ee[oe];for(let oe=0;oe<se;oe++)ee[oe+X]=le[oe]}e.$Jf=ie;function ne(ee,te,le,X){const ue=V(ee,te),se=ee.splice(ue,le);return ie(ee,ue,X),se}e.$Kf=ne;function V(ee,te){return te<0?Math.max(te+ee.length,0):Math.min(te,ee.length)}var H;(function(ee){function te(ue){return ue<0}ee.isLessThan=te;function le(ue){return ue>0}ee.isGreaterThan=le;function X(ue){return ue===0}ee.isNeitherLessOrGreaterThan=X,ee.greaterThan=1,ee.lessThan=-1,ee.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function ce(ee,te){return(le,X)=>te(ee(le),ee(X))}e.$Lf=ce;function pe(...ee){return(te,le)=>{for(const X of ee){const ue=X(te,le);if(!H.isNeitherLessOrGreaterThan(ue))return ue}return H.neitherLessOrGreaterThan}}e.$Mf=pe;const ye=(ee,te)=>ee-te;e.$Nf=ye;function ge(ee,te){if(ee.length===0)return;let le=ee[0];for(let X=1;X<ee.length;X++){const ue=ee[X];te(ue,le)>0&&(le=ue)}return le}e.$Of=ge;function M(ee,te){if(ee.length===0)return;let le=ee[0];for(let X=1;X<ee.length;X++){const ue=ee[X];te(ue,le)>=0&&(le=ue)}return le}e.$Pf=M;function Y(ee,te){return ge(ee,(le,X)=>-te(le,X))}e.$Qf=Y;class ve{constructor(te){this.f=te,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.f.length&&te(this.f[le]);)le++;const X=le===this.c?null:this.f.slice(this.c,le);return this.c=le,X}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.f[le]);)le--;const X=le===this.d?null:this.f.slice(le+1,this.d+1);return this.d=le,X}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const te=this.f[this.c];return this.c++,te}removeLast(){const te=this.f[this.d];return this.d--,te}takeCount(te){const le=this.f.slice(this.c,this.c+te);return this.c+=te,le}}e.$Rf=ve;class Se{constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new Se(le=>this.iterate(X=>te(X)?le(X):!0))}map(te){return new Se(le=>this.iterate(X=>le(te(X))))}some(te){let le=!1;return this.iterate(X=>(le=te(X),!le)),le}findFirst(te){let le;return this.iterate(X=>te(X)?(le=X,!1):!0),le}findLast(te){let le;return this.iterate(X=>(te(X)&&(le=X),!0)),le}findLastMaxBy(te){let le,X=!0;return this.iterate(ue=>((X||H.isGreaterThan(te(ue,le)))&&(X=!1,le=ue),!0)),le}}e.$Sf=Se,Se.empty=new Se(ee=>{})}),define(De[53],Ce([1,0,8]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.$nc=e.$mc=e.$lc=e.ok=void 0;function A(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=A;function h(k,g="Unreachable"){throw new Error(g)}e.$lc=h;function F(k){if(!k)throw new b.$ab("Assertion Failed")}e.$mc=F;function R(k){if(!k()){debugger;k(),(0,b.$X)(new b.$ab("Assertion Failed"))}}e.$nc=R;function m(k,g){let L=0;for(;L<k.length-1;){const I=k[L],w=k[L+1];if(!g(I,w))return!1;L++}return!0}e.$oc=m}),define(De[67],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function b(A){const h=this;let F=!1,R;return function(){return F||(F=!0,R=A.apply(h,arguments)),R}}e.$bb=b}),define(De[112],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=void 0;class b{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$gL=b,e.$hL=new b("id#")}),define(De[48],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(A){function h(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}A.is=h;const F=Object.freeze([]);function R(){return F}A.empty=R;function*m(f){yield f}A.single=m;function k(f){return h(f)?f:m(f)}A.wrap=k;function g(f){return f||F}A.from=g;function L(f){return!f||f[Symbol.iterator]().next().done===!0}A.isEmpty=L;function I(f){return f[Symbol.iterator]().next().value}A.first=I;function w(f,E){for(const n of f)if(E(n))return!0;return!1}A.some=w;function D(f,E){for(const n of f)if(E(n))return n}A.find=D;function*C(f,E){for(const n of f)E(n)&&(yield n)}A.filter=C;function*p(f,E){let n=0;for(const o of f)yield E(o,n++)}A.map=p;function*i(...f){for(const E of f)for(const n of E)yield n}A.concat=i;function c(f,E,n){let o=n;for(const s of f)o=E(o,s);return o}A.reduce=c;function*u(f,E,n=f.length){for(E<0&&(E+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);E<n;E++)yield f[E]}A.slice=u;function v(f,E=Number.POSITIVE_INFINITY){const n=[];if(E===0)return[n,f];const o=f[Symbol.iterator]();for(let s=0;s<E;s++){const t=o.next();if(t.done)return[n,A.empty()];n.push(t.value)}return[n,{[Symbol.iterator](){return o}}]}A.consume=v})(b||(e.Iterable=b={}))}),define(De[151],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(b||(e.ScanError=b={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var h;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var F;(function(n){n.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(n,o=!1){let s=0;const t=n.length;let d="",$=0,l=16,S=0;function y(B){let O=0,K=0;for(;O<B;){const z=n.charCodeAt(s);if(z>=48&&z<=57)K=K*16+z-48;else if(z>=65&&z<=70)K=K*16+z-65+10;else if(z>=97&&z<=102)K=K*16+z-97+10;else break;s++,O++}return O<B&&(K=-1),K}function a(B){s=B,d="",$=0,l=16,S=0}function r(){const B=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return S=3,n.substring(B,s);let O=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;O=s}else S=3;return n.substring(B,O)}function P(){let B="",O=s;for(;;){if(s>=t){B+=n.substring(O,s),S=2;break}const K=n.charCodeAt(s);if(K===34){B+=n.substring(O,s),s++;break}if(K===92){if(B+=n.substring(O,s),s++,s>=t){S=2;break}switch(n.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=y(4);j>=0?B+=String.fromCharCode(j):S=4;break}default:S=5}O=s;continue}if(K>=0&&K<=31)if(k(K)){B+=n.substring(O,s),S=2;break}else S=6;s++}return B}function N(){if(d="",S=0,$=s,s>=t)return $=t,l=17;let B=n.charCodeAt(s);if(m(B)){do s++,d+=String.fromCharCode(B),B=n.charCodeAt(s);while(m(B));return l=15}if(k(B))return s++,d+=String.fromCharCode(B),B===13&&n.charCodeAt(s)===10&&(s++,d+=`
`),l=14;switch(B){case 123:return s++,l=1;case 125:return s++,l=2;case 91:return s++,l=3;case 93:return s++,l=4;case 58:return s++,l=6;case 44:return s++,l=5;case 34:return s++,d=P(),l=10;case 47:{const O=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<t&&!k(n.charCodeAt(s));)s++;return d=n.substring(O,s),l=12}if(n.charCodeAt(s+1)===42){s+=2;const K=t-1;let z=!1;for(;s<K;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,S=1),d=n.substring(O,s),l=13}return d+=String.fromCharCode(B),s++,l=16}case 45:if(d+=String.fromCharCode(B),s++,s===t||!g(n.charCodeAt(s)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=r(),l=11;default:for(;s<t&&U(B);)s++,B=n.charCodeAt(s);if($!==s){switch(d=n.substring($,s),d){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return d+=String.fromCharCode(B),s++,l=16}}function U(B){if(m(B)||k(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let B;do B=N();while(B>=12&&B<=15);return B}return{setPosition:a,getPosition:()=>s,scan:o?q:N,getToken:()=>l,getTokenValue:()=>d,getTokenOffset:()=>$,getTokenLength:()=>s-$,getTokenError:()=>S}}e.$sm=R;function m(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function k(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function I(n,o){const s=[],t=new Object;let d;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(y,a,r,P){$.value=y,$.offset=a,$.length=r,$.type=P,$.colonOffset=void 0,d=$}try{v(n,{onObjectBegin:(y,a)=>{if(o<=y)throw t;d=void 0,l=o>y,s.push("")},onObjectProperty:(y,a,r)=>{if(o<a||(S(y,a,r,"property"),s[s.length-1]=y,o<=a+r))throw t},onObjectEnd:(y,a)=>{if(o<=y)throw t;d=void 0,s.pop()},onArrayBegin:(y,a)=>{if(o<=y)throw t;d=void 0,s.push(0)},onArrayEnd:(y,a)=>{if(o<=y)throw t;d=void 0,s.pop()},onLiteralValue:(y,a,r)=>{if(o<a||(S(y,a,r,E(y)),o<=a+r))throw t},onSeparator:(y,a,r)=>{if(o<=a)throw t;if(y===":"&&d&&d.type==="property")d.colonOffset=a,l=!1,d=void 0;else if(y===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(l=!0,s[s.length-1]=""),d=void 0}}})}catch(y){if(y!==t)throw y}return{path:s,previousNode:d,isAtPropertyKey:l,matches:y=>{let a=0;for(let r=0;a<y.length&&r<s.length;r++)if(y[a]===s[r]||y[a]==="*")a++;else if(y[a]!=="**")return!1;return a===y.length}}}e.$tm=I;function w(n,o=[],s=F.DEFAULT){let t=null,d=[];const $=[];function l(y){Array.isArray(d)?d.push(y):t!==null&&(d[t]=y)}return v(n,{onObjectBegin:()=>{const y={};l(y),$.push(d),d=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{d=$.pop()},onArrayBegin:()=>{const y=[];l(y),$.push(d),d=y,t=null},onArrayEnd:()=>{d=$.pop()},onLiteralValue:l,onError:(y,a,r)=>{o.push({error:y,offset:a,length:r})}},s),d[0]}e.$um=w;function D(n,o=[],s=F.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(y){t.type==="property"&&(t.length=y-t.offset,t=t.parent)}function $(y){return t.children.push(y),y}v(n,{onObjectBegin:y=>{t=$({type:"object",offset:y,length:-1,parent:t,children:[]})},onObjectProperty:(y,a,r)=>{t=$({type:"property",offset:a,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:y,offset:a,length:r,parent:t})},onObjectEnd:(y,a)=>{t.length=y+a-t.offset,t=t.parent,d(y+a)},onArrayBegin:(y,a)=>{t=$({type:"array",offset:y,length:-1,parent:t,children:[]})},onArrayEnd:(y,a)=>{t.length=y+a-t.offset,t=t.parent,d(y+a)},onLiteralValue:(y,a,r)=>{$({type:E(y),offset:a,length:r,parent:t,value:y}),d(a+r)},onSeparator:(y,a,r)=>{t.type==="property"&&(y===":"?t.colonOffset=a:y===","&&d(a))},onError:(y,a,r)=>{o.push({error:y,offset:a,length:r})}},s);const S=t.children[0];return S&&delete S.parent,S}e.$vm=D;function C(n,o){if(!n)return;let s=n;for(const t of o)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let d=!1;for(const $ of s.children)if(Array.isArray($.children)&&$.children[0].value===t){s=$.children[1],d=!0;break}if(!d)return}else{const d=t;if(s.type!=="array"||d<0||!Array.isArray(s.children)||d>=s.children.length)return;s=s.children[d]}return s}e.$wm=C;function p(n){if(!n.parent||!n.parent.children)return[];const o=p(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;o.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&o.push(s)}return o}e.$xm=p;function i(n){switch(n.type){case"array":return n.children.map(i);case"object":{const o=Object.create(null);for(const s of n.children){const t=s.children[1];t&&(o[s.children[0].value]=i(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$ym=i;function c(n,o,s=!1){return o>=n.offset&&o<n.offset+n.length||s&&o===n.offset+n.length}e.$zm=c;function u(n,o,s=!1){if(c(n,o,s)){const t=n.children;if(Array.isArray(t))for(let d=0;d<t.length&&t[d].offset<=o;d++){const $=u(t[d],o,s);if($)return $}return n}}e.$Am=u;function v(n,o,s=F.DEFAULT){const t=R(n,!1);function d(ce){return ce?()=>ce(t.getTokenOffset(),t.getTokenLength()):()=>!0}function $(ce){return ce?pe=>ce(pe,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=d(o.onObjectBegin),S=$(o.onObjectProperty),y=d(o.onObjectEnd),a=d(o.onArrayBegin),r=d(o.onArrayEnd),P=$(o.onLiteralValue),N=$(o.onSeparator),U=d(o.onComment),q=$(o.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function K(){for(;;){const ce=t.scan();switch(t.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ce){case 12:case 13:B?z(10):U();break;case 16:z(1);break;case 15:case 14:break;default:return ce}}}function z(ce,pe=[],ye=[]){if(q(ce),pe.length+ye.length>0){let ge=t.getToken();for(;ge!==17;){if(pe.indexOf(ge)!==-1){K();break}else if(ye.indexOf(ge)!==-1)break;ge=K()}}}function j(ce){const pe=t.getTokenValue();return ce?P(pe):S(pe),K(),!0}function he(){switch(t.getToken()){case 11:{let ce=0;try{ce=JSON.parse(t.getTokenValue()),typeof ce!="number"&&(z(2),ce=0)}catch{z(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return K(),!0}function ie(){return t.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),t.getToken()===6?(N(":"),K(),H()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ne(){l(),K();let ce=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ce||z(4,[],[]),N(","),K(),t.getToken()===2&&O)break}else ce&&z(6,[],[]);ie()||z(4,[],[2,5]),ce=!0}return y(),t.getToken()!==2?z(7,[2],[]):K(),!0}function V(){a(),K();let ce=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ce||z(4,[],[]),N(","),K(),t.getToken()===4&&O)break}else ce&&z(6,[],[]);H()||z(4,[],[4,5]),ce=!0}return r(),t.getToken()!==4?z(8,[4],[]):K(),!0}function H(){switch(t.getToken()){case 3:return V();case 1:return ne();case 10:return j(!0);default:return he()}}return K(),t.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):H()?(t.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.$Bm=v;function f(n,o){const s=R(n),t=[];let d,$=0,l;do switch(l=s.getPosition(),d=s.scan(),d){case 12:case 13:case 17:$!==l&&t.push(n.substring($,l)),o!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,o)),$=s.getPosition();break}while(d!==17);return t.join("")}e.$Cm=f;function E(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Dm=E}),define(De[54],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=void 0;class b{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$S=b}),define(De[4],Ce([1,0,67,48]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const h=!1;let F=null;function R($){F=$}if(e.$cb=R,h){const $="__is_disposable_tracked__";R(new class{trackDisposable(l){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[$]||console.log(S)},3e3)}setParent(l,S){if(l&&l!==u.None)try{l[$]=!0}catch{}}markAsDisposed(l){if(l&&l!==u.None)try{l[$]=!0}catch{}}markAsSingleton(l){}})}function m($){return F?.trackDisposable($),$}function k($){F?.markAsDisposed($)}function g($,l){F?.setParent($,l)}function L($,l){if(F)for(const S of $)F.setParent(S,l)}function I($){return F?.markAsSingleton($),$}e.$db=I;function w($){return typeof $.dispose=="function"&&$.dispose.length===0}e.$eb=w;function D($){if(A.Iterable.is($)){const l=[];for(const S of $)if(S)try{S.dispose()}catch(y){l.push(y)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}e.$fb=D;function C($){for(const l of $)w(l)&&l.dispose();return[]}e.$gb=C;function p(...$){const l=i(()=>D($));return L($,l),l}e.$hb=p;function i($){const l=m({dispose:(0,b.$bb)(()=>{k(l),$()})});return l}e.$ib=i;class c{constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{D(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return g(l,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}}e.$jb=c,c.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new c,m(this),g(this.q,this)}dispose(){k(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}e.$kb=u,u.None=Object.freeze({dispose(){}});class v{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&g(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&g(l,null),l}}e.$lb=v;class f{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mb=f;class E{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(l){let S=l;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,k(this))},this}}e.$nb=E;class n{constructor(){this.a=new Map}acquire(l,...S){let y=this.a.get(l);y||(y={counter:0,object:this.b(l,...S)},this.a.set(l,y));const{object:a}=y,r=(0,b.$bb)(()=>{--y.counter===0&&(this.c(l,y.object),this.a.delete(l))});return y.counter++,{object:a,dispose:r}}}e.$ob=n;class o{constructor(l){this.a=l}async acquire(l,...S){const y=this.a.acquire(l,...S);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(a){throw y.dispose(),a}}}e.$pb=o;class s{constructor(l){this.object=l}dispose(){}}e.$qb=s;function t($){const l=new c;try{$(l)}finally{l.dispose()}}e.$rb=t;class d{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get(l){return this.a.get(l)}set(l,S,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(l)?.dispose(),this.a.set(l,S)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sb=d}),define(De[68],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=void 0;class b{constructor(F){this.element=F,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class A{constructor(){this.a=b.Undefined,this.b=b.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===b.Undefined}clear(){let F=this.a;for(;F!==b.Undefined;){const R=F.next;F.prev=b.Undefined,F.next=b.Undefined,F=R}this.a=b.Undefined,this.b=b.Undefined,this.c=0}unshift(F){return this.d(F,!1)}push(F){return this.d(F,!0)}d(F,R){const m=new b(F);if(this.a===b.Undefined)this.a=m,this.b=m;else if(R){const g=this.b;this.b=m,m.prev=g,g.next=m}else{const g=this.a;this.a=m,m.next=g,g.prev=m}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(m))}}shift(){if(this.a!==b.Undefined){const F=this.a.element;return this.e(this.a),F}}pop(){if(this.b!==b.Undefined){const F=this.b.element;return this.e(this.b),F}}e(F){if(F.prev!==b.Undefined&&F.next!==b.Undefined){const R=F.prev;R.next=F.next,F.next.prev=R}else F.prev===b.Undefined&&F.next===b.Undefined?(this.a=b.Undefined,this.b=b.Undefined):F.next===b.Undefined?(this.b=this.b.prev,this.b.next=b.Undefined):F.prev===b.Undefined&&(this.a=this.a.next,this.a.prev=b.Undefined);this.c-=1}*[Symbol.iterator](){let F=this.a;for(;F!==b.Undefined;)yield F.element,F=F.next}}e.$jc=A}),define(De[28],Ce([1,0]),function(re,e){"use strict";var b,A,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.Touch=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;function F(p,i,c){let u=p.get(i);return u===void 0&&(u=c,p.set(i,u)),u}e.$gi=F;function R(p){const i=[];return p.forEach((c,u)=>{i.push(`${u} => ${c}`)}),`Map(${p.size}) {${i.join(", ")}}`}e.$hi=R;function m(p){const i=[];return p.forEach(c=>{i.push(c)}),`Set(${p.size}) {${i.join(", ")}}`}e.$ii=m;class k{constructor(i,c){this.uri=i,this.value=c}}class g{constructor(i,c){this[b]="ResourceMap",i instanceof g?(this.b=new Map(i.b),this.c=c??g.a):(this.b=new Map,this.c=i??g.a)}set(i,c){return this.b.set(this.c(i),new k(i,c)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,c){typeof c<"u"&&(i=i.bind(c));for(const[u,v]of this.b)i(v.value,v.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$ji=g,g.a=p=>p.toString();class L{constructor(i,c){this[A]="ResourceSet",!i||typeof i=="function"?this.a=new g(i):(this.a=new g(c),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,c){this.a.forEach((u,v)=>i.call(c,v,v,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$ki=L;var I;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class w{constructor(){this[h]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,c=0){const u=this.a.get(i);if(u)return c!==0&&this.j(u,c),u.value}set(i,c,u=0){let v=this.a.get(i);if(v)v.value=c,u!==0&&this.j(v,u);else{switch(v={key:i,value:c,next:void 0,previous:void 0},u){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(i,v),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this.a.get(i);if(c)return this.a.delete(i),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,c){const u=this.e;let v=this.b;for(;v;){if(c?i.bind(c)(v.value,v.key,this):i(v.value,v.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const i=this,c=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return v}values(){const i=this,c=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return v}entries(){const i=this,c=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return v}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this.b,u=this.size;for(;c&&u>i;)this.a.delete(c.key),c=c.next,u--;this.b=c,this.d=u,c&&(c.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const c=i.next,u=i.previous;if(!c||!u)throw new Error("Invalid list");c.previous=u,u.next=c}i.next=void 0,i.previous=void 0,this.e++}j(i,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this.b)return;const u=i.next,v=i.previous;i===this.c?(v.next=void 0,this.c=v):(u.previous=v,v.next=u),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(c===2){if(i===this.c)return;const u=i.next,v=i.previous;i===this.b?(u.previous=void 0,this.b=u):(u.previous=v,v.next=u),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((c,u)=>{i.push([u,c])}),i}fromJSON(i){this.clear();for(const[c,u]of i)this.set(c,u)}}e.$li=w;class D extends w{constructor(i,c=1){super(),this.k=i,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$mi=D;class C{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let c=this.a.get(i)||0;return c===0?!1:(c--,c===0?this.a.delete(i):this.a.set(i,c),!0)}has(i){return this.a.has(i)}}e.$ni=C}),function(re,e){typeof define=="function"&&define.amd?define(De[152],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ee,te){for(var le=0;le<te.length;le++){var X=te[le];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ee,X.key,X)}}function b(ee,te,le){return te&&e(ee.prototype,te),le&&e(ee,le),Object.defineProperty(ee,"prototype",{writable:!1}),ee}function A(ee,te){if(ee){if(typeof ee=="string")return h(ee,te);var le=Object.prototype.toString.call(ee).slice(8,-1);if(le==="Object"&&ee.constructor&&(le=ee.constructor.name),le==="Map"||le==="Set")return Array.from(ee);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return h(ee,te)}}function h(ee,te){(te==null||te>ee.length)&&(te=ee.length);for(var le=0,X=new Array(te);le<te;le++)X[le]=ee[le];return X}function F(ee,te){var le=typeof Symbol<"u"&&ee[Symbol.iterator]||ee["@@iterator"];if(le)return(le=le.call(ee)).next.bind(le);if(Array.isArray(ee)||(le=A(ee))||te&&ee&&typeof ee.length=="number"){le&&(ee=le);var X=0;return function(){return X>=ee.length?{done:!0}:{done:!1,value:ee[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=R();function m(ee){re.defaults=ee}var k=/[&<>"']/,g=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(te){return w[te]};function C(ee,te){if(te){if(k.test(ee))return ee.replace(g,D)}else if(L.test(ee))return ee.replace(I,D);return ee}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function i(ee){return ee.replace(p,function(te,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var c=/(^|[^\[])\^/g;function u(ee,te){ee=typeof ee=="string"?ee:ee.source,te=te||"";var le={replace:function(ue,se){return se=se.source||se,se=se.replace(c,"$1"),ee=ee.replace(ue,se),le},getRegex:function(){return new RegExp(ee,te)}};return le}var v=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(ee,te,le){if(ee){var X;try{X=decodeURIComponent(i(le)).replace(v,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}te&&!f.test(le)&&(le=d(te,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var n={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(ee,te){n[" "+ee]||(o.test(ee)?n[" "+ee]=ee+"/":n[" "+ee]=y(ee,"/",!0)),ee=n[" "+ee];var le=ee.indexOf(":")===-1;return te.substring(0,2)==="//"?le?te:ee.replace(s,"$1")+te:te.charAt(0)==="/"?le?te:ee.replace(t,"$1")+te:ee+te}var $={exec:function(){}};function l(ee){for(var te=1,le,X;te<arguments.length;te++){le=arguments[te];for(X in le)Object.prototype.hasOwnProperty.call(le,X)&&(ee[X]=le[X])}return ee}function S(ee,te){var le=ee.replace(/\|/g,function(se,oe,T){for(var J=!1,Z=oe;--Z>=0&&T[Z]==="\\";)J=!J;return J?"|":" |"}),X=le.split(/ \|/),ue=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>te)X.splice(te);else for(;X.length<te;)X.push("");for(;ue<X.length;ue++)X[ue]=X[ue].trim().replace(/\\\|/g,"|");return X}function y(ee,te,le){var X=ee.length;if(X===0)return"";for(var ue=0;ue<X;){var se=ee.charAt(X-ue-1);if(se===te&&!le)ue++;else if(se!==te&&le)ue++;else break}return ee.slice(0,X-ue)}function a(ee,te){if(ee.indexOf(te[1])===-1)return-1;for(var le=ee.length,X=0,ue=0;ue<le;ue++)if(ee[ue]==="\\")ue++;else if(ee[ue]===te[0])X++;else if(ee[ue]===te[1]&&(X--,X<0))return ue;return-1}function r(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ee,te){if(te<1)return"";for(var le="";te>1;)te&1&&(le+=ee),te>>=1,ee+=ee;return le+ee}function N(ee,te,le,X){var ue=te.href,se=te.title?C(te.title):null,oe=ee[1].replace(/\\([\[\]])/g,"$1");if(ee[0].charAt(0)!=="!"){X.state.inLink=!0;var T={type:"link",raw:le,href:ue,title:se,text:oe,tokens:X.inlineTokens(oe)};return X.state.inLink=!1,T}return{type:"image",raw:le,href:ue,title:se,text:C(oe)}}function U(ee,te){var le=ee.match(/^(\s+)(?:```)/);if(le===null)return te;var X=le[1];return te.split(`
`).map(function(ue){var se=ue.match(/^\s+/);if(se===null)return ue;var oe=se[0];return oe.length>=X.length?ue.slice(X.length):ue}).join(`
`)}var q=function(){function ee(le){this.options=le||re.defaults}var te=ee.prototype;return te.space=function(X){var ue=this.rules.block.newline.exec(X);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},te.code=function(X){var ue=this.rules.block.code.exec(X);if(ue){var se=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?se:y(se,`
`)}}},te.fences=function(X){var ue=this.rules.block.fences.exec(X);if(ue){var se=ue[0],oe=U(se,ue[3]||"");return{type:"code",raw:se,lang:ue[2]?ue[2].trim():ue[2],text:oe}}},te.heading=function(X){var ue=this.rules.block.heading.exec(X);if(ue){var se=ue[2].trim();if(/#$/.test(se)){var oe=y(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:se,tokens:this.lexer.inline(se)}}},te.hr=function(X){var ue=this.rules.block.hr.exec(X);if(ue)return{type:"hr",raw:ue[0]}},te.blockquote=function(X){var ue=this.rules.block.blockquote.exec(X);if(ue){var se=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},te.list=function(X){var ue=this.rules.block.list.exec(X);if(ue){var se,oe,T,J,Z,x,me,Ee,fe,Ie,Pe,qe,Ve=ue[1].trim(),tt=Ve.length>1,Ge={type:"list",raw:"",ordered:tt,start:tt?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=tt?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=tt?Ve:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(qe=!1,!(!(ue=Ye.exec(X))||this.rules.block.hr.test(X)));){if(se=ue[0],X=X.substring(se.length),Ee=ue[2].split(`
`,1)[0],fe=X.split(`
`,1)[0],this.options.pedantic?(J=2,Pe=Ee.trimLeft()):(J=ue[2].search(/[^ ]/),J=J>4?1:J,Pe=Ee.slice(J),J+=ue[1].length),x=!1,!Ee&&/^ *$/.test(fe)&&(se+=fe+`
`,X=X.substring(fe.length+1),qe=!0),!qe)for(var st=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,J-1)+"}#");X&&(Ie=X.split(`
`,1)[0],Ee=Ie,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(Ee)||rt.test(Ee)||st.test(Ee)||at.test(X)));){if(Ee.search(/[^ ]/)>=J||!Ee.trim())Pe+=`
`+Ee.slice(J);else if(!x)Pe+=`
`+Ee;else break;!x&&!Ee.trim()&&(x=!0),se+=Ie+`
`,X=X.substring(Ie.length+1)}Ge.loose||(me?Ge.loose=!0:/\n *\n *$/.test(se)&&(me=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(Pe),oe&&(T=oe[0]!=="[ ] ",Pe=Pe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:se,task:!!oe,checked:T,loose:!1,text:Pe}),Ge.raw+=se}Ge.items[Ge.items.length-1].raw=se.trimRight(),Ge.items[Ge.items.length-1].text=Pe.trimRight(),Ge.raw=Ge.raw.trimRight();var de=Ge.items.length;for(Z=0;Z<de;Z++){this.lexer.state.top=!1,Ge.items[Z].tokens=this.lexer.blockTokens(Ge.items[Z].text,[]);var Me=Ge.items[Z].tokens.filter(function(Q){return Q.type==="space"}),_=Me.every(function(Q){for(var we=Q.raw.split(""),je=0,Oe=F(we),Xe;!(Xe=Oe()).done;){var et=Xe.value;if(et===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&Me.length&&_&&(Ge.loose=!0,Ge.items[Z].loose=!0)}return Ge}},te.html=function(X){var ue=this.rules.block.html.exec(X);if(ue){var se={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(ue[0]):C(ue[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},te.def=function(X){var ue=this.rules.block.def.exec(X);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var se=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:ue[0],href:ue[2],title:ue[3]}}},te.table=function(X){var ue=this.rules.block.table.exec(X);if(ue){var se={type:"table",header:S(ue[1]).map(function(me){return{text:me}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=ue[0];var oe=se.align.length,T,J,Z,x;for(T=0;T<oe;T++)/^ *-+: *$/.test(se.align[T])?se.align[T]="right":/^ *:-+: *$/.test(se.align[T])?se.align[T]="center":/^ *:-+ *$/.test(se.align[T])?se.align[T]="left":se.align[T]=null;for(oe=se.rows.length,T=0;T<oe;T++)se.rows[T]=S(se.rows[T],se.header.length).map(function(me){return{text:me}});for(oe=se.header.length,J=0;J<oe;J++)se.header[J].tokens=this.lexer.inline(se.header[J].text);for(oe=se.rows.length,J=0;J<oe;J++)for(x=se.rows[J],Z=0;Z<x.length;Z++)x[Z].tokens=this.lexer.inline(x[Z].text);return se}}},te.lheading=function(X){var ue=this.rules.block.lheading.exec(X);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},te.paragraph=function(X){var ue=this.rules.block.paragraph.exec(X);if(ue){var se=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:se,tokens:this.lexer.inline(se)}}},te.text=function(X){var ue=this.rules.block.text.exec(X);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},te.escape=function(X){var ue=this.rules.inline.escape.exec(X);if(ue)return{type:"escape",raw:ue[0],text:C(ue[1])}},te.tag=function(X){var ue=this.rules.inline.tag.exec(X);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):C(ue[0]):ue[0]}},te.link=function(X){var ue=this.rules.inline.link.exec(X);if(ue){var se=ue[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=y(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var T=a(ue[2],"()");if(T>-1){var J=ue[0].indexOf("!")===0?5:4,Z=J+ue[1].length+T;ue[2]=ue[2].substring(0,T),ue[0]=ue[0].substring(0,Z).trim(),ue[3]=""}}var x=ue[2],me="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(x);Ee&&(x=Ee[1],me=Ee[3])}else me=ue[3]?ue[3].slice(1,-1):"";return x=x.trim(),/^</.test(x)&&(this.options.pedantic&&!/>$/.test(se)?x=x.slice(1):x=x.slice(1,-1)),N(ue,{href:x&&x.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},te.reflink=function(X,ue){var se;if((se=this.rules.inline.reflink.exec(X))||(se=this.rules.inline.nolink.exec(X))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=ue[oe.toLowerCase()],!oe||!oe.href){var T=se[0].charAt(0);return{type:"text",raw:T,text:T}}return N(se,oe,se[0],this.lexer)}},te.emStrong=function(X,ue,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(X);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=oe[1]||oe[2]||"";if(!T||T&&(se===""||this.rules.inline.punctuation.exec(se))){var J=oe[0].length-1,Z,x,me=J,Ee=0,fe=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,ue=ue.slice(-1*X.length+J);(oe=fe.exec(ue))!=null;)if(Z=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!Z){if(x=Z.length,oe[3]||oe[4]){me+=x;continue}else if((oe[5]||oe[6])&&J%3&&!((J+x)%3)){Ee+=x;continue}if(me-=x,!(me>0)){if(x=Math.min(x,x+me+Ee),Math.min(J,x)%2){var Ie=X.slice(1,J+oe.index+x);return{type:"em",raw:X.slice(0,J+oe.index+x+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var Pe=X.slice(2,J+oe.index+x-1);return{type:"strong",raw:X.slice(0,J+oe.index+x+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}}}}},te.codespan=function(X){var ue=this.rules.inline.code.exec(X);if(ue){var se=ue[2].replace(/\n/g," "),oe=/[^ ]/.test(se),T=/^ /.test(se)&&/ $/.test(se);return oe&&T&&(se=se.substring(1,se.length-1)),se=C(se,!0),{type:"codespan",raw:ue[0],text:se}}},te.br=function(X){var ue=this.rules.inline.br.exec(X);if(ue)return{type:"br",raw:ue[0]}},te.del=function(X){var ue=this.rules.inline.del.exec(X);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},te.autolink=function(X,ue){var se=this.rules.inline.autolink.exec(X);if(se){var oe,T;return se[2]==="@"?(oe=C(this.options.mangle?ue(se[1]):se[1]),T="mailto:"+oe):(oe=C(se[1]),T=oe),{type:"link",raw:se[0],text:oe,href:T,tokens:[{type:"text",raw:oe,text:oe}]}}},te.url=function(X,ue){var se;if(se=this.rules.inline.url.exec(X)){var oe,T;if(se[2]==="@")oe=C(this.options.mangle?ue(se[0]):se[0]),T="mailto:"+oe;else{var J;do J=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(J!==se[0]);oe=C(se[0]),se[1]==="www."?T="http://"+oe:T=oe}return{type:"link",raw:se[0],text:oe,href:T,tokens:[{type:"text",raw:oe,text:oe}]}}},te.inlineText=function(X,ue){var se=this.rules.inline.text.exec(X);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):C(se[0]):se[0]:oe=C(this.options.smartypants?ue(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ee}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=u(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=u(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=u(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=u(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=u(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=u(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=l({},B),B.gfm=l({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=u(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=u(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=l({},B.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:u(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=u(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=u(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=u(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=u(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=u(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=u(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=u(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=u(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=u(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=u(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=u(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=l({},O),O.pedantic=l({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=l({},O.normal,{escape:u(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=u(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=l({},O.gfm,{br:u(O.br).replace("{2,}","*").getRegex(),text:u(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(ee){var te="",le,X,ue=ee.length;for(le=0;le<ue;le++)X=ee.charCodeAt(le),Math.random()>.5&&(X="x"+X.toString(16)),te+="&#"+X+";";return te}var j=function(){function ee(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||re.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:B.normal,inline:O.normal};this.options.pedantic?(X.block=B.pedantic,X.inline=O.pedantic):this.options.gfm&&(X.block=B.gfm,this.options.breaks?X.inline=O.breaks:X.inline=O.gfm),this.tokenizer.rules=X}ee.lex=function(X,ue){var se=new ee(ue);return se.lex(X)},ee.lexInline=function(X,ue){var se=new ee(ue);return se.inlineTokens(X)};var te=ee.prototype;return te.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},te.blockTokens=function(X,ue){var se=this;ue===void 0&&(ue=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(me,Ee,fe){return Ee+"    ".repeat(fe.length)});for(var oe,T,J,Z;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(oe=me.call({lexer:se},X,ue))?(X=X.substring(oe.raw.length),ue.push(oe),!0):!1}))){if(oe=this.tokenizer.space(X)){X=X.substring(oe.raw.length),oe.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(oe);continue}if(oe=this.tokenizer.code(X)){X=X.substring(oe.raw.length),T=ue[ue.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+oe.raw,T.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(oe);continue}if(oe=this.tokenizer.fences(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.heading(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.hr(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.blockquote(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.list(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.html(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.def(X)){X=X.substring(oe.raw.length),T=ue[ue.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+oe.raw,T.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.lheading(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(J=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,Ee=X.slice(1),fe=void 0;se.options.extensions.startBlock.forEach(function(Ie){fe=Ie.call({lexer:this},Ee),typeof fe=="number"&&fe>=0&&(me=Math.min(me,fe))}),me<1/0&&me>=0&&(J=X.substring(0,me+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(J))){T=ue[ue.length-1],Z&&T.type==="paragraph"?(T.raw+=`
`+oe.raw,T.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(oe),Z=J.length!==X.length,X=X.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(X)){X=X.substring(oe.raw.length),T=ue[ue.length-1],T&&T.type==="text"?(T.raw+=`
`+oe.raw,T.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(oe);continue}if(X){var x="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return this.state.top=!0,ue},te.inline=function(X,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:X,tokens:ue}),ue},te.inlineTokens=function(X,ue){var se=this;ue===void 0&&(ue=[]);var oe,T,J,Z=X,x,me,Ee;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(x=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)fe.includes(x[0].slice(x[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,x.index)+"["+P("a",x[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(x=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,x.index)+"["+P("a",x[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(x=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,x.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(me||(Ee=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Pe){return(oe=Pe.call({lexer:se},X,ue))?(X=X.substring(oe.raw.length),ue.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.tag(X)){X=X.substring(oe.raw.length),T=ue[ue.length-1],T&&oe.type==="text"&&T.type==="text"?(T.raw+=oe.raw,T.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.link(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(oe.raw.length),T=ue[ue.length-1],T&&oe.type==="text"&&T.type==="text"?(T.raw+=oe.raw,T.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.emStrong(X,Z,Ee)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.codespan(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.br(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.del(X)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.autolink(X,z)){X=X.substring(oe.raw.length),ue.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(X,z))){X=X.substring(oe.raw.length),ue.push(oe);continue}if(J=X,this.options.extensions&&this.options.extensions.startInline&&function(){var Pe=1/0,qe=X.slice(1),Ve=void 0;se.options.extensions.startInline.forEach(function(tt){Ve=tt.call({lexer:this},qe),typeof Ve=="number"&&Ve>=0&&(Pe=Math.min(Pe,Ve))}),Pe<1/0&&Pe>=0&&(J=X.substring(0,Pe+1))}(),oe=this.tokenizer.inlineText(J,K)){X=X.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Ee=oe.raw.slice(-1)),me=!0,T=ue[ue.length-1],T&&T.type==="text"?(T.raw+=oe.raw,T.text+=oe.text):ue.push(oe);continue}if(X){var Ie="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ue},b(ee,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ee}(),he=function(){function ee(le){this.options=le||re.defaults}var te=ee.prototype;return te.code=function(X,ue,se){var oe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(X,oe);T!=null&&T!==X&&(se=!0,X=T)}return X=X.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+C(oe,!0)+'">'+(se?X:C(X,!0))+`</code></pre>
`:"<pre><code>"+(se?X:C(X,!0))+`</code></pre>
`},te.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},te.html=function(X){return X},te.heading=function(X,ue,se,oe){if(this.options.headerIds){var T=this.options.headerPrefix+oe.slug(se);return"<h"+ue+' id="'+T+'">'+X+"</h"+ue+`>
`}return"<h"+ue+">"+X+"</h"+ue+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(X,ue,se){var oe=ue?"ol":"ul",T=ue&&se!==1?' start="'+se+'"':"";return"<"+oe+T+`>
`+X+"</"+oe+`>
`},te.listitem=function(X){return"<li>"+X+`</li>
`},te.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(X){return"<p>"+X+`</p>
`},te.table=function(X,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ue+`</table>
`},te.tablerow=function(X){return`<tr>
`+X+`</tr>
`},te.tablecell=function(X,ue){var se=ue.header?"th":"td",oe=ue.align?"<"+se+' align="'+ue.align+'">':"<"+se+">";return oe+X+("</"+se+`>
`)},te.strong=function(X){return"<strong>"+X+"</strong>"},te.em=function(X){return"<em>"+X+"</em>"},te.codespan=function(X){return"<code>"+X+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(X){return"<del>"+X+"</del>"},te.link=function(X,ue,se){if(X=E(this.options.sanitize,this.options.baseUrl,X),X===null)return se;var oe='<a href="'+C(X)+'"';return ue&&(oe+=' title="'+ue+'"'),oe+=">"+se+"</a>",oe},te.image=function(X,ue,se){if(X=E(this.options.sanitize,this.options.baseUrl,X),X===null)return se;var oe='<img src="'+X+'" alt="'+se+'"';return ue&&(oe+=' title="'+ue+'"'),oe+=this.options.xhtml?"/>":">",oe},te.text=function(X){return X},ee}(),ie=function(){function ee(){}var te=ee.prototype;return te.strong=function(X){return X},te.em=function(X){return X},te.codespan=function(X){return X},te.del=function(X){return X},te.html=function(X){return X},te.text=function(X){return X},te.link=function(X,ue,se){return""+se},te.image=function(X,ue,se){return""+se},te.br=function(){return""},ee}(),ne=function(){function ee(){this.seen={}}var te=ee.prototype;return te.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(X,ue){var se=X,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[X];do oe++,se=X+"-"+oe;while(this.seen.hasOwnProperty(se))}return ue||(this.seen[X]=oe,this.seen[se]=0),se},te.slug=function(X,ue){ue===void 0&&(ue={});var se=this.serialize(X);return this.getNextSafeSlug(se,ue.dryrun)},ee}(),V=function(){function ee(le){this.options=le||re.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ne}ee.parse=function(X,ue){var se=new ee(ue);return se.parse(X)},ee.parseInline=function(X,ue){var se=new ee(ue);return se.parseInline(X)};var te=ee.prototype;return te.parse=function(X,ue){ue===void 0&&(ue=!0);var se="",oe,T,J,Z,x,me,Ee,fe,Ie,Pe,qe,Ve,tt,Ge,Ye,st,at,xe,rt,de=X.length;for(oe=0;oe<de;oe++){if(Pe=X[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(rt=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Pe.type))){se+=rt||"";continue}switch(Pe.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(Pe.tokens),Pe.depth,i(this.parseInline(Pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(Pe.text,Pe.lang,Pe.escaped);continue}case"table":{for(fe="",Ee="",Z=Pe.header.length,T=0;T<Z;T++)Ee+=this.renderer.tablecell(this.parseInline(Pe.header[T].tokens),{header:!0,align:Pe.align[T]});for(fe+=this.renderer.tablerow(Ee),Ie="",Z=Pe.rows.length,T=0;T<Z;T++){for(me=Pe.rows[T],Ee="",x=me.length,J=0;J<x;J++)Ee+=this.renderer.tablecell(this.parseInline(me[J].tokens),{header:!1,align:Pe.align[J]});Ie+=this.renderer.tablerow(Ee)}se+=this.renderer.table(fe,Ie);continue}case"blockquote":{Ie=this.parse(Pe.tokens),se+=this.renderer.blockquote(Ie);continue}case"list":{for(qe=Pe.ordered,Ve=Pe.start,tt=Pe.loose,Z=Pe.items.length,Ie="",T=0;T<Z;T++)Ye=Pe.items[T],st=Ye.checked,at=Ye.task,Ge="",Ye.task&&(xe=this.renderer.checkbox(st),tt?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=xe+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=xe+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:xe}):Ge+=xe),Ge+=this.parse(Ye.tokens,tt),Ie+=this.renderer.listitem(Ge,at,st);se+=this.renderer.list(Ie,qe,Ve);continue}case"html":{se+=this.renderer.html(Pe.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(Pe.tokens));continue}case"text":{for(Ie=Pe.tokens?this.parseInline(Pe.tokens):Pe.text;oe+1<de&&X[oe+1].type==="text";)Pe=X[++oe],Ie+=`
`+(Pe.tokens?this.parseInline(Pe.tokens):Pe.text);se+=ue?this.renderer.paragraph(Ie):Ie;continue}default:{var Me='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return se},te.parseInline=function(X,ue){ue=ue||this.renderer;var se="",oe,T,J,Z=X.length;for(oe=0;oe<Z;oe++){if(T=X[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(J=this.options.extensions.renderers[T.type].call({parser:this},T),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){se+=J||"";continue}switch(T.type){case"escape":{se+=ue.text(T.text);break}case"html":{se+=ue.html(T.text);break}case"link":{se+=ue.link(T.href,T.title,this.parseInline(T.tokens,ue));break}case"image":{se+=ue.image(T.href,T.title,T.text);break}case"strong":{se+=ue.strong(this.parseInline(T.tokens,ue));break}case"em":{se+=ue.em(this.parseInline(T.tokens,ue));break}case"codespan":{se+=ue.codespan(T.text);break}case"br":{se+=ue.br();break}case"del":{se+=ue.del(this.parseInline(T.tokens,ue));break}case"text":{se+=ue.text(T.text);break}default:{var x='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(x);return}else throw new Error(x)}}}return se},ee}();function H(ee,te,le){if(typeof ee>"u"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof te=="function"&&(le=te,te=null),te=l({},H.defaults,te||{}),r(te),le){var X=te.highlight,ue;try{ue=j.lex(ee,te)}catch(Z){return le(Z)}var se=function(x){var me;if(!x)try{te.walkTokens&&H.walkTokens(ue,te.walkTokens),me=V.parse(ue,te)}catch(Ee){x=Ee}return te.highlight=X,x?le(x):le(null,me)};if(!X||X.length<3||(delete te.highlight,!ue.length))return se();var oe=0;H.walkTokens(ue,function(Z){Z.type==="code"&&(oe++,setTimeout(function(){X(Z.text,Z.lang,function(x,me){if(x)return se(x);me!=null&&me!==Z.text&&(Z.text=me,Z.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function T(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+C(Z.message+"",!0)+"</pre>";throw Z}try{var J=j.lex(ee,te);if(te.walkTokens){if(te.async)return Promise.all(H.walkTokens(J,te.walkTokens)).then(function(){return V.parse(J,te)}).catch(T);H.walkTokens(J,te.walkTokens)}return V.parse(J,te)}catch(Z){T(Z)}}H.options=H.setOptions=function(ee){return l(H.defaults,ee),m(H.defaults),H},H.getDefaults=R,H.defaults=re.defaults,H.use=function(){for(var ee=arguments.length,te=new Array(ee),le=0;le<ee;le++)te[le]=arguments[le];var X=l.apply(void 0,[{}].concat(te)),ue=H.defaults.extensions||{renderers:{},childTokens:{}},se;te.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var Z=ue.renderers?ue.renderers[J.name]:null;Z?ue.renderers[J.name]=function(){for(var x=arguments.length,me=new Array(x),Ee=0;Ee<x;Ee++)me[Ee]=arguments[Ee];var fe=J.renderer.apply(this,me);return fe===!1&&(fe=Z.apply(this,me)),fe}:ue.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[J.level]?ue[J.level].unshift(J.tokenizer):ue[J.level]=[J.tokenizer],J.start&&(J.level==="block"?ue.startBlock?ue.startBlock.push(J.start):ue.startBlock=[J.start]:J.level==="inline"&&(ue.startInline?ue.startInline.push(J.start):ue.startInline=[J.start]))}J.childTokens&&(ue.childTokens[J.name]=J.childTokens)})),oe.renderer&&function(){var J=H.defaults.renderer||new he,Z=function(Ee){var fe=J[Ee];J[Ee]=function(){for(var Ie=arguments.length,Pe=new Array(Ie),qe=0;qe<Ie;qe++)Pe[qe]=arguments[qe];var Ve=oe.renderer[Ee].apply(J,Pe);return Ve===!1&&(Ve=fe.apply(J,Pe)),Ve}};for(var x in oe.renderer)Z(x);X.renderer=J}(),oe.tokenizer&&function(){var J=H.defaults.tokenizer||new q,Z=function(Ee){var fe=J[Ee];J[Ee]=function(){for(var Ie=arguments.length,Pe=new Array(Ie),qe=0;qe<Ie;qe++)Pe[qe]=arguments[qe];var Ve=oe.tokenizer[Ee].apply(J,Pe);return Ve===!1&&(Ve=fe.apply(J,Pe)),Ve}};for(var x in oe.tokenizer)Z(x);X.tokenizer=J}(),oe.walkTokens){var T=H.defaults.walkTokens;X.walkTokens=function(J){var Z=[];return Z.push(oe.walkTokens.call(this,J)),T&&(Z=Z.concat(T.call(this,J))),Z}}se&&(X.extensions=ue),H.setOptions(X)})},H.walkTokens=function(ee,te){for(var le=[],X=function(){var T=se.value;switch(le=le.concat(te.call(H,T)),T.type){case"table":{for(var J=F(T.header),Z;!(Z=J()).done;){var x=Z.value;le=le.concat(H.walkTokens(x.tokens,te))}for(var me=F(T.rows),Ee;!(Ee=me()).done;)for(var fe=Ee.value,Ie=F(fe),Pe;!(Pe=Ie()).done;){var qe=Pe.value;le=le.concat(H.walkTokens(qe.tokens,te))}break}case"list":{le=le.concat(H.walkTokens(T.items,te));break}default:H.defaults.extensions&&H.defaults.extensions.childTokens&&H.defaults.extensions.childTokens[T.type]?H.defaults.extensions.childTokens[T.type].forEach(function(Ve){le=le.concat(H.walkTokens(T[Ve],te))}):T.tokens&&(le=le.concat(H.walkTokens(T.tokens,te)))}},ue=F(ee),se;!(se=ue()).done;)X();return le},H.parseInline=function(ee,te){if(typeof ee>"u"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");te=l({},H.defaults,te||{}),r(te);try{var le=j.lexInline(ee,te);return te.walkTokens&&H.walkTokens(le,te.walkTokens),V.parseInline(le,te)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+C(X.message+"",!0)+"</pre>";throw X}},H.Parser=V,H.parser=V.parse,H.Renderer=he,H.TextRenderer=ie,H.Lexer=j,H.lexer=j.lex,H.Tokenizer=q,H.Slugger=ne,H.parse=H;var ce=H.options,pe=H.setOptions,ye=H.use,ge=H.walkTokens,M=H.parseInline,Y=H,ve=V.parse,Se=j.lex;re.Lexer=j,re.Parser=V,re.Renderer=he,re.Slugger=ne,re.TextRenderer=ie,re.Tokenizer=q,re.getDefaults=R,re.lexer=Se,re.marked=H,re.options=ce,re.parse=Y,re.parseInline=M,re.parser=ve,re.setOptions=pe,re.use=ye,re.walkTokens=ge,Object.defineProperty(re,"__esModule",{value:!0})}),define(De[69],Ce([1,0,28]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=void 0;const A=new b.$mi(1e4);function h(g){return k(g,"NFC",A)}e.$4k=h;const F=new b.$mi(1e4);function R(g){return k(g,"NFD",F)}e.$5k=R;const m=/[^\u0000-\u0080]/;function k(g,L,I){if(!g)return g;const w=I.get(g);if(w)return w;let D;return m.test(g)?D=g.normalize(L):D=g,I.set(g,D),D}e.$6k=function(){const g=/[\u0300-\u036f]/g;return function(L){return R(L).replace(g,"")}}()}),define(De[113],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=e.rot=e.$ql=void 0;function b(m,k,g){return Math.min(Math.max(m,k),g)}e.$ql=b;function A(m,k){return(k+m%k)%k}e.rot=A;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$sl=h;class F{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$tl=F;class R{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const g=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$ul=R}),function(){function re(h){const F=[];typeof h=="number"&&F.push("code/timeOrigin",h);function R(k){F.push(k,Date.now())}function m(){const k=[];for(let g=0;g<F.length;g+=2)k.push({name:F[g],startTime:F[g+1]});return k}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(h+R.startTime)});return F}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function b(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=b(A))}(),define(De[9],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let b=!1,A=!1,h=!1,F=!1,R=!1,m=!1,k=!1,g=!1,L=!1,I=!1,w,D=e.$a,C=e.$a,p,i;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?c=e.$b.vscode.process:typeof process<"u"&&(c=process);const u=typeof c?.versions?.electron=="string",v=u&&c?.type==="renderer";if(typeof navigator=="object"&&!v){i=navigator.userAgent,b=i.indexOf("Windows")>=0,A=i.indexOf("Macintosh")>=0,g=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=i.indexOf("Linux")>=0,I=i?.indexOf("Mobi")>=0,m=!0,w=e.$a,D=w,C=navigator.language;const l=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=l&&l.getAttribute("data-settings");if(S)try{const y=JSON.parse(S),a=y.availableLanguages["*"];w=y.locale,C=y.osLocale,D=a||e.$a,p=y._translationsConfigFile}catch{}}else if(typeof c=="object"){b=c.platform==="win32",A=c.platform==="darwin",h=c.platform==="linux",F=h&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,k=u,L=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,D=e.$a;const l=c.env.VSCODE_NLS_CONFIG;if(l)try{const S=JSON.parse(l),y=S.availableLanguages["*"];w=S.locale,C=S.osLocale,D=y||e.$a,p=S._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var f;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(f||(e.Platform=f={}));function E(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=E;let n=0;A?n=1:b?n=3:h&&(n=2),e.$d=b,e.$e=A,e.$f=h,e.$g=F,e.$h=R,e.$i=k,e.$j=m,e.$k=m&&typeof e.$b.importScripts=="function",e.$l=g,e.$m=I,e.$n=L,e.$o=n,e.$p=i,e.$q=D;var o;(function(l){function S(){return e.$q}l.value=S;function y(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}l.isDefaultVariant=y;function a(){return e.$q==="en"}l.isDefault=a})(o||(e.Language=o={})),e.$r=w,e.$s=C,e.$t=p,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const l=[];e.$b.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let a=0,r=l.length;a<r;a++){const P=l[a];if(P.id===y.data.vscodeScheduleAsyncWork){l.splice(a,1),P.callback();return}}});let S=0;return y=>{const a=++S;l.push({id:a,callback:y}),e.$b.postMessage({vscodeScheduleAsyncWork:a},"*")}}return l=>setTimeout(l)})();var s;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=A||g?2:b?1:3;let t=!0,d=!1;function $(){if(!d){d=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,t=new Uint16Array(l.buffer)[0]===(2<<8)+1}return t}e.$x=$,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(De[39],Ce([1,0,9]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6b=e.$5b=e.env=e.cwd=void 0;let A;if(typeof b.$b.vscode<"u"&&typeof b.$b.vscode.process<"u"){const h=b.$b.vscode.process;A={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return b.$d?"win32":b.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$5b=A.platform,e.$6b=A.arch}),define(De[10],Ce([1,0,39]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ic=e.sep=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=void 0;const A=65,h=97,F=90,R=122,m=46,k=47,g=92,L=58,I=63;class w extends Error{constructor(o,s,t){let d;typeof s=="string"&&s.indexOf("not ")===0?(d="must not be",s=s.replace(/^not /,"")):d="must be";const $=o.indexOf(".")!==-1?"property":"argument";let l=`The "${o}" ${$} ${d} of type ${s}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function D(n,o){if(n===null||typeof n!="object")throw new w(o,"Object",n)}function C(n,o){if(typeof n!="string")throw new w(o,"string",n)}const p=b.$5b==="win32";function i(n){return n===k||n===g}function c(n){return n===k}function u(n){return n>=A&&n<=F||n>=h&&n<=R}function v(n,o,s,t){let d="",$=0,l=-1,S=0,y=0;for(let a=0;a<=n.length;++a){if(a<n.length)y=n.charCodeAt(a);else{if(t(y))break;y=k}if(t(y)){if(!(l===a-1||S===1))if(S===2){if(d.length<2||$!==2||d.charCodeAt(d.length-1)!==m||d.charCodeAt(d.length-2)!==m){if(d.length>2){const r=d.lastIndexOf(s);r===-1?(d="",$=0):(d=d.slice(0,r),$=d.length-1-d.lastIndexOf(s)),l=a,S=0;continue}else if(d.length!==0){d="",$=0,l=a,S=0;continue}}o&&(d+=d.length>0?`${s}..`:"..",$=2)}else d.length>0?d+=`${s}${n.slice(l+1,a)}`:d=n.slice(l+1,a),$=a-l-1;l=a,S=0}else y===m&&S!==-1?++S:S=-1}return d}function f(n,o){D(o,"pathObject");const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${n}${t}`:t}e.$7b={resolve(...n){let o="",s="",t=!1;for(let d=n.length-1;d>=-1;d--){let $;if(d>=0){if($=n[d],C($,"path"),$.length===0)continue}else o.length===0?$=b.cwd():($=b.env[`=${o}`]||b.cwd(),($===void 0||$.slice(0,2).toLowerCase()!==o.toLowerCase()&&$.charCodeAt(2)===g)&&($=`${o}\\`));const l=$.length;let S=0,y="",a=!1;const r=$.charCodeAt(0);if(l===1)i(r)&&(S=1,a=!0);else if(i(r))if(a=!0,i($.charCodeAt(1))){let P=2,N=P;for(;P<l&&!i($.charCodeAt(P));)P++;if(P<l&&P!==N){const U=$.slice(N,P);for(N=P;P<l&&i($.charCodeAt(P));)P++;if(P<l&&P!==N){for(N=P;P<l&&!i($.charCodeAt(P));)P++;(P===l||P!==N)&&(y=`\\\\${U}\\${$.slice(N,P)}`,S=P)}}}else S=1;else u(r)&&$.charCodeAt(1)===L&&(y=$.slice(0,2),S=2,l>2&&i($.charCodeAt(2))&&(a=!0,S=3));if(y.length>0)if(o.length>0){if(y.toLowerCase()!==o.toLowerCase())continue}else o=y;if(t){if(o.length>0)break}else if(s=`${$.slice(S)}\\${s}`,t=a,a&&o.length>0)break}return s=v(s,!t,"\\",i),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(n){C(n,"path");const o=n.length;if(o===0)return".";let s=0,t,d=!1;const $=n.charCodeAt(0);if(o===1)return c($)?"\\":n;if(i($))if(d=!0,i(n.charCodeAt(1))){let S=2,y=S;for(;S<o&&!i(n.charCodeAt(S));)S++;if(S<o&&S!==y){const a=n.slice(y,S);for(y=S;S<o&&i(n.charCodeAt(S));)S++;if(S<o&&S!==y){for(y=S;S<o&&!i(n.charCodeAt(S));)S++;if(S===o)return`\\\\${a}\\${n.slice(y)}\\`;S!==y&&(t=`\\\\${a}\\${n.slice(y,S)}`,s=S)}}}else s=1;else u($)&&n.charCodeAt(1)===L&&(t=n.slice(0,2),s=2,o>2&&i(n.charCodeAt(2))&&(d=!0,s=3));let l=s<o?v(n.slice(s),!d,"\\",i):"";return l.length===0&&!d&&(l="."),l.length>0&&i(n.charCodeAt(o-1))&&(l+="\\"),t===void 0?d?`\\${l}`:l:d?`${t}\\${l}`:`${t}${l}`},isAbsolute(n){C(n,"path");const o=n.length;if(o===0)return!1;const s=n.charCodeAt(0);return i(s)||o>2&&u(s)&&n.charCodeAt(1)===L&&i(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,s;for(let $=0;$<n.length;++$){const l=n[$];C(l,"path"),l.length>0&&(o===void 0?o=s=l:o+=`\\${l}`)}if(o===void 0)return".";let t=!0,d=0;if(typeof s=="string"&&i(s.charCodeAt(0))){++d;const $=s.length;$>1&&i(s.charCodeAt(1))&&(++d,$>2&&(i(s.charCodeAt(2))?++d:t=!1))}if(t){for(;d<o.length&&i(o.charCodeAt(d));)d++;d>=2&&(o=`\\${o.slice(d)}`)}return e.$7b.normalize(o)},relative(n,o){if(C(n,"from"),C(o,"to"),n===o)return"";const s=e.$7b.resolve(n),t=e.$7b.resolve(o);if(s===t||(n=s.toLowerCase(),o=t.toLowerCase(),n===o))return"";let d=0;for(;d<n.length&&n.charCodeAt(d)===g;)d++;let $=n.length;for(;$-1>d&&n.charCodeAt($-1)===g;)$--;const l=$-d;let S=0;for(;S<o.length&&o.charCodeAt(S)===g;)S++;let y=o.length;for(;y-1>S&&o.charCodeAt(y-1)===g;)y--;const a=y-S,r=l<a?l:a;let P=-1,N=0;for(;N<r;N++){const q=n.charCodeAt(d+N);if(q!==o.charCodeAt(S+N))break;q===g&&(P=N)}if(N!==r){if(P===-1)return t}else{if(a>r){if(o.charCodeAt(S+N)===g)return t.slice(S+N+1);if(N===2)return t.slice(S+N)}l>r&&(n.charCodeAt(d+N)===g?P=N:N===2&&(P=3)),P===-1&&(P=0)}let U="";for(N=d+P+1;N<=$;++N)(N===$||n.charCodeAt(N)===g)&&(U+=U.length===0?"..":"\\..");return S+=P,U.length>0?`${U}${t.slice(S,y)}`:(t.charCodeAt(S)===g&&++S,t.slice(S,y))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const o=e.$7b.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==I&&s!==m)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return n},dirname(n){C(n,"path");const o=n.length;if(o===0)return".";let s=-1,t=0;const d=n.charCodeAt(0);if(o===1)return i(d)?n:".";if(i(d)){if(s=t=1,i(n.charCodeAt(1))){let S=2,y=S;for(;S<o&&!i(n.charCodeAt(S));)S++;if(S<o&&S!==y){for(y=S;S<o&&i(n.charCodeAt(S));)S++;if(S<o&&S!==y){for(y=S;S<o&&!i(n.charCodeAt(S));)S++;if(S===o)return n;S!==y&&(s=t=S+1)}}}}else u(d)&&n.charCodeAt(1)===L&&(s=o>2&&i(n.charCodeAt(2))?3:2,t=s);let $=-1,l=!0;for(let S=o-1;S>=t;--S)if(i(n.charCodeAt(S))){if(!l){$=S;break}}else l=!1;if($===-1){if(s===-1)return".";$=s}return n.slice(0,$)},basename(n,o){o!==void 0&&C(o,"ext"),C(n,"path");let s=0,t=-1,d=!0,$;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let l=o.length-1,S=-1;for($=n.length-1;$>=s;--$){const y=n.charCodeAt($);if(i(y)){if(!d){s=$+1;break}}else S===-1&&(d=!1,S=$+1),l>=0&&(y===o.charCodeAt(l)?--l===-1&&(t=$):(l=-1,t=S))}return s===t?t=S:t===-1&&(t=n.length),n.slice(s,t)}for($=n.length-1;$>=s;--$)if(i(n.charCodeAt($))){if(!d){s=$+1;break}}else t===-1&&(d=!1,t=$+1);return t===-1?"":n.slice(s,t)},extname(n){C(n,"path");let o=0,s=-1,t=0,d=-1,$=!0,l=0;n.length>=2&&n.charCodeAt(1)===L&&u(n.charCodeAt(0))&&(o=t=2);for(let S=n.length-1;S>=o;--S){const y=n.charCodeAt(S);if(i(y)){if(!$){t=S+1;break}continue}d===-1&&($=!1,d=S+1),y===m?s===-1?s=S:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||d===-1||l===0||l===1&&s===d-1&&s===t+1?"":n.slice(s,d)},format:f.bind(null,"\\"),parse(n){C(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.length;let t=0,d=n.charCodeAt(0);if(s===1)return i(d)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(i(d)){if(t=1,i(n.charCodeAt(1))){let P=2,N=P;for(;P<s&&!i(n.charCodeAt(P));)P++;if(P<s&&P!==N){for(N=P;P<s&&i(n.charCodeAt(P));)P++;if(P<s&&P!==N){for(N=P;P<s&&!i(n.charCodeAt(P));)P++;P===s?t=P:P!==N&&(t=P+1)}}}}else if(u(d)&&n.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=n,o;if(t=2,i(n.charCodeAt(2))){if(s===3)return o.root=o.dir=n,o;t=3}}t>0&&(o.root=n.slice(0,t));let $=-1,l=t,S=-1,y=!0,a=n.length-1,r=0;for(;a>=t;--a){if(d=n.charCodeAt(a),i(d)){if(!y){l=a+1;break}continue}S===-1&&(y=!1,S=a+1),d===m?$===-1?$=a:r!==1&&(r=1):$!==-1&&(r=-1)}return S!==-1&&($===-1||r===0||r===1&&$===S-1&&$===l+1?o.base=o.name=n.slice(l,S):(o.name=n.slice(l,$),o.base=n.slice(l,S),o.ext=n.slice($,S))),l>0&&l!==t?o.dir=n.slice(0,l-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(p){const n=/\\/g;return()=>{const o=b.cwd().replace(n,"/");return o.slice(o.indexOf("/"))}}return()=>b.cwd()})();e.$8b={resolve(...n){let o="",s=!1;for(let t=n.length-1;t>=-1&&!s;t--){const d=t>=0?n[t]:E();C(d,"path"),d.length!==0&&(o=`${d}/${o}`,s=d.charCodeAt(0)===k)}return o=v(o,!s,"/",c),s?`/${o}`:o.length>0?o:"."},normalize(n){if(C(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===k,s=n.charCodeAt(n.length-1)===k;return n=v(n,!o,"/",c),n.length===0?o?"/":s?"./":".":(s&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return C(n,"path"),n.length>0&&n.charCodeAt(0)===k},join(...n){if(n.length===0)return".";let o;for(let s=0;s<n.length;++s){const t=n[s];C(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$8b.normalize(o)},relative(n,o){if(C(n,"from"),C(o,"to"),n===o||(n=e.$8b.resolve(n),o=e.$8b.resolve(o),n===o))return"";const s=1,t=n.length,d=t-s,$=1,l=o.length-$,S=d<l?d:l;let y=-1,a=0;for(;a<S;a++){const P=n.charCodeAt(s+a);if(P!==o.charCodeAt($+a))break;P===k&&(y=a)}if(a===S)if(l>S){if(o.charCodeAt($+a)===k)return o.slice($+a+1);if(a===0)return o.slice($+a)}else d>S&&(n.charCodeAt(s+a)===k?y=a:a===0&&(y=0));let r="";for(a=s+y+1;a<=t;++a)(a===t||n.charCodeAt(a)===k)&&(r+=r.length===0?"..":"/..");return`${r}${o.slice($+y)}`},toNamespacedPath(n){return n},dirname(n){if(C(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===k;let s=-1,t=!0;for(let d=n.length-1;d>=1;--d)if(n.charCodeAt(d)===k){if(!t){s=d;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":n.slice(0,s)},basename(n,o){o!==void 0&&C(o,"ext"),C(n,"path");let s=0,t=-1,d=!0,$;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let l=o.length-1,S=-1;for($=n.length-1;$>=0;--$){const y=n.charCodeAt($);if(y===k){if(!d){s=$+1;break}}else S===-1&&(d=!1,S=$+1),l>=0&&(y===o.charCodeAt(l)?--l===-1&&(t=$):(l=-1,t=S))}return s===t?t=S:t===-1&&(t=n.length),n.slice(s,t)}for($=n.length-1;$>=0;--$)if(n.charCodeAt($)===k){if(!d){s=$+1;break}}else t===-1&&(d=!1,t=$+1);return t===-1?"":n.slice(s,t)},extname(n){C(n,"path");let o=-1,s=0,t=-1,d=!0,$=0;for(let l=n.length-1;l>=0;--l){const S=n.charCodeAt(l);if(S===k){if(!d){s=l+1;break}continue}t===-1&&(d=!1,t=l+1),S===m?o===-1?o=l:$!==1&&($=1):o!==-1&&($=-1)}return o===-1||t===-1||$===0||$===1&&o===t-1&&o===s+1?"":n.slice(o,t)},format:f.bind(null,"/"),parse(n){C(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.charCodeAt(0)===k;let t;s?(o.root="/",t=1):t=0;let d=-1,$=0,l=-1,S=!0,y=n.length-1,a=0;for(;y>=t;--y){const r=n.charCodeAt(y);if(r===k){if(!S){$=y+1;break}continue}l===-1&&(S=!1,l=y+1),r===m?d===-1?d=y:a!==1&&(a=1):d!==-1&&(a=-1)}if(l!==-1){const r=$===0&&s?1:$;d===-1||a===0||a===1&&d===l-1&&d===$+1?o.base=o.name=n.slice(r,l):(o.name=n.slice(r,d),o.base=n.slice(r,l),o.ext=n.slice(d,l))}return $>0?o.dir=n.slice(0,$-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$8b.win32=e.$7b.win32=e.$7b,e.$8b.posix=e.$7b.posix=e.$8b,e.$9b=p?e.$7b.normalize:e.$8b.normalize,e.$0b=p?e.$7b.isAbsolute:e.$8b.isAbsolute,e.$$b=p?e.$7b.join:e.$8b.join,e.$_b=p?e.$7b.resolve:e.$8b.resolve,e.$ac=p?e.$7b.relative:e.$8b.relative,e.$bc=p?e.$7b.dirname:e.$8b.dirname,e.$cc=p?e.$7b.basename:e.$8b.basename,e.$dc=p?e.$7b.extname:e.$8b.extname,e.$ec=p?e.$7b.format:e.$8b.format,e.$fc=p?e.$7b.parse:e.$8b.parse,e.$gc=p?e.$7b.toNamespacedPath:e.$8b.toNamespacedPath,e.sep=p?e.$7b.sep:e.$8b.sep,e.$ic=p?e.$7b.delimiter:e.$8b.delimiter}),define(De[114],Ce([1,0,54,10]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0;const h=new b.$S(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),F=new b.$S(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new b.$S(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(S,y,a=!1){const r=S||"",P=y||"",N=h.value.collator.compare(r,P);return h.value.collatorIsNumeric&&N===0&&r!==P?r<P?-1:1:N}e.$Vp=m;function k(S,y){const a=F.value.collator;return S=S||"",y=y||"",f(a,S,y)}e.$Wp=k;function g(S,y){const a=F.value.collator;return S=S||"",y=y||"",s(S,y)||f(a,S,y)}e.$Xp=g;function L(S,y){const a=F.value.collator;return S=S||"",y=y||"",o(S,y)||f(a,S,y)}e.$Yp=L;function I(S,y){return S=S||"",y=y||"",S===y?0:S<y?-1:1}e.$Zp=I;function w(S,y){const[a,r]=u(S),[P,N]=u(y);let U=h.value.collator.compare(r,N);if(U===0){if(h.value.collatorIsNumeric&&r!==N)return r<N?-1:1;if(U=h.value.collator.compare(a,P),h.value.collatorIsNumeric&&U===0&&a!==P)return a<P?-1:1}return U}e.$1p=w;function D(S,y){S=S||"",y=y||"";const a=v(S),r=v(y),P=F.value.collator,N=R.value.collator;return f(N,a,r)||f(P,S,y)}e.$2p=D;function C(S,y){S=S||"",y=y||"";const a=v(S),r=v(y),P=F.value.collator,N=R.value.collator;return f(N,a,r)||s(S,y)||f(P,S,y)}e.$3p=C;function p(S,y){S=S||"",y=y||"";const a=v(S),r=v(y),P=F.value.collator,N=R.value.collator;return f(N,a,r)||o(S,y)||f(P,S,y)}e.$4p=p;function i(S,y){S=S||"",y=y||"";const a=v(S).toLowerCase(),r=v(y).toLowerCase();return a!==r?a<r?-1:1:S!==y?S<y?-1:1:0}e.$5p=i;const c=/^(.*?)(\.([^.]*))?$/;function u(S,y=!1){const a=S?c.exec(S):[];let r=[a&&a[1]||"",a&&a[3]||""];return y&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function v(S){const y=S?c.exec(S):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function f(S,y,a){const r=S.compare(y,a);return r!==0?r:y.length!==a.length?y.length<a.length?-1:1:0}function E(S){const y=S.charAt(0);return y.toLocaleUpperCase()!==y}function n(S){const y=S.charAt(0);return y.toLocaleLowerCase()!==y}function o(S,y){return E(S)&&n(y)?-1:n(S)&&E(y)?1:0}function s(S,y){return n(S)&&E(y)?-1:E(S)&&n(y)?1:0}function t(S,y,a=!1){return a||(S=S&&S.toLowerCase(),y=y&&y.toLowerCase()),S===y?0:S<y?-1:1}function d(S,y,a=!1){const r=S.split(A.sep),P=y.split(A.sep),N=r.length-1,U=P.length-1;let q,B;for(let O=0;;O++){if(q=N===O,B=U===O,q&&B)return m(r[O],P[O],a);if(q)return-1;if(B)return 1;const K=t(r[O],P[O],a);if(K!==0)return K}}e.$6p=d;function $(S,y,a){const r=S.toLowerCase(),P=y.toLowerCase(),N=l(S,y,a);if(N)return N;const U=r.endsWith(a),q=P.endsWith(a);if(U!==q)return U?-1:1;const B=m(r,P);return B!==0?B:r.localeCompare(P)}e.$7p=$;function l(S,y,a){const r=S.toLowerCase(),P=y.toLowerCase(),N=r.startsWith(a),U=P.startsWith(a);if(N!==U)return N?-1:1;if(N&&U){if(r.length<P.length)return-1;if(r.length>P.length)return 1}return 0}e.$8p=l}),define(De[91],Ce([1,0,10]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=void 0,e.$rr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(L){const I=(0,b.$dc)(L),w=A[I.toLowerCase()];return w!==void 0?w:R(L)}e.$sr=F;function R(L){const I=(0,b.$dc)(L);return h[I.toLowerCase()]}e.$tr=R;function m(L){for(const I in h)if(h[I]===L)return I}e.$ur=m;const k=/^(.+)\/(.+?)(;.+)?$/;function g(L,I){const w=k.exec(L);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:L}e.$vr=g}),define(De[92],Ce([1,0,9]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.TerminateResponseCode=e.Source=void 0;var A;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(A||(e.Source=A={}));var h;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function F(m,...k){const g=k.reduce((w,D)=>(w[D]=!0,w),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(m).filter(w=>!g[w]).forEach(w=>{for(let D=0;D<L.length;D++)if(w.search(L[D])!==-1){delete m[w];break}})}e.$cl=F;function R(m){m&&(delete m.DEBUG,b.$e&&delete m.DYLD_LIBRARY_PATH,b.$f&&delete m.LD_PRELOAD)}e.$dl=R}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var A in b)(typeof exports=="object"?exports:re)[A]=b[A]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function b(A){if(e[A])return e[A].exports;var h=e[A]={i:A,l:!1,exports:{}};return re[A].call(h.exports,h,h.exports,b),h.l=!0,h.exports}return b.m=re,b.c=e,b.d=function(A,h,F){b.o(A,h)||Object.defineProperty(A,h,{enumerable:!0,get:F})},b.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},b.t=function(A,h){if(1&h&&(A=b(A)),8&h||4&h&&typeof A=="object"&&A&&A.__esModule)return A;var F=Object.create(null);if(b.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:A}),2&h&&typeof A!="string")for(var R in A)b.d(F,R,function(m){return A[m]}.bind(null,R));return F},b.n=function(A){var h=A&&A.__esModule?function(){return A.default}:function(){return A};return b.d(h,"a",h),h},b.o=function(A,h){return Object.prototype.hasOwnProperty.call(A,h)},b.p="",b(b.s=0)}([function(re,e,b){(function(A){var h;e=re.exports=ye,h=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],k=e.src=[],g=0,L=g++;k[L]="0|[1-9]\\d*";var I=g++;k[I]="[0-9]+";var w=g++;k[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=g++;k[D]="("+k[L]+")\\.("+k[L]+")\\.("+k[L]+")";var C=g++;k[C]="("+k[I]+")\\.("+k[I]+")\\.("+k[I]+")";var p=g++;k[p]="(?:"+k[L]+"|"+k[w]+")";var i=g++;k[i]="(?:"+k[I]+"|"+k[w]+")";var c=g++;k[c]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var u=g++;k[u]="(?:-?("+k[i]+"(?:\\."+k[i]+")*))";var v=g++;k[v]="[0-9A-Za-z-]+";var f=g++;k[f]="(?:\\+("+k[v]+"(?:\\."+k[v]+")*))";var E=g++,n="v?"+k[D]+k[c]+"?"+k[f]+"?";k[E]="^"+n+"$";var o="[v=\\s]*"+k[C]+k[u]+"?"+k[f]+"?",s=g++;k[s]="^"+o+"$";var t=g++;k[t]="((?:<|>)?=?)";var d=g++;k[d]=k[I]+"|x|X|\\*";var $=g++;k[$]=k[L]+"|x|X|\\*";var l=g++;k[l]="[v=\\s]*("+k[$]+")(?:\\.("+k[$]+")(?:\\.("+k[$]+")(?:"+k[c]+")?"+k[f]+"?)?)?";var S=g++;k[S]="[v=\\s]*("+k[d]+")(?:\\.("+k[d]+")(?:\\.("+k[d]+")(?:"+k[u]+")?"+k[f]+"?)?)?";var y=g++;k[y]="^"+k[t]+"\\s*"+k[l]+"$";var a=g++;k[a]="^"+k[t]+"\\s*"+k[S]+"$";var r=g++;k[r]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;k[P]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[P]+"\\s+",m[N]=new RegExp(k[N],"g");var U=g++;k[U]="^"+k[P]+k[l]+"$";var q=g++;k[q]="^"+k[P]+k[S]+"$";var B=g++;k[B]="(?:\\^)";var O=g++;k[O]="(\\s*)"+k[B]+"\\s+",m[O]=new RegExp(k[O],"g");var K=g++;k[K]="^"+k[B]+k[l]+"$";var z=g++;k[z]="^"+k[B]+k[S]+"$";var j=g++;k[j]="^"+k[t]+"\\s*("+o+")$|^$";var he=g++;k[he]="^"+k[t]+"\\s*("+n+")$|^$";var ie=g++;k[ie]="(\\s*)"+k[t]+"\\s*("+o+"|"+k[l]+")",m[ie]=new RegExp(k[ie],"g");var ne=g++;k[ne]="^\\s*("+k[l]+")\\s+-\\s+("+k[l]+")\\s*$";var V=g++;k[V]="^\\s*("+k[S]+")\\s+-\\s+("+k[S]+")\\s*$";var H=g++;k[H]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)h(ce,k[ce]),m[ce]||(m[ce]=new RegExp(k[ce]));function pe(fe,Ie){if(fe instanceof ye)return fe;if(typeof fe!="string"||fe.length>F||!(Ie?m[s]:m[E]).test(fe))return null;try{return new ye(fe,Ie)}catch{return null}}function ye(fe,Ie){if(fe instanceof ye){if(fe.loose===Ie)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ye))return new ye(fe,Ie);h("SemVer",fe,Ie),this.loose=Ie;var Pe=fe.trim().match(Ie?m[s]:m[E]);if(!Pe)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function(qe){if(/^[0-9]+$/.test(qe)){var Ve=+qe;if(Ve>=0&&Ve<R)return Ve}return qe}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=pe,e.valid=function(fe,Ie){var Pe=pe(fe,Ie);return Pe?Pe.version:null},e.clean=function(fe,Ie){var Pe=pe(fe.trim().replace(/^[=v]+/,""),Ie);return Pe?Pe.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(fe){return h("SemVer.compare",this.version,this.loose,fe),fe instanceof ye||(fe=new ye(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},ye.prototype.compareMain=function(fe){return fe instanceof ye||(fe=new ye(fe,this.loose)),M(this.major,fe.major)||M(this.minor,fe.minor)||M(this.patch,fe.patch)},ye.prototype.comparePre=function(fe){if(fe instanceof ye||(fe=new ye(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var Ie=0;do{var Pe=this.prerelease[Ie],qe=fe.prerelease[Ie];if(h("prerelease compare",Ie,Pe,qe),Pe===void 0&&qe===void 0)return 0;if(qe===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==qe)return M(Pe,qe)}while(++Ie)},ye.prototype.inc=function(fe,Ie){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,Ie,Pe,qe){typeof Pe=="string"&&(qe=Pe,Pe=void 0);try{return new ye(fe,Pe).inc(Ie,qe).version}catch{return null}},e.diff=function(fe,Ie){if(ee(fe,Ie))return null;var Pe=pe(fe),qe=pe(Ie);if(Pe.prerelease.length||qe.prerelease.length){for(var Ve in Pe)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Pe[Ve]!==qe[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Pe)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Pe[Ve]!==qe[Ve])return Ve},e.compareIdentifiers=M;var ge=/^[0-9]+$/;function M(fe,Ie){var Pe=ge.test(fe),qe=ge.test(Ie);return Pe&&qe&&(fe=+fe,Ie=+Ie),Pe&&!qe?-1:qe&&!Pe?1:fe<Ie?-1:fe>Ie?1:0}function Y(fe,Ie,Pe){return new ye(fe,Pe).compare(new ye(Ie,Pe))}function ve(fe,Ie,Pe){return Y(fe,Ie,Pe)>0}function Se(fe,Ie,Pe){return Y(fe,Ie,Pe)<0}function ee(fe,Ie,Pe){return Y(fe,Ie,Pe)===0}function te(fe,Ie,Pe){return Y(fe,Ie,Pe)!==0}function le(fe,Ie,Pe){return Y(fe,Ie,Pe)>=0}function X(fe,Ie,Pe){return Y(fe,Ie,Pe)<=0}function ue(fe,Ie,Pe,qe){var Ve;switch(Ie){case"===":typeof fe=="object"&&(fe=fe.version),typeof Pe=="object"&&(Pe=Pe.version),Ve=fe===Pe;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof Pe=="object"&&(Pe=Pe.version),Ve=fe!==Pe;break;case"":case"=":case"==":Ve=ee(fe,Pe,qe);break;case"!=":Ve=te(fe,Pe,qe);break;case">":Ve=ve(fe,Pe,qe);break;case">=":Ve=le(fe,Pe,qe);break;case"<":Ve=Se(fe,Pe,qe);break;case"<=":Ve=X(fe,Pe,qe);break;default:throw new TypeError("Invalid operator: "+Ie)}return Ve}function se(fe,Ie){if(fe instanceof se){if(fe.loose===Ie)return fe;fe=fe.value}if(!(this instanceof se))return new se(fe,Ie);h("comparator",fe,Ie),this.loose=Ie,this.parse(fe),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(fe,Ie){return M(Ie,fe)},e.major=function(fe,Ie){return new ye(fe,Ie).major},e.minor=function(fe,Ie){return new ye(fe,Ie).minor},e.patch=function(fe,Ie){return new ye(fe,Ie).patch},e.compare=Y,e.compareLoose=function(fe,Ie){return Y(fe,Ie,!0)},e.rcompare=function(fe,Ie,Pe){return Y(Ie,fe,Pe)},e.sort=function(fe,Ie){return fe.sort(function(Pe,qe){return e.compare(Pe,qe,Ie)})},e.rsort=function(fe,Ie){return fe.sort(function(Pe,qe){return e.rcompare(Pe,qe,Ie)})},e.gt=ve,e.lt=Se,e.eq=ee,e.neq=te,e.gte=le,e.lte=X,e.cmp=ue,e.Comparator=se;var oe={};function T(fe,Ie){if(fe instanceof T)return fe.loose===Ie?fe:new T(fe.raw,Ie);if(fe instanceof se)return new T(fe.value,Ie);if(!(this instanceof T))return new T(fe,Ie);if(this.loose=Ie,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function J(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function Z(fe,Ie,Pe,qe,Ve,tt,Ge,Ye,st,at,xe,rt,de){return((Ie=J(Pe)?"":J(qe)?">="+Pe+".0.0":J(Ve)?">="+Pe+"."+qe+".0":">="+Ie)+" "+(Ye=J(st)?"":J(at)?"<"+(+st+1)+".0.0":J(xe)?"<"+st+"."+(+at+1)+".0":rt?"<="+st+"."+at+"."+xe+"-"+rt:"<="+Ye)).trim()}function x(fe,Ie){for(var Pe=0;Pe<fe.length;Pe++)if(!fe[Pe].test(Ie))return!1;if(Ie.prerelease.length){for(Pe=0;Pe<fe.length;Pe++)if(h(fe[Pe].semver),fe[Pe].semver!==oe&&fe[Pe].semver.prerelease.length>0){var qe=fe[Pe].semver;if(qe.major===Ie.major&&qe.minor===Ie.minor&&qe.patch===Ie.patch)return!0}return!1}return!0}function me(fe,Ie,Pe){try{Ie=new T(Ie,Pe)}catch{return!1}return Ie.test(fe)}function Ee(fe,Ie,Pe,qe){var Ve,tt,Ge,Ye,st;switch(fe=new ye(fe,qe),Ie=new T(Ie,qe),Pe){case">":Ve=ve,tt=X,Ge=Se,Ye=">",st=">=";break;case"<":Ve=Se,tt=le,Ge=ve,Ye="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(fe,Ie,qe))return!1;for(var at=0;at<Ie.set.length;++at){var xe=Ie.set[at],rt=null,de=null;if(xe.forEach(function(Me){Me.semver===oe&&(Me=new se(">=0.0.0")),rt=rt||Me,de=de||Me,Ve(Me.semver,rt.semver,qe)?rt=Me:Ge(Me.semver,de.semver,qe)&&(de=Me)}),rt.operator===Ye||rt.operator===st||(!de.operator||de.operator===Ye)&&tt(fe,de.semver)||de.operator===st&&Ge(fe,de.semver))return!1}return!0}se.prototype.parse=function(fe){var Ie=this.loose?m[j]:m[he],Pe=fe.match(Ie);if(!Pe)throw new TypeError("Invalid comparator: "+fe);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new ye(Pe[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(fe){return h("Comparator.test",fe,this.loose),this.semver===oe||(typeof fe=="string"&&(fe=new ye(fe,this.loose)),ue(fe,this.operator,this.semver,this.loose))},se.prototype.intersects=function(fe,Ie){if(!(fe instanceof se))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new T(fe.value,Ie),me(this.value,Pe,Ie);if(fe.operator==="")return Pe=new T(this.value,Ie),me(fe.semver,Pe,Ie);var qe=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),tt=this.semver.version===fe.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),Ye=ue(this.semver,"<",fe.semver,Ie)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),st=ue(this.semver,">",fe.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return qe||Ve||tt&&Ge||Ye||st},e.Range=T,T.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},T.prototype.toString=function(){return this.range},T.prototype.parseRange=function(fe){var Ie=this.loose;fe=fe.trim(),h("range",fe,Ie);var Pe=Ie?m[V]:m[ne];fe=fe.replace(Pe,Z),h("hyphen replace",fe),fe=fe.replace(m[ie],"$1$2$3"),h("comparator trim",fe,m[ie]),fe=(fe=(fe=fe.replace(m[N],"$1~")).replace(m[O],"$1^")).split(/\s+/).join(" ");var qe=Ie?m[j]:m[he],Ve=fe.split(" ").map(function(tt){return function(Ge,Ye){return h("comp",Ge),Ge=function(st,at){return st.trim().split(/\s+/).map(function(xe){return function(rt,de){h("caret",rt,de);var Me=de?m[z]:m[K];return rt.replace(Me,function(_,Q,we,je,Oe){var Xe;return h("caret",rt,_,Q,we,je,Oe),J(Q)?Xe="":J(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":J(je)?Xe=Q==="0"?">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+".0 <"+(+Q+1)+".0.0":Oe?(h("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+je+Oe+" <"+Q+"."+we+"."+(+je+1):">="+Q+"."+we+"."+je+Oe+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+je+Oe+" <"+(+Q+1)+".0.0"):(h("no pr"),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+je+" <"+Q+"."+we+"."+(+je+1):">="+Q+"."+we+"."+je+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+je+" <"+(+Q+1)+".0.0"),h("caret return",Xe),Xe})}(xe,at)}).join(" ")}(Ge,Ye),h("caret",Ge),Ge=function(st,at){return st.trim().split(/\s+/).map(function(xe){return function(rt,de){var Me=de?m[q]:m[U];return rt.replace(Me,function(_,Q,we,je,Oe){var Xe;return h("tilde",rt,_,Q,we,je,Oe),J(Q)?Xe="":J(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":J(je)?Xe=">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":Oe?(h("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+we+"."+je+Oe+" <"+Q+"."+(+we+1)+".0"):Xe=">="+Q+"."+we+"."+je+" <"+Q+"."+(+we+1)+".0",h("tilde return",Xe),Xe})}(xe,at)}).join(" ")}(Ge,Ye),h("tildes",Ge),Ge=function(st,at){return h("replaceXRanges",st,at),st.split(/\s+/).map(function(xe){return function(rt,de){rt=rt.trim();var Me=de?m[a]:m[y];return rt.replace(Me,function(_,Q,we,je,Oe,Xe){h("xRange",rt,_,Q,we,je,Oe,Xe);var et=J(we),nt=et||J(je),ft=nt||J(Oe);return Q==="="&&ft&&(Q=""),et?_=Q===">"||Q==="<"?"<0.0.0":"*":Q&&ft?(nt&&(je=0),ft&&(Oe=0),Q===">"?(Q=">=",nt?(we=+we+1,je=0,Oe=0):ft&&(je=+je+1,Oe=0)):Q==="<="&&(Q="<",nt?we=+we+1:je=+je+1),_=Q+we+"."+je+"."+Oe):nt?_=">="+we+".0.0 <"+(+we+1)+".0.0":ft&&(_=">="+we+"."+je+".0 <"+we+"."+(+je+1)+".0"),h("xRange return",_),_})}(xe,at)}).join(" ")}(Ge,Ye),h("xrange",Ge),Ge=function(st,at){return h("replaceStars",st,at),st.trim().replace(m[H],"")}(Ge,Ye),h("stars",Ge),Ge}(tt,Ie)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(tt){return!!tt.match(qe)})),Ve=Ve.map(function(tt){return new se(tt,Ie)})},T.prototype.intersects=function(fe,Ie){if(!(fe instanceof T))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function(qe){return fe.set.some(function(Ve){return Ve.every(function(tt){return qe.intersects(tt,Ie)})})})})},e.toComparators=function(fe,Ie){return new T(fe,Ie).set.map(function(Pe){return Pe.map(function(qe){return qe.value}).join(" ").trim().split(" ")})},T.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new ye(fe,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(x(this.set[Ie],fe))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(fe,Ie,Pe){var qe=null,Ve=null;try{var tt=new T(Ie,Pe)}catch{return null}return fe.forEach(function(Ge){tt.test(Ge)&&(qe&&Ve.compare(Ge)!==-1||(Ve=new ye(qe=Ge,Pe)))}),qe},e.minSatisfying=function(fe,Ie,Pe){var qe=null,Ve=null;try{var tt=new T(Ie,Pe)}catch{return null}return fe.forEach(function(Ge){tt.test(Ge)&&(qe&&Ve.compare(Ge)!==1||(Ve=new ye(qe=Ge,Pe)))}),qe},e.validRange=function(fe,Ie){try{return new T(fe,Ie).range||"*"}catch{return null}},e.ltr=function(fe,Ie,Pe){return Ee(fe,Ie,"<",Pe)},e.gtr=function(fe,Ie,Pe){return Ee(fe,Ie,">",Pe)},e.outside=Ee,e.prerelease=function(fe,Ie){var Pe=pe(fe,Ie);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(fe,Ie,Pe){return fe=new T(fe,Pe),Ie=new T(Ie,Pe),fe.intersects(Ie)},e.coerce=function(fe){if(fe instanceof ye)return fe;if(typeof fe!="string")return null;var Ie=fe.match(m[r]);return Ie==null?null:pe((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,b(1))},function(re,e){var b,A,h=re.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(i){if(b===setTimeout)return setTimeout(i,0);if((b===F||!b)&&setTimeout)return b=setTimeout,setTimeout(i,0);try{return b(i,0)}catch{try{return b.call(null,i,0)}catch{return b.call(this,i,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:F}catch{b=F}try{A=typeof clearTimeout=="function"?clearTimeout:R}catch{A=R}})();var k,g=[],L=!1,I=-1;function w(){L&&k&&(L=!1,k.length?g=k.concat(g):I=-1,g.length&&D())}function D(){if(!L){var i=m(w);L=!0;for(var c=g.length;c;){for(k=g,g=[];++I<c;)k&&k[I].run();I=-1,c=g.length}k=null,L=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===R||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(i)}}function C(i,c){this.fun=i,this.array=c}function p(){}h.nextTick=function(i){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];g.push(new C(i,c)),g.length!==1||L||m(D)},C.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=p,h.addListener=p,h.once=p,h.off=p,h.removeListener=p,h.removeAllListeners=p,h.emit=p,h.prependListener=p,h.prependOnceListener=p,h.listeners=function(i){return[]},h.binding=function(i){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(i){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(De[40],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;const b=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(F){return new A(F)}constructor(F){this.c=b&&F===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1c=A}),define(De[3],Ce([1,0,8,67,4,68,40]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.Event=void 0;const m=!1,k=!1;var g;(function(S){S.None=()=>h.$kb.None;function y(ee){if(k){const{onDidAddListener:te}=ee,le=C.create();let X=0;ee.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function a(ee,te){return z(ee,()=>{},0,void 0,!0,void 0,te)}S.defer=a;function r(ee){return(te,le=null,X)=>{let ue=!1,se;return se=ee(oe=>{if(!ue)return se?se.dispose():ue=!0,te.call(le,oe)},null,X),ue&&se.dispose(),se}}S.once=r;function P(ee,te,le){return K((X,ue=null,se)=>ee(oe=>X.call(ue,te(oe)),null,se),le)}S.map=P;function N(ee,te,le){return K((X,ue=null,se)=>ee(oe=>{te(oe),X.call(ue,oe)},null,se),le)}S.forEach=N;function U(ee,te,le){return K((X,ue=null,se)=>ee(oe=>te(oe)&&X.call(ue,oe),null,se),le)}S.filter=U;function q(ee){return ee}S.signal=q;function B(...ee){return(te,le=null,X)=>(0,h.$hb)(...ee.map(ue=>ue(se=>te.call(le,se),null,X)))}S.any=B;function O(ee,te,le,X){let ue=le;return P(ee,se=>(ue=te(ue,se),ue),X)}S.reduce=O;function K(ee,te){let le;const X={onWillAddFirstListener(){le=ee(ue.fire,ue)},onDidRemoveLastListener(){le?.dispose()}};te||y(X);const ue=new v(X);return te?.add(ue),ue.event}function z(ee,te,le=100,X=!1,ue=!1,se,oe){let T,J,Z,x=0,me;const Ee={leakWarningThreshold:se,onWillAddFirstListener(){T=ee(Ie=>{x++,J=te(J,Ie),X&&!Z&&(fe.fire(J),J=void 0),me=()=>{const Pe=J;J=void 0,Z=void 0,(!X||x>1)&&fe.fire(Pe),x=0},typeof le=="number"?(clearTimeout(Z),Z=setTimeout(me,le)):Z===void 0&&(Z=0,queueMicrotask(me))})},onWillRemoveListener(){ue&&x>0&&me?.()},onDidRemoveLastListener(){me=void 0,T.dispose()}};oe||y(Ee);const fe=new v(Ee);return oe?.add(fe),fe.event}S.debounce=z;function j(ee,te=0,le){return S.debounce(ee,(X,ue)=>X?(X.push(ue),X):[ue],te,void 0,!0,void 0,le)}S.accumulate=j;function he(ee,te=(X,ue)=>X===ue,le){let X=!0,ue;return U(ee,se=>{const oe=X||!te(se,ue);return X=!1,ue=se,oe},le)}S.latch=he;function ie(ee,te,le){return[S.filter(ee,te,le),S.filter(ee,X=>!te(X),le)]}S.split=ie;function ne(ee,te=!1,le=[]){let X=le.slice(),ue=ee(T=>{X?X.push(T):oe.fire(T)});const se=()=>{X?.forEach(T=>oe.fire(T)),X=null},oe=new v({onWillAddFirstListener(){ue||(ue=ee(T=>oe.fire(T)))},onDidAddFirstListener(){X&&(te?setTimeout(se):se())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return oe.event}S.buffer=ne;class V{constructor(te){this.event=te,this.d=new h.$jb}map(te){return new V(P(this.event,te,this.d))}forEach(te){return new V(N(this.event,te,this.d))}filter(te){return new V(U(this.event,te,this.d))}reduce(te,le){return new V(O(this.event,te,le,this.d))}latch(){return new V(he(this.event,void 0,this.d))}debounce(te,le=100,X=!1,ue=!1,se){return new V(z(this.event,te,le,X,ue,se,this.d))}on(te,le,X){return this.event(te,le,X)}once(te,le,X){return r(this.event)(te,le,X)}dispose(){this.d.dispose()}}function H(ee){return new V(ee)}S.chain=H;function ce(ee,te,le=X=>X){const X=(...T)=>oe.fire(le(...T)),ue=()=>ee.on(te,X),se=()=>ee.removeListener(te,X),oe=new v({onWillAddFirstListener:ue,onDidRemoveLastListener:se});return oe.event}S.fromNodeEventEmitter=ce;function pe(ee,te,le=X=>X){const X=(...T)=>oe.fire(le(...T)),ue=()=>ee.addEventListener(te,X),se=()=>ee.removeEventListener(te,X),oe=new v({onWillAddFirstListener:ue,onDidRemoveLastListener:se});return oe.event}S.fromDOMEventEmitter=pe;function ye(ee){return new Promise(te=>r(ee)(te))}S.toPromise=ye;function ge(ee,te){return te(void 0),ee(le=>te(le))}S.runAndSubscribe=ge;function M(ee,te){let le=null;function X(se){le?.dispose(),le=new h.$jb,te(se,le)}X(void 0);const ue=ee(se=>X(se));return(0,h.$ib)(()=>{ue.dispose(),le?.dispose()})}S.runAndSubscribeWithStore=M;class Y{constructor(te,le){this._observable=te,this.d=0,this.f=!1;const X={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||y(X),this.emitter=new v(X),le&&le.add(this.emitter)}beginUpdate(te){this.d++}handlePossibleChange(te){}handleChange(te,le){this.f=!0}endUpdate(te){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function ve(ee,te){return new Y(ee,te).emitter.event}S.fromObservable=ve;function Se(ee){return te=>{let le=0,X=!1;const ue={beginUpdate(){le++},endUpdate(){le--,le===0&&(ee.reportChanges(),X&&(X=!1,te()))},handlePossibleChange(){},handleChange(){X=!0}};return ee.addObserver(ue),{dispose(){ee.removeObserver(ue)}}}}S.fromObservableLight=Se})(g||(e.Event=g={}));class L{constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${L.d++}`,L.all.add(this)}start(y){this.f=new R.$1c,this.listenerCount=y}stop(){if(this.f){const y=this.f.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.f=void 0}}}e.$3c=L,L.all=new Set,L.d=0;let I=-1;function w(S){const y=I;return I=S,{dispose(){I=y}}}e.$4c=w;class D{constructor(y,a=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=a,this.f=0}dispose(){this.d?.clear()}check(y,a){const r=this.threshold;if(r<=0||a<r)return;this.d||(this.d=new Map);const P=this.d.get(y.value)||0;if(this.d.set(y.value,P+1),this.f-=1,this.f<=0){this.f=r*.5;let N,U=0;for(const[q,B]of this.d)(!N||U<B)&&(N=q,U=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${U}):`),console.warn(N)}return()=>{const N=this.d.get(y.value)||0;this.d.set(y.value,N-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class i{constructor(y){this.value=y,this.id=p++}}const c=2,u=(S,y)=>{if(S instanceof i)y(S);else for(let a=0;a<S.length;a++){const r=S[a];r&&y(r)}};class v{constructor(y){this.u=0,this.d=y,this.f=I>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(m){const y=this.q;queueMicrotask(()=>{u(y,a=>a.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(y,a,r)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$kb.None;if(this.j)return h.$kb.None;a&&(y=y.bind(a));const P=new i(y);let N,U;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(P.stack=C.create(),N=this.f.check(P.stack,this.u+1)),m&&(P.stack=U??C.create()),this.q?this.q instanceof i?(this.t??=new E,this.q=[this.q,P]):this.q.push(P):(this.d?.onWillAddFirstListener?.(this),this.q=P,this.d?.onDidAddFirstListener?.(this)),this.u++;const q=(0,h.$ib)(()=>{N?.(),this.v(P)});return r instanceof h.$jb?r.add(q):Array.isArray(r)&&r.push(q),q},this.m}v(y){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const a=this.q,r=a.indexOf(y);if(r===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,a[r]=void 0;const P=this.t.current===this;if(this.u*c<=a.length){let N=0;for(let U=0;U<a.length;U++)a[U]?a[N++]=a[U]:P&&(this.t.end--,N<this.t.i&&this.t.i--);a.length=N}}w(y,a){if(!y)return;const r=this.d?.onListenerError||b.$X;if(!r){y.value(a);return}try{y.value(a)}catch(P){r(P)}}x(y){const a=y.current.q;for(;y.i<y.end;)this.w(a[y.i++],y.value);y.reset()}fire(y){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof i)this.w(this.q,y);else{const a=this.t;a.enqueue(this,y,this.q.length),this.x(a)}this.g?.stop()}hasListeners(){return this.u>0}}e.$5c=v;const f=()=>new E;e.$6c=f;class E{constructor(){this.i=-1,this.end=0}enqueue(y,a,r){this.i=0,this.end=r,this.current=y,this.value=a}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends v{async fireAsync(y,a,r){if(this.q)for(this.h||(this.h=new F.$jc),u(this.q,P=>this.h.push([P.value,y]));this.h.size>0&&!a.isCancellationRequested;){const[P,N]=this.h.shift(),U=[],q={...N,token:a,waitUntil:B=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");r&&(B=r(B,P)),U.push(B)}};try{P(q)}catch(B){(0,b.$X)(B);continue}Object.freeze(U),await Promise.allSettled(U).then(B=>{for(const O of B)O.status==="rejected"&&(0,b.$X)(O.reason)})}}}e.$7c=n;class o extends v{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new F.$jc,this.y=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.y(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.u&&(this.h!==0?this.s.push(y):super.fire(y))}}e.$8c=o;class s extends o{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}e.$9c=s;class t extends v{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(a=>super.fire(a)),this.h=[]}))}}e.$0c=t;class d{constructor(){this.f=!1,this.g=[],this.d=new v({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(y){const a={event:y,listener:null};this.g.push(a),this.f&&this.k(a);const r=()=>{this.f&&this.m(a);const P=this.g.indexOf(a);this.g.splice(P,1)};return(0,h.$ib)((0,A.$bb)(r))}h(){this.f=!0,this.g.forEach(y=>this.k(y))}j(){this.f=!1,this.g.forEach(y=>this.m(y))}k(y){y.listener=y.event(a=>this.d.fire(a))}m(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.d.dispose()}}e.$$c=d;class ${constructor(){this.d=[]}wrapEvent(y){return(a,r,P)=>y(N=>{const U=this.d[this.d.length-1];U?U.push(()=>a.call(r,N)):a.call(r,N)},void 0,P)}bufferEvents(y){const a=[];this.d.push(a);const r=y();return this.d.pop(),a.forEach(P=>P()),r}}e.$_c=$;class l{constructor(){this.d=!1,this.f=g.None,this.g=h.$kb.None,this.h=new v({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(y){this.f=y,this.d&&(this.g.dispose(),this.g=y(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$ad=l}),define(De[21],Ce([1,0,3]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.CancellationToken=void 0;const A=Object.freeze(function(m,k){const g=setTimeout(m.bind(k),0);return{dispose(){clearTimeout(g)}}});var h;(function(m){function k(g){return g===m.None||g===m.Cancelled||g instanceof F?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}m.isCancellationToken=k,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(h||(e.CancellationToken=h={}));class F{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new b.$5c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(k){this.a=void 0,this.b=void 0,this.b=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new F),this.a}cancel(){this.a?this.a instanceof F&&this.a.cancel():this.a=h.Cancelled}dispose(k=!1){k&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof F&&this.a.dispose():this.a=h.None}}e.$bd=R}),define(De[153],Ce([1,0,21]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=void 0;class A{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new b.$bd,k=this.b(m.token);return this.a={promise:k,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$cd=A;class h{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const k=JSON.stringify(m);return this.b!==k&&(this.b=k,this.a=this.c(m)),this.a}}e.$dd=h;class F{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const k=this.b(m);return this.a.set(m,k),k}}e.$ed=F}),define(De[93],Ce([1,0,8,4]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function h(f){const E=f;return E?typeof E.read=="function":!1}e.$tb=h;function F(f){const E=f;return E?[E.on,E.pause,E.resume,E.destroy].every(n=>typeof n=="function"):!1}e.$ub=F;function R(f){const E=f;return E?F(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$vb=R;function m(f,E){return new k(f,E)}e.$wb=m;class k{constructor(E,n){this.e=E,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(n=>n(E))}h(E){this.c.error.length===0?(0,b.$X)(E):this.c.error.slice(0).forEach(n=>n(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,n){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(E,n){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(n);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(f,E){const n=[];let o;for(;(o=f.read())!==null;)n.push(o);return E(n)}e.$xb=g;function L(f,E,n){const o=[];let s;for(;(s=f.read())!==null&&o.length<n;)o.push(s);return s===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return f.read()}}}e.$yb=L;function I(f,E){return new Promise((n,o)=>{const s=[];w(f,{onData:t=>{E&&s.push(t)},onError:t=>{E?o(t):n(void 0)},onEnd:()=>{n(E?E(s):void 0)}})})}e.$zb=I;function w(f,E){let n=!1;return f.on("error",o=>{n||E.onError(o)}),f.on("end",()=>{n||E.onEnd()}),f.on("data",o=>{n||E.onData(o)}),(0,A.$ib)(()=>n=!0)}e.$Ab=w;function D(f,E){return new Promise((n,o)=>{const s=new A.$jb,t=[],d=S=>{if(t.push(S),t.length>E)return s.dispose(),f.pause(),n({stream:f,buffer:t,ended:!1})},$=S=>o(S),l=()=>n({stream:f,buffer:t,ended:!0});s.add((0,A.$ib)(()=>f.removeListener("error",$))),f.on("error",$),s.add((0,A.$ib)(()=>f.removeListener("end",l))),f.on("end",l),s.add((0,A.$ib)(()=>f.removeListener("data",d))),f.on("data",d)})}e.$Bb=D;function C(f,E){const n=m(E);return n.end(f),n}e.$Cb=C;function p(){const f=m(()=>{throw new Error("not supported")});return f.end(),f}e.$Db=p;function i(f){let E=!1;return{read:()=>E?null:(E=!0,f)}}e.$Eb=i;function c(f,E,n){const o=m(n);return w(f,{onData:s=>o.write(E.data(s)),onError:s=>o.error(E.error?E.error(s):s),onEnd:()=>o.end()}),o}e.$Fb=c;function u(f,E,n){let o=!1;return{read:()=>{const s=E.read();return o?s:(o=!0,s!==null?n([f,s]):f)}}}e.$Gb=u;function v(f,E,n){let o=!1;const s=m(n);return w(E,{onData:t=>o?s.write(t):(o=!0,s.write(n([f,t]))),onError:t=>s.error(t),onEnd:()=>{o||(o=!0,s.write(f)),s.end()}}),s}e.$Hb=v}),define(De[22],Ce([1,0,54,93]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const h=typeof Buffer<"u",F=new b.$S(()=>new Uint8Array(256));let R,m;class k{static alloc(a){return h?new k(Buffer.allocUnsafe(a)):new k(new Uint8Array(a))}static wrap(a){return h&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new k(a)}static fromString(a,r){return!(r?.dontUseNodeBuffer||!1)&&h?new k(Buffer.from(a)):(R||(R=new TextEncoder),new k(R.encode(a)))}static fromByteArray(a){const r=k.alloc(a.length);for(let P=0,N=a.length;P<N;P++)r.buffer[P]=a[P];return r}static concat(a,r){if(typeof r>"u"){r=0;for(let U=0,q=a.length;U<q;U++)r+=a[U].byteLength}const P=k.alloc(r);let N=0;for(let U=0,q=a.length;U<q;U++){const B=a[U];P.set(B,N),N+=B.byteLength}return P}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=k.alloc(this.byteLength);return a.set(this),a}toString(){return h?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(a,r){return new k(this.buffer.subarray(a,r))}set(a,r){if(a instanceof k)this.buffer.set(a.buffer,r);else if(a instanceof Uint8Array)this.buffer.set(a,r);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),r);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),r);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return I(this.buffer,a)}writeUInt32BE(a,r){w(this.buffer,a,r)}readUInt32LE(a){return D(this.buffer,a)}writeUInt32LE(a,r){C(this.buffer,a,r)}readUInt8(a){return p(this.buffer,a)}writeUInt8(a,r){i(this.buffer,a,r)}indexOf(a){const r=a instanceof k?a.buffer:a,P=r.byteLength,N=this.buffer,U=N.byteLength;if(P===0)return 0;if(P===1)return N.indexOf(r[0]);if(P>U)return-1;const q=F.value;q.fill(r.length);for(let z=0;z<r.length;z++)q[r[z]]=r.length-z-1;let B=r.length-1,O=B,K=-1;for(;B<U;)if(N[B]===r[O]){if(O===0){K=B;break}B--,O--}else B+=Math.max(r.length-O,q[N[B]]),O=r.length-1;return K}}e.$Ib=k;function g(y,a){return y[a+0]<<0>>>0|y[a+1]<<8>>>0}e.$Jb=g;function L(y,a,r){y[r+0]=a&255,a=a>>>8,y[r+1]=a&255}e.$Kb=L;function I(y,a){return y[a]*2**24+y[a+1]*2**16+y[a+2]*2**8+y[a+3]}e.$Lb=I;function w(y,a,r){y[r+3]=a,a=a>>>8,y[r+2]=a,a=a>>>8,y[r+1]=a,a=a>>>8,y[r]=a}e.$Mb=w;function D(y,a){return y[a+0]<<0>>>0|y[a+1]<<8>>>0|y[a+2]<<16>>>0|y[a+3]<<24>>>0}e.$Nb=D;function C(y,a,r){y[r+0]=a&255,a=a>>>8,y[r+1]=a&255,a=a>>>8,y[r+2]=a&255,a=a>>>8,y[r+3]=a&255}e.$Ob=C;function p(y,a){return y[a]}e.$Pb=p;function i(y,a,r){y[r]=a}e.$Qb=i;function c(y){return A.$xb(y,a=>k.concat(a))}e.$Rb=c;function u(y){return A.$Eb(y)}e.$Sb=u;function v(y){return A.$zb(y,a=>k.concat(a))}e.$Tb=v;async function f(y){return y.ended?k.concat(y.buffer):k.concat([...y.buffer,await v(y.stream)])}e.$Ub=f;function E(y){return A.$Cb(y,a=>k.concat(a))}e.$Vb=E;function n(y){return A.$Fb(y,{data:a=>typeof a=="string"?k.fromString(a):k.wrap(a)},a=>k.concat(a))}e.$Wb=n;function o(y){return A.$wb(a=>k.concat(a),y)}e.$Xb=o;function s(y,a){return A.$Gb(y,a,r=>k.concat(r))}e.$Yb=s;function t(y,a){return A.$Hb(y,a,r=>k.concat(r))}e.$Zb=t;function d(y){let a=0,r=0,P=0;const N=new Uint8Array(Math.floor(y.length/4*3)),U=B=>{switch(r){case 3:N[P++]=a|B,r=0;break;case 2:N[P++]=a|B>>>2,a=B<<6,r=3;break;case 1:N[P++]=a|B>>>4,a=B<<4,r=2;break;default:a=B<<2,r=1}};for(let B=0;B<y.length;B++){const O=y.charCodeAt(B);if(O>=65&&O<=90)U(O-65);else if(O>=97&&O<=122)U(O-97+26);else if(O>=48&&O<=57)U(O-48+52);else if(O===43||O===45)U(62);else if(O===47||O===95)U(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${y[B]}`)}}const q=P;for(;r>0;)U(0);return k.wrap(N).slice(0,q)}e.$1b=d;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:y},a=!0,r=!1){const P=r?l:$;let N="";const U=y.byteLength%3;let q=0;for(;q<y.byteLength-U;q+=3){const B=y[q+0],O=y[q+1],K=y[q+2];N+=P[B>>>2],N+=P[(B<<4|O>>>4)&63],N+=P[(O<<2|K>>>6)&63],N+=P[K&63]}if(U===1){const B=y[q+0];N+=P[B>>>2],N+=P[B<<4&63],a&&(N+="==")}else if(U===2){const B=y[q+0],O=y[q+1];N+=P[B>>>2],N+=P[(B<<4|O>>>4)&63],N+=P[O<<2&63],a&&(N+="=")}return N}e.$2b=S}),define(De[11],Ce([1,0,153,54]),function(re,e,b,A){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.GraphemeBreakType=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=void 0;function F(de){return!de||typeof de!="string"?!0:de.trim().length===0}e.$hd=F;const R=/{(\d+)}/g;function m(de,...Me){return Me.length===0?de:de.replace(R,function(_,Q){const we=parseInt(Q,10);return isNaN(we)||we<0||we>=Me.length?_:Me[we]})}e.$id=m;const k=/{([^}]+)}/g;function g(de,Me){return de.replace(k,(_,Q)=>Me[Q]??_)}e.$jd=g;function L(de){return de.replace(/[<>&]/g,function(Me){switch(Me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Me}})}e.$kd=L;function I(de){return de.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$ld=I;function w(de,Me){let _=0;const Q=Me.charCodeAt(0);for(let we=de.length-1;we>=0;we--)de.charCodeAt(we)===Q&&_++;return _}e.$md=w;function D(de,Me,_="\u2026"){return de.length<=Me?de:`${de.substr(0,Me)}${_}`}e.$nd=D;function C(de,Me=" "){const _=p(de,Me);return i(_,Me)}e.$od=C;function p(de,Me){if(!de||!Me)return de;const _=Me.length;if(_===0||de.length===0)return de;let Q=0;for(;de.indexOf(Me,Q)===Q;)Q=Q+_;return de.substring(Q)}e.$pd=p;function i(de,Me){if(!de||!Me)return de;const _=Me.length,Q=de.length;if(_===0||Q===0)return de;let we=Q,je=-1;for(;je=de.lastIndexOf(Me,we-1),!(je===-1||je+_!==we);){if(je===0)return"";we=je}return de.substring(0,we)}e.$qd=i;function c(de){return de.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$rd=c;function u(de){return de.replace(/\*/g,"")}e.$sd=u;function v(de,Me,_={}){if(!de)throw new Error("Cannot create regex from empty string");Me||(de=I(de)),_.wholeWord&&(/\B/.test(de.charAt(0))||(de="\\b"+de),/\B/.test(de.charAt(de.length-1))||(de=de+"\\b"));let Q="";return _.global&&(Q+="g"),_.matchCase||(Q+="i"),_.multiline&&(Q+="m"),_.unicode&&(Q+="u"),new RegExp(de,Q)}e.$td=v;function f(de){return de.source==="^"||de.source==="^$"||de.source==="$"||de.source==="^\\s*$"?!1:!!(de.exec("")&&de.lastIndex===0)}e.$ud=f;function E(de){return!!de.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$vd=E;function n(de){return(de.global?"g":"")+(de.ignoreCase?"i":"")+(de.multiline?"m":"")+(de.unicode?"u":"")}e.$wd=n;function o(de){return de.split(/\r\n|\r|\n/)}e.$xd=o;function s(de){for(let Me=0,_=de.length;Me<_;Me++){const Q=de.charCodeAt(Me);if(Q!==32&&Q!==9)return Me}return-1}e.$yd=s;function t(de,Me=0,_=de.length){for(let Q=Me;Q<_;Q++){const we=de.charCodeAt(Q);if(we!==32&&we!==9)return de.substring(Me,Q)}return de.substring(Me,_)}e.$zd=t;function d(de,Me=de.length-1){for(let _=Me;_>=0;_--){const Q=de.charCodeAt(_);if(Q!==32&&Q!==9)return _}return-1}e.$Ad=d;function $(de,Me,_){const Q=[];let we=0;for(const je of de.matchAll(Me)){if(Q.push(de.slice(we,je.index)),je.index===void 0)throw new Error("match.index should be defined");we=je.index+je[0].length,Q.push(_(je[0],...je.slice(1),je.index,de,je.groups))}return Q.push(de.slice(we)),Promise.all(Q).then(je=>je.join(""))}e.$Bd=$;function l(de,Me){return de<Me?-1:de>Me?1:0}e.$Cd=l;function S(de,Me,_=0,Q=de.length,we=0,je=Me.length){for(;_<Q&&we<je;_++,we++){const et=de.charCodeAt(_),nt=Me.charCodeAt(we);if(et<nt)return-1;if(et>nt)return 1}const Oe=Q-_,Xe=je-we;return Oe<Xe?-1:Oe>Xe?1:0}e.$Dd=S;function y(de,Me){return a(de,Me,0,de.length,0,Me.length)}e.$Ed=y;function a(de,Me,_=0,Q=de.length,we=0,je=Me.length){for(;_<Q&&we<je;_++,we++){let et=de.charCodeAt(_),nt=Me.charCodeAt(we);if(et===nt)continue;if(et>=128||nt>=128)return S(de.toLowerCase(),Me.toLowerCase(),_,Q,we,je);P(et)&&(et-=32),P(nt)&&(nt-=32);const ft=et-nt;if(ft!==0)return ft}const Oe=Q-_,Xe=je-we;return Oe<Xe?-1:Oe>Xe?1:0}e.$Fd=a;function r(de){return de>=48&&de<=57}e.$Gd=r;function P(de){return de>=97&&de<=122}e.$Hd=P;function N(de){return de>=65&&de<=90}e.$Id=N;function U(de,Me){return de.length===Me.length&&a(de,Me)===0}e.$Jd=U;function q(de,Me){const _=Me.length;return Me.length>de.length?!1:a(de,Me,0,_)===0}e.$Kd=q;function B(de,Me){const _=Math.min(de.length,Me.length);let Q;for(Q=0;Q<_;Q++)if(de.charCodeAt(Q)!==Me.charCodeAt(Q))return Q;return _}e.$Ld=B;function O(de,Me){const _=Math.min(de.length,Me.length);let Q;const we=de.length-1,je=Me.length-1;for(Q=0;Q<_;Q++)if(de.charCodeAt(we-Q)!==Me.charCodeAt(je-Q))return Q;return _}e.$Md=O;function K(de){return 55296<=de&&de<=56319}e.$Nd=K;function z(de){return 56320<=de&&de<=57343}e.$Od=z;function j(de,Me){return(de-55296<<10)+(Me-56320)+65536}e.$Pd=j;function he(de,Me,_){const Q=de.charCodeAt(_);if(K(Q)&&_+1<Me){const we=de.charCodeAt(_+1);if(z(we))return j(Q,we)}return Q}e.$Qd=he;function ie(de,Me){const _=de.charCodeAt(Me-1);if(z(_)&&Me>1){const Q=de.charCodeAt(Me-2);if(K(Q))return j(Q,_)}return _}class ne{get offset(){return this.e}constructor(Me,_=0){this.c=Me,this.d=Me.length,this.e=_}setOffset(Me){this.e=Me}prevCodePoint(){const Me=ie(this.c,this.e);return this.e-=Me>=65536?2:1,Me}nextCodePoint(){const Me=he(this.c,this.d,this.e);return this.e+=Me>=65536?2:1,Me}eol(){return this.e>=this.d}}e.$Rd=ne;class V{get offset(){return this.c.offset}constructor(Me,_=0){this.c=new ne(Me,_)}nextGraphemeLength(){const Me=Ve.getInstance(),_=this.c,Q=_.offset;let we=Me.getGraphemeBreakType(_.nextCodePoint());for(;!_.eol();){const je=_.offset,Oe=Me.getGraphemeBreakType(_.nextCodePoint());if(Pe(we,Oe)){_.setOffset(je);break}we=Oe}return _.offset-Q}prevGraphemeLength(){const Me=Ve.getInstance(),_=this.c,Q=_.offset;let we=Me.getGraphemeBreakType(_.prevCodePoint());for(;_.offset>0;){const je=_.offset,Oe=Me.getGraphemeBreakType(_.prevCodePoint());if(Pe(Oe,we)){_.setOffset(je);break}we=Oe}return Q-_.offset}eol(){return this.c.eol()}}e.$Sd=V;function H(de,Me){return new V(de,Me).nextGraphemeLength()}e.$Td=H;function ce(de,Me){return new V(de,Me).prevGraphemeLength()}e.$Ud=ce;function pe(de,Me){Me>0&&z(de.charCodeAt(Me))&&Me--;const _=Me+H(de,Me);return[_-ce(de,_),_]}e.$Vd=pe;function ye(de){const Me=new V(de);let _=0;for(;!Me.eol();)_++,Me.nextGraphemeLength();return _}e.$Wd=ye;let ge;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(de){return ge||(ge=M()),ge.test(de)}e.$Xd=Y;const ve=/^[\t\n\r\x20-\x7E]*$/;function Se(de){return ve.test(de)}e.$Yd=Se,e.$Zd=/[\u2028\u2029]/;function ee(de){return e.$Zd.test(de)}e.$1d=ee;function te(de){return de>=11904&&de<=55215||de>=63744&&de<=64255||de>=65281&&de<=65374}e.$2d=te;function le(de){return de>=127462&&de<=127487||de===8986||de===8987||de===9200||de===9203||de>=9728&&de<=10175||de===11088||de===11093||de>=127744&&de<=128591||de>=128640&&de<=128764||de>=128992&&de<=129008||de>=129280&&de<=129535||de>=129648&&de<=129782}e.$3d=le;function X(de,Me){if(de.length<Me)return de;const _=/\b/g;let Q=0;for(;_.test(de)&&!(de.length-_.lastIndex<Me);)Q=_.lastIndex,_.lastIndex+=1;return de.substring(Q).replace(/^\s/,"")}e.$4d=X;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function oe(de){return de&&(de=de.replace(ue,"").replace(se,"")),de}e.$5d=oe,e.$6d=String.fromCharCode(65279);function T(de){return!!(de&&de.length>0&&de.charCodeAt(0)===65279)}e.$7d=T;function J(de){return T(de)?de.substr(1):de}e.$8d=J;function Z(de,Me){if(!de||!Me||de.length<Me.length)return!1;const _=Me.length,Q=de.toLowerCase();let we=0,je=-1;for(;we<_;){const Oe=Q.indexOf(Me[we],je+1);if(Oe<0)return!1;je=Oe,we++}return!0}e.$9d=Z;function x(de,Me=!1){return de?(Me&&(de=de.replace(/\\./g,"")),de.toLowerCase()!==de):!1}e.$0d=x;function me(de){return de.charAt(0).toUpperCase()+de.slice(1)}e.$$d=me;function Ee(de,Me=1){if(Me===0)return"";let _=-1;do _=de.indexOf(`
`,_+1),Me--;while(Me>0&&_>=0);return _===-1?de:(de[_-1]==="\r"&&_--,de.substr(0,_))}e.$_d=Ee;function fe(de){return de=de%(2*26),de<26?String.fromCharCode(97+de):String.fromCharCode(65+de-26)}e.$ae=fe;function Ie(de){return Ve.getInstance().getGraphemeBreakType(de)}e.$be=Ie;function Pe(de,Me){return de===0?Me!==5&&Me!==7:de===2&&Me===3?!1:de===4||de===2||de===3||Me===4||Me===2||Me===3?!0:!(de===8&&(Me===8||Me===9||Me===11||Me===12)||(de===11||de===9)&&(Me===9||Me===10)||(de===12||de===10)&&Me===10||Me===5||Me===13||Me===7||de===1||de===13&&Me===14||de===6&&Me===6)}var qe;(function(de){de[de.Other=0]="Other",de[de.Prepend=1]="Prepend",de[de.CR=2]="CR",de[de.LF=3]="LF",de[de.Control=4]="Control",de[de.Extend=5]="Extend",de[de.Regional_Indicator=6]="Regional_Indicator",de[de.SpacingMark=7]="SpacingMark",de[de.L=8]="L",de[de.V=9]="V",de[de.T=10]="T",de[de.LV=11]="LV",de[de.LVT=12]="LVT",de[de.ZWJ=13]="ZWJ",de[de.Extended_Pictographic=14]="Extended_Pictographic"})(qe||(e.GraphemeBreakType=qe={}));class Ve{static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=tt()}getGraphemeBreakType(Me){if(Me<32)return Me===10?3:Me===13?2:4;if(Me<127)return 0;const _=this.d,Q=_.length/3;let we=1;for(;we<=Q;)if(Me<_[3*we])we=2*we;else if(Me>_[3*we+1])we=2*we+1;else return _[3*we+2];return 0}}Ve.c=null;function tt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(de,Me){if(de===0)return 0;const _=Ye(de,Me);if(_!==void 0)return _;const Q=new ne(Me,de);return Q.prevCodePoint(),Q.offset}e.$ce=Ge;function Ye(de,Me){const _=new ne(Me,de);let Q=_.prevCodePoint();for(;st(Q)||Q===65039||Q===8419;){if(_.offset===0)return;Q=_.prevCodePoint()}if(!le(Q))return;let we=_.offset;return we>0&&_.prevCodePoint()===8205&&(we=_.offset),we}function st(de){return 127995<=de&&de<=127999}var at;(function(de){de[de.zwj=8205]="zwj",de[de.emojiVariantSelector=65039]="emojiVariantSelector",de[de.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$de="\xA0";class xe{static getInstance(Me){return xe.d.get(Array.from(Me))}static getLocales(){return xe.e.value}constructor(Me){this.f=Me}isAmbiguous(Me){return this.f.has(Me)}getPrimaryConfusable(Me){return this.f.get(Me)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ee=xe,h=xe,xe.c=new A.$S(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),xe.d=new b.$dd(de=>{function Me(nt){const ft=new Map;for(let vt=0;vt<nt.length;vt+=2)ft.set(nt[vt],nt[vt+1]);return ft}function _(nt,ft){const vt=new Map(nt);for(const[Nt,Tt]of ft)vt.set(Nt,Tt);return vt}function Q(nt,ft){if(!nt)return ft;const vt=new Map;for(const[Nt,Tt]of nt)ft.has(Nt)&&vt.set(Nt,Tt);return vt}const we=h.c.value;let je=de.filter(nt=>!nt.startsWith("_")&&nt in we);je.length===0&&(je=["_default"]);let Oe;for(const nt of je){const ft=Me(we[nt]);Oe=Q(Oe,ft)}const Xe=Me(we._common),et=_(Xe,Oe);return new xe(et)}),xe.e=new A.$S(()=>Object.keys(xe.c.value).filter(de=>!de.startsWith("_")));class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Me){return rt.e().has(Me)}static get codePoints(){return rt.e()}}e.$fe=rt,rt.d=void 0}),define(De[115],Ce([1,0,28,11]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.FuzzyScore=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.or=void 0;function h(...se){return function(oe,T){for(let J=0,Z=se.length;J<Z;J++){const x=se[J](oe,T);if(x)return x}return null}}e.or=h,e.$gj=F.bind(void 0,!1),e.$hj=F.bind(void 0,!0);function F(se,oe,T){if(!T||T.length<oe.length)return null;let J;return se?J=A.$Kd(T,oe):J=T.indexOf(oe)===0,J?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(se,oe){const T=oe.toLowerCase().indexOf(se.toLowerCase());return T===-1?null:[{start:T,end:T+se.length}]}e.$ij=R;function m(se,oe){return k(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$jj=m;function k(se,oe,T,J){if(T===se.length)return[];if(J===oe.length)return null;if(se[T]===oe[J]){let Z=null;return(Z=k(se,oe,T+1,J+1))?c({start:J,end:J+1},Z):null}return k(se,oe,T,J+1)}function g(se){return 97<=se&&se<=122}function L(se){return 65<=se&&se<=90}e.$kj=L;function I(se){return 48<=se&&se<=57}function w(se){return se===32||se===9||se===10||se===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>D.add(se.charCodeAt(0)));function C(se){return w(se)||D.has(se)}function p(se,oe){return se===oe||C(se)&&C(oe)}function i(se){return g(se)||L(se)||I(se)}function c(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function u(se,oe){for(let T=oe;T<se.length;T++){const J=se.charCodeAt(T);if(L(J)||I(J)||T>0&&!i(se.charCodeAt(T-1)))return T}return se.length}function v(se,oe,T,J){if(T===se.length)return[];if(J===oe.length)return null;if(se[T]!==oe[J].toLowerCase())return null;{let Z=null,x=J+1;for(Z=v(se,oe,T+1,J+1);!Z&&(x=u(oe,x))<oe.length;)Z=v(se,oe,T+1,x),x++;return Z===null?null:c({start:J,end:J+1},Z)}}function f(se){let oe=0,T=0,J=0,Z=0,x=0;for(let Pe=0;Pe<se.length;Pe++)x=se.charCodeAt(Pe),L(x)&&oe++,g(x)&&T++,i(x)&&J++,I(x)&&Z++;const me=oe/se.length,Ee=T/se.length,fe=J/se.length,Ie=Z/se.length;return{upperPercent:me,lowerPercent:Ee,alphaPercent:fe,numericPercent:Ie}}function E(se){const{upperPercent:oe,lowerPercent:T}=se;return T===0&&oe>.6}function n(se){const{upperPercent:oe,lowerPercent:T,alphaPercent:J,numericPercent:Z}=se;return T>.2&&oe<.8&&J>.6&&Z<.2}function o(se){let oe=0,T=0,J=0,Z=0;for(let x=0;x<se.length;x++)J=se.charCodeAt(x),L(J)&&oe++,g(J)&&T++,w(J)&&Z++;return(oe===0||T===0)&&Z===0?se.length<=30:oe<=5}function s(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!o(se)||oe.length>60)return null;const T=f(oe);if(!n(T)){if(!E(T))return null;oe=oe.toLowerCase()}let J=null,Z=0;for(se=se.toLowerCase();Z<oe.length&&(J=v(se,oe,0,Z))===null;)Z=u(oe,Z+1);return J}e.$lj=s;function t(se,oe,T=!1){if(!oe||oe.length===0)return null;let J=null,Z=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();Z<oe.length&&(J=d(se,oe,0,Z,T))===null;)Z=$(oe,Z+1);return J}e.$mj=t;function d(se,oe,T,J,Z){if(T===se.length)return[];if(J===oe.length)return null;if(p(se.charCodeAt(T),oe.charCodeAt(J))){let x=null,me=J+1;if(x=d(se,oe,T+1,J+1,Z),!Z)for(;!x&&(me=$(oe,me))<oe.length;)x=d(se,oe,T+1,me,Z),me++;return x?se.charCodeAt(T)!==oe.charCodeAt(J)?x:c({start:J,end:J+1},x):null}else return null}function $(se,oe){for(let T=oe;T<se.length;T++)if(C(se.charCodeAt(T))||T>0&&C(se.charCodeAt(T-1)))return T;return se.length}const l=h(e.$hj,s,R),S=h(e.$hj,s,m),y=new b.$mi(1e4);function a(se,oe,T=!1){if(typeof se!="string"||typeof oe!="string")return null;let J=y.get(se);J||(J=new RegExp(A.$rd(se),"i"),y.set(se,J));const Z=J.exec(oe);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:T?S(se,oe):l(se,oe)}e.$nj=a;function r(se,oe){const T=ve(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?N(T):null}e.$oj=r;function P(se,oe,T,J,Z,x){const me=Math.min(13,se.length);for(;T<me;T++){const Ee=ve(se,oe,T,J,Z,x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,x]}e.$pj=P;function N(se){if(typeof se>"u")return[];const oe=[],T=se[1];for(let J=se.length-1;J>1;J--){const Z=se[J]+T,x=oe[oe.length-1];x&&x.end===Z?x.end=Z+1:oe.push({start:Z,end:Z+1})}return oe}e.$qj=N;const U=128;function q(){const se=[],oe=[];for(let T=0;T<=U;T++)oe[T]=0;for(let T=0;T<=U;T++)se.push(oe.slice(0));return se}function B(se){const oe=[];for(let T=0;T<=se;T++)oe[T]=0;return oe}const O=B(2*U),K=B(2*U),z=q(),j=q(),he=q(),ie=!1;function ne(se,oe,T,J,Z){function x(Ee,fe,Ie=" "){for(;Ee.length<fe;)Ee=Ie+Ee;return Ee}let me=` |   |${J.split("").map(Ee=>x(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=T;Ee++)Ee===0?me+=" |":me+=`${oe[Ee-1]}|`,me+=se[Ee].slice(0,Z+1).map(fe=>x(fe.toString(),3)).join("|")+`
`;return me}function V(se,oe,T,J){se=se.substr(oe),T=T.substr(J),console.log(ne(j,se,se.length,T,T.length)),console.log(ne(he,se,se.length,T,T.length)),console.log(ne(z,se,se.length,T,T.length))}function H(se,oe){if(oe<0||oe>=se.length)return!1;const T=se.codePointAt(oe);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$3d(T)}}function ce(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function pe(se,oe,T){return oe[se]!==T[se]}function ye(se,oe,T,J,Z,x,me=!1){for(;oe<T&&Z<x;)se[oe]===J[Z]&&(me&&(O[oe]=Z),oe+=1),Z+=1;return oe===T}e.$rj=ye;var ge;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var M;(function(se){se.Default=[-100,0];function oe(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}se.isDefault=oe})(M||(e.FuzzyScore=M={}));class Y{constructor(oe,T){this.firstMatchCanBeWeak=oe,this.boostFullMatch=T}}e.$sj=Y,Y.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ve(se,oe,T,J,Z,x,me=Y.default){const Ee=se.length>U?U:se.length,fe=J.length>U?U:J.length;if(T>=Ee||x>=fe||Ee-T>fe-x||!ye(oe,T,Ee,Z,x,fe,!0))return;Se(Ee,fe,T,x,oe,Z);let Ie=1,Pe=1,qe=T,Ve=x;const tt=[!1];for(Ie=1,qe=T;qe<Ee;Ie++,qe++){const xe=O[qe],rt=K[qe],de=qe+1<Ee?K[qe+1]:fe;for(Pe=xe-x+1,Ve=xe;Ve<de;Pe++,Ve++){let Me=Number.MIN_SAFE_INTEGER,_=!1;Ve<=rt&&(Me=ee(se,oe,qe,T,J,Z,Ve,fe,x,z[Ie-1][Pe-1]===0,tt));let Q=0;Me!==Number.MAX_SAFE_INTEGER&&(_=!0,Q=Me+j[Ie-1][Pe-1]);const we=Ve>xe,je=we?j[Ie][Pe-1]+(z[Ie][Pe-1]>0?-5:0):0,Oe=Ve>xe+1&&z[Ie][Pe-1]>0,Xe=Oe?j[Ie][Pe-2]+(z[Ie][Pe-2]>0?-5:0):0;if(Oe&&(!we||Xe>=je)&&(!_||Xe>=Q))j[Ie][Pe]=Xe,he[Ie][Pe]=3,z[Ie][Pe]=0;else if(we&&(!_||je>=Q))j[Ie][Pe]=je,he[Ie][Pe]=2,z[Ie][Pe]=0;else if(_)j[Ie][Pe]=Q,he[Ie][Pe]=1,z[Ie][Pe]=z[Ie-1][Pe-1]+1;else throw new Error("not possible")}}if(ie&&V(se,T,J,x),!tt[0]&&!me.firstMatchCanBeWeak)return;Ie--,Pe--;const Ge=[j[Ie][Pe],x];let Ye=0,st=0;for(;Ie>=1;){let xe=Pe;do{const rt=he[Ie][xe];if(rt===3)xe=xe-2;else if(rt===2)xe=xe-1;else break}while(xe>=1);Ye>1&&oe[T+Ie-1]===Z[x+Pe-1]&&!pe(xe+x-1,J,Z)&&Ye+1>z[Ie][xe]&&(xe=Pe),xe===Pe?Ye++:Ye=1,st||(st=xe),Ie--,Pe=xe-1,Ge.push(Pe)}fe===Ee&&me.boostFullMatch&&(Ge[0]+=2);const at=st-Ee;return Ge[0]-=at,Ge}e.$tj=ve;function Se(se,oe,T,J,Z,x){let me=se-1,Ee=oe-1;for(;me>=T&&Ee>=J;)Z[me]===x[Ee]&&(K[me]=Ee,me--),Ee--}function ee(se,oe,T,J,Z,x,me,Ee,fe,Ie,Pe){if(oe[T]!==x[me])return Number.MIN_SAFE_INTEGER;let qe=1,Ve=!1;return me===T-J?qe=se[T]===Z[me]?7:5:pe(me,Z,x)&&(me===0||!pe(me-1,Z,x))?(qe=se[T]===Z[me]?7:5,Ve=!0):H(x,me)&&(me===0||!H(x,me-1))?qe=5:(H(x,me-1)||ce(x,me-1))&&(qe=5,Ve=!0),qe>1&&T===J&&(Pe[0]=!0),Ve||(Ve=pe(me,Z,x)||H(x,me-1)||ce(x,me-1)),T===J?me>fe&&(qe-=Ve?3:5):Ie?qe+=Ve?2:0:qe+=Ve?0:1,me+1===Ee&&(qe-=Ve?3:5),qe}function te(se,oe,T,J,Z,x,me){return X(se,oe,T,J,Z,x,!0,me)}e.$uj=te;function le(se,oe,T,J,Z,x,me){return X(se,oe,T,J,Z,x,!1,me)}e.$vj=le;function X(se,oe,T,J,Z,x,me,Ee){let fe=ve(se,oe,T,J,Z,x,Ee);if(fe&&!me)return fe;if(se.length>=3){const Ie=Math.min(7,se.length-1);for(let Pe=T+1;Pe<Ie;Pe++){const qe=ue(se,Pe);if(qe){const Ve=ve(qe,qe.toLowerCase(),T,J,Z,x,Ee);Ve&&(Ve[0]-=3,(!fe||Ve[0]>fe[0])&&(fe=Ve))}}}return fe}function ue(se,oe){if(oe+1>=se.length)return;const T=se[oe],J=se[oe+1];if(T!==J)return se.slice(0,oe)+J+T+se.slice(oe+2)}}),define(De[70],Ce([1,0,11]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0;function A(c){return h(c,0)}e.$_h=A;function h(c,u){switch(typeof c){case"object":return c===null?F(349,u):Array.isArray(c)?k(c,u):g(c,u);case"string":return m(c,u);case"boolean":return R(c,u);case"number":return F(c,u);case"undefined":return F(937,u);default:return F(617,u)}}e.$ai=h;function F(c,u){return(u<<5)-u+c|0}e.$bi=F;function R(c,u){return F(c?433:863,u)}function m(c,u){u=F(149417,u);for(let v=0,f=c.length;v<f;v++)u=F(c.charCodeAt(v),u);return u}e.$ci=m;function k(c,u){return u=F(104579,u),c.reduce((v,f)=>h(f,v),u)}function g(c,u){return u=F(181387,u),Object.keys(c).sort().reduce((v,f)=>(v=m(f,v),h(c[f],v)),u)}class L{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=h(u,this.g),this.g}}e.$di=L;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(c,u,v=32){const f=v-u,E=~((1<<f)-1);return(c<<u|(E&c)>>>f)>>>0}function D(c,u=0,v=c.byteLength,f=0){for(let E=0;E<v;E++)c[u+E]=f}function C(c,u,v="0"){for(;c.length<u;)c=v+c;return c}function p(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(v=>v.toString(16).padStart(2,"0")).join(""):C((c>>>0).toString(16),u/4)}e.$ei=p;class i{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const v=u.length;if(v===0)return;const f=this.p;let E=this.r,n=this.u,o,s;for(n!==0?(o=n,s=-1,n=0):(o=u.charCodeAt(0),s=0);;){let t=o;if(b.$Nd(o))if(s+1<v){const d=u.charCodeAt(s+1);b.$Od(d)?(s++,t=b.$Pd(o,d)):t=65533}else{n=o;break}else b.$Od(o)&&(t=65533);if(E=this.w(f,E,t),s++,s<v)o=u.charCodeAt(s);else break}this.r=E,this.u=n}w(u,v,f){return f<128?u[v++]=f:f<2048?(u[v++]=192|(f&1984)>>>6,u[v++]=128|(f&63)>>>0):f<65536?(u[v++]=224|(f&61440)>>>12,u[v++]=128|(f&4032)>>>6,u[v++]=128|(f&63)>>>0):(u[v++]=240|(f&1835008)>>>18,u[v++]=128|(f&258048)>>>12,u[v++]=128|(f&4032)>>>6,u[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=i.g,v=this.q;for(let l=0;l<64;l+=4)u.setUint32(l,v.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)u.setUint32(l,w(u.getUint32(l-12,!1)^u.getUint32(l-32,!1)^u.getUint32(l-56,!1)^u.getUint32(l-64,!1),1),!1);let f=this.h,E=this.l,n=this.m,o=this.n,s=this.o,t,d,$;for(let l=0;l<80;l++)l<20?(t=E&n|~E&o,d=1518500249):l<40?(t=E^n^o,d=1859775393):l<60?(t=E&n|E&o|n&o,d=2400959708):(t=E^n^o,d=3395469782),$=w(f,5)+t+s+d+u.getUint32(l*4,!1)&4294967295,s=o,o=n,n=w(E,30),E=f,f=$;this.h=this.h+f&4294967295,this.l=this.l+E&4294967295,this.m=this.m+n&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$fi=i,i.g=new DataView(new ArrayBuffer(320))}),define(De[116],Ce([1,0,114,115,70,10,9,11]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=void 0;const k=0,g=[k,[]];function L(z,j,he,ie){if(!z||!j)return g;const ne=z.length,V=j.length;if(ne<V)return g;const H=z.toLowerCase();return I(j,he,V,z,H,ne,ie)}e.$9p=L;function I(z,j,he,ie,ne,V,H){const ce=[],pe=[];for(let Y=0;Y<he;Y++){const ve=Y*V,Se=ve-V,ee=Y>0,te=z[Y],le=j[Y];for(let X=0;X<V;X++){const ue=X>0,se=ve+X,oe=se-1,T=Se+X-1,J=ue?ce[oe]:0,Z=ee&&ue?ce[T]:0,x=ee&&ue?pe[T]:0;let me;!Z&&ee?me=0:me=w(te,le,ie,ne,X,x),me&&Z+me>=J&&(H||ee||ne.startsWith(j,X))?(pe[se]=x+1,ce[se]=Z+me):(pe[se]=k,ce[se]=J)}}const ye=[];let ge=he-1,M=V-1;for(;ge>=0&&M>=0;){const Y=ge*V+M;pe[Y]===k||(ye.push(M),ge--),M--}return[ce[he*V-1],ye.reverse()]}function w(z,j,he,ie,ne,V){let H=0;if(!D(j,ie[ne]))return H;if(H+=1,V>0&&(H+=V*5),z===he[ne]&&(H+=1),ne===0)H+=8;else{const ce=C(he.charCodeAt(ne-1));ce?H+=ce:(0,A.$kj)(he.charCodeAt(ne))&&V===0&&(H+=2)}return H}function D(z,j){return z===j?!0:z==="/"||z==="\\"?j==="/"||j==="\\":!1}function C(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function i(z,j,he=0,ie=0){const ne=j;return ne.values&&ne.values.length>1?c(z,ne.values,he,ie):u(z,j,he,ie)}e.$0p=i;function c(z,j,he,ie){let ne=0;const V=[];for(const H of j){const[ce,pe]=u(z,H,he,ie);if(typeof ce!="number")return p;ne+=ce,V.push(...pe)}return[ne,S(V)]}function u(z,j,he,ie){const ne=(0,A.$tj)(j.original,j.originalLowercase,he,z,z.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ne?[ne[0],(0,A.$qj)(ne)]:p}const v=Object.freeze({score:0}),f=1<<18,E=1<<17,n=1<<16;function o(z,j,he,ie){const ne=ie.values?ie.values:[ie];return(0,h.$_h)({[ie.normalized]:{values:ne.map(H=>({value:H.normalized,expectContiguousMatch:H.expectContiguousMatch})),label:z,description:j,allowNonContiguousMatches:he}})}function s(z,j,he,ie,ne){if(!z||!j.normalized)return v;const V=ie.getItemLabel(z);if(!V)return v;const H=ie.getItemDescription(z),ce=o(V,H,he,j),pe=ne[ce];if(pe)return pe;const ye=t(V,H,ie.getItemPath(z),j,he);return ne[ce]=ye,ye}e.$$p=s;function t(z,j,he,ie,ne){const V=!he||!ie.containsPathSeparator;return he&&(R.$f?ie.pathNormalized===he:(0,m.$Jd)(ie.pathNormalized,he))?{score:f,labelMatch:[{start:0,end:z.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:ie.values&&ie.values.length>1?d(z,j,he,ie.values,V,ne):$(z,j,he,ie,V,ne)}function d(z,j,he,ie,ne,V){let H=0;const ce=[],pe=[];for(const ye of ie){const{score:ge,labelMatch:M,descriptionMatch:Y}=$(z,j,he,ye,ne,V);if(ge===k)return v;H+=ge,M&&ce.push(...M),Y&&pe.push(...Y)}return{score:H,labelMatch:S(ce),descriptionMatch:S(pe)}}function $(z,j,he,ie,ne,V){if(ne||!j){const[H,ce]=L(z,ie.normalized,ie.normalizedLowercase,V&&!ie.expectContiguousMatch);if(H){const pe=(0,A.$hj)(ie.normalized,z);let ye;if(pe){ye=E;const ge=Math.round(ie.normalized.length/z.length*100);ye+=ge}else ye=n;return{score:ye+H,labelMatch:pe||l(ce)}}}if(j){let H=j;he&&(H=`${j}${F.sep}`);const ce=H.length,pe=`${H}${z}`,[ye,ge]=L(pe,ie.normalized,ie.normalizedLowercase,V&&!ie.expectContiguousMatch);if(ye){const M=l(ge),Y=[],ve=[];return M.forEach(Se=>{Se.start<ce&&Se.end>ce?(Y.push({start:0,end:Se.end-ce}),ve.push({start:Se.start,end:ce})):Se.start>=ce?Y.push({start:Se.start-ce,end:Se.end-ce}):ve.push(Se)}),{score:ye,labelMatch:Y,descriptionMatch:ve}}}return v}function l(z){const j=[];if(!z)return j;let he;for(const ie of z)he&&he.end===ie?he.end+=1:(he={start:ie,end:ie+1},j.push(he));return j}function S(z){const j=z.sort((ne,V)=>ne.start-V.start),he=[];let ie;for(const ne of j)!ie||!y(ie,ne)?(ie=ne,he.push(ne)):(ie.start=Math.min(ie.start,ne.start),ie.end=Math.max(ie.end,ne.end));return he}function y(z,j){return!(z.end<j.start||j.end<z.start)}function a(z,j,he,ie,ne,V){const H=s(z,he,ie,ne,V),ce=s(j,he,ie,ne,V),pe=H.score,ye=ce.score;if((pe===f||ye===f)&&pe!==ye)return pe===f?-1:1;if(pe>n||ye>n){if(pe!==ye)return pe>ye?-1:1;if(pe<E&&ye<E){const te=P(H.labelMatch,ce.labelMatch);if(te!==0)return te}const Se=ne.getItemLabel(z)||"",ee=ne.getItemLabel(j)||"";if(Se.length!==ee.length)return Se.length-ee.length}if(pe!==ye)return pe>ye?-1:1;const ge=Array.isArray(H.labelMatch)&&H.labelMatch.length>0,M=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(ge&&!M)return-1;if(M&&!ge)return 1;const Y=r(z,H,ne),ve=r(j,ce,ne);return Y&&ve&&Y!==ve?ve>Y?-1:1:N(z,j,he,ne)}e.$_p=a;function r(z,j,he){let ie=-1,ne=-1;if(j.descriptionMatch&&j.descriptionMatch.length?ie=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(ie=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(ne=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const V=he.getItemDescription(z);V&&(ne+=V.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(ne=j.descriptionMatch[j.descriptionMatch.length-1].end);return ne-ie}function P(z,j){if(!z&&!j||(!z||!z.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!z||!z.length)return 1;const he=z[0].start,ne=z[z.length-1].end-he,V=j[0].start,ce=j[j.length-1].end-V;return ne===ce?0:ce<ne?1:-1}function N(z,j,he,ie){const ne=ie.getItemLabel(z)||"",V=ie.getItemLabel(j)||"",H=ie.getItemDescription(z),ce=ie.getItemDescription(j),pe=ne.length+(H?H.length:0),ye=V.length+(ce?ce.length:0);if(pe!==ye)return pe-ye;const ge=ie.getItemPath(z),M=ie.getItemPath(j);return ge&&M&&ge.length!==M.length?ge.length-M.length:ne!==V?(0,b.$7p)(ne,V,he.normalized):H&&ce&&H!==ce?(0,b.$7p)(H,ce,he.normalized):ge&&M&&ge!==M?(0,b.$7p)(ge,M,he.normalized):0}function U(z){return z.startsWith('"')&&z.endsWith('"')}const q=" ";function B(z){typeof z!="string"&&(z="");const j=z.toLowerCase(),{pathNormalized:he,normalized:ie,normalizedLowercase:ne}=O(z),V=he.indexOf(F.sep)>=0,H=U(z);let ce;const pe=z.split(q);if(pe.length>1)for(const ye of pe){const ge=U(ye),{pathNormalized:M,normalized:Y,normalizedLowercase:ve}=O(ye);Y&&(ce||(ce=[]),ce.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:M,normalized:Y,normalizedLowercase:ve,expectContiguousMatch:ge}))}return{original:z,originalLowercase:j,pathNormalized:he,normalized:ie,normalizedLowercase:ne,values:ce,containsPathSeparator:V,expectContiguousMatch:H}}e.$aq=B;function O(z){let j;R.$d?j=z.replace(/\//g,F.sep):j=z.replace(/\\/g,F.sep);const he=(0,m.$sd)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:he,normalizedLowercase:he.toLowerCase()}}function K(z){return Array.isArray(z)?B(z.map(j=>j.original).join(q)):B(z.original)}e.$bq=K}),define(De[41],Ce([1,0,11]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(A||(A={})),function(h){const F="error",R="warning",m="warn",k="info",g="ignore";function L(w){return w?b.$Jd(F,w)?h.Error:b.$Jd(R,w)||b.$Jd(m,w)?h.Warning:b.$Jd(k,w)?h.Info:h.Ignore:h.Ignore}h.fromValue=L;function I(w){switch(w){case h.Error:return F;case h.Warning:return R;case h.Info:return k;default:return g}}h.toString=I}(A||(A={})),e.default=A}),define(De[154],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(De[71],Ce([1,0,19,11]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;class h{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const C=D.charCodeAt(0),p=this.b.charCodeAt(this.c);return C-p}value(){return this.b[this.c]}}e.$nh=h;class F{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,A.$Dd)(D,this.b,0,D.length,this.c,this.d):(0,A.$Fd)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$oh=F;class R{constructor(D=!0,C=!0){this.f=D,this.g=C}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let C=D.length-1;C>=0;C--,this.c--){const p=this.b.charCodeAt(C);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,A.$Dd)(D,this.b,0,D.length,this.d,this.e):(0,A.$Fd)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ph=R;var m;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(m||(m={}));class k{constructor(D,C){this.f=D,this.g=C,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,A.$Ed)(D,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Ed)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,A.$Cd)(D,this.c.query);if(this.d[this.e]===5)return(0,A.$Cd)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$qh=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(L||(L={}));class I{static forUris(D=()=>!1,C=()=>!1){return new I(new k(D,C))}static forPaths(D=!1){return new I(new R(void 0,!D))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new F)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,C){if(C){const p=C.slice(0);(0,b.$Bf)(p);for(const i of p)this.set(i,D)}else{const p=D.slice(0);(0,b.$Bf)(p);for(const i of p)this.set(i[0],i[1])}}set(D,C){const p=this.b.reset(D);let i;this.c||(this.c=new g,this.c.segment=p.value());const c=[];for(i=this.c;;){const v=p.cmp(i.segment);if(v>0)i.left||(i.left=new g,i.left.segment=p.value()),c.push([-1,i]),i=i.left;else if(v<0)i.right||(i.right=new g,i.right.segment=p.value()),c.push([1,i]),i=i.right;else if(p.hasNext())p.next(),i.mid||(i.mid=new g,i.mid.segment=p.value()),c.push([0,i]),i=i.mid;else break}const u=i.value;i.value=C,i.key=D;for(let v=c.length-1;v>=0;v--){const f=c[v][1];f.updateHeight();const E=f.balanceFactor();if(E<-1||E>1){const n=c[v][0],o=c[v+1][0];if(n===1&&o===1)c[v][1]=f.rotateLeft();else if(n===-1&&o===-1)c[v][1]=f.rotateRight();else if(n===1&&o===-1)f.right=c[v+1][1]=c[v+1][1].rotateRight(),c[v][1]=f.rotateLeft();else if(n===-1&&o===1)f.left=c[v+1][1]=c[v+1][1].rotateLeft(),c[v][1]=f.rotateRight();else throw new Error;if(v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this.c=c[0][1]}}return u}get(D){return this.d(D)?.value}d(D){const C=this.b.reset(D);let p=this.c;for(;p;){const i=C.cmp(p.segment);if(i>0)p=p.left;else if(i<0)p=p.right;else if(C.hasNext())C.next(),p=p.mid;else break}return p}has(D){const C=this.d(D);return!(C?.value===void 0&&C?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,C){const p=this.b.reset(D),i=[];let c=this.c;for(;c;){const u=p.cmp(c.segment);if(u>0)i.push([-1,c]),c=c.left;else if(u<0)i.push([1,c]),c=c.right;else if(p.hasNext())p.next(),i.push([0,c]),c=c.mid;else break}if(c){if(C?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const u=this.f(c.right);if(u.key){const{key:v,value:f,segment:E}=u;this.e(u.key,!1),c.key=v,c.value=f,c.segment=E}}else{const u=c.left??c.right;if(i.length>0){const[v,f]=i[i.length-1];switch(v){case-1:f.left=u;break;case 0:f.mid=u;break;case 1:f.right=u;break}}else this.c=u}for(let u=i.length-1;u>=0;u--){const v=i[u][1];v.updateHeight();const f=v.balanceFactor();if(f>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),i[u][1]=v.rotateLeft()):f<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),i[u][1]=v.rotateRight()),u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const C=this.b.reset(D);let p=this.c,i;for(;p;){const c=C.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(C.hasNext())C.next(),i=p.value||i,p=p.mid;else break}return p&&p.value||i}findSuperstr(D){return this.g(D,!1)}g(D,C){const p=this.b.reset(D);let i=this.c;for(;i;){const c=p.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(p.hasNext())p.next(),i=i.mid;else return i.mid?this.h(i.mid):C?i.value:void 0}}hasElementOrSubtree(D){return this.g(D,!0)!==void 0}forEach(D){for(const[C,p]of this)D(p,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(D){const C=[];return this.j(D,C),C[Symbol.iterator]()}j(D,C){D&&(D.left&&this.j(D.left,C),D.value&&C.push([D.key,D.value]),D.mid&&this.j(D.mid,C),D.right&&this.j(D.right,C))}_isBalanced(){const D=C=>{if(!C)return!0;const p=C.balanceFactor();return p<-1||p>1?!1:D(C.left)&&D(C.right)};return D(this.c)}}e.$rh=I}),define(De[12],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;function b(o){return typeof o=="string"}e.$ge=b;function A(o){return Array.isArray(o)&&o.every(s=>b(s))}e.$he=A;function h(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$ie=h;function F(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.$je=F;function R(o){return typeof o=="number"&&!isNaN(o)}e.$ke=R;function m(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$le=m;function k(o){return o===!0||o===!1}e.$me=k;function g(o){return typeof o>"u"}e.$ne=g;function L(o){return!I(o)}e.$oe=L;function I(o){return g(o)||o===null}e.$pe=I;function w(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$qe=w;function D(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$re=D;function C(...o){const s=[];for(let t=0;t<o.length;t++){const d=o[t];if(I(d))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);s.push(d)}return s}e.$se=C;const p=Object.prototype.hasOwnProperty;function i(o){if(!h(o))return!1;for(const s in o)if(p.call(o,s))return!1;return!0}e.$te=i;function c(o){return typeof o=="function"}e.$ue=c;function u(...o){return o.length>0&&o.every(c)}e.$ve=u;function v(o,s){const t=Math.min(o.length,s.length);for(let d=0;d<t;d++)f(o[d],s[d])}e.$we=v;function f(o,s){if(b(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(c(s)){try{if(o instanceof s)return}catch{}if(!I(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$xe=f;function E(o){return o===null?void 0:o}e.$ye=E;function n(o){return typeof o>"u"?null:o}e.$ze=n}),define(De[72],Ce([1,0,12]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=void 0;const A=Object.create(null);function h(m,k){if((0,b.$ge)(k)){const g=A[k];if(g===void 0)throw new Error(`${m} references an unknown codicon: ${k}`);k=g}return A[m]=k,{id:m}}function F(){return A}e.$wj=F;function R(){return Object.values(e.$yj)}e.$xj=R,e.$yj={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package_:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(De[31],Ce([1,0,10,9,11,12]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function R($){return $===47||$===92}e.$Ae=R;function m($){return $.replace(/[\\/]/g,b.$8b.sep)}e.$Be=m;function k($){return $.indexOf("/")===-1&&($=m($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Ce=k;function g($,l=b.$8b.sep){if(!$)return"";const S=$.length,y=$.charCodeAt(0);if(R(y)){if(R($.charCodeAt(1))&&!R($.charCodeAt(2))){let r=3;const P=r;for(;r<S&&!R($.charCodeAt(r));r++);if(P!==r&&!R($.charCodeAt(r+1))){for(r+=1;r<S;r++)if(R($.charCodeAt(r)))return $.slice(0,r+1).replace(/[\\/]/g,l)}}return l}else if(c(y)&&$.charCodeAt(1)===58)return R($.charCodeAt(2))?$.slice(0,2)+l:$.slice(0,2);let a=$.indexOf("://");if(a!==-1){for(a+=3;a<S;a++)if(R($.charCodeAt(a)))return $.slice(0,a+1)}return""}e.$De=g;function L($){if(!A.$d||!$||$.length<5)return!1;let l=$.charCodeAt(0);if(l!==92||(l=$.charCodeAt(1),l!==92))return!1;let S=2;const y=S;for(;S<$.length&&(l=$.charCodeAt(S),l!==92);S++);return!(y===S||(l=$.charCodeAt(S+1),isNaN(l)||l===92))}e.$Ee=L;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C($,l=A.$d){const S=l?I:w;return!(!$||$.length===0||/^\s+$/.test($)||(S.lastIndex=0,S.test($))||l&&D.test($)||$==="."||$===".."||l&&$[$.length-1]==="."||l&&$.length!==$.trim().length||$.length>255)}e.$Fe=C;function p($,l,S){const y=$===l;return!S||y?y:!$||!l?!1:(0,h.$Jd)($,l)}e.$Ge=p;function i($,l,S,y=b.sep){if($===l)return!0;if(!$||!l||l.length>$.length)return!1;if(S){if(!(0,h.$Kd)($,l))return!1;if(l.length===$.length)return!0;let r=l.length;return l.charAt(l.length-1)===y&&r--,$.charAt(r)===y}return l.charAt(l.length-1)!==y&&(l+=y),$.indexOf(l)===0}e.$He=i;function c($){return $>=65&&$<=90||$>=97&&$<=122}e.$Ie=c;function u($,l){return A.$d&&$.endsWith(":")&&($+=b.sep),(0,b.$0b)($)||($=(0,b.$$b)(l,$)),$=(0,b.$9b)($),A.$d?($=(0,h.$qd)($,b.sep),$.endsWith(":")&&($+=b.sep)):($=(0,h.$qd)($,b.sep),$||($=b.sep)),$}e.$Je=u;function v($){const l=(0,b.$9b)($);return A.$d?$.length>3?!1:f(l)&&($.length===2||l.charCodeAt(2)===92):l===b.$8b.sep}e.$Ke=v;function f($,l=A.$d){return l?c($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Le=f;function E($,l=A.$d){return f($,l)?$[0]:void 0}e.$Me=E;function n($,l,S){return l.length>$.length?-1:$===l?0:(S&&($=$.toLowerCase(),l=l.toLowerCase()),$.indexOf(l))}e.$Ne=n;function o($){const l=$.split(":");let S,y,a;for(const r of l){const P=Number(r);(0,F.$ke)(P)?y===void 0?y=P:a===void 0&&(a=P):S=S?[S,r].join(":"):r}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:y!==void 0?y:void 0,column:a!==void 0?a:y!==void 0?1:void 0}}e.$Oe=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d($,l,S=8){let y="";for(let r=0;r<S;r++){let P;r===0&&A.$d&&!l&&(S===3||S===4)?P=t:P=s,y+=P.charAt(Math.floor(Math.random()*P.length))}let a;return l?a=`${l}-${y}`:a=y,$?(0,b.$$b)($,a):a}e.$Pe=d}),define(De[24],Ce([1,0,12]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=void 0;function A(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([v,f])=>{u[v]=f&&typeof f=="object"?A(f):f}),u}e.$Em=A;function h(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const v=u.shift();Object.freeze(v);for(const f in v)if(F.call(v,f)){const E=v[f];typeof E=="object"&&!Object.isFrozen(E)&&!(0,b.$je)(E)&&u.push(E)}}return c}e.$Fm=h;const F=Object.prototype.hasOwnProperty;function R(c,u){return m(c,u,new Set)}e.$Gm=R;function m(c,u,v){if((0,b.$pe)(c))return c;const f=u(c);if(typeof f<"u")return f;if(Array.isArray(c)){const E=[];for(const n of c)E.push(m(n,u,v));return E}if((0,b.$ie)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const E={};for(const n in c)F.call(c,n)&&(E[n]=m(c[n],u,v));return v.delete(c),E}return c}function k(c,u,v=!0){return(0,b.$ie)(c)?((0,b.$ie)(u)&&Object.keys(u).forEach(f=>{f in c?v&&((0,b.$ie)(c[f])&&(0,b.$ie)(u[f])?k(c[f],u[f],v):c[f]=u[f]):c[f]=u[f]}),c):u}e.$Hm=k;function g(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let v,f;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(v=0;v<c.length;v++)if(!g(c[v],u[v]))return!1}else{const E=[];for(f in c)E.push(f);E.sort();const n=[];for(f in u)n.push(f);if(n.sort(),!g(E,n))return!1;for(v=0;v<E.length;v++)if(!g(c[E[v]],u[E[v]]))return!1}return!0}e.$Im=g;function L(c){const u=new Set;return JSON.stringify(c,(v,f)=>{if((0,b.$ie)(f)||Array.isArray(f)){if(u.has(f))return"[Circular]";u.add(f)}return f})}e.$Jm=L;function I(c,u){const v=Object.create(null);return!c||!u||Object.keys(u).forEach(E=>{const n=c[E],o=u[E];g(n,o)||(v[E]=o)}),v}e.$Km=I;function w(c,u){const v=u.toLowerCase(),f=Object.keys(c).find(E=>E.toLowerCase()===v);return f?c[f]:c[u]}e.$Lm=w;function D(c,u){const v=Object.create(null);for(const[f,E]of Object.entries(c))u(f,E)&&(v[f]=E);return v}e.$Mm=D;function C(c){let u=[],v=Object.getPrototypeOf(c);for(;Object.prototype!==v;)u=u.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return u}e.$Nm=C;function p(c){const u=[];for(const v of C(c))typeof c[v]=="function"&&u.push(v);return u}e.$Om=p;function i(c,u){const v=E=>function(){const n=Array.prototype.slice.call(arguments,0);return u(E,n)},f={};for(const E of c)f[E]=v(E);return f}e.$Pm=i}),define(De[55],Ce([1,0,72]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$zj=e.ThemeColor=void 0;var A;(function(R){function m(k){return k&&typeof k=="object"&&typeof k.id=="string"}R.isThemeColor=m})(A||(e.ThemeColor=A={}));function h(R){return{id:R}}e.$zj=h;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function k(u){const v=m.exec(u.id);if(!v)return k(b.$yj.error);const[,f,E]=v,n=["codicon","codicon-"+f];return E&&n.push("codicon-modifier-"+E.substring(1)),n}R.asClassNameArray=k;function g(u){return k(u).join(" ")}R.asClassName=g;function L(u){return"."+k(u).join(".")}R.asCSSSelector=L;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||A.isThemeColor(u.color))}R.isThemeIcon=I;const w=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function D(u){const v=w.exec(u);if(!v)return;const[,f]=v;return{id:f}}R.fromString=D;function C(u){return{id:u}}R.fromId=C;function p(u,v){let f=u.id;const E=f.lastIndexOf("~");return E!==-1&&(f=f.substring(0,E)),v&&(f=`${f}~${v}`),{id:f}}R.modify=p;function i(u){const v=u.id.lastIndexOf("~");if(v!==-1)return u.id.substring(v+1)}R.getModifier=i;function c(u,v){return u.id===v.id&&u.color?.id===v.color?.id}R.isEqual=c})(F||(e.ThemeIcon=F={}))}),define(De[155],Ce([1,0,115,11,55]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=void 0;const F="$(",R=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function k(c){return c.replace(m,(u,v)=>v?u:`\\${u}`)}e.$Aj=k;const g=new RegExp(`\\\\${R.source}`,"g");function L(c){return c.replace(g,u=>`\\${u}`)}e.$Bj=L;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function w(c){return c.indexOf(F)===-1?c:c.replace(I,(u,v,f,E)=>f?u:v||E||"")}e.$Cj=w;function D(c){return c?c.replace(/\$\((.*?)\)/g,(u,v)=>` ${v} `).trim():""}e.$Dj=D;const C=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(c){C.lastIndex=0;let u="";const v=[];let f=0;for(;;){const E=C.lastIndex,n=C.exec(c),o=c.substring(E,n?.index);if(o.length>0){u+=o;for(let s=0;s<o.length;s++)v.push(f)}if(!n)break;f+=n[0].length}return{text:u,iconOffsets:v}}e.$Ej=p;function i(c,u,v=!1){const{text:f,iconOffsets:E}=u;if(!E||E.length===0)return(0,b.$nj)(c,f,v);const n=(0,A.$pd)(f," "),o=f.length-n.length,s=(0,b.$nj)(c,n,v);if(s)for(const t of s){const d=E[t.start+o]+o;t.start+=d,t.end+=d}return s}e.$Fj=i}),define(De[117],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gd=e.$fd=e.Constants=void 0;var b;(function(F){F[F.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",F[F.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",F[F.MAX_UINT_8=255]="MAX_UINT_8",F[F.MAX_UINT_16=65535]="MAX_UINT_16",F[F.MAX_UINT_32=4294967295]="MAX_UINT_32",F[F.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b||(e.Constants=b={}));function A(F){return F<0?0:F>255?255:F|0}e.$fd=A;function h(F){return F<0?0:F>4294967295?4294967295:F|0}e.$gd=h}),define(De[2],Ce([1,0,10,9]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,F=/^\//,R=/^\/\//;function m(t,d){if(!t.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!h.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!F.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(t,d){return!t&&!d?"file":t}function g(t,d){switch(t){case"https":case"http":case"file":d?d[0]!==I&&(d=I+d):d=I;break}return d}const L="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(d){return d instanceof D?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,$,l,S,y,a=!1){typeof d=="object"?(this.scheme=d.scheme||L,this.authority=d.authority||L,this.path=d.path||L,this.query=d.query||L,this.fragment=d.fragment||L):(this.scheme=k(d,a),this.authority=$||L,this.path=g(this.scheme,l||L),this.query=S||L,this.fragment=y||L,m(this,a))}get fsPath(){return f(this,!1)}with(d){if(!d)return this;let{scheme:$,authority:l,path:S,query:y,fragment:a}=d;return $===void 0?$=this.scheme:$===null&&($=L),l===void 0?l=this.authority:l===null&&(l=L),S===void 0?S=this.path:S===null&&(S=L),y===void 0?y=this.query:y===null&&(y=L),a===void 0?a=this.fragment:a===null&&(a=L),$===this.scheme&&l===this.authority&&S===this.path&&y===this.query&&a===this.fragment?this:new i($,l,S,y,a)}static parse(d,$=!1){const l=w.exec(d);return l?new i(l[2]||L,s(l[4]||L),s(l[5]||L),s(l[7]||L),s(l[9]||L),$):new i(L,L,L,L,L)}static file(d){let $=L;if(A.$d&&(d=d.replace(/\\/g,I)),d[0]===I&&d[1]===I){const l=d.indexOf(I,2);l===-1?($=d.substring(2),d=I):($=d.substring(2,l),d=d.substring(l)||I)}return new i("file",$,d,L,L)}static from(d,$){return new i(d.scheme,d.authority,d.path,d.query,d.fragment,$)}static joinPath(d,...$){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return A.$d&&d.scheme==="file"?l=D.file(b.$7b.join(f(d,!0),...$)).path:l=b.$8b.join(d.path,...$),d.with({path:l})}toString(d=!1){return E(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof D)return d;{const $=new i(d);return $._formatted=d.external??null,$._fsPath=d._sep===p?d.fsPath??null:null,$}}else return d}}e.URI=D;function C(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$Re=C;const p=A.$d?1:void 0;class i extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(d=!1){return d?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=p),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,d,$){let l,S=-1;for(let y=0;y<t.length;y++){const a=t.charCodeAt(y);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||d&&a===47||$&&a===91||$&&a===93||$&&a===58)S!==-1&&(l+=encodeURIComponent(t.substring(S,y)),S=-1),l!==void 0&&(l+=t.charAt(y));else{l===void 0&&(l=t.substr(0,y));const r=c[a];r!==void 0?(S!==-1&&(l+=encodeURIComponent(t.substring(S,y)),S=-1),l+=r):S===-1&&(S=y)}}return S!==-1&&(l+=encodeURIComponent(t.substring(S))),l!==void 0?l:t}function v(t){let d;for(let $=0;$<t.length;$++){const l=t.charCodeAt($);l===35||l===63?(d===void 0&&(d=t.substr(0,$)),d+=c[l]):d!==void 0&&(d+=t[$])}return d!==void 0?d:t}function f(t,d){let $;return t.authority&&t.path.length>1&&t.scheme==="file"?$=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?d?$=t.path.substr(1):$=t.path[1].toLowerCase()+t.path.substr(2):$=t.path,A.$d&&($=$.replace(/\//g,"\\")),$}e.$Se=f;function E(t,d){const $=d?v:u;let l="",{scheme:S,authority:y,path:a,query:r,fragment:P}=t;if(S&&(l+=S,l+=":"),(y||S==="file")&&(l+=I,l+=I),y){let N=y.indexOf("@");if(N!==-1){const U=y.substr(0,N);y=y.substr(N+1),N=U.lastIndexOf(":"),N===-1?l+=$(U,!1,!1):(l+=$(U.substr(0,N),!1,!1),l+=":",l+=$(U.substr(N+1),!1,!0)),l+="@"}y=y.toLowerCase(),N=y.lastIndexOf(":"),N===-1?l+=$(y,!1,!0):(l+=$(y.substr(0,N),!1,!0),l+=y.substr(N))}if(a){if(a.length>=3&&a.charCodeAt(0)===47&&a.charCodeAt(2)===58){const N=a.charCodeAt(1);N>=65&&N<=90&&(a=`/${String.fromCharCode(N+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===58){const N=a.charCodeAt(0);N>=65&&N<=90&&(a=`${String.fromCharCode(N+32)}:${a.substr(2)}`)}l+=$(a,!0,!1)}return r&&(l+="?",l+=$(r,!1,!1)),P&&(l+="#",l+=d?P:u(P,!1,!1)),l}function n(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+n(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(o)?t.replace(o,d=>n(d)):t}}),define(De[156],Ce([1,0,2]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Bp=e.$Ap=e.$zp=void 0;function A(g){const L=g;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$zp=A;function h(g){const L=[];let I;try{const w=JSON.parse(g.arguments),D=w[w.length-1];D&&D.__$stack&&(w.pop(),I=D.__$stack),L.push(...w)}catch{L.push("Unable to log remote console arguments",g.arguments)}return{args:L,stack:I}}e.$Ap=h;function F(g){if(typeof g!="string")return F(h(g).stack);const L=g;if(L){const I=R(L),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:b.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Bp=F;function R(g){if(!g)return g;const L=g.indexOf(`
`);return L===-1?g:g.substring(0,L)}function m(g,L){const{args:I,stack:w}=h(g),D=typeof I[0]=="string"&&I.length===1;let C=R(w);C&&(C=`(${C.trim()})`);let p=[];if(typeof I[0]=="string"?C&&D?p=[`%c[${L}] %c${I[0]} %c${C}`,k("blue"),k(""),k("grey")]:p=[`%c[${L}] %c${I[0]}`,k("blue"),k(""),...I.slice(1)]:p=[`%c[${L}]%`,k("blue"),...I],C&&!D&&p.push(C),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=m;function k(g){return`color: ${g}`}}),define(De[73],Ce([1,0,22,11,2]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function F(g){return JSON.stringify(g,m)}e.$Sg=F;function R(g){let L=JSON.parse(g);return L=k(L),L}e.$Tg=R;function m(g,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.$wd)(L)}:L}function k(g,L=0){if(!g||L>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return h.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof b.$Ib||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let I=0;I<g.length;++I)g[I]=k(g[I],L+1);else for(const I in g)Object.hasOwnProperty.call(g,I)&&(g[I]=k(g[I],L+1))}return g}e.$Ug=k}),define(De[16],Ce([1,0,8,9,2]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var F;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$Te="vscode-tkn",e.$Ue="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${F.vscodeRemoteResource}`}set(L,I,w){this.a[L]=I,this.b[L]=w}setConnectionToken(L,I){this.c[L]=I}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(i){return b.$X(i),L}const I=L.authority;let w=this.a[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const D=this.b[I],C=this.c[I];let p=`path=${encodeURIComponent(L.path)}`;return typeof C=="string"&&(p+=`&${e.$Ue}=${encodeURIComponent(C)}`),h.URI.from({scheme:A.$j?this.d:F.vscodeRemoteResource,authority:`${w}:${D}`,path:A.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:p})}}e.$Ve=new R,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class m{asBrowserUri(L){const I=this.b(L,re);return this.uriToBrowserUri(I)}uriToBrowserUri(L){return L.scheme===F.vscodeRemote?e.$Ve.rewrite(L):L.scheme===F.file&&(A.$h||A.$k&&A.$b.origin===`${F.vscodeFileResource}://${m.a}`)?L.with({scheme:F.vscodeFileResource,authority:L.authority||m.a,query:null,fragment:null}):L}asFileUri(L){const I=this.b(L,re);return this.uriToFileUri(I)}uriToFileUri(L){return L.scheme===F.vscodeFileResource?L.with({scheme:F.file,authority:L.authority!==m.a?L.authority:null,query:null,fragment:null}):L}b(L,I){return h.URI.isUri(L)?L:h.URI.parse(I.toUrl(L))}}m.a="vscode-app",e.$1e=new m;var k;(function(g){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(L.get("3"));const I="vscode-coi";function w(C){let p;typeof C=="string"?p=new URL(C).searchParams:C instanceof URL?p=C.searchParams:h.URI.isUri(C)&&(p=new URL(C.toString(!0)).searchParams);const i=p?.get(I);if(i)return L.get(i)}g.getHeadersFromQuery=w;function D(C,p,i){if(!globalThis.crossOriginIsolated)return;const c=p&&i?"3":i?"2":"1";C instanceof URLSearchParams?C.set(I,c):C[I]=c}g.addSearchParam=D})(k||(e.COI=k={}))}),define(De[23],Ce([1,0,31,16,10,9,11,2]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function k(D){return(0,m.$Se)(D,!0)}e.$Tf=k;class g{constructor(C){this.a=C}compare(C,p,i=!1){return C===p?0:(0,R.$Cd)(this.getComparisonKey(C,i),this.getComparisonKey(p,i))}isEqual(C,p,i=!1){return C===p?!0:!C||!p?!1:this.getComparisonKey(C,i)===this.getComparisonKey(p,i)}getComparisonKey(C,p=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,p,i=!1){if(C.scheme===p.scheme){if(C.scheme===A.Schemas.file)return b.$He(k(C),k(p),this.a(C))&&C.query===p.query&&(i||C.fragment===p.fragment);if((0,e.$$f)(C.authority,p.authority))return b.$He(C.path,p.path,this.a(C),"/")&&C.query===p.query&&(i||C.fragment===p.fragment)}return!1}joinPath(C,...p){return m.URI.joinPath(C,...p)}basenameOrAuthority(C){return(0,e.$3f)(C)||C.authority}basename(C){return h.$8b.basename(C.path)}extname(C){return h.$8b.extname(C.path)}dirname(C){if(C.path.length===0)return C;let p;return C.scheme===A.Schemas.file?p=m.URI.file(h.$bc(k(C))).path:(p=h.$8b.dirname(C.path),C.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),p="/")),C.with({path:p})}normalizePath(C){if(!C.path.length)return C;let p;return C.scheme===A.Schemas.file?p=m.URI.file(h.$9b(k(C))).path:p=h.$8b.normalize(C.path),C.with({path:p})}relativePath(C,p){if(C.scheme!==p.scheme||!(0,e.$$f)(C.authority,p.authority))return;if(C.scheme===A.Schemas.file){const u=h.$ac(k(C),k(p));return F.$d?b.$Be(u):u}let i=C.path||"/";const c=p.path||"/";if(this.a(C)){let u=0;for(const v=Math.min(i.length,c.length);u<v&&!(i.charCodeAt(u)!==c.charCodeAt(u)&&i.charAt(u).toLowerCase()!==c.charAt(u).toLowerCase());u++);i=c.substr(0,u)+i.substr(u)}return h.$8b.relative(i,c)}resolvePath(C,p){if(C.scheme===A.Schemas.file){const i=m.URI.file(h.$_b(k(C),p));return C.with({authority:i.authority,path:i.path})}return p=b.$Ce(p),C.with({path:h.$8b.resolve(C.path,p)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,p){return C===p||C!==void 0&&p!==void 0&&(0,R.$Jd)(C,p)}hasTrailingPathSeparator(C,p=h.sep){if(C.scheme===A.Schemas.file){const i=k(C);return i.length>b.$De(i).length&&i[i.length-1]===p}else{const i=C.path;return i.length>1&&i.charCodeAt(i.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,p=h.sep){return(0,e.$_f)(C,p)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,p=h.sep){let i=!1;if(C.scheme===A.Schemas.file){const c=k(C);i=c!==void 0&&c.length===b.$De(c).length&&c[c.length-1]===p}else{p="/";const c=C.path;i=c.length===1&&c.charCodeAt(c.length-1)===47}return!i&&!(0,e.$_f)(C,p)?C.with({path:C.path+"/"}):C}}e.$Uf=g,e.$Vf=new g(()=>!1),e.$Wf=new g(D=>D.scheme===A.Schemas.file?!F.$f:!0),e.$Xf=new g(D=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function L(D,C){const p=[];for(let i=0;i<D.length;i++){const c=C(D[i]);D.some((u,v)=>v===i?!1:(0,e.$Zf)(c,C(u)))||p.push(D[i])}return p}e.$cg=L;var I;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function C(p){const i=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(v=>{const[f,E]=v.split(":");f&&E&&i.set(f,E)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&i.set(D.META_DATA_MIME,u),i}D.parseMetaData=C})(I||(e.DataUri=I={}));function w(D,C,p){if(C){let i=D.path;return i&&i[0]!==h.$8b.sep&&(i=h.$8b.sep+i),D.with({scheme:p,authority:C,path:i})}return D.with({scheme:p})}e.$dg=w}),define(De[17],Ce([1,0,21,8,3,4,23,9,154]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function g(ge){return!!ge&&typeof ge.then=="function"}e.$eg=g;function L(ge){const M=new b.$bd,Y=ge(M.token),ve=new Promise((Se,ee)=>{const te=M.token.onCancellationRequested(()=>{te.dispose(),M.dispose(),ee(new A.$2)});Promise.resolve(Y).then(le=>{te.dispose(),M.dispose(),Se(le)},le=>{te.dispose(),M.dispose(),ee(le)})});return new class{cancel(){M.cancel()}then(Se,ee){return ve.then(Se,ee)}catch(Se){return this.then(void 0,Se)}finally(Se){return ve.finally(Se)}}}e.$fg=L;function I(ge,M,Y){return new Promise((ve,Se)=>{const ee=M.onCancellationRequested(()=>{ee.dispose(),ve(Y)});ge.then(ve,Se).finally(()=>ee.dispose())})}e.$gg=I;function w(ge,M){return new Promise((Y,ve)=>{const Se=M.onCancellationRequested(()=>{Se.dispose(),ve(new A.$2)});ge.then(Y,ve).finally(()=>Se.dispose())})}e.$hg=w;async function D(ge){let M=-1;const Y=ge.map((ve,Se)=>ve.then(ee=>(M=Se,ee)));try{return await Promise.race(Y)}finally{ge.forEach((ve,Se)=>{Se!==M&&ve.cancel()})}}e.$ig=D;function C(ge,M,Y){let ve;const Se=setTimeout(()=>{ve?.(void 0),Y?.()},M);return Promise.race([ge.finally(()=>clearTimeout(Se)),new Promise(ee=>ve=ee)])}e.$jg=C;function p(ge){return new Promise((M,Y)=>{const ve=ge();g(ve)?ve.then(M,Y):M(ve)})}e.$kg=p;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(M){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=M,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(Y,Y).then(ve)})}return new Promise((Y,ve)=>{this.b.then(Y,ve)})}return this.a=M(),new Promise((Y,ve)=>{this.a.then(Se=>{this.a=null,Y(Se)},Se=>{this.a=null,ve(Se)})})}dispose(){this.f=!0}}e.$lg=i;class c{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.$mg=c;class u{constructor(){this.a=new Map}queue(M,Y){const Se=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(M)===Se&&this.a.delete(M)});return this.a.set(M,Se),Se}}e.$ng=u;const v=(ge,M)=>{let Y=!0;const ve=setTimeout(()=>{Y=!1,M()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ve),Y=!1}}},f=ge=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,ge())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class E{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,Y=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((Se,ee)=>{this.d=Se,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const Se=this.g;return this.g=null,Se()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=Y===k.$2c?f(ve):v(Y,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=E;class n{constructor(M){this.a=new E(M),this.b=new i}trigger(M,Y){return this.a.trigger(()=>this.b.queue(M),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=n;class o{constructor(){this.a=!1,this.b=new Promise((M,Y)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=o;class s extends o{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.$rg=s;function t(ge,M){return M?new Promise((Y,ve)=>{const Se=setTimeout(()=>{ee.dispose(),Y()},ge),ee=M.onCancellationRequested(()=>{clearTimeout(Se),ee.dispose(),ve(new A.$2)})}):L(Y=>t(ge,Y))}e.$sg=t;function d(ge,M=0){const Y=setTimeout(ge,M);return(0,F.$ib)(()=>clearTimeout(Y))}e.$tg=d;function $(ge){const M=[];let Y=0;const ve=ge.length;function Se(){return Y<ve?ge[Y++]():null}function ee(te){te!=null&&M.push(te);const le=Se();return le?le.then(ee):Promise.resolve(M)}return Promise.resolve(null).then(ee)}e.$ug=$;function l(ge,M=ve=>!!ve,Y=null){let ve=0;const Se=ge.length,ee=()=>{if(ve>=Se)return Promise.resolve(Y);const te=ge[ve++];return Promise.resolve(te()).then(X=>M(X)?Promise.resolve(X):ee())};return ee()}e.$vg=l;function S(ge,M=ve=>!!ve,Y=null){if(ge.length===0)return Promise.resolve(Y);let ve=ge.length;const Se=()=>{ve=-1;for(const ee of ge)ee.cancel?.()};return new Promise((ee,te)=>{for(const le of ge)le.then(X=>{--ve>=0&&M(X)?(Se(),ee(X)):ve===0&&ee(Y)}).catch(X=>{--ve>=0&&(Se(),te(X))})})}e.$wg=S;class y{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new h.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((Y,ve)=>{this.f.push({factory:M,c:Y,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const Y=M.factory();Y.then(M.c,M.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=y;class a extends y{constructor(){super(1)}}e.$yg=a;class r{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new ne;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,Y=R.$Vf){const ve=Y.getComparisonKey(M);let Se=this.a.get(ve);return Se||(Se=new a,h.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Se)),Se}f(){this.d()&&this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}e.$zg=r;class P{constructor(M,Y){this.a=-1,typeof M=="function"&&typeof Y=="number"&&this.setIfNotSet(M,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},Y)}setIfNotSet(M,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},Y))}}e.$Ag=P;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,Y){this.cancel(),this.a=setInterval(()=>{M()},Y)}}e.$Bg=N;class U{constructor(M,Y){this.b=-1,this.a=M,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=U;class q{constructor(M,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=M,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=q;class B extends U{constructor(M,Y){super(M,Y),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.$Eg=B;class O extends F.$kb{constructor(M,Y){super(),this.g=M,this.h=Y,this.a=[],this.b=this.B(new F.$lb),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of M)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=ge=>{(0,m.$v)(()=>{if(M)return;const Y=Date.now()+15;ge(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.$Gg=(ge,M)=>{const Y=requestIdleCallback(ge,typeof M=="number"?{timeout:M}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(Y))}}}}();class K{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(Y){this.g=Y}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=K;async function z(ge,M,Y){let ve;for(let Se=0;Se<Y;Se++)try{return await ge()}catch(ee){ve=ee,await t(M)}throw ve}e.$Ig=z;class j{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,Y,ve){return this.a={taskId:M,cancel:()=>ve?.(),promise:Y},Y.then(()=>this.d(M),()=>this.d(M)),Y}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let Y,ve;const Se=new Promise((ee,te)=>{Y=ee,ve=te});this.b={run:M,promise:Se,promiseResolve:Y,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=j;class he{constructor(M,Y=()=>Date.now()){this.d=M,this.f=Y,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.$Kg=he;var ie;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ie||(ie={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((M,Y)=>{this.a=M,this.b=Y})}complete(M){return new Promise(Y=>{this.a(M),this.d={outcome:0,value:M},Y()})}error(M){return new Promise(Y=>{this.b(M),this.d={outcome:1,value:M},Y()})}cancel(){return this.error(new A.$2)}}e.$Lg=ne;var V;(function(ge){async function M(ve){let Se;const ee=await Promise.all(ve.map(te=>te.then(le=>le,le=>{Se||(Se=le)})));if(typeof Se<"u")throw Se;return ee}ge.settled=M;function Y(ve){return new Promise(async(Se,ee)=>{try{await ve(Se,ee)}catch(te){ee(te)}})}ge.withAsyncBody=Y})(V||(e.Promises=V={}));var H;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(H||(H={}));class ce{static fromArray(M){return new ce(Y=>{Y.emitMany(M)})}static fromPromise(M){return new ce(async Y=>{Y.emitMany(await M)})}static fromPromises(M){return new ce(async Y=>{await Promise.all(M.map(async ve=>Y.emitOne(await ve)))})}static merge(M){return new ce(async Y=>{await Promise.all(M.map(async ve=>{for await(const Se of ve)Y.emitOne(Se)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new h.$5c,queueMicrotask(async()=>{const Y={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(M(Y)),this.j()}catch(ve){this.k(ve)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(M,Y){return new ce(async ve=>{for await(const Se of M)ve.emitOne(Y(Se))})}map(M){return ce.map(this,M)}static filter(M,Y){return new ce(async ve=>{for await(const Se of M)Y(Se)&&ve.emitOne(Se)})}filter(M){return ce.filter(this,M)}static coalesce(M){return ce.filter(M,Y=>!!Y)}coalesce(){return ce.coalesce(this)}static async toPromise(M){const Y=[];for await(const ve of M)Y.push(ve);return Y}toPromise(){return ce.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}e.$Mg=ce,ce.EMPTY=ce.fromArray([]);class pe extends ce{constructor(M,Y){super(Y),this.l=M}cancel(){this.l.cancel()}}e.$Ng=pe;function ye(ge){const M=new b.$bd,Y=ge(M.token);return new pe(M,async ve=>{const Se=M.token.onCancellationRequested(()=>{Se.dispose(),M.dispose(),ve.reject(new A.$2)});try{for await(const ee of Y){if(M.token.isCancellationRequested)return;ve.emitOne(ee)}Se.dispose(),M.dispose()}catch(ee){Se.dispose(),M.dispose(),ve.reject(ee)}})}e.$Og=ye}),define(De[32],Ce([1,0,19,17,31,28,10,9,11]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0;function g(){return Object.create(null)}e.$8i=g,e.$9i="**",e.$0i="/";const L="[/\\\\]",I="[^/\\\\]",w=/\//g;function D(he,ie){switch(he){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${ie?`|${L}${I}+`:""})*?`}}function C(he,ie){if(!he)return[];const ne=[];let V=!1,H=!1,ce="";for(const pe of he){switch(pe){case ie:if(!V&&!H){ne.push(ce),ce="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":H=!0;break;case"]":H=!1;break}ce+=pe}return ce&&ne.push(ce),ne}e.$$i=C;function p(he){if(!he)return"";let ie="";const ne=C(he,e.$0i);if(ne.every(V=>V===e.$9i))ie=".*";else{let V=!1;ne.forEach((H,ce)=>{if(H===e.$9i){if(V)return;ie+=D(2,ce===ne.length-1)}else{let pe=!1,ye="",ge=!1,M="";for(const Y of H){if(Y!=="}"&&pe){ye+=Y;continue}if(ge&&(Y!=="]"||!M)){let ve;Y==="-"?ve=Y:(Y==="^"||Y==="!")&&!M?ve="^":Y===e.$0i?ve="":ve=(0,k.$ld)(Y),M+=ve;continue}switch(Y){case"{":pe=!0;continue;case"[":ge=!0;continue;case"}":{const Se=`(?:${C(ye,",").map(ee=>p(ee)).join("|")})`;ie+=Se,pe=!1,ye="";break}case"]":{ie+="["+M+"]",ge=!1,M="";break}case"?":ie+=I;continue;case"*":ie+=D(1);continue;default:ie+=(0,k.$ld)(Y)}}ce<ne.length-1&&(ne[ce+1]!==e.$9i||ce+2<ne.length)&&(ie+=L)}V=H===e.$9i})}return ie}const i=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new F.$mi(1e4),o=function(){return!1},s=function(){return null};function t(he,ie){if(!he)return s;let ne;typeof he!="string"?ne=he.pattern:ne=he,ne=ne.trim();const V=`${ne}_${!!ie.trimForExclusions}`;let H=n.get(V);if(H)return d(H,he);let ce;return i.test(ne)?H=l(ne.substr(4),ne):(ce=c.exec($(ne,ie)))?H=S(ce[1],ne):(ie.trimForExclusions?v:u).test(ne)?H=y(ne,ie):(ce=f.exec($(ne,ie)))?H=a(ce[1].substr(1),ne,!0):(ce=E.exec($(ne,ie)))?H=a(ce[1],ne,!1):H=r(ne),n.set(V,H),d(H,he)}function d(he,ie){if(typeof ie=="string")return he;const ne=function(V,H){return(0,h.$He)(V,ie.base,!m.$f)?he((0,k.$pd)(V.substr(ie.base.length),R.sep),H):null};return ne.allBasenames=he.allBasenames,ne.allPaths=he.allPaths,ne.basenames=he.basenames,ne.patterns=he.patterns,ne}function $(he,ie){return ie.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function l(he,ie){return function(ne,V){return typeof ne=="string"&&ne.endsWith(he)?ie:null}}function S(he,ie){const ne=`/${he}`,V=`\\${he}`,H=function(pe,ye){return typeof pe!="string"?null:ye?ye===he?ie:null:pe===he||pe.endsWith(ne)||pe.endsWith(V)?ie:null},ce=[he];return H.basenames=ce,H.patterns=[ie],H.allBasenames=ce,H}function y(he,ie){const ne=z(he.slice(1,-1).split(",").map(ye=>t(ye,ie)).filter(ye=>ye!==s),he),V=ne.length;if(!V)return s;if(V===1)return ne[0];const H=function(ye,ge){for(let M=0,Y=ne.length;M<Y;M++)if(ne[M](ye,ge))return he;return null},ce=ne.find(ye=>!!ye.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const pe=ne.reduce((ye,ge)=>ge.allPaths?ye.concat(ge.allPaths):ye,[]);return pe.length&&(H.allPaths=pe),H}function a(he,ie,ne){const V=R.sep===R.$8b.sep,H=V?he:he.replace(w,R.sep),ce=R.sep+H,pe=R.$8b.sep+he;let ye;return ne?ye=function(ge,M){return typeof ge=="string"&&(ge===H||ge.endsWith(ce)||!V&&(ge===he||ge.endsWith(pe)))?ie:null}:ye=function(ge,M){return typeof ge=="string"&&(ge===H||!V&&ge===he)?ie:null},ye.allPaths=[(ne?"*/":"./")+he],ye}function r(he){try{const ie=new RegExp(`^${p(he)}$`);return function(ne){return ie.lastIndex=0,typeof ne=="string"&&ie.test(ne)?he:null}}catch{return s}}function P(he,ie,ne){return!he||typeof ie!="string"?!1:N(he)(ie,void 0,ne)}e.$_i=P;function N(he,ie={}){if(!he)return o;if(typeof he=="string"||U(he)){const ne=t(he,ie);if(ne===s)return o;const V=function(H,ce){return!!ne(H,ce)};return ne.allBasenames&&(V.allBasenames=ne.allBasenames),ne.allPaths&&(V.allPaths=ne.allPaths),V}return O(he,ie)}e.$aj=N;function U(he){const ie=he;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.$bj=U;function q(he){return he.allBasenames||[]}e.$cj=q;function B(he){return he.allPaths||[]}e.$dj=B;function O(he,ie){const ne=z(Object.getOwnPropertyNames(he).map(ye=>K(ye,he[ye],ie)).filter(ye=>ye!==s)),V=ne.length;if(!V)return s;if(!ne.some(ye=>!!ye.requiresSiblings)){if(V===1)return ne[0];const ye=function(Y,ve){let Se;for(let ee=0,te=ne.length;ee<te;ee++){const le=ne[ee](Y,ve);if(typeof le=="string")return le;(0,A.$eg)(le)&&(Se||(Se=[]),Se.push(le))}return Se?(async()=>{for(const ee of Se){const te=await ee;if(typeof te=="string")return te}return null})():null},ge=ne.find(Y=>!!Y.allBasenames);ge&&(ye.allBasenames=ge.allBasenames);const M=ne.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return M.length&&(ye.allPaths=M),ye}const H=function(ye,ge,M){let Y,ve;for(let Se=0,ee=ne.length;Se<ee;Se++){const te=ne[Se];te.requiresSiblings&&M&&(ge||(ge=(0,R.$cc)(ye)),Y||(Y=ge.substr(0,ge.length-(0,R.$dc)(ye).length)));const le=te(ye,ge,Y,M);if(typeof le=="string")return le;(0,A.$eg)(le)&&(ve||(ve=[]),ve.push(le))}return ve?(async()=>{for(const Se of ve){const ee=await Se;if(typeof ee=="string")return ee}return null})():null},ce=ne.find(ye=>!!ye.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const pe=ne.reduce((ye,ge)=>ge.allPaths?ye.concat(ge.allPaths):ye,[]);return pe.length&&(H.allPaths=pe),H}function K(he,ie,ne){if(ie===!1)return s;const V=t(he,ne);if(V===s)return s;if(typeof ie=="boolean")return V;if(ie){const H=ie.when;if(typeof H=="string"){const ce=(pe,ye,ge,M)=>{if(!M||!V(pe,ye))return null;const Y=H.replace("$(basename)",()=>ge),ve=M(Y);return(0,A.$eg)(ve)?ve.then(Se=>Se?he:null):ve?he:null};return ce.requiresSiblings=!0,ce}}return V}function z(he,ie){const ne=he.filter(ye=>!!ye.basenames);if(ne.length<2)return he;const V=ne.reduce((ye,ge)=>{const M=ge.basenames;return M?ye.concat(M):ye},[]);let H;if(ie){H=[];for(let ye=0,ge=V.length;ye<ge;ye++)H.push(ie)}else H=ne.reduce((ye,ge)=>{const M=ge.patterns;return M?ye.concat(M):ye},[]);const ce=function(ye,ge){if(typeof ye!="string")return null;if(!ge){let Y;for(Y=ye.length;Y>0;Y--){const ve=ye.charCodeAt(Y-1);if(ve===47||ve===92)break}ge=ye.substr(Y)}const M=V.indexOf(ge);return M!==-1?H[M]:null};ce.basenames=V,ce.patterns=H,ce.allBasenames=V;const pe=he.filter(ye=>!ye.basenames);return pe.push(ce),pe}function j(he,ie){return(0,b.$$e)(he,ie,(ne,V)=>typeof ne=="string"&&typeof V=="string"?ne===V:typeof ne!="string"&&typeof V!="string"?ne.base===V.base&&ne.pattern===V.pattern:!1)}e.$ej=j}),define(De[94],Ce([1,0,8,155,23,11,2]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class k{constructor(c="",u=!1){if(this.value=c,typeof this.value!="string")throw(0,b.$4)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(c,u=0){return this.value+=w(this.supportThemeIcons?(0,A.$Aj)(c):c).replace(/([ \t]+)/g,(v,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,u){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(c,u,v){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(c),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(c,u){const v=new RegExp((0,F.$ld)(u),"g");return c.replace(v,(f,E)=>c.charAt(E-1)!=="\\"?`\\${f}`:f)}}e.$Gj=k;function g(i){return L(i)?!i.value:Array.isArray(i)?i.every(g):!0}e.$Hj=g;function L(i){return i instanceof k?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.$Ij=L;function I(i,c){return i===c?!0:!i||!c?!1:i.value===c.value&&i.isTrusted===c.isTrusted&&i.supportThemeIcons===c.supportThemeIcons&&i.supportHtml===c.supportHtml&&(i.baseUri===c.baseUri||!!i.baseUri&&!!c.baseUri&&(0,h.$Yf)(R.URI.from(i.baseUri),R.URI.from(c.baseUri)))}e.$Jj=I;function w(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Kj=w;function D(i){return i.replace(/"/g,"&quot;")}e.$Lj=D;function C(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Mj=C;function p(i){const c=[],u=i.split("|").map(f=>f.trim());i=u[0];const v=u[1];if(v){const f=/height=(\d+)/.exec(v),E=/width=(\d+)/.exec(v),n=f?f[1]:"",o=E?E[1]:"",s=isFinite(parseInt(o)),t=isFinite(parseInt(n));s&&c.push(`width="${o}"`),t&&c.push(`height="${n}"`)}return{href:i,dimensions:c}}e.$Nj=p}),define(De[118],Ce([1,0,19,31,10,9,23,11]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xz=e.$Wz=e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=void 0;function k(t,d){const{os:$,tildify:l,relative:S}=d;if(S){const r=g(t,S,$);if(typeof r=="string")return r}let y=t.fsPath;if($===1&&!F.$d?y=y.replace(/\//g,"\\"):$!==1&&F.$d&&(y=y.replace(/\\/g,"/")),$!==1&&l?.userHome){const r=l.userHome.fsPath;let P;t.scheme!==l.userHome.scheme&&t.path.startsWith(h.$8b.sep)?P=l.userHome.with({path:t.path}).fsPath:P=t.fsPath,y=w(P,r,$)}return($===1?h.$7b:h.$8b).normalize(L(y,$===1))}e.$Oz=k;function g(t,d,$){const l=$===1?h.$7b:h.$8b,S=$===3?R.$Vf:R.$Xf,y=d.getWorkspace(),a=(0,b.$sf)(y.folders);if(!a)return;t.scheme!==a.uri.scheme&&t.path.startsWith(h.$8b.sep)&&(t=a.uri.with({path:t.path}));const r=d.getWorkspaceFolder(t);if(!r)return;let P;if(S.isEqual(r.uri,t)?P="":P=S.relativePath(r.uri,t)??"",P&&(P=l.normalize(P)),y.folders.length>1&&!d.noPrefix){const N=r.name?r.name:S.basenameOrAuthority(r.uri);P=P?`${N} \u2022 ${P}`:N}return P}function L(t,d=F.$d){return(0,A.$Le)(t,d)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$Pz=L;let I=Object.create(null);function w(t,d,$=F.OS){if($===1||!t||!d)return t;let l=I.original===d?I.normalized:void 0;l||(l=d,F.$d&&(l=(0,A.$Be)(l)),l=`${(0,m.$qd)(l,h.$8b.sep)}${h.$8b.sep}`,I={original:d,normalized:l});let S=t;return F.$d&&(S=(0,A.$Be)(S)),($===3?S.startsWith(l):(0,m.$Kd)(S,l))?`~/${S.substr(l.length)}`:t}e.$Qz=w;function D(t,d){return t.replace(/^~($|\/|\\)/,`${d}$1`)}e.$Rz=D;const C="\u2026",p="\\\\",i="~";function c(t,d=h.sep){const $=new Array(t.length);let l=!1;for(let S=0;S<t.length;S++){const y=t[S];if(y===""){$[S]=`.${d}`;continue}if(!y){$[S]=y;continue}l=!0;let a="",r=y;r.indexOf(p)===0?(a=r.substr(0,r.indexOf(p)+p.length),r=r.substr(r.indexOf(p)+p.length)):r.indexOf(d)===0?(a=r.substr(0,r.indexOf(d)+d.length),r=r.substr(r.indexOf(d)+d.length)):r.indexOf(i)===0&&(a=r.substr(0,r.indexOf(i)+i.length),r=r.substr(r.indexOf(i)+i.length));const P=r.split(d);for(let N=1;l&&N<=P.length;N++)for(let U=P.length-N;l&&U>=0;U--){l=!1;let q=P.slice(U,U+N).join(d);for(let B=0;!l&&B<t.length;B++)if(B!==S&&t[B]&&t[B].indexOf(q)>-1){const O=U+N===P.length,K=U>0&&t[B].indexOf(d)>-1?d+q:q,z=t[B].endsWith(K);l=!O||z}if(!l){let B="";(P[0].endsWith(":")||a!=="")&&(U===1&&(U=0,N++,q=P[0]+d+q),U>0&&(B=P[0]+d),B=a+B),U>0&&(B=B+C+d),B=B+q,U+N<P.length&&(B=B+d+C),$[S]=B}}l&&($[S]=y)}return $}e.$Sz=c;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function v(t,d=Object.create(null)){const $=[];let l=!1,S="";for(const y of t)if(y==="$"||l&&y==="{")S&&$.push({value:S,type:u.TEXT}),S="",l=!0;else if(y==="}"&&l){const a=d[S];if(typeof a=="string")a.length&&$.push({value:a,type:u.VARIABLE});else if(a){const r=$[$.length-1];(!r||r.type!==u.SEPARATOR)&&$.push({value:a.label,type:u.SEPARATOR})}S="",l=!1}else S+=y;return S&&!l&&$.push({value:S,type:u.TEXT}),$.filter((y,a)=>{if(y.type===u.SEPARATOR){const r=$[a-1],P=$[a+1];return[r,P].every(N=>N&&(N.type===u.VARIABLE||N.type===u.TEXT)&&N.value.length>0)}return!0}).map(y=>y.value).join("")}e.$Tz=v;function f(t,d){return F.$e||d?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$e?"&":"&&"):t.replace(/&&|&/g,$=>$==="&"?"&&":"&")}e.$Uz=f;function E(t,d){return F.$e||d?t.replace(/\(&&\w\)|&&/g,""):F.$d?t.replace(/&&|&/g,$=>$==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Vz=E;function n(t){return t.replace(/&/g,"&&")}e.$Wz=n;function o(t){if(t.endsWith("]")){const d=t.lastIndexOf(" [",t.length-2);if(d!==-1){const $=s(t.substring(0,d));return{name:$.name,parentPath:$.parentPath+t.substring(d)}}}return s(t)}e.$Xz=o;function s(t){const d=t.indexOf("/")!==-1?h.$8b:h.$7b,$=d.basename(t),l=d.dirname(t);return $.length?{name:$,parentPath:l}:{name:l,parentPath:""}}}),define(De[119],Ce([1,0,22,2]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=void 0;function h(I){return I.toJSON()}class F{constructor(w){this.a=w}transformIncoming(w){const D=this.a.transformIncoming(w);return D===w?w:h(A.URI.from(D))}transformOutgoing(w){const D=this.a.transformOutgoing(w);return D===w?w:h(A.URI.from(D))}transformOutgoingURI(w){const D=this.a.transformOutgoing(w);return D===w?w:A.URI.from(D)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$km=F,e.$lm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,w,D){if(!I||D>200)return null;if(typeof I=="object"){if(I instanceof A.URI)return w.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const p=R(I[C],w,D+1);p!==null&&(I[C]=p)}}return null}function m(I,w){const D=R(I,w,0);return D===null?I:D}e.$mm=m;function k(I,w,D,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return D?A.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof b.$Ib)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const i=k(I[p],w,D,C+1);i!==null&&(I[p]=i)}}return null}function g(I,w){const D=k(I,w,!1,0);return D===null?I:D}e.$nm=g;function L(I,w){const D=k(I,w,!0,0);return D===null?I:D}e.$om=L}),define(De[33],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(h){return b.test(h)}e.$2e=A,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(m){for(let k=0;k<m.length;k++)m[k]=Math.floor(Math.random()*256);return m};const F=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){h(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let k=0,g="";return g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g+="-",g+=R[F[k++]],g+=R[F[k++]],g+="-",g+=R[F[k++]],g+=R[F[k++]],g+="-",g+=R[F[k++]],g+=R[F[k++]],g+="-",g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g+=R[F[k++]],g}}()}),define(De[157],Ce([1,0,19,48,33]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.$0r=e.$9r=e.$8r=void 0;function F(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$8r=F;function R(I,w,D){const C={id:(0,h.$3e)(),name:I,uri:w,data:D};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.$9r=R;class m{constructor(){this.a=new Map}get size(){let w=0;for(const D of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const D=[...this.a.keys()];return A.Iterable.some(this,([C,p])=>p.asFile())&&D.push("files"),L(k(w),D)}get(w){return this.a.get(this.b(w))?.[0]}append(w,D){const C=this.a.get(w);C?C.push(D):this.a.set(this.b(w),[D])}replace(w,D){this.a.set(this.b(w),[D])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,D]of this.a)for(const C of D)yield[w,C]}b(w){return k(w)}}e.$0r=m;function k(I){return I.toLowerCase()}function g(I,w){return L(k(I),w.map(k))}e.$$r=g;function L(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const D=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[C,p,i]=D;return i==="*"?w.some(c=>c.startsWith(p+"/")):!1}e.$_r=Object.freeze({create:I=>(0,b.$of)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$_r.split(I).filter(w=>!w.startsWith("#"))})}),define(De[29],Ce([1,0,49,74,344,17,31,69,10,9,23,2]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function D(O,K=w.UNLINK,z){if((0,R.$Ke)(O))throw new Error("rimraf - will refuse to recursively delete root");return K===w.UNLINK?p(O):C(O,z)}async function C(O,K=(0,R.$Pe)((0,A.tmpdir)())){try{try{await b.promises.rename(O,K)}catch(z){return z.code==="ENOENT"?void 0:p(O)}p(K).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function p(O){return(0,h.promisify)(b.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function i(O){if((0,R.$Ke)(O))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=i;async function c(O,K){return f(await(K?u(O):(0,h.promisify)(b.readdir)(O)))}async function u(O){try{return await(0,h.promisify)(b.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const K=[],z=await c(O);for(const j of z){let he=!1,ie=!1,ne=!1;try{const V=await e.Promises.lstat((0,k.$$b)(O,j));he=V.isFile(),ie=V.isDirectory(),ne=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}K.push({name:j,isFile:()=>he,isDirectory:()=>ie,isSymbolicLink:()=>ne})}return K}function v(O){return f(b.readdirSync(O))}e.readdirSync=v;function f(O){return O.map(K=>typeof K=="string"?g.$e?(0,m.$4k)(K):K:(K.name=g.$e?(0,m.$4k)(K.name):K.name,K))}async function E(O){const K=await c(O),z=[];for(const j of K)await o.existsDirectory((0,k.$$b)(O,j))&&z.push(j);return z}function n(O,K=1e3){return new Promise(z=>{let j=!1;const he=setInterval(()=>{j||(j=!0,b.access(O,ie=>{j=!1,ie&&(clearInterval(he),z(void 0))}))},K)})}e.whenDeleted=n;var o;(function(O){async function K(he){let ie;try{if(ie=await e.Promises.lstat(he),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(he),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ne){if(ne.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(g.$d&&ne.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(he)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw V}throw ne}}O.stat=K;async function z(he){try{const{stat:ie,symbolicLink:ne}=await O.stat(he);return ie.isFile()&&ne?.dangling!==!0}catch{}return!1}O.existsFile=z;async function j(he){try{const{stat:ie,symbolicLink:ne}=await O.stat(he);return ie.isDirectory()&&ne?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(o||(e.SymlinkSupport=o={}));const s=new F.$zg;function t(O,K,z){return s.queueFor(I.URI.file(O),L.$Wf).queue(()=>{const j=y(z);return new Promise((he,ie)=>l(O,K,j,ne=>ne?ie(ne):he()))})}let d=!0;function $(O){d=O}e.configureFlushOnWrite=$;function l(O,K,z,j){if(!d)return b.writeFile(O,K,{mode:z.mode,flag:z.flag},j);b.open(O,z.flag,z.mode,(he,ie)=>{if(he)return j(he);b.writeFile(ie,K,ne=>{if(ne)return b.close(ie,()=>j(ne));b.fdatasync(ie,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),$(!1)),b.close(ie,H=>j(H))))})})}function S(O,K,z){const j=y(z);if(!d)return b.writeFileSync(O,K,{mode:j.mode,flag:j.flag});const he=b.openSync(O,j.flag,j.mode);try{b.writeFileSync(he,K);try{b.fdatasyncSync(he)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),$(!1)}}finally{b.closeSync(he)}}e.writeFileSync=S;function y(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function a(O,K){if(O!==K)try{await e.Promises.rename(O,K)}catch(z){if(O.toLowerCase()!==K.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await r(O,K,{preserveSymlinks:!1}),await D(O,w.MOVE);else throw z}}async function r(O,K,z){return N(O,K,{root:{source:O,target:K},options:z,handledSourcePaths:new Set})}const P=511;async function N(O,K,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:j,symbolicLink:he}=await o.stat(O);if(he){if(z.options.preserveSymlinks)try{return await B(O,K,z)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(he.dangling)return}return j.isDirectory()?U(O,K,j.mode&P,z):q(O,K,j.mode&P)}async function U(O,K,z,j){await e.Promises.mkdir(K,{recursive:!0,mode:z});const he=await c(O);for(const ie of he)await N((0,k.$$b)(O,ie),(0,k.$$b)(K,ie),j)}async function q(O,K,z){await e.Promises.copyFile(O,K),await e.Promises.chmod(K,z)}async function B(O,K,z){let j=await e.Promises.readlink(O);(0,R.$He)(j,z.root.source,!g.$f)&&(j=(0,k.$$b)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,K)}e.Promises=new class{get access(){return(0,h.promisify)(b.access)}get stat(){return(0,h.promisify)(b.stat)}get lstat(){return(0,h.promisify)(b.lstat)}get utimes(){return(0,h.promisify)(b.utimes)}get read(){return(O,K,z,j,he)=>new Promise((ie,ne)=>{b.read(O,K,z,j,he,(V,H,ce)=>V?ne(V):ie({bytesRead:H,buffer:ce}))})}get readFile(){return(0,h.promisify)(b.readFile)}get write(){return(O,K,z,j,he)=>new Promise((ie,ne)=>{b.write(O,K,z,j,he,(V,H,ce)=>V?ne(V):ie({bytesWritten:H,buffer:ce}))})}get appendFile(){return(0,h.promisify)(b.appendFile)}get fdatasync(){return(0,h.promisify)(b.fdatasync)}get truncate(){return(0,h.promisify)(b.truncate)}get rename(){return(0,h.promisify)(b.rename)}get copyFile(){return(0,h.promisify)(b.copyFile)}get open(){return(0,h.promisify)(b.open)}get close(){return(0,h.promisify)(b.close)}get symlink(){return(0,h.promisify)(b.symlink)}get readlink(){return(0,h.promisify)(b.readlink)}get chmod(){return(0,h.promisify)(b.chmod)}get mkdir(){return(0,h.promisify)(b.mkdir)}get unlink(){return(0,h.promisify)(b.unlink)}get rmdir(){return(0,h.promisify)(b.rmdir)}get realpath(){return(0,h.promisify)(b.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return E}get writeFile(){return t}get rm(){return D}get move(){return a}get copy(){return r}}}),define(De[95],Ce([1,0,49,10,9,11,29]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function m(w){if(h.$f)return w;const D=(0,A.$bc)(w);if(w===D)return w;const C=((0,A.$cc)(w)||w).toLowerCase();try{const i=(0,R.readdirSync)(D).filter(c=>c.toLowerCase()===C);if(i.length===1){const c=m(D);if(c)return(0,A.$$b)(c,i[0])}else if(i.length>1){const c=i.indexOf(C);if(c>=0){const u=m(D);if(u)return(0,A.$$b)(u,i[c])}}}catch{}return null}e.$Gp=m;async function k(w){if(h.$f)return w;const D=(0,A.$bc)(w);if(w===D)return w;const C=((0,A.$cc)(w)||w).toLowerCase();try{const i=(await R.Promises.readdir(D)).filter(c=>c.toLowerCase()===C);if(i.length===1){const c=await k(D);if(c)return(0,A.$$b)(c,i[0])}else if(i.length>1){const c=i.indexOf(C);if(c>=0){const u=await k(D);if(u)return(0,A.$$b)(u,i[c])}}}catch{}return null}e.$Hp=k;async function g(w){try{return await R.Promises.realpath(w)}catch{const C=I(w);return await R.Promises.access(C,b.constants.R_OK),C}}e.$Ip=g;function L(w){try{return b.realpathSync(w)}catch{const C=I(w);return b.accessSync(C,b.constants.R_OK),C}}e.$Jp=L;function I(w){return(0,F.$qd)((0,A.$9b)(w),A.sep)}}),define(De[96],Ce([1,0,10,9,39,92,12,29]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$fl=e.$el=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return F.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return F.TerminateResponseCode}});function k(I=h.env){return I.comspec||"cmd.exe"}e.$el=k;function g(I){let w=[],D=!1;const C=function(p){if(D){w.push(p);return}(!I.send(p,c=>{if(c&&console.error(c),D=!1,w.length>0){const u=w.slice(0);w=[],u.forEach(v=>C(v))}})||A.$d)&&(D=!0)};return{send:C}}e.$fl=g;var L;(function(I){async function w(D,C,p){if(b.$0b(D))return D;if(C===void 0&&(C=h.cwd()),b.$bc(D)!=="."||(p===void 0&&R.$ge(h.env.PATH)&&(p=h.env.PATH.split(b.$ic)),p===void 0||p.length===0))return b.$$b(C,D);async function c(u){if(await m.Promises.exists(u)){let v;try{v=await m.Promises.stat(u)}catch(f){f.message.startsWith("EACCES")&&(v=await m.Promises.lstat(u))}return v?!v.isDirectory():!1}return!1}for(const u of p){let v;if(b.$0b(u)?v=b.$$b(u,D):v=b.$$b(C,u,D),await c(v))return v;let f=v+".com";if(await c(f)||(f=v+".exe",await c(f)))return f}return b.$$b(C,D)}I.findExecutable=w})(L||(e.win32=L={}))});var He=this&&this.__decorate||function(re,e,b,A){var h=arguments.length,F=h<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,b):A,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(re,e,b,A);else for(var m=re.length-1;m>=0;m--)(R=re[m])&&(F=(h<3?R(F):h>3?R(e,b,F):R(e,b))||F);return h>3&&F&&Object.defineProperty(e,b,F),F};define(De[75],Ce([1,0,19,17,22,21,66,8,3,4,73,11,12]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.ProxyChannel=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.RequestInitiator=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0;var D;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(D||(D={}));function C(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(p||(p={}));function i(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(c||(c={}));function u(ie){let ne=0;for(let V=0;;V+=7){const H=ie.read(1);if(ne|=(H.buffer[0]&127)<<V,!(H.buffer[0]&128))return ne}}const v=s(0);function f(ie,ne){if(ne===0){ie.write(v);return}let V=0;for(let ce=ne;ce!==0;ce=ce>>>7)V++;const H=h.$Ib.alloc(V);for(let ce=0;ne!==0;ce++)H.buffer[ce]=ne&127,ne=ne>>>7,ne>0&&(H.buffer[ce]|=128);ie.write(H)}class E{constructor(ne){this.b=ne,this.a=0}read(ne){const V=this.b.slice(this.a,this.a+ne);return this.a+=V.byteLength,V}}e.$Vg=E;class n{constructor(){this.a=[]}get buffer(){return h.$Ib.concat(this.a)}write(ne){this.a.push(ne)}}e.$Wg=n;var o;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(o||(o={}));function s(ie){const ne=h.$Ib.alloc(1);return ne.writeUInt8(ie,0),ne}const t={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},d=typeof Buffer<"u";function $(ie,ne){if(typeof ne>"u")ie.write(t.Undefined);else if(typeof ne=="string"){const V=h.$Ib.fromString(ne);ie.write(t.String),f(ie,V.byteLength),ie.write(V)}else if(d&&Buffer.isBuffer(ne)){const V=h.$Ib.wrap(ne);ie.write(t.Buffer),f(ie,V.byteLength),ie.write(V)}else if(ne instanceof h.$Ib)ie.write(t.VSBuffer),f(ie,ne.byteLength),ie.write(ne);else if(Array.isArray(ne)){ie.write(t.Array),f(ie,ne.length);for(const V of ne)$(ie,V)}else if(typeof ne=="number"&&(ne|0)===ne)ie.write(t.Uint),f(ie,ne);else{const V=h.$Ib.fromString(JSON.stringify(ne));ie.write(t.Object),f(ie,V.byteLength),ie.write(V)}}e.$Xg=$;function l(ie){switch(ie.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ie.read(u(ie)).toString();case o.Buffer:return ie.read(u(ie)).buffer;case o.VSBuffer:return ie.read(u(ie));case o.Array:{const V=u(ie),H=[];for(let ce=0;ce<V;ce++)H.push(l(ie));return H}case o.Object:return JSON.parse(ie.read(u(ie)).toString());case o.Int:return u(ie)}}e.$Yg=l;class S{constructor(ne,V,H=null,ce=1e3){this.h=ne,this.j=V,this.k=H,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(ne,V){this.b.set(ne,V),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const V=this.o([ne.type]);this.k?.logOutgoing(V,0,1,i(ne.type));return}case 201:case 202:case 204:case 203:{const V=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(V,ne.id,1,i(ne.type),ne.data);return}}}o(ne,V=void 0){const H=new n;return $(H,ne),$(H,V),this.p(H.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const V=new E(ne),H=l(V),ce=l(V),pe=H[0];switch(pe){case 100:return this.k?.logIncoming(ne.byteLength,H[1],1,`${C(pe)}: ${H[2]}.${H[3]}`,ce),this.s({type:pe,id:H[1],channelName:H[2],name:H[3],arg:ce});case 102:return this.k?.logIncoming(ne.byteLength,H[1],1,`${C(pe)}: ${H[2]}.${H[3]}`,ce),this.t({type:pe,id:H[1],channelName:H[2],name:H[3],arg:ce});case 101:return this.k?.logIncoming(ne.byteLength,H[1],1,`${C(pe)}`),this.u({type:pe,id:H[1]});case 103:return this.k?.logIncoming(ne.byteLength,H[1],1,`${C(pe)}`),this.u({type:pe,id:H[1]})}}s(ne){const V=this.b.get(ne.channelName);if(!V){this.v(ne);return}const H=new F.$bd;let ce;try{ce=V.call(this.j,ne.name,ne.arg,H.token)}catch(ge){ce=Promise.reject(ge)}const pe=ne.id;ce.then(ge=>{this.m({id:pe,data:ge,type:201}),this.d.delete(ne.id)},ge=>{ge instanceof Error?this.m({id:pe,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:pe,data:ge,type:203}),this.d.delete(ne.id)});const ye=(0,g.$ib)(()=>H.cancel());this.d.set(ne.id,ye)}t(ne){const V=this.b.get(ne.channelName);if(!V){this.v(ne);return}const H=ne.id,pe=V.listen(this.j,ne.name,ne.arg)(ye=>this.m({id:H,data:ye,type:204}));this.d.set(ne.id,pe)}u(ne){const V=this.d.get(ne.id);V&&(V.dispose(),this.d.delete(ne.id))}v(ne){let V=this.g.get(ne.channelName);V||(V=[],this.g.set(ne.channelName,V));const H=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:ne,timeoutTimer:H})}w(ne){const V=this.g.get(ne);if(V){for(const H of V)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$fb)(this.d.values()),this.d.clear()}}e.$Zg=S;var y;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class a{constructor(ne,V=null){this.l=ne,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$5c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=V}getChannel(ne){const V=this;return{call(H,ce,pe){return V.a?Promise.reject(new m.$2):V.m(ne,H,ce,pe)},listen(H,ce){return V.a?k.Event.None:V.o(ne,H,ce)}}}m(ne,V,H,ce=F.CancellationToken.None){const pe=this.g++,ge={id:pe,type:100,channelName:ne,name:V,arg:H};if(ce.isCancellationRequested)return Promise.reject(new m.$2);let M;return new Promise((ve,Se)=>{if(ce.isCancellationRequested)return Se(new m.$2);const ee=()=>{const ue=se=>{switch(se.type){case 201:this.f.delete(pe),ve(se.data);break;case 202:{this.f.delete(pe);const oe=new Error(se.data.message);oe.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,oe.name=se.data.name,Se(oe);break}case 203:this.f.delete(pe),Se(se.data);break}};this.f.set(pe,ue),this.p(ge)};let te=null;this.b===c.Idle?ee():(te=(0,A.$fg)(ue=>this.u()),te.then(()=>{te=null,ee()}));const le=()=>{te?(te.cancel(),te=null):this.p({id:pe,type:101}),Se(new m.$2)},X=ce.onCancellationRequested(le);M=(0,g.$hb)((0,g.$ib)(le),X),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(ne,V,H){const ce=this.g++,ye={id:ce,type:102,channelName:ne,name:V,arg:H};let ge=null;const M=new k.$5c({onWillAddFirstListener:()=>{ge=(0,A.$fg)(ve=>this.u()),ge.then(()=>{ge=null,this.d.add(M),this.p(ye)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(M),this.p({id:ce,type:103}))}}),Y=ve=>M.fire(ve.data);return this.f.set(ce,Y),M.event}p(ne){switch(ne.type){case 100:case 102:{const V=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(V,ne.id,0,`${C(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const V=this.q([ne.type,ne.id]);this.j?.logOutgoing(V,ne.id,0,C(ne.type));return}}}q(ne,V=void 0){const H=new n;return $(H,ne),$(H,V),this.r(H.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const V=new E(ne),H=l(V),ce=l(V),pe=H[0];switch(pe){case 200:return this.j?.logIncoming(ne.byteLength,0,0,i(pe)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,H[1],0,i(pe),ce),this.t({type:H[0],id:H[1],data:ce})}}t(ne){if(ne.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$fb)(this.d.values()),this.d.clear()}}e.$1g=a,He([R.$Pg],a.prototype,"onDidInitializePromise",null);class r{get connections(){const ne=[];return this.f.forEach(V=>ne.push(V)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new k.$5c,this.onDidAddConnection=this.g.event,this.h=new k.$5c,this.onDidRemoveConnection=this.h.event,ne(({protocol:V,onDidClientDisconnect:H})=>{k.Event.once(V.onMessage)(pe=>{const ye=new E(pe),ge=l(ye),M=new S(V,ge),Y=new a(V);this.a.forEach((Se,ee)=>M.registerChannel(ee,Se));const ve={channelServer:M,channelClient:Y,ctx:ge};this.f.add(ve),this.g.fire(ve),H(()=>{M.dispose(),Y.dispose(),this.f.delete(ve),this.h.fire(ve)})})})}getChannel(ne,V){const H=this;return{call(ce,pe,ye){let ge;if((0,w.$ue)(V)){const Y=(0,b.$Hf)(H.connections.filter(V));ge=Y?Promise.resolve(Y):k.Event.toPromise(k.Event.filter(H.onDidAddConnection,V))}else ge=V.routeCall(H,ce,pe);const M=ge.then(Y=>Y.channelClient.getChannel(ne));return N(M).call(ce,pe,ye)},listen(ce,pe){if((0,w.$ue)(V))return H.j(ne,V,ce,pe);const ye=V.routeEvent(H,ce,pe).then(ge=>ge.channelClient.getChannel(ne));return N(ye).listen(ce,pe)}}}j(ne,V,H,ce){const pe=this;let ye=new g.$jb;const ge=new k.$5c({onWillAddFirstListener:()=>{ye=new g.$jb;const M=new k.$$c,Y=new Map,ve=ee=>{const le=ee.channelClient.getChannel(ne).listen(H,ce),X=M.add(le);Y.set(ee,X)},Se=ee=>{const te=Y.get(ee);te&&(te.dispose(),Y.delete(ee))};pe.connections.filter(V).forEach(ve),k.Event.filter(pe.onDidAddConnection,V)(ve,void 0,ye),pe.onDidRemoveConnection(Se,void 0,ye),M.event(ge.fire,ge,ye),ye.add(M)},onDidRemoveLastListener:()=>{ye.dispose()}});return ge.event}registerChannel(ne,V){this.a.set(ne,V),this.f.forEach(H=>{H.channelServer.registerChannel(ne,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$2g=r;class P{constructor(ne,V,H=null){const ce=new n;$(ce,V),ne.send(ce.buffer),this.a=new a(ne,H),this.d=new S(ne,V,H)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,V){this.d.registerChannel(ne,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$3g=P;function N(ie){return{call(ne,V,H){return ie.then(ce=>ce.call(ne,V,H))},listen(ne,V){const H=new k.$ad;return ie.then(ce=>H.input=ce.listen(ne,V)),H.event}}}e.$4g=N;function U(ie){let ne=!1;return{call(V,H,ce){return ne?ie.call(V,H,ce):(0,A.$sg)(0).then(()=>ne=!0).then(()=>ie.call(V,H,ce))},listen(V,H){if(ne)return ie.listen(V,H);const ce=new k.$ad;return(0,A.$sg)(0).then(()=>ne=!0).then(()=>ce.input=ie.listen(V,H)),ce.event}}}e.$5g=U;class q{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const V of ne.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await k.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}e.$6g=q;var B;(function(ie){function ne(pe,ye){const ge=pe,M=ye&&ye.disableMarshalling,Y=new Map;for(const ve in ge)H(ve)&&Y.set(ve,k.Event.buffer(ge[ve],!0));return new class{listen(ve,Se,ee){const te=Y.get(Se);if(te)return te;if(ce(Se)){const le=ge[Se];if(typeof le=="function")return le.call(ge,ee)}throw new Error(`Event not found: ${Se}`)}call(ve,Se,ee){const te=ge[Se];if(typeof te=="function"){if(!M&&Array.isArray(ee))for(let le=0;le<ee.length;le++)ee[le]=(0,L.$Ug)(ee[le]);return te.apply(ge,ee)}throw new Error(`Method not found: ${Se}`)}}}ie.fromService=ne;function V(pe,ye){const ge=ye&&ye.disableMarshalling;return new Proxy({},{get(M,Y){if(typeof Y=="string")return ye?.properties?.has(Y)?ye.properties.get(Y):ce(Y)?function(ve){return pe.listen(Y,ve)}:H(Y)?pe.listen(Y):async function(...ve){let Se;ye&&!(0,w.$pe)(ye.context)?Se=[ye.context,...ve]:Se=ve;const ee=await pe.call(Y,Se);return ge?ee:(0,L.$Ug)(ee)};throw new Error(`Property not found: ${String(Y)}`)}})}ie.toService=V;function H(pe){return pe[0]==="o"&&pe[1]==="n"&&I.$Id(pe.charCodeAt(2))}function ce(pe){return/^onDynamic/.test(pe)&&I.$Id(pe.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const ne=ie.toString();if(ne!=="[object Object]")return ne}return ie}function z(ie){return Array.isArray(ie)?ie.map(K):K(ie)}function j(ie,ne,V,H,ce,pe,ye){ye=z(ye);const ge=O[ce],M=ge[H%ge.length];let Y=[`%c[${ie}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(pe)?(Y=Y.concat(ye),Y.push(")")):Y.push(ye),console.log.apply(console,Y)}class he{constructor(ne,V){this.d=ne,this.f=V,this.a=0,this.b=0}logOutgoing(ne,V,H,ce,pe){this.b+=ne,j(this.d,this.b,ne,V,H,ce,pe)}logIncoming(ne,V,H,ce,pe){this.a+=ne,j(this.f,this.a,ne,V,H,ce,pe)}}e.$7g=he}),define(De[120],Ce([1,0,22,3,4,75]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_g=e.$$g=e.$0g=e.$9g=e.ProtocolConstants=e.$8g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var m;(function(t){t.enableDiagnostics=!1,t.records=[];const d=new WeakMap;let $=0;function l(y,a){if(!d.has(y)){const r=String(++$);d.set(y,r)}return d.get(y)}function S(y,a,r,P){if(!t.enableDiagnostics)return;const N=l(y,a);if(P instanceof b.$Ib||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=b.$Ib.alloc(P.byteLength);U.set(P),t.records.push({timestamp:Date.now(),id:N,label:a,type:r,buff:U})}else t.records.push({timestamp:Date.now(),id:N,label:a,type:r,data:P})}t.traceSocketEvent=S})(m||(e.SocketDiagnostics=m={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function L(){return g||(g=b.$Ib.alloc(0)),g}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(d){this.a.push(d),this.b+=d.byteLength}read(d){return this.c(d,!0)}peek(d){return this.c(d,!1)}c(d,$){if(d===0)return L();if(d>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===d){const a=this.a[0];return $&&(this.a.shift(),this.b-=d),a}if(this.a[0].byteLength>d){const a=this.a[0].slice(0,d);return $&&(this.a[0]=this.a[0].slice(d),this.b-=d),a}const l=b.$Ib.alloc(d);let S=0,y=0;for(;d>0;){const a=this.a[y];if(a.byteLength>d){const r=a.slice(0,d);l.set(r,S),S+=d,$&&(this.a[y]=a.slice(d),this.b-=d),d-=d}else l.set(a,S),S+=a.byteLength,$?(this.a.shift(),this.b-=a.byteLength):y++,d-=a.byteLength}return l}}e.$8g=I;var w;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(w||(w={}));function D(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class p{constructor(d,$,l,S){this.type=d,this.id=$,this.ack=l,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class i extends h.$kb{constructor(d){super(),this.f=this.B(new A.$5c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=d,this.b=!1,this.c=new I,this.B(this.a.onData($=>this.acceptChunk($))),this.lastReadTime=Date.now()}acceptChunk(d){if(!(!d||d.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(d);this.c.byteLength>=this.g.readLen;){const $=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=$.readUInt32BE(9),this.g.messageType=$.readUInt8(0),this.g.id=$.readUInt32BE(1),this.g.ack=$.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,S=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",$),this.f.fire(new p(l,S,y,$)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(d){this.k=null,this.a=!1,this.b=!1,this.c=d,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(d){if(this.a)return;d.writtenTime=Date.now(),this.lastWriteTime=Date.now();const $=b.$Ib.alloc(13);$.writeUInt8(d.type,0),$.writeUInt32BE(d.id,1),$.writeUInt32BE(d.ack,5),$.writeUInt32BE(d.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(d.type),id:d.id,ack:d.ack,messageSize:d.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",d.data),this.j($,d.data)}g(d,$){const l=this.f===0;return this.d.push(d,$),this.f+=d.byteLength+$.byteLength,l}h(){const d=b.$Ib.concat(this.d,this.f);return this.d.length=0,this.f=0,d}j(d,$){this.g(d,$)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const d=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:d.byteLength}),this.c.write(d)}}class u extends h.$kb{constructor(d){super(),this.f=new A.$5c,this.onMessage=this.f.event,this.g=new A.$5c,this.onDidDispose=this.g.event,this.a=d,this.b=this.B(new c(this.a)),this.c=this.B(new i(this.a)),this.B(this.c.onMessage($=>{$.type===1&&this.f.fire($.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(d){this.b.write(new p(1,0,0,d))}}e.$9g=u;class v extends F.$3g{static fromSocket(d,$){return new v(new u(d),$)}get onDidDispose(){return this.b.onDidDispose}constructor(d,$,l=null){super(d,$,l),this.b=d}dispose(){super.dispose();const d=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),d.end()}}e.$0g=v;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$5c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(d){this.b?this.d.length>0?this.d.push(d):this.a.fire(d):this.d.push(d)}flushBuffer(){this.d=[]}}e.$$g=f;class E{constructor(d){this.data=d,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let d=0,$=this.a;for(;$;)$=$.next,d++;return d}peek(){return this.a?this.a.data:null}toArray(){const d=[];let $=0,l=this.a;for(;l;)d[$++]=l.data,l=l.next;return d}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(d){const $=new E(d);if(!this.a){this.a=$,this.b=$;return}this.b.next=$,this.b=$}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const d=Date.now();for(let $=0;$<o.a;$++)this.c[$]=d-1e3*$;setInterval(()=>{for(let $=o.a;$>=1;$--)this.c[$]=this.c[$-1];this.c[0]=Date.now()},1e3)}d(){const d=Date.now(),$=(1+o.a)*1e3;let l=0;for(let S=0;S<o.a;S++)d-this.c[S]<=$&&l++;return 1-l/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class s{get unacknowledgedCount(){return this.c-this.d}constructor(d){this.u=new f,this.onControlMessage=this.u.event,this.v=new f,this.onMessage=this.v.event,this.w=new f,this.onDidDispose=this.w.event,this.x=new f,this.onSocketClose=this.x.event,this.y=new f,this.onSocketTimeout=this.y.event,this.s=d.loadEstimator??o.getInstance(),this.t=d.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$jb,this.o=d.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new i(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),d.initialChunk&&this.q.acceptChunk(d.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const d=new p(5,0,0,L());this.p.write(d),this.p.flush()}sendPause(){const d=new p(7,0,0,L());this.p.write(d)}sendResume(){const d=new p(8,0,0,L());this.p.write(d)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(d,$){this.a=!0,this.r.dispose(),this.r=new h.$jb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=d,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new i(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk($)}endAcceptReconnection(){this.a=!1,this.h=this.g;const d=new p(3,0,this.h,L());this.p.write(d);const $=this.b.toArray();for(let l=0,S=$.length;l<S;l++)this.p.write($[l]);this.B()}acceptDisconnect(){this.w.fire()}z(d){if(d.ack>this.d){this.d=d.ack;do{const $=this.b.peek();if($&&$.id<=d.ack)this.b.pop();else break}while(!0)}switch(d.type){case 0:break;case 1:{if(d.id>this.g)if(d.id!==this.g+1){const $=Date.now();$-this.m>1e4&&(this.m=$,this.p.write(new p(6,0,0,L())))}else this.g=d.id,this.j=Date.now(),this.A(),this.v.fire(d.data);break}case 2:{this.u.fire(d.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const $=this.b.toArray();for(let l=0,S=$.length;l<S;l++)this.p.write($[l]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(d){const $=++this.c;this.h=this.g;const l=new p(1,$,this.h,d);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(d){const $=new p(2,0,0,d);this.p.write($)}A(){if(this.g<=this.h||this.k)return;const d=Date.now()-this.j;if(d>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-d+5)}B(){if(this.c<=this.d||this.f||this.a)return;const d=this.b.peek(),$=Date.now()-d.writtenTime,l=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if($>=2e4&&l>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:$,timeSinceLastReceivedSomeData:l});return}const y=Math.max(2e4-$,2e4-l,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const d=new p(3,0,this.h,L());this.p.write(d)}D(){this.h=this.g;const d=new p(9,0,this.h,L());this.p.write(d)}}e.$_g=s}),define(De[158],Ce([1,0,45,17,22,21,156,8,3,4,24,96,92,75]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=void 0;class C extends D.$Zg{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",u=>h.$Ib.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Dp=C;class p{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new k.$5c,this.onDidProcessExit=this.h.event;const v=u&&u.timeout?u.timeout:6e4;this.b=new A.$og(v),this.d=null,this.f=null}getChannel(c){const u=this;return{call(v,f,E){return u.k(c,v,f,E)},listen(v,f){return u.l(c,v,f)}}}k(c,u,v,f=F.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(m.$3());this.b.cancel();const E=this.n(c),n=(0,A.$fg)(t=>E.call(u,v,t)),o=f.onCancellationRequested(()=>n.cancel()),s=(0,g.$ib)(()=>n.cancel());return this.c.add(s),n.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,u,v){if(!this.b)return k.Event.None;this.b.cancel();let f;const E=new k.$5c({onWillAddFirstListener:()=>{f=this.n(c).listen(u,v)(E.fire,E),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,L.$Em)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d)).filter(d=>!d.startsWith("--vscode-"))),(0,w.$dl)(u.env),this.d=(0,b.fork)(this.i,c,u);const v=new k.$5c;k.Event.fromNodeEventEmitter(this.d,"message",d=>d)(d=>{if((0,R.$zp)(d)){(0,R.log)(d,`IPC Library: ${this.j.serverName}`);return}v.fire(h.$Ib.wrap(Buffer.from(d,"base64")))});const E=this.j.useQueue?(0,I.$fl)(this.d):this.d,n=d=>this.d&&this.d.connected&&E.send(d.buffer.toString("base64")),o=v.event,s={send:n,onMessage:o};this.f=new D.$1g(s);const t=()=>this.o();process.once("exit",t),this.d.on("error",d=>console.warn('IPC "'+this.j.serverName+'" errored with '+d)),this.d.on("exit",(d,$)=>{process.removeListener("exit",t),this.c.forEach(l=>(0,g.$fb)(l)),this.c.clear(),d!==0&&$!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+d+" and signal "+$),this.b?.cancel(),this.o(),this.h.fire({code:d,signal:$})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Ep=p}),define(De[121],Ce([1,0,117]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=void 0;class A{constructor(m){const k=(0,b.$fd)(m);this.c=k,this.a=A.d(k),this.b=new Map}static d(m){const k=new Uint8Array(256);return k.fill(m),k}set(m,k){const g=(0,b.$fd)(k);m>=0&&m<256?this.a[m]=g:this.b.set(m,g)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Zr=A;var h;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(h||(h={}));class F{constructor(){this.a=new A(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$1r=F}),define(De[56],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;class b{constructor(h,F){this.lineNumber=h,this.column=F}with(h=this.lineNumber,F=this.column){return h===this.lineNumber&&F===this.column?this:new b(h,F)}delta(h=0,F=0){return this.with(this.lineNumber+h,this.column+F)}equals(h){return b.equals(this,h)}static equals(h,F){return!h&&!F?!0:!!h&&!!F&&h.lineNumber===F.lineNumber&&h.column===F.column}isBefore(h){return b.isBefore(this,h)}static isBefore(h,F){return h.lineNumber<F.lineNumber?!0:F.lineNumber<h.lineNumber?!1:h.column<F.column}isBeforeOrEqual(h){return b.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,F){return h.lineNumber<F.lineNumber?!0:F.lineNumber<h.lineNumber?!1:h.column<=F.column}static compare(h,F){const R=h.lineNumber|0,m=F.lineNumber|0;if(R===m){const k=h.column|0,g=F.column|0;return k-g}return R-m}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new b(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.$Kr=b}),define(De[36],Ce([1,0,56]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class A{constructor(F,R,m,k){F>m||F===m&&R>k?(this.startLineNumber=m,this.startColumn=k,this.endLineNumber=F,this.endColumn=R):(this.startLineNumber=F,this.startColumn=R,this.endLineNumber=m,this.endColumn=k)}isEmpty(){return A.isEmpty(this)}static isEmpty(F){return F.startLineNumber===F.endLineNumber&&F.startColumn===F.endColumn}containsPosition(F){return A.containsPosition(this,F)}static containsPosition(F,R){return!(R.lineNumber<F.startLineNumber||R.lineNumber>F.endLineNumber||R.lineNumber===F.startLineNumber&&R.column<F.startColumn||R.lineNumber===F.endLineNumber&&R.column>F.endColumn)}static strictContainsPosition(F,R){return!(R.lineNumber<F.startLineNumber||R.lineNumber>F.endLineNumber||R.lineNumber===F.startLineNumber&&R.column<=F.startColumn||R.lineNumber===F.endLineNumber&&R.column>=F.endColumn)}containsRange(F){return A.containsRange(this,F)}static containsRange(F,R){return!(R.startLineNumber<F.startLineNumber||R.endLineNumber<F.startLineNumber||R.startLineNumber>F.endLineNumber||R.endLineNumber>F.endLineNumber||R.startLineNumber===F.startLineNumber&&R.startColumn<F.startColumn||R.endLineNumber===F.endLineNumber&&R.endColumn>F.endColumn)}strictContainsRange(F){return A.strictContainsRange(this,F)}static strictContainsRange(F,R){return!(R.startLineNumber<F.startLineNumber||R.endLineNumber<F.startLineNumber||R.startLineNumber>F.endLineNumber||R.endLineNumber>F.endLineNumber||R.startLineNumber===F.startLineNumber&&R.startColumn<=F.startColumn||R.endLineNumber===F.endLineNumber&&R.endColumn>=F.endColumn)}plusRange(F){return A.plusRange(this,F)}static plusRange(F,R){let m,k,g,L;return R.startLineNumber<F.startLineNumber?(m=R.startLineNumber,k=R.startColumn):R.startLineNumber===F.startLineNumber?(m=R.startLineNumber,k=Math.min(R.startColumn,F.startColumn)):(m=F.startLineNumber,k=F.startColumn),R.endLineNumber>F.endLineNumber?(g=R.endLineNumber,L=R.endColumn):R.endLineNumber===F.endLineNumber?(g=R.endLineNumber,L=Math.max(R.endColumn,F.endColumn)):(g=F.endLineNumber,L=F.endColumn),new A(m,k,g,L)}intersectRanges(F){return A.intersectRanges(this,F)}static intersectRanges(F,R){let m=F.startLineNumber,k=F.startColumn,g=F.endLineNumber,L=F.endColumn;const I=R.startLineNumber,w=R.startColumn,D=R.endLineNumber,C=R.endColumn;return m<I?(m=I,k=w):m===I&&(k=Math.max(k,w)),g>D?(g=D,L=C):g===D&&(L=Math.min(L,C)),m>g||m===g&&k>L?null:new A(m,k,g,L)}equalsRange(F){return A.equalsRange(this,F)}static equalsRange(F,R){return!F&&!R?!0:!!F&&!!R&&F.startLineNumber===R.startLineNumber&&F.startColumn===R.startColumn&&F.endLineNumber===R.endLineNumber&&F.endColumn===R.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(F){return new b.$Kr(F.endLineNumber,F.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(F){return new b.$Kr(F.startLineNumber,F.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(F,R){return new A(this.startLineNumber,this.startColumn,F,R)}setStartPosition(F,R){return new A(F,R,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(F){return new A(F.startLineNumber,F.startColumn,F.startLineNumber,F.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(F){return new A(F.endLineNumber,F.endColumn,F.endLineNumber,F.endColumn)}delta(F){return new A(this.startLineNumber+F,this.startColumn,this.endLineNumber+F,this.endColumn)}static fromPositions(F,R=F){return new A(F.lineNumber,F.column,R.lineNumber,R.column)}static lift(F){return F?new A(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn):null}static isIRange(F){return F&&typeof F.startLineNumber=="number"&&typeof F.startColumn=="number"&&typeof F.endLineNumber=="number"&&typeof F.endColumn=="number"}static areIntersectingOrTouching(F,R){return!(F.endLineNumber<R.startLineNumber||F.endLineNumber===R.startLineNumber&&F.endColumn<R.startColumn||R.endLineNumber<F.startLineNumber||R.endLineNumber===F.startLineNumber&&R.endColumn<F.startColumn)}static areIntersecting(F,R){return!(F.endLineNumber<R.startLineNumber||F.endLineNumber===R.startLineNumber&&F.endColumn<=R.startColumn||R.endLineNumber<F.startLineNumber||R.endLineNumber===F.startLineNumber&&R.endColumn<=F.startColumn)}static compareRangesUsingStarts(F,R){if(F&&R){const g=F.startLineNumber|0,L=R.startLineNumber|0;if(g===L){const I=F.startColumn|0,w=R.startColumn|0;if(I===w){const D=F.endLineNumber|0,C=R.endLineNumber|0;if(D===C){const p=F.endColumn|0,i=R.endColumn|0;return p-i}return D-C}return I-w}return g-L}return(F?1:0)-(R?1:0)}static compareRangesUsingEnds(F,R){return F.endLineNumber===R.endLineNumber?F.endColumn===R.endColumn?F.startLineNumber===R.startLineNumber?F.startColumn-R.startColumn:F.startLineNumber-R.startLineNumber:F.endColumn-R.endColumn:F.endLineNumber-R.endLineNumber}static spansMultipleLines(F){return F.endLineNumber>F.startLineNumber}toJSON(){return this}}e.$Lr=A}),define(De[159],Ce([1,0,56,36]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.SelectionDirection=void 0;var h;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class F extends A.$Lr{constructor(m,k,g,L){super(m,k,g,L),this.selectionStartLineNumber=m,this.selectionStartColumn=k,this.positionLineNumber=g,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return F.selectionsEqual(this,m)}static selectionsEqual(m,k){return m.selectionStartLineNumber===k.selectionStartLineNumber&&m.selectionStartColumn===k.selectionStartColumn&&m.positionLineNumber===k.positionLineNumber&&m.positionColumn===k.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,k){return this.getDirection()===0?new F(this.startLineNumber,this.startColumn,m,k):new F(m,k,this.startLineNumber,this.startColumn)}getPosition(){return new b.$Kr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new b.$Kr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,k){return this.getDirection()===0?new F(m,k,this.endLineNumber,this.endColumn):new F(this.endLineNumber,this.endColumn,m,k)}static fromPositions(m,k=m){return new F(m.lineNumber,m.column,k.lineNumber,k.column)}static fromRange(m,k){return k===0?new F(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new F(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new F(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,k){if(m&&!k||!m&&k)return!1;if(!m&&!k)return!0;if(m.length!==k.length)return!1;for(let g=0,L=m.length;g<L;g++)if(!this.selectionsEqual(m[g],k[g]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,k,g,L,I){return I===0?new F(m,k,g,L):new F(g,L,m,k)}}e.$Tr=F}),define(De[160],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0,e.$Er={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[161],Ce([1,0,121]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.WordCharacterClass=void 0;var A;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class h extends b.$Zr{constructor(m){super(0);for(let k=0,g=m.length;k<g;k++)this.set(m.charCodeAt(k),2);this.set(32,1),this.set(9,1)}}e.$2r=h;function F(R){const m={};return k=>(m.hasOwnProperty(k)||(m[k]=R(k)),m[k])}e.$3r=F(R=>new h(R))}),define(De[122],Ce([1,0,48,4,68]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0,e.$Fr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function F(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.$Fr)I.indexOf(D)>=0||(w+="\\"+D);return w+="\\s]+)",new RegExp(w,"g")}e.$Gr=F();function R(I){let w=e.$Gr;if(I&&I instanceof RegExp)if(I.global)w=I;else{let D="g";I.ignoreCase&&(D+="i"),I.multiline&&(D+="m"),I.unicode&&(D+="u"),w=new RegExp(I.source,D)}return w.lastIndex=0,w}e.$Hr=R;const m=new h.$jc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function k(I){const w=m.unshift(I);return(0,A.$ib)(w)}e.$Ir=k;function g(I,w,D,C,p){if(p||(p=b.Iterable.first(m)),D.length>p.maxLen){let f=I-p.maxLen/2;return f<0?f=0:C+=f,D=D.substring(f,I+p.maxLen/2),g(I,w,D,C,p)}const i=Date.now(),c=I-1-C;let u=-1,v=null;for(let f=1;!(Date.now()-i>=p.timeBudget);f++){const E=c-p.windowSize*f;w.lastIndex=Math.max(0,E);const n=L(w,D,c,u);if(!n&&v||(v=n,E<=0))break;u=E}if(v){const f={word:v[0],startColumn:C+1+v.index,endColumn:C+1+v.index+v[0].length};return w.lastIndex=0,f}return null}e.$Jr=g;function L(I,w,D,C){let p;for(;p=I.exec(w);){const i=p.index||0;if(i<=D&&I.lastIndex>=D)return p;if(C>0&&i>C)return null}return null}}),define(De[162],Ce([1,0,32,10]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yE=void 0;function h(F,R,m,k,g,L){if(Array.isArray(F)){let I=0;for(const w of F){const D=h(w,R,m,k,g,L);if(D===10)return D;D>I&&(I=D)}return I}else{if(typeof F=="string")return k?F==="*"?5:F===m?10:0:0;if(F){const{language:I,pattern:w,scheme:D,hasAccessToAllModels:C,notebookType:p}=F;if(!k&&!C)return 0;p&&g&&(R=g);let i=0;if(D)if(D===R.scheme)i=10;else if(D==="*")i=5;else return 0;if(I)if(I===m)i=10;else if(I==="*")i=Math.max(i,5);else return 0;if(p)if(p===L)i=10;else if(p==="*"&&L!==void 0)i=Math.max(i,5);else return 0;if(w){let c;if(typeof w=="string"?c=w:c={...w,base:(0,A.$9b)(w.base)},c===R.fsPath||(0,b.$_i)(c,R.fsPath))i=10;else return 0}return i}else return 0}}e.$yE=h}),define(De[163],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=e.$vs=e.IndentAction=void 0;var b;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(b||(e.IndentAction=b={}));class A{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let k=0,g=m.notIn.length;k<g;k++)switch(m.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,k){if(m.getTokenCount()===0)return!0;const g=m.findTokenIndexAtOffset(k-2),L=m.getStandardTokenType(g);return this.isOK(L)}g(m,k){for(let g=m;g<=k;g++){const L=String.fromCharCode(g);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vs=A;class h{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of m)F(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),F(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),F(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),F(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&F(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$ws=h;function F(R,m,k){R.has(m)?R.get(m).push(k):R.set(m,[k])}}),define(De[164],Ce([1,0,121]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FW=e.$EW=e.$DW=e.State=void 0;var A;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class h{constructor(C,p,i){const c=new Uint8Array(C*p);for(let u=0,v=C*p;u<v;u++)c[u]=i;this.a=c,this.rows=C,this.cols=p}get(C,p){return this.a[C*this.cols+p]}set(C,p,i){this.a[C*this.cols+p]=i}}class F{constructor(C){let p=0,i=0;for(let u=0,v=C.length;u<v;u++){const[f,E,n]=C[u];E>p&&(p=E),f>i&&(i=f),n>i&&(i=n)}p++,i++;const c=new h(i,p,0);for(let u=0,v=C.length;u<v;u++){const[f,E,n]=C[u];c.set(f,E,n)}this.a=c,this.b=p}nextState(C,p){return p<0||p>=this.b?0:this.a.get(C,p)}}e.$DW=F;let R=null;function m(){return R===null&&(R=new F([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var k;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(k||(k={}));let g=null;function L(){if(g===null){g=new b.$Zr(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<D.length;p++)g.set(D.charCodeAt(p),1);const C=".,;:";for(let p=0;p<C.length;p++)g.set(C.charCodeAt(p),2)}return g}class I{static a(C,p,i,c,u){let v=u-1;do{const f=p.charCodeAt(v);if(C.get(f)!==2)break;v--}while(v>c);if(c>0){const f=p.charCodeAt(c-1),E=p.charCodeAt(v);(f===40&&E===41||f===91&&E===93||f===123&&E===125)&&v--}return{range:{startLineNumber:i,startColumn:c+1,endLineNumber:i,endColumn:v+2},url:p.substring(c,v+1)}}static computeLinks(C,p=m()){const i=L(),c=[];for(let u=1,v=C.getLineCount();u<=v;u++){const f=C.getLineContent(u),E=f.length;let n=0,o=0,s=0,t=1,d=!1,$=!1,l=!1,S=!1;for(;n<E;){let y=!1;const a=f.charCodeAt(n);if(t===13){let r;switch(a){case 40:d=!0,r=0;break;case 41:r=d?0:1;break;case 91:l=!0,$=!0,r=0;break;case 93:l=!1,r=$?0:1;break;case 123:S=!0,r=0;break;case 125:r=S?0:1;break;case 39:case 34:case 96:s===a?r=1:s===39||s===34||s===96?r=0:r=1;break;case 42:r=s===42?1:0;break;case 124:r=s===124?1:0;break;case 32:r=l?0:1;break;default:r=i.get(a)}r===1&&(c.push(I.a(i,f,u,o,n)),y=!0)}else if(t===12){let r;a===91?($=!0,r=0):r=i.get(a),r===1?y=!0:t=13}else t=p.nextState(t,a),t===0&&(y=!0);y&&(t=1,d=!1,$=!1,S=!1,o=n+1,s=a),n++}t===13&&c.push(I.a(i,f,u,o,E))}return c}}e.$EW=I;function w(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:I.computeLinks(D)}e.$FW=w}),define(De[123],Ce([1,0,24]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.$Ut=e.$Tt=e.$St=e.ModelConstants=e.PositionAffinity=e.$Rt=e.TrackedRangeStickiness=e.$Qt=e.$Pt=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var A;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(A||(e.OverviewRulerLane=A={}));var h;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var F;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(F||(e.MinimapPosition=F={}));var R;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var m;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var k;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var g;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(E){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,E.tabSize|0),E.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,E.indentSize|0),this.a=!1),this.insertSpaces=!!E.insertSpaces,this.defaultEOL=E.defaultEOL|0,this.trimAutoWhitespace=!!E.trimAutoWhitespace,this.bracketPairColorizationOptions=E.bracketPairColorizationOptions}equals(E){return this.tabSize===E.tabSize&&this.a===E.a&&this.indentSize===E.indentSize&&this.insertSpaces===E.insertSpaces&&this.defaultEOL===E.defaultEOL&&this.trimAutoWhitespace===E.trimAutoWhitespace&&(0,b.$Im)(this.bracketPairColorizationOptions,E.bracketPairColorizationOptions)}createChangeEvent(E){return{tabSize:this.tabSize!==E.tabSize,indentSize:this.indentSize!==E.indentSize,insertSpaces:this.insertSpaces!==E.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==E.trimAutoWhitespace}}}e.$Pt=L;class I{constructor(E,n){this._findMatchBrand=void 0,this.range=E,this.matches=n}}e.$Qt=I;var w;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function D(f){return f&&typeof f.read=="function"}e.$Rt=D;var C;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var p;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class i{constructor(E,n,o,s,t,d){this.identifier=E,this.range=n,this.text=o,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=t,this._isTracked=d}}e.$St=i;class c{constructor(E,n,o){this.regex=E,this.wordSeparators=n,this.simpleSearch=o}}e.$Tt=c;class u{constructor(E,n,o){this.reverseEdits=E,this.changes=n,this.trimAutoWhitespaceLineNumbers=o}}e.$Ut=u;function v(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.$Vt=v}),define(De[165],Ce([1,0,19,117]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.$ou=e.$nu=void 0;class h{constructor(k){this.a=k,this.b=new Uint32Array(k.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(k,g){k=(0,A.$gd)(k);const L=this.a,I=this.b,w=g.length;return w===0?!1:(this.a=new Uint32Array(L.length+w),this.a.set(L.subarray(0,k),0),this.a.set(L.subarray(k),k+w),this.a.set(g,k),k-1<this.c[0]&&(this.c[0]=k-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(k,g){return k=(0,A.$gd)(k),g=(0,A.$gd)(g),this.a[k]===g?!1:(this.a[k]=g,k-1<this.c[0]&&(this.c[0]=k-1),!0)}removeValues(k,g){k=(0,A.$gd)(k),g=(0,A.$gd)(g);const L=this.a,I=this.b;if(k>=L.length)return!1;const w=L.length-k;return g>=w&&(g=w),g===0?!1:(this.a=new Uint32Array(L.length-g),this.a.set(L.subarray(0,k),0),this.a.set(L.subarray(k+g),k),this.b=new Uint32Array(this.a.length),k-1<this.c[0]&&(this.c[0]=k-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(k){return k<0?0:(k=(0,A.$gd)(k),this.d(k))}d(k){if(k<=this.c[0])return this.b[k];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),k>=this.a.length&&(k=this.a.length-1);for(let L=g;L<=k;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],k),this.b[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let g=0,L=this.a.length-1,I=0,w=0,D=0;for(;g<=L;)if(I=g+(L-g)/2|0,w=this.b[I],D=w-this.a[I],k<D)L=I-1;else if(k>=w)g=I+1;else break;return new R(I,k-D)}}e.$nu=h;class F{constructor(k){this.a=k,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(k){return this.g(),k===0?0:this.d[k-1]}getIndexOf(k){this.g();const g=this.e[k],L=g>0?this.d[g-1]:0;return new R(g,k-L)}removeValues(k,g){this.a.splice(k,g),this.f(k)}insertValues(k,g){this.a=(0,b.$Af)(this.a,k,g),this.f(k)}f(k){this.b=!1,this.c=Math.min(this.c,k-1)}g(){if(!this.b){for(let k=this.c+1,g=this.a.length;k<g;k++){const L=this.a[k],I=k>0?this.d[k-1]:0;this.d[k]=I+L;for(let w=0;w<L;w++)this.e[I+w]=k}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(k,g){this.a[k]!==g&&(this.a[k]=g,this.f(k))}}e.$ou=F;class R{constructor(k,g){this.index=k,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=g}}e.$pu=R}),define(De[166],Ce([1,0,11,56,165]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=void 0;class F{constructor(m,k,g,L){this.d=m,this.f=k,this.g=g,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const k=m.changes;for(const g of k)this.o(g.range),this.p(new A.$Kr(g.range.startLineNumber,g.range.startColumn),g.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,k=this.f.length,g=new Uint32Array(k);for(let L=0;L<k;L++)g[L]=this.f[L].length+m;this.j=new h.$nu(g)}}n(m,k){this.f[m]=k,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,k){if(k.length===0)return;const g=(0,b.$xd)(k);if(g.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+g[0]+this.f[m.lineNumber-1].substring(m.column-1));return}g[g.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+g[0]);const L=new Uint32Array(g.length-1);for(let I=1;I<g.length;I++)this.f.splice(m.lineNumber+I-1,0,g[I]),L[I-1]=g[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,L)}}e.$qu=F}),define(De[167],Ce([1,0,11,161,56,36,123]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=void 0;const m=999;class k{constructor(u,v,f,E){this.searchString=u,this.isRegex=v,this.matchCase=f,this.wordSeparators=E}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=g(this.searchString):u=this.searchString.indexOf(`
`)>=0;let v=null;try{v=b.$td(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!v)return null;let f=!this.isRegex&&!u;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new R.$Tt(v,this.wordSeparators?(0,A.$3r)(this.wordSeparators):null,f?this.searchString:null)}}e.$FB=k;function g(c){if(!c||c.length===0)return!1;for(let u=0,v=c.length;u<v;u++){const f=c.charCodeAt(u);if(f===10)return!0;if(f===92){if(u++,u>=v)break;const E=c.charCodeAt(u);if(E===110||E===114||E===87)return!0}}return!1}e.$GB=g;function L(c,u,v){if(!v)return new R.$Qt(c,null);const f=[];for(let E=0,n=u.length;E<n;E++)f[E]=u[E];return new R.$Qt(c,f)}e.$HB=L;class I{constructor(u){const v=[];let f=0;for(let E=0,n=u.length;E<n;E++)u.charCodeAt(E)===10&&(v[f++]=E);this.a=v}findLineFeedCountBeforeOffset(u){const v=this.a;let f=0,E=v.length-1;if(E===-1||u<=v[0])return 0;for(;f<E;){const n=f+((E-f)/2>>0);v[n]>=u?E=n-1:v[n+1]>=u?(f=n,E=n):f=n+1}return f+1}}class w{static findMatches(u,v,f,E,n){const o=v.parseSearchRequest();return o?o.regex.multiline?this.b(u,f,new i(o.wordSeparators,o.regex),E,n):this.c(u,f,o,E,n):[]}static a(u,v,f,E,n,o){let s,t=0;E?(t=E.findLineFeedCountBeforeOffset(n),s=v+n+t):s=v+n;let d;if(E){const y=E.findLineFeedCountBeforeOffset(n+o.length)-t;d=s+o.length+y}else d=s+o.length;const $=u.getPositionAt(s),l=u.getPositionAt(d);return new F.$Lr($.lineNumber,$.column,l.lineNumber,l.column)}static b(u,v,f,E,n){const o=u.getOffsetAt(v.getStartPosition()),s=u.getValueInRange(v,1),t=u.getEOL()===`\r
`?new I(s):null,d=[];let $=0,l;for(f.reset(0);l=f.next(s);)if(d[$++]=L(this.a(u,o,s,t,l.index,l[0]),l,E),$>=n)return d;return d}static c(u,v,f,E,n){const o=[];let s=0;if(v.startLineNumber===v.endLineNumber){const d=u.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return s=this.d(f,d,v.startLineNumber,v.startColumn-1,s,o,E,n),o}const t=u.getLineContent(v.startLineNumber).substring(v.startColumn-1);s=this.d(f,t,v.startLineNumber,v.startColumn-1,s,o,E,n);for(let d=v.startLineNumber+1;d<v.endLineNumber&&s<n;d++)s=this.d(f,u.getLineContent(d),d,0,s,o,E,n);if(s<n){const d=u.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);s=this.d(f,d,v.endLineNumber,0,s,o,E,n)}return o}static d(u,v,f,E,n,o,s,t){const d=u.wordSeparators;if(!s&&u.simpleSearch){const S=u.simpleSearch,y=S.length,a=v.length;let r=-y;for(;(r=v.indexOf(S,r+y))!==-1;)if((!d||p(d,v,a,r,y))&&(o[n++]=new R.$Qt(new F.$Lr(f,r+1+E,f,r+1+y+E),null),n>=t))return n;return n}const $=new i(u.wordSeparators,u.regex);let l;$.reset(0);do if(l=$.next(v),l&&(o[n++]=L(new F.$Lr(f,l.index+1+E,f,l.index+1+l[0].length+E),l,s),n>=t))return n;while(l);return n}static findNextMatch(u,v,f,E){const n=v.parseSearchRequest();if(!n)return null;const o=new i(n.wordSeparators,n.regex);return n.regex.multiline?this.e(u,f,o,E):this.f(u,f,o,E)}static e(u,v,f,E){const n=new h.$Kr(v.lineNumber,1),o=u.getOffsetAt(n),s=u.getLineCount(),t=u.getValueInRange(new F.$Lr(n.lineNumber,n.column,s,u.getLineMaxColumn(s)),1),d=u.getEOL()===`\r
`?new I(t):null;f.reset(v.column-1);const $=f.next(t);return $?L(this.a(u,o,t,d,$.index,$[0]),$,E):v.lineNumber!==1||v.column!==1?this.e(u,new h.$Kr(1,1),f,E):null}static f(u,v,f,E){const n=u.getLineCount(),o=v.lineNumber,s=u.getLineContent(o),t=this.g(f,s,o,v.column,E);if(t)return t;for(let d=1;d<=n;d++){const $=(o+d-1)%n,l=u.getLineContent($+1),S=this.g(f,l,$+1,1,E);if(S)return S}return null}static g(u,v,f,E,n){u.reset(E-1);const o=u.next(v);return o?L(new F.$Lr(f,o.index+1,f,o.index+1+o[0].length),o,n):null}static findPreviousMatch(u,v,f,E){const n=v.parseSearchRequest();if(!n)return null;const o=new i(n.wordSeparators,n.regex);return n.regex.multiline?this.h(u,f,o,E):this.j(u,f,o,E)}static h(u,v,f,E){const n=this.b(u,new F.$Lr(1,1,v.lineNumber,v.column),f,E,10*m);if(n.length>0)return n[n.length-1];const o=u.getLineCount();return v.lineNumber!==o||v.column!==u.getLineMaxColumn(o)?this.h(u,new h.$Kr(o,u.getLineMaxColumn(o)),f,E):null}static j(u,v,f,E){const n=u.getLineCount(),o=v.lineNumber,s=u.getLineContent(o).substring(0,v.column-1),t=this.k(f,s,o,E);if(t)return t;for(let d=1;d<=n;d++){const $=(n+o-d-1)%n,l=u.getLineContent($+1),S=this.k(f,l,$+1,E);if(S)return S}return null}static k(u,v,f,E){let n=null,o;for(u.reset(0);o=u.next(v);)n=L(new F.$Lr(f,o.index+1,f,o.index+1+o[0].length),o,E);return n}}e.$IB=w;function D(c,u,v,f,E){if(f===0)return!0;const n=u.charCodeAt(f-1);if(c.get(n)!==0||n===13||n===10)return!0;if(E>0){const o=u.charCodeAt(f);if(c.get(o)!==0)return!0}return!1}function C(c,u,v,f,E){if(f+E===v)return!0;const n=u.charCodeAt(f+E);if(c.get(n)!==0||n===13||n===10)return!0;if(E>0){const o=u.charCodeAt(f+E-1);if(c.get(o)!==0)return!0}return!1}function p(c,u,v,f,E){return D(c,u,v,f,E)&&C(c,u,v,f,E)}e.$JB=p;class i{constructor(u,v){this._wordSeparators=u,this.a=v,this.b=-1,this.c=0}reset(u){this.a.lastIndex=u,this.b=-1,this.c=0}next(u){const v=u.length;let f;do{if(this.b+this.c===v||(f=this.a.exec(u),!f))return null;const E=f.index,n=f[0].length;if(E===this.b&&n===this.c){if(n===0){b.$Qd(u,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=E,this.c=n,!this._wordSeparators||p(this._wordSeparators,u,v,E,n))return f}while(f);return null}}e.$KB=i}),define(De[124],Ce([1,0,22,9]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7=e.$i7=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function F(I){for(let w=0,D=I.length;w<D;w+=4){const C=I[w+0],p=I[w+1],i=I[w+2],c=I[w+3];I[w+0]=c,I[w+1]=i,I[w+2]=p,I[w+3]=C}}function R(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return A.$x()||F(w),b.$Ib.wrap(w)}function m(I){const w=I.buffer;if(A.$x()||F(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const D=new Uint8Array(w.byteLength);return D.set(w),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function k(I){const w=new Uint32Array(g(I));let D=0;if(w[D++]=I.id,I.type==="full")w[D++]=1,w[D++]=I.data.length,w.set(I.data,D),D+=I.data.length;else{w[D++]=2,w[D++]=I.deltas.length;for(const C of I.deltas)w[D++]=C.start,w[D++]=C.deleteCount,C.data?(w[D++]=C.data.length,w.set(C.data,D),D+=C.data.length):w[D++]=0}return R(w)}e.$i7=k;function g(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const D of I.deltas)D.data&&(w+=D.data.length)}return w}function L(I){const w=m(I);let D=0;const C=w[D++];if(w[D++]===1){const u=w[D++],v=w.subarray(D,D+u);return D+=u,{id:C,type:"full",data:v}}const i=w[D++],c=[];for(let u=0;u<i;u++){const v=w[D++],f=w[D++],E=w[D++];let n;E>0&&(n=w.subarray(D,D+E),D+=E),c[u]={start:v,deleteCount:f,data:n}}return{id:C,type:"delta",deltas:c}}e.$j7=L}),define(De[168],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c4=e.$b4=void 0;class b{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$b4=b;class A{constructor(F){this.identifier=F}}e.$c4=A}),define(De[169],Ce([1,0,3,4]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new b.$5c,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,k){return this.a.set(m,k),this.handleChange([m]),(0,A.$ib)(()=>{this.a.get(m)===k&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,k){this.b.get(m)?.dispose();const g=new F(this,m,k);return this.b.set(m,g),(0,A.$ib)(()=>{const L=this.b.get(m);!L||L!==g||(this.b.delete(m),L.dispose())})}async getOrCreate(m){const k=this.get(m);if(k)return k;const g=this.b.get(m);return!g||g.isResolved?null:(await g.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const g=this.b.get(m);return!!(!g||g.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$bs=h;class F extends A.$kb{get isResolved(){return this.c}constructor(m,k,g){super(),this.f=m,this.g=k,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[76],Ce([1,0,72,2,36,169]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qs=e.$ps=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$os=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.$ns=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ms=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ls=e.$ks=e.$js=void 0;class R{constructor(P,N,U){this.offset=P,this.type=N,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$js=R;class m{constructor(P,N){this.tokens=P,this.endState=N,this._tokenizationResultBrand=void 0}}e.$ks=m;class k{constructor(P,N){this.tokens=P,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$ls=k;var g;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(g||(e.CompletionItemKind=g={}));var L;(function(r){const P=new Map;P.set(0,b.$yj.symbolMethod),P.set(1,b.$yj.symbolFunction),P.set(2,b.$yj.symbolConstructor),P.set(3,b.$yj.symbolField),P.set(4,b.$yj.symbolVariable),P.set(5,b.$yj.symbolClass),P.set(6,b.$yj.symbolStruct),P.set(7,b.$yj.symbolInterface),P.set(8,b.$yj.symbolModule),P.set(9,b.$yj.symbolProperty),P.set(10,b.$yj.symbolEvent),P.set(11,b.$yj.symbolOperator),P.set(12,b.$yj.symbolUnit),P.set(13,b.$yj.symbolValue),P.set(15,b.$yj.symbolEnum),P.set(14,b.$yj.symbolConstant),P.set(15,b.$yj.symbolEnum),P.set(16,b.$yj.symbolEnumMember),P.set(17,b.$yj.symbolKeyword),P.set(27,b.$yj.symbolSnippet),P.set(18,b.$yj.symbolText),P.set(19,b.$yj.symbolColor),P.set(20,b.$yj.symbolFile),P.set(21,b.$yj.symbolReference),P.set(22,b.$yj.symbolCustomColor),P.set(23,b.$yj.symbolFolder),P.set(24,b.$yj.symbolTypeParameter),P.set(25,b.$yj.account),P.set(26,b.$yj.issues);function N(B){let O=P.get(B);return O||(console.info("No codicon found for CompletionItemKind "+B),O=b.$yj.symbolProperty),O}r.toIcon=N;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function q(B,O){let K=U.get(B);return typeof K>"u"&&!O&&(K=9),K}r.fromString=q})(L||(e.CompletionItemKinds=L={}));var I;(function(r){r[r.Deprecated=1]="Deprecated"})(I||(e.CompletionItemTag=I={}));var w;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(w||(e.CompletionItemInsertTextRule=w={}));var D;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D||(e.CompletionTriggerKind=D={}));var C;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(C||(e.InlineCompletionTriggerKind=C={}));class p{constructor(P,N,U,q){this.range=P,this.text=N,this.completionKind=U,this.isSnippetText=q}equals(P){return h.$Lr.lift(this.range).equalsRange(P.range)&&this.text===P.text&&this.completionKind===P.completionKind&&this.isSnippetText===P.isSnippetText}}e.$ms=p;var i;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var c;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var u;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function v(r){return r&&A.URI.isUri(r.uri)&&h.$Lr.isIRange(r.range)&&(h.$Lr.isIRange(r.originSelectionRange)||h.$Lr.isIRange(r.targetSelectionRange))}e.$ns=v;var f;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(f||(e.SymbolKind=f={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var n;(function(r){const P=new Map;P.set(0,b.$yj.symbolFile),P.set(1,b.$yj.symbolModule),P.set(2,b.$yj.symbolNamespace),P.set(3,b.$yj.symbolPackage),P.set(4,b.$yj.symbolClass),P.set(5,b.$yj.symbolMethod),P.set(6,b.$yj.symbolProperty),P.set(7,b.$yj.symbolField),P.set(8,b.$yj.symbolConstructor),P.set(9,b.$yj.symbolEnum),P.set(10,b.$yj.symbolInterface),P.set(11,b.$yj.symbolFunction),P.set(12,b.$yj.symbolVariable),P.set(13,b.$yj.symbolConstant),P.set(14,b.$yj.symbolString),P.set(15,b.$yj.symbolNumber),P.set(16,b.$yj.symbolBoolean),P.set(17,b.$yj.symbolArray),P.set(18,b.$yj.symbolObject),P.set(19,b.$yj.symbolKey),P.set(20,b.$yj.symbolNull),P.set(21,b.$yj.symbolEnumMember),P.set(22,b.$yj.symbolStruct),P.set(23,b.$yj.symbolEvent),P.set(24,b.$yj.symbolOperator),P.set(25,b.$yj.symbolTypeParameter);function N(U){let q=P.get(U);return q||(console.info("No codicon found for SymbolKind "+U),q=b.$yj.symbolProperty),q}r.toIcon=N})(n||(e.SymbolKinds=n={}));class o{static fromValue(P){switch(P){case"comment":return o.Comment;case"imports":return o.Imports;case"region":return o.Region}return new o(P)}constructor(P){this.value=P}}e.$os=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var s;(function(r){function P(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}r.is=P})(s||(e.Command=s={}));var t;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(t||(e.CommentThreadCollapsibleState=t={}));var d;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(d||(e.CommentThreadState=d={}));var $;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})($||(e.CommentMode=$={}));var l;(function(r){r[r.Published=0]="Published",r[r.Draft=1]="Draft"})(l||(e.CommentState=l={}));var S;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(S||(e.InlayHintKind=S={}));class y{constructor(P){this.b=P,this.a=null}dispose(){this.a&&this.a.then(P=>{P&&P.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ps=y,e.$qs=new F.$bs;var a;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(a||(e.ExternalUriOpenerPriority=a={}))}),define(De[170],Ce([14,15]),function(re,e){return re.create("vs/base/common/actions",e)}),define(De[171],Ce([1,0,3,4,170]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class F extends A.$kb{constructor(w,D="",C="",p=!0,i){super(),this.h=this.B(new b.$5c),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=D,this.u=C,this.w=p,this.C=i}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,D){this.C&&await this.C(w)}}e.$3h=F;class R extends A.$kb{constructor(){super(...arguments),this.f=this.B(new b.$5c),this.onWillRun=this.f.event,this.h=this.B(new b.$5c),this.onDidRun=this.h.event}async run(w,D){if(!w.enabled)return;this.f.fire({action:w});let C;try{await this.k(w,D)}catch(p){C=p}this.h.fire({action:w,error:C})}async k(w,D){await w.run(D)}}e.$4h=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let D=[];for(const C of w)C.length&&(D.length?D=[...D,new m,...C]:D=C);return D}async run(){}}e.$5h=m,m.ID="vs.actions.separator";class k{get actions(){return this.a}constructor(w,D,C,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=D,this.class=p,this.a=C}async run(){}}e.$6h=k;class g extends F{constructor(){super(g.ID,h.localize(0,null),void 0,!1)}}e.$7h=g,g.ID="vs.actions.empty";function L(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$8h=L}),define(De[172],Ce([14,15]),function(re,e){return re.create("vs/base/common/date",e)}),define(De[173],Ce([1,0,172]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0;const A=60,h=A*60,F=h*24,R=F*7,m=F*30,k=F*365;function g(I,w,D,C){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,b.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!C&&p<30)return(0,b.localize)(1,null);let i;return p<A?(i=p,w?i===1?D?(0,b.localize)(2,null,i):(0,b.localize)(3,null,i):D?(0,b.localize)(4,null,i):(0,b.localize)(5,null,i):i===1?D?(0,b.localize)(6,null,i):(0,b.localize)(7,null,i):D?(0,b.localize)(8,null,i):(0,b.localize)(9,null,i)):p<h?(i=Math.floor(p/A),w?i===1?D?(0,b.localize)(10,null,i):(0,b.localize)(11,null,i):D?(0,b.localize)(12,null,i):(0,b.localize)(13,null,i):i===1?D?(0,b.localize)(14,null,i):(0,b.localize)(15,null,i):D?(0,b.localize)(16,null,i):(0,b.localize)(17,null,i)):p<F?(i=Math.floor(p/h),w?i===1?D?(0,b.localize)(18,null,i):(0,b.localize)(19,null,i):D?(0,b.localize)(20,null,i):(0,b.localize)(21,null,i):i===1?D?(0,b.localize)(22,null,i):(0,b.localize)(23,null,i):D?(0,b.localize)(24,null,i):(0,b.localize)(25,null,i)):p<R?(i=Math.floor(p/F),w?i===1?(0,b.localize)(26,null,i):(0,b.localize)(27,null,i):i===1?(0,b.localize)(28,null,i):(0,b.localize)(29,null,i)):p<m?(i=Math.floor(p/R),w?i===1?D?(0,b.localize)(30,null,i):(0,b.localize)(31,null,i):D?(0,b.localize)(32,null,i):(0,b.localize)(33,null,i):i===1?D?(0,b.localize)(34,null,i):(0,b.localize)(35,null,i):D?(0,b.localize)(36,null,i):(0,b.localize)(37,null,i)):p<k?(i=Math.floor(p/m),w?i===1?D?(0,b.localize)(38,null,i):(0,b.localize)(39,null,i):D?(0,b.localize)(40,null,i):(0,b.localize)(41,null,i):i===1?D?(0,b.localize)(42,null,i):(0,b.localize)(43,null,i):D?(0,b.localize)(44,null,i):(0,b.localize)(45,null,i)):(i=Math.floor(p/k),w?i===1?D?(0,b.localize)(46,null,i):(0,b.localize)(47,null,i):D?(0,b.localize)(48,null,i):(0,b.localize)(49,null,i):i===1?D?(0,b.localize)(50,null,i):(0,b.localize)(51,null,i):D?(0,b.localize)(52,null,i):(0,b.localize)(53,null,i))}e.$Ol=g;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Pl=L}),define(De[174],Ce([14,15]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,19,12,174]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function F(I,w){return w&&(I.stack||I.stacktrace)?h.localize(0,null,m(I),R(I.stack)||R(I.stacktrace)):m(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function k(I=null,w=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const D=b.$jf(I),C=k(D[0],w);return D.length>1?h.localize(4,null,C,D.length):C}if(A.$ge(I))return I;if(I.detail){const D=I.detail;if(D.error)return F(D.error,w);if(D.exception)return F(D.exception,w)}return I.stack?F(I,w):I.message?I.message:h.localize(5,null)}e.$9h=k;function g(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.$0h=g;function L(I,w){let D;return typeof I=="string"?D=new Error(I):D=I,D.actions=w,D}e.$$h=L}),define(De[175],Ce([14,15]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(De[125],Ce([1,0,19,24,9,160,122,175]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=g;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(Q,we,je,Oe){this.id=Q,this.name=we,this.defaultValue=je,this.schema=Oe}applyUpdate(Q,we){return D(Q,we)}compute(Q,we,je){return je}}class w{constructor(Q,we){this.newValue=Q,this.didChange=we}}e.ApplyUpdateResult=w;function D(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new w(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const je=Array.isArray(_)&&Array.isArray(Q)&&b.$$e(_,Q);return new w(Q,!je)}let we=!1;for(const je in Q)if(Q.hasOwnProperty(je)){const Oe=D(_[je],Q[je]);Oe.didChange&&(_[je]=Oe.newValue,we=!0)}return new w(_,we)}class C{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,we){return D(Q,we)}validate(Q){return this.defaultValue}}class p{constructor(Q,we,je,Oe){this.id=Q,this.name=we,this.defaultValue=je,this.schema=Oe}applyUpdate(Q,we){return D(Q,we)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,we,je){return je}}function i(_,Q){return typeof _>"u"?Q:_==="false"?!1:!!_}e.boolean=i;class c extends p{constructor(Q,we,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Q,we,je,Oe)}validate(Q){return i(Q,this.defaultValue)}}function u(_,Q,we,je){if(typeof _>"u")return Q;let Oe=parseInt(_,10);return isNaN(Oe)?Q:(Oe=Math.max(we,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=u;class v extends p{static clampedInt(Q,we,je,Oe){return u(Q,we,je,Oe)}constructor(Q,we,je,Oe,Xe,et=void 0){typeof et<"u"&&(et.type="integer",et.default=je,et.minimum=Oe,et.maximum=Xe),super(Q,we,je,et),this.minimum=Oe,this.maximum=Xe}validate(Q){return v.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function f(_,Q,we,je){if(typeof _>"u")return Q;const Oe=E.float(_,Q);return E.clamp(Oe,we,je)}e.clampedFloat=f;class E extends p{static clamp(Q,we,je){return Q<we?we:Q>je?je:Q}static float(Q,we){if(typeof Q=="number")return Q;if(typeof Q>"u")return we;const je=parseFloat(Q);return isNaN(je)?we:je}constructor(Q,we,je,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=je),super(Q,we,je,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(E.float(Q,this.defaultValue))}}class n extends p{static string(Q,we){return typeof Q!="string"?we:Q}constructor(Q,we,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Q,we,je,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function o(_,Q,we,je){return typeof _!="string"?Q:je&&_ in je?je[_]:we.indexOf(_)===-1?Q:_}e.stringSet=o;class s extends p{constructor(Q,we,je,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=je),super(Q,we,je,Xe),this.c=Oe}validate(Q){return o(Q,this.defaultValue,this.c)}}class t extends I{constructor(Q,we,je,Oe,Xe,et,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Xe,nt.default=Oe),super(Q,we,je,nt),this.c=Xe,this.d=et}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function d(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,we,je){return je===0?Q.accessibilitySupport:je}}class l extends I{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertSpace:i(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function y(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(a||(e.TextEditorCursorStyle=a={}));function r(_){switch(_){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=r;function P(_){switch(_){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class N extends C{constructor(){super(138)}compute(Q,we,je){const Oe=["monaco-editor"];return we.get(37)&&Oe.push(we.get(37)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),we.get(71)==="default"?Oe.push("mouse-default"):we.get(71)==="copy"&&Oe.push("mouse-copy"),we.get(108)&&Oe.push("showUnused"),we.get(136)&&Oe.push("showDeprecated"),Oe.join(" ")}}class U extends c{constructor(){super(35,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Q,we,je){return je&&Q.emptySelectionClipboard}}class q extends I{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:m.localize(16,null),included:h.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:m.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{cursorMoveOnType:i(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":o(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":o(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(we.loop,this.defaultValue.loop)}}}class B extends I{constructor(){super(49,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Q?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class O extends I{constructor(){super(52,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?O.OFF:Q==="true"?O.TRANSLATE:Q:Q?O.TRANSLATE:O.OFF}compute(Q,we,je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=O,O.OFF="normal",O.TRANSLATE="translate";class K extends C{constructor(){super(48)}compute(Q,we,je){return Q.fontInfo}}class z extends p{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Q){const we=E.float(Q,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(we,6,100)}compute(Q,we,je){return Q.fontInfo.fontSize}}class j extends I{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.d,maximum:j.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(v.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.d,j.e))}}j.c=["normal","bold","100","200","300","400","500","600","700","800","900"],j.d=1,j.e=1e3;class he extends I{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:je,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:je,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:je,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:je,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:je,description:m.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{multiple:o(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??o(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??o(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??o(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??o(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??o(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends I{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:m.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:m.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),delay:v.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:i(we.sticky,this.defaultValue.sticky),above:i(we.above,this.defaultValue.above)}}}var ne;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(ne||(e.RenderMinimap=ne={}));class V extends C{constructor(){super(141)}compute(Q,we,je){return V.computeLayout(we,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const we=Q.height/Q.lineHeight,je=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,we-1));const Xe=(je+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),et=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:et}}static c(Q,we){const je=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const et=we.stableMinimapLayoutInput,nt=et&&Q.outerHeight===et.outerHeight&&Q.lineHeight===et.lineHeight&&Q.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&Q.pixelRatio===et.pixelRatio&&Q.scrollBeyondLastLine===et.scrollBeyondLastLine&&Q.paddingTop===et.paddingTop&&Q.paddingBottom===et.paddingBottom&&Q.minimap.enabled===et.minimap.enabled&&Q.minimap.side===et.minimap.side&&Q.minimap.size===et.minimap.size&&Q.minimap.showSlider===et.minimap.showSlider&&Q.minimap.renderCharacters===et.minimap.renderCharacters&&Q.minimap.maxColumn===et.minimap.maxColumn&&Q.minimap.scale===et.minimap.scale&&Q.verticalScrollbarWidth===et.verticalScrollbarWidth&&Q.isViewportWrapping===et.isViewportWrapping,ft=Q.lineHeight,vt=Q.typicalHalfwidthCharacterWidth,Nt=Q.scrollBeyondLastLine,Tt=Q.minimap.renderCharacters;let Et=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Bt=Q.minimap.maxColumn,Ot=Q.minimap.size,jt=Q.minimap.side,Vt=Q.verticalScrollbarWidth,Ht=Q.viewLineCount,ut=Q.remainingWidth,gt=Q.isViewportWrapping,Wt=Tt?2:3;let Rt=Math.floor(Xe*Oe);const Ct=Rt/Xe;let lt=!1,Pt=!1,Mt=Wt*Et,Fe=Et/Xe,Le=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:kt,extraLinesBeyondLastLine:It,desiredRatio:At,minimapLineCount:bt}=V.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:Nt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:ft,pixelRatio:Xe});if(Ht/bt>1)lt=!0,Pt=!0,Et=1,Mt=1,Fe=Et/Xe;else{let mt=!1,yt=Et+1;if(Ot==="fit"){const wt=Math.ceil((kt+Ht+It)*Mt);gt&&nt&&ut<=we.stableFitRemainingWidth?(mt=!0,yt=we.stableFitMaxMinimapScale):mt=wt>Rt}if(Ot==="fill"||mt){lt=!0;const wt=Et;Mt=Math.min(ft*Xe,Math.max(1,Math.floor(1/At))),gt&&nt&&ut<=we.stableFitRemainingWidth&&(yt=we.stableFitMaxMinimapScale),Et=Math.min(yt,Math.max(1,Math.floor(Mt/Wt))),Et>wt&&(Le=Math.min(2,Et/wt)),Fe=Et/Xe/Le,Rt=Math.ceil(Math.max(it,kt+Ht+It)*Mt),gt?(we.stableMinimapLayoutInput=Q,we.stableFitRemainingWidth=ut,we.stableFitMaxMinimapScale=Et):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Ae=Math.floor(Bt*Fe),ae=Math.min(Ae,Math.max(0,Math.floor((ut-Vt-2)*Fe/(vt+Fe)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Xe*ae);const Be=Ne/Xe;Ne=Math.floor(Ne*Le);const Qe=Tt?1:2,Je=jt==="left"?0:je-ae-Vt;return{renderMinimap:Qe,minimapLeft:Je,minimapWidth:ae,minimapHeightIsEditorHeight:lt,minimapIsSampling:Pt,minimapScale:Et,minimapLineHeight:Mt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:Ct}}static computeLayout(Q,we){const je=we.outerWidth|0,Oe=we.outerHeight|0,Xe=we.lineHeight|0,et=we.lineNumbersDigitCount|0,nt=we.typicalHalfwidthCharacterWidth,ft=we.maxDigitWidth,vt=we.pixelRatio,Nt=we.viewLineCount,Tt=Q.get(133),Et=Tt==="inherit"?Q.get(132):Tt,Bt=Et==="inherit"?Q.get(128):Et,Ot=Q.get(131),jt=we.isDominatedByLongLines,Vt=Q.get(55),Ht=Q.get(65).renderType!==0,ut=Q.get(66),gt=Q.get(102),Wt=Q.get(81),Rt=Q.get(70),Ct=Q.get(100),lt=Ct.verticalScrollbarSize,Pt=Ct.verticalHasArrows,Mt=Ct.arrowSize,Fe=Ct.horizontalScrollbarSize,Le=Q.get(41),Ae=Q.get(107)!=="never";let ae=Q.get(63);Le&&Ae&&(ae+=16);let Ne=0;if(Ht){const qt=Math.max(et,ut);Ne=Math.round(qt*ft)}let Be=0;Vt&&(Be=Xe*we.glyphMarginDecorationLaneCount);let Qe=0,Je=Qe+Be,it=Je+Ne,kt=it+ae;const It=je-Be-Ne-ae;let At=!1,bt=!1,pt=-1;Et==="inherit"&&jt?(At=!0,bt=!0):Bt==="on"||Bt==="bounded"?bt=!0:Bt==="wordWrapColumn"&&(pt=Ot);const mt=V.c({outerWidth:je,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:nt,pixelRatio:vt,scrollBeyondLastLine:gt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Rt,verticalScrollbarWidth:lt,viewLineCount:Nt,remainingWidth:It,isViewportWrapping:bt},we.memory||new L);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Qe+=mt.minimapWidth,Je+=mt.minimapWidth,it+=mt.minimapWidth,kt+=mt.minimapWidth);const yt=It-mt.minimapWidth,wt=Math.max(1,Math.floor((yt-lt-2)/nt)),Xt=Pt?Mt:0;return bt&&(pt=Math.max(1,wt),Bt==="bounded"&&(pt=Math.min(pt,Ot))),{width:je,height:Oe,glyphMarginLeft:Qe,glyphMarginWidth:Be,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Je,lineNumbersWidth:Ne,decorationsLeft:it,decorationsWidth:ae,contentLeft:kt,contentWidth:yt,minimap:mt,viewportColumn:wt,isWordWrapMinified:At,isViewportWrapping:bt,wrappingColumn:pt,verticalScrollbarWidth:lt,horizontalScrollbarHeight:Fe,overviewRuler:{top:Xt,width:lt,height:Oe-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=V;class H extends I{constructor(){super(135,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(46,null),m.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(48,null)}})}validate(Q){return o(Q,"simple",["simple","advanced"])}compute(Q,we,je){return we.get(2)===2?"advanced":je}}class ce extends I{constructor(){const Q={enabled:!0};super(62,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:m.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:i(Q.enabled,this.defaultValue.enabled)}}}class pe extends I{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(112,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:m.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:m.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:m.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ye extends I{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(137,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:m.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(54,null),m.localize(55,null,h.$e?"Ctrl+Option":"Ctrl+Alt"),m.localize(56,null,h.$e?"Ctrl+Option":"Ctrl+Alt"),m.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:m.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:m.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:m.localize(60,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:o(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(we.fontFamily,this.defaultValue.fontFamily),padding:i(we.padding,this.defaultValue.padding)}}}class ge extends I{constructor(){super(63,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):v.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,we,je){return je<0?v.clampedInt(-je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class M extends E{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>E.clamp(Q,0,150),{markdownDescription:m.localize(61,null)})}compute(Q,we,je){return Q.fontInfo.lineHeight}}class Y extends I{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:m.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:m.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(64,null),m.localize(65,null),m.localize(66,null)],default:Q.size,description:m.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:m.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:m.localize(69,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:m.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:m.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),autohide:i(we.autohide,this.defaultValue.autohide),size:o(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(we.side,this.defaultValue.side,["right","left"]),showSlider:o(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(we.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(we.scale,1,1,3),maxColumn:v.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(_){return _==="ctrlCmd"?h.$e?"metaKey":"ctrlKey":"altKey"}class Se extends I{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{top:v.clampedInt(we.top,0,0,1e3),bottom:v.clampedInt(we.bottom,0,0,1e3)}}}class ee extends I{constructor(){const Q={enabled:!0,cycle:!0};super(83,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:m.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:m.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),cycle:i(we.cycle,this.defaultValue.cycle)}}}class te extends C{constructor(){super(139)}compute(Q,we,je){return Q.pixelRatio}}class le extends I{constructor(){const Q={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)]}];super(86,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:Q.strings,description:m.localize(80,null)},comments:{anyOf:we,default:Q.comments,description:m.localize(81,null)},other:{anyOf:we,default:Q.other,description:m.localize(82,null)}},default:Q,markdownDescription:m.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const vt=Q?"on":"off";return{comments:vt,strings:vt,other:vt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:we,comments:je,strings:Oe}=Q,Xe=["on","inline","off"];let et,nt,ft;return typeof we=="boolean"?et=we?"on":"off":et=o(we,this.defaultValue.other,Xe),typeof je=="boolean"?nt=je?"on":"off":nt=o(je,this.defaultValue.comments,Xe),typeof Oe=="boolean"?ft=Oe?"on":"off":ft=o(Oe,this.defaultValue.strings,Xe),{other:et,comments:nt,strings:ft}}}var X;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class ue extends I{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(84,null),m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:"on",description:m.localize(88,null)})}validate(Q){let we=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(we=4,je=Q):Q==="interval"?we=3:Q==="relative"?we=2:Q==="on"?we=1:we=0),{renderType:we,renderFn:je}}}function se(_){const Q=_.get(95);return Q==="editable"?_.get(88):Q!=="on"}e.filterValidationDecorations=se;class oe extends I{constructor(){const Q=[],we={type:"number",description:m.localize(89,null)};super(99,"rulers",Q,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:m.localize(90,null),format:"color-hex"}}}]},default:Q,description:m.localize(91,null)})}validate(Q){if(Array.isArray(Q)){const we=[];for(const je of Q)if(typeof je=="number")we.push({column:v.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;we.push({column:v.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return we.sort((je,Oe)=>je.column-Oe.column),we}return this.defaultValue}}class T extends I{constructor(){super(89,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function J(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class Z extends I{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(100,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:"auto",description:m.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:"auto",description:m.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:m.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:m.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:m.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q,je=v.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=v.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:J(we.vertical,this.defaultValue.vertical),horizontal:J(we.horizontal,this.defaultValue.horizontal),useShadows:i(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:v.clampedInt(we.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:v.clampedInt(we.verticalSliderSize,Oe,0,1e3),scrollByPage:i(we.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends I{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(122,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:m.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:m.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:m.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:m.localize(109,null)}})}applyUpdate(Q,we){let je=!1;we.allowedCharacters&&Q&&(A.$Im(Q.allowedCharacters,we.allowedCharacters)||(Q={...Q,allowedCharacters:we.allowedCharacters},je=!0)),we.allowedLocales&&Q&&(A.$Im(Q.allowedLocales,we.allowedLocales)||(Q={...Q,allowedLocales:we.allowedLocales},je=!0));const Oe=super.applyUpdate(Q,we);return je?new w(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{nonBasicASCII:Ie(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ie(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ie(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,we){if(typeof Q!="object"||!Q)return we;const je={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(je[Oe]=!0);return je}}class me extends I{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:m.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(111,null),m.localize(112,null)],description:m.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:m.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),mode:o(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:i(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends I{constructor(){const Q={enabled:F.$Er.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Er.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:m.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends I{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],default:Q.bracketPairs,description:m.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Q.bracketPairsHorizontal,description:m.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:m.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:m.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],default:Q.highlightActiveIndentation,description:m.localize(130,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{bracketPairs:Ie(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ie(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ie(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ie(_,Q,we){const je=we.indexOf(_);return je===-1?Q:we[je]}class Pe extends I{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(115,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(131,null),m.localize(132,null)],default:Q.insertMode,description:m.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:m.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:m.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:m.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(137,null),m.localize(138,null),m.localize(139,null),m.localize(140,null)],default:Q.selectionMode,markdownDescription:m.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:m.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:m.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:m.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:m.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:m.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertMode:o(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(we.showIcons,this.defaultValue.showIcons),showStatusBar:i(we.showStatusBar,this.defaultValue.showStatusBar),preview:i(we.preview,this.defaultValue.preview),previewMode:o(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(we.showMethods,this.defaultValue.showMethods),showFunctions:i(we.showFunctions,this.defaultValue.showFunctions),showConstructors:i(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(we.showFields,this.defaultValue.showFields),showVariables:i(we.showVariables,this.defaultValue.showVariables),showClasses:i(we.showClasses,this.defaultValue.showClasses),showStructs:i(we.showStructs,this.defaultValue.showStructs),showInterfaces:i(we.showInterfaces,this.defaultValue.showInterfaces),showModules:i(we.showModules,this.defaultValue.showModules),showProperties:i(we.showProperties,this.defaultValue.showProperties),showEvents:i(we.showEvents,this.defaultValue.showEvents),showOperators:i(we.showOperators,this.defaultValue.showOperators),showUnits:i(we.showUnits,this.defaultValue.showUnits),showValues:i(we.showValues,this.defaultValue.showValues),showConstants:i(we.showConstants,this.defaultValue.showConstants),showEnums:i(we.showEnums,this.defaultValue.showEnums),showEnumMembers:i(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(we.showKeywords,this.defaultValue.showKeywords),showWords:i(we.showWords,this.defaultValue.showWords),showColors:i(we.showColors,this.defaultValue.showColors),showFiles:i(we.showFiles,this.defaultValue.showFiles),showReferences:i(we.showReferences,this.defaultValue.showReferences),showFolders:i(we.showFolders,this.defaultValue.showFolders),showTypeParameters:i(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(we.showSnippets,this.defaultValue.showSnippets),showUsers:i(we.showUsers,this.defaultValue.showUsers),showIssues:i(we.showIssues,this.defaultValue.showIssues)}}}class qe extends I{constructor(){super(110,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(180,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class tt extends I{constructor(){super(134,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(181,null),m.localize(182,null),m.localize(183,null),m.localize(184,null)],description:m.localize(185,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,we,je){return we.get(2)===2?0:je}}class Ge extends C{constructor(){super(142)}compute(Q,we,je){const Oe=we.get(141);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class Ye extends I{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(188,null),m.localize(189,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),showDropSelector:o(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends I{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:i(we.enabled,this.defaultValue.enabled),showPasteSelector:o(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const at="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$e?xe:h.$f?rt:at,fontWeight:"normal",fontSize:h.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function de(_){return e.editorOptionsRegistry[_.id]=_,_}var Me;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=7]="autoClosingDelete",_[_.autoClosingOvertype=8]="autoClosingOvertype",_[_.autoClosingQuotes=9]="autoClosingQuotes",_[_.autoIndent=10]="autoIndent",_[_.automaticLayout=11]="automaticLayout",_[_.autoSurround=12]="autoSurround",_[_.bracketPairColorization=13]="bracketPairColorization",_[_.guides=14]="guides",_[_.codeLens=15]="codeLens",_[_.codeLensFontFamily=16]="codeLensFontFamily",_[_.codeLensFontSize=17]="codeLensFontSize",_[_.colorDecorators=18]="colorDecorators",_[_.colorDecoratorsLimit=19]="colorDecoratorsLimit",_[_.columnSelection=20]="columnSelection",_[_.comments=21]="comments",_[_.contextmenu=22]="contextmenu",_[_.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",_[_.cursorBlinking=24]="cursorBlinking",_[_.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",_[_.cursorStyle=26]="cursorStyle",_[_.cursorSurroundingLines=27]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",_[_.cursorWidth=29]="cursorWidth",_[_.disableLayerHinting=30]="disableLayerHinting",_[_.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",_[_.domReadOnly=32]="domReadOnly",_[_.dragAndDrop=33]="dragAndDrop",_[_.dropIntoEditor=34]="dropIntoEditor",_[_.emptySelectionClipboard=35]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",_[_.extraEditorClassName=37]="extraEditorClassName",_[_.fastScrollSensitivity=38]="fastScrollSensitivity",_[_.find=39]="find",_[_.fixedOverflowWidgets=40]="fixedOverflowWidgets",_[_.folding=41]="folding",_[_.foldingStrategy=42]="foldingStrategy",_[_.foldingHighlight=43]="foldingHighlight",_[_.foldingImportsByDefault=44]="foldingImportsByDefault",_[_.foldingMaximumRegions=45]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=47]="fontFamily",_[_.fontInfo=48]="fontInfo",_[_.fontLigatures=49]="fontLigatures",_[_.fontSize=50]="fontSize",_[_.fontWeight=51]="fontWeight",_[_.fontVariations=52]="fontVariations",_[_.formatOnPaste=53]="formatOnPaste",_[_.formatOnType=54]="formatOnType",_[_.glyphMargin=55]="glyphMargin",_[_.gotoLocation=56]="gotoLocation",_[_.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",_[_.hover=58]="hover",_[_.inDiffEditor=59]="inDiffEditor",_[_.inlineSuggest=60]="inlineSuggest",_[_.letterSpacing=61]="letterSpacing",_[_.lightbulb=62]="lightbulb",_[_.lineDecorationsWidth=63]="lineDecorationsWidth",_[_.lineHeight=64]="lineHeight",_[_.lineNumbers=65]="lineNumbers",_[_.lineNumbersMinChars=66]="lineNumbersMinChars",_[_.linkedEditing=67]="linkedEditing",_[_.links=68]="links",_[_.matchBrackets=69]="matchBrackets",_[_.minimap=70]="minimap",_[_.mouseStyle=71]="mouseStyle",_[_.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=73]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",_[_.multiCursorModifier=75]="multiCursorModifier",_[_.multiCursorPaste=76]="multiCursorPaste",_[_.multiCursorLimit=77]="multiCursorLimit",_[_.occurrencesHighlight=78]="occurrencesHighlight",_[_.overviewRulerBorder=79]="overviewRulerBorder",_[_.overviewRulerLanes=80]="overviewRulerLanes",_[_.padding=81]="padding",_[_.pasteAs=82]="pasteAs",_[_.parameterHints=83]="parameterHints",_[_.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",_[_.quickSuggestions=86]="quickSuggestions",_[_.quickSuggestionsDelay=87]="quickSuggestionsDelay",_[_.readOnly=88]="readOnly",_[_.readOnlyMessage=89]="readOnlyMessage",_[_.renameOnType=90]="renameOnType",_[_.renderControlCharacters=91]="renderControlCharacters",_[_.renderFinalNewline=92]="renderFinalNewline",_[_.renderLineHighlight=93]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=95]="renderValidationDecorations",_[_.renderWhitespace=96]="renderWhitespace",_[_.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",_[_.roundedSelection=98]="roundedSelection",_[_.rulers=99]="rulers",_[_.scrollbar=100]="scrollbar",_[_.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=102]="scrollBeyondLastLine",_[_.scrollPredominantAxis=103]="scrollPredominantAxis",_[_.selectionClipboard=104]="selectionClipboard",_[_.selectionHighlight=105]="selectionHighlight",_[_.selectOnLineNumbers=106]="selectOnLineNumbers",_[_.showFoldingControls=107]="showFoldingControls",_[_.showUnused=108]="showUnused",_[_.snippetSuggestions=109]="snippetSuggestions",_[_.smartSelect=110]="smartSelect",_[_.smoothScrolling=111]="smoothScrolling",_[_.stickyScroll=112]="stickyScroll",_[_.stickyTabStops=113]="stickyTabStops",_[_.stopRenderingLineAfter=114]="stopRenderingLineAfter",_[_.suggest=115]="suggest",_[_.suggestFontSize=116]="suggestFontSize",_[_.suggestLineHeight=117]="suggestLineHeight",_[_.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",_[_.suggestSelection=119]="suggestSelection",_[_.tabCompletion=120]="tabCompletion",_[_.tabIndex=121]="tabIndex",_[_.unicodeHighlighting=122]="unicodeHighlighting",_[_.unusualLineTerminators=123]="unusualLineTerminators",_[_.useShadowDOM=124]="useShadowDOM",_[_.useTabStops=125]="useTabStops",_[_.wordBreak=126]="wordBreak",_[_.wordSeparators=127]="wordSeparators",_[_.wordWrap=128]="wordWrap",_[_.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=131]="wordWrapColumn",_[_.wordWrapOverride1=132]="wordWrapOverride1",_[_.wordWrapOverride2=133]="wordWrapOverride2",_[_.wrappingIndent=134]="wrappingIndent",_[_.wrappingStrategy=135]="wrappingStrategy",_[_.showDeprecated=136]="showDeprecated",_[_.inlayHints=137]="inlayHints",_[_.editorClassName=138]="editorClassName",_[_.pixelRatio=139]="pixelRatio",_[_.tabFocusMode=140]="tabFocusMode",_[_.layoutInfo=141]="layoutInfo",_[_.wrappingInfo=142]="wrappingInfo",_[_.defaultColorDecorators=143]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(Me||(e.EditorOption=Me={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:de(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(194,null)})),acceptSuggestionOnEnter:de(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(195,null),""],markdownDescription:m.localize(196,null)})),accessibilitySupport:de(new $),accessibilityPageSize:de(new v(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(197,null),tags:["accessibility"]})),ariaLabel:de(new n(4,"ariaLabel",m.localize(198,null))),screenReaderAnnounceInlineSuggestion:de(new c(6,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:de(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(200,null),m.localize(201,null),""],description:m.localize(202,null)})),autoClosingDelete:de(new s(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(203,null),""],description:m.localize(204,null)})),autoClosingOvertype:de(new s(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(205,null),""],description:m.localize(206,null)})),autoClosingQuotes:de(new s(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoIndent:de(new t(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[m.localize(210,null),m.localize(211,null),m.localize(212,null),m.localize(213,null),m.localize(214,null)],description:m.localize(215,null)})),automaticLayout:de(new c(11,"automaticLayout",!1)),autoSurround:de(new s(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),bracketPairColorization:de(new Ee),bracketPairGuides:de(new fe),stickyTabStops:de(new c(113,"stickyTabStops",!1,{description:m.localize(220,null)})),codeLens:de(new c(15,"codeLens",!0,{description:m.localize(221,null)})),codeLensFontFamily:de(new n(16,"codeLensFontFamily","",{description:m.localize(222,null)})),codeLensFontSize:de(new v(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(223,null)})),colorDecorators:de(new c(18,"colorDecorators",!0,{description:m.localize(224,null)})),colorDecoratorActivatedOn:de(new s(144,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(225,null),m.localize(226,null),m.localize(227,null)],description:m.localize(228,null)})),colorDecoratorsLimit:de(new v(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(229,null)})),columnSelection:de(new c(20,"columnSelection",!1,{description:m.localize(230,null)})),comments:de(new l),contextmenu:de(new c(22,"contextmenu",!0)),copyWithSyntaxHighlighting:de(new c(23,"copyWithSyntaxHighlighting",!0,{description:m.localize(231,null)})),cursorBlinking:de(new t(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],y,{description:m.localize(232,null)})),cursorSmoothCaretAnimation:de(new s(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null)],description:m.localize(236,null)})),cursorStyle:de(new t(26,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(237,null)})),cursorSurroundingLines:de(new v(27,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(238,null)})),cursorSurroundingLinesStyle:de(new s(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorWidth:de(new v(29,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(242,null)})),disableLayerHinting:de(new c(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:de(new c(31,"disableMonospaceOptimizations",!1)),domReadOnly:de(new c(32,"domReadOnly",!1)),dragAndDrop:de(new c(33,"dragAndDrop",!0,{description:m.localize(243,null)})),emptySelectionClipboard:de(new U),dropIntoEditor:de(new Ye),stickyScroll:de(new pe),experimentalWhitespaceRendering:de(new s(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),extraEditorClassName:de(new n(37,"extraEditorClassName","")),fastScrollSensitivity:de(new E(38,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:m.localize(248,null)})),find:de(new q),fixedOverflowWidgets:de(new c(40,"fixedOverflowWidgets",!1)),folding:de(new c(41,"folding",!0,{description:m.localize(249,null)})),foldingStrategy:de(new s(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),foldingHighlight:de(new c(43,"foldingHighlight",!0,{description:m.localize(253,null)})),foldingImportsByDefault:de(new c(44,"foldingImportsByDefault",!1,{description:m.localize(254,null)})),foldingMaximumRegions:de(new v(45,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(255,null)})),unfoldOnClickAfterEndOfLine:de(new c(46,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(256,null)})),fontFamily:de(new n(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(257,null)})),fontInfo:de(new K),fontLigatures2:de(new B),fontSize:de(new z),fontWeight:de(new j),fontVariations:de(new O),formatOnPaste:de(new c(53,"formatOnPaste",!1,{description:m.localize(258,null)})),formatOnType:de(new c(54,"formatOnType",!1,{description:m.localize(259,null)})),glyphMargin:de(new c(55,"glyphMargin",!0,{description:m.localize(260,null)})),gotoLocation:de(new he),hideCursorInOverviewRuler:de(new c(57,"hideCursorInOverviewRuler",!1,{description:m.localize(261,null)})),hover:de(new ie),inDiffEditor:de(new c(59,"inDiffEditor",!1)),letterSpacing:de(new E(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>E.clamp(_,-5,20),{description:m.localize(262,null)})),lightbulb:de(new ce),lineDecorationsWidth:de(new ge),lineHeight:de(new M),lineNumbers:de(new ue),lineNumbersMinChars:de(new v(66,"lineNumbersMinChars",5,1,300)),linkedEditing:de(new c(67,"linkedEditing",!1,{description:m.localize(263,null)})),links:de(new c(68,"links",!0,{description:m.localize(264,null)})),matchBrackets:de(new s(69,"matchBrackets","always",["always","near","never"],{description:m.localize(265,null)})),minimap:de(new Y),mouseStyle:de(new s(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:de(new E(72,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:m.localize(266,null)})),mouseWheelZoom:de(new c(73,"mouseWheelZoom",!1,{markdownDescription:m.localize(267,null)})),multiCursorMergeOverlapping:de(new c(74,"multiCursorMergeOverlapping",!0,{description:m.localize(268,null)})),multiCursorModifier:de(new t(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[m.localize(269,null),m.localize(270,null)],markdownDescription:m.localize(271,null)})),multiCursorPaste:de(new s(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(272,null),m.localize(273,null)],markdownDescription:m.localize(274,null)})),multiCursorLimit:de(new v(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(275,null)})),occurrencesHighlight:de(new c(78,"occurrencesHighlight",!0,{description:m.localize(276,null)})),overviewRulerBorder:de(new c(79,"overviewRulerBorder",!0,{description:m.localize(277,null)})),overviewRulerLanes:de(new v(80,"overviewRulerLanes",3,0,3)),padding:de(new Se),pasteAs:de(new st),parameterHints:de(new ee),peekWidgetDefaultFocus:de(new s(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(278,null),m.localize(279,null)],description:m.localize(280,null)})),definitionLinkOpensInPeek:de(new c(85,"definitionLinkOpensInPeek",!1,{description:m.localize(281,null)})),quickSuggestions:de(new le),quickSuggestionsDelay:de(new v(87,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(282,null)})),readOnly:de(new c(88,"readOnly",!1)),readOnlyMessage:de(new T),renameOnType:de(new c(90,"renameOnType",!1,{description:m.localize(283,null),markdownDeprecationMessage:m.localize(284,null)})),renderControlCharacters:de(new c(91,"renderControlCharacters",!0,{description:m.localize(285,null),restricted:!0})),renderFinalNewline:de(new s(92,"renderFinalNewline",h.$f?"dimmed":"on",["off","on","dimmed"],{description:m.localize(286,null)})),renderLineHighlight:de(new s(93,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(287,null)],description:m.localize(288,null)})),renderLineHighlightOnlyWhenFocus:de(new c(94,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(289,null)})),renderValidationDecorations:de(new s(95,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:de(new s(96,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(290,null),m.localize(291,null),m.localize(292,null),""],description:m.localize(293,null)})),revealHorizontalRightPadding:de(new v(97,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:de(new c(98,"roundedSelection",!0,{description:m.localize(294,null)})),rulers:de(new oe),scrollbar:de(new Z),scrollBeyondLastColumn:de(new v(101,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(295,null)})),scrollBeyondLastLine:de(new c(102,"scrollBeyondLastLine",!0,{description:m.localize(296,null)})),scrollPredominantAxis:de(new c(103,"scrollPredominantAxis",!0,{description:m.localize(297,null)})),selectionClipboard:de(new c(104,"selectionClipboard",!0,{description:m.localize(298,null),included:h.$f})),selectionHighlight:de(new c(105,"selectionHighlight",!0,{description:m.localize(299,null)})),selectOnLineNumbers:de(new c(106,"selectOnLineNumbers",!0)),showFoldingControls:de(new s(107,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],description:m.localize(303,null)})),showUnused:de(new c(108,"showUnused",!0,{description:m.localize(304,null)})),showDeprecated:de(new c(136,"showDeprecated",!0,{description:m.localize(305,null)})),inlayHints:de(new ye),snippetSuggestions:de(new s(109,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(306,null),m.localize(307,null),m.localize(308,null),m.localize(309,null)],description:m.localize(310,null)})),smartSelect:de(new qe),smoothScrolling:de(new c(111,"smoothScrolling",!1,{description:m.localize(311,null)})),stopRenderingLineAfter:de(new v(114,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:de(new Pe),inlineSuggest:de(new me),suggestFontSize:de(new v(116,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:de(new v(117,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:de(new c(118,"suggestOnTriggerCharacters",!0,{description:m.localize(314,null)})),suggestSelection:de(new s(119,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),tabCompletion:de(new s(120,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(319,null),m.localize(320,null),m.localize(321,null)],description:m.localize(322,null)})),tabIndex:de(new v(121,"tabIndex",0,-1,1073741824)),unicodeHighlight:de(new x),unusualLineTerminators:de(new s(123,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(323,null),m.localize(324,null),m.localize(325,null)],description:m.localize(326,null)})),useShadowDOM:de(new c(124,"useShadowDOM",!0)),useTabStops:de(new c(125,"useTabStops",!0,{description:m.localize(327,null)})),wordBreak:de(new s(126,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),wordSeparators:de(new n(127,"wordSeparators",R.$Fr,{description:m.localize(331,null)})),wordWrap:de(new s(128,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(332,null),m.localize(333,null),m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordWrapBreakAfterCharacters:de(new n(129,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:de(new n(130,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:de(new v(131,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(337,null)})),wordWrapOverride1:de(new s(132,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:de(new s(133,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:de(new N),defaultColorDecorators:de(new c(143,"defaultColorDecorators",!1,{markdownDescription:m.localize(338,null)})),pixelRatio:de(new te),tabFocusMode:de(new c(140,"tabFocusMode",!1,{markdownDescription:m.localize(339,null)})),layoutInfo:de(new V),wrappingInfo:de(new Ge),wrappingIndent:de(new tt),wrappingStrategy:de(new H)}}),define(De[176],Ce([14,15]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[177],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(De[178],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(De[179],Ce([14,15]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[180],Ce([14,15]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[181],Ce([14,15]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[182],Ce([14,15]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(De[183],Ce([14,15]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(De[184],Ce([14,15]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[185],Ce([14,15]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(De[186],Ce([14,15]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(De[187],Ce([14,15]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(De[188],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostChat",e)}),define(De[189],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[190],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[191],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[192],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(De[193],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(De[194],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[195],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[196],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[197],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[198],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[199],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[200],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[201],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(De[202],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(De[203],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[204],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[205],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[206],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[207],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[208],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[209],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[210],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[211],Ce([1,0,8,178]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var h;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(h||(e.TokenType=h={}));function F(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,A.localize)(3,null),m=(0,A.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,b.$5)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const I=this.d,w=this.c.substring(this.d,this.e),D={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:L}),this.f.push(D)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const I=this.c.substring(this.d,this.e),w=k.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,I=!1,w=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(m);return}const C=this.c.charCodeAt(L);if(I)I=!1;else if(C===47&&!w){L++;break}else C===91?w=!0:C===92?I=!0:C===93&&(w=!1);L++}for(;L<this.c.length&&k.a.has(this.c.charCodeAt(L));)L++;this.e=L;const D=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:D,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=k,k.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),k.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(De[212],Ce([1,0,23,41,180,345]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function k(c){return c=c.trim(),c==="*"||R.test(c)}e.$oo=k;function g(c){if(!k(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(R);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$po=g;function L(c){if(!c)return null;const u=c.majorBase,v=c.majorMustEqual,f=c.minorBase;let E=c.minorMustEqual;const n=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(u===0||(E=!1),o=!1);let s=0;if(c.preRelease){const t=m.exec(c.preRelease);if(t){const[,d,$,l]=t;s=Date.UTC(Number(d),Number($)-1,Number(l))}}return{majorBase:u,majorMustEqual:v,minorBase:f,minorMustEqual:E,patchBase:n,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:s}}e.$qo=L;function I(c,u,v){let f;typeof c=="string"?f=L(g(c)):f=c;let E;u instanceof Date?E=u.getTime():typeof u=="string"&&(E=new Date(u).getTime());let n;if(typeof v=="string"?n=L(g(v)):n=v,!f||!n)return!1;const o=f.majorBase,s=f.minorBase,t=f.patchBase;let d=n.majorBase,$=n.minorBase,l=n.patchBase;const S=n.notBefore;let y=n.majorMustEqual,a=n.minorMustEqual,r=n.patchMustEqual;return n.isMinimum?o>d?!0:o<d?!1:s>$?!0:s<$||E&&E<S?!1:t>=l:(o===1&&d===0&&(!y||!a||!r)&&(d=1,$=0,l=0,y=!0,a=!1,r=!1),o<d?!1:o>d?!y:s<$?!1:s>$?!a:t<l?!1:t>l?!r:!(E&&E<S))}e.$ro=I;function w(c,u,v,f,E){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([A.default.Error,h.localize(0,null)]),n;if(typeof f.name!="string")return n.push([A.default.Error,h.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([A.default.Error,h.localize(2,null,"version")]),n;if(!f.engines)return n.push([A.default.Error,h.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([A.default.Error,h.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!i(f.extensionDependencies))return n.push([A.default.Error,h.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!i(f.activationEvents))return n.push([A.default.Error,h.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([A.default.Error,h.localize(7,null,"activationEvents","main","browser")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([A.default.Warning,h.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([A.default.Error,h.localize(9,null,"main")]),n;{const t=(0,b.$6f)(v,f.main);(0,b.$Zf)(t,v)||n.push([A.default.Warning,h.localize(10,null,t.path,v.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([A.default.Error,h.localize(11,null,"browser")]),n;{const t=(0,b.$6f)(v,f.browser);(0,b.$Zf)(t,v)||n.push([A.default.Warning,h.localize(12,null,t.path,v.path)])}}if(!F.valid(f.version))return n.push([A.default.Error,h.localize(13,null)]),n;const o=[];if(!D(c,u,f,E,o))for(const t of o)n.push([A.default.Error,t]);return n}e.$so=w;function D(c,u,v,f,E){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:p(c,u,v.engines.vscode,E)}e.$to=D;function C(c,u,v){return c==="*"||p(u,v,c)}e.$uo=C;function p(c,u,v,f=[]){const E=L(g(v));if(!E)return f.push(h.localize(14,null,v)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return f.push(h.localize(15,null,v)),!1}else if(!E.majorMustEqual)return f.push(h.localize(16,null,v)),!1;return I(c,u,E)?!0:(f.push(h.localize(17,null,c,v)),!1)}function i(c){if(!Array.isArray(c))return!1;for(let u=0,v=c.length;u<v;u++)if(typeof c[u]!="string")return!1;return!0}}),define(De[97],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class b{constructor(h,F=[],R=!1){this.ctor=h,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$ih=b}),define(De[98],Ce([1,0,97]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.InstantiationType=void 0;const A=[];var h;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function F(m,k,g){k instanceof b.$ih||(k=new b.$ih(k,[],!!g)),A.push([m,k])}e.$9q=F;function R(){return A}e.$0q=R}),define(De[213],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class b{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Pp=b;class A{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const m=this.lookupOrInsertNode(F),k=this.lookupOrInsertNode(R);m.outgoing.set(k.key,k),k.incoming.set(m.key,m)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let m=this.a.get(R);return m||(m=new b(R,F),this.a.set(R,m)),m}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,m]of this.a)F.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const m=new Set([F]),k=this.c(R,m);if(k)return k}}c(F,R){for(const[m,k]of F.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const g=this.c(k,R);if(g)return g;R.delete(m)}}}e.$Qp=A}),define(De[5],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e._util=void 0;var b;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(k){return k[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(b||(e._util=b={})),e.$kh=h("instantiationService");function A(R,m,k){m[b.DI_TARGET]===m?m[b.DI_DEPENDENCIES].push({id:R,index:k}):(m[b.DI_DEPENDENCIES]=[{id:R,index:k}],m[b.DI_TARGET]=m)}function h(R){if(b.serviceIds.has(R))return b.serviceIds.get(R);const m=function(k,g,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(m,k,L)};return m.toString=()=>R,b.serviceIds.set(R,m),m}e.$lh=h;function F(R){return R}e.$mh=F}),define(De[57],Ce([1,0,12,2,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,h.$lh)("configurationService");function F(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}e.$Sh=F;function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}e.$Th=R;var m;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function k(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=k;function g(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Vh=g;function L(c,u){const v=Object.create(null);for(const f in c)I(v,f,c[f],u);return v}e.$Wh=L;function I(c,u,v,f){const E=u.split("."),n=E.pop();let o=c;for(let s=0;s<E.length;s++){const t=E[s];let d=o[t];switch(typeof d){case"undefined":d=o[t]=Object.create(null);break;case"object":break;default:f(`Ignoring ${u} as ${E.slice(0,s+1).join(".")} is ${JSON.stringify(d)}`);return}o=d}if(typeof o=="object"&&o!==null)try{o[n]=v}catch{f(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$Xh=I;function w(c,u){const v=u.split(".");D(c,v)}e.$Yh=w;function D(c,u){const v=u.shift();if(u.length===0){delete c[v];return}if(Object.keys(c).indexOf(v)!==-1){const f=c[v];typeof f=="object"&&!Array.isArray(f)&&(D(f,u),Object.keys(f).length===0&&delete c[v])}}function C(c,u,v){function f(o,s){let t=o;for(const d of s){if(typeof t!="object"||t===null)return;t=t[d]}return t}const E=u.split("."),n=f(c,E);return typeof n>"u"?v:n}e.$Zh=C;function p(c,u,v){Object.keys(u).forEach(f=>{f!=="__proto__"&&(f in c?b.$ie(c[f])&&b.$ie(u[f])?p(c[f],u[f],v):v&&(c[f]=u[f]):c[f]=u[f])})}e.$1h=p;function i(c){return c.replace(/[\[\]]/g,"")}e.$2h=i}),define(De[47],Ce([1,0,9,11,211,5,177,8]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",b.$e),k.set("isLinux",b.$f),k.set("isWindows",b.$d),k.set("isWeb",b.$j),k.set("isMacNative",b.$e&&!b.$j),k.set("isEdge",b.$B),k.set("isFirefox",b.$z),k.set("isChrome",b.$y),k.set("isSafari",b.$A);function g(ge,M){if(k.get(ge)!==void 0)throw(0,m.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(ge,M)}e.$pi=g;const L=Object.prototype.hasOwnProperty;var I;(function(ge){ge[ge.False=0]="False",ge[ge.True=1]="True",ge[ge.Defined=2]="Defined",ge[ge.Not=3]="Not",ge[ge.Equals=4]="Equals",ge[ge.NotEquals=5]="NotEquals",ge[ge.And=6]="And",ge[ge.Regex=7]="Regex",ge[ge.NotRegex=8]="NotRegex",ge[ge.Or=9]="Or",ge[ge.In=10]="In",ge[ge.NotIn=11]="NotIn",ge[ge.Greater=12]="Greater",ge[ge.GreaterEquals=13]="GreaterEquals",ge[ge.Smaller=14]="Smaller",ge[ge.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},D=(0,R.localize)(0,null),C=(0,R.localize)(1,null),p=(0,R.localize)(2,null),i=(0,R.localize)(3,null),c=(0,R.localize)(4,null),u=(0,R.localize)(5,null),v=(0,R.localize)(6,null),f=(0,R.localize)(7,null);class E{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=w){this.k=M,this.d=new h.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:D,offset:0,lexeme:"",additionalInfo:C});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const ve=this.D(),Se=ve.type===17?u:void 0;throw this.h.push({message:c,offset:ve.offset,lexeme:h.$oi.getLexeme(ve),additionalInfo:Se}),E.c}return Y}catch(Y){if(Y!==E.c)throw Y;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const Y=this.o();M.push(Y)}return M.length===1?M[0]:n.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const Y=this.s();M.push(Y)}return M.length===1?M[0]:n.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),d.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const Y=this.l();return this.A(1,i),Y?.negate()}case 17:return this.z(),P.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Y=this.l();return this.A(1,i),Y}case 17:{const Y=M.lexeme;if(this.z(),this.y(9)){const Se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Se.type!==10)throw this.B("REGEX",Se);const ee=Se.lexeme,te=ee.lastIndexOf("/"),le=te===ee.length-1?void 0:this.w(ee.substring(te+1));let X;try{X=new RegExp(ee.substring(1,te),le)}catch{throw this.B("REGEX",Se)}return K.create(Y,X)}switch(Se.type){case 10:case 19:{const ee=[Se.lexeme];this.z();let te=this.D(),le=0;for(let T=0;T<Se.lexeme.length;T++)Se.lexeme.charCodeAt(T)===40?le++:Se.lexeme.charCodeAt(T)===41&&le--;for(;!this.E()&&te.type!==15&&te.type!==16;){switch(te.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let T=0;T<te.lexeme.length;T++)te.lexeme.charCodeAt(T)===40?le++:Se.lexeme.charCodeAt(T)===41&&le--}if(le<0)break;ee.push(h.$oi.getLexeme(te)),this.z(),te=this.D()}const X=ee.join(""),ue=X.lastIndexOf("/"),se=ue===X.length-1?void 0:this.w(X.substring(ue+1));let oe;try{oe=new RegExp(X.substring(1,ue),se)}catch{throw this.B("REGEX",Se)}return n.regex(Y,oe)}case 18:{const ee=Se.lexeme;this.z();let te=null;if(!(0,A.$hd)(ee)){const le=ee.indexOf("/"),X=ee.lastIndexOf("/");if(le!==X&&le>=0){const ue=ee.slice(le+1,X),se=ee[X+1]==="i"?"i":"";try{te=new RegExp(ue,se)}catch{throw this.B("REGEX",Se)}}}if(te===null)throw this.B("REGEX",Se);return K.create(Y,te)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Se=this.u();return n.notIn(Y,Se)}switch(this.D().type){case 3:{this.z();const Se=this.u();if(this.x().type===18)return n.equals(Y,Se);switch(Se){case"true":return n.has(Y);case"false":return n.not(Y);default:return n.equals(Y,Se)}}case 4:{this.z();const Se=this.u();if(this.x().type===18)return n.notEquals(Y,Se);switch(Se){case"true":return n.not(Y);case"false":return n.has(Y);default:return n.notEquals(Y,Se)}}case 5:return this.z(),B.create(Y,this.u());case 6:return this.z(),O.create(Y,this.u());case 7:return this.z(),U.create(Y,this.u());case 8:return this.z(),q.create(Y,this.u());case 13:return this.z(),n.in(Y,this.u());default:return n.has(Y)}}case 20:throw this.h.push({message:v,offset:M.offset,lexeme:"",additionalInfo:f}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,Y){if(this.C(M))return this.z();throw this.B(Y,this.D())}B(M,Y,ve){const Se=(0,R.localize)(8,null,M,h.$oi.getLexeme(Y)),ee=Y.offset,te=h.$oi.getLexeme(Y);return this.h.push({message:Se,offset:ee,lexeme:te,additionalInfo:ve}),E.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=E,E.c=new Error;class n{static false(){return d.INSTANCE}static true(){return $.INSTANCE}static has(M){return l.create(M)}static equals(M,Y){return S.create(M,Y)}static notEquals(M,Y){return r.create(M,Y)}static regex(M,Y){return K.create(M,Y)}static in(M,Y){return y.create(M,Y)}static notIn(M,Y){return a.create(M,Y)}static not(M){return P.create(M)}static and(...M){return he.create(M,null,!0)}static or(...M){return ie.create(M,null,!0)}static greater(M,Y){return U.create(M,Y)}static greaterEquals(M,Y){return q.create(M,Y)}static smaller(M,Y){return B.create(M,Y)}static smallerEquals(M,Y){return O.create(M,Y)}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$ri=n,n.c=new E({regexParsingWithErrorRecovery:!1});function o(ge){const M=new E({regexParsingWithErrorRecovery:!1});return ge.map(Y=>(M.parse(Y),M.lexingErrors.length>0?M.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}e.$si=o;function s(ge,M){const Y=ge?ge.substituteConstants():void 0,ve=M?M.substituteConstants():void 0;return!Y&&!ve?!0:!Y||!ve?!1:Y.equals(ve)}e.$ti=s;function t(ge,M){return ge.cmp(M)}class d{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return $.INSTANCE}}e.$ui=d,d.INSTANCE=new d;class ${constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return d.INSTANCE}}e.$vi=$,$.INSTANCE=new $;class l{static create(M,Y=null){const ve=k.get(M);return typeof ve=="boolean"?ve?$.INSTANCE:d.INSTANCE:new l(M,Y)}constructor(M,Y){this.key=M,this.c=Y,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=k.get(this.key);return typeof M=="boolean"?M?$.INSTANCE:d.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$wi=l;class S{static create(M,Y,ve=null){if(typeof Y=="boolean")return Y?l.create(M,ve):P.create(M,ve);const Se=k.get(M);return typeof Se=="boolean"?Y===(Se?"true":"false")?$.INSTANCE:d.INSTANCE:new S(M,Y,ve)}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=k.get(this.c);if(typeof M=="boolean"){const Y=M?"true":"false";return this.d===Y?$.INSTANCE:d.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.$xi=S;class y{static create(M,Y){return new y(M,Y)}constructor(M,Y){this.d=M,this.f=Y,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:H(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const Y=M.getValue(this.f),ve=M.getValue(this.d);return Array.isArray(Y)?Y.includes(ve):typeof ve=="string"&&typeof Y=="object"&&Y!==null?L.call(Y,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=a.create(this.d,this.f)),this.c}}e.$yi=y;class a{static create(M,Y){return new a(M,Y)}constructor(M,Y){this.d=M,this.f=Y,this.type=11,this.c=y.create(M,Y)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=a;class r{static create(M,Y,ve=null){if(typeof Y=="boolean")return Y?P.create(M,ve):l.create(M,ve);const Se=k.get(M);return typeof Se=="boolean"?Y===(Se?"true":"false")?d.INSTANCE:$.INSTANCE:new r(M,Y,ve)}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=k.get(this.c);if(typeof M=="boolean"){const Y=M?"true":"false";return this.d===Y?d.INSTANCE:$.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ai=r;class P{static create(M,Y=null){const ve=k.get(M);return typeof ve=="boolean"?ve?d.INSTANCE:$.INSTANCE:new P(M,Y)}constructor(M,Y){this.c=M,this.d=Y,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:V(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=k.get(this.c);return typeof M=="boolean"?M?d.INSTANCE:$.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Bi=P;function N(ge,M){if(typeof ge=="string"){const Y=parseFloat(ge);isNaN(Y)||(ge=Y)}return typeof ge=="string"||typeof ge=="number"?M(ge):d.INSTANCE}class U{static create(M,Y,ve=null){return N(Y,Se=>new U(M,Se,ve))}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ci=U;class q{static create(M,Y,ve=null){return N(Y,Se=>new q(M,Se,ve))}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Di=q;class B{static create(M,Y,ve=null){return N(Y,Se=>new B(M,Se,ve))}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ei=B;class O{static create(M,Y,ve=null){return N(Y,Se=>new O(M,Se,ve))}constructor(M,Y,ve){this.c=M,this.d=Y,this.f=ve,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Fi=O;class K{static create(M,Y){return new K(M,Y)}constructor(M,Y){this.d=M,this.f=Y,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const Y=this.f?this.f.source:"",ve=M.f?M.f.source:"";return Y<ve?-1:Y>ve?1:0}equals(M){if(M.type===this.type){const Y=this.f?this.f.source:"",ve=M.f?M.f.source:"";return this.d===M.d&&Y===ve}return!1}substituteConstants(){return this}evaluate(M){const Y=M.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$Gi=K;class z{static create(M){return new z(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new z(this.c.map(M))}negate(){return this.c}}e.$Hi=z;function j(ge){let M=null;for(let Y=0,ve=ge.length;Y<ve;Y++){const Se=ge[Y].substituteConstants();if(ge[Y]!==Se&&M===null){M=[];for(let ee=0;ee<Y;ee++)M[ee]=ge[ee]}M!==null&&(M[Y]=Se)}return M===null?ge:M}class he{static create(M,Y,ve){return he.d(M,Y,ve)}constructor(M,Y){this.expr=M,this.c=Y,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Y=0,ve=this.expr.length;Y<ve;Y++){const Se=t(this.expr[Y],M.expr[Y]);if(Se!==0)return Se}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Y=0,ve=this.expr.length;Y<ve;Y++)if(!this.expr[Y].equals(M.expr[Y]))return!1;return!0}return!1}substituteConstants(){const M=j(this.expr);return M===this.expr?this:he.create(M,this.c,!1)}evaluate(M){for(let Y=0,ve=this.expr.length;Y<ve;Y++)if(!this.expr[Y].evaluate(M))return!1;return!0}static d(M,Y,ve){const Se=[];let ee=!1;for(const te of M)if(te){if(te.type===1){ee=!0;continue}if(te.type===0)return d.INSTANCE;if(te.type===6){Se.push(...te.expr);continue}Se.push(te)}if(Se.length===0&&ee)return $.INSTANCE;if(Se.length!==0){if(Se.length===1)return Se[0];Se.sort(t);for(let te=1;te<Se.length;te++)Se[te-1].equals(Se[te])&&(Se.splice(te,1),te--);if(Se.length===1)return Se[0];for(;Se.length>1;){const te=Se[Se.length-1];if(te.type!==9)break;Se.pop();const le=Se.pop(),X=Se.length===0,ue=ie.create(te.expr.map(se=>he.create([se,le],null,ve)),null,X);ue&&(Se.push(ue),Se.sort(t))}if(Se.length===1)return Se[0];if(ve){for(let te=0;te<Se.length;te++)for(let le=te+1;le<Se.length;le++)if(Se[te].negate().equals(Se[le]))return d.INSTANCE;if(Se.length===1)return Se[0]}return new he(Se,Y)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const Y of this.expr)M.push(...Y.keys());return M}map(M){return new he(this.expr.map(Y=>Y.map(M)),null)}negate(){if(!this.c){const M=[];for(const Y of this.expr)M.push(Y.negate());this.c=ie.create(M,this,!0)}return this.c}}e.$Ii=he;class ie{static create(M,Y,ve){return ie.d(M,Y,ve)}constructor(M,Y){this.expr=M,this.c=Y,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Y=0,ve=this.expr.length;Y<ve;Y++){const Se=t(this.expr[Y],M.expr[Y]);if(Se!==0)return Se}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Y=0,ve=this.expr.length;Y<ve;Y++)if(!this.expr[Y].equals(M.expr[Y]))return!1;return!0}return!1}substituteConstants(){const M=j(this.expr);return M===this.expr?this:ie.create(M,this.c,!1)}evaluate(M){for(let Y=0,ve=this.expr.length;Y<ve;Y++)if(this.expr[Y].evaluate(M))return!0;return!1}static d(M,Y,ve){let Se=[],ee=!1;if(M){for(let te=0,le=M.length;te<le;te++){const X=M[te];if(X){if(X.type===0){ee=!0;continue}if(X.type===1)return $.INSTANCE;if(X.type===9){Se=Se.concat(X.expr);continue}Se.push(X)}}if(Se.length===0&&ee)return d.INSTANCE;Se.sort(t)}if(Se.length!==0){if(Se.length===1)return Se[0];for(let te=1;te<Se.length;te++)Se[te-1].equals(Se[te])&&(Se.splice(te,1),te--);if(Se.length===1)return Se[0];if(ve){for(let te=0;te<Se.length;te++)for(let le=te+1;le<Se.length;le++)if(Se[te].negate().equals(Se[le]))return $.INSTANCE;if(Se.length===1)return Se[0]}return new ie(Se,Y)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const Y of this.expr)M.push(...Y.keys());return M}map(M){return new ie(this.expr.map(Y=>Y.map(M)),null)}negate(){if(!this.c){const M=[];for(const Y of this.expr)M.push(Y.negate());for(;M.length>1;){const Y=M.shift(),ve=M.shift(),Se=[];for(const ee of ye(Y))for(const te of ye(ve))Se.push(he.create([ee,te],null,!1));M.unshift(ie.create(Se,null,!1))}this.c=ie.create(M,this,!0)}return this.c}}e.$Ji=ie;class ne extends l{static all(){return ne.d.values()}constructor(M,Y,ve){super(M,null),this.f=Y,typeof ve=="object"?ne.d.push({...ve,key:M}):ve!==!0&&ne.d.push({key:M,description:ve,type:Y!=null?typeof Y:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return S.create(this.key,M)}notEqualsTo(M){return r.create(this.key,M)}}e.$Ki=ne,ne.d=[],e.$Li=(0,F.$lh)("contextKeyService");function V(ge,M){return ge<M?-1:ge>M?1:0}function H(ge,M,Y,ve){return ge<Y?-1:ge>Y?1:M<ve?-1:M>ve?1:0}function ce(ge,M){if(ge.type===0||M.type===1)return!0;if(ge.type===9)return M.type===9?pe(ge.expr,M.expr):!1;if(M.type===9){for(const Y of M.expr)if(ce(ge,Y))return!0;return!1}if(ge.type===6){if(M.type===6)return pe(M.expr,ge.expr);for(const Y of ge.expr)if(ce(Y,M))return!0;return!1}return ge.equals(M)}e.$Mi=ce;function pe(ge,M){let Y=0,ve=0;for(;Y<ge.length&&ve<M.length;){const Se=ge[Y].cmp(M[ve]);if(Se<0)return!1;Se===0&&Y++,ve++}return Y===ge.length}function ye(ge){return ge.type===9?ge.expr:[ge]}}),define(De[214],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,b.$lh)("environmentService"),e.$th=(0,b.$mh)(e.$sh)}),define(De[126],Ce([1,0,179,5]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Mn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=void 0,e.$An="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Bn=new RegExp(e.$An),e.$Cn="__web_extension",e.$Dn="skipWalkthrough",e.$En="extensionsSync";function h(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Fn=h;function F(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Gn=F;function R(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Hn=R;function m(u,v){return v==="web"&&!u.includes("web")}e.$In=m;function k(u,v,f){return m(v,f)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===f?!0:g(f).includes(u)}e.$Jn=k;function g(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Kn=g;function L(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$Ln=L;var I;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var D;(function(u){u.Install="install",u.Uninstall="uninstall"})(D||(e.StatisticType=D={}));var C;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$Mn=(0,A.$lh)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var i;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class c extends Error{constructor(v,f){super(v),this.code=f,this.name=f}}e.$Nn=c,e.$On=(0,A.$lh)("extensionManagementService"),e.$Pn="extensionsIdentifiers/disabled",e.$Qn="extensionsIdentifiers/enabled",e.$Rn=(0,A.$lh)("IGlobalExtensionEnablementService"),e.$Sn=(0,A.$lh)("IExtensionTipsService"),e.$Tn=(0,b.localize)(0,null),e.$Un={value:e.$Tn,original:"Extensions"},e.$Vn={value:(0,b.localize)(1,null),original:"Preferences"}}),define(De[215],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kUb=e.$jUb=e.$iUb=void 0,e.$iUb=(0,b.$lh)("externalTerminal"),e.$jUb="Terminal.app",e.$kUb=(0,b.$lh)("externalTerminal")}),define(De[216],Ce([1,0,45,16,10,9,92,29,96,181,215]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X2b=e.$W2b=e.$V2b=void 0;const I=g.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends w{openTerminal(f,E){return this.spawnTerminal(b,f,k.$el(),E)}spawnTerminal(f,E,n,o){const s=E.windowsExec||D.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=h.$cc(s,".exe").toLowerCase();if(t==="cmder")return f.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),t==="wt"&&d.push("-d ."),new Promise(($,l)=>{const S=i(process),y=f.spawn(n,d,{cwd:o,env:S});y.on("error",l),y.on("exit",()=>$())})}runInTerminal(f,E,n,o,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:D.getDefaultTerminalWindows();return new Promise((d,$)=>{const l=`"${E} - ${I}"`,S=`""${n.join('" "')}" & pause"`,y=Object.assign({},i(process),o);Object.keys(y).filter(U=>y[U]===null).forEach(U=>delete y[U]);const a={cwd:E,env:y,windowsVerbatimArguments:!0};let r,P;h.$cc(t,".exe")==="wt"?(r=t,P=["-d",".",D.b,"/c",S]):(r=D.b,P=["/c","start",l,"/wait",t,"/c",S]),b.spawn(r,P,a).on("error",U=>{$(c(U))}),d(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.$V2b=D,D.b="cmd.exe";class C extends w{openTerminal(f,E){return this.spawnTerminal(b,f,E)}runInTerminal(f,E,n,o,s){const t=s.osxExec||L.$jUb;return new Promise((d,$)=>{if(t===L.$jUb||t==="iTerm.app"){const l=t===L.$jUb?"TerminalHelper":"iTermHelper",y=[A.$1e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`).fsPath,"-t",f||I,"-w",E];for(const P of n)y.push("-a"),y.push(P);if(o){const P=Object.assign({},i(process),o);for(const N in P){const U=P[N];U===null?(y.push("-u"),y.push(N)):(y.push("-e"),y.push(`${N}=${U}`))}}let a="";const r=b.spawn(C.b,y);r.on("error",P=>{$(c(P))}),r.stderr.on("data",P=>{a+=P.toString()}),r.on("exit",P=>{if(P===0)d(void 0);else if(a){const N=a.split(`
`,1);$(new Error(N[0]))}else $(new Error(g.localize(1,null,l,P)))})}else $(new Error(g.localize(2,null,t)))})}spawnTerminal(f,E,n){const o=E.osxExec||L.$jUb;return new Promise((s,t)=>{const d=["-a",o];n&&d.push(n);const $=i(process),l=f.spawn("/usr/bin/open",d,{cwd:n,env:$});l.on("error",t),l.on("exit",()=>s())})}}e.$W2b=C,C.b="/usr/bin/osascript";class p extends w{openTerminal(f,E){return this.spawnTerminal(b,f,E)}runInTerminal(f,E,n,o,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((d,$)=>{const l=[];t.then(S=>{S.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const y=`${u(n)}; echo; read -p "${p.b}" -n1;`;l.push(`''${y}''`);const a=Object.assign({},i(process),o);Object.keys(a).filter(U=>a[U]===null).forEach(U=>delete a[U]);const r={cwd:E,env:a};let P="";const N=b.spawn(S,l,r);N.on("error",U=>{$(c(U))}),N.stderr.on("data",U=>{P+=U.toString()}),N.on("exit",U=>{if(U===0)d(void 0);else if(P){const q=P.split(`
`,1);$(new Error(q[0]))}else $(new Error(g.localize(4,null,S,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!F.$f)p.d=Promise.resolve("xterm");else{const f=await m.Promises.exists("/etc/debian_version");p.d=new Promise(E=>{f?E("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?E("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?E("konsole"):process.env.COLORTERM?E(process.env.COLORTERM):process.env.TERM?E(process.env.TERM):E("xterm")})}return p.d}spawnTerminal(f,E,n){const o=E.linuxExec?Promise.resolve(E.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{o.then(d=>{const $=i(process),l=f.spawn(d,[],{cwd:n,env:$});l.on("error",t),l.on("exit",()=>s())})})}}e.$X2b=p,p.b=g.localize(3,null);function i(v){const f={...v.env};return(0,R.$cl)(f),f}function c(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(g.localize(5,null,v.path)):v}function u(v){let f="";for(const E of v)E.indexOf(" ")>=0?f+='"'+E+'"':f+=E,f+=" ";return f}}),define(De[30],Ce([1,0,71,10,11,12,2,182,5,9,16]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileKind=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileOperationResult=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileChangeType=e.$6j=e.FileOperation=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.FileSystemProviderErrorCode=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Pj=e.$Oj=void 0,e.$Oj=(0,k.$lh)("fileService");function I(V){return V.create===!0}e.$Pj=I;var w;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var D;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(D||(e.FilePermission=D={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function p(V){return!!(V.capabilities&2)}e.$Qj=p;function i(V){return!!(V.capabilities&8)}e.$Rj=i;function c(V){return!!(V.capabilities&131072)}e.$Sj=c;function u(V){return!!(V.capabilities&4)}e.$Tj=u;function v(V){return!!(V.capabilities&16)}e.$Uj=v;function f(V){return p(V)?!!(V.capabilities&16384):!1}e.$Vj=f;function E(V){return p(V)?!!(V.capabilities&32768):!1}e.$Wj=E;function n(V){return!!(V.capabilities&65536)}e.$Xj=n;function o(V){return!!(V.capabilities&2048)}e.$Yj=o;var s;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class t extends Error{static create(H,ce){const pe=new t(H.toString(),ce);return l(pe,ce),pe}constructor(H,ce){super(H),this.code=ce}}e.$Zj=t;function d(V,H){return t.create(V,H)}e.$1j=d;function $(V){return V||d((0,m.localize)(0,null),s.Unknown)}e.$2j=$;function l(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.$3j=l;function S(V){if(!V)return s.Unknown;if(V instanceof t)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return s.Unknown;switch(H[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$4j=S;function y(V){if(V instanceof q)return V.fileOperationResult;switch(S(V)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$5j=y;var a;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(a||(e.FileOperation=a={}));class r{constructor(H,ce,pe){this.resource=H,this.operation=ce,this.target=pe}isOperation(H){return this.operation===H}}e.$6j=r;var P;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class N{constructor(H,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const pe=new Map;for(const ye of H){const ge=pe.get(ye.type);switch(ge?ge.push([ye.resource,ye]):pe.set(ye.type,[[ye.resource,ye]]),ye.type){case 1:this.rawAdded.push(ye.resource);break;case 0:this.rawUpdated.push(ye.resource);break;case 2:this.rawDeleted.push(ye.resource);break}}for(const[ye,ge]of pe)switch(ye){case 1:this.a=b.$rh.forUris(()=>ce),this.a.fill(ge);break;case 0:this.b=b.$rh.forUris(()=>ce),this.b.fill(ge);break;case 2:this.c=b.$rh.forUris(()=>ce),this.c.fill(ge);break}}contains(H,...ce){return this.d(H,{includeChildren:!1},...ce)}affects(H,...ce){return this.d(H,{includeChildren:!0},...ce)}d(H,ce,...pe){if(!H)return!1;const ye=pe.length>0;return!!((!ye||pe.includes(1))&&(this.a?.get(H)||ce.includeChildren&&this.a?.findSuperstr(H))||(!ye||pe.includes(0))&&(this.b?.get(H)||ce.includeChildren&&this.b?.findSuperstr(H))||(!ye||pe.includes(2))&&(this.c?.findSubstr(H)||ce.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$7j=N;function U(V,H,ce){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==A.sep&&(H+=A.sep),ce?(0,h.$Kd)(V,H):V.indexOf(H)===0)}e.$8j=U;class q extends Error{constructor(H,ce,pe){super(H),this.fileOperationResult=ce,this.options=pe}}e.$9j=q;class B extends q{constructor(H,ce,pe,ye){super(H,ce,ye),this.fileOperationResult=ce,this.size=pe}}e.$0j=B;class O extends q{constructor(H,ce,pe){super(H,2,pe),this.stat=ce}}e.$$j=O;var K;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$_j={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bk="files.associations",e.$ck="files.exclude",e.$dk="files.readonlyInclude",e.$ek="files.readonlyExclude",e.$fk="files.readonlyFromPermissions";var z;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$gk="";function j(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$hk=j;async function he(V,H){if(!H.hasProvider(R.URI.from({scheme:V.scheme})))return new Promise(ce=>{const pe=H.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===V.scheme&&ye.added&&(pe.dispose(),ce())})})}e.$ik=he;class ie{static formatSize(H){return(0,F.$ke)(H)||(H=0),H<ie.KB?(0,m.localize)(1,null,H.toFixed(0)):H<ie.MB?(0,m.localize)(2,null,(H/ie.KB).toFixed(2)):H<ie.GB?(0,m.localize)(3,null,(H/ie.MB).toFixed(2)):H<ie.TB?(0,m.localize)(4,null,(H/ie.GB).toFixed(2)):(0,m.localize)(5,null,(H/ie.TB).toFixed(2))}}e.$jk=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;function ne(V){const H=typeof V=="string"||V?.scheme===L.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===L.Schemas.file?1024*ie.MB:H?10*ie.MB:g.$j?50*ie.MB:1024*ie.MB}e.$kk=ne}),define(De[217],Ce([1,0,22,8,183,30]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;async function R(L,I,w,D,C,p){let i;try{await m(L,I,w,D,C,p)}catch(c){i=c}finally{i&&C.errorTransformer&&(i=C.errorTransformer(i)),typeof i<"u"&&w.error(i),w.end()}}e.$op=R;async function m(L,I,w,D,C,p){k(p);const i=await L.open(I,{create:!1});try{k(p);let c=0,u=0,v=C&&typeof C.length=="number"?C.length:void 0,f=b.$Ib.alloc(Math.min(C.bufferSize,typeof v=="number"?v:C.bufferSize)),E=C&&typeof C.position=="number"?C.position:0,n=0;do u=await L.read(i,E,f.buffer,n,f.byteLength-n),E+=u,n+=u,c+=u,typeof v=="number"&&(v-=u),n===f.byteLength&&(await w.write(D(f)),f=b.$Ib.alloc(Math.min(C.bufferSize,typeof v=="number"?v:C.bufferSize)),n=0);while(u>0&&(typeof v!="number"||v>0)&&k(p)&&g(c,C));if(n>0){let o=n;typeof v=="number"&&(o=Math.min(n,v)),w.write(D(f.slice(0,o)))}}catch(c){throw(0,F.$2j)(c)}finally{await L.close(i)}}function k(L){if(L.isCancellationRequested)throw(0,A.$3)();return!0}function g(L,I){if(typeof I?.limits?.size=="number"&&L>I.limits.size)throw(0,F.$1j)((0,h.localize)(0,null),F.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[77],Ce([1,0,32,4,10,9,2,30]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0;function k(c){return c.recursive===!0}e.$qp=k;class g extends A.$kb{constructor(u,v,f,E){super(),this.h=u,this.i=v,this.j=f,this.k=E,this.c=this.B(new A.$lb),this.f=void 0,this.g=0}m(){const u=new A.$jb;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(v=>this.h(v))),u.add(this.b.onDidLogMessage(v=>this.i(v))),u.add(this.b.onDidError(v=>this.n(v)))}n(u){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$rp=g,g.a=5;class L extends g{constructor(u,v,f){super(u,v,f,{type:"node.js",restartOnError:!1})}}e.$sp=L;class I extends g{constructor(u,v,f){super(u,v,f,{type:"universal",restartOnError:!0})}}e.$tp=I;function w(c){return c.map(u=>({type:u.type,resource:R.URI.file(u.path)}))}e.$up=w;function D(c){const u=new i;for(const v of c)u.processEvent(v);return u.coalesce()}e.$vp=D;function C(c,u){return typeof u=="string"&&!u.startsWith(b.$9i)&&!(0,h.$0b)(u)?{base:c,pattern:u}:u}e.$wp=C;function p(c,u){const v=[];for(const f of u)v.push((0,b.$aj)(C(c,f)));return v}e.$xp=p;class i{constructor(){this.a=new Set,this.b=new Map}c(u){return F.$f?u.path:u.path.toLowerCase()}processEvent(u){const v=this.b.get(this.c(u));let f=!1;if(v){const E=v.type,n=u.type;v.path!==u.path&&(u.type===2||u.type===1)?f=!0:E===1&&n===2?(this.b.delete(this.c(u)),this.a.delete(v)):E===2&&n===1?v.type=0:E===1&&n===0||(v.type=n)}else f=!0;f&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],v=[];return Array.from(this.a).filter(f=>f.type!==2?(u.push(f),!1):!0).sort((f,E)=>f.path.length-E.path.length).filter(f=>v.some(E=>(0,m.$8j)(f.path,E,!F.$f))?!1:(v.push(f.path),!0)).concat(u)}}}),define(De[218],Ce([1,0,49,17,21,31,4,69,10,9,95,29,77]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=void 0;class D extends R.$kb{constructor(i,c,u,v){super(),this.j=i,this.k=c,this.l=u,this.m=v,this.c=this.B(new A.$Fg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.k(f))),this.f=this.B(new A.$Eg(f=>this.u(f),D.b)),this.g=(0,w.$xp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,w.$xp)(this.j.path,this.j.includes):void 0,this.i=new h.$bd,this.ready=this.n()}async n(){try{const i=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const c=await I.Promises.stat(i);this.B(await this.s(i,c.isDirectory()))}catch(i){i.code!=="ENOENT"?this.w(i):this.z(i)}}async r(i){let c=i.path;try{c=await I.Promises.realpath(i.path),i.path===c&&(c=await(0,L.$Hp)(i.path)??i.path),i.path!==c&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${c})`)}catch{}return c}async s(i,c){if(g.$e&&(0,F.$He)(i,"/Volumes/",!0))return this.w(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$kb.None;const u=new h.$bd(this.i.token),v=new R.$jb;try{const f=(0,k.$cc)(i),E=(0,b.watch)(i);v.add((0,R.$ib)(()=>{E.removeAllListeners(),E.close()})),this.z(`Started watching: '${i}'`);const n=new Set;if(c)try{for(const s of await I.Promises.readdir(i))n.add(s)}catch(s){this.w(s)}const o=new Map;v.add((0,R.$ib)(()=>{for(const[,s]of o)s.dispose();o.clear()})),E.on("error",(s,t)=>{this.w(`Failed to watch ${i} for changes using fs.watch() (${s}, ${t})`),this.dispose()}),E.on("change",(s,t)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${t}`);let d="";if(t&&(d=t.toString(),g.$e&&(d=(0,m.$4k)(d))),!(!d||s!=="change"&&s!=="rename"))if(c)if(s==="rename"){o.get(d)?.dispose();const $=setTimeout(async()=>{if(o.delete(d),d===f&&!await I.Promises.exists(i)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.v((0,k.$$b)(i,d));if(u.token.isCancellationRequested)return;let S;l?n.has(d)?S=0:(S=1,n.add(d)):(n.delete(d),S=2),this.t({path:(0,k.$$b)(this.j.path,d),type:S})},D.a);o.set(d,(0,R.$ib)(()=>clearTimeout($)))}else{let $;n.has(d)?$=0:($=1,n.add(d)),this.t({path:(0,k.$$b)(this.j.path,d),type:$})}else if(s==="rename"||d!==f){const $=setTimeout(async()=>{const l=await I.Promises.exists(i);u.token.isCancellationRequested||(l?(this.t({path:this.j.path,type:0},!0),v.add(await this.s(i,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},D.a);v.clear(),v.add((0,R.$ib)(()=>clearTimeout($)))}else this.t({path:this.j.path,type:0},!0)})}catch(f){await I.Promises.exists(i)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${i} for changes using fs.watch() (${f.toString()})`)}return(0,R.$ib)(()=>{u.dispose(!0),v.dispose()})}t(i,c=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`),!c&&this.g.some(u=>u(i.path))?this.m&&this.z(` >> ignored (excluded) ${i.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(u=>u(i.path))?this.m&&this.z(` >> ignored (not included) ${i.path}`):this.f.work(i))}u(i){const c=(0,w.$vp)(i);if(c.length>0){if(this.m)for(const v of c)this.z(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.c.work(c)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(i){if(g.$f)return I.Promises.exists(i);try{const c=(0,k.$cc)(i);return(await I.Promises.readdir((0,k.$bc)(i))).some(v=>v===c)}catch(c){return this.z(c),!1}}setVerboseLogging(i){this.m=i}w(i){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}y(i){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}z(i){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Kp=D,D.a=100,D.b=75;async function C(p,i,c,u,v=512){const f=await I.Promises.open(p,"r"),E=Buffer.allocUnsafe(v),n=new h.$bd(u);let o,s=!1;const t={path:p,excludes:[],recursive:!1},d=new D(t,$=>{(async()=>{for(const{type:l}of $)if(l===0){if(s)return;s=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:S}=await I.Promises.read(f,E,0,v,null);if(!S||n.token.isCancellationRequested)break;i(E.slice(0,S))}}catch(S){o=new Error(S),n.dispose(!0)}finally{s=!1}}})()});return await d.ready,c(),new Promise(($,l)=>{n.token.onCancellationRequested(async()=>{d.dispose();try{await I.Promises.close(f)}catch(S){o=new Error(S)}o?l(o):$()})})}e.$Lp=C}),define(De[219],Ce([1,0,3,32,4,9,218]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class m extends h.$kb{constructor(){super(...arguments),this.a=this.B(new b.$5c),this.onDidChangeFile=this.a.event,this.b=this.B(new b.$5c),this.onDidLogMessage=this.b.event,this.onDidError=b.Event.None,this.c=new Map,this.f=!1}async watch(g){const L=this.i(g),I=L.filter(D=>{const C=this.c.get(D.path);return C?!(0,A.$ej)(C.request.excludes,D.excludes)||!(0,A.$ej)(C.request.includes,D.includes):!0}),w=Array.from(this.c.values()).filter(({request:D})=>!L.find(C=>C.path===D.path&&(0,A.$ej)(C.excludes,D.excludes)&&(0,A.$ej)(C.includes,D.includes))).map(({request:D})=>D.path);I.length&&this.j(`Request to start watching: ${I.map(D=>`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const D of w)this.h(D);for(const D of I)this.g(D)}g(g){const L=new R.$Kp(g,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:g,instance:L};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const L=this.c.get(g);L&&(this.c.delete(g),L.instance.dispose())}i(g){const L=new Map;for(const I of g){const w=F.$f?I.path:I.path.toLowerCase();L.set(w,I)}return Array.from(L.values())}async setVerboseLogging(g){this.f=g;for(const[,L]of this.c)L.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,L){return L?`[File Watcher (node.js)] ${g} (path: ${L.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Mp=m}),define(De[220],Ce([1,0,77,219]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class h extends b.$sp{constructor(R,m,k){super(R,m,k),this.m()}l(){return new A.$Mp}}e.$Np=h}),define(De[221],Ce([1,0,16,75,158,77]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;class R extends F.$tp{constructor(k,g,L){super(k,g,L),this.m()}l(k){const g=k.add(new h.$Ep(b.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:L,signal:I})=>this.n(`terminated by itself with code ${L}, signal: ${I}`))),A.ProxyChannel.toService((0,A.$5g)(g.getChannel("watcher")))}}e.$Fp=R}),define(De[99],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class b{constructor(...h){this.a=new Map;for(const[F,R]of h)this.set(F,R)}set(h,F){const R=this.a.get(h);return this.a.set(h,F),R}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$jh=b}),define(De[222],Ce([1,0,17,8,4,97,213,5,99,68]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;const L=!1;class I extends Error{constructor(i){super("cyclic dependency between services"),this.message=i.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${i.toString()}`}}class w{constructor(i=new k.$jh,c=!1,u,v=L){this.f=i,this.g=c,this.h=u,this.i=v,this.o=new Set,this.f.set(m.$kh,this),this._globalGraph=v?u?._globalGraph??new R.$Qp(f=>f):void 0}createChild(i){return new w(i,this.g,this,this.i)}invokeFunction(i,...c){const u=C.traceInvocation(this.i,i);let v=!1;try{return i({get:E=>{if(v)throw(0,A.$5)("service accessor is only valid during the invocation of its target method");const n=this.m(E,u);if(!n)throw new Error(`[invokeFunction] unknown service '${E}'`);return n}},...c)}finally{v=!0,u.stop()}}createInstance(i,...c){let u,v;return i instanceof F.$ih?(u=C.traceCreation(this.i,i.ctor),v=this.j(i.ctor,i.staticArguments.concat(c),u)):(u=C.traceCreation(this.i,i),v=this.j(i,c,u)),u.stop(),v}j(i,c=[],u){const v=m._util.getServiceDependencies(i).sort((n,o)=>n.index-o.index),f=[];for(const n of v){const o=this.m(n.id,u);o||this.u(`[createInstance] ${i.name} depends on UNKNOWN service ${n.id}.`,!1),f.push(o)}const E=v.length>0?v[0].index:c.length;if(c.length!==E){console.trace(`[createInstance] First service dependency of ${i.name} at position ${E+1} conflicts with ${c.length} static arguments`);const n=E-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,E)}return Reflect.construct(i,c.concat(f))}k(i,c){if(this.f.get(i)instanceof F.$ih)this.f.set(i,c);else if(this.h)this.h.k(i,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(i){const c=this.f.get(i);return!c&&this.h?this.h.l(i):c}m(i,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(i));const u=this.l(i);return u instanceof F.$ih?this.q(i,u,c.branch(i,!0)):(c.branch(i,!1),u)}q(i,c,u){if(this.o.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this.o.add(i);try{return this.r(i,c,u)}finally{this.o.delete(i)}}r(i,c,u){const v=new R.$Qp(n=>n.id.toString());let f=0;const E=[{id:i,desc:c,_trace:u}];for(;E.length;){const n=E.pop();if(v.lookupOrInsertNode(n),f++>1e3)throw new I(v);for(const o of m._util.getServiceDependencies(n.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${i} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),s instanceof F.$ih){const t={id:o.id,desc:s,_trace:n._trace.branch(o.id,!0)};v.insertEdge(n,t),E.push(t)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new I(v);break}for(const{data:o}of n){if(this.l(o.id)instanceof F.$ih){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}v.removeNode(o)}}return this.l(i)}s(i,c,u=[],v,f){if(this.f.get(i)instanceof F.$ih)return this.t(i,c,u,v,f);if(this.h)return this.h.s(i,c,u,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(i,c,u=[],v,f){if(v){const E=new w(void 0,this.g,this,this.i);E.c=String(i);const n=new Map,o=new b.$Hg(()=>{const s=E.j(c,u,f);for(const[t,d]of n){const $=s[t];if(typeof $=="function")for(const l of d)$.apply(s,l)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let l=n.get(t);return l||(l=new g.$jc,n.set(t,l)),(y,a,r)=>{const P=l.push([y,a,r]);return(0,h.$ib)(P)}}if(t in s)return s[t];const d=o.value;let $=d[t];return typeof $!="function"||($=$.bind(d),s[t]=$),$},set(s,t,d){return o.value[t]=d,!0},getPrototypeOf(s){return c.prototype}})}else return this.j(c,u,f)}u(i,c){if(c&&console.warn(i),this.g)throw new Error(i)}}e.$Rp=w;var D;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(D||(D={}));class C{static traceInvocation(i,c){return i?new C(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(i,c){return i?new C(1,c.name):C.c}constructor(i,c){this.type=i,this.name=c,this.g=Date.now(),this.h=[]}branch(i,c){const u=new C(3,i.toString());return this.h.push([i,c,u]),u}stop(){const i=Date.now()-this.g;C.f+=i;let c=!1;function u(f,E){const n=[],o=new Array(f+1).join("	");for(const[s,t,d]of E.h)if(t&&d){c=!0,n.push(`${o}CREATES -> ${s}`);const $=u(f+1,d);$&&n.push($)}else n.push(`${o}uses -> ${s}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(i>2||c)&&C.all.add(v.join(`
`))}}e.$Sp=C,C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0}),define(De[18],Ce([1,0,46,3,70,4,28,9,23,12,2,47,5]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,w.$lh)("logService"),e.$Oi=(0,w.$lh)("loggerService");function D(){return new Date().toISOString()}function C(y){return(0,g.$ke)(y)}e.$Pi=C;var p;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Qi=p.Info;function i(y,a,r){switch(a){case p.Trace:y.trace(r);break;case p.Debug:y.debug(r);break;case p.Info:y.info(r);break;case p.Warning:y.warn(r);break;case p.Error:y.error(r);break;case p.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=i;function c(y,a=!1){let r="";for(let P=0;P<y.length;P++){let N=y[P];if(N instanceof Error&&(N=(0,b.$9h)(N,a)),typeof N=="object")try{N=JSON.stringify(N)}catch{}r+=(P>0?" ":"")+N}return r}class u extends F.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new A.$5c),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==p.Off&&this.b<=a}}e.$Si=u;class v extends u{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...r){this.f(p.Trace)&&this.g(p.Trace,c([a,...r],!0))}debug(a,...r){this.f(p.Debug)&&this.g(p.Debug,c([a,...r]))}info(a,...r){this.f(p.Info)&&this.g(p.Info,c([a,...r]))}warn(a,...r){this.f(p.Warning)&&this.g(p.Warning,c([a,...r]))}error(a,...r){if(this.f(p.Error))if(a instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=a.stack,this.g(p.Error,c(P))}else this.g(p.Error,c([a,...r]))}flush(){}}e.$Ti=v;class f extends u{constructor(a=e.$Qi){super(),this.setLevel(a),this.g=!m.$d}trace(a,...r){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,a,...r):console.log(`[main ${D()}]`,a,...r))}debug(a,...r){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,a,...r):console.log(`[main ${D()}]`,a,...r))}info(a,...r){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,a,...r):console.log(`[main ${D()}]`,a,...r))}warn(a,...r){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,a,...r):console.warn(`[main ${D()}]`,a,...r))}error(a,...r){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,a,...r):console.error(`[main ${D()}]`,a,...r))}dispose(){}flush(){}}e.$Ui=f;class E extends u{constructor(a=e.$Qi,r=!0){super(),this.g=r,this.setLevel(a)}trace(a,...r){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",a,...r):console.log(a,...r))}debug(a,...r){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",a,...r):console.log(a,...r))}info(a,...r){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",a,...r):console.log(a,...r))}warn(a,...r){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",a,...r):console.log(a,...r))}error(a,...r){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",a,...r):console.error(a,...r))}dispose(){}flush(){}}e.$Vi=E;class n extends u{constructor(a,r=e.$Qi){super(),this.g=a,this.setLevel(r)}trace(a,...r){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(a),...r])}debug(a,...r){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(a),...r])}info(a,...r){this.f(p.Info)&&this.g.log(p.Info,[this.h(a),...r])}warn(a,...r){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(a),...r])}error(a,...r){this.f(p.Error)&&this.g.log(p.Error,[this.h(a),...r])}h(a){return typeof a=="string"?a:(0,b.$9h)(a,this.f(p.Trace))}dispose(){}flush(){}}e.$Wi=n;class o extends u{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const r of this.g)r.setLevel(a);super.setLevel(a)}trace(a,...r){for(const P of this.g)P.trace(a,...r)}debug(a,...r){for(const P of this.g)P.debug(a,...r)}info(a,...r){for(const P of this.g)P.info(a,...r)}warn(a,...r){for(const P of this.g)P.warn(a,...r)}error(a,...r){for(const P of this.g)P.error(a,...r)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.$Xi=o;class s extends F.$kb{constructor(a,r,P){if(super(),this.h=a,this.j=r,this.b=new R.$ji,this.c=this.B(new A.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$5c),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}k(a){return(0,g.$ge)(a)?[...this.b.values()].find(r=>r.info.id===a):this.b.get(a)}getLogger(a){return this.k(a)?.logger}createLogger(a,r){const P=this.l(a),N=(0,g.$ge)(a)?a:r?.id??(0,h.$_h)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const q=r?.logLevel==="always"?p.Trace:r?.logLevel;U||(U=this.m(P,q??this.getLogLevel(P)??this.h,{...r,id:N}));const B={logger:U,info:{resource:P,id:N,logLevel:q,name:r?.name,hidden:r?.hidden,extensionId:r?.extensionId,when:r?.when}};return this.registerLogger(B.info),this.b.set(P,B),U}l(a){return(0,g.$ge)(a)?(0,k.$6f)(this.j,`${a}.log`):a}setLogLevel(a,r){if(L.URI.isUri(a)){const P=a,N=r,U=this.b.get(P);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([P,N]))}else{this.h=a;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(a,r){const P=this.k(a);P&&r!==!P.info.hidden&&(P.info.hidden=!r,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,r]))}getLogLevel(a){let r;return a&&(r=this.b.get(a)?.info.logLevel),r??this.h}registerLogger(a){const r=this.b.get(a.resource);r?r.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this.b.set(a.resource,{info:a,logger:void 0}),this.c.fire({added:[a],removed:[]}))}deregisterLogger(a){const r=this.b.get(a);r&&(r.logger&&r.logger.dispose(),this.b.delete(a),this.c.fire({added:[],removed:[r.info]}))}*getRegisteredLoggers(){for(const a of this.b.values())yield a.info}getRegisteredLogger(a){return this.b.get(a)?.info}dispose(){this.b.forEach(a=>a.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=s;class t{constructor(){this.onDidChangeLogLevel=new A.$5c().event}setLevel(a){}getLevel(){return p.Info}trace(a,...r){}debug(a,...r){}info(a,...r){}warn(a,...r){}error(a,...r){}critical(a,...r){}dispose(){}flush(){}}e.$Zi=t;class d extends t{}e.$1i=d;function $(y){if(y.verbose)return p.Trace;if(typeof y.logLevel=="string"){const a=S(y.logLevel.toLowerCase());if(a!==void 0)return a}return e.$Qi}e.$2i=$;function l(y){switch(y){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$3i=l;function S(y){switch(y){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$4i=S,e.$5i=new I.$Ki("logLevel",l(p.Info))}),define(De[223],Ce([1,0,19,17,8,3,4,10,77,18]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class L extends R.$kb{constructor(w,D){super(),this.a=w,this.b=D,this.c=this.B(new F.$5c),this.onDidChangeFile=this.c.event,this.g=this.B(new F.$5c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.$pg(0)),this.s=[],this.t=this.B(new A.$pg(0))}watch(w,D){return D.recursive||this.b?.watcher?.forceUniversal?this.l(w,D):this.u(w,D)}l(w,D){const C={path:this.C(w),excludes:D.excludes,includes:D.includes,recursive:D.recursive},p=(0,b.$yf)(this.j,C);return this.m(),(0,R.$ib)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,h.$X)(w))}n(){this.h||(this.h=this.B(this.p(D=>this.c.fire((0,k.$up)(D)),D=>this.z(D),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const D of this.j)(0,k.$qp)(D)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const D of this.j)(0,k.$qp)(D)&&w.includes(D.path)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,D){const C={path:this.C(w),excludes:D.excludes,includes:D.includes,recursive:!1},p=(0,b.$yf)(this.s,C);return this.v(),(0,R.$ib)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,h.$X)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,k.$up)(w)),w=>this.z(w),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,m.$9b)(w.fsPath)}}e.$yp=L}),define(De[224],Ce([1,0,49,346,17,28,22,3,31,4,10,9,23,93,29,184,30,217,223,46,221,220]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0,(()=>{try{(0,A.gracefulify)(b)}catch(o){console.error(`Error enabling graceful-fs: ${(0,v.$9h)(o)}`)}})();class n extends u.$yp{constructor(s,t){super(s,t),this.onDidChangeCapabilities=m.Event.None,this.I=new F.$ji(d=>w.$Wf.getComparisonKey(d)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$f&&(this.F|=1024)),this.F}async stat(s){try{const{stat:t,symbolicLink:d}=await C.SymlinkSupport.stat(this.C(s));return{type:this.H(t,d),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:i.FilePermission.Locked}}catch(t){throw this.ab(t)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const t=await C.Promises.readdir(this.C(s),{withFileTypes:!0}),d=[];return await Promise.all(t.map(async $=>{try{let l;$.isSymbolicLink()?l=(await this.stat((0,w.$6f)(s,$.name))).type:l=this.H($),d.push([$.name,l])}catch(l){this.a.trace(l)}})),d}catch(t){throw this.ab(t)}}H(s,t){let d;return t?.dangling?d=i.FileType.Unknown:s.isFile()?d=i.FileType.File:s.isDirectory()?d=i.FileType.Directory:d=i.FileType.Unknown,t&&(d|=i.FileType.SymbolicLink),d}async J(s){const t=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let d;for(;d=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await d.wait();const $=new h.$qg;return this.I.set(s,$),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,g.$ib)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.I.get(s)===$&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),$.open()})}async readFile(s,t){let d;try{t?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),d=await this.J(s));const $=this.C(s);return await C.Promises.readFile($)}catch($){throw this.ab($)}finally{d?.dispose()}}L(s){n.D&&this.a.trace(s)}readFileStream(s,t,d){const $=(0,D.$wb)(l=>R.$Ib.concat(l.map(S=>R.$Ib.wrap(S))).buffer);return(0,c.$op)(this,s,$,l=>l.buffer,{...t,bufferSize:256*1024},d),$}async writeFile(s,t,d){return d?.atomic!==!1&&d?.atomic?.postfix?this.M(s,(0,w.$6f)((0,w.$5f)(s),`${(0,w.$3f)(s)}${d.atomic.postfix}`),t,d):this.N(s,t,d)}async M(s,t,d,$){await this.N(t,d,$);try{await this.rename(t,s,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async N(s,t,d){let $;try{const l=this.C(s);if(!d.create||!d.overwrite){if(await C.Promises.exists(l)){if(!d.overwrite)throw(0,i.$1j)((0,p.localize)(0,null),i.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,i.$1j)((0,p.localize)(1,null),i.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(s,{create:!0,unlock:d.unlock}),await this.write($,0,t,0,t.byteLength)}catch(l){throw await this.bb(s,l)}finally{typeof $=="number"&&await this.close($)}}static configureFlushOnWrite(s){n.R=s}async open(s,t){const d=this.C(s);let $;(0,i.$Pj)(t)&&($=await this.J(s));let l;try{if((0,i.$Pj)(t)&&t.unlock)try{const{stat:y}=await C.SymlinkSupport.stat(d);y.mode&128||await C.Promises.chmod(d,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let S;if((0,i.$Pj)(t)){if(I.$d)try{await C.Promises.truncate(d,0),S="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}S||(S="w")}else S="r";l=await C.Promises.open(d,S)}catch(S){throw $?.dispose(),(0,i.$Pj)(t)?await this.bb(s,S):this.ab(S)}if(this.O.set(l,0),(0,i.$Pj)(t)&&this.Q.set(l,s),$){const S=this.P.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${d})`),this.P.set(l,$),S&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${d})`),S.dispose())}return l}async close(s){const t=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&n.R)try{await C.Promises.fdatasync(s)}catch(d){n.configureFlushOnWrite(!1),this.a.error(d)}return await C.Promises.close(s)}catch(d){throw this.ab(d)}finally{t&&(this.P.get(s)===t&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),t.dispose())}}async read(s,t,d,$,l){const S=this.S(s,t);let y=null;try{y=(await C.Promises.read(s,d,$,l,S)).bytesRead}catch(a){throw this.ab(a)}finally{this.U(s,S,y)}return y}S(s,t){return t===this.O.get(s)?null:t}U(s,t,d){const $=this.O.get(s);typeof $=="number"&&(typeof t=="number"||(typeof d=="number"?this.O.set(s,$+d):this.O.delete(s)))}async write(s,t,d,$,l){return(0,h.$Ig)(()=>this.W(s,t,d,$,l),100,3)}async W(s,t,d,$,l){const S=this.S(s,t);let y=null;try{y=(await C.Promises.write(s,d,$,l,S)).bytesWritten}catch(a){throw await this.bb(this.Q.get(s),a)}finally{this.U(s,S,y)}return y}async mkdir(s){try{await C.Promises.mkdir(this.C(s))}catch(t){throw this.ab(t)}}async delete(s,t){try{const d=this.C(s);if(t.recursive){let $;t?.atomic!==!1&&t.atomic.postfix&&($=(0,L.$$b)((0,L.$bc)(d),`${(0,L.$cc)(d)}${t.atomic.postfix}`)),await C.Promises.rm(d,C.RimRafMode.MOVE,$)}else try{await C.Promises.unlink(d)}catch($){if($.code==="EPERM"||$.code==="EISDIR"){let l=!1;try{const{stat:S,symbolicLink:y}=await C.SymlinkSupport.stat(d);l=S.isDirectory()&&!y}catch{}if(l)await C.Promises.rmdir(d);else throw $}else throw $}}catch(d){throw this.ab(d)}}async rename(s,t,d){const $=this.C(s),l=this.C(t);if($!==l)try{await this.X(s,t,"move",d.overwrite),await C.Promises.move($,l)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,L.$cc)($),(0,L.$cc)((0,L.$bc)(l)),S.toString()))),this.ab(S)}}async copy(s,t,d){const $=this.C(s),l=this.C(t);if($!==l)try{await this.X(s,t,"copy",d.overwrite),await C.Promises.copy($,l,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,L.$cc)($),(0,L.$cc)((0,L.$bc)(l)),S.toString()))),this.ab(S)}}async X(s,t,d,$){const l=this.C(s),S=this.C(t);let y=!1;if(!!(this.capabilities&1024)||(y=(0,k.$Ge)(l,S,!0)),y){if(d==="copy")throw(0,i.$1j)((0,p.localize)(4,null),i.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const r=await this.G(s);if(!r)throw(0,i.$1j)((0,p.localize)(5,null),i.FileSystemProviderErrorCode.FileNotFound);const P=await this.G(t);if(P){if(!$)throw(0,i.$1j)((0,p.localize)(6,null),i.FileSystemProviderErrorCode.FileExists);r.type&i.FileType.File&&P.type&i.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,t){return this.Y(s,t,!1)}async Y(s,t,d){const $=this.C(s),l=this.C(t),S=!!(this.capabilities&1024);if((0,k.$Ge)($,l,!S))return;const y=new g.$jb;try{const[a,r]=await Promise.all([this.J(s),this.J(t)]);y.add(a),y.add(r),d&&await C.Promises.mkdir((0,L.$bc)(l),{recursive:!0}),await C.Promises.copyFile($,l)}catch(a){if(a.code==="ENOENT"&&!d)return this.Y(s,t,!0);throw this.ab(a)}finally{y.dispose()}}p(s,t,d){return new f.$Fp($=>s($),$=>t($),d)}y(s,t,d){return new E.$Np($=>s($),$=>t($),d)}ab(s){if(s instanceof i.$Zj)return s;let t=s,d;switch(s.code){case"ENOENT":d=i.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=i.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=i.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=i.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=i.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=i.FileSystemProviderErrorCode.Unknown;break;default:d=i.FileSystemProviderErrorCode.Unknown}return(0,i.$1j)(t,d)}async bb(s,t){let d=this.ab(t);if(s&&d.code===i.FileSystemProviderErrorCode.NoPermissions)try{const{stat:$}=await C.SymlinkSupport.stat(this.C(s));$.mode&128||(d=(0,i.$1j)(t,i.FileSystemProviderErrorCode.FileWriteLocked))}catch($){this.a.trace($)}return d}}e.$Op=n,n.D=!1,n.R=!0}),define(De[225],Ce([1,0,4,18]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=void 0;class h extends b.$kb{constructor(R,m=[]){super(),this.a=new A.$Xi([R,...m]),this.B(R.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$yM=h}),define(De[226],Ce([1,0,30,18]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0;var h;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(h||(h={}));async function F(g,L,I,w,D){try{const C=await new Promise((i,c)=>{re(["@vscode/spdlog"],i,c)});C.setFlushOn(h.Trace);const p=await C.createAsyncRotatingLogger(g,L,I,w);return D?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(C){console.error(C)}return null}function R(g,L,I){switch(L){case A.LogLevel.Trace:g.trace(I);break;case A.LogLevel.Debug:g.debug(I);break;case A.LogLevel.Info:g.info(I);break;case A.LogLevel.Warning:g.warn(I);break;case A.LogLevel.Error:g.error(I);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function m(g,L){switch(L){case A.LogLevel.Trace:g.setLevel(h.Trace);break;case A.LogLevel.Debug:g.setLevel(h.Debug);break;case A.LogLevel.Info:g.setLevel(h.Info);break;case A.LogLevel.Warning:g.setLevel(h.Warning);break;case A.LogLevel.Error:g.setLevel(h.Error);break;case A.LogLevel.Off:g.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class k extends A.$Ti{constructor(L,I,w,D,C){super(),this.k=[],this.setLevel(C),this.l=this.n(L,I,w,D),this.B(this.onDidChangeLogLevel(p=>{this.m&&m(this.m,p)}))}async n(L,I,w,D){const C=w?6:1,p=30/C*b.$jk.MB,i=await F(L,I,p,C,D);if(i){this.m=i,m(this.m,this.getLevel());for(const{level:c,message:u}of this.k)R(this.m,c,u);this.k=[]}}g(L,I){this.m?R(this.m,L,I):this.getLevel()<=L&&this.k.push({level:L,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$nM=k}),define(De[127],Ce([1,0,41,185,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(k){function g(C,p){return p-C}k.compare=g;const L=Object.create(null);L[k.Error]=(0,A.localize)(0,null),L[k.Warning]=(0,A.localize)(1,null),L[k.Info]=(0,A.localize)(2,null);function I(C){return L[C]||""}k.toString=I;function w(C){switch(C){case b.default.Error:return k.Error;case b.default.Warning:return k.Warning;case b.default.Info:return k.Info;case b.default.Ignore:return k.Hint}}k.fromSeverity=w;function D(C){switch(C){case k.Error:return b.default.Error;case k.Warning:return b.default.Warning;case k.Info:return b.default.Info;case k.Hint:return b.default.Ignore}}k.toSeverity=D}(R||(e.MarkerSeverity=R={}));var m;(function(k){const g="";function L(w){return I(w,!0)}k.makeKey=L;function I(w,D){const C=[g];return w.source?C.push(w.source.replace("\xA6","\\\xA6")):C.push(g),w.code?typeof w.code=="string"?C.push(w.code.replace("\xA6","\\\xA6")):C.push(w.code.value.replace("\xA6","\\\xA6")):C.push(g),w.severity!==void 0&&w.severity!==null?C.push(R.toString(w.severity)):C.push(g),w.message&&D?C.push(w.message.replace("\xA6","\\\xA6")):C.push(g),w.startLineNumber!==void 0&&w.startLineNumber!==null?C.push(w.startLineNumber.toString()):C.push(g),w.startColumn!==void 0&&w.startColumn!==null?C.push(w.startColumn.toString()):C.push(g),w.endLineNumber!==void 0&&w.endLineNumber!==null?C.push(w.endLineNumber.toString()):C.push(g),w.endColumn!==void 0&&w.endColumn!==null?C.push(w.endColumn.toString()):C.push(g),C.push(g),C.join("\xA6")}k.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$is=(0,h.$lh)("markerService")}),define(De[227],Ce([1,0,3,41,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oz=e.$nz=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$mz=e.Severity=void 0,e.Severity=A.default,e.$mz=(0,h.$lh)("notificationService");var F;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var m;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class k{constructor(){this.progress=new g,this.onDidClose=b.Event.None,this.onDidChangeVisibility=b.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$nz=k;class g{infinite(){}done(){}total(I){}worked(I){}}e.$oz=g}),define(De[128],Ce([1,0,11,2,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EY=e.$DY=e.$CY=e.$BY=e.$AY=void 0,e.$AY=(0,h.$lh)("openerService");function F(g,L){return A.URI.isUri(g)?(0,b.$Jd)(g.scheme,L):(0,b.$Kd)(g,L+":")}e.$BY=F;function R(g,...L){return L.some(I=>F(g,I))}e.$CY=R;function m(g,L){return g.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.$DY=m;function k(g){let L;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return I&&(L={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},g=g.with({fragment:""})),{selection:L,uri:g}}e.$EY=k}),define(De[228],Ce([1,0,9,39]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof b.$b.vscode<"u"&&typeof b.$b.vscode.context<"u"){const F=b.$b.vscode.context.configuration();if(F)h=F.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const F=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:F.version})}Object.assign(h,{extensionsGallery:A.env.EXTENSIONS_GALLERY?JSON.parse(A.env.EXTENSIONS_GALLERY):h.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else h={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.1",sha256:"095dc6d5d45490966dfa74d24add92036b42bf02a37d88c4b0f510dc91deeee6",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.80.0",sha256:"ac75e4ecf79efafa2bb0e6c8c548a6c8359555623f677a386cbcea80630aee4f",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.80.1",commit:"74f6148eb9ea00507ec113ec51c489d6ffb4b771",date:"2023-07-19T22:05:25.246Z"},Object.keys(h).length===0&&Object.assign(h,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(De[229],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,b.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"});var We=this&&this.__param||function(re,e){return function(b,A){e(b,A,re)}};define(De[129],Ce([1,0,17,21,4,5]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uz=e.$tz=e.$sz=e.$rz=e.$qz=e.ProgressLocation=e.$pz=void 0,e.$pz=(0,F.$lh)("progressService");var R;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$qz=Object.freeze({total(){},worked(){},done(){}});class m{get value(){return this.a}constructor(I){this.b=I}report(I){this.a=I,this.b(this.a)}}e.$rz=m,m.None=Object.freeze({report(){}});let k=e.$sz=class extends h.$kb{constructor(I,w){super(),this.a=new b.$Lg,w.withProgress(I,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,h.$ib)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$sz=k=He([We(1,e.$pz)],k);class g extends h.$kb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new h.$jb)}start(I){this.stop();const w=++this.a,D=new A.$bd;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,h.$ib)(()=>clearTimeout(this.f))),this.b.add((0,h.$ib)(()=>D.cancel())),this.b.add((0,h.$ib)(()=>this.c?this.c.done():void 0)),{id:w,token:D.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$tz=g,e.$uz=(0,F.$lh)("editorProgressService")}),define(De[42],Ce([1,0,53,12]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;class h{constructor(){this.a=new Map}add(R,m){b.ok(A.$ge(R)),b.ok(A.$ie(m)),b.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Qm=new h}),define(De[100],Ce([1,0,3,42]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0,e.$Rm={JSONContribution:"base.contributions.json"};function h(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class F{constructor(){this.b=new b.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[h(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;A.$Qm.add(e.$Rm.JSONContribution,R)}),define(De[130],Ce([1,0,19,3,12,176,57,100,42]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.ConfigurationScope=e.$Vm=e.EditPresentationTypes=void 0;var g;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Vm={Configuration:"base.contributions.configuration"};var L;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m="vscode://schemas/settings/resourceLanguage",e.$4m="vscode://schemas/settings/configurationDefaults";const I=k.$Qm.as(m.$Rm.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$5c,this.onDidSchemaChange=this.i.event,this.j=new A.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$3m,this.g),this.v()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const s=new Set;this.n(n,o,s),I.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const o=new Set;this.o(n,o),I.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:n,remove:o}){const s=new Set;this.o(o,s),this.n(n,!1,s),I.registerSchema(e.$3m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const o=new Set;this.k(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(n,o){const s=[];for(const{overrides:t,source:d}of n)for(const $ in t)if(o.add($),e.$6m.test($)){const l=this.a.get($),S=l?.valuesSources??new Map;if(d)for(const P of Object.keys(t[$]))S.set(P,d);const y={...l?.value||{},...t[$]};this.a.set($,{source:d,value:y,valuesSources:S});const a=(0,R.$2h)($),r={type:"object",default:y,description:F.localize(1,null,a),$ref:e.$3m,defaultDefaultValue:y,source:h.$ge(d)?void 0:d,defaultValueSource:d};s.push(...p($)),this.d[$]=r,this.b.properties[$]=r}else{this.a.set($,{value:t[$],source:d});const l=this.d[$];l&&(this.w($,l),this.r($,l))}this.m(s)}deregisterDefaultConfigurations(n){const o=new Set;this.l(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(n,o){for(const{overrides:s,source:t}of n)for(const d in s){const $=this.a.get(d),l=h.$ge(t)?t:t?.id,S=h.$ge($?.source)?$?.source:$?.source?.id;if(l===S)if(o.add(d),this.a.delete(d),e.$6m.test(d))delete this.d[d],delete this.b.properties[d];else{const y=this.d[d];y&&(this.w(d,y),this.r(d,y))}}this.u()}deltaConfiguration(n){let o=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),o=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),o=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const o of n)this.h.add(o);this.u()}n(n,o,s){n.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,s),this.c.push(t),this.q(t)})}o(n,o){const s=t=>{if(t.properties)for(const d in t.properties){o.add(d);const $=this.d[d];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[d],this.s(d,t.properties[d])}t.allOf?.forEach(d=>s(d))};for(const t of n){s(t);const d=this.c.indexOf(t);d!==-1&&this.c.splice(d,1)}}p(n,o=!0,s,t,d=3,$){d=h.$pe(n.scope)?d:n.scope;const l=n.properties;if(l)for(const y in l){const a=l[y];if(o&&v(y,a)){delete l[y];continue}if(a.source=s,a.defaultDefaultValue=l[y].default,this.w(y,a),e.$6m.test(y)?a.scope=void 0:(a.scope=h.$pe(a.scope)?d:a.scope,a.restricted=h.$pe(a.restricted)?!!t?.includes(y):a.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),$.add(y)}const S=n.allOf;if(S)for(const y of S)this.p(y,o,s,t,d,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const o=s=>{const t=s.properties;if(t)for(const $ in t)this.r($,t[$]);s.allOf?.forEach(o)};o(n)}r(n,o){switch(e.$Wm.properties[n]=o,o.scope){case 1:e.$Xm.properties[n]=o;break;case 2:e.$Ym.properties[n]=o;break;case 6:e.$Zm.properties[n]=o;break;case 3:e.$1m.properties[n]=o;break;case 4:e.$2m.properties[n]=o;break;case 5:e.$2m.properties[n]=o,this.g.properties[n]=o;break}}s(n,o){switch(delete e.$Wm.properties[n],o.scope){case 1:delete e.$Xm.properties[n];break;case 2:delete e.$Ym.properties[n];break;case 6:delete e.$Zm.properties[n];break;case 3:delete e.$1m.properties[n];break;case 4:case 5:delete e.$2m.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const o=`[${n}]`,s={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$3m};this.w(o,s),e.$Wm.properties[o]=s,e.$Xm.properties[o]=s,e.$Ym.properties[o]=s,e.$Zm.properties[o]=s,e.$1m.properties[o]=s,e.$2m.properties[o]=s}}v(){const n={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$3m};e.$Wm.patternProperties[e.$5m]=n,e.$Xm.patternProperties[e.$5m]=n,e.$Ym.patternProperties[e.$5m]=n,e.$Zm.patternProperties[e.$5m]=n,e.$1m.patternProperties[e.$5m]=n,e.$2m.patternProperties[e.$5m]=n,this.i.fire()}w(n,o){const s=this.a.get(n);let t=s?.value,d=s?.source;h.$ne(t)&&(t=o.defaultDefaultValue,d=void 0),h.$ne(t)&&(t=c(o.type)),o.default=t,o.defaultValueSource=d}}const D="\\[([^\\]]+)\\]",C=new RegExp(D,"g");e.$5m=`^(${D})+$`,e.$6m=new RegExp(e.$5m);function p(E){const n=[];if(e.$6m.test(E)){let o=C.exec(E);for(;o?.length;){const s=o[1].trim();s&&n.push(s),o=C.exec(E)}}return(0,b.$of)(n)}e.$7m=p;function i(E){return E.reduce((n,o)=>`${n}[${o}]`,"")}e.$8m=i;function c(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$9m=c;const u=new w;k.$Qm.add(e.$Vm.Configuration,u);function v(E,n){return E.trim()?e.$6m.test(E)?F.localize(7,null,E):u.getConfigurationProperties()[E]!==void 0?F.localize(8,null,E):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?F.localize(9,null,E,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:F.localize(6,null)}e.$0m=v;function f(){const E=[],n=u.getConfigurationProperties();for(const o of Object.keys(n))E.push([o,n[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$$m=f}),define(De[230],Ce([1,0,19,3,151,4,28,24,12,2,57,130,42]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=void 0;function D(o){return Object.isFrozen(o)?o:m.$Fm(o)}class C{constructor(s={},t=[],d=[],$){this.b=s,this.c=t,this.d=d,this.raw=$,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof C)return t;const d=new p("");return d.parseRaw(t),d.configurationModel});this.f=s.reduce((t,d)=>d===t?d:t.merge(d),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.$Zh)(this.contents,s):this.contents}inspect(s,t){const d=this.rawConfiguration.getValue(s),$=t?this.rawConfiguration.getOverrideValue(s,t):void 0,l=t?this.rawConfiguration.override(t).getValue(s):d;return{value:d,override:$,merged:l}}getOverrideValue(s,t){const d=this.i(t);return d?s?(0,L.$Zh)(d,s):d:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const d of this.overrides)d.identifiers.includes(s)&&t.push(...d.keys);return b.$of(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return b.$of(s)}override(s){let t=this.a.get(s);return t||(t=this.g(s),this.a.set(s,t)),t}merge(...s){const t=m.$Em(this.contents),d=m.$Em(this.overrides),$=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const S of s)if(l.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(t,S.contents);for(const y of S.overrides){const[a]=d.filter(r=>b.$$e(r.identifiers,y.identifiers));a?(this.h(a.contents,y.contents),a.keys.push(...y.keys),a.keys=b.$of(a.keys)):d.push(m.$Em(y))}for(const y of S.keys)$.indexOf(y)===-1&&$.push(y)}return new C(t,$,d,l.every(S=>S instanceof C)?void 0:l)}g(s){const t=this.i(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const d={};for(const $ of b.$of([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[$];const S=t[$];S&&(typeof l=="object"&&typeof S=="object"?(l=m.$Em(l),this.h(l,S)):l=S),d[$]=l}return new C(d,this.keys,this.overrides)}h(s,t){for(const d of Object.keys(t)){if(d in s&&k.$ie(s[d])&&k.$ie(t[d])){this.h(s[d],t[d]);continue}s[d]=m.$Em(t[d])}}i(s){let t=null,d=null;const $=l=>{l&&(d?this.h(d,l):d=m.$Em(l))};for(const l of this.overrides)b.$$e(l.identifiers,[s])?t=l.contents:l.identifiers.includes(s)&&$(l.contents);return $(t),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,t){this.j(s,t,!0)}setValue(s,t){this.j(s,t,!1)}removeValue(s){const t=this.keys.indexOf(s);t!==-1&&(this.keys.splice(t,1),(0,L.$Yh)(this.contents,s),I.$6m.test(s)&&this.overrides.splice(this.overrides.findIndex(d=>b.$$e(d.identifiers,(0,I.$7m)(s))),1))}j(s,t,d){(0,L.$Xh)(this.contents,s,t,$=>console.error($)),d=d||this.keys.indexOf(s)===-1,d&&this.keys.push(s),I.$6m.test(s)&&this.overrides.push({identifiers:(0,I.$7m)(s),keys:Object.keys(this.contents[s]),contents:(0,L.$Wh)(this.contents[s],$=>console.error($))})}}e.$_m=C;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,t){if(!k.$pe(s)){const d=this.g(s);this.parseRaw(d,t)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,t){this.a=s;const{contents:d,keys:$,overrides:l,restricted:S,hasExcludedProperties:y}=this.h(s,t);this.b=new C(d,$,l,y?[s]:void 0),this.c=S||[]}g(s){let t={},d=null,$=[];const l=[],S=[];function y(r){Array.isArray($)?$.push(r):d!==null&&($[d]=r)}const a={onObjectBegin:()=>{const r={};y(r),l.push($),$=r,d=null},onObjectProperty:r=>{d=r},onObjectEnd:()=>{$=l.pop()},onArrayBegin:()=>{const r=[];y(r),l.push($),$=r,d=null},onArrayEnd:()=>{$=l.pop()},onLiteralValue:y,onError:(r,P,N)=>{S.push({error:r,offset:P,length:N})}};if(s)try{h.$Bm(s,a),t=$[0]||{}}catch(r){console.error(`Error while parsing settings file ${this.f}: ${r}`),this.d=[r]}return t}h(s,t){const d=w.$Qm.as(I.$Vm.Configuration).getConfigurationProperties(),$=this.i(s,d,!0,t);s=$.raw;const l=(0,L.$Wh)(s,a=>console.error(`Conflict in settings file ${this.f}: ${a}`)),S=Object.keys(s),y=this.j(s,a=>console.error(`Conflict in settings file ${this.f}: ${a}`));return{contents:l,keys:S,overrides:y,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}i(s,t,d,$){let l=!1;if(!$?.scopes&&!$?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:l};const S={},y=[];for(const a in s)if(I.$6m.test(a)&&d){const r=this.i(s[a],t,!1,$);S[a]=r.raw,l=l||r.hasExcludedProperties,y.push(...r.restricted)}else{const r=t[a],P=r?typeof r.scope<"u"?r.scope:3:void 0;r?.restricted&&y.push(a),(P===void 0||$.scopes===void 0||$.scopes.includes(P))&&!($.skipRestricted&&r?.restricted)?S[a]=s[a]:l=!0}return{raw:S,restricted:y,hasExcludedProperties:l}}j(s,t){const d=[];for(const $ of Object.keys(s))if(I.$6m.test($)){const l={};for(const S in s[$])l[S]=s[$][S];d.push({identifiers:(0,I.$7m)($),keys:Object.keys(l),contents:(0,L.$Wh)(l,t)})}return d}}e.$an=p;class i extends F.$kb{constructor(s,t,d,$){super(),this.f=s,this.g=t,this.h=$,this.c=this.B(new A.$5c),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&d.isEqual(l.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$bn=i;class c{constructor(s,t,d,$,l,S,y,a,r,P,N,U,q){this.a=s,this.b=t,this.c=d,this.overrideIdentifiers=$,this.d=l,this.f=S,this.g=y,this.h=a,this.i=r,this.j=P,this.k=N,this.l=U,this.m=q}get value(){return D(this.c)}n(s,t,d){const $=s.inspect(t,d);return{get value(){return D($.value)},get override(){return D($.override)},get merged(){return D($.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(s,t,d,$,l=new C,S=new C,y=new R.$ji,a=new C,r=new R.$ji){this.c=s,this.d=t,this.f=d,this.g=$,this.h=l,this.i=S,this.j=y,this.l=a,this.m=r,this.a=null,this.b=new R.$ji,this.n=null}getValue(s,t,d){return this.q(s,t,d).getValue(s)}updateValue(s,t,d={}){let $;d.resource?($=this.m.get(d.resource),$||($=new C,this.m.set(d.resource,$))):$=this.l,t===void 0?$.removeValue(s):$.setValue(s,t),d.resource||(this.a=null)}inspect(s,t,d){const $=this.q(s,t,d),l=this.u(t.resource,d),S=t.resource?this.m.get(t.resource)||this.l:this.l,y=new Set;for(const a of $.overrides)for(const r of a.identifiers)$.getOverrideValue(s,r)!==void 0&&y.add(r);return new c(s,t,$.getValue(s),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this.i:void 0,l||void 0,S)}keys(s){const t=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,t){this.j.set(s,t),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const d=[];if(!t){const{added:$,updated:l,removed:S}=E(this.c,s);t=[...$,...l,...S]}for(const $ of t)for(const l of(0,I.$7m)($)){const S=this.c.getKeysForOverrideIdentifier(l),y=s.getKeysForOverrideIdentifier(l),a=[...y.filter(r=>S.indexOf(r)===-1),...S.filter(r=>y.indexOf(r)===-1),...S.filter(r=>!m.$Im(this.c.override(l).getValue(r),s.override(l).getValue(r)))];d.push([l,a])}return this.updateDefaultConfiguration(s),{keys:t,overrides:d}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:d,removed:$}=E(this.d,s),l=[...t,...d,...$];return l.length&&this.updatePolicyConfiguration(s),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:d,removed:$,overrides:l}=E(this.applicationConfiguration,s),S=[...t,...d,...$];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:l}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:d,removed:$,overrides:l}=E(this.localUserConfiguration,s),S=[...t,...d,...$];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:l}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:d,removed:$,overrides:l}=E(this.remoteUserConfiguration,s),S=[...t,...d,...$];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:l}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:d,removed:$,overrides:l}=E(this.workspaceConfiguration,s),S=[...t,...d,...$];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:l}}compareAndUpdateFolderConfiguration(s,t){const d=this.p.get(s),{added:$,updated:l,removed:S,overrides:y}=E(d,t),a=[...$,...l,...S];return(a.length||!d)&&this.updateFolderConfiguration(s,t),{keys:a,overrides:y}}compareAndDeleteFolderConfiguration(s){const t=this.p.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:d,updated:$,removed:l,overrides:S}=E(t,void 0);return{keys:[...d,...$,...l],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,t,d){let $=this.r(t,d);return t.overrideIdentifier&&($=$.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&($=$.merge(this.d)),$}r({resource:s},t){let d=this.s();if(t&&s){const $=t.getFolder(s);$&&(d=this.t($.uri)||d);const l=this.m.get(s);l&&(d=d.merge(l))}return d}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let t=this.b.get(s);if(!t){const d=this.s(),$=this.j.get(s);$?(t=d.merge($),this.b.set(s,t)):t=d}return t}u(s,t){if(t&&s){const d=t.getFolder(s);if(d)return this.j.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,t)=>{const{contents:d,overrides:$,keys:l}=this.j.get(t);return s.push([t,{contents:d,overrides:$,keys:l}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(t=>s.add(t)),this.userConfiguration.keys.forEach(t=>s.add(t)),this.i.keys.forEach(t=>s.add(t)),this.j.forEach(t=>t.keys.forEach(d=>s.add(d))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(d=>s.add(d))),[...s.values()]}w(s){const t=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(d=>t.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(d=>t.add(d)),this.i.getKeysForOverrideIdentifier(s).forEach(d=>t.add(d)),this.j.forEach(d=>d.getKeysForOverrideIdentifier(s).forEach($=>t.add($))),[...t.values()]}static parse(s){const t=this.x(s.defaults),d=this.x(s.policy),$=this.x(s.application),l=this.x(s.user),S=this.x(s.workspace),y=s.folders.reduce((a,r)=>(a.set(g.URI.revive(r[0]),this.x(r[1])),a),new R.$ji);return new u(t,d,$,l,new C,S,y,new C,new R.$ji)}static x(s){return new C(s.contents,s.keys,s.overrides)}}e.$cn=u;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,t=new Map;for(const $ of o)$.keys.forEach(l=>s.add(l)),$.overrides.forEach(([l,S])=>{const y=(0,R.$gi)(t,l,new Set);S.forEach(a=>y.add(a))});const d=[];return t.forEach(($,l)=>d.push([l,[...$.values()]])),{keys:[...s.values()],overrides:d}}e.$dn=v;class f{constructor(s,t,d,$){this.change=s,this.f=t,this.g=d,this.h=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of s.keys)this.affectedKeys.add(l);for(const[,l]of s.overrides)for(const S of l)this.affectedKeys.add(S);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(s,t){const d=this.a+s,$=this.d.indexOf(d);if($<0)return!1;const l=$+d.length;if(l>=this.d.length)return!1;const S=this.d.charCodeAt(l);if(S!==this.b&&S!==this.c)return!1;if(t){const y=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.f?.workspace):void 0,a=this.g.getValue(s,t,this.h);return!m.$Im(y,a)}return!0}}e.$en=f;function E(o,s){const{added:t,removed:d,updated:$}=n(s?.rawConfiguration,o?.rawConfiguration),l=[],S=o?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const a=y.filter(r=>!S.includes(r));for(const r of a)l.push([r,s.getKeysForOverrideIdentifier(r)])}if(o){const a=S.filter(r=>!y.includes(r));for(const r of a)l.push([r,o.getKeysForOverrideIdentifier(r)])}if(s&&o){for(const a of S)if(y.includes(a)){const r=n({contents:o.getOverrideValue(void 0,a)||{},keys:o.getKeysForOverrideIdentifier(a)},{contents:s.getOverrideValue(void 0,a)||{},keys:s.getKeysForOverrideIdentifier(a)});l.push([a,[...r.added,...r.removed,...r.updated]])}}return{added:t,removed:d,updated:$,overrides:l}}function n(o,s){const t=o?s?o.keys.filter(l=>s.keys.indexOf(l)===-1):[...o.keys]:[],d=s?o?s.keys.filter(l=>o.keys.indexOf(l)===-1):[...s.keys]:[],$=[];if(o&&s){for(const l of s.keys)if(o.keys.indexOf(l)!==-1){const S=(0,L.$Zh)(s.contents,l),y=(0,L.$Zh)(o.contents,l);m.$Im(S,y)||$.push(l)}}return{added:t,removed:d,updated:$}}}),define(De[131],Ce([1,0,8,5]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.RemoteAuthorityResolverErrorCode=e.$uk=e.$tk=e.RemoteConnectionType=e.$sk=void 0,e.$sk=(0,A.$lh)("remoteAuthorityResolverService");var h;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class F{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$tk=F;class R{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$uk=R;var m;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class k extends b.$_{static isNotAvailable(I){return I instanceof k&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===m.NoResolverFound}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,w=m.Unknown,D){super(I),this._message=I,this._code=w,this._detail=D,this.isHandled=w===m.NotAvailable&&D===!0,Object.setPrototypeOf(this,k.prototype)}}e.$vk=k;function g(L){const I=L.indexOf("+");return I===-1?L:L.substring(0,I)}e.$wk=g}),define(De[78],Ce([1,0,16]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function A(g){return g.scheme===b.Schemas.vscodeRemote?g.authority:void 0}e.$xk=A;function h(g){if(!g)return;const L=g.indexOf("+");return L<0?g:g.substr(0,L)}e.$yk=h;function F(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$zk=F;function R(g){const{host:L,port:I}=k(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.$Ak=R;function m(g,L){let{host:I,port:w}=k(g);return typeof w>"u"&&(w=L),{host:I,port:w}}e.$Bk=m;function k(g){const L=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=g.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:g,port:void 0}}}),define(De[25],Ce([1,0,11,5,78]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.TargetPlatform=e.ExtensionType=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=void 0,e.$yl="extensions.user.cache",e.$zl="extensions.builtin.cache",e.$Al="undefined_publisher",e.$Bl=["ui","workspace","web"];function F(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Cl=F,e.$Dl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class k{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,c){if(typeof i>"u"||i===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof i=="string"||typeof c=="string"){const u=typeof i=="string"?i:i.value,v=typeof c=="string"?c:c.value;return b.$Jd(u,v)}return i._lower===c._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.$El=k;class g{get size(){return this.c.size}constructor(i){if(this.c=new Set,i)for(const c of i)this.add(c)}add(i){this.c.add(k.toKey(i))}delete(i){return this.c.delete(k.toKey(i))}has(i){return this.c.has(k.toKey(i))}}e.$Fl=g;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(i){this.c.delete(k.toKey(i))}get(i){return this.c.get(k.toKey(i))}has(i){return this.c.has(k.toKey(i))}set(i,c){this.c.set(k.toKey(i),c)}values(){return this.c.values()}forEach(i){this.c.forEach(i)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gl=L;function I(p){return w(p)}e.$Hl=I;function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$Il=w;function D(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$Jl=D;function C(p,i){if(i){const c=`onResolveRemoteAuthority:${(0,h.$yk)(i)}`;return!!p.activationEvents?.includes(c)}return!1}e.$Kl=C,e.$Ll=(0,A.$lh)("IBuiltinExtensionsScannerService")}),define(De[132],Ce([1,0,8,25]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WE=e.$VE=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const k of R){const g=this.readActivationEvents(k);g.length>0&&(m[A.$El.toKey(k.identifier)]=g)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return m;for(const k in R.contributes){const g=this.a.get(k);if(!g)continue;const L=R.contributes[k],I=Array.isArray(L)?L:[L];try{g(I,m)}catch(w){(0,b.$X)(w)}}return m}}e.$VE=h,e.$WE=new h}),define(De[231],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xYb=void 0;class b{constructor(){this.b=new Map}async createNewMessage(h){try{const F=await this.c();if(F){const R=String(b.a++);return this.b.set(R,F),{id:R,data:F.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,F){if(!h.id)return!0;const R=this.b.get(h.id);if(!R)return!1;this.b.delete(h.id);try{return R.validate(F)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$xYb=b,b.a=1}),define(De[232],Ce([1,0,231]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=void 0;class A extends b.$xYb{c(){return this.h().then(F=>new F.validator)}d(F){return this.h().then(R=>new R.signer().sign(F))}h(){return new Promise((F,R)=>re(["vsda"],F,R))}}e.$f4b=A}),define(De[233],Ce([1,0,9,39,33]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=void 0;function F(k){if(b.$o===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function R(k,g,L,I,w,D,C,p){const i=Object.create(null);i["common.machineId"]=D,i.sessionID=(0,h.$3e)()+Date.now(),i.commitHash=I,i.version=w,i["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,b.$c)(b.$o),i["common.nodePlatform"]=A.$5b,i["common.nodeArch"]=L,i["common.product"]=p||"desktop",C&&(i["common.msftInternal"]=C);let c=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),b.$g&&(i["common.snap"]="true");const v=F(g);return v&&(i["common.platformDetail"]=v),i}e.$Wn=R;function m(k){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const L=g.toLowerCase();return k.some(I=>L===I)}e.$Xn=m}),define(De[234],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,b.$lh)("telemetryService"),e.$Sk=(0,b.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var A;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var h;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(De[79],Ce([1,0,24,12,3,57,78,233,234]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=void 0;class g{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$Yn=g;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Zn=L,e.$1n=new L;class I{async publicLog(d,$,l){}async publicLogError(d,$,l){}}e.$2n=I,e.$3n="telemetry",e.$4n="extensionTelemetryLog",e.$5n={log:()=>null,flush:()=>Promise.resolve(null)};function w(t,d){return h.Event.debounce(d.onDidChangeConfiguration,(l,S)=>{const y=l?new Set([...l.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,F.$Uh)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$6n=w;function D(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry||d.extensionTestsLocationURI)}e.$7n=D;function C(t,d){return!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$8n=C;function p(t){const d=t.getValue(k.$Yk),$=t.getValue(k.$Zk);if(t.getValue(k.$1k)===!1||$===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9n=p;function i(t){const d={},$={},l={};v(t,l);for(let S in l){S=S.length>150?S.substr(S.length-149):S;const y=l[S];typeof y=="number"?$[S]=y:typeof y=="boolean"?$[S]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${y.length}`),d[S]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(d[S]=y)}return{properties:d,measurements:$}}e.$0n=i;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const d=(0,R.$yk)(t);return c.has(d)?d:"other"}e.$$n=u;function v(t,d,$=0,l){if(t)for(const S of Object.getOwnPropertyNames(t)){const y=t[S],a=l?l+S:S;Array.isArray(y)?d[a]=(0,b.$Jm)(y):y instanceof Date?d[a]=y.toISOString():(0,A.$ie)(y)?$<2?v(y,d,$+1,a+"."):d[a]=(0,b.$Jm)(y):d[a]=y}}function f(t,d){const $=t.msftInternalDomains||[],l=d.getValue("telemetry.internalTesting");return(0,m.$Xn)($)||l}e.$_n=f;function E(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$ao=E;function n(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let $=t;const l=[];for(const r of d)for(;;){const P=r.exec(t);if(!P)break;l.push([P.index,r.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for($="";;){const r=y.exec(t);if(!r)break;const P=l.some(([N,U])=>r.index<U&&N<y.lastIndex);!S.test(r[0])&&!P&&($+=t.substring(a,r.index)+"<REDACTED: user-file-path>",a=y.lastIndex)}return a<t.length&&($+=t.substr(a)),$}function o(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of d)if($.regex.test(t))return`<REDACTED: ${$.label}>`;return t}function s(t,d){return(0,b.$Gm)(t,$=>{if($ instanceof g||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let l=$.replaceAll("%20"," ");l=n(l,d);for(const S of d)l=l.replace(S,"");return l=o(l),l}})}e.$bo=s}),define(De[235],Ce([1,0,11,126,25,9,2,8,39,79]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function L(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,b.$Ed)(s.id,t.id)===0}e.$co=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const d=t.manifest?t.manifest.version:t.version,$=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,d,$)}static parse(t){const d=I.exec(t);return d&&d[1]&&d[2]?new w({id:d[1]},d[2],d[4]||void 0):null}constructor(t,d,$="undefined"){this.version=d,this.targetPlatform=$,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?L(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$do=w;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const t=D.exec(s);return t&&t[1]?[i(t[1]),t[2]]:[i(s),void 0]}e.$eo=C;function p(s,t){return`${s}.${t}`}e.$fo=p;function i(s){return s.toLowerCase()}e.$go=i;function c(s,t){return i(p(s??h.$Al,t))}e.$ho=c;function u(s,t){const d=[],$=l=>{for(const S of d)if(S.some(y=>L(t(y),t(l))))return S;return null};for(const l of s){const S=$(l);S?S.push(l):d.push([l])}return d}e.$io=u;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$jo=v;function f(s){return{id:new g.$Yn(s.identifier.id),name:new g.$Yn(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$ko=f,e.$lo=new h.$El("pprice.better-merge");function E(s,t){const d=[],$=t.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const l=$.shift();if(l&&d.every(S=>!L(S.identifier,{id:l}))){const S=s.filter(y=>L(y.identifier,{id:l}));S.length===1&&(d.push(S[0]),$.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.$mo=E;async function n(s,t){if(!F.$f)return!1;let d;try{d=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,m.$8)(l))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,t){const d=await n(s,t),$=(0,A.$Hn)(d?"alpine":F.$o,k.$6b);return t.debug("ComputeTargetPlatform:",$),$}e.$no=o}),define(De[236],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;function b(k){return[...k.entries()]}e.$Wq=b;function A(k){return k?[...k.entries()]:[]}e.$Xq=A;function h(k){return new Map(k)}e.$Yq=h;function F(k){return new Map(k??[])}e.$Zq=F;function R(k){return Array.from(k.entries()).map(g=>[g[0],b(g[1].map),A(g[1].descriptionMap)])}e.$1q=R;function m(k){return new Map(k.map(g=>[g[0],{map:h(g[1]),descriptionMap:F(g[2])}]))}e.$2q=m}),define(De[237],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhb=void 0;class b{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,F,R=5){const m=F(k=>{const g=typeof k=="string"?k:k.data;let L=this.a.get(h);if(L){L.data.push(g);return}const I=setTimeout(()=>this.flushBuffer(h),R);L={data:[g],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),m.dispose()}},this.a.set(h,L)});return m}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const F=this.a.get(h);F&&(this.a.delete(h),this.b(h,F.data.join("")))}}e.$Rhb=b}),define(De[238],Ce([1,0,17,72,55,3,12,2,186,100,42]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ku=e.$Ju=e.$Iu=e.$Hu=e.$Gu=e.$Fu=e.$Eu=e.$Du=e.IconFontDefinition=e.IconContribution=e.$Cu=void 0,e.$Cu={IconContribution:"base.contributions.icons"};var I;(function(f){function E(n,o){let s=n.defaults;for(;h.ThemeIcon.isThemeIcon(s);){const t=C.getIcon(s.id);if(!t)return;s=t.defaults}return s}f.getDefinition=E})(I||(e.IconContribution=I={}));var w;(function(f){function E(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}f.toJSONObject=E;function n(o){const s=t=>(0,R.$ge)(t)?t:void 0;if(o&&Array.isArray(o.src)&&o.src.every(t=>(0,R.$ge)(t.format)&&(0,R.$ge)(t.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(t=>({format:t.format,location:m.URI.parse(t.location)}))}}f.fromJSONObject=n})(w||(e.IconFontDefinition=w={}));class D{constructor(){this.a=new F.$5c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(E,n,o,s){const t=this.b[E];if(t){if(o&&!t.description){t.description=o,this.d.properties[E].markdownDescription=`${o} $(${E})`;const l=this.e.enum.indexOf(E);l!==-1&&(this.e.enumDescriptions[l]=o),this.a.fire()}return t}const d={id:E,description:o,defaults:n,deprecationMessage:s};this.b[E]=d;const $={$ref:"#/definitions/icons"};return s&&($.deprecationMessage=s),o&&($.markdownDescription=`${o}: $(${E})`),this.d.properties[E]=$,this.e.enum.push(E),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:E}}deregisterIcon(E){delete this.b[E],delete this.d.properties[E];const n=this.e.enum.indexOf(E);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(E=>this.b[E])}getIcon(E){return this.b[E]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(E,n){const o=this.f[E];return o||(this.f[E]=n,this.a.fire(),n)}deregisterIconFont(E){delete this.f[E]}getIconFont(E){return this.f[E]}toString(){const E=(t,d)=>t.id.localeCompare(d.id),n=t=>{for(;h.ThemeIcon.isThemeIcon(t.defaults);)t=this.b[t.defaults.id];return`codicon codicon-${t?t.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(t=>this.b[t]);for(const t of s.filter(d=>!!d.description).sort(E))o.push(`|<i class="${n(t)}"></i>|${t.id}|${h.ThemeIcon.isThemeIcon(t.defaults)?t.defaults.id:t.id}|${t.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const t of s.filter(d=>!h.ThemeIcon.isThemeIcon(d.defaults)).sort(E))o.push(`|<i class="${n(t)}"></i>|${t.id}|`);return o.join(`
`)}}const C=new D;L.$Qm.add(e.$Cu.IconContribution,C);function p(f,E,n,o){return C.registerIcon(f,E,n,o)}e.$Du=p;function i(){return C}e.$Eu=i;function c(){const f=(0,A.$wj)();for(const E in f){const n="\\"+f[E].toString(16);C.registerIcon(E,{fontCharacter:n})}}c(),e.$Fu="vscode://schemas/icons";const u=L.$Qm.as(g.$Rm.JSONContribution);u.registerSchema(e.$Fu,C.getIconSchema());const v=new b.$Cg(()=>u.notifySchemaChanged(e.$Fu),200);C.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$Gu=p("widget-close",A.$yj.close,(0,k.localize)(2,null)),e.$Hu=p("goto-previous-location",A.$yj.arrowUp,(0,k.localize)(3,null)),e.$Iu=p("goto-next-location",A.$yj.arrowDown,(0,k.localize)(4,null)),e.$Ju=h.ThemeIcon.modify(A.$yj.sync,"spin"),e.$Ku=h.ThemeIcon.modify(A.$yj.loading,"spin")}),define(De[133],Ce([1,0,3,57,5,18]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ez=e.$Dz=e.$Cz=e.$Bz=e.$Az=e.$zz=e.$yz=e.$xz=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$wz=e.$vz=void 0,e.$vz=(0,h.$lh)("tunnelService"),e.$wz=(0,h.$lh)("sharedTunnelsService");var R;(function(p){p.Http="http",p.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(m||(e.TunnelPrivacyId=m={}));var k;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(i)return{address:i[1],port:+i[2]}}e.$xz=g,e.$yz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.$yz.indexOf(p)>=0}e.$zz=L,e.$Az=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(p){return e.$Az.indexOf(p)>=0}e.$Bz=I;function w(p,i,c,u){if(c===1)return!1;if(c===2&&I(i)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(v?.length===4&&parseInt(v[1])>=18)return!1}return p<1024}e.$Cz=w;class D{constructor(i,c,u){this.remoteAddress=i,this.localAddress=c,this.b=u,this.a=new b.$5c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Dz=D;let C=e.$Ez=class{constructor(i,c){this.i=i,this.j=c,this.a=new b.$5c,this.onTunnelOpened=this.a.event,this.b=new b.$5c,this.onTunnelClosed=this.b.event,this.c=new b.$5c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const i=this.j.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.e=i,i?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.f=i.elevation,this.g=i.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const i=[],c=Array.from(this.d.values());for(const u of c){const v=Array.from(u.values());for(const f of v){const E=await f.value;E&&i.push(E)}}return i}async dispose(){for(const i of this.d.values()){for(const{value:c}of i.values())await c.then(u=>u?.dispose());i.clear()}this.d.clear()}setEnvironmentTunnel(i,c,u,v,f){this.o(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:u,privacy:v,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(I(i)||L(i))&&(i=e.$yz[0]);const u=this.q(i,c);if(u)return++u.refcount,u.value}openTunnel(i,c,u,v,f,E=!1,n,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${f}.`),!i)return;if(c||(c="localhost"),v||(v=this.k),this.e&&this.h.has(u)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(i,c,u,v,f,E,n,o);return s?s.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,u);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(t);return(t.tunnelRemoteHost!==c||t.tunnelRemotePort!==u)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&t.privacy!==n&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.d.get(i.tunnelRemoteHost);if(c){const u=c.get(i.tunnelRemotePort);u&&(u.refcount--,await this.n(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async n(i,c,u){if(u.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const v=u.value.then(async f=>{f&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.d.has(i)&&this.d.get(i).delete(c),v}}async closeTunnel(i,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const u=this.d.get(i);if(u&&u.has(c)){const v=u.get(c);v.refcount=0,await this.n(i,c,v)}}o(i,c,u){this.d.has(i)||this.d.set(i,new Map),this.d.get(i).set(c,{refcount:1,value:u})}async p(i,c){const u=this.d.get(i);if(u){const v=u.get(c);(v?await v.value:void 0)||u.delete(c),u.size===0&&this.d.delete(i)}}q(i,c){const u=[i];L(i)?(u.push(...e.$yz),u.push(...e.$Az)):I(i)&&u.push(...e.$Az);const v=u.map(f=>this.d.get(f));for(const f of v){const E=f?.get(c);if(E)return E}}canTunnel(i){return!!g(i)}s(i,c,u,v,f,E,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${v}.`);const o=u;this.h.add(o);const s=v===void 0?u:v,t={elevationRequired:f?this.isPortPrivileged(s):!1},d={remoteAddress:{host:c,port:u},localAddressPort:v,privacy:E,public:E?E!==m.Private:void 0,protocol:n},$=i.forwardPort(d,t);return $?(this.o(c,u,$),$.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),$}};e.$Ez=C=He([We(0,F.$Ni),We(1,A.$Rh)],C)}),define(De[239],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Fz=void 0,e.$Fz=(0,b.$lh)("editSessionIdentityService");var A;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(A||(e.EditSessionIdentityMatch=A={}))}),define(De[240],Ce([1,0,16]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.$LI=e.$KI=e.$JI=e.$II=void 0;function A(k){return k.scheme!==b.Schemas.file&&k.scheme!==b.Schemas.vscodeRemote}e.$II=A;function h(k){if(k.folders.length)return k.folders.every(g=>A(g.uri))?k.folders[0].uri:void 0;if(k.configuration&&A(k.configuration))return k.configuration}e.$JI=h;function F(k){return h(k)?.scheme}e.$KI=F;function R(k){return h(k)?.authority}e.$LI=R;function m(k){return h(k)!==void 0}e.$MI=m}),define(De[50],Ce([1,0,187,10,71,23,2,5,16]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,m.$lh)("contextService");function g(t){const d=t;return typeof d?.id=="string"&&R.URI.isUri(d.uri)}e.$vh=g;function L(t){return typeof t?.id=="string"&&!g(t)&&!w(t)}e.$wh=L,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function I(t,d){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$cc)(t)}:d?e.$xh:e.$yh;const $=t;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}e.$zh=I;function w(t){const d=t;return typeof d?.id=="string"&&R.URI.isUri(d.configPath)}e.$Ah=w;function D(t){const d=t;if(d?.uri)return{id:d.id,uri:R.URI.revive(d.uri)};const $=t;if($?.configPath)return{id:$.id,configPath:R.URI.revive($.configPath)};if(t?.id)return{id:t.id}}e.$Bh=D;var C;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function p(t){const d=t;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.$Ch=p;function i(t){const d=t;return!!(d&&typeof d=="object"&&R.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.$Dh=i;class c{constructor(d,$,l,S,y){this.h=d,this.j=l,this.k=S,this.l=y,this.c=h.$rh.forUris(this.l,()=>!0),this.folders=$}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=h.$rh.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=c;class u{constructor(d,$){this.raw=$,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.$6f)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=u;function v(t){return new u({uri:t,index:0,name:(0,F.$2f)(t)},{uri:t.toString()})}e.$Gh=v,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,b.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function f(t,d){return F.$Wf.isEqualOrParent(t,d.untitledWorkspacesHome)}e.$Lh=f;function E(t){let d;return R.URI.isUri(t)?d=t:d=t.configuration,d?.scheme===k.Schemas.tmp}e.$Mh=E,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.$Nh}e.$Oh=n;function o(t,d){return!f(t,d)&&!E(t)}e.$Ph=o;function s(t){return(typeof t=="string"?(0,A.$dc)(t):(0,F.$4f)(t))===e.$Ih}e.$Qh=s}),define(De[80],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;class b{constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const F=this.c++;return this.b.set(F,h),this.e(),F}get(h,F){return this.b.has(h)?this.b.get(h)[F]:void 0}delete(h){this.b.delete(h),this.e()}e(){b.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$U0b=b,b.a=!1}),define(De[51],Ce([1,0,16,23,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0;class F{constructor(){this.a=new Set(Object.keys(b.Schemas)),this.b=new Map,this.extUri=new A.$Uf(m=>{const k=this.b.get(m.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(m,k){k===null?this.b.delete(m.scheme):this.b.set(m.scheme,k)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$W0b=F,e.$X0b=(0,h.$lh)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=void 0,e.$rL=(0,b.$lh)("IExtHostInitDataService")}),define(De[241],Ce([1,0,192,18,225,26]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;let R=e.$Z_b=class extends h.$yM{constructor(k,g,L){const I=L.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",w=L.remote.isRemote?(0,b.localize)(0,null):k?(0,b.localize)(1,null):(0,b.localize)(2,null);super(g.createLogger(I,{name:w}))}};e.$Z_b=R=He([We(1,A.$Oi),We(2,F.$rL)],R)}),define(De[242],Ce([1,0,17]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=e.$n$b=void 0;class A{constructor(R,m,k){this.h=new Map,this.a=R,this.b=m,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new b.$Cg(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of g.values())L.complete()}catch(L){for(const I of g.values())I.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let k=this.f[R];return typeof k>"u"&&(k=m),k}update(R,m){this.f[R]=m;const k=this.h.get(R);if(k!==void 0)return k.p;const g=new b.$Lg;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$n$b=A;class h extends A{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$o$b=h}),define(De[243],Ce([1,0,3,2]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=void 0;class h{constructor(R){this.c=R,this.a=new b.$5c,this.onDidSaveNotebookDocument=this.a.event,this.b=new b.$5c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,k,g){const I=this.c.getNotebookDocument(A.URI.revive(R)).acceptModelChanged(m.value,k,g);this.b.fire(I)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(A.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(A.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$M_b=h}),define(De[20],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.$bL=void 0,e.$bL=(0,b.$lh)("IExtHostRpcService");class A{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$cL=A});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[244],Ce([1,0,25,3]),function(re,e,b,A){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0;class F{constructor(m,k){h.set(this,void 0),this.b=new A.$5c,this.onDidChange=this.b.event,this.a=b.$El.toKey(m.identifier),Ze(this,h,k,"f"),Te(this,h,"f").onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(m){return Te(this,h,"f").get(this.a,m)}store(m,k){return Te(this,h,"f").store(this.a,m,k)}delete(m){return Te(this,h,"f").delete(this.a,m)}}e.$z$b=F,h=new WeakMap}),define(De[58],Ce([1,0,5,133,3,20]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=e.$rob=e.TunnelDtoConverter=void 0;var R;(function(k){function g(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:I.protocol}}k.fromApiTunnel=g;function L(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==A.TunnelPrivacyId.ConstantPrivate&&I.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}k.fromServiceTunnel=L})(R||(e.TunnelDtoConverter=R={})),e.$rob=(0,b.$lh)("IExtHostTunnelService");let m=e.$sob=class{constructor(g){this.onDidChangeTunnels=new h.$5c().event}async $applyCandidateFilter(g){return g}async openTunnel(g,L){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,L){return{dispose:()=>{}}}async $providePortAttributes(g,L,I,w,D){return[]}async $forwardPort(g,L){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.$sob=m=He([We(0,F.$bL)],m)}),define(De[59],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=e.$80b=void 0,e.$80b=(0,b.$lh)("IURITransformerService");class A{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$90b=A}),define(De[245],Ce([1,0,22]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9=e.$K9=void 0;class A{constructor(){this.buffers=[]}add(k){let g=this.buffers.indexOf(k);return g<0&&(g=this.buffers.length,this.buffers.push(k)),g}}function h(m,k){if(k.serializeBuffersForPostMessage){const g=new A,I=JSON.stringify(m,(D,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C)};if(ArrayBuffer.isView(C)){const p=F(C);if(p)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C.buffer),view:{type:p,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),w=g.buffers.map(D=>{const C=new Uint8Array(D);return b.$Ib.wrap(C)});return{message:I,buffers:w}}else return{message:JSON.stringify(m),buffers:[]}}e.$K9=h;function F(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,k){const g=k.map(w=>{const D=new ArrayBuffer(w.byteLength);return new Uint8Array(D).set(w.buffer),D}),L=k.length?(w,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const C=D,{index:p}=C,i=g[p];if(C.view)switch(C.view.type){case 1:return new Int8Array(i,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(i,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(i,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(i,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(i,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(i,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(i,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(i,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(i,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(i,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(i,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return i}return D}:void 0;return{message:JSON.parse(m,L),arrayBuffers:g}}e.$L9=R}),define(De[246],Ce([1,0,101,347,348,102,2,349]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;function k(C,p,i,c,u,v){const f=v.environment.useHostProxy,E=typeof f=="boolean"?f:!v.remote.isRemote,n={resolveProxy:t=>C.resolveProxy(t),getHttpProxySetting:()=>p.getConfiguration("http").get("proxy"),log:(t,d,...$)=>{switch(t){case m.LogLevel.Trace:c.trace(d,...$);break;case m.LogLevel.Debug:c.debug(d,...$);break;case m.LogLevel.Info:c.info(d,...$);break;case m.LogLevel.Warning:c.warn(d,...$);break;case m.LogLevel.Error:c.error(d,...$);break;case m.LogLevel.Critical:c.error(d,...$);break;case m.LogLevel.Off:break;default:l(t,d,$);break}function l(S,y,...a){c.error("Unknown log level",S),c.error(y,...a)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:E,useSystemCertificatesV2:I(p),addCertificates:[],env:process.env};p.onDidChangeConfiguration(t=>{n.useSystemCertificatesV2=I(p)});const o=(0,m.createProxyResolver)(n),s=g(n,p,o);return D(i,s)}e.$vac=k;function g(C,p,i){const c={config:p.getConfiguration("http").get("proxySupport")||"off"};p.onDidChangeConfiguration(v=>{c.config=p.getConfiguration("http").get("proxySupport")||"off"});const u={config:L(p)};return p.onDidChangeConfiguration(v=>{u.config=L(p)}),{http:{off:Object.assign({},b,(0,m.createHttpPatch)(b,i,{config:"off"},u,!0)),on:Object.assign({},b,(0,m.createHttpPatch)(b,i,{config:"on"},u,!0)),override:Object.assign({},b,(0,m.createHttpPatch)(b,i,{config:"override"},u,!0)),onRequest:Object.assign({},b,(0,m.createHttpPatch)(b,i,c,u,!0)),default:Object.assign(b,(0,m.createHttpPatch)(b,i,c,u,!1))},https:{off:Object.assign({},A,(0,m.createHttpPatch)(A,i,{config:"off"},u,!0)),on:Object.assign({},A,(0,m.createHttpPatch)(A,i,{config:"on"},u,!0)),override:Object.assign({},A,(0,m.createHttpPatch)(A,i,{config:"override"},u,!0)),onRequest:Object.assign({},A,(0,m.createHttpPatch)(A,i,c,u,!0)),default:Object.assign(A,(0,m.createHttpPatch)(A,i,c,u,!1))},net:Object.assign(F,(0,m.createNetPatch)(C,F)),tls:Object.assign(h,(0,m.createTlsPatch)(C,h))}}function L(C){const p=C.getConfiguration("http");return!p.get("experimental.systemCertificatesV2")&&!!p.get("systemCertificates")}function I(C){const p=C.getConfiguration("http");return!!p.get("experimental.systemCertificatesV2")&&!!p.get("systemCertificates")}const w=new Map;function D(C,p){return C.getExtensionPathIndex().then(i=>{const c=globalThis._VSCODE_NODE_MODULES.module,u=c._load;c._load=function(f,E,n){if(f==="net")return p.net;if(f==="tls")return p.tls;if(f!=="http"&&f!=="https")return u.apply(this,arguments);const o=p[f],s=i.findSubstr(R.URI.file(E.filename));let t=w.get(s);if(t||w.set(s,t={}),!t[f]){const d=o.default;t[f]={...d}}return t[f]}})}}),define(De[247],Ce([1,0,119]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;function A(F){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:F,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function h(F){return new b.$km(A(F))}e.$ar=h}),define(De[134],Ce([1,0,201,12,2,4,5,42,30,16,46,171,41]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.EditorsOrder=e.$nE=e.CloseDirection=e.$mE=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorInputCapabilities=e.$dE=e.SaveReason=e.Verbosity=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=void 0,e.$4D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5D={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.$6D="workbench.editor.sidebysideEditor",e.$7D="workbench.editors.textDiffEditor",e.$8D="workbench.editors.binaryResourceDiffEditor";var D;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var C;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function p(H){const ce=H;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.$9D=p;function i(H,ce,pe){for(const ye of pe.visibleEditorPanes)if(ye.group.id===ce&&H.matches(ye.input))return ye.getViewState()}e.$0D=i;function c(H){if($(H))return!1;const ce=H;return h.URI.isUri(ce?.resource)}e.$$D=c;function u(H){if($(H))return!1;const ce=H;return ce?.original!==void 0&&ce.modified!==void 0}e.$_D=u;function v(H){if($(H)||u(H))return!1;const ce=H;return ce?.primary!==void 0&&ce.secondary!==void 0}e.$aE=v;function f(H){if($(H))return!1;const ce=H;return ce?ce.resource===void 0||ce.resource.scheme===g.Schemas.untitled||ce.forceUntitled===!0:!1}e.$bE=f;function E(H){if($(H))return!1;const ce=H;return h.URI.isUri(ce?.base?.resource)&&h.URI.isUri(ce?.input1?.resource)&&h.URI.isUri(ce?.input2?.resource)&&h.URI.isUri(ce?.result?.resource)}e.$cE=E;var n;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var o;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class s{constructor(){this.a=new Map}registerSource(ce,pe){let ye=this.a.get(ce);return ye||(ye={source:ce,label:pe},this.a.set(ce,ye)),ye.source}getSourceLabel(ce){return this.a.get(ce)?.label??ce}}e.$dE=new s;var t;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(t||(e.EditorInputCapabilities=t={}));class d extends F.$kb{}e.$eE=d;function $(H){return H instanceof d}e.$fE=$;function l(H){const ce=H;return h.URI.isUri(ce?.preferredResource)}function S(H){const ce=H;return $(ce?.primary)&&$(ce?.secondary)}e.$gE=S;function y(H){const ce=H;return $(ce?.modified)&&$(ce?.original)}e.$hE=y;function a(H,ce,pe,ye,ge){return V(ye,[(0,I.$8h)({id:"workbench.action.openLargeFile",label:(0,b.localize)(2,null),run:()=>{const M={...pe,limits:{size:Number.MAX_VALUE}};H.openEditor(ce,M)}}),(0,I.$8h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,b.localize)(3,null),run:()=>ge.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$iE=a;function r(H){return $(H?.editor)}e.$jE=r;function P(H){const ce=H;return r(H)&&ce?.group!==void 0}e.$kE=P;function N(H){const ce=H;return typeof ce?.groupId=="number"&&$(ce.editor)}e.$lE=N;var U;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var q;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var B;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri(ce,pe){if(!ce)return;if(E(ce))return e.$mE.getOriginalUri(ce.result,pe);if(pe?.supportSideBySide){const{primary:ge,secondary:M}=this.a(ce);if(ge&&M){if(pe?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(ge,{filterByScheme:pe.filterByScheme}),secondary:this.getOriginalUri(M,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===B.ANY)return this.getOriginalUri(ge,{filterByScheme:pe.filterByScheme})??this.getOriginalUri(M,{filterByScheme:pe.filterByScheme});ce=pe.supportSideBySide===B.PRIMARY?ge:M}}if(u(ce)||v(ce)||E(ce))return;const ye=l(ce)?ce.preferredResource:ce.resource;return!ye||!pe||!pe.filterByScheme?ye:this.b(ye,pe.filterByScheme)}a(ce){return S(ce)||v(ce)?{primary:ce.primary,secondary:ce.secondary}:y(ce)||u(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,pe){if(!ce)return;if(E(ce))return e.$mE.getCanonicalUri(ce.result,pe);if(pe?.supportSideBySide){const{primary:ge,secondary:M}=this.a(ce);if(ge&&M){if(pe?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(ge,{filterByScheme:pe.filterByScheme}),secondary:this.getCanonicalUri(M,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===B.ANY)return this.getCanonicalUri(ge,{filterByScheme:pe.filterByScheme})??this.getCanonicalUri(M,{filterByScheme:pe.filterByScheme});ce=pe.supportSideBySide===B.PRIMARY?ge:M}}if(u(ce)||v(ce)||E(ce))return;const ye=ce.resource;return!ye||!pe||!pe.filterByScheme?ye:this.b(ye,pe.filterByScheme)}b(ce,pe){if(Array.isArray(pe)){if(pe.some(ye=>ce.scheme===ye))return ce}else if(pe===ce.scheme)return ce}}e.$mE=new O;var K;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class z{constructor(){this.c=new Map,this.d=new Map}start(ce){const pe=this.a=ce.get(R.$kh);for(const[ye,ge]of this.c)this.e(ye,ge,pe);this.c.clear()}e(ce,pe,ye){const ge=ye.createInstance(pe);this.d.set(ce,ge)}registerFileEditorFactory(ce){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ce}getFileEditorFactory(){return(0,A.$re)(this.b)}registerEditorSerializer(ce,pe){if(this.c.has(ce)||this.d.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.a?this.e(ce,pe,this.a):this.c.set(ce,pe),(0,F.$ib)(()=>{this.c.delete(ce),this.d.delete(ce)})}getEditorSerializer(ce){return this.d.get(typeof ce=="string"?ce:ce.typeId)}}m.$Qm.add(e.$4D.EditorFactory,new z);async function j(H,ce,pe){return!H||!H.length?[]:await Promise.all(H.map(async ye=>{const ge=h.URI.revive(ye.fileUri);if(!ge){pe.info("Cannot resolve the path because it is not valid.",ye);return}if(!await ce.canHandleResource(ge)){pe.info("Cannot resolve the path because it cannot be handled",ye);return}let Y=ye.exists,ve=ye.type;if(typeof Y!="boolean"||typeof ve!="number")try{ve=(await ce.stat(ge)).isDirectory?k.FileType.Directory:k.FileType.Unknown,Y=!0}catch(ee){pe.error(ee),Y=!1}if(!Y&&ye.openOnlyIfExists){pe.info("Cannot resolve the path because it does not exist",ye);return}if(ve===k.FileType.Directory){pe.info("Cannot resolve the path because it is a directory",ye);return}const Se={...ye.options,pinned:!0};return Y?{resource:ge,options:Se}:{resource:ge,options:Se,forceUntitled:!0}}))}e.$nE=j;var he;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ie(H){const ce=H;if(!ce)return!1;const pe=ce;if(pe.modified)return ie(pe.modified);const ye=ce;return!!(ye.contributionsState&&ye.viewState&&Array.isArray(ye.cursorState))}e.$oE=ie;function ne(H){return(0,L.$0h)(H)}e.$pE=ne;function V(H,ce,pe){const ye=(0,L.$$h)(H,ce);return ye.forceMessage=pe?.forceMessage,ye.forceSeverity=pe?.forceSeverity,ye.allowDialog=pe?.allowDialog,ye}e.$qE=V}),define(De[248],Ce([1,0,3,202,5,4,28,42,19,65,24,72,238]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$vE=e.$uE=e.ViewContentGroups=e.$tE=e.$sE=e.ViewContainerLocation=e.Extensions=e.$rE=void 0,e.$rE=(0,w.$Du)("default-view-icon",I.$yj.window,(0,A.localize)(0,null));var D;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var C;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$sE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$tE=p;class i extends F.$kb{constructor(){super(...arguments),this.c=this.B(new b.$5c),this.onDidRegister=this.c.event,this.f=this.B(new b.$5c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$vf)([...this.g.values()])}registerViewContainer(t,d,$){const l=this.get(t.id);if(l)return l;const S=t;return S.openCommandActionDescriptor=$?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$gi)(this.g,d,[]).push(S),$?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(t){for(const d of this.g.keys()){const $=this.g.get(d),l=$?.indexOf(t);if(l!==-1){$?.splice(l,1),$.length===0&&this.g.delete(d),this.f.fire({viewContainer:t,viewContainerLocation:d});return}}}get(t){return this.all.filter(d=>d.id===t)[0]}getViewContainers(t){return[...this.g.get(t)||[]]}getViewContainerLocation(t){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter($=>$?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.h.find(d=>this.getViewContainerLocation(d)===t)}}m.$Qm.add(D.ViewContainersRegistry,new i);var c;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(c||(e.ViewContentGroups=c={}));function u(s,t){const d=s.group??c.More,$=t.group??c.More;return d!==$?d.localeCompare($):(s.order??5)-(t.order??5)}class v extends F.$kb{constructor(){super(...arguments),this.c=this.B(new b.$5c),this.onViewsRegistered=this.c.event,this.f=this.B(new b.$5c),this.onViewsDeregistered=this.f.event,this.g=this.B(new b.$5c),this.onDidChangeContainer=this.g.event,this.h=this.B(new b.$5c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new g.$G}registerViews(t,d){this.registerViews2([{views:t,viewContainer:d}])}registerViews2(t){t.forEach(({views:d,viewContainer:$})=>this.l(d,$)),this.c.fire(t)}deregisterViews(t,d){const $=this.m(t,d);$.length&&this.f.fire({views:$,viewContainer:d})}moveViews(t,d){for(const $ of this.j.keys())if($!==d){const l=this.m(t,$);l.length&&(this.l(l,d),this.g.fire({views:l,from:$,to:d}))}}getViews(t){return this.j.get(t)||[]}getView(t){for(const d of this.i){const $=(this.j.get(d)||[]).filter(l=>l.id===t)[0];if($)return $}return null}getViewContainer(t){for(const d of this.i)if((this.j.get(d)||[]).filter(l=>l.id===t)[0])return d;return null}registerViewWelcomeContent(t,d){return this.k.add(t,d),this.h.fire(t),(0,F.$ib)(()=>{this.k.delete(t,d),this.h.fire(t)})}registerViewWelcomeContent2(t,d){const $=new Map;for(const[l,S]of d)this.k.add(t,S),$.set(l,(0,F.$ib)(()=>{this.k.delete(t,S),this.h.fire(t)}));return this.h.fire(t),$}getViewWelcomeContent(t){const d=[];return this.k.forEach(t,$=>d.push($)),d.sort(u)}l(t,d){let $=this.j.get(d);$||($=[],this.j.set(d,$),this.i.push(d));for(const l of t){if(this.getView(l.id)!==null)throw new Error((0,A.localize)(1,null,l.id));$.push(l)}}m(t,d){const $=this.j.get(d);if(!$)return[];const l=[],S=[];for(const y of $)t.includes(y)?l.push(y):S.push(y);return l.length&&(S.length?this.j.set(d,S):(this.j.delete(d),this.i.splice(this.i.indexOf(d),1))),l}}m.$Qm.add(D.ViewsRegistry,new v),e.$uE=(0,h.$lh)("viewsService"),e.$vE=(0,h.$lh)("viewDescriptorService");var f;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var E;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class n{constructor(t,d){this.c=!1,this.d=!1,(0,L.$Hm)(this,t),this.d=!!d,this.resolve=async $=>{if(d&&!this.c){const l=await d($);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}$.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$wE=n;class o extends Error{constructor(t){super((0,A.localize)(2,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.$xE=o}),define(De[135],Ce([1,0,3,17,203]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new b.$5c,this.n=new b.$5c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,k,g,L){const I={command:m};if(k&&Object.keys(k).length>0&&(I.arguments=k),this.s("request",I),typeof L=="number"){const w=setTimeout(()=>{clearTimeout(w);const D=this.f.get(I.seq);if(D){this.f.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,h.localize)(0,null,L,m)};D(C)}},L)}return g&&this.f.set(I.seq,g),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,k){return m.type!=="event"||k.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,A.$sg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const k=m,g=this.f.get(k.request_seq);g&&(this.f.delete(k.request_seq),g(k));break}}}}s(m,k){k.type=m,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((k,g)=>m.set(g,k)),await(0,A.$sg)(500),m.forEach((k,g)=>{k({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$e0=F}),define(De[249],Ce([1,0,204,47,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$IG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$HG=e.MemoryRangeType=e.$GG=e.State=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$EF="workbench.view.debug",e.$FF="workbench.debug.variablesView",e.$GF="workbench.debug.watchExpressionsView",e.$HF="workbench.debug.callStackView",e.$IF="workbench.debug.loadedScriptsView",e.$JF="workbench.debug.breakPointsView",e.$KF="workbench.debug.disassemblyView",e.$LF="workbench.panel.repl",e.$MF="workbench.panel.repl.view",e.$NF=new A.$Ki("debugType",void 0,{type:"string",description:b.localize(0,null)}),e.$OF=new A.$Ki("debugConfigurationType",void 0,{type:"string",description:b.localize(1,null)}),e.$PF=new A.$Ki("debugState","inactive",{type:"string",description:b.localize(2,null)}),e.$QF="debugUx",e.$RF=new A.$Ki(e.$QF,"default",{type:"string",description:b.localize(3,null)}),e.$SF=new A.$Ki("hasDebugged",!1,{type:"boolean",description:b.localize(4,null)}),e.$TF=new A.$Ki("inDebugMode",!1,{type:"boolean",description:b.localize(5,null)}),e.$UF=new A.$Ki("inDebugRepl",!1,{type:"boolean",description:b.localize(6,null)}),e.$VF=new A.$Ki("breakpointWidgetVisible",!1,{type:"boolean",description:b.localize(7,null)}),e.$WF=new A.$Ki("inBreakpointWidget",!1,{type:"boolean",description:b.localize(8,null)}),e.$XF=new A.$Ki("breakpointsFocused",!0,{type:"boolean",description:b.localize(9,null)}),e.$YF=new A.$Ki("watchExpressionsFocused",!0,{type:"boolean",description:b.localize(10,null)}),e.$ZF=new A.$Ki("watchExpressionsExist",!1,{type:"boolean",description:b.localize(11,null)}),e.$1F=new A.$Ki("variablesFocused",!0,{type:"boolean",description:b.localize(12,null)}),e.$2F=new A.$Ki("expressionSelected",!1,{type:"boolean",description:b.localize(13,null)}),e.$3F=new A.$Ki("breakpointInputFocused",!1,{type:"boolean",description:b.localize(14,null)}),e.$4F=new A.$Ki("callStackItemType",void 0,{type:"string",description:b.localize(15,null)}),e.$5F=new A.$Ki("callStackSessionIsAttach",!1,{type:"boolean",description:b.localize(16,null)}),e.$6F=new A.$Ki("callStackItemStopped",!1,{type:"boolean",description:b.localize(17,null)}),e.$7F=new A.$Ki("callStackSessionHasOneThread",!1,{type:"boolean",description:b.localize(18,null)}),e.$8F=new A.$Ki("watchItemType",void 0,{type:"string",description:b.localize(19,null)}),e.$9F=new A.$Ki("canViewMemory",void 0,{type:"boolean",description:b.localize(20,null)}),e.$0F=new A.$Ki("breakpointItemType",void 0,{type:"string",description:b.localize(21,null)}),e.$$F=new A.$Ki("breakpointSupportsCondition",!1,{type:"boolean",description:b.localize(22,null)}),e.$_F=new A.$Ki("loadedScriptsSupported",!1,{type:"boolean",description:b.localize(23,null)}),e.$aG=new A.$Ki("loadedScriptsItemType",void 0,{type:"string",description:b.localize(24,null)}),e.$bG=new A.$Ki("focusedSessionIsAttach",!1,{type:"boolean",description:b.localize(25,null)}),e.$cG=new A.$Ki("stepBackSupported",!1,{type:"boolean",description:b.localize(26,null)}),e.$dG=new A.$Ki("restartFrameSupported",!1,{type:"boolean",description:b.localize(27,null)}),e.$eG=new A.$Ki("stackFrameSupportsRestart",!1,{type:"boolean",description:b.localize(28,null)}),e.$fG=new A.$Ki("jumpToCursorSupported",!1,{type:"boolean",description:b.localize(29,null)}),e.$gG=new A.$Ki("stepIntoTargetsSupported",!1,{type:"boolean",description:b.localize(30,null)}),e.$hG=new A.$Ki("breakpointsExist",!1,{type:"boolean",description:b.localize(31,null)}),e.$iG=new A.$Ki("debuggersAvailable",!1,{type:"boolean",description:b.localize(32,null)}),e.$jG=new A.$Ki("debugExtensionAvailable",!0,{type:"boolean",description:b.localize(33,null)}),e.$kG=new A.$Ki("debugProtocolVariableMenuContext",void 0,{type:"string",description:b.localize(34,null)}),e.$lG=new A.$Ki("debugSetVariableSupported",!1,{type:"boolean",description:b.localize(35,null)}),e.$mG=new A.$Ki("debugSetExpressionSupported",!1,{type:"boolean",description:b.localize(36,null)}),e.$nG=new A.$Ki("breakWhenValueChangesSupported",!1,{type:"boolean",description:b.localize(37,null)}),e.$oG=new A.$Ki("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:b.localize(38,null)}),e.$pG=new A.$Ki("breakWhenValueIsReadSupported",!1,{type:"boolean",description:b.localize(39,null)}),e.$qG=new A.$Ki("terminateDebuggeeSupported",!1,{type:"boolean",description:b.localize(40,null)}),e.$rG=new A.$Ki("suspendDebuggeeSupported",!1,{type:"boolean",description:b.localize(41,null)}),e.$sG=new A.$Ki("variableEvaluateNamePresent",!1,{type:"boolean",description:b.localize(42,null)}),e.$tG=new A.$Ki("variableIsReadonly",!1,{type:"boolean",description:b.localize(43,null)}),e.$uG=new A.$Ki("exceptionWidgetVisible",!1,{type:"boolean",description:b.localize(44,null)}),e.$vG=new A.$Ki("multiSessionRepl",!1,{type:"boolean",description:b.localize(45,null)}),e.$wG=new A.$Ki("multiSessionDebug",!1,{type:"boolean",description:b.localize(46,null)}),e.$xG=new A.$Ki("disassembleRequestSupported",!1,{type:"boolean",description:b.localize(47,null)}),e.$yG=new A.$Ki("disassemblyViewFocus",!1,{type:"boolean",description:b.localize(48,null)}),e.$zG=new A.$Ki("languageSupportsDisassembleRequest",!1,{type:"boolean",description:b.localize(49,null)}),e.$AG=new A.$Ki("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:b.localize(50,null)});const F=w=>b.localize(51,null,w);e.$BG=F,e.$CG="editor.contrib.debug",e.$DG="editor.contrib.breakpoint",e.$EG="debug",e.$FG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:b.localize(52,null)};var R;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(R||(e.State=R={}));function m(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$GG=m;var k;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$HG="vscode-debug-memory";var g;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var L;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$IG=(0,h.$lh)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[250],Ce([1,0,11,2,10,24,16,36,21,19]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=void 0;const L=/{([^}]+)}/g;function I(l,S,y){return l.replace(L,function(a,r){return S&&r.length>0&&r[0]!=="_"?a:y&&y.hasOwnProperty(r)?y[r]:a})}e.$EE=I;function w(l){const S={};for(const y of Object.keys(l))y.startsWith("!")||(S[y]=l[y]);return S}e.$FE=w;function D(l){return l.configuration.request==="attach"&&!C(l)&&(!l.parentSession||D(l.parentSession))}e.$GE=D;function C(l){let S=l.configuration.type;if(S)return S==="vslsShare"&&(S=l.configuration.adapterProxy.configuration.type),(0,b.$Jd)(S,"extensionhost")||(0,b.$Jd)(S,"pwa-extensionhost")?l:l.parentSession?C(l.parentSession):void 0}e.$HE=C;function p(l){return l.type&&(l.label||l.program||l.runtime)}e.$IE=p;function i(l,S,y){let a,r=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=P.exec(l);){const U=N.index+1,q=U+N[0].length;if(U<=S&&q>=y){a=N[0],r=U;break}}if(a){const U=/\w+/g;let q=null;for(;(q=U.exec(a))&&!(q.index+1+r+q[0].length>=y););q&&(a=a.substring(0,U.lastIndex))}return a?{start:r,end:r+a.length-1}:{start:0,end:0}}e.$JE=i;async function c(l,S,y,a){if(l.evaluatableExpressionProvider.has(S)){const r=l.evaluatableExpressionProvider.ordered(S),P=(0,g.$jf)(await Promise.all(r.map(async N=>{try{return await N.provideEvaluatableExpression(S,y,a??k.CancellationToken.None)}catch{return}})));if(P.length>0){let N=P[0].expression;const U=P[0].range;return N||(N=S.getLineContent(y.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:N}}}else{const r=S.getLineContent(y.lineNumber),{start:P,end:N}=i(r,y.column,y.column),U=r.substring(P-1,N);return{matchingExpression:U,range:new m.$Lr(y.lineNumber,P,y.lineNumber,P+U.length)}}return null}e.$KE=c;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(l){return!!(l&&l.match(u))}e.$LE=v;function f(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(v(l.path))return A.URI.parse(l.path);if((0,h.$0b)(l.path))return A.URI.file(l.path)}return l.path}function E(l){if(typeof l.path=="object"){const S=A.URI.revive(l.path);if(S)return S.scheme===R.Schemas.file?S.fsPath:S.toString()}return l.path}function n(l,S){const y=S?f:E,a=(0,F.$Em)(l);return s(a,(r,P)=>{r&&P&&(P.path=y(P))}),a}e.$ME=n;function o(l,S){const y=S?f:E,a=(0,F.$Em)(l);return s(a,(r,P)=>{!r&&P&&(P.path=y(P))}),a}e.$NE=o;function s(l,S){switch(l.type){case"event":{const y=l;switch(y.event){case"output":S(!1,y.body.source);break;case"loadedSource":S(!1,y.body.source);break;case"breakpoint":S(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=l;switch(y.command){case"setBreakpoints":S(!0,y.arguments.source);break;case"breakpointLocations":S(!0,y.arguments.source);break;case"source":S(!0,y.arguments.source);break;case"gotoTargets":S(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(a=>S(!1,a));break;default:break}break}case"response":{const y=l;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(a=>S(!1,a.source));break;case"loadedSources":y.body.sources.forEach(a=>S(!1,a));break;case"scopes":y.body.scopes.forEach(a=>S(!1,a.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(a=>S(!1,a.source));break;case"setBreakpoints":y.body.breakpoints.forEach(a=>S(!1,a.source));break;case"disassemble":y.body?.instructions.forEach(r=>S(!1,r.location));break;default:break}break}}}function t(l){return l.filter(S=>!S.presentation?.hidden).sort((S,y)=>S.presentation?y.presentation?S.presentation.group?y.presentation.group?S.presentation.group!==y.presentation.group?S.presentation.group.localeCompare(y.presentation.group):d(S.presentation.order,y.presentation.order):-1:y.presentation.group?1:d(S.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$OE=t;function d(l,S){return typeof l!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:l-S}async function $(l,S){const y=l.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(y!=="none"&&(await S.saveAll(),y==="allEditorsInActiveGroup")){const a=S.activeEditorPane;a&&a.input.resource?.scheme===R.Schemas.untitled&&await S.save({editor:a.input,groupId:a.group.id})}await l.reloadConfiguration()}e.$PE=$}),define(De[251],Ce([1,0,45,102,24,10,9,11,29,205,135]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=e.$9_b=e.$8_b=e.$7_b=e.$6_b=void 0;class I extends L.$e0{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(c,u){this.p=u,this.r=Buffer.allocUnsafe(0),this.t=-1,c.on("data",v=>this.w(v))}sendMessage(c){if(this.p){const u=JSON.stringify(c);this.p.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${I.a}${u}`,"utf8")}}w(c){for(this.r=Buffer.concat([this.r,c]);;){if(this.t>=0){if(this.r.length>=this.t){const u=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(v){this.m.fire(new Error((v.message||v)+`
`+u))}continue}}else{const u=this.r.indexOf(I.a);if(u!==-1){const f=this.r.toString("utf8",0,u).split(I.b);for(const E of f){const n=E.split(I.l);n[0]==="Content-Length"&&(this.t=Number(n[1]))}this.r=this.r.slice(u+I.a.length);continue}}break}}}e.$6_b=I,I.a=`\r
\r
`,I.b=/\r?\n/,I.l=/: */;class w extends I{startSession(){return new Promise((c,u)=>{let v=!1;this.x=this.y(()=>{this.v(this.x,this.x),c(),v=!0}),this.x.on("close",()=>{v?this.m.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.x.on("error",f=>{v?this.m.fire(f):u(f)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$7_b=w;class D extends w{constructor(c){super(),this.z=c}y(c){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$8_b=D;class C extends w{constructor(c){super(),this.z=c}y(c){return A.createConnection(this.z.path,c)}}e.$9_b=C;class p extends I{constructor(c,u){super(),this.y=c,this.z=u}async startSession(){const c=this.y.command,u=this.y.args,v=this.y.options||{};try{if(c)if(F.$0b(c)){if(!await k.Promises.exists(c))throw new Error(g.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let f=process.env;if(v.env&&Object.keys(v.env).length>0&&(f=h.$Hm(h.$Em(process.env),v.env)),c==="node")if(Array.isArray(u)&&u.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:f,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};v.cwd&&(n.cwd=v.cwd);const o=b.fork(u[0],u.slice(1),n);if(!o.pid)throw new Error(g.localize(2,null,u[0]));this.x=o}else throw new Error(g.localize(3,null));else{const E={env:f};v.cwd&&(E.cwd=v.cwd),this.x=b.spawn(c,u,E)}this.x.on("error",E=>{this.m.fire(E)}),this.x.on("exit",(E,n)=>{this.n.fire(E)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",E=>{this.m.fire(E)}),this.x.stdin.on("error",E=>{this.m.fire(E)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(f){this.m.fire(f)}}async stopSession(){return this.x?(await this.u(),R.$d?new Promise((c,u)=>{const v=b.exec(`taskkill /F /T /PID ${this.x.pid}`,function(f,E,n){if(f)return u(f)});v.on("exit",c),v.on("error",u)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,u){if(!c)return;const v=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?v.runtime=F.$$b(u,c.runtime):v.runtime=c.runtime),c.runtimeArgs&&(v.runtimeArgs=c.runtimeArgs),c.program&&(F.$0b(c.program)?v.program=c.program:v.program=F.$$b(u,c.program)),c.args&&(v.args=c.args);const f=c;return f.win&&(v.win=p.A(f.win,u)),f.winx86&&(v.winx86=p.A(f.winx86,u)),f.windows&&(v.windows=p.A(f.windows,u)),f.osx&&(v.osx=p.A(f.osx,u)),f.linux&&(v.linux=p.A(f.linux,u)),v}static platformAdapterExecutable(c,u){let v=Object.create(null);u=u.toLowerCase();for(const t of c)if(t.contributes){const d=t.contributes.debuggers;d&&d.length>0&&d.filter($=>typeof $.type=="string"&&m.$Jd($.type,u)).forEach($=>{const l=p.A($,t.extensionLocation.fsPath);v=h.$Hm(v,l,t.isBuiltin)})}let f;R.$d&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=v.winx86||v.win||v.windows:R.$d?f=v.win||v.windows:R.$e?f=v.osx:R.$f&&(f=v.linux),f=f||v;const E=f.program||v.program,n=f.args||v.args,o=f.runtime||v.runtime,s=f.runtimeArgs||v.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof E=="string"?[E]:[]).concat(n||[])};if(E)return{type:"executable",command:E,args:n||[]}}}e.$0_b=p}),define(De[252],Ce([1,0,45,31,9]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=void 0;function F(g,L){return new Promise((I,w)=>{let D="";const C=b.spawn(g,L);C.pid&&C.stdout.on("data",p=>{D+=p.toString()}),C.on("error",p=>{w(p)}),C.on("close",p=>{I(D)})})}async function R(g){if(g)if(h.$d){const L=await new Promise((I,w)=>{re(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{L.getProcessTree(g,w=>{I(!!w&&w.children.length>0)})})}else return F("/usr/bin/pgrep",["-lP",String(g)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$$_b=R;var m;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(m||(m={}));function k(g,L,I,w,D){g=g.trim().toLowerCase();let C;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?C=1:g.indexOf("cmd.exe")>=0?C=0:g.indexOf("bash")>=0?C=2:h.$d?C=0:C=2;let p,i=" ";switch(C){case 1:if(p=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),w){const c=(0,A.$Me)(w);c&&(i+=`${c}:; `),i+=`cd ${p(w)}; `}if(D)for(const c in D){const u=D[c];u===null?i+=`Remove-Item env:${c}; `:i+=`\${env:${c}}='${u}'; `}if(L.length>0){const c=L.shift(),u=I?c:p(c);i+=u[0]==="'"?`& ${u} `:`${u} `;for(const v of L)i+=v==="<"||v===">"||I?v:p(v),i+=" "}break;case 0:if(p=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(u=>c.includes(u))||c.length===0?`"${c}"`:c),w){const c=(0,A.$Me)(w);c&&(i+=`${c}: && `),i+=`cd ${p(w)} && `}if(D){i+='cmd /C "';for(const c in D){let u=D[c];u===null?i+=`set "${c}=" && `:(u=u.replace(/[&^|<>]/g,v=>`^${v}`),i+=`set "${c}=${u}" && `)}}for(const c of L)i+=c==="<"||c===">"||I?c:p(c),i+=" ";D&&(i+='"');break;case 2:{p=u=>(u=u.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),u.length===0?'""':u);const c=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(w&&(i+=`cd ${p(w)} ; `),D){i+="/usr/bin/env";for(const u in D){const v=D[u];v===null?i+=` -u ${c(u)}`:i+=` ${c(`${u}=${v}`)}`}i+=" "}for(const u of L)i+=u==="<"||u===">"||I?u:p(u),i+=" ";break}}return i}e.$__b=k}),define(De[103],Ce([1,0,22,32,48,91,16,10,9,47]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.$gH=e.CellStatusbarAlignment=e.$fH=e.$eH=e.$dH=e.NotebookEditorPriority=e.$cH=e.$bH=e.$aH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_G=e.$$G=e.$0G=e.$9G=e.CellKind=e.$8G=e.$7G=e.$6G=void 0,e.$6G="workbench.editor.notebook",e.$7G="workbench.editor.notebookTextDiffEditor",e.$8G="workbench.editor.interactive";var L;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(L||(e.CellKind=L={})),e.$9G=["application/json","application/javascript","text/html","image/svg+xml",F.$rr.latex,F.$rr.markdown,"image/png","image/jpeg",F.$rr.text],e.$0G=[F.$rr.latex,F.$rr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$rr.text],e.$$G=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_G="_notAvailable";var I;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var D;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(D||(e.NotebookExecutionState=D={}));var C;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var p;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var i;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var c;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var u;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var v;(function(z){z.scheme=R.Schemas.vscodeNotebookCell;const j=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${j.join("")}]+`),ie=7;function ne(ge,M){const Y=M.toString(ie),Se=`${Y.length<j.length?j[Y.length-1]:"z"}${Y}s${(0,b.$2b)(b.$Ib.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:z.scheme,fragment:Se})}z.generate=ne;function V(ge){if(ge.scheme!==z.scheme)return;const M=ge.fragment.indexOf("s");if(M<0)return;const Y=parseInt(ge.fragment.substring(0,M).replace(he,""),ie),ve=(0,b.$1b)(ge.fragment.substring(M+1)).toString();if(!isNaN(Y))return{handle:Y,notebook:ge.with({scheme:ve,fragment:null})}}z.parse=V;function H(ge,M){return ge.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${M??""},${ge.scheme!==R.Schemas.file?ge.scheme:""}`})}z.generateCellOutputUri=H;function ce(ge){if(ge.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const M=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!M)return;const Y=M[1]&&M[1]!==""?M[1]:void 0,ve=M[2];return{outputId:Y,notebook:ge.with({scheme:ve||R.Schemas.file,fragment:null})}}z.parseCellOutputUri=ce;function pe(ge,M,Y){return z.generate(ge,M).with({scheme:Y})}z.generateCellPropertyUri=pe;function ye(ge,M){if(ge.scheme===M)return z.parse(ge.with({scheme:z.scheme}))}z.parseCellPropertyUri=ye})(v||(e.CellUri=v={}));const f=z=>k.$d?z.replace(/\//g,"\\"):z;class E{constructor(j=[],he=e.$9G){this.e=he,this.d=[...new Set(j)].map(ie=>({pattern:ie,matches:A.$aj(f(ie))}))}sort(j){const he=new Map(h.Iterable.map(j,ne=>[ne,f(ne)]));let ie=[];for(const{matches:ne}of this.d)for(const[V,H]of he)if(ne(H)){ie.push(V),he.delete(V);break}return he.size&&(ie=ie.concat([...he.keys()].sort((ne,V)=>this.e.indexOf(ne)-this.e.indexOf(V)))),ie}prioritize(j,he){const ie=this.f(j);if(ie===-1){this.d.unshift({pattern:j,matches:A.$aj(f(j))});return}const ne=new Set(he.map(H=>this.f(H,ie)));ne.delete(-1);const V=Array.from(ne).sort();this.d.splice(ie+1,0,...V.map(H=>this.d[H]));for(let H=V.length-1;H>=0;H--)this.d.splice(V[H],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,he=this.d.length){const ie=f(j);for(let ne=0;ne<he;ne++)if(this.d[ne].matches(ie))return ne;return-1}}e.$aH=E;function n(z,j,he,ie=(ne,V)=>ne===V){const ne=[];function V(pe,ye,ge){if(ye===0&&ge.length===0)return;const M=ne[ne.length-1];M&&M.start+M.deleteCount===pe?(M.deleteCount+=ye,M.toInsert.push(...ge)):ne.push({start:pe,deleteCount:ye,toInsert:ge})}let H=0,ce=0;for(;;){if(H===z.length){V(H,0,j.slice(ce));break}if(ce===j.length){V(H,z.length-H,[]);break}const pe=z[H],ye=j[ce];if(ie(pe,ye)){H+=1,ce+=1;continue}he(ye)?(V(H,1,[]),H+=1):(V(H,0,[ye]),ce+=1)}return ne}e.$bH=n,e.$cH=new g.$Ki("notebookEditorCursorAtBoundary","none");var o;(function(z){z.default="default",z.option="option"})(o||(e.NotebookEditorPriority=o={}));function s(z){const j=z;return!!((typeof j.include=="string"||A.$bj(j.include))&&(typeof j.exclude=="string"||A.$bj(j.exclude)))}e.$dH=s;function t(z,j,he){if(Array.isArray(z.viewType)&&z.viewType.indexOf(j)>=0||z.viewType===j)return!0;if(z.filenamePattern){const ie=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,ne=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(A.$_i(ie,(0,m.$cc)(he.fsPath).toLowerCase()))return!(ne&&A.$_i(ne,(0,m.$cc)(he.fsPath).toLowerCase()))}return!1}e.$eH=t,e.$fH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var d;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class ${static create(j){return`${$.d}${j}`}static parse(j){if(j.startsWith($.d))return j.substring($.d.length)}}e.$gH=$,$.d="notebook/";function l(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$hH=l;const S=new TextDecoder;function y(z){const j=[];let he=!1;for(const ie of z)(j.length===0||he)&&(j.push(ie),he=!0);return N(j),K(b.$Ib.concat(j.map(ie=>b.$Ib.wrap(ie))))}e.$iH=y;const a=`${String.fromCharCode(27)}[A`,r=a.split("").map(z=>z.charCodeAt(0)),P=10;function N(z){z.forEach((j,he)=>{if(he===0||j.length<a.length)return;const ie=z[he-1],ne=j.subarray(0,a.length);if(ne[0]===r[0]&&ne[1]===r[1]&&ne[2]===r[2]){const V=ie.lastIndexOf(P);if(V===-1)return;z[he-1]=ie.subarray(0,V),z[he]=j.subarray(a.length)}})}function U(z){let j=z;do z=j,j=z.replace(/[^\n]\x08/gm,"");while(j.length<z.length);return z}function q(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const j=z.match(/^(.*)\r+/m)[1];let he=z.match(/\r+(.*)$/m)[1];he=he+j.slice(he.length,j.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return z}const B="\b".charCodeAt(0),O="\r".charCodeAt(0);function K(z){return!z.buffer.includes(B)&&!z.buffer.includes(O)?z:b.$Ib.fromString(q(U(S.decode(z.buffer))))}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[7],Ce([1,0,19,8,94,28,91,11,12,2,33,25,30,131,103]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C){"use strict";var p,i,c,u,v,f,E,n,o,s,t,d,$,l,S,y,a,r,P,N,U,q,B,O,K,z;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.TestRunProfileKind=e.TestResultState=e.$JK=e.$IK=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HK=e.$GK=e.$FK=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EK=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.ColorThemeKind=e.$yK=e.$xK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wK=e.DebugConsoleMode=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$qK=e.$pK=e.FileChangeType=e.$oK=e.$nK=e.$mK=e.$lK=e.InlineCompletionTriggerKind=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.ConfigurationTarget=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1J=e.ViewBadge=e.ProgressLocation=e.$ZJ=e.$YJ=e.TaskScope=e.ShellQuoting=e.$XJ=e.$WJ=e.$VJ=e.TaskPanelKind=e.TaskRevealKind=e.$UJ=e.TerminalLocation=e.$TJ=e.$SJ=e.$RJ=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$MJ=e.StatusBarAlignment=e.ViewColumn=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HJ=e.$GJ=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.LanguageStatusSeverity=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.CodeActionTriggerKind=e.$tJ=e.$sJ=e.SymbolTag=e.SymbolKind=e.$rJ=e.DocumentHighlightKind=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$mJ=e.$lJ=e.FileEditType=e.$kJ=e.$jJ=e.$iJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function j(G){return Object.assign(G,{apply:function(){const be=arguments.length===1?[]:arguments[1];return Reflect.construct(G,be,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[be,...Re]=arguments;return Reflect.construct(G,Re,be.constructor)}}})}var he;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(he||(e.TerminalOutputAnchor=he={}));var ie;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(ie||(e.TerminalQuickFixType=ie={}));let ne=e.$bJ=o=class{static from(...W){let be=W;return new o(function(){if(be){for(const Re of be)Re&&typeof Re.dispose=="function"&&Re.dispose();be=void 0}})}constructor(W){p.set(this,void 0),Ze(this,p,W,"f")}dispose(){typeof Te(this,p,"f")=="function"&&(Te(this,p,"f").call(this),Ze(this,p,void 0,"f"))}};p=new WeakMap,e.$bJ=ne=o=He([j],ne);let V=e.$cJ=s=class{static Min(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Re=1;Re<W.length;Re++){const Ke=W[Re];Ke.isBefore(be)&&(be=Ke)}return be}static Max(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Re=1;Re<W.length;Re++){const Ke=W[Re];Ke.isAfter(be)&&(be=Ke)}return be}static isPosition(W){if(!W)return!1;if(W instanceof s)return!0;const{line:be,character:Re}=W;return typeof be=="number"&&typeof Re=="number"}static of(W){if(W instanceof s)return W;if(this.isPosition(W))return new s(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,be){if(W<0)throw(0,A.$4)("line must be non-negative");if(be<0)throw(0,A.$4)("character must be non-negative");this.c=W,this.e=be}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,be=0){if(W===null||be===null)throw(0,A.$4)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,be=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&be===0?this:new s(this.line+Re,this.character+be)}with(W,be=this.character){if(W===null||be===null)throw(0,A.$4)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,be=typeof W.character=="number"?W.character:this.character),Re===this.line&&be===this.character?this:new s(Re,be)}toJSON(){return{line:this.line,character:this.character}}};e.$cJ=V=s=He([j],V);let H=e.$dJ=t=class{static isRange(W){return W instanceof t?!0:W?V.isPosition(W.start)&&V.isPosition(W.end):!1}static of(W){if(W instanceof t)return W;if(this.isRange(W))return new t(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,be,Re,Ke){let _e,ct;if(typeof W=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ke=="number"?(_e=new V(W,be),ct=new V(Re,Ke)):V.isPosition(W)&&V.isPosition(be)&&(_e=V.of(W),ct=V.of(be)),!_e||!ct)throw new Error("Invalid arguments");_e.isBefore(ct)?(this.c=_e,this.e=ct):(this.c=ct,this.e=_e)}contains(W){return t.isRange(W)?this.contains(W.start)&&this.contains(W.end):V.isPosition(W)?!(V.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const be=V.Max(W.start,this.c),Re=V.Min(W.end,this.e);if(!be.isAfter(Re))return new t(be,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const be=V.Min(W.start,this.c),Re=V.Max(W.end,this.end);return new t(be,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,be=this.end){if(W===null||be===null)throw(0,A.$4)();let Re;return W?V.isPosition(W)?Re=W:(Re=W.start||this.start,be=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&be.isEqual(this.end)?this:new t(Re,be)}toJSON(){return[this.start,this.end]}};e.$dJ=H=t=He([j],H);let ce=e.$eJ=d=class extends H{static isSelection(W){return W instanceof d?!0:W?H.isRange(W)&&V.isPosition(W.anchor)&&V.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,be,Re,Ke){let _e,ct;if(typeof W=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ke=="number"?(_e=new V(W,be),ct=new V(Re,Ke)):V.isPosition(W)&&V.isPosition(be)&&(_e=V.of(W),ct=V.of(be)),!_e||!ct)throw new Error("Invalid arguments");super(_e,ct),this.f=_e,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$eJ=ce=d=He([j],ce);const pe=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,A.$4)("connectionToken")};class ye{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be,Re){if(typeof W!="string"||W.length===0)throw(0,A.$4)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,A.$4)("port");typeof Re<"u"&&pe(Re),this.host=W,this.port=Math.round(be),this.connectionToken=Re}}e.$fJ=ye;class ge{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be){this.makeConnection=W,this.connectionToken=be,typeof be<"u"&&pe(be)}}e.$gJ=ge;class M extends Error{static NotAvailable(W,be){return new M(W,D.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(W){return new M(W,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,be=D.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=be,this._detail=Re,Object.setPrototypeOf(this,M.prototype)}}e.$hJ=M;var Y;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var ve;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(ve||(e.EnvironmentVariableMutatorType=ve={}));let Se=e.$iJ=$=class{static isTextEdit(W){return W instanceof $?!0:W?H.isRange(W)&&typeof W.newText=="string":!1}static replace(W,be){return new $(W,be)}static insert(W,be){return $.replace(new H(W,W),be)}static delete(W){return $.replace(W,"")}static setEndOfLine(W){const be=new $(new H(new V(0,0),new V(0,0)),"");return be.newEol=W,be}get range(){return this.c}set range(W){if(W&&!H.isRange(W))throw(0,A.$4)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,A.$4)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,A.$4)("newEol");this.f=W}constructor(W,be){this.c=W,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$iJ=Se=$=He([j],Se);let ee=e.$jJ=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?_t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,be){return new l(W,be)}static insertCells(W,be){return new l(new _t(W,W),be)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,be){const Re=new l(new _t(W,W),[]);return Re.newCellMetadata=be,Re}static updateNotebookMetadata(W){const be=new l(new _t(0,0),[]);return be.newNotebookMetadata=W,be}constructor(W,be){this.range=W,this.newCells=be}};e.$jJ=ee=l=He([j],ee);class te{static isSnippetTextEdit(W){return W instanceof te?!0:W?H.isRange(W.range)&&ue.isSnippetString(W.snippet):!1}static replace(W,be){return new te(W,be)}static insert(W,be){return te.replace(new H(W,W),be)}constructor(W,be){this.range=W,this.snippet=be}}e.$kJ=te;var le;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let X=e.$lJ=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,be,Re,Ke){this.c.push({_type:1,from:W,to:be,options:Re,metadata:Ke})}createFile(W,be,Re){this.c.push({_type:1,from:void 0,to:W,options:be,metadata:Re})}deleteFile(W,be,Re){this.c.push({_type:1,from:W,to:void 0,options:be,metadata:Re})}e(W,be,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:be},notebookMetadata:be})}f(W,be,Re,Ke){const _e=be.start,ct=be.end;(_e!==ct||Re.length>0)&&this.c.push({_type:5,uri:W,index:_e,count:ct-_e,cells:Re,metadata:Ke})}g(W,be,Re,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:3,index:be,metadata:Re}})}replace(W,be,Re,Ke){this.c.push({_type:2,uri:W,edit:new Se(be,Re),metadata:Ke})}insert(W,be,Re,Ke){this.replace(W,new H(be,be),Re,Ke)}delete(W,be,Re){this.replace(W,be,"",Re)}has(W){return this.c.some(be=>be._type===2&&be.uri.toString()===W.toString())}set(W,be){if(be)for(const Re of be){if(!Re)continue;let Ke,_e;Array.isArray(Re)?(Ke=Re[0],_e=Re[1]):Ke=Re,ee.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,_e):this.f(W,Ke.range,Ke.newCells,_e):te.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:W,edit:Ke,metadata:_e})}else{for(let Re=0;Re<this.c.length;Re++){const Ke=this.c[Re];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,b.$kf)(this.c)}}get(W){const be=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&be.push(Re.edit);return be}entries(){const W=new F.$ji;for(const be of this.c)if(be._type===2){let Re=W.get(be.uri);Re||(Re=[be.uri,[]],W.set(be.uri,Re)),Re[1].push(be.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$lJ=X=He([j],X);let ue=e.$mJ=S=class{static isSnippetString(W){return W instanceof S?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=S.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,be=this.e++){if(typeof W=="function"){const Re=new S;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=S.c(W);return this.value+="${",this.value+=be,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,be=this.e++){const Re=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,be){if(typeof be=="function"){const Re=new S;Re.e=this.e,be(Re),this.e=Re.e,be=Re.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$mJ=ue=S=He([j],ue);var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var oe;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let T=e.$nJ=y=class{static isLocation(W){return W instanceof y?!0:W?H.isRange(W.range)&&g.URI.isUri(W.uri):!1}constructor(W,be){if(this.uri=W,be)if(H.isRange(be))this.range=H.of(be);else if(V.isPosition(be))this.range=new H(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$nJ=T=y=He([j],T);let J=e.$oJ=class{static is(W){return W?typeof W.message=="string"&&W.location&&H.isRange(W.location.range)&&g.URI.isUri(W.location.uri):!1}constructor(W,be){this.location=W,this.message=be}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.location.range.isEqual(be.location.range)&&W.location.uri.toString()===be.location.uri.toString()}};e.$oJ=J=He([j],J);let Z=e.$pJ=class{constructor(W,be,Re=oe.Error){if(!H.isRange(W))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=W,this.message=be,this.severity=Re}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.severity===be.severity&&W.code===be.code&&W.severity===be.severity&&W.source===be.source&&W.range.isEqual(be.range)&&(0,b.$$e)(W.tags,be.tags)&&(0,b.$$e)(W.relatedInformation,be.relatedInformation,J.isEqual)}};e.$pJ=Z=He([j],Z);let x=e.$qJ=class{constructor(W,be){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=be}};e.$qJ=x=He([j],x);var me;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let Ee=e.$rJ=class{constructor(W,be=me.Text){this.range=W,this.kind=be}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$rJ=Ee=He([j],Ee);var fe;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var Ie;(function(G){G[G.Deprecated=1]="Deprecated"})(Ie||(e.SymbolTag=Ie={}));let Pe=e.$sJ=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,be,Re,Ke,_e){this.name=W,this.kind=be,this.containerName=_e,typeof Re=="string"&&(this.containerName=Re),Ke instanceof T?this.location=Ke:Re instanceof H&&(this.location=new T(Ke,Re)),a.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$sJ=Pe=a=He([j],Pe);let qe=e.$tJ=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(r.validate)}constructor(W,be,Re,Ke,_e){this.name=W,this.detail=be,this.kind=Re,this.range=Ke,this.selectionRange=_e,this.children=[],r.validate(this)}};e.$tJ=qe=r=He([j],qe);var Ve;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ve||(e.CodeActionTriggerKind=Ve={}));let tt=e.$uJ=class{constructor(W,be){this.title=W,this.kind=be}};e.$uJ=tt=He([j],tt);let Ge=e.$vJ=P=class{constructor(W){this.value=W}append(W){return new P(this.value?this.value+P.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+P.c)}};Ge.c=".",e.$vJ=Ge=P=He([j],Ge);class Ye extends Ge{constructor(W){super(W),this.value=W}}e.$wJ=Ye,Ge.Empty=new Ge(""),Ge.QuickFix=Ge.Empty.append("quickfix"),Ge.Refactor=Ge.Empty.append("refactor"),Ge.RefactorExtract=Ge.Refactor.append("extract"),Ge.RefactorInline=Ge.Refactor.append("inline"),Ge.RefactorMove=Ge.Refactor.append("move"),Ge.RefactorRewrite=Ge.Refactor.append("rewrite"),Ge.Source=Ge.Empty.append("source"),Ge.SourceOrganizeImports=Ge.Source.append("organizeImports"),Ge.SourceFixAll=Ge.Source.append("fixAll"),Ge.Notebook=Ge.Empty.append("notebook");let st=e.$xJ=class{constructor(W,be){if(this.range=W,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xJ=st=He([j],st);class at{constructor(W,be,Re,Ke,_e,ct){this.kind=W,this.name=be,this.detail=Re,this.uri=Ke,this.range=_e,this.selectionRange=ct}}e.$yJ=at;class xe{constructor(W,be){this.fromRanges=be,this.from=W}}e.$zJ=xe;class rt{constructor(W,be){this.fromRanges=be,this.to=W}}e.$AJ=rt;var de;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(de||(e.LanguageStatusSeverity=de={}));let Me=e.$BJ=class{constructor(W,be){this.range=W,this.command=be}get isResolved(){return!!this.command}};e.$BJ=Me=He([j],Me);let _=e.$CJ=N=class{static isMarkdownString(W){return W instanceof N?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,be=!1){i.set(this,void 0),Ze(this,i,new h.$Gj(W,{supportThemeIcons:be}),"f")}get value(){return Te(this,i,"f").value}set value(W){Te(this,i,"f").value=W}get isTrusted(){return Te(this,i,"f").isTrusted}set isTrusted(W){Te(this,i,"f").isTrusted=W}get supportThemeIcons(){return Te(this,i,"f").supportThemeIcons}set supportThemeIcons(W){Te(this,i,"f").supportThemeIcons=W}get supportHtml(){return Te(this,i,"f").supportHtml}set supportHtml(W){Te(this,i,"f").supportHtml=W}get baseUri(){return Te(this,i,"f").baseUri}set baseUri(W){Te(this,i,"f").baseUri=W}appendText(W){return Te(this,i,"f").appendText(W),this}appendMarkdown(W){return Te(this,i,"f").appendMarkdown(W),this}appendCodeblock(W,be){return Te(this,i,"f").appendCodeblock(be??"",W),this}};i=new WeakMap,e.$CJ=_=N=He([j],_);let Q=e.$DJ=class{constructor(W,be){this.label=W,this.documentation=be}};e.$DJ=Q=He([j],Q);let we=e.$EJ=class{constructor(W,be){this.label=W,this.documentation=be,this.parameters=[]}};e.$EJ=we=He([j],we);let je=e.$FJ=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FJ=je=He([j],je);var Oe;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Oe||(e.SignatureHelpTriggerKind=Oe={}));var Xe;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Xe||(e.InlayHintKind=Xe={}));let et=e.$GJ=class{constructor(W){this.value=W}};e.$GJ=et=He([j],et);let nt=e.$HJ=class{constructor(W,be,Re){this.position=W,this.label=be,this.kind=Re}};e.$HJ=nt=He([j],nt);var ft;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft||(e.CompletionTriggerKind=ft={}));var vt;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Nt;(function(G){G[G.Deprecated=1]="Deprecated"})(Nt||(e.CompletionItemTag=Nt={}));let Tt=e.$IJ=class{constructor(W,be){this.label=W,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IJ=Tt=He([j],Tt);let Et=e.$JJ=class{constructor(W=[],be=!1){this.items=W,this.isIncomplete=be}};e.$JJ=Et=He([j],Et);let Bt=e.$KJ=class{constructor(W,be,Re){this.insertText=W,this.range=be,this.command=Re}};e.$KJ=Bt=He([j],Bt);let Ot=e.$LJ=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$LJ=Ot=He([j],Ot);var jt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(jt||(e.ViewColumn=jt={}));var Vt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Vt||(e.StatusBarAlignment=Vt={}));function Ht(G,W){return`${I.$El.toKey(G)}.${W}`}e.$MJ=Ht;var ut;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var Wt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Wt||(e.TextEditorRevealType=Wt={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var Ct;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var lt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(lt||(e.DecorationRangeBehavior=lt={})),function(G){function W(be){switch(be){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(Rt||(e.TextEditorSelectionChangeKind=Rt={}));let Pt=e.$NJ=class{constructor(W,be){if(be&&!g.URI.isUri(be))throw(0,A.$4)("target");if(!H.isRange(W)||W.isEmpty)throw(0,A.$4)("range");this.range=W,this.target=be}};e.$NJ=Pt=He([j],Pt);let Mt=e.$OJ=class{constructor(W,be,Re,Ke){this.red=W,this.green=be,this.blue=Re,this.alpha=Ke}};e.$OJ=Mt=He([j],Mt);let Fe=e.$PJ=class{constructor(W,be){if(be&&!(be instanceof Mt))throw(0,A.$4)("color");if(!H.isRange(W)||W.isEmpty)throw(0,A.$4)("range");this.range=W,this.color=be}};e.$PJ=Fe=He([j],Fe);let Le=e.$QJ=class{constructor(W){if(!W||typeof W!="string")throw(0,A.$4)("label");this.label=W}};e.$QJ=Le=He([j],Le);var Ae;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ae||(e.ColorFormat=Ae={}));var ae;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ae||(e.SourceControlInputBoxValidationType=ae={}));var Ne;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ne||(e.TerminalExitReason=Ne={}));class Be{constructor(W,be,Re){if(this.startIndex=W,this.length=be,this.tooltip=Re,typeof W!="number"||W<0)throw(0,A.$4)("startIndex");if(typeof be!="number"||be<1)throw(0,A.$4)("length");if(Re!==void 0&&typeof Re!="string")throw(0,A.$4)("tooltip")}}e.$RJ=Be;class Qe{constructor(W){this.uri=W}}e.$SJ=Qe;class Je{constructor(W){this.terminalCommand=W}}e.$TJ=Je;var it;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(it||(e.TerminalLocation=it={}));class kt{constructor(W){if(this.options=W,typeof W!="object")throw(0,A.$4)("options")}}e.$UJ=kt;var It;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var At;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(At||(e.TaskPanelKind=At={}));let bt=e.$VJ=U=class{static from(W){switch(W){case"clean":return U.Clean;case"build":return U.Build;case"rebuild":return U.Rebuild;case"test":return U.Test;default:return}}constructor(W,be){if(this.label=be,typeof W!="string"||typeof be!="string")throw(0,A.$4)("name");this.c=W}get id(){return this.c}};bt.Clean=new U("clean","Clean"),bt.Build=new U("build","Build"),bt.Rebuild=new U("rebuild","Rebuild"),bt.Test=new U("test","Test"),e.$VJ=bt=U=He([j],bt);function pt(G){let W="";for(let be=0;be<G.length;be++)W+=G[be].replace(/,/g,",,")+",";return W}let mt=e.$WJ=class{constructor(W,be,Re){if(typeof W!="string")throw(0,A.$4)("process");this.e=[],this.c=W,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Re):this.f=be)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,A.$4)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const be of this.e)W.push(be);return pt(W)}};e.$WJ=mt=He([j],mt);let yt=e.$XJ=class{constructor(W,be,Re){if(this.f=[],Array.isArray(be)){if(!W)throw(0,A.$4)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,A.$4)("command");this.e=W,this.f=be,this.g=Re}else{if(typeof W!="string")throw(0,A.$4)("commandLine");this.c=W,this.g=be}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,A.$4)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,A.$4)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)W.push(typeof be=="string"?be:be.value);return pt(W)}};e.$XJ=yt=He([j],yt);var wt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(wt||(e.ShellQuoting=wt={}));var Xt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Xt||(e.TaskScope=Xt={}));class qt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.$3e)()}set callback(W){this.c=W}get callback(){return this.c}}e.$YJ=qt;let ni=e.$ZJ=q=class{constructor(W,be,Re,Ke,_e,ct){this.j=!1,this.k=this.definition=W;let dt;typeof be=="string"?(this.m=this.name=be,this.t=this.source=Re,this.execution=Ke,dt=_e,this.j=!0):be===Xt.Global||be===Xt.Workspace?(this.target=be,this.m=this.name=Re,this.t=this.source=Ke,this.execution=_e,dt=ct):(this.target=be,this.m=this.name=Re,this.t=this.source=Ke,this.execution=_e,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof mt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof yt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof qt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,L.$3e)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,A.$4)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,A.$4)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const be=this.k.type;(q.g===be||q.e===be||q.f===be||q.c===be)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,A.$4)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};ni.c="customExecution",ni.e="process",ni.f="shell",ni.g="$empty",e.$ZJ=ni=q=He([j],ni);var ai;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var yi;(function(G){function W(be){const Re=be;return(0,k.$ke)(Re.value)?Re.tooltip&&!(0,k.$ge)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}G.isViewBadge=W})(yi||(e.ViewBadge=yi={}));let Lt=e.$1J=B=class{static isTreeItem(W,be){const Re=W;if(Re.checkboxState!==void 0){const Ke=(0,k.$ke)(Re.checkboxState)?Re.checkboxState:(0,k.$ie)(Re.checkboxState)&&(0,k.$ke)(Re.checkboxState.state)?Re.checkboxState.state:void 0,_e=!(0,k.$ke)(Re.checkboxState)&&(0,k.$ie)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==fi.Checked&&Ke!==fi.Unchecked||_e!==void 0&&!(0,k.$ge)(_e))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof B)return!0;if(Re.label!==void 0&&!(0,k.$ge)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,k.$ge)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,k.$ge)(Re.iconPath)&&!g.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,k.$ge)(Re.iconPath.id))){const Ke=Re.iconPath;if(!Ke||!(0,k.$ge)(Ke.light)&&!g.URI.isUri(Ke.light)&&!(0,k.$ge)(Ke.dark)&&!g.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,k.$ge)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!g.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,k.$ge)(Re.tooltip)&&!(Re.tooltip instanceof _)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<ci.None&&Re.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,k.$ge)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,be=ci.None){this.collapsibleState=be,g.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$1J=Lt=B=He([j],Lt);var ci;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var fi;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(fi||(e.TreeItemCheckboxState=fi={}));let Dt=e.$2J=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$2J=Dt=He([j],Dt);class Ei extends Dt{}e.$3J=Ei;class Fi extends Ei{constructor(W){super(""),c.set(this,void 0),Ze(this,c,W,"f")}asFile(){return Te(this,c,"f")}}e.$4J=Fi,c=new WeakMap;class mi{constructor(W,be,Re,Ke){this.name=W,this.uri=be,this._itemId=Re,this.c=Ke}data(){return this.c()}}e.$5J=mi;let Ti=e.$6J=class{constructor(W){u.add(this),v.set(this,new Map);for(const[be,Re]of W??[]){const Ke=Te(this,v,"f").get(Te(this,u,"m",f).call(this,be));Ke?Ke.push(Re):Te(this,v,"f").set(Te(this,u,"m",f).call(this,be),[Re])}}get(W){return Te(this,v,"f").get(Te(this,u,"m",f).call(this,W))?.[0]}set(W,be){Te(this,v,"f").set(Te(this,u,"m",f).call(this,W),[be])}forEach(W,be){for(const[Re,Ke]of Te(this,v,"f"))for(const _e of Ke)W.call(be,_e,Re,this)}*[(v=new WeakMap,u=new WeakSet,Symbol.iterator)](){for(const[W,be]of Te(this,v,"f"))for(const Re of be)yield[W,Re]}};f=function(W){return W.toLowerCase()},e.$6J=Ti=He([j],Ti);let Mi=e.$7J=class{constructor(W){this.insertText=W}};e.$7J=Mi=He([j],Mi);let zt=e.$8J=class{constructor(W,be,Re){this.id=be,this.label=Re,this.insertText=W}};e.$8J=zt=He([j],zt);let Yt=e.$9J=class{constructor(W,be){this.id=W,this.color=be}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$9J=Yt=He([j],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let Ni=e.$0J=class{constructor(W){this.id=W}};e.$0J=Ni=He([j],Ni);var ui;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let li=e.$$J=class{get base(){return this.c}set base(W){this.c=W,this.e=g.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,be){if(typeof W!="string"&&(!W||!g.URI.isUri(W)&&!g.URI.isUri(W.uri)))throw(0,A.$4)("base");if(typeof be!="string")throw(0,A.$4)("pattern");typeof W=="string"?this.baseUri=g.URI.file(W):g.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$J=li=He([j],li);const ht=new WeakMap;function an(G,W){ht.set(G,W)}e.$_J=an;let Jt=e.$aK=class{constructor(W,be,Re,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof be=="string"&&(this.condition=be),typeof Re=="string"&&(this.hitCondition=Re),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ht.get(this)??(0,L.$3e)()),this.c}};e.$aK=Jt=He([j],Jt);let ri=e.$bK=class extends Jt{constructor(W,be,Re,Ke,_e){if(super(be,Re,Ke,_e),W===null)throw(0,A.$4)("location");this.location=W}};e.$bK=ri=He([j],ri);let ki=e.$cK=class extends Jt{constructor(W,be,Re,Ke,_e){super(be,Re,Ke,_e),this.functionName=W}};e.$cK=ki=He([j],ki);let Oi=e.$dK=class extends Jt{constructor(W,be,Re,Ke,_e,ct,dt){if(super(Ke,_e,ct,dt),!be)throw(0,A.$4)("dataId");this.label=W,this.dataId=be,this.canPersist=Re}};e.$dK=Oi=He([j],Oi);let zi=e.$eK=class{constructor(W,be,Re){this.command=W,this.args=be||[],this.options=Re}};e.$eK=zi=He([j],zi);let ji=e.$fK=class{constructor(W,be){this.port=W,this.host=be}};e.$fK=ji=He([j],ji);let Si=e.$gK=class{constructor(W){this.path=W}};e.$gK=Si=He([j],Si);let Ui=e.$hK=class{constructor(W){this.implementation=W}};e.$hK=Ui=He([j],Ui);let Di=e.$iK=class{constructor(W,be,Re){this.session=W,this.threadId=be,this.frameId=Re}};e.$iK=Di=He([j],Di);let si=e.$jK=class{constructor(W,be){this.session=W,this.threadId=be}};e.$jK=si=He([j],si);let Bi=e.$kK=class{constructor(W,be){this.range=W,this.expression=be}};e.$kK=Bi=He([j],Bi);var gi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=e.$lK=class{constructor(W,be){this.range=W,this.text=be}};e.$lK=$i=He([j],$i);let Wi=e.$mK=class{constructor(W,be,Re=!0){this.range=W,this.variableName=be,this.caseSensitiveLookup=Re}};e.$mK=Wi=He([j],Wi);let qi=e.$nK=class{constructor(W,be){this.range=W,this.expression=be}};e.$nK=qi=He([j],qi);let oi=e.$oK=class{constructor(W,be){this.frameId=W,this.stoppedLocation=be}};e.$oK=oi=He([j],oi);var Vi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Hi=e.$pK=O=class extends Error{static FileExists(W){return new O(W,w.FileSystemProviderErrorCode.FileExists,O.FileExists)}static FileNotFound(W){return new O(W,w.FileSystemProviderErrorCode.FileNotFound,O.FileNotFound)}static FileNotADirectory(W){return new O(W,w.FileSystemProviderErrorCode.FileNotADirectory,O.FileNotADirectory)}static FileIsADirectory(W){return new O(W,w.FileSystemProviderErrorCode.FileIsADirectory,O.FileIsADirectory)}static NoPermissions(W){return new O(W,w.FileSystemProviderErrorCode.NoPermissions,O.NoPermissions)}static Unavailable(W){return new O(W,w.FileSystemProviderErrorCode.Unavailable,O.Unavailable)}constructor(W,be=w.FileSystemProviderErrorCode.Unknown,Re){super(g.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,w.$3j)(this,be),Object.setPrototypeOf(this,O.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$pK=Hi=O=He([j],Hi);let Ji=e.$qK=class{constructor(W,be,Re){this.start=W,this.end=be,this.kind=Re}};e.$qK=Ji=He([j],Ji);var ei;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(ei||(e.FoldingRangeKind=ei={}));var Ki;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var Gi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var Ci;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Ci||(e.CommentState=Ci={}));var Yi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));class cn{constructor(W,be=[]){this.tokenTypes=W,this.tokenModifiers=be}}e.$rK=cn;function un(G){return typeof G>"u"||(0,k.$he)(G)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let be=0,Re=W.tokenTypes.length;be<Re;be++)this.j.set(W.tokenTypes[be],be);for(let be=0,Re=W.tokenModifiers.length;be<Re;be++)this.k.set(W.tokenModifiers[be],be)}}push(W,be,Re,Ke,_e){if(typeof W=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(W,be,Re,Ke,_e);if(H.isRange(W)&&typeof be=="string"&&un(Re))return this.m(W,be,Re);throw(0,A.$4)()}m(W,be,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(be))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,_e=W.start.character,ct=W.end.character-W.start.character,dt=this.j.get(be);let Ut=0;if(Re)for(const Gt of Re){if(!this.k.has(Gt))throw new Error("`tokenModifier` is not in the provided legend");const Qt=this.k.get(Gt);Ut|=1<<Qt>>>0}this.n(Ke,_e,ct,dt,Ut)}n(W,be,Re,Ke,_e){if(this.f&&(W<this.c||W===this.c&&be<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Gt=0,Qt=0;for(let xt=0;xt<Ut;xt++){let ti=this.g[5*xt],Li=this.g[5*xt+1];ti===0?(ti=Gt,Li+=Qt):ti+=Gt,this.g[5*xt]=ti,this.g[5*xt+1]=Li,Gt=ti,Qt=Li}}let ct=W,dt=be;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Re,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=W,this.e=be}static o(W){const be=[],Re=W.length/5|0;for(let dt=0;dt<Re;dt++)be[dt]=dt;be.sort((dt,Ut)=>{const Gt=W[5*dt],Qt=W[5*Ut];if(Gt===Qt){const xt=W[5*dt+1],ti=W[5*Ut+1];return xt-ti}return Gt-Qt});const Ke=new Uint32Array(W.length);let _e=0,ct=0;for(let dt=0;dt<Re;dt++){const Ut=5*be[dt],Gt=W[Ut+0],Qt=W[Ut+1],xt=W[Ut+2],ti=W[Ut+3],Li=W[Ut+4],An=Gt-_e,Kn=An===0?Qt-ct:Qt,Ri=5*dt;Ke[Ri+0]=An,Ke[Ri+1]=Kn,Ke[Ri+2]=xt,Ke[Ri+3]=ti,Ke[Ri+4]=Li,_e=Gt,ct=Qt}return Ke}build(W){return this.f?new bi(new Uint32Array(this.g),W):new bi(hi.o(this.g),W)}}e.$sK=hi;class bi{constructor(W,be){this.resultId=be,this.data=W}}e.$tK=bi;class Ue{constructor(W,be,Re){this.start=W,this.deleteCount=be,this.data=Re}}e.$uK=Ue;class Zt{constructor(W,be){this.resultId=be,this.edits=W}}e.$vK=Zt;var Ii;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Ii||(e.DebugConsoleMode=Ii={}));let $t=e.$wK=class{constructor(){}};$t.Back={iconPath:new Yt("arrow-left")},e.$wK=$t=He([j],$t);var Qi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Xi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var Pi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Pi||(e.ExtensionKind=Pi={}));class ln{static validate(W){if(typeof W.badge=="string"){let be=(0,m.$Td)(W.badge,0);if(be<W.badge.length&&(be+=(0,m.$Td)(W.badge,be)),W.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Yt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,be,Re){this.badge=W,this.tooltip=be,this.color=Re}}e.$xK=ln;let di=e.$yK=class{constructor(W){this.kind=W}};e.$yK=di=He([j],di);var Zi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Zi||(e.ColorThemeKind=Zi={}));class _t{static isNotebookRange(W){return W instanceof _t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,be){if(W<0)throw(0,A.$4)("start must be positive");if(be<0)throw(0,A.$4)("end must be positive");W<=be?(this.c=W,this.e=be):(this.c=be,this.e=W)}with(W){let be=this.c,Re=this.e;return W.start!==void 0&&(be=W.start),W.end!==void 0&&(Re=W.end),be===this.c&&Re===this.e?this:new _t(be,Re)}}e.$zK=_t;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(be=>pi.isNotebookCellData(be))}static isNotebookCellData(W){return!0}constructor(W,be,Re,Ke,_e,ct,dt){this.kind=W,this.value=be,this.languageId=Re,this.mime=Ke,this.outputs=_e??[],this.metadata=ct,this.executionSummary=dt,pi.validate(this)}}e.$AK=pi;class _i{constructor(W){this.cells=W}}e.$BK=_i;class Kt{static isNotebookCellOutputItem(W){return W instanceof Kt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const be={name:W.name,message:W.message,stack:W.stack};return Kt.json(be,"application/vnd.code.notebook.error")}static stdout(W){return Kt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Kt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,be="application/octet-stream"){return new Kt(W,be)}static text(W,be=R.$rr.text){const Re=Te(Kt,E,"f",n).encode(String(W));return new Kt(Re,be)}static json(W,be="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Kt.text(Re,be)}constructor(W,be){this.data=W,this.mime=be;const Re=(0,R.$vr)(be,!0);if(!Re)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$CK=Kt,E=Kt,n={value:new TextEncoder};class wi{static isNotebookCellOutput(W){return W instanceof wi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,be=!1){const Re=new Set,Ke=new Set;for(let _e=0;_e<W.length;_e++){const ct=W[_e],dt=(0,R.$vr)(ct.mime);if(!Re.has(dt)||(0,C.$hH)(dt)){Re.add(dt);continue}Ke.add(_e),be&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((_e,ct)=>!Ke.has(ct))}constructor(W,be,Re){this.items=wi.ensureUniqueMimeTypes(W,!0),typeof be=="string"?(this.id=be,this.metadata=Re):(this.id=(0,L.$3e)(),this.metadata=be??Re)}}e.$DK=wi;var xi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var en;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(en||(e.NotebookCellExecutionState=en={}));var tn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var nn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(nn||(e.NotebookEditorRevealType=nn={}));class hn{constructor(W,be){this.text=W,this.alignment=be}}e.$EK=hn;var rn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(sn||(e.NotebookControllerAffinity2=sn={}));class $e{constructor(W,be=[]){this.uri=W,this.provides=(0,b.$Gf)(be)}}e.$FK=$e;class ke{constructor(W){this.label=W}}e.$GK=ke;let ze=e.$HK=class{constructor(W,be){this.label=W,this.timestamp=be}};e.$HK=ze=He([j],ze);var ot;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ot||(e.ExtensionMode=ot={}));var St;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(St||(e.ExtensionRuntime=St={}));var Ft;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Ft||(e.StandardTokenType=Ft={}));class Mn{constructor(W,be){this.ranges=W,this.wordPattern=be}}e.$IK=Mn;class Nn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$JK=Nn;var mn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(mn||(e.TestResultState=mn={}));var gn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(gn||(e.TestRunProfileKind=gn={}));let dn=e.$KK=class{constructor(W=void 0,be=void 0,Re=void 0,Ke=!1){this.include=W,this.exclude=be,this.profile=Re,this.continuous=Ke}};e.$KK=dn=He([j],dn);let $n=e.$LK=class extends dn{};e.$LK=$n=He([j],$n);let bn=e.$MK=K=class{static diff(W,be,Re){const Ke=new K(W);return Ke.expectedOutput=be,Ke.actualOutput=Re,Ke}constructor(W){this.message=W}};e.$MK=bn=K=He([j],bn);let pn=e.$NK=class{constructor(W){this.id=W}};e.$NK=pn=He([j],pn);let Ai=e.$OK=class{constructor(W,be){this.covered=W,this.total=be}};e.$OK=Ai=He([j],Ai);let wn=e.$PK=z=class{static fromDetails(W,be){const Re=new Ai(0,0),Ke=new Ai(0,0),_e=new Ai(0,0);for(const dt of be)if("branches"in dt){Re.total+=1,Re.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)Ke.total+=1,Ke.covered+=Ut.executionCount>0?1:0}else _e.total+=1,_e.covered+=dt.executionCount>0?1:0;const ct=new z(W,Re,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ct.detailedCoverage=be,ct}constructor(W,be,Re,Ke){this.uri=W,this.statementCoverage=be,this.branchCoverage=Re,this.functionCoverage=Ke}};e.$PK=wn=z=He([j],wn);let vn=e.$QK=class{constructor(W,be,Re=[]){this.executionCount=W,this.location=be,this.branches=Re}};e.$QK=vn=He([j],vn);let yn=e.$RK=class{constructor(W,be){this.executionCount=W,this.location=be}};e.$RK=yn=He([j],yn);let En=e.$SK=class{constructor(W,be){this.executionCount=W,this.location=be}};e.$SK=En=He([j],En);var kn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Sn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Sn||(e.WorkspaceTrustState=Sn={}));var Dn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class On{constructor(W,be,Re,Ke,_e,ct){this.kind=W,this.name=be,this.detail=Re,this.uri=Ke,this.range=_e,this.selectionRange=ct}}e.$TK=On;class zn{constructor(W){this.uri=W}}e.$UK=zn;class jn{constructor(W,be){this.original=W,this.modified=be}}e.$VK=jn;class Un{constructor(W,be,Re,Ke){this.base=W,this.input1=be,this.input2=Re,this.result=Ke}}e.$WK=Un;class Bn{constructor(W,be){this.uri=W,this.viewType=be}}e.$XK=Bn;class Wn{constructor(W){this.viewType=W}}e.$YK=Wn;class qn{constructor(W,be){this.uri=W,this.notebookType=be}}e.$ZK=qn;class Vn{constructor(W,be,Re){this.original=W,this.modified=be,this.notebookType=Re}}e.$1K=Vn;class Hn{constructor(){}}e.$2K=Hn;class Jn{constructor(W,be){this.uri=W,this.inputBoxUri=be}}e.$3K=Jn;var Cn;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var In;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(In||(e.InteractiveSessionCopyKind=In={}));var Pn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}))}),define(De[136],Ce([1,0,53,16,11,166,122,7,19]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.$eL=e.$dL=void 0;const g=new Map;function L(C,p){p?g.set(C,p):g.delete(C)}e.$dL=L;function I(C){return g.get(C)}class w extends F.$qu{constructor(p,i,c,u,v,f,E,n){super(i,c,u,v),this.c=p,this.m=f,this.q=E,this.notebook=n,this.b=!1}dispose(){(0,b.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,k.$$e)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===A.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(i){return i?p.s(i):p.getText()},get eol(){return p.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(i){return p.t(i)},offsetAt(i){return p.u(i)},positionAt(i){return p.v(i)},validateRange(i){return p.w(i)},validatePosition(i){return p.x(i)},getWordRangeAtPosition(i,c){return p.y(i,c)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,b.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,b.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const i=this.w(p);if(i.isEmpty)return"";if(i.isSingleLine)return this.f[i.start.line].substring(i.start.character,i.end.character);const c=this.g,u=i.start.line,v=i.end.line,f=[];f.push(this.f[u].substring(i.start.character));for(let E=u+1;E<v;E++)f.push(this.f[E]);return f.push(this.f[v].substring(0,i.end.character)),f.join(c)}t(p){let i;if(p instanceof m.$cJ?i=p.line:typeof p=="number"&&(i=p),typeof i!="number"||i<0||i>=this.f.length||Math.floor(i)!==i)throw new Error("Illegal value for `line`");return new D(i,this.f[i],i===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const i=this.j.getIndexOf(p),c=this.f[i.index].length;return new m.$cJ(i.index,Math.min(i.remainder,c))}w(p){if(!(p instanceof m.$dJ))throw new Error("Invalid argument");const i=this.x(p.start),c=this.x(p.end);return i===p.start&&c===p.end?p:new m.$dJ(i.line,i.character,c.line,c.character)}x(p){if(!(p instanceof m.$cJ))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:i,character:c}=p,u=!1;if(i<0)i=0,c=0,u=!0;else if(i>=this.f.length)i=this.f.length-1,c=this.f[i].length,u=!0;else{const v=this.f[i].length;c<0?(c=0,u=!0):c>v&&(c=v,u=!0)}return u?new m.$cJ(i,c):p}y(p,i){const c=this.x(p);if(!i)i=I(this.m);else if((0,h.$ud)(i))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${i.source}' because it matches the empty string.`);const u=(0,R.$Jr)(c.character+1,(0,R.$Hr)(i),this.f[c.line],0);if(u)return new m.$dJ(c.line,u.startColumn-1,c.line,u.endColumn-1)}}e.$eL=w;class D{constructor(p,i,c){this.a=p,this.b=i,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$dJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$dJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fL=D}),define(De[253],Ce([1,0,7,20,3]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=void 0;let F=e.$v_b=class{constructor(m){this.a=new b.$yK(b.ColorThemeKind.Dark),this.b=new h.$5c}get activeColorTheme(){return this.a}$onColorThemeChange(m){let k;switch(m){case"light":k=b.ColorThemeKind.Light;break;case"hcDark":k=b.ColorThemeKind.HighContrast;break;case"hcLight":k=b.ColorThemeKind.HighContrastLight;break;default:k=b.ColorThemeKind.Dark}this.a=new b.$yK(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$v_b=F=He([We(0,A.$bL)],F)}),define(De[254],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=e.CellExecutionUpdateType=void 0;var A;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(A||(e.CellExecutionUpdateType=A={})),e.$kH=(0,b.$lh)("INotebookExecutionService")}),define(De[60],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(F){F.Delimiter="\0"})(b||(e.TestIdPathParts=b={}));var A;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class h{static fromExtHostTestItem(R,m,k=R.parent){if(R._isRoot)return new h([m]);const g=[R.id];for(let L=k;L&&L.id!==m;L=L.parent)g.push(L.id);return g.push(m),new h(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new h(R.split("\0"))}static join(R,m){return new h([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:h.isChild(R,m)?2:h.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new h(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new h(this.path,R)}compare(R){if(typeof R=="string")return h.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$XH=h}),define(De[81],Ce([1,0,2,36,60]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$4H=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3H=e.$2H=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1H=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZH=e.$YH=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var R;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var m;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$YH=[2,4,8,16,32,64];const k=S=>"runId"in S;e.$ZH=k;var g;(function(S){S.serialize=y=>({range:y.range.toJSON(),uri:y.uri.toJSON()}),S.deserialize=y=>({range:A.$Lr.lift(y.range),uri:b.URI.revive(y.uri)})})(g||(e.IRichLocation=g={}));var L;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(L||(e.TestMessageType=L={}));var I;(function(S){S.serialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,location:y.location&&g.serialize(y.location)}),S.deserialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,location:y.location&&g.deserialize(y.location)})})(I||(e.ITestErrorMessage=I={}));const w=(S,y)=>`${y?"s":"e"}${S}`;e.$1H=w;var D;(function(S){S.serialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&g.serialize(y.location)}),S.deserialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&g.deserialize(y.location)})})(D||(e.ITestOutputMessage=D={}));var C;(function(S){S.serialize=y=>y.type===0?I.serialize(y):D.serialize(y),S.deserialize=y=>y.type===0?I.deserialize(y):D.deserialize(y)})(C||(e.ITestMessage=C={}));var p;(function(S){S.serializeWithoutMessages=y=>({state:y.state,duration:y.duration,messages:[]}),S.serialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(C.serialize)}),S.deserialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(C.deserialize)})})(p||(e.ITestTaskState=p={}));const i="\0",c=(S,y)=>S+i+y;e.$2H=c;const u=S=>{const y=S.indexOf(i);return{ctrlId:S.slice(0,y),tagId:S.slice(y+1)}};e.$3H=u;var v;(function(S){S.serialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?.toJSON(),range:y.range?.toJSON()||null,description:y.description,error:y.error,sortText:y.sortText}),S.deserialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?b.URI.revive(y.uri):void 0,range:y.range?A.$Lr.lift(y.range):null,description:y.description,error:y.error,sortText:y.sortText})})(v||(e.ITestItem=v={}));var f;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(f||(e.TestItemExpandState=f={}));var E;(function(S){S.serialize=y=>({expand:y.expand,item:v.serialize(y.item)}),S.deserialize=y=>({controllerId:h.$XH.root(y.item.extId),expand:y.expand,item:v.deserialize(y.item)})})(E||(e.InternalTestItem=E={}));var n;(function(S){S.serialize=y=>{let a;return y.item&&(a={},y.item.label!==void 0&&(a.label=y.item.label),y.item.tags!==void 0&&(a.tags=y.item.tags),y.item.busy!==void 0&&(a.busy=y.item.busy),y.item.uri!==void 0&&(a.uri=y.item.uri?.toJSON()),y.item.range!==void 0&&(a.range=y.item.range?.toJSON()),y.item.description!==void 0&&(a.description=y.item.description),y.item.error!==void 0&&(a.error=y.item.error),y.item.sortText!==void 0&&(a.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:a}},S.deserialize=y=>{let a;return y.item&&(a={},y.item.label!==void 0&&(a.label=y.item.label),y.item.tags!==void 0&&(a.tags=y.item.tags),y.item.busy!==void 0&&(a.busy=y.item.busy),y.item.range!==void 0&&(a.range=y.item.range?A.$Lr.lift(y.item.range):null),y.item.description!==void 0&&(a.description=y.item.description),y.item.error!==void 0&&(a.error=y.item.error),y.item.sortText!==void 0&&(a.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:a}}})(n||(e.ITestItemUpdate=n={}));const o=(S,y)=>{y.expand!==void 0&&(S.expand=y.expand),y.item!==void 0&&(S.item=S.item?Object.assign(S.item,y.item):y.item)};e.$4H=o;var s;(function(S){S.serializeWithoutMessages=y=>({...E.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(p.serializeWithoutMessages)}),S.serialize=y=>({...E.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(p.serialize)}),S.deserialize=y=>({...E.deserialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(p.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var t;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(t||(e.DetailType=t={}));var d;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(d||(e.TestDiffOpType=d={}));var $;(function(S){S.deserialize=y=>y.op===0?{op:y.op,item:E.deserialize(y.item)}:y.op===1?{op:y.op,item:n.deserialize(y.item)}:y.op===2?{op:y.op,uri:b.URI.revive(y.uri),docv:y.docv}:y,S.serialize=y=>y.op===0?{op:y.op,item:E.serialize(y.item)}:y.op===1?{op:y.op,item:n.serialize(y.item)}:y})($||(e.TestsDiffOp=$={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(y){const a=this.o();for(const r of y)switch(r.op){case 0:this.j(E.deserialize(r.item),a);break;case 1:this.k(n.deserialize(r.item),a);break;case 3:this.l(r.itemId,a);break;case 5:this.m(r.itemId);break;case 4:this.updatePendingRoots(r.amount);break;case 6:this.c.set(r.tag.id,r.tag);break;case 7:this.c.delete(r.id);break}a.complete?.()}j(y,a){const r=h.$XH.parentId(y.item.extId)?.toString();let P;if(!r)P=this.p(y),this.f.add(P),this.d.set(y.item.extId,P);else if(this.d.has(r)){const N=this.d.get(r);N.children.add(y.item.extId),P=this.p(y,N),this.d.set(y.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(y)}`);return}return a.add?.(P),y.expand===2&&this.g++,P}k(y,a){const r=this.d.get(y.extId);if(r)return y.expand!==void 0&&(r.expand===2&&this.g--,y.expand===2&&this.g++),(0,e.$4H)(r,y),a.update?.(r),r}l(y,a){const r=this.d.get(y);if(!r)return;const P=h.$XH.parentId(r.item.extId)?.toString();P?this.d.get(P).children.delete(r.item.extId):this.f.delete(r);const N=[[y]];for(;N.length;)for(const U of N.pop()){const q=this.d.get(U);q&&(N.push(q.children),this.d.delete(U),a.remove?.(q,q!==r),q.expand===2&&this.g--)}}m(y){}updatePendingRoots(y){this.h+=y}o(){return{}}}e.$5H=l}),define(De[104],Ce([1,0,17,3,4,53,81,60]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TestItemEventOp=void 0;var k;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const g=(u,v)=>u===v,I=Object.entries({range:(u,v)=>u===v?!0:!u||!v?!1:u.equalsRange(v),busy:g,label:g,description:g,error:g,sortText:g,tags:(u,v)=>!(u.length!==v.length||u.some(f=>!v.includes(f)))}),w=(u,v)=>{let f;for(const[E,n]of I)n(u[E],v[E])||(f?f[E]=v[E]:f={[E]:v[E]});return f};class D extends h.$kb{get root(){return this.m.root}constructor(v){super(),this.m=v,this.f=this.B(new b.$Cg(()=>this.flushDiff(),200)),this.g=this.B(new A.$5c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(v){this.h=v;for(const f of this.tree.values())this.G(f)}get resolveHandler(){return this.h}collectDiff(){const v=this.k;return this.k=[],v}pushDiff(v){switch(v.op){case 2:{for(const f of this.k)if(f.op===2&&f.uri===v.uri){f.docv=v.docv;return}break}case 1:{const f=this.k[this.k.length-1];if(f){if(f.op===1&&f.item.extId===v.item.extId){(0,R.$4H)(f.item,v.item);return}if(f.op===0&&f.item.item.extId===v.item.extId){(0,R.$4H)(f.item,v.item);return}}break}}this.k.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,f){const E=this.tree.get(v);if(E){if((E.expandLevels===void 0||f>E.expandLevels)&&(E.expandLevels=f),E.expand===1){const n=this.I(E);return n.isOpen()?this.H(E,f-1):n.wait().then(()=>this.H(E,f-1))}else if(E.expand===3)return E.resolveBarrier?.isOpen()===!1?E.resolveBarrier.wait().then(()=>this.H(E,f-1)):this.H(E,f-1)}}dispose(){for(const v of this.tree.values())this.m.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(v,f){switch(f.op){case 3:this.L(m.$XH.joinToString(v.fullId,f.id));break;case 0:this.u(f.item,v);break;case 5:for(const E of f.ops)this.p(v,E);break;case 1:this.w(f.new,f.old,v.fullId.toString());break;case 2:this.G(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:f.update}});break;case 6:this.s(v.actual.uri);break;default:(0,F.$lc)(f)}}s(v){v&&this.pushDiff({op:2,uri:v,docv:this.m.getDocumentVersion(v)})}u(v,f){const E=m.$XH.fromExtHostTestItem(v,this.root.id,f?.actual),n=this.m.getApiFor(v);n.parent&&n.parent!==f?.actual&&this.m.getChildren(n.parent).delete(v.id);let o=this.tree.get(E.toString());if(!o){o={fullId:E,actual:v,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},v.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(v,f),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(v)}}),this.F(v,o,f);return}if(o.actual===v){this.D(v,o,f);return}if(o.actual.uri?.toString()!==v.uri?.toString())return this.L(E.toString()),this.u(v,f);const s=this.m.getChildren(o.actual),t=o.actual,d=w(this.m.toITestItem(t),this.m.toITestItem(v));this.m.getApiFor(t).listener=void 0,o.actual=v,o.expand=0,d&&(d.hasOwnProperty("tags")&&(this.w(v.tags,t.tags,E.toString()),delete d.tags),this.p(o,{op:4,update:d})),this.F(v,o,f);for(const[$,l]of s)this.m.getChildren(v).get(l.id)||this.L(m.$XH.joinToString(E,l.id));this.s(o.actual.uri)}w(v,f,E){const n=new Set(f.map(o=>o.id));for(const o of v)n.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:E,item:{tags:v.map(o=>(0,R.$2H)(this.m.controllerId,o.id))}}}),n.forEach(this.z,this)}y(v){const f=this.j.get(v.id);f?f.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$2H)(this.m.controllerId,v.id)}}))}z(v){const f=this.j.get(v);f&&!--f.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,R.$2H)(this.m.controllerId,v)}))}C(v,f){this.m.getApiFor(v).parent=f&&f.actual!==this.root?f.actual:void 0}D(v,f,E){this.C(v,E);const n=this.m.getApiFor(v);n.parent=E?.actual,n.listener=o=>this.p(f,o),this.G(f)}F(v,f,E){this.D(v,f,E);for(const[n,o]of this.m.getChildren(v))this.u(o,f)}G(v){let f;this.h?v.resolveBarrier?f=v.resolveBarrier.isOpen()?3:2:f=v.actual.canResolveChildren?1:0:f=0,f!==v.expand&&(v.expand=f,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:f}}),f===1&&v.expandLevels!==void 0&&this.I(v))}H(v,f){if(f<0)return;const E=[];for(const[n,o]of this.m.getChildren(v.actual)){const s=this.expand(m.$XH.joinToString(v.fullId,o.id),f);(0,b.$eg)(s)&&E.push(s)}if(E.length)return Promise.all(E).then(()=>{})}I(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const o=new b.$qg;return o.open(),o}v.expand=2,this.J(v);const f=v.resolveBarrier=new b.$qg,E=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let n;try{n=this.h(v.actual===this.root?void 0:v.actual)}catch(o){E(o)}return(0,b.$eg)(n)?n.catch(E).then(()=>{f.open(),this.G(v)}):(f.open(),this.G(v)),v.resolveBarrier}J(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}L(v){const f=this.tree.get(v);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const E=[f];for(;E.length;){const n=E.pop();if(n){this.m.getApiFor(n.actual).listener=void 0;for(const o of n.actual.tags)this.z(o.id);this.tree.delete(n.fullId.toString());for(const[o,s]of this.m.getChildren(n.actual))E.push(this.tree.get(m.$XH.joinToString(n.fullId,s.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$4K=D;class C extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$5K=C;class p extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6K=p;class i extends Error{constructor(v,f,E){super(`TestItem with ID "${v}" is from controller "${f}" and cannot be added as a child of an item from controller "${E}".`)}}e.$7K=i;const c=(u,v,f)=>{let E=new Map;return{get size(){return E.size},forEach(n,o){for(const s of E.values())n.call(o,s,this)},[Symbol.iterator](){return E.entries()},replace(n){const o=new Map,s=new Set(E.keys()),t={op:5,ops:[]};for(const d of n){if(!(d instanceof f))throw new p(d.id);const $=v(d).controllerId;if($!==u.controllerId)throw new i(d.id,$,u.controllerId);if(o.has(d.id))throw new C(d.id);o.set(d.id,d),s.delete(d.id),t.ops.push({op:0,item:d})}for(const d of s.keys())t.ops.push({op:3,id:d});u.listener?.(t),E=o},add(n){if(!(n instanceof f))throw new p(n.id);E.set(n.id,n),u.listener?.({op:0,item:n})},delete(n){E.delete(n)&&u.listener?.({op:3,id:n})},get(n){return E.get(n)},toJSON(){return Array.from(E.values())}}};e.$8K=c}),define(De[137],Ce([1,0,104]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.$9K=void 0;const A=new WeakMap,h=(R,m)=>{const k={controllerId:m};return A.set(R,k),k};e.$9K=h;const F=R=>{const m=A.get(R);if(!m)throw new b.$6K(R?.id||"<unknown>");return m};e.$0K=F}),define(De[105],Ce([1,0,16,2]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lb=e.$Zlb=e.$Ylb=e.$Xlb=e.$Wlb=void 0,e.$Wlb="vscode-cdn.net",e.$Xlb=`vscode-resource.${e.$Wlb}`,e.$Ylb=`'self' https://*.${e.$Wlb}`;function h(m,k){return m.scheme===b.Schemas.http||m.scheme===b.Schemas.https?m:(k&&k.authority&&k.isRemote&&m.scheme===b.Schemas.file&&(m=A.URI.from({scheme:b.Schemas.vscodeRemote,authority:k.authority,path:m.path})),A.URI.from({scheme:b.Schemas.https,authority:`${m.scheme}+${F(m.authority)}.${e.$Xlb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Zlb=h;function F(m){return m.replace(/./g,k=>{const g=k.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?k:"-"+g.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(k,g)=>String.fromCharCode(parseInt(g,16)))}e.$1lb=R}),define(De[255],Ce([1,0,3,4,105]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6$b=void 0;class F{constructor(m,k,g){this.d=m,this.e=k,this.f=g,this.a=0,this.b=new A.$jb,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const L=k.getVisibleTextEditors();for(const I of this.c.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,k,g,L,I){let w;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===m){w=v;break}if(!w)throw new Error("not a visible editor");const D=this,C=this.a++,p=new b.$5c,i=new b.$5c,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,h.$Zlb)(v,D.f)}get cspSource(){return h.$Ylb}set options(v){this.b=v,D.d.$setOptions(C,v)}get options(){return this.b}set html(v){this.a=v,D.d.$setHtml(C,v)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(v){return D.d.$postMessage(C,v)}},u=new class{constructor(){this.editor=m,this.line=k,this.height=g,this.webview=c,this.onDidDispose=i.event}dispose(){D.c.has(C)&&(D.c.delete(C),D.d.$disposeEditorInset(C),i.fire(),i.dispose(),p.dispose())}};return this.d.$createEditorInset(C,w.id,w.value.document.uri,k+1,g,L||{},I.identifier,I.extensionLocation),this.c.set(C,{editor:m,inset:u,onDidReceiveMessage:p}),u}$onDidDispose(m){const k=this.c.get(m);k&&k.inset.dispose()}$onDidReceiveMessage(m,k){this.c.get(m)?.onDidReceiveMessage.fire(k)}}e.$6$b=F}),define(De[256],Ce([1,0,5]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.VariableKind=e.$EL=void 0,e.$EL=(0,b.$lh)("configurationResolverService");var A;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(A||(e.VariableKind=A={}));class h extends Error{constructor(R,m){super(m),this.variable=R}}e.$FL=h}),define(De[257],Ce([1,0,10,39,12,24,9,118,208,256,11]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0;class I{constructor(D,C,p,i){this.h=new Map,this.a=D,this.b=C,this.g=p,i&&(this.c=i.then(c=>this.i(c)))}i(D){if(R.$d){const C=Object.create(null);return Object.keys(D).forEach(p=>{C[p.toLowerCase()]=D[p]}),C}return D}resolveWithEnvironment(D,C,p){return this.l({env:this.i(D),userHome:void 0},C?C.uri:void 0,p)}async resolveAsync(D,C){const p={env:await this.c,userHome:await this.g};return this.l(p,D?D.uri:void 0,C)}async j(D,C,p,i){const c=F.$Em(C);R.$d&&c.windows?Object.keys(c.windows).forEach(v=>c[v]=c.windows[v]):R.$e&&c.osx?Object.keys(c.osx).forEach(v=>c[v]=c.osx[v]):R.$f&&c.linux&&Object.keys(c.linux).forEach(v=>c[v]=c.linux[v]),delete c.windows,delete c.osx,delete c.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,D?D.uri:void 0,c,p,i)}async resolveAnyAsync(D,C,p){return this.j(D,C,p)}async resolveAnyMap(D,C,p){const i=new Map;return{newConfig:await this.j(D,C,p,i),resolvedVariables:i}}resolveWithInteractionReplace(D,C,p,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,C,p,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,C){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,C)}async l(D,C,p,i,c){if(h.$ge(p))return this.m(D,C,p,i,c);if(Array.isArray(p))return Promise.all(p.map(u=>this.l(D,C,u,i,c)));if(h.$ie(p)){const u=Object.create(null),v=await Promise.all(Object.keys(p).map(async f=>[await this.m(D,C,f,i,c),await this.l(D,C,p[f],i,c)]));for(const[f,E]of v)u[f]=E;return u}return p}m(D,C,p,i,c){return(0,L.$Bd)(p,I.VARIABLE_REGEXP,async(u,v)=>{if(v.includes(I.VARIABLE_LHS))return u;let f=await this.o(D,u,v,C,i);return c?.set(v,f),f!==u&&h.$ge(f)&&f.match(I.VARIABLE_REGEXP)&&(f=await this.m(D,C,f,i,c)),f})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,C,p,i,c){let u;const v=p.split(":");v.length>1&&(p=v[0],u=v[1]);const f=o=>{const s=this.a.getFilePath();if(s)return(0,m.$Pz)(s);throw new g.$FL(o,(0,k.localize)(0,null,C))},E=o=>{const s=f(o);if(this.a.getWorkspaceFolderPathForFile){const t=this.a.getWorkspaceFolderPathForFile();if(t)return(0,m.$Pz)(t)}throw new g.$FL(o,(0,k.localize)(1,null,C,b.$cc(s)))},n=o=>{if(u){const s=this.a.getFolderUri(u);if(s)return s;throw new g.$FL(o,(0,k.localize)(2,null,C,u))}if(i)return i;throw this.a.getWorkspaceFolderCount()>1?new g.$FL(o,(0,k.localize)(3,null,C)):new g.$FL(o,(0,k.localize)(4,null,C))};switch(p){case"env":if(u){if(D.env){const o=D.env[R.$d?u.toLowerCase():u];if(h.$ge(o))return o}return""}throw new g.$FL(g.VariableKind.Env,(0,k.localize)(5,null,C));case"config":if(u){const o=this.a.getConfigurationValue(i,u);if(h.$pe(o))throw new g.$FL(g.VariableKind.Config,(0,k.localize)(6,null,C,u));if(h.$ie(o))throw new g.$FL(g.VariableKind.Config,(0,k.localize)(7,null,C,u));return o}throw new g.$FL(g.VariableKind.Config,(0,k.localize)(8,null,C));case"command":return this.p(g.VariableKind.Command,C,u,c,"command");case"input":return this.p(g.VariableKind.Input,C,u,c,"input");case"extensionInstallFolder":if(u){const o=await this.a.getExtension(u);if(!o)throw new g.$FL(g.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,C,u));return this.n(o.extensionLocation)}throw new g.$FL(g.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,C));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,m.$Pz)(this.n(n(g.VariableKind.WorkspaceFolder)));case"cwd":return i||u?(0,m.$Pz)(this.n(n(g.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Pz)(b.$cc(this.n(n(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new g.$FL(g.VariableKind.UserHome,(0,k.localize)(11,null,C))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new g.$FL(g.VariableKind.LineNumber,(0,k.localize)(12,null,C))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new g.$FL(g.VariableKind.SelectedText,(0,k.localize)(13,null,C))}case"file":return f(g.VariableKind.File);case"fileWorkspaceFolder":return E(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return i||u?b.$ac(this.n(n(g.VariableKind.RelativeFile)),f(g.VariableKind.RelativeFile)):f(g.VariableKind.RelativeFile);case"relativeFileDirname":{const o=b.$bc(f(g.VariableKind.RelativeFileDirname));if(i||u){const s=b.$ac(this.n(n(g.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return b.$bc(f(g.VariableKind.FileDirname));case"fileExtname":return b.$dc(f(g.VariableKind.FileExtname));case"fileBasename":return b.$cc(f(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=b.$cc(f(g.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-b.$dc(o).length)}case"fileDirnameBasename":return b.$cc(b.$bc(f(g.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||C}case"execInstallFolder":{const o=this.a.getAppRoot();return o||C}case"pathSeparator":return b.sep;default:try{const o=u?`${p}:${u}`:p;return this.p(g.VariableKind.Unknown,C,o,c,void 0)}catch{return C}}}}p(D,C,p,i,c){if(p&&i){const u=c===void 0?i[p]:i[c+":"+p];if(typeof u=="string")return u;throw new g.$FL(D,(0,k.localize)(14,null,C))}return C}}e.$dM=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[138],Ce([1,0,5,134]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,b.$lh)("editorGroupsService");var h;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var F;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var k;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function g(C){const p=C;return(0,A.$fE)(p?.editor)&&(0,A.$fE)(p?.replacement)}e.$sC=g;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(C){const p=C;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$tC=w;function D(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=D}),define(De[258],Ce([1,0,5,138]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,b.$lh)("editorService"),e.$wC=-1,e.$xC=-2;function h(F){const R=F;return typeof F=="number"||(0,A.$tC)(R)}e.$yC=h}),define(De[13],Ce([1,0,19,22,157,67,94,28,152,73,91,24,12,2,36,76,127,137,134,103,60,81,258,7]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aL=e.$_K=e.MarkdownString=e.$$K=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Fe){function Le(ae){const{selectionStartLineNumber:Ne,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:Je}=ae,it=new o.$cJ(Ne-1,Be-1),kt=new o.$cJ(Qe-1,Je-1);return new o.$eJ(it,kt)}Fe.to=Le;function Ae(ae){const{anchor:Ne,active:Be}=ae;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Fe.from=Ae})(s||(e.Selection=s={}));var t;(function(Fe){function Le(ae){if(!ae)return;const{start:Ne,end:Be}=ae;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Fe.from=Le;function Ae(ae){if(!ae)return;const{startLineNumber:Ne,startColumn:Be,endLineNumber:Qe,endColumn:Je}=ae;return new o.$dJ(Ne-1,Be-1,Qe-1,Je-1)}Fe.to=Ae})(t||(e.Range=t={}));var d;(function(Fe){function Le(Ae){switch(Ae){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Fe.to=Le})(d||(e.TokenType=d={}));var $;(function(Fe){function Le(ae){return new o.$cJ(ae.lineNumber-1,ae.column-1)}Fe.to=Le;function Ae(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Fe.from=Ae})($||(e.Position=$={}));var l;(function(Fe){function Le(Ne,Be,Qe){return(0,b.$jf)((0,b.$Gf)(Ne).map(Je=>Ae(Je,Be,Qe)))}Fe.from=Le;function Ae(Ne,Be,Qe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:Qe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ae(Ne.scheme,Be),pattern:Me.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:Qe?.isBuiltin}}function ae(Ne,Be){return Be&&typeof Ne=="string"?Be.transformOutgoingScheme(Ne):Ne}})(l||(e.DocumentSelector=l={}));var S;(function(Fe){function Le(ae){switch(ae){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Fe.from=Le;function Ae(ae){switch(ae){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Fe.to=Ae})(S||(e.DiagnosticTag=S={}));var y;(function(Fe){function Le(ae){let Ne;return ae.code&&((0,w.$ge)(ae.code)||(0,w.$ke)(ae.code)?Ne=String(ae.code):Ne={value:String(ae.code.value),target:ae.code.target}),{...t.from(ae.range),message:ae.message,source:ae.source,code:Ne,severity:r.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(a.from),tags:Array.isArray(ae.tags)?(0,b.$jf)(ae.tags.map(S.from)):void 0}}Fe.from=Le;function Ae(ae){const Ne=new o.$pJ(t.to(ae),ae.message,r.to(ae.severity));return Ne.source=ae.source,Ne.code=(0,w.$ge)(ae.code)?ae.code:ae.code?.value,Ne.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(a.to),Ne.tags=ae.tags&&(0,b.$jf)(ae.tags.map(S.to)),Ne}Fe.to=Ae})(y||(e.Diagnostic=y={}));var a;(function(Fe){function Le(ae){return{...t.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Fe.from=Le;function Ae(ae){return new o.$oJ(new o.$nJ(ae.resource,t.to(ae)),ae.message)}Fe.to=Ae})(a||(e.DiagnosticRelatedInformation=a={}));var r;(function(Fe){function Le(ae){switch(ae){case o.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Fe.from=Le;function Ae(ae){switch(ae){case i.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Fe.to=Ae})(r||(e.DiagnosticSeverity=r={}));var P;(function(Fe){function Le(ae){return typeof ae=="number"&&ae>=o.ViewColumn.One?ae-1:ae===o.ViewColumn.Beside?n.$xC:n.$wC}Fe.from=Le;function Ae(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Ae})(P||(e.ViewColumn=P={}));function N(Fe){return typeof Fe.range<"u"}function U(Fe){return Fe.length===0?!0:!!N(Fe[0])}e.$$K=U;var q;(function(Fe){function Le(Je){return Je.map(Fe.from)}Fe.fromMany=Le;function Ae(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ae(Je){let it;if(Ae(Je)){const{language:bt,value:pt}=Je;it={value:"```"+bt+`
`+pt+"\n```\n"}}else o.$CJ.isMarkdownString(Je)?it={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?it={value:Je}:it={value:""};const kt=Object.create(null);it.uris=kt;const It=bt=>{try{let pt=D.URI.parse(bt,!0);pt=pt.with({query:Ne(pt.query,kt)}),kt[bt]=pt}catch{}return""},At=new k.marked.Renderer;return At.link=It,At.image=bt=>typeof bt=="string"?It(R.$Nj(bt).href):"",(0,k.marked)(it.value,{renderer:At}),it}Fe.from=ae;function Ne(Je,it){if(!Je)return Je;let kt;try{kt=(0,g.$Tg)(Je)}catch{}if(!kt)return Je;let It=!1;return kt=(0,I.$Gm)(kt,At=>{if(D.URI.isUri(At)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[bt]=At,It=!0,bt}else return}),It?JSON.stringify(kt):Je}function Be(Je){const it=new o.$CJ(Je.value,Je.supportThemeIcons);return it.isTrusted=Je.isTrusted,it.supportHtml=Je.supportHtml,it.baseUri=Je.baseUri?D.URI.from(Je.baseUri):void 0,it}Fe.to=Be;function Qe(Je){if(Je)return typeof Je=="string"?Je:Fe.from(Je)}Fe.fromStrict=Qe})(q||(e.MarkdownString=q={}));function B(Fe){return U(Fe)?Fe.map(Le=>({range:t.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?q.fromMany(Le.hoverMessage):Le.hoverMessage?q.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Fe.map(Le=>({range:t.from(Le)}))}e.$_K=B;function O(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?D.URI.file(Fe):Fe}e.$aL=O;var K;(function(Fe){function Le(Ae){return typeof Ae>"u"?Ae:{contentText:Ae.contentText,contentIconPath:Ae.contentIconPath?O(Ae.contentIconPath):void 0,border:Ae.border,borderColor:Ae.borderColor,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,color:Ae.color,backgroundColor:Ae.backgroundColor,margin:Ae.margin,width:Ae.width,height:Ae.height}}Fe.from=Le})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var z;(function(Fe){function Le(Ae){return typeof Ae>"u"?Ae:{backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?O(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?K.from(Ae.before):void 0,after:Ae.after?K.from(Ae.after):void 0}}Fe.from=Le})(z||(e.ThemableDecorationRenderOptions=z={}));var j;(function(Fe){function Le(Ae){if(typeof Ae>"u")return Ae;switch(Ae){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Le})(j||(e.DecorationRangeBehavior=j={}));var he;(function(Fe){function Le(Ae){return{isWholeLine:Ae.isWholeLine,rangeBehavior:Ae.rangeBehavior?j.from(Ae.rangeBehavior):void 0,overviewRulerLane:Ae.overviewRulerLane,light:Ae.light?z.from(Ae.light):void 0,dark:Ae.dark?z.from(Ae.dark):void 0,backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?O(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?K.from(Ae.before):void 0,after:Ae.after?K.from(Ae.after):void 0}}Fe.from=Le})(he||(e.DecorationRenderOptions=he={}));var ie;(function(Fe){function Le(ae){return{text:ae.newText,eol:ae.newEol&&st.from(ae.newEol),range:t.from(ae.range)}}Fe.from=Le;function Ae(ae){const Ne=new o.$iJ(t.to(ae.range),ae.text);return Ne.newEol=typeof ae.eol>"u"?void 0:st.to(ae.eol),Ne}Fe.to=Ae})(ie||(e.TextEdit=ie={}));var ne;(function(Fe){function Le(ae,Ne){const Be={edits:[]};if(ae instanceof o.$lJ){const Qe=new m.$ki;for(const Je of ae._allEntries())Je._type===1&&D.URI.isUri(Je.to)&&Je.from===void 0&&Qe.add(Je.to);for(const Je of ae._allEntries())if(Je._type===1){let it;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?it={type:"base64",value:(0,A.$2b)(A.$Ib.wrap(Je.options.contents))}:it={type:"dataTransferItem",id:Je.options.contents._itemId}),Be.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:it},metadata:Je.metadata})}else Je._type===2?Be.edits.push({resource:Je.uri,textEdit:ie.from(Je.edit),versionId:Qe.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Be.edits.push({resource:Je.uri,textEdit:{range:t.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Qe.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Be.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Be.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(et.from)}})}return Be}Fe.from=Le;function Ae(ae){const Ne=new o.$lJ,Be=new m.$ji;for(const Qe of ae.edits)if(Qe.textEdit){const Je=Qe,it=D.URI.revive(Je.resource),kt=t.to(Je.textEdit.range),It=Je.textEdit.text,At=Je.textEdit.insertAsSnippet;let bt;At?bt=o.$kJ.replace(kt,new o.$mJ(It)):bt=o.$iJ.replace(kt,It);const pt=Be.get(it);pt?pt.push(bt):Be.set(it,[bt])}else Ne.renameFile(D.URI.revive(Qe.oldResource),D.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Je]of Be)Ne.set(Qe,Je);return Ne}Fe.to=Ae})(ne||(e.WorkspaceEdit=ne={}));var V;(function(Fe){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function Ae(Ne){return typeof Le[Ne]=="number"?Le[Ne]:6}Fe.from=Ae;function ae(Ne){for(const Be in Le)if(Le[Be]===Ne)return Number(Be);return o.SymbolKind.Property}Fe.to=ae})(V||(e.SymbolKind=V={}));var H;(function(Fe){function Le(ae){switch(ae){case o.SymbolTag.Deprecated:return 1}}Fe.from=Le;function Ae(ae){switch(ae){case 1:return o.SymbolTag.Deprecated}}Fe.to=Ae})(H||(e.SymbolTag=H={}));var ce;(function(Fe){function Le(ae){return{name:ae.name,kind:V.from(ae.kind),tags:ae.tags&&ae.tags.map(H.from),containerName:ae.containerName,location:Y.from(ae.location)}}Fe.from=Le;function Ae(ae){const Ne=new o.$sJ(ae.name,V.to(ae.kind),ae.containerName,Y.to(ae.location));return Ne.tags=ae.tags&&ae.tags.map(H.to),Ne}Fe.to=Ae})(ce||(e.WorkspaceSymbol=ce={}));var pe;(function(Fe){function Le(ae){const Ne={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),kind:V.from(ae.kind),tags:ae.tags?.map(H.from)??[]};return ae.children&&(Ne.children=ae.children.map(Le)),Ne}Fe.from=Le;function Ae(ae){const Ne=new o.$tJ(ae.name,ae.detail,V.to(ae.kind),t.to(ae.range),t.to(ae.selectionRange));return(0,b.$nf)(ae.tags)&&(Ne.tags=ae.tags.map(H.to)),ae.children&&(Ne.children=ae.children.map(Ae)),Ne}Fe.to=Ae})(pe||(e.DocumentSymbol=pe={}));var ye;(function(Fe){function Le(ae){const Ne=new o.$yJ(V.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Ne._sessionId=ae._sessionId,Ne._itemId=ae._itemId,Ne}Fe.to=Le;function Ae(ae,Ne,Be){if(Ne=Ne??ae._sessionId,Be=Be??ae._itemId,Ne===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Be,name:ae.name,detail:ae.detail,kind:V.from(ae.kind),uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(H.from)}}Fe.from=Ae})(ye||(e.CallHierarchyItem=ye={}));var ge;(function(Fe){function Le(Ae){return new o.$zJ(ye.to(Ae.from),Ae.fromRanges.map(ae=>t.to(ae)))}Fe.to=Le})(ge||(e.CallHierarchyIncomingCall=ge={}));var M;(function(Fe){function Le(Ae){return new o.$AJ(ye.to(Ae.to),Ae.fromRanges.map(ae=>t.to(ae)))}Fe.to=Le})(M||(e.CallHierarchyOutgoingCall=M={}));var Y;(function(Fe){function Le(ae){return{range:ae.range&&t.from(ae.range),uri:ae.uri}}Fe.from=Le;function Ae(ae){return new o.$nJ(D.URI.revive(ae.uri),t.to(ae.range))}Fe.to=Ae})(Y||(e.location=Y={}));var ve;(function(Fe){function Le(ae){const Ne=ae,Be=ae;return{originSelectionRange:Ne.originSelectionRange?t.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Be.uri,range:t.from(Ne.targetRange?Ne.targetRange:Be.range),targetSelectionRange:Ne.targetSelectionRange?t.from(Ne.targetSelectionRange):void 0}}Fe.from=Le;function Ae(ae){return{targetUri:D.URI.revive(ae.uri),targetRange:t.to(ae.range),targetSelectionRange:ae.targetSelectionRange?t.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?t.to(ae.originSelectionRange):void 0}}Fe.to=Ae})(ve||(e.DefinitionLink=ve={}));var Se;(function(Fe){function Le(ae){return{range:t.from(ae.range),contents:q.fromMany(ae.contents)}}Fe.from=Le;function Ae(ae){return new o.$qJ(ae.contents.map(q.to),t.to(ae.range))}Fe.to=Ae})(Se||(e.Hover=Se={}));var ee;(function(Fe){function Le(ae){return{range:t.from(ae.range),expression:ae.expression}}Fe.from=Le;function Ae(ae){return new o.$kK(t.to(ae.range),ae.expression)}Fe.to=Ae})(ee||(e.EvaluatableExpression=ee={}));var te;(function(Fe){function Le(ae){if(ae instanceof o.$lK)return{type:"text",range:t.from(ae.range),text:ae.text};if(ae instanceof o.$mK)return{type:"variable",range:t.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof o.$nK)return{type:"expression",range:t.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Le;function Ae(ae){switch(ae.type){case"text":return{range:t.to(ae.range),text:ae.text};case"variable":return{range:t.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:t.to(ae.range),expression:ae.expression}}}Fe.to=Ae})(te||(e.InlineValue=te={}));var le;(function(Fe){function Le(ae){return{frameId:ae.frameId,stoppedLocation:t.from(ae.stoppedLocation)}}Fe.from=Le;function Ae(ae){return new o.$oK(ae.frameId,t.to(ae.stoppedLocation))}Fe.to=Ae})(le||(e.InlineValueContext=le={}));var X;(function(Fe){function Le(ae){return{range:t.from(ae.range),kind:ae.kind}}Fe.from=Le;function Ae(ae){return new o.$rJ(t.to(ae.range),ae.kind)}Fe.to=Ae})(X||(e.DocumentHighlight=X={}));var ue;(function(Fe){function Le(Ae){switch(Ae){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Fe.to=Le})(ue||(e.CompletionTriggerKind=ue={}));var se;(function(Fe){function Le(Ae){return{triggerKind:ue.to(Ae.triggerKind),triggerCharacter:Ae.triggerCharacter}}Fe.to=Le})(se||(e.CompletionContext=se={}));var oe;(function(Fe){function Le(ae){switch(ae){case o.CompletionItemTag.Deprecated:return 1}}Fe.from=Le;function Ae(ae){switch(ae){case 1:return o.CompletionItemTag.Deprecated}}Fe.to=Ae})(oe||(e.CompletionItemTag=oe={}));var T;(function(Fe){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Ae(Be){return Le.get(Be)??9}Fe.from=Ae;const ae=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ne(Be){return ae.get(Be)??o.CompletionItemKind.Property}Fe.to=Ne})(T||(e.CompletionItemKind=T={}));var J;(function(Fe){function Le(Ae,ae){const Ne=new o.$IJ(Ae.label);return Ne.insertText=Ae.insertText,Ne.kind=T.to(Ae.kind),Ne.tags=Ae.tags?.map(oe.to),Ne.detail=Ae.detail,Ne.documentation=R.$Ij(Ae.documentation)?q.to(Ae.documentation):Ae.documentation,Ne.sortText=Ae.sortText,Ne.filterText=Ae.filterText,Ne.preselect=Ae.preselect,Ne.commitCharacters=Ae.commitCharacters,C.$Lr.isIRange(Ae.range)?Ne.range=t.to(Ae.range):typeof Ae.range=="object"&&(Ne.range={inserting:t.to(Ae.range.insert),replacing:t.to(Ae.range.replace)}),Ne.keepWhitespace=typeof Ae.insertTextRules>"u"?!1:!!(Ae.insertTextRules&1),typeof Ae.insertTextRules<"u"&&Ae.insertTextRules&4?Ne.insertText=new o.$mJ(Ae.insertText):(Ne.insertText=Ae.insertText,Ne.textEdit=Ne.range instanceof o.$dJ?new o.$iJ(Ne.range,Ne.insertText):void 0),Ae.additionalTextEdits&&Ae.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ae.additionalTextEdits.map(Be=>ie.to(Be))),Ne.command=ae&&Ae.command?ae.fromInternal(Ae.command):void 0,Ne}Fe.to=Le})(J||(e.CompletionItem=J={}));var Z;(function(Fe){function Le(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:q.fromStrict(ae.documentation)}}Fe.from=Le;function Ae(ae){return{label:ae.label,documentation:R.$Ij(ae.documentation)?q.to(ae.documentation):ae.documentation}}Fe.to=Ae})(Z||(e.ParameterInformation=Z={}));var x;(function(Fe){function Le(ae){return{label:ae.label,documentation:q.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(Z.from):[],activeParameter:ae.activeParameter}}Fe.from=Le;function Ae(ae){return{label:ae.label,documentation:R.$Ij(ae.documentation)?q.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(Z.to):[],activeParameter:ae.activeParameter}}Fe.to=Ae})(x||(e.SignatureInformation=x={}));var me;(function(Fe){function Le(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(x.from):[]}}Fe.from=Le;function Ae(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(x.to):[]}}Fe.to=Ae})(me||(e.SignatureHelp=me={}));var Ee;(function(Fe){function Le(Ae,ae){const Ne=new o.$HJ($.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(fe.to.bind(void 0,Ae)),ae.kind&&Ie.to(ae.kind));return Ne.textEdits=ae.textEdits&&ae.textEdits.map(ie.to),Ne.tooltip=R.$Ij(ae.tooltip)?q.to(ae.tooltip):ae.tooltip,Ne.paddingLeft=ae.paddingLeft,Ne.paddingRight=ae.paddingRight,Ne}Fe.to=Le})(Ee||(e.InlayHint=Ee={}));var fe;(function(Fe){function Le(Ae,ae){const Ne=new o.$GJ(ae.label);return Ne.tooltip=R.$Ij(ae.tooltip)?q.to(ae.tooltip):ae.tooltip,p.Command.is(ae.command)&&(Ne.command=Ae.fromInternal(ae.command)),ae.location&&(Ne.location=Y.to(ae.location)),Ne}Fe.to=Le})(fe||(e.InlayHintLabelPart=fe={}));var Ie;(function(Fe){function Le(ae){return ae}Fe.from=Le;function Ae(ae){return ae}Fe.to=Ae})(Ie||(e.InlayHintKind=Ie={}));var Pe;(function(Fe){function Le(ae){return{range:t.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Fe.from=Le;function Ae(ae){let Ne;if(ae.url)try{Ne=typeof ae.url=="string"?D.URI.parse(ae.url,!0):D.URI.revive(ae.url)}catch{}return new o.$NJ(t.to(ae.range),Ne)}Fe.to=Ae})(Pe||(e.DocumentLink=Pe={}));var qe;(function(Fe){function Le(ae){const Ne=new o.$QJ(ae.label);return ae.textEdit&&(Ne.textEdit=ie.to(ae.textEdit)),ae.additionalTextEdits&&(Ne.additionalTextEdits=ae.additionalTextEdits.map(Be=>ie.to(Be))),Ne}Fe.to=Le;function Ae(ae){return{label:ae.label,textEdit:ae.textEdit?ie.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Ne=>ie.from(Ne)):void 0}}Fe.from=Ae})(qe||(e.ColorPresentation=qe={}));var Ve;(function(Fe){function Le(ae){return new o.$OJ(ae[0],ae[1],ae[2],ae[3])}Fe.to=Le;function Ae(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Fe.from=Ae})(Ve||(e.Color=Ve={}));var tt;(function(Fe){function Le(ae){return{range:t.from(ae.range)}}Fe.from=Le;function Ae(ae){return new o.$xJ(t.to(ae.range))}Fe.to=Ae})(tt||(e.SelectionRange=tt={}));var Ge;(function(Fe){function Le(Ae){switch(Ae){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Fe.to=Le})(Ge||(e.TextDocumentSaveReason=Ge={}));var Ye;(function(Fe){function Le(ae){switch(ae){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Le;function Ae(ae){switch(ae){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Fe.to=Ae})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var st;(function(Fe){function Le(ae){if(ae===o.EndOfLine.CRLF)return 1;if(ae===o.EndOfLine.LF)return 0}Fe.from=Le;function Ae(ae){if(ae===1)return o.EndOfLine.CRLF;if(ae===0)return o.EndOfLine.LF}Fe.to=Ae})(st||(e.EndOfLine=st={}));var at;(function(Fe){function Le(Ae){if(typeof Ae=="object")return Ae.viewId;switch(Ae){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Le})(at||(e.ProgressLocation=at={}));var xe;(function(Fe){function Le(ae){const Ne={start:ae.start+1,end:ae.end+1};return ae.kind&&(Ne.kind=rt.from(ae.kind)),Ne}Fe.from=Le;function Ae(ae){const Ne={start:ae.start-1,end:ae.end-1};return ae.kind&&(Ne.kind=rt.to(ae.kind)),Ne}Fe.to=Ae})(xe||(e.FoldingRange=xe={}));var rt;(function(Fe){function Le(ae){if(ae)switch(ae){case o.FoldingRangeKind.Comment:return p.$os.Comment;case o.FoldingRangeKind.Imports:return p.$os.Imports;case o.FoldingRangeKind.Region:return p.$os.Region}}Fe.from=Le;function Ae(ae){if(ae)switch(ae.value){case p.$os.Comment.value:return o.FoldingRangeKind.Comment;case p.$os.Imports.value:return o.FoldingRangeKind.Imports;case p.$os.Region.value:return o.FoldingRangeKind.Region}}Fe.to=Ae})(rt||(e.FoldingRangeKind=rt={}));var de;(function(Fe){function Le(Ae){if(Ae)return{pinned:typeof Ae.preview=="boolean"?!Ae.preview:void 0,inactive:Ae.background,preserveFocus:Ae.preserveFocus,selection:typeof Ae.selection=="object"?t.from(Ae.selection):void 0,override:typeof Ae.override=="boolean"?u.$5D.id:void 0}}Fe.from=Le})(de||(e.TextEditorOpenOptions=de={}));var Me;(function(Fe){function Le(Be){return Be instanceof o.$$J?Be.toJSON():typeof Be=="string"?Be:Ae(Be)||ae(Be)?new o.$$J(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Fe.from=Le;function Ae(Be){const Qe=Be;return Qe?D.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function ae(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne(Be){return typeof Be=="string"?Be:new o.$$J(D.URI.revive(Be.baseUri),Be.pattern)}Fe.to=Ne})(Me||(e.GlobPattern=Me={}));var _;(function(Fe){function Le(Ae){if(Ae){if(Array.isArray(Ae))return Ae.map(Le);if(typeof Ae=="string")return Ae;{const ae=Ae;return{language:ae.language,scheme:ae.scheme,pattern:Me.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Fe.from=Le})(_||(e.LanguageSelector=_={}));var Q;(function(Fe){function Le(ae){return{start:ae.start,end:ae.end}}Fe.from=Le;function Ae(ae){return new o.$zK(ae.start,ae.end)}Fe.to=Ae})(Q||(e.NotebookRange=Q={}));var we;(function(Fe){function Le(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Fe.to=Le;function Ae(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Fe.from=Ae})(we||(e.NotebookCellExecutionSummary=we={}));var je;(function(Fe){function Le(Ae){if(Ae===v.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Ae===v.NotebookCellExecutionState.Pending)return;if(Ae===v.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ae}`)}Fe.to=Le})(je||(e.NotebookCellExecutionState=je={}));var Oe;(function(Fe){function Le(ae){switch(ae){case o.NotebookCellKind.Markup:return v.CellKind.Markup;case o.NotebookCellKind.Code:default:return v.CellKind.Code}}Fe.from=Le;function Ae(ae){switch(ae){case v.CellKind.Markup:return o.NotebookCellKind.Markup;case v.CellKind.Code:default:return o.NotebookCellKind.Code}}Fe.to=Ae})(Oe||(e.NotebookCellKind=Oe={}));var Xe;(function(Fe){function Le(ae){const Ne={metadata:ae.metadata??Object.create(null),cells:[]};for(const Be of ae.cells)o.$AK.validate(Be),Ne.cells.push(et.from(Be));return Ne}Fe.from=Le;function Ae(ae){const Ne=new o.$BK(ae.cells.map(et.to));return(0,w.$te)(ae.metadata)||(Ne.metadata=ae.metadata),Ne}Fe.to=Ae})(Xe||(e.NotebookData=Xe={}));var et;(function(Fe){function Le(ae){return{cellKind:Oe.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:we.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(ft.from):[]}}Fe.from=Le;function Ae(ae){return new o.$AK(Oe.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(ft.to):void 0,ae.metadata,ae.internalMetadata?we.to(ae.internalMetadata):void 0)}Fe.to=Ae})(et||(e.NotebookCellData=et={}));var nt;(function(Fe){function Le(ae){return{mime:ae.mime,valueBytes:A.$Ib.wrap(ae.data)}}Fe.from=Le;function Ae(ae){return new o.$CK(ae.valueBytes.buffer,ae.mime)}Fe.to=Ae})(nt||(e.NotebookCellOutputItem=nt={}));var ft;(function(Fe){function Le(ae){return{outputId:ae.id,items:ae.items.map(nt.from),metadata:ae.metadata}}Fe.from=Le;function Ae(ae){const Ne=ae.items.map(nt.to);return new o.$DK(Ne,ae.outputId,ae.metadata)}Fe.to=Ae})(ft||(e.NotebookCellOutput=ft={}));var vt;(function(Fe){function Le(Ne){return ae(Ne)?{include:(0,w.$ye)(Me.from(Ne.include)),exclude:(0,w.$ye)(Me.from(Ne.exclude))}:(0,w.$ye)(Me.from(Ne))}Fe.from=Le;function Ae(Ne){return ae(Ne)?{include:Me.to(Ne.include),exclude:Me.to(Ne.exclude)}:Me.to(Ne)}Fe.to=Ae;function ae(Ne){const Be=Ne;return Be?!(0,w.$pe)(Be.include)&&!(0,w.$pe)(Be.exclude):!1}})(vt||(e.NotebookExclusiveDocumentPattern=vt={}));var Nt;(function(Fe){function Le(Ae,ae,Ne){const Be=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{alignment:Ae.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(Be,Ne),text:Ae.text,tooltip:Ae.tooltip,accessibilityInformation:Ae.accessibilityInformation,priority:Ae.priority}}Fe.from=Le})(Nt||(e.NotebookStatusBarItem=Nt={}));var Tt;(function(Fe){function Le(Ae,ae,Ne){const Be=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{command:ae.toInternal(Be,Ne),label:Ae.label,description:Ae.description,detail:Ae.detail,documentation:Ae.documentation}}Fe.from=Le})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Et;(function(Fe){function Le(Ae){return{transientOutputs:Ae?.transientOutputs??!1,transientCellMetadata:Ae?.transientCellMetadata??{},transientDocumentMetadata:Ae?.transientDocumentMetadata??{},cellContentMetadata:Ae?.cellContentMetadata??{}}}Fe.from=Le})(Et||(e.NotebookDocumentContentOptions=Et={}));var Bt;(function(Fe){function Le(ae){return{uri:ae.uri,provides:ae.provides}}Fe.from=Le;function Ae(ae){return new o.$FK(D.URI.revive(ae.uri),ae.provides)}Fe.to=Ae})(Bt||(e.NotebookRendererScript=Bt={}));var Ot;(function(Fe){function Le(ae){return{message:q.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,location:ae.location&&{range:t.from(ae.location.range),uri:ae.location.uri}}}Fe.from=Le;function Ae(ae){const Ne=new o.$MK(typeof ae.message=="string"?ae.message:q.to(ae.message));return Ne.actualOutput=ae.actual,Ne.expectedOutput=ae.expected,Ne.location=ae.location?Y.to(ae.location):void 0,Ne}Fe.to=Ae})(Ot||(e.TestMessage=Ot={}));var jt;(function(Fe){Fe.namespace=E.$2H,Fe.denamespace=E.$3H})(jt||(e.TestTag=jt={}));var Vt;(function(Fe){function Le(ae){const Ne=(0,c.$0K)(ae).controllerId;return{extId:f.$XH.fromExtHostTestItem(ae,Ne).toString(),label:ae.label,uri:D.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(Be=>jt.namespace(Ne,Be.id)),range:C.$Lr.lift(t.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&q.fromStrict(ae.error)||null}}Fe.from=Le;function Ae(ae){return{parent:void 0,error:void 0,id:f.$XH.fromString(ae.extId).localId,label:ae.label,uri:D.URI.revive(ae.uri),tags:(ae.tags||[]).map(Ne=>{const{tagId:Be}=jt.denamespace(Ne);return new o.$NK(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Fe.toPlain=Ae})(Vt||(e.TestItem=Vt={})),function(Fe){function Le(ae){return{id:ae.id}}Fe.from=Le;function Ae(ae){return new o.$NK(ae.id)}Fe.to=Ae}(jt||(e.TestTag=jt={}));var Ht;(function(Fe){const Le=(ae,Ne)=>{const Be=[];for(const[Je,it]of Ne)f.$XH.compare(it.item.extId,Je)===2&&(Ne.delete(Je),Be.push(it));const Qe={...Vt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(it=>it.type===0).map(Ot.to)})),children:Be.map(Je=>Le(Je,Ne))};for(const Je of Qe.children)Je.parent=Qe;return Qe};function Ae(ae){const Ne=[],Be=new Map;for(const Qe of ae.items){Be.set(Qe.item.extId,Qe);const Je=f.$XH.root(Qe.item.extId);ae.request.targets.some(it=>it.controllerId===Je&&it.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:ae.completedAt,results:Ne.map(Qe=>Le(Qe,Be))}}Fe.to=Ae})(Ht||(e.TestResults=Ht={}));var ut;(function(Fe){function Le(Be){return{covered:Be.covered,total:Be.covered}}function Ae(Be){return"line"in Be?$.from(Be):t.from(Be)}function ae(Be){return"branches"in Be?{count:Be.executionCount,location:Ae(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ae(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:Ae(Be.location)}}Fe.fromDetailed=ae;function Ne(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(ae)}}Fe.fromFile=Ne})(ut||(e.TestCoverage=ut={}));var gt;(function(Fe){function Le(Ae){switch(Ae){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Fe.to=Le})(gt||(e.CodeActionTriggerKind=gt={}));var Wt;(function(Fe){function Le(ae){const Ne=new o.$TK(V.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Ne._sessionId=ae._sessionId,Ne._itemId=ae._itemId,Ne}Fe.to=Le;function Ae(ae,Ne,Be){if(Ne=Ne??ae._sessionId,Be=Be??ae._itemId,Ne===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Be,kind:V.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(H.from)}}Fe.from=Ae})(Wt||(e.TypeHierarchyItem=Wt={}));var Rt;(function(Fe){function Le(Ae){if(Ae)return{value:Ae.value,tooltip:Ae.tooltip}}Fe.from=Le})(Rt||(e.ViewBadge=Rt={}));var Ct;(function(Fe){function Le(Be,Qe,Je){const it=Qe.fileData;return it?new o.$4J(new o.$5J(it.name,D.URI.revive(it.uri),it.id,(0,F.$bb)(()=>Je(it.id)))):Be===L.$rr.uriList&&Qe.uriListData?new o.$3J(Ne(Qe.uriListData)):new o.$3J(Qe.asString)}Fe.to=Le;async function Ae(Be,Qe){const Je=await Qe.asString();if(Be===L.$rr.uriList)return{asString:Je,fileData:void 0,uriListData:ae(Je)};const it=Qe.asFile();return{asString:Je,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Fe.from=Ae;function ae(Be){return h.$_r.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return D.URI.parse(Qe)}catch{}return Qe})}function Ne(Be){return h.$_r.create(Be.map(Qe=>typeof Qe=="string"?Qe:D.URI.revive(Qe)))}})(Ct||(e.DataTransferItem=Ct={}));var lt;(function(Fe){function Le(ae,Ne){const Be=ae.items.map(([Qe,Je])=>[Qe,Ct.to(Qe,Je,Ne)]);return new o.$6J(Be)}Fe.toDataTransfer=Le;async function Ae(ae){const Ne={items:[]},Be=[];for(const[Qe,Je]of ae)Be.push((async()=>{Ne.items.push([Qe,await Ct.from(Qe,Je)])})());return await Promise.all(Be),Ne}Fe.from=Ae})(lt||(e.DataTransfer=lt={}));var Pt;(function(Fe){function Le(ae){return{message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Fe.to=Le;function Ae(ae){return{kind:"reply",message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Fe.from=Ae})(Pt||(e.ChatReplyFollowup=Pt={}));var Mt;(function(Fe){function Le(Ae){return typeof Ae=="string"?{title:Ae,message:Ae,kind:"reply"}:"commandId"in Ae?{kind:"command",title:Ae.title??"",commandId:Ae.commandId??"",args:Ae.args}:Pt.from(Ae)}Fe.from=Le})(Mt||(e.ChatFollowup=Mt={}))}),define(De[259],Ce([1,0,2,8,7,13,68]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;class m{constructor(g,L,I,w={timeout:1500,errors:3}){this.c=g,this.d=L,this.f=I,this.g=w,this.a=new R.$jc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(L,I,w)=>{const C={dispose:this.a.push([L,I,g])};return Array.isArray(w)&&w.push(C),C}}async $participateInSave(g,L){const I=b.URI.revive(g);let w=!1;const D=setTimeout(()=>w=!0,this.g.timeout),C=[];try{for(const p of[...this.a]){if(w)break;const i=this.d.getDocument(I),c=await this.h(p,{document:i,reason:F.TextDocumentSaveReason.to(L)});C.push(c)}}finally{clearTimeout(D)}return C}h([g,L,I],w){const D=this.b.get(g);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(I,g,L,w).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const p=this.b.get(g);this.b.set(g,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,L,I,w){const D=[],C=Date.now(),{document:p,reason:i}=w,{version:c}=p,u=Object.freeze({document:p,reason:i,waitUntil(v){if(Object.isFrozen(D))throw(0,A.$5)("waitUntil can not be called async");D.push(Promise.resolve(v))}});try{L.apply(I,[u])}catch(v){return Promise.reject(v)}return Object.freeze(D),new Promise((v,f)=>{const E=setTimeout(()=>f(new Error("timeout")),this.g.timeout);return Promise.all(D).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(E),v(n)}).catch(n=>{clearTimeout(E),f(n)})}).then(v=>{const f={edits:[]};for(const E of v)if(Array.isArray(E)&&E.every(n=>n instanceof h.$iJ))for(const{newText:n,newEol:o,range:s}of E)f.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:s&&F.Range.from(s),text:n,eol:o&&F.EndOfLine.from(o)}});if(f.edits.length!==0)return c===p.version?this.f.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.$e$b=m}),define(De[260],Ce([1,0,16,2,13,7,103]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=e.$r_b=void 0;class m{constructor(I,w,D,C){this.start=I,this.deletedCount=w,this.deletedItems=D,this.items=C}asApiEvent(){return{range:new F.$zK(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,D){this.notebook=I,this.h=w,this.j=D,this.handle=D.handle,this.uri=A.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(h.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(C){I.g=C},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(D)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,w,D){const C=D.map(h.NotebookCellOutputItem.to),p=this.a.find(i=>i.id===I);if(p&&(w||(p.items.length=0),p.items.push(...C),p.items.length>1&&p.items.every(i=>R.$hH(i.mime)))){const i=new Map,c=[];p.items.forEach(u=>{let v;i.has(u.mime)?v=i.get(u.mime):(v=[],i.set(u.mime,v),c.push(u.mime)),v.push(u.data)}),p.items.length=0,c.forEach(u=>{const v=R.$iH(i.get(u));p.items.push({mime:u,data:v.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$r_b=k;class g{constructor(I,w,D,C,p){this.k=I,this.l=w,this.m=D,this.uri=C,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===b.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(D){return D=I.n(D),I.b[D].apiCell},getCells(D){return(D?I.p(D):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,D){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:D});const C={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},p=[];for(const c of I.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,C.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,C.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),p.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),p.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const i=new Map;for(let c=0;c<p.length;c++){const u=p[c],v=i.get(u.cell);if(v===void 0){const f=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});i.set(u.cell,f-1)}else C.cellChanges[v]={...C.cellChanges[v],...u}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,D=I.end|0;return w<0&&(w=0),D>this.b.length&&(D=this.b.length),I.with({start:w,end:D})}p(I){I=this.o(I);const w=[];for(let D=I.start;D<I.end;D++)w.push(this.b[D]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,D){if(this.j)return;const C=[],p=[],i=[];if(I.reverse().forEach(c=>{const v=c[2].map(n=>{const o=new k(this,this.l,n);return w||p.push(k.asModelAddData(this.apiNotebook,n)),o}),f=new m(c[0],c[1],[],v),E=this.b.splice(c[0],c[1],...v);for(const n of E)i.push(n.uri),f.deletedItems.push(n.apiCell);C.push(f)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:i}),D)for(const c of C)D.push(c.asApiEvent())}s(I,w,D,C){const p=this.b.splice(I,w);this.b.splice(D,0,...p);const i=[new m(I,w,p.map(c=>c.apiCell),[]),new m(D,0,[],p)];for(const c of i)C.push(c.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,D,C){this.b[I].setOutputItems(w,D,C)}v(I,w){const D=this.b[I];D.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(D.uri,w)}w(I,w){const D=this.b[I];D.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$s_b=g,g.a=0}),define(De[261],Ce([1,0,3,2,13,7]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;class R{constructor(k,g,L,I={timeout:1500,errors:3}){this.b=k,this.c=g,this.d=L,this.f=I,this.a=new b.$7c}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(g,L,I)=>{const w=function(C){g.call(L,C)};return w.extension=k,this.a.event(w,void 0,I)}}async $participateInSave(k,g,L){const I=A.URI.revive(k),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const D=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:h.TextDocumentSaveReason.to(g)},L,async(p,i)=>{const c=Date.now(),u=await await Promise.resolve(p);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier),!L.isCancellationRequested&&u&&(u instanceof F.$lJ?D.push(u):this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(D.length===0)return!0;const C={edits:[]};for(const p of D){const{edits:i}=h.WorkspaceEdit.from(p);C.edits=C.edits.concat(i)}return this.d.$tryApplyWorkspaceEdit(C)}}e.$S_b=R}),define(De[139],Ce([1,0,8,13,7]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;class F{constructor(m,k,g,L,I,w){this.id=m,this.f=k,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=L,this.c=w}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(k){this.selections=[k]},get selections(){return m.a},set selections(k){if(!Array.isArray(k)||!k.every(h.$zK.isNotebookRange))throw(0,b.$4)("selections");m.a=k,m.g(k)},get visibleRanges(){return m.b},revealRange(k,g){m.f.$tryRevealRange(m.id,A.NotebookRange.from(k),g??h.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(A.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$t_b=F,F.apiEditorsToExtHost=new WeakMap}),define(De[262],Ce([1,0,8,3,18,13]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=void 0;let R=e.$L_b=class{constructor(k,g){this.c=k,this.d=g,this.a=new A.$5c({onListenerError:b.$Y}),this.b=new A.$5c({onListenerError:b.$Y}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,g);const L=this.d.getEditorById(k);g.visibleRanges&&L._acceptVisibleRanges(g.visibleRanges.ranges.map(F.NotebookRange.to)),g.selections&&L._acceptSelections(g.selections.selections.map(F.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const g in k)this.d.getEditorById(g)._acceptViewColumn(F.ViewColumn.to(k[g]))}};e.$L_b=R=He([We(0,h.$Ni)],R)}),define(De[263],Ce([1,0,13,129,193,21,66,8]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=void 0;class k{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,D,C){const p=this.b++,{title:i,location:c,cancellable:u}=D,v={label:(0,h.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(p,{location:b.ProgressLocation.from(c),title:i,source:v,cancellable:u},w.isUnderDevelopment?void 0:w.identifier.value).catch(m.$Y),this.d(p,C,!!u)}d(w,D,C){let p;C&&(p=new F.$bd,this.c.set(w,p));const i=u=>{this.a.$progressEnd(u),this.c.delete(u),p?.dispose()};let c;try{c=D(new L(this.a,w),C&&p?p.token:F.CancellationToken.None)}catch(u){throw i(w),u}return c.then(u=>i(w),u=>i(w)),c}$acceptProgressCanceled(w){const D=this.c.get(w);D&&(D.cancel(),this.c.delete(w))}}e.$P$b=k;function g(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class L extends A.$rz{constructor(w,D){super(C=>this.throttledReport(C)),this.c=w,this.d=D}throttledReport(w){this.c.$progressReport(this.d,w)}}He([(0,R.$Rg)(100,(I,w)=>g(I,w),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[140],Ce([1,0,36,137,60,104,81,13,2]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=e.$nL=void 0;const g=(v,f,E,n)=>{let o=f;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!E(o,s)){const t=o;o=s,v.listener?.(n(s,t))}}}},L=(v,f)=>v===f,I={range:(v,f)=>v===f?!0:!v||!f?!1:v.isEqual(f),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(v,f)=>!(v.length!==f.length||v.some(E=>!f.find(n=>E.id===n.id)))},w=v=>f=>({op:4,update:v(f)}),D=(v,f)=>({range:(()=>{let E;const n=w(o=>({range:b.$Lr.lift(m.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return E},set(o){v.listener?.({op:6}),I.range(E,o)||(E=o,v.listener?.(n(o)))}}})(),label:g(v,f,I.label,w(E=>({label:E}))),description:g(v,void 0,I.description,w(E=>({description:E}))),sortText:g(v,void 0,I.sortText,w(E=>({sortText:E}))),canResolveChildren:g(v,!1,I.canResolveChildren,E=>({op:2,state:E})),busy:g(v,!1,I.busy,w(E=>({busy:E}))),error:g(v,void 0,I.error,w(E=>({error:m.MarkdownString.fromStrict(E)||null}))),tags:g(v,[],I.tags,(E,n)=>({op:1,new:E.map(m.TestTag.from),old:n.map(m.TestTag.from)}))}),C=v=>{const f=h.$XH.fromString(v.extId),E=new i(f.controllerId,f.localId,v.label,k.URI.revive(v.uri)||void 0);return E.range=m.Range.to(v.range||void 0),E.description=v.description||void 0,E.sortText=v.sortText||void 0,E.tags=v.tags.map(n=>m.TestTag.to({id:(0,R.$3H)(n).tagId})),E},p=v=>{let f;for(const E of v.tests){const n=C(E.item);(0,A.$0K)(n).parent=f,f=n}return f};e.$nL=p;class i{constructor(f,E,n,o){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const s=(0,A.$9K)(this,f);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof c?void 0:s.parent}},children:{value:(0,F.$8K)(s,A.$0K,i),enumerable:!0,writable:!1},...D(s,n)})}}e.$oL=i;class c extends i{constructor(f,E){super(f,f,E,void 0),this._isRoot=!0}}e.$pL=c;class u extends F.$4K{constructor(f,E,n){super({controllerId:f,getDocumentVersion:o=>o&&n.getDocument(o)?.version,getApiFor:A.$0K,getChildren:o=>o.children,root:new c(f,E),toITestItem:m.TestItem.from})}}e.$qL=u}),define(De[141],Ce([1,0,53,8,112,13,7]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=void 0;class m{constructor(w,D,C){const p=m.c.nextId();w.$registerTextEditorDecorationType(D.identifier,p,F.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:p,dispose(){w.$removeTextEditorDecorationType(p)}})}}e.$iL=m,m.c=new h.$gL("TextEditorDecorationType");class k{constructor(w,D){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,D){this.k();let C=null;if(w instanceof R.$cJ)C=new R.$dJ(w,w);else if(w instanceof R.$dJ)C=w;else throw new Error("Unrecognized location");this.l(C,D,!1)}insert(w,D){this.k(),this.l(new R.$dJ(w,w),D,!0)}delete(w){this.k();let D=null;if(w instanceof R.$dJ)D=w;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(w,D,C){const p=this.c.validateRange(w);this.g.push({range:p,text:D,forceMoveMarkers:C})}setEndOfLine(w){if(this.k(),w!==R.EndOfLine.LF&&w!==R.EndOfLine.CRLF)throw(0,A.$4)("endOfLine");this.h=w}}class g{constructor(w,D,C,p){this.c=w,this.d=D,this._accept(C),this.e=p;const i=this;this.value={get tabSize(){return i.f},set tabSize(c){i.m(c)},get indentSize(){return i.g},set indentSize(c){i.o(c)},get insertSpaces(){return i.h},set insertSpaces(c){i.q(c)},get cursorStyle(){return i.j},set cursorStyle(c){i.s(c)},get lineNumbers(){return i.k},set lineNumbers(c){i.t(c)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const D=Math.floor(w);return D>0?D:null}if(typeof w=="string"){const D=parseInt(w,10);return isNaN(D)?null:D>0?D:null}return null}m(w){const D=this.l(w);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const D=Math.floor(w);return D>0?D:null}if(typeof w=="string"){const D=parseInt(w,10);return isNaN(D)?null:D>0?D:null}return null}o(w){const D=this.n(w);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(w){return w==="auto"?"auto":w==="false"?!1:!!w}q(w){const D=this.p(w);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(w)})))}assign(w){const D={};let C=!1;if(typeof w.tabSize<"u"){const p=this.l(w.tabSize);p==="auto"?(C=!0,D.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,C=!0,D.tabSize=p)}if(typeof w.indentSize<"u"){const p=this.n(w.indentSize);p==="tabSize"?(C=!0,D.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,C=!0,D.indentSize=p)}if(typeof w.insertSpaces<"u"){const p=this.p(w.insertSpaces);p==="auto"?(C=!0,D.insertSpaces=p):this.h!==p&&(this.h=p,C=!0,D.insertSpaces=p)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,C=!0,D.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,C=!0,D.lineNumbers=F.TextEditorLineNumbersStyle.from(w.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(w,D){D.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(C)})}}e.$jL=g;class L{constructor(w,D,C,p,i,c,u,v){this.id=w,this.j=D,this.k=C,this.g=!1,this.h=new Set,this.c=i,this.d=new g(this.j,this.id,c,C),this.e=u,this.f=v;const f=this;this.value=Object.freeze({get document(){return p.value},set document(E){throw(0,A.$6)("document")},get selection(){return f.c&&f.c[0]},set selection(E){if(!(E instanceof R.$eJ))throw(0,A.$4)("selection");f.c=[E],f.l()},get selections(){return f.c},set selections(E){if(!Array.isArray(E)||E.some(n=>!(n instanceof R.$eJ)))throw(0,A.$4)("selections");f.c=E,f.l()},get visibleRanges(){return f.e},set visibleRanges(E){throw(0,A.$6)("visibleRanges")},get options(){return f.d.value},set options(E){f.g||f.d.assign(E)},get viewColumn(){return f.f},set viewColumn(E){throw(0,A.$6)("viewColumn")},edit(E,n={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new k(p.value,n);return E(o),f.m(o)},insertSnippet(E,n,o={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=f.c.map(t=>F.Range.from(t));else if(n instanceof R.$cJ){const{lineNumber:t,column:d}=F.Position.from(n);s=[{startLineNumber:t,startColumn:d,endLineNumber:t,endColumn:d}]}else if(n instanceof R.$dJ)s=[F.Range.from(n)];else{s=[];for(const t of n)if(t instanceof R.$dJ)s.push(F.Range.from(t));else{const{lineNumber:d,column:$}=F.Position.from(t);s.push({startLineNumber:d,startColumn:$,endLineNumber:d,endColumn:$})}}return D.$tryInsertSnippet(w,p.value.version,E.value,s,o)},setDecorations(E,n){const o=n.length===0;o&&!f.h.has(E.key)||(o?f.h.delete(E.key):f.h.add(E.key),f.n(()=>{if(F.$$K(n))return D.$trySetDecorations(w,E.key,F.$_K(n));{const s=new Array(4*n.length);for(let t=0,d=n.length;t<d;t++){const $=n[t];s[4*t]=$.start.line+1,s[4*t+1]=$.start.character+1,s[4*t+2]=$.end.line+1,s[4*t+3]=$.end.character+1}return D.$trySetDecorationsFast(w,E.key,s)}}))},revealRange(E,n){f.n(()=>D.$tryRevealRange(w,F.Range.from(E),n||R.TextEditorRevealType.Default))},show(E){D.$tryShowEditor(w,F.ViewColumn.from(E))},hide(){D.$tryHideEditor(w)}})}dispose(){(0,b.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,b.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,b.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,b.ok)(!this.g),this.f=w}_acceptSelections(w){(0,b.ok)(!this.g),this.c=w}async l(){const w=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const D=w.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const C=D.edits.map(i=>i.range);C.sort((i,c)=>i.end.line===c.end.line?i.end.character===c.end.character?i.start.line===c.start.line?i.start.character-c.start.character:i.start.line-c.start.line:i.end.character-c.end.character:i.end.line-c.end.line);for(let i=0,c=C.length-1;i<c;i++){const u=C[i].end;if(C[i+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=D.edits.map(i=>({range:F.Range.from(i.range),text:i.text,forceMoveMarkers:i.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,p,{setEndOfLine:typeof D.setEndOfLine=="number"?F.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.$kL=L}),define(De[264],Ce([1,0,197,7,23,2,3,4,248,17,7,12,19,13,21,168]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;function i(v,f){if((0,I.$ge)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let E;return Array.isArray(v.highlights)&&(E=v.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),E=E.length?E:void 0),{label:v.label,highlights:E}}}class c{constructor(f,E,n){this.d=f,this.e=E,this.f=n,this.a=new Map,this.b=new p.$b4;function o(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}E.registerArgumentProcessor({processArgument:s=>o(s)?this.i(s):Array.isArray(s)&&s.length>0?s.map(t=>o(t)?this.i(t):t):s})}registerTreeDataProvider(f,E,n){const o=this.createTreeView(f,{treeDataProvider:E},n);return{dispose:()=>o.dispose()}}createTreeView(f,E,n){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=E.dragAndDropController?.dropMimeTypes??[],s=E.dragAndDropController?.dragMimeTypes??[],t=!!E.dragAndDropController?.handleDrag,d=!!E.dragAndDropController?.handleDrop,$=this.h(f,E,n),l={showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,dropMimeTypes:o,dragMimeTypes:s,hasHandleDrag:t,hasHandleDrop:d,manuallyManageCheckboxes:!!E.manageCheckboxStateManually},S=this.d.$registerTreeViewDataProvider(f,l);return{get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(y){$.message=y},get title(){return $.title},set title(y){$.title=y},get description(){return $.description},set description(y){$.description=y},get badge(){return $.badge},set badge(y){y!==void 0&&L.ViewBadge.isViewBadge(y)?$.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&($.badge=void 0)},reveal:(y,a)=>$.reveal(y,a),dispose:async()=>{await S,this.a.delete(f),$.dispose()}}}$getChildren(f,E){const n=this.a.get(f);return n?n.getChildren(E):Promise.reject(new k.$xE(f))}async $handleDrop(f,E,n,o,s,t,d,$){const l=this.a.get(f);if(!l)return Promise.reject(new k.$xE(f));const S=D.DataTransfer.toDataTransfer(n,async y=>(await this.d.$resolveDropFileData(f,E,y)).buffer);return d===f&&$&&await this.g(S,l,$,s,t),l.onDrop(S,o,s)}async g(f,E,n,o,s){const t=this.b.removeDragOperationTransfer(s);if(t)(await t)?.forEach((d,$)=>{d&&f.set($,d)});else if(s&&E.handleDrag){const d=E.handleDrag(n,f,o);this.b.addDragOperationTransfer(s,d),await d}return f}async $handleDrag(f,E,n,o){const s=this.a.get(f);if(!s)return Promise.reject(new k.$xE(f));const t=await this.g(new A.$6J,s,E,o,n);if(!(!t||o.isCancellationRequested))return D.DataTransfer.from(t)}async $hasResolve(f){const E=this.a.get(f);if(!E)throw new k.$xE(f);return E.hasResolve}$resolve(f,E,n){const o=this.a.get(f);if(!o)throw new k.$xE(f);return o.resolveTreeItem(E,n)}$setExpanded(f,E,n){const o=this.a.get(f);if(!o)throw new k.$xE(f);o.setExpanded(E,n)}$setSelection(f,E){const n=this.a.get(f);if(!n)throw new k.$xE(f);n.setSelection(E)}$setFocus(f,E){const n=this.a.get(f);if(!n)throw new k.$xE(f);n.setFocus(E)}$setVisible(f,E){const n=this.a.get(f);if(!n)throw new k.$xE(f);n.setVisible(E)}$changeCheckboxState(f,E){const n=this.a.get(f);if(!n)throw new k.$xE(f);n.setCheckboxState(E)}h(f,E,n){const o=new u(f,E,this.d,this.e.converter,this.f,n);return this.a.set(f,o),o}i(f){const E=this.a.get(f.$treeViewId);return E&&"$treeItemHandle"in f?E.getExtensionElement(f.$treeItemHandle):E&&"$focusedTreeItem"in f&&f.$focusedTreeItem?E.focusedElement:null}}e.$W$b=c;class u extends m.$kb{get visible(){return this.k}get selectedElements(){return this.l.map(f=>this.getExtensionElement(f)).filter(f=>!(0,I.$pe)(f))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(f,E,n,o,s,t){if(super(),this.C=f,this.D=n,this.F=o,this.G=s,this.H=t,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new R.$5c),this.onDidExpandElement=this.r.event,this.s=this.B(new R.$5c),this.onDidCollapseElement=this.s.event,this.t=this.B(new R.$5c),this.onDidChangeSelection=this.t.event,this.u=this.B(new R.$5c),this.onDidChangeVisibility=this.u.event,this.v=this.B(new R.$5c),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new R.$5c),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.$bd,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const S of t.contributes.views[l])S.id===f&&(this.J=S.name);this.f=E.treeDataProvider,this.g=E.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(l=>this.w.fire({message:!1,element:l})));let d,$;this.B(R.Event.debounce(this.w.event,(l,S)=>(l||(l={message:!1,elements:[]}),S.element!==!1&&(d||(d=new Promise(y=>$=y),this.y=this.y.then(()=>d)),Array.isArray(S.element)?l.elements.push(...S.element):l.elements.push(S.element)),S.message&&(l.message=!0),l),200,!0)(({message:l,elements:S})=>{S.length&&(this.z=this.z.then(()=>{const y=$;return d=null,this.U(S).then(()=>y())})),l&&this.D.$setMessage(this.C,this.I)}))}async getChildren(f){const E=f?this.getExtensionElement(f):void 0;if(f&&!E)return this.G.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let n=this.Q(f);return n||(n=await this.R(E)),n?n.map(o=>o.item):void 0}getExtensionElement(f){return this.i.get(f)}reveal(f,E){E=E||{select:!0,focus:!1};const n=(0,I.$pe)(E.select)?!0:E.select,o=(0,I.$pe)(E.focus)?!1:E.focus,s=(0,I.$pe)(E.expand)?!1:E.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.y.then(()=>this.N(f)).then(t=>this.P(f,t[t.length-1]).then(d=>this.D.$reveal(this.C,{item:d.item,parentChain:t.map($=>$.item)},{select:n,focus:o,expand:s})),t=>this.G.error(t)):this.D.$reveal(this.C,void 0,{select:n,focus:o,expand:s})}get message(){return this.I}set message(f){this.I=f,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(f){this.J=f,this.D.$setTitle(this.C,f,this.L)}get description(){return this.L}set description(f){this.L=f,this.D.$setTitle(this.C,this.J,f)}get badge(){return this.M}set badge(f){this.M?.value===f?.value&&this.M?.tooltip===f?.tooltip||(this.M=D.ViewBadge.from(f),this.D.$setBadge(this.C,f))}setExpanded(f,E){const n=this.getExtensionElement(f);n&&(E?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelection(f){(0,w.$$e)(this.l,f)||(this.l=f,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(f){this.m=f}setVisible(f){f!==this.k&&(this.k=f,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(f){const E=(await Promise.all(f.map(async n=>{const o=this.getExtensionElement(n.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:n.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);E.forEach(n=>{n.treeItem.checkboxState=n.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:E.map(n=>[n.extensionItem,n.newState])})}async handleDrag(f,E,n){const o=[];for(const s of f){const t=this.getExtensionElement(s);t&&o.push(t)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,E,n),E}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(f,E,n){const o=E?this.getExtensionElement(E):void 0;if(!(!o&&E||!this.g?.handleDrop))return(0,g.$kg)(()=>this.g?.handleDrop?this.g.handleDrop(o,f,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(f,E){if(!this.f.resolveTreeItem)return;const n=this.i.get(f);if(n){const o=this.j.get(n);if(o){const s=await this.f.resolveTreeItem(o.extensionItem,n,E)??o.extensionItem;return this.cb(s),o.item.tooltip=this.$(s.tooltip),o.item.command=this.ab(o.disposableStore,s.command),o.item}}}N(f){return this.O(f).then(E=>E?this.N(E).then(n=>this.P(E,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}O(f){const E=this.j.get(f);return E?Promise.resolve(E.parent?this.i.get(E.parent.item.handle):void 0):(0,g.$kg)(()=>this.f.getParent(f))}P(f,E){const n=this.j.get(f);return n?Promise.resolve(n):(0,g.$kg)(()=>this.f.getTreeItem(f)).then(o=>this.fb(f,o,E,!0)).then(o=>this.getChildren(E?E.item.handle:void 0).then(()=>{const s=this.getExtensionElement(o);if(s){const t=this.j.get(s);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(f){if(f){let E;if(typeof f=="string"){const n=this.getExtensionElement(f);E=n?this.j.get(n):void 0}else E=f;return E&&E.children||void 0}return this.h}async R(f){this.mb(f);const E=new C.$bd(this.S.token);try{const n=f?this.j.get(f):void 0,o=await this.f.getChildren(f);if(E.token.isCancellationRequested)return;const s=await Promise.all((0,w.$jf)(o||[]).map(async t=>{const d=await this.f.getTreeItem(t);return d&&!E.token.isCancellationRequested?this.Z(t,d,n):null}));return E.token.isCancellationRequested?void 0:(0,w.$jf)(s)}finally{E.dispose()}}U(f){if(f.some(n=>!n))return this.S.dispose(!0),this.S=new C.$bd,this.ob(),this.D.$refresh(this.C);{const n=this.W(f);if(n.length)return this.X(n)}return Promise.resolve(void 0)}W(f){const E=new Set,n=f.map(s=>this.j.get(s));for(const s of n)if(s&&!E.has(s.item.handle)){let t=s;for(;t&&t.parent&&n.findIndex(d=>t&&t.parent&&d&&d.item.handle===t.parent.item.handle)===-1;){const d=this.i.get(t.parent.item.handle);t=d?this.j.get(d):void 0}t&&!t.parent&&E.add(s.item.handle)}const o=[];return E.forEach(s=>{const t=this.i.get(s);if(t){const d=this.j.get(t);d&&(!d.parent||!E.has(d.parent.item.handle))&&o.push(s)}}),o}X(f){const E={};return Promise.all(f.map(n=>this.Y(n).then(o=>{o&&(E[n]=o.item)}))).then(()=>Object.keys(E).length?this.D.$refresh(this.C,E):void 0)}Y(f){const E=this.getExtensionElement(f);if(E){const n=this.j.get(E);if(n)return this.mb(E),(0,g.$kg)(()=>this.f.getTreeItem(E)).then(o=>{if(o){const s=this.db(E,o,n.parent);return this.kb(E,s,n,n.parent),n.dispose(),s}return null})}return Promise.resolve(null)}Z(f,E,n){const o=this.db(f,E,n);if(E.id&&this.i.has(o.item.handle))throw new Error((0,b.localize)(0,null,E.id));return this.jb(f,o),this.lb(o,n),o}$(f){return L.$CJ.isMarkdownString(f)?D.MarkdownString.from(f):f}ab(f,E){return E?{...this.F.toInternal(E,f),originalId:E.command}:void 0}bb(f){if(f.checkboxState===void 0)return;let E,n,o;return typeof f.checkboxState=="number"?E=f.checkboxState:(E=f.checkboxState.state,n=f.checkboxState.tooltip,o=f.checkboxState.accessibilityInformation),{isChecked:E===L.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:o}}cb(f){if(!L.$1J.isTreeItem(f,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}db(f,E,n){this.cb(E);const o=new m.$jb,s=this.fb(f,E,n),t=this.gb(E);return{item:{handle:s,parentHandle:n?n.item.handle:void 0,label:i(E.label,this.H),description:E.description,resourceUri:E.resourceUri,tooltip:this.$(E.tooltip),command:this.ab(o,E.command),contextValue:E.contextValue,icon:t,iconDark:this.hb(E)||t,themeIcon:this.eb(E),collapsibleState:(0,I.$pe)(E.collapsibleState)?L.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation,checkbox:this.bb(E)},extensionItem:E,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}eb(f){return f.iconPath instanceof L.$9J?f.iconPath:void 0}fb(f,{id:E,label:n,resourceUri:o},s,t){if(E)return`${u.b}/${E}`;const d=i(n,this.H),$=s?s.item.handle:u.a;let l=d?d.label:o?(0,h.$3f)(o):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const S=this.j.has(f)?this.j.get(f).item.handle:void 0,y=this.Q(s)||[];let a,r=0;do{if(a=`${$}/${r}:${l}`,t||!this.i.has(a)||S===a)break;r++}while(r<=y.length);return a}gb(f){if(f.iconPath&&!(f.iconPath instanceof L.$9J))return typeof f.iconPath=="string"||F.URI.isUri(f.iconPath)?this.ib(f.iconPath):this.ib(f.iconPath.light)}hb(f){if(f.iconPath&&!(f.iconPath instanceof L.$9J)&&f.iconPath.dark)return this.ib(f.iconPath.dark)}ib(f){return F.URI.isUri(f)?f:F.URI.file(f)}jb(f,E){this.i.set(E.item.handle,f),this.j.set(f,E)}kb(f,E,n,o){this.i.delete(E.item.handle),this.j.delete(f),E.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.jb(f,E);const s=this.Q(o)||[],t=s.filter(d=>d.item.handle===n.item.handle)[0];t&&s.splice(s.indexOf(t),1,E)}lb(f,E){E?(E.children||(E.children=[]),E.children.push(f)):(this.h||(this.h=[]),this.h.push(f))}mb(f){if(f){const E=this.j.get(f);if(E){if(E.children)for(const n of E.children){const o=this.i.get(n.item.handle);o&&this.nb(o)}E.children=void 0}}else this.ob()}nb(f){const E=this.j.get(f);if(E){if(E.children)for(const n of E.children){const o=this.i.get(n.item.handle);o&&this.nb(o)}this.j.delete(f),this.i.delete(E.item.handle),E.dispose()}}ob(){this.h=void 0,this.i.clear(),this.j.forEach(f=>f.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.ob(),this.D.$disposeTree(this.C)}}u.a="0",u.b="1"}),define(De[265],Ce([1,0,5,214]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=void 0,e.$pI=(0,b.$mh)(A.$sh)}),define(De[142],Ce([1,0,25,3,10,4]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BZb=e.$AZb=e.$zZb=e.$yZb=e.$xZb=void 0;class R{constructor(i){this.removedDueToLooping=i}}e.$xZb=R;class m{static isHostExtension(i,c,u){if(c.getExtensionDescription(i))return!1;const v=u.getExtensionDescription(i);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(i,c){this.h=i,this.c=new A.$5c,this.onDidChange=this.c.event,this.d=c,this.j()}j(){this.d.sort(D),this.e=new b.$Gl,this.f=[],this.g=new Map;for(const i of this.d){if(this.e.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.e.set(i.identifier,i),this.f.push(i);const c=this.h.readActivationEvents(i);if(Array.isArray(c))for(let u of c)u==="onUri"&&(u=`onUri:${b.$El.toKey(i.identifier)}`),this.g.has(u)||this.g.set(u,[]),this.g.get(u).push(i)}}set(i){this.d=i,this.j(),this.c.fire(void 0)}deltaExtensions(i,c){this.d=C(this.d,c),this.d=this.d.concat(i);const u=m.k(this.d);return this.d=C(this.d,u.map(v=>v.identifier)),this.j(),this.c.fire(void 0),new R(u)}static k(i){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,o){this.addNode(n),this.addNode(o),this.c.has(n)?this.c.get(n).push(o):this.c.set(n,[o])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,o){const s=c.getArcs(n);for(let t=0;t<s.length;t++)if(!o.has(s[t]))return!1;return!0}getNodes(){return this.e}},u=new b.$Gl;for(const n of i)if(u.set(n.identifier,n),n.extensionDependencies)for(const o of n.extensionDependencies)c.addArc(b.$El.toKey(n.identifier),b.$El.toKey(o));const v=new Set;c.getNodes().filter(n=>c.getArcs(n).length===0).forEach(n=>v.add(n));const f=c.getNodes().filter(n=>!v.has(n));let E;do{E=!1;for(let n=0;n<f.length;n++){const o=f[n];c.hasOnlyGoodArcs(o,v)&&(f.splice(n,1),n--,v.add(o),E=!0)}}while(E);return f.map(n=>u.get(n))}containsActivationEvent(i){return this.g.has(i)}containsExtension(i){return this.e.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this.g.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(i){const c=this.e.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this.f)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$yZb=m,e.$zZb={readActivationEvents:p=>p.activationEvents};class k{constructor(i){this.d=new I,this.c=new m(i,[])}async acquireLock(i){const c=await this.d.acquire(i);return new g(this,c)}deltaExtensions(i,c,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this.c.getExtensionDescriptionByIdOrUUID(i,c)}}e.$AZb=k;class g extends F.$kb{constructor(i,c){super(),this.f=i,this.c=!1,this.B(c)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$BZb=g;class L{constructor(i){this.name=i,this.promise=new Promise((c,u)=>{this.c=c})}resolve(i){this.c(i)}}class I{constructor(){this.c=[],this.d=!1}async acquire(i){const c=new L(i);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let c=!0;const u=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),v=()=>{c&&(clearTimeout(u),c=!1,this.d=!1,this.e())};i.resolve((0,F.$ib)(v))}}var w;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})(w||(w={}));function D(p,i){const c=p.isBuiltin?0:p.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==u)return c-u;const v=h.$8b.basename(p.extensionLocation.path),f=h.$8b.basename(i.extensionLocation.path);return v<f?-1:v>f?1:0}function C(p,i){const c=new b.$Fl(i);return p.filter(u=>!c.has(u.identifier))}}),define(De[266],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.ExtHostConnectionType=void 0;var b;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(b||(e.ExtHostConnectionType=b={}));class A{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[A.ENV_KEY]=this.pipeName}}e.$9l=A,A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class h{constructor(){this.type=2}serialize(I){I[h.ENV_KEY]="1"}}e.$0l=h,h.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class F{constructor(){this.type=3}serialize(I){I[F.ENV_KEY]="1"}}e.$$l=F,F.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function R(L){delete L[A.ENV_KEY],delete L[h.ENV_KEY],delete L[F.ENV_KEY]}function m(L,I){R(I),L.serialize(I)}e.$_l=m;function k(L){if(L[A.ENV_KEY])return g(L,new A(L[A.ENV_KEY]));if(L[h.ENV_KEY])return g(L,new h);if(L[F.ENV_KEY])return g(L,new F);throw new Error("No connection information defined in environment!")}e.$am=k;function g(L,I){return R(L),I}}),define(De[106],Ce([1,0,22]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Nl=e.$Ml=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(A||(e.UIKind=A={}));var h;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var F;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(g){const L=b.$Ib.alloc(1);switch(g){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$Ml=R;function m(g,L){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$Nl=m;var k;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(De[82],Ce([1,0,5,3,18,26,106,78,79,24,2,4,195]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$uL=e.$tL=e.$sL=void 0;let D=e.$sL=class extends I.$kb{constructor(c,u){super(),this.n=c,this.p=u,this.a=this.B(new A.$5c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.$5c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=L.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=u.createLogger(this.j,{id:k.$4n,name:(0,w.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(v=>{(0,h.$Pi)(v)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,u,v){const f=this.getTelemetryDetails(),E=new C(u,v,c,this.k,this.i,this.getBuiltInCommonProperties(c),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),n=this.m.get(c.identifier.value)??[];return this.m.set(c.identifier.value,[...n,E]),E.apiTelemetryLogger}$initializeTelemetryLevel(c,u,v){this.f=c,this.g=u,this.c=v??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(c){const u=Object.create(null);switch(u["common.extname"]=`${c.publisher}.${c.name}`,u["common.extversion"]=c.version,u["common.vscodemachineid"]=this.n.telemetryInfo.machineId,u["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,u["common.vscodeversion"]=this.n.version,u["common.isnewappinstall"]=p(this.n.telemetryInfo.firstSessionDate),u["common.product"]=this.n.environment.appHost,this.n.uiKind){case R.UIKind.Web:u["common.uikind"]="web";break;case R.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,m.$yk)((0,k.$$n)(this.n.remote.authority)),u}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const u=this.getTelemetryDetails();this.m.forEach((v,f)=>{const E=v.filter(n=>!n.isDisposed);E.length===0?this.m.delete(f):this.m.set(f,E)}),this.m.forEach(v=>{for(const f of v)f.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(c,u){const f=this.m.get(c.value)?.filter(n=>!n.isDisposed);if(!f)return this.m.delete(c.value),!1;let E=!1;for(const n of f)n.ignoreUnhandledExtHostErrors||(n.logError(u),E=!0);return E}};e.$sL=D=He([We(0,F.$rL),We(1,h.$Oi)],D);class C{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,u,v,f,E,n,o){this.g=v,this.h=f,this.i=E,this.j=n,this.a=new A.$5c,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(c,u){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let u="properties"in c?c.properties??{}:c;return u=(0,k.$bo)(u,[]),this.c&&(u=(0,g.$Hm)(u,this.c)),this.b||(u=(0,g.$Hm)(u,this.j)),"properties"in c?c.properties=u:c=u,c}k(c,u){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(c,u),this.h.trace(c,u))}logUsage(c,u){this.d.isUsageEnabled&&this.k(c,u)}logError(c,u){!this.d.isErrorsEnabled||!this.f||(typeof c=="string"?this.k(c,u):this.f.sendErrorData(c,u))}get apiTelemetryLogger(){if(!this.e){const c=this,u={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$tL=C;function p(i){const c=Date.now()-new Date(i).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$uL=p,e.$vL=(0,b.$lh)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,235,132,25,5]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.ActivationKind=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.ExtensionHostStartup=e.$9E=e.$8E=e.$7E=e.$6E=void 0,e.$6E=Object.freeze({identifier:new R.$El("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$7E="extensions.webWorker",e.$8E=(0,m.$lh)("extensionService");class k{constructor(E){this.dependency=E}}e.$9E=k;var g;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class L{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:F.$WE.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(E,n){const o=[],s=[],t=[],d=[],$=I(this.c),l=I(E),S=(N,U)=>N.extensionLocation.toString()===U.extensionLocation.toString()||N.isBuiltin===U.isBuiltin||N.isUserBuiltin===U.isUserBuiltin||N.isUnderDevelopment===U.isUnderDevelopment;for(const N of this.c){const U=l.get(N.identifier);if(!U){o.push(N.identifier),$.delete(N.identifier);continue}if(!S(N,U)){o.push(N.identifier),$.delete(N.identifier);continue}}for(const N of E){const U=$.get(N.identifier);if(!U){s.push(N);continue}if(!S(U,N)){o.push(U.identifier),$.delete(U.identifier);continue}}const y=new R.$Fl(this.d),a=new R.$Fl(n);for(const N of this.d)a.has(N)||t.push(N);for(const N of n)y.has(N)||d.push(N);const r=F.$WE.createActivationEventsMap(s),P={toRemove:o,toAdd:s,addActivationEvents:r,myToRemove:t,myToAdd:d};return this.delta(P),P}delta(E){const{toRemove:n,toAdd:o,myToRemove:s,myToAdd:t}=E,d=new R.$Fl(n),$=new R.$Fl(s);for(let l=0;l<this.c.length;l++)d.has(this.c[l].identifier)&&(this.c.splice(l,1),l--);for(let l=0;l<this.d.length;l++)$.has(this.d[l])&&(this.d.splice(l,1),l--);for(const l of o)this.c.push(l);for(const l of t)this.d.push(l)}containsExtension(E){for(const n of this.d)if(R.$El.equals(n,E))return!0;return!1}}e.$0E=L;function I(f){const E=new R.$Gl;for(const n of f)E.set(n.identifier,n);return E}function w(f,E){return!0}e.$$E=w;function D(f,E){if(!w(f,E))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${E}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${E}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.$_E=D;class C{constructor(E,n,o,s){this.codeLoadingTime=E,this.activateCallTime=n,this.activateResolvedTime=o,this.activationReason=s}}e.$aF=C;class p{constructor(E,n){this.description=E,this.value=n}}e.$bF=p;var i;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(i||(e.ActivationKind=i={}));function c(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,h.$ho)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}e.$cF=c;function u(f,E){return{identifier:new R.$El((0,h.$fo)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!E,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}e.$dF=u;class v{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None,this.onWillStop=b.Event.None,this.extensions=[]}activateByEvent(E){return Promise.resolve(void 0)}activationEventIsDone(E){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(E,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$eF=v}),define(De[267],Ce([1,0,8,142,25,27,18,17]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=e.$j$b=e.$i$b=e.$h$b=e.$g$b=e.$f$b=void 0;class k{constructor(c,u,v,f){this.startup=c,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=f}}e.$f$b=k,k.NONE=new k(!1,-1,-1,-1);class g{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,u){return c===-1||u===-1?-1:u-c}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$g$b=g;class L{constructor(c,u,v,f,E,n){this.activationFailed=c,this.activationFailedError=u,this.activationTimes=v,this.module=f,this.exports=E,this.subscriptions=n}}e.$h$b=L;class I extends L{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$i$b=I;class w extends L{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$j$b=w;class D extends L{constructor(c){super(!0,c,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=e.$k$b=class{constructor(c,u,v,f){this.g=f,this.a=c,this.b=u,this.c=v,this.d=new h.$Gl,this.f=Object.create(null)}dispose(){for(const[c,u]of this.d)u.dispose()}async waitForActivatingExtensions(){const c=[];for(const[u,v]of this.d)c.push(v.wait());await Promise.all(c)}isActivated(c){const u=this.d.get(c);return!!(u&&u.value)}getActivatedExtension(c){const u=this.d.get(c);if(!u||!u.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return u.value}async activateByEvent(c,u){if(this.f[c])return;const v=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(v.map(f=>({id:f.identifier,reason:{startup:u,extensionId:f.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,u){const v=this.a.getExtensionDescription(c);if(!v)throw new Error(`Extension '${c}' is not known`);return this.h([{id:v.identifier,reason:u}])}async h(c){const u=c.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(u.map(v=>v.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const u=this.a.getExtensionDescription(c.id);if(!u){const E=new Error(`Cannot activate unknown extension '${c.id.value}'`),n=this.k(c,null,[],new D(E));return this.c.onExtensionActivationError(c.id,E,new F.$9E(c.id.value)),n}const v=[],f=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const E of f){if(this.m(E))continue;const n=this.d.get(E);if(n){v.push(n);continue}if(this.l(E)){v.push(this.j({id:this.b.getExtensionDescription(E).identifier,reason:c.reason}));continue}const o=this.a.getExtensionDescription(E);if(o){if(!o.main&&!o.browser)continue;v.push(this.j({id:o.identifier,reason:c.reason}));continue}const s=u.displayName||u.identifier.value,t=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${E}'`),d=this.k(c,u.displayName,[],new D(t));return this.c.onExtensionActivationError(u.identifier,t,new F.$9E(E)),d}return this.k(c,u.displayName,v,null)}k(c,u,v,f){const E=new p(c.id,u,c.reason,v,f,this.c,this.g);return this.d.set(c.id,E),E}l(c){return A.$yZb.isHostExtension(c,this.a,this.b)}m(c){const u=this.b.getExtensionDescription(c);return u?!u.main&&!u.browser:!1}};e.$k$b=C=He([We(3,R.$Ni)],C);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,u,v,f,E,n,o){this.c=c,this.d=u,this.f=v,this.g=f,this.h=E,this.j=n,this.k=o,this.a=new m.$qg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const u=this.g[c];if(u.value&&!u.value.activationFailed){this.g.splice(c,1),c--;continue}if(u.value&&u.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);v.detail=u.value.activationFailedError,this.h=new D(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const u=new Error;if(c&&c.name&&(u.name=c.name),c&&c.message?u.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:u.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(u.stack=c.stack),this.h=new D(u),this.b&&b.$1(c))return;this.j.onExtensionActivationError(this.c,u,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};p=He([We(6,R.$Ni)],p)}),define(De[268],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemIcon:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemIcon.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[269],Ce([1,0,209,8,41,126,100,42,25,268,229,132]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const w=m.$Qm.as(R.$Rm.JSONContribution);class D{constructor(E,n,o){this.a=E,this.b=n,this.c=o}d(E,n){this.a({type:E,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(E){this.d(h.default.Error,E)}warn(E){this.d(h.default.Warning,E)}info(E){this.d(h.default.Info,E)}}e.$fF=D;class C{static a(E){const n=new k.$Fl;for(let o=0,s=E.length;o<s;o++)n.add(E[o].description.identifier);return n}static compute(E,n){if(!E||!E.length)return new C(n,[]);if(!n||!n.length)return new C([],E);const o=this.a(E),s=this.a(n),t=n.filter($=>!o.has($.description.identifier)),d=E.filter($=>!s.has($.description.identifier));return new C(t,d)}constructor(E,n){this.added=E,this.removed=n}}e.$gF=C;class p{constructor(E,n){this.name=E,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(E){if(this.a!==null)throw new Error("Handler already set!");this.a=E,this.d()}acceptUsers(E){this.c=C.compute(this.b,E),this.b=E,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(E){(0,A.$X)(E)}}}e.$hF=p;const i={type:"string",enum:["ui","workspace"],enumDescriptions:[b.localize(0,null),b.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$iF={properties:{engines:{type:"object",description:b.localize(2,null),properties:{vscode:{type:"string",description:b.localize(3,null),default:"^1.22.0"}}},publisher:{description:b.localize(4,null),type:"string"},displayName:{description:b.localize(5,null),type:"string"},categories:{description:b.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Dl},{type:"string",const:"Languages",deprecationMessage:b.localize(7,null)}]}},galleryBanner:{type:"object",description:b.localize(8,null),properties:{color:{description:b.localize(9,null),type:"string"},theme:{description:b.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:b.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:b.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:b.localize(13,null)},enabledApiProposals:{markdownDescription:b.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:b.localize(15,null),type:"string",enum:["none"],enumDescriptions:[b.localize(16,null)]},activationEvents:{description:b.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:b.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:b.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:b.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:b.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:b.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:b.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:b.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:b.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:b.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:b.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:b.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:b.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:b.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:b.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:b.localize(32,null)},{label:"onUri",body:"onUri",description:b.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:b.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:b.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:b.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:b.localize(37,null)},{label:"onRenderer",description:b.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:b.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:b.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:b.localize(41,null)},{label:"*",description:b.localize(42,null),body:"*"}]}},badges:{type:"array",description:b.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:b.localize(44,null)},href:{type:"string",description:b.localize(45,null)},description:{type:"string",description:b.localize(46,null)}}}},markdown:{type:"string",description:b.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:b.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:b.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$An}},extensionPack:{description:b.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$An}},extensionKind:{description:b.localize(51,null),type:"array",items:i,default:["workspace"],defaultSnippets:[{body:["ui"],description:b.localize(52,null)},{body:["workspace"],description:b.localize(53,null)},{body:["ui","workspace"],description:b.localize(54,null)},{body:["workspace","ui"],description:b.localize(55,null)},{body:[],description:b.localize(56,null)}]},capabilities:{description:b.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:b.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:b.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(60,null),b.localize(61,null),b.localize(62,null)]},description:{type:"string",markdownDescription:b.localize(63,null)}}},untrustedWorkspaces:{description:b.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:b.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)]},restrictedConfigurations:{description:b.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:b.localize(70,null)}}}}},sponsor:{description:b.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:b.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:b.localize(73,null),type:"string"},"vscode:uninstall":{description:b.localize(74,null),type:"string"}}},icon:{type:"string",description:b.localize(75,null)},l10n:{type:"string",description:b.localize(76,null)}}};class u{constructor(){this.a=new Map}registerExtensionPoint(E){if(this.a.has(E.extensionPoint))throw new Error("Duplicate extension point: "+E.extensionPoint);const n=new p(E.extensionPoint,E.defaultExtensionKind);return this.a.set(E.extensionPoint,n),E.activationEventsGenerator&&I.$WE.register(E.extensionPoint,E.activationEventsGenerator),e.$iF.properties.contributes.properties[E.extensionPoint]=E.jsonSchema,w.registerSchema(c,e.$iF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$jF=u;const v={ExtensionsRegistry:"ExtensionsRegistry"};m.$Qm.add(v.ExtensionsRegistry,new u),e.$kF=m.$Qm.as(v.ExtensionsRegistry),w.registerSchema(c,e.$iF),w.registerSchema(L.$7i,{properties:{extensionEnabledApiProposals:{description:b.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(De[270],Ce([1,0,206,12,24,269,47,3]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:b.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:b.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:b.localize(2,null),default:""}}};var g;(function(w){function D(C,p,i){if(!C)return;const c=A.$ge(C.type)?C.type:void 0;if(!c||c.length===0){i.error(b.localize(3,null));return}const u=[];if(Array.isArray(C.required))for(const v of C.required)A.$ge(v)&&u.push(v);return{extensionId:p.value,taskType:c,required:u,properties:C.properties?h.$Em(C.properties):{},when:C.when?R.$ri.deserialize(C.when):void 0}}w.from=D})(g||(g={}));const L=F.$kF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,D)=>{for(const C of w)C.type&&D.push(`onTaskType:${C.type}`)},jsonSchema:{description:b.localize(4,null),type:"array",items:k}});class I{constructor(){this.d=new m.$5c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,C)=>{L.setHandler((p,i)=>{this.c=void 0;try{for(const c of i.removed){const u=c.value;for(const v of u)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const c of i.added){const u=c.value;for(const v of u){const f=g.from(v,c.description.identifier,c.collector);f&&(this.a[f.taskType]=f)}}(i.removed.length>0||i.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const C of this.all()){const p={type:"object",additionalProperties:!1};C.required.length>0&&(p.required=C.required.slice(0)),C.properties!==void 0?p.properties=h.$Em(C.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[C.taskType]},D.push(p)}this.c={oneOf:D}}return this.c}}e.$tF=new I}),define(De[271],Ce([1,0,207,12,23,24,47,270]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$DF=e.JsonSchemaVersion=e.ExecutionEngine=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$xF=e.ShellQuoting=e.$wF=e.$vF=e.$uF=void 0,e.$uF="settings",e.$vF=new R.$Ki("taskRunning",!1,b.localize(0,null)),e.$wF={value:b.localize(1,null),original:"Tasks"};var k;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$xF="$customized",function(O){function K(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=K}(k||(e.ShellQuoting=k={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L||(e.RevealKind=L={})),function(O){function K(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=K}(L||(e.RevealKind=L={}));var I;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(O){function K(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=K}(I||(e.RevealProblemKind=I={}));var w;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(w||(e.PanelKind=w={})),function(O){function K(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=K}(w||(e.PanelKind=w={}));var D;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(D||(e.PresentationOptions=D={}));var C;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(O){function K(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=K;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(C||(e.RuntimeType=C={}));var p;(function(O){function K(z){return A.$ge(z)?z:z.value}O.value=K})(p||(e.CommandString=p={}));var i;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function K(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=K;function z(j){if(j!==void 0)return A.$ge(j)?K(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(i||(e.TaskGroup=i={}));var c;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var u;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function K(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=K})(u||(e.TaskSourceKind=u={}));var v;(function(O){O.parallel="parallel",O.sequence="sequence"})(v||(e.DependsOrder=v={}));var f;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(f||(e.RunOnOptions=f={}));var E;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:f.default,instanceLimit:1}})(E||(e.RunOptions=E={}));class n{constructor(K,z,j,he,ie,ne){this._label="",this._id=K,z&&(this._label=z),j&&(this.type=j),this.runOptions=he,this.configurationProperties=ie,this._source=ne}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.d(),id:this._id};return JSON.stringify(K)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,z=!1){if(K===void 0)return!1;if(A.$ge(K))return K===this._label||K===this.configurationProperties.identifier||z&&K===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this.c===void 0&&(this.c=[]),K&&(this.c=this.c.concat(K))}get taskLoadMessages(){return this.c}}e.$yF=n;class o extends n{constructor(K,z,j,he,ie,ne,V,H){super(K,j,void 0,V,H,z),this.command={},this._source=z,this.hasDefinedMatchers=ne,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case C.Shell:z="shell";break;case C.Process:z="process";break;case C.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(K){return K instanceof o}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===u.User?e.$uF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.d();if(!K)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const j={type:e.$xF,folder:K,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$3f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(K){return new o(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$zF=o;class s extends n{constructor(K,z,j,he,ie,ne,V){super(K,j,he,ne,V,z),this._source=z,this.configures=ie}static is(K){return K instanceof s}f(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$3f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===u.User?e.$uF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.d();if(!K)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const j={type:e.$xF,folder:K,id:z};return JSON.stringify(j)}}e.$AF=s;class t extends n{constructor(K,z,j,he,ie,ne,V,H,ce){super(K,j,he,H,ce,z),this.defines=ie,this.hasDefinedMatchers=V,this.command=ne,this.icon=ce.icon,this.hide=ce.hide}clone(){return new t(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof t}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.d(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(K){return new t(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$BF=t;class d extends n{constructor(K,z,j,he,ie,ne){super(K,j,he,ie,ne,z),this._source=z}clone(){return new d(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof d}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(K){return new d(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.$CF=d;var $;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(O){O._default=O.Terminal}($||(e.ExecutionEngine=$={}));var l;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class S{constructor(K){this.c=new Map;for(let z=0;z<K.length;z++)this.c.set(K[z].uri.toString(),z)}compare(K,z){const j=K.getWorkspaceFolder(),he=z.getWorkspaceFolder();if(j&&he){let ie=this.c.get(j.uri.toString());ie=ie===void 0?0:ie+1;let ne=this.c.get(he.uri.toString());return ne=ne===void 0?0:ne+1,ie===ne?K._label.localeCompare(z._label):ie-ne}else return!j&&he?-1:j&&!he?1:0}}e.$DF=S;var y;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(y||(e.TaskEventKind=y={}));var a;(function(O){O.SingleRun="singleRun",O.Background="background"})(a||(e.TaskRunType=a={}));var r;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(r||(e.TaskRunSource=r={}));var P;(function(O){function K(z,j,he,ie){if(j){const ne={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:j};return z==="start"?ne.resolvedVariables=ie:z==="processStarted"?ne.processId=ie:z==="processEnded"&&(ne.exitCode=ie),Object.freeze(ne)}else return Object.freeze({kind:"changed"})}O.create=K})(P||(e.TaskEvent=P={}));var N;(function(O){function K(j){const he=Object.keys(j).sort();let ie="";for(const ne of he){let V=j[ne];V instanceof Object?V=K(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),ie+=ne+","+V+","}return ie}function z(j){const ie={_key:K(j),type:j.taskType};return Object.assign(ie,j),ie}O.create=z})(N||(e.KeyedTaskIdentifier=N={}));var U;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(U||(e.TaskSettingId=U={}));var q;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var B;(function(O){function K(z,j){const he=m.$tF.get(z.type);if(he===void 0){const H=F.$Em(z);return delete H._key,N.create(H)}const ie=Object.create(null);ie.type=he.taskType;const ne=new Set;he.required.forEach(H=>ne.add(H));const V=he.properties;for(const H of Object.keys(V)){const ce=z[H];if(ce!=null)ie[H]=ce;else if(ne.has(H)){const pe=V[H];if(pe.default!==void 0)ie[H]=F.$Em(pe.default);else switch(pe.type){case"boolean":ie[H]=!1;break;case"number":case"integer":ie[H]=0;break;case"string":ie[H]="";break;default:j.error(b.localize(2,null,JSON.stringify(z,void 0,0),H));return}}}return N.create(ie)}O.createTaskIdentifier=K})(B||(e.TaskDefinition=B={}))}),define(De[272],Ce([1,0,8]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DZb=e.$CZb=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,b.$X)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$CZb=A;class h extends A{constructor(){super(),this.h=!0,this.i=new b.$2}}e.$DZb=h}),define(De[61],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=void 0;class b{constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++b.count}}e.$Kz=b,b.count=0;const A=[];function h(m){const k=new b(m);return A[k.nid]=k,k}e.$Lz=h;function F(m){return A[m].sid}e.$Mz=F;class R{constructor(k){this.value=k}}e.$Nz=R}),define(De[6],Ce([1,0,61]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$I=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var h;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var F;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var k;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var g;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static mixin(i){return i._id=I.a++,i}}e.$$I=I,I.a=0;var w;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var D;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var C;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.$_I={MainThreadAuthentication:(0,b.$Lz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.$Lz)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.$Lz)("MainThreadClipboard"),MainThreadCommands:(0,b.$Lz)("MainThreadCommands"),MainThreadComments:(0,b.$Lz)("MainThreadComments"),MainThreadConfiguration:(0,b.$Lz)("MainThreadConfiguration"),MainThreadConsole:(0,b.$Lz)("MainThreadConsole"),MainThreadDebugService:(0,b.$Lz)("MainThreadDebugService"),MainThreadDecorations:(0,b.$Lz)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.$Lz)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.$Lz)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.$Lz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.$Lz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.$Lz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.$Lz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.$Lz)("MainThreadEditorTabs"),MainThreadErrors:(0,b.$Lz)("MainThreadErrors"),MainThreadTreeViews:(0,b.$Lz)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.$Lz)("MainThreadDownloadService"),MainThreadKeytar:(0,b.$Lz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.$Lz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.$Lz)("MainThreadLanguages"),MainThreadLogger:(0,b.$Lz)("MainThreadLogger"),MainThreadMessageService:(0,b.$Lz)("MainThreadMessageService"),MainThreadOutputService:(0,b.$Lz)("MainThreadOutputService"),MainThreadProgress:(0,b.$Lz)("MainThreadProgress"),MainThreadQuickDiff:(0,b.$Lz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,b.$Lz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.$Lz)("MainThreadStatusBar"),MainThreadSecretState:(0,b.$Lz)("MainThreadSecretState"),MainThreadStorage:(0,b.$Lz)("MainThreadStorage"),MainThreadTelemetry:(0,b.$Lz)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.$Lz)("MainThreadTerminalService"),MainThreadWebviews:(0,b.$Lz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.$Lz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.$Lz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.$Lz)("MainThreadCustomEditors"),MainThreadUrls:(0,b.$Lz)("MainThreadUrls"),MainThreadUriOpeners:(0,b.$Lz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,b.$Lz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,b.$Lz)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.$Lz)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.$Lz)("MainThreadExtensionService"),MainThreadSCM:(0,b.$Lz)("MainThreadSCM"),MainThreadSearch:(0,b.$Lz)("MainThreadSearch"),MainThreadShare:(0,b.$Lz)("MainThreadShare"),MainThreadTask:(0,b.$Lz)("MainThreadTask"),MainThreadWindow:(0,b.$Lz)("MainThreadWindow"),MainThreadLabelService:(0,b.$Lz)("MainThreadLabelService"),MainThreadNotebook:(0,b.$Lz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.$Lz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.$Lz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.$Lz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.$Lz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.$Lz)("MainThreadInteractive"),MainThreadChat:(0,b.$Lz)("MainThreadChat"),MainThreadInlineChat:(0,b.$Lz)("MainThreadInlineChatShape"),MainThreadTheming:(0,b.$Lz)("MainThreadTheming"),MainThreadTunnelService:(0,b.$Lz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,b.$Lz)("MainThreadManagedSockets"),MainThreadTimeline:(0,b.$Lz)("MainThreadTimeline"),MainThreadTesting:(0,b.$Lz)("MainThreadTesting"),MainThreadLocalization:(0,b.$Lz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,b.$Lz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,b.$Lz)("MainThreadIssueReporter")},e.$aJ={ExtHostCommands:(0,b.$Lz)("ExtHostCommands"),ExtHostConfiguration:(0,b.$Lz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.$Lz)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.$Lz)("ExtHostDebugService"),ExtHostDecorations:(0,b.$Lz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.$Lz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.$Lz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.$Lz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.$Lz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.$Lz)("ExtHostEditors"),ExtHostTreeViews:(0,b.$Lz)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.$Lz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.$Lz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.$Lz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.$Lz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.$Lz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.$Lz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,b.$Lz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,b.$Lz)("ExtHostStatusBar"),ExtHostShare:(0,b.$Lz)("ExtHostShare"),ExtHostExtensionService:(0,b.$Lz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.$Lz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.$Lz)("ExtHostTerminalService"),ExtHostSCM:(0,b.$Lz)("ExtHostSCM"),ExtHostSearch:(0,b.$Lz)("ExtHostSearch"),ExtHostTask:(0,b.$Lz)("ExtHostTask"),ExtHostWorkspace:(0,b.$Lz)("ExtHostWorkspace"),ExtHostWindow:(0,b.$Lz)("ExtHostWindow"),ExtHostWebviews:(0,b.$Lz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.$Lz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.$Lz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.$Lz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.$Lz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.$Lz)("ExtHostEditorTabs"),ExtHostProgress:(0,b.$Lz)("ExtHostProgress"),ExtHostComments:(0,b.$Lz)("ExtHostComments"),ExtHostSecretState:(0,b.$Lz)("ExtHostSecretState"),ExtHostStorage:(0,b.$Lz)("ExtHostStorage"),ExtHostUrls:(0,b.$Lz)("ExtHostUrls"),ExtHostUriOpeners:(0,b.$Lz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,b.$Lz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,b.$Lz)("ExtHostOutputService"),ExtHosLabelService:(0,b.$Lz)("ExtHostLabelService"),ExtHostNotebook:(0,b.$Lz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.$Lz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.$Lz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.$Lz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.$Lz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,b.$Lz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,b.$Lz)("ExtHostInteractive"),ExtHostInlineChat:(0,b.$Lz)("ExtHostInlineChatShape"),ExtHostChat:(0,b.$Lz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,b.$Lz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,b.$Lz)("ExtHostTheming"),ExtHostTunnelService:(0,b.$Lz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,b.$Lz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,b.$Lz)("ExtHostAuthentication"),ExtHostTimeline:(0,b.$Lz)("ExtHostTimeline"),ExtHostTesting:(0,b.$Lz)("ExtHostTesting"),ExtHostTelemetry:(0,b.$Lz)("ExtHostTelemetry"),ExtHostLocalization:(0,b.$Lz)("ExtHostLocalization"),ExtHostIssueReporter:(0,b.$Lz)("ExtHostIssueReporter")}}),define(De[83],Ce([1,0,5,18,6,20]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=e.$20b=e.$10b=void 0,e.$10b=(0,b.$lh)("IExtHostApiDeprecationService");let R=e.$20b=class{constructor(k,g){this.c=g,this.a=new Set,this.b=k.getProxy(h.$_I.MainThreadTelemetry)}report(k,g,L){const I=this.d(k,g);this.a.has(I)||(this.a.add(I),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:k}))}d(k,g){return`${k}-${g.identifier.value}`}};e.$20b=R=He([We(0,F.$bL),We(1,A.$Ni)],R),e.$30b=Object.freeze(new class{report(m,k,g){}})}),define(De[273],Ce([1,0,3,6,7,25]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new b.$5c,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=g.getProxy(A.$_I.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,L,I,w={}){const D=F.$El.toKey(g.identifier),C=[...I].sort().join(" ");return await this.f.getOrCreate(`${D} ${L} ${C}`,async()=>{await this.a.$ensureProvider(L);const p=g.displayName||g.name;return this.a.$getSession(L,I,D,p,w)})}async getSessions(g,L,I){const w=F.$El.toKey(g.identifier),D=[...I].sort().join(" ");return await this.g.getOrCreate(`${w} ${D}`,async()=>{await this.a.$ensureProvider(L);const C=g.displayName||g.name;return this.a.$getSessions(L,I,w,C)})}async removeSession(g,L){const I=this.b.get(g);return I?I.provider.removeSession(L):this.a.$removeSession(g,L)}registerAuthenticationProvider(g,L,I,w){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:L,provider:I,options:w??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===g)||this.c.push({id:g,label:L});const D=I.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(g,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(g,L,w?.supportsMultipleAccounts??!1),new h.$bJ(()=>{D.dispose(),this.b.delete(g);const C=this.c.findIndex(p=>p.id===g);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,L,I){const w=this.b.get(g);if(w)return Promise.resolve(w.provider.createSession(L,I));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,L){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,L){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,L){return this.d.fire({provider:{id:g,label:L}}),Promise.resolve()}}e.$w_b=R;class m{constructor(){this.a=new Map}getOrCreate(g,L){const I=this.a.get(g);if(I)return I;const w=L().finally(()=>this.a.delete(g));return this.a.set(g,w),w}}}),define(De[274],Ce([1,0,6,20,13]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=void 0;let F=e.$C_b=class{constructor(m,k){this.a=m.getProxy(b.$_I.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>k.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,k,g){const L=h.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,g?.isRefactoring??!1)}};e.$C_b=F=He([We(0,A.$bL)],F)}),define(De[275],Ce([1,0,3,48,4,40,12,188,6,13]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class L{constructor(D,C){this.extension=D,this.provider=C,this.handle=L.a++}}L.a=0;class I{constructor(D,C){this.i=C,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new b.$5c,this.onDidPerformUserAction=this.g.event,this.h=D.getProxy(k.$_I.MainThreadChat)}registerChatProvider(D,C,p){const i=new L(D,p);return this.b.set(i.handle,i),this.h.$registerChatProvider(i.handle,C),(0,h.$ib)(()=>{this.h.$unregisterChatProvider(i.handle),this.b.delete(i.handle)})}transferChatSession(D,C){const p=A.Iterable.find(this.e.keys(),i=>this.e.get(i)===D)??0;typeof p=="number"&&this.h.$transferChatSession(p,C)}addChatRequest(D){this.h.$addRequest(D)}sendInteractiveRequestToProvider(D,C){this.h.$sendRequestToProvider(D,C)}async $prepareChat(D,C,p){const i=this.b.get(D);if(!i)return;const c=await i.provider.prepareSession(C,p);if(!c)return;const u=I.a++;return this.e.set(u,c),{id:u,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $resolveRequest(D,C,p,i){const c=this.b.get(D);if(!c)return;const u=this.e.get(C);if(!u||!c.provider.resolveRequest)return;const v=await c.provider.resolveRequest(u,p,i);if(v)return{message:typeof v.message=="string"?v.message:g.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(D,C){const p=this.b.get(D);if(!p||!p.provider.provideWelcomeMessage)return;const i=await p.provider.provideWelcomeMessage(C);if(i)return i.map(c=>typeof c=="string"?c:c.map(u=>g.ChatReplyFollowup.from(u)))}async $provideFollowups(D,C,p){const i=this.b.get(D);if(!i)return;const c=this.e.get(C);return!c||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(c,p))?.map(v=>g.ChatFollowup.from(v))}$removeRequest(D,C,p){const i=this.b.get(D);if(!i)return;const c=this.e.get(C);c&&i.provider.removeRequest&&i.provider.removeRequest(c,p)}async $provideReply(D,C,p,i){const c=this.b.get(D);if(!c)return;const u=this.e.get(C);if(!u)return;const v={session:u,message:typeof p.message=="string"?p.message:g.ChatReplyFollowup.to(p.message)},f=F.$1c.create(!1);let E;const n={report:t=>{if(i.isCancellationRequested)return;typeof E>"u"&&(E=f.elapsed());const d="responseId"in t?{requestId:t.responseId}:t;this.h.$acceptResponseProgress(D,C,d)}};let o;try{o=await c.provider.provideResponseWithProgress(v,n,i),o||(o={errorDetails:{message:(0,m.localize)(0,null)}})}catch(t){o={errorDetails:{message:(0,m.localize)(1,null,t.message),responseIsIncomplete:!0}},this.i.error(t)}try{if(u.saveState&&this.e.has(C)){const t=u.saveState();this.h.$acceptChatState(C,t)}}catch(t){this.i.warn(t)}const s={firstProgress:E??0,totalElapsed:f.elapsed()};return{errorDetails:o.errorDetails,timings:s}}async $provideSlashCommands(D,C,p){const i=this.b.get(D);if(!i)return;const c=this.e.get(C);return!c||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(c,p))?.map(v=>({...v,kind:g.CompletionItemKind.from(v.kind)}))}$releaseSession(D){this.e.delete(D)}async $onDidPerformUserAction(D){this.g.fire(D)}registerSlashCommandProvider(D,C,p){const i=new L(D,p);return this.d.set(i.handle,i),this.h.$registerSlashCommandProvider(i.handle,C),(0,h.$ib)(()=>{this.h.$unregisterSlashCommandProvider(i.handle),this.d.delete(i.handle)})}async $provideProviderSlashCommands(D,C){const p=this.d.get(D);return p?(await p.provider.provideSlashCommands(C))?.map(c=>({...c,kind:g.CompletionItemKind.from(c.kind)})):void 0}async $resolveSlashCommand(D,C,p){const i=this.d.get(D);if(!i)return;const c=await i.provider.resolveSlashCommand(C,p);return(0,R.$ye)(c)}}e.$Q_b=I,I.a=0}),define(De[276],Ce([1,0,6]),function(re,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$60b=void 0;class A{constructor(F){const R=F.getProxy(b.$_I.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$60b=A});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[37],Ce([1,0,12,7,13,24,6,19,18,73,36,56,2,4,5,20,140,22,61,46,40,79,82]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n){"use strict";var o,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=void 0;let d=e.$wL=class{constructor(r,P,N){o.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),t.set(this,void 0),Ze(this,o,r.getProxy(R.$_I.MainThreadCommands),"f"),this.d=P,Ze(this,t,N,"f"),Ze(this,s,r.getProxy(R.$_I.MainThreadTelemetry),"f"),this.converter=new $(this,U=>{const q=this.c.get(U);return q?.result===S.Void?q:void 0},P),this.f=[{processArgument(U){return(0,g.$Ug)(U)}},{processArgument(U){return(0,F.$Gm)(U,function(q){if(L.$Lr.isIRange(q))return h.Range.to(q);if(I.$Kr.isIPosition(q))return h.Position.to(q);if(L.$Lr.isIRange(q.range)&&w.URI.isUri(q.uri))return h.location.to(q);if(q instanceof c.$Ib)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(r){this.f.push(r)}registerApiCommand(r){const P=this.registerCommand(!1,r.id,async(...N)=>{const U=r.args.map((B,O)=>{if(!B.validate(N[O]))throw new Error(`Invalid argument '${B.name}' when running '${r.id}', received: ${N[O]}`);return B.convert(N[O])}),q=await this.executeCommand(r.internalId,...U);return r.result.convert(q,N,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this.c.set(r.id,r),new A.$bJ(()=>{P.dispose(),this.c.delete(r.id)})}registerCommand(r,P,N,U,q,B){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:N,thisArg:U,description:q,extension:B}),r&&Te(this,o,"f").$registerCommand(P),new A.$bJ(()=>{this.b.delete(P)&&r&&Te(this,o,"f").$unregisterCommand(P)})}executeCommand(r,...P){return this.d.trace("ExtHostCommands#executeCommand",r),this.g(r,P,!0)}async g(r,P,N){if(this.b.has(r))return Te(this,o,"f").$fireCommandActivationEvent(r),this.h(r,P,!1);{let U=!1;const q=(0,F.$Gm)(P,function(B){if(B instanceof A.$cJ)return h.Position.from(B);if(B instanceof A.$dJ)return h.Range.from(B);if(B instanceof A.$nJ)return h.location.from(B);if(A.$zK.isNotebookRange(B))return h.NotebookRange.from(B);if(B instanceof ArrayBuffer)return U=!0,c.$Ib.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return U=!0,c.$Ib.wrap(B);if(B instanceof c.$Ib)return U=!0,B;if(!Array.isArray(B))return B});try{const B=await Te(this,o,"f").$executeCommand(r,U?new u.$Nz(q):q,N);return(0,g.$Ug)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(r,P,!1);throw B}}}async h(r,P,N){const U=this.b.get(r);if(!U)throw new Error("Unknown command");const{callback:q,thisArg:B,description:O}=U;if(O)for(let z=0;z<O.args.length;z++)try{(0,b.$xe)(P[z],O.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${O.args[z].name}' - ${O.args[z].description}`)}const K=f.$1c.create();try{return await q.apply(B,P)}catch(z){if(r===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...P);j&&(r=j.command)}if(this.d.error(z,r,U.extension?.identifier),!N)throw z;if(U.extension?.identifier){const j=Te(this,t,"f").onExtensionError(U.extension.identifier,z);this.d.trace("forwarded error to extension?",j,U.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$9h)(z)),this.id=r,this.source=U.extension?.displayName??U.extension?.name}}}finally{this.j(U,r,K.elapsed())}}j(r,P,N){r.extension&&Te(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:new E.$Yn(P),duration:N})}$executeContributedCommand(r,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",r);const N=this.b.get(r);return N?(P=P.map(U=>this.f.reduce((q,B)=>B.processArgument(q,N.extension?.identifier),U)),this.h(r,P,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this.d.trace("ExtHostCommands#getCommands",r),Te(this,o,"f").$getCommands().then(P=>(r&&(P=P.filter(N=>N[0]!=="_")),P))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[P,N]of this.b){const{description:U}=N;U&&(r[P]=U)}return Promise.resolve(r)}};o=new WeakMap,s=new WeakMap,t=new WeakMap,e.$wL=d=He([We(0,p.$bL),We(1,k.$Ni),We(2,n.$vL)],d),e.$xL=(0,C.$lh)("IExtHostCommands");class ${constructor(r,P,N){this.d=r,this.f=P,this.g=N,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(r,P){if(!r)return;const N={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return N;const U=this.f(r.command);if(U)N.id=U.internalId,N.arguments=U.args.map((q,B)=>q.convert(r.arguments&&r.arguments[B]));else if((0,m.$nf)(r.arguments)){const q=`${r.command}/${++this.c}`;this.b.set(q,r),P.add((0,D.$ib)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),N.$ident=q,N.id=this.delegatingCommandId,N.arguments=[q],this.g.trace("CommandsConverter#CREATE",r.command,q)}return N}fromInternal(r){return typeof r.$ident=="string"?this.b.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this.b.get(r[0])}h(...r){const P=this.getActualCommand(...r);return this.g.trace("CommandsConverter#EXECUTE",r[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${r[0]}`)}}e.$yL=$;class l{constructor(r,P,N,U){this.name=r,this.description=P,this.validate=N,this.convert=U}optional(){return new l(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,P){return new l(r??this.name,P??this.description,this.validate,this.convert)}}e.$zL=l,l.Uri=new l("uri","Uri of a text document",a=>w.URI.isUri(a),a=>a),l.Position=new l("position","A position in a text document",a=>A.$cJ.isPosition(a),h.Position.from),l.Range=new l("range","A range in a text document",a=>A.$dJ.isRange(a),h.Range.from),l.Selection=new l("selection","A selection in a text document",a=>A.$eJ.isSelection(a),h.Selection.from),l.Number=new l("number","",a=>typeof a=="number",a=>a),l.String=new l("string","",a=>typeof a=="string",a=>a),l.CallHierarchyItem=new l("item","A call hierarchy item",a=>a instanceof A.$yJ,h.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",a=>a instanceof A.$TK,h.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",a=>a instanceof i.$oL,h.TestItem.from);class S{constructor(r,P){this.description=r,this.convert=P}}e.$AL=S,S.Void=new S("no result",a=>a);class y{constructor(r,P,N,U,q){this.id=r,this.internalId=P,this.description=N,this.args=U,this.result=q}}e.$BL=y}),define(De[277],Ce([1,0,19,16,2,76,124,47,128,37,13,7]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;const w=[new g.$BL("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of DocumentHighlight-instances.",C(L.DocumentHighlight.to))),new g.$BL("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$zL.Uri],new g.$AL("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,c)=>{if((0,b.$mf)(i))return;class u extends I.$sJ{static to(f){const E=new u(f.name,L.SymbolKind.to(f.kind),f.containerName||"",new I.$nJ(c[0],L.Range.to(f.range)));return E.detail=f.detail,E.range=E.location.range,E.selectionRange=L.Range.to(f.selectionRange),E.children=f.children?f.children.map(u.to):[],E}}return i.map(u.to)})),new g.$BL("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$zL.Uri,new g.$zL("options","Formatting options",i=>!0,i=>i)],new g.$AL("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.$BL("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$zL.Uri,g.$zL.Range,new g.$zL("options","Formatting options",i=>!0,i=>i)],new g.$AL("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.$BL("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$zL.Uri,g.$zL.Position,new g.$zL("ch","Trigger character",i=>typeof i=="string",i=>i),new g.$zL("options","Formatting options",i=>!0,i=>i)],new g.$AL("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.$BL("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$BL("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$BL("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$BL("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$BL("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Location-instances.",C(L.location.to))),new g.$BL("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of Hover-instances.",C(L.Hover.to))),new g.$BL("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$zL.Uri,new g.$zL("position","A position in a text document",i=>Array.isArray(i)&&i.every(c=>I.$cJ.isPosition(c)),i=>i.map(L.Position.from))],new g.$AL("A promise that resolves to an array of ranges.",i=>i.map(c=>{let u;for(const v of c.reverse())u=new I.$xJ(L.Range.to(v),u);return u}))),new g.$BL("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$zL.String.with("query","Search string")],new g.$AL("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(L.WorkspaceSymbol.to))),new g.$BL("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(L.CallHierarchyItem.to))),new g.$BL("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$zL.CallHierarchyItem],new g.$AL("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(L.CallHierarchyIncomingCall.to))),new g.$BL("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$zL.CallHierarchyItem],new g.$AL("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(L.CallHierarchyOutgoingCall.to))),new g.$BL("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:L.Range.to(i.range),placeholder:i.text}})),new g.$BL("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$zL.Uri,g.$zL.Position,g.$zL.String.with("newName","The new symbol name")],new g.$AL("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return L.WorkspaceEdit.to(i)}})),new g.$BL("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$zL.Uri,g.$zL.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$AL("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(L.DocumentLink.to))),new g.$BL("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$zL.Uri],new g.$AL("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new I.$rK(i.tokenTypes,i.tokenModifiers)})),new g.$BL("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$zL.Uri],new g.$AL("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const c=(0,R.$j7)(i);if(c.type==="full")return new I.$tK(c.data,void 0)})),new g.$BL("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$zL.Uri,g.$zL.Range.optional()],new g.$AL("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new I.$rK(i.tokenTypes,i.tokenModifiers)})),new g.$BL("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$zL.Uri,g.$zL.Range],new g.$AL("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const c=(0,R.$j7)(i);if(c.type==="full")return new I.$tK(c.data,void 0)})),new g.$BL("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$zL.Uri,g.$zL.Position,g.$zL.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$zL.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$AL("A promise that resolves to a CompletionList-instance.",(i,c,u)=>{if(!i)return new I.$JJ([]);const v=i.suggestions.map(f=>L.CompletionItem.to(f,u));return new I.$JJ(v,i.incomplete)})),new g.$BL("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$zL.Uri,g.$zL.Position,g.$zL.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$AL("A promise that resolves to SignatureHelp.",i=>{if(i)return L.SignatureHelp.to(i)})),new g.$BL("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$zL.Uri,g.$zL.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$AL("A promise that resolves to an array of CodeLens-instances.",(i,c,u)=>C(v=>new I.$BJ(L.Range.to(v.range),v.command&&u.fromInternal(v.command)))(i))),new g.$BL("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$zL.Uri,new g.$zL("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>I.$dJ.isRange(i),i=>I.$eJ.isSelection(i)?L.Selection.from(i):L.Range.from(i)),g.$zL.String.with("kind","Code action kind to return code actions for").optional(),g.$zL.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$AL("A promise that resolves to an array of Command-instances.",(i,c,u)=>C(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(v.command)}else{const f=new I.$uJ(v.title,v.kind?new I.$vJ(v.kind):void 0);return v.edit&&(f.edit=L.WorkspaceEdit.to(v.edit)),v.command&&(f.command=u.fromInternal(v.command)),f.isPreferred=v.isPreferred,f}})(i))),new g.$BL("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$zL.Uri],new g.$AL("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(c=>new I.$PJ(L.Range.to(c.range),L.Color.to(c.color))):[])),new g.$BL("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$zL("color","The color to show and insert",i=>i instanceof I.$OJ,L.Color.from),new g.$zL("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:L.Range.from(i.range)}))],new g.$AL("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(L.ColorPresentation.to):[])),new g.$BL("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$zL.Uri,g.$zL.Range],new g.$AL("A promise that resolves to an array of Inlay objects",(i,c,u)=>i.map(L.InlayHint.to.bind(void 0,u)))),new g.$BL("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$zL.Uri],new g.$AL("A promise that resolves to an array of FoldingRange objects",(i,c)=>{if(i)return i.map(L.FoldingRange.to)})),new g.$BL("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$AL("A promise that resolves to an array of NotebookContentProvider static info objects.",C(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(c=>L.NotebookExclusiveDocumentPattern.to(c))})))),new g.$BL("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$zL.Uri,g.$zL.Range],new g.$AL("A promise that resolves to an array of InlineValue objects",i=>i.map(L.InlineValue.to))),new g.$BL("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$zL("uriOrString","Uri-instance or string (only http/https)",i=>h.URI.isUri(i)||typeof i=="string"&&(0,k.$CY)(i,A.Schemas.http,A.Schemas.https),i=>i),new g.$zL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[L.ViewColumn.from(i),void 0]:[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)])).optional(),g.$zL.String.with("label","").optional()],g.$AL.Void),new g.$BL("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$zL.Uri.with("resource","Resource to open"),g.$zL.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$zL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[L.ViewColumn.from(i),void 0]:[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)])).optional()],g.$AL.Void),new g.$BL("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$zL.Uri.with("left","Left-hand side resource of the diff editor"),g.$zL.Uri.with("right","Right-hand side resource of the diff editor"),g.$zL.String.with("title","Human readable title for the diff editor").optional(),new g.$zL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)]).optional()],g.$AL.Void),new g.$BL("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$zL.Uri,g.$zL.Position],new g.$AL("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.$BL("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$zL.TypeHierarchyItem],new g.$AL("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.$BL("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$zL.TypeHierarchyItem],new g.$AL("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.$BL("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$zL.TestItem],g.$AL.Void),new g.$BL("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$zL.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$AL.Void),new g.$BL("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$zL.String.with("name","The context key name"),new g.$zL("value","The context key value",()=>!0,i=>i)],g.$AL.Void)];class D{static register(c){w.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",m.$si)}}e.$50b=D;function C(i){return c=>{if(Array.isArray(c))return c.map(i)}}function p(i){if(!Array.isArray(i))return;const c=[];for(const u of i)F.$ns(u)?c.push(L.DefinitionLink.to(u)):c.push(L.location.to(u));return c}}),define(De[278],Ce([1,0,17,66,3,4,2,76,25,13,7,6,27,12]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=void 0;function C(p,i,c){const u=p.getProxy(I.$_I.MainThreadComments);class v{constructor(){this.b=new Map,this.c=new k.$Gl,i.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const S=this.b.get(l.handle);return S?S.value:l}else if(l&&l.$mid===7){const S=this.b.get(l.commentControlHandle);if(!S)return l;const y=S.getCommentThread(l.commentThreadHandle);return y?y.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const y=S.getCommentThread(l.thread.commentThreadHandle);return y?l.$mid===8?y.value:{thread:y.value,text:l.text}:l}else if(l&&l.$mid===10){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const y=S.getCommentThread(l.thread.commentThreadHandle);if(!y)return l;const a=l.commentUniqueId,r=y.getCommentByUniqueId(a);return r||l}else if(l&&l.$mid===11){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const y=S.getCommentThread(l.thread.commentThreadHandle);if(!y)return l;const a=l.text,r=l.commentUniqueId,P=y.getCommentByUniqueId(r);return P?(typeof P.body=="string"?P.body=a:P.body=new L.$CJ(a),P):l}return l}})}createCommentController(l,S,y){const a=v.a++,r=new E(l,a,S,y);this.b.set(r.handle,r);const P=this.c.get(l.identifier)||[];return P.push(r),this.c.set(l.identifier,P),r.value}$createCommentThreadTemplate(l,S,y){const a=this.b.get(l);a&&a.$createCommentThreadTemplate(S,y)}async $updateCommentThreadTemplate(l,S,y){const a=this.b.get(l);a&&a.$updateCommentThreadTemplate(S,y)}$deleteCommentThread(l,S){this.b.get(l)?.$deleteCommentThread(S)}$provideCommentingRanges(l,S,y){const a=this.b.get(l);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const r=c.getDocument(R.URI.revive(S));return(0,b.$kg)(async()=>{const P=await a.commentingRangeProvider.provideCommentingRanges(r,y);let N;return Array.isArray(P)?N={ranges:P,fileComments:!1}:P?N={ranges:P.ranges||[],fileComments:P.fileComments||!1}:N=(0,D.$ye)(P),N}).then(P=>{let N;return P&&(N={ranges:P.ranges.map(U=>g.Range.from(U)),fileComments:P.fileComments}),N})}$toggleReaction(l,S,y,a,r){const P=this.b.get(l);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,b.$kg)(()=>{const N=P.getCommentThread(S);if(N){const U=N.getCommentByUniqueId(a.uniqueIdInThread);if(P!==void 0&&U&&P.reactionHandler)return P.reactionHandler(U,s(r))}return Promise.resolve(void 0)})}}v.a=0;class f{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,S,y,a,r,P,N,U){this.m=S,this.n=y,this.o=a,this.p=r,this.q=P,this.extensionDescription=N,this.r=U,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$5c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$lb,this.l.value=new F.$jb,this.n===void 0&&(this.n=`${l}.${this.handle}`),u.$createCommentThread(S,this.handle,this.n,this.o,g.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{u.$deleteCommentThread(S,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(B){q.range=B},get comments(){return q.comments},set comments(B){q.comments=B},get collapsibleState(){return q.collapsibleState},set collapsibleState(B){q.collapsibleState=B},get canReply(){return q.canReply},set canReply(B){q.canReply=B},get contextValue(){return q.contextValue},set contextValue(B){q.contextValue=B},get label(){return q.label},set label(B){q.label=B},get state(){return q.state},set state(B){q.state=B},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$jb);const l=y=>Object.prototype.hasOwnProperty.call(this.b,y),S={};l("range")&&(S.range=g.Range.from(this.p)),l("label")&&(S.label=this.label),l("contextValue")&&(S.contextValue=this.contextValue??null),l("comments")&&(S.comments=this.q.map(y=>n(this,y,this.k,this.extensionDescription))),l("collapsibleState")&&(S.collapseState=t(this.g)),l("canReply")&&(S.canReply=this.canReply),l("state")&&(S.state=d(this.h)),l("isTemplate")&&(S.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(l){for(const S of this.k){const y=S[0],a=S[1];if(l===a)return y}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}f.a=0,He([(0,A.$Qg)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,S,y,a){this.f=l,this.g=S,this.h=y,this.i=a,this.a=new Map,u.$registerCommentController(this.handle,y,a);const r=this;this.value=Object.freeze({id:r.id,label:r.label,get options(){return r.options},set options(P){r.options=P},get commentingRangeProvider(){return r.commentingRangeProvider},set commentingRangeProvider(P){r.commentingRangeProvider=P},get reactionHandler(){return r.reactionHandler},set reactionHandler(P){r.reactionHandler=P},createCommentThread(P,N,U){return r.createCommentThread(P,N,U).value},dispose:()=>{r.dispose()}}),this.e=[],this.e.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(l,S,y){S===void 0&&(0,w.$_E)(this.f,"fileComments");const a=new f(this.id,this.handle,void 0,l,S,y,this.f,!1);return this.a.set(a.handle,a),a}$createCommentThreadTemplate(l,S){const y=new f(this.id,this.handle,void 0,R.URI.revive(l),g.Range.to(S),[],this.f,!0);return y.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(l,S){const y=this.a.get(l);y&&(y.range=g.Range.to(S))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function n($,l,S,y){let a=S.get(l);return a||(a=++$.commentHandle,S.set(l,a)),l.state!==void 0&&(0,w.$_E)(y,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:a,body:typeof l.body=="string"?l.body:g.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(r=>o(r)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function o($){return{label:$.label,iconPath:$.iconPath?g.$aL($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted}}function s($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?R.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1}}function t($){if($!==void 0)switch($){case L.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d($){if($!==void 0)switch($){case L.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new v}e.$70b=C}),define(De[279],Ce([1,0,24,6,26,20]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0;let R=e.$Y_b=class{constructor(L,I){this.a=L.getProxy(A.$_I.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,I){const w=this,D=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){w.e(L,I,D,arguments)}})}e(L,I,w,D){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:k(D,this.b)}),this.c&&this.f(L,w,D)}};e.$Y_b=R=He([We(0,F.$bL),We(1,h.$rL)],R);const m=1e5;function k(g,L){const I=[];if(g.length)for(let w=0;w<g.length;w++){let D=g[w];if(typeof D>"u")D="undefined";else if(D instanceof Error){const C=D;C.stack?D=C.stack:D=C.toString()}I.push(D)}if(L){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,b.$Jm)(I);return w.length>m?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[143],Ce([1,0,2,6,7,5,20,18,19,11,10,27]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=e.$8$b=void 0;let w=e.$8$b=class on{constructor(C,p){this.h=p,this.f=new Map,this.g=C.getProxy(A.$_I.MainThreadDecorations)}registerFileDecorationProvider(C,p){const i=on.c++;this.f.set(i,{provider:C,extensionDescription:p}),this.g.$registerDecorationProvider(i,p.identifier.value);const c=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const v=(0,k.$Gf)(u);if(v.length<=on.d){this.g.$onDidChange(i,v);return}this.h.warn("[Decorations] CAPPING events from decorations provider",p.identifier.value,v.length);const f=v.map(o=>({uri:o,rank:(0,g.$md)(o.path,"/")})),E=(0,k.$ef)(f,(o,s)=>o.rank-s.rank||(0,g.$Cd)(o.uri.path,s.uri.path)),n=[];e:for(const o of E){let s;for(const t of o){const d=(0,L.$bc)(t.uri.path);if(s!==d&&(s=d,n.push(t.uri)>=on.d))break e}}this.g.$onDidChange(i,n)});return new h.$bJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(C,p,i){if(!this.f.has(C))return Object.create(null);const c=Object.create(null),{provider:u,extensionDescription:v}=this.f.get(C);return await Promise.all(p.map(async f=>{try{const{uri:E,id:n}=f,o=await Promise.resolve(u.provideFileDecoration(b.URI.revive(E),i));if(!o)return;try{h.$xK.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.$_E)(v,"codiconDecoration"),c[n]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${v}': ${s}`)}}catch(E){this.h.error(E)}})),c}};w.c=0,w.d=250,e.$8$b=w=He([We(0,R.$bL),We(1,m.$Ni)],w),e.$9$b=(0,F.$lh)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[280],Ce([1,0,189,127,2,6,7,13,3,18,28,51]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";var w,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=e.$Y0b=void 0;class p{constructor(u,v,f,E,n,o,s){this.d=u,this.e=v,this.f=f,this.g=E,w.set(this,void 0),D.set(this,void 0),C.set(this,void 0),this.c=!1,Ze(this,C,new L.$ji(t=>n.getComparisonKey(t)),"f"),Ze(this,w,o,"f"),Ze(this,D,s,"f")}dispose(){this.c||(Te(this,D,"f").fire([...Te(this,C,"f").keys()]),Te(this,w,"f")?.$clear(this.e),Te(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(u,v){if(!u){this.clear();return}this.h();let f=[];if(h.URI.isUri(u)){if(!v){this.delete(u);return}Te(this,C,"f").set(u,v.slice()),f=[u]}else if(Array.isArray(u)){f=[];let n;u=[...u].sort(p.j);for(const o of u){const[s,t]=o;if((!n||s.toString()!==n.toString())&&(n&&Te(this,C,"f").get(n).length===0&&Te(this,C,"f").delete(n),n=s,f.push(s),Te(this,C,"f").set(s,[])),t)Te(this,C,"f").get(s)?.push(...t);else{const d=Te(this,C,"f").get(s);d&&(d.length=0)}}}if(Te(this,D,"f").fire(f),!Te(this,w,"f"))return;const E=[];for(const n of f){let o=[];const s=Te(this,C,"f").get(n);if(s)if(s.length>this.f){o=[];const t=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const $ of s)if($.severity===t[d]&&o.push({...m.Diagnostic.from($),modelVersionId:this.g(n)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,b.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(t=>({...m.Diagnostic.from(t),modelVersionId:this.g(n)}));E.push([n,o])}Te(this,w,"f").$changeMany(this.e,E)}delete(u){this.h(),Te(this,D,"f").fire([u]),Te(this,C,"f").delete(u),Te(this,w,"f")?.$changeMany(this.e,[[u,void 0]])}clear(){this.h(),Te(this,D,"f").fire([...Te(this,C,"f").keys()]),Te(this,C,"f").clear(),Te(this,w,"f")?.$clear(this.e)}forEach(u,v){this.h();for(const[f,E]of this)u.call(v,f,E,this)}*[(w=new WeakMap,D=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const u of Te(this,C,"f").keys())yield[u,this.get(u)]}get(u){this.h();const v=Te(this,C,"f").get(u);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(u){return this.h(),Array.isArray(Te(this,C,"f").get(u))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(u,v){return u[0].toString()<v[0].toString()?-1:u[0].toString()>v[0].toString()?1:0}}e.$Y0b=p;let i=e.$Z0b=class vi{static _mapper(u){const v=new L.$ji;for(const f of u)v.set(f,f);return{uris:Object.freeze(Array.from(v.values()))}}constructor(u,v,f,E){this.h=v,this.j=f,this.k=E,this.f=new Map,this.g=new k.$9c({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.g.event,vi._mapper),this.e=u.getProxy(F.$_I.MainThreadDiagnostics)}createDiagnosticCollection(u,v){const{f,e:E,g:n,h:o,j:s,k:t}=this,d=new class{$changeMany(S,y){E.$changeMany(S,y),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,S,y.length===0?"CLEARING":y)}$clear(S){E.$clear(S),o.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,S)}dispose(){E.dispose()}};let $;if(!v)v="_generated_diagnostic_collection_name_#"+vi.c++,$=v;else if(!f.has(v))$=v;else{this.h.warn(`DiagnosticCollection with name '${v}' does already exist.`);do $=v+vi.c++;while(f.has($))}return new class extends p{constructor(){super(v,$,vi.d,S=>t.getDocument(S)?.version,s.extUri,d,n),f.set($,this)}dispose(){super.dispose(),f.delete($)}}}getDiagnostics(u){if(u)return this.l(u);{const v=new Map,f=[];for(const E of this.f.values())E.forEach((n,o)=>{let s=v.get(n.toString());typeof s>"u"&&(s=f.length,v.set(n.toString(),s),f.push([n,[]])),f[s][1]=f[s][1].concat(...o)});return f}}l(u){let v=[];for(const f of this.f.values())f.has(u)&&(v=v.concat(f.get(u)));return v}$acceptMarkersChange(u){if(!this.m){const v="_generated_mirror",f=new p(v,v,vi.d,E=>{},this.j.extUri,void 0,this.g);this.f.set(v,f),this.m=f}for(const[v,f]of u)this.m.set(h.URI.revive(v),f.map(m.Diagnostic.to))}};i.c=0,i.d=1e3,e.$Z0b=i=He([We(1,g.$Ni),We(2,I.$X0b)],i)}),define(De[281],Ce([1,0,2,6,27]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;class F{constructor(m){this.a=m.getProxy(A.$_I.MainThreadDialogs)}showOpenDialog(m,k){return k?.allowUIResources&&(0,h.$_E)(m,"showLocal"),this.a.$showOpenDialog(k).then(g=>g?g.map(L=>b.URI.revive(L)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(k=>k?b.URI.revive(k):void 0)}}e.$c$b=F}),define(De[282],Ce([1,0,8,2,7,6,16,21,11]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;class g{constructor(I,w,D){this.d=w,this.e=D,this.b=new Map,this.c=I.getProxy(F.$_I.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const D=g.a++;this.b.set(D,w),this.c.$registerTextContentProvider(D,I);let C;return typeof w.onDidChange=="function"&&(C=w.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(D,p).then(i=>{if(!i&&typeof i!="string")return;const c=this.d.getDocument(p);if(!c)return;const u=(0,k.$xd)(i);if(!c.equalLines(u))return this.c.$onVirtualDocumentChange(p,i)},b.$X)})),new h.$bJ(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,w){const D=this.b.get(I);return D?Promise.resolve(D.provideTextDocumentContent(A.URI.revive(w),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$d$b=g,g.a=0}),define(De[283],Ce([1,0,3,4,2,6,136,13,12,24,7,8]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;class w{constructor(C,p){this.a=new b.$5c({onListenerError:I.$Y}),this.b=new b.$5c({onListenerError:I.$Y}),this.c=new b.$5c({onListenerError:I.$Y}),this.d=new b.$5c({onListenerError:I.$Y}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.$jb,this.h=new Map,this.f=C.getProxy(F.$_I.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(i=>{for(const c of i)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const c of i)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const p=this.g.getDocument(C);if(p)return p}getDocument(C){const p=this.getDocumentData(C);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return p.document}ensureDocumentData(C){const p=this.g.getDocument(C);if(p)return Promise.resolve(p);let i=this.h.get(C.toString());return i||(i=this.f.$tryOpenDocument(C).then(c=>{this.h.delete(C.toString());const u=h.URI.revive(c);return(0,k.$re)(this.g.getDocument(u))},c=>(this.h.delete(C.toString()),Promise.reject(c))),this.h.set(C.toString(),i)),i}createDocumentData(C){return this.f.$tryCreateDocument(C).then(p=>h.URI.revive(p))}$acceptModelLanguageChanged(C,p){const i=h.URI.revive(C),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(p),this.a.fire(c.document)}$acceptModelSaved(C){const p=h.URI.revive(C),i=this.g.getDocument(p);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(C,p){const i=h.URI.revive(C),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,p,i){const c=h.URI.revive(C),u=this.g.getDocument(c);if(!u)throw new Error("unknown document");u._acceptIsDirty(i),u.onEvents(p);let v;p.isUndoing?v=L.TextDocumentChangeReason.Undo:p.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Fm)({document:u.document,contentChanges:p.changes.map(f=>({range:m.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:v}))}setWordDefinitionFor(C,p){(0,R.$dL)(C,p)}}e.$V0b=w}),define(De[62],Ce([1,0,53,3,4,2,5,6,136,20,141,13,18,28,16,48,54]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=void 0;class c{constructor(f){this.value=f,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=e.$lL=class{constructor(f,E){this.h=f,this.i=E,this.a=null,this.b=new Map,this.c=new D.$ji,this.d=new A.$5c,this.e=new A.$5c,this.f=new A.$5c,this.g=new A.$5c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const E=[],n=[],o=[];if(f.removedDocuments)for(const s of f.removedDocuments){const t=F.URI.revive(s),d=this.c.get(t);d?.unref()&&(this.c.delete(t),E.push(d.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const t=F.URI.revive(s.uri);let d=this.c.get(t);if(d&&t.scheme!==C.Schemas.vscodeNotebookCell&&t.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);d||(d=new c(new k.$eL(this.h.getProxy(m.$_I.MainThreadDocuments),t,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(t,d),n.push(d.value)),d.ref()}if(f.removedEditors)for(const s of f.removedEditors){const t=this.b.get(s);this.b.delete(s),t&&o.push(t)}if(f.addedEditors)for(const s of f.addedEditors){const t=F.URI.revive(s.documentUri);b.ok(this.c.has(t),`document '${t}' does not exist`),b.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const d=this.c.get(t).value,$=new L.$kL(s.id,this.h.getProxy(m.$_I.MainThreadTextEditors),this.i,new i.$S(()=>d.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(l=>I.Range.to(l)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,$)}f.newActiveEditor!==void 0&&(b.ok(f.newActiveEditor===null||this.b.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this.a=f.newActiveEditor),(0,h.$fb)(E),(0,h.$fb)(o),f.removedDocuments&&this.e.fire(E),f.addedDocuments&&this.d.fire(n),(f.removedEditors||f.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(f){return this.c.get(f)?.value}allDocuments(){return p.Iterable.map(this.c.values(),f=>f.value)}getEditor(f){return this.b.get(f)}activeEditor(f){if(!this.a)return;const E=this.b.get(this.a);return f?E:E?.value}allEditors(){return[...this.b.values()]}};e.$lL=u=He([We(0,g.$bL),We(1,w.$Ni)],u),e.$mL=(0,R.$lh)("IExtHostDocumentsAndEditors")}),define(De[63],Ce([1,0,13,6,2,3,5,7,20,12,65]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=void 0,e.$a_b=(0,R.$lh)("IExtHostEditorTabs");class I{constructor(i,c,u){this.e=u,this.d=c,this.acceptDtoUpdate(i)}get apiObject(){if(!this.a){const i=this,c={get isActive(){return i.b.id===i.e()},get label(){return i.b.label},get input(){return i.c},get isDirty(){return i.b.isDirty},get isPinned(){return i.b.isPinned},get isPreview(){return i.b.isPreview},get group(){return i.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(i){this.b=i,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$UK(h.URI.revive(this.b.input.uri));case 2:return new m.$VK(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified));case 3:return new m.$WK(h.URI.revive(this.b.input.base),h.URI.revive(this.b.input.input1),h.URI.revive(this.b.input.input2),h.URI.revive(this.b.input.result));case 6:return new m.$XK(h.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$YK(this.b.input.viewType);case 4:return new m.$ZK(h.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$1K(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$2K;case 9:return new m.$3K(h.URI.revive(this.b.input.uri),h.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(i,c){this.c=[],this.d="",this.b=i,this.e=c;for(const u of i.tabs)u.isActive&&(this.d=u.id),this.c.push(new I(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const i=this,c={get isActive(){return i.b.groupId===i.e()},get viewColumn(){return b.ViewColumn.to(i.b.viewColumn)},get activeTab(){return i.c.find(u=>u.tabId===i.d)?.apiObject},get tabs(){return Object.freeze(i.c.map(u=>u.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(i){this.b=i}acceptTabOperation(i){if(i.kind===0){const u=new I(i.tabDto,this,()=>this.activeTabId());return this.c.splice(i.index,0,u),i.tabDto.isActive&&(this.d=u.tabId),u}else if(i.kind===1){const u=this.c.splice(i.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${i.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if(i.kind===3){if(i.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice(i.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${i.oldIndex} which does not exist`);return this.c.splice(i.index,0,u),u}const c=this.c.find(u=>u.tabId===i.tabDto.id);if(!c)throw new Error("INVALID tab");return i.tabDto.isActive?this.d=i.tabDto.id:this.d===i.tabDto.id&&!i.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(i.tabDto),c}activeTabId(){return this.d}}let D=e.$b_b=class{constructor(i){this.b=new F.$5c,this.c=new F.$5c,this.e=[],this.a=i.getProxy(A.$_I.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const i=this,c={onDidChangeTabGroups:i.c.event,onDidChangeTabs:i.b.event,get all(){return Object.freeze(i.e.map(u=>u.apiObject))},get activeTabGroup(){const u=i.d;return(0,g.$re)(i.e.find(f=>f.groupId===u)?.apiObject)},close:async(u,v)=>{const f=Array.isArray(u)?u:[u];return f.length?C(f[0])?this.j(f,v):this.i(f,v):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(i){const c=new Set(this.e.map(s=>s.groupId)),u=new Set(i.map(s=>s.groupId)),v=(0,L.$E)(c,u),f=this.e.filter(s=>v.removed.includes(s.groupId)).map(s=>s.apiObject),E=[],n=[];this.e=i.map(s=>{const t=new w(s,()=>this.d);return v.added.includes(t.groupId)?E.push(t.apiObject):n.push(t.apiObject),t});const o=(0,g.$re)(i.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:E,closed:f,changed:n}))}$acceptTabGroupUpdate(i){const c=this.e.find(u=>u.groupId===i.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(i),i.isActive&&(this.d=i.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(i){const c=this.e.find(v=>v.groupId===i.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const u=c.acceptTabOperation(i);switch(i.kind){case 0:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g(i){for(const c of this.e)for(const u of c.tabs)if(u.apiObject===i)return u}h(i){return this.e.find(c=>c.apiObject===i)}async i(i,c){const u=[];for(const v of i){const f=this.g(v);if(!f)throw new Error("Tab close: Invalid tab not found!");u.push(f.tabId)}return this.a.$closeTab(u,c)}async j(i,c){const u=[];for(const v of i){const f=this.h(v);if(!f)throw new Error("Group close: Invalid group not found!");u.push(f.groupId)}return this.a.$closeGroup(u,c)}};e.$b_b=D=He([We(0,k.$bL)],D);function C(p){return p.tabs!==void 0}}),define(De[284],Ce([1,0,2,6,4,7,13,164,11,22,27,94]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0;class w{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const i=this.a.indexOf(p);i>=0&&(this.a.splice(i,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),i=[];let c,u,v=14,f=14;for(const E of p){let n=c?(0,k.$Ld)(c,E):0;for(n===0?u=1:u=f;n<E.length;n++)n+1===E.length?(v=f,f=9):f+=1,i.push([u,E.toUpperCase().charCodeAt(n),f]),i.push([u,E.toLowerCase().charCodeAt(n),f]),u=f;c=E,f=v}i.push([9,58,10]),i.push([10,47,12]),this.b=new m.$DW(i)}}provideDocumentLinks(p){this.c();const i=[],c=m.$EW.computeLinks({getLineContent(u){return p.lineAt(u-1).text},getLineCount(){return p.lineCount}},this.b);for(const u of c){const v=R.DocumentLink.to(u);v.target&&i.push(v)}return i}}class D{constructor(p,i){this.i=i,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(A.$_I.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,i,c,u={}){if(D.j(c),this.d.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const v=this.h++;this.b.add(i),this.d.add(i),this.c.set(v,c);let f=2;u.isCaseSensitive&&(f+=1024),u.isReadonly&&(f+=2048),typeof c.copy=="function"&&(f+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,L.$_E)(p,"fsChunks"),f+=4);let E;u.isReadonly&&(0,I.$Ij)(u.isReadonly)&&((0,L.$_E)(p,"readonlyMessage"),E={value:u.isReadonly.value,isTrusted:u.isReadonly.isTrusted,supportThemeIcons:u.isReadonly.supportThemeIcons,supportHtml:u.isReadonly.supportHtml,baseUri:u.isReadonly.baseUri,uris:u.isReadonly.uris}),this.a.$registerFileSystemProvider(v,i,f,E).catch(o=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${i}`),console.error(o)});const n=c.onDidChangeFile(o=>{const s=[];for(const t of o){const{uri:d,type:$}=t;if(d.scheme!==i)continue;let l;switch($){case F.FileChangeType.Changed:l=0;break;case F.FileChangeType.Created:l=1;break;case F.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:d,type:l})}this.a.$onFileSystemChange(v,s)});return(0,h.$ib)(()=>{n.dispose(),this.b.delete(i),this.d.delete(i),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:i,ctime:c,mtime:u,size:v,permissions:f}=p;return{type:i,ctime:c,mtime:u,size:v,permissions:f}}$stat(p,i){return Promise.resolve(this.l(p).stat(b.URI.revive(i))).then(c=>D.k(c))}$readdir(p,i){return Promise.resolve(this.l(p).readDirectory(b.URI.revive(i)))}$readFile(p,i){return Promise.resolve(this.l(p).readFile(b.URI.revive(i))).then(c=>g.$Ib.wrap(c))}$writeFile(p,i,c,u){return Promise.resolve(this.l(p).writeFile(b.URI.revive(i),c.buffer,u))}$delete(p,i,c){return Promise.resolve(this.l(p).delete(b.URI.revive(i),c))}$rename(p,i,c,u){return Promise.resolve(this.l(p).rename(b.URI.revive(i),b.URI.revive(c),u))}$copy(p,i,c,u){const v=this.l(p);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(b.URI.revive(i),b.URI.revive(c),u))}$mkdir(p,i){return Promise.resolve(this.l(p).createDirectory(b.URI.revive(i)))}$watch(p,i,c,u){const v=this.l(p).watch(b.URI.revive(c),u);this.f.set(i,v)}$unwatch(p,i){const c=this.f.get(i);c&&(c.dispose(),this.f.delete(i))}$open(p,i,c){const u=this.l(p);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(b.URI.revive(i),c))}$close(p,i){const c=this.l(p);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(i))}$read(p,i,c,u){const v=this.l(p);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const f=g.$Ib.alloc(u);return Promise.resolve(v.read(i,c,f.buffer,0,u)).then(E=>f.slice(0,E))}$write(p,i,c,u){const v=this.l(p);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(i,c,u.buffer,0,u.byteLength))}l(p){const i=this.c.get(p);if(!i){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return i}}e.$J$b=D}),define(De[64],Ce([1,0,6,30,7,22,5,20,51,4,17,23,16]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=e.$p$b=void 0;let D=e.$p$b=class ii{constructor(p,i){this.b=new Map,this.c=new L.$zg,this.a=p.getProxy(b.$_I.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(u){try{let v;const f=c.b.get(u.scheme);return f?(await c.a.$ensureActivation(u.scheme),v=await f.impl.stat(u)):v=await c.a.$stat(u),{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}catch(v){ii.e(v)}},async readDirectory(u){try{const v=c.b.get(u.scheme);return v?(await c.a.$ensureActivation(u.scheme),(await v.impl.readDirectory(u)).slice()):await c.a.$readdir(u)}catch(v){return ii.e(v)}},async createDirectory(u){try{const v=c.b.get(u.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(u.scheme),await c.d(v.impl,v.extUri,u)):await c.a.$mkdir(u)}catch(v){return ii.e(v)}},async readFile(u){try{const v=c.b.get(u.scheme);return v?(await c.a.$ensureActivation(u.scheme),(await v.impl.readFile(u)).slice()):(await c.a.$readFile(u)).buffer}catch(v){return ii.e(v)}},async writeFile(u,v){try{const f=c.b.get(u.scheme);return f&&!f.isReadonly?(await c.a.$ensureActivation(u.scheme),await c.d(f.impl,f.extUri,f.extUri.dirname(u)),await c.c.queueFor(u).queue(()=>Promise.resolve(f.impl.writeFile(u,v,{create:!0,overwrite:!0})))):await c.a.$writeFile(u,F.$Ib.wrap(v))}catch(f){return ii.e(f)}},async delete(u,v){try{const f=c.b.get(u.scheme);return f&&!f.isReadonly?(await c.a.$ensureActivation(u.scheme),await f.impl.delete(u,{recursive:!1,...v})):await c.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...v})}catch(f){return ii.e(f)}},async rename(u,v,f){try{return await c.a.$rename(u,v,{overwrite:!1,...f})}catch(E){return ii.e(E)}},async copy(u,v,f){try{return await c.a.$copy(u,v,{overwrite:!1,...f})}catch(E){return ii.e(E)}},isWritableFileSystem(u){const v=i.getCapabilities(u);if(typeof v=="number")return!(v&2048)}})}async d(p,i,c){const u=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await p.stat(c)).type&A.FileType.Directory))throw h.$pK.FileExists(`Unable to create folder '${c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(v){if(A.$4j(v)!==A.FileSystemProviderErrorCode.FileNotFound)throw v;u.push(i.basename(c)),c=i.dirname(c)}for(let v=u.length-1;v>=0;v--){c=i.joinPath(c,u[v]);try{await p.createDirectory(c)}catch(f){if(A.$4j(f)!==A.FileSystemProviderErrorCode.FileExists)throw f}}}static e(p){if(p instanceof h.$pK)throw p;if(p instanceof A.$Zj)switch(p.code){case A.FileSystemProviderErrorCode.FileExists:throw h.$pK.FileExists(p.message);case A.FileSystemProviderErrorCode.FileNotFound:throw h.$pK.FileNotFound(p.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw h.$pK.FileNotADirectory(p.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw h.$pK.FileIsADirectory(p.message);case A.FileSystemProviderErrorCode.NoPermissions:throw h.$pK.NoPermissions(p.message);case A.FileSystemProviderErrorCode.Unavailable:throw h.$pK.Unavailable(p.message);default:throw new h.$pK(p.message,p.name)}if(!(p instanceof Error))throw new h.$pK(String(p));if(p.name==="ENOPRO"||p.message.includes("ENOPRO"))throw h.$pK.Unavailable(p.message);switch(p.name){case A.FileSystemProviderErrorCode.FileExists:throw h.$pK.FileExists(p.message);case A.FileSystemProviderErrorCode.FileNotFound:throw h.$pK.FileNotFound(p.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw h.$pK.FileNotADirectory(p.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw h.$pK.FileIsADirectory(p.message);case A.FileSystemProviderErrorCode.NoPermissions:throw h.$pK.NoPermissions(p.message);case A.FileSystemProviderErrorCode.Unavailable:throw h.$pK.Unavailable(p.message);default:throw new h.$pK(p.message,p.name)}}addFileSystemProvider(p,i,c){return this.b.set(p,{impl:i,extUri:c?.isCaseSensitive?I.$Vf:I.$Xf,isReadonly:!!c?.isReadonly}),(0,g.$ib)(()=>this.b.delete(p))}};e.$p$b=D=He([We(0,m.$bL),We(1,k.$X0b)],D),e.$q$b=(0,R.$lh)("IExtHostConsumerFileSystem")}),define(De[285],Ce([1,0,3,32,2,6,13,7]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,w,D,C,p,i,c,u){this.a=new b.$5c,this.b=new b.$5c,this.c=new b.$5c;const v=this.h(I,D,p);this.g=0,i&&(this.g+=1),c&&(this.g+=2),u&&(this.g+=4);const f=(0,A.$aj)(p),E=typeof p=="string",n=C(o=>{if(!i)for(const s of o.created){const t=h.URI.revive(s);f(t.fsPath)&&(!E||w.getWorkspaceFolder(t))&&this.a.fire(t)}if(!c)for(const s of o.changed){const t=h.URI.revive(s);f(t.fsPath)&&(!E||w.getWorkspaceFolder(t))&&this.b.fire(t)}if(!u)for(const s of o.deleted){const t=h.URI.revive(s);f(t.fsPath)&&(!E||w.getWorkspaceFolder(t))&&this.c.fire(t)}});this.d=m.$bJ.from(v,this.a,this.b,this.c,n)}h(I,w,D){const C=m.$bJ.from();if(typeof D=="string")return C;const p=I.getProxy(F.$_I.MainThreadFileSystem);let i=!1;(D.pattern.includes(A.$9i)||D.pattern.includes(A.$0i))&&(i=!0);const c=Math.random();return p.$watch(w.identifier.value,c,D.baseUri,{recursive:i,excludes:[]}),m.$bJ.from({dispose:()=>p.$unwatch(c)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(I,w,D){this.j=I,this.k=w,this.l=D,this.a=new b.$5c,this.b=new b.$5c,this.c=new b.$5c,this.d=new b.$5c,this.g=new b.$7c,this.h=new b.$7c,this.i=new b.$7c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,w,D,C,p,i){return new k(this.j,I,w,this.a.event,R.GlobPattern.from(D),C,p,i)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,w){switch(I){case 2:this.b.fire(Object.freeze({files:w.map(D=>({oldUri:h.URI.revive(D.source),newUri:h.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(D=>h.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(D=>h.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,w){return(D,C,p)=>{const i=function(u){D.call(C,u)};return i.extension=I,w.event(i,void 0,p)}}async $onWillRunFileOperation(I,w,D,C){switch(I){case 2:return await this.n(this.g,{files:w.map(p=>({oldUri:h.URI.revive(p.source),newUri:h.URI.revive(p.target)}))},D,C);case 1:return await this.n(this.i,{files:w.map(p=>h.URI.revive(p.target))},D,C);case 0:case 3:return await this.n(this.h,{files:w.map(p=>h.URI.revive(p.target))},D,C)}}async n(I,w,D,C){const p=new Set,i=[];if(await I.fireAsync(w,C,async(u,v)=>{const f=Date.now(),E=await Promise.resolve(u);E instanceof m.$lJ&&(i.push([v.extension,E]),p.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-f>D&&this.k.warn("SLOW file-participant",v.extension.identifier)}),C.isCancellationRequested||i.length===0)return;const c={edits:[]};for(const[,u]of i){const{edits:v}=R.WorkspaceEdit.from(u,{getTextDocumentVersion:f=>this.l.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(v)}return{edit:c,extensionNames:Array.from(p)}}}e.$K$b=g}),define(De[286],Ce([1,0,4,2,6,13,7,37]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=void 0;class k{constructor(w,D){this.extension=w,this.provider=D,this.handle=k.a++}}k.a=0;class g{constructor(w){this.session=w,this.responses=[]}}class L{constructor(w,D,C,p){this.f=C,this.g=p,this.b=new Map,this.d=new Map,this.e=w.getProxy(h.$_I.MainThreadInlineChat),D.registerApiCommand(new m.$BL("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$zL("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?F.Range.from(i.initialRange):void 0,message:i.message,autoSend:i.autoSend}})],m.$AL.Void))}registerProvider(w,D){const C=new k(w,D);return this.b.set(C.handle,C),this.e.$registerInteractiveEditorProvider(C.handle,w.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,b.$ib)(()=>{this.e.$unregisterInteractiveEditorProvider(C.handle),this.b.delete(C.handle)})}async $prepareSession(w,D,C,p){const i=this.b.get(w);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(A.URI.revive(D)),u=F.Selection.to(C),v=await i.provider.prepareInteractiveEditorSession({document:c,selection:u},p);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const f=L.a++;return this.d.set(f,new g(v)),{id:f,placeholder:v.placeholder,slashCommands:v.slashCommands?.map(E=>({command:E.command,detail:E.detail,refer:E.refer})),wholeRange:F.Range.from(v.wholeRange),message:v.message}}async $provideResponse(w,D,C,p){const i=this.b.get(w);if(!i)return;const c=this.d.get(D.id);if(!c)return;const u=await i.provider.provideInteractiveEditorResponse({session:c.session,prompt:C.prompt,selection:F.Selection.to(C.selection),wholeRange:F.Range.to(C.wholeRange),attempt:C.attempt},p);if(u){const v=c.responses.push(u)-1,f={wholeRange:F.Range.from(u.wholeRange),placeholder:u.placeholder};if(L.h(u))return{...f,id:v,type:"message",message:F.MarkdownString.from(u.contents)};const{edits:E}=u;if(E instanceof R.$lJ)return{...f,id:v,type:"bulkEdit",edits:F.WorkspaceEdit.from(E)};if(Array.isArray(E))return{...f,id:v,type:"editorEdit",edits:E.map(F.TextEdit.from)}}}$handleFeedback(w,D,C,p){const i=this.b.get(w),c=this.d.get(D),u=c?.responses[C];if(i&&u){let v;switch(p){case 1:v=R.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:v=R.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:v=R.InteractiveEditorResponseFeedbackKind.Undone;break}i.provider.handleInteractiveEditorResponseFeedback?.(c.session,u,v)}}$releaseSession(w,D){const C=this.d.get(D),p=this.b.get(w);C&&p&&p.provider.releaseInteractiveEditorSession?.(C.session),this.d.delete(D)}static h(w){return typeof w=="object"&&typeof w.contents=="object"}}e.$R_b=L,L.a=0}),define(De[287],Ce([1,0,2,37]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=void 0;class h{constructor(R,m,k,g,L){this.a=m,this.b=k,this.c=g;const I=new A.$BL("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.$zL("showOptions","Show Options",w=>!0,w=>w),new A.$zL("resource","Interactive resource Uri",w=>!0,w=>w),new A.$zL("controllerId","Notebook controller Id",w=>!0,w=>w),new A.$zL("title","Interactive editor title",w=>!0,w=>w)],new A.$AL("Notebook and input URI",w=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const D=this.a.getEditorById(w.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:b.URI.revive(w.notebookUri),inputUri:b.URI.revive(w.inputUri),notebookEditor:D.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:b.URI.revive(w.notebookUri),inputUri:b.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,m,k,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:k,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(b.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$N_b=h}),define(De[288],Ce([1,0,6,7]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=void 0;class h{constructor(R){this.a=new Map,this.b=R.getProxy(b.$_I.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(R);if(!k)throw new Error("Issue request handler not found");const g=await k.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(R,m){const k=R.identifier.value;return this.a.set(k,m),this.b.$registerIssueUriRequestHandler(k),new A.$bJ(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$U_b=h}),define(De[289],Ce([1,0,4,6]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;class h{constructor(R){this.b=0,this.a=R.getProxy(A.$_I.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,b.$ib)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$7$b=h}),define(De[290],Ce([1,0,2,24,13,7,76,6,11,36,19,12,159,21,4,124,112,80,40,8,17,27,191]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=void 0;class o{constructor(T,J){this.d=T,this.e=J}async provideDocumentSymbols(T,J){const Z=this.d.getDocument(T),x=await this.e.provideDocumentSymbols(Z,J);if(!(0,L.$mf)(x))return x[0]instanceof F.$tJ?x.map(h.DocumentSymbol.from):o.f(x)}static f(T){T=T.slice(0).sort((x,me)=>{let Ee=x.location.range.start.compareTo(me.location.range.start);return Ee===0&&(Ee=me.location.range.end.compareTo(x.location.range.end)),Ee});const J=[],Z=[];for(const x of T){const me={name:x.name||"!!MISSING: name!!",kind:h.SymbolKind.from(x.kind),tags:x.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:h.Range.from(x.location.range),selectionRange:h.Range.from(x.location.range),children:[]};for(;;){if(Z.length===0){Z.push(me),J.push(me);break}const Ee=Z[Z.length-1];if(g.$Lr.containsRange(Ee.range,me.range)&&!g.$Lr.equalsRange(Ee.range,me.range)){Ee.children?.push(me),Z.push(me);break}Z.pop()}}return J}}class s{constructor(T,J,Z){this.g=T,this.h=J,this.j=Z,this.e=new c.$U0b("CodeLens"),this.f=new Map}async provideCodeLenses(T,J){const Z=this.g.getDocument(T),x=await this.j.provideCodeLenses(Z,J);if(!x||J.isCancellationRequested)return;const me=this.e.add(x),Ee=new C.$jb;this.f.set(me,Ee);const fe={cacheId:me,lenses:[]};for(let Ie=0;Ie<x.length;Ie++)fe.lenses.push({cacheId:[me,Ie],range:h.Range.from(x[Ie].range),command:this.h.toInternal(x[Ie].command,Ee)});return fe}async resolveCodeLens(T,J){const Z=T.cacheId&&this.e.get(...T.cacheId);if(!Z)return;let x;if(typeof this.j.resolveCodeLens!="function"||Z.isResolved?x=Z:x=await this.j.resolveCodeLens(Z,J),x||(x=Z),J.isCancellationRequested)return;const me=T.cacheId&&this.f.get(T.cacheId[0]);if(me)return T.command=this.h.toInternal(x.command??s.d,me),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}s.d={command:"missing",title:"!!MISSING: command!!"};function t(oe){return Array.isArray(oe)?oe.map(h.DefinitionLink.from):oe?[h.DefinitionLink.from(oe)]:[]}class d{constructor(T,J){this.d=T,this.e=J}async provideDefinition(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideDefinition(x,me,Z);return t(Ee)}}class ${constructor(T,J){this.d=T,this.e=J}async provideDeclaration(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideDeclaration(x,me,Z);return t(Ee)}}class l{constructor(T,J){this.d=T,this.e=J}async provideImplementation(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideImplementation(x,me,Z);return t(Ee)}}class S{constructor(T,J){this.d=T,this.e=J}async provideTypeDefinition(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideTypeDefinition(x,me,Z);return t(Ee)}}class y{constructor(T,J){this.d=T,this.e=J}async provideHover(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideHover(x,me,Z);if(!(!Ee||(0,L.$mf)(Ee.contents)))return Ee.range||(Ee.range=x.getWordRangeAtPosition(me)),Ee.range||(Ee.range=new F.$dJ(me,me)),h.Hover.from(Ee)}}class a{constructor(T,J){this.d=T,this.e=J}async provideEvaluatableExpression(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideEvaluatableExpression(x,me,Z);if(Ee)return h.EvaluatableExpression.from(Ee)}}class r{constructor(T,J){this.d=T,this.e=J}async provideInlineValues(T,J,Z,x){const me=this.d.getDocument(T),Ee=await this.e.provideInlineValues(me,h.Range.to(J),h.InlineValueContext.to(Z),x);if(Array.isArray(Ee))return Ee.map(fe=>h.InlineValue.from(fe))}}class P{constructor(T,J){this.d=T,this.e=J}async provideDocumentHighlights(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideDocumentHighlights(x,me,Z);if(Array.isArray(Ee))return Ee.map(h.DocumentHighlight.from)}}class N{constructor(T,J){this.d=T,this.e=J}async provideLinkedEditingRanges(T,J,Z){const x=this.d.getDocument(T),me=h.Position.to(J),Ee=await this.e.provideLinkedEditingRanges(x,me,Z);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.$jf)(Ee.ranges.map(h.Range.from)),wordPattern:Ee.wordPattern}}}class U{constructor(T,J){this.d=T,this.e=J}async provideReferences(T,J,Z,x){const me=this.d.getDocument(T),Ee=h.Position.to(J),fe=await this.e.provideReferences(me,Ee,Z,x);if(Array.isArray(fe))return fe.map(h.location.from)}}class q{constructor(T,J,Z,x,me,Ee,fe){this.h=T,this.j=J,this.k=Z,this.l=x,this.m=me,this.n=Ee,this.o=fe,this.e=new c.$U0b("CodeAction"),this.f=new Map,this.g=new F.$vJ("notebook")}async provideCodeActions(T,J,Z,x){const me=this.h.getDocument(T),Ee=w.$Tr.isISelection(J)?h.Selection.to(J):h.Range.to(J),fe=[];for(const Ge of this.k.getDiagnostics(T))if(Ee.intersection(Ge.range)&&fe.push(Ge)>q.d)break;const Ie={diagnostics:fe,only:Z.only?new F.$vJ(Z.only):void 0,triggerKind:h.CodeActionTriggerKind.to(Z.trigger)},Pe=await this.l.provideCodeActions(me,Ee,Ie,x);if(!(0,L.$nf)(Pe)||x.isCancellationRequested)return;const qe=this.e.add(Pe),Ve=new C.$jb;this.f.set(qe,Ve);const tt=[];for(let Ge=0;Ge<Pe.length;Ge++){const Ye=Pe[Ge];if(Ye)if(q.p(Ye))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Ye.title,command:this.j.toInternal(Ye,Ve)});else{if(Ie.triggerKind!==F.CodeActionTriggerKind.Invoke&&Ye.kind&&this.g.contains(Ye.kind))continue;Ie.only&&(Ye.kind?Ie.only.contains(Ye.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${Ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[qe,Ge],title:Ye.title,command:Ye.command&&this.j.toInternal(Ye.command,Ve),diagnostics:Ye.diagnostics&&Ye.diagnostics.map(h.Diagnostic.from),edit:Ye.edit&&h.WorkspaceEdit.from(Ye.edit,void 0),kind:Ye.kind&&Ye.kind.value,isPreferred:Ye.isPreferred,disabled:Ye.disabled?.reason})}}return{cacheId:qe,actions:tt}}async resolveCodeAction(T,J){const[Z,x]=T,me=this.e.get(Z,x);if(!me||q.p(me))return{};if(!this.l.resolveCodeAction)return{};const Ee=await this.l.resolveCodeAction(me,J)??me;let fe;Ee.edit&&(fe=h.WorkspaceEdit.from(Ee.edit,void 0));let Ie;if(Ee.command){const Pe=this.f.get(Z);Pe&&(Ie=this.j.toInternal(Ee.command,Pe))}return{edit:fe,command:Ie}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static p(T){return typeof T.command=="string"&&typeof T.title=="string"}}q.d=1e3;class B{constructor(T,J,Z,x,me){this.d=T,this.e=J,this.f=Z,this.g=x,this.h=me}async prepareDocumentPaste(T,J,Z,x){if(!this.f.prepareDocumentPaste)return;const me=this.e.getDocument(T),Ee=J.map(Pe=>h.Range.to(Pe)),fe=h.DataTransfer.toDataTransfer(Z,()=>{throw new v.$9});if(await this.f.prepareDocumentPaste(me,Ee,fe,x),x.isCancellationRequested)return;const Ie=Array.from(fe).filter(([,Pe])=>!(Pe instanceof F.$3J));return h.DataTransfer.from(Ie)}async providePasteEdits(T,J,Z,x,me){if(!this.f.provideDocumentPasteEdits)return;const Ee=this.e.getDocument(J),fe=Z.map(qe=>h.Range.to(qe)),Ie=h.DataTransfer.toDataTransfer(x,async qe=>(await this.d.$resolvePasteFileData(this.g,T,qe)).buffer),Pe=await this.f.provideDocumentPasteEdits(Ee,fe,Ie,me);if(Pe)return{id:Pe.id?this.h.identifier.value+"."+Pe.id:this.h.identifier.value,label:Pe.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Pe.priority??0,insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?h.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class O{constructor(T,J){this.d=T,this.e=J}async provideDocumentFormattingEdits(T,J,Z){const x=this.d.getDocument(T),me=await this.e.provideDocumentFormattingEdits(x,J,Z);if(Array.isArray(me))return me.map(h.TextEdit.from)}}class K{constructor(T,J){this.d=T,this.e=J}async provideDocumentRangeFormattingEdits(T,J,Z,x){const me=this.d.getDocument(T),Ee=h.Range.to(J),fe=await this.e.provideDocumentRangeFormattingEdits(me,Ee,Z,x);if(Array.isArray(fe))return fe.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,J,Z,x){(0,I.$qe)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const me=this.d.getDocument(T),Ee=J.map(h.Range.to),fe=await this.e.provideDocumentRangesFormattingEdits(me,Ee,Z,x);if(Array.isArray(fe))return fe.map(h.TextEdit.from)}}class z{constructor(T,J){this.d=T,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,J,Z,x,me){const Ee=this.d.getDocument(T),fe=h.Position.to(J),Ie=await this.e.provideOnTypeFormattingEdits(Ee,fe,Z,x,me);if(Array.isArray(Ie))return Ie.map(h.TextEdit.from)}}class j{constructor(T,J){this.e=T,this.f=J,this.d=new c.$U0b("WorkspaceSymbols")}async provideWorkspaceSymbols(T,J){const Z=await this.e.provideWorkspaceSymbols(T,J);if(!(0,L.$nf)(Z))return{symbols:[]};const x=this.d.add(Z),me={cacheId:x,symbols:[]};for(let Ee=0;Ee<Z.length;Ee++){const fe=Z[Ee];if(!fe||!fe.name){this.f.warn("INVALID SymbolInformation",fe);continue}me.symbols.push({...h.WorkspaceSymbol.from(fe),cacheId:[x,Ee]})}return me}async resolveWorkspaceSymbol(T,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const Z=this.d.get(...T.cacheId);if(Z){const x=await this.e.resolveWorkspaceSymbol(Z,J);return x&&(0,A.$Hm)(T,h.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class he{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,J,Z){this.d=T,this.e=J,this.f=Z}async provideRenameEdits(T,J,Z,x){const me=this.d.getDocument(T),Ee=h.Position.to(J);try{const fe=await this.e.provideRenameEdits(me,Ee,Z,x);return fe?h.WorkspaceEdit.from(fe):void 0}catch(fe){const Ie=he.g(fe);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(T,J,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(T),me=h.Position.to(J);try{const Ee=await this.e.prepareRename(x,me,Z);let fe,Ie;if(F.$dJ.isRange(Ee)?(fe=Ee,Ie=x.getText(Ee)):(0,I.$ie)(Ee)&&(fe=Ee.range,Ie=Ee.placeholder),!fe||!Ie)return;if(fe.start.line>me.line||fe.end.line<me.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(fe),text:Ie}}catch(Ee){const fe=he.g(Ee);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class ie{constructor(T,J){this.resultId=T,this.tokens=J}}class ne{constructor(T,J){this.f=T,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,J,Z){const x=this.f.getDocument(T),me=J!==0?this.d.get(J):null;let Ee=typeof me?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,me.resultId,Z):await this.g.provideDocumentSemanticTokens(x,Z);return me&&this.d.delete(J),Ee?(Ee=ne.h(Ee),this.o(ne.n(me,Ee),Ee)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return ne.j(T)?ne.k(T)?T:new F.$tK(new Uint32Array(T.data),T.resultId):ne.l(T)?ne.m(T)?T:new F.$vK(T.edits.map(J=>new F.$uK(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const J of T.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(T,J){if(!ne.j(J)||!T||!T.tokens)return J;const Z=T.tokens,x=Z.length,me=J.data,Ee=me.length;let fe=0;const Ie=Math.min(x,Ee);for(;fe<Ie&&Z[fe]===me[fe];)fe++;if(fe===x&&fe===Ee)return new F.$vK([],J.resultId);let Pe=0;const qe=Ie-fe;for(;Pe<qe&&Z[x-Pe-1]===me[Ee-Pe-1];)Pe++;return new F.$vK([{start:fe,deleteCount:x-fe-Pe,data:me.subarray(fe,Ee-Pe)}],J.resultId)}o(T,J){if(ne.j(T)){const Z=this.e++;return this.d.set(Z,new ie(T.resultId,T.data)),(0,p.$i7)({id:Z,type:"full",data:T.data})}if(ne.l(T)){const Z=this.e++;return ne.j(J)?this.d.set(Z,new ie(J.resultId,J.data)):this.d.set(Z,new ie(T.resultId)),(0,p.$i7)({id:Z,type:"delta",deltas:(T.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class V{constructor(T,J){this.d=T,this.e=J}async provideDocumentRangeSemanticTokens(T,J,Z){const x=this.d.getDocument(T),me=await this.e.provideDocumentRangeSemanticTokens(x,h.Range.to(J),Z);return me?this.f(me):null}f(T){return(0,p.$i7)({id:0,type:"full",data:T.data})}}class H{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,J,Z,x,me){this.f=T,this.g=J,this.h=Z,this.j=x,this.k=me,this.d=new c.$U0b("CompletionItem"),this.e=new Map}async provideCompletionItems(T,J,Z,x){const me=this.f.getDocument(T),Ee=h.Position.to(J),fe=me.getWordRangeAtPosition(Ee)||new F.$dJ(Ee,Ee),Ie=fe.with({end:Ee}),Pe=new u.$1c,qe=await this.h.provideCompletionItems(me,Ee,x,h.CompletionContext.to(Z));if(!qe||x.isCancellationRequested)return;const Ve=Array.isArray(qe)?new F.$JJ(qe):qe,tt=H.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),Ge=new C.$jb;this.e.set(tt,Ge);const Ye=[],st={x:tt,b:Ye,a:{replace:h.Range.from(fe),insert:h.Range.from(Ie)},c:Ve.isIncomplete||void 0,d:Pe.elapsed()};for(let at=0;at<Ve.items.length;at++){const xe=Ve.items[at],rt=this.l(xe,[tt,at],Ie,fe);Ye.push(rt)}return st}async resolveCompletionItem(T,J){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...T);if(!Z)return;const x=this.l(Z,T),me=await this.h.resolveCompletionItem(Z,J);if(!me)return;const Ee=this.l(me,T);return(x.h!==Ee.h||x.i!==Ee.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x.n!==Ee.n||x.o!==Ee.o||!(0,A.$Im)(x.p,Ee.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,d:Ee.d,c:Ee.c,l:Ee.l,h:Ee.h,i:Ee.i,n:Ee.n,o:Ee.o,p:Ee.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,J,Z,x){const me=this.e.get(J[0]);if(!me)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(T.command,me),fe={x:J,a:T.label,b:T.kind!==void 0?h.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(h.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:h.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(h.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),fe.h=T.textEdit.newText):typeof T.insertText=="string"?fe.h=T.insertText:T.insertText instanceof F.$mJ&&(fe.h=T.insertText.value,fe.i|=4);let Ie;return T.textEdit?Ie=T.textEdit.range:T.range&&(Ie=T.range),F.$dJ.isRange(Ie)?fe.j=h.Range.from(Ie):Ie&&(!Z?.isEqual(Ie.inserting)||!x?.isEqual(Ie.replacing))&&(fe.j={insert:h.Range.from(Ie.inserting),replace:h.Range.from(Ie.replacing)}),fe}}class ce{async provideInlineCompletions(T,J,Z,x){}disposeCompletions(T){}handleDidShowCompletionItem(T,J,Z){}handlePartialAccept(T,J,Z){}}class pe extends ce{constructor(T,J,Z,x){super(),this.f=T,this.g=J,this.h=Z,this.j=x,this.d=new ye,this.e=(0,E.$$E)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,E.$$E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,J,Z,x){const me=this.g.getDocument(T),Ee=h.Position.to(J),fe=await this.h.provideInlineCompletionItems(me,Ee,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:h.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},x);if(!fe||x.isCancellationRequested)return;const Ie=Array.isArray(fe)?fe:fe.items,Pe=this.e?Array.isArray(fe)?[]:fe.commands||[]:[],qe=this.e&&!Array.isArray(fe)?fe.suppressSuggestions:void 0,Ve=this.e&&!Array.isArray(fe)?fe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ie}),items:Ie.map((Ye,st)=>{let at;Ye.command&&(tt||(tt=new C.$jb),at=this.j.toInternal(Ye.command,tt));const xe=Ye.insertText;return{insertText:typeof xe=="string"?xe:{snippet:xe.value},filterText:Ye.filterText,range:Ye.range?h.Range.from(Ye.range):void 0,command:at,idx:st,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Pe.map(Ye=>(tt||(tt=new C.$jb),this.j.toInternal(Ye,tt))),suppressSuggestions:qe,enableForwardStability:Ve}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,J,Z){const x=this.d.get(T)?.items[J];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,Z)}handlePartialAccept(T,J,Z){const x=this.d.get(T)?.items[J];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,Z)}}class ye{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const J=this.e++;return this.d.set(J,T),J}disposeReferenceId(T){const J=this.d.get(T);return this.d.delete(T),J}get(T){return this.d.get(T)}}class ge{constructor(T,J){this.e=T,this.f=J,this.d=new c.$U0b("SignatureHelp")}async provideSignatureHelp(T,J,Z,x){const me=this.e.getDocument(T),Ee=h.Position.to(J),fe=this.g(Z),Ie=await this.f.provideSignatureHelp(me,Ee,x,fe);if(Ie){const Pe=this.d.add([Ie]);return{...h.SignatureHelp.from(Ie),id:Pe}}}g(T){let J;if(T.activeSignatureHelp){const Z=h.SignatureHelp.to(T.activeSignatureHelp),x=this.d.get(T.activeSignatureHelp.id,0);x?(J=x,J.activeSignature=Z.activeSignature,J.activeParameter=Z.activeParameter):J=Z}return{...T,activeSignatureHelp:J}}releaseSignatureHelp(T){this.d.delete(T)}}class M{constructor(T,J,Z,x,me){this.f=T,this.g=J,this.h=Z,this.j=x,this.k=me,this.d=new c.$U0b("InlayHints"),this.e=new Map}async provideInlayHints(T,J,Z){const x=this.f.getDocument(T),me=h.Range.to(J),Ee=await this.h.provideInlayHints(x,me,Z);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(Z.isCancellationRequested)return;const fe=this.d.add(Ee);this.e.set(fe,new C.$jb);const Ie={hints:[],cacheId:fe};for(let Pe=0;Pe<Ee.length;Pe++)this.l(Ee[Pe],me)&&Ie.hints.push(this.m(Ee[Pe],[fe,Pe]));return this.j.trace(`[InlayHints] ${Ie.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),Ie}async resolveInlayHint(T,J){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...T);if(!Z)return;const x=await this.h.resolveInlayHint(Z,J);if(x&&this.l(x))return this.m(x,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,J){return T.label.length===0||Array.isArray(T.label)&&T.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(J&&!J.contains(T.position))}m(T,J){const Z=this.e.get(J[0]);if(!Z)throw Error("DisposableStore is missing...");const x={label:"",cacheId:J,tooltip:h.MarkdownString.fromStrict(T.tooltip),position:h.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(h.TextEdit.from),kind:T.kind&&h.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?x.label=T.label:x.label=T.label.map(me=>{const Ee={label:me.value};return Ee.tooltip=h.MarkdownString.fromStrict(me.tooltip),F.$nJ.isLocation(me.location)&&(Ee.location=h.location.from(me.location)),me.command&&(Ee.command=this.g.toInternal(me.command,Z)),Ee}),x}}class Y{constructor(T,J){this.e=T,this.f=J,this.d=new c.$U0b("DocumentLink")}async provideLinks(T,J){const Z=this.e.getDocument(T),x=await this.f.provideDocumentLinks(Z,J);if(!(!Array.isArray(x)||x.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(Y.g).map(h.DocumentLink.from)};{const me=this.d.add(x),Ee={links:[],cacheId:me};for(let fe=0;fe<x.length;fe++){if(!Y.g(x[fe]))continue;const Ie=h.DocumentLink.from(x[fe]);Ie.cacheId=[me,fe],Ee.links.push(Ie)}return Ee}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,J){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...T);if(!Z)return;const x=await this.f.resolveDocumentLink(Z,J);if(!(!x||!Y.g(x)))return h.DocumentLink.from(x)}releaseLinks(T){this.d.delete(T)}}class ve{constructor(T,J){this.d=T,this.e=J}async provideColors(T,J){const Z=this.d.getDocument(T),x=await this.e.provideDocumentColors(Z,J);return Array.isArray(x)?x.map(Ee=>({color:h.Color.from(Ee.color),range:h.Range.from(Ee.range)})):[]}async provideColorPresentations(T,J,Z){const x=this.d.getDocument(T),me=h.Range.to(J.range),Ee=h.Color.to(J.color),fe=await this.e.provideColorPresentations(Ee,{document:x,range:me},Z);if(Array.isArray(fe))return fe.map(h.ColorPresentation.from)}}class Se{constructor(T,J){this.d=T,this.e=J}async provideFoldingRanges(T,J,Z){const x=this.d.getDocument(T),me=await this.e.provideFoldingRanges(x,J,Z);if(Array.isArray(me))return me.map(h.FoldingRange.from)}}class ee{constructor(T,J,Z){this.d=T,this.e=J,this.f=Z}async provideSelectionRanges(T,J,Z){const x=this.d.getDocument(T),me=J.map(h.Position.to),Ee=await this.e.provideSelectionRanges(x,me,Z);if(!(0,L.$nf)(Ee))return[];if(Ee.length!==me.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ie=0;Ie<me.length;Ie++){const Pe=[];fe.push(Pe);let qe=me[Ie],Ve=Ee[Ie];for(;;){if(!Ve.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(h.SelectionRange.from(Ve)),!Ve.parent)break;qe=Ve.range,Ve=Ve.parent}}return fe}}class te{constructor(T,J){this.f=T,this.g=J,this.d=new i.$gL(""),this.e=new Map}async prepareSession(T,J,Z){const x=this.f.getDocument(T),me=h.Position.to(J),Ee=await this.g.prepareCallHierarchy(x,me,Z);if(!Ee)return;const fe=this.d.nextId();return this.e.set(fe,new Map),Array.isArray(Ee)?Ee.map(Ie=>this.h(fe,Ie)):[this.h(fe,Ee)]}async provideCallsTo(T,J,Z){const x=this.j(T,J);if(!x)throw new Error("missing call hierarchy item");const me=await this.g.provideCallHierarchyIncomingCalls(x,Z);if(me)return me.map(Ee=>({from:this.h(T,Ee.from),fromRanges:Ee.fromRanges.map(fe=>h.Range.from(fe))}))}async provideCallsFrom(T,J,Z){const x=this.j(T,J);if(!x)throw new Error("missing call hierarchy item");const me=await this.g.provideCallHierarchyOutgoingCalls(x,Z);if(me)return me.map(Ee=>({to:this.h(T,Ee.to),fromRanges:Ee.fromRanges.map(fe=>h.Range.from(fe))}))}releaseSession(T){this.e.delete(T)}h(T,J){const Z=this.e.get(T),x=h.CallHierarchyItem.from(J,T,Z.size.toString(36));return Z.set(x._itemId,J),x}j(T,J){return this.e.get(T)?.get(J)}}class le{constructor(T,J){this.f=T,this.g=J,this.d=new i.$gL(""),this.e=new Map}async prepareSession(T,J,Z){const x=this.f.getDocument(T),me=h.Position.to(J),Ee=await this.g.prepareTypeHierarchy(x,me,Z);if(!Ee)return;const fe=this.d.nextId();return this.e.set(fe,new Map),Array.isArray(Ee)?Ee.map(Ie=>this.h(fe,Ie)):[this.h(fe,Ee)]}async provideSupertypes(T,J,Z){const x=this.j(T,J);if(!x)throw new Error("missing type hierarchy item");const me=await this.g.provideTypeHierarchySupertypes(x,Z);if(me)return me.map(Ee=>this.h(T,Ee))}async provideSubtypes(T,J,Z){const x=this.j(T,J);if(!x)throw new Error("missing type hierarchy item");const me=await this.g.provideTypeHierarchySubtypes(x,Z);if(me)return me.map(Ee=>this.h(T,Ee))}releaseSession(T){this.e.delete(T)}h(T,J){const Z=this.e.get(T),x=h.TypeHierarchyItem.from(J,T,Z.size.toString(36));return Z.set(x._itemId,J),x}j(T,J){return this.e.get(T)?.get(J)}}class X{constructor(T,J,Z,x,me){this.d=T,this.e=J,this.f=Z,this.g=x,this.h=me}async provideDocumentOnDropEdits(T,J,Z,x,me){const Ee=this.e.getDocument(J),fe=h.Position.to(Z),Ie=h.DataTransfer.toDataTransfer(x,async qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,qe)).buffer),Pe=await this.f.provideDocumentDropEdits(Ee,fe,Ie,me);if(Pe)return{id:Pe.id?this.h.identifier.value+"."+Pe.id:this.h.identifier.value,label:Pe.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),priority:Pe.priority??0,insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?h.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class ue{constructor(T,J){this.adapter=T,this.extension=J}}class se{constructor(T,J,Z,x,me,Ee,fe,Ie){this.g=J,this.h=Z,this.j=x,this.k=me,this.l=Ee,this.m=fe,this.n=Ie,this.f=new Map,this.e=T.getProxy(m.$_I.MainThreadLanguageFeatures)}o(T,J){return h.DocumentSelector.from(T,this.g,J)}p(T){return new F.$bJ(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return se.d++}async s(T,J,Z,x,me,Ee=!1){const fe=this.f.get(T);if(!fe||!(fe.adapter instanceof J))return x;const Ie=Date.now();Ee||this.l.trace(`[${fe.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const Pe=Z(fe.adapter,fe.extension);return Promise.resolve(Pe).catch(qe=>{(0,v.$1)(qe)||(this.l.error(`[${fe.extension.identifier.value}] provider FAILED`),this.l.error(qe),this.n.onExtensionError(fe.extension.identifier,qe))}).finally(()=>{Ee||this.l.trace(`[${fe.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),D.CancellationToken.isCancellationToken(me)?(0,f.$hg)(Pe,me):Pe}t(T,J){const Z=this.q();return this.f.set(Z,new ue(T,J)),Z}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,J,Z,x){const me=this.t(new o(this.h,Z),T),Ee=x&&x.label||se.u(T);return this.e.$registerDocumentSymbolProvider(me,this.o(J,T),Ee),this.p(me)}$provideDocumentSymbols(T,J,Z){return this.s(T,o,x=>x.provideDocumentSymbols(b.URI.revive(J),Z),void 0,Z)}registerCodeLensProvider(T,J,Z){const x=this.q(),me=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ue(new s(this.h,this.j.converter,Z),T)),this.e.$registerCodeLensSupport(x,this.o(J,T),me);let Ee=this.p(x);if(me!==void 0){const fe=Z.onDidChangeCodeLenses(Ie=>this.e.$emitCodeLensEvent(me));Ee=F.$bJ.from(Ee,fe)}return Ee}$provideCodeLenses(T,J,Z){return this.s(T,s,x=>x.provideCodeLenses(b.URI.revive(J),Z),void 0,Z)}$resolveCodeLens(T,J,Z){return this.s(T,s,x=>x.resolveCodeLens(J,Z),void 0,void 0)}$releaseCodeLenses(T,J){this.s(T,s,Z=>Promise.resolve(Z.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(T,J,Z){const x=this.t(new d(this.h,Z),T);return this.e.$registerDefinitionSupport(x,this.o(J,T)),this.p(x)}$provideDefinition(T,J,Z,x){return this.s(T,d,me=>me.provideDefinition(b.URI.revive(J),Z,x),[],x)}registerDeclarationProvider(T,J,Z){const x=this.t(new $(this.h,Z),T);return this.e.$registerDeclarationSupport(x,this.o(J,T)),this.p(x)}$provideDeclaration(T,J,Z,x){return this.s(T,$,me=>me.provideDeclaration(b.URI.revive(J),Z,x),[],x)}registerImplementationProvider(T,J,Z){const x=this.t(new l(this.h,Z),T);return this.e.$registerImplementationSupport(x,this.o(J,T)),this.p(x)}$provideImplementation(T,J,Z,x){return this.s(T,l,me=>me.provideImplementation(b.URI.revive(J),Z,x),[],x)}registerTypeDefinitionProvider(T,J,Z){const x=this.t(new S(this.h,Z),T);return this.e.$registerTypeDefinitionSupport(x,this.o(J,T)),this.p(x)}$provideTypeDefinition(T,J,Z,x){return this.s(T,S,me=>me.provideTypeDefinition(b.URI.revive(J),Z,x),[],x)}registerHoverProvider(T,J,Z,x){const me=this.t(new y(this.h,Z),T);return this.e.$registerHoverProvider(me,this.o(J,T)),this.p(me)}$provideHover(T,J,Z,x){return this.s(T,y,me=>me.provideHover(b.URI.revive(J),Z,x),void 0,x)}registerEvaluatableExpressionProvider(T,J,Z,x){const me=this.t(new a(this.h,Z),T);return this.e.$registerEvaluatableExpressionProvider(me,this.o(J,T)),this.p(me)}$provideEvaluatableExpression(T,J,Z,x){return this.s(T,a,me=>me.provideEvaluatableExpression(b.URI.revive(J),Z,x),void 0,x)}registerInlineValuesProvider(T,J,Z,x){const me=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new r(this.h,Z),T);this.e.$registerInlineValuesProvider(Ee,this.o(J,T),me);let fe=this.p(Ee);if(me!==void 0){const Ie=Z.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(me));fe=F.$bJ.from(fe,Ie)}return fe}$provideInlineValues(T,J,Z,x,me){return this.s(T,r,Ee=>Ee.provideInlineValues(b.URI.revive(J),Z,x,me),void 0,me)}registerDocumentHighlightProvider(T,J,Z){const x=this.t(new P(this.h,Z),T);return this.e.$registerDocumentHighlightProvider(x,this.o(J,T)),this.p(x)}$provideDocumentHighlights(T,J,Z,x){return this.s(T,P,me=>me.provideDocumentHighlights(b.URI.revive(J),Z,x),void 0,x)}registerLinkedEditingRangeProvider(T,J,Z){const x=this.t(new N(this.h,Z),T);return this.e.$registerLinkedEditingRangeProvider(x,this.o(J,T)),this.p(x)}$provideLinkedEditingRanges(T,J,Z,x){return this.s(T,N,async me=>{const Ee=await me.provideLinkedEditingRanges(b.URI.revive(J),Z,x);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?se.w(Ee.wordPattern):void 0}},void 0,x)}registerReferenceProvider(T,J,Z){const x=this.t(new U(this.h,Z),T);return this.e.$registerReferenceSupport(x,this.o(J,T)),this.p(x)}$provideReferences(T,J,Z,x,me){return this.s(T,U,Ee=>Ee.provideReferences(b.URI.revive(J),Z,x,me),void 0,me)}registerCodeActionProvider(T,J,Z,x){const me=new C.$jb,Ee=this.t(new q(this.h,this.j.converter,this.k,Z,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(Ee,this.o(J,T),{providedKinds:x?.providedCodeActionKinds?.map(fe=>fe.value),documentation:x?.documentation?.map(fe=>({kind:fe.kind.value,command:this.j.converter.toInternal(fe.command,me)}))},se.u(T),!!Z.resolveCodeAction),me.add(this.p(Ee)),me}$provideCodeActions(T,J,Z,x,me){return this.s(T,q,Ee=>Ee.provideCodeActions(b.URI.revive(J),Z,x,me),void 0,me)}$resolveCodeAction(T,J,Z){return this.s(T,q,x=>x.resolveCodeAction(J,Z),{},void 0)}$releaseCodeActions(T,J){this.s(T,q,Z=>Promise.resolve(Z.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(T,J,Z){const x=this.t(new O(this.h,Z),T);return this.e.$registerDocumentFormattingSupport(x,this.o(J,T),T.identifier,T.displayName||T.name),this.p(x)}$provideDocumentFormattingEdits(T,J,Z,x){return this.s(T,O,me=>me.provideDocumentFormattingEdits(b.URI.revive(J),Z,x),void 0,x)}registerDocumentRangeFormattingEditProvider(T,J,Z){const x=typeof Z.provideDocumentRangesFormattingEdits=="function";x&&(0,E.$_E)(T,"formatMultipleRanges");const me=this.t(new K(this.h,Z),T);return this.e.$registerRangeFormattingSupport(me,this.o(J,T),T.identifier,T.displayName||T.name,x),this.p(me)}$provideDocumentRangeFormattingEdits(T,J,Z,x,me){return this.s(T,K,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(J),Z,x,me),void 0,me)}$provideDocumentRangesFormattingEdits(T,J,Z,x,me){return this.s(T,K,Ee=>Ee.provideDocumentRangesFormattingEdits(b.URI.revive(J),Z,x,me),void 0,me)}registerOnTypeFormattingEditProvider(T,J,Z,x){const me=this.t(new z(this.h,Z),T);return this.e.$registerOnTypeFormattingSupport(me,this.o(J,T),x,T.identifier),this.p(me)}$provideOnTypeFormattingEdits(T,J,Z,x,me,Ee){return this.s(T,z,fe=>fe.provideOnTypeFormattingEdits(b.URI.revive(J),Z,x,me,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(T,J){const Z=this.t(new j(J,this.l),T);return this.e.$registerNavigateTypeSupport(Z,typeof J.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(T,J,Z){return this.s(T,j,x=>x.provideWorkspaceSymbols(J,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(T,J,Z){return this.s(T,j,x=>x.resolveWorkspaceSymbol(J,Z),void 0,void 0)}$releaseWorkspaceSymbols(T,J){this.s(T,j,Z=>Z.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(T,J,Z){const x=this.t(new he(this.h,Z,this.l),T);return this.e.$registerRenameSupport(x,this.o(J,T),he.supportsResolving(Z)),this.p(x)}$provideRenameEdits(T,J,Z,x,me){return this.s(T,he,Ee=>Ee.provideRenameEdits(b.URI.revive(J),Z,x,me),void 0,me)}$resolveRenameLocation(T,J,Z,x){return this.s(T,he,me=>me.resolveRenameLocation(b.URI.revive(J),Z,x),void 0,x)}registerDocumentSemanticTokensProvider(T,J,Z,x){const me=this.t(new ne(this.h,Z),T),Ee=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(me,this.o(J,T),x,Ee);let fe=this.p(me);if(Ee){const Ie=Z.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(Ee));fe=F.$bJ.from(fe,Ie)}return fe}$provideDocumentSemanticTokens(T,J,Z,x){return this.s(T,ne,me=>me.provideDocumentSemanticTokens(b.URI.revive(J),Z,x),null,x)}$releaseDocumentSemanticTokens(T,J){this.s(T,ne,Z=>Z.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,J,Z,x){const me=this.t(new V(this.h,Z),T);return this.e.$registerDocumentRangeSemanticTokensProvider(me,this.o(J,T),x),this.p(me)}$provideDocumentRangeSemanticTokens(T,J,Z,x){return this.s(T,V,me=>me.provideDocumentRangeSemanticTokens(b.URI.revive(J),Z,x),null,x)}registerCompletionItemProvider(T,J,Z,x){const me=this.t(new H(this.h,this.j.converter,Z,this.m,T),T);return this.e.$registerCompletionsProvider(me,this.o(J,T),x,H.supportsResolving(Z),T.identifier),this.p(me)}$provideCompletionItems(T,J,Z,x,me){return this.s(T,H,Ee=>Ee.provideCompletionItems(b.URI.revive(J),Z,x,me),void 0,me)}$resolveCompletionItem(T,J,Z){return this.s(T,H,x=>x.resolveCompletionItem(J,Z),void 0,Z)}$releaseCompletionItems(T,J){this.s(T,H,Z=>Z.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(T,J,Z){const x=new pe(T,this.h,Z,this.j.converter),me=this.t(x,T);return this.e.$registerInlineCompletionsSupport(me,this.o(J,T),x.supportsHandleEvents),this.p(me)}$provideInlineCompletions(T,J,Z,x,me){return this.s(T,ce,Ee=>Ee.provideInlineCompletions(b.URI.revive(J),Z,x,me),void 0,me)}$handleInlineCompletionDidShow(T,J,Z,x){this.s(T,ce,async me=>{me.handleDidShowCompletionItem(J,Z,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,J,Z,x){this.s(T,ce,async me=>{me.handlePartialAccept(J,Z,x)},void 0,void 0)}$freeInlineCompletionsList(T,J){this.s(T,ce,async Z=>{Z.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(T,J,Z,x){const me=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,Ee=this.t(new ge(this.h,Z),T);return this.e.$registerSignatureHelpProvider(Ee,this.o(J,T),me),this.p(Ee)}$provideSignatureHelp(T,J,Z,x,me){return this.s(T,ge,Ee=>Ee.provideSignatureHelp(b.URI.revive(J),Z,x,me),void 0,me)}$releaseSignatureHelp(T,J){this.s(T,ge,Z=>Z.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(T,J,Z){const x=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,me=this.t(new M(this.h,this.j.converter,Z,this.l,T),T);this.e.$registerInlayHintsProvider(me,this.o(J,T),typeof Z.resolveInlayHint=="function",x,se.u(T));let Ee=this.p(me);if(x!==void 0){const fe=Z.onDidChangeInlayHints(Ie=>this.e.$emitInlayHintsEvent(x));Ee=F.$bJ.from(Ee,fe)}return Ee}$provideInlayHints(T,J,Z,x){return this.s(T,M,me=>me.provideInlayHints(b.URI.revive(J),Z,x),void 0,x)}$resolveInlayHint(T,J,Z){return this.s(T,M,x=>x.resolveInlayHint(J,Z),void 0,Z)}$releaseInlayHints(T,J){this.s(T,M,Z=>Z.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(T,J,Z){const x=this.t(new Y(this.h,Z),T);return this.e.$registerDocumentLinkProvider(x,this.o(J,T),typeof Z.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(T,J,Z){return this.s(T,Y,x=>x.provideLinks(b.URI.revive(J),Z),void 0,Z,J.scheme==="output")}$resolveDocumentLink(T,J,Z){return this.s(T,Y,x=>x.resolveLink(J,Z),void 0,void 0,!0)}$releaseDocumentLinks(T,J){this.s(T,Y,Z=>Z.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(T,J,Z){const x=this.t(new ve(this.h,Z),T);return this.e.$registerDocumentColorProvider(x,this.o(J,T)),this.p(x)}$provideDocumentColors(T,J,Z){return this.s(T,ve,x=>x.provideColors(b.URI.revive(J),Z),[],Z)}$provideColorPresentations(T,J,Z,x){return this.s(T,ve,me=>me.provideColorPresentations(b.URI.revive(J),Z,x),void 0,x)}registerFoldingRangeProvider(T,J,Z){const x=this.q(),me=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ue(new Se(this.h,Z),T)),this.e.$registerFoldingRangeProvider(x,this.o(J,T),T.identifier,me);let Ee=this.p(x);if(me!==void 0){const fe=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(me));Ee=F.$bJ.from(Ee,fe)}return Ee}$provideFoldingRanges(T,J,Z,x){return this.s(T,Se,me=>me.provideFoldingRanges(b.URI.revive(J),Z,x),void 0,x)}registerSelectionRangeProvider(T,J,Z){const x=this.t(new ee(this.h,Z,this.l),T);return this.e.$registerSelectionRangeProvider(x,this.o(J,T)),this.p(x)}$provideSelectionRanges(T,J,Z,x){return this.s(T,ee,me=>me.provideSelectionRanges(b.URI.revive(J),Z,x),[],x)}registerCallHierarchyProvider(T,J,Z){const x=this.t(new te(this.h,Z),T);return this.e.$registerCallHierarchyProvider(x,this.o(J,T)),this.p(x)}$prepareCallHierarchy(T,J,Z,x){return this.s(T,te,me=>Promise.resolve(me.prepareSession(b.URI.revive(J),Z,x)),void 0,x)}$provideCallHierarchyIncomingCalls(T,J,Z,x){return this.s(T,te,me=>me.provideCallsTo(J,Z,x),void 0,x)}$provideCallHierarchyOutgoingCalls(T,J,Z,x){return this.s(T,te,me=>me.provideCallsFrom(J,Z,x),void 0,x)}$releaseCallHierarchy(T,J){this.s(T,te,Z=>Promise.resolve(Z.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(T,J,Z){const x=this.t(new le(this.h,Z),T);return this.e.$registerTypeHierarchyProvider(x,this.o(J,T)),this.p(x)}$prepareTypeHierarchy(T,J,Z,x){return this.s(T,le,me=>Promise.resolve(me.prepareSession(b.URI.revive(J),Z,x)),void 0,x)}$provideTypeHierarchySupertypes(T,J,Z,x){return this.s(T,le,me=>me.provideSupertypes(J,Z,x),void 0,x)}$provideTypeHierarchySubtypes(T,J,Z,x){return this.s(T,le,me=>me.provideSubtypes(J,Z,x),void 0,x)}$releaseTypeHierarchy(T,J){this.s(T,le,Z=>Promise.resolve(Z.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(T,J,Z,x){const me=this.q();return this.f.set(me,new ue(new X(this.e,this.h,Z,me,T),T)),this.e.$registerDocumentOnDropEditProvider(me,this.o(J,T),(0,E.$$E)(T,"dropMetadata")?x:void 0),this.p(me)}$provideDocumentOnDropEdits(T,J,Z,x,me,Ee){return this.s(T,X,fe=>Promise.resolve(fe.provideDocumentOnDropEdits(J,b.URI.revive(Z),x,me,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(T,J,Z,x){const me=this.q();return this.f.set(me,new ue(new B(this.e,this.h,Z,me,T),T)),this.e.$registerPasteEditProvider(me,this.o(J,T),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(me)}$prepareDocumentPaste(T,J,Z,x,me){return this.s(T,B,Ee=>Ee.prepareDocumentPaste(b.URI.revive(J),Z,x,me),void 0,me)}$providePasteEdits(T,J,Z,x,me,Ee){return this.s(T,B,fe=>fe.providePasteEdits(J,b.URI.revive(Z),x,me,Ee),void 0,Ee)}static w(T){return{pattern:T.source,flags:(0,k.$wd)(T)}}static y(T){return{decreaseIndentPattern:se.w(T.decreaseIndentPattern),increaseIndentPattern:se.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?se.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?se.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:se.w(T.beforeText),afterText:T.afterText?se.w(T.afterText):void 0,previousLineText:T.previousLineText?se.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(se.z)}setLanguageConfiguration(T,J,Z){const{wordPattern:x}=Z;if(x&&(0,k.$ud)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(J,x):this.h.setWordDefinitionFor(J,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const me=this.q(),Ee={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?se.w(Z.wordPattern):void 0,indentationRules:Z.indentationRules?se.y(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?se.B(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this.e.$setLanguageConfiguration(me,J,Ee),this.p(me)}$setWordDefinitions(T){for(const J of T)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$40b=se,se.d=0}),define(De[291],Ce([1,0,6,13,7,41,17,4]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class k{constructor(L,I,w,D){this.c=I,this.d=w,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(b.$_I.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,I){await this.a.$changeLanguage(L,I);const w=this.c.getDocumentData(L);if(!w)throw new Error(`document '${L.toString()}' NOT found`);return w.document}async tokenAtPosition(L,I){const w=L.version,D=A.Position.from(I),C=await this.a.$tokensAtPosition(L.uri,D),p={type:h.StandardTokenType.Other,range:L.getWordRangeAtPosition(I)??new h.$dJ(I.line,I.character,I.line,I.character)};if(!C)return p;const i={range:A.Range.to(C.range),type:A.TokenType.to(C.type)};return!i.range.contains(I)||w!==L.version?p:i}createLanguageStatusItem(L,I,w){const D=this.f++,C=this.a,p=this.g,i=`${L.identifier.value}/${I}`;if(p.has(i))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(i);const c={selector:w,id:I,name:L.displayName??L.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const v=new m.$jb,f=()=>{u?.dispose(),u=(0,R.$tg)(()=>{v.clear(),this.a.$setLanguageStatus(D,{id:i,name:c.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===h.LanguageStatusSeverity.Error?F.default.Error:c.severity===h.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:c.command&&this.d.toInternal(c.command,v),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},E={dispose(){v.dispose(),u?.dispose(),C.$removeLanguageStatus(D),p.delete(i)},get id(){return c.id},get name(){return c.name},set name(n){c.name=n,f()},get selector(){return c.selector},set selector(n){c.selector=n,f()},get text(){return c.text},set text(n){c.text=n,f()},get detail(){return c.detail},set detail(n){c.detail=n,f()},get severity(){return c.severity},set severity(n){c.severity=n,f()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(n){c.accessibilityInformation=n,f()},get command(){return c.command},set command(n){c.command=n,f()},get busy(){return c.busy},set busy(n){c.busy=n,f()}};return f(),E}}e.$L$b=k}),define(De[107],Ce([1,0,9,11,2,5,18,6,26,20]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=e.$A$b=void 0;let L=e.$A$b=class{constructor(w,D,C){this.f=C,this.d=new Map,this.a=D.getProxy(m.$_I.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===b.$a}getMessage(w,D){const{message:C,args:p,comment:i}=D;if(this.c)return(0,A.$jd)(C,p??{});let c=C;i&&i.length>0&&(c+=`/${Array.isArray(i)?i.join(""):i}`);const u=this.d.get(w)?.contents[c];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,A.$jd)(u??C,p??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let D;const C=await this.g(w);if(!C){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(C),i=JSON.parse(p);D=w.isBuiltin?i.contents?.bundle:i}catch(p){this.f.error(`Failed to load translations for ${w.identifier.value} from ${C}: ${p.message}`);return}D&&this.d.set(w.identifier.value,{contents:D,uri:C})}async g(w){if(w.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return h.URI.revive(D)}return w.l10n?h.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$A$b=L=He([We(0,k.$rL),We(1,g.$bL),We(2,R.$Ni)],L),e.$B$b=(0,F.$lh)("IExtHostLocalizationService")}),define(De[144],Ce([1,0,18,6,26,20,2,73]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=void 0;let k=e.$X_b=class extends b.$Yi{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(D=>(0,m.$Ug)(D))),this.n=I.getProxy(A.$_I.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(R.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.n.$setVisibility(I,w)}m(I,w,D){return new g(this.n,I,w,D)}};e.$X_b=k=He([We(0,F.$bL),We(1,h.$rL)],k);class g extends b.$Ti{constructor(I,w,D,C){super(C?.logLevel==="always"),this.m=I,this.n=w,this.k=!1,this.l=[],this.setLevel(D),this.m.$createLogger(w,C).then(()=>{this.r(this.l),this.k=!0})}g(I,w){const D=[[I,w]];this.k?this.r(D):this.l.push(...D)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(De[108],Ce([1,0,6,5,4,20,22]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=void 0,e.$C$b=(0,A.$lh)("IExtHostManagedSockets");let m=e.$D$b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(b.$_I.MainThreadManagedSockets)}setFactory(I,w){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,D=await this.c.makeConnection(),C=new h.$jb;return this.d.set(w,new g(w,D,C)),C.add((0,h.$ib)(()=>this.d.delete(w))),C.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),C.dispose()})),C.add(D.onDidClose(p=>{this.a.$onDidManagedSocketClose(w,p?.stack??p?.message),C.dispose()})),C.add(D.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(w,R.$Ib.wrap(p)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$D$b=m=He([We(0,F.$bL)],m);class k{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class g extends h.$kb{constructor(I,w,D){super(),this.socketId=I,this.actual=w,this.B(D)}}}),define(De[292],Ce([1,0,6,18,27]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=void 0;function F(m){return m&&m.title}let R=e.$M$b=class{constructor(k,g){this.b=g,this.a=k.getProxy(b.$_I.MainThreadMessageService)}showMessage(k,g,L,I,w){const D={source:{identifier:k.identifier,label:k.displayName||k.name}};let C;typeof I=="string"||F(I)?C=[I,...w]:(D.modal=I?.modal,D.useCustom=I?.useCustom,D.detail=I?.detail,C=w),D.useCustom&&(0,h.$_E)(k,"resolvers");const p=[];for(let i=0;i<C.length;i++){const c=C[i];if(typeof c=="string")p.push({title:c,handle:i,isCloseAffordance:!1});else if(typeof c=="object"){const{title:u,isCloseAffordance:v}=c;p.push({title:u,isCloseAffordance:!!v,handle:i})}else this.b.warn("Invalid message item:",c)}return this.a.$showMessage(g,L,D,p).then(i=>{if(typeof i=="number")return C[i]})}};e.$M$b=R=He([We(1,A.$Ni)],R)}),define(De[293],Ce([1,0,22,3,4,28,11,12,2,30,80,6,37,13,7,61,260,139,8,23,24]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=void 0;class E{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,s,t,d,$){this.q=t,this.r=d,this.s=$,this.f=new Map,this.g=new F.$ji,this.h=new Map,this.j=new A.$5c({onListenerError:u.$Y}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$5c({onListenerError:u.$Y}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$5c({onListenerError:u.$Y}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$5c({onListenerError:u.$Y}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new L.$U0b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=o.getProxy(I.$_I.MainThreadNotebook),this.c=o.getProxy(I.$_I.MainThreadNotebookDocuments),this.d=o.getProxy(I.$_I.MainThreadNotebookEditors),this.i=s.converter,s.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===13){const S=l.notebookEditor?.notebookUri,y=l.cell.handle,r=this.g.get(S)?.getCell(y);if(r)return r.apiCell}if(l&&l.$mid===14){const S=l.uri,y=this.g.get(S);if(y)return y.apiNotebook}return l}}),E.y(s)}getEditorById(o){const s=this.h.get(o);if(!s)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return s}getIdByEditor(o){for(const[s,t]of this.h)if(t.apiEditor===o)return s}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,s){const t=this.g.get(o);if(!t&&!s)throw new Error(`NO notebook document for '${o}'`);return t}static t(o,s){if(!s)return;const t=s.filenamePattern.map(d=>D.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(s.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:s.displayName,filenamePattern:t,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,s,t){const d=E.a++,$=typeof t.onDidChangeCellStatusBarItems=="function"?E.a++:void 0;this.f.set(d,t),this.b.$registerNotebookCellStatusBarItemProvider(d,$,s);let l;return $!==void 0&&(l=t.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent($))),new C.$bJ(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,$),l?.dispose()})}async createNotebookDocument(o){const s=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&D.NotebookData.from(o.content)});return k.URI.revive(s)}async openNotebookDocument(o){const s=this.g.get(o);if(s)return s.apiNotebook;const t=await this.c.$tryOpenNotebook(o),d=this.g.get(k.URI.revive(t));return(0,m.$re)(d?.apiNotebook)}async showNotebookDocument(o,s){k.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let t;typeof s=="object"?t={position:D.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(D.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:t={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,t),$=d&&this.h.get(d)?.apiEditor;if($)return $;throw d?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,s,t,d){const $=this.f.get(o),l=k.URI.revive(s),S=this.g.get(l);if(!S||!$)return;const y=S.getCellFromIndex(t);if(!y)return;const a=await $.provideCellStatusBarItems(y.apiCell,d);if(!a)return;const r=new h.$jb,P=this.p.add([r]),U=(Array.isArray(a)?a:[a]).map(q=>D.NotebookStatusBarItem.from(q,this.i,r));return{cacheId:P,items:U}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,s,t,d,$){if((0,R.$hd)(s))throw new Error("viewType cannot be empty or just whitespace");const l=this.u++;return this.w.set(l,{viewType:s,serializer:t,options:d}),this.b.$registerNotebookSerializer(l,{id:o.identifier,location:o.extensionLocation},s,D.NotebookDocumentContentOptions.from(d),E.t(o,$)),(0,h.$ib)(()=>{this.b.$unregisterNotebookSerializer(l)})}async $dataToNotebook(o,s,t){const d=this.w.get(o);if(!d)throw new Error("NO serializer found");const $=await d.serializer.deserializeNotebook(s.buffer,t);return new p.$Nz(D.NotebookData.from($))}async $notebookToData(o,s,t){const d=this.w.get(o);if(!d)throw new Error("NO serializer found");const $=await d.serializer.serializeNotebook(D.NotebookData.to(s.value),t);return b.$Ib.wrap($)}async $saveNotebook(o,s,t,d,$){const l=k.URI.revive(s),S=this.w.get(o);if(!S)throw new Error("NO serializer found");const y=this.g.get(l);if(!y)throw new Error("Document NOT found");if(y.versionId!==t)throw new Error("Document version mismatch");const a={metadata:(0,f.$Mm)(y.apiNotebook.metadata,U=>!(S.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of y.apiNotebook.getCells()){const q=new C.$AK(U.kind,U.document.getText(),U.document.languageId,U.mime,S.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);q.metadata=(0,f.$Mm)(U.metadata,B=>!(S.options?.transientCellMetadata??{})[B]),a.cells.push(q)}const r=await S.serializer.serializeNotebook(a,$);await this.s.value.writeFile(l,r);const P=await this.s.value.stat(l);return{name:(0,v.$3f)(l),isFile:(P.type&g.FileType.File)!==0,isDirectory:(P.type&g.FileType.Directory)!==0,isSymbolicLink:(P.type&g.FileType.SymbolicLink)!==0,mtime:P.mtime,ctime:P.ctime,size:P.size,readonly:!!((P.permissions??0)&g.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(l.scheme),locked:!!((P.permissions??0)&g.FilePermission.Locked),etag:g.$hk({mtime:P.mtime,size:P.size}),children:void 0}}x(o,s,t){if(this.h.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const d=new c.$t_b(s,this.d,o,t.visibleRanges.map(D.NotebookRange.to),t.selections.map(D.NotebookRange.to),typeof t.viewColumn=="number"?D.ViewColumn.to(t.viewColumn):void 0);this.h.set(s,d)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const t of o.value.removedDocuments){const d=k.URI.revive(t),$=this.g.get(d);$&&($.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(l=>l.document.uri)}),this.n.fire($.apiNotebook));for(const l of this.h.values())l.notebookData.uri.toString()===d.toString()&&this.h.delete(l.id)}if(o.value.addedDocuments){const t=[];for(const d of o.value.addedDocuments){const $=k.URI.revive(d.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const l=new i.$s_b(this.c,this.q,this.r,$,d);t.push(...d.cells.map(S=>i.$r_b.asModelAddData(l.apiNotebook,S))),this.g.get($)?.dispose(),this.g.set($,l),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(l.apiNotebook)}}if(o.value.addedEditors)for(const t of o.value.addedEditors){if(this.h.has(t.id))return;const d=k.URI.revive(t.documentUri),$=this.g.get(d);$&&this.x($,t.id,t)}const s=[];if(o.value.removedEditors)for(const t of o.value.removedEditors){const d=this.h.get(t);d&&(this.h.delete(t),this.k?.id===d.id&&(this.k=void 0),s.push(d))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const t=new Set;this.l.forEach(d=>t.add(d.id));for(const d of this.h.values()){const $=t.has(d.id);d._acceptVisibility($)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static y(o){const s=w.$zL.String.with("notebookType","A notebook type"),t=new w.$BL("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new w.$zL("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>b.$Ib.wrap($))],new w.$AL("Notebook Data",$=>D.NotebookData.to($.value))),d=new w.$BL("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new w.$zL("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new p.$Nz(D.NotebookData.from($)))],new w.$AL("Bytes",$=>$.buffer));o.registerApiCommand(t),o.registerApiCommand(d)}}e.$u_b=E,E.a=0}),define(De[294],Ce([1,0,19,17,21,3,4,28,2,25,18,80,6,37,13,7,105,254,27,61]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=e.$I_b=void 0;let f=e.$I_b=class{constructor(l,S,y,a,r){this.m=S,this.n=y,this.o=a,this.q=r,this.b=new m.$ji,this.c=new m.$ji,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$U0b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new F.$5c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(w.$_I.MainThreadNotebookKernels);const P=new D.$BL("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.$zL("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const U=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:U}}else if(N&&"notebookEditor"in N){const U=this.n.getIdByEditor(N.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return N})],D.$AL.Void);this.o.registerApiCommand(P)}createNotebookController(l,S,y,a,r,P){for(const pe of this.j.values())if(pe.controller.id===S&&g.$El.equals(l.identifier,pe.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,U=this;this.q.trace(`NotebookController[${N}], CREATED by ${l.identifier.value}, ${S}`);const q=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${l.identifier}'`);let B=!1;const O=new R.$jb,K=new F.$5c,z=new F.$5c,j={id:d(l.identifier,S),notebookType:y,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:a||l.identifier.value,preloads:P?P.map(C.NotebookRendererScript.from):[]};let he=r??q,ie;this.a.$addKernel(N,j).catch(pe=>{console.log(pe),B=!0});let ne=0;const V=()=>{if(B)return;const pe=++ne;Promise.resolve().then(()=>{pe===ne&&this.a.$updateKernel(N,j)})},H=new m.$ji,ce={get id(){return S},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:K.event,get label(){return j.label},set label(pe){j.label=pe??l.displayName??l.name,V()},get detail(){return j.detail??""},set detail(pe){j.detail=pe,V()},get description(){return j.description??""},set description(pe){j.description=pe,V()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(pe){j.supportedLanguages=pe,V()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){j.supportsExecutionOrder=pe,V()},get rendererScripts(){return j.preloads?j.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return he},set executeHandler(pe){he=pe??q},get interruptHandler(){return ie},set interruptHandler(pe){ie=pe,j.supportsInterrupt=!!pe,V()},createNotebookCellExecution(pe){if(B)throw new Error("notebook controller is DISPOSED");if(!H.has(pe.notebook.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return U._createNotebookCellExecution(pe,d(l.identifier,this.id))},createNotebookExecution(pe){if((0,u.$_E)(l,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!H.has(pe.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return U._createNotebookExecution(pe,d(l.identifier,this.id))},dispose:()=>{B||(this.q.trace(`NotebookController[${N}], DISPOSED`),B=!0,this.j.delete(N),O.dispose(),K.dispose(),z.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(pe,ye){ye===p.NotebookControllerAffinity2.Hidden&&(0,u.$_E)(l,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(N,pe.uri,ye)},onDidReceiveMessage:z.event,postMessage(pe,ye){return(0,u.$_E)(l,"notebookMessaging"),U.a.$postMessage(N,ye&&U.n.getIdByEditor(ye),pe)},asWebviewUri(pe){return(0,u.$_E)(l,"notebookMessaging"),(0,i.$Zlb)(pe,U.m.remote)}};return this.j.set(N,{extensionId:l.identifier,controller:ce,onDidReceiveMessage:z,onDidChangeSelection:K,associatedNotebooks:H}),ce}getIdByController(l){for(const[S,y]of this.j)if(y.controller===l)return d(y.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,S){const y=this.f++,a=this;this.q.trace(`NotebookControllerDetectionTask[${y}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(y,S);const r={dispose:()=>{this.e.delete(y),a.a.$removeKernelDetectionTask(y)}};return this.e.set(y,r),r}registerKernelSourceActionProvider(l,S,y){const a=this.h++,r=typeof y.onDidChangeNotebookKernelSourceActions=="function"?a:void 0,P=this;this.g.set(a,y),this.q.trace(`NotebookKernelSourceActionProvider[${a}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(a,a,S);let N;return r!==void 0&&(N=y.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(r))),{dispose:()=>{this.g.delete(a),P.a.$removeKernelSourceActionProvider(a,a),N?.dispose()}}}async $provideKernelSourceActions(l,S){const y=this.g.get(l);if(y){const a=new R.$jb;return this.i.add([a]),(await y.provideNotebookKernelSourceActions(S)??[]).map(P=>C.NotebookKernelSourceAction.from(P,this.o.converter,a))}return[]}$acceptNotebookAssociation(l,S,y){const a=this.j.get(l);if(a){const r=this.n.getNotebookDocument(k.URI.revive(S));y?a.associatedNotebooks.set(r.uri,!0):a.associatedNotebooks.delete(r.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,r.uri.toString(),y),a.onDidChangeSelection.fire({selected:y,notebook:r.apiNotebook})}}async $executeCells(l,S,y){const a=this.j.get(l);if(!a)return;const r=this.n.getNotebookDocument(k.URI.revive(S)),P=[];for(const N of y){const U=r.getCell(N);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,r.uri.toString(),P.length),await a.controller.executeHandler.call(a.controller,P,r.apiNotebook,a.controller)}catch(N){this.q.error(`NotebookController[${l}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(l,S,y){const a=this.j.get(l);if(!a)return;const r=this.n.getNotebookDocument(k.URI.revive(S));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,r.apiNotebook);else for(const P of y){const N=r.getCell(P);N&&this.b.get(N.uri)?.cancel()}if(a.controller.interruptHandler){const P=this.c.get(r.uri);y.length&&Array.isArray(P)&&P.length&&P.forEach(N=>N.dispose())}}$acceptKernelMessageFromRenderer(l,S,y){const a=this.j.get(l);if(!a)return;const r=this.n.getEditorById(S);a.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:y}))}$cellExecutionChanged(l,S,y){const r=this.n.getNotebookDocument(k.URI.revive(l)).getCell(S);if(r){const P=y?C.NotebookCellExecutionState.to(y):p.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:r.apiCell,state:P})}}_createNotebookCellExecution(l,S){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!a)throw new Error("invalid cell");if(this.b.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const r=new n(S,a,this.a);this.b.set(a.uri,r);const P=r.onDidChangeState(()=>{r.state===E.Resolved&&(r.dispose(),P.dispose(),this.b.delete(a.uri))});return r.asApiObject()}_createNotebookExecution(l,S){const y=this.n.getNotebookDocument(l.uri),a=l.getCells().find(N=>{const U=y.getCellFromApiCell(N);return U&&this.b.has(U.uri)});if(a)throw new Error(`duplicate cell execution for ${a.document.uri}`);if(this.c.has(y.uri))throw new Error(`duplicate notebook execution for ${y.uri}`);const r=new s(S,y,this.a),P=r.onDidChangeState(()=>{r.state===o.Resolved&&(r.dispose(),P.dispose(),this.c.delete(y.uri))});return this.c.set(y.uri,[r,P]),r.asApiObject()}};e.$I_b=f=He([We(4,L.$Ni)],f);var E;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(E||(E={}));class n extends R.$kb{get state(){return this.f}constructor(l,S,y){super(),this.j=S,this.k=y,this.b=n.a++,this.c=new F.$5c,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new h.$bd),this.h=new t(10,a=>this.m(a)),this.i=S.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const S=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new v.$Nz(S))}n(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let S=this.j;if(l&&(S=this.j.notebook.getCellFromApiCell(l)),!S)throw new Error("INVALID cell");return S.handle}s(l){return l.map(S=>{const y=p.$DK.ensureUniqueMimeTypes(S.items,!0);return y===S.items?C.NotebookCellOutput.from(S):C.NotebookCellOutput.from({items:y,id:S.id,metadata:S.metadata})})}async t(l,S,y){const a=this.r(S),r=this.s((0,b.$Gf)(l));return this.l({editType:c.CellExecutionUpdateType.Output,cellHandle:a,append:y,outputs:r})}async w(l,S,y){return l=p.$DK.ensureUniqueMimeTypes((0,b.$Gf)(l),!0),this.l({editType:c.CellExecutionUpdateType.OutputItems,items:l.map(C.NotebookCellOutputItem.from),outputId:S.id,append:y})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(y){l.i=y,l.m([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(y){if(l.f===E.Resolved||l.f===E.Started)throw new Error("Cannot call start again");l.f=E.Started,l.c.fire(),l.m({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:y})},end(y,a){if(l.f===E.Resolved)throw new Error("Cannot call resolve twice");l.f=E.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new v.$Nz({runEndTime:a,lastRunSuccess:y}))},clearOutput(y){return l.n(),l.t([],y,!1)},appendOutput(y,a){return l.n(),l.t(y,a,!0)},replaceOutput(y,a){return l.n(),l.t(y,a,!1)},appendOutputItems(y,a){return l.n(),l.w(y,a,!0)},replaceOutputItems(y,a){return l.n(),l.w(y,a,!1)}})}}n.a=0;var o;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(o||(o={}));class s extends R.$kb{get state(){return this.f}constructor(l,S,y){super(),this.h=S,this.i=y,this.b=s.a++,this.c=new F.$5c,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new h.$bd),this.i.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===o.Resolved||this.f===o.Started)throw new Error("Cannot call start again");this.f=o.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===o.Resolved)throw new Error("Cannot call resolve twice");this.f=o.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}s.a=0;class t{constructor(l,S){this.e=l,this.f=S,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.$Lg,this.b=Date.now(),(0,A.$sg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>l.complete())}}function d($,l){return`${$.value}/${l}`}e.$J_b=d}),define(De[295],Ce([1,0,3,6,139]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;class F{constructor(m,k){this.c=k,this.a=new Map,this.b=m.getProxy(A.$_I.MainThreadNotebookRenderers)}$postRendererMessage(m,k,g){const L=this.c.getEditorById(m);this.a.get(k)?.fire({editor:L.apiEditor,message:g})}createRendererMessaging(m,k){if(!m.contributes?.notebookRenderer?.some(L=>L.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(L,I,w)=>this.d(k).event(L,I,w),postMessage:(L,I)=>{h.$t_b.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const w=I&&h.$t_b.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,k,L)}}}d(m){let k=this.a.get(m);return k||(k=new b.$5c({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(m)}}),this.a.set(m,k),k)}}e.$K_b=F}),define(De[296],Ce([1,0,4,12,2,27,6]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class m{constructor(g){this.b=new Map,this.a=g.getProxy(R.$_I.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,L,I){if((0,F.$_E)(g,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,I),this.a.$registerProfileContentHandler(L,I.name,I.description,g.identifier.value),(0,b.$ib)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(g,L,I,w){const D=this.b.get(g);if(!D)throw new Error(`Unknown handler with id: ${g}`);return D.saveProfile(L,I,w)}async $readProfile(g,L,I){const w=this.b.get(g);if(!w)throw new Error(`Unknown handler with id: ${g}`);return w.readProfile((0,A.$ge)(L)?L:h.URI.revive(L),I)}}e.$O_b=m}),define(De[297],Ce([1,0,2,6,17,13]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;class R{constructor(k,g){this.d=g,this.c=new Map,this.b=k.getProxy(A.$_I.MainThreadQuickDiff)}$provideOriginalResource(k,g,L){const I=b.URI.revive(g),w=this.c.get(k);return w?(0,h.$kg)(()=>w.provideOriginalResource(I,L)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(k,g,L,I){const w=R.a++;return this.c.set(w,g),this.b.$registerQuickDiffProvider(w,F.DocumentSelector.from(k,this.d),L,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$P_b=R,R.a=0}),define(De[298],Ce([1,0,21,3,4,6,2,7,8,19,41,55,27,13]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;function C(p,i,c){const u=p.getProxy(F.$_I.MainThreadQuickOpen);class v{constructor(l,S){this.e=new Map,this.f=0,this.a=l,this.b=S}showQuickPick(l,S,y,a=b.CancellationToken.None){this.c=void 0;const r=Promise.resolve(S),P=++this.f,N=u.$show(P,{title:y?.title,placeHolder:y?.placeHolder,matchOnDescription:y?.matchOnDescription,matchOnDetail:y?.matchOnDetail,ignoreFocusLost:y?.ignoreFocusOut,canPickMany:y?.canPickMany},a),U={},q=N.then(()=>U);return Promise.race([q,r]).then(B=>{if(B===U)return;const O=(0,w.$$E)(l,"quickPickItemTooltip"),K=(0,w.$$E)(l,"quickPickItemIcon");return r.then(z=>{const j=[];for(let he=0;he<z.length;he++){const ie=z[he];if(typeof ie=="string")j.push({label:ie,handle:he});else if(ie.kind===m.QuickPickItemKind.Separator)j.push({type:"separator",label:ie.label});else{ie.tooltip&&!O&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`),ie.iconPath&&!K&&console.warn(`Extension '${l.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ne=ie.iconPath&&K?s(ie.iconPath):void 0;j.push({label:ie.label,iconPath:ne?.iconPath,iconClass:ne?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:O?D.MarkdownString.fromStrict(ie.tooltip):void 0,handle:he})}}return y&&typeof y.onDidSelectItem=="function"&&(this.c=he=>{y.onDidSelectItem(z[he])}),u.$setItems(P,j),N.then(he=>{if(typeof he=="number")return z[he];if(Array.isArray(he))return he.map(ie=>z[ie])})})}).then(void 0,B=>{if(!(0,k.$1)(B))return u.$setError(P,B),Promise.reject(B)})}$onItemSelected(l){this.c?.(l)}showInput(l,S=b.CancellationToken.None){return this.d=l?.validateInput,u.$input(l,typeof this.d=="function",S).then(void 0,y=>{if(!(0,k.$1)(y))return Promise.reject(y)})}async $validateInput(l){if(!this.d)return;const S=await this.d(l);if(!S||typeof S=="string")return S;let y;switch(S.severity){case m.InputBoxValidationSeverity.Info:y=L.default.Info;break;case m.InputBoxValidationSeverity.Warning:y=L.default.Warning;break;case m.InputBoxValidationSeverity.Error:y=L.default.Error;break;default:y=S.message?L.default.Error:L.default.Ignore;break}return{content:S.message,severity:y}}async showWorkspaceFolderPick(l,S=b.CancellationToken.None){const y=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!y)return;const a=await this.a.getWorkspaceFolders2();if(a)return a.find(r=>r.uri.toString()===y.uri.toString())}createQuickPick(l){const S=new t(l,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(l){const S=new d(l,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(l,S){this.e.get(l)?._fireDidChangeValue(S)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,S){const y=this.e.get(l);y instanceof t&&y._fireDidChangeActive(S)}$onDidChangeSelection(l,S){const y=this.e.get(l);y instanceof t&&y._fireDidChangeSelection(S)}$onDidTriggerButton(l,S){this.e.get(l)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(l,S,y){const a=this.e.get(l);a instanceof t&&a._fireDidTriggerItemButton(S,y)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class f{constructor(l,S){this.x=l,this.y=S,this._id=t.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.$5c,this.q=new A.$5c,this.r=new A.$5c,this.s=new A.$5c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((S,y)=>{const a=S===m.$wK.Back?-1:y;this.o.set(a,S)}),this.z({buttons:l.map((S,y)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===m.$wK.Back?-1:y}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const S=this.o.get(l);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$fb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(l){if(!this.v){for(const S of Object.keys(l)){const y=l[S];this.u[S]=y===void 0?null:y}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}f.a=1;function E($){if($ instanceof m.$9J)return{id:$.id};const l=o($),S=n($);return{dark:typeof l=="string"?R.URI.file(l):l,light:typeof S=="string"?R.URI.file(S):S}}function n($){return typeof $=="object"&&"light"in $?$.light:$}function o($){return typeof $=="object"&&"dark"in $?$.dark:$}function s($){const l=E($);let S,y;return"id"in l?y=I.ThemeIcon.asClassName(l):S=l,{iconPath:S,iconClass:y}}class t extends f{constructor(l,S){super(l.identifier,S),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.$5c,this.L=[],this.M=new A.$5c,this.N=new A.$5c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((r,P)=>{this.C.set(P,r),this.D.set(r,P)});const S=(0,w.$$E)(this.O,"quickPickItemTooltip"),y=(0,w.$$E)(this.O,"quickPickItemIcon"),a=[];for(let r=0;r<l.length;r++){const P=l[r];if(P.kind===m.QuickPickItemKind.Separator)a.push({type:"separator",label:P.label});else{P.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),P.iconPath&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=P.iconPath&&y?s(P.iconPath):void 0;a.push({handle:r,label:P.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,tooltip:S?D.MarkdownString.fromStrict(P.tooltip):void 0,buttons:P.buttons?.map((U,q)=>({...s(U.iconPath),tooltip:U.tooltip,handle:q}))})}}this.z({items:a})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(l){const S=(0,g.$jf)(l.map(y=>this.C.get(y)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(l){const S=(0,g.$jf)(l.map(y=>this.C.get(y)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(l,S){const y=this.C.get(l);if(!y||!y.buttons||!y.buttons.length)return;const a=y.buttons[S];a&&this.N.fire({button:a,item:y})}}class d extends f{constructor(l,S){super(l.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:L.default.Error}):this.z({validationMessage:l.message,severity:l.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new v(i,c)}e.$Q$b=C});var Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b};define(De[299],Ce([1,0,2,3,66,4,17,6,19,114,18,25,55,13,27,16]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p){"use strict";var i,c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=e.$R$b=void 0;function v(a){if(a)return typeof a.iconPath=="string"?b.URI.file(a.iconPath):b.URI.isUri(a.iconPath)||w.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function f(a,r){if(!a.iconPath&&!r.iconPath)return 0;if(a.iconPath){if(!r.iconPath)return 1}else return-1;const P=typeof a.iconPath=="string"?a.iconPath:b.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,N=typeof r.iconPath=="string"?r.iconPath:b.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,g.$6p)(P,N)}function E(a,r){let P=0;if(a.strikeThrough!==r.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==r.faded)return a.faded?1:-1;if(a.tooltip!==r.tooltip)return(a.tooltip||"").localeCompare(r.tooltip||"");if(P=f(a,r),P!==0)return P;if(a.light&&r.light)P=f(a.light,r.light);else{if(a.light)return 1;if(r.light)return-1}if(P!==0)return P;if(a.dark&&r.dark)P=f(a.dark,r.dark);else{if(a.dark)return 1;if(r.dark)return-1}return P}function n(a,r){if(a.command!==r.command)return a.command<r.command?-1:1;if(a.title!==r.title)return a.title<r.title?-1:1;if(a.tooltip!==r.tooltip){if(a.tooltip!==void 0&&r.tooltip!==void 0)return a.tooltip<r.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(a.arguments===r.arguments)return 0;if(a.arguments)if(r.arguments){if(a.arguments.length!==r.arguments.length)return a.arguments.length-r.arguments.length}else return 1;else return-1;for(let P=0;P<a.arguments.length;P++){const N=a.arguments[P],U=r.arguments[P];if(N!==U)return N<U?-1:1}return 0}function o(a,r){let P=(0,g.$6p)(a.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(P!==0)return P;if(a.command&&r.command)P=n(a.command,r.command);else{if(a.command)return 1;if(r.command)return-1}if(P!==0)return P;if(a.decorations&&r.decorations)P=E(a.decorations,r.decorations);else{if(a.decorations)return 1;if(r.decorations)return-1}return P}function s(a,r){for(let P=0;P<a.length;P++)if(a[P]!==r[P])return!1;return!0}function t(a,r){return a.command===r.command&&a.title===r.title&&a.tooltip===r.tooltip&&(a.arguments&&r.arguments?s(a.arguments,r.arguments):a.arguments===r.arguments)}function d(a,r){return(0,k.$$e)(a,r,t)}class ${get value(){return this.d}set value(r){r=r??"",Te(this,i,"f").$setInputBoxValue(this.l,r),this.n(r)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(r){Te(this,i,"f").$setInputBoxPlaceholder(this.l,r),this.f=r}get validateInput(){return(0,C.$_E)(this.k,"scmValidation"),this.g}set validateInput(r){if((0,C.$_E)(this.k,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=r,Te(this,i,"f").$setValidationProviderIsEnabled(this.l,!!r)}get enabled(){return this.h}set enabled(r){r=!!r,this.h!==r&&(this.h=r,Te(this,i,"f").$setInputBoxEnablement(this.l,r))}get visible(){return this.j}set visible(r){r=!!r,this.j!==r&&(this.j=r,Te(this,i,"f").$setInputBoxVisibility(this.l,r))}get document(){return(0,C.$_E)(this.k,"scmTextDocument"),Te(this,c,"f").getDocument(this.m)}constructor(r,P,N,U,q){this.k=r,this.l=U,this.m=q,i.set(this,void 0),c.set(this,void 0),this.d="",this.e=new A.$5c,this.f="",this.h=!0,this.j=!0,Ze(this,c,P,"f"),Ze(this,i,N,"f")}showValidationMessage(r,P){(0,C.$_E)(this.k,"scmValidation"),Te(this,i,"f").$showValidationMessage(this.l,r,P)}$onInputBoxValueChange(r){this.n(r)}n(r){this.d=r,this.e.fire(r)}}e.$R$b=$,i=new WeakMap,c=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(r){this.v=r,this.q.$updateGroupLabel(this.t,this.handle,r)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(r){this.p=r,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(r){this.f=[...r],this.k.fire()}constructor(r,P,N,U,q){this.q=r,this.s=P,this.t=N,this.u=U,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.$5c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.$5c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(r){return this.g.get(r)}$executeResourceCommand(r,P){const N=this.h.get(r);return N?(0,R.$kg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this.f].sort(o),N=(0,k.$ff)(this.o,r,o).map(B=>{const O=B.toInsert.map(K=>{const z=this.e++;this.g.set(z,K);const j=K.resourceUri;let he;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"){const Y=new F.$jb;he=this.s.converter.toInternal(K.command,Y),this.j.set(z,Y)}else this.h.set(z,K.command);const ie=v(K.decorations),ne=K.decorations&&v(K.decorations.light)||ie,V=K.decorations&&v(K.decorations.dark)||ie,H=[ne,V],ce=K.decorations&&K.decorations.tooltip||"",pe=K.decorations&&!!K.decorations.strikeThrough,ye=K.decorations&&!!K.decorations.faded,ge=K.contextValue||"";return{rawResource:[z,j,H,ce,pe,ye,ge,he],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:O}}),U=N.map(({start:B,deleteCount:O,toInsert:K})=>[B,O,K.map(z=>z.rawResource)]),q=N.reverse();for(const{start:B,deleteCount:O,toInsert:K}of q){const z=K.map(he=>he.handle),j=this.n.splice(B,O,...z);for(const he of j)this.g.delete(he),this.h.delete(he),this.j.get(he)?.dispose(),this.j.delete(he)}return this.o=r,U}dispose(){this.l=!0,this.m.fire()}}l.d=0;class S{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(r){this.g!==r&&(this.g=r,Te(this,u,"f").$updateSourceControl(this.t,{count:r}))}get quickDiffProvider(){return this.h}set quickDiffProvider(r){this.h=r;let P;(0,C.$$E)(this.u,"quickDiffProvider")&&(P=r?.label),Te(this,u,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!r,quickDiffLabel:P})}get commitTemplate(){return this.j}set commitTemplate(r){r!==this.j&&(this.j=r,Te(this,u,"f").$updateSourceControl(this.t,{commitTemplate:r}))}get acceptInputCommand(){return this.l}set acceptInputCommand(r){this.k.value=new F.$jb,this.l=r;const P=this.v.converter.toInternal(r,this.k.value);Te(this,u,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,C.$_E)(this.u,"scmActionButton"),this.n}set actionButton(r){(0,C.$_E)(this.u,"scmActionButton"),this.m.value=new F.$jb,this.n=r;const P=r!==void 0?{command:this.v.converter.toInternal(r.command,this.m.value),secondaryCommands:r.secondaryCommands?.map(N=>N.map(U=>this.v.converter.toInternal(U,this.m.value))),description:r.description,enabled:r.enabled}:void 0;Te(this,u,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(r){if(this.p&&r&&d(this.p,r))return;this.o.value=new F.$jb,this.p=r;const P=(r||[]).map(N=>this.v.converter.toInternal(N,this.o.value));Te(this,u,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(r,P,N,U,q,B,O){this.u=r,this.v=U,this.w=q,this.x=B,this.y=O,u.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new F.$lb,this.l=void 0,this.m=new F.$lb,this.o=new F.$lb,this.p=void 0,this.q=!1,this.s=new A.$5c,this.onDidChangeSelection=this.s.event,this.t=S.d++,this.z=new Map,this.A=new Set,Ze(this,u,N,"f");const K=b.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${q}/scm${this.t}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new $(r,P,Te(this,u,"f"),this.t,K),Te(this,u,"f").$registerSourceControl(this.t,q,B,O,K)}createResourceGroup(r,P){const N=new l(Te(this,u,"f"),this.v,this.t,r,P),U=A.Event.once(N.onDidDispose)(()=>this.z.delete(N));return this.z.set(N,U),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const r=[],P=[];for(const[N,U]of this.z){U.dispose();const q=N.onDidUpdateResourceStates(()=>{this.A.add(N),this.eventuallyUpdateResourceStates()});A.Event.once(N.onDidDispose)(()=>{this.A.delete(N),q.dispose(),this.e.delete(N.handle),Te(this,u,"f").$unregisterGroup(this.t,N.handle)}),r.push([N.handle,N.id,N.label,N.features]);const B=N._takeResourceStateSnapshot();B.length>0&&P.push([N.handle,B]),this.e.set(N.handle,N)}Te(this,u,"f").$registerGroups(this.t,r,P),this.z.clear()}eventuallyUpdateResourceStates(){const r=[];this.A.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&r.push([P.handle,N])}),r.length>0&&Te(this,u,"f").$spliceResourceStates(this.t,r),this.A.clear()}getResourceGroup(r){return this.e.get(r)}setSelectionState(r){this.q=r,this.s.fire(r)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(r=>r.dispose()),Te(this,u,"f").$unregisterSourceControl(this.t)}}u=new WeakMap,S.d=0,He([(0,h.$Qg)(100)],S.prototype,"eventuallyAddResourceGroups",null),He([(0,h.$Qg)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=e.$S$b=class Ln{get onDidChangeActiveProvider(){return this.j.event}constructor(r,P,N,U){this.l=P,this.m=N,this.n=U,this.g=new Map,this.h=new I.$Gl,this.j=new A.$5c,this.e=r.getProxy(m.$_I.MainThreadSCM),this.f=r.getProxy(m.$_I.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const B=this.g.get(q.sourceControlHandle);if(!B)return q;const O=B.getResourceGroup(q.groupHandle);return O?O.getResourceState(q.handle):q}else if(q&&q.$mid===4){const B=this.g.get(q.sourceControlHandle);return B?B.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const B=this.g.get(q.handle);return B||q}return q}})}createSourceControl(r,P,N,U){this.n.trace("ExtHostSCM#createSourceControl",r.identifier.value,P,N,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const q=Ln.d++,B=new S(r,this.m,this.e,this.l,P,N,U);this.g.set(q,B);const O=this.h.get(r.identifier)||[];return O.push(B),this.h.set(r.identifier,O),B}getLastInputBox(r){this.n.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const P=this.h.get(r.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(r,P,N){const U=b.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",r,U.toString());const q=this.g.get(r);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$kg)(()=>q.quickDiffProvider.provideOriginalResource(U,N)).then(B=>B||null)}$onInputBoxValueChange(r,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",r);const N=this.g.get(r);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(r,P,N,U){this.n.trace("ExtHostSCM#$executeResourceCommand",r,P,N);const q=this.g.get(r);if(!q)return Promise.resolve(void 0);const B=q.getResourceGroup(P);return B?B.$executeResourceCommand(N,U):Promise.resolve(void 0)}$validateInput(r,P,N){this.n.trace("ExtHostSCM#$validateInput",r);const U=this.g.get(r);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$kg)(()=>U.inputBox.validateInput(P,N)).then(q=>{if(!q)return Promise.resolve(void 0);const B=D.MarkdownString.fromStrict(q.message);return B?Promise.resolve([B,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this.g.get(r)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=r,Promise.resolve(void 0)}};y.d=0,e.$S$b=y=He([We(3,L.$Ni)],y)}),define(De[109],Ce([1,0,6,3,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=e.$x$b=void 0;class F{constructor(m){this.b=new A.$5c,this.onDidChangePassword=this.b.event,this.a=m.getProxy(b.$_I.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,k){return this.a.$getPassword(m,k)}store(m,k,g){return this.a.$setPassword(m,k,g)}delete(m,k){return this.a.$deletePassword(m,k)}}e.$x$b=F,e.$y$b=(0,h.$lh)("IExtHostSecretState")}),define(De[300],Ce([1,0,6,7]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;class h{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(b.$_I.MainThreadSemanticSimilarity)}async $provideSimilarityScore(R,m,k,g){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const L=this.a.get(R);if(!L)throw new Error("Semantic similarity provider not found");return await L.provideSimilarityScore(m,k,g)}registerSemanticSimilarityProvider(R,m){const k=this.b;return this.b++,this.a.set(k,m),this.c.$registerSemanticSimilarityProvider(k),new A.$bJ(()=>{this.c.$unregisterSemanticSimilarityProvider(k),this.a.delete(k)})}}e.$T_b=h}),define(De[301],Ce([1,0,6,13,2]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0;class F{constructor(m,k){this.d=k,this.c=new Map,this.b=m.getProxy(b.$_I.MainThreadShare)}async $provideShare(m,k,g){return await this.c.get(m)?.provideShare({selection:A.Range.to(k.selection),resourceUri:h.URI.revive(k.resourceUri)},g)??void 0}registerShareProvider(m,k){const g=F.a++;return this.c.set(g,k),this.b.$registerShareProvider(g,A.DocumentSelector.from(m,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$V_b=F,F.a=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[302],Ce([1,0,7,6,194,4,13,12]),function(re,e,b,A,h,F,R,m){"use strict";var k,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=e.$T$b=void 0;class L{constructor(C,p,i,c,u,v=b.StatusBarAlignment.Left,f){if(k.set(this,void 0),g.set(this,void 0),this.i=!1,this.k="",this.q=new F.$jb,Ze(this,k,C,"f"),Ze(this,g,p,"f"),u&&c){this.c=(0,b.$MJ)(c.identifier,u);const E=i.get(this.c);E&&(v=E.alignLeft?b.StatusBarAlignment.Left:b.StatusBarAlignment.Right,f=E.priority,this.j=!0,this.name=E.name,this.text=E.text,this.tooltip=E.tooltip,this.command=E.command,this.accessibilityInformation=E.accessibilityInformation)}else this.c=String(L.a++);this.e=c,this.f=u,this.g=v,this.h=this.u(f)}u(C){if((0,m.$ke)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!L.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new F.$jb,typeof C=="string"?this.r={fromApi:C,internal:Te(this,g,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Te(this,g,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Te(this,k,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let p;this.m?p=this.m:p=(0,h.localize)(0,null,this.e.displayName||this.e.name);let i=this.n;this.o&&(i=L.b.get(this.o.id));const c=R.MarkdownString.fromStrict(this.l);Te(this,k,"f").$setEntry(this.c,C,this.e?.identifier.value,p,this.k,c,this.r?.internal,i,this.o,this.g===b.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$T$b=L,k=new WeakMap,g=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new b.$0J("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new b.$0J("statusBarItem.warningForeground")]]);class I{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",b.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const p={message:C};return this.b.unshift(p),this.c(),new b.$bJ(()=>{const i=this.b.indexOf(p);i>=0&&(this.b.splice(i,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class w{constructor(C,p){this.e=new Map,this.a=C.getProxy(A.$_I.MainThreadStatusBar),this.b=p,this.c=new I(this)}$acceptStaticEntries(C){for(const p of C)this.e.set(p.entryId,p)}createStatusBarEntry(C,p,i,c){return new L(this.a,this.b,this.e,C,p,i,c)}setStatusBarMessage(C,p){const i=this.c.setMessage(C);let c;return typeof p=="number"?c=setTimeout(()=>i.dispose(),p):typeof p<"u"&&p.then(()=>i.dispose(),()=>i.dispose()),new b.$bJ(()=>{i.dispose(),clearTimeout(c)})}}e.$U$b=w}),define(De[110],Ce([1,0,6,3,5]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=e.$l$b=void 0;class F{constructor(m,k){this.c=k,this.b=new A.$5c,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(b.$_I.MainThreadStorage)}registerExtensionStorageKeysToSync(m,k){this.a.$registerExtensionStorageKeysToSync(m,k)}async initializeExtensionStorage(m,k,g){const L=await this.a.$initializeExtensionStorage(m,k);let I;return L&&(I=this.d(m,k,L)),I||g}setValue(m,k,g){return this.a.$setValue(m,k,g)}$acceptValue(m,k,g){const L=this.d(m,k,g);L&&this.b.fire({shared:m,key:k,value:L})}d(m,k,g){try{return JSON.parse(g)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${m}): ${L}`)}}}e.$l$b=F,e.$m$b=(0,h.$lh)("IExtHostStorage")}),define(De[84],Ce([1,0,5,26,18,64,2]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=e.$r$b=void 0,e.$r$b=(0,b.$lh)("IExtensionStoragePaths");let m=e.$s$b=class{constructor(g,L,I){this.d=L,this.f=I,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,L=await this.g(g);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$s$b=m=He([We(0,A.$rL),We(1,h.$Ni),We(2,F.$q$b)],m)}),define(De[43],Ce([1,0,3,6,5,2,20,4,7,196,8,236,21,33,237,55,12,17,13,27]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=e.$u$b=e.$t$b=void 0,e.$t$b=(0,h.$lh)("IExtHostTerminalService");class f{constructor(a,r,P,N){this.j=a,this._id=r,this.k=P,this.l=N,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.k=Object.freeze(this.k),this.b=new Promise(q=>this.f=q);const U=this;this.value={get name(){return U.l||""},get processId(){return U.b},get creationOptions(){return U.k},get exitStatus(){return U.h},get state(){return U.i},sendText(q,B=!0){U.n(),U.j.$sendText(U._id,q,B)},show(q){U.n(),U.j.$show(U._id,q)},hide(){U.n(),U.j.$hide(U._id)},dispose(){U.a||(U.a=!0,U.j.$dispose(U._id))},get dimensions(){if(!(U.d===void 0||U.g===void 0))return{columns:U.d,rows:U.g}}}}async create(a,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.j.$createTerminal(this._id,{name:a.name,shellPath:(0,i.$ye)(a.shellPath),shellArgs:(0,i.$ye)(a.shellArgs),cwd:(0,i.$ye)(a.cwd),env:(0,i.$ye)(a.env),icon:(0,i.$ye)($(a.iconPath)),color:p.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,i.$ye)(a.message),strictEnv:(0,i.$ye)(a.strictEnv),hideFromUser:(0,i.$ye)(a.hideFromUser),isFeatureTerminal:(0,i.$ye)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,i.$ye)(r?.useShellEnvironment),location:r?.location||this.m(a.location,r?.resolvedExtHostIdentifier),isTransient:(0,i.$ye)(a.isTransient)})}async createExtensionTerminal(a,r,P,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.j.$createTerminal(this._id,{name:this.l,isExtensionCustomPtyTerminal:!0,icon:P,color:p.ThemeColor.isThemeColor(N)?N.id:void 0,location:this.m(a,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}m(a,r){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in a?{viewColumn:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}n(){if(this.a)throw new Error("Terminal has already been disposed")}set name(a){this.l=a}setExitStatus(a,r){this.h=Object.freeze({code:a,reason:r})}setDimensions(a,r){return a===this.d&&r===this.g||a===0||r===0?!1:(this.d=a,this.g=r,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}_setProcessId(a){this.f?(this.f(a),this.f=void 0):this.b.then(r=>{r!==a&&(this.b=Promise.resolve(a))})}}e.$u$b=f;class E{get onProcessReady(){return this.b.event}constructor(a){this.g=a,this.id=0,this.shouldPersist=!1,this.a=new b.$5c,this.onProcessData=this.a.event,this.b=new b.$5c,this.d=new b.$5c,this.onDidChangeProperty=this.d.event,this.f=new b.$5c,this.onProcessExit=this.f.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(a){this.g.handleInput?.(a)}resize(a,r){this.g.setDimensions?.({columns:a,rows:r})}clearBuffer(){}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(a||void 0),a&&this.g.setDimensions?.(a),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,o=e.$v$b=class extends m.$kb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(a=>a.value)}get onDidWriteTerminalData(){return this.H.event}constructor(a,r){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new b.$5c,this.onDidCloseTerminal=this.z.event,this.C=new b.$5c,this.onDidOpenTerminal=this.C.event,this.D=new b.$5c,this.onDidChangeActiveTerminal=this.D.event,this.F=new b.$5c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new b.$5c,this.onDidChangeTerminalState=this.G.event,this.I=new b.$5c,this.onDidChangeShell=this.I.event,this.a=r.getProxy(A.$_I.MainThreadTerminalService),this.n=new C.$Rhb(this.a.$sendProcessData),this.H=new b.$5c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(a),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(a){return(a?this.m:this.l)?.path||""}getDefaultShellArgs(a){return(a?this.m:this.l)?.args||[]}createExtensionTerminal(a,r){const P=new f(this.a,(0,D.$3e)(),a,a.name),N=new E(a.pty);return P.createExtensionTerminal(a.location,this.J(a,r).resolvedExtHostIdentifier,$(a.iconPath),l(a.color)).then(U=>{const q=this.L(U,N);this.h[U]=q}),this.f.push(P),P.value}J(a,r){if(r=r||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const P=a.location.parentTerminal;if(P){const N=this.f.find(U=>U.value===P);N&&(r.resolvedExtHostIdentifier=N._id)}}else a.location&&typeof a.location!="object"?r.location=a.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(a,r){if(!this.N(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const N=new E(r),U=this.L(a,N);this.h[a]=U}async $acceptActiveTerminalChanged(a){const r=this.b;if(a===null){this.b=void 0,r!==this.b&&this.D.fire(this.b);return}const P=this.N(a);P&&(this.b=P,r!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(a,r){const P=this.N(a);P&&this.H.fire({terminal:P.value,data:r})}async $acceptTerminalDimensions(a,r,P){const N=this.N(a);N&&N.setDimensions(r,P)&&this.F.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptTerminalMaximumDimensions(a,r,P){this.g.get(a)?.resize(r,P)}async $acceptTerminalTitleChange(a,r){const P=this.N(a);P&&(P.name=r)}async $acceptTerminalClosed(a,r,P){const N=this.P(this.f,a);if(N!==null){const U=this.f.splice(N,1)[0];U.setExitStatus(r,P),this.z.fire(U.value)}}$acceptTerminalOpened(a,r,P,N){if(r){const B=this.P(this.f,r);if(B!==null){this.f[B]._id=a,this.C.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const U={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:F.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},q=new f(this.a,a,U,P);this.f.push(q),this.C.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(a,r){this.N(a)?._setProcessId(r)}async $startExtensionTerminal(a,r){const P=this.N(a);if(!P)return{message:(0,g.localize)(0,null,a)};P.isOpen||await new Promise(U=>{const q=this.onDidOpenTerminal(async B=>{B===P.value&&(q.dispose(),U())})});const N=this.g.get(a);N?N.startSendingEvents(r):this.i[a]={initialDimensions:r}}L(a,r){const P=new m.$jb;P.add(r.onProcessReady(U=>this.a.$sendProcessReady(a,U.pid,U.cwd,U.windowsPty))),P.add(r.onDidChangeProperty(U=>this.a.$sendProcessProperty(a,U))),this.n.startBuffering(a,r.onProcessData),P.add(r.onProcessExit(U=>this.M(a,U))),this.g.set(a,r);const N=this.i[a];return N&&r instanceof E&&(r.startSendingEvents(N.initialDimensions),delete this.i[a]),P}$acceptProcessAckDataEvent(a,r){this.g.get(a)?.acknowledgeDataEvent(r)}$acceptProcessInput(a,r){this.g.get(a)?.input(r)}$acceptTerminalInteraction(a){const r=this.N(a);r?.setInteractedWith()&&this.G.fire(r.value)}$acceptProcessResize(a,r,P){try{this.g.get(a)?.resize(r,P)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(a,r){this.g.get(a)?.shutdown(r)}$acceptProcessRequestInitialCwd(a){this.g.get(a)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(a,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(a){this.g.get(a)?.getCwd().then(r=>this.a.$sendProcessProperty(a,{type:"cwd",value:r}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this.s.add(a),this.s.size===1&&this.a.$startLinkProvider(),new k.$bJ(()=>{this.s.delete(a),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(a,r,P){if(this.u.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.u.set(r,P),this.a.$registerProfileProvider(r,a.identifier.value),new k.$bJ(()=>{this.u.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(a,r,P){if(this.v.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this.v.set(a,P),this.a.$registerQuickFixProvider(a,r),new k.$bJ(()=>{this.v.delete(a),this.a.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,r){const P=new w.$bd().token;if(P.isCancellationRequested)return;const N=this.v.get(a);if(!N)return;const U=await N.provideTerminalQuickFixes(r,P);if(U!==null)return U}async $createContributedProfileTerminal(a,r){const P=new w.$bd().token;let N=await this.u.get(a)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,r);return}this.createTerminalFromOptions(N.options,r)}}async $provideLinks(a,r){const P=this.N(a);if(!P)return[];this.w.delete(a),this.y.get(a)?.dispose(!0);const U=new w.$bd;this.y.set(a,U);const q=[],B={terminal:P.value,line:r},O=[];for(const j of this.s)O.push(c.Promises.withAsyncBody(async he=>{U.token.onCancellationRequested(()=>he({provider:j,links:[]}));const ie=await j.provideTerminalLinks(B,U.token)||[];U.token.isCancellationRequested||he({provider:j,links:ie})}));const K=await Promise.all(O);if(U.token.isCancellationRequested)return[];const z=new Map;for(const j of K)j&&j.links.length>0&&q.push(...j.links.map(he=>{const ie={id:n++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return z.set(ie.id,{provider:j.provider,link:he}),ie}));return this.w.set(a,z),q}$activateLink(a,r){const P=this.w.get(a)?.get(r);P&&P.provider.handleTerminalLink(P.link)}M(a,r){this.n.stopBuffering(a),this.g.delete(a),delete this.i[a];const P=this.h[a];P&&(P.dispose(),delete this.h[a]),this.a.$sendProcessExit(a,r)}N(a){return this.O(this.f,a)}O(a,r){const P=this.P(a,r);return P!==null?a[P]:null}P(a,r){const P=a.findIndex(N=>N._id===r);return P===-1?null:P}getEnvironmentVariableCollection(a){let r=this.k.get(a.identifier.value);return r||(r=new s(a),this.R(a.identifier.value,r)),r.getScopedEnvironmentVariableCollection(void 0)}Q(a,r){const P=(0,I.$Wq)(r.map),N=(0,I.$Xq)(r.descriptionMap);this.a.$setEnvironmentVariableCollection(a,r.persistent,P.length===0?void 0:P,N)}$initEnvironmentVariableCollections(a){a.forEach(r=>{const P=r[0],N=new s(void 0,r[1]);this.R(P,N)})}$acceptDefaultProfile(a,r){const P=this.l;this.l=a,this.m=r,P?.path!==a.path&&this.I.fire(a.path)}R(a,r){this.k.set(a,r),r.onDidChangeCollection(()=>{this.Q(a,r)})}};e.$v$b=o=He([We(1,R.$bL)],o);class s{get persistent(){return this.b}set persistent(a){this.b=a,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(a,r){this.f=a,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new b.$5c,this.map=new Map(r)}getScopedEnvironmentVariableCollection(a){this.f&&a&&(0,v.$_E)(this.f,"envCollectionWorkspace");const r=this.i(a);let P=this.a.get(r);return P||(P=new t(this,a),this.a.set(r,P),P.onDidChangeCollection(()=>this.d.fire())),P}replace(a,r,P,N){this.f&&P&&(0,v.$_E)(this.f,"envCollectionOptions"),this.g(a,{value:r,type:k.EnvironmentVariableMutatorType.Replace,options:P??{},scope:N})}append(a,r,P,N){this.f&&P&&(0,v.$_E)(this.f,"envCollectionOptions"),this.g(a,{value:r,type:k.EnvironmentVariableMutatorType.Append,options:P??{},scope:N})}prepend(a,r,P,N){this.f&&P&&(0,v.$_E)(this.f,"envCollectionOptions"),this.g(a,{value:r,type:k.EnvironmentVariableMutatorType.Prepend,options:P??{},scope:N})}g(a,r){if(r.options&&r.options.applyAtProcessCreation===!1&&!r.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.h(a,r.scope),N=this.map.get(P);if(!N||N.value!==r.value||N.type!==r.type||N.options?.applyAtProcessCreation!==(r.options.applyAtProcessCreation??!0)||N.options?.applyAtShellIntegration!==(r.options.applyAtShellIntegration??!1)||N.scope?.workspaceFolder?.index!==r.scope?.workspaceFolder?.index){const U=this.h(a,r.scope),q={variable:a,...r,options:{applyAtProcessCreation:r.options.applyAtProcessCreation??!0,applyAtShellIntegration:r.options.applyAtShellIntegration??!1}};this.map.set(U,q),this.d.fire()}}get(a,r){const P=this.h(a,r),N=this.map.get(P);return N?S(N):void 0}h(a,r){const P=this.i(r);return P.length?`${a}:::${P}`:a}i(a){return this.j(a?.workspaceFolder)??""}j(a){return a?a.uri.toString():void 0}getVariableMap(a){const r=new Map;for(const[P,N]of this.map)this.i(N.scope)===this.i(a)&&r.set(P,S(N));return r}delete(a,r){const P=this.h(a,r);this.map.delete(P),this.d.fire()}clear(a){if(a?.workspaceFolder){for(const[r,P]of this.map)P.scope?.workspaceFolder?.index===a.workspaceFolder.index&&this.map.delete(r);this.k(a)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(a,r){const P=this.i(r),N=this.descriptionMap.get(P);if(!N||N.description!==a){let U;typeof a=="string"?U=a:U=a?.value.split(`

`)[0];const q={description:U,scope:r};this.descriptionMap.set(P,q),this.d.fire()}}getDescription(a){const r=this.i(a);return this.descriptionMap.get(r)?.description}k(a){const r=this.i(a);this.descriptionMap.delete(r)}}class t{get persistent(){return this.b.persistent}set persistent(a){this.b.persistent=a}get onDidChangeCollection(){return this.a&&this.a.event}constructor(a,r){this.b=a,this.d=r,this.a=new b.$5c}getScopedEnvironmentVariableCollection(a){return this.b.getScopedEnvironmentVariableCollection(a)}replace(a,r,P){this.b.replace(a,r,P,this.d)}append(a,r,P){this.b.append(a,r,P,this.d)}prepend(a,r,P){this.b.prepend(a,r,P,this.d)}get(a){return this.b.get(a,this.d)}forEach(a,r){this.b.getVariableMap(this.d).forEach((P,N)=>a.call(r,N,P,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(a){this.b.delete(a,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(a){this.b.setDescription(a,this.d)}get description(){return this.b.getDescription(this.d)}}let d=e.$w$b=class extends o{constructor(a){super(!1,a)}createTerminal(a,r,P){throw new L.$0}createTerminalFromOptions(a,r){throw new L.$0}};e.$w$b=d=He([We(0,R.$bL)],d);function $(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function l(y){return p.ThemeColor.isThemeColor(y)?y:void 0}function S(y){const a={...y};return delete a.scope,a.options=a.options??void 0,delete a.variable,a}});var Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b};define(De[303],Ce([1,0,19,17,22,21,3,67,70,4,24,12,33,6,20,140,13,7,60,104,81,27]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E){"use strict";var n,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=e.$F_b=e.$E_b=e.$D_b=void 0;let s=e.$D_b=class{constructor(O,K,z){this.j=z,this.c=new R.$5c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(D.$_I.MainThreadTesting),this.h=new N(this.f),this.g=new l(this.f),K.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const he=j,ie=he.tests[he.tests.length-1].item.extId;return this.d.get(u.$XH.root(ie))?.collection.tree.get(ie)?.actual??(0,p.$nL)(j)}}),K.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await K.executeCommand("_testing.getExplorerSelection"),he=ie=>{const ne=this.d.get(u.$XH.root(ie));if(ne)return u.$XH.isRoot(ie)?ne.controller:ne.collection.tree.get(ie)?.actual};return{include:j?.include.map(he).filter(I.$oe)||[],exclude:j?.exclude.map(he).filter(I.$oe)||[]}})}createTestController(O,K,z,j){if(this.d.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const he=new g.$jb,ie=he.add(new p.$qL(K,z,this.j));ie.root.label=z;const ne=new Map,V=this.f,H={items:ie.root.children,get label(){return z},set label(pe){z=pe,ie.root.label=pe,V.$updateController(K,{label:z})},get refreshHandler(){return j},set refreshHandler(pe){j=pe,V.$updateController(K,{canRefresh:!!pe})},get id(){return K},createRunProfile:(pe,ye,ge,M,Y,ve)=>{let Se=(0,k.$_h)(pe);for(;ne.has(Se);)Se++;return new U(this.f,ne,K,Se,pe,ye,ge,M,Y,ve)},createTestItem(pe,ye,ge){return new p.$oL(K,pe,ye,ge)},createTestRun:(pe,ye,ge=!0)=>this.g.createTestRun(K,ie,pe,ye,ge),invalidateTestResults:pe=>{(0,E.$_E)(O,"testInvalidateResults");for(const ye of pe instanceof Array?pe:[pe]){const ge=ye?u.$XH.fromExtHostTestItem(ye,K).toString():K;this.f.$markTestRetired(ge)}},set resolveHandler(pe){ie.resolveHandler=pe},get resolveHandler(){return ie.resolveHandler},dispose:()=>{he.dispose()}};V.$registerTestController(K,z,!!j),he.add((0,g.$ib)(()=>V.$unregisterTestController(K)));const ce={controller:H,collection:ie,profiles:ne};return this.d.set(K,ce),he.add((0,g.$ib)(()=>this.d.delete(K))),he.add(ie.onDidGenerateDiff(pe=>V.$publishDiff(K,pe.map(f.TestsDiffOp.serialize)))),H}createTestObserver(){return this.h.checkout()}async runTests(O,K=F.CancellationToken.None){const z=S(O);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(he=>u.$XH.fromExtHostTestItem(he,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:q[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:O.exclude?.map(he=>he.id)},K)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,K,z){return(0,b.$If)(this.g.trackers,he=>he.id===O?he.getCoverage(K):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(O,K,z,j){return(0,b.$If)(this.g.trackers,ie=>ie.id===O?ie.getCoverage(K):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(O,K){this.d.get(O)?.profiles.get(K)?.configureHandler?.()}async $refreshTests(O,K){await this.d.get(O)?.controller.refreshHandler?.(K)}$publishTestResults(O){this.results=Object.freeze(O.map(K=>(0,L.$Fm)(i.TestResults.to(K))).concat(this.results).sort((K,z)=>z.completedAt-K.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,K){const z=this.d.get(u.$XH.fromString(O).controllerId)?.collection;z&&(await z.expand(O,K<0?1/0:K),z.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(f.TestsDiffOp.deserialize))}async $runControllerTests(O,K){return Promise.all(O.map(z=>this.k(z,!1,K)))}async $startContinuousRun(O,K){const z=new F.$bd(K),j=await Promise.all(O.map(he=>this.k(he,!0,z.token)));return!K.isCancellationRequested&&!j.some(he=>he.error)&&await new Promise(he=>K.onCancellationRequested(he)),z.dispose(!0),j}async k(O,K,z){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:he,profiles:ie}=j,ne=ie.get(O.profileId);if(!ne)return{};const V=O.testIds.map(ye=>he.tree.get(ye)).filter(I.$oe),H=O.excludeExtIds.map(ye=>j.collection.tree.get(ye)).filter(I.$oe).filter(ye=>V.some(ge=>ge.fullId.compare(ye.fullId)===2));if(!V.length)return{};const ce=new c.$KK(V.some(ye=>ye.actual instanceof p.$pL)?void 0:V.map(ye=>ye.actual),H.map(ye=>ye.actual),ne,K),pe=(0,f.$ZH)(O)&&this.g.prepareForMainThreadTestRun(ce,y.fromInternal(O,j.collection),z);try{return await ne.runHandler(ce,z),{}}catch(ye){return{error:String(ye)}}finally{pe&&(pe.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};e.$D_b=s=He([We(0,C.$bL)],s);const t=1e4;var d;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(d||(d={}));class $ extends g.$kb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,K,z){super(),this.k=O,this.l=K,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$5c),this.onEnd=this.j.event,this.h=this.B(new F.$bd(z));const j=this.B(new A.$Cg(()=>this.m(),t));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const K=this.k.id,z=this.k.controllerId,j=(0,w.$3e)(),he=new a(this.l,K,j),ie=ce=>(pe,...ye)=>{if(V){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.k.isIncluded(pe)&&(this.s(pe),ce(pe,...ye))},ne=(ce,pe)=>{const ye=pe instanceof Array?pe.map(i.TestMessage.from):[i.TestMessage.from(pe)];if(ce.uri&&ce.range){const ge={range:i.Range.from(ce.range),uri:ce.uri};for(const M of ye)M.location=M.location||ge}this.l.$appendTestMessagesInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),ye)};let V=!1;const H={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return he.coverageProvider},set coverageProvider(ce){he.coverageProvider=ce},enqueued:ie(ce=>{this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),1)}),skipped:ie(ce=>{this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),5)}),started:ie(ce=>{this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),2)}),errored:ie((ce,pe,ye)=>{ne(ce,pe),this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),6,ye)}),failed:ie((ce,pe,ye)=>{ne(ce,pe),this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,z).toString(),4,ye)}),passed:ie((ce,pe)=>{this.l.$updateTestStateInRun(K,j,u.$XH.fromExtHostTestItem(ce,this.k.controllerId).toString(),3,pe)}),appendOutput:(ce,pe,ye)=>{V||(ye&&(this.k.isIncluded(ye)?this.s(ye):ye=void 0),this.l.$appendOutputToRun(K,j,h.$Ib.fromString(ce),pe&&i.location.from(pe),ye&&u.$XH.fromExtHostTestItem(ye,z).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(K,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:H,coverage:he}),this.l.$startedTestRunTask(K,{id:j,name:O,running:!0}),H}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof p.$oL))throw new v.$6K(O.id);if(this.g.has(u.$XH.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const K=[],z=this.k.colllection.root;for(;;){const j=i.TestItem.from(O);if(K.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===z))break;O=O.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,K)}}class l{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,K,z){return this.f(O,K,z)}cancelRunById(O){for(const K of this.c.values())if(K.id===O){K.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,K,z,j,he){const ie=this.c.get(z);if(ie)return ie.createRun(j);const ne=y.fromPublic(O,K,z,he),V=S(z);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!z.continuous,profile:V&&{group:q[V.kind],id:V.profileId},exclude:z.exclude?.map(ce=>u.$XH.fromExtHostTestItem(ce,K.root.id).toString())??[],id:ne.id,include:z.include?.map(ce=>u.$XH.fromExtHostTestItem(ce,K.root.id).toString())??[K.root.id],persist:he});const H=this.f(z,ne);return H.onEnd(()=>{this.d.$finishedExtensionTestRun(ne.id),H.dispose()}),H.createRun(j)}f(O,K,z){const j=new $(K,this.d,z);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.$E_b=l;const S=B=>{if(B.profile){if(!(B.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class y{static fromPublic(O,K,z,j){return new y(O,(0,w.$3e)(),z.include?.map(he=>u.$XH.fromExtHostTestItem(he,O).toString())??[O],z.exclude?.map(he=>u.$XH.fromExtHostTestItem(he,O).toString())??[],j,K)}static fromInternal(O,K){return new y(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,K)}constructor(O,K,z,j,he,ie){this.controllerId=O,this.id=K,this.isPersisted=he,this.colllection=ie,this.c=z.map(ne=>ne+"\0"),this.d=j.map(ne=>ne+"\0")}isIncluded(O){const K=u.$XH.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const z of this.d)if(K===z||K.startsWith(z))return!1;for(const z of this.c)if(K===z||K.startsWith(z))return!0;return!1}}e.$F_b=y;class a{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");O&&(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,K,z){this.f=O,this.g=K,this.h=z}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(i.TestCoverage.fromFile)??[]}catch(K){throw this.d=void 0,K}}async resolveFileCoverage(O,K){const z=await this.d;let j=z?.[O];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[O]=await this.c.resolveFileCoverage?.(j,K)??j),j.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,i.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const K=u.$XH.parentId(O.item.extId);if(K&&this.g.has(K.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:K,f:z}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...K].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class P extends f.$5H{constructor(){super(...arguments),this.q=new R.$5c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,K){return{...O,revived:i.TestItem.toPlain(O.item),depth:K?K.depth+1:0,children:new Set}}o(){return new r(this.q)}}class N{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(K=>K.revived)},dispose:(0,m.$bb)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new P;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class U{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Te(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Te(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Te(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Te(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?i.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Te(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,K,z,j,he,ie,ne,V=!1,H=void 0,ce=!1){this.controllerId=z,this.profileId=j,this.d=he,this.kind=ie,this.runHandler=ne,this.f=V,this._tag=H,this.g=ce,n.set(this,void 0),o.set(this,void 0),Ze(this,n,O,"f"),Ze(this,o,K,"f"),K.set(j,this);const pe=q[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Te(this,n,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:H?i.TestTag.namespace(this.controllerId,H.id):null,label:he,group:pe,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Te(this,o,"f")?.delete(this.profileId)&&(Ze(this,o,void 0,"f"),Te(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$G_b=U,n=new WeakMap,o=new WeakMap;const q={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(De[304],Ce([1,0,19,8,3,6,141,13,7]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=void 0;class g{constructor(I,w){this.i=w,this.a=new h.$5c({onListenerError:A.$Y}),this.b=new h.$5c({onListenerError:A.$Y}),this.c=new h.$5c({onListenerError:A.$Y}),this.d=new h.$5c({onListenerError:A.$Y}),this.f=new h.$5c({onListenerError:A.$Y}),this.g=new h.$5c({onListenerError:A.$Y}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(F.$_I.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(D=>this.g.fire(D)),this.i.onDidChangeActiveTextEditor(D=>this.f.fire(D))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const w=this.i.allEditors();return I?w:w.map(D=>D.value)}async showTextDocument(I,w,D){let C;typeof w=="number"?C={position:m.ViewColumn.from(w),preserveFocus:D}:typeof w=="object"?C={position:m.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?m.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:C={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,C),i=p&&this.i.getEditor(p);if(i)return i.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new R.$iL(this.h,I,w).value}$acceptEditorPropertiesChanged(I,w){const D=this.i.getEditor(I);if(!D)throw new Error("unknown text editor");if(w.options&&D._acceptOptions(w.options),w.selections){const C=w.selections.selections.map(m.Selection.to);D._acceptSelections(C)}if(w.visibleRanges){const C=b.$jf(w.visibleRanges.map(m.Range.to));D._acceptVisibleRanges(C)}if(w.options&&this.b.fire({textEditor:D.value,options:{...w.options,lineNumbers:m.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const C=k.TextEditorSelectionChangeKind.fromValue(w.selections.source),p=w.selections.selections.map(m.Selection.to);this.a.fire({textEditor:D.value,selections:p,kind:C})}if(w.visibleRanges){const C=b.$jf(w.visibleRanges.map(m.Range.to));this.c.fire({textEditor:D.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const w in I){const D=this.i.getEditor(w);if(!D)throw new Error("Unknown text editor");const C=m.ViewColumn.to(I[w]);D.value.viewColumn!==C&&(D._acceptViewColumn(C),this.d.fire({textEditor:D.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$V$b=g}),define(De[305],Ce([1,0,2,5,6,4,7,13,25,12]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=e.$x_b=void 0,e.$x_b=(0,A.$lh)("IExtHostTimeline");class L{constructor(D,C){this.b=new Map,this.c=new Map,this.a=D.getProxy(h.$_I.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(p,i)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&k.$El.equals(i,this.b.get(p.source)?.extension)){const c=p.uri===void 0?void 0:b.URI.revive(p.uri);return this.c.get(p.source)?.get(I(c))?.get(p.handle)}else return;return p}})}async $getTimeline(D,C,p,i){return this.b.get(D)?.provider.provideTimeline(b.URI.revive(C),p,i)}registerTimelineProvider(D,C,p,i){const c=new F.$jb,u=this.d(C.id,i,c).bind(this);let v;C.onDidChange&&(v=C.onDidChange(E=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:C.id}),this));const f=this.c;return this.f({...C,scheme:D,onDidChange:void 0,async provideTimeline(E,n,o){n?.resetCache&&(c.clear(),f.get(C.id)?.clear());const s=await C.provideTimeline(E,n,o);if(s==null)return;const t=u(E,n);return{...s,source:C.id,items:s.items.map(t)}},dispose(){for(const E of f.values())E.get(C.id)?.clear();v?.dispose(),c.dispose()}},p)}d(D,C,p){return(i,c)=>{let u;if(c?.cacheResults){let v=this.c.get(D);v===void 0&&(v=new Map,this.c.set(D,v));const f=I(i);u=v.get(f),u===void 0&&(u=new Map,v.set(f,u))}return v=>{const{iconPath:f,...E}=v,n=`${D}|${v.id??v.timestamp}`;u?.set(n,v);let o,s,t;v.iconPath&&(f instanceof R.$9J?t={id:f.id,color:f.color}:b.URI.isUri(f)?(o=f,s=f):{light:o,dark:s}=f);let d;return R.$CJ.isMarkdownString(E.tooltip)?d=m.MarkdownString.from(E.tooltip):(0,g.$ge)(E.tooltip)?d=E.tooltip:R.$CJ.isMarkdownString(E.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=m.MarkdownString.from(E.detail)):(0,g.$ge)(E.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=E.detail),{...E,id:E.id??void 0,handle:n,source:D,command:v.command?C.toInternal(v.command,p):void 0,icon:o,iconDark:s,themeIcon:t,tooltip:d,accessibilityInformation:v.accessibilityInformation}}}}f(D,C){if(this.b.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this.a.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this.b.set(D.id,{provider:D,extension:C}),(0,F.$ib)(()=>{for(const i of this.c.values())i.get(D.id)?.clear();this.b.delete(D.id),this.a.$unregisterTimelineProvider(D.id),D.dispose()})}}e.$y_b=L;function I(w){return w?.toString()}}),define(De[306],Ce([1,0,4,16,2,6]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;class R{constructor(k){this.c=new Map,this.b=k.getProxy(F.$_I.MainThreadUriOpeners)}registerExternalUriOpener(k,g,L,I){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const w=I.schemes.find(D=>!R.a.has(D));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(g,L),this.b.$registerUriOpener(g,I.schemes,k,I.label),(0,b.$ib)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(k,g,L){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener with id: ${k}`);const w=h.URI.revive(g);return I.canOpenExternalUri(w,L)}async $openUri(k,g,L){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener id: '${k}'`);return I.openExternalUri(h.URI.revive(g.resolvedUri),{sourceUri:h.URI.revive(g.sourceUri)},L)}}e.$H_b=R,R.a=new Set([A.Schemas.http,A.Schemas.https])}),define(De[307],Ce([1,0,6,2,4,8,25]),function(re,e,b,A,h,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;class m{constructor(g){this.c=new R.$Fl,this.d=new Map,this.b=g.getProxy(b.$_I.MainThreadUrls)}registerUriHandler(g,L){const I=g.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=m.a++;return this.c.add(I),this.d.set(w,L),this.b.$registerUriHandler(w,I,g.displayName||g.name),(0,h.$ib)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(g,L){const I=this.d.get(g);if(!I)return Promise.resolve(void 0);try{I.handleUri(A.URI.revive(L))}catch(w){(0,F.$X)(w)}return Promise.resolve(void 0)}async createAppUri(g){return A.URI.revive(await this.b.$createAppUri(g))}}e.$X$b=m,m.a=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[85],Ce([1,0,3,16,24,2,212,245,105,6]),function(re,e,b,A,h,F,R,m,k,g){"use strict";var L,I,w,D,C,p,i,c,u,v,f,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=e.$2$b=e.$1$b=e.$Z$b=e.$Y$b=void 0;class o{constructor(r,P,N,U,q,B,O){L.set(this,void 0),I.set(this,void 0),w.set(this,void 0),D.set(this,void 0),C.set(this,void 0),p.set(this,void 0),i.set(this,""),c.set(this,void 0),u.set(this,!1),v.set(this,!1),f.set(this,void 0),E.set(this,void 0),this._onMessageEmitter=new b.$5c,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new b.$5c),this._onDidDispose=Te(this,n,"f").event,Ze(this,L,r,"f"),Ze(this,I,P,"f"),Ze(this,c,N,"f"),Ze(this,D,U,"f"),Ze(this,C,q,"f"),Ze(this,p,B,"f"),Ze(this,f,s(B),"f"),Ze(this,E,t(B),"f"),Ze(this,w,O,"f")}dispose(){Ze(this,u,!0,"f"),Te(this,n,"f").fire(),Te(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return Ze(this,v,!0,"f"),(0,k.$Zlb)(r,Te(this,D,"f"))}get cspSource(){const r=Te(this,p,"f").extensionLocation;if(r.scheme===A.Schemas.https||r.scheme===A.Schemas.http){let P=r.toString();return P.endsWith("/")||(P+="/"),P+" "+k.$Ylb}return k.$Ylb}get html(){return this.a(),Te(this,i,"f")}set html(r){this.a(),Te(this,i,"f")!==r&&(Ze(this,i,r,"f"),Te(this,E,"f")&&!Te(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(Ze(this,v,!0,"f"),Te(this,w,"f").report("Webview vscode-resource: uris",Te(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,I,"f").$setHtml(Te(this,L,"f"),this.b(r)))}get options(){return this.a(),Te(this,c,"f")}set options(r){this.a(),h.$Im(Te(this,c,"f"),r)||Te(this,I,"f").$setOptions(Te(this,L,"f"),l(Te(this,p,"f"),Te(this,C,"f"),r)),Ze(this,c,r,"f")}async postMessage(r){if(Te(this,u,"f"))return!1;const P=(0,m.$K9)(r,{serializeBuffersForPostMessage:Te(this,f,"f")});return Te(this,I,"f").$postMessage(Te(this,L,"f"),P.message,...P.buffers)}a(){if(Te(this,u,"f"))throw new Error("Webview is disposed")}b(r){if(!Te(this,E,"f"))return r;const P=Te(this,p,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,N=Te(this,p,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Te(this,p,"f").extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,q,B,O,K,z)=>{const j=F.URI.from({scheme:O||"file",path:decodeURIComponent(K)}),he=(0,k.$Zlb)(j,{isRemote:P,authority:N}).toString();return`${q}${he}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,q,B,O,K,z)=>{const j=F.URI.from({scheme:O||"file",path:decodeURIComponent(K)}),he=(0,k.$Zlb)(j,{isRemote:P,authority:N}).toString();return`${q}${he}${z}`})}}e.$Y$b=o,L=new WeakMap,I=new WeakMap,w=new WeakMap,D=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap,c=new WeakMap,u=new WeakMap,v=new WeakMap,f=new WeakMap,E=new WeakMap,n=new WeakMap;function s(a){try{const r=(0,R.$qo)((0,R.$po)(a.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$Z$b=s;function t(a){try{const r=(0,R.$qo)((0,R.$po)(a.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d{constructor(r,P,N,U,q){this.c=P,this.d=N,this.e=U,this.f=q,this.b=new Map,this.a=r.getProxy(g.$_I.MainThreadWebviews)}$onMessage(r,P,N){const U=this.g(r);if(U){const{message:q}=(0,m.$L9)(P,N.value);U._onMessageEmitter.fire(q)}}$onMissingCsp(r,P){this.e.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,P,N){const U=new o(r,this.a,S(P),this.c,this.d,N,this.f);return this.b.set(r,U),U._onDidDispose(()=>{this.b.delete(r)}),U}deleteWebview(r){this.b.delete(r)}g(r){return this.b.get(r)}}e.$1$b=d;function $(a){return{id:a.identifier,location:a.extensionLocation}}e.$2$b=$;function l(a,r,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||y(a,r)}}e.$3$b=l;function S(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(r=>F.URI.from(r))}}function y(a,r){return[...(r?.getWorkspaceFolders()||[]).map(P=>P.uri),a.extensionLocation]}}),define(De[308],Ce([1,0,21,70,4,16,23,2,13,85,80,6,7]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;class D{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.$U0b("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=E(this.document.uri)+this.a++;return(0,R.$6f)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,t){const d=this.b(o,s.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const $=new D(s,t);return this.a.set(d,$),$}delete(o,s){const t=this.b(o,s.uri);this.a.delete(t)}b(o,s){return`${o}@@@${s}`}}var p;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(p||(p={}));class i{constructor(){this.a=new Map}addTextProvider(o,s,t){return this.b(0,o,s,t)}addCustomProvider(o,s,t){return this.b(1,o,s,t)}get(o){return this.a.get(o)}b(o,s,t,d){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:t,provider:d}),new w.$bJ(()=>this.a.delete(s))}}class c{constructor(o,s,t,d,$){this.d=s,this.f=t,this.g=d,this.h=$,this.b=new i,this.c=new C,this.a=o.getProxy(I.$_I.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,t,d){const $=new h.$jb;return v(t)?($.add(this.b.addTextProvider(s,o,t)),this.a.$registerTextEditorProvider((0,g.$2$b)(o),s,d.webviewOptions||{},{supportsMove:!!t.moveCustomTextEditor},(0,g.$Z$b)(o))):($.add(this.b.addCustomProvider(s,o,t)),u(t)&&$.add(t.onDidChangeCustomDocument(l=>{const S=this.i(s,l.document.uri);if(f(l)){const y=S.addEdit(l);this.a.$onDidEdit(l.document.uri,s,y,l.label)}else this.a.$onContentChange(l.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.$2$b)(o),s,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,g.$Z$b)(o))),w.$bJ.from($,new w.$bJ(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,t,d,$){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=m.URI.revive(o),y=await l.provider.openCustomDocument(S,{backupId:t,untitledDocumentData:d?.buffer},$);let a;return u(l.provider)&&this.f&&(a=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(s,y,a),{editable:u(l.provider)}}async $disposeCustomDocument(o,s){const t=this.b.get(s);if(!t)throw new Error(`No provider found for '${s}'`);if(t.type!==1)throw new Error(`Invalid provider type for '${s}'`);const d=m.URI.revive(o),{document:$}=this.i(s,d);this.c.delete(s,$),$.dispose()}async $resolveCustomEditor(o,s,t,d,$,l){const S=this.b.get(t);if(!S)throw new Error(`No provider found for '${t}'`);const y=k.ViewColumn.to($),a=this.g.createNewWebview(s,d.contentOptions,S.extension),r=this.h.createNewWebviewPanel(s,t,d.title,y,d.options,a,d.active),P=m.URI.revive(o);switch(S.type){case 1:{const{document:N}=this.i(t,P);return S.provider.resolveCustomEditor(N,r,l)}case 0:{const N=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(N,r,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,t){this.i(s,o).disposeEdits(t)}async $onMoveCustomEditor(o,s,t){const d=this.b.get(t);if(!d)throw new Error(`No provider found for '${t}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${t}'`);const $=this.h.getWebviewPanel(o);if(!$)throw new Error("No webview found");const l=m.URI.revive(s),S=this.d.getDocument(l);await d.provider.moveCustomTextEditor(S,$,b.CancellationToken.None)}async $undo(o,s,t,d){return this.i(s,o).undo(t,d)}async $redo(o,s,t,d){return this.i(s,o).redo(t,d)}async $revert(o,s,t){const d=this.i(s,o);await this.j(s).revertCustomDocument(d.document,t),d.disposeBackup()}async $onSave(o,s,t){const d=this.i(s,o);await this.j(s).saveCustomDocument(d.document,t),d.disposeBackup()}async $onSaveAs(o,s,t,d){const $=this.i(s,o);return this.j(s).saveCustomDocumentAs($.document,m.URI.revive(t),d)}async $backup(o,s,t){const d=this.i(s,o),l=await this.j(s).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},t);return d.updateBackup(l),l.id}i(o,s){const t=this.c.get(o,m.URI.revive(s));if(!t)throw new Error("No custom document found");return t}j(o){const t=this.b.get(o)?.provider;if(!t||!u(t))throw new Error("Custom document is not editable");return t}}e.$B_b=c;function u(n){return!!n.onDidChangeCustomDocument}function v(n){return typeof n.resolveCustomTextEditor=="function"}function f(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function E(n){const o=n.scheme===F.Schemas.file||n.scheme===F.Schemas.untitled?n.fsPath:n.toString();return(0,A.$_h)(o)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[309],Ce([1,0,3,4,2,33,13,85,6,7]),function(re,e,b,A,h,F,R,m,k,g){"use strict";var L,I,w,D,C,p,i,c,u,v,f,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;class o extends A.$kb{constructor($,l,S,y){super(),L.set(this,void 0),I.set(this,void 0),w.set(this,void 0),D.set(this,void 0),C.set(this,void 0),p.set(this,void 0),i.set(this,void 0),c.set(this,void 0),u.set(this,!0),v.set(this,void 0),f.set(this,!1),E.set(this,this.B(new b.$5c)),this.onDidDispose=Te(this,E,"f").event,n.set(this,this.B(new b.$5c)),this.onDidChangeViewState=Te(this,n,"f").event,Ze(this,L,$,"f"),Ze(this,I,l,"f"),Ze(this,D,S,"f"),Ze(this,w,y.viewType,"f"),Ze(this,C,y.panelOptions,"f"),Ze(this,c,y.viewColumn,"f"),Ze(this,p,y.title,"f"),Ze(this,v,y.active,"f")}dispose(){Te(this,f,"f")||(Ze(this,f,!0,"f"),Te(this,E,"f").fire(),Te(this,I,"f").$disposeWebview(Te(this,L,"f")),Te(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Te(this,D,"f")}get viewType(){return this.c(),Te(this,w,"f")}get title(){return this.c(),Te(this,p,"f")}set title($){this.c(),Te(this,p,"f")!==$&&(Ze(this,p,$,"f"),Te(this,I,"f").$setTitle(Te(this,L,"f"),$))}get iconPath(){return this.c(),Te(this,i,"f")}set iconPath($){this.c(),Te(this,i,"f")!==$&&(Ze(this,i,$,"f"),Te(this,I,"f").$setIconPath(Te(this,L,"f"),h.URI.isUri($)?{light:$,dark:$}:$))}get options(){return Te(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Te(this,c,"f")=="number"&&Te(this,c,"f")<0))return Te(this,c,"f")}get active(){return this.c(),Te(this,v,"f")}get visible(){return this.c(),Te(this,u,"f")}_updateViewState($){Te(this,f,"f")||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(Ze(this,v,$.active,"f"),Ze(this,u,$.visible,"f"),Ze(this,c,$.viewColumn,"f"),Te(this,n,"f").fire({webviewPanel:this}))}reveal($,l){this.c(),Te(this,I,"f").$reveal(Te(this,L,"f"),{viewColumn:typeof $>"u"?void 0:R.ViewColumn.from($),preserveFocus:!!l})}c(){if(Te(this,f,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,w=new WeakMap,D=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap,c=new WeakMap,u=new WeakMap,v=new WeakMap,f=new WeakMap,E=new WeakMap,n=new WeakMap;class s{static c(){return(0,F.$3e)()}constructor($,l,S){this.g=l,this.h=S,this.e=new Map,this.f=new Map,this.d=$.getProxy(k.$_I.MainThreadWebviewPanels)}createWebviewPanel($,l,S,y,a={}){const r=typeof y=="object"?y.viewColumn:y,P={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof y=="object"&&!!y.preserveFocus},N=(0,m.$Z$b)($),U=s.c();this.d.$createWebviewPanel((0,m.$2$b)($),U,l,{title:S,panelOptions:t(a),webviewOptions:(0,m.$3$b)($,this.h,a),serializeBuffersForPostMessage:N},P);const q=this.g.createNewWebview(U,a,$);return this.createNewWebviewPanel(U,l,S,r,a,q,!0)}$onDidChangeWebviewPanelViewStates($){const l=Object.keys($);l.sort((S,y)=>{const a=$[S],r=$[y];return a.active?1:r.active?-1:+a.visible-+r.visible});for(const S of l){const y=this.getWebviewPanel(S);if(!y)continue;const a=$[S];y._updateViewState({active:a.active,visible:a.visible,viewColumn:R.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.e.delete($),this.g.deleteWebview($)}registerWebviewPanelSerializer($,l,S){if(this.f.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.f.set(l,{serializer:S,extension:$}),this.d.$registerSerializer(l,{serializeBuffersForPostMessage:(0,m.$Z$b)($)}),new g.$bJ(()=>{this.f.delete(l),this.d.$unregisterSerializer(l)})}async $deserializeWebviewPanel($,l,S,y){const a=this.f.get(l);if(!a)throw new Error(`No serializer found for '${l}'`);const{serializer:r,extension:P}=a,N=this.g.createNewWebview($,S.webviewOptions,P),U=this.createNewWebviewPanel($,l,S.title,y,S.panelOptions,N,S.active);await r.deserializeWebviewPanel(U,S.state)}createNewWebviewPanel($,l,S,y,a,r,P){const N=new o($,this.d,r,{viewType:l,title:S,viewColumn:y,panelOptions:a,active:P});return this.e.set($,N),N}getWebviewPanel($){return this.e.get($)}}e.$A_b=s;function t(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[310],Ce([1,0,3,4,85,13,6,7]),function(re,e,b,A,h,F,R,m){"use strict";var k,g,L,I,w,D,C,p,i,c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;class v extends A.$kb{constructor(n,o,s,t,d,$){super(),k.set(this,void 0),g.set(this,void 0),L.set(this,void 0),I.set(this,void 0),w.set(this,!1),D.set(this,void 0),C.set(this,void 0),p.set(this,void 0),i.set(this,void 0),c.set(this,this.B(new b.$5c)),this.onDidChangeVisibility=Te(this,c,"f").event,u.set(this,this.B(new b.$5c)),this.onDidDispose=Te(this,u,"f").event,Ze(this,L,s,"f"),Ze(this,C,t,"f"),Ze(this,k,n,"f"),Ze(this,g,o,"f"),Ze(this,I,d,"f"),Ze(this,D,$,"f")}dispose(){Te(this,w,"f")||(Ze(this,w,!0,"f"),Te(this,u,"f").fire(),Te(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),Te(this,C,"f")}set title(n){this.a(),Te(this,C,"f")!==n&&(Ze(this,C,n,"f"),Te(this,g,"f").$setWebviewViewTitle(Te(this,k,"f"),n))}get description(){return this.a(),Te(this,p,"f")}set description(n){this.a(),Te(this,p,"f")!==n&&(Ze(this,p,n,"f"),Te(this,g,"f").$setWebviewViewDescription(Te(this,k,"f"),n))}get visible(){return Te(this,D,"f")}get webview(){return Te(this,I,"f")}get viewType(){return Te(this,L,"f")}_setVisible(n){n===Te(this,D,"f")||Te(this,w,"f")||(Ze(this,D,n,"f"),Te(this,c,"f").fire())}get badge(){return this.a(),Te(this,i,"f")}set badge(n){this.a(),!(n?.value===Te(this,i,"f")?.value&&n?.tooltip===Te(this,i,"f")?.tooltip)&&(Ze(this,i,F.ViewBadge.from(n),"f"),Te(this,g,"f").$setWebviewViewBadge(Te(this,k,"f"),n))}show(n){this.a(),Te(this,g,"f").$show(Te(this,k,"f"),!!n)}a(){if(Te(this,w,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,g=new WeakMap,L=new WeakMap,I=new WeakMap,w=new WeakMap,D=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap,c=new WeakMap,u=new WeakMap;class f{constructor(n,o){this.d=o,this.b=new Map,this.c=new Map,this.a=n.getProxy(R.$_I.MainThreadWebviewViews)}registerWebviewViewProvider(n,o,s,t){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:n}),this.a.$registerWebviewViewProvider((0,h.$2$b)(n),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$Z$b)(n)}),new m.$bJ(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(n,o,s,t,d){const $=this.b.get(o);if(!$)throw new Error(`No view provider found for '${o}'`);const{provider:l,extension:S}=$,y=this.d.createNewWebview(n,{},S),a=new v(n,this.a,o,s,y,!0);this.c.set(n,a),await l.resolveWebviewView(a,{state:t},d)}async $onDidChangeWebviewViewVisibility(n,o){this.e(n)._setVisible(o)}async $disposeWebviewView(n){const o=this.e(n);this.c.delete(n),o.dispose(),this.d.deleteWebview(n)}e(n){const o=this.c.get(n);if(!o)throw new Error("No webview found");return o}}e.$z_b=f}),define(De[145],Ce([1,0,3,6,2,16,11,5,20,27]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=e.$4$b=void 0;let L=e.$4$b=class Rn{getState(w){const D=this.d;return{get focused(){return D.focused},get active(){return(0,g.$_E)(w,"windowActivity"),D.active}}}constructor(w){this.c=new b.$5c,this.onDidChangeWindowState=this.c.event,this.d=Rn.a,this.b=w.getProxy(A.$_I.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:C})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",C)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,D){D!==this.d[w]&&(this.d={...this.d,[w]:D},this.c.fire(this.d))}openUri(w,D){let C;if(typeof w=="string"){C=w;try{w=h.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.$hd)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,C,D)}async asExternalUri(w,D){if((0,R.$hd)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(w,D);return h.URI.from(C)}};L.a={focused:!0,active:!0},e.$4$b=L=He([We(0,k.$bL)],L),e.$5$b=(0,m.$lh)("IExtHostWindow")}),define(De[311],Ce([1,0,279,26,20]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;const F=1024*1024;let R=e.$xac=class extends b.$Y_b{constructor(k,g){super(k,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(k,g,L){const I=k==="error"||k==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),g.apply(console,L),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(k,g){const L=process[k],I=L.write;let w="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(D,C,p)=>{if(!this.g){w+=D.toString(C);const i=w.length>F?w.length:w.lastIndexOf(`
`);i!==-1&&(console[g](w.slice(0,i)),w=w.slice(i+1))}I.call(L,D,C,p)}})}};e.$xac=R=He([We(0,h.$bL),We(1,A.$rL)],R)}),define(De[312],Ce([1,0,64,16,18,224,30,9]),function(re,e,b,A,h,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;let k=e.$yac=class{constructor(I,w){I.addFileSystemProvider(A.Schemas.file,new g(w),{isCaseSensitive:m.$f})}};e.$yac=k=He([We(0,b.$q$b),We(1,h.$Ni)],k);class g{constructor(I){this.b=I,this.a=new F.$Op(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,D){return this.a.writeFile(I,w,{...D,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,D){return this.a.rename(I,w,D)}copy(I,w,D){return this.a.copy(I,w,D)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(De[313],Ce([1,0,10,74,33,37,4,6,2,20]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;let L=e.$wac=class extends R.$kb{constructor(w,D){super();const C=w.getProxy(m.$_I.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async p=>{const i=k.URI.file((0,b.$$b)((0,A.tmpdir)(),(0,h.$3e)()));return await C.$download(p,i),i})}};e.$wac=L=He([We(0,g.$bL),We(1,F.$xL)],L)}),define(De[314],Ce([1,0,144,16,226,33]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class R extends b.$X_b{m(k,g,L){return k.scheme===A.Schemas.file?new h.$nM(L?.name||(0,F.$3e)(),k.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,g):super.m(k,g,L)}registerLogger(k){super.registerLogger(k),this.n.$registerLogger(k)}deregisterLogger(k){super.deregisterLogger(k),this.n.$deregisterLogger(k)}}e.$Jac=R}),define(De[315],Ce([1,0,49,10,2,84,4,16,17,29]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class L extends F.$s$b{constructor(){super(...arguments),this.i=null}async g(n){const o=await super.g(n);if(o.scheme!==m.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let t=0;do{let d;t===0?d=s:d=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${t}`:`${s}-${t}`,await I(d);const $=A.$$b(d,"vscode.lock"),l=await p(this.d,$,!1);if(l)return this.i=l,process.on("exit",()=>{l.dispose()}),h.URI.file(d);t++}while(t<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Iac=L;async function I(E){try{await g.Promises.stat(E);return}catch{}try{await g.Promises.mkdir(E,{recursive:!0})}catch{}}const w=1e3,D=10*60*1e3;class C extends R.$kb{constructor(n,o){super(),this.b=n,this.c=o,this.a=this.B(new k.$Bg),this.a.cancelAndSet(async()=>{const s=await i(n,o);(!s||s.pid!==process.pid)&&(n.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(o,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${o}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{b.unlinkSync(this.c)}catch{}}async setWillRelease(n){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+n};await g.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function p(E,n,o){try{const t={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){E.error(t)}const s=await i(E,n);return!s||s.pid!==process.pid?o?(E.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(E.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),v(E,n)):(E.info(`Lock '${n}': Lock acquired.`),new C(E,n))}async function i(E,n){let o;try{o=await g.Promises.readFile(n)}catch(s){return E.error(s),null}try{return JSON.parse(String(o))}catch(s){return E.error(s),null}}async function c(E,n){let o;try{o=await g.Promises.stat(n)}catch(s){return E.error(s),0}return o.mtime.getTime()}function u(E){try{return process.kill(E,0),!0}catch{return!1}}async function v(E,n){const o=await i(E,n);if(!o)return E.info(`Lock '${n}': Could not read pid of lock holder.`),f(E,n);if(o.willReleaseAt){let l=o.willReleaseAt-Date.now();if(l<5e3){for(l>0?E.info(`Lock '${n}': The lockfile is scheduled to be released in ${l} ms.`):E.info(`Lock '${n}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,k.$sg)(Math.min(100,l)),await c(E,n)===0)return f(E,n);l=o.willReleaseAt-Date.now()}return f(E,n)}}if(!u(o.pid))return E.info(`Lock '${n}': The pid ${o.pid} appears to be gone.`),f(E,n);const s=await c(E,n),t=Date.now()-s;if(t<=D)return E.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;E.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,k.$sg)(2e3);const d=await c(E,n),$=Date.now()-d;return $<=D?(E.info(`Lock '${n}': The lock does not look stale, elapsed: ${$} ms, giving up.`),null):(E.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),f(E,n))}async function f(E,n){E.info(`Lock '${n}': Deleting a stale lock.`);try{await g.Promises.unlink(n)}catch{}return p(E,n,!0)}}),define(De[316],Ce([1,0,33,20,43]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=void 0;let F=e.$4_b=class extends h.$v$b{constructor(m){super(!0,m)}createTerminal(m,k,g){return this.createTerminalFromOptions({name:m,shellPath:k,shellArgs:g})}createTerminalFromOptions(m,k){const g=new h.$u$b(this.a,(0,b.$3e)(),m,m.name);return this.f.push(g),g.create(m,this.J(m,k)),g.value}};e.$4_b=F=He([We(0,A.$bL)],F)}),define(De[317],Ce([1,0,6,20,200,4,26,2,45,23,29,7,9,58,3,133,113,18]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=e.$Gac=e.$Fac=e.$Eac=e.$Dac=e.$Cac=e.$Bac=e.$Aac=void 0;class u extends p.$Dz{}function v(l){const S=l.trim().split(`
`),y=[];return S.forEach(r=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(r);P&&P.length>=3&&y.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),y.reduce((r,P)=>(r[P.socket]=P,r),{})}e.$Aac=v;function f(...l){const S=[].concat(...l.map(n));return[...new Map(S.filter(y=>y.st==="0A").map(y=>{const a=y.local_address.split(":");return{socket:parseInt(y.inode,10),ip:E(a[0]),port:parseInt(a[1],16)}}).map(y=>[y.ip+":"+y.port,y])).values()]}e.$Bac=f;function E(l){let S="";if(l.length===8)for(let y=l.length-2;y>=0;y-=2)S+=parseInt(l.substr(y,2),16),y!==0&&(S+=".");else for(let y=0;y<l.length;y+=8){const a=l.substring(y,y+8);let r="";for(let P=8;P>=2;P-=2)r+=a.substring(P-2,P),(P===6||P===2)&&(r=parseInt(r,16).toString(16),S+=`${r}`,r="",y+P!==l.length-6&&(S+=":"))}return S}e.$Cac=E;function n(l){const S=l.trim().split(`
`),y=S.shift().trim().split(/\s+/).filter(r=>r!=="rx_queue"&&r!=="tm->when");return S.map(r=>r.trim().split(/\s+/).reduce((P,N,U)=>(P[y[U]||U]=N,P),{}))}e.$Dac=n;function o(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function s(l){const S=l.trim().split(`
`),y=[];return S.forEach(a=>{const r=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(a);r&&r.length>=4&&y.push({pid:parseInt(r[1],10),ppid:parseInt(r[2]),cmd:r[3]})}),y}e.$Eac=s;async function t(l,S,y){const a=y.reduce((P,N)=>(P[N.pid]=N,P),{}),r=[];return l.forEach(({socket:P,ip:N,port:U})=>{const q=S[P]?S[P].pid:void 0,B=q?a[q]?.cmd:void 0;q&&B&&!o(B)&&r.push({host:N,port:U,detail:B,pid:q})}),r}e.$Fac=t;function d(l,S,y){const a=new Map,r=s(S);for(const P of l){const N=y.get(P.port);if(N){a.set(P.port,N);continue}const U=r.find(q=>q.cmd.includes(`${P.port}`));if(U){let q=U,B;do B=r.find(O=>O.ppid===q.pid),B&&(q=B);while(B);a.set(P.port,{host:P.ip,port:P.port,pid:q.pid,detail:q.cmd,ppid:q.ppid})}else a.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return a}e.$Gac=d;let $=e.$Hac=class extends F.$kb{constructor(S,y,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$5c,this.onDidChangeTunnels=this.h.event,this.k=!1,this.l=new Map,this.n=void 0,this.p=0,this.r=new Map,this.a=S.getProxy(b.$_I.MainThreadTunnelService),w.$f&&y.remote.isRemote&&y.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.t())}async openTunnel(S,y){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${S.identifier.value} called openTunnel API for ${y.remoteAddress.host}:${y.remoteAddress.port}.`);const a=await this.a.$openTunnel(y,S.displayName);if(a){const r=new u(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(r),r}}async t(){this.n=await this.w(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.n.map(S=>S.port).join(", ")}`)}async getTunnels(){return this.a.$getTunnels()}u(S){return Math.max(S*20,2e3)}v(){return this.p++}registerPortsAttributesProvider(S,y){const a=this.v();return this.r.set(a,{selector:S,provider:y}),this.a.$registerPortsAttributesProvider(S,a),new I.$bJ(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(S,y,a,r,P){const N=[];for(const q of S){const B=this.r.get(q);if(!B)return[];N.push(...await Promise.all(y.map(async O=>({providedAttributes:await B.provider.providePortAttributes(O,a,r,P),port:O}))))}const U=N.filter(q=>!!q.providedAttributes);return U.length>0?U.map(q=>({autoForwardAction:q.providedAttributes.autoForwardAction,port:q.port})):[]}async $registerCandidateFinder(S){if(S&&this.k)return;this.k=S;let y;this.n&&(y=this.n,await this.a.$onFoundNewCandidates(this.n));const a=new i.$tl;let r=0;for(;this.k;){const P=new Date().getTime(),N=(await this.w()).filter(B=>(0,p.$zz)(B.host)||(0,p.$Bz)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(B=>B.port).join(", ")}`);const U=new Date().getTime()-P;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),r++>3&&a.update(U),(!y||JSON.stringify(y)!==JSON.stringify(N))&&(y=N,await this.a.$onFoundNewCandidates(y));const q=this.u(a.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${q} ms.`),await new Promise(B=>setTimeout(()=>B(),q))}}async setTunnelFactory(S){if(S){if(S.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(S.candidatePortSource),S.showCandidatePort&&(this.f=S.showCandidatePort,this.a.$setCandidateFilter()),S.tunnelFactory){this.b=S.tunnelFactory;let y=S.tunnelFeatures?.privacyOptions??[];S.tunnelFeatures?.public&&y.length===0&&(y=[{id:"private",label:h.localize(0,null),themeIcon:"lock"},{id:"public",label:h.localize(1,null),themeIcon:"eye"}]);const a=S.tunnelFeatures?{elevation:!!S.tunnelFeatures?.elevation,public:!!S.tunnelFeatures?.public,privacyOptions:y}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,F.$ib)(()=>{this.b=void 0})}async $closeTunnel(S,y){if(this.g.has(S.host)){const a=this.g.get(S.host);a.has(S.port)&&(y&&a.get(S.port).disposeListener.dispose(),await a.get(S.port).tunnel.dispose(),a.delete(S.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(S,y){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(S,y);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const r=await a;this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.g.has(S.remoteAddress.host)||this.g.set(S.remoteAddress.host,new Map);const P=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(S.remoteAddress.host).set(S.remoteAddress.port,{tunnel:r,disposeListener:P}),D.TunnelDtoConverter.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(S){const y=await Promise.all(S.map(r=>this.f(r.host,r.port,r.detail??""))),a=S.filter((r,P)=>y[P]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${S.map(r=>r.port).join(", ")} to ${a.map(r=>r.port).join(", ")}`),a}async w(){let S="",y="";try{S=await L.Promises.readFile("/proc/net/tcp","utf8"),y=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const a=f(S,y),r=await new Promise(z=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,he,ie)=>{z(he)})}),P=v(r),N=await L.Promises.readdir("/proc"),U=[];for(const z of N)try{const j=Number(z),he=g.$6f(m.URI.file("/proc"),z);if((await L.Promises.stat(he.fsPath)).isDirectory()&&!isNaN(j)){const ne=await L.Promises.readlink(g.$6f(he,"cwd").fsPath),V=await L.Promises.readFile(g.$6f(he,"cmdline").fsPath,"utf8");U.push({pid:j,cwd:ne,cmd:V})}}catch{}const q=[],B=a.filter(z=>{const j=P[z.socket];return j||q.push(z),j}),O=t(B,P,U);let K;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${q.length}`),q.length>0){const z=await new Promise(j=>{(0,k.exec)("ps -F -A -l | grep root",(he,ie,ne)=>{j(ie)})});this.l=d(q,z,this.l),K=Array.from(this.l.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.map(j=>j.port).join(", ")}`)}return O.then(z=>K?z.concat(K):z)}};e.$Hac=$=He([We(0,A.$bL),We(1,R.$rL),We(2,c.$Ni)],$)}),define(De[318],Ce([1,0,17,22,21,8,3,4,119,272,61]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$GZb=e.ResponsiveState=e.RequestInitiator=e.$FZb=e.$EZb=void 0;function w(a,r){try{return JSON.stringify(a,r)}catch{return"null"}}const D="$$ref$$",C={[D]:-1};class p{constructor(r,P){this.jsonString=r,this.referencedBuffers=P}}function i(a,r=null,P=!1){const N=[];return{jsonString:(P?w:JSON.stringify)(a,(q,B)=>{if(typeof B>"u")return C;if(typeof B=="object"){if(B instanceof A.$Ib){const O=N.push(B)-1;return{[D]:O}}if(r)return r(q,B)}return B}),referencedBuffers:N}}e.$EZb=i;function c(a,r,P){return JSON.parse(a,(N,U)=>{if(U){const q=U[D];if(typeof q=="number")return r[q];if(P&&U.$mid===1)return P.transformIncoming(U)}return U})}e.$FZb=c;function u(a,r){return JSON.stringify(a,r)}function v(a){return a?(r,P)=>P&&P.$mid===1?a.transformOutgoing(P):P:null}var f;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));var E;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(E||(e.ResponsiveState=E={}));const n=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class t extends m.$kb{constructor(r,P=null,N=null){super(),this[I]=!0,this.b=this.B(new R.$5c),this.onDidChangeResponsiveState=this.b.event,this.c=r,this.f=P,this.g=N,this.h=v(this.g),this.j=!1,this.k=[],this.l=[];for(let U=0,q=L.$Kz.count;U<q;U++)this.k[U]=null,this.l[U]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new b.$Cg(()=>this.C(),1e3)),this.c.onMessage(U=>this.G(U))}dispose(){this.j=!0,Object.keys(this.s).forEach(r=>{this.s[r].resolveErr(F.$3())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(r){this.u===0&&(this.v=Date.now()+t.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(r){this.v=Date.now()+t.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(r){this.t!==r&&(this.t=r,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(r){return this.g?(0,k.$nm)(r,this.g):r}getProxy(r){const{nid:P,sid:N}=r;return this.l[P]||(this.l[P]=this.F(P,N)),this.l[P]}F(r,P){const N={get:(U,q)=>(typeof q=="string"&&!U[q]&&q.charCodeAt(0)===36&&(U[q]=(...B)=>this.O(r,q,B)),q===s?P:U[q])};return new Proxy(Object.create(null),N)}set(r,P){return this.k[r.nid]=P,P}assertRegistered(r){for(let P=0,N=r.length;P<N;P++){const U=r[P];if(!this.k[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}G(r){if(this.j)return;const P=r.byteLength,N=d.read(r,0),U=N.readUInt8(),q=N.readUInt32();switch(U){case 1:case 2:{let{rpcId:B,method:O,args:K}=l.deserializeRequestJSONArgs(N);this.g&&(K=(0,k.$nm)(K,this.g)),this.H(P,q,B,O,K,U===2);break}case 3:case 4:{let{rpcId:B,method:O,args:K}=l.deserializeRequestMixedArgs(N);this.g&&(K=(0,k.$nm)(K,this.g)),this.H(P,q,B,O,K,U===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.z(q);break}case 6:{this.I(P,q);break}case 7:{this.J(P,q,void 0);break}case 9:{let B=l.deserializeReplyOKJSON(N);this.g&&(B=(0,k.$nm)(B,this.g)),this.J(P,q,B);break}case 10:{const B=l.deserializeReplyOKJSONWithBuffers(N,this.g);this.J(P,q,B);break}case 8:{const B=l.deserializeReplyOKVSBuffer(N);this.J(P,q,B);break}case 11:{let B=l.deserializeReplyErrError(N);this.g&&(B=(0,k.$nm)(B,this.g)),this.L(P,q,B);break}case 12:{this.L(P,q,void 0);break}default:console.error("received unexpected message"),console.error(r)}}H(r,P,N,U,q,B){this.f?.logIncoming(r,P,1,`receiveRequest ${(0,L.$Mz)(N)}.${U}(`,q);const O=String(P);let K,z;if(B){const he=new h.$bd;q.push(he.token),K=this.M(N,U,q),z=()=>he.cancel()}else K=this.M(N,U,q),z=n;this.p[O]=z;const j=l.serializeAcknowledged(P);this.f?.logOutgoing(j.byteLength,P,1,"ack"),this.c.send(j),K.then(he=>{delete this.p[O];const ie=l.serializeReplyOK(P,he,this.h);this.f?.logOutgoing(ie.byteLength,P,1,"reply:",he),this.c.send(ie)},he=>{delete this.p[O];const ie=l.serializeReplyErr(P,he);this.f?.logOutgoing(ie.byteLength,P,1,"replyErr:",he),this.c.send(ie)})}I(r,P){this.f?.logIncoming(r,P,1,"receiveCancel");const N=String(P);this.p[N]?.()}J(r,P,N){this.f?.logIncoming(r,P,0,"receiveReply:",N);const U=String(P);if(!this.s.hasOwnProperty(U))return;const q=this.s[U];delete this.s[U],q.resolveOk(N)}L(r,P,N){this.f?.logIncoming(r,P,0,"receiveReplyErr:",N);const U=String(P);if(!this.s.hasOwnProperty(U))return;const q=this.s[U];delete this.s[U];let B;N&&(N.$isError?(B=new Error,B.name=N.name,B.message=N.message,B.stack=N.stack):B=N),q.resolveErr(B)}M(r,P,N){try{return Promise.resolve(this.N(r,P,N))}catch(U){return Promise.reject(U)}}N(r,P,N){const U=this.k[r];if(!U)throw new Error("Unknown actor "+(0,L.$Mz)(r));const q=U[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,L.$Mz)(r));return q.apply(U,N)}O(r,P,N){if(this.j)return new g.$DZb;let U=null;if(N.length>0&&h.CancellationToken.isCancellationToken(N[N.length-1])&&(U=N.pop()),U&&U.isCancellationRequested)return Promise.reject(F.$3());const q=l.serializeRequestArguments(N,this.h),B=++this.m,O=String(B),K=new g.$CZb;U&&U.onCancellationRequested(()=>{const j=l.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(l.serializeCancel(B))}),this.s[O]=K,this.y(B);const z=l.serializeRequest(B,r,P,q,!!U);return this.f?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.$Mz)(r)}.${P}(`,N),this.c.send(z),K}}e.$GZb=t,I=o,t.a=3*1e3;class d{static alloc(r,P,N){const U=new d(A.$Ib.alloc(N+1+4),0);return U.writeUInt8(r),U.writeUInt32(P),U}static read(r,P){return new d(r,P)}get buffer(){return this.a}constructor(r,P){this.a=r,this.b=P}static sizeUInt8(){return 1}writeUInt8(r){this.a.writeUInt8(r,this.b),this.b+=1}readUInt8(){const r=this.a.readUInt8(this.b);return this.b+=1,r}writeUInt32(r){this.a.writeUInt32BE(r,this.b),this.b+=4}readUInt32(){const r=this.a.readUInt32BE(this.b);return this.b+=4,r}static sizeShortString(r){return 1+r.byteLength}writeShortString(r){this.a.writeUInt8(r.byteLength,this.b),this.b+=1,this.a.set(r,this.b),this.b+=r.byteLength}readShortString(){const r=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+r).toString();return this.b+=r,N}static sizeLongString(r){return 4+r.byteLength}writeLongString(r){this.a.writeUInt32BE(r.byteLength,this.b),this.b+=4,this.a.set(r,this.b),this.b+=r.byteLength}readLongString(){const r=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+r).toString();return this.b+=r,N}writeBuffer(r){this.a.writeUInt32BE(r.byteLength,this.b),this.b+=4,this.a.set(r,this.b),this.b+=r.byteLength}static sizeVSBuffer(r){return 4+r.byteLength}writeVSBuffer(r){this.a.writeUInt32BE(r.byteLength,this.b),this.b+=4,this.a.set(r,this.b),this.b+=r.byteLength}readVSBuffer(){const r=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+r);return this.b+=r,P}static sizeMixedArray(r){let P=0;P+=1;for(let N=0,U=r.length;N<U;N++){const q=r[N];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let B=0;B<q.buffers.length;++B)P+=this.sizeVSBuffer(q.buffers[B]);break;case 4:break}}return P}writeMixedArray(r){this.a.writeUInt8(r.length,this.b),this.b+=1;for(let P=0,N=r.length;P<N;P++){const U=r[P];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let q=0;q<U.buffers.length;++q)this.writeBuffer(U.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const r=this.a.readUInt8(this.b);this.b+=1;const P=new Array(r);for(let N=0;N<r;N++)switch(this.readUInt8()){case 1:P[N]=this.readLongString();break;case 2:P[N]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),B=this.readLongString(),O=[];for(let K=0;K<q;++K)O.push(this.readVSBuffer());P[N]=new L.$Nz(c(B,O,null));break}case 4:P[N]=void 0;break}return P}}d.sizeUInt32=4;var $;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})($||($={}));class l{static a(r){for(let P=0,N=r.length;P<N;P++)if(r[P]instanceof A.$Ib||r[P]instanceof L.$Nz||typeof r[P]>"u")return!0;return!1}static serializeRequestArguments(r,P){if(this.a(r)){const N=[];for(let U=0,q=r.length;U<q;U++){const B=r[U];if(B instanceof A.$Ib)N[U]={type:2,value:B};else if(typeof B>"u")N[U]={type:4};else if(B instanceof L.$Nz){const{jsonString:O,referencedBuffers:K}=i(B.value,P);N[U]={type:3,value:A.$Ib.fromString(O),buffers:K}}else N[U]={type:1,value:A.$Ib.fromString(u(B,P))}}return{type:1,args:N}}return{type:0,args:u(r,P)}}static serializeRequest(r,P,N,U,q){switch(U.type){case 0:return this.b(r,P,N,U.args,q);case 1:return this.c(r,P,N,U.args,q)}}static b(r,P,N,U,q){const B=A.$Ib.fromString(N),O=A.$Ib.fromString(U);let K=0;K+=d.sizeUInt8(),K+=d.sizeShortString(B),K+=d.sizeLongString(O);const z=d.alloc(q?2:1,r,K);return z.writeUInt8(P),z.writeShortString(B),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(r){const P=r.readUInt8(),N=r.readShortString(),U=r.readLongString();return{rpcId:P,method:N,args:JSON.parse(U)}}static c(r,P,N,U,q){const B=A.$Ib.fromString(N);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(B),O+=d.sizeMixedArray(U);const K=d.alloc(q?4:3,r,O);return K.writeUInt8(P),K.writeShortString(B),K.writeMixedArray(U),K.buffer}static deserializeRequestMixedArgs(r){const P=r.readUInt8(),N=r.readShortString(),U=r.readMixedArray(),q=new Array(U.length);for(let B=0,O=U.length;B<O;B++){const K=U[B];typeof K=="string"?q[B]=JSON.parse(K):q[B]=K}return{rpcId:P,method:N,args:q}}static serializeAcknowledged(r){return d.alloc(5,r,0).buffer}static serializeCancel(r){return d.alloc(6,r,0).buffer}static serializeReplyOK(r,P,N){if(typeof P>"u")return this.d(r);if(P instanceof A.$Ib)return this.e(r,P);if(P instanceof L.$Nz){const{jsonString:U,referencedBuffers:q}=i(P.value,N,!0);return this.g(r,U,q)}else return this.f(r,w(P,N))}static d(r){return d.alloc(7,r,0).buffer}static e(r,P){let N=0;N+=d.sizeVSBuffer(P);const U=d.alloc(8,r,N);return U.writeVSBuffer(P),U.buffer}static deserializeReplyOKVSBuffer(r){return r.readVSBuffer()}static f(r,P){const N=A.$Ib.fromString(P);let U=0;U+=d.sizeLongString(N);const q=d.alloc(9,r,U);return q.writeLongString(N),q.buffer}static g(r,P,N){const U=A.$Ib.fromString(P);let q=0;q+=d.sizeUInt32,q+=d.sizeLongString(U);for(const O of N)q+=d.sizeVSBuffer(O);const B=d.alloc(10,r,q);B.writeUInt32(N.length),B.writeLongString(U);for(const O of N)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(r){const P=r.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(r,P){const N=r.readUInt32(),U=r.readLongString(),q=[];for(let B=0;B<N;++B)q.push(r.readVSBuffer());return new L.$Nz(c(U,q,P))}static serializeReplyErr(r,P){const N=P?w(F.$Z(P),null):void 0;if(typeof N!="string")return this.h(r);const U=A.$Ib.fromString(N);let q=0;q+=d.sizeLongString(U);const B=d.alloc(11,r,q);return B.writeLongString(U),B.buffer}static deserializeReplyErrError(r){const P=r.readLongString();return JSON.parse(P)}static h(r){return d.alloc(12,r,0).buffer}}var S;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var y;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(y||(y={}))}),define(De[319],Ce([1,0,3,42,47,5]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=e.$nI=e.OutputChannelUpdateMode=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=void 0,e.$cI="text/x-code-output",e.$dI="output",e.$eI="Log",e.$fI="text/x-code-log-output",e.$gI="log",e.$hI="log",e.$iI="workbench.panel.output",e.$jI=new h.$Ki("inOutput",!1),e.$kI=new h.$Ki("activeLogOutput",!1),e.$lI=new h.$Ki("outputView.scrollLock",!1),e.$mI=(0,F.$lh)("outputService");var R;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$nI={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new b.$5c,this.onDidRegisterChannel=this.b.event,this.c=new b.$5c,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(L=>g.push(L)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}A.$Qm.add(e.$nI.OutputChannels,new m),e.$oI=new h.$Ki("activeOutputChannel","")}),define(De[146],Ce([1,0,6,5,20,25,18,319,64,26,51,173,22,12,30,3,4]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=e.$N$b=void 0;class c extends R.$Ti{get disposed(){return this.l}constructor(E,n,o,s,t){super(),this.id=E,this.name=n,this.m=o,this.n=s,this.extension=t,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(E){this.append(E+`
`)}append(E){this.info(E)}clear(){const E=this.k;this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Clear,E)}replace(E){const n=this.k;this.info(E),this.n.$update(this.id,m.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(E,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof E=="boolean"?E:n))}hide(){this.n.$close(this.id)}g(E,n){this.k+=w.$Ib.fromString(n).byteLength,(0,R.log)(this.m,E,n),this.visible&&(this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class u extends c{appendLine(E){this.append(E)}}let v=e.$N$b=class{constructor(E,n,o,s,t,d){this.i=n,this.j=o,this.k=s,this.l=t,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=E.getProxy(b.$_I.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,I.$Pl)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.h=E;for(const[n,o]of this.g)o.visible=n===this.h}createOutputChannel(E,n,o){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,t=(0,D.$ge)(n)?n:void 0;if((0,D.$ge)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const $=this.i.environment.extensionLogLevel?.find(([S])=>F.$El.equals(o.identifier,S))?.[1];$&&(d=(0,R.$4i)($));const l=s?this.o(E,d,o):this.n(E,t,o);return l.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),s?this.r(E,d??this.m.getLevel(),l):this.q(E,l)}async n(E,n,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,t=this.k.extUri.joinPath(s,`${this.f++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(t,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(E,t,n,o.identifier.value);return new c($,E,d,this.a,o)}async o(E,n,o){const s=await this.p(o),t=E.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(s,`${t}.log`),$=`${o.identifier.value}.${t}`,l=this.l.createLogger(d,{id:$,name:E,logLevel:n,extensionId:o.identifier.value});return new u($,E,l,this.a,o)}p(E){let n=this.d.get(E.identifier.value);if(!n){const o=this.k.extUri.joinPath(this.i.logsLocation,E.identifier.value);this.d.set(E.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,C.$4j)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return n}q(E,n){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return E},append(t){s(),n.then(d=>d.append(t))},appendLine(t){s(),n.then(d=>d.appendLine(t))},clear(){s(),n.then(t=>t.clear())},replace(t){s(),n.then(d=>d.replace(t))},show(t,d){s(),n.then($=>$.show(t,d))},hide(){s(),n.then(t=>t.hide())},dispose(){o=!0,n.then(t=>t.dispose())}}}r(E,n,o){const s=new i.$jb,t=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},d=s.add(new p.$5c);function $(l){n=l,d.fire(l)}return o.then(l=>{s.add(l),l.logLevel!==n&&$(l.logLevel),s.add(l.onDidChangeLogLevel(S=>$(S)))}),{...this.q(E,o),get logLevel(){return n},onDidChangeLogLevel:d.event,trace(l,...S){t(),o.then(y=>y.trace(l,...S))},debug(l,...S){t(),o.then(y=>y.debug(l,...S))},info(l,...S){t(),o.then(y=>y.info(l,...S))},warn(l,...S){t(),o.then(y=>y.warn(l,...S))},error(l,...S){t(),o.then(y=>y.error(l,...S))},dispose(){s.dispose()}}}};e.$N$b=v=He([We(0,h.$bL),We(1,g.$rL),We(2,k.$q$b),We(3,L.$X0b),We(4,R.$Oi),We(5,R.$Ni)],v),e.$O$b=(0,A.$lh)("IExtHostOutputService")});var Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b};define(De[320],Ce([1,0,5,17]),function(re,e,b,A){"use strict";var h,F,R,m,k,g,L,I,w,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0,e.$5l=(0,b.$lh)("remoteAgentService"),e.$6l=new(C=class{constructor(){h.set(this,5),F.set(this,2e3),R.set(this,[]),m.set(this,3),k.set(this,[]),g.set(this,100),L.set(this,2),I.set(this,500),w.set(this,1500),D.set(this,void 0)}get latency(){return Te(this,D,"f")}async measure(p){let i=1/0;for(let u=0;u<Te(this,h,"f");u++){const v=await p.getRoundTripTime();if(v===void 0)return;i=Math.min(i,v/2),await(0,A.$sg)(Te(this,F,"f"))}Te(this,k,"f").push(i),Te(this,k,"f").length>Te(this,g,"f")&&Te(this,k,"f").shift();let c;return Te(this,R,"f").length<Te(this,m,"f")?Te(this,R,"f").push(i):c=Te(this,R,"f").reduce((u,v)=>u+v,0)/Te(this,R,"f").length,Ze(this,D,{initial:c,current:i,average:Te(this,k,"f").reduce((u,v)=>u+v,0)/Te(this,k,"f").length,high:(()=>typeof c>"u"?!1:i>Te(this,w,"f")||i>Te(this,I,"f")&&i>c*Te(this,L,"f"))()},"f"),Te(this,D,"f")}},h=new WeakMap,F=new WeakMap,R=new WeakMap,m=new WeakMap,k=new WeakMap,g=new WeakMap,L=new WeakMap,I=new WeakMap,w=new WeakMap,D=new WeakMap,C)}),define(De[321],Ce([1,0,31,16,10,9,23,2,5,240,50,265,320]),function(re,e,b,A,h,F,R,m,k,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.$NI=void 0,e.$NI=(0,k.$lh)("pathService");let D=e.$OI=class Fn{constructor(p,i,c,u){this.d=p,this.e=i,this.f=c,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const v=await this.e.getEnvironment();return this.c=v?.userHome??p})()}hasValidBasename(p,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(p,u,i)):this.h(p,i,c)}h(p,i,c){return p.scheme===A.Schemas.file||p.scheme===A.Schemas.vscodeRemote?(0,b.$Fe)(c??(0,R.$3f)(p),i===1):!0}get defaultUriScheme(){return Fn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(p,i){if(p.remoteAuthority)return A.Schemas.vscodeRemote;const c=(0,g.$KI)(i.getWorkspace());if(c)return c;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const v=i.getWorkspace().configuration;return v?v.scheme:A.Schemas.file}userHome(p){return p?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(p=>p===1?h.$7b:h.$8b)}async fileURI(p){let i="";if(await this.a===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const u=p.indexOf("/",2);u===-1?(i=p.substring(2),p="/"):(i=p.substring(2,u),p=p.substring(u)||"/")}return m.URI.from({scheme:A.Schemas.file,authority:i,path:p,query:"",fragment:""})}};e.$OI=D=He([We(1,w.$5l),We(2,I.$pI),We(3,L.$uh)],D)}),define(De[86],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$rH=e.$qH=void 0;class b{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new b(0,0)}with(R){return new b(0,0)}}e.$qH=b;class A{constructor(R,m,k,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(R,m),this.end=new b(k,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new A(0,0,0,0)}with(R){return new A(0,0,0,0)}}e.$rH=A;var h;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(De[34],Ce([1,0,19,32,24,31,11,5,10,8,86,17]),function(re,e,b,A,h,F,R,m,k,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.SearchErrorCode=e.$FH=e.$EH=e.SearchSortOrder=e.ViewMode=e.$DH=e.$CH=e.$BH=e.$AH=e.SearchCompletionExitCode=e.$zH=e.$yH=e.$xH=e.QueryType=e.SearchProviderType=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$sH="workbench.view.search",e.$tH="workbench.panel.search",e.$uH="workbench.view.search",e.$vH="search.exclude";const w="\u27EA ",D=" characters skipped \u27EB",C=(w.length+D.length+5)*2;e.$wH=(0,m.$lh)("searchService");var p;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(p||(e.SearchProviderType=p={}));var i;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(i||(e.QueryType=i={}));function c(V){return!!V.preview}e.$xH=c;function u(V){return!!V.resource}e.$yH=u;function v(V){return!!V.message}e.$zH=v;var f;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(f||(e.SearchCompletionExitCode=f={}));class E{constructor(H){this.resource=H,this.results=[]}}e.$AH=E;class n{constructor(H,ce,pe,ye){this.ranges=ce,this.webviewIndex=ye;const ge=Array.isArray(ce)?ce:[ce];if(pe&&pe.matchLines===1&&o(ge)){H=(0,R.$_d)(H,pe.matchLines);let M="",Y=0,ve=0;const Se=Math.floor(pe.charsPerLine/5),ee=[];for(const te of ge){const le=Math.max(te.startColumn-Se,0),X=te.startColumn+pe.charsPerLine;if(le>ve+Se+C){const ue=w+(le-ve)+D;M+=ue+H.slice(le,X),Y+=le-(ve+ue.length)}else M+=H.slice(ve,X);ee.push(new t(0,te.startColumn-Y,te.endColumn-Y)),ve=X}this.preview={text:M,matches:Array.isArray(this.ranges)?ee:ee[0]}}else{const M=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:H,matches:(0,b.$Ff)(ce,Y=>new s(Y.startLineNumber-M,Y.startColumn,Y.endLineNumber-M,Y.endColumn))}}}}e.$BH=n;function o(V){const H=V[0].startLineNumber;for(const ce of V)if(ce.startLineNumber!==H||ce.endLineNumber!==H)return!1;return!0}class s{constructor(H,ce,pe,ye){this.startLineNumber=H,this.startColumn=ce,this.endLineNumber=pe,this.endColumn=ye}}e.$CH=s;class t extends s{constructor(H,ce,pe){super(H,ce,H,pe)}}e.$DH=t;var d;(function(V){V.List="list",V.Tree="tree"})(d||(e.ViewMode=d={}));var $;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function l(V,H=!0){const ce=V&&V.files&&V.files.exclude,pe=H&&V&&V.search&&V.search.exclude;if(!ce&&!pe)return;if(!ce||!pe)return ce||pe;let ye=Object.create(null);return ye=h.$Hm(ye,h.$Em(ce)),ye=h.$Hm(ye,h.$Em(pe),!0),ye}e.$EH=l;function S(V,H){return V.excludePattern&&A.$_i(V.excludePattern,H)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&A.$_i(V.includePattern,H)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(ce=>{const pe=ce.folder.fsPath;if(F.$He(H,pe)){const ye=k.$ac(pe,H);return!ce.includePattern||!!A.$_i(ce.includePattern,ye)}else return!1}):!1:!0}e.$FH=S;var y;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(y||(e.SearchErrorCode=y={}));class a extends Error{constructor(H,ce){super(H),this.code=ce}}e.$GH=a;function r(V){const H=V.message;if((0,g.$1)(V))return new a(H,y.canceled);try{const ce=JSON.parse(H);return new a(ce.message,ce.code)}catch{return new a(H,y.other)}}e.$HH=r;function P(V){const H={message:V.message,code:V.code};return new Error(JSON.stringify(H))}e.$IH=P;function N(V){return V.type==="error"?!0:V.type==="success"}e.$JH=N;function U(V){return V.type==="success"}e.$KH=U;function q(V){return!!V.path}e.$LH=q;function B(V,H){const ce=V.searchPath?V.searchPath:V.relativePath;return(0,R.$9d)(ce,H)}e.$MH=B;class O{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NH=O;function K(V,H){const ce={...V||{},...H||{}};return Object.keys(ce).filter(pe=>{const ye=ce[pe];return typeof ye=="boolean"&&ye})}e.$OH=K;class z{constructor(H,ce){this.c=null,this.a={...H.excludePattern||{},...ce.excludePattern||{}},this.b=A.$aj(this.a);let pe=H.includePattern;ce.includePattern&&(pe?pe={...pe,...ce.includePattern}:pe=ce.includePattern),pe&&(this.c=A.$aj(pe))}matchesExcludesSync(H,ce,pe){return!!(this.b&&this.b(H,ce,pe))}includedInQuerySync(H,ce,pe){return!(this.b&&this.b(H,ce,pe)||this.c&&!this.c(H,ce,pe))}includedInQuery(H,ce,pe){const ye=this.b(H,ce,pe),ge=()=>this.c?!!this.c(H,ce,pe):!0;return(0,I.$eg)(ye)?ye.then(M=>M?!1:ge()):ge()}hasSiblingExcludeClauses(){return j(this.a)}}e.$PH=z;function j(V){for(const H in V)if(typeof V[H]!="boolean")return!0;return!1}function he(V){if(!V)return;let H;return ce=>(H||(H=(V()||Promise.resolve([])).then(pe=>pe?ne(pe):{})),H.then(pe=>!!pe[ce]))}e.$QH=he;function ie(V){if(!V)return;let H;return ce=>{if(!H){const pe=V();H=pe?ne(pe):{}}return!!H[ce]}}e.$RH=ie;function ne(V){const H={};for(const ce of V)H[ce]=!0;return H}}),define(De[35],Ce([1,0,19,17,21,3,4,71,16,113,23,11,12,2,198,5,18,227,50,51,26,20,13,7,59,34,6]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n,o,s,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$0b=e.$00b=void 0;function $(U,q,B){return new L.$Uf(O=>a(O,B)).isEqual(U,q)}function l(U,q,B){return $(U.uri,q.uri,B)?0:(0,I.$Cd)(U.uri.toString(),q.uri.toString())}function S(U,q,B){return U.index!==q.index?U.index<q.index?-1:1:$(U.uri,q.uri,B)?(0,I.$Cd)(U.name,q.name):(0,I.$Cd)(U.uri.toString(),q.uri.toString())}function y(U,q,B,O){const K=U.slice(0).sort((j,he)=>B(j,he,O)),z=q.slice(0).sort((j,he)=>B(j,he,O));return(0,b.$gf)(K,z,(j,he)=>B(j,he,O))}function a(U,q){const B=q.getCapabilities(U.scheme);return!(B&&B&1024)}class r extends u.$Eh{static toExtHostWorkspace(q,B,O,K){if(!q)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:he,configuration:ie,transient:ne,isUntitled:V}=q,H=[],ce=B;B?he.forEach((M,Y)=>{const ve=D.URI.revive(M.uri),Se=r.o(O||B,ve,K);Se?(Se.name=M.name,Se.index=M.index,H.push(Se)):H.push({uri:ve,name:M.name,index:Y})}):H.push(...he.map(({uri:M,name:Y,index:ve})=>({uri:D.URI.revive(M),name:Y,index:ve}))),H.sort((M,Y)=>M.index<Y.index?-1:1);const pe=new r(z,j,H,!!ne,ie?D.URI.revive(ie):null,!!V,M=>a(M,K)),{added:ye,removed:ge}=y(ce?ce.workspaceFolders:[],pe.workspaceFolders,l,K);return{workspace:pe,added:ye,removed:ge}}static o(q,B,O){for(let K=0;K<q.folders.length;K++){const z=q.workspaceFolders[K];if($(z.uri,B,O))return z}}constructor(q,B,O,K,z,j,he){super(q,O.map(ie=>new u.$Fh(ie)),K,z,he),this.t=B,this.u=j,this.q=[],this.s=m.$rh.forUris(he),O.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,B){return B&&this.s.get(q)&&(q=(0,L.$5f)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let P=e.$00b=class{constructor(q,B,O,K,z){this.c=new F.$5c,this.onDidChangeWorkspace=this.c.event,this.g=new F.$5c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$7c,this.B=new Map,this.h=K,this.s=O,this.t=z,this.j=new g.$sl,this.k=new A.$qg,this.o=q.getProxy(d.$_I.MainThreadWorkspace),this.q=q.getProxy(d.$_I.MainThreadMessageService);const j=B.workspace;this.l=j?new r(j.id,j.name,[],!!j.transient,j.configuration?D.URI.revive(j.configuration):null,!!j.isUntitled,he=>a(he,O)):void 0}$initializeWorkspace(q,B){this.v=B,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?D.URI.from({scheme:k.Schemas.untitled,path:(0,L.$3f)((0,L.$5f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,B,O,...K){const z=[];if(Array.isArray(K)&&K.forEach(V=>{D.URI.isUri(V.uri)&&!z.some(H=>$(H.uri,V.uri,this.s))&&z.push({uri:V.uri,name:V.name||(0,L.$2f)(V.uri)})}),this.n||[B,O].some(V=>typeof V!="number"||V<0)||O===0&&z.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+O>j.length)return!1;const he=j.slice(0);he.splice(B,O,...z.map(V=>({uri:V.uri,name:V.name||(0,L.$2f)(V.uri),index:void 0})));for(let V=0;V<he.length;V++){const H=he[V];if(he.some((ce,pe)=>pe!==V&&$(H.uri,ce.uri,this.s)))return!1}he.forEach((V,H)=>V.index=H);const{added:ie,removed:ne}=y(j,he,S,this.s);if(ie.length===0&&ne.length===0)return!1;if(this.o){const V=q.displayName||q.name;this.o.$updateWorkspaceFolders(V,B,O,z).then(void 0,H=>{this.n=void 0;const ce={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,C.localize)(0,null,V,H.toString()),ce,[])})}return this.y(he),!0}getWorkspaceFolder(q,B){if(this.x)return this.x.getWorkspaceFolder(q,B)}async getWorkspaceFolder2(q,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,B)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,B){let O,K="";if(typeof q=="string"?(O=D.URI.file(q),K=q):typeof q<"u"&&(O=q,K=q.fsPath),!O)return K;const z=this.getWorkspaceFolder(O,!0);if(!z)return K;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,L.$8f)(z.uri,O);return B&&z.name&&(j=`${z.name}/${j}`),j}y(q){this.x&&(this.n=r.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:B,added:O,removed:K}=r.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:K}))}findFiles(q,B,O,K,z=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:ie}=N(n.GlobPattern.from(q));return this.o.$startFileSearch((0,w.$ze)(he),(0,w.$ze)(ie),(0,w.$ze)(j),(0,w.$ze)(O),z).then(ne=>Array.isArray(ne)?ne.map(V=>D.URI.revive(V)):[])}async findTextInFiles(q,B,O,K,z=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),he=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ie,folder:ne}=N(n.GlobPattern.from(B.include)),V=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,H={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:he,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ie,excludePattern:V},ce=!1;if(this.u[j]=pe=>{if(ce)return;const ye=D.URI.revive(pe.resource);pe.results.forEach(ge=>{(0,t.$xH)(ge)?O({uri:ye,preview:{text:ge.preview.text,matches:(0,b.$Ff)(ge.preview.matches,M=>new o.$dJ(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))},ranges:(0,b.$Ff)(ge.ranges,M=>new o.$dJ(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))}):O({uri:ye,text:ge.text,lineNumber:ge.lineNumber})})},z.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(q,(0,w.$ze)(ne),H,j,z);return delete this.u[j],pe||{}}catch(pe){throw delete this.u[j],pe}}$handleTextSearchResult(q,B){this.u[B]?.(q)}async save(q){const B=await this.o.$save(q,{saveAs:!1});return D.URI.revive(B)}async saveAs(q){const B=await this.o.$save(q,{saveAs:!0});return D.URI.revive(B)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,B){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,B);const O=this.t.transformOutgoingScheme(q),K=this.z++;return this.o.$registerEditSessionIdentityProvider(K,O),(0,R.$ib)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(q,B){this.h.info("Getting edit session identifier for workspaceFolder",q);const O=await this.resolveWorkspaceFolder(D.URI.revive(q));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const K=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!K),!K)return;const z=await K.provideEditSessionIdentity(O,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(q,B,O,K){this.h.info("Getting edit session identifier for workspaceFolder",q);const z=await this.resolveWorkspaceFolder(D.URI.revive(q));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const he=await j.provideEditSessionIdentityMatch?.(B,O,K);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(q){return(B,O,K)=>{const z=function(he){B.call(O,he)};return z.extension=q,this.A.event(z,void 0,K)}}async $onWillCreateEditSessionIdentity(q,B,O){const K=await this.resolveWorkspaceFolder(D.URI.revive(q));if(K===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:K},B,async(z,j)=>{const he=Date.now();await Promise.resolve(z),Date.now()-he>O&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(q,B){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,B);const O=this.t.transformOutgoingScheme(q),K=this.z++;return this.o.$registerCanonicalUriProvider(K,O),(0,R.$ib)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(K)})}async provideCanonicalUri(q,B,O){const K=this.B.get(q.scheme);if(!K)return;const z=await K.provideCanonicalUri?.(D.URI.revive(q),B,O);if(z)return z}async $provideCanonicalUri(q,B,O){return this.provideCanonicalUri(D.URI.revive(q),{targetScheme:B},O)}};e.$00b=P=He([We(0,E.$bL),We(1,f.$rL),We(2,v.$X0b),We(3,i.$Ni),We(4,s.$80b)],P),e.$$0b=(0,p.$lh)("IExtHostWorkspace");function N(U){let q,B;return U&&(typeof U=="string"?q=U:(q=U.pattern,B=D.URI.revive(U.baseUri))),{includePattern:q,folder:B}}}),define(De[38],Ce([1,0,24,3,35,6,7,230,130,12,17,5,20,18,2]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=e.$a$b=e.$_0b=void 0;function p(o,s){if(s){const t=s.split(".");let d=o;for(let $=0;d&&$<t.length;$++)d=d[t[$]];return d}}function i(o){return o instanceof C.URI}function c(o){return o&&o.uri instanceof C.URI&&o.languageId&&typeof o.languageId=="string"}function u(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function v(o){return o&&o.uri instanceof C.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function f(o){if(i(o))return{resource:o};if(c(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(u(o))return{overrideIdentifier:o.languageId};if(v(o))return{resource:o.uri};if(o===null)return{resource:null}}let E=e.$_0b=class{constructor(s,t,d){this.a=s.getProxy(F.$_I.MainThreadConfiguration),this.c=t,this.b=d,this.d=new L.$qg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,t){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(s,t))}};e.$_0b=E=He([We(0,w.$bL),We(1,h.$$0b),We(2,D.$Ni)],E);class n{constructor(s,t,d,$){this.a=new A.$5c,this.b=s,this.f=$,this.c=t,this.e=m.$cn.parse(d),this.d=this.k(d.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,t){const d={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$cn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(t,d))}getConfiguration(s,t,d){const $=f(t)||{},l=this.g(s?p(this.e.getValue(void 0,$,this.c.workspace),s):this.e.getValue(void 0,$,this.c.workspace));s&&this.h(s,$,d?.identifier);function S(a){if(a==null)return null;if(typeof a=="boolean")return a?2:5;switch(a){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const y={has(a){return typeof p(l,a)<"u"},get:(a,r)=>{this.h(s?`${s}.${a}`:a,$,d?.identifier);let P=p(l,a);if(typeof P>"u")P=r;else{let N;const U=(q,B)=>{if((0,g.$ie)(q)){let O;const K=()=>{N=N||(0,b.$Em)(l),O=O||p(N,B)};return new Proxy(q,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return K(),()=>O;if(N)return O=O||p(N,B),O[j];const he=z[j];return typeof j=="string"?U(he,`${B}.${j}`):he},set:(z,j,he)=>(K(),O&&(O[j]=he),!0),deleteProperty:(z,j)=>(K(),O&&delete O[j],!0),defineProperty:(z,j,he)=>(K(),O&&Object.defineProperty(O,j,he),!0)})}return Array.isArray(q)?(0,b.$Em)(q):q};P=U(P,a)}return P},update:(a,r,P,N)=>{a=s?`${s}.${a}`:a;const U=S(P);return r!==void 0?this.b.$updateConfigurationOption(U,a,r,$,N):this.b.$removeConfigurationOption(U,a,$,N)},inspect:a=>{a=s?`${s}.${a}`:a;const r=this.e.inspect(a,$,this.c.workspace);if(r)return{key:a,defaultValue:(0,b.$Em)(r.policy?.value??r.default?.value),globalValue:(0,b.$Em)(r.user?.value??r.application?.value),workspaceValue:(0,b.$Em)(r.workspace?.value),workspaceFolderValue:(0,b.$Em)(r.workspaceFolder?.value),defaultLanguageValue:(0,b.$Em)(r.default?.override),globalLanguageValue:(0,b.$Em)(r.user?.override??r.application?.override),workspaceLanguageValue:(0,b.$Em)(r.workspace?.override),workspaceFolderLanguageValue:(0,b.$Em)(r.workspaceFolder?.override),languageIds:(0,b.$Em)(r.overrideIdentifiers)}}};return typeof l=="object"&&(0,b.$Hm)(y,l,!1),Object.freeze(y)}g(s){const t=d=>(0,g.$ie)(d)?new Proxy(d,{get:($,l)=>t($[l]),set:($,l,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:($,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:($,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return t(s)}h(s,t,d){const $=k.$6m.test(s)?4:this.d.get(s),l=d?`[${d.value}] `:"";if($===4){typeof t?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){t?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,t){const d=new m.$en(s,t,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:($,l)=>d.affectsConfiguration($,f(l))})}k(s){return s.reduce((t,d)=>(t.set(d[0],d[1]),t),new Map)}}e.$a$b=n,e.$b$b=(0,I.$lh)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[87],Ce([1,0,2,17,3,6,7,35,62,38,21,43,20,26,5,16,9,18,83,271,8]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=e.$$$b=e.$0$b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(q){function B(K){if(K!=null)return K}q.from=B;function O(K){if(K!=null)return K}q.to=O})(n||(n={}));var o;(function(q){function B(K){if(K!=null)return K}q.from=B;function O(K){if(K!=null)return K}q.to=O})(o||(o={}));var s;(function(q){function B(K){if(K!=null)return K}q.from=B;function O(K){if(K!=null)return K}q.to=O})(s||(s={}));var t;(function(q){function B(z){if(z){const j=z;return j&&!!j.process}else return!1}q.is=B;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=s.from(z.options)),j}q.from=O;function K(z){if(z!=null)return new R.$WJ(z.process,z.args,z.options)}q.to=K})(t||(t={}));var d;(function(q){function B(K){if(K!=null)return K}q.from=B;function O(K){if(K!=null)return K}q.to=O})(d||(d={}));var $;(function(q){function B(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}q.is=B;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=d.from(z.options)),j}q.from=O;function K(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new R.$XJ(z.commandLine,z.options):new R.$XJ(z.command,z.args?z.args:[],z.options)}q.to=K})($||($={}));var l;(function(q){function B(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}q.is=B;function O(z){return{customExecution:"customExecution"}}q.from=O;function K(z,j){return j.get(z)}q.to=K})(l||(e.CustomExecutionDTO=l={}));var S;(function(q){function B(O,K){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===R.TaskScope.Workspace&&K&&K.workspaceFile?z=K.workspaceFile:z=v.$uF),{id:O._id,workspaceFolder:z}}q.from=B})(S||(e.TaskHandleDTO=S={}));var y;(function(q){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}q.from=B})(y||(y={}));var a;(function(q){function B(z,j){if(z==null)return[];const he=[];for(const ie of z){const ne=O(ie,j);ne&&he.push(ne)}return he}q.fromMany=B;function O(z,j){if(z==null)return;let he;z.execution instanceof R.$WJ?he=t.from(z.execution):z.execution instanceof R.$XJ?he=$.from(z.execution):z.execution&&z.execution instanceof R.$YJ&&(he=l.from(z.execution));const ie=n.from(z.definition);let ne;return z.scope?typeof z.scope=="number"?ne=z.scope:ne=z.scope.uri:ne=R.TaskScope.Workspace,!ie||!ne?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:ne},execution:he,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:o.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}q.from=O;async function K(z,j,he){if(z==null)return;let ie;t.is(z.execution)?ie=t.to(z.execution):$.is(z.execution)?ie=$.to(z.execution):l.is(z.execution)&&(ie=l.to(z._id,he));const ne=n.to(z.definition);let V;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?V=z.source.scope:V=await j.resolveWorkspaceFolder(b.URI.revive(z.source.scope)):V=R.TaskScope.Workspace),!ne||!V)return;const H=new R.$ZJ(ne,V,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(H.isBackground=z.isBackground),z.group!==void 0&&(H.group=R.$VJ.from(z.group._id),H.group&&z.group.isDefault&&(H.group=new R.$VJ(H.group.id,H.group.label),z.group.isDefault===!0&&(H.group.isDefault=z.group.isDefault))),z.presentationOptions&&(H.presentationOptions=o.to(z.presentationOptions)),z._id&&(H._id=z._id),z.detail&&(H.detail=z.detail),H}q.to=K})(a||(e.TaskDTO=a={}));var r;(function(q){function B(K){return K}q.from=B;function O(K){if(K)return Object.assign(Object.create(null),K)}q.to=O})(r||(r={}));class P{constructor(B,O,K){this._id=O,this.a=K,E.set(this,void 0),Ze(this,E,B,"f")}get task(){return this.a}terminate(){Te(this,E,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}E=new WeakMap;let N=e.$0$b=class{constructor(B,O,K,z,j,he,ie,ne){this.q=new h.$5c,this.r=new h.$5c,this.s=new h.$5c,this.t=new h.$5c,this.a=B.getProxy(F.$_I.MainThreadTask),this.b=K,this.c=z,this.d=j,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=ne,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,K){if(!K)return new R.$bJ(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:K,extension:B}),this.a.$registerTaskProvider(z,O),new R.$bJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(r.from(B)).then(async O=>{const K=[];for(const z of O){const j=await a.to(z,this.b,this.m);j&&K.push(j)}return K})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof P))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,K){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(O,await z.callback(K))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const K=this.j.get(B);if(!K)return Promise.reject(new Error("no handler found"));const z=[],j=(0,A.$kg)(()=>K.provider.provideTasks(L.CancellationToken.None)).then(he=>this.u(O,z,K,he));return new Promise(he=>{j.then(ie=>{Promise.all(z).then(()=>{he(ie)})})})}async $resolveTask(B,O){const K=this.j.get(B);if(!K)return Promise.reject(new Error("no handler found"));if(O.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${K.type}].`);const z=await a.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await K.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,K);const he=a.from(j,K.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(he.execution)&&await this.x(he,j,!0),await this.v(he)}w(){return this.h++}async x(B,O,K){const z=await this.a.$createTaskId(B);!K&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new f.$_("Unexpected: The specified task is missing an execution");return j}const K=this.l.get(B.id);if(K)return K;const z=new Promise((j,he)=>{function ie(ne,V,H){H?j(new P(ne,V.id,H)):he("Unexpected: Task does not exist.")}O?ie(this,B,O):a.to(B.task,this.b,this.m).then(ne=>ie(this,B,ne))});return this.l.set(B.id,z),z.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const K=this.n.values();let z=K.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=K.next()}};e.$0$b=N=He([We(0,w.$bL),We(1,D.$rL),We(2,m.$$0b),We(3,k.$mL),We(4,g.$b$b),We(5,I.$t$b),We(6,c.$Ni),We(7,u.$10b)],N);let U=e.$$$b=class extends N{constructor(B,O,K,z,j,he,ie,ne){super(B,O,K,z,j,he,ie,ne),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:i.$c(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const K=a.from(O,B);if(K===void 0)throw new Error("Task is not valid");if(l.is(K.execution))await this.x(K,O,!1);else throw new f.$0;const z=await this.y(await this.a.$getTaskExecution(K),O);return this.a.$executeTask(K).catch(j=>{throw new Error(j)}),z}u(B,O,K,z){const j=[];if(z)for(const he of z){this.z(he,K),(!he.definition||!B[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=a.from(he,K.extension);ie&&l.is(ie.execution)?(j.push(ie),O.push(this.x(ie,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:K.extension}}async v(B){if(l.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,K){}};e.$$$b=U=He([We(0,w.$bL),We(1,D.$rL),We(2,m.$$0b),We(3,k.$mL),We(4,g.$b$b),We(5,I.$t$b),We(6,c.$Ni),We(7,u.$10b)],U),e.$_$b=(0,C.$lh)("IExtHostTask")}),define(De[322],Ce([1,0,10,21,46,32,23,40,34]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=void 0;class g{constructor(w,D,C){this.k=w,this.l=D,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&F.$aj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&F.$aj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const D=this.k.folderQueries||[];return new Promise((C,p)=>{const i=c=>{this.f++,w(c)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const u=c.toString(),v=b.$cc(u);this.j&&this.j(u,v)||this.v(i,{base:c,basename:v})}),Promise.all(D.map(c=>this.p(c,i))).then(c=>{C({limitHit:this.e,stats:c[0]||void 0})},c=>{p(new Error((0,h.$9h)(c)))})})}async p(w,D){const C=new A.$bd,p=this.q(w),i=this.r(),c=new k.$PH(this.k,w),u=!c.hasSiblingExcludeClauses();let v;try{this.h.add(C),v=m.$1c.create();const f=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,C.token),E=v.elapsed(),n=m.$1c.create();return this.g&&!this.e||(f&&f.forEach(o=>{const s=b.$8b.relative(w.folder.path,o.path);if(u){const t=b.$cc(o.path);this.v(D,{base:w.folder,relativePath:s,basename:t});return}this.s(i,w.folder,s,D)}),this.g&&!this.e)?null:(this.u(i,c,D),{providerTime:E,postProcessTime:n.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(w){const D=(0,k.$OH)(this.k.includePattern,w.includePattern),C=(0,k.$OH)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:C,includes:D,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},D,C,p){if(C===this.a){const c=b.$cc(this.a);this.v(p,{base:D,relativePath:this.a,basename:c})}function i(c){const u=b.$cc(c),v=b.$bc(c);let f=w[v];f||(f=w[v]=[],i(v)),f.push({base:D,relativePath:c,basename:u})}i(C)}u({rootEntries:w,pathToEntries:D},C,p){const i=this,c=this.a;function u(v){const f=(0,k.$RH)(()=>v.map(E=>E.basename));for(let E=0,n=v.length;E<n;E++){const o=v[E],{relativePath:s,basename:t}=o;if(C.matchesExcludesSync(s,t,c!==t?f:void 0))continue;const d=D[s];if(d)u(d);else{if(s===c)continue;i.v(p,o)}if(i.e)break}}u(w)}v(w,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(D))}}class L{constructor(){this.b=new Map}fileSearch(w,D,C,p){const i=this.c(w.cacheKey),c=new g(w,D,i&&i.token);let u=0;const v=f=>{u+=f.length,C(f.map(E=>this.d(E)))};return this.e(c,L.a,v,p).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:f.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new A.$bd),this.b.get(w)}d(w){return w.relativePath?{resource:R.$6f(w.base,w.relativePath)}:{resource:w.base}}e(w,D,C,p){p.onCancellationRequested(()=>{w.cancel()});const i=u=>{u&&(c.push(u),D>0&&c.length>=D&&(C(c),c=[]))};let c=[];return w.search(i).then(u=>(c.length&&C(c),u),u=>(c.length&&C(c),Promise.reject(u)))}}e.$j_b=L,L.a=512}),define(De[323],Ce([1,0,19,65,32,118,28,16,10,23,11,12,2,167,210,57,18,50,138,321,34]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.$PI=void 0;let E=e.$PI=class{constructor(a,r,P,N,U){this.a=a,this.b=r,this.c=P,this.d=N,this.e=U}text(a,r,P={}){a=this.f(a,P);const N=this.a.getValue(),U=r&&r.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(r?.map(c.$Gh),P),type:2,contentPattern:a,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(a,r){const P=this.a.getValue();a.isRegExp&&(a.pattern=a.pattern.replace(/\r?\n/g,"\\n"));const N={...a,wordSeparators:P.editor.wordSeparators};return this.j(a,r)&&(N.isCaseSensitive=!0),this.k(a)&&(N.isMultiline=!0),r.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=r.notebookSearchConfig.includeMarkupInput),r.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=r.notebookSearchConfig.includeMarkupPreview),r.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=r.notebookSearchConfig.includeCodeInput),r.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=r.notebookSearchConfig.includeOutput),N}file(a,r={}){return{...this.h(a,r),type:1,filePattern:r.filePattern?r.filePattern.trim():r.filePattern,exists:r.exists,sortByScore:r.sortByScore,cacheKey:r.cacheKey}}g(a,r){return a?(a=Array.isArray(a)?a.map(d):d(a),r?this.parseSearchPaths(a):{pattern:o(...Array.isArray(a)?a:[a])}):{}}h(a=[],r={}){const P=this.g(r.includePattern,r.expandPatterns),N=this.g(r.excludePattern,r.expandPatterns),U=a.length>1,q=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(K=>this.q(K,r,N)):a.map(K=>this.r(K,r,N,U))).filter(K=>!!K),B={_reason:r._reason,folderQueries:q,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:r.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:r.onlyOpenEditors,maxResults:r.maxResults};if(r.onlyOpenEditors){const K=b.$jf(b.$vf(this.c.groups.map(he=>he.editors.map(ie=>ie.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(K));const z=K.filter(he=>(0,f.$FH)(B,he.fsPath)),j=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...B,...j}}const O=r.extraFileResources&&r.extraFileResources.filter(K=>(0,f.$FH)(B,K.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(a){const r=[],P=new R.$ji,N={};let U=!1;return a.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,g.$0f)(q)){const O=this.b.getWorkspaceFolder(q)?.uri??q.with({path:k.$bc(q.fsPath)});let K=P.get(O);K||(U=!0,K={folder:O,includePattern:{}},r.push(K),P.set(O,K));const z=k.$ac(O.fsPath,q.fsPath);(0,I.$re)(K.includePattern)[z.replace(/\\/g,"/")]=!0}else q.fsPath&&(U=!0,N[q.fsPath]=!0)}),{folderQueries:r,includePattern:N,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(a,r){if(r.isSmartCase){if(a.isRegExp){if(L.$0d(a.pattern,!0))return!0}else if(L.$0d(a.pattern))return!0}return!!a.isCaseSensitive}k(a){return a.isMultiline||a.isRegExp&&(0,D.$GB)(a.pattern)||a.pattern.indexOf(`
`)>=0?!0:!!a.isMultiline}parseSearchPaths(a){const r=j=>k.$0b(j)||/^\.\.?([\/\\]|$)/.test(j),N=(Array.isArray(a)?a:s(a)).map(j=>{const he=this.e.resolvedUserHome;return he?(0,F.$Rz)(j,he.scheme===m.Schemas.file?he.fsPath:he.path):j}),U=A.$D(N,j=>r(j)?"searchPaths":"exprSegments"),q=(U.exprSegments||[]).map(j=>L.$qd(j,"/")).map(j=>L.$qd(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),t(j))),B={},O=this.m(U.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const K=b.$vf(q),z=o(...K);return z&&(B.pattern=z),B}l(a,r){return r.disregardExcludeSettings?void 0:(0,f.$EH)(a,!r.disregardSearchExcludeSettings)}m(a){if(!a||!a.length)return[];const r=a.flatMap(N=>{let{pathPortion:U,globPortion:q}=n(N);return q&&(q=$(q)),this.n(U).flatMap(O=>this.o(O,q))}),P=new Map;return r.forEach(N=>{const U=N.searchPath.toString(),q=P.get(U);q?N.pattern&&(q.pattern=q.pattern||{},q.pattern[N.pattern]=!0):P.set(U,{searchPath:N.searchPath,pattern:N.pattern?o(N.pattern):void 0})}),Array.from(P.values())}n(a){if(k.$0b(a)){const r=this.b.getWorkspace().folders;return r[0]&&r[0].uri.scheme!==m.Schemas.file?[{searchPath:r[0].uri.with({path:a})}]:[{searchPath:w.URI.file(k.$9b(a))}]}if(this.b.getWorkbenchState()===2){const r=this.b.getWorkspace().folders[0].uri;if(a=d(a),a.startsWith("../")||a===".."){const N=k.$8b.resolve(r.path,a);return[{searchPath:r.with({path:N})}]}const P=$(a);return[{searchPath:r,pattern:P}]}else{if(a==="./"||a===".\\")return[];{const r=a.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(U=>{const q=r.match(new RegExp(`^${L.$ld(U.name)}(?:/(.*)|$)`));return q?{match:q,folder:U}:null}).filter(I.$oe);if(N.length)return N.map(U=>{const q=U.match[1];return{searchPath:U.folder.uri,pattern:q&&$(q)}});{const U=a.match(/\.[\/\\](.+)[\/\\]?/),q=U?U[1]:a,B=C.localize(0,null,q);throw new Error(B)}}}}o(a,r){const P=a.pattern&&r?`${a.pattern}/${r}`:a.pattern||r,N=[{searchPath:a.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:a.searchPath,pattern:P+"/**"}),N}q(a,r,P){const N=this.r((0,c.$Gh)(a.searchPath),r,P,!1);return N?{...N,includePattern:a.pattern}:null}r(a,r,P,N){let U;const q=w.URI.isUri(a)?a:a.uri;if(P.searchPaths){const j=P.searchPaths.filter(he=>(0,g.$Yf)(he.searchPath,q))[0];if(j&&!j.pattern)return null;j&&(U=j.pattern)}const B=this.a.getValue({resource:q}),K={...this.l(B,r)||{},...U||{}},z=w.URI.isUri(a)?(0,g.$3f)(a):a.name;return{folder:q,folderName:N?z:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof r.disregardIgnoreFiles=="boolean"?r.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof r.disregardGlobalIgnoreFiles=="boolean"?r.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof r.disregardParentIgnoreFiles=="boolean"?r.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof r.ignoreSymlinks=="boolean"?r.ignoreSymlinks:!B.search.followSymlinks}}};e.$PI=E=He([We(0,p.$Rh),We(1,c.$uh),We(2,u.$rC),We(3,i.$Ni),We(4,v.$NI)],E);function n(y){const a=y.match(/[\*\{\}\(\)\[\]\?]/);if(a){const r=a.index,P=y.substr(0,r).match(/[/|\\][^/\\]*$/);if(P){let N=y.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:y.substr((P.index||0)+1)}}}return{pathPortion:y}}function o(...y){return y.length?y.reduce((a,r)=>(a[r]=!0,a),Object.create(null)):void 0}function s(y){return h.$$i(y,",").map(a=>a.trim()).filter(a=>!!a.length)}function t(y){return[`**/${y}/**`,`**/${y}`].map(r=>r.replace(/\*\*\/\*\*/g,"**"))}function d(y){return y.replace(/\\/g,"/")}function $(y){return d(y).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(y){return y.replace(/([?*[\]])/g,"[$1]")}function S(y,a){y=b.$of(y,N=>N.toString());const r=[],P=a.getWorkspace();return y&&y.forEach(N=>{let U;if(a.getWorkbenchState()===2)U=(0,g.$8f)(P.folders[0].uri,N),U&&U!=="."&&(U="./"+U);else{const q=a.getWorkspaceFolder(N);if(q){const B=q.name;if(P.folders.filter(K=>K.name===B).length===1){const K=(0,g.$8f)(q.uri,N);K===""?U=`./${q.name}`:U=`./${q.name}/${K}`}else U=N.fsPath}}U&&r.push(l(U))}),r}e.$QI=S}),define(De[324],Ce([1,0,23,2,21,8,5,323,34,50]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aib=e.$zib=void 0;const L=7e3;function I(p,i){const c=i.activationEvents;if(!c)return Promise.resolve(void 0);const u=[],v=[];for(const t of c)if(/^workspaceContains:/.test(t)){const d=t.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||p.forceUsingSearch?v.push(d):u.push(d)}if(u.length===0&&v.length===0)return Promise.resolve(void 0);let f;const E=new Promise((t,d)=>{f=t}),n=t=>f({activationEvent:t}),o=Promise.all(u.map(t=>w(p,t,n))).then(()=>{}),s=D(p,i.identifier,v,n);return Promise.all([o,s]).then(()=>{f(void 0)}),E}e.$zib=I;async function w(p,i,c){for(const u of p.folders)if(await p.exists(b.$6f(A.URI.revive(u),i))){c(`workspaceContains:${i}`);return}}async function D(p,i,c,u){if(c.length===0)return Promise.resolve(void 0);const v=new h.$bd,f=p.checkExists(p.folders,c,v.token),E=setTimeout(async()=>{v.cancel(),p.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},L);let n=!1;try{n=await f}catch(o){F.$1(o)||F.$X(o)}v.dispose(),clearTimeout(E),n&&u(`workspaceContains:${c.join(",")}`)}function C(p,i,c,u){const v=p.get(R.$kh),f=p.get(k.$wH),n=v.createInstance(m.$PI).file(i.map(o=>(0,g.$Gh)(A.URI.revive(o))),{_reason:"checkExists",includePattern:c,exists:!0});return f.fileSearch(n,u).then(o=>!!o.limitHit,o=>F.$1(o)?!1:Promise.reject(o))}e.$Aib=C});var Ze=this&&this.__classPrivateFieldSet||function(re,e,b,A,h){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?h.call(re,b):h?h.value=b:e.set(re,b),b},Te=this&&this.__classPrivateFieldGet||function(re,e,b,A){if(b==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?A:b==="a"?A.call(re):A?A.value:e.get(re)};define(De[44],Ce([1,0,190,10,88,23,17,4,71,2,18,6,38,267,110,35,27,142,8,25,22,242,7,131,5,26,84,20,99,58,43,3,324,109,244,16,107,40,9,108]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n,o,s,t,d,$,l,S,y,a,r,P,N,U,q,B,O,K){"use strict";var z,j,he;Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=e.$G$b=e.$F$b=e.$E$b=void 0,e.$E$b=(0,s.$lh)("IHostUtils");let ie=e.$F$b=class Tn extends m.$kb{constructor(M,Y,ve,Se,ee,te,le,X,ue,se,oe,T){super(),this.R=T,this.a=this.B(new a.$5c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=Y,this.g=ve,this.f=le,this.j=Se,this.k=ee,this.l=te,this.m=ue,this.p=se,this.s=oe,this.t=this.g.getProxy(I.$_I.MainThreadWorkspace),this.u=this.g.getProxy(I.$_I.MainThreadTelemetry),this.v=this.g.getProxy(I.$_I.MainThreadExtensionService),this.w=new R.$qg,this.y=new R.$qg,this.z=new R.$qg,this.C=new R.$qg,this.D=new ye(this.f.activationEvents),this.G=new c.$yZb(this.D,this.f.allExtensions);const J=new v.$Fl(this.f.myExtensions);this.F=new c.$yZb(this.D,ce(this.G,J)),this.H=new C.$l$b(this.g,this.l),this.I=new P.$x$b(this.g),this.J=X,this.h=M.createChild(new l.$jh([C.$m$b,this.H],[P.$y$b,this.I])),this.L=this.B(new D.$k$b(this.F,this.G,{onExtensionActivationError:(Z,x,me)=>{this.v.$onExtensionActivationError(Z,u.$Z(x),me)},actualActivateExtension:async(Z,x)=>{if(c.$yZb.isHostExtension(Z,this.F,this.G))return await this.v.$activateExtension(Z,x),new D.$j$b;const me=this.F.getExtensionDescription(Z);return this.$(me,x)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(M){u.$X(M)}}async S(){this.J.onWillDeactivateAll();let M=[];try{M=this.F.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this.Z(ee))}catch{}await Promise.all(M)}terminate(M,Y=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${M}`),this.l.flush(),this.p.dispose(),this.L.dispose(),u.setUnexpectedErrorHandler(Se=>{this.l.error(Se)}),this.g.dispose();const ve=this.S();Promise.race([(0,R.$sg)(5e3),ve]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.l.info(`Extension host exiting with code ${Y}`),this.l.flush(),this.l.dispose(),this.c.exit(Y)})}isActivated(M){return this.z.isOpen()?this.L.isActivated(M):!1}async getExtension(M){const Y=await this.v.$getExtension(M);return Y&&{...Y,identifier:new v.$El(Y.identifier.value),extensionLocation:g.URI.revive(Y.extensionLocation)}}U(M,Y){return this.L.activateByEvent(M,Y)}W(M,Y){return this.L.activateById(M,Y)}activateByIdWithErrors(M,Y){return this.W(M,Y).then(()=>{const ve=this.L.getActivatedExtension(M);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(M=>this.F)}getExtensionExports(M){if(this.z.isOpen())return this.L.getActivatedExtension(M).exports;try{return this.L.getActivatedExtension(M).exports}catch{return null}}async X(M){if(M.scheme!==U.Schemas.file)return M;const Y=await this.c.realpath(M.fsPath);return g.URI.file(Y)}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(M=>new pe(M))),this.M}async Y(M){const Y=k.$rh.forUris(ve=>F.$Wf.ignorePathCasing(ve));return await Promise.all(M.map(async ve=>{if(this.qb(ve)){const Se=await this.X(ve.extensionLocation);Y.set(Se,ve)}})),Y}Z(M){let Y=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(M))return Y;const ve=this.L.getActivatedExtension(M);if(!ve)return Y;try{typeof ve.module.deactivate=="function"&&(Y=Promise.resolve(ve.module.deactivate()).then(void 0,Se=>(this.l.error(Se),Promise.resolve(void 0))))}catch(Se){this.l.error(`An error occurred when deactivating the extension '${M.value}':`),this.l.error(Se)}try{(0,m.$fb)(ve.subscriptions)}catch(Se){this.l.error(`An error occurred when deactivating the subscriptions for extension '${M.value}':`),this.l.error(Se)}return Y}async $(M,Y){return this.f.remote.isRemote?this.v.$onWillActivateExtension(M.identifier):await this.v.$onWillActivateExtension(M.identifier),this.bb(M,Y).then(ve=>{const Se=ve.activationTimes;return this.v.$onDidActivateExtension(M.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,Y),this.ab(M,Y,"success",Se),ve},ve=>{throw this.ab(M,Y,"failure"),ve})}ab(M,Y,ve,Se){const ee=V(M,Y);this.u.$publicLog2("extensionActivationTimes",{...ee,...Se||{},outcome:ve})}bb(M,Y){const ve=V(M,Y);this.u.$publicLog2("activatePlugin",ve);const Se=this.qb(M);if(!Se)return Promise.resolve(new D.$i$b(D.$f$b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${M.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${M.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.l.flush();const ee=new D.$g$b(Y.startup);return Promise.all([this.rb(M,(0,F.$6f)(M.extensionLocation,Se),ee),this.cb(M)]).then(te=>(h.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Tn.db(this.l,M.identifier,te[0],te[1],ee))).then(te=>(h.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),te))}cb(M){const Y=new E.$o$b(M,this.H),ve=new E.$n$b(M.identifier.value,!1,this.H),Se=new N.$z$b(M,this.I),ee=M.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,te=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([Y.whenReady,ve.whenReady,this.J.whenReady]).then(()=>{const le=this;let X,ue;const se=(0,i.$$E)(M,"ipc")?this.f.messagePorts?.get(v.$El.toKey(M.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:ve,secrets:Se,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(oe){return A.$$b(M.extensionLocation.fsPath,oe)},get storagePath(){return le.J.workspaceValue(M)?.fsPath},get globalStoragePath(){return le.J.globalValue(M).fsPath},get logPath(){return A.$$b(le.f.logsLocation.fsPath,M.identifier.value)},get logUri(){return g.URI.joinPath(le.f.logsLocation,M.identifier.value)},get storageUri(){return le.J.workspaceValue(M)},get globalStorageUri(){return le.J.globalValue(M)},get extensionMode(){return ee},get extension(){return X===void 0&&(X=new H(le,M.identifier,M,te,!1)),X},get extensionRuntime(){return(0,i.$_E)(M,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.p.getEnvironmentVariableCollection(M)},get messagePassingProtocol(){if(!ue){if(!se)return;const oe=a.Event.buffer(a.Event.fromDOMEventEmitter(se,"message",T=>T.data));se.start(),ue={onDidReceiveMessage:oe,postMessage:se.postMessage.bind(se)}}return ue}})})}static db(M,Y,ve,Se,ee){return ve=ve||{activate:void 0,deactivate:void 0},this.eb(M,Y,ve,Se,ee).then(te=>new D.$h$b(!1,null,ee.build(),ve,te,Se.subscriptions))}static eb(M,Y,ve,Se,ee){if(typeof ve.activate=="function")try{ee.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const te=typeof global=="object"?global:self,le=ve.activate.apply(te,[Se]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(le).then(X=>(ee.activateResolveStop(),X))}catch(te){return Promise.reject(te)}else return Promise.resolve(ve)}fb(M,Y){this.W(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:Y}).then(void 0,ve=>{this.l.error(ve)})}gb(M,Y=0){const Se=Date.now();(0,O.$v)(()=>{for(let ee=Y;ee<M.length;ee+=1){const te=M[ee];for(const le of te.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Se>50){this.gb(M,ee);break}else this.fb(te,le)}})}hb(){this.v.$setPerformanceMarks(h.getMarks()),this.k.getConfigProvider().then(M=>{const Y=M.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.F.getAllExtensionDescriptions();if(Y)this.gb(ve);else for(const Se of ve)if(Se.activationEvents)for(const ee of Se.activationEvents)ee==="onStartupFinished"&&this.fb(Se,ee)})}ib(){const M=this.U("*",!0).then(void 0,te=>{this.l.error(te)});this.B(this.j.onDidChangeWorkspace(te=>this.jb(te.added)));const Y=this.j.workspace?this.j.workspace.folders:[],ve=this.jb(Y),Se=this.lb(),ee=Promise.all([Se,M,ve]).then(()=>{});return Promise.race([ee,(0,R.$sg)(1e4)]).then(()=>{this.hb()}),ee}jb(M){return M.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(Y=>this.kb(M,Y))).then(()=>{})}async kb(M,Y){if(this.isActivated(Y.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.l,folders:M.map(te=>te.uri),forceUsingSearch:ve,exists:te=>this.c.exists(te.fsPath),checkExists:(te,le,X)=>this.t.$checkExists(te,le,X)},ee=await(0,r.$zib)(Se,Y);if(ee)return this.W(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ee.activationEvent}).then(void 0,te=>this.l.error(te))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(M){throw console.error(M),M}}async mb(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:Y}=this.f.environment;if(!M||!Y)throw new Error(b.localize(0,null));const ve=await this.rb(null,Y,new D.$g$b(!1));if(!ve||typeof ve.run!="function")throw new Error(b.localize(1,null,Y.toString()));return new Promise((Se,ee)=>{const te=(ue,se)=>{ue?ee(ue):Se(typeof se=="number"&&se>0?1:0)},le=(0,F.$Tf)(Y),X=ve.run(le,te);X&&X.then&&X.then(()=>{Se(0)}).catch(ue=>{ee(ue instanceof Error&&ue.stack?ue.stack:String(ue))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,R.$sg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(M,Y){return this.N[M]=Y,(0,m.$ib)(()=>{delete this.N[M]})}async getRemoteExecServer(M){const{resolver:Y}=await this.ob(M);return Y?.resolveExecServer?.(M,{resolveAttempt:0})}async ob(M){const Y=M.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ve=M.substr(0,Y);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.N[ve]}}async $resolveAuthority(M,Y){const ve=B.$1c.create(!1),Se=()=>`[resolveAuthority(${(0,o.$wk)(M)},${Y})][${ve.elapsed()}ms] `,ee=me=>this.l.info(`${Se()}${me}`),te=(me,Ee=void 0)=>this.l.error(`${Se()}${me}`,Ee),le=me=>{if(me instanceof n.$hJ)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me},X=M.split(/@|%40/g).reverse();ee(`activating remote resolvers ${X.join(" -> ")}`);let ue;try{ue=await Promise.all(X.map(async me=>{ee("activating resolver...");const{resolver:Ee,authorityPrefix:fe}=await this.ob(me);if(!Ee)throw te("no resolver"),new n.$hJ(`No remote extension installed to resolve ${fe}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Ee,authorityPrefix:fe,remoteAuthority:me}}))}catch(me){return le(me)}const se=new R.$Bg;se.cancelAndSet(()=>ee("waiting..."),1e3);let oe,T;for(const[me,{authorityPrefix:Ee,resolver:fe,remoteAuthority:Ie}]of ue.entries())try{if(me===ue.length-1)ee("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${Ee}`),oe=await fe.resolve(Ie,{resolveAttempt:Y,execServer:T}),h.mark(`code/extHost/didResolveAuthorityOK/${Ee}`),ee("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(fe));else{if(ee(`invoking resolveExecServer() for ${Ie}`),h.mark(`code/extHost/willResolveExecServer/${Ee}`),T=await fe.resolveExecServer?.(Ie,{resolveAttempt:Y,execServer:T}),!T)throw new n.$hJ(`Exec server was not available for ${Ie}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${Ee}`)}}catch(Pe){return h.mark(`code/extHost/didResolveAuthorityError/${Ee}`),te("returned an error",Pe),se.dispose(),le(Pe)}se.dispose();const J={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},Z={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};ee(`returned ${n.$gJ.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let x;if(n.$gJ.isManagedResolvedAuthority(oe)){const me=Y;this.R.setFactory(me,oe.makeConnection),x={authority:M,connectTo:new o.$tk(me),connectionToken:oe.connectionToken}}else x={authority:M,connectTo:new o.$uk(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:x,options:Z,tunnelInformation:J}}}async $getCanonicalURI(M,Y){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.$wk)(M)})`);const{resolver:ve}=await this.ob(M);if(!ve)return null;const Se=g.URI.revive(Y);if(typeof ve.getCanonicalURI>"u")return Se;const ee=await(0,R.$kg)(()=>ve.getCanonicalURI(Se));return ee||Se}$startExtensionHost(M){M.toAdd.forEach(Se=>Se.extensionLocation=g.URI.revive(Se.extensionLocation));const{globalRegistry:Y,myExtensions:ve}=ne(this.D,this.G,this.F,M);return this.G.set(Y.getAllExtensionDescriptions()),this.F.set(ve),this.nb()}$activateByEvent(M,Y){return Y===1?this.U(M,!1):this.z.wait().then(ve=>this.U(M,!1))}async $activate(M,Y){return await this.z.wait(),this.F.getExtensionDescription(M)?(await this.W(M,Y),!0):!1}async $deltaExtensions(M){M.toAdd.forEach(te=>te.extensionLocation=g.URI.revive(te.extensionLocation));const{globalRegistry:Y,myExtensions:ve}=ne(this.D,this.G,this.F,M),Se=await this.Y(ve);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.G.set(Y.getAllExtensionDescriptions()),this.F.set(ve),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){const Y=f.$Ib.alloc(M),ve=Math.random()%256;for(let Se=0;Se<M;Se++)Y.writeUInt8(ve,Se);return Y}async $updateRemoteConnectionData(M){this.Q=M,this.a.fire()}};e.$F$b=ie=He([We(0,s.$kh),We(1,e.$E$b),We(2,$.$bL),We(3,p.$$0b),We(4,w.$b$b),We(5,L.$Ni),We(6,t.$rL),We(7,d.$r$b),We(8,S.$rob),We(9,y.$t$b),We(10,q.$B$b),We(11,K.$C$b)],ie);function ne(ge,M,Y,ve){ge.addActivationEvents(ve.addActivationEvents);const Se=new c.$yZb(ge,M.getAllExtensionDescriptions());Se.deltaExtensions(ve.toAdd,ve.toRemove);const ee=new v.$Fl(Y.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of ve.myToRemove)ee.delete(le);for(const le of ve.myToAdd)ee.add(le);const te=ce(Se,ee);return{globalRegistry:Se,myExtensions:te}}function V(ge,M){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.$G$b=(0,s.$lh)("IExtHostExtensionService");class H{constructor(M,Y,ve,Se,ee){z.set(this,void 0),j.set(this,void 0),he.set(this,void 0),Ze(this,z,M,"f"),Ze(this,j,Y,"f"),Ze(this,he,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=A.$9b((0,F.$Tf)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Se,this.isFromDifferentExtensionHost=ee}get isActive(){return Te(this,z,"f").isActivated(Te(this,he,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Te(this,z,"f").getExtensionExports(Te(this,he,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Te(this,z,"f").activateByIdWithErrors(Te(this,he,"f"),{startup:!1,extensionId:Te(this,j,"f"),activationEvent:"api"}),this.exports}}e.$H$b=H,z=new WeakMap,j=new WeakMap,he=new WeakMap;function ce(ge,M){return ge.getAllExtensionDescriptions().filter(Y=>M.has(Y.identifier))}class pe{constructor(M){this.a=M}setSearchTree(M){this.a=M}findSubstr(M){return this.a.findSubstr(M)}forEach(M){return this.a.forEach(M)}}e.$I$b=pe;class ye{constructor(M){this.a=new v.$Gl,this.addActivationEvents(M)}readActivationEvents(M){return this.a.get(M.identifier)}addActivationEvents(M){for(const Y of Object.keys(M))this.a.set(Y,M[Y])}}}),define(De[325],Ce([1,0,88,2,6,38,27,25,20,26,5,44,39,18,11]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;let p=e.$1_b=class{constructor(E,n,o,s,t,d,$){this.c=E,this.d=n,this.f=o,this.g=s,this.h=t,this.i=d,this.j=$,this.a=new Map,this.b=[]}async install(){this.k(),b.mark("code/extHost/willWaitForConfig");const E=await this.g.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const n=await this.h.getExtensionPathIndex();this.register(new c(this.c,n,this.d,E,this.j)),this.register(this.f.createInstance(u,n)),this.register(this.f.createInstance(i)),this.i.remote.isRemote&&this.register(this.f.createInstance(v,n,this.i.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const n of E.nodeModuleName)this.a.set(n,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(n=>E.alternativeModuleName(n))}};e.$1_b=p=He([We(2,L.$kh),We(3,F.$b$b),We(4,I.$G$b),We(5,g.$rL),We(6,D.$Ni)],p);let i=class fn{constructor(E){if(E.environment.appRoot&&fn.a.size){const n=(0,C.$ld)(this.c(E.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${t}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const n=this.b.exec(this.c(E));if(!n)return;const[,o,s,t]=n,d=fn.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),o+d+t}c(E){return E.replace(/\\/g,"/")}};i.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),i=He([We(0,g.$rL)],i);class c{constructor(E,n,o,s,t){this.c=E,this.d=n,this.e=o,this.f=s,this.g=t,this.nodeModuleName="vscode",this.a=new m.$Gl}load(E,n){const o=this.d.findSubstr(n);if(o){let s=this.a.get(o.identifier);return s||(s=this.c(o,this.e,this.f),this.a.set(o.identifier,s)),s}if(!this.b){let s="";this.d.forEach((t,d)=>s+=`	${d} -> ${t.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$6E,this.e,this.f)}return this.b}}let u=class{constructor(E,n,o){this.d=E,this.nodeModuleName="keytar",this.a=n.getProxy(h.$_I.MainThreadTelemetry);const{environment:s}=o,t=n.getProxy(h.$_I.MainThreadKeytar);if(s.appRoot){let d=s.appRoot.fsPath;w.$5b==="win32"&&(d=d.replace(/\\/g,"/")),d[d.length-1]==="/"&&(d=d.substr(0,d.length-1)),this.b=new Set,this.b.add(`${d}/node_modules.asar/keytar`),this.b.add(`${d}/node_modules/keytar`)}this.c={getPassword:(d,$)=>t.$getPassword(d,$),setPassword:(d,$,l)=>t.$setPassword(d,$,l),deletePassword:(d,$)=>t.$deletePassword(d,$),findPassword:d=>t.$findPassword(d),findCredentials(d){return t.$findCredentials(d)}}}load(E,n){const o=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(E){const n=E.length;if(n<=7||!this.b)return;const o=n-7;if((E.charAt(o)==="/"||E.charAt(o)==="\\")&&E.endsWith("keytar")&&(E=E.replace(/\\/g,"/"),this.b.has(E)))return"keytar"}};u=He([We(1,k.$bL),We(2,g.$rL)],u);let v=class{constructor(E,n,o){this.e=E,this.f=n,this.nodeModuleName=["open","opn"],this.d=o.getProxy(h.$_I.MainThreadTelemetry);const s=o.getProxy(h.$_I.MainThreadWindow);this.c=(t,d)=>{const $=A.URI.parse(t);return d?this.g(t,d):$.scheme==="http"||$.scheme==="https"?s.$openUri($,t,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?s.$openUri($,t,{}):this.g(t,d)}}load(E,n,o){const s=this.e.findSubstr(n);return s&&(this.a=s.identifier.value,this.h()),this.b=o(E),this.c}g(E,n){return this.i(),this.b(E,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};v=He([We(2,k.$bL)],v)}),define(De[52],Ce([1,0,54,4,10,39,5,62,63,44,7,35,257,38]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=void 0,e.$c_b=(0,R.$lh)("IExtHostVariableResolverProvider");class C extends w.$dM{constructor(c,u,v,f,E,n,o){function s(){if(v){const t=v.activeEditor();if(t)return t.document.uri;const d=f.tabGroups.all.find($=>$.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof L.$VK||d.input instanceof L.$1K)return d.input.modified;if(d.input instanceof L.$UK||d.input instanceof L.$ZK||d.input instanceof L.$XK)return d.input.uri}}}super({getFolderUri:t=>{const d=n.folders.filter($=>$.name===t);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(t,d)=>E.getConfiguration(void 0,t).get(d),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const t=s();if(t)return h.$9b(t.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const t=s();if(t){const d=u.getWorkspaceFolder(t);if(d)return h.$9b(d.uri.fsPath)}}},getSelectedText:()=>{if(v){const t=v.activeEditor();if(t&&!t.selection.isEmpty)return t.document.getText(t.selection)}},getLineNumber:()=>{if(v){const t=v.activeEditor();if(t)return String(t.selection.end.line+1)}},getExtension:t=>c.getExtension(t)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(F.env))}}let p=e.$d_b=class extends A.$kb{constructor(c,u,v,f,E){super(),this.b=c,this.c=u,this.g=v,this.h=f,this.i=E,this.a=new b.$S(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async t=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,n,s,this.j())})}getResolver(){return this.a.value}j(){}};e.$d_b=p=He([We(0,g.$G$b),We(1,I.$$0b),We(2,m.$mL),We(3,D.$b$b),We(4,k.$a_b)],p)}),define(De[89],Ce([1,0,17,3,12,2,5,6,63,44,20,7,35,135,250,38,52]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=e.$h_b=e.$g_b=e.$f_b=e.$e_b=void 0,e.$e_b=(0,R.$lh)("IExtHostDebugService");let c=e.$f_b=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,t,d,$,l,S){this.F=t,this.G=d,this.H=$,this.I=l,this.J=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new A.$5c,this.n=new A.$5c,this.o=new A.$5c,this.u=new A.$5c,this.k=s.getProxy(m.$_I.MainThreadDebugService),this.z=new A.$5c({onWillAddFirstListener:()=>{this.V()}}),this.B=new A.$5c,this.v=new v(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(y=>{y.onDidChange(a=>{this.K(y)}),this.K(y)})}asDebugSourceUri(s,t){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let $=`debug:${encodeURIComponent(d.path||"")}`,l="?";return t&&($+=`${l}session=${encodeURIComponent(t.id)}`,l="&"),$+=`${l}ref=${d.sourceReference}`,F.URI.parse($)}else{if(d.path)return F.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(s){const t=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const $=d.contributes.debuggers;if($&&$.length>0)for(const l of $)(0,C.$IE)(l)&&t.push(l.type)}this.k.$registerDebugTypes(t)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const s=[];return this.w.forEach(t=>s.push(t)),s}addBreakpoints(s){this.V();const t=s.filter(l=>{const S=l.id;return this.w.has(S)?!1:(this.w.set(S,l),!0)});this.W(t,[],[]);const d=[],$=new Map;for(const l of t)if(l instanceof I.$bK){let S=$.get(l.location.uri.toString());S||(S={type:"sourceMulti",uri:l.location.uri,lines:[]},$.set(l.location.uri.toString(),S),d.push(S)),S.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof I.$cK&&d.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){this.V();const t=s.filter(S=>this.w.delete(S.id));this.W([],t,[]);const d=t.filter(S=>S instanceof I.$bK).map(S=>S.id),$=t.filter(S=>S instanceof I.$cK).map(S=>S.id),l=t.filter(S=>S instanceof I.$dK).map(S=>S.id);return this.k.$unregisterBreakpoints(d,$,l)}startDebugging(s,t,d){return this.k.$startDebugging(s?s.uri:void 0,t,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,t,d){if(!t)return new I.$bJ(()=>{});const $=this.d++;return this.f.push({type:s,handle:$,provider:t}),this.k.$registerDebugConfigurationProvider(s,d,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,$),new I.$bJ(()=>{this.f=this.f.filter(l=>l.provider!==t),this.k.$unregisterDebugConfigurationProvider($)})}registerDebugAdapterDescriptorFactory(s,t,d){if(!d)return new I.$bJ(()=>{});if(!this.R(s,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.O(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const $=this.g++;return this.h.push({type:t,handle:$,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(t,$),new I.$bJ(()=>{this.h=this.h.filter(l=>l.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory($)})}registerDebugAdapterTrackerFactory(s,t){if(!t)return new I.$bJ(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:t}),new I.$bJ(()=>{this.j=this.j.filter($=>$.factory!==t)})}async $runInTerminal(s,t){return Promise.resolve(void 0)}async $substituteVariables(s,t){let d;const $=await this.Y(s);return $&&(d={uri:$.uri,name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(d,t)}L(s,t){if(s.type==="implementation")return new E(s.implementation)}M(){}async $startDASession(s,t){const d=this,$=await this.X(t);return this.T(this.O($.type),$).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}' (extension might have failed to activate)`);const S=this.N(l),y=this.L(S,$);if(!y)throw new Error(`Couldn't create a debug adapter for type '${$.type}'.`);const a=y;return this.C.set(s,a),this.S($).then(r=>(r&&this.D.set(s,r),a.onMessage(async P=>{if(P.type==="request"&&P.command==="handshake"){const N=P,U={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const q=await this.E.sign(N.arguments.value);U.body={signature:q},a.sendResponse(U)}else throw new Error("no signer")}catch(q){U.success=!1,U.message=q.message,a.sendResponse(U)}}else r&&r.onDidSendMessage&&r.onDidSendMessage(P),P=(0,C.$NE)(P,!0),d.k.$acceptDAMessage(s,P)}),a.onError(P=>{r&&r.onError&&r.onError(P),this.k.$acceptDAError(s,P.name,P.message,P.stack)}),a.onExit(P=>{r&&r.onExit&&r.onExit((0,h.$ye)(P),void 0),this.k.$acceptDAExit(s,(0,h.$ye)(P),void 0)}),r&&r.onWillStartSession&&r.onWillStartSession(),a.startSession()))})}$sendDAMessage(s,t){t=(0,C.$ME)(t,!1);const d=this.D.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(t),this.C.get(s)?.sendMessage(t)}$stopDASession(s){const t=this.D.get(s);this.D.delete(s),t&&t.onWillStopSession&&t.onWillStopSession();const d=this.C.get(s);return this.C.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const t=[],d=[],$=[];if(s.added)for(const l of s.added){const S=l.id;if(S&&!this.w.has(S)){let y;if(l.type==="function")y=new I.$cK(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")y=new I.$dK(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const a=F.URI.revive(l.uri);y=new I.$bK(new I.$nJ(a,new I.$cJ(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,I.$_J)(y,S),this.w.set(S,y),t.push(y)}}if(s.removed)for(const l of s.removed){const S=this.w.get(l);S&&(this.w.delete(l),d.push(S))}if(s.changed){for(const l of s.changed)if(l.id){const S=this.w.get(l.id);if(S){if(S instanceof I.$cK&&l.type==="function"){const y=S;y.enabled=l.enabled,y.condition=l.condition,y.hitCondition=l.hitCondition,y.logMessage=l.logMessage,y.functionName=l.functionName}else if(S instanceof I.$bK&&l.type==="source"){const y=S;y.enabled=l.enabled,y.condition=l.condition,y.hitCondition=l.hitCondition,y.logMessage=l.logMessage,y.location=new I.$nJ(F.URI.revive(l.uri),new I.$cJ(l.line,l.character))}$.push(S)}}}this.W(t,d,$)}async $acceptStackFrameFocus(s){let t;const d=s.sessionId?await this.X(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?t=new I.$jK(d,s.threadId):t=new I.$iK(d,s.threadId,s.frameId),this.A=t,this.B.fire(this.A)}$provideDebugConfigurations(s,t,d){return(0,b.$kg)(async()=>{const $=this.Q(s);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.Y(t);return $.provideDebugConfigurations(l,d)}).then($=>{if(!$)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return $})}$resolveDebugConfiguration(s,t,d,$){return(0,b.$kg)(async()=>{const l=this.Q(s);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.Y(t);return l.resolveDebugConfiguration(S,d,$)})}$resolveDebugConfigurationWithSubstitutedVariables(s,t,d,$){return(0,b.$kg)(async()=>{const l=this.Q(s);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.Y(t);return l.resolveDebugConfigurationWithSubstitutedVariables(S,d,$)})}async $provideDebugAdapter(s,t){const d=this.P(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const $=await this.X(t);return this.T(d,$).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}'`);return this.N(l)})}async $acceptDebugSessionStarted(s){const t=await this.X(s);this.m.fire(t)}async $acceptDebugSessionTerminated(s){const t=await this.X(s);t&&(this.n.fire(t),this.l.delete(t.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.X(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,t){(await this.X(s))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(s,t){const $={session:await this.X(s),event:t.event,body:t.body};this.u.fire($)}N(s){if(s instanceof I.$eK)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.$fK)return{type:"server",port:s.port,host:s.host};if(s instanceof I.$gK)return{type:"pipeServer",path:s.path};if(s instanceof I.$hK)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}O(s){const t=this.h.filter(d=>d.type===s);if(t.length>0)return t[0].factory}P(s){const t=this.h.filter(d=>d.handle===s);if(t.length>0)return t[0].factory}Q(s){const t=this.f.filter(d=>d.handle===s);if(t.length>0)return t[0].provider}R(s,t){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const $ of d)if($.label&&$.type&&$.type===t)return!0}}return!1}S(s){const d=s.configuration.type,$=this.j.filter(l=>l.type===d||l.type==="*").map(l=>(0,b.$kg)(()=>l.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all($).then(l=>{const S=l.filter(y=>!!y);if(S.length>0)return new f(S)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async T(s,t){const d=t.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new I.$fK(d));if(s){const l=await this.G.getExtensionRegistry();return(0,b.$kg)(()=>s.createDebugAdapterDescriptor(t,this.U(t,l))).then(S=>{if(S)return S})}const $=await this.G.getExtensionRegistry();return Promise.resolve(this.U(t,$))}U(s,t){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(s,t,d){(s.length>0||t.length>0||d.length>0)&&this.z.fire(Object.freeze({added:s,removed:t,changed:d}))}async X(s){if(s)if(typeof s=="string"){const t=this.l.get(s);if(t)return t}else{let t=this.l.get(s.id);if(!t){const d=await this.Y(s.folderUri),$=s.parent?this.l.get(s.parent):void 0;t=new u(this.k,s.id,s.type,s.name,d,s.configuration,$),this.l.set(t.id,t),this.k.$sessionCached(t.id)}return t}throw new Error("cannot find session")}Y(s){if(s){const t=F.URI.revive(s);return this.F.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.$f_b=c=He([We(0,L.$bL),We(1,w.$$0b),We(2,g.$G$b),We(3,p.$b$b),We(4,k.$a_b),We(5,i.$c_b)],c);class u{constructor(s,t,d,$,l,S,y){this.d=s,this.f=t,this.g=d,this.h=$,this.i=l,this.j=S,this.k=y}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,t){return this.d.$customDebugAdapterRequest(this.f,s,t)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$g_b=u;class v{constructor(s){this.value=Object.freeze({append(t){s.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.$h_b=v;class f{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(t=>t.onError?t.onError(s):void 0)}onExit(s,t){this.d.forEach(d=>d.onExit?d.onExit(s,t):void 0)}}class E extends D.$e0{constructor(s){super(),this.h=s,s.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=e.$i_b=class extends c{constructor(s,t,d,$,l,S){super(s,t,d,$,l,S)}};e.$i_b=n=He([We(0,L.$bL),We(1,w.$$0b),We(2,g.$G$b),We(3,p.$b$b),We(4,k.$a_b),We(5,i.$c_b)],n)}),define(De[326],Ce([1,0,8,88,2,6,318,18,98,99,26,222,20,59,44,82]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=void 0;class i{static async installEarlyHandler(v){const f=v.get(m.$Ni),n=v.get(w.$bL).getProxy(F.$_I.MainThreadErrors);b.setUnexpectedErrorHandler(o=>{f.error(o);const s=b.$Z(o);n.$onUnexpectedError(s)})}static async installFullHandler(v){const f=v.get(m.$Ni),E=v.get(w.$bL),n=v.get(C.$G$b),o=v.get(p.$vL),s=E.getProxy(F.$_I.MainThreadExtensionService),t=E.getProxy(F.$_I.MainThreadErrors),d=await n.getExtensionPathIndex(),$=new WeakMap;function l(a,r){if($.has(a))return $.get(a).stack;let P="",N,U;for(const B of r)P+=`
	at ${B.toString()}`,U=B.getFileName(),!N&&U&&(N=d.findSubstr(h.URI.file(U)));const q=`${a.name||"Error"}: ${a.message||""}${P}`;return $.set(a,{extensionIdentifier:N?.identifier,stack:q}),q}const S=Symbol("prepareStackTrace wrapped");let y=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return y},set(a){if(a===l||a[S]){y=a;return}y=function(r,P){return l(r,P),a.call(Error,r,P)},Object.assign(y,{[S]:!0})}}),b.setUnexpectedErrorHandler(a=>{f.error(a);const r=b.$Z(a),P=$.get(a);if(!P?.extensionIdentifier){t.$onUnexpectedError(r);return}s.$onExtensionRuntimeError(P.extensionIdentifier,r);const N=o.onExtensionError(P.extensionIdentifier,a);f.trace("forwarded error to extension?",N,P)})}}e.$2_b=i,Error.stackTraceLimit=100;class c{constructor(v,f,E,n,o){this.a=E,this.b=new R.$GZb(v,null,n),f=c.e(f,this.b);const s=new g.$jh(...(0,k.$0q)());s.set(L.$rL,{_serviceBrand:void 0,...f,messagePorts:o}),s.set(w.$bL,new w.$cL(this.b)),s.set(D.$80b,new D.$90b(n)),s.set(C.$E$b,E);const t=new I.$Rp(s,!0);t.invokeFunction(i.installEarlyHandler),this.d=t.invokeFunction(d=>d.get(m.$Ni)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",f),this.c=t.invokeFunction(d=>d.get(C.$G$b)),this.c.initialize(),t.invokeFunction(i.installFullHandler)}async asBrowserUri(v){const f=this.b.getProxy(F.$_I.MainThreadExtensionService);return h.URI.revive(await f.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,f){v.allExtensions.forEach(n=>{n.extensionLocation=h.URI.revive(f.transformIncomingURIs(n.extensionLocation))}),v.environment.appRoot=h.URI.revive(f.transformIncomingURIs(v.environment.appRoot));const E=v.environment.extensionDevelopmentLocationURI;return E&&(v.environment.extensionDevelopmentLocationURI=E.map(n=>h.URI.revive(f.transformIncomingURIs(n)))),v.environment.extensionTestsLocationURI=h.URI.revive(f.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=h.URI.revive(f.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=h.URI.revive(f.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=h.URI.revive(f.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=h.URI.revive(f.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=h.URI.revive(f.transformIncomingURIs(v.logsLocation)),v.workspace=f.transformIncomingURIs(v.workspace),v}}e.$3_b=c}),define(De[327],Ce([1,0,17,9,199,216,232,89,63,44,20,43,7,52,35,251,252,38]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=void 0;let u=e.$aac=class extends m.$f_b{constructor(o,s,t,d,$,l,S){super(o,s,t,d,l,S),this.ab=$,this.Z=new E}L(o,s){switch(o.type){case"server":return new p.$8_b(o);case"pipeServer":return new p.$9_b(o);case"executable":return new p.$0_b(o,s.type)}return super.L(o,s)}U(o,s){const t=p.$0_b.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(t)return new w.$eK(t.command,t.args,t.options)}M(){return new R.$f4b}async $runInTerminal(o,s){if(o.kind==="integrated"){this.$||(this.$=this.ab.onDidCloseTerminal(q=>{this.Z.onTerminalClosed(q)}));const t=await this.H.getConfigProvider(),d=this.ab.getDefaultShell(!0),$=this.ab.getDefaultShellArgs(!0),l=o.title||h.localize(0,null),S=JSON.stringify({shell:d,shellArgs:$});let y=await this.Z.checkout(S,l),a,r=!1;if(y)a=o.cwd;else{const q={shellPath:d,shellArgs:$,cwd:o.cwd,name:l,iconPath:new w.$9J("debug")};r=!0,y=this.ab.createTerminalFromOptions(q,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.Z.insert(y,S)}y.show(!0);const P=await y.processId;r?await new Promise(q=>setTimeout(q,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0||d.indexOf("cmd.exe")>=0?y.sendText("cls"):d.indexOf("bash")>=0?y.sendText("clear"):A.$d?y.sendText("cls"):y.sendText("clear"));const N=(0,i.$__b)(d,o.args,!!o.argsCanBeInterpretedByShell,a,o.env);y.sendText(N);const U=this.onDidTerminateDebugSession(q=>{q.id===s&&(this.Z.free(y),U.dispose())});return P}else if(o.kind==="external")return f(o,await this.H.getConfigProvider());return super.$runInTerminal(o,s)}};e.$aac=u=He([We(0,L.$bL),We(1,C.$$0b),We(2,g.$G$b),We(3,c.$b$b),We(4,I.$t$b),We(5,k.$a_b),We(6,D.$c_b)],u);let v;function f(n,o){if(!v)if(A.$d)v=new F.$V2b;else if(A.$e)v=new F.$W2b;else if(A.$f)v=new F.$X2b;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return v.runInTerminal(n.title,n.cwd,n.args,n.env||{},s.external||{})}class E{constructor(){this.b=new Map}async checkout(o,s){const d=[...this.b.entries()].map(([$,l])=>(0,b.$fg)(async S=>{if($.name!==s||l.lastUsedAt!==-1&&await(0,i.$$_b)(await $.processId))return null;const y=Date.now();return l.lastUsedAt+E.a>y||S.isCancellationRequested||l.config!==o?null:(l.lastUsedAt=y,$)}));return await(0,b.$wg)(d,$=>!!$)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}E.a=1e3}),define(De[328],Ce([1,0,10,2,96,35,62,38,50,43,20,26,87,16,18,83,23,74,52]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=void 0;let v=e.$5_b=class extends w.$0$b{constructor(E,n,o,s,t,d,$,l,S){super(E,n,o,s,t,d,$,l),this.B=o,this.C=S,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(E,n){const o=n;if(!n.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=w.TaskHandleDTO.from(o,this.B),t=await this.a.$getTaskExecution(s);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.y(t,n);return this.a.$executeTask(s).catch(()=>{}),d}else{const s=w.TaskDTO.from(n,E);if(s===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(s.execution)&&await this.x(s,n,!1);const t=await this.y(await this.a.$getTaskExecution(s),n);return this.a.$executeTask(s).catch(()=>{}),t}}u(E,n,o,s){const t=[];if(s)for(const d of s){this.z(d,o),(!d.definition||!E[d.definition.type])&&this.f.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const $=w.TaskDTO.from(d,o.extension);$&&(t.push($),w.CustomExecutionDTO.is($.execution)&&n.push(this.x($,d,!0)))}return{tasks:t,extension:o.extension}}async v(E){return E}async F(E){let n=E&&E.length>0?E[0]:void 0;if(!n){const o=A.URI.file((0,c.homedir)());n=new k.$Fh({uri:o,name:i.$3f(o),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(E,n){const o=A.URI.revive(E),s={process:void 0,variables:Object.create(null)},t=await this.b.resolveWorkspaceFolder(o),d=await this.b.getWorkspaceFolders2()??[],$=await this.C.getResolver(),l=t?{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(d);for(const S of n.variables)s.variables[S]=await $.resolveAsync(l,S);if(n.process!==void 0){let S;if(n.process.path!==void 0){S=n.process.path.split(b.$ic);for(let y=0;y<S.length;y++)S[y]=await $.resolveAsync(l,S[y])}s.process=await h.win32.findExecutable(await $.resolveAsync(l,n.process.name),n.process.cwd!==void 0?await $.resolveAsync(l,n.process.cwd):void 0,S)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(E,n,o){return h.win32.findExecutable(E,n,o)}};e.$5_b=v=He([We(0,L.$bL),We(1,I.$rL),We(2,F.$$0b),We(3,R.$mL),We(4,m.$b$b),We(5,g.$t$b),We(6,C.$Ni),We(7,p.$10b),We(8,u.$c_b)],v)}),define(De[329],Ce([1,0,74,52]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;class h extends A.$d_b{j(){return(0,b.homedir)()}}e.$Kac=h}),define(De[147],Ce([1,0,19,17,21,46,16,10,23,2,34]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=e.$m_b=e.$l_b=e.$k_b=void 0;class I{constructor(u,v,f,E){this.d=u,this.e=v,this.f=f,this.g=E,this.a=null,this.b=!1,this.c=0}search(u,v){const f=this.d.folderQueries||[],E=new h.$bd;return v.onCancellationRequested(()=>E.cancel()),new Promise((n,o)=>{this.a=new D(u);let s=!1;const t=(d,$)=>{if(!s&&!this.b){const l=this.h(d);p(d)&&typeof this.d.maxResults=="number"&&this.c+l>this.d.maxResults&&(this.b=!0,s=!0,E.cancel(),d=this.j(d,this.d.maxResults-this.c));const S=this.h(d);this.c+=S,(S>0||!p(d))&&this.a.add(d,$)}};Promise.all(f.map((d,$)=>this.k(d,l=>t(l,$),E.token))).then(d=>{E.dispose(),this.a.flush();const $=d.some(l=>!!l&&!!l.limitHit);n({limitHit:this.b||$,messages:(0,b.$vf)(d.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.g}})},d=>{E.dispose();const $=(0,F.$9h)(d);o(new Error($))})})}h(u){return p(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}j(u,v){const f=Array.isArray(u.ranges)?u.ranges:[u.ranges],E=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:f.slice(0,v),preview:{matches:E.slice(0,v),text:u.preview.text},uri:u.uri}}async k(u,v,f){const E=new L.$PH(this.d,u),n=[],o={report:d=>{if(!this.l(d))return;const $=u.folder.scheme===R.Schemas.file?(0,L.$QH)(()=>this.f.readdir(k.$5f(d.uri))):void 0,l=k.$8f(u.folder,d.uri);if(l){const S=E.includedInQuery(l,m.$cc(l),$);(0,A.$eg)(S)?n.push(S.then(y=>{y&&v(d)})):S&&v(d)}}},s=this.n(u),t=await this.e.provideTextSearchResults(w(this.d.contentPattern),s,o,f);return n.length&&await Promise.all(n),t}l(u){if(p(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(u){const v=(0,L.$OH)(this.d.includePattern,u.includePattern),f=(0,L.$OH)(this.d.excludePattern,u.excludePattern),E={folder:g.URI.from(u.folder),excludes:f,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.f.toCanonicalName(u.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return E.usePCRE2=this.d.usePCRE2,E}}e.$k_b=I;function w(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class D{constructor(u){this.e=u,this.b=-1,this.d=null,this.a=new i(512,v=>this.g(v))}add(u,v){this.d&&(this.b!==v||!k.$Yf(this.c,u.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:u.uri,results:[]}),this.d.results.push(C(u))}f(){const u=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,u)}flush(){this.f(),this.a.flush()}g(u){this.e(u)}}e.$l_b=D;function C(c){return p(c)?{preview:{matches:(0,b.$Ff)(c.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:c.preview.text},ranges:(0,b.$Ff)(c.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function p(c){return!!c.preview}e.$m_b=p;class i{constructor(u,v){this.g=u,this.h=v,this.c=0,this.d=[],this.e=0}addItem(u,v){u&&this.j(u,v)}addItems(u,v){u&&this.k(u,v)}j(u,v){this.d.push(u),this.e+=v,this.l()}k(u,v){this.d=this.d.concat(u),this.e+=v,this.l()}l(){this.c<i.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},i.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$n_b=i,i.a=4e3,i.b=50}),define(De[90],Ce([1,0,4,6,5,322,20,59,18,2,147]),function(re,e,b,A,h,F,R,m,k,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=e.$p_b=e.$o_b=void 0,e.$o_b=(0,h.$lh)("IExtHostSearch");let I=e.$p_b=class{constructor(p,i,c){this.k=p,this.l=i,this.n=c,this.c=this.k.getProxy(A.$_I.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$j_b}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,i){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const c=this.d++;return this.e.set(c,i),this.c.$registerTextSearchProvider(c,this.o(p)),(0,b.$ib)(()=>{this.g.delete(p),this.e.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(p,i){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const c=this.d++;return this.h.set(c,i),this.c.$registerFileSearchProvider(c,this.o(p)),(0,b.$ib)(()=>{this.i.delete(p),this.h.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(p,i,c,u){const v=w(c),f=this.h.get(p);if(f)return this.j.fileSearch(v,f,E=>{this.c.$handleFileMatch(p,i,E.map(n=>n.resource))},u);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,i,c,u){const v=this.e.get(p);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const f=w(c);return this.q(f,v).search(n=>this.c.$handleTextMatch(p,i,n),u)}$enableExtensionHostSearch(){}q(p,i){return new L.$k_b(p,i,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.$p_b=I=He([We(0,R.$bL),We(1,m.$80b),We(2,k.$Ni)],I);function w(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(D),extraFileResources:C.extraFileResources&&C.extraFileResources.map(p=>g.URI.revive(p))}}e.$q_b=w;function D(C){return{...C,folder:g.URI.revive(C.folder)}}}),define(De[330],Ce([1,0,21,8,3,41,2,125,123,163,162,30,6,106,277,276,37,278,38,280,281,282,259,283,62,44,284,285,290,291,292,146,263,298,299,302,110,43,304,264,13,7,79,307,85,145,35,25,255,289,78,143,87,89,90,18,59,20,26,293,253,58,83,273,305,84,64,310,308,309,274,51,303,306,109,63,82,294,86,295,16,128,262,243,287,4,27,249,107,239,296,297,275,286,261,300,288,108,301]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n,o,s,t,d,$,l,S,y,a,r,P,N,U,q,B,O,K,z,j,he,ie,ne,V,H,ce,pe,ye,ge,M,Y,ve,Se,ee,te,le,X,ue,se,oe,T,J,Z,x,me,Ee,fe,Ie,Pe,qe,Ve,tt,Ge,Ye,st,at,xe,rt,de,Me,_,Q,we,je,Oe,Xe,et,nt,ft,vt,Nt,Tt,Et,Bt,Ot,jt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;function Ht(ut){const gt=ut.get(X.$rL),Wt=ut.get(qe.$X0b),Rt=ut.get(me.$q$b),Ct=ut.get(t.$G$b),lt=ut.get(H.$$0b),Pt=ut.get(st.$vL),Mt=ut.get(u.$b$b),Fe=ut.get(te.$80b),Le=ut.get(le.$bL),Ae=ut.get(q.$m$b),ae=ut.get(x.$r$b),Ne=ut.get(ee.$Oi),Be=ut.get(ee.$Ni),Qe=ut.get(oe.$rob),Je=ut.get(T.$10b),it=ut.get(V.$5$b),kt=ut.get(Ge.$y$b),It=ut.get(Ye.$a_b),At=ut.get(jt.$C$b);Le.set(w.$aJ.ExtHostFileSystemInfo,Wt),Le.set(w.$aJ.ExtHostLogLevelServiceShape,Ne),Le.set(w.$aJ.ExtHostWorkspace,lt),Le.set(w.$aJ.ExtHostConfiguration,Mt),Le.set(w.$aJ.ExtHostExtensionService,Ct),Le.set(w.$aJ.ExtHostStorage,Ae),Le.set(w.$aJ.ExtHostTunnelService,Qe),Le.set(w.$aJ.ExtHostWindow,it),Le.set(w.$aJ.ExtHostSecretState,kt),Le.set(w.$aJ.ExtHostTelemetry,Pt),Le.set(w.$aJ.ExtHostEditorTabs,It),Le.set(w.$aJ.ExtHostManagedSockets,At);const bt=Le.set(w.$aJ.ExtHostDecorations,ut.get(M.$9$b)),pt=Le.set(w.$aJ.ExtHostDocumentsAndEditors,ut.get(s.$mL)),mt=Le.set(w.$aJ.ExtHostCommands,ut.get(i.$xL)),yt=Le.set(w.$aJ.ExtHostTerminalService,ut.get(B.$t$b)),wt=Le.set(w.$aJ.ExtHostDebugService,ut.get(ve.$e_b)),Xt=Le.set(w.$aJ.ExtHostSearch,ut.get(Se.$o_b)),qt=Le.set(w.$aJ.ExtHostTask,ut.get(Y.$_$b)),ni=Le.set(w.$aJ.ExtHostOutputService,ut.get(a.$O$b)),ai=Le.set(w.$aJ.ExtHostLocalization,ut.get(et.$B$b)),yi=Le.set(w.$aJ.ExtHostUrls,new ie.$X$b(Le)),Lt=Le.set(w.$aJ.ExtHostDocuments,new o.$V0b(Le,pt)),ci=Le.set(w.$aJ.ExtHostDocumentContentProviders,new E.$d$b(Le,pt,Be)),fi=Le.set(w.$aJ.ExtHostDocumentSaveParticipant,new n.$e$b(Be,Lt,Le.getProxy(w.$_I.MainThreadBulkEdits))),Dt=Le.set(w.$aJ.ExtHostNotebook,new ue.$u_b(Le,mt,pt,Lt,Rt)),Ei=Le.set(w.$aJ.ExtHostNotebookDocuments,new Q.$M_b(Dt)),Fi=Le.set(w.$aJ.ExtHostNotebookEditors,new _.$L_b(Be,Dt)),mi=Le.set(w.$aJ.ExtHostNotebookKernels,new at.$I_b(Le,gt,Dt,mt,Be)),Ti=Le.set(w.$aJ.ExtHostNotebookRenderers,new rt.$K_b(Le,Dt)),Mi=Le.set(w.$aJ.ExtHostNotebookDocumentSaveParticipant,new Et.$S_b(Be,Dt,Le.getProxy(w.$_I.MainThreadBulkEdits))),zt=Le.set(w.$aJ.ExtHostEditors,new O.$V$b(Le,pt)),Yt=Le.set(w.$aJ.ExtHostTreeViews,new K.$W$b(Le.getProxy(w.$_I.MainThreadTreeViews),mt,Be)),Ni=Le.set(w.$aJ.ExtHostEditorInsets,new pe.$6$b(Le.getProxy(w.$_I.MainThreadEditorInsets),zt,gt.remote)),ui=Le.set(w.$aJ.ExtHostDiagnostics,new v.$Z0b(Le,Be,Wt,pt)),li=Le.set(w.$aJ.ExtHostLanguages,new S.$L$b(Le,Lt,mt.converter,Fe)),ht=Le.set(w.$aJ.ExtHostLanguageFeatures,new l.$40b(Le,Fe,Lt,mt,ui,Be,Je,Pt)),an=Le.set(w.$aJ.ExtHostFileSystem,new d.$J$b(Le,ht)),Jt=Le.set(w.$aJ.ExtHostFileSystemEventService,new $.$K$b(Le,Be,pt)),ri=Le.set(w.$aJ.ExtHostQuickOpen,(0,P.$Q$b)(Le,lt,mt)),ki=Le.set(w.$aJ.ExtHostSCM,new N.$S$b(Le,mt,Lt,Be)),Oi=Le.set(w.$aJ.ExtHostQuickDiff,new vt.$P_b(Le,Fe)),zi=Le.set(w.$aJ.ExtHostShare,new Vt.$V_b(Le,Fe)),ji=Le.set(w.$aJ.ExtHostComments,(0,c.$70b)(Le,mt,Lt)),Si=Le.set(w.$aJ.ExtHostProgress,new r.$P$b(Le.getProxy(w.$_I.MainThreadProgress))),Ui=Le.set(w.$aJ.ExtHosLabelService,new ye.$7$b(Le)),Di=Le.set(w.$aJ.ExtHostTheming,new se.$v_b(Le)),si=Le.set(w.$aJ.ExtHostAuthentication,new J.$w_b(Le)),Bi=Le.set(w.$aJ.ExtHostTimeline,new Z.$y_b(Le,mt)),gi=Le.set(w.$aJ.ExtHostWebviews,new ne.$1$b(Le,gt.remote,lt,Be,Je)),$i=Le.set(w.$aJ.ExtHostWebviewPanels,new Ie.$A_b(Le,gi,lt)),Wi=Le.set(w.$aJ.ExtHostCustomEditors,new fe.$B_b(Le,Lt,ae,gi,$i)),qi=Le.set(w.$aJ.ExtHostWebviewViews,new Ee.$z_b(Le,gi)),oi=Le.set(w.$aJ.ExtHostTesting,new Ve.$D_b(Le,mt,pt)),Vi=Le.set(w.$aJ.ExtHostUriOpeners,new tt.$H_b(Le)),Hi=Le.set(w.$aJ.ExtHostProfileContentHandlers,new ft.$O_b(Le));Le.set(w.$aJ.ExtHostInteractive,new we.$N_b(Le,Dt,pt,mt,Be));const Ji=Le.set(w.$aJ.ExtHostInlineChat,new Tt.$R_b(Le,mt,Lt,Be)),ei=Le.set(w.$aJ.ExtHostChat,new Nt.$Q_b(Le,Be)),Ki=Le.set(w.$aJ.ExtHostSemanticSimilarity,new Bt.$T_b(Le)),Gi=Le.set(w.$aJ.ExtHostIssueReporter,new Ot.$U_b(Le)),Ci=Le.set(w.$aJ.ExtHostStatusBar,new U.$U$b(Le,mt.converter)),Yi=Object.values(w.$aJ);Le.assertRegistered(Yi);const cn=new Pe.$C_b(Le,pt),un=new p.$60b(Le),hi=new y.$M$b(Le,Be),bi=new f.$c$b(Le);return C.$50b.register(mt),function(Ue,Zt,Ii){const $t=function(){let $e=!Ue.isUnderDevelopment;function ke(){$e||(Be.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function ze(ot){if(Array.isArray(ot))ot.forEach(ze);else if(typeof ot=="string")ke();else{const St=ot;typeof St.scheme>"u"&&ke(),typeof St.exclusive=="boolean"&&(0,Oe.$_E)(Ue,"documentFiltersExclusive")}return ot}}(),Qi={getSession($e,ke,ze){return si.getSession(Ue,$e,ke,ze)},getSessions($e,ke){return(0,Oe.$_E)(Ue,"authGetSessions"),si.getSessions(Ue,$e,ke)},async hasSession($e,ke){return(0,Oe.$_E)(Ue,"authSession"),!!await si.getSession(Ue,$e,ke,{silent:!0})},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider($e,ke,ze,ot){return si.registerAuthenticationProvider($e,ke,ze,ot)}},Xi={registerCommand($e,ke,ze){return mt.registerCommand(!0,$e,ke,ze,void 0,Ue)},registerTextEditorCommand($e,ke,ze){return mt.registerCommand(!0,$e,(...ot)=>{const St=zt.getActiveTextEditor();if(!St){Be.warn("Cannot execute "+$e+" because there is no active text editor.");return}return St.edit(Ft=>{ke.apply(ze,[St,Ft,...ot])}).then(Ft=>{Ft||Be.warn("Edits from command "+$e+" were not applied.")},Ft=>{Be.warn("An error occurred while running command "+$e,Ft)})},void 0,void 0,Ue)},registerDiffInformationCommand:($e,ke,ze)=>((0,Oe.$_E)(Ue,"diffCommand"),mt.registerCommand(!0,$e,async(...ot)=>{const St=pt.activeEditor(!0);if(!St){Be.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(St.id);ke.apply(ze,[Ft,...ot])},void 0,void 0,Ue)),executeCommand($e,...ke){return mt.executeCommand($e,...ke)},getCommands($e=!1){return mt.getCommands($e)}},Pi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return un.value},get shell(){return yt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Oe.$_E)(Ue,"envShellEvent"),yt.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$_E)(Ue,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$_E)(Ue,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,st.$uL)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,ke){return st.$tL.validateSender($e),Pt.instantiateLogger(Ue,$e,ke)},openExternal($e,ke){return it.openUri($e,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===gt.environment.appUriScheme)return yi.createAppUri($e);try{return await it.asExternalUri($e,{allowTunneling:!!gt.remote.authority})}catch(ke){if((0,Me.$BY)($e,de.Schemas.http)||(0,Me.$BY)($e,de.Schemas.https))return $e;throw ke}},get remoteName(){return(0,ge.$yk)(gt.remote.authority)},get remoteAuthority(){return(0,Oe.$_E)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Be.getLevel()},get onDidChangeLogLevel(){return Be.onDidChangeLogLevel},registerIssueUriRequestHandler($e){return(0,Oe.$_E)(Ue,"handleIssueUri"),Gi.registerIssueUriRequestHandler(Ue,$e)},get appQuality(){return(0,Oe.$_E)(Ue,"resolvers"),gt.quality},get appCommit(){return(0,Oe.$_E)(Ue,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Pi);const ln={createTestController($e,ke,ze){return oi.createTestController(Ue,$e,ke,ze)},createTestObserver(){return(0,Oe.$_E)(Ue,"testObserver"),oi.createTestObserver()},runTests($e){return(0,Oe.$_E)(Ue,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,Oe.$_E)(Ue,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Oe.$_E)(Ue,"testObserver"),oi.results}},di=gt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Zi={getExtension($e,ke){(0,Oe.$$E)(Ue,"extensionsAny")||(ke=!1);const ze=Zt.mine.getExtensionDescription($e);if(ze)return new t.$H$b(Ct,Ue.identifier,ze,di,!1);if(ke){const ot=Zt.all.getExtensionDescription($e);if(ot)return new t.$H$b(Ct,Ue.identifier,ot,di,!0)}},get all(){const $e=[];for(const ke of Zt.mine.getAllExtensionDescriptions())$e.push(new t.$H$b(Ct,Ue.identifier,ke,di,!1));return $e},get allAcrossExtensionHosts(){(0,Oe.$_E)(Ue,"extensionsAny");const $e=new ce.$Fl(Zt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ke=[];for(const ze of Zt.all.getAllExtensionDescriptions()){const ot=!$e.has(ze.identifier);ke.push(new t.$H$b(Ct,Ue.identifier,ze,di,ot))}return ke},get onDidChange(){return(0,Oe.$$E)(Ue,"extensionsAny")?h.Event.any(Zt.mine.onDidChange,Zt.all.onDidChange):Zt.mine.onDidChange}},_t={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Ue.identifier,$e)},get onDidChangeDiagnostics(){return ui.onDidChangeDiagnostics},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,ke){return li.changeLanguage($e.uri,ke)},match($e,ke){const ze=Lt.getDocumentData(ke.uri)?.notebook;return(0,L.$yE)(z.LanguageSelector.from($e),ke.uri,ke.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider($e,ke,ze){return ht.registerCodeActionProvider(Ue,$t($e),ke,ze)},registerDocumentPasteEditProvider($e,ke,ze){return(0,Oe.$_E)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,$t($e),ke,ze)},registerCodeLensProvider($e,ke){return ht.registerCodeLensProvider(Ue,$t($e),ke)},registerDefinitionProvider($e,ke){return ht.registerDefinitionProvider(Ue,$t($e),ke)},registerDeclarationProvider($e,ke){return ht.registerDeclarationProvider(Ue,$t($e),ke)},registerImplementationProvider($e,ke){return ht.registerImplementationProvider(Ue,$t($e),ke)},registerTypeDefinitionProvider($e,ke){return ht.registerTypeDefinitionProvider(Ue,$t($e),ke)},registerHoverProvider($e,ke){return ht.registerHoverProvider(Ue,$t($e),ke,Ue.identifier)},registerEvaluatableExpressionProvider($e,ke){return ht.registerEvaluatableExpressionProvider(Ue,$t($e),ke,Ue.identifier)},registerInlineValuesProvider($e,ke){return ht.registerInlineValuesProvider(Ue,$t($e),ke,Ue.identifier)},registerDocumentHighlightProvider($e,ke){return ht.registerDocumentHighlightProvider(Ue,$t($e),ke)},registerLinkedEditingRangeProvider($e,ke){return ht.registerLinkedEditingRangeProvider(Ue,$t($e),ke)},registerReferenceProvider($e,ke){return ht.registerReferenceProvider(Ue,$t($e),ke)},registerRenameProvider($e,ke){return ht.registerRenameProvider(Ue,$t($e),ke)},registerDocumentSymbolProvider($e,ke,ze){return ht.registerDocumentSymbolProvider(Ue,$t($e),ke,ze)},registerWorkspaceSymbolProvider($e){return ht.registerWorkspaceSymbolProvider(Ue,$e)},registerDocumentFormattingEditProvider($e,ke){return ht.registerDocumentFormattingEditProvider(Ue,$t($e),ke)},registerDocumentRangeFormattingEditProvider($e,ke){return ht.registerDocumentRangeFormattingEditProvider(Ue,$t($e),ke)},registerOnTypeFormattingEditProvider($e,ke,ze,...ot){return ht.registerOnTypeFormattingEditProvider(Ue,$t($e),ke,[ze].concat(ot))},registerDocumentSemanticTokensProvider($e,ke,ze){return ht.registerDocumentSemanticTokensProvider(Ue,$t($e),ke,ze)},registerDocumentRangeSemanticTokensProvider($e,ke,ze){return ht.registerDocumentRangeSemanticTokensProvider(Ue,$t($e),ke,ze)},registerSignatureHelpProvider($e,ke,ze,...ot){return typeof ze=="object"?ht.registerSignatureHelpProvider(Ue,$t($e),ke,ze):ht.registerSignatureHelpProvider(Ue,$t($e),ke,typeof ze>"u"?[]:[ze,...ot])},registerCompletionItemProvider($e,ke,...ze){return ht.registerCompletionItemProvider(Ue,$t($e),ke,ze)},registerInlineCompletionItemProvider($e,ke){return ke.handleDidShowCompletionItem&&(0,Oe.$_E)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$_E)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,$t($e),ke)},registerDocumentLinkProvider($e,ke){return ht.registerDocumentLinkProvider(Ue,$t($e),ke)},registerColorProvider($e,ke){return ht.registerColorProvider(Ue,$t($e),ke)},registerFoldingRangeProvider($e,ke){return ht.registerFoldingRangeProvider(Ue,$t($e),ke)},registerSelectionRangeProvider($e,ke){return ht.registerSelectionRangeProvider(Ue,$e,ke)},registerCallHierarchyProvider($e,ke){return ht.registerCallHierarchyProvider(Ue,$e,ke)},registerTypeHierarchyProvider($e,ke){return ht.registerTypeHierarchyProvider(Ue,$e,ke)},setLanguageConfiguration:($e,ke)=>ht.setLanguageConfiguration(Ue,$e,ke),getTokenInformationAtPosition($e,ke){return(0,Oe.$_E)(Ue,"tokenInformation"),li.tokenAtPosition($e,ke)},registerInlayHintsProvider($e,ke){return ht.registerInlayHintsProvider(Ue,$e,ke)},createLanguageStatusItem($e,ke){return li.createLanguageStatusItem(Ue,$e,ke)},registerDocumentDropEditProvider($e,ke,ze){return ht.registerDocumentOnDropEditProvider(Ue,$e,ke,(0,Oe.$$E)(Ue,"dropMetadata")?ze:void 0)}},pi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return yt.activeTerminal},get terminals(){return yt.terminals},async showTextDocument($e,ke,ze){const ot=await(R.URI.isUri($e)?Promise.resolve(_i.openTextDocument($e)):Promise.resolve($e));return zt.showTextDocument(ot,ke,ze)},createTextEditorDecorationType($e){return zt.createTextEditorDecorationType(Ue,$e)},onDidChangeActiveTextEditor($e,ke,ze){return zt.onDidChangeActiveTextEditor($e,ke,ze)},onDidChangeVisibleTextEditors($e,ke,ze){return zt.onDidChangeVisibleTextEditors($e,ke,ze)},onDidChangeTextEditorSelection($e,ke,ze){return zt.onDidChangeTextEditorSelection($e,ke,ze)},onDidChangeTextEditorOptions($e,ke,ze){return zt.onDidChangeTextEditorOptions($e,ke,ze)},onDidChangeTextEditorVisibleRanges($e,ke,ze){return zt.onDidChangeTextEditorVisibleRanges($e,ke,ze)},onDidChangeTextEditorViewColumn($e,ke,ze){return zt.onDidChangeTextEditorViewColumn($e,ke,ze)},onDidCloseTerminal($e,ke,ze){return yt.onDidCloseTerminal($e,ke,ze)},onDidOpenTerminal($e,ke,ze){return yt.onDidOpenTerminal($e,ke,ze)},onDidChangeActiveTerminal($e,ke,ze){return yt.onDidChangeActiveTerminal($e,ke,ze)},onDidChangeTerminalDimensions($e,ke,ze){return(0,Oe.$_E)(Ue,"terminalDimensions"),yt.onDidChangeTerminalDimensions($e,ke,ze)},onDidChangeTerminalState($e,ke,ze){return yt.onDidChangeTerminalState($e,ke,ze)},onDidWriteTerminalData($e,ke,ze){return(0,Oe.$_E)(Ue,"terminalDataWriteEvent"),yt.onDidWriteTerminalData($e,ke,ze)},get state(){return it.getState(Ue)},onDidChangeWindowState($e,ke,ze){return it.onDidChangeWindowState($e,ke,ze)},showInformationMessage($e,...ke){return hi.showMessage(Ue,F.default.Info,$e,ke[0],ke.slice(1))},showWarningMessage($e,...ke){return hi.showMessage(Ue,F.default.Warning,$e,ke[0],ke.slice(1))},showErrorMessage($e,...ke){return hi.showMessage(Ue,F.default.Error,$e,ke[0],ke.slice(1))},showQuickPick($e,ke,ze){return ri.showQuickPick(Ue,$e,ke,ze)},showWorkspaceFolderPick($e){return ri.showWorkspaceFolderPick($e)},showInputBox($e,ke){return ri.showInput($e,ke)},showOpenDialog($e){return bi.showOpenDialog(Ue,$e)},showSaveDialog($e){return bi.showSaveDialog($e)},createStatusBarItem($e,ke,ze){let ot,St,Ft;return typeof $e=="string"?(ot=$e,St=ke,Ft=ze):(St=$e,Ft=ke),Ci.createStatusBarEntry(Ue,ot,St,Ft)},setStatusBarMessage($e,ke){return Ci.setStatusBarMessage($e,ke)},withScmProgress($e){return Je.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Si.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(ke,ze)=>$e({report(ot){}}))},withProgress($e,ke){return Si.withProgress(Ue,$e,ke)},createOutputChannel($e,ke){return ni.createOutputChannel($e,ke,Ue)},createWebviewPanel($e,ke,ze,ot){return $i.createWebviewPanel(Ue,$e,ke,ze,ot)},createWebviewTextEditorInset($e,ke,ze,ot){return(0,Oe.$_E)(Ue,"editorInsets"),Ni.createWebviewEditorInset($e,ke,ze,ot,Ue)},createTerminal($e,ke,ze){return typeof $e=="object"?"pty"in $e?yt.createExtensionTerminal($e):yt.createTerminalFromOptions($e):yt.createTerminal($e,ke,ze)},registerTerminalLinkProvider($e){return yt.registerLinkProvider($e)},registerTerminalProfileProvider($e,ke){return yt.registerProfileProvider(Ue,$e,ke)},registerTerminalQuickFixProvider($e,ke){return(0,Oe.$_E)(Ue,"terminalQuickFixProvider"),yt.registerTerminalQuickFixProvider($e,Ue.identifier.value,ke)},registerTreeDataProvider($e,ke){return Yt.registerTreeDataProvider($e,ke,Ue)},createTreeView($e,ke){return Yt.createTreeView($e,ke,Ue)},registerWebviewPanelSerializer:($e,ke)=>$i.registerWebviewPanelSerializer(Ue,$e,ke),registerCustomEditorProvider:($e,ke,ze={})=>Wi.registerCustomEditorProvider(Ue,$e,ke,ze),registerFileDecorationProvider($e){return bt.registerFileDecorationProvider($e,Ue)},registerUriHandler($e){return yi.registerUriHandler(Ue,$e)},createQuickPick(){return ri.createQuickPick(Ue)},createInputBox(){return ri.createInputBox(Ue)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme($e,ke,ze){return Di.onDidChangeActiveColorTheme($e,ke,ze)},registerWebviewViewProvider($e,ke,ze){return qi.registerWebviewViewProvider(Ue,$e,ke,ze?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,ke,ze){return Dt.onDidChangeActiveNotebookEditor($e,ke,ze)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection($e,ke,ze){return Fi.onDidChangeNotebookEditorSelection($e,ke,ze)},onDidChangeNotebookEditorVisibleRanges($e,ke,ze){return Fi.onDidChangeNotebookEditorVisibleRanges($e,ke,ze)},showNotebookDocument($e,ke){return Dt.showNotebookDocument($e,ke)},registerExternalUriOpener($e,ke,ze){return(0,Oe.$_E)(Ue,"externalUriOpener"),Vi.registerExternalUriOpener(Ue.identifier,$e,ke,ze)},registerProfileContentHandler($e,ke){return(0,Oe.$_E)(Ue,"profileContentHandlers"),Hi.registrProfileContentHandler(Ue,$e,ke)},registerQuickDiffProvider($e,ke,ze,ot){return(0,Oe.$_E)(Ue,"quickDiffProvider"),Oi.registerQuickDiffProvider($t($e),ke,ze,ot)},get tabGroups(){return It.tabGroups},registerShareProvider($e,ke){return(0,Oe.$_E)(Ue,"shareProvider"),zi.registerShareProvider($t($e),ke)}},_i={get rootPath(){return Je.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath($e){throw A.$6()},getWorkspaceFolder($e){return lt.getWorkspaceFolder($e)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name($e){throw A.$6()},get workspaceFile(){return lt.workspaceFile},set workspaceFile($e){throw A.$6()},updateWorkspaceFolders:($e,ke,...ze)=>lt.updateWorkspaceFolders(Ue,$e,ke||0,...ze),onDidChangeWorkspaceFolders:function($e,ke,ze){return lt.onDidChangeWorkspace($e,ke,ze)},asRelativePath:($e,ke)=>lt.getRelativePath($e,ke),findFiles:($e,ke,ze,ot)=>lt.findFiles($e,ke,ze,Ue.identifier,ot),findTextInFiles:($e,ke,ze,ot)=>{(0,Oe.$_E)(Ue,"findTextInFiles");let St,Ft;return typeof ke=="object"?(St=ke,Ft=ze):(St={},Ft=ke,ot=ze),lt.findTextInFiles($e,St||{},Ft,Ue.identifier,ot)},save:$e=>((0,Oe.$_E)(Ue,"saveEditor"),lt.save($e)),saveAs:$e=>((0,Oe.$_E)(Ue,"saveEditor"),lt.saveAs($e)),saveAll:$e=>lt.saveAll($e),applyEdit($e,ke){return cn.applyWorkspaceEdit($e,Ue,ke)},createFileSystemWatcher:($e,ke,ze,ot)=>Jt.createFileSystemWatcher(lt,Ue,$e,ke,ze,ot),get textDocuments(){return Lt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw A.$6()},openTextDocument($e){let ke;const ze=$e;if(typeof $e=="string")ke=Promise.resolve(R.URI.file($e));else if(R.URI.isUri($e))ke=Promise.resolve($e);else if(!ze||typeof ze=="object")ke=Lt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ot=>Lt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:($e,ke,ze)=>Lt.onDidAddDocument($e,ke,ze),onDidCloseTextDocument:($e,ke,ze)=>Lt.onDidRemoveDocument($e,ke,ze),onDidChangeTextDocument:($e,ke,ze)=>Lt.onDidChangeDocument($e,ke,ze),onDidSaveTextDocument:($e,ke,ze)=>Lt.onDidSaveDocument($e,ke,ze),onWillSaveTextDocument:($e,ke,ze)=>fi.getOnWillSaveTextDocumentEvent(Ue)($e,ke,ze),get notebookDocuments(){return Dt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,ke){let ze;if(R.URI.isUri($e))ze=$e,await Dt.openNotebookDocument($e);else if(typeof $e=="string")ze=R.URI.revive(await Dt.createNotebookDocument({viewType:$e,content:ke}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument($e,ke,ze){return Ei.onDidSaveNotebookDocument($e,ke,ze)},onDidChangeNotebookDocument($e,ke,ze){return Ei.onDidChangeNotebookDocument($e,ke,ze)},onWillSaveNotebookDocument($e,ke,ze){return Mi.getOnWillSaveNotebookDocumentEvent(Ue)($e,ke,ze)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer($e,ke,ze,ot){return Dt.registerNotebookSerializer(Ue,$e,ke,ze,(0,Oe.$$E)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:($e,ke,ze)=>Ii.onDidChangeConfiguration($e,ke,ze),getConfiguration($e,ke){return ke=arguments.length===1?void 0:ke,Ii.getConfiguration($e,ke,Ue)},registerTextDocumentContentProvider($e,ke){return ci.registerTextDocumentContentProvider($e,ke)},registerTaskProvider:($e,ke)=>(Je.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Ue,$e,ke)),registerFileSystemProvider($e,ke,ze){return(0,je.$hb)(an.registerFileSystemProvider(Ue,$e,ke,ze),Rt.addFileSystemProvider($e,ke,ze))},get fs(){return Rt.value},registerFileSearchProvider:($e,ke)=>((0,Oe.$_E)(Ue,"fileSearchProvider"),Xt.registerFileSearchProvider($e,ke)),registerTextSearchProvider:($e,ke)=>((0,Oe.$_E)(Ue,"textSearchProvider"),Xt.registerTextSearchProvider($e,ke)),registerRemoteAuthorityResolver:($e,ke)=>((0,Oe.$_E)(Ue,"resolvers"),Ct.registerRemoteAuthorityResolver($e,ke)),registerResourceLabelFormatter:$e=>((0,Oe.$_E)(Ue,"resolvers"),Ui.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,Oe.$_E)(Ue,"resolvers"),Ct.getRemoteExecServer($e)),onDidCreateFiles:($e,ke,ze)=>Jt.onDidCreateFile($e,ke,ze),onDidDeleteFiles:($e,ke,ze)=>Jt.onDidDeleteFile($e,ke,ze),onDidRenameFiles:($e,ke,ze)=>Jt.onDidRenameFile($e,ke,ze),onWillCreateFiles:($e,ke,ze)=>Jt.getOnWillCreateFileEvent(Ue)($e,ke,ze),onWillDeleteFiles:($e,ke,ze)=>Jt.getOnWillDeleteFileEvent(Ue)($e,ke,ze),onWillRenameFiles:($e,ke,ze)=>Jt.getOnWillRenameFileEvent(Ue)($e,ke,ze),openTunnel:$e=>((0,Oe.$_E)(Ue,"tunnels"),Qe.openTunnel(Ue,$e).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Oe.$_E)(Ue,"tunnels"),Qe.getTunnels()},onDidChangeTunnels:($e,ke,ze)=>((0,Oe.$_E)(Ue,"tunnels"),Qe.onDidChangeTunnels($e,ke,ze)),registerPortAttributesProvider:($e,ke)=>((0,Oe.$_E)(Ue,"portsAttributes"),Qe.registerPortsAttributesProvider($e,ke)),registerTimelineProvider:($e,ke)=>((0,Oe.$_E)(Ue,"timeline"),Bi.registerTimelineProvider($e,ke,Ue.identifier,mt.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:$e=>((0,Oe.$_E)(Ue,"workspaceTrust"),lt.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,ke,ze)=>lt.onDidGrantWorkspaceTrust($e,ke,ze),registerEditSessionIdentityProvider:($e,ke)=>((0,Oe.$_E)(Ue,"editSessionIdentityProvider"),lt.registerEditSessionIdentityProvider($e,ke)),onWillCreateEditSessionIdentity:($e,ke,ze)=>((0,Oe.$_E)(Ue,"editSessionIdentityProvider"),lt.getOnWillCreateEditSessionIdentityEvent(Ue)($e,ke,ze)),registerCanonicalUriProvider:($e,ke)=>((0,Oe.$_E)(Ue,"canonicalUriProvider"),lt.registerCanonicalUriProvider($e,ke)),getCanonicalUri:($e,ke,ze)=>((0,Oe.$_E)(Ue,"canonicalUriProvider"),lt.provideCanonicalUri($e,ke,ze))},Kt={get inputBox(){return Je.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(Ue)},createSourceControl($e,ke,ze){return ki.createSourceControl(Ue,$e,ke,ze)}},wi={createCommentController($e,ke){return ji.createCommentController(Ue,$e,ke)}},xi={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},get stackFrameFocus(){return wt.stackFrameFocus},onDidStartDebugSession($e,ke,ze){return wt.onDidStartDebugSession($e,ke,ze)},onDidTerminateDebugSession($e,ke,ze){return wt.onDidTerminateDebugSession($e,ke,ze)},onDidChangeActiveDebugSession($e,ke,ze){return wt.onDidChangeActiveDebugSession($e,ke,ze)},onDidReceiveDebugSessionCustomEvent($e,ke,ze){return wt.onDidReceiveDebugSessionCustomEvent($e,ke,ze)},onDidChangeBreakpoints($e,ke,ze){return wt.onDidChangeBreakpoints($e,ke,ze)},onDidChangeStackFrameFocus($e,ke,ze){return(0,Oe.$_E)(Ue,"debugFocus"),wt.onDidChangeStackFrameFocus($e,ke,ze)},registerDebugConfigurationProvider($e,ke,ze){return wt.registerDebugConfigurationProvider($e,ke,ze||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,ke){return wt.registerDebugAdapterDescriptorFactory(Ue,$e,ke)},registerDebugAdapterTrackerFactory($e,ke){return wt.registerDebugAdapterTrackerFactory($e,ke)},startDebugging($e,ke,ze){return!ze||typeof ze=="object"&&"configuration"in ze?wt.startDebugging($e,ke,{parentSession:ze}):wt.startDebugging($e,ke,ze||{})},stopDebugging($e){return wt.stopDebugging($e)},addBreakpoints($e){return wt.addBreakpoints($e)},removeBreakpoints($e){return wt.removeBreakpoints($e)},asDebugSourceUri($e,ke){return wt.asDebugSourceUri($e,ke)}},en={registerTaskProvider:($e,ke)=>qt.registerTaskProvider(Ue,$e,ke),fetchTasks:$e=>qt.fetchTasks($e),executeTask:$e=>qt.executeTask(Ue,$e),get taskExecutions(){return qt.taskExecutions},onDidStartTask:($e,ke,ze)=>qt.onDidStartTask($e,ke,ze),onDidEndTask:($e,ke,ze)=>qt.onDidEndTask($e,ke,ze),onDidStartTaskProcess:($e,ke,ze)=>qt.onDidStartTaskProcess($e,ke,ze),onDidEndTaskProcess:($e,ke,ze)=>qt.onDidEndTaskProcess($e,ke,ze)},tn={createNotebookController($e,ke,ze,ot,St){return mi.createNotebookController(Ue,$e,ke,ze,ot,(0,Oe.$$E)(Ue,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:($e,ke)=>Dt.registerNotebookCellStatusBarItemProvider(Ue,$e,ke),createRendererMessaging($e){return Ti.createRendererMessaging(Ue,$e)},createNotebookControllerDetectionTask($e){return(0,Oe.$_E)(Ue,"notebookKernelSource"),mi.createNotebookControllerDetectionTask(Ue,$e)},registerKernelSourceActionProvider($e,ke){return(0,Oe.$_E)(Ue,"notebookKernelSource"),mi.registerKernelSourceActionProvider(Ue,$e,ke)},onDidChangeNotebookCellExecutionState($e,ke,ze){return(0,Oe.$_E)(Ue,"notebookCellExecutionState"),mi.onDidChangeNotebookCellExecutionState($e,ke,ze)}},nn={t(...$e){if(typeof $e[0]=="string"){const ke=$e.shift(),ze=!$e||typeof $e[0]!="object"?$e:$e[0];return ai.getMessage(Ue.identifier.value,{message:ke,args:ze})}return ai.getMessage(Ue.identifier.value,$e[0])},get bundle(){return ai.getBundle(Ue.identifier.value)},get uri(){return ai.getBundleUri(Ue.identifier.value)}},hn={_version:1,registerInteractiveEditorSessionProvider($e){return(0,Oe.$_E)(Ue,"interactive"),Ji.registerProvider(Ue,$e)},registerInteractiveSessionProvider($e,ke){return(0,Oe.$_E)(Ue,"interactive"),ei.registerChatProvider(Ue,$e,ke)},addInteractiveRequest($e){return(0,Oe.$_E)(Ue,"interactive"),ei.addChatRequest($e)},sendInteractiveRequestToProvider($e,ke){return(0,Oe.$_E)(Ue,"interactive"),ei.sendInteractiveRequestToProvider($e,ke)},get onDidPerformUserAction(){return(0,Oe.$_E)(Ue,"interactiveUserActions"),ei.onDidPerformUserAction},transferChatSession($e,ke){return(0,Oe.$_E)(Ue,"interactive"),ei.transferChatSession($e,ke)}},rn={registerSlashCommandProvider($e,ke){return(0,Oe.$_E)(Ue,"interactiveSlashCommands"),ei.registerSlashCommandProvider(Ue,$e,ke)}},sn={registerSemanticSimilarityProvider($e){return(0,Oe.$_E)(Ue,"semanticSimilarity"),Ki.registerSemanticSimilarityProvider(Ue,$e)}};return{version:gt.version,ai:sn,authentication:Qi,commands:Xi,comments:wi,debug:xi,env:Pi,extensions:Zi,interactive:hn,interactiveSlashCommands:rn,l10n:nn,languages:_t,notebooks:tn,scm:Kt,tasks:en,tests:ln,window:pi,workspace:_i,Breakpoint:j.$aK,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.$zJ,CallHierarchyItem:j.$yJ,CallHierarchyOutgoingCall:j.$AJ,CancellationError:A.$2,CancellationTokenSource:b.$bd,CandidatePortSource:w.CandidatePortSource,CodeAction:j.$uJ,CodeActionKind:j.$vJ,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.$BJ,Color:j.$OJ,ColorInformation:j.$PJ,ColorPresentation:j.$QJ,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentState:j.CommentState,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.$IJ,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.$JJ,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.$YJ,DebugAdapterExecutable:j.$eK,DebugAdapterInlineImplementation:j.$hK,DebugAdapterNamedPipeServer:j.$gK,DebugAdapterServer:j.$fK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.$pJ,DiagnosticRelatedInformation:j.$oJ,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.$bJ,DocumentHighlight:j.$rJ,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.$NJ,DocumentSymbol:j.$tJ,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.$kK,InlineValueText:j.$lK,InlineValueVariableLookup:j.$mK,InlineValueEvaluatableExpression:j.$nK,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:h.$5c,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.$xK,FileDecoration2:j.$xK,FileSystemError:j.$pK,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:j.$qK,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.$cK,InlineCompletionItem:j.$KJ,InlineCompletionList:j.$LJ,Hover:j.$qJ,IndentAction:g.IndentAction,Location:j.$nJ,MarkdownString:j.$CJ,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:j.$DJ,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.$cJ,ProcessExecution:j.$WJ,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.$wK,Range:j.$dJ,RelativePattern:j.$$J,Selection:j.$eJ,SelectionRange:j.$xJ,SemanticTokens:j.$tK,SemanticTokensBuilder:j.$sK,SemanticTokensEdit:j.$uK,SemanticTokensEdits:j.$vK,SemanticTokensLegend:j.$rK,ShellExecution:j.$XJ,ShellQuoting:j.ShellQuoting,SignatureHelp:j.$FJ,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.$EJ,SnippetString:j.$mJ,SourceBreakpoint:j.$bK,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.$sJ,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.$ZJ,TaskGroup:j.$VJ,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.$RJ,TerminalQuickFixCommand:j.$TJ,TerminalQuickFixOpener:j.$SJ,TerminalLocation:j.TerminalLocation,TerminalProfile:j.$UJ,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.$iJ,SnippetTextEdit:j.$kJ,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.$0J,ThemeIcon:j.$9J,TreeItem:j.$1J,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.$TK,UIKind:D.UIKind,Uri:R.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.$lJ,DocumentDropEdit:j.$7J,DocumentPasteEdit:j.$8J,InlayHint:j.$HJ,InlayHintLabelPart:j.$GJ,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.$hJ,ResolvedAuthority:j.$fJ,ManagedResolvedAuthority:j.$gJ,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.$HK,NotebookRange:j.$zK,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.$AK,NotebookData:j.$BK,NotebookRendererScript:j.$FK,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.$DK,NotebookCellOutputItem:j.$CK,NotebookCellStatusBarItem:j.$EK,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.$jJ,NotebookKernelSourceAction:j.$GK,PortAttributes:j.$JK,LinkedEditingRanges:j.$IK,TestResultState:j.TestResultState,TestRunRequest:j.$KK,TestRunRequest2:j.$LK,TestMessage:j.$MK,TestTag:j.$NK,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:xe.TextSearchCompleteMessageType,DataTransfer:j.$6J,DataTransferItem:j.$2J,CoveredCount:j.$OK,FileCoverage:j.$PK,StatementCoverage:j.$QK,BranchCoverage:j.$RK,FunctionCoverage:j.$SK,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.$UK,TabInputTextDiff:j.$VK,TabInputTextMerge:j.$WK,TabInputCustom:j.$XK,TabInputNotebook:j.$ZK,TabInputNotebookDiff:j.$1K,TabInputWebview:j.$YK,TabInputTerminal:j.$2K,TabInputInteractiveWindow:j.$3K,TelemetryTrustedValue:he.$Yn,LogLevel:ee.LogLevel,EditSessionIdentityMatch:nt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:j.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind,StackFrameFocus:j.$iK,ThreadFocus:j.$jK,NotebookCodeActionKind:j.$wJ}}}e.$W_b=Ht}),define(De[331],Ce([1,0,98,146,35,143,38,37,62,43,87,89,90,110,58,83,145,64,51,109,82,63,144,18,52,107,108]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n,o,s,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.$9q)(t.$B$b,t.$A$b,1),(0,b.$9q)(o.$Oi,n.$X_b,1),(0,b.$9q)(p.$10b,p.$20b,1),(0,b.$9q)(m.$xL,m.$wL,0),(0,b.$9q)(R.$b$b,R.$_0b,0),(0,b.$9q)(c.$q$b,c.$p$b,0),(0,b.$9q)(I.$e_b,I.$i_b,0),(0,b.$9q)(F.$9$b,F.$8$b,0),(0,b.$9q)(k.$mL,k.$lL,0),(0,b.$9q)(d.$C$b,d.$D$b,0),(0,b.$9q)(u.$X0b,u.$W0b,0),(0,b.$9q)(A.$O$b,A.$N$b,1),(0,b.$9q)(w.$o_b,w.$p_b,0),(0,b.$9q)(D.$m$b,D.$l$b,0),(0,b.$9q)(L.$_$b,L.$$$b,0),(0,b.$9q)(g.$t$b,g.$w$b,0),(0,b.$9q)(C.$rob,C.$sob,0),(0,b.$9q)(i.$5$b,i.$4$b,0),(0,b.$9q)(h.$$0b,h.$00b,0),(0,b.$9q)(v.$y$b,v.$x$b,0),(0,b.$9q)(f.$vL,f.$sL,0),(0,b.$9q)(E.$a_b,E.$b_b,0),(0,b.$9q)(s.$c_b,s.$d_b,0)}),define(De[111],Ce([1,0,19,18,34,86]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=e.$cac=e.$bac=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$bac=R;function m(I,w,D,C){const p=(0,b.$Ff)(D,k),i=new h.$BH(w,p,C),c=i.preview.matches;return{ranges:(0,b.$Ff)(p,g),uri:I,preview:{text:i.preview.text,matches:(0,b.$Ff)(c,g)}}}e.$cac=m;function k(I){return new h.$CH(I.start.line,I.start.character,I.end.line,I.end.character)}function g(I){return new F.$rH(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=e.$dac=class{constructor(w,D){this.a=w,this.b=D}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$dac=L=He([We(1,A.$Ni)],L)}),define(De[332],Ce([1,0,45,10,69,31,9,11,111,333]),function(re,e,b,A,h,F,R,m,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=e.$fac=e.$eac=void 0;const L=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(v,f,E,n){const o=w(v,f,E,n),s=f.folder.fsPath;return{cmd:b.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.$eac=I;function w(v,f,E,n){const o=["--files","--hidden","--case-sensitive","--no-require-git"];C([f],E,!1).forEach(t=>{const d=(0,k.$bac)(t);if(o.push("-g",d),R.$e){const $=(0,h.$5k)(d);$!==d&&o.push("-g",$)}});const s=D([f],n,void 0,!1);return s.globArgs.forEach(t=>{const d=`!${(0,k.$bac)(t)}`;if(o.push("-g",d),R.$e){const $=(0,h.$5k)(d);$!==d&&o.push("-g",$)}}),f.disregardIgnoreFiles!==!1?o.push("--no-ignore"):f.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),f.ignoreSymlinks||o.push("--follow"),v.exists&&o.push("--quiet"),o.push("--no-config"),f.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function D(v,f,E,n=!0){const o=[];let s={};return v.forEach(t=>{const d=Object.assign({},t.excludePattern||{},f||{}),$=p(d,n?t.folder.fsPath:void 0,E);o.push(...$.globArgs),$.siblingClauses&&(s=Object.assign(s,$.siblingClauses))}),{globArgs:o,siblingClauses:s}}function C(v,f,E=!0){const n=[];return v.forEach(o=>{const s=Object.assign({},f||{},o.includePattern||{}),t=p(s,E?o.folder.fsPath:void 0);n.push(...t.globArgs)}),n}function p(v,f,E){const n=[],o={};return Object.keys(v).forEach(s=>{if(E&&E.has(s)||!s)return;const t=v[s];s=c(f?i(f,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof t=="boolean"&&t?(s.startsWith("\\\\")&&(s+="**"),n.push(u(s))):t&&t.when&&(o[s]=t)}),{globArgs:n,siblingClauses:o}}function i(v,f){return A.$0b(f)?f:A.$$b(v,f)}e.$fac=i;function c(v){return v=m.$qd(v,"\\"),m.$qd(v,"/")}function u(v){return F.$De(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.$gac=u}),define(De[334],Ce([1,0,45,49,10,335,19,46,32,69,31,9,40,11,12,29,34,332,116]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=e.$hac=void 0;const v=new Set;process.on("exit",()=>{v.forEach(s=>s())});class f{constructor(t){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=t,this.b=t.filePattern||"",this.d=t.includePattern&&k.$aj(t.includePattern),this.f=t.maxResults||null,this.g=!!t.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,u.$aq)(this.b).normalizedLowercase),this.u=t.excludePattern&&k.$aj(t.excludePattern),this.t=new Map,t.folderQueries.forEach(d=>{const $=Object.assign({},d.excludePattern||{},this.a.excludePattern||{}),l=d.folder.fsPath;t.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==l).forEach(S=>{(0,L.$He)(S,l)&&($[h.$ac(l,S)]=!0)}),this.t.set(l,new n($,l))})}cancel(){this.l=!0,v.forEach(t=>t())}walk(t,d,$,l,S){if(this.m=w.$1c.create(!1),this.l)return S(null,this.j);d.forEach(y=>{const a=h.$cc(y.fsPath);this.u&&this.u(y.fsPath,a)||this.J($,{relativePath:y.fsPath,searchPath:void 0})}),this.r=w.$1c.create(!1),this.w(t,(y,a)=>{this.x(this.y,this,y,$,l,r=>{if(r){const P=(0,m.$9h)(r);console.error(P),this.q.push(P),a(r,void 0)}else a(null,void 0)})},(y,a)=>{this.m.stop();const r=y?R.$jf(y)[0]:null;S(r,this.j)})}w(t,d,$){const l=new Array(t.length),S=new Array(t.length);let y=!1,a=0;if(t.length===0)return $(null,[]);t.forEach((r,P)=>{d(r,(N,U)=>{if(N?(y=!0,l[P]=null,S[P]=N):(l[P]=U,S[P]=null),++a===t.length)return $(y?S:null,l)})})}x(t,d,...$){try{t.apply(d,$)}catch(l){$[$.length-1](l)}}y(t,d,$,l){const S=t.folder.fsPath,y=I.$e,a=()=>q&&q.kill();v.add(a);let r=z=>{v.delete(a),r=()=>{},l(z)},P="";const N=this.D(),U=(0,c.$eac)(this.a,t,this.a.includePattern,this.t.get(t.folder.fsPath).expression),q=U.cmd,B=!Object.keys(U.siblingClauses).length,O=U.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let K=`${U.rgDiskPath} ${O}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),$({message:K}),this.s=0,this.z(q,"utf8",$,(z,j,he)=>{if(z){r(z);return}if(this.j){r();return}const ne=(P+(y?g.$4k(j||""):j)).split(`
`);if(he){const V=ne.length;ne[V-1]=ne[V-1].trim(),ne[V-1]||ne.pop()}else P=ne.pop()||"";if(ne.length&&ne[0].indexOf(`
`)!==-1){r(new Error("Splitting up files failed"));return}if(this.s+=ne.length,B){for(const V of ne)if(this.J(d,{base:S,relativePath:V,searchPath:this.N(t,V)}),this.j){a();break}(he||this.j)&&r();return}this.G(t,N,S,ne,d),he&&(this.H(N,S,d),r())})}spawnFindCmd(t){const d=this.t.get(t.folder.fsPath),$=d.getBasenameTerms(),l=d.getPathTerms(),S=["-L","."];if($.length||l.length){S.push("-not","(","(");for(const y of $)S.push("-name",y),S.push("-o");for(const y of l)S.push("-path",y),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),b.spawn("find",S,{cwd:t.folder.fsPath})}readStdout(t,d,$){let l="";this.z(t,d,()=>{},(S,y,a)=>{if(S){$(S);return}l+=y,a&&$(null,l)})}z(t,d,$,l){let S=(r,P,N)=>{(r||N)&&(S=()=>{},this.r?.stop()),l(r,P,N)},y=!1;t.stdout?(this.A(t.stdout,d,S),t.stdout.once("data",()=>y=!0)):$({message:"stdout is null"});let a;t.stderr?a=this.B(t.stderr):$({message:"stderr is null"}),t.on("error",r=>{S(r)}),t.on("close",r=>{let P;!y&&(P=this.C(a,d))&&o(P)?S(new Error(`command failed with error code ${r}: ${this.C(a,d)}`)):(this.g&&r===0&&(this.j=!0),S(null,"",!0))})}A(t,d,$){const l=new F.StringDecoder(d);return t.on("data",S=>{$(null,l.write(S))}),l}B(t){const d=[];return t.on("data",$=>{d.push($)}),d}C(t,d){const $=new F.StringDecoder(d);return t.map(l=>$.write(l)).join("")}D(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}G(t,{pathToEntries:d},$,l,S){l.indexOf(this.b)!==-1&&this.J(S,{base:$,relativePath:this.b,searchPath:this.N(t,this.b)});const y=a=>{const r=h.$cc(a),P=h.$bc(a);let N=d[P];N||(N=d[P]=[],y(P)),N.push({base:$,relativePath:a,basename:r,searchPath:this.N(t,a)})};l.forEach(y)}H({rootEntries:t,pathToEntries:d},$,l){const S=this,y=this.t.get($),a=this.b;function r(P){S.o++;const N=(0,i.$RH)(()=>P.map(U=>U.basename));for(let U=0,q=P.length;U<q;U++){const B=P[U],{relativePath:O,basename:K}=B;if(y.test(O,K,a!==K?N:void 0))continue;const z=d[O];if(z)r(z);else{if(S.p++,O===a)continue;S.J(l,B)}if(S.j)break}}r(t)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(t,d,$,l,S){const y=t.folder,a=(0,i.$RH)(()=>$);this.w($,(r,P)=>{if(this.l||this.j)return P(null);const N=d?[d,r].join(h.sep):r;if(this.t.get(t.folder.fsPath).test(N,r,this.a.filePattern!==r?a:void 0))return P(null);const U=[y.fsPath,N].join(h.sep);A.lstat(U,(q,B)=>{if(q||this.l||this.j)return P(null);this.L(U,B,(O,K)=>O||this.l||this.j?P(null):K.isDirectory()?(this.o++,this.M(U,B,(z,j)=>z||this.l||this.j||(j=j||"",this.v[j])?P(null):(this.v[j]=!0,p.Promises.readdir(U).then(he=>{if(this.l||this.j)return P(null);this.I(t,N,he,l,ie=>P(ie||null))},he=>{P(null)})))):(this.p++,N===this.b||this.h&&C.$ke(K.size)&&K.size>this.h||this.J(l,{base:y.fsPath,relativePath:N,searchPath:this.N(t,N)}),P(null,void 0)))})},r=>{const P=r&&R.$jf(r);return S(P&&P.length>0?P[0]:void 0)})}J(t,d){this.K(d)&&(!this.d||this.d(d.relativePath,h.$cc(d.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||t(d))}K(t){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,i.$MH)(t,this.c)}return!0}L(t,d,$){return d.isSymbolicLink()?A.stat(t,$):$(null,d)}M(t,d,$){return d.isSymbolicLink()?A.realpath(t,(l,S)=>l?$(l):$(null,S)):$(null,t)}N(t,d){return t.folderName?h.$$b(t.folderName,d):d}}e.$hac=f;class E{constructor(t){this.a=t.folderQueries,this.b=t.extraFileResources||[],this.c=new f(t)}search(t,d,$){this.c.walk(this.a,this.b,t,d,(l,S)=>{$(l,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$iac=E;class n{constructor(t,d){this.expression=t,this.c=d,this.d(t)}d(t){let d,$;Object.keys(t).filter(l=>t[l]).forEach(l=>{h.$0b(l)?(d=d||k.$8i(),d[l]=t[l]):($=$||k.$8i(),$[l]=t[l])}),this.a=d&&k.$aj(d,{trimForExclusions:!0}),this.b=$&&k.$aj($,{trimForExclusions:!0})}test(t,d,$){return this.b&&this.b(t,d,$)||this.a&&this.a(h.$$b(this.c,t),d,$)}getBasenameTerms(){const t=[];return this.a&&t.push(...k.$cj(this.a)),this.b&&t.push(...k.$cj(this.b)),t}getPathTerms(){const t=[];return this.a&&t.push(...k.$dj(this.a)),this.b&&t.push(...k.$dj(this.b)),t}}function o(s){const t=s.trim().split(`
`),d=t[0].trim();if(d.startsWith("Error parsing regex"))return d;if(d.startsWith("regex parse error"))return D.$$d(t[t.length-1].trim());if(d.startsWith("error parsing glob")||d.startsWith("unsupported encoding"))return d.charAt(0).toUpperCase()+d.substr(1);if(d==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(d.startsWith("Literal "))return d}}),define(De[336],Ce([1,0,93,22]),function(re,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.$HC=e.DecodeStreamErrorKind=e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=void 0,e.$zC="utf8",e.$AC="utf8bom",e.$BC="utf16be",e.$CC="utf16le";function h(s){return[e.$zC,e.$AC,e.$BC,e.$CC].some(t=>t===s)}e.$DC=h,e.$EC=[254,255],e.$FC=[255,254],e.$GC=[239,187,191];const F=512,R=512,m=512*8,k=512*128;var g;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(g||(e.DecodeStreamErrorKind=g={}));class L extends Error{constructor(t,d){super(t),this.decodeStreamErrorKind=d}}e.$HC=L;class I{static async create(t){let d;if(t!==e.$zC)d=(await new Promise((l,S)=>{re(["@vscode/iconv-lite-umd"],l,S)})).getDecoder(p(t));else{const $=new TextDecoder;d={write(l){return $.decode(l,{stream:!0})},end(){return $.decode()}}}return new I(d)}constructor(t){this.a=t}write(t){return this.a.write(t)}end(){return this.a.end()}}function w(s,t){const d=t.minBytesRequiredForDetection??t.guessEncoding?m:R;return new Promise(($,l)=>{const S=(0,b.$wb)(U=>U.join("")),y=[];let a=0,r;const P=async()=>{try{const U=await o({buffer:A.$Ib.concat(y),bytesRead:a},t.guessEncoding);if(U.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);U.encoding=await t.overwriteEncoding(U.encoding),r=await I.create(U.encoding);const q=r.write(A.$Ib.concat(y).buffer);S.write(q),y.length=0,a=0,$({stream:S,detected:U})}catch(U){N?.dispose(),S.destroy(),l(U)}},N=(0,b.$Ab)(s,{onData:async U=>{r?S.write(r.write(U.buffer)):(y.push(U),a+=U.byteLength,a>=d&&(s.pause(),await P(),setTimeout(()=>s.resume())))},onError:U=>S.error(U),onEnd:async()=>{r||await P(),S.end(r?.end())}})})}e.$IC=w;async function D(s,t,d){const l=(await new Promise((a,r)=>{re(["@vscode/iconv-lite-umd"],a,r)})).getEncoder(p(t),d);let S=!1,y=!1;return{read(){if(y)return null;const a=s.read();if(typeof a!="string"){if(y=!0,!S&&d?.addBOM)switch(t){case e.$zC:case e.$AC:return A.$Ib.wrap(Uint8Array.from(e.$GC));case e.$BC:return A.$Ib.wrap(Uint8Array.from(e.$EC));case e.$CC:return A.$Ib.wrap(Uint8Array.from(e.$FC))}const r=l.end();return r&&r.length>0?(S=!0,A.$Ib.wrap(r)):null}return S=!0,A.$Ib.wrap(l.write(a))}}}e.$JC=D;async function C(s){return(await new Promise((d,$)=>{re(["@vscode/iconv-lite-umd"],d,$)})).encodingExists(p(s))}e.$KC=C;function p(s){return s===e.$AC||s===null?e.$zC:s}e.$LC=p;function i(s,t){if(!s||t<e.$EC.length)return null;const d=s.readUInt8(0),$=s.readUInt8(1);if(d===e.$EC[0]&&$===e.$EC[1])return e.$BC;if(d===e.$FC[0]&&$===e.$FC[1])return e.$CC;if(t<e.$GC.length)return null;const l=s.readUInt8(2);return d===e.$GC[0]&&$===e.$GC[1]&&l===e.$GC[2]?e.$AC:null}e.$MC=i;const c=["ascii","utf-16","utf-32"];async function u(s){const t=await new Promise((y,a)=>{re(["jschardet"],y,a)}),d=s.slice(0,k),$=E(d.buffer),l=t.detect($);if(!l||!l.encoding)return null;const S=l.encoding.toLowerCase();return 0<=c.indexOf(S)?null:f(l.encoding)}const v={ibm866:"cp866",big5:"cp950"};function f(s){const t=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[t]||t}function E(s){let t="";for(let d=0;d<s.length;d++)t+=String.fromCharCode(s[d]);return t}function n(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=s.match(/windows(\d+)/);return t?"windows-"+t[1]:s}}}e.$NC=n;function o({buffer:s,bytesRead:t},d){let $=i(s,t),l=!1;if($!==e.$BC&&$!==e.$CC&&s){let S=!0,y=!0,a=!1;for(let r=0;r<t&&r<F;r++){const P=r%2===1,N=s.readUInt8(r)===0;if(N&&(a=!0),S&&(P&&!N||!P&&N)&&(S=!1),y&&(P&&N||!P&&!N)&&(y=!1),N&&!S&&!y)break}a&&(S?$=e.$CC:y?$=e.$BC:l=!0)}return d&&!l&&!$&&s?u(s.slice(0,t)).then(S=>({seemsBinary:!1,encoding:S})):{seemsBinary:l,encoding:$}}e.$OC=o,e.$PC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[148],Ce([1,0,336,29,147]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;class F extends h.$k_b{constructor(m,k,g=A,L="searchProcess"){super(m,k,{readdir:I=>g.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,b.$NC)(I)},L)}}e.$qac=F}),define(De[149],Ce([1,0,45,350,335,19,65,32,10,11,2,34,86,351,333,111]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=e.$oac=e.$nac=e.$mac=e.$lac=e.$kac=e.$jac=void 0;const i=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class c{constructor(r){this.a=r}provideTextSearchResults(r,P,N,U){return this.a.appendLine(`provideTextSearchResults ${r.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((q,B)=>{U.onCancellationRequested(()=>V());const O=o(r,P),K=P.folder.fsPath,z=O.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.a.appendLine(`${i} ${z}
 - cwd: ${K}`);let j=b.spawn(i,O,{cwd:K});j.on("error",ge=>{console.error(ge),this.a.appendLine("Error: "+(ge&&ge.message)),B((0,I.$IH)(new I.$GH(ge&&ge.message,I.SearchErrorCode.rgProcessError)))});let he=!1;const ie=new f(P.maxResults,K,P.previewOptions);ie.on("result",ge=>{he=!0,ce="",N.report(ge)});let ne=!1;const V=()=>{ne=!0,j?.kill(),ie?.cancel()};let H=!1;ie.on("hitLimit",()=>{H=!0,V()});let ce="";j.stdout.on("data",ge=>{ie.handleData(ge),he||(ce+=ge)});let pe=!1;j.stdout.once("data",()=>pe=!0);let ye="";j.stderr.on("data",ge=>{const M=ge.toString();this.a.appendLine(M),ye.length+M.length<1e6&&(ye+=M)}),j.on("close",()=>{if(this.a.appendLine(pe?"Got data from stdout":"No data from stdout"),this.a.appendLine(he?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),ne)q({limitHit:H});else{ie.flush(),j=null;let ge;ye&&!pe&&(ge=u(ye))?B((0,I.$IH)(new I.$GH(ge.message,ge.code))):q({limitHit:H})}})})}}e.$jac=c;function u(a){const r=a.split(`
`),P=r[0].trim();if(r.some(U=>U.startsWith("regex parse error")))return new I.$GH(v(r),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$GH(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$GH(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$GH(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$GH(P,I.SearchErrorCode.regexParseError)}function v(a){const r=["Regex parse error"],P=a.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const U=N.split(":")[1];r.push(":"+U)}}return r.join("")}class f extends A.EventEmitter{constructor(r,P,N){super(),this.g=r,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(r,P){return super.on(r,P),this}handleData(r){if(this.b)return;const P=typeof r=="string"?r:this.d.write(r);this.k(P)}k(r){let P=r.indexOf(`
`);const N=this.a+r;if(P>=0)P+=this.a.length;else{this.a=N;return}let U=0;for(;P>=0;)this.m(N.substring(U,P).trim()),U=P+1,P=N.indexOf(`
`,U);this.a=N.substring(U)}m(r){if(this.b||!r)return;let P;try{P=JSON.parse(r)}catch{throw new Error(`malformed line from rg: ${r}`)}if(P.type==="match"){const N=E(P.data.path),U=L.URI.file(k.$$b(this.h,N)),q=this.n(P.data,U);this.p(q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=E(P.data.path),U=L.URI.file(k.$$b(this.h,N));this.o(P.data,U).forEach(B=>this.p(B))}}n(r,P){const N=r.line_number-1,U=E(r.lines),q=Buffer.from(U);let B=0,O=0,K=N;r.submatches.length===0&&r.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const z=(0,F.$jf)(r.submatches.map((j,he)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=E(j.match),ne=q.slice(B,j.start).toString(),V=n(ne),H=V.numLines>0?V.lastLineLength:V.lastLineLength+O,ce=n(ie),pe=V.numLines+K,ye=ce.numLines+pe,ge=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+H;return B=j.end,O=ge,K=ye,new w.$rH(pe,H,ye,ge)}));return(0,p.$cac)(P,U,z,this.j)}o(r,P){const N=E(r.lines),U=r.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((q,B)=>({text:q,uri:P,lineNumber:U+B}))}p(r){this.emit("result",r)}}e.$kac=f;function E(a){return a.bytes?Buffer.from(a.bytes,"base64").toString():a.text}function n(a){const r=/\n/g;let P=0,N=-1,U;for(;U=r.exec(a);)P++,N=U.index;const q=N>=0?a.length-N-1:a.length;return{numLines:P,lastLineLength:q}}function o(a,r){const P=["--hidden","--no-require-git"];P.push(a.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:U}=(0,R.$D)(r.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const B=new Set;U.forEach(O=>{B.add(O)}),P.push("-g","!*"),B.forEach(O=>{s(O).map(p.$bac).forEach(K=>{P.push("-g",K)})})}N&&N.length&&N.forEach(B=>{P.push("-g",B)}),r.excludes.map(p.$bac).forEach(B=>P.push("-g",`!${B}`)),r.maxFileSize&&P.push("--max-filesize",r.maxFileSize+""),r.useIgnoreFiles?r.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),r.followSymlinks&&P.push("--follow"),r.encoding&&r.encoding!=="utf8"&&P.push("--encoding",r.encoding),a.pattern==="--"&&(a.isRegExp=!0,a.pattern="\\-\\-"),a.isMultiline&&!a.isRegExp&&(a.pattern=(0,g.$ld)(a.pattern),a.isRegExp=!0),r.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),a.isRegExp&&(a.pattern=t(a.pattern),P.push("--engine","auto"));let q;if(a.isWordMatch){const O=(0,g.$td)(a.pattern,!!a.isRegExp,{wholeWord:a.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",O)}else if(a.isRegExp){let B=$(a.pattern);B=l(B),P.push("--regexp",B)}else q=a.pattern,P.push("--fixed-strings");return P.push("--no-config"),r.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),a.isMultiline&&P.push("--multiline"),r.beforeContext&&P.push("--before-context",r.beforeContext+""),r.afterContext&&P.push("--after-context",r.afterContext+""),P.push("--"),q&&P.push(q),P.push("."),P}e.$lac=o;function s(a){return y(a).flatMap(P=>{const N=(0,m.$$i)(P,"/");return N.map((U,q)=>N.slice(0,q+1).join("/"))})}function t(a){const r=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;a.match(r);)a=a.replace(r,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;a.match(P);)a=a.replace(P,"$1\\x{$2}");return a}e.$mac=t;const d=a=>a.type==="Assertion"&&a.kind==="lookbehind";function $(a){let r;try{r=new D.RegExpParser().parsePattern(a)}catch{return a}let P="",N=0;const U=(O,K,z)=>{P+=a.slice(N,O)+z,N=K},q=[];return new D.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const K=q[0];if(!K)U(O.start,O.end,"\\r?\\n");else if(!q.some(d))if(K.type==="CharacterClass")if(K.negate){const z=a.slice(K.start+2,O.start)+a.slice(O.end,K.end-1);K.parent?.type==="Quantifier"?U(K.start,K.end,z?`[^${z}]`:"."):U(K.start,K.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=a.slice(K.start+1,O.start)+a.slice(O.end,K.end-1);U(K.start,K.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else K.type==="Quantifier"&&U(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){q.unshift(O)},onQuantifierLeave(){q.shift()},onCharacterClassRangeEnter(O){q.unshift(O)},onCharacterClassRangeLeave(){q.shift()},onCharacterClassEnter(O){q.unshift(O)},onCharacterClassLeave(){q.shift()},onAssertionEnter(O){d(O)&&q.push(O)},onAssertionLeave(O){q[0]===O&&q.shift()}}).visit(r),P+=a.slice(N),P}e.$nac=$;function l(a){return a.replace(/\n/g,"\\r?\\n")}e.$oac=l;function S(a){let r=!1,P=!1,N="",U="";for(let q=0;q<a.length;q++){const B=a[q];switch(B){case"\\":P?(r?U+="\\"+B:N+="\\"+B,P=!1):P=!0;break;case"{":if(P)r?U+=B:N+=B,P=!1;else{if(r)return{strInBraces:N+"{"+U+"{"+a.substring(q+1)};r=!0}break;case"}":if(P)r?U+=B:N+=B,P=!1;else{if(r)return{fixedStart:N,strInBraces:U,fixedEnd:a.substring(q+1)};N+=B}break;default:r?U+=(P?"\\":"")+B:N+=(P?"\\":"")+B,P=!1;break}}return{strInBraces:N+(r?"{"+U:"")}}function y(a){const{fixedStart:r,strInBraces:P,fixedEnd:N}=S(a);if(r===void 0||N===void 0)return[P];let U=(0,m.$$i)(P,",");U.length||(U=[""]);const q=y(N);return U.flatMap(B=>{const O=r+B;return q.map(K=>O+K)})}e.$pac=y}),define(De[337],Ce([1,0,21,149,129,16]),function(re,e,b,A,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;class R{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,L,I,w){const D=new A.$jac(this.b);if(L.folder.scheme===F.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:F.Schemas.file})},p=new h.$rz(i=>I.report({...i,uri:i.uri.with({scheme:L.folder.scheme})}));return this.c(w,i=>D.provideTextSearchResults(g,C,p,i))}else return this.c(w,C=>D.provideTextSearchResults(g,L,I,C))}async c(g,L){const I=m(g);this.a.add(I);const w=await L(I.token);return this.a.delete(I),w}d(){this.a.forEach(g=>g.cancel())}}e.$tac=R;function m(k){const g=new b.$bd;return k.onCancellationRequested(()=>g.cancel()),g}}),define(De[338],Ce([1,0,29,149,148]),function(re,e,b,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;class F{constructor(k){this.a=k}search(k,g,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(D){L({message:D})}},w=new h.$qac(this.a,new A.$jac(I),b);return new Promise((D,C)=>w.search(p=>{g(p.map(R))},k).then(p=>D({limitHit:p.limitHit,type:"success",stats:p.stats}),C))}}e.$rac=F;function R(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((k,g)=>{if(g.ranges){const L=g;return k+(Array.isArray(L.ranges)?L.ranges.length:1)}else return k+1},0)}}}),define(De[339],Ce([1,0,19,17,8,3,116,10,40,2,30,34,334,338]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class C{constructor(f="searchProcess"){this.d=f,this.b=Object.create(null)}fileSearch(f){let E;const n=c(f),o=new F.$5c({onDidAddFirstListener:()=>{E=(0,A.$fg)(s=>this.doFileSearchWithEngine(w.$iac,n,t=>o.fire(t),s)),E.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{E.cancel()}});return o.event}textSearch(f){let E;const n=c(f),o=new F.$5c({onDidAddFirstListener:()=>{E=(0,A.$fg)(s=>this.f(n,t=>o.fire(t),s)),E.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{E.cancel()}});return o.event}f(f,E,n){return f.maxFileSize=this.g().maxFileSize,new D.$rac(f).search(n,E,E)}g(){return{maxFileSize:process.arch==="ia32"?300*L.$jk.MB:16*L.$jk.GB}}doFileSearch(f,E,n){return this.doFileSearchWithEngine(w.$iac,f,E,n)}doFileSearchWithEngine(f,E,n,o,s=C.a){let t=0;const d=l=>{Array.isArray(l)?(t+=l.length,n(l.map(S=>this.h(S)))):l.relativePath?(t++,n(this.h(l))):n(l)};if(E.sortByScore){let l=this.l(E,d,o);if(!l){const S=E.maxResults?Object.assign({},E,{maxResults:null}):E,y=new f(S);l=this.j(y,E,n,d,o)}return new Promise((S,y)=>{l.then(([a,r])=>{const P=r.map(N=>this.h(N));this.o(P,n,s),S(a)},y)})}const $=new f(E);return this.r($,d,s,o).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.d,fromCache:!1,resultCount:t,sortingTime:void 0}}))}h(f){return{path:f.base?(0,m.$$b)(f.base,f.relativePath):f.relativePath}}j(f,E,n,o,s){const t=new F.$5c;let d=(0,A.$fg)(l=>{let S=[];const y=a=>{Array.isArray(a)?S=a:(o(a),t.fire(a))};return this.r(f,y,-1,l).then(a=>[a,S])}),$;if(E.cacheKey){$=this.k(E.cacheKey);const l={promise:d,event:t.event,resolved:!1};$.resultsToSearchCache[E.filePattern||""]=l,d.then(()=>{l.resolved=!0},S=>{delete $.resultsToSearchCache[E.filePattern||""]}),d=this.s(d)}return d.then(([l,S])=>{const y=$?$.scorerCache:Object.create(null),a=(typeof E.maxResults!="number"||E.maxResults>0)&&k.$1c.create(!1);return this.n(E,S,y,s).then(r=>{const P=a?a.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:E.folderQueries.length,resultCount:r.length},messages:l.messages,limitHit:l.limitHit||typeof E.maxResults=="number"&&S.length>E.maxResults},r]})})}k(f){const E=this.b[f];return E||(this.b[f]=new p)}l(f,E,n){const o=f.cacheKey&&this.b[f.cacheKey];if(!o)return;const s=this.q(o,f.filePattern||"",E,n);if(s)return s.then(([t,d,$])=>{const l=k.$1c.create(!1);return this.n(f,d,o.scorerCache,n).then(S=>{const y=l.elapsed(),a={fromCache:!0,detailStats:$,type:this.d,resultCount:d.length,sortingTime:y};return[{type:"success",limitHit:t.limitHit||typeof f.maxResults=="number"&&d.length>f.maxResults,stats:a},S]})})}n(f,E,n,o){const s=(0,R.$aq)(f.filePattern||""),t=($,l)=>(0,R.$_p)($,l,s,!0,i,n),d=typeof f.maxResults=="number"?f.maxResults:Number.MAX_VALUE;return b.$if(E,t,d,1e4,o)}o(f,E,n){if(n&&n>0)for(let o=0;o<f.length;o+=n)E(f.slice(o,o+n));else E(f)}q(f,E,n,o){const s=k.$1c.create(!1),t=E.indexOf(m.sep)>=0;let d;for(const y in f.resultsToSearchCache)if(E.startsWith(y)){if(t&&y.indexOf(m.sep)<0&&y!=="")continue;const a=f.resultsToSearchCache[y];d={promise:this.s(a.promise),event:a.event,resolved:a.resolved};break}if(!d)return null;const $=s.elapsed(),l=k.$1c.create(!1),S=d.event(n);return o&&o.onCancellationRequested(()=>{S.dispose()}),d.promise.then(([y,a])=>{if(o&&o.isCancellationRequested)throw(0,h.$3)();const r=[],P=(0,R.$aq)(E).normalizedLowercase;for(const N of a)(0,I.$MH)(N,P)&&r.push(N);return[y,r,{cacheWasResolved:d.resolved,cacheLookupTime:$,cacheFilterTime:l.elapsed(),cacheEntryCount:a.length}]})}r(f,E,n,o){return new Promise((s,t)=>{let d=[];o?.onCancellationRequested(()=>f.cancel()),f.search($=>{$&&(n?(d.push($),n>0&&d.length>=n&&(E(d),d=[])):E($))},$=>{E($)},($,l)=>{d.length&&E(d),$?t($):s(l)})})}clearCache(f){return delete this.b[f],Promise.resolve(void 0)}s(f){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(E,n){return f.then(E,n)}catch(E){return this.then(void 0,E)}finally(E){return f.finally(E)}}}}e.$sac=C,C.a=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const i=new class{getItemLabel(v){return(0,m.$cc)(v.relativePath)}getItemDescription(v){return(0,m.$bc)(v.relativePath)}getItemPath(v){return v.relativePath}};function c(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(u),extraFileResources:v.extraFileResources&&v.extraFileResources.map(f=>g.URI.revive(f))}}function u(v){return{...v,folder:g.URI.revive(v.folder)}}}),define(De[340],Ce([1,0,4,16,2,29,18,26,20,90,59,34,339,337,111,148]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;let i=e.$uac=class extends g.$p_b{constructor(u,v,f,E){super(u,f,E),this.s=F,this.t=-1,this.v=null,this.w=!1;const n=new C.$dac("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new D.$tac(n)),v.remote.isRemote&&v.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const u=new C.$dac("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new D.$tac(u)),this.y(A.Schemas.file,new w.$sac("fileSearchProvider"))}y(u,v){const f=this.d++;return this.v=v,this.t=f,this.c.$registerFileSearchProvider(f,this.o(u)),(0,b.$ib)(()=>{this.v=null,this.c.$unregisterProvider(f)})}$provideFileSearchResults(u,v,f,E){const n=(0,g.$q_b)(f);return u===this.t?this.z(u,v,n,E):super.$provideFileSearchResults(u,v,f,E)}z(u,v,f,E){const n=o=>{if((0,I.$LH)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(u,v,o.map(s=>h.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(f,n,E)}$clearCache(u){return this.v?.clearCache(u),super.$clearCache(u)}q(u,v){return new p.$qac(u,v,void 0,"textSearchProvider")}};e.$uac=i=He([We(0,k.$bL),We(1,m.$rL),We(2,L.$80b),We(3,R.$Ni)],i)}),define(De[150],Ce([1,0,352,102,74,353,22,8,3,4,10,9,33,75,120]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0;class p{traceSocketEvent(a,r){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,r)}constructor(a,r=""){this.f=!0,this.debugLabel=r,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,m.$X)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const r=P=>{this.traceSocketEvent("read",P),a(R.$Ib.wrap(P))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(a){const r=P=>{a({type:0,hadError:P,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(a){const r=()=>{a()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,m.$X)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,m.$X)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$ah=p;var i;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(i||(i={}));var c;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(c||(c={}));class u extends g.$kb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,r){this.socket.traceSocketEvent(a,r)}constructor(a,r,P,N){super(),this.f=this.B(new k.$5c),this.g=this.B(new k.$5c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new v(this,r,P,N,this.f,(U,q)=>this.k(U,q))),this.B(this.a.onError(U=>{console.error(U),(0,m.$X)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new C.$8g,this.B(this.socket.onData(U=>this.l(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let r=0;for(;r<a.byteLength;)this.a.writeMessage(a.slice(r,Math.min(r+262144,a.byteLength))),r+=262144}k(a,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let P=2;a.byteLength<126?P+=0:a.byteLength<2**16?P+=2:P+=8;const N=R.$Ib.alloc(P);if(r?N.writeUInt8(194,0):N.writeUInt8(130,0),a.byteLength<126)N.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){N.writeUInt8(126,1);let U=1;N.writeUInt8(a.byteLength>>>8&255,++U),N.writeUInt8(a.byteLength>>>0&255,++U)}else{N.writeUInt8(127,1);let U=1;N.writeUInt8(0,++U),N.writeUInt8(0,++U),N.writeUInt8(0,++U),N.writeUInt8(0,++U),N.writeUInt8(a.byteLength>>>24&255,++U),N.writeUInt8(a.byteLength>>>16&255,++U),N.writeUInt8(a.byteLength>>>8&255,++U),N.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(R.$Ib.concat([N,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),P=r.readUInt8(0),N=(P&128)>>>7,U=(P&64)>>>6,q=r.readUInt8(1),B=(q&128)>>>7,O=q&127;this.j.state=2,this.j.readLen=2+(B?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),P=r.readUInt8(1),N=(P&128)>>>7;let U=P&127,q=1;U===126?U=r.readUInt8(++q)*2**8+r.readUInt8(++q):U===127&&(U=r.readUInt8(++q)*0+r.readUInt8(++q)*0+r.readUInt8(++q)*0+r.readUInt8(++q)*0+r.readUInt8(++q)*2**24+r.readUInt8(++q)*2**16+r.readUInt8(++q)*2**8+r.readUInt8(++q));let B=0;N&&(B=r.readUInt8(++q)*2**24+r.readUInt8(++q)*2**16+r.readUInt8(++q)*2**8+r.readUInt8(++q)),this.j.state=3,this.j.readLen=U,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),n(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$bh=u;class v extends g.$kb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Ib.alloc(0)}constructor(a,r,P,N,U,q){super(),this.l=a,this.m=U,this.n=q,this.a=this.B(new k.$5c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$5c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new k.$5c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,r?(this.b=this.B(new f(this.l,N,P,{windowBits:15})),this.f=this.B(new E(this.l,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const r=await this.s(this.f,a);this.n(r,!0)}else this.n(a,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(a,r){return new Promise((P,N)=>{a.write(r),a.flush(U=>P(U))})}acceptFrame(a,r,P){this.h.push({data:a,isCompressed:r,isLastFrameOfMessage:P}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const r=await this.w(this.b,a.data,a.isLastFrameOfMessage);this.m.fire(r)}else this.m.fire(a.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(a,r,P){return new Promise((N,U)=>{a.write(r),P&&a.write(R.$Ib.fromByteArray([0,0,255,255])),a.flush(q=>N(q))})}}class f extends g.$kb{get recordedInflateBytes(){return this.j?R.$Ib.concat(this.f):R.$Ib.alloc(0)}constructor(a,r,P,N){super(),this.h=a,this.j=r,this.a=this.B(new k.$5c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,F.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(R.$Ib.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=R.$Ib.concat(this.g);this.g.length=0,a(r)})}}class E extends g.$kb{constructor(a,r){super(),this.g=a,this.a=this.B(new k.$5c),this.onError=this.a.event,this.f=[],this.b=(0,F.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$Ib.wrap(P))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=R.$Ib.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),a(r)})}}function n(y,a){if(a===0)return;const r=y.byteLength>>>2;for(let O=0;O<r;O++){const K=y.readUInt32BE(O*4);y.writeUInt32BE(K^a,O*4)}const P=r*4,N=y.byteLength-P,U=a>>>24&255,q=a>>>16&255,B=a>>>8&255;N>=1&&y.writeUInt8(y.readUInt8(P)^U,P),N>=2&&y.writeUInt8(y.readUInt8(P+1)^q,P+1),N>=3&&y.writeUInt8(y.readUInt8(P+2)^B,P+2)}e.$ch=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const y=(0,w.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const a=process.platform!=="darwin"&&e.$ch?e.$ch:(0,h.tmpdir)(),r=(0,L.$$b)(a,`vscode-ipc-${y}.sock`);return d(r),r}e.$dh=s;function t(y,a,r){const P=(0,b.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${r}-${a}-sock`;const N=r.substr(0,4),U=a.substr(0,6),q=P.substr(0,8);let B;return process.platform!=="darwin"&&e.$ch&&!process.env.VSCODE_PORTABLE?B=(0,L.$$b)(e.$ch,`vscode-${q}-${N}-${U}.sock`):B=(0,L.$$b)(y,`${N}-${U}.sock`),d(B),B}e.$eh=t;function d(y){const a=o[I.$o];typeof a=="number"&&y.length>=a&&console.warn(`WARNING: IPC handle "${y}" is longer than ${a} chars, try a shorter --user-data-dir`)}class $ extends D.$2g{static b(a){const r=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(r,P=>({protocol:new C.$9g(new p(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(a){super($.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$fh=$;function l(y){return new Promise((a,r)=>{const P=(0,A.createServer)();P.on("error",r),P.listen(y,()=>{P.removeListener("error",r),a(new $(P))})})}e.$gh=l;function S(y,a){return new Promise((r,P)=>{const N=(0,A.createConnection)(y,()=>{N.removeListener("error",P),r(C.$0g.fromSocket(new p(N,`ipc-client${a}`),a))});N.once("error",P)})}e.$hh=S}),define(De[341],Ce([1,0,150,101,49,37,2,18,50]),function(re,e,b,A,h,F,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=void 0;class g{constructor(w,D,C){this.b=w,this.c=D,this.f=C,this.a=A.createServer((p,i)=>this.h(p,i)),this.g().catch(p=>(D.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,D){const C=(i,c)=>{D.writeHead(i,{"content-type":"application/json"}),D.end(JSON.stringify(c||null),u=>u&&this.c.error(u))},p=[];w.setEncoding("utf8"),w.on("data",i=>p.push(i)),w.on("end",async()=>{try{const i=JSON.parse(p.join(""));let c;switch(i.type){case"open":c=await this.i(i);break;case"openExternal":c=await this.j(i);break;case"status":c=await this.l(i);break;case"extensionManagement":c=await this.k(i);break;default:C(404,`Unknown message type: ${i.type}`);break}C(200,c)}catch(i){const c=i instanceof Error?i.message:JSON.stringify(i);C(500,c),this.c.error("Error while processing pipe request",i)}})}async i(w){const{fileURIs:D,folderURIs:C,forceNewWindow:p,diffMode:i,mergeMode:c,addMode:u,forceReuseWindow:v,gotoLineMode:f,waitMarkerFilePath:E,remoteAuthority:n}=w,o=[];if(Array.isArray(C))for(const $ of C)try{o.push({folderUri:R.URI.parse($)})}catch{}if(Array.isArray(D))for(const $ of D)try{(0,k.$Qh)($)?o.push({workspaceUri:R.URI.parse($)}):o.push({fileUri:R.URI.parse($)})}catch{}const s=E?R.URI.file(E):void 0,d={forceNewWindow:p,diffMode:i,mergeMode:c,addMode:u,gotoLineMode:f,forceReuseWindow:v,preferNewWindow:!v&&!s&&!u,waitMarkerFileURI:s,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",o,d)}async j(w){for(const D of w.uris){const C=R.URI.parse(D),p=C.scheme==="file"?C:D;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(w){const D=p=>p?.map(i=>/\.vsix$/i.test(i)?R.URI.parse(i):i),C={list:w.list,install:D(w.install),uninstall:D(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$CL=g;let L=e.$DL=class extends g{constructor(w,D){super(w,D,(0,b.$dh)())}};e.$DL=L=He([We(0,F.$xL),We(1,m.$Ni)],L)}),define(De[342],Ce([1,0,101,88,330,325,246,44,313,2,16,7,341,95,311,35,312]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;class c extends F.$1_b{k(){const f=this,E=globalThis._VSCODE_NODE_MODULES.module,n=E._load;E._load=function(d,$,l){return d=s(d),f.a.has(d)?f.a.get(d).load(d,g.URI.file((0,D.$Jp)($.filename)),S=>n.apply(this,[S,$,l])):n.apply(this,arguments)};const o=E._resolveLookupPaths;E._resolveLookupPaths=(t,d)=>o.call(this,s(t),d);const s=t=>{for(const d of f.b){const $=d(t);if($){t=$;break}}return t}}}class u extends m.$F$b{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async pb(){this.h.createInstance(C.$xac);const f=this.h.invokeFunction(h.$W_b);if(this.h.createInstance(k.$wac),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(w.$DL);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(i.$yac),await this.h.createInstance(c,f,{mine:this.F,all:this.G}).install(),A.mark("code/extHost/didInitAPI"),(async()=>{const o=process.env.VSCODE_IPC_HOOK_CLI,s=process.env.CODE_SERVER_SESSION_SOCKET;if(!o||!s)return;const d={workspace:this.h.invokeFunction(l=>l.get(p.$$0b).workspace),socketPath:o},$=JSON.stringify({entry:d});await new Promise((l,S)=>{const y={path:"/add-session",socketPath:s,method:"POST",headers:{"content-type":"application/json"}},a=b.request(y,r=>{r.on("error",S),r.on("end",()=>{try{r.statusCode===200?l():S(new Error("Unexpected status code: "+r.statusCode))}catch(P){S(P)}})});a.on("error",S),a.write($),a.end()})})().catch(o=>{this.l.error(o)});const n=await this.k.getConfigProvider();await(0,R.$vac)(this.j,n,this,this.l,this.u,this.f),A.mark("code/extHost/didInitProxyResolver")}qb(f){return f.main}async rb(f,E,n){if(E.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let o=null;n.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this.l.flush();const s=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{s&&A.mark(`code/extHost/willLoadExtensionCode/${s}`),o=re.__$__nodeRequire(E.fsPath)}finally{s&&A.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}return o}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const E in f){const n=f[E];n===null?delete process.env[E]:process.env[E]=n}}}e.$zac=u}),define(De[343],Ce([1,0,98,316,328,327,340,342,317,89,44,90,87,43,58,84,315,314,18,329,52,241,97]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u,v,f,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.$9q)(L.$G$b,m.$zac,0),(0,b.$9q)(u.$Oi,c.$Jac,1),(0,b.$9q)(u.$Ni,new n.$ih(E.$Z_b,[!1],!0)),(0,b.$9q)(p.$r$b,i.$Iac,0),(0,b.$9q)(g.$e_b,F.$aac,0),(0,b.$9q)(I.$o_b,R.$uac,0),(0,b.$9q)(w.$_$b,h.$5_b,0),(0,b.$9q)(D.$t$b,A.$4_b,0),(0,b.$9q)(C.$rob,k.$Hac,0),(0,b.$9q)(f.$c_b,v.$Kac,0)}),define(De[354],Ce([1,0,101,102,355,88,8,120,150,228,106,326,22,29,95,17,125,247,266,331,343]),function(re,e,b,A,h,F,R,m,k,g,L,I,w,D,C,p,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const v=h(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const $=globalThis._VSCODE_NODE_MODULES.module,l=$._load;$._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const f=process.exit.bind(process);function E($){process.exit=function(l){if($)f(l);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let n=function($){f()};function o(){const $=(0,u.$am)(process.env);if($.type===3)return new Promise((l,S)=>{const y=a=>{const r=a[0],P=new m.$$g;r.on("message",N=>P.fire(w.$Ib.wrap(N.data))),r.on("close",()=>{n("renderer closed the MessagePort")}),r.start(),l({onMessage:P.event,send:N=>r.postMessage(N.buffer)})};process.parentPort.on("message",a=>y(a.ports))});if($.type===2)return new Promise((l,S)=>{let y=null;const a=setTimeout(()=>{n("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),r=108e5,P=3e5,N=new p.$Dg(()=>n("renderer disconnected for too long (1)"),r),U=new p.$Dg(()=>n("renderer disconnected for too long (2)"),P);process.on("message",(B,O)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const K=w.$Ib.wrap(Buffer.from(B.initialDataChunk,"base64"));let z;if(B.skipWebSocketFrames)z=new k.$ah(O,"extHost-socket");else{const j=w.$Ib.wrap(Buffer.from(B.inflateBytes,"base64"));z=new k.$bh(new k.$ah(O,"extHost-socket"),B.permessageDeflate,j,!1)}y?(N.cancel(),U.cancel(),y.beginAcceptReconnection(z,K),y.endAcceptReconnection(),y.sendResume()):(clearTimeout(a),y=new m.$_g({socket:z,initialChunk:K}),y.sendResume(),y.onDidDispose(()=>n("renderer disconnected")),l(y),y.onSocketClose(()=>{N.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;N.isScheduled()&&U.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const l=$.pipeName;return new Promise((S,y)=>{const a=A.createConnection(l,()=>{a.removeListener("error",y);const r=new m.$_g({socket:new k.$ah(a,"extHost-renderer")});r.sendResume(),S(r)});a.once("error",y),a.on("close",()=>{n("renderer closed the socket")})})}}async function s(){const $=await o();return new class{constructor(){this.a=new m.$$g,this.onMessage=this.a.event,this.b=!1,$.onMessage(l=>{(0,L.$Nl)(l,2)?(this.b=!0,n("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||$.send(l)}async drain(){if($.drain)return $.drain()}}}function t($){return new Promise(l=>{const S=$.onMessage(y=>{S.dispose();const a=JSON.parse(y.toString()),r=a.commit,P=g.default.commit;if(r&&P&&r!==P&&f(55),a.parentPid){let N=0;setInterval(function(){try{process.kill(a.parentPid,0),N=0}catch(q){q&&q.code==="EPERM"?(N++,N>=3&&n(`parent process ${a.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):n(`parent process ${a.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(a.parentPid)}catch(q){(0,R.$X)(q)}}$.send((0,L.$Ml)(0)),l({protocol:$,initData:a})});$.send((0,L.$Ml)(1))})}async function d(){const $=[];process.on("unhandledRejection",(N,U)=>{$.push(U),setTimeout(()=>{const q=$.indexOf(U);q>=0&&U.catch(B=>{$.splice(q,1),(0,R.$1)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),N&&(0,R.$X)(N))})},1e3)}),process.on("rejectionHandled",N=>{const U=$.indexOf(N);U>=0&&$.splice(U,1)}),process.on("uncaughtException",function(N){(0,R.$W)(N)||(0,R.$X)(N)}),F.mark("code/extHost/willConnectToRenderer");const l=await s();F.mark("code/extHost/didConnectToRenderer");const S=await t(l);F.mark("code/extHost/didWaitForInitData");const{initData:y}=S;E(!!y.environment.extensionTestsLocationURI),y.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,y.environment.skipWorkspaceStorageLock=(0,i.boolean)(v.skipWorkspaceStorageLock,!1);const a=new class{constructor(){this.pid=process.pid}exit(U){f(U)}exists(U){return D.Promises.exists(U)}realpath(U){return(0,C.$Ip)(U)}};let r=null;y.remote.authority&&v.transformURIs&&(r=(0,c.$ar)(y.remote.authority));const P=new I.$3_b(S.protocol,y,a,r);n=N=>{P.terminate(N);const U=process.env.VSCODE_IPC_HOOK_CLI,q=process.env.CODE_SERVER_SESSION_SOCKET;if(!U||!q)return;const B=JSON.stringify({socketPath:U}),O={path:"/delete-session",socketPath:q,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},K=b.request(O);K.write(B),K.end()}}d().catch($=>console.log($))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
