"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/nullTokenize","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/languages","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/base/common/assert","vs/base/common/lazy","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],W=function(D){for(var e=[],T=0,k=D.length;T<k;T++)e[T]=V[D[T]];return e};define(V[3],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=void 0;let T;function k(r){T=r}e.$Ic=k;function v(){return T}e.$Jc=v;class I{constructor(){this.a=0,this.d=new WeakMap}b(a){return n([u(g("|  ",this.a)),a])}c(a){return a.didChange?[u(" "),s(c(a.oldValue,70),{color:"red",strikeThrough:!0}),u(" "),s(c(a.newValue,60),{color:"green"})]:[u(" (unchanged)")]}handleObservableChanged(a,m){console.log(...this.b([t("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.c(m)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(m=>m.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const m=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,U)=>(this.d.get(a).add(C),m.apply(a,[C,U]))}handleDerivedRecomputed(a,m){const C=this.d.get(a);console.log(...this.b([t("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.c(m),this.formatChanges(C)])),C.clear()}handleFromEventObservableTriggered(a,m){console.log(...this.b([t("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.c(m)]))}handleAutorunCreated(a){const m=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,U)=>(this.d.get(a).add(C),m.apply(a,[C,U]))}handleAutorunTriggered(a){const m=this.d.get(a);console.log(...this.b([t("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(m)])),m.clear()}handleBeginTransaction(a){let m=a.getDebugName();m===void 0&&(m=""),console.log(...this.b([t("transaction"),s(m,{color:"BlueViolet"})])),this.a++}handleEndTransaction(){this.a--}}e.$Kc=I;function n(r){const a=new Array,C={};let U="";function M(d){if("length"in d)for(const b of d)b&&M(b);else"text"in d?(U+=`%c${d.text}`,a.push(d.style),d.data&&Object.assign(C,d.data)):"data"in d&&Object.assign(C,d.data)}M(r);const S=[U,...a];return Object.keys(C).length>0&&S.push(C),S}function u(r){return s(r,{color:"black"})}function t(r){return s(i(`${r}: `,10),{color:"black",bold:!0})}function s(r,a={color:"black"}){function m(U){return Object.entries(U).reduce((M,[S,d])=>`${M}${S}:${d};`,"")}const C={color:a.color};return a.strikeThrough&&(C["text-decoration"]="line-through"),a.bold&&(C["font-weight"]="bold"),{text:r,style:m(C)}}function c(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?h(r,a):f(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function h(r,a){let m="[ ",C=!0;for(const U of r){if(C||(m+=", "),m.length-5>a){m+="...";break}C=!1,m+=`${c(U,a-m.length)}`}return m+=" ]",m}function f(r,a){let m="{ ",C=!0;for(const[U,M]of Object.entries(r)){if(C||(m+=", "),m.length-5>a){m+="...";break}C=!1,m+=`${U}: ${c(M,a-m.length)}`}return m+=" }",m}function g(r,a){let m="";for(let C=1;C<=a;C++)m+=r;return m}function i(r,a){for(;r.length<a;)r+=" ";return r}}),define(V[8],W([0,1,40,2,3]),function(D,e,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function I(g,i){return new h(g,i,void 0,void 0)}e.$pc=I;function n(g,i,r){return new h(g,r,i.createEmptyChangeSummary,i.handleChange)}e.$qc=n;function u(g,i){return s(i,g)}e.$rc=u;function t(g,i,r){const a=new k.$jb,m=n(g,{createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(C,U)=>{a.clear(),r(C,U,a)});return(0,k.$ib)(()=>{m.dispose(),a.dispose()})}e.$sc=t;function s(g,i){const r=new k.$jb,a=I(i,m=>{r.clear(),g(m,r)});return(0,k.$ib)(()=>{a.dispose(),r.dispose()})}e.$tc=s;var c;(function(g){g[g.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",g[g.stale=2]="stale",g[g.upToDate=3]="upToDate"})(c||(c={}));class h{constructor(i,r,a,m){this.debugName=i,this.h=r,this.i=a,this.j=m,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,v.$Jc)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3,(0,v.$Jc)()?.handleAutorunTriggered(this);try{const r=this.g;this.g=this.i?.(),this.h(this,r)}finally{for(const r of this.f)r.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,T.$nc)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,r){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:r,didChange:m=>m===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const r=i.get();return this.e.add(i),this.f.delete(i),r}}e.$uc=h,function(g){g.Observer=h}(I||(e.$pc=I={}));function f(g,i,r){let a;return I(g,m=>{const C=i.read(m),U=a;a=C,r({lastValue:U,newValue:C})})}e.$vc=f}),define(V[6],W([0,1,3]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=void 0;let k;function v(r){k=r}e.$Pc=v;class I{get TChange(){return null}reportChanges(){this.get()}read(a){return a?a.readObservable(this):this.get()}map(a){return k(()=>{const m=c(a);return m!==void 0?m:`${this.debugName} (mapped)`},m=>a(this.read(m),m))}}e.$Qc=I;class n extends I{constructor(){super(...arguments),this.a=new Set}addObserver(a){const m=this.a.size;this.a.add(a),m===0&&this.b()}removeObserver(a){this.a.delete(a)&&this.a.size===0&&this.c()}b(){}c(){}}e.$Rc=n;function u(r,a){const m=new s(r,a);try{(0,T.$Jc)()?.handleBeginTransaction(m),r(m)}finally{m.finish(),(0,T.$Jc)()?.handleEndTransaction()}}e.$Sc=u;function t(r,a,m){r?a(r):u(a,m)}e.$Tc=t;class s{constructor(a,m){this.b=a,this.c=m,this.a=[]}getDebugName(){return this.c?this.c():c(this.b)}updateObserver(a,m){this.a.push({observer:a,observable:m}),a.beginUpdate(m)}finish(){const a=this.a;this.a=null;for(const{observer:m,observable:C}of a)m.endUpdate(C)}}e.$Uc=s;function c(r){const a=r.toString(),C=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(C?C[1]:void 0)?.trim()}e.$Vc=c;function h(r,a){return new f(r,a)}e.$Wc=h;class f extends n{constructor(a,m){super(),this.debugName=a,this.d=m}get(){return this.d}set(a,m,C){if(this.d===a)return;let U;m||(m=U=new s(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.d;this.e(a),(0,T.$Jc)()?.handleObservableChanged(this,{oldValue:M,newValue:a,change:C,didChange:!0});for(const S of this.a)m.updateObserver(S,this),S.handleChange(this,C)}finally{U&&U.finish()}}toString(){return`${this.debugName}: ${this.d}`}e(a){this.d=a}}e.$Xc=f;function g(r,a){return new i(r,a)}e.$Yc=g;class i extends f{e(a){this.d!==a&&(this.d&&this.d.dispose(),this.d=a)}dispose(){this.d?.dispose()}}e.$Zc=i}),define(V[9],W([0,1,4,2,6,3]),function(D,e,T,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oc=e.$Nc=e.$Mc=e.$Lc=void 0;function n(h,f){return new c(h,f,void 0,void 0,void 0)}e.$Lc=n;function u(h,f,g){return new c(h,g,f.createEmptyChangeSummary,f.handleChange,void 0)}e.$Mc=u;function t(h,f){const g=new k.$jb;return new c(h,i=>(g.clear(),f(i,g)),void 0,void 0,()=>g.dispose())}e.$Nc=t,(0,v.$Pc)(n);var s;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(s||(s={}));class c extends v.$Rc{get debugName(){return typeof this.k=="function"?this.k():this.k}constructor(f,g,i,r,a=void 0){super(),this.k=f,this.l=g,this.m=i,this.n=r,this.p=a,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.i=new Set,this.j=void 0,this.j=this.m?.(),(0,I.$Jc)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const f of this.h)f.removeObserver(this);this.h.clear(),this.p?.()}get(){if(this.a.size===0){const f=this.l(this,this.m?.());return this.c(),f}else{do{if(this.e===1){this.e=3;for(const f of this.h)if(f.reportChanges(),this.e===2)break}this.s()}while(this.e!==3);return this.f}}s(){if(this.e===3)return;const f=this.i;this.i=this.h,this.h=f;const g=this.e!==0,i=this.f;this.e=3;const r=this.j;this.j=this.m?.();try{this.f=this.l(this,r)}finally{for(const m of this.i)m.removeObserver(this);this.i.clear()}const a=g&&i!==this.f;if((0,I.$Jc)()?.handleDerivedRecomputed(this,{oldValue:i,newValue:this.f,change:void 0,didChange:a}),a)for(const m of this.a)m.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(f){this.g++;const g=this.g===1;if(this.e===3&&(this.e=1,!g))for(const i of this.a)i.handlePossibleChange(this);if(g)for(const i of this.a)i.beginUpdate(this)}endUpdate(f){if(this.g--,this.g===0){const g=[...this.a];for(const i of g)i.endUpdate(this)}if(this.g<0)throw new T.$ab}handlePossibleChange(f){if(this.e===3&&this.h.has(f)&&!this.i.has(f)){this.e=1;for(const g of this.a)g.handlePossibleChange(this)}}handleChange(f,g){if(this.h.has(f)&&!this.i.has(f)){const i=this.n?this.n({changedObservable:f,change:g,didChange:a=>a===f},this.j):!0,r=this.e===3;if(i&&(this.e===1||r)&&(this.e=2,r))for(const a of this.a)a.handlePossibleChange(this)}}readObservable(f){f.addObserver(this);const g=f.get();return this.h.add(f),this.i.delete(f),g}addObserver(f){const g=!this.a.has(f)&&this.g>0;super.addObserver(f),g&&f.beginUpdate(this)}removeObserver(f){const g=this.a.has(f)&&this.g>0;super.removeObserver(f),g&&f.endUpdate(this)}}e.$Oc=c}),define(V[20],W([0,1,2,8,6,9,3]),function(D,e,T,k,v,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function u(b){return new t(b)}e.$wc=u;class t extends v.$Qc{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function s(b){const w=(0,v.$Wc)("promiseValue",{});return b.then(L=>{w.set({value:L},void 0)}),w}e.$xc=s;function c(b,w){return new Promise(L=>{let j=!1,l=!1;const O=(0,k.$pc)("waitForState",R=>{const E=b.read(R);w(E)&&(j?O.dispose():l=!0,L(E))});j=!0,l&&O.dispose()})}e.$yc=c;function h(b,w){return new f(b,w)}e.$zc=h;class f extends v.$Rc{constructor(w,L){super(),this.h=w,this.i=L,this.f=!1,this.l=j=>{const l=this.i(j),O=!this.f||this.e!==l;(0,n.$Jc)()?.handleFromEventObservableTriggered(this,{oldValue:this.e,newValue:l,change:void 0,didChange:O}),O&&(this.e=l,this.f&&(0,v.$Sc)(R=>{for(const E of this.a)R.updateObserver(E,this),E.handleChange(this,void 0)},()=>{const R=this.j();return"Event fired"+(R?`: ${R}`:"")}),this.f=!0)}}j(){return(0,v.$Vc)(this.i)}get debugName(){const w=this.j();return"From Event"+(w?`: ${w}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this.i(void 0)}}e.$Ac=f,function(b){b.Observer=f}(h||(e.$zc=h={}));function g(b,w){return new i(b,w)}e.$Bc=g;class i extends v.$Rc{constructor(w,L){super(),this.debugName=w,this.f=L,this.h=()=>{(0,v.$Sc)(j=>{for(const l of this.a)j.updateObserver(l,this),l.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function r(b){return new a(b)}e.$Cc=r;class a extends v.$Rc{constructor(w){super(),this.debugName=w}trigger(w,L){if(!w){(0,v.$Sc)(j=>{this.trigger(j,L)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.a)w.updateObserver(j,this),j.handleChange(this,L)}get(){}}function m(b,w,L){const j=(0,v.$Wc)("debounced",void 0);let l;return L.add((0,k.$pc)("debounce",O=>{const R=b.read(O);l&&clearTimeout(l),l=setTimeout(()=>{(0,v.$Sc)(E=>{j.set(R,E)})},w)})),j}e.$Dc=m;function C(b,w,L){const j=(0,v.$Wc)("triggeredRecently",!1);let l;return L.add(b(()=>{j.set(!0,void 0),l&&clearTimeout(l),l=setTimeout(()=>{j.set(!1,void 0)},w)})),j}e.$Ec=C;function U(b,w){const L=new M(w??!1);return b.addObserver(L),w&&b.reportChanges(),(0,T.$ib)(()=>{b.removeObserver(L)})}e.$Fc=U;class M{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,L){}}function S(b,w){let L;return(0,I.$Lc)(b,l=>(L=w(l,L),L))}e.$Gc=S;function d(b,w){let L;const j=(0,v.$Wc)("derivedObservableWithWritableCache.counter",0),l=(0,I.$Lc)(b,O=>(j.read(O),L=w(O,L),L));return Object.assign(l,{clearCache:O=>{L=void 0,j.set(j.get()+1,O)}})}e.$Hc=d});var se=this&&this.__createBinding||(Object.create?function(D,e,T,k){k===void 0&&(k=T);var v=Object.getOwnPropertyDescriptor(e,T);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[T]}}),Object.defineProperty(D,k,v)}:function(D,e,T,k){k===void 0&&(k=T),D[k]=e[T]}),re=this&&this.__exportStar||function(D,e){for(var T in D)T!=="default"&&!Object.prototype.hasOwnProperty.call(e,T)&&se(e,D,T)};define(V[10],W([0,1,6,9,8,20,3]),function(D,e,T,k,v,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return T.$Wc}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return T.$Sc}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$Lc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$pc}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$vc}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$qc}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$tc}}),re(I,e),!1&&(0,n.$Ic)(new n.$Kc)}),define(V[21],W([0,1,4,2]),function(D,e,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function v(M){const S=M;return S?typeof S.read=="function":!1}e.$tb=v;function I(M){const S=M;return S?[S.on,S.pause,S.resume,S.destroy].every(d=>typeof d=="function"):!1}e.$ub=I;function n(M){const S=M;return S?I(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$vb=n;function u(M,S){return new t(M,S)}e.$wb=u;class t{constructor(S,d){this.e=S,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(d=>d(S))}h(S){this.c.error.length===0?(0,T.$X)(S):this.c.error.slice(0).forEach(d=>d(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,d){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(S,d){if(this.a.destroyed)return;let b;switch(S){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const w=b.indexOf(d);w>=0&&b.splice(w,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(M,S){const d=[];let b;for(;(b=M.read())!==null;)d.push(b);return S(d)}e.$xb=s;function c(M,S,d){const b=[];let w;for(;(w=M.read())!==null&&b.length<d;)b.push(w);return w===null&&b.length>0?S(b):{read:()=>{if(b.length>0)return b.shift();if(typeof w<"u"){const L=w;return w=void 0,L}return M.read()}}}e.$yb=c;function h(M,S){return new Promise((d,b)=>{const w=[];f(M,{onData:L=>{S&&w.push(L)},onError:L=>{S?b(L):d(void 0)},onEnd:()=>{d(S?S(w):void 0)}})})}e.$zb=h;function f(M,S){let d=!1;return M.on("error",b=>{d||S.onError(b)}),M.on("end",()=>{d||S.onEnd()}),M.on("data",b=>{d||S.onData(b)}),(0,k.$ib)(()=>d=!0)}e.$Ab=f;function g(M,S){return new Promise((d,b)=>{const w=new k.$jb,L=[],j=R=>{if(L.push(R),L.length>S)return w.dispose(),M.pause(),d({stream:M,buffer:L,ended:!1})},l=R=>b(R),O=()=>d({stream:M,buffer:L,ended:!0});w.add((0,k.$ib)(()=>M.removeListener("error",l))),M.on("error",l),w.add((0,k.$ib)(()=>M.removeListener("end",O))),M.on("end",O),w.add((0,k.$ib)(()=>M.removeListener("data",j))),M.on("data",j)})}e.$Bb=g;function i(M,S){const d=u(S);return d.end(M),d}e.$Cb=i;function r(){const M=u(()=>{throw new Error("not supported")});return M.end(),M}e.$Db=r;function a(M){let S=!1;return{read:()=>S?null:(S=!0,M)}}e.$Eb=a;function m(M,S,d){const b=u(d);return f(M,{onData:w=>b.write(S.data(w)),onError:w=>b.error(S.error?S.error(w):w),onEnd:()=>b.end()}),b}e.$Fb=m;function C(M,S,d){let b=!1;return{read:()=>{const w=S.read();return b?w:(b=!0,w!==null?d([M,w]):M)}}}e.$Gb=C;function U(M,S,d){let b=!1;const w=u(d);return f(S,{onData:L=>b?w.write(L):(b=!0,w.write(d([M,L]))),onError:L=>w.error(L),onEnd:()=>{b||(b=!0,w.write(M)),w.end()}}),w}e.$Hb=U}),define(V[11],W([0,1,41,21]),function(D,e,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const v=typeof Buffer<"u",I=new T.$S(()=>new Uint8Array(256));let n,u;class t{static alloc($){return v?new t(Buffer.allocUnsafe($)):new t(new Uint8Array($))}static wrap($){return v&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new t($)}static fromString($,N){return!(N?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from($)):(n||(n=new TextEncoder),new t(n.encode($)))}static fromByteArray($){const N=t.alloc($.length);for(let z=0,K=$.length;z<K;z++)N.buffer[z]=$[z];return N}static concat($,N){if(typeof N>"u"){N=0;for(let _=0,H=$.length;_<H;_++)N+=$[_].byteLength}const z=t.alloc(N);let K=0;for(let _=0,H=$.length;_<H;_++){const q=$[_];z.set(q,K),K+=q.byteLength}return z}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=t.alloc(this.byteLength);return $.set(this),$}toString(){return v?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice($,N){return new t(this.buffer.subarray($,N))}set($,N){if($ instanceof t)this.buffer.set($.buffer,N);else if($ instanceof Uint8Array)this.buffer.set($,N);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),N);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return h(this.buffer,$)}writeUInt32BE($,N){f(this.buffer,$,N)}readUInt32LE($){return g(this.buffer,$)}writeUInt32LE($,N){i(this.buffer,$,N)}readUInt8($){return r(this.buffer,$)}writeUInt8($,N){a(this.buffer,$,N)}indexOf($){const N=$ instanceof t?$.buffer:$,z=N.byteLength,K=this.buffer,_=K.byteLength;if(z===0)return 0;if(z===1)return K.indexOf(N[0]);if(z>_)return-1;const H=I.value;H.fill(N.length);for(let p=0;p<N.length;p++)H[N[p]]=N.length-p-1;let q=N.length-1,G=q,Z=-1;for(;q<_;)if(K[q]===N[G]){if(G===0){Z=q;break}q--,G--}else q+=Math.max(N.length-G,H[K[q]]),G=N.length-1;return Z}}e.$Ib=t;function s(E,$){return E[$+0]<<0>>>0|E[$+1]<<8>>>0}e.$Jb=s;function c(E,$,N){E[N+0]=$&255,$=$>>>8,E[N+1]=$&255}e.$Kb=c;function h(E,$){return E[$]*2**24+E[$+1]*2**16+E[$+2]*2**8+E[$+3]}e.$Lb=h;function f(E,$,N){E[N+3]=$,$=$>>>8,E[N+2]=$,$=$>>>8,E[N+1]=$,$=$>>>8,E[N]=$}e.$Mb=f;function g(E,$){return E[$+0]<<0>>>0|E[$+1]<<8>>>0|E[$+2]<<16>>>0|E[$+3]<<24>>>0}e.$Nb=g;function i(E,$,N){E[N+0]=$&255,$=$>>>8,E[N+1]=$&255,$=$>>>8,E[N+2]=$&255,$=$>>>8,E[N+3]=$&255}e.$Ob=i;function r(E,$){return E[$]}e.$Pb=r;function a(E,$,N){E[N]=$}e.$Qb=a;function m(E){return k.$xb(E,$=>t.concat($))}e.$Rb=m;function C(E){return k.$Eb(E)}e.$Sb=C;function U(E){return k.$zb(E,$=>t.concat($))}e.$Tb=U;async function M(E){return E.ended?t.concat(E.buffer):t.concat([...E.buffer,await U(E.stream)])}e.$Ub=M;function S(E){return k.$Cb(E,$=>t.concat($))}e.$Vb=S;function d(E){return k.$Fb(E,{data:$=>typeof $=="string"?t.fromString($):t.wrap($)},$=>t.concat($))}e.$Wb=d;function b(E){return k.$wb($=>t.concat($),E)}e.$Xb=b;function w(E,$){return k.$Gb(E,$,N=>t.concat(N))}e.$Yb=w;function L(E,$){return k.$Hb(E,$,N=>t.concat(N))}e.$Zb=L;function j(E){let $=0,N=0,z=0;const K=new Uint8Array(Math.floor(E.length/4*3)),_=q=>{switch(N){case 3:K[z++]=$|q,N=0;break;case 2:K[z++]=$|q>>>2,$=q<<6,N=3;break;case 1:K[z++]=$|q>>>4,$=q<<4,N=2;break;default:$=q<<2,N=1}};for(let q=0;q<E.length;q++){const G=E.charCodeAt(q);if(G>=65&&G<=90)_(G-65);else if(G>=97&&G<=122)_(G-97+26);else if(G>=48&&G<=57)_(G-48+52);else if(G===43||G===45)_(62);else if(G===47||G===95)_(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${E[q]}`)}}const H=z;for(;N>0;)_(0);return t.wrap(K).slice(0,H)}e.$1b=j;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:E},$=!0,N=!1){const z=N?O:l;let K="";const _=E.byteLength%3;let H=0;for(;H<E.byteLength-_;H+=3){const q=E[H+0],G=E[H+1],Z=E[H+2];K+=z[q>>>2],K+=z[(q<<4|G>>>4)&63],K+=z[(G<<2|Z>>>6)&63],K+=z[Z&63]}if(_===1){const q=E[H+0];K+=z[q>>>2],K+=z[q<<4&63],$&&(K+="==")}else if(_===2){const q=E[H+0],G=E[H+1];K+=z[q>>>2],K+=z[(q<<4|G>>>4)&63],K+=z[G<<2&63],$&&(K+="=")}return K}e.$2b=R}),define(V[22],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(V[23],W([0,1,24,5,25,42]),function(D,e,T,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function n(l){return l===47||l===92}e.$Ae=n;function u(l){return l.replace(/[\\/]/g,T.$8b.sep)}e.$Be=u;function t(l){return l.indexOf("/")===-1&&(l=u(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Ce=t;function s(l,O=T.$8b.sep){if(!l)return"";const R=l.length,E=l.charCodeAt(0);if(n(E)){if(n(l.charCodeAt(1))&&!n(l.charCodeAt(2))){let N=3;const z=N;for(;N<R&&!n(l.charCodeAt(N));N++);if(z!==N&&!n(l.charCodeAt(N+1))){for(N+=1;N<R;N++)if(n(l.charCodeAt(N)))return l.slice(0,N+1).replace(/[\\/]/g,O)}}return O}else if(m(E)&&l.charCodeAt(1)===58)return n(l.charCodeAt(2))?l.slice(0,2)+O:l.slice(0,2);let $=l.indexOf("://");if($!==-1){for($+=3;$<R;$++)if(n(l.charCodeAt($)))return l.slice(0,$+1)}return""}e.$De=s;function c(l){if(!k.$d||!l||l.length<5)return!1;let O=l.charCodeAt(0);if(O!==92||(O=l.charCodeAt(1),O!==92))return!1;let R=2;const E=R;for(;R<l.length&&(O=l.charCodeAt(R),O!==92);R++);return!(E===R||(O=l.charCodeAt(R+1),isNaN(O)||O===92))}e.$Ee=c;const h=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(l,O=k.$d){const R=O?h:f;return!(!l||l.length===0||/^\s+$/.test(l)||(R.lastIndex=0,R.test(l))||O&&g.test(l)||l==="."||l===".."||O&&l[l.length-1]==="."||O&&l.length!==l.trim().length||l.length>255)}e.$Fe=i;function r(l,O,R){const E=l===O;return!R||E?E:!l||!O?!1:(0,v.$Jd)(l,O)}e.$Ge=r;function a(l,O,R,E=T.sep){if(l===O)return!0;if(!l||!O||O.length>l.length)return!1;if(R){if(!(0,v.$Kd)(l,O))return!1;if(O.length===l.length)return!0;let N=O.length;return O.charAt(O.length-1)===E&&N--,l.charAt(N)===E}return O.charAt(O.length-1)!==E&&(O+=E),l.indexOf(O)===0}e.$He=a;function m(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Ie=m;function C(l,O){return k.$d&&l.endsWith(":")&&(l+=T.sep),(0,T.$0b)(l)||(l=(0,T.$$b)(O,l)),l=(0,T.$9b)(l),k.$d?(l=(0,v.$qd)(l,T.sep),l.endsWith(":")&&(l+=T.sep)):(l=(0,v.$qd)(l,T.sep),l||(l=T.sep)),l}e.$Je=C;function U(l){const O=(0,T.$9b)(l);return k.$d?l.length>3?!1:M(O)&&(l.length===2||O.charCodeAt(2)===92):O===T.$8b.sep}e.$Ke=U;function M(l,O=k.$d){return O?m(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$Le=M;function S(l,O=k.$d){return M(l,O)?l[0]:void 0}e.$Me=S;function d(l,O,R){return O.length>l.length?-1:l===O?0:(R&&(l=l.toLowerCase(),O=O.toLowerCase()),l.indexOf(O))}e.$Ne=d;function b(l){const O=l.split(":");let R,E,$;for(const N of O){const z=Number(N);(0,I.$ke)(z)?E===void 0?E=z:$===void 0&&($=z):R=R?[R,N].join(":"):N}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:E!==void 0?E:void 0,column:$!==void 0?$:E!==void 0?1:void 0}}e.$Oe=b;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function j(l,O,R=8){let E="";for(let N=0;N<R;N++){let z;N===0&&k.$d&&!O&&(R===3||R===4)?z=L:z=w,E+=z.charAt(Math.floor(Math.random()*z.length))}let $;return O?$=`${O}-${E}`:$=E,l?(0,T.$$b)(l,$):$}e.$Pe=j}),define(V[26],W([0,1,4,5,12]),function(D,e,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var I;(function(s){s.inMemory="inmemory",s.vscode="vscode",s.internal="private",s.walkThrough="walkThrough",s.walkThroughSnippet="walkThroughSnippet",s.http="http",s.https="https",s.file="file",s.mailto="mailto",s.untitled="untitled",s.data="data",s.command="command",s.vscodeRemote="vscode-remote",s.vscodeRemoteResource="vscode-remote-resource",s.vscodeManagedRemoteResource="vscode-managed-remote-resource",s.vscodeUserData="vscode-userdata",s.vscodeCustomEditor="vscode-custom-editor",s.vscodeNotebookCell="vscode-notebook-cell",s.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",s.vscodeNotebookCellOutput="vscode-notebook-cell-output",s.vscodeInteractiveInput="vscode-interactive-input",s.vscodeSettings="vscode-settings",s.vscodeWorkspaceTrust="vscode-workspace-trust",s.vscodeTerminal="vscode-terminal",s.vscodeChatSesssion="vscode-chat-editor",s.webviewPanel="webview-panel",s.vscodeWebview="vscode-webview",s.extension="extension",s.vscodeFileResource="vscode-file",s.tmp="tmp",s.vsls="vsls",s.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={})),e.$Te="vscode-tkn",e.$Ue="tkn";class n{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${I.vscodeRemoteResource}`}set(c,h,f){this.a[c]=h,this.b[c]=f}setConnectionToken(c,h){this.c[c]=h}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(a){return T.$X(a),c}const h=c.authority;let f=this.a[h];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const g=this.b[h],i=this.c[h];let r=`path=${encodeURIComponent(c.path)}`;return typeof i=="string"&&(r+=`&${e.$Ue}=${encodeURIComponent(i)}`),v.URI.from({scheme:k.$j?this.d:I.vscodeRemoteResource,authority:`${f}:${g}`,path:k.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:r})}}e.$Ve=new n,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class u{asBrowserUri(c){const h=this.b(c,D);return this.uriToBrowserUri(h)}uriToBrowserUri(c){return c.scheme===I.vscodeRemote?e.$Ve.rewrite(c):c.scheme===I.file&&(k.$h||k.$k&&k.$b.origin===`${I.vscodeFileResource}://${u.a}`)?c.with({scheme:I.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const h=this.b(c,D);return this.uriToFileUri(h)}uriToFileUri(c){return c.scheme===I.vscodeFileResource?c.with({scheme:I.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,h){return v.URI.isUri(c)?c:v.URI.parse(h.toUrl(c))}}u.a="vscode-app",e.$1e=new u;var t;(function(s){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);s.CoopAndCoep=Object.freeze(c.get("3"));const h="vscode-coi";function f(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:v.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const a=r?.get(h);if(a)return c.get(a)}s.getHeadersFromQuery=f;function g(i,r,a){if(!globalThis.crossOriginIsolated)return;const m=r&&a?"3":a?"2":"1";i instanceof URLSearchParams?i.set(h,m):i[h]=m}s.addSearchParam=g})(t||(e.COI=t={}))}),define(V[13],W([0,1,23,26,24,5,25,12]),function(D,e,T,k,v,I,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function t(g){return(0,u.$Se)(g,!0)}e.$Tf=t;class s{constructor(i){this.a=i}compare(i,r,a=!1){return i===r?0:(0,n.$Cd)(this.getComparisonKey(i,a),this.getComparisonKey(r,a))}isEqual(i,r,a=!1){return i===r?!0:!i||!r?!1:this.getComparisonKey(i,a)===this.getComparisonKey(r,a)}getComparisonKey(i,r=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,r,a=!1){if(i.scheme===r.scheme){if(i.scheme===k.Schemas.file)return T.$He(t(i),t(r),this.a(i))&&i.query===r.query&&(a||i.fragment===r.fragment);if((0,e.$$f)(i.authority,r.authority))return T.$He(i.path,r.path,this.a(i),"/")&&i.query===r.query&&(a||i.fragment===r.fragment)}return!1}joinPath(i,...r){return u.URI.joinPath(i,...r)}basenameOrAuthority(i){return(0,e.$3f)(i)||i.authority}basename(i){return v.$8b.basename(i.path)}extname(i){return v.$8b.extname(i.path)}dirname(i){if(i.path.length===0)return i;let r;return i.scheme===k.Schemas.file?r=u.URI.file(v.$bc(t(i))).path:(r=v.$8b.dirname(i.path),i.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),r="/")),i.with({path:r})}normalizePath(i){if(!i.path.length)return i;let r;return i.scheme===k.Schemas.file?r=u.URI.file(v.$9b(t(i))).path:r=v.$8b.normalize(i.path),i.with({path:r})}relativePath(i,r){if(i.scheme!==r.scheme||!(0,e.$$f)(i.authority,r.authority))return;if(i.scheme===k.Schemas.file){const C=v.$ac(t(i),t(r));return I.$d?T.$Be(C):C}let a=i.path||"/";const m=r.path||"/";if(this.a(i)){let C=0;for(const U=Math.min(a.length,m.length);C<U&&!(a.charCodeAt(C)!==m.charCodeAt(C)&&a.charAt(C).toLowerCase()!==m.charAt(C).toLowerCase());C++);a=m.substr(0,C)+a.substr(C)}return v.$8b.relative(a,m)}resolvePath(i,r){if(i.scheme===k.Schemas.file){const a=u.URI.file(v.$_b(t(i),r));return i.with({authority:a.authority,path:a.path})}return r=T.$Ce(r),i.with({path:v.$8b.resolve(i.path,r)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,r){return i===r||i!==void 0&&r!==void 0&&(0,n.$Jd)(i,r)}hasTrailingPathSeparator(i,r=v.sep){if(i.scheme===k.Schemas.file){const a=t(i);return a.length>T.$De(a).length&&a[a.length-1]===r}else{const a=i.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,r=v.sep){return(0,e.$_f)(i,r)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,r=v.sep){let a=!1;if(i.scheme===k.Schemas.file){const m=t(i);a=m!==void 0&&m.length===T.$De(m).length&&m[m.length-1]===r}else{r="/";const m=i.path;a=m.length===1&&m.charCodeAt(m.length-1)===47}return!a&&!(0,e.$_f)(i,r)?i.with({path:i.path+"/"}):i}}e.$Uf=s,e.$Vf=new s(()=>!1),e.$Wf=new s(g=>g.scheme===k.Schemas.file?!I.$f:!0),e.$Xf=new s(g=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function c(g,i){const r=[];for(let a=0;a<g.length;a++){const m=i(g[a]);g.some((C,U)=>U===a?!1:(0,e.$Zf)(m,i(C)))||r.push(g[a])}return r}e.$cg=c;var h;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function i(r){const a=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(U=>{const[M,S]=U.split(":");M&&S&&a.set(M,S)});const C=r.path.substring(0,r.path.indexOf(";"));return C&&a.set(g.META_DATA_MIME,C),a}g.parseMetaData=i})(h||(e.DataUri=h={}));function f(g,i,r){if(i){let a=g.path;return a&&a[0]!==v.$8b.sep&&(a=v.$8b.sep+a),g.with({scheme:r,authority:i,path:a})}return g.with({scheme:r})}e.$dg=f}),define(V[14],W([0,1,43,4,27,2,13,5,22]),function(D,e,T,k,v,I,n,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function s(P){return!!P&&typeof P.then=="function"}e.$eg=s;function c(P){const o=new T.$bd,y=P(o.token),A=new Promise((B,F)=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),o.dispose(),F(new k.$2)});Promise.resolve(y).then(X=>{Y.dispose(),o.dispose(),B(X)},X=>{Y.dispose(),o.dispose(),F(X)})});return new class{cancel(){o.cancel()}then(B,F){return A.then(B,F)}catch(B){return this.then(void 0,B)}finally(B){return A.finally(B)}}}e.$fg=c;function h(P,o,y){return new Promise((A,B)=>{const F=o.onCancellationRequested(()=>{F.dispose(),A(y)});P.then(A,B).finally(()=>F.dispose())})}e.$gg=h;function f(P,o){return new Promise((y,A)=>{const B=o.onCancellationRequested(()=>{B.dispose(),A(new k.$2)});P.then(y,A).finally(()=>B.dispose())})}e.$hg=f;async function g(P){let o=-1;const y=P.map((A,B)=>A.then(F=>(o=B,F)));try{return await Promise.race(y)}finally{P.forEach((A,B)=>{B!==o&&A.cancel()})}}e.$ig=g;function i(P,o,y){let A;const B=setTimeout(()=>{A?.(void 0),y?.()},o);return Promise.race([P.finally(()=>clearTimeout(B)),new Promise(F=>A=F)])}e.$jg=i;function r(P){return new Promise((o,y)=>{const A=P();s(A)?A.then(o,y):o(A)})}e.$kg=r;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=o,!this.b){const y=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(y,y).then(A)})}return new Promise((y,A)=>{this.b.then(y,A)})}return this.a=o(),new Promise((y,A)=>{this.a.then(B=>{this.a=null,y(B)},B=>{this.a=null,A(B)})})}dispose(){this.f=!0}}e.$lg=a;class m{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$mg=m;class C{constructor(){this.a=new Map}queue(o,y){const B=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(o)===B&&this.a.delete(o)});return this.a.set(o,B),B}}e.$ng=C;const U=(P,o)=>{let y=!0;const A=setTimeout(()=>{y=!1,o()},P);return{isTriggered:()=>y,dispose:()=>{clearTimeout(A),y=!1}}},M=P=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,P())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class S{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,y=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((B,F)=>{this.d=B,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$2c?M(A):U(y,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=S;class d{constructor(o){this.a=new S(o),this.b=new a}trigger(o,y){return this.a.trigger(()=>this.b.queue(o),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=d;class b{constructor(){this.a=!1,this.b=new Promise((o,y)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=b;class w extends b{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$rg=w;function L(P,o){return o?new Promise((y,A)=>{const B=setTimeout(()=>{F.dispose(),y()},P),F=o.onCancellationRequested(()=>{clearTimeout(B),F.dispose(),A(new k.$2)})}):c(y=>L(P,y))}e.$sg=L;function j(P,o=0){const y=setTimeout(P,o);return(0,I.$ib)(()=>clearTimeout(y))}e.$tg=j;function l(P){const o=[];let y=0;const A=P.length;function B(){return y<A?P[y++]():null}function F(Y){Y!=null&&o.push(Y);const X=B();return X?X.then(F):Promise.resolve(o)}return Promise.resolve(null).then(F)}e.$ug=l;function O(P,o=A=>!!A,y=null){let A=0;const B=P.length,F=()=>{if(A>=B)return Promise.resolve(y);const Y=P[A++];return Promise.resolve(Y()).then(Q=>o(Q)?Promise.resolve(Q):F())};return F()}e.$vg=O;function R(P,o=A=>!!A,y=null){if(P.length===0)return Promise.resolve(y);let A=P.length;const B=()=>{A=-1;for(const F of P)F.cancel?.()};return new Promise((F,Y)=>{for(const X of P)X.then(Q=>{--A>=0&&o(Q)?(B(),F(Q)):A===0&&F(y)}).catch(Q=>{--A>=0&&(B(),Y(Q))})})}e.$wg=R;class E{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new v.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((y,A)=>{this.f.push({factory:o,c:y,e:A}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const y=o.factory();y.then(o.c,o.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=E;class $ extends E{constructor(){super(1)}}e.$yg=$;class N{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const o=new ee;return this.b.add(o),o.p}d(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,y=n.$Vf){const A=y.getComparisonKey(o);let B=this.a.get(A);return B||(B=new $,v.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(A),this.f()}),this.a.set(A,B)),B}f(){this.d()&&this.g()}g(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.g()}}e.$zg=N;class z{constructor(o,y){this.a=-1,typeof o=="function"&&typeof y=="number"&&this.setIfNotSet(o,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},y)}setIfNotSet(o,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},y))}}e.$Ag=z;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(o,y){this.cancel(),this.a=setInterval(()=>{o()},y)}}e.$Bg=K;class _{constructor(o,y){this.b=-1,this.a=o,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=_;class H{constructor(o,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=o,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=H;class q extends _{constructor(o,y){super(o,y),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$Eg=q;class G extends I.$kb{constructor(o,y){super(),this.g=o,this.h=y,this.a=[],this.b=this.B(new I.$lb),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of o)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=P=>{(0,u.$v)(()=>{if(o)return;const y=Date.now()+15;P(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:e.$Gg=(P,o)=>{const y=requestIdleCallback(P,typeof o=="number"?{timeout:o}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(y))}}}}();class Z{constructor(o){this.d=!1,this.a=()=>{try{this.f=o()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=Z;async function p(P,o,y){let A;for(let B=0;B<y;B++)try{return await P()}catch(F){A=F,await L(o)}throw A}e.$Ig=p;class ae{hasPending(o){return this.a?typeof o=="number"?this.a.taskId===o:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(o,y,A){return this.a={taskId:o,cancel:()=>A?.(),promise:y},y.then(()=>this.d(o),()=>this.d(o)),y}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this.b)this.b.run=o;else{let y,A;const B=new Promise((F,Y)=>{y=F,A=Y});this.b={run:o,promise:B,promiseResolve:y,promiseReject:A}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=ae;class he{constructor(o,y=()=>Date.now()){this.d=o,this.f=y,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Kg=he;var x;(function(P){P[P.Resolved=0]="Resolved",P[P.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,y)=>{this.a=o,this.b=y})}complete(o){return new Promise(y=>{this.a(o),this.d={outcome:0,value:o},y()})}error(o){return new Promise(y=>{this.b(o),this.d={outcome:1,value:o},y()})}cancel(){return this.error(new k.$2)}}e.$Lg=ee;var te;(function(P){async function o(A){let B;const F=await Promise.all(A.map(Y=>Y.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return F}P.settled=o;function y(A){return new Promise(async(B,F)=>{try{await A(B,F)}catch(Y){F(Y)}})}P.withAsyncBody=y})(te||(e.Promises=te={}));var ne;(function(P){P[P.Initial=0]="Initial",P[P.DoneOK=1]="DoneOK",P[P.DoneError=2]="DoneError"})(ne||(ne={}));class J{static fromArray(o){return new J(y=>{y.emitMany(o)})}static fromPromise(o){return new J(async y=>{y.emitMany(await o)})}static fromPromises(o){return new J(async y=>{await Promise.all(o.map(async A=>y.emitOne(await A)))})}static merge(o){return new J(async y=>{await Promise.all(o.map(async A=>{for await(const B of A)y.emitOne(B)}))})}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new v.$5c,queueMicrotask(async()=>{const y={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(o(y)),this.j()}catch(A){this.k(A)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(o,y){return new J(async A=>{for await(const B of o)A.emitOne(y(B))})}map(o){return J.map(this,o)}static filter(o,y){return new J(async A=>{for await(const B of o)y(B)&&A.emitOne(B)})}filter(o){return J.filter(this,o)}static coalesce(o){return J.filter(o,y=>!!y)}coalesce(){return J.coalesce(this)}static async toPromise(o){const y=[];for await(const A of o)y.push(A);return y}toPromise(){return J.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$Mg=J,J.EMPTY=J.fromArray([]);class ie extends J{constructor(o,y){super(y),this.l=o}cancel(){this.l.cancel()}}e.$Ng=ie;function ce(P){const o=new T.$bd,y=P(o.token);return new ie(o,async A=>{const B=o.token.onCancellationRequested(()=>{B.dispose(),o.dispose(),A.reject(new k.$2)});try{for await(const F of y){if(o.token.isCancellationRequested)return;A.emitOne(F)}B.dispose(),o.dispose()}catch(F){B.dispose(),o.dispose(),A.reject(F)}})}e.$Og=ce}),define(V[15],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.StringEOL=void 0;var T;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function k(v){let I=0,n=0,u=0,t=0;for(let s=0,c=v.length;s<c;s++){const h=v.charCodeAt(s);h===13?(I===0&&(n=s),I++,s+1<c&&v.charCodeAt(s+1)===10?(t|=2,s++):t|=3,u=s+1):h===10&&(t|=1,I===0&&(n=s),I++,u=s+1)}return I===0&&(n=v.length),[I,n,v.length-u,t]}e.$cs=k}),define(V[16],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(T||(e.LanguageId=T={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var I;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n||(e.MetadataConsts=n={}));class u{static getLanguageId(s){return(s&255)>>>0}static getTokenType(s){return(s&768)>>>8}static containsBalancedBrackets(s){return(s&1024)!==0}static getFontStyle(s){return(s&30720)>>>11}static getForeground(s){return(s&16744448)>>>15}static getBackground(s){return(s&4278190080)>>>24}static getClassNameFromMetadata(s){let h="mtk"+this.getForeground(s);const f=this.getFontStyle(s);return f&1&&(h+=" mtki"),f&2&&(h+=" mtkb"),f&4&&(h+=" mtku"),f&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(s,c){const h=this.getForeground(s),f=this.getFontStyle(s);let g=`color: ${c[h]};`;f&1&&(g+="font-style: italic;"),f&2&&(g+="font-weight: bold;");let i="";return f&4&&(i+=" underline"),f&8&&(i+=" line-through"),i&&(g+=`text-decoration:${i};`),g}static getPresentationFromMetadata(s){const c=this.getForeground(s),h=this.getFontStyle(s);return{foreground:c,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$as=u}),define(V[28],W([0,1,29]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class k{constructor(n){this.b=n,this.a=[]}get(n){return n<this.a.length?this.a[n]:this.b}set(n,u){for(;n>=this.a.length;)this.a[this.a.length]=this.b;this.a[n]=u}replace(n,u,t){if(n>=this.a.length)return;if(u===0){this.insert(n,t);return}else if(t===0){this.delete(n,u);return}const s=this.a.slice(0,n),c=this.a.slice(n+u),h=v(t,this.b);this.a=s.concat(h,c)}delete(n,u){u===0||n>=this.a.length||this.a.splice(n,u)}insert(n,u){if(u===0||n>=this.a.length)return;const t=[];for(let s=0;s<u;s++)t[s]=this.b;this.a=(0,T.$Af)(this.a,n,t)}}e.$WB=k;function v(I,n){const u=[];for(let t=0;t<I;t++)u[t]=n;return u}}),define(V[17],W([0,1,30]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=e.$UB=e.$TB=void 0,e.$TB=new class{clone(){return this}equals(I){return this===I}};function k(I,n){return new T.$ks([new T.$js(0,"",I)],n)}e.$UB=k;function v(I,n){const u=new Uint32Array(2);return u[0]=0,u[1]=(I<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new T.$ls(u,n===null?e.$TB:n)}e.$VB=v}),define(V[7],W([0,1,16]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class k{static createEmpty(n,u){const t=k.defaultTokenMetadata,s=new Uint32Array(2);return s[0]=n.length,s[1]=t,new k(s,n,u)}constructor(n,u,t){this._lineTokensBrand=void 0,this.a=n,this.b=this.a.length>>>1,this.c=u,this.d=t}equals(n){return n instanceof k?this.slicedEquals(n,0,this.b):!1}slicedEquals(n,u,t){if(this.c!==n.c||this.b!==n.b)return!1;const s=u<<1,c=s+(t<<1);for(let h=s;h<c;h++)if(this.a[h]!==n.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(n){return n>0?this.a[n-1<<1]:0}getMetadata(n){return this.a[(n<<1)+1]}getLanguageId(n){const u=this.a[(n<<1)+1],t=T.$as.getLanguageId(u);return this.d.decodeLanguageId(t)}getStandardTokenType(n){const u=this.a[(n<<1)+1];return T.$as.getTokenType(u)}getForeground(n){const u=this.a[(n<<1)+1];return T.$as.getForeground(u)}getClassName(n){const u=this.a[(n<<1)+1];return T.$as.getClassNameFromMetadata(u)}getInlineStyle(n,u){const t=this.a[(n<<1)+1];return T.$as.getInlineStyleFromMetadata(t,u)}getPresentation(n){const u=this.a[(n<<1)+1];return T.$as.getPresentationFromMetadata(u)}getEndOffset(n){return this.a[n<<1]}findTokenIndexAtOffset(n){return k.findIndexInTokensArray(this.a,n)}inflate(){return this}sliceAndInflate(n,u,t){return new v(this,n,u,t)}static convertToEndOffset(n,u){const s=(n.length>>>1)-1;for(let c=0;c<s;c++)n[c<<1]=n[c+1<<1];n[s<<1]=u}static findIndexInTokensArray(n,u){if(n.length<=2)return 0;let t=0,s=(n.length>>>1)-1;for(;t<s;){const c=t+Math.floor((s-t)/2),h=n[c<<1];if(h===u)return c+1;h<u?t=c+1:h>u&&(s=c)}return t}withInserted(n){if(n.length===0)return this;let u=0,t=0,s="";const c=new Array;let h=0;for(;;){const f=u<this.b?this.a[u<<1]:-1,g=t<n.length?n[t]:null;if(f!==-1&&(g===null||f<=g.offset)){s+=this.c.substring(h,f);const i=this.a[(u<<1)+1];c.push(s.length,i),u++,h=f}else if(g){if(g.offset>h){s+=this.c.substring(h,g.offset);const i=this.a[(u<<1)+1];c.push(s.length,i),h=g.offset}s+=g.text,c.push(s.length,g.tokenMetadata),t++}else break}return new k(new Uint32Array(c),s,this.d)}}e.$ds=k,k.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class v{constructor(n,u,t,s){this.a=n,this.b=u,this.c=t,this.d=s,this.e=n.findTokenIndexAtOffset(u),this.f=0;for(let c=this.e,h=n.getCount();c<h&&!(n.getStartOffset(c)>=t);c++)this.f++}getMetadata(n){return this.a.getMetadata(this.e+n)}getLanguageId(n){return this.a.getLanguageId(this.e+n)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(n){return n instanceof v?this.b===n.b&&this.c===n.c&&this.d===n.d&&this.a.slicedEquals(n.a,this.e,this.f):!1}getCount(){return this.f}getForeground(n){return this.a.getForeground(this.e+n)}getEndOffset(n){const u=this.a.getEndOffset(this.e+n);return Math.min(this.c,u)-this.b+this.d}getClassName(n){return this.a.getClassName(this.e+n)}getInlineStyle(n,u){return this.a.getInlineStyle(this.e+n,u)}getPresentation(n){return this.a.getPresentation(this.e+n)}findTokenIndexAtOffset(n){return this.a.findTokenIndexAtOffset(n+this.b-this.d)-this.e}}}),define(V[31],W([0,1,7]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=void 0,e.$es=new Uint32Array(0).buffer;class k{static deleteBeginning(n,u){return n===null||n===e.$es?n:k.delete(n,0,u)}static deleteEnding(n,u){if(n===null||n===e.$es)return n;const t=v(n),s=t[t.length-2];return k.delete(n,u,s)}static delete(n,u,t){if(n===null||n===e.$es||u===t)return n;const s=v(n),c=s.length>>>1;if(u===0&&s[s.length-2]===t)return e.$es;const h=T.$ds.findIndexInTokensArray(s,u),f=h>0?s[h-1<<1]:0,g=s[h<<1];if(t<g){const C=t-u;for(let U=h;U<c;U++)s[U<<1]-=C;return n}let i,r;f!==u?(s[h<<1]=u,i=h+1<<1,r=u):(i=h<<1,r=f);const a=t-u;for(let C=h+1;C<c;C++){const U=s[C<<1]-a;U>r&&(s[i++]=U,s[i++]=s[(C<<1)+1],r=U)}if(i===s.length)return n;const m=new Uint32Array(i);return m.set(s.subarray(0,i),0),m.buffer}static append(n,u){if(u===e.$es)return n;if(n===e.$es)return u;if(n===null)return n;if(u===null)return null;const t=v(n),s=v(u),c=s.length>>>1,h=new Uint32Array(t.length+s.length);h.set(t,0);let f=t.length;const g=t[t.length-2];for(let i=0;i<c;i++)h[f++]=s[i<<1]+g,h[f++]=s[(i<<1)+1];return h.buffer}static insert(n,u,t){if(n===null||n===e.$es)return n;const s=v(n),c=s.length>>>1;let h=T.$ds.findIndexInTokensArray(s,u);h>0&&s[h-1<<1]===u&&h--;for(let f=h;f<c;f++)s[f<<1]+=t;return n}}e.$fs=k;function v(I){return I instanceof Uint32Array?I:new Uint32Array(I)}e.$gs=v}),define(V[32],W([0,1,29,11,44,15,31,18]),function(D,e,T,k,v,I,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class t{static deserialize(c,h,f){const g=new Uint32Array(c.buffer),i=(0,k.$Lb)(c,h);h+=4;const r=(0,k.$Lb)(c,h);h+=4;const a=[];for(let m=0;m<r;m++){const C=(0,k.$Lb)(c,h);h+=4,a.push(g.subarray(h/4,h/4+C/4)),h+=C}return f.push(new t(i,a)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(c,h){this.a=c,this.b=h}getLineRange(){return new u.$Mr(this.a,this.a+this.b.length)}getLineTokens(c){return this.b[c-this.a]}appendLineTokens(c){this.b.push(c)}serializeSize(){let c=0;c+=4,c+=4;for(let h=0;h<this.b.length;h++){const f=this.b[h];if(!(f instanceof Uint32Array))throw new Error("Not supported!");c+=4,c+=f.byteLength}return c}serialize(c,h){(0,k.$Mb)(c,this.a,h),h+=4,(0,k.$Mb)(c,this.b.length,h),h+=4;for(let f=0;f<this.b.length;f++){const g=this.b[f];if(!(g instanceof Uint32Array))throw new Error("Not supported!");(0,k.$Mb)(c,g.byteLength,h),h+=4,c.set(new Uint8Array(g.buffer),h),h+=g.byteLength}return h}applyEdit(c,h){const[f,g]=(0,I.$cs)(h);this.c(c),this.d(new v.$Kr(c.startLineNumber,c.startColumn),f,g)}c(c){if(c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn)return;const h=c.startLineNumber-this.a,f=c.endLineNumber-this.a;if(f<0){const g=f-h;this.a-=g;return}if(!(h>=this.b.length)){if(h<0&&f>=this.b.length){this.a=0,this.b=[];return}if(h===f){this.b[h]=n.$fs.delete(this.b[h],c.startColumn-1,c.endColumn-1);return}if(h>=0)if(this.b[h]=n.$fs.deleteEnding(this.b[h],c.startColumn-1),f<this.b.length){const g=n.$fs.deleteBeginning(this.b[f],c.endColumn-1);this.b[h]=n.$fs.append(this.b[h],g),this.b.splice(h+1,f-h)}else this.b[h]=n.$fs.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const g=-h;this.a-=g,this.b[f]=n.$fs.deleteBeginning(this.b[f],c.endColumn-1),this.b=this.b.slice(f)}}}d(c,h,f){if(h===0&&f===0)return;const g=c.lineNumber-this.a;if(g<0){this.a+=h;return}if(!(g>=this.b.length)){if(h===0){this.b[g]=n.$fs.insert(this.b[g],c.column-1,f);return}this.b[g]=n.$fs.deleteEnding(this.b[g],c.column-1),this.b[g]=n.$fs.insert(this.b[g],c.column-1,f),this.e(c.lineNumber,h)}}e(c,h){if(h===0)return;const f=[];for(let g=0;g<h;g++)f[g]=null;this.b=T.$Af(this.b,c,f)}}e.$hs=t}),define(V[19],W([0,1,11,32]),function(D,e,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=void 0;class v{static deserialize(n){let u=0;const t=(0,T.$Lb)(n,u);u+=4;const s=[];for(let c=0;c<t;c++)u=k.$hs.deserialize(n,u,s);return s}constructor(){this.a=[]}add(n,u){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(u);return}}this.a.push(new k.$hs(n,[u]))}finalize(){return this.a}serialize(){const n=this.b(),u=new Uint8Array(n);return this.c(u),u}b(){let n=0;n+=4;for(let u=0;u<this.a.length;u++)n+=this.a[u].serializeSize();return n}c(n){let u=0;(0,T.$Mb)(n,this.a.length,u),u+=4;for(let t=0;t<this.a.length;t++)u=this.a[t].serialize(n,u)}}e.$XB=v}),define(V[33],W([0,1,14,4,5,34,15,18,45,17,28,19,7]),function(D,e,T,k,v,I,n,u,t,s,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=void 0;var g;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(g||(g={}));class i{constructor(d,b){this.tokenizationSupport=b,this.a=this.tokenizationSupport.getInitialState(),this.store=new a(d)}getStartState(d){return d===1?this.a:this.store.getEndState(d-1)}}e.$YB=i;class r extends i{constructor(d,b,w,L){super(d,b),this._textModel=w,this._languageIdCodec=L}updateTokensUntilLine(d,b){const w=this._textModel.getLanguageId();for(;;){const L=this.store.getFirstInvalidEndStateLineNumber();if(!L||L>b)break;const j=this._textModel.getLineContent(L),l=this.getStartState(L),O=U(this._languageIdCodec,w,this.tokenizationSupport,j,!0,l);d.add(L,O.tokens),this.store.setEndState(L,O.endState)}}getTokenTypeIfInsertingCharacter(d,b){const w=this.getStartState(d.lineNumber);if(!w)return 0;const L=this._textModel.getLanguageId(),j=this._textModel.getLineContent(d.lineNumber),l=j.substring(0,d.column-1)+b+j.substring(d.column-1),O=U(this._languageIdCodec,L,this.tokenizationSupport,l,!0,w),R=new f.$ds(O.tokens,l,this._languageIdCodec);if(R.getCount()===0)return 0;const E=R.findTokenIndexAtOffset(d.column-1);return R.getStandardTokenType(E)}tokenizeLineWithEdit(d,b,w){const L=d.lineNumber,j=d.column,l=this.getStartState(L);if(!l)return null;const O=this._textModel.getLineContent(L),R=O.substring(0,j-1)+w+O.substring(j-1+b),E=this._textModel.getLanguageIdAtPosition(L,0),$=U(this._languageIdCodec,E,this.tokenizationSupport,R,!0,l);return new f.$ds($.tokens,R,this._languageIdCodec)}isCheapToTokenize(d){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<b||d===b&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,b,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,w),{heuristicTokens:!1};let L=this.b(b);const j=this._textModel.getLanguageId();for(let l=b;l<=w;l++){const O=this._textModel.getLineContent(l),R=U(this._languageIdCodec,j,this.tokenizationSupport,O,!0,L);d.add(l,R.tokens),L=R.endState}return{heuristicTokens:!0}}b(d){let b=this._textModel.getLineFirstNonWhitespaceColumn(d);const w=[];let L=null;for(let O=d-1;b>1&&O>=1;O--){const R=this._textModel.getLineFirstNonWhitespaceColumn(O);if(R!==0&&R<b&&(w.push(this._textModel.getLineContent(O)),b=R,L=this.getStartState(O),L))break}L||(L=this.tokenizationSupport.getInitialState()),w.reverse();const j=this._textModel.getLanguageId();let l=L;for(const O of w)l=U(this._languageIdCodec,j,this.tokenizationSupport,O,!1,l).endState;return l}}e.$ZB=r;class a{constructor(d){this.d=d,this.a=new m,this.b=new C,this.b.addRange(new t.$SB(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,b){for(;;){const L=this.b.min;if(L!==null&&L<=d)this.b.removeMin();else break}const w=this.a.setEndState(d,b);return w&&d<this.d&&this.b.addRange(new t.$SB(d+1,d+2)),w}acceptChange(d,b){this.d+=b-d.length,this.a.acceptChange(d,b),this.b.addRangeAndResize(new t.$SB(d.startLineNumber,d.endLineNumberExclusive),b)}acceptChanges(d){for(const b of d){const[w]=(0,n.$cs)(b.text);this.acceptChange(new u.$Mr(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}invalidateEndStateRange(d){this.b.addRange(new t.$SB(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.b.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this.b.min===null}}e.$1B=a;class m{constructor(){this.a=new c.$WB(null)}getEndState(d){return this.a.get(d)}setEndState(d,b){const w=this.a.get(d);return w&&w.equals(b)?!1:(this.a.set(d,b),!0)}acceptChange(d,b){let w=d.length;b>0&&w>0&&(w--,b--),this.a.replace(d.startLineNumber,w,b)}acceptChanges(d){for(const b of d){const[w]=(0,n.$cs)(b.text);this.acceptChange(new u.$Mr(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}}e.$2B=m;class C{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.$SB(d.start+1,d.endExclusive),d.start}addRange(d){t.$SB.addRange(d,this.a)}addRangeAndResize(d,b){let w=0;for(;!(w>=this.a.length||d.start<=this.a[w].endExclusive);)w++;let L=w;for(;!(L>=this.a.length||d.endExclusive<this.a[L].start);)L++;const j=b-d.length;for(let l=L;l<this.a.length;l++)this.a[l]=this.a[l].delta(j);if(w===L){const l=new t.$SB(d.start,d.start+b);l.isEmpty||this.a.splice(w,0,l)}else{const l=Math.min(d.start,this.a[w].start),O=Math.max(d.endExclusive,this.a[L-1].endExclusive),R=new t.$SB(l,O+j);R.isEmpty?this.a.splice(w,L-w):this.a.splice(w,L-w,R)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.$3B=C;function U(S,d,b,w,L,j){let l=null;if(b)try{l=b.tokenizeEncoded(w,L,j.clone())}catch(O){(0,k.$X)(O)}return l||(l=(0,s.$VB)(S.encodeLanguageId(d),j)),f.$ds.convertToEndOffset(l.tokens,w.length),l}class M{constructor(d,b){this.b=d,this.d=b,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,T.$Gg)(d=>{this.f=!1,this.h(d)}))}h(d){const b=Date.now()+d.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<b?(0,v.$v)(w):this.g())};w()}j(){const d=this.b._textModel.getLineCount(),b=new h.$XB,w=I.$1c.create(!1);do if(w.elapsed()>1||this.l(b)>=d)break;while(this.k());this.d.setTokens(b.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.isTokenizationComplete():!1}l(d){if(!this.b||!this.k())return this.b._textModel.getLineCount()+1;const b=this.b.store.getFirstInvalidEndStateLineNumber();return this.b.updateTokensUntilLine(d,b),b}checkFinished(){this.a||this.b.store.isTokenizationComplete()&&this.d.backgroundTokenizationFinished()}requestTokens(d,b){this.b.store.invalidateEndStateRange(new u.$Mr(d,b))}}e.$4B=M}),define(V[35],W([0,1,27,2,34,16,30]),function(D,e,T,k,v,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oyb=void 0;class u extends k.$kb{constructor(s,c,h,f,g=()=>!1,i){super(),this.c=s,this.f=c,this.g=h,this.h=f,this.j=g,this.k=i,this.a=[],this.b=this.B(new T.$5c),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(s,c,h){throw new Error("Not supported!")}createBackgroundTokenizer(s,c){if(this.h)return this.h(s,c)}tokenizeEncoded(s,c,h){const f=this.k&&Math.random()*1e4<1,g=f?new v.$1c(!0):void 0,i=this.c.tokenizeLine2(s,h,500);if(f){const a=g.elapsed();this.k(a,s.length)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${s.substring(0,100)}`),new n.$ls(i.tokens,h);if(this.g){const a=this.a,m=i.tokens;for(let C=0,U=m.length>>>1;C<U;C++){const M=m[(C<<1)+1],S=I.$as.getLanguageId(M);a[S]||(a[S]=!0,this.b.fire(S))}}let r;return h.equals(i.ruleStack)?r=h:r=i.ruleStack,new n.$ls(i.tokens,r)}}e.$oyb=u}),define(V[36],W([0,1,17,2,10]),function(D,e,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=void 0;class I extends k.$kb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(u,t,s){super(),this.a=u,this.b=t,this.c=s,this.B((0,v.$Fc)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(u,t,s){throw new Error("Not supported!")}tokenizeEncoded(u,t,s){return u.length>=this.c.get()?(0,T.$VB)(this.a,s):this.b.tokenizeEncoded(u,t,s)}createBackgroundTokenizer(u,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(u,t)}}e.$pyb=I}),define(V[37],W([0,1,13]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(I){if(this.a[I.scopeName]){const n=this.a[I.scopeName];T.$Yf(n.location,I.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${I.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${I.location.toString()}`)}this.a[I.scopeName]=I}getGrammarDefinition(I){return this.a[I]||null}}e.$ryb=k}),define(V[38],W([0,1,2,37]),function(D,e,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tyb=e.$syb=void 0,e.$syb="No TM Grammar registered for this language.";class v extends T.$kb{constructor(n,u,t,s){super(),this.a=n,this.b=t.INITIAL,this.c=new k.$ryb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:s,loadGrammar:async c=>{const h=this.c.getGrammarDefinition(c);if(!h)return this.a.logTrace(`No grammar found for scope ${c}`),null;const f=h.location;try{const g=await this.a.readFile(f);return t.parseRawGrammar(g,f.path)}catch(g){return this.a.logError(`Unable to load and parse grammar for scope ${c} from ${f}`,g),null}},getInjections:c=>{const h=c.split(".");let f=[];for(let g=1;g<=h.length;g++){const i=h.slice(0,g).join(".");f=[...f,...this.f[i]||[]]}return f}}));for(const c of u){if(this.c.register(c),c.injectTo){for(const h of c.injectTo){let f=this.f[h];f||(this.f[h]=f=[]),f.push(c.scopeName)}if(c.embeddedLanguages)for(const h of c.injectTo){let f=this.g[h];f||(this.g[h]=f=[]),f.push(c.embeddedLanguages)}}c.language&&this.h.set(c.language,c.scopeName)}}has(n){return this.h.has(n)}setTheme(n,u){this.j.setTheme(n,u)}getColorMap(){return this.j.getColorMap()}async createGrammar(n,u){const t=this.h.get(n);if(typeof t!="string")throw new Error(e.$syb);const s=this.c.getGrammarDefinition(t);if(!s)throw new Error(e.$syb);const c=s.embeddedLanguages;if(this.g[t]){const g=this.g[t];for(const i of g)for(const r of Object.keys(i))c[r]=i[r]}const h=Object.keys(c).length>0;let f;try{f=await this.j.loadGrammarWithConfiguration(t,u,{embeddedLanguages:c,tokenTypes:s.tokenTypes,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors})}catch(g){throw g.message&&g.message.startsWith("No grammar provided for")?new Error(e.$syb):g}return{languageId:n,grammar:f,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:s.sourceExtensionId}}}e.$tyb=v}),define(V[39],W([0,1,14,10,18,46,33,19,7,35,36,47]),function(D,e,T,k,v,I,n,u,t,s,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uyb=void 0;class f extends I.$qu{constructor(r,a,m,C,U,M,S,d){super(r,a,m,C),this.m=U,this.q=M,this.s=S,this.a=null,this.b=!1,this.c=(0,k.observableValue)("_maxTokenizationLineLength",-1),this.t=new T.$Cg(()=>this.v(),10),this.c.set(d,void 0),this.u()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,a){this.q=r,this.s=a,this.u()}onEvents(r){super.onEvents(r),this.a&&this.a.store.acceptChanges(r.changes),this.t.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,a){this.a&&(this.a.store.invalidateEndStateRange(new v.$Mr(r,a)),this.t.schedule())}u(){this.a=null;const r=this.q,a=this.s;this.m.getOrCreateGrammar(r,a).then(m=>{if(!(this.b||r!==this.q||a!==this.s||!m)){if(m.grammar){const C=new c.$pyb(this.s,new s.$oyb(m.grammar,m.initialState,!1,void 0,void 0,(U,M)=>{this.m.reportTokenizationTime(U,r,m.sourceExtensionId,M)}),this.c);this.a=new n.$YB(this.f.length,C)}else this.a=null;this.v()}})}v(){if(this.b||!this.a)return;const r=new Date().getTime();for(;;){let a=0;const m=new u.$XB,C=new g;for(;;){const S=this.a.store.getFirstInvalidEndStateLineNumber();if(S===null||a>200)break;a++;const d=this.f[S-1],b=this.a.getStartState(S),w=this.a.tokenizationSupport.tokenizeEncoded(d,!0,b);if(this.a.store.setEndState(S,w.endState)){const j=(0,h.diffStateStacksRefEq)(b,w.endState);C.setState(S,j)}else C.setState(S,null);if(t.$ds.convertToEndOffset(w.tokens,d.length),m.add(S,w.tokens),new Date().getTime()-r>20)break}if(a===0)break;const U=C.getStateDeltas();if(this.m.setTokensAndStates(this.d,this.h,m.serialize(),U),new Date().getTime()-r>20){setTimeout(()=>this.v(),3);return}}}}e.$uyb=f;class g{constructor(){this.a=-1,this.b=[]}setState(r,a){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(a):this.b.push({startLineNumber:r,stateDeltas:[a]}),this.a=r}getStateDeltas(){return this.b}}}),define(V[48],W([0,1,12,38,39]),function(D,e,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class I{constructor(t,s){this.f=s,this.b=Object.create(null),this.c=[],this.a=t.host;const c=s.grammarDefinitions.map(h=>({location:T.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(c)}async g(t){const s=this.f.textmateMainUri,c=await new Promise((r,a)=>{D([s],r,a)}),h=await new Promise((r,a)=>{D([this.f.onigurumaMainUri],r,a)}),g=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(g);const i=Promise.resolve({createOnigScanner:r=>h.createOnigScanner(r),createOnigString:r=>h.createOnigString(r)});return new k.$tyb({logTrace:r=>{},logError:(r,a)=>console.error(r,a),readFile:r=>this.a.readFile(r)},t,c,i)}acceptNewModel(t){const s=T.URI.revive(t.uri),c=s.toString();this.b[c]=new v.$uyb(s,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,s){this.b[t].onEvents(s)}retokenize(t,s,c){this.b[t].retokenize(s,c)}acceptModelLanguageChanged(t,s,c){this.b[t].onLanguageId(s,c)}acceptRemovedModel(t){this.b[t]&&(this.b[t].dispose(),delete this.b[t])}async acceptTheme(t,s){(await this.d)?.setTheme(t,s)}acceptMaxTokenizationLineLength(t,s){this.b[t].acceptMaxTokenizationLineLength(s)}async getOrCreateGrammar(t,s){const c=await this.d;return c?(this.c[s]||(this.c[s]=c.createGrammar(t,s)),this.c[s]):Promise.resolve(null)}setTokensAndStates(t,s,c,h){this.a.setTokensAndStates(t,s,c,h)}reportTokenizationTime(t,s,c,h){this.a.reportTokenizationTime(t,s,c,h)}}e.TextMateTokenizationWorker=I;function n(u,t){return new I(u,t)}e.create=n})}).call(this);

//# sourceMappingURL=textMate.worker.js.map
